/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/process","vs/base/common/labels","vs/platform/userDataProfile/common/userDataProfile","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(H){for(var e=[],E=0,t=H.length;E<t;E++)e[E]=ee[H[E]];return e};define(ee[121],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(R){return R?R.replace(/\$\((.*?)\)/g,(M,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(M,I,w){this.id=M,this.definition=I,this.description=w,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var P;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function I(p){if(p instanceof t)return["codicon","codicon-"+p.id];const y=M.exec(p.id);if(!y)return I(t.error);const[,b,h]=y,d=["codicon","codicon-"+b];return h&&d.push("codicon-modifier-"+h.substring(1)),d}R.asClassNameArray=I;function w(p){return I(p).join(" ")}R.asClassName=w;function m(p){return"."+I(p).join(".")}R.asCSSSelector=m})(P=e.CSSIcon||(e.CSSIcon={}))}),define(ee[122],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(I,w){const m=Math.pow(10,w);return Math.round(I*m)/m}class t{constructor(w,m,p,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,w))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=E(Math.max(Math.min(1,y),0),3)}static equals(w,m){return w.r===m.r&&w.g===m.g&&w.b===m.b&&w.a===m.a}}e.RGBA=t;class P{constructor(w,m,p,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=E(Math.max(Math.min(1,m),0),3),this.l=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,y),0),3)}static equals(w,m){return w.h===m.h&&w.s===m.s&&w.l===m.l&&w.a===m.a}static fromRGBA(w){const m=w.r/255,p=w.g/255,y=w.b/255,b=w.a,h=Math.max(m,p,y),d=Math.min(m,p,y);let v=0,l=0;const u=(d+h)/2,g=h-d;if(g>0){switch(l=Math.min(u<=.5?g/(2*u):g/(2-2*u),1),h){case m:v=(p-y)/g+(p<y?6:0);break;case p:v=(y-m)/g+2;break;case y:v=(m-p)/g+4;break}v*=60,v=Math.round(v)}return new P(v,l,u,b)}static i(w,m,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?w+(m-w)*6*p:p<1/2?m:p<2/3?w+(m-w)*(2/3-p)*6:w}static toRGBA(w){const m=w.h/360,{s:p,l:y,a:b}=w;let h,d,v;if(p===0)h=d=v=y;else{const l=y<.5?y*(1+p):y+p-y*p,u=2*y-l;h=P.i(u,l,m+1/3),d=P.i(u,l,m),v=P.i(u,l,m-1/3)}return new t(Math.round(h*255),Math.round(d*255),Math.round(v*255),b)}}e.HSLA=P;class R{constructor(w,m,p,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=E(Math.max(Math.min(1,m),0),3),this.v=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,y),0),3)}static equals(w,m){return w.h===m.h&&w.s===m.s&&w.v===m.v&&w.a===m.a}static fromRGBA(w){const m=w.r/255,p=w.g/255,y=w.b/255,b=Math.max(m,p,y),h=Math.min(m,p,y),d=b-h,v=b===0?0:d/b;let l;return d===0?l=0:b===m?l=((p-y)/d%6+6)%6:b===p?l=(y-m)/d+2:l=(m-p)/d+4,new R(Math.round(l*60),v,b,w.a)}static toRGBA(w){const{h:m,s:p,v:y,a:b}=w,h=y*p,d=h*(1-Math.abs(m/60%2-1)),v=y-h;let[l,u,g]=[0,0,0];return m<60?(l=h,u=d):m<120?(l=d,u=h):m<180?(u=h,g=d):m<240?(u=d,g=h):m<300?(l=d,g=h):m<=360&&(l=h,g=d),l=Math.round((l+v)*255),u=Math.round((u+v)*255),g=Math.round((g+v)*255),new t(l,u,g,b)}}e.HSVA=R;class M{static fromHex(w){return M.Format.CSS.parseHex(w)||M.red}static equals(w,m){return!w&&!m?!0:!w||!m?!1:w.equals(m)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(w){if(w)if(w instanceof t)this.rgba=w;else if(w instanceof P)this.i=w,this.rgba=P.toRGBA(w);else if(w instanceof R)this.j=w,this.rgba=R.toRGBA(w);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(w){return!!w&&t.equals(this.rgba,w.rgba)&&P.equals(this.hsla,w.hsla)&&R.equals(this.hsva,w.hsva)}getRelativeLuminance(){const w=M.k(this.rgba.r),m=M.k(this.rgba.g),p=M.k(this.rgba.b),y=.2126*w+.7152*m+.0722*p;return E(y,4)}static k(w){const m=w/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(w){const m=this.getRelativeLuminance(),p=w.getRelativeLuminance();return m>p?(m+.05)/(p+.05):(p+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(w){const m=this.getRelativeLuminance(),p=w.getRelativeLuminance();return m>p}isDarkerThan(w){const m=this.getRelativeLuminance(),p=w.getRelativeLuminance();return m<p}lighten(w){return new M(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*w,this.hsla.a))}darken(w){return new M(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*w,this.hsla.a))}transparent(w){const{r:m,g:p,b:y,a:b}=this.rgba;return new M(new t(m,p,y,b*w))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(w){const m=w.rgba,p=this.rgba.a,y=m.a,b=p+y*(1-p);if(b<1e-6)return M.transparent;const h=this.rgba.r*p/b+m.r*y*(1-p)/b,d=this.rgba.g*p/b+m.g*y*(1-p)/b,v=this.rgba.b*p/b+m.b*y*(1-p)/b;return new M(new t(h,d,v,b))}makeOpaque(w){if(this.isOpaque()||w.rgba.a!==1)return this;const{r:m,g:p,b:y,a:b}=this.rgba;return new M(new t(w.rgba.r-b*(w.rgba.r-m),w.rgba.g-b*(w.rgba.g-p),w.rgba.b-b*(w.rgba.b-y),1))}flatten(...w){const m=w.reduceRight((p,y)=>M.o(y,p));return M.o(this,m)}static o(w,m){const p=1-w.rgba.a;return new M(new t(p*m.rgba.r+w.rgba.a*w.rgba.r,p*m.rgba.g+w.rgba.a*w.rgba.g,p*m.rgba.b+w.rgba.a*w.rgba.b))}toString(){return this.u||(this.u=M.Format.CSS.format(this)),this.u}static getLighterColor(w,m,p){if(w.isLighterThan(m))return w;p=p||.5;const y=w.getRelativeLuminance(),b=m.getRelativeLuminance();return p=p*(b-y)/b,w.lighten(p)}static getDarkerColor(w,m,p){if(w.isDarkerThan(m))return w;p=p||.5;const y=w.getRelativeLuminance(),b=m.getRelativeLuminance();return p=p*(y-b)/y,w.darken(p)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(I){let w;(function(m){let p;(function(y){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:I.Format.CSS.formatRGBA(i)}y.formatRGB=b;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}y.formatRGBA=h;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(i)}y.formatHSL=d;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}y.formatHSLA=v;function l(i){const r=i.toString(16);return r.length!==2?"0"+r:r}function u(i){return`#${l(i.rgba.r)}${l(i.rgba.g)}${l(i.rgba.b)}`}y.formatHex=u;function g(i,r=!1){return r&&i.rgba.a===1?I.Format.CSS.formatHex(i):`#${l(i.rgba.r)}${l(i.rgba.g)}${l(i.rgba.b)}${l(Math.round(i.rgba.a*255))}`}y.formatHexA=g;function k(i){return i.isOpaque()?I.Format.CSS.formatHex(i):I.Format.CSS.formatRGBA(i)}y.format=k;function S(i){const r=i.length;if(r===0||i.charCodeAt(0)!==35)return null;if(r===7){const n=16*D(i.charCodeAt(1))+D(i.charCodeAt(2)),o=16*D(i.charCodeAt(3))+D(i.charCodeAt(4)),a=16*D(i.charCodeAt(5))+D(i.charCodeAt(6));return new I(new t(n,o,a,1))}if(r===9){const n=16*D(i.charCodeAt(1))+D(i.charCodeAt(2)),o=16*D(i.charCodeAt(3))+D(i.charCodeAt(4)),a=16*D(i.charCodeAt(5))+D(i.charCodeAt(6)),c=16*D(i.charCodeAt(7))+D(i.charCodeAt(8));return new I(new t(n,o,a,c/255))}if(r===4){const n=D(i.charCodeAt(1)),o=D(i.charCodeAt(2)),a=D(i.charCodeAt(3));return new I(new t(16*n+n,16*o+o,16*a+a))}if(r===5){const n=D(i.charCodeAt(1)),o=D(i.charCodeAt(2)),a=D(i.charCodeAt(3)),c=D(i.charCodeAt(4));return new I(new t(16*n+n,16*o+o,16*a+a,(16*c+c)/255))}return null}y.parseHex=S;function D(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=m.CSS||(m.CSS={}))})(w=I.Format||(I.Format={}))}(M=e.Color||(e.Color={}))}),define(ee[54],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(M){return(I,w,m)=>{let p=null,y=null;if(typeof m.value=="function"?(p="value",y=m.value):typeof m.get=="function"&&(p="get",y=m.get),!y)throw new Error("not supported");m[p]=M(y,w)}}function t(M,I,w){let m=null,p=null;if(typeof w.value=="function"?(m="value",p=w.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(m="get",p=w.get),!p)throw new Error("not supported");const y=`$memoize$${I}`;w[m]=function(...b){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,b)}),this[y]}}e.memoize=t;function P(M,I,w){return E((m,p)=>{const y=`$debounce$${p}`,b=`$debounce$result$${p}`;return function(...h){this[b]||(this[b]=w?w():void 0),clearTimeout(this[y]),I&&(this[b]=I(this[b],...h),h=[this[b]]),this[y]=setTimeout(()=>{m.apply(this,h),this[b]=w?w():void 0},M)}})}e.debounce=P;function R(M,I,w){return E((m,p)=>{const y=`$throttle$timer$${p}`,b=`$throttle$result$${p}`,h=`$throttle$lastRun$${p}`,d=`$throttle$pending$${p}`;return function(...v){if(this[b]||(this[b]=w?w():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[b]=I(this[b],...v)),this[d])return;const l=this[h]+M;l<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[b]]),this[b]=w?w():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),m.apply(this,[this[b]]),this[b]=w?w():void 0},l-Date.now()))}})}e.throttle=R}),define(ee[13],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?k.isErrorNoTelemetry(i)?new k(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=E,e.errorHandler=new E;function t(D){e.errorHandler.setUnexpectedErrorHandler(D)}e.setUnexpectedErrorHandler=t;function P(D){w(D)||e.errorHandler.onUnexpectedError(D)}e.onUnexpectedError=P;function R(D){w(D)||e.errorHandler.onUnexpectedExternalError(D)}e.onUnexpectedExternalError=R;function M(D){if(D instanceof Error){const{name:i,message:r}=D,n=D.stacktrace||D.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:k.isErrorNoTelemetry(D)}}return D}e.transformErrorForSerialization=M;const I="Canceled";function w(D){return D instanceof m?!0:D instanceof Error&&D.name===I&&D.message===I}e.isCancellationError=w;class m extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=m;function p(){const D=new Error(I);return D.name=D.message,D}e.canceled=p;function y(D){return D?new Error(`Illegal argument: ${D}`):new Error("Illegal argument")}e.illegalArgument=y;function b(D){return D?new Error(`Illegal state: ${D}`):new Error("Illegal state")}e.illegalState=b;function h(D){return D?new Error(`readonly property '${D} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(D){const i=new Error(`${D} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function v(D){return D?D.message?D.message:D.stack?D.stack.split(`
`)[0]:String(D):"Error"}e.getErrorMessage=v;class l extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=l;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class k extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof k)return i;const r=new k;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=k;class S extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}e.BugIndicatingError=S}),define(ee[25],te([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,X=0){return B[B.length-(1+X)]}e.tail=t;function P(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=P;function R(B,X,Z=(oe,de)=>oe===de){if(B===X)return!0;if(!B||!X||B.length!==X.length)return!1;for(let oe=0,de=B.length;oe<de;oe++)if(!Z(B[oe],X[oe]))return!1;return!0}e.equals=R;function M(B,X){const Z=B.length-1;X<Z&&(B[X]=B[Z]),B.pop()}e.removeFastWithoutKeepingOrder=M;function I(B,X,Z){return w(B.length,oe=>Z(B[oe],X))}e.binarySearch=I;function w(B,X){let Z=0,oe=B-1;for(;Z<=oe;){const de=(Z+oe)/2|0,ke=X(de);if(ke<0)Z=de+1;else if(ke>0)oe=de-1;else return de}return-(Z+1)}e.binarySearch2=w;function m(B,X){let Z=0,oe=B.length;if(oe===0)return 0;for(;Z<oe;){const de=Math.floor((Z+oe)/2);X(B[de])?oe=de:Z=de+1}return Z}e.findFirstInSorted=m;function p(B,X,Z){if(B=B|0,B>=X.length)throw new TypeError("invalid index");const oe=X[Math.floor(X.length*Math.random())],de=[],ke=[],De=[];for(const Pe of X){const Ae=Z(Pe,oe);Ae<0?de.push(Pe):Ae>0?ke.push(Pe):De.push(Pe)}return B<de.length?p(B,de,Z):B<de.length+De.length?De[0]:p(B-(de.length+De.length),ke,Z)}e.quickSelect=p;function y(B,X){const Z=[];let oe;for(const de of B.slice(0).sort(X))!oe||X(oe[0],de)!==0?(oe=[de],Z.push(oe)):oe.push(de);return Z}e.groupBy=y;function b(B,X,Z){const oe=[];function de(Pe,Ae,ve){if(Ae===0&&ve.length===0)return;const me=oe[oe.length-1];me&&me.start+me.deleteCount===Pe?(me.deleteCount+=Ae,me.toInsert.push(...ve)):oe.push({start:Pe,deleteCount:Ae,toInsert:ve})}let ke=0,De=0;for(;;){if(ke===B.length){de(ke,0,X.slice(De));break}if(De===X.length){de(ke,B.length-ke,[]);break}const Pe=B[ke],Ae=X[De],ve=Z(Pe,Ae);ve===0?(ke+=1,De+=1):ve<0?(de(ke,1,[]),ke+=1):ve>0&&(de(ke,0,[Ae]),De+=1)}return oe}e.sortedDiff=b;function h(B,X,Z){const oe=b(B,X,Z),de=[],ke=[];for(const De of oe)de.push(...B.slice(De.start,De.start+De.deleteCount)),ke.push(...De.toInsert);return{removed:de,added:ke}}e.delta=h;function d(B,X,Z){if(Z===0)return[];const oe=B.slice(0,Z).sort(X);return l(B,X,oe,Z,B.length),oe}e.top=d;function v(B,X,Z,oe,de){return Z===0?Promise.resolve([]):new Promise((ke,De)=>{(async()=>{const Pe=B.length,Ae=B.slice(0,Z).sort(X);for(let ve=Z,me=Math.min(Z+oe,Pe);ve<Pe;ve=me,me=Math.min(me+oe,Pe)){if(ve>Z&&await new Promise(ye=>setTimeout(ye)),de&&de.isCancellationRequested)throw new E.CancellationError;l(B,X,Ae,ve,me)}return Ae})().then(ke,De)})}e.topAsync=v;function l(B,X,Z,oe,de){for(const ke=Z.length;oe<de;oe++){const De=B[oe];if(X(De,Z[ke-1])<0){Z.pop();const Pe=m(Z,Ae=>X(De,Ae)<0);Z.splice(Pe,0,De)}}}function u(B){return B.filter(X=>!!X)}e.coalesce=u;function g(B){let X=0;for(let Z=0;Z<B.length;Z++)B[Z]&&(B[X]=B[Z],X+=1);B.length=X}e.coalesceInPlace=g;function k(B,X,Z){B.splice(Z,0,B.splice(X,1)[0])}e.move=k;function S(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=S;function D(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=D;function i(B,X=Z=>Z){const Z=new Set;return B.filter(oe=>{const de=X(oe);return Z.has(de)?!1:(Z.add(de),!0)})}e.distinct=i;function r(B){const X=new Set;return Z=>{const oe=B(Z);return X.has(oe)?!1:(X.add(oe),!0)}}e.uniqueFilter=r;function n(B,X){const Z=o(B,X);if(Z!==-1)return B[Z]}e.findLast=n;function o(B,X){for(let Z=B.length-1;Z>=0;Z--){const oe=B[Z];if(X(oe))return Z}return-1}e.lastIndex=o;function a(B,X){return B.length>0?B[0]:X}e.firstOrDefault=a;function c(B,X){return B.length>0?B[B.length-1]:X}e.lastOrDefault=c;function s(B,X,Z=(oe,de)=>oe===de){let oe=0;for(let de=0,ke=Math.min(B.length,X.length);de<ke&&Z(B[de],X[de]);de++)oe++;return oe}e.commonPrefixLength=s;function f(B){return[].concat(...B)}e.flatten=f;function C(B,X){let Z=typeof X=="number"?B:0;typeof X=="number"?Z=B:(Z=0,X=B);const oe=[];if(Z<=X)for(let de=Z;de<X;de++)oe.push(de);else for(let de=Z;de>X;de--)oe.push(de);return oe}e.range=C;function L(B,X,Z){return B.reduce((oe,de)=>(oe[X(de)]=Z?Z(de):de,oe),Object.create(null))}e.index=L;function O(B,X){return B.push(X),()=>j(B,X)}e.insert=O;function j(B,X){const Z=B.indexOf(X);if(Z>-1)return B.splice(Z,1),X}e.remove=j;function K(B,X,Z){const oe=B.slice(0,X),de=B.slice(X);return oe.concat(Z,de)}e.arrayInsert=K;function V(B,X){let Z;if(typeof X=="number"){let oe=X;Z=()=>{const de=Math.sin(oe++)*179426549;return de-Math.floor(de)}}else Z=Math.random;for(let oe=B.length-1;oe>0;oe-=1){const de=Math.floor(Z()*(oe+1)),ke=B[oe];B[oe]=B[de],B[de]=ke}}e.shuffle=V;function J(B,X){const Z=B.indexOf(X);Z>-1&&(B.splice(Z,1),B.unshift(X))}e.pushToStart=J;function re(B,X){const Z=B.indexOf(X);Z>-1&&(B.splice(Z,1),B.push(X))}e.pushToEnd=re;function se(B,X){for(const Z of X)B.push(Z)}e.pushMany=se;function ae(B,X){return Array.isArray(B)?B.map(X):X(B)}e.mapArrayOrNot=ae;function fe(B){return Array.isArray(B)?B:[B]}e.asArray=fe;function ge(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=ge;function q(B,X){for(const Z of B){const oe=X(Z);if(oe!==void 0)return oe}}e.mapFind=q;function T(B,X,Z){const oe=z(B,X),de=B.length,ke=Z.length;B.length=de+ke;for(let De=de-1;De>=oe;De--)B[De+ke]=B[De];for(let De=0;De<ke;De++)B[De+oe]=Z[De]}e.insertInto=T;function U(B,X,Z,oe){const de=z(B,X),ke=B.splice(de,Z);return T(B,de,oe),ke}e.splice=U;function z(B,X){return X<0?Math.max(X+B.length,0):Math.min(X,B.length)}var Q;(function(B){function X(de){return de<0}B.isLessThan=X;function Z(de){return de>0}B.isGreaterThan=Z;function oe(de){return de===0}B.isNeitherLessOrGreaterThan=oe,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function ne(B,X){return(Z,oe)=>X(B(Z),B(oe))}e.compareBy=ne;function x(...B){return(X,Z)=>{for(const oe of B){const de=oe(X,Z);if(!Q.isNeitherLessOrGreaterThan(de))return de}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const A=(B,X)=>B-X;e.numberComparator=A;function F(B,X){if(B.length===0)return;let Z=B[0];for(let oe=1;oe<B.length;oe++){const de=B[oe];X(de,Z)>0&&(Z=de)}return Z}e.findMaxBy=F;function W(B,X){if(B.length===0)return;let Z=B[0];for(let oe=1;oe<B.length;oe++){const de=B[oe];X(de,Z)>=0&&(Z=de)}return Z}e.findLastMaxBy=W;function N(B,X){return F(B,(Z,oe)=>-X(Z,oe))}e.findMinBy=N;class ${constructor(X){this.f=X,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(X){let Z=this.c;for(;Z<this.f.length&&X(this.f[Z]);)Z++;const oe=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,oe}takeFromEndWhile(X){let Z=this.d;for(;Z>=0&&X(this.f[Z]);)Z--;const oe=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const X=this.f[this.c];return this.c++,X}removeLast(){const X=this.f[this.d];return this.d--,X}takeCount(X){const Z=this.f.slice(this.c,this.c+X);return this.c+=X,Z}}e.ArrayQueue=$;class G{constructor(X){this.iterate=X}forEach(X){this.iterate(Z=>(X(Z),!0))}toArray(){const X=[];return this.iterate(Z=>(X.push(Z),!0)),X}filter(X){return new G(Z=>this.iterate(oe=>X(oe)?Z(oe):!0))}map(X){return new G(Z=>this.iterate(oe=>Z(X(oe))))}some(X){let Z=!1;return this.iterate(oe=>(Z=X(oe),!Z)),Z}findFirst(X){let Z;return this.iterate(oe=>X(oe)?(Z=oe,!1):!0),Z}findLast(X){let Z;return this.iterate(oe=>(X(oe)&&(Z=oe),!0)),Z}findLastMaxBy(X){let Z,oe=!0;return this.iterate(de=>((oe||Q.isGreaterThan(X(de,Z)))&&(oe=!1,Z=de),!0)),Z}}e.CallbackIterable=G,G.empty=new G(B=>{})}),define(ee[123],te([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,m){if(!w)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function P(w,m="Unreachable"){throw new Error(m)}e.assertNever=P;function R(w){if(!w)throw new E.BugIndicatingError("Assertion Failed")}e.assert=R;function M(w){if(!w()){debugger;w(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function I(w,m){let p=0;for(;p<w.length-1;){const y=w[p],b=w[p+1];if(!m(y,b))return!1;p++}return!0}e.checkAdjacentItems=I}),define(ee[50],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const P=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(P,arguments)),M}}e.once=E}),define(ee[68],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function P(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}t.is=P;const R=Object.freeze([]);function M(){return R}t.empty=M;function*I(S){yield S}t.single=I;function w(S){return P(S)?S:I(S)}t.wrap=w;function m(S){return S||R}t.from=m;function p(S){return!S||S[Symbol.iterator]().next().done===!0}t.isEmpty=p;function y(S){return S[Symbol.iterator]().next().value}t.first=y;function b(S,D){for(const i of S)if(D(i))return!0;return!1}t.some=b;function h(S,D){for(const i of S)if(D(i))return i}t.find=h;function*d(S,D){for(const i of S)D(i)&&(yield i)}t.filter=d;function*v(S,D){let i=0;for(const r of S)yield D(r,i++)}t.map=v;function*l(...S){for(const D of S)for(const i of D)yield i}t.concat=l;function u(S,D,i){let r=i;for(const n of S)r=D(r,n);return r}t.reduce=u;function*g(S,D,i=S.length){for(D<0&&(D+=S.length),i<0?i+=S.length:i>S.length&&(i=S.length);D<i;D++)yield S[D]}t.slice=g;function k(S,D=Number.POSITIVE_INFINITY){const i=[];if(D===0)return[i,S];const r=S[Symbol.iterator]();for(let n=0;n<D;n++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=k})(E=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(i,r=!1){let n=0;const o=i.length;let a="",c=0,s=16,f=0;function C(re){let se=0,ae=0;for(;se<re;){const fe=i.charCodeAt(n);if(fe>=48&&fe<=57)ae=ae*16+fe-48;else if(fe>=65&&fe<=70)ae=ae*16+fe-65+10;else if(fe>=97&&fe<=102)ae=ae*16+fe-97+10;else break;n++,se++}return se<re&&(ae=-1),ae}function L(re){n=re,a="",c=0,s=16,f=0}function O(){const re=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return f=3,i.substring(re,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;se=n}else f=3;return i.substring(re,se)}function j(){let re="",se=n;for(;;){if(n>=o){re+=i.substring(se,n),f=2;break}const ae=i.charCodeAt(n);if(ae===34){re+=i.substring(se,n),n++;break}if(ae===92){if(re+=i.substring(se,n),n++,n>=o){f=2;break}switch(i.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const ge=C(4);ge>=0?re+=String.fromCharCode(ge):f=4;break}default:f=5}se=n;continue}if(ae>=0&&ae<=31)if(w(ae)){re+=i.substring(se,n),f=2;break}else f=6;n++}return re}function K(){if(a="",f=0,c=n,n>=o)return c=o,s=17;let re=i.charCodeAt(n);if(I(re)){do n++,a+=String.fromCharCode(re),re=i.charCodeAt(n);while(I(re));return s=15}if(w(re))return n++,a+=String.fromCharCode(re),re===13&&i.charCodeAt(n)===10&&(n++,a+=`
`),s=14;switch(re){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,a=j(),s=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!w(i.charCodeAt(n));)n++;return a=i.substring(se,n),s=12}if(i.charCodeAt(n+1)===42){n+=2;const ae=o-1;let fe=!1;for(;n<ae;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,fe=!0;break}n++}return fe||(n++,f=1),a=i.substring(se,n),s=13}return a+=String.fromCharCode(re),n++,s=16}case 45:if(a+=String.fromCharCode(re),n++,n===o||!m(i.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=O(),s=11;default:for(;n<o&&V(re);)n++,re=i.charCodeAt(n);if(c!==n){switch(a=i.substring(c,n),a){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return a+=String.fromCharCode(re),n++,s=16}}function V(re){if(I(re)||w(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let re;do re=K();while(re>=12&&re<=15);return re}return{setPosition:L,getPosition:()=>n,scan:r?J:K,getToken:()=>s,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>f}}e.createScanner=M;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var p;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(p||(p={}));function y(i,r){const n=[],o=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function f(C,L,O,j){c.value=C,c.offset=L,c.length=O,c.type=j,c.colonOffset=void 0,a=c}try{k(i,{onObjectBegin:(C,L)=>{if(r<=C)throw o;a=void 0,s=r>C,n.push("")},onObjectProperty:(C,L,O)=>{if(r<L||(f(C,L,O,"property"),n[n.length-1]=C,r<=L+O))throw o},onObjectEnd:(C,L)=>{if(r<=C)throw o;a=void 0,n.pop()},onArrayBegin:(C,L)=>{if(r<=C)throw o;a=void 0,n.push(0)},onArrayEnd:(C,L)=>{if(r<=C)throw o;a=void 0,n.pop()},onLiteralValue:(C,L,O)=>{if(r<L||(f(C,L,O,D(C)),r<=L+O))throw o},onSeparator:(C,L,O)=>{if(r<=L)throw o;if(C===":"&&a&&a.type==="property")a.colonOffset=L,s=!1,a=void 0;else if(C===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(s=!0,n[n.length-1]=""),a=void 0}}})}catch(C){if(C!==o)throw C}return{path:n,previousNode:a,isAtPropertyKey:s,matches:C=>{let L=0;for(let O=0;L<C.length&&O<n.length;O++)if(C[L]===n[O]||C[L]==="*")L++;else if(C[L]!=="**")return!1;return L===C.length}}}e.getLocation=y;function b(i,r=[],n=R.DEFAULT){let o=null,a=[];const c=[];function s(C){Array.isArray(a)?a.push(C):o!==null&&(a[o]=C)}return k(i,{onObjectBegin:()=>{const C={};s(C),c.push(a),a=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const C=[];s(C),c.push(a),a=C,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:s,onError:(C,L,O)=>{r.push({error:C,offset:L,length:O})}},n),a[0]}e.parse=b;function h(i,r=[],n=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(C){o.type==="property"&&(o.length=C-o.offset,o=o.parent)}function c(C){return o.children.push(C),C}k(i,{onObjectBegin:C=>{o=c({type:"object",offset:C,length:-1,parent:o,children:[]})},onObjectProperty:(C,L,O)=>{o=c({type:"property",offset:L,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:C,offset:L,length:O,parent:o})},onObjectEnd:(C,L)=>{o.length=C+L-o.offset,o=o.parent,a(C+L)},onArrayBegin:(C,L)=>{o=c({type:"array",offset:C,length:-1,parent:o,children:[]})},onArrayEnd:(C,L)=>{o.length=C+L-o.offset,o=o.parent,a(C+L)},onLiteralValue:(C,L,O)=>{c({type:D(C),offset:L,length:O,parent:o,value:C}),a(L+O)},onSeparator:(C,L,O)=>{o.type==="property"&&(C===":"?o.colonOffset=L:C===","&&a(L))},onError:(C,L,O)=>{r.push({error:C,offset:L,length:O})}},n);const f=o.children[0];return f&&delete f.parent,f}e.parseTree=h;function d(i,r){if(!i)return;let n=i;for(const o of r)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===o){n=c.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.findNodeAtLocation=d;function v(i){if(!i.parent||!i.parent.children)return[];const r=v(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=v;function l(i){switch(i.type){case"array":return i.children.map(l);case"object":{const r=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(r[n.children[0].value]=l(o))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=l;function u(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=u;function g(i,r,n=!1){if(u(i,r,n)){const o=i.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=r;a++){const c=g(o[a],r,n);if(c)return c}return i}}e.findNodeAtOffset=g;function k(i,r,n=R.DEFAULT){const o=M(i,!1);function a(ne){return ne?()=>ne(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(ne){return ne?x=>ne(x,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=a(r.onObjectBegin),f=c(r.onObjectProperty),C=a(r.onObjectEnd),L=a(r.onArrayBegin),O=a(r.onArrayEnd),j=c(r.onLiteralValue),K=c(r.onSeparator),V=a(r.onComment),J=c(r.onError),re=n&&n.disallowComments,se=n&&n.allowTrailingComma;function ae(){for(;;){const ne=o.scan();switch(o.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:re||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ne){case 12:case 13:re?fe(10):V();break;case 16:fe(1);break;case 15:case 14:break;default:return ne}}}function fe(ne,x=[],A=[]){if(J(ne),x.length+A.length>0){let F=o.getToken();for(;F!==17;){if(x.indexOf(F)!==-1){ae();break}else if(A.indexOf(F)!==-1)break;F=ae()}}}function ge(ne){const x=o.getTokenValue();return ne?j(x):f(x),ae(),!0}function q(){switch(o.getToken()){case 11:{let ne=0;try{ne=JSON.parse(o.getTokenValue()),typeof ne!="number"&&(fe(2),ne=0)}catch{fe(2)}j(ne);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ae(),!0}function T(){return o.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),o.getToken()===6?(K(":"),ae(),Q()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function U(){s(),ae();let ne=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ne||fe(4,[],[]),K(","),ae(),o.getToken()===2&&se)break}else ne&&fe(6,[],[]);T()||fe(4,[],[2,5]),ne=!0}return C(),o.getToken()!==2?fe(7,[2],[]):ae(),!0}function z(){L(),ae();let ne=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ne||fe(4,[],[]),K(","),ae(),o.getToken()===4&&se)break}else ne&&fe(6,[],[]);Q()||fe(4,[],[4,5]),ne=!0}return O(),o.getToken()!==4?fe(8,[4],[]):ae(),!0}function Q(){switch(o.getToken()){case 3:return z();case 1:return U();case 10:return ge(!0);default:return q()}}return ae(),o.getToken()===17?n.allowEmptyContent?!0:(fe(4,[],[]),!1):Q()?(o.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=k;function S(i,r){const n=M(i),o=[];let a,c=0,s;do switch(s=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:c!==s&&o.push(i.substring(c,s)),r!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,r)),c=n.getPosition();break}while(a!==17);return o.join("")}e.stripComments=S;function D(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(ee[124],te([0,1,43]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,p,y){let b,h,d,v,l;if(p){for(v=p.offset,l=v+p.length,d=v;d>0&&!w(m,d-1);)d--;let s=l;for(;s<m.length&&!w(m,s);)s++;h=m.substring(d,s),b=M(h,y)}else h=m,b=0,d=0,v=0,l=m.length;const u=I(y,m);let g=!1,k=0,S;y.insertSpaces?S=R(" ",y.tabSize||4):S="	";const D=(0,E.createScanner)(h,!1);let i=!1;function r(){return u+R(S,b+k)}function n(){let s=D.scan();for(g=!1;s===15||s===14;)g=g||s===14,s=D.scan();return i=s===16||D.getTokenError()!==0,s}const o=[];function a(s,f,C){!i&&f<l&&C>v&&m.substring(f,C)!==s&&o.push({offset:f,length:C-f,content:s})}let c=n();if(c!==17){const s=D.getTokenOffset()+d,f=R(S,b);a(f,d,s)}for(;c!==17;){let s=D.getTokenOffset()+D.getTokenLength()+d,f=n(),C="";for(;!g&&(f===12||f===13);){const O=D.getTokenOffset()+d;a(" ",s,O),s=D.getTokenOffset()+D.getTokenLength()+d,C=f===12?r():"",f=n()}if(f===2)c!==1&&(k--,C=r());else if(f===4)c!==3&&(k--,C=r());else{switch(c){case 3:case 1:k++,C=r();break;case 5:case 12:C=r();break;case 13:g?C=r():C=" ";break;case 6:C=" ";break;case 10:if(f===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?C=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}g&&(f===12||f===13)&&(C=r())}const L=D.getTokenOffset()+d;a(C,s,L),c=f}return o}e.format=t;function P(m,p){const y=JSON.stringify(m,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?y.replace(/\r\n|\r|\n/g,p.eol):y}e.toFormattedString=P;function R(m,p){let y="";for(let b=0;b<p;b++)y+=m;return y}function M(m,p){let y=0,b=0;const h=p.tabSize||4;for(;y<m.length;){const d=m.charAt(y);if(d===" ")b++;else if(d==="	")b+=h;else break;y++}return Math.floor(b/h)}function I(m,p){for(let y=0;y<p.length;y++){const b=p.charAt(y);if(b==="\r")return y+1<p.length&&p.charAt(y+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=I;function w(m,p){return`\r
`.indexOf(m.charAt(p))!==-1}e.isEOL=w}),define(ee[125],te([0,1,43,124]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(m,p,y){return R(m,p,void 0,y)}e.removeProperty=P;function R(m,p,y,b,h){const d=p.slice(),v=[],l=(0,E.parseTree)(m,v);let u,g;for(;d.length>0&&(g=d.pop(),u=(0,E.findNodeAtLocation)(l,d),u===void 0&&y!==void 0);)typeof g=="string"?y={[g]:y}:y=[y];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const k=(0,E.findNodeAtLocation)(u,[g]);if(k!==void 0)if(y===void 0){if(!k.parent)throw new Error("Malformed AST");const S=u.children.indexOf(k.parent);let D,i=k.parent.offset+k.parent.length;if(S>0){const r=u.children[S-1];D=r.offset+r.length}else D=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return M(m,{offset:D,length:i-D,content:""},b)}else return M(m,{offset:k.offset,length:k.length,content:JSON.stringify(y)},b);else{if(y===void 0)return[];const S=`${JSON.stringify(g)}: ${JSON.stringify(y)}`,D=h?h(u.children.map(r=>r.children[0].value)):u.children.length;let i;if(D>0){const r=u.children[D-1];i={offset:r.offset+r.length,length:0,content:","+S}}else u.children.length===0?i={offset:u.offset+1,length:0,content:S}:i={offset:u.offset+1,length:0,content:S+","};return M(m,i,b)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(y!==void 0){const k=`${JSON.stringify(y)}`;let S;if(u.children.length===0||g===0)S={offset:u.offset+1,length:0,content:u.children.length===0?k:k+","};else{const D=g===-1||g>u.children.length?u.children.length:g,i=u.children[D-1];S={offset:i.offset+i.length,length:0,content:","+k}}return M(m,S,b)}else{const k=g,S=u.children[k];let D;if(u.children.length===1)D={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===k){const i=u.children[k-1],r=i.offset+i.length,n=u.offset+u.length;D={offset:r,length:n-2-r,content:""}}else D={offset:S.offset,length:u.children[k+1].offset-S.offset,content:""};return M(m,D,b)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return M(m,{offset:l?l.offset:0,length:l?l.length:0,content:JSON.stringify(y)},b)}}e.setProperty=R;function M(m,p,y){let b=I(m,p),h=p.offset,d=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;h>0&&!(0,t.isEOL)(b,h-1);)h--;for(;d<b.length&&!(0,t.isEOL)(b,d);)d++}const v=(0,t.format)(b,{offset:h,length:d-h},y);for(let u=v.length-1;u>=0;u--){const g=v[u];b=I(b,g),h=Math.min(h,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const l=m.length-(b.length-d)-h;return[{offset:h,length:l,content:b.substring(h,d)}]}e.withFormatting=M;function I(m,p){return m.substring(0,p.offset)+p.content+m.substring(p.offset+p.length)}e.applyEdit=I;function w(m,p){const y=p.slice(0).sort((h,d)=>{const v=h.offset-d.offset;return v===0?h.length-d.length:v});let b=m.length;for(let h=y.length-1;h>=0;h--){const d=y[h];if(d.offset+d.length<=b)m=I(m,d);else throw new Error("Overlapping edit");b=d.offset}return m}e.applyEdits=w}),define(ee[126],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(P){this.d=P,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(P){return new E(()=>P(this.getValue()))}}e.Lazy=E}),define(ee[2],te([0,1,50,68]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let R=null;function M(c){R=c}if(e.setDisposableTracker=M,P){const c="__is_disposable_tracked__";M(new class{trackDisposable(s){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(f)},3e3)}setParent(s,f){if(s&&s!==g.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==g.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function I(c){return R?.trackDisposable(c),c}function w(c){R?.markAsDisposed(c)}function m(c,s){R?.setParent(c,s)}function p(c,s){if(!!R)for(const f of c)R.setParent(f,s)}function y(c){return R?.markAsSingleton(c),c}e.markAsSingleton=y;function b(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=b;function h(c){if(t.Iterable.is(c)){const s=[];for(const f of c)if(f)try{f.dispose()}catch(C){s.push(C)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function d(c){for(const s of c)b(s)&&s.dispose();return[]}e.disposeIfDisposable=d;function v(...c){const s=l(()=>h(c));return p(c,s),s}e.combinedDisposable=v;function l(c){const s=I({dispose:(0,E.once)(()=>{w(s),c()})});return s}e.toDisposable=l;class u{constructor(){this.c=new Set,this.f=!1,I(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return m(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this.q=new u,I(this),m(this.q,this)}dispose(){w(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class k{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&m(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&m(s,null),s}}e.MutableDisposable=k;class S{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(s){let f=s;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,w(this))},this}}e.SafeDisposable=D;class i{constructor(){this.a=new Map}acquire(s,...f){let C=this.a.get(s);C||(C={counter:0,object:this.b(s,...f)},this.a.set(s,C));const{object:L}=C,O=(0,E.once)(()=>{--C.counter===0&&(this.c(s,C.object),this.a.delete(s))});return C.counter++,{object:L,dispose:O}}}e.ReferenceCollection=i;class r{constructor(s){this.a=s}async acquire(s,...f){const C=this.a.acquire(s,...f);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(L){throw C.dispose(),L}}}e.AsyncReferenceCollection=r;class n{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=n;function o(c){const s=new u;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=o;class a{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,f,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(s)?.dispose(),this.a.set(s,f)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(ee[97],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let R=this.a;for(;R!==E.Undefined;){const M=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=M}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const I=new E(R);if(this.a===E.Undefined)this.a=I,this.b=I;else if(M){const m=this.b;this.b=I,I.prev=m,m.next=I}else{const m=this.a;this.a=I,I.next=m,m.prev=I}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(I))}}shift(){if(this.a!==E.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==E.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===E.Undefined&&R.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):R.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):R.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ee[40],te([0,1]),function(H,e){"use strict";var E,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(d,v,l){let u=d.get(v);return u===void 0&&(u=l,d.set(v,u)),u}e.getOrSet=R;function M(d){const v=[];return d.forEach((l,u)=>{v.push(`${u} => ${l}`)}),`Map(${d.size}) {${v.join(", ")}}`}e.mapToString=M;function I(d){const v=[];return d.forEach(l=>{v.push(l)}),`Set(${d.size}) {${v.join(", ")}}`}e.setToString=I;class w{constructor(v,l){this.uri=v,this.value=l}}class m{constructor(v,l){this[E]="ResourceMap",v instanceof m?(this.b=new Map(v.b),this.c=l??m.a):(this.b=new Map,this.c=v??m.a)}set(v,l){return this.b.set(this.c(v),new w(v,l)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,l){typeof l<"u"&&(v=v.bind(l));for(const[u,g]of this.b)v(g.value,g.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}e.ResourceMap=m,m.a=d=>d.toString();class p{constructor(v,l){this[t]="ResourceSet",!v||typeof v=="function"?this.a=new m(v):(this.a=new m(l),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,l){this.a.forEach((u,g)=>v.call(l,g,g,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class b{constructor(){this[P]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,l=0){const u=this.a.get(v);if(!!u)return l!==0&&this.j(u,l),u.value}set(v,l,u=0){let g=this.a.get(v);if(g)g.value=l,u!==0&&this.j(g,u);else{switch(g={key:v,value:l,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(v,g),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const l=this.a.get(v);if(!!l)return this.a.delete(v),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,l){const u=this.e;let g=this.b;for(;g;){if(l?v.bind(l)(g.value,g.key,this):v(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const v=this,l=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.key,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}values(){const v=this,l=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.value,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}entries(){const v=this,l=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:[u.key,u.value],done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let l=this.b,u=this.size;for(;l&&u>v;)this.a.delete(l.key),l=l.next,u--;this.b=l,this.d=u,l&&(l.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const l=v.next,u=v.previous;if(!l||!u)throw new Error("Invalid list");l.previous=u,u.next=l}v.next=void 0,v.previous=void 0,this.e++}j(v,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(v===this.b)return;const u=v.next,g=v.previous;v===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(l===2){if(v===this.c)return;const u=v.next,g=v.previous;v===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((l,u)=>{v.push([u,l])}),v}fromJSON(v){this.clear();for(const[l,u]of v)this.set(l,u)}}e.LinkedMap=b;class h extends b{constructor(v,l=1){super(),this.k=v,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,l=2){return super.get(v,l)}peek(v){return super.get(v,0)}set(v,l){return super.set(v,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(ee[78],te([0,1,40]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function P(m){return w(m,"NFC",t)}e.normalizeNFC=P;const R=new E.LRUCache(1e4);function M(m){return w(m,"NFD",R)}e.normalizeNFD=M;const I=/[^\u0000-\u0080]/;function w(m,p,y){if(!m)return m;const b=y.get(m);if(b)return b;let h;return I.test(m)?h=m.normalize(p):h=m,y.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(p){return M(p).replace(m,"")}}()}),define(ee[127],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(I,w,m){return Math.min(Math.max(I,w),m)}e.clamp=E;function t(I,w){return(w+I%w)%w}e.rot=t;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class R{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class M{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const m=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=M}),function(){function H(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function M(w){R.push(w,Date.now())}function I(){const w=[];for(let m=0;m<R.length;m+=2)w.push({name:R[m],startTime:R[m+1]});return w}return{mark:M,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(P+M.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:H)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function E(t){if(e[t])return e[t].exports;var P=e[t]={i:t,l:!1,exports:{}};return H[t].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=H,E.c=e,E.d=function(t,P,R){E.o(t,P)||Object.defineProperty(t,P,{enumerable:!0,get:R})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,P){if(1&P&&(t=E(t)),8&P||4&P&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(E.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&P&&typeof t!="string")for(var M in t)E.d(R,M,function(I){return t[I]}.bind(null,M));return R},E.n=function(t){var P=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(P,"a",P),P},E.o=function(t,P){return Object.prototype.hasOwnProperty.call(t,P)},E.p="",E(E.s=0)}([function(H,e,E){(function(t){var P;e=H.exports=A,P=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],m=0,p=m++;w[p]="0|[1-9]\\d*";var y=m++;w[y]="[0-9]+";var b=m++;w[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;w[h]="("+w[p]+")\\.("+w[p]+")\\.("+w[p]+")";var d=m++;w[d]="("+w[y]+")\\.("+w[y]+")\\.("+w[y]+")";var v=m++;w[v]="(?:"+w[p]+"|"+w[b]+")";var l=m++;w[l]="(?:"+w[y]+"|"+w[b]+")";var u=m++;w[u]="(?:-("+w[v]+"(?:\\."+w[v]+")*))";var g=m++;w[g]="(?:-?("+w[l]+"(?:\\."+w[l]+")*))";var k=m++;w[k]="[0-9A-Za-z-]+";var S=m++;w[S]="(?:\\+("+w[k]+"(?:\\."+w[k]+")*))";var D=m++,i="v?"+w[h]+w[u]+"?"+w[S]+"?";w[D]="^"+i+"$";var r="[v=\\s]*"+w[d]+w[g]+"?"+w[S]+"?",n=m++;w[n]="^"+r+"$";var o=m++;w[o]="((?:<|>)?=?)";var a=m++;w[a]=w[y]+"|x|X|\\*";var c=m++;w[c]=w[p]+"|x|X|\\*";var s=m++;w[s]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[u]+")?"+w[S]+"?)?)?";var f=m++;w[f]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[g]+")?"+w[S]+"?)?)?";var C=m++;w[C]="^"+w[o]+"\\s*"+w[s]+"$";var L=m++;w[L]="^"+w[o]+"\\s*"+w[f]+"$";var O=m++;w[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=m++;w[j]="(?:~>?)";var K=m++;w[K]="(\\s*)"+w[j]+"\\s+",I[K]=new RegExp(w[K],"g");var V=m++;w[V]="^"+w[j]+w[s]+"$";var J=m++;w[J]="^"+w[j]+w[f]+"$";var re=m++;w[re]="(?:\\^)";var se=m++;w[se]="(\\s*)"+w[re]+"\\s+",I[se]=new RegExp(w[se],"g");var ae=m++;w[ae]="^"+w[re]+w[s]+"$";var fe=m++;w[fe]="^"+w[re]+w[f]+"$";var ge=m++;w[ge]="^"+w[o]+"\\s*("+r+")$|^$";var q=m++;w[q]="^"+w[o]+"\\s*("+i+")$|^$";var T=m++;w[T]="(\\s*)"+w[o]+"\\s*("+r+"|"+w[s]+")",I[T]=new RegExp(w[T],"g");var U=m++;w[U]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var z=m++;w[z]="^\\s*("+w[f]+")\\s+-\\s+("+w[f]+")\\s*$";var Q=m++;w[Q]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)P(ne,w[ne]),I[ne]||(I[ne]=new RegExp(w[ne]));function x(ie,ue){if(ie instanceof A)return ie;if(typeof ie!="string"||ie.length>R||!(ue?I[n]:I[D]).test(ie))return null;try{return new A(ie,ue)}catch{return null}}function A(ie,ue){if(ie instanceof A){if(ie.loose===ue)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof A))return new A(ie,ue);P("SemVer",ie,ue),this.loose=ue;var he=ie.trim().match(ue?I[n]:I[D]);if(!he)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<M)return Ce}return be}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=x,e.valid=function(ie,ue){var he=x(ie,ue);return he?he.version:null},e.clean=function(ie,ue){var he=x(ie.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=A,A.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},A.prototype.toString=function(){return this.version},A.prototype.compare=function(ie){return P("SemVer.compare",this.version,this.loose,ie),ie instanceof A||(ie=new A(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},A.prototype.compareMain=function(ie){return ie instanceof A||(ie=new A(ie,this.loose)),W(this.major,ie.major)||W(this.minor,ie.minor)||W(this.patch,ie.patch)},A.prototype.comparePre=function(ie){if(ie instanceof A||(ie=new A(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],be=ie.prerelease[ue];if(P("prerelease compare",ue,he,be),he===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(he===void 0)return-1;if(he!==be)return W(he,be)}while(++ue)},A.prototype.inc=function(ie,ue){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ue,he,be){typeof he=="string"&&(be=he,he=void 0);try{return new A(ie,he).inc(ue,be).version}catch{return null}},e.diff=function(ie,ue){if(B(ie,ue))return null;var he=x(ie),be=x(ue);if(he.prerelease.length||be.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==be[Ce])return Ce},e.compareIdentifiers=W;var F=/^[0-9]+$/;function W(ie,ue){var he=F.test(ie),be=F.test(ue);return he&&be&&(ie=+ie,ue=+ue),he&&!be?-1:be&&!he?1:ie<ue?-1:ie>ue?1:0}function N(ie,ue,he){return new A(ie,he).compare(new A(ue,he))}function $(ie,ue,he){return N(ie,ue,he)>0}function G(ie,ue,he){return N(ie,ue,he)<0}function B(ie,ue,he){return N(ie,ue,he)===0}function X(ie,ue,he){return N(ie,ue,he)!==0}function Z(ie,ue,he){return N(ie,ue,he)>=0}function oe(ie,ue,he){return N(ie,ue,he)<=0}function de(ie,ue,he,be){var Ce;switch(ue){case"===":typeof ie=="object"&&(ie=ie.version),typeof he=="object"&&(he=he.version),Ce=ie===he;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof he=="object"&&(he=he.version),Ce=ie!==he;break;case"":case"=":case"==":Ce=B(ie,he,be);break;case"!=":Ce=X(ie,he,be);break;case">":Ce=$(ie,he,be);break;case">=":Ce=Z(ie,he,be);break;case"<":Ce=G(ie,he,be);break;case"<=":Ce=oe(ie,he,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function ke(ie,ue){if(ie instanceof ke){if(ie.loose===ue)return ie;ie=ie.value}if(!(this instanceof ke))return new ke(ie,ue);P("comparator",ie,ue),this.loose=ue,this.parse(ie),this.semver===De?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ie,ue){return W(ue,ie)},e.major=function(ie,ue){return new A(ie,ue).major},e.minor=function(ie,ue){return new A(ie,ue).minor},e.patch=function(ie,ue){return new A(ie,ue).patch},e.compare=N,e.compareLoose=function(ie,ue){return N(ie,ue,!0)},e.rcompare=function(ie,ue,he){return N(ue,ie,he)},e.sort=function(ie,ue){return ie.sort(function(he,be){return e.compare(he,be,ue)})},e.rsort=function(ie,ue){return ie.sort(function(he,be){return e.rcompare(he,be,ue)})},e.gt=$,e.lt=G,e.eq=B,e.neq=X,e.gte=Z,e.lte=oe,e.cmp=de,e.Comparator=ke;var De={};function Pe(ie,ue){if(ie instanceof Pe)return ie.loose===ue?ie:new Pe(ie.raw,ue);if(ie instanceof ke)return new Pe(ie.value,ue);if(!(this instanceof Pe))return new Pe(ie,ue);if(this.loose=ue,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ae(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function ve(ie,ue,he,be,Ce,We,Te,qe,Ue,je,Xe,$e,Ke){return((ue=Ae(he)?"":Ae(be)?">="+he+".0.0":Ae(Ce)?">="+he+"."+be+".0":">="+ue)+" "+(qe=Ae(Ue)?"":Ae(je)?"<"+(+Ue+1)+".0.0":Ae(Xe)?"<"+Ue+"."+(+je+1)+".0":$e?"<="+Ue+"."+je+"."+Xe+"-"+$e:"<="+qe)).trim()}function me(ie,ue){for(var he=0;he<ie.length;he++)if(!ie[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<ie.length;he++)if(P(ie[he].semver),ie[he].semver!==De&&ie[he].semver.prerelease.length>0){var be=ie[he].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function ye(ie,ue,he){try{ue=new Pe(ue,he)}catch{return!1}return ue.test(ie)}function Me(ie,ue,he,be){var Ce,We,Te,qe,Ue;switch(ie=new A(ie,be),ue=new Pe(ue,be),he){case">":Ce=$,We=oe,Te=G,qe=">",Ue=">=";break;case"<":Ce=G,We=Z,Te=$,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(ie,ue,be))return!1;for(var je=0;je<ue.set.length;++je){var Xe=ue.set[je],$e=null,Ke=null;if(Xe.forEach(function(Y){Y.semver===De&&(Y=new ke(">=0.0.0")),$e=$e||Y,Ke=Ke||Y,Ce(Y.semver,$e.semver,be)?$e=Y:Te(Y.semver,Ke.semver,be)&&(Ke=Y)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(ie,Ke.semver)||Ke.operator===Ue&&Te(ie,Ke.semver))return!1}return!0}ke.prototype.parse=function(ie){var ue=this.loose?I[ge]:I[q],he=ie.match(ue);if(!he)throw new TypeError("Invalid comparator: "+ie);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new A(he[2],this.loose):this.semver=De},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(ie){return P("Comparator.test",ie,this.loose),this.semver===De||(typeof ie=="string"&&(ie=new A(ie,this.loose)),de(ie,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(ie,ue){if(!(ie instanceof ke))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Pe(ie.value,ue),ye(this.value,he,ue);if(ie.operator==="")return he=new Pe(this.value,ue),ye(ie.semver,he,ue);var be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),We=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),qe=de(this.semver,"<",ie.semver,ue)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ue=de(this.semver,">",ie.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return be||Ce||We&&Te||qe||Ue},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ie){var ue=this.loose;ie=ie.trim(),P("range",ie,ue);var he=ue?I[z]:I[U];ie=ie.replace(he,ve),P("hyphen replace",ie),ie=ie.replace(I[T],"$1$2$3"),P("comparator trim",ie,I[T]),ie=(ie=(ie=ie.replace(I[K],"$1~")).replace(I[se],"$1^")).split(/\s+/).join(" ");var be=ue?I[ge]:I[q],Ce=ie.split(" ").map(function(We){return function(Te,qe){return P("comp",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){P("caret",$e,Ke);var Y=Ke?I[fe]:I[ae];return $e.replace(Y,function(ce,le,we,Se,Oe){var Be;return P("caret",$e,ce,le,we,Se,Oe),Ae(le)?Be="":Ae(we)?Be=">="+le+".0.0 <"+(+le+1)+".0.0":Ae(Se)?Be=le==="0"?">="+le+"."+we+".0 <"+le+"."+(+we+1)+".0":">="+le+"."+we+".0 <"+(+le+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Be=le==="0"?we==="0"?">="+le+"."+we+"."+Se+Oe+" <"+le+"."+we+"."+(+Se+1):">="+le+"."+we+"."+Se+Oe+" <"+le+"."+(+we+1)+".0":">="+le+"."+we+"."+Se+Oe+" <"+(+le+1)+".0.0"):(P("no pr"),Be=le==="0"?we==="0"?">="+le+"."+we+"."+Se+" <"+le+"."+we+"."+(+Se+1):">="+le+"."+we+"."+Se+" <"+le+"."+(+we+1)+".0":">="+le+"."+we+"."+Se+" <"+(+le+1)+".0.0"),P("caret return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),P("caret",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var Y=Ke?I[J]:I[V];return $e.replace(Y,function(ce,le,we,Se,Oe){var Be;return P("tilde",$e,ce,le,we,Se,Oe),Ae(le)?Be="":Ae(we)?Be=">="+le+".0.0 <"+(+le+1)+".0.0":Ae(Se)?Be=">="+le+"."+we+".0 <"+le+"."+(+we+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Be=">="+le+"."+we+"."+Se+Oe+" <"+le+"."+(+we+1)+".0"):Be=">="+le+"."+we+"."+Se+" <"+le+"."+(+we+1)+".0",P("tilde return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),P("tildes",Te),Te=function(Ue,je){return P("replaceXRanges",Ue,je),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var Y=Ke?I[L]:I[C];return $e.replace(Y,function(ce,le,we,Se,Oe,Be){P("xRange",$e,ce,le,we,Se,Oe,Be);var it=Ae(we),xe=it||Ae(Se),He=xe||Ae(Oe);return le==="="&&He&&(le=""),it?ce=le===">"||le==="<"?"<0.0.0":"*":le&&He?(xe&&(Se=0),He&&(Oe=0),le===">"?(le=">=",xe?(we=+we+1,Se=0,Oe=0):He&&(Se=+Se+1,Oe=0)):le==="<="&&(le="<",xe?we=+we+1:Se=+Se+1),ce=le+we+"."+Se+"."+Oe):xe?ce=">="+we+".0.0 <"+(+we+1)+".0.0":He&&(ce=">="+we+"."+Se+".0 <"+we+"."+(+Se+1)+".0"),P("xRange return",ce),ce})}(Xe,je)}).join(" ")}(Te,qe),P("xrange",Te),Te=function(Ue,je){return P("replaceStars",Ue,je),Ue.trim().replace(I[Q],"")}(Te,qe),P("stars",Te),Te}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(We){return!!We.match(be)})),Ce=Ce.map(function(We){return new ke(We,ue)})},Pe.prototype.intersects=function(ie,ue){if(!(ie instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(be){return ie.set.some(function(Ce){return Ce.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(ie,ue){return new Pe(ie,ue).set.map(function(he){return he.map(function(be){return be.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new A(ie,this.loose));for(var ue=0;ue<this.set.length;ue++)if(me(this.set[ue],ie))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(ie,ue,he){var be=null,Ce=null;try{var We=new Pe(ue,he)}catch{return null}return ie.forEach(function(Te){We.test(Te)&&(be&&Ce.compare(Te)!==-1||(Ce=new A(be=Te,he)))}),be},e.minSatisfying=function(ie,ue,he){var be=null,Ce=null;try{var We=new Pe(ue,he)}catch{return null}return ie.forEach(function(Te){We.test(Te)&&(be&&Ce.compare(Te)!==1||(Ce=new A(be=Te,he)))}),be},e.validRange=function(ie,ue){try{return new Pe(ie,ue).range||"*"}catch{return null}},e.ltr=function(ie,ue,he){return Me(ie,ue,"<",he)},e.gtr=function(ie,ue,he){return Me(ie,ue,">",he)},e.outside=Me,e.prerelease=function(ie,ue){var he=x(ie,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(ie,ue,he){return ie=new Pe(ie,he),ue=new Pe(ue,he),ie.intersects(ue)},e.coerce=function(ie){if(ie instanceof A)return ie;if(typeof ie!="string")return null;var ue=ie.match(I[O]);return ue==null?null:x((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,E(1))},function(H,e){var E,t,P=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function I(l){if(E===setTimeout)return setTimeout(l,0);if((E===R||!E)&&setTimeout)return E=setTimeout,setTimeout(l,0);try{return E(l,0)}catch{try{return E.call(null,l,0)}catch{return E.call(this,l,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:R}catch{E=R}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var w,m=[],p=!1,y=-1;function b(){p&&w&&(p=!1,w.length?m=w.concat(m):y=-1,m.length&&h())}function h(){if(!p){var l=I(b);p=!0;for(var u=m.length;u;){for(w=m,m=[];++y<u;)w&&w[y].run();y=-1,u=m.length}w=null,p=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(l)}}function d(l,u){this.fun=l,this.array=u}function v(){}P.nextTick=function(l){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];m.push(new d(l,u)),m.length!==1||p||I(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(l){return[]},P.binding=function(l){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(l){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ee[128],te([0,1]),function(H,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,w,m){this.level=I,this.key=w,this.value=m,this.forward=[]}}const P=void 0;class R{constructor(I,w=2**16){this.comparator=I,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new t(this.c,P,P)}get size(){return this.f}clear(){this.e=new t(this.c,P,P)}has(I){return Boolean(R.g(this,I,this.comparator))}get(I){return R.g(this,I,this.comparator)?.value}set(I,w){return R.h(this,I,w,this.comparator)&&(this.f+=1),this}delete(I){const w=R.k(this,I,this.comparator);return w&&(this.f-=1),w}forEach(I,w){let m=this.e.forward[0];for(;m;)I.call(w,m.value,m.key,this),m=m.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",w=this.e.forward[0];for(;w;)I+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return I}static g(I,w,m){let p=I.e;for(let y=I.d-1;y>=0;y--)for(;p.forward[y]&&m(p.forward[y].key,w)<0;)p=p.forward[y];if(p=p.forward[0],p&&m(p.key,w)===0)return p}static h(I,w,m,p){const y=[];let b=I.e;for(let h=I.d-1;h>=0;h--){for(;b.forward[h]&&p(b.forward[h].key,w)<0;)b=b.forward[h];y[h]=b}if(b=b.forward[0],b&&p(b.key,w)===0)return b.value=m,!1;{const h=R.j(I);if(h>I.d){for(let d=I.d;d<h;d++)y[d]=I.e;I.d=h}b=new t(h,w,m);for(let d=0;d<h;d++)b.forward[d]=y[d].forward[d],y[d].forward[d]=b;return!0}}static j(I,w=.5){let m=1;for(;Math.random()<w&&m<I.c;)m+=1;return m}static k(I,w,m){const p=[];let y=I.e;for(let b=I.d-1;b>=0;b--){for(;y.forward[b]&&m(y.forward[b].key,w)<0;)y=y.forward[b];p[b]=y}if(y=y.forward[0],!y||m(y.key,w)!==0)return!1;for(let b=0;b<I.d&&p[b].forward[b]===y;b++)p[b].forward[b]=y.forward[b];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.SkipList=R}),define(ee[59],te([0,1,13,2]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(S){const D=S;return D?typeof D.read=="function":!1}e.isReadable=P;function R(S){const D=S;return D?[D.on,D.pause,D.resume,D.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function M(S){const D=S;return D?R(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=M;function I(S,D){return new w(S,D)}e.newWriteableStream=I;class w{constructor(D,i){this.e=D,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(i=>i(D))}h(D){this.c.error.length===0?(0,E.onUnexpectedError)(D):this.c.error.slice(0).forEach(i=>i(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,i){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(D,i){if(this.a.destroyed)return;let r;switch(D){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(S,D){const i=[];let r;for(;(r=S.read())!==null;)i.push(r);return D(i)}e.consumeReadable=m;function p(S,D,i){const r=[];let n;for(;(n=S.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?D(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return S.read()}}}e.peekReadable=p;function y(S,D){return new Promise((i,r)=>{const n=[];b(S,{onData:o=>{D&&n.push(o)},onError:o=>{D?r(o):i(void 0)},onEnd:()=>{i(D?D(n):void 0)}})})}e.consumeStream=y;function b(S,D){let i=!1;return S.on("error",r=>{i||D.onError(r)}),S.on("end",()=>{i||D.onEnd()}),S.on("data",r=>{i||D.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=b;function h(S,D){return new Promise((i,r)=>{const n=new t.DisposableStore,o=[],a=f=>{if(o.push(f),o.length>D)return n.dispose(),S.pause(),i({stream:S,buffer:o,ended:!1})},c=f=>r(f),s=()=>i({stream:S,buffer:o,ended:!0});n.add((0,t.toDisposable)(()=>S.removeListener("error",c))),S.on("error",c),n.add((0,t.toDisposable)(()=>S.removeListener("end",s))),S.on("end",s),n.add((0,t.toDisposable)(()=>S.removeListener("data",a))),S.on("data",a)})}e.peekStream=h;function d(S,D){const i=I(D);return i.end(S),i}e.toStream=d;function v(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=v;function l(S){let D=!1;return{read:()=>D?null:(D=!0,S)}}e.toReadable=l;function u(S,D,i){const r=I(i);return b(S,{onData:n=>r.write(D.data(n)),onError:n=>r.error(D.error?D.error(n):n),onEnd:()=>r.end()}),r}e.transform=u;function g(S,D,i){let r=!1;return{read:()=>{const n=D.read();return r?n:(r=!0,n!==null?i([S,n]):S)}}}e.prefixedReadable=g;function k(S,D,i){let r=!1;const n=I(i);return b(D,{onData:o=>r?n.write(o):(r=!0,n.write(i([S,o]))),onError:o=>n.error(o),onEnd:()=>{r||(r=!0,n.write(S)),n.end()}}),n}e.prefixedStream=k}),define(ee[17],te([0,1,59]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let P,R;class M{static alloc(f){return t?new M(Buffer.allocUnsafe(f)):new M(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new M(f)}static fromString(f,C){return!(C?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(f)):(P||(P=new TextEncoder),new M(P.encode(f)))}static fromByteArray(f){const C=M.alloc(f.length);for(let L=0,O=f.length;L<O;L++)C.buffer[L]=f[L];return C}static concat(f,C){if(typeof C>"u"){C=0;for(let j=0,K=f.length;j<K;j++)C+=f[j].byteLength}const L=M.alloc(C);let O=0;for(let j=0,K=f.length;j<K;j++){const V=f[j];L.set(V,O),O+=V.byteLength}return L}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=M.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(f,C){return new M(this.buffer.subarray(f,C))}set(f,C){if(f instanceof M)this.buffer.set(f.buffer,C);else if(f instanceof Uint8Array)this.buffer.set(f,C);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),C);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return m(this.buffer,f)}writeUInt32BE(f,C){p(this.buffer,f,C)}readUInt32LE(f){return y(this.buffer,f)}writeUInt32LE(f,C){b(this.buffer,f,C)}readUInt8(f){return h(this.buffer,f)}writeUInt8(f,C){d(this.buffer,f,C)}}e.VSBuffer=M;function I(s,f){return s[f+0]<<0>>>0|s[f+1]<<8>>>0}e.readUInt16LE=I;function w(s,f,C){s[C+0]=f&255,f=f>>>8,s[C+1]=f&255}e.writeUInt16LE=w;function m(s,f){return s[f]*2**24+s[f+1]*2**16+s[f+2]*2**8+s[f+3]}e.readUInt32BE=m;function p(s,f,C){s[C+3]=f,f=f>>>8,s[C+2]=f,f=f>>>8,s[C+1]=f,f=f>>>8,s[C]=f}e.writeUInt32BE=p;function y(s,f){return s[f+0]<<0>>>0|s[f+1]<<8>>>0|s[f+2]<<16>>>0|s[f+3]<<24>>>0}e.readUInt32LE=y;function b(s,f,C){s[C+0]=f&255,f=f>>>8,s[C+1]=f&255,f=f>>>8,s[C+2]=f&255,f=f>>>8,s[C+3]=f&255}e.writeUInt32LE=b;function h(s,f){return s[f]}e.readUInt8=h;function d(s,f,C){s[C]=f}e.writeUInt8=d;function v(s){return E.consumeReadable(s,f=>M.concat(f))}e.readableToBuffer=v;function l(s){return E.toReadable(s)}e.bufferToReadable=l;function u(s){return E.consumeStream(s,f=>M.concat(f))}e.streamToBuffer=u;async function g(s){return s.ended?M.concat(s.buffer):M.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=g;function k(s){return E.toStream(s,f=>M.concat(f))}e.bufferToStream=k;function S(s){return E.transform(s,{data:f=>typeof f=="string"?M.fromString(f):M.wrap(f)},f=>M.concat(f))}e.streamToBufferReadableStream=S;function D(s){return E.newWriteableStream(f=>M.concat(f),s)}e.newWriteableBufferStream=D;function i(s,f){return E.prefixedReadable(s,f,C=>M.concat(C))}e.prefixedBufferReadable=i;function r(s,f){return E.prefixedStream(s,f,C=>M.concat(C))}e.prefixedBufferStream=r;function n(s){let f=0,C=0,L=0;const O=new Uint8Array(Math.floor(s.length/4*3)),j=V=>{switch(C){case 3:O[L++]=f|V,C=0;break;case 2:O[L++]=f|V>>>2,f=V<<6,C=3;break;case 1:O[L++]=f|V>>>4,f=V<<4,C=2;break;default:f=V<<2,C=1}};for(let V=0;V<s.length;V++){const J=s.charCodeAt(V);if(J>=65&&J<=90)j(J-65);else if(J>=97&&J<=122)j(J-97+26);else if(J>=48&&J<=57)j(J-48+52);else if(J===43||J===45)j(62);else if(J===47||J===95)j(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${s[V]}`)}}const K=L;for(;C>0;)j(0);return M.wrap(O).slice(0,K)}e.decodeBase64=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:s},f=!0,C=!1){const L=C?a:o;let O="";const j=s.byteLength%3;let K=0;for(;K<s.byteLength-j;K+=3){const V=s[K+0],J=s[K+1],re=s[K+2];O+=L[V>>>2],O+=L[(V<<4|J>>>4)&63],O+=L[(J<<2|re>>>6)&63],O+=L[re&63]}if(j===1){const V=s[K+0];O+=L[V>>>2],O+=L[V<<4&63],f&&(O+="==")}else if(j===2){const V=s[K+0],J=s[K+1];O+=L[V>>>2],O+=L[(V<<4|J>>>4)&63],O+=L[J<<2&63],f&&(O+="=")}return O}e.encodeBase64=c}),define(ee[11],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function t(r){return Array.isArray(r)&&r.every(n=>E(n))}e.isStringArray=t;function P(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=P;function R(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=R;function M(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=M;function I(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=I;function w(r){return r===!0||r===!1}e.isBoolean=w;function m(r){return typeof r>"u"}e.isUndefined=m;function p(r){return!y(r)}e.isDefined=p;function y(r){return m(r)||r===null}e.isUndefinedOrNull=y;function b(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=b;function h(r){if(y(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=h;function d(...r){const n=[];for(let o=0;o<r.length;o++){const a=r[o];if(y(a))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(a)}return n}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function l(r){if(!P(r))return!1;for(const n in r)if(v.call(r,n))return!1;return!0}e.isEmptyObject=l;function u(r){return typeof r=="function"}e.isFunction=u;function g(...r){return r.length>0&&r.every(u)}e.areFunctions=g;function k(r,n){const o=Math.min(r.length,n.length);for(let a=0;a<o;a++)S(r[a],n[a])}e.validateConstraints=k;function S(r,n){if(E(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(r instanceof n)return}catch{}if(!y(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function D(r){return r===null?void 0:r}e.withNullAsUndefined=D;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(ee[44],te([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([k,S])=>{g[k]=S&&typeof S=="object"?t(S):S}),g}e.deepClone=t;function P(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const k=g.shift();Object.freeze(k);for(const S in k)if(R.call(k,S)){const D=k[S];typeof D=="object"&&!Object.isFrozen(D)&&!(0,E.isTypedArray)(D)&&g.push(D)}}return u}e.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function M(u,g){return I(u,g,new Set)}e.cloneAndChange=M;function I(u,g,k){if((0,E.isUndefinedOrNull)(u))return u;const S=g(u);if(typeof S<"u")return S;if(Array.isArray(u)){const D=[];for(const i of u)D.push(I(i,g,k));return D}if((0,E.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const D={};for(const i in u)R.call(u,i)&&(D[i]=I(u[i],g,k));return k.delete(u),D}return u}function w(u,g,k=!0){return(0,E.isObject)(u)?((0,E.isObject)(g)&&Object.keys(g).forEach(S=>{S in u?k&&((0,E.isObject)(u[S])&&(0,E.isObject)(g[S])?w(u[S],g[S],k):u[S]=g[S]):u[S]=g[S]}),u):g}e.mixin=w;function m(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let k,S;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(k=0;k<u.length;k++)if(!m(u[k],g[k]))return!1}else{const D=[];for(S in u)D.push(S);D.sort();const i=[];for(S in g)i.push(S);if(i.sort(),!m(D,i))return!1;for(k=0;k<D.length;k++)if(!m(u[D[k]],g[D[k]]))return!1}return!0}e.equals=m;function p(u){const g=new Set;return JSON.stringify(u,(k,S)=>{if((0,E.isObject)(S)||Array.isArray(S)){if(g.has(S))return"[Circular]";g.add(S)}return S})}e.safeStringify=p;function y(u,g){const k=Object.create(null);return!u||!g||Object.keys(g).forEach(D=>{const i=u[D],r=g[D];m(i,r)||(k[D]=r)}),k}e.distinct=y;function b(u,g){const k=g.toLowerCase(),S=Object.keys(u).find(D=>D.toLowerCase()===k);return S?u[S]:u[g]}e.getCaseInsensitive=b;function h(u,g){const k=Object.create(null);for(const[S,D]of Object.entries(u))g(S,D)&&(k[S]=D);return k}e.filter=h;function d(u){let g=[],k=Object.getPrototypeOf(u);for(;Object.prototype!==k;)g=g.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return g}e.getAllPropertyNames=d;function v(u){const g=[];for(const k of d(u))typeof u[k]=="function"&&g.push(k);return g}e.getAllMethodNames=v;function l(u,g){const k=D=>function(){const i=Array.prototype.slice.call(arguments,0);return g(D,i)},S={};for(const D of u)S[D]=k(D);return S}e.createProxyObject=l}),define(ee[31],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return E.test(P)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),M=[];for(let I=0;I<256;I++)M.push(I.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,m="";return m+=M[R[w++]],m+=M[R[w++]],m+=M[R[w++]],m+=M[R[w++]],m+="-",m+=M[R[w++]],m+=M[R[w++]],m+="-",m+=M[R[w++]],m+=M[R[w++]],m+="-",m+=M[R[w++]],m+=M[R[w++]],m+="-",m+=M[R[w++]],m+=M[R[w++]],m+=M[R[w++]],m+=M[R[w++]],m+=M[R[w++]],m+=M[R[w++]],m}}()}),define(ee[129],te([0,1,79,41,50]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,I){if(await new Promise((p,y)=>{const b=t.createReadStream(M),h=E.createHash("sha1");b.pipe(h);const d=(0,P.once)((v,l)=>{b.removeAllListeners(),h.removeAllListeners(),v?y(v):p(l)});b.once("error",d),b.once("end",d),h.once("error",d),h.once("data",v=>d(void 0,v.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=R}),define(ee[130],te([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(M){const I=M.replace(/\-/g,":").toLowerCase();return!t.has(I)}function R(){const M=(0,E.networkInterfaces)();for(const I in M){const w=M[I];if(w){for(const{mac:m}of w)if(P(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ee[98],te([0,1,80]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,w,m,p=1){let y=!1;return new Promise(b=>{const h=setTimeout(()=>{if(!y)return y=!0,b(0)},m);P(I,w,p,d=>{if(!y)return y=!0,clearTimeout(h),b(d)})})}e.findFreePort=t;function P(I,w,m,p){if(w===0)return p(0);const y=new E.Socket;y.once("connect",()=>(M(y),P(I+m,w-1,m,p))),y.once("data",()=>{}),y.once("error",b=>(M(y),b.code!=="ECONNREFUSED"?P(I+m,w-1,m,p):p(I))),y.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,w,m,p="127.0.0.1"){let y=!1,b,h=1;const d=E.createServer({pauseOnConnect:!0});function v(l,u){y||(y=!0,d.removeAllListeners(),d.close(),b&&clearTimeout(b),u(l))}return new Promise(l=>{b=setTimeout(()=>{v(0,l)},m),d.on("listening",()=>{v(I,l)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<w?(I++,h++,d.listen(I,p)):v(0,l)}),d.on("close",()=>{v(0,l)}),d.listen(I,p)})}e.findFreePortFaster=R;function M(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(w){console.error(w)}}}),define(ee[131],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[132],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(P,R){this.a=P,this.onMessage=R}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[42],te([0,1,14,13]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class P{constructor(){this.a=new WeakMap}on(M,I){const w=(m,...p)=>{this.b(M,m)&&I(m,...p)};return this.a.set(I,w),E.ipcMain.on(M,w),this}once(M,I){return E.ipcMain.once(M,(w,...m)=>{this.b(M,w)&&I(w,...m)}),this}handle(M,I){return E.ipcMain.handle(M,(w,...m)=>this.b(M,w)?I(w,...m):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return E.ipcMain.removeHandler(M),this}removeListener(M,I){const w=this.a.get(I);return w&&(E.ipcMain.removeListener(M,w),this.a.delete(I)),this}b(M,I){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const w=I.senderFrame,m=w.url;if(!m)return!0;let p="unknown";try{p=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${m}'.`),!1}return p!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${p}'.`),!1):w.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new P}),define(ee[133],te([0,1,14,42,11,131]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(w,m,p,y,b)=>{const h=I(w,y,p);h.popup({window:(0,P.withNullAsUndefined)(E.BrowserWindow.fromWebContents(w.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{h&&w.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=M;function I(w,m,p){const y=new E.Menu;return p.forEach(b=>{let h;b.type==="separator"?h=new E.MenuItem({type:b.type}):Array.isArray(b.submenu)?h=new E.MenuItem({submenu:I(w,m,b.submenu),label:b.label}):h=new E.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(d,v,l)=>w.sender.send(m,b.id,l)}),y.append(h)}),y}}),define(ee[99],te([0,1,14]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=E.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[134],te([12,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(ee[135],te([0,1,134]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,P=t*60,R=P*24,M=R*7,I=R*30,w=R*365;function m(y,b,h,d){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,E.localize)(0,null,m(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,E.localize)(1,null);let l;return v<t?(l=v,b?l===1?h?(0,E.localize)(2,null,l):(0,E.localize)(3,null,l):h?(0,E.localize)(4,null,l):(0,E.localize)(5,null,l):l===1?h?(0,E.localize)(6,null,l):(0,E.localize)(7,null,l):h?(0,E.localize)(8,null,l):(0,E.localize)(9,null,l)):v<P?(l=Math.floor(v/t),b?l===1?h?(0,E.localize)(10,null,l):(0,E.localize)(11,null,l):h?(0,E.localize)(12,null,l):(0,E.localize)(13,null,l):l===1?h?(0,E.localize)(14,null,l):(0,E.localize)(15,null,l):h?(0,E.localize)(16,null,l):(0,E.localize)(17,null,l)):v<R?(l=Math.floor(v/P),b?l===1?h?(0,E.localize)(18,null,l):(0,E.localize)(19,null,l):h?(0,E.localize)(20,null,l):(0,E.localize)(21,null,l):l===1?h?(0,E.localize)(22,null,l):(0,E.localize)(23,null,l):h?(0,E.localize)(24,null,l):(0,E.localize)(25,null,l)):v<M?(l=Math.floor(v/R),b?l===1?(0,E.localize)(26,null,l):(0,E.localize)(27,null,l):l===1?(0,E.localize)(28,null,l):(0,E.localize)(29,null,l)):v<I?(l=Math.floor(v/M),b?l===1?h?(0,E.localize)(30,null,l):(0,E.localize)(31,null,l):h?(0,E.localize)(32,null,l):(0,E.localize)(33,null,l):l===1?h?(0,E.localize)(34,null,l):(0,E.localize)(35,null,l):h?(0,E.localize)(36,null,l):(0,E.localize)(37,null,l)):v<w?(l=Math.floor(v/I),b?l===1?h?(0,E.localize)(38,null,l):(0,E.localize)(39,null,l):h?(0,E.localize)(40,null,l):(0,E.localize)(41,null,l):l===1?h?(0,E.localize)(42,null,l):(0,E.localize)(43,null,l):h?(0,E.localize)(44,null,l):(0,E.localize)(45,null,l)):(l=Math.floor(v/w),b?l===1?h?(0,E.localize)(46,null,l):(0,E.localize)(47,null,l):h?(0,E.localize)(48,null,l):(0,E.localize)(49,null,l):l===1?h?(0,E.localize)(50,null,l):(0,E.localize)(51,null,l):h?(0,E.localize)(52,null,l):(0,E.localize)(53,null,l))}e.fromNow=m;function p(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(ee[136],te([12,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ee[45],te([0,1,25,11,136]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(y,b){return b&&(y.stack||y.stacktrace)?P.localize(0,null,I(y),M(y.stack)||M(y.stacktrace)):I(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(1,null,y.message):y.message||P.localize(2,null)}function w(y=null,b=!1){if(!y)return P.localize(3,null);if(Array.isArray(y)){const h=E.coalesce(y),d=w(h[0],b);return h.length>1?P.localize(4,null,d,h.length):d}if(t.isString(y))return y;if(y.detail){const h=y.detail;if(h.error)return R(h.error,b);if(h.exception)return R(h.exception,b)}return y.stack?R(y,b):y.message?y.message:P.localize(5,null)}e.toErrorMessage=w;function m(y){const b=y;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=m;function p(y,b){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=b,h}e.createErrorWithActions=p}),define(ee[137],te([12,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ee[138],te([0,1,137]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(P){switch(P){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[139],te([12,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,139]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,P=!1,R=!1,M=!1,I=!1,w=!1,m=!1,p=!1,y=!1,b=!1,h,d=e.LANGUAGE_DEFAULT,v,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",k=g&&u?.type==="renderer";if(typeof navigator=="object"&&!k)l=navigator.userAgent,t=l.indexOf("Windows")>=0,P=l.indexOf("Macintosh")>=0,p=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=l.indexOf("Linux")>=0,b=l?.indexOf("Mobi")>=0,w=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,d=h;else if(typeof u=="object"){t=u.platform==="win32",P=u.platform==="darwin",R=u.platform==="linux",M=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=g,y=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const f=JSON.parse(s),C=f.availableLanguages["*"];h=f.locale,d=C||e.LANGUAGE_DEFAULT,v=f._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var S;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function D(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let i=0;P?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=P,e.isLinux=R,e.isLinuxSnap=M,e.isNative=I,e.isElectron=m,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=b,e.isCI=y,e.platform=i,e.userAgent=l,e.language=d;var r;(function(s){function f(){return e.language}s.value=f;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=C;function L(){return e.language==="en"}s.isDefault=L})(r=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let L=0,O=s.length;L<O;L++){const j=s[L];if(j.id===C.data.vscodeScheduleAsyncWork){s.splice(L,1),j.callback();return}}});let f=0;return C=>{const L=++f;s.push({id:L,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return s=>setTimeout(s)})();var n;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||p?2:t?1:3;let o=!0,a=!1;function c(){if(!a){a=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[35],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const P=E.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,35]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,P=97,R=90,M=122,I=46,w=47,m=92,p=58,y=63;class b extends Error{constructor(r,n,o){let a;typeof n=="string"&&n.indexOf("not ")===0?(a="must not be",n=n.replace(/^not /,"")):a="must be";const c=r.indexOf(".")!==-1?"property":"argument";let s=`The "${r}" ${c} ${a} of type ${n}`;s+=`. Received type ${typeof o}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,r){if(i===null||typeof i!="object")throw new b(r,"Object",i)}function d(i,r){if(typeof i!="string")throw new b(r,"string",i)}const v=E.platform==="win32";function l(i){return i===w||i===m}function u(i){return i===w}function g(i){return i>=t&&i<=R||i>=P&&i<=M}function k(i,r,n,o){let a="",c=0,s=-1,f=0,C=0;for(let L=0;L<=i.length;++L){if(L<i.length)C=i.charCodeAt(L);else{if(o(C))break;C=w}if(o(C)){if(!(s===L-1||f===1))if(f===2){if(a.length<2||c!==2||a.charCodeAt(a.length-1)!==I||a.charCodeAt(a.length-2)!==I){if(a.length>2){const O=a.lastIndexOf(n);O===-1?(a="",c=0):(a=a.slice(0,O),c=a.length-1-a.lastIndexOf(n)),s=L,f=0;continue}else if(a.length!==0){a="",c=0,s=L,f=0;continue}}r&&(a+=a.length>0?`${n}..`:"..",c=2)}else a.length>0?a+=`${n}${i.slice(s+1,L)}`:a=i.slice(s+1,L),c=L-s-1;s=L,f=0}else C===I&&f!==-1?++f:f=-1}return a}function S(i,r){h(r,"pathObject");const n=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${o}`:`${n}${i}${o}`:o}e.win32={resolve(...i){let r="",n="",o=!1;for(let a=i.length-1;a>=-1;a--){let c;if(a>=0){if(c=i[a],d(c,"path"),c.length===0)continue}else r.length===0?c=E.cwd():(c=E.env[`=${r}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===m)&&(c=`${r}\\`));const s=c.length;let f=0,C="",L=!1;const O=c.charCodeAt(0);if(s===1)l(O)&&(f=1,L=!0);else if(l(O))if(L=!0,l(c.charCodeAt(1))){let j=2,K=j;for(;j<s&&!l(c.charCodeAt(j));)j++;if(j<s&&j!==K){const V=c.slice(K,j);for(K=j;j<s&&l(c.charCodeAt(j));)j++;if(j<s&&j!==K){for(K=j;j<s&&!l(c.charCodeAt(j));)j++;(j===s||j!==K)&&(C=`\\\\${V}\\${c.slice(K,j)}`,f=j)}}}else f=1;else g(O)&&c.charCodeAt(1)===p&&(C=c.slice(0,2),f=2,s>2&&l(c.charCodeAt(2))&&(L=!0,f=3));if(C.length>0)if(r.length>0){if(C.toLowerCase()!==r.toLowerCase())continue}else r=C;if(o){if(r.length>0)break}else if(n=`${c.slice(f)}\\${n}`,o=L,L&&r.length>0)break}return n=k(n,!o,"\\",l),o?`${r}\\${n}`:`${r}${n}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let n=0,o,a=!1;const c=i.charCodeAt(0);if(r===1)return u(c)?"\\":i;if(l(c))if(a=!0,l(i.charCodeAt(1))){let f=2,C=f;for(;f<r&&!l(i.charCodeAt(f));)f++;if(f<r&&f!==C){const L=i.slice(C,f);for(C=f;f<r&&l(i.charCodeAt(f));)f++;if(f<r&&f!==C){for(C=f;f<r&&!l(i.charCodeAt(f));)f++;if(f===r)return`\\\\${L}\\${i.slice(C)}\\`;f!==C&&(o=`\\\\${L}\\${i.slice(C,f)}`,n=f)}}}else n=1;else g(c)&&i.charCodeAt(1)===p&&(o=i.slice(0,2),n=2,r>2&&l(i.charCodeAt(2))&&(a=!0,n=3));let s=n<r?k(i.slice(n),!a,"\\",l):"";return s.length===0&&!a&&(s="."),s.length>0&&l(i.charCodeAt(r-1))&&(s+="\\"),o===void 0?a?`\\${s}`:s:a?`${o}\\${s}`:`${o}${s}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const n=i.charCodeAt(0);return l(n)||r>2&&g(n)&&i.charCodeAt(1)===p&&l(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,n;for(let c=0;c<i.length;++c){const s=i[c];d(s,"path"),s.length>0&&(r===void 0?r=n=s:r+=`\\${s}`)}if(r===void 0)return".";let o=!0,a=0;if(typeof n=="string"&&l(n.charCodeAt(0))){++a;const c=n.length;c>1&&l(n.charCodeAt(1))&&(++a,c>2&&(l(n.charCodeAt(2))?++a:o=!1))}if(o){for(;a<r.length&&l(r.charCodeAt(a));)a++;a>=2&&(r=`\\${r.slice(a)}`)}return e.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const n=e.win32.resolve(i),o=e.win32.resolve(r);if(n===o||(i=n.toLowerCase(),r=o.toLowerCase(),i===r))return"";let a=0;for(;a<i.length&&i.charCodeAt(a)===m;)a++;let c=i.length;for(;c-1>a&&i.charCodeAt(c-1)===m;)c--;const s=c-a;let f=0;for(;f<r.length&&r.charCodeAt(f)===m;)f++;let C=r.length;for(;C-1>f&&r.charCodeAt(C-1)===m;)C--;const L=C-f,O=s<L?s:L;let j=-1,K=0;for(;K<O;K++){const J=i.charCodeAt(a+K);if(J!==r.charCodeAt(f+K))break;J===m&&(j=K)}if(K!==O){if(j===-1)return o}else{if(L>O){if(r.charCodeAt(f+K)===m)return o.slice(f+K+1);if(K===2)return o.slice(f+K)}s>O&&(i.charCodeAt(a+K)===m?j=K:K===2&&(j=3)),j===-1&&(j=0)}let V="";for(K=a+j+1;K<=c;++K)(K===c||i.charCodeAt(K)===m)&&(V+=V.length===0?"..":"\\..");return f+=j,V.length>0?`${V}${o.slice(f,C)}`:(o.charCodeAt(f)===m&&++f,o.slice(f,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===m){if(r.charCodeAt(1)===m){const n=r.charCodeAt(2);if(n!==y&&n!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===p&&r.charCodeAt(2)===m)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let n=-1,o=0;const a=i.charCodeAt(0);if(r===1)return l(a)?i:".";if(l(a)){if(n=o=1,l(i.charCodeAt(1))){let f=2,C=f;for(;f<r&&!l(i.charCodeAt(f));)f++;if(f<r&&f!==C){for(C=f;f<r&&l(i.charCodeAt(f));)f++;if(f<r&&f!==C){for(C=f;f<r&&!l(i.charCodeAt(f));)f++;if(f===r)return i;f!==C&&(n=o=f+1)}}}}else g(a)&&i.charCodeAt(1)===p&&(n=r>2&&l(i.charCodeAt(2))?3:2,o=n);let c=-1,s=!0;for(let f=r-1;f>=o;--f)if(l(i.charCodeAt(f))){if(!s){c=f;break}}else s=!1;if(c===-1){if(n===-1)return".";c=n}return i.slice(0,c)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,o=-1,a=!0,c;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===p&&(n=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,f=-1;for(c=i.length-1;c>=n;--c){const C=i.charCodeAt(c);if(l(C)){if(!a){n=c+1;break}}else f===-1&&(a=!1,f=c+1),s>=0&&(C===r.charCodeAt(s)?--s===-1&&(o=c):(s=-1,o=f))}return n===o?o=f:o===-1&&(o=i.length),i.slice(n,o)}for(c=i.length-1;c>=n;--c)if(l(i.charCodeAt(c))){if(!a){n=c+1;break}}else o===-1&&(a=!1,o=c+1);return o===-1?"":i.slice(n,o)},extname(i){d(i,"path");let r=0,n=-1,o=0,a=-1,c=!0,s=0;i.length>=2&&i.charCodeAt(1)===p&&g(i.charCodeAt(0))&&(r=o=2);for(let f=i.length-1;f>=r;--f){const C=i.charCodeAt(f);if(l(C)){if(!c){o=f+1;break}continue}a===-1&&(c=!1,a=f+1),C===I?n===-1?n=f:s!==1&&(s=1):n!==-1&&(s=-1)}return n===-1||a===-1||s===0||s===1&&n===a-1&&n===o+1?"":i.slice(n,a)},format:S.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.length;let o=0,a=i.charCodeAt(0);if(n===1)return l(a)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(l(a)){if(o=1,l(i.charCodeAt(1))){let j=2,K=j;for(;j<n&&!l(i.charCodeAt(j));)j++;if(j<n&&j!==K){for(K=j;j<n&&l(i.charCodeAt(j));)j++;if(j<n&&j!==K){for(K=j;j<n&&!l(i.charCodeAt(j));)j++;j===n?o=j:j!==K&&(o=j+1)}}}}else if(g(a)&&i.charCodeAt(1)===p){if(n<=2)return r.root=r.dir=i,r;if(o=2,l(i.charCodeAt(2))){if(n===3)return r.root=r.dir=i,r;o=3}}o>0&&(r.root=i.slice(0,o));let c=-1,s=o,f=-1,C=!0,L=i.length-1,O=0;for(;L>=o;--L){if(a=i.charCodeAt(L),l(a)){if(!C){s=L+1;break}continue}f===-1&&(C=!1,f=L+1),a===I?c===-1?c=L:O!==1&&(O=1):c!==-1&&(O=-1)}return f!==-1&&(c===-1||O===0||O===1&&c===f-1&&c===s+1?r.base=r.name=i.slice(s,f):(r.name=i.slice(s,c),r.base=i.slice(s,f),r.ext=i.slice(c,f))),s>0&&s!==o?r.dir=i.slice(0,s-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(v){const i=/\\/g;return()=>{const r=E.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...i){let r="",n=!1;for(let o=i.length-1;o>=-1&&!n;o--){const a=o>=0?i[o]:D();d(a,"path"),a.length!==0&&(r=`${a}/${r}`,n=a.charCodeAt(0)===w)}return r=k(r,!n,"/",u),n?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===w,n=i.charCodeAt(i.length-1)===w;return i=k(i,!r,"/",u),i.length===0?r?"/":n?"./":".":(n&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===w},join(...i){if(i.length===0)return".";let r;for(let n=0;n<i.length;++n){const o=i[n];d(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const n=1,o=i.length,a=o-n,c=1,s=r.length-c,f=a<s?a:s;let C=-1,L=0;for(;L<f;L++){const j=i.charCodeAt(n+L);if(j!==r.charCodeAt(c+L))break;j===w&&(C=L)}if(L===f)if(s>f){if(r.charCodeAt(c+L)===w)return r.slice(c+L+1);if(L===0)return r.slice(c+L)}else a>f&&(i.charCodeAt(n+L)===w?C=L:L===0&&(C=0));let O="";for(L=n+C+1;L<=o;++L)(L===o||i.charCodeAt(L)===w)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(c+C)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===w;let n=-1,o=!0;for(let a=i.length-1;a>=1;--a)if(i.charCodeAt(a)===w){if(!o){n=a;break}}else o=!1;return n===-1?r?"/":".":r&&n===1?"//":i.slice(0,n)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,o=-1,a=!0,c;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,f=-1;for(c=i.length-1;c>=0;--c){const C=i.charCodeAt(c);if(C===w){if(!a){n=c+1;break}}else f===-1&&(a=!1,f=c+1),s>=0&&(C===r.charCodeAt(s)?--s===-1&&(o=c):(s=-1,o=f))}return n===o?o=f:o===-1&&(o=i.length),i.slice(n,o)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===w){if(!a){n=c+1;break}}else o===-1&&(a=!1,o=c+1);return o===-1?"":i.slice(n,o)},extname(i){d(i,"path");let r=-1,n=0,o=-1,a=!0,c=0;for(let s=i.length-1;s>=0;--s){const f=i.charCodeAt(s);if(f===w){if(!a){n=s+1;break}continue}o===-1&&(a=!1,o=s+1),f===I?r===-1?r=s:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||o===-1||c===0||c===1&&r===o-1&&r===n+1?"":i.slice(r,o)},format:S.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.charCodeAt(0)===w;let o;n?(r.root="/",o=1):o=0;let a=-1,c=0,s=-1,f=!0,C=i.length-1,L=0;for(;C>=o;--C){const O=i.charCodeAt(C);if(O===w){if(!f){c=C+1;break}continue}s===-1&&(f=!1,s=C+1),O===I?a===-1?a=C:L!==1&&(L=1):a!==-1&&(L=-1)}if(s!==-1){const O=c===0&&n?1:c;a===-1||L===0||L===1&&a===s-1&&a===c+1?r.base=r.name=i.slice(O,s):(r.name=i.slice(O,a),r.base=i.slice(O,s),r.ext=i.slice(a,s))}return c>0?r.dir=i.slice(0,c-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ee[81],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...w){const m=w.reduce((b,h)=>(b[h]=!0,b),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(b=>!m[b]).forEach(b=>{for(let h=0;h<p.length;h++)if(b.search(p[h])!==-1){delete I[b];break}})}e.sanitizeProcessEnvironment=R;function M(I){!I||(delete I.DEBUG,E.isMacintosh&&delete I.DYLD_LIBRARY_PATH,E.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[69],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class P{static create(M=!0){return new P(M)}constructor(M){this.a=t&&M,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=P}),define(ee[3],te([0,1,13,50,2,97,69]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,w=!1;var m;(function(c){c.None=()=>P.Disposable.None;function s(N){if(w){const{onDidAddListener:$}=N,G=d.create();let B=0;N.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),$?.()}}}function f(N,$){return se(N,()=>{},0,void 0,void 0,$)}c.defer=f;function C(N){return($,G=null,B)=>{let X=!1,Z;return Z=N(oe=>{if(!X)return Z?Z.dispose():X=!0,$.call(G,oe)},null,B),X&&Z.dispose(),Z}}c.once=C;function L(N,$,G){return re((B,X=null,Z)=>N(oe=>B.call(X,$(oe)),null,Z),G)}c.map=L;function O(N,$,G){return re((B,X=null,Z)=>N(oe=>{$(oe),B.call(X,oe)},null,Z),G)}c.forEach=O;function j(N,$,G){return re((B,X=null,Z)=>N(oe=>$(oe)&&B.call(X,oe),null,Z),G)}c.filter=j;function K(N){return N}c.signal=K;function V(...N){return($,G=null,B)=>(0,P.combinedDisposable)(...N.map(X=>X(Z=>$.call(G,Z),null,B)))}c.any=V;function J(N,$,G,B){let X=G;return L(N,Z=>(X=$(X,Z),X),B)}c.reduce=J;function re(N,$){let G;const B={onWillAddFirstListener(){G=N(X.fire,X)},onDidRemoveLastListener(){G?.dispose()}};$||s(B);const X=new l(B);return $?.add(X),X.event}function se(N,$,G=100,B=!1,X,Z){let oe,de,ke,De=0;const Pe={leakWarningThreshold:X,onWillAddFirstListener(){oe=N(ve=>{De++,de=$(de,ve),B&&!ke&&(Ae.fire(de),de=void 0),clearTimeout(ke),ke=setTimeout(()=>{const me=de;de=void 0,ke=void 0,(!B||De>1)&&Ae.fire(me),De=0},G)})},onDidRemoveLastListener(){oe.dispose()}};Z||s(Pe);const Ae=new l(Pe);return Z?.add(Ae),Ae.event}c.debounce=se;function ae(N,$=0,G){return c.debounce(N,(B,X)=>B?(B.push(X),B):[X],$,void 0,void 0,G)}c.accumulate=ae;function fe(N,$=(B,X)=>B===X,G){let B=!0,X;return j(N,Z=>{const oe=B||!$(Z,X);return B=!1,X=Z,oe},G)}c.latch=fe;function ge(N,$,G){return[c.filter(N,$,G),c.filter(N,B=>!$(B),G)]}c.split=ge;function q(N,$=!1,G=[]){let B=G.slice(),X=N(de=>{B?B.push(de):oe.fire(de)});const Z=()=>{B?.forEach(de=>oe.fire(de)),B=null},oe=new l({onWillAddFirstListener(){X||(X=N(de=>oe.fire(de)))},onDidAddFirstListener(){B&&($?setTimeout(Z):Z())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return oe.event}c.buffer=q;class T{constructor($){this.event=$,this.c=new P.DisposableStore}map($){return new T(L(this.event,$,this.c))}forEach($){return new T(O(this.event,$,this.c))}filter($){return new T(j(this.event,$,this.c))}reduce($,G){return new T(J(this.event,$,G,this.c))}latch(){return new T(fe(this.event,void 0,this.c))}debounce($,G=100,B=!1,X){return new T(se(this.event,$,G,B,X,this.c))}on($,G,B){return this.event($,G,B)}once($,G,B){return C(this.event)($,G,B)}dispose(){this.c.dispose()}}function U(N){return new T(N)}c.chain=U;function z(N,$,G=B=>B){const B=(...de)=>oe.fire(G(...de)),X=()=>N.on($,B),Z=()=>N.removeListener($,B),oe=new l({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return oe.event}c.fromNodeEventEmitter=z;function Q(N,$,G=B=>B){const B=(...de)=>oe.fire(G(...de)),X=()=>N.addEventListener($,B),Z=()=>N.removeEventListener($,B),oe=new l({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return oe.event}c.fromDOMEventEmitter=Q;function ne(N){return new Promise($=>C(N)($))}c.toPromise=ne;function x(N,$){return $(void 0),N(G=>$(G))}c.runAndSubscribe=x;function A(N,$){let G=null;function B(Z){G?.dispose(),G=new P.DisposableStore,$(Z,G)}B(void 0);const X=N(Z=>B(Z));return(0,P.toDisposable)(()=>{X.dispose(),G?.dispose()})}c.runAndSubscribeWithStore=A;class F{constructor($,G){this.obs=$,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};G||s(B),this.emitter=new l(B),G&&G.add(this.emitter)}beginUpdate($){this.c++}handleChange($,G){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(N,$){return new F(N,$).emitter.event}c.fromObservable=W})(m=e.Event||(e.Event={}));class p{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${p.c++}`,p.all.add(this)}start(s){this.d=new M.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=p,p.all=new Set,p.c=0;let y=-1;function b(c){const s=y;return y=c,{dispose(){y=s}}}e.setGlobalLeakWarningThreshold=b;class h{constructor(s,f=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=f,this.d=0}dispose(){this.c?.clear()}check(s,f){const C=this.threshold;if(C<=0||f<C)return;this.c||(this.c=new Map);const L=this.c.get(s.value)||0;if(this.c.set(s.value,L+1),this.d-=1,this.d<=0){this.d=C*.5;let O,j=0;for(const[K,V]of this.c)(!O||j<V)&&(O=K,j=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${j}):`),console.warn(O)}return()=>{const O=this.c.get(s.value)||0;this.c.set(s.value,O-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(s,f,C){this.callback=s,this.callbackThis=f,this.stack=C,this.subscription=new P.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class l{constructor(s){this.j=!1,this.d=s,this.f=y>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(I){const s=Array.from(this.q);queueMicrotask(()=>{for(const f of s)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,f,C)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,j;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(j=d.create(),O=this.f.check(j,this.q.size+1)),I&&(j=j??d.create());const K=new v(s,f,j),V=this.q.push(K);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,f);const J=K.subscription.set(()=>{O?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return C instanceof P.DisposableStore?C.add(J):Array.isArray(C)&&C.push(J),J}),this.l}fire(s){if(this.q){this.m||(this.m=new g);for(const f of this.q)this.m.push(this,f,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=l;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(s,f,C){this.c.push(new k(s,f,C))}clear(s){const f=new R.LinkedList;for(const C of this.c)C.emitter!==s&&f.push(C);this.c=f}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(f){(0,E.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=u;class g extends u{clear(s){this.c.clear()}}class k{constructor(s,f,C){this.emitter=s,this.listener=f,this.event=C}}class S extends l{async fireAsync(s,f,C){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const L of this.q)this.c.push([L,s]);for(;this.c.size>0&&!f.isCancellationRequested;){const[L,O]=this.c.shift(),j=[],K={...O,token:f,waitUntil:V=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");C&&(V=C(V,L.callback)),j.push(V)}};try{L.invoke(K)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(j),await Promise.allSettled(j).then(V=>{for(const J of V)J.status==="rejected"&&(0,E.onUnexpectedError)(J.reason)})}}}}e.AsyncEmitter=S;class D extends l{constructor(s){super(s),this.h=0,this.s=new R.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=D;class i extends D{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=i;class r extends l{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(f=>super.fire(f)),this.c=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.d=!1,this.f=[],this.c=new l({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const f={event:s,listener:null};this.f.push(f),this.d&&this.j(f);const C=()=>{this.d&&this.k(f);const L=this.f.indexOf(f);this.f.splice(L,1)};return(0,P.toDisposable)((0,t.once)(C))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(f=>this.c.fire(f))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class o{constructor(){this.c=[]}wrapEvent(s){return(f,C,L)=>s(O=>{const j=this.c[this.c.length-1];j?j.push(()=>f.call(C,O)):f.call(C,O)},void 0,L)}bufferEvents(s){const f=[];this.c.push(f);const C=s();return this.c.pop(),f.forEach(L=>L()),C}}e.EventBufferer=o;class a{constructor(){this.c=!1,this.d=m.None,this.f=P.Disposable.None,this.g=new l({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(ee[22],te([0,1,3]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,w){const m=setTimeout(I.bind(w),0);return{dispose(){clearTimeout(m)}}});var P;(function(I){function w(m){return m===I.None||m===I.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}I.isCancellationToken=w,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=P.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=P.None}}e.CancellationTokenSource=M}),define(ee[140],te([0,1,22]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new E.CancellationTokenSource,w=this.b(I.token);return this.a={promise:w,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.Cache=t;class P{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const w=JSON.stringify(I);return this.b!==w&&(this.b=w,this.a=this.c(I)),this.a}}e.LRUCachedFunction=P;class R{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const w=this.b(I);return this.a.set(I,w),w}}e.CachedFunction=R}),define(ee[27],te([0,1,140,126]),function(H,e,E,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function I(Y,...ce){return ce.length===0?Y:Y.replace(M,function(le,we){const Se=parseInt(we,10);return isNaN(Se)||Se<0||Se>=ce.length?le:ce[Se]})}e.format=I;const w=/{([^}]+)}/g;function m(Y,ce){return Y.replace(w,(le,we)=>ce[we]??le)}e.format2=m;function p(Y){return Y.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=p;function y(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function b(Y,ce){let le=0;const we=ce.charCodeAt(0);for(let Se=Y.length-1;Se>=0;Se--)Y.charCodeAt(Se)===we&&le++;return le}e.count=b;function h(Y,ce,le="\u2026"){return Y.length<=ce?Y:`${Y.substr(0,ce)}${le}`}e.truncate=h;function d(Y,ce=" "){const le=v(Y,ce);return l(le,ce)}e.trim=d;function v(Y,ce){if(!Y||!ce)return Y;const le=ce.length;if(le===0||Y.length===0)return Y;let we=0;for(;Y.indexOf(ce,we)===we;)we=we+le;return Y.substring(we)}e.ltrim=v;function l(Y,ce){if(!Y||!ce)return Y;const le=ce.length,we=Y.length;if(le===0||we===0)return Y;let Se=we,Oe=-1;for(;Oe=Y.lastIndexOf(ce,Se-1),!(Oe===-1||Oe+le!==Se);){if(Oe===0)return"";Se=Oe}return Y.substring(0,Se)}e.rtrim=l;function u(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function k(Y,ce,le={}){if(!Y)throw new Error("Cannot create regex from empty string");ce||(Y=y(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let we="";return le.global&&(we+="g"),le.matchCase||(we+="i"),le.multiline&&(we+="m"),le.unicode&&(we+="u"),new RegExp(Y,we)}e.createRegExp=k;function S(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function D(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function i(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=i;function r(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=r;function n(Y){for(let ce=0,le=Y.length;ce<le;ce++){const we=Y.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.firstNonWhitespaceIndex=n;function o(Y,ce=0,le=Y.length){for(let we=ce;we<le;we++){const Se=Y.charCodeAt(we);if(Se!==32&&Se!==9)return Y.substring(ce,we)}return Y.substring(ce,le)}e.getLeadingWhitespace=o;function a(Y,ce=Y.length-1){for(let le=ce;le>=0;le--){const we=Y.charCodeAt(le);if(we!==32&&we!==9)return le}return-1}e.lastNonWhitespaceIndex=a;function c(Y,ce,le){const we=[];let Se=0;for(const Oe of Y.matchAll(ce)){if(we.push(Y.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,we.push(le(Oe[0],...Oe.slice(1),Oe.index,Y,Oe.groups))}return we.push(Y.slice(Se)),Promise.all(we).then(Oe=>Oe.join(""))}e.replaceAsync=c;function s(Y,ce){return Y<ce?-1:Y>ce?1:0}e.compare=s;function f(Y,ce,le=0,we=Y.length,Se=0,Oe=ce.length){for(;le<we&&Se<Oe;le++,Se++){const xe=Y.charCodeAt(le),He=ce.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const Be=we-le,it=Oe-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=f;function C(Y,ce){return L(Y,ce,0,Y.length,0,ce.length)}e.compareIgnoreCase=C;function L(Y,ce,le=0,we=Y.length,Se=0,Oe=ce.length){for(;le<we&&Se<Oe;le++,Se++){let xe=Y.charCodeAt(le),He=ce.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return f(Y.toLowerCase(),ce.toLowerCase(),le,we,Se,Oe);j(xe)&&(xe-=32),j(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const Be=we-le,it=Oe-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function j(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=j;function K(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=K;function V(Y,ce){return Y.length===ce.length&&L(Y,ce)===0}e.equalsIgnoreCase=V;function J(Y,ce){const le=ce.length;return ce.length>Y.length?!1:L(Y,ce,0,le)===0}e.startsWithIgnoreCase=J;function re(Y,ce){const le=Math.min(Y.length,ce.length);let we;for(we=0;we<le;we++)if(Y.charCodeAt(we)!==ce.charCodeAt(we))return we;return le}e.commonPrefixLength=re;function se(Y,ce){const le=Math.min(Y.length,ce.length);let we;const Se=Y.length-1,Oe=ce.length-1;for(we=0;we<le;we++)if(Y.charCodeAt(Se-we)!==ce.charCodeAt(Oe-we))return we;return le}e.commonSuffixLength=se;function ae(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ae;function fe(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=fe;function ge(Y,ce){return(Y-55296<<10)+(ce-56320)+65536}e.computeCodePoint=ge;function q(Y,ce,le){const we=Y.charCodeAt(le);if(ae(we)&&le+1<ce){const Se=Y.charCodeAt(le+1);if(fe(Se))return ge(we,Se)}return we}e.getNextCodePoint=q;function T(Y,ce){const le=Y.charCodeAt(ce-1);if(fe(le)&&ce>1){const we=Y.charCodeAt(ce-2);if(ae(we))return ge(we,le)}return le}class U{get offset(){return this.e}constructor(ce,le=0){this.c=ce,this.d=ce.length,this.e=le}setOffset(ce){this.e=ce}prevCodePoint(){const ce=T(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=q(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=U;class z{get offset(){return this.c.offset}constructor(ce,le=0){this.c=new U(ce,le)}nextGraphemeLength(){const ce=We.getInstance(),le=this.c,we=le.offset;let Se=ce.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Oe=le.offset,Be=ce.getGraphemeBreakType(le.nextCodePoint());if(be(Se,Be)){le.setOffset(Oe);break}Se=Be}return le.offset-we}prevGraphemeLength(){const ce=We.getInstance(),le=this.c,we=le.offset;let Se=ce.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Oe=le.offset,Be=ce.getGraphemeBreakType(le.prevCodePoint());if(be(Be,Se)){le.setOffset(Oe);break}Se=Be}return we-le.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Q(Y,ce){return new z(Y,ce).nextGraphemeLength()}e.nextCharLength=Q;function ne(Y,ce){return new z(Y,ce).prevGraphemeLength()}e.prevCharLength=ne;function x(Y,ce){ce>0&&fe(Y.charCodeAt(ce))&&ce--;const le=ce+Q(Y,ce);return[le-ne(Y,le),le]}e.getCharContainingOffset=x;function A(Y){const ce=new z(Y);let le=0;for(;!ce.eol();)le++,ce.nextGraphemeLength();return le}e.charCount=A;let F;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(Y){return F||(F=W()),F.test(Y)}e.containsRTL=N;const $=/^[\t\n\r\x20-\x7E]*$/;function G(Y){return $.test(Y)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=B;function X(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=X;function Z(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=Z;function oe(Y,ce){if(Y.length<ce)return Y;const le=/\b/g;let we=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<ce);)we=le.lastIndex,le.lastIndex+=1;return Y.substring(we).replace(/^\s/,"")}e.lcut=oe;const de=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Pe(Y){return Y&&(Y=Y.replace(de,""),Y=Y.replace(ke,""),Y=Y.replace(De,"")),Y}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(Y){return Ae(Y)?Y.substr(1):Y}e.stripUTF8BOM=ve;function me(Y,ce){if(!Y||!ce||Y.length<ce.length)return!1;const le=ce.length,we=Y.toLowerCase();let Se=0,Oe=-1;for(;Se<le;){const Be=we.indexOf(ce[Se],Oe+1);if(Be<0)return!1;Oe=Be,Se++}return!0}e.fuzzyContains=me;function ye(Y,ce=!1){return Y?(ce&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ye;function Me(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Me;function ie(Y,ce=1){if(ce===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),ce--;while(ce>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=ie;function ue(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=ue;function he(Y){return We.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=he;function be(Y,ce){return Y===0?ce!==5&&ce!==7:Y===2&&ce===3?!1:Y===4||Y===2||Y===3||ce===4||ce===2||ce===3?!0:!(Y===8&&(ce===8||ce===9||ce===11||ce===12)||(Y===11||Y===9)&&(ce===9||ce===10)||(Y===12||Y===10)&&ce===10||ce===5||ce===13||ce===7||Y===1||Y===13&&ce===14||Y===6&&ce===6)}var Ce;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const le=this.d,we=le.length/3;let Se=1;for(;Se<=we;)if(ce<le[3*Se])Se=2*Se;else if(ce>le[3*Se+1])Se=2*Se+1;else return le[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Y,ce){if(Y===0)return 0;const le=Ue(Y,ce);if(le!==void 0)return le;const we=new U(ce,Y);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=qe;function Ue(Y,ce){const le=new U(ce,Y);let we=le.prevCodePoint();for(;je(we)||we===65039||we===8419;){if(le.offset===0)return;we=le.prevCodePoint()}if(!Z(we))return;let Se=le.offset;return Se>0&&le.prevCodePoint()===8205&&(Se=le.offset),Se}function je(Y){return 127995<=Y&&Y<=127999}var Xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(ce){return $e.d.get(Array.from(ce))}static getLocales(){return $e.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,P=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new E.LRUCachedFunction(Y=>{function ce(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function le(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function we(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=P.c.getValue();let Oe=Y.filter(He=>!He.startsWith("_")&&He in Se);Oe.length===0&&(Oe=["_default"]);let Be;for(const He of Oe){const tt=ce(Se[He]);Be=we(Be,tt)}const it=ce(Se._common),xe=le(it,Be);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(Y=>!Y.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(ce){return Ke.e().has(ce)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ee[32],te([0,1,9,4,27,11]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(a){return a===47||a===92}e.isPathSeparator=M;function I(a){return a.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=I;function w(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=w;function m(a,c=E.posix.sep){if(!a)return"";const s=a.length,f=a.charCodeAt(0);if(M(f)){if(M(a.charCodeAt(1))&&!M(a.charCodeAt(2))){let L=3;const O=L;for(;L<s&&!M(a.charCodeAt(L));L++);if(O!==L&&!M(a.charCodeAt(L+1))){for(L+=1;L<s;L++)if(M(a.charCodeAt(L)))return a.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(u(f)&&a.charCodeAt(1)===58)return M(a.charCodeAt(2))?a.slice(0,2)+c:a.slice(0,2);let C=a.indexOf("://");if(C!==-1){for(C+=3;C<s;C++)if(M(a.charCodeAt(C)))return a.slice(0,C+1)}return""}e.getRoot=m;function p(a){if(!t.isWindows||!a||a.length<5)return!1;let c=a.charCodeAt(0);if(c!==92||(c=a.charCodeAt(1),c!==92))return!1;let s=2;const f=s;for(;s<a.length&&(c=a.charCodeAt(s),c!==92);s++);return!(f===s||(c=a.charCodeAt(s+1),isNaN(c)||c===92))}e.isUNC=p;const y=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,c=t.isWindows){const s=c?y:b;return!(!a||a.length===0||/^\s+$/.test(a)||(s.lastIndex=0,s.test(a))||c&&h.test(a)||a==="."||a===".."||c&&a[a.length-1]==="."||c&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function v(a,c,s){const f=a===c;return!s||f?f:!a||!c?!1:(0,P.equalsIgnoreCase)(a,c)}e.isEqual=v;function l(a,c,s,f=E.sep){if(a===c)return!0;if(!a||!c||c.length>a.length)return!1;if(s){if(!(0,P.startsWithIgnoreCase)(a,c))return!1;if(c.length===a.length)return!0;let L=c.length;return c.charAt(c.length-1)===f&&L--,a.charAt(L)===f}return c.charAt(c.length-1)!==f&&(c+=f),a.indexOf(c)===0}e.isEqualOrParent=l;function u(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=u;function g(a,c){return t.isWindows&&a.endsWith(":")&&(a+=E.sep),(0,E.isAbsolute)(a)||(a=(0,E.join)(c,a)),a=(0,E.normalize)(a),t.isWindows?(a=(0,P.rtrim)(a,E.sep),a.endsWith(":")&&(a+=E.sep)):(a=(0,P.rtrim)(a,E.sep),a||(a=E.sep)),a}e.sanitizeFilePath=g;function k(a){const c=(0,E.normalize)(a);return t.isWindows?a.length>3?!1:S(c)&&(a.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=k;function S(a,c=t.isWindows){return c?u(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function D(a){return S(a)?a[0]:void 0}e.getDriveLetter=D;function i(a,c,s){return c.length>a.length?-1:a===c?0:(s&&(a=a.toLowerCase(),c=c.toLowerCase()),a.indexOf(c))}e.indexOfPath=i;function r(a){const c=a.split(":");let s,f,C;for(const L of c){const O=Number(L);(0,R.isNumber)(O)?f===void 0?f=O:C===void 0&&(C=O):s=s?[s,L].join(":"):L}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:f!==void 0?f:void 0,column:C!==void 0?C:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,c,s=8){let f="";for(let L=0;L<s;L++)f+=n.charAt(Math.floor(Math.random()*n.length));let C;return c?C=`${c}-${f}`:C=f,a?(0,E.join)(a,C):C}e.randomPath=o}),define(ee[70],te([0,1,27]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return P(u,0)}e.hash=t;function P(u,g){switch(typeof u){case"object":return u===null?R(349,g):Array.isArray(u)?w(u,g):m(u,g);case"string":return I(u,g);case"boolean":return M(u,g);case"number":return R(u,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=P;function R(u,g){return(g<<5)-g+u|0}e.numberHash=R;function M(u,g){return R(u?433:863,g)}function I(u,g){g=R(149417,g);for(let k=0,S=u.length;k<S;k++)g=R(u.charCodeAt(k),g);return g}e.stringHash=I;function w(u,g){return g=R(104579,g),u.reduce((k,S)=>P(S,k),g)}function m(u,g){return g=R(181387,g),Object.keys(u).sort().reduce((k,S)=>(k=I(S,k),P(u[S],k)),g)}class p{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=P(g,this.g),this.g}}e.Hasher=p;var y;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function b(u,g,k=32){const S=k-g,D=~((1<<S)-1);return(u<<g|(D&u)>>>S)>>>0}function h(u,g=0,k=u.byteLength,S=0){for(let D=0;D<k;D++)u[g+D]=S}function d(u,g,k="0"){for(;u.length<g;)u=k+u;return u}function v(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(k=>k.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),g/4)}e.toHexString=v;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const k=g.length;if(k===0)return;const S=this.p;let D=this.r,i=this.u,r,n;for(i!==0?(r=i,n=-1,i=0):(r=g.charCodeAt(0),n=0);;){let o=r;if(E.isHighSurrogate(r))if(n+1<k){const a=g.charCodeAt(n+1);E.isLowSurrogate(a)?(n++,o=E.computeCodePoint(r,a)):o=65533}else{i=r;break}else E.isLowSurrogate(r)&&(o=65533);if(D=this.w(S,D,o),n++,n<k)r=g.charCodeAt(n);else break}this.r=D,this.u=i}w(g,k,S){return S<128?g[k++]=S:S<2048?(g[k++]=192|(S&1984)>>>6,g[k++]=128|(S&63)>>>0):S<65536?(g[k++]=224|(S&61440)>>>12,g[k++]=128|(S&4032)>>>6,g[k++]=128|(S&63)>>>0):(g[k++]=240|(S&1835008)>>>18,g[k++]=128|(S&258048)>>>12,g[k++]=128|(S&4032)>>>6,g[k++]=128|(S&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=l.g,k=this.q;for(let s=0;s<64;s+=4)g.setUint32(s,k.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)g.setUint32(s,b(g.getUint32(s-12,!1)^g.getUint32(s-32,!1)^g.getUint32(s-56,!1)^g.getUint32(s-64,!1),1),!1);let S=this.h,D=this.l,i=this.m,r=this.n,n=this.o,o,a,c;for(let s=0;s<80;s++)s<20?(o=D&i|~D&r,a=1518500249):s<40?(o=D^i^r,a=1859775393):s<60?(o=D&i|D&r|i&r,a=2400959708):(o=D^i^r,a=3395469782),c=b(S,5)+o+n+a+g.getUint32(s*4,!1)&4294967295,n=r,r=i,i=b(D,30),D=S,S=c;this.h=this.h+S&4294967295,this.l=this.l+D&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=l,l.g=new DataView(new ArrayBuffer(320))}),define(ee[82],te([0,1,27]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(t||(t={})),function(P){const R="error",M="warning",I="warn",w="info",m="ignore";function p(b){return b?E.equalsIgnoreCase(R,b)?P.Error:E.equalsIgnoreCase(M,b)||E.equalsIgnoreCase(I,b)?P.Warning:E.equalsIgnoreCase(w,b)?P.Info:P.Ignore:P.Ignore}P.fromValue=p;function y(b){switch(b){case P.Error:return R;case P.Warning:return M;case P.Info:return w;default:return m}}P.toString=y}(t||(t={})),e.default=t}),define(ee[60],te([0,1,25,27]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const d=h.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.StringIterator=P;class R{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,t.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class M{constructor(h=!0,d=!0){this.f=h,this.g=d}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let d=h.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,t.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=M;var I;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(I||(I={}));class w{constructor(h,d){this.f=h,this.g=d,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,t.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(p||(p={}));class y{static forUris(h=()=>!1,d=()=>!1){return new y(new w(h,d))}static forPaths(h=!1){return new y(new M(void 0,!h))}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new R)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,d){if(d){const v=d.slice(0);(0,E.shuffle)(v);for(const l of v)this.set(l,h)}else{const v=h.slice(0);(0,E.shuffle)(v);for(const l of v)this.set(l[0],l[1])}}set(h,d){const v=this.b.reset(h);let l;this.c||(this.c=new m,this.c.segment=v.value());const u=[];for(l=this.c;;){const k=v.cmp(l.segment);if(k>0)l.left||(l.left=new m,l.left.segment=v.value()),u.push([-1,l]),l=l.left;else if(k<0)l.right||(l.right=new m,l.right.segment=v.value()),u.push([1,l]),l=l.right;else if(v.hasNext())v.next(),l.mid||(l.mid=new m,l.mid.segment=v.value()),u.push([0,l]),l=l.mid;else break}const g=l.value;l.value=d,l.key=h;for(let k=u.length-1;k>=0;k--){const S=u[k][1];S.updateHeight();const D=S.balanceFactor();if(D<-1||D>1){const i=u[k][0],r=u[k+1][0];if(i===1&&r===1)u[k][1]=S.rotateLeft();else if(i===-1&&r===-1)u[k][1]=S.rotateRight();else if(i===1&&r===-1)S.right=u[k+1][1]=u[k+1][1].rotateRight(),u[k][1]=S.rotateLeft();else if(i===-1&&r===1)S.left=u[k+1][1]=u[k+1][1].rotateLeft(),u[k][1]=S.rotateRight();else throw new Error;if(k>0)switch(u[k-1][0]){case-1:u[k-1][1].left=u[k][1];break;case 1:u[k-1][1].right=u[k][1];break;case 0:u[k-1][1].mid=u[k][1];break}else this.c=u[0][1]}}return g}get(h){return this.d(h)?.value}d(h){const d=this.b.reset(h);let v=this.c;for(;v;){const l=d.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(h){const d=this.d(h);return!(d?.value===void 0&&d?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,d){const v=this.b.reset(h),l=[];let u=this.c;for(;u;){const g=v.cmp(u.segment);if(g>0)l.push([-1,u]),u=u.left;else if(g<0)l.push([1,u]),u=u.right;else if(v.hasNext())v.next(),l.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:k,value:S,segment:D}=g;this.e(g.key,!1),u.key=k,u.value=S,u.segment=D}}else{const g=u.left??u.right;if(l.length>0){const[k,S]=l[l.length-1];switch(k){case-1:S.left=g;break;case 0:S.mid=g;break;case 1:S.right=g;break}}else this.c=g}for(let g=l.length-1;g>=0;g--){const k=l[g][1];k.updateHeight();const S=k.balanceFactor();if(S>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),l[g][1]=k.rotateLeft()):S<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),l[g][1]=k.rotateRight()),g>0)switch(l[g-1][0]){case-1:l[g-1][1].left=l[g][1];break;case 1:l[g-1][1].right=l[g][1];break;case 0:l[g-1][1].mid=l[g][1];break}else this.c=l[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const d=this.b.reset(h);let v=this.c,l;for(;v;){const u=d.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(d.hasNext())d.next(),l=v.value||l,v=v.mid;else break}return v&&v.value||l}findSuperstr(h){return this.g(h,!1)}g(h,d){const v=this.b.reset(h);let l=this.c;for(;l;){const u=v.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else return l.mid?this.h(l.mid):d?l.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[d,v]of this)h(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const d=[];return this.j(h,d),d[Symbol.iterator]()}j(h,d){!h||(h.left&&this.j(h.left,d),h.value&&d.push([h.key,h.value]),h.mid&&this.j(h.mid,d),h.right&&this.j(h.right,d))}_isBalanced(){const h=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:h(d.left)&&h(d.right)};return h(this.c)}}e.TernarySearchTree=y}),define(ee[7],te([0,1,9,4]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function I(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!P.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,o){return!n&&!o?"file":n}function m(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==y&&(o=y+o):o=y;break}return o}const p="",y="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(o){return o instanceof h?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,a,c,s,f,C=!1){typeof o=="object"?(this.scheme=o.scheme||p,this.authority=o.authority||p,this.path=o.path||p,this.query=o.query||p,this.fragment=o.fragment||p):(this.scheme=w(o,C),this.authority=a||p,this.path=m(this.scheme,c||p),this.query=s||p,this.fragment=f||p,I(this,C))}get fsPath(){return k(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:c,path:s,query:f,fragment:C}=o;return a===void 0?a=this.scheme:a===null&&(a=p),c===void 0?c=this.authority:c===null&&(c=p),s===void 0?s=this.path:s===null&&(s=p),f===void 0?f=this.query:f===null&&(f=p),C===void 0?C=this.fragment:C===null&&(C=p),a===this.scheme&&c===this.authority&&s===this.path&&f===this.query&&C===this.fragment?this:new v(a,c,s,f,C)}static parse(o,a=!1){const c=b.exec(o);return c?new v(c[2]||p,r(c[4]||p),r(c[5]||p),r(c[7]||p),r(c[9]||p),a):new v(p,p,p,p,p)}static file(o){let a=p;if(t.isWindows&&(o=o.replace(/\\/g,y)),o[0]===y&&o[1]===y){const c=o.indexOf(y,2);c===-1?(a=o.substring(2),o=y):(a=o.substring(2,c),o=o.substring(c)||y)}return new v("file",a,o,p,p)}static from(o){const a=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return I(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&o.scheme==="file"?c=h.file(E.win32.join(k(o,!0),...a)).path:c=E.posix.join(o.path,...a),o.with({path:c})}toString(o=!1){return S(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof h)return o;{const a=new v(o);return a._formatted=o.external,a._fsPath=o._sep===d?o.fsPath:null,a}}else return o}}e.URI=h;const d=t.isWindows?1:void 0;class v extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(o=!1){return o?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,o,a){let c,s=-1;for(let f=0;f<n.length;f++){const C=n.charCodeAt(f);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||o&&C===47||a&&C===91||a&&C===93||a&&C===58)s!==-1&&(c+=encodeURIComponent(n.substring(s,f)),s=-1),c!==void 0&&(c+=n.charAt(f));else{c===void 0&&(c=n.substr(0,f));const L=l[C];L!==void 0?(s!==-1&&(c+=encodeURIComponent(n.substring(s,f)),s=-1),c+=L):s===-1&&(s=f)}}return s!==-1&&(c+=encodeURIComponent(n.substring(s))),c!==void 0?c:n}function g(n){let o;for(let a=0;a<n.length;a++){const c=n.charCodeAt(a);c===35||c===63?(o===void 0&&(o=n.substr(0,a)),o+=l[c]):o!==void 0&&(o+=n[a])}return o!==void 0?o:n}function k(n,o){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=k;function S(n,o){const a=o?g:u;let c="",{scheme:s,authority:f,path:C,query:L,fragment:O}=n;if(s&&(c+=s,c+=":"),(f||s==="file")&&(c+=y,c+=y),f){let j=f.indexOf("@");if(j!==-1){const K=f.substr(0,j);f=f.substr(j+1),j=K.lastIndexOf(":"),j===-1?c+=a(K,!1,!1):(c+=a(K.substr(0,j),!1,!1),c+=":",c+=a(K.substr(j+1),!1,!0)),c+="@"}f=f.toLowerCase(),j=f.lastIndexOf(":"),j===-1?c+=a(f,!1,!0):(c+=a(f.substr(0,j),!1,!0),c+=f.substr(j))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const j=C.charCodeAt(1);j>=65&&j<=90&&(C=`/${String.fromCharCode(j+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const j=C.charCodeAt(0);j>=65&&j<=90&&(C=`${String.fromCharCode(j+32)}:${C.substr(2)}`)}c+=a(C,!0,!1)}return L&&(c+="?",c+=a(L,!1,!1)),O&&(c+="#",c+=o?O:u(O,!1,!1)),c}function D(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+D(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,o=>D(o)):n}}),define(ee[141],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const p=m;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=t;function P(m){const p=[];let y;try{const b=JSON.parse(m.arguments),h=b[b.length-1];h&&h.__$stack&&(b.pop(),y=h.__$stack),p.push(...b)}catch{p.push("Unable to log remote console arguments",m.arguments)}return{args:p,stack:y}}e.parse=P;function R(m){if(typeof m!="string")return R(P(m).stack);const p=m;if(p){const y=M(p),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(b&&b.length===4)return{uri:E.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function M(m){if(!m)return m;const p=m.indexOf(`
`);return p===-1?m:m.substring(0,p)}function I(m,p){const{args:y,stack:b}=P(m),h=typeof y[0]=="string"&&y.length===1;let d=M(b);d&&(d=`(${d.trim()})`);let v=[];if(typeof y[0]=="string"?d&&h?v=[`%c[${p}] %c${y[0]} %c${d}`,w("blue"),w(""),w("grey")]:v=[`%c[${p}] %c${y[0]}`,w("blue"),w(""),...y.slice(1)]:v=[`%c[${p}]%`,w("blue"),...y],d&&!h&&v.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,v)}e.log=I;function w(m){return`color: ${m}`}}),define(ee[71],te([0,1,17,27,7]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,I)}e.stringify=R;function M(m){let p=JSON.parse(m);return p=w(p),p}e.parse=M;function I(m,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,t.regExpFlags)(p)}:p}function w(m,p=0){if(!m||p>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return P.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof E.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=w(m[y],p+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=w(m[y],p+1))}return m}e.revive=w}),define(ee[15],te([0,1,13,4,7]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebook="vscode-notebook",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,y,b){this.a[p]=y,this.b[p]=b}setConnectionToken(p,y){this.c[p]=y}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(l){return E.onUnexpectedError(l),p}const y=p.authority;let b=this.a[y];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const h=this.b[y],d=this.c[y];let v=`path=${encodeURIComponent(p.path)}`;return typeof d=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),P.URI.from({scheme:t.isWeb?this.d:R.vscodeRemoteResource,authority:`${b}:${h}`,path:this.f,query:v})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(p){const y=this.b(p,H);return this.uriToBrowserUri(y)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===R.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${R.vscodeFileResource}://${I.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||I.a,query:null,fragment:null}):p}asFileUri(p){const y=this.b(p,H);return this.uriToFileUri(y)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==I.a?p.authority:null,query:null,fragment:null}):p}b(p,y){return P.URI.isUri(p)?p:P.URI.parse(y.toUrl(p))}}I.a="vscode-app",e.FileAccess=new I;var w;(function(m){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(p.get("3"));const y="vscode-coi";function b(d){let v;typeof d=="string"?v=new URL(d).searchParams:d instanceof URL?v=d.searchParams:P.URI.isUri(d)&&(v=new URL(d.toString(!0)).searchParams);const l=v?.get(y);if(!!l)return p.get(l)}m.getHeadersFromQuery=b;function h(d,v,l){if(!globalThis.crossOriginIsolated)return;const u=v&&l?"3":l?"2":"1";d instanceof URLSearchParams?d.set(y,u):d[y]=u}m.addSearchParam=h})(w=e.COI||(e.COI={}))}),define(ee[20],te([0,1,32,15,9,4,27,7]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=w;class m{constructor(d){this.a=d}compare(d,v,l=!1){return d===v?0:(0,M.compare)(this.getComparisonKey(d,l),this.getComparisonKey(v,l))}isEqual(d,v,l=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,l)===this.getComparisonKey(v,l)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,l=!1){if(d.scheme===v.scheme){if(d.scheme===t.Schemas.file)return E.isEqualOrParent(w(d),w(v),this.a(d))&&d.query===v.query&&(l||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return E.isEqualOrParent(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(l||d.fragment===v.fragment)}return!1}joinPath(d,...v){return I.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return P.posix.basename(d.path)}extname(d){return P.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===t.Schemas.file?v=I.URI.file(P.dirname(w(d))).path:(v=P.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===t.Schemas.file?v=I.URI.file(P.normalize(w(d))).path:v=P.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===t.Schemas.file){const g=P.relative(w(d),w(v));return R.isWindows?E.toSlashes(g):g}let l=d.path||"/";const u=v.path||"/";if(this.a(d)){let g=0;for(const k=Math.min(l.length,u.length);g<k&&!(l.charCodeAt(g)!==u.charCodeAt(g)&&l.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);l=u.substr(0,g)+l.substr(g)}return P.posix.relative(l,u)}resolvePath(d,v){if(d.scheme===t.Schemas.file){const l=I.URI.file(P.resolve(w(d),v));return d.with({authority:l.authority,path:l.path})}return v=E.toPosixPath(v),d.with({path:P.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,M.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=P.sep){if(d.scheme===t.Schemas.file){const l=w(d);return l.length>E.getRoot(l).length&&l[l.length-1]===v}else{const l=d.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=P.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=P.sep){let l=!1;if(d.scheme===t.Schemas.file){const u=w(d);l=u!==void 0&&u.length===E.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=d.path;l=u.length===1&&u.charCodeAt(u.length-1)===47}return!l&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(h,d){const v=[];for(let l=0;l<h.length;l++){const u=d(h[l]);h.some((g,k)=>k===l?!1:(0,e.isEqualOrParent)(u,d(g)))||v.push(h[l])}return v}e.distinctParents=p;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(v){const l=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(k=>{const[S,D]=k.split(":");S&&D&&l.set(S,D)});const g=v.path.substring(0,v.path.indexOf(";"));return g&&l.set(h.META_DATA_MIME,g),l}h.parseMetaData=d})(y=e.DataUri||(e.DataUri={}));function b(h,d,v){if(d){let l=h.path;return l&&l[0]!==P.posix.sep&&(l=P.posix.sep+l),h.with({scheme:v,authority:d,path:l})}return h.with({scheme:v})}e.toLocalResource=b}),define(ee[8],te([0,1,22,13,3,2,20,4]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(x){return!!x&&typeof x.then=="function"}e.isThenable=w;function m(x){const A=new E.CancellationTokenSource,F=x(A.token),W=new Promise((N,$)=>{const G=A.token.onCancellationRequested(()=>{G.dispose(),A.dispose(),$(new t.CancellationError)});Promise.resolve(F).then(B=>{G.dispose(),A.dispose(),N(B)},B=>{G.dispose(),A.dispose(),$(B)})});return new class{cancel(){A.cancel()}then(N,$){return W.then(N,$)}catch(N){return this.then(void 0,N)}finally(N){return W.finally(N)}}}e.createCancelablePromise=m;function p(x,A,F){return new Promise((W,N)=>{const $=A.onCancellationRequested(()=>{$.dispose(),W(F)});x.then(W,N).finally(()=>$.dispose())})}e.raceCancellation=p;function y(x,A){return new Promise((F,W)=>{const N=A.onCancellationRequested(()=>{N.dispose(),W(new t.CancellationError)});x.then(F,W).finally(()=>N.dispose())})}e.raceCancellationError=y;async function b(x){let A=-1;const F=x.map((N,$)=>N.then(G=>(A=$,G))),W=await Promise.race(F);return x.forEach((N,$)=>{$!==A&&N.cancel()}),W}e.raceCancellablePromises=b;function h(x,A,F){let W;const N=setTimeout(()=>{W?.(void 0),F?.()},A);return Promise.race([x.finally(()=>clearTimeout(N)),new Promise($=>W=$)])}e.raceTimeout=h;function d(x){return new Promise((A,F)=>{const W=x();w(W)?W.then(A,F):A(W)})}e.asPromise=d;class v{constructor(){this.a=null,this.b=null,this.d=null}queue(A){if(this.a){if(this.d=A,!this.b){const F=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(F,F).then(W)})}return new Promise((F,W)=>{this.b.then(F,W)})}return this.a=A(),new Promise((F,W)=>{this.a.then(N=>{this.a=null,F(N)},N=>{this.a=null,W(N)})})}}e.Throttler=v;class l{constructor(){this.a=Promise.resolve(null)}queue(A){return this.a=this.a.then(()=>A(),()=>A())}}e.Sequencer=l;class u{constructor(){this.a=new Map}queue(A,F){const N=(this.a.get(A)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(A)===N&&this.a.delete(A)});return this.a.set(A,N),N}}e.SequencerByKey=u;const g=(x,A)=>{let F=!0;const W=setTimeout(()=>{F=!1,A()},x);return{isTriggered:()=>F,dispose:()=>{clearTimeout(W),F=!1}}},k=x=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,x())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(A){this.defaultDelay=A,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(A,F=this.defaultDelay){this.g=A,this.h(),this.b||(this.b=new Promise((N,$)=>{this.d=N,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=F===e.MicrotaskDelay?k(W):g(F,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=S;class D{constructor(A){this.a=new S(A),this.b=new v}trigger(A,F){return this.a.trigger(()=>this.b.queue(A),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=D;class i{constructor(){this.a=!1,this.b=new Promise((A,F)=>{this.d=A})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(A){super(),this.f=setTimeout(()=>this.open(),A)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function n(x,A){return A?new Promise((F,W)=>{const N=setTimeout(()=>{$.dispose(),F()},x),$=A.onCancellationRequested(()=>{clearTimeout(N),$.dispose(),W(new t.CancellationError)})}):m(F=>n(x,F))}e.timeout=n;function o(x,A=0){const F=setTimeout(x,A);return(0,R.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=o;function a(x){const A=[];let F=0;const W=x.length;function N(){return F<W?x[F++]():null}function $(G){G!=null&&A.push(G);const B=N();return B?B.then($):Promise.resolve(A)}return Promise.resolve(null).then($)}e.sequence=a;function c(x,A=W=>!!W,F=null){let W=0;const N=x.length,$=()=>{if(W>=N)return Promise.resolve(F);const G=x[W++];return Promise.resolve(G()).then(X=>A(X)?Promise.resolve(X):$())};return $()}e.first=c;function s(x,A=W=>!!W,F=null){if(x.length===0)return Promise.resolve(F);let W=x.length;const N=()=>{W=-1;for(const $ of x)$.cancel?.()};return new Promise(($,G)=>{for(const B of x)B.then(X=>{--W>=0&&A(X)?(N(),$(X)):W===0&&$(F)}).catch(X=>{--W>=0&&(N(),G(X))})})}e.firstParallel=s;class f{constructor(A){this.a=0,this.d=A,this.f=[],this.b=0,this.g=new P.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(A){return this.a++,new Promise((F,W)=>{this.f.push({factory:A,c:F,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const A=this.f.shift();this.b++;const F=A.factory();F.then(A.c,A.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class C extends f{constructor(){super(1)}}e.Queue=C;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const A=new q;return this.b.add(A),A.p}d(){for(const[,A]of this.a)if(A.size>0)return!1;return!0}queueFor(A,F=M.extUri){const W=F.getComparisonKey(A);let N=this.a.get(W);return N||(N=new C,P.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,N)),N}f(){!this.d()||this.g()}g(){for(const A of this.b)A.complete();this.b.clear()}dispose(){for(const[,A]of this.a)A.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class O{constructor(A,F){this.a=-1,typeof A=="function"&&typeof F=="number"&&this.setIfNotSet(A,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,A()},F)}setIfNotSet(A,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,A()},F))}}e.TimeoutTimer=O;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setInterval(()=>{A()},F)}}e.IntervalTimer=j;class K{constructor(A,F){this.b=-1,this.a=A,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(A=this.d){this.cancel(),this.b=setTimeout(this.f,A)}get delay(){return this.d}set delay(A){this.d=A}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class V{constructor(A,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=A,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(A=this.b){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(A/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class J extends K{constructor(A,F){super(A,F),this.j=[]}work(A){this.j.push(A),this.isScheduled()||this.schedule()}h(){const A=this.j;this.j=[],this.a?.(A)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=J;class re extends R.Disposable{constructor(A,F){super(),this.g=A,this.h=F,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(A){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+A.length>this.g.maxBufferedWork)return!1}else if(this.pending+A.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of A)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,I.setTimeout0)(()=>{if(A)return;const F=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(x,A)=>{const F=requestIdleCallback(x,typeof A=="number"?{timeout:A}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(F))}}}}();class se{constructor(A){this.d=!1,this.a=()=>{try{this.f=A()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=se;async function ae(x,A,F){let W;for(let N=0;N<F;N++)try{return await x()}catch($){W=$,await n(A)}throw W}e.retry=ae;class fe{hasPending(A){return this.a?typeof A=="number"?this.a.taskId===A:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(A,F,W){return this.a={taskId:A,cancel:()=>W?.(),promise:F},F.then(()=>this.d(A),()=>this.d(A)),F}d(A){this.a&&A===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const A=this.b;this.b=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this.b)this.b.run=A;else{let F,W;const N=new Promise(($,G)=>{F=$,W=G});this.b={run:A,promise:N,promiseResolve:F,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=fe;class ge{constructor(A,F=()=>Date.now()){this.d=A,this.f=F,this.a=0,this.b=0}increment(){const A=this.f();return A-this.a>this.d&&(this.a=A,this.b=0),this.b++,this.b}}e.IntervalCounter=ge;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((A,F)=>{this.a=A,this.b=F})}complete(A){return new Promise(F=>{this.a(A),this.f=!0,F()})}error(A){return new Promise(F=>{this.b(A),this.d=!0,F()})}cancel(){new Promise(A=>{this.b(new t.CancellationError),this.d=!0,A()})}}e.DeferredPromise=q;var T;(function(x){async function A(W){let N;const $=await Promise.all(W.map(G=>G.then(B=>B,B=>{N||(N=B)})));if(typeof N<"u")throw N;return $}x.settled=A;function F(W){return new Promise(async(N,$)=>{try{await W(N,$)}catch(G){$(G)}})}x.withAsyncBody=F})(T=e.Promises||(e.Promises={}));var U;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(U||(U={}));class z{static fromArray(A){return new z(F=>{F.emitMany(A)})}static fromPromise(A){return new z(async F=>{F.emitMany(await A)})}static fromPromises(A){return new z(async F=>{await Promise.all(A.map(async W=>F.emitOne(await W)))})}static merge(A){return new z(async F=>{await Promise.all(A.map(async W=>{for await(const N of W)F.emitOne(N)}))})}constructor(A){this.a=0,this.b=[],this.d=null,this.f=new P.Emitter,queueMicrotask(async()=>{const F={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(A(F)),this.j()}catch(W){this.k(W)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(A<this.b.length)return{done:!1,value:this.b[A++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(A,F){return new z(async W=>{for await(const N of A)W.emitOne(F(N))})}map(A){return z.map(this,A)}static filter(A,F){return new z(async W=>{for await(const N of A)F(N)&&W.emitOne(N)})}filter(A){return z.filter(this,A)}static coalesce(A){return z.filter(A,F=>!!F)}coalesce(){return z.coalesce(this)}static async toPromise(A){const F=[];for await(const W of A)F.push(W);return F}toPromise(){return z.toPromise(this)}g(A){this.a===0&&(this.b.push(A),this.f.fire())}h(A){this.a===0&&(this.b=this.b.concat(A),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(A){this.a===0&&(this.a=2,this.d=A,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Q extends z{constructor(A,F){super(F),this.l=A}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function ne(x){const A=new E.CancellationTokenSource,F=x(A.token);return new Q(A,async W=>{const N=A.token.onCancellationRequested(()=>{N.dispose(),A.dispose(),W.reject(new t.CancellationError)});try{for await(const $ of F){if(A.token.isCancellationRequested)return;W.emitOne($)}N.dispose(),A.dispose()}catch($){N.dispose(),A.dispose(),W.reject($)}})}e.createCancelableAsyncIterable=ne}),define(ee[100],te([0,1,25,8,32,40,9,4,27]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",y="[^/\\\\]",b=/\//g;function h(q,T){switch(q){case 0:return"";case 1:return`${y}*?`;default:return`(?:${p}|${y}+${p}${T?`|${p}${y}+`:""})*?`}}function d(q,T){if(!q)return[];const U=[];let z=!1,Q=!1,ne="";for(const x of q){switch(x){case T:if(!z&&!Q){U.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ne+=x}return ne&&U.push(ne),U}e.splitGlobAware=d;function v(q){if(!q)return"";let T="";const U=d(q,e.GLOB_SPLIT);if(U.every(z=>z===e.GLOBSTAR))T=".*";else{let z=!1;U.forEach((Q,ne)=>{if(Q===e.GLOBSTAR){if(z)return;T+=h(2,ne===U.length-1)}else{let x=!1,A="",F=!1,W="";for(const N of Q){if(N!=="}"&&x){A+=N;continue}if(F&&(N!=="]"||!W)){let $;N==="-"?$=N:(N==="^"||N==="!")&&!W?$="^":N===e.GLOB_SPLIT?$="":$=(0,w.escapeRegExpCharacters)(N),W+=$;continue}switch(N){case"{":x=!0;continue;case"[":F=!0;continue;case"}":{T+=`(?:${d(A,",").map(B=>v(B)).join("|")})`,x=!1,A="";break}case"]":{T+="["+W+"]",F=!1,W="";break}case"?":T+=y;continue;case"*":T+=h(1);continue;default:T+=(0,w.escapeRegExpCharacters)(N)}}ne<U.length-1&&(U[ne+1]!==e.GLOBSTAR||ne+2<U.length)&&(T+=p)}z=Q===e.GLOBSTAR})}return T}const l=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function o(q,T){if(!q)return n;let U;typeof q!="string"?U=q.pattern:U=q,U=U.trim();const z=`${U}_${!!T.trimForExclusions}`;let Q=i.get(z);if(Q)return a(Q,q);let ne;return l.test(U)?Q=s(U.substr(4),U):(ne=u.exec(c(U,T)))?Q=f(ne[1],U):(T.trimForExclusions?k:g).test(U)?Q=C(U,T):(ne=S.exec(c(U,T)))?Q=L(ne[1].substr(1),U,!0):(ne=D.exec(c(U,T)))?Q=L(ne[1],U,!1):Q=O(U),i.set(z,Q),a(Q,q)}function a(q,T){if(typeof T=="string")return q;const U=function(z,Q){return(0,P.isEqualOrParent)(z,T.base,!I.isLinux)?q((0,w.ltrim)(z.substr(T.base.length),M.sep),Q):null};return U.allBasenames=q.allBasenames,U.allPaths=q.allPaths,U.basenames=q.basenames,U.patterns=q.patterns,U}function c(q,T){return T.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function s(q,T){return function(U,z){return typeof U=="string"&&U.endsWith(q)?T:null}}function f(q,T){const U=`/${q}`,z=`\\${q}`,Q=function(x,A){return typeof x!="string"?null:A?A===q?T:null:x===q||x.endsWith(U)||x.endsWith(z)?T:null},ne=[q];return Q.basenames=ne,Q.patterns=[T],Q.allBasenames=ne,Q}function C(q,T){const U=fe(q.slice(1,-1).split(",").map(A=>o(A,T)).filter(A=>A!==n),q),z=U.length;if(!z)return n;if(z===1)return U[0];const Q=function(A,F){for(let W=0,N=U.length;W<N;W++)if(U[W](A,F))return q;return null},ne=U.find(A=>!!A.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const x=U.reduce((A,F)=>F.allPaths?A.concat(F.allPaths):A,[]);return x.length&&(Q.allPaths=x),Q}function L(q,T,U){const z=M.sep===M.posix.sep,Q=z?q:q.replace(b,M.sep),ne=M.sep+Q,x=M.posix.sep+q;let A;return U?A=function(F,W){return typeof F=="string"&&(F===Q||F.endsWith(ne)||!z&&(F===q||F.endsWith(x)))?T:null}:A=function(F,W){return typeof F=="string"&&(F===Q||!z&&F===q)?T:null},A.allPaths=[(U?"*/":"./")+q],A}function O(q){try{const T=new RegExp(`^${v(q)}$`);return function(U){return T.lastIndex=0,typeof U=="string"&&T.test(U)?q:null}}catch{return n}}function j(q,T,U){return!q||typeof T!="string"?!1:K(q)(T,void 0,U)}e.match=j;function K(q,T={}){if(!q)return r;if(typeof q=="string"||V(q)){const U=o(q,T);if(U===n)return r;const z=function(Q,ne){return!!U(Q,ne)};return U.allBasenames&&(z.allBasenames=U.allBasenames),U.allPaths&&(z.allPaths=U.allPaths),z}return se(q,T)}e.parse=K;function V(q){const T=q;return T?typeof T.base=="string"&&typeof T.pattern=="string":!1}e.isRelativePattern=V;function J(q){return q.allBasenames||[]}e.getBasenameTerms=J;function re(q){return q.allPaths||[]}e.getPathTerms=re;function se(q,T){const U=fe(Object.getOwnPropertyNames(q).map(A=>ae(A,q[A],T)).filter(A=>A!==n)),z=U.length;if(!z)return n;if(!U.some(A=>!!A.requiresSiblings)){if(z===1)return U[0];const A=function(N,$){let G;for(let B=0,X=U.length;B<X;B++){const Z=U[B](N,$);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(G||(G=[]),G.push(Z))}return G?(async()=>{for(const B of G){const X=await B;if(typeof X=="string")return X}return null})():null},F=U.find(N=>!!N.allBasenames);F&&(A.allBasenames=F.allBasenames);const W=U.reduce((N,$)=>$.allPaths?N.concat($.allPaths):N,[]);return W.length&&(A.allPaths=W),A}const Q=function(A,F,W){let N,$;for(let G=0,B=U.length;G<B;G++){const X=U[G];X.requiresSiblings&&W&&(F||(F=(0,M.basename)(A)),N||(N=F.substr(0,F.length-(0,M.extname)(A).length)));const Z=X(A,F,N,W);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&($||($=[]),$.push(Z))}return $?(async()=>{for(const G of $){const B=await G;if(typeof B=="string")return B}return null})():null},ne=U.find(A=>!!A.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const x=U.reduce((A,F)=>F.allPaths?A.concat(F.allPaths):A,[]);return x.length&&(Q.allPaths=x),Q}function ae(q,T,U){if(T===!1)return n;const z=o(q,U);if(z===n)return n;if(typeof T=="boolean")return z;if(T){const Q=T.when;if(typeof Q=="string"){const ne=(x,A,F,W)=>{if(!W||!z(x,A))return null;const N=Q.replace("$(basename)",()=>F),$=W(N);return(0,t.isThenable)($)?$.then(G=>G?q:null):$?q:null};return ne.requiresSiblings=!0,ne}}return z}function fe(q,T){const U=q.filter(A=>!!A.basenames);if(U.length<2)return q;const z=U.reduce((A,F)=>{const W=F.basenames;return W?A.concat(W):A},[]);let Q;if(T){Q=[];for(let A=0,F=z.length;A<F;A++)Q.push(T)}else Q=U.reduce((A,F)=>{const W=F.patterns;return W?A.concat(W):A},[]);const ne=function(A,F){if(typeof A!="string")return null;if(!F){let N;for(N=A.length;N>0;N--){const $=A.charCodeAt(N-1);if($===47||$===92)break}F=A.substr(N)}const W=z.indexOf(F);return W!==-1?Q[W]:null};ne.basenames=z,ne.patterns=Q,ne.allBasenames=z;const x=q.filter(A=>!A.basenames);return x.push(ne),x}function ge(q,T){return(0,E.equals)(q,T,(U,z)=>typeof U=="string"&&typeof z=="string"?U===z:typeof U!="string"&&typeof z!="string"?U.base===z.base&&U.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(ee[36],te([0,1,25,32,9,4,20,27]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(n,o){const{os:a,tildify:c,relative:s}=o;if(s){const L=m(n,s,a);if(typeof L=="string")return L}let f=n.fsPath;if(a===1&&!R.isWindows?f=f.replace(/\//g,"\\"):a!==1&&R.isWindows&&(f=f.replace(/\\/g,"/")),a!==1&&c?.userHome){const L=c.userHome.fsPath;let O;n.scheme!==c.userHome.scheme&&n.path.startsWith(P.posix.sep)?O=c.userHome.with({path:n.path}).fsPath:O=n.fsPath,f=b(O,L,a)}return(a===1?P.win32:P.posix).normalize(p(f,a===1))}e.getPathLabel=w;function m(n,o,a){const c=a===1?P.win32:P.posix,s=a===3?M.extUri:M.extUriIgnorePathCase,f=o.getWorkspace(),C=(0,E.firstOrDefault)(f.folders);if(!C)return;n.scheme!==C.uri.scheme&&n.path.startsWith(P.posix.sep)&&(n=C.uri.with({path:n.path}));const L=o.getWorkspaceFolder(n);if(!L)return;let O;if(s.isEqual(L.uri,n)?O="":O=s.relativePath(L.uri,n)??"",O&&(O=c.normalize(O)),f.folders.length>1&&!o.noPrefix){const j=L.name?L.name:s.basenameOrAuthority(L.uri);O=O?`${j} \u2022 ${O}`:j}return O}function p(n,o=R.isWindows){return(0,t.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=p;let y=Object.create(null);function b(n,o,a=R.OS){if(a===1||!n||!o)return n;let c=y.original===o?y.normalized:void 0;c||(c=o,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,I.rtrim)(c,P.posix.sep)}${P.posix.sep}`,y={original:o,normalized:c});let s=n;return R.isWindows&&(s=(0,t.toSlashes)(s)),(a===3?s.startsWith(c):(0,I.startsWithIgnoreCase)(s,c))?`~/${s.substr(c.length)}`:n}e.tildify=b;function h(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=h;const d="\u2026",v="\\\\",l="~";function u(n,o=P.sep){const a=new Array(n.length);let c=!1;for(let s=0;s<n.length;s++){const f=n[s];if(f===""){a[s]=`.${o}`;continue}if(!f){a[s]=f;continue}c=!0;let C="",L=f;L.indexOf(v)===0?(C=L.substr(0,L.indexOf(v)+v.length),L=L.substr(L.indexOf(v)+v.length)):L.indexOf(o)===0?(C=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(l)===0&&(C=L.substr(0,L.indexOf(l)+l.length),L=L.substr(L.indexOf(l)+l.length));const O=L.split(o);for(let j=1;c&&j<=O.length;j++)for(let K=O.length-j;c&&K>=0;K--){c=!1;let V=O.slice(K,K+j).join(o);for(let J=0;!c&&J<n.length;J++)if(J!==s&&n[J]&&n[J].indexOf(V)>-1){const re=K+j===O.length,se=K>0&&n[J].indexOf(o)>-1?o+V:V,ae=n[J].endsWith(se);c=!re||ae}if(!c){let J="";(O[0].endsWith(":")||C!=="")&&(K===1&&(K=0,j++,V=O[0]+o+V),K>0&&(J=O[0]+o),J=C+J),K>0&&(J=J+d+o),J=J+V,K+j<O.length&&(J=J+o+d),a[s]=J}}c&&(a[s]=f)}return a}e.shorten=u;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function k(n,o=Object.create(null)){const a=[];let c=!1,s="";for(const f of n)if(f==="$"||c&&f==="{")s&&a.push({value:s,type:g.TEXT}),s="",c=!0;else if(f==="}"&&c){const C=o[s];if(typeof C=="string")C.length&&a.push({value:C,type:g.VARIABLE});else if(C){const L=a[a.length-1];(!L||L.type!==g.SEPARATOR)&&a.push({value:C.label,type:g.SEPARATOR})}s="",c=!1}else s+=f;return s&&!c&&a.push({value:s,type:g.TEXT}),a.filter((f,C)=>{if(f.type===g.SEPARATOR){const L=a[C-1],O=a[C+1];return[L,O].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=k;function S(n,o){return R.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function D(n,o){return R.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const o=n.indexOf("/")!==-1?P.posix:P.win32,a=o.basename(n),c=o.dirname(n);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ee[142],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(p){return p.toJSON()}class P{constructor(y){this.a=y}transformIncoming(y){const b=this.a.transformIncoming(y);return b===y?y:t(E.URI.from(b))}transformOutgoing(y){const b=this.a.transformOutgoing(y);return b===y?y:t(E.URI.from(b))}transformOutgoingURI(y){const b=this.a.transformOutgoing(y);return b===y?y:E.URI.from(b)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function R(p,y,b){if(!p||b>200)return null;if(typeof p=="object"){if(p instanceof E.URI)return y.transformOutgoing(p);for(const h in p)if(Object.hasOwnProperty.call(p,h)){const d=R(p[h],y,b+1);d!==null&&(p[h]=d)}}return null}function M(p,y){const b=R(p,y,0);return b===null?p:b}e.transformOutgoingURIs=M;function I(p,y,b,h){if(!p||h>200)return null;if(typeof p=="object"){if(p.$mid===1)return b?E.URI.revive(y.transformIncoming(p)):y.transformIncoming(p);for(const d in p)if(Object.hasOwnProperty.call(p,d)){const v=I(p[d],y,b,h+1);v!==null&&(p[d]=v)}}return null}function w(p,y){const b=I(p,y,!1,0);return b===null?p:b}e.transformIncomingURIs=w;function m(p,y){const b=I(p,y,!0,0);return b===null?p:b}e.transformAndReviveIncomingURIs=m}),define(ee[83],te([0,1,26,13,60,31,130]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(p){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,y=0;const b=(0,E.networkInterfaces)();for(const h in b){const d=b[h];if(d)for(const{mac:v,internal:l}of d)l||(y+=1,this.c(v.toUpperCase())&&(p+=1))}this.b=y>0?p/y:0}return this.b}};let I;async function w(){return I||(I=(async()=>await m()||R.generateUuid())()),I}e.getMachineId=w;async function m(){try{const p=await new Promise((b,h)=>{H(["crypto"],b,h)}),y=(0,M.getMac)();return p.createHash("sha256").update(y,"utf8").digest("hex")}catch(p){t.onUnexpectedError(p);return}}}),define(ee[23],te([0,1,41,26,143,8,32,78,9,4,20,7]),function(H,e,E,t,P,R,M,I,w,m,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function h(se,ae=b.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ae===b.UNLINK?v(se):d(se)}async function d(se){try{const ae=(0,M.randomPath)((0,t.tmpdir)());try{await E.promises.rename(se,ae)}catch(fe){return fe.code==="ENOENT"?void 0:v(se)}v(ae).catch(fe=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function v(se){return(0,P.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function l(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function u(se,ae){return S(await(ae?g(se):(0,P.promisify)(E.readdir)(se)))}async function g(se){try{return await(0,P.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ae=[],fe=await u(se);for(const ge of fe){let q=!1,T=!1,U=!1;try{const z=await e.Promises.lstat((0,w.join)(se,ge));q=z.isFile(),T=z.isDirectory(),U=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ae.push({name:ge,isFile:()=>q,isDirectory:()=>T,isSymbolicLink:()=>U})}return ae}function k(se){return S(E.readdirSync(se))}e.readdirSync=k;function S(se){return se.map(ae=>typeof ae=="string"?m.isMacintosh?(0,I.normalizeNFC)(ae):ae:(ae.name=m.isMacintosh?(0,I.normalizeNFC)(ae.name):ae.name,ae))}async function D(se){const ae=await u(se),fe=[];for(const ge of ae)await r.existsDirectory((0,w.join)(se,ge))&&fe.push(ge);return fe}function i(se,ae=1e3){return new Promise(fe=>{let ge=!1;const q=setInterval(()=>{ge||(ge=!0,E.access(se,T=>{ge=!1,T&&(clearInterval(q),fe(void 0))}))},ae)})}e.whenDeleted=i;var r;(function(se){async function ae(q){let T;try{if(T=await e.Promises.lstat(q),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(m.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw z}throw U}}se.stat=ae;async function fe(q){try{const{stat:T,symbolicLink:U}=await se.stat(q);return T.isFile()&&U?.dangling!==!0}catch{}return!1}se.existsFile=fe;async function ge(q){try{const{stat:T,symbolicLink:U}=await se.stat(q);return T.isDirectory()&&U?.dangling!==!0}catch{}return!1}se.existsDirectory=ge})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function o(se,ae,fe){return n.queueFor(y.URI.file(se),p.extUriBiasedIgnorePathCase).queue(()=>{const ge=C(fe);return new Promise((q,T)=>s(se,ae,ge,U=>U?T(U):q()))})}let a=!0;function c(se){a=se}e.configureFlushOnWrite=c;function s(se,ae,fe,ge){if(!a)return E.writeFile(se,ae,{mode:fe.mode,flag:fe.flag},ge);E.open(se,fe.flag,fe.mode,(q,T)=>{if(q)return ge(q);E.writeFile(T,ae,U=>{if(U)return E.close(T,()=>ge(U));E.fdatasync(T,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),E.close(T,Q=>ge(Q))))})})}function f(se,ae,fe){const ge=C(fe);if(!a)return E.writeFileSync(se,ae,{mode:ge.mode,flag:ge.flag});const q=E.openSync(se,ge.flag,ge.mode);try{E.writeFileSync(q,ae);try{E.fdatasyncSync(q)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),c(!1)}}finally{E.closeSync(q)}}e.writeFileSync=f;function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function L(se,ae){if(se!==ae)try{await e.Promises.rename(se,ae)}catch(fe){if(se.toLowerCase()!==ae.toLowerCase()&&fe.code==="EXDEV"||se.endsWith("."))await O(se,ae,{preserveSymlinks:!1}),await h(se,b.MOVE);else throw fe}}async function O(se,ae,fe){return K(se,ae,{root:{source:se,target:ae},options:fe,handledSourcePaths:new Set})}const j=511;async function K(se,ae,fe){if(fe.handledSourcePaths.has(se))return;fe.handledSourcePaths.add(se);const{stat:ge,symbolicLink:q}=await r.stat(se);if(q){if(fe.options.preserveSymlinks)try{return await re(se,ae,fe)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(q.dangling)return}return ge.isDirectory()?V(se,ae,ge.mode&j,fe):J(se,ae,ge.mode&j)}async function V(se,ae,fe,ge){await e.Promises.mkdir(ae,{recursive:!0,mode:fe});const q=await u(se);for(const T of q)await K((0,w.join)(se,T),(0,w.join)(ae,T),ge)}async function J(se,ae,fe){await e.Promises.copyFile(se,ae),await e.Promises.chmod(ae,fe)}async function re(se,ae,fe){let ge=await e.Promises.readlink(se);(0,M.isEqualOrParent)(ge,fe.root.source,!m.isLinux)&&(ge=(0,w.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ae)}e.Promises=new class{get access(){return(0,P.promisify)(E.access)}get stat(){return(0,P.promisify)(E.stat)}get lstat(){return(0,P.promisify)(E.lstat)}get utimes(){return(0,P.promisify)(E.utimes)}get read(){return(se,ae,fe,ge,q)=>new Promise((T,U)=>{E.read(se,ae,fe,ge,q,(z,Q,ne)=>z?U(z):T({bytesRead:Q,buffer:ne}))})}get readFile(){return(0,P.promisify)(E.readFile)}get write(){return(se,ae,fe,ge,q)=>new Promise((T,U)=>{E.write(se,ae,fe,ge,q,(z,Q,ne)=>z?U(z):T({bytesWritten:Q,buffer:ne}))})}get appendFile(){return(0,P.promisify)(E.appendFile)}get fdatasync(){return(0,P.promisify)(E.fdatasync)}get truncate(){return(0,P.promisify)(E.truncate)}get rename(){return(0,P.promisify)(E.rename)}get copyFile(){return(0,P.promisify)(E.copyFile)}get open(){return(0,P.promisify)(E.open)}get close(){return(0,P.promisify)(E.close)}get symlink(){return(0,P.promisify)(E.symlink)}get readlink(){return(0,P.promisify)(E.readlink)}get chmod(){return(0,P.promisify)(E.chmod)}get mkdir(){return(0,P.promisify)(E.mkdir)}get unlink(){return(0,P.promisify)(E.unlink)}get rmdir(){return(0,P.promisify)(E.rmdir)}get realpath(){return(0,P.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return D}get writeFile(){return o}get rm(){return h}get move(){return L}get copy(){return O}}}),define(ee[101],te([0,1,41,9,4,27,23]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(b){if(P.isLinux)return b;const h=(0,t.dirname)(b);if(b===h)return b;const d=((0,t.basename)(b)||b).toLowerCase();try{const l=(0,M.readdirSync)(h).filter(u=>u.toLowerCase()===d);if(l.length===1){const u=I(h);if(u)return(0,t.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(d);if(u>=0){const g=I(h);if(g)return(0,t.join)(g,l[u])}}}catch{}return null}e.realcaseSync=I;async function w(b){if(P.isLinux)return b;const h=(0,t.dirname)(b);if(b===h)return b;const d=((0,t.basename)(b)||b).toLowerCase();try{const l=(await M.Promises.readdir(h)).filter(u=>u.toLowerCase()===d);if(l.length===1){const u=await w(h);if(u)return(0,t.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(d);if(u>=0){const g=await w(h);if(g)return(0,t.join)(g,l[u])}}}catch{}return null}e.realcase=w;async function m(b){try{return await M.Promises.realpath(b)}catch{const d=y(b);return await M.Promises.access(d,E.constants.R_OK),d}}e.realpath=m;function p(b){try{return E.realpathSync(b)}catch{const d=y(b);return E.accessSync(d,E.constants.R_OK),d}}e.realpathSync=p;function y(b){return(0,R.rtrim)((0,t.normalize)(b),t.sep)}}),define(ee[144],te([0,1,26,9,23]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var w;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(w||(w={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class y{constructor(D,i,r){this.exePath=D,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:S=!1}={}){return S?m===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:S=!1,findPreview:D=!1}={}){const i=b({useAlternateBitness:S});if(!i)return null;const r=t.join(i,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let n=-1,o=null;for(const s of await P.Promises.readdir(r)){let f=-1;if(D){const L=s.indexOf("-");if(L<0)continue;const O=s.substring(0,L);if(!R.test(O)||s.substring(L+1)!=="preview")continue;f=parseInt(O,10)}else{if(!R.test(s))continue;f=parseInt(s,10)}if(f<=n)continue;const C=t.join(r,s,"pwsh.exe");!await P.SymlinkSupport.existsFile(C)||(o=C,n=f)}if(!o)return null;const a=i.includes("x86")?" (x86)":"",c=D?" Preview":"";return new y(o,`PowerShell${c}${a}`,!0)}async function d({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const D=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const n of await P.Promises.readdir(D))if(i.test(n)){const o=t.join(D,n,"pwsh.exe");return new y(o,r)}return null}function v(){const S=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new y(S,".NET Core PowerShell Global Tool")}function l(){const S=t.join(process.env.windir,m===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(S,"Windows PowerShell",!0)}async function*u(){let S=await h();S&&(yield S),S=await h({useAlternateBitness:!0}),S&&(yield S),S=await d(),S&&(yield S),S=v(),S&&(yield S),S=await h({findPreview:!0}),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await h({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=l(),S&&(yield S)}async function*g(){for await(const S of u())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=g;async function k(){for await(const S of g())return S;return null}e.getFirstAvailablePowerShellInstallation=k}),define(ee[84],te([0,1,9,4,35,81,11,23]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function w(y=P.env){return y.comspec||"cmd.exe"}e.getWindowsShell=w;function m(y){let b=[],h=!1;const d=function(v){if(h){b.push(v);return}(!y.send(v,u=>{if(u&&console.error(u),h=!1,b.length>0){const g=b.slice(0);b=[],g.forEach(k=>d(k))}})||t.isWindows)&&(h=!0)};return{send:d}}e.createQueuedSender=m;var p;(function(y){async function b(h,d,v){if(E.isAbsolute(h))return h;if(d===void 0&&(d=P.cwd()),E.dirname(h)!=="."||(v===void 0&&M.isString(P.env.PATH)&&(v=P.env.PATH.split(E.delimiter)),v===void 0||v.length===0))return E.join(d,h);async function u(g){if(await I.Promises.exists(g)){let k;try{k=await I.Promises.stat(g)}catch(S){S.message.startsWith("EACCES")&&(k=await I.Promises.lstat(g))}return k?!k.isDirectory():!1}return!1}for(const g of v){let k;if(E.isAbsolute(g)?k=E.join(g,h):k=E.join(d,g,h),await u(k))return k;let S=k+".com";if(await u(S)||(S=k+".exe",await u(S)))return S}return E.join(d,h)}y.findExecutable=b})(p=e.win32||(e.win32={}))}),define(ee[102],te([0,1,46,15]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(M){return new Promise((I,w)=>{let m;const p=new Map;function y(h,d,v,l,u){const g=p.get(d);if(h===M||g){const k={name:b(v),cmd:v,pid:h,ppid:d,load:l,mem:u};p.set(h,k),h===M&&(m=k),g&&(g.children||(g.children=[]),g.children.push(k),g.children.length>1&&(g.children=g.children.sort((S,D)=>S.pid-D.pid)))}}function b(h){const d=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,l=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,S=/\\pipe\\winpty-control/,D=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(k.exec(h))return"electron-crash-reporter";if(S.exec(h))return"winpty-process";if(D.exec(h))return"console-window-host (Windows internal process)";let r=i.exec(h);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(h)?"shared-process":v.exec(h)?"issue-reporter":l.exec(h)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(h))return"utility-network-service";if(g.exec(h))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const n=/[a-zA-Z-]+\.js/g;let o="";do r=n.exec(h),r&&(o+=r+" ");while(r);return o&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${o}`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{H(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(M,v=>{if(!v){w(new Error(`Root process ${M} not found`));return}d.getProcessCpuUsage(v,l=>{const u=new Map;l.forEach(g=>{const k=h(g.commandLine||"");u.set(g.pid,{name:b(k),cmd:k,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),m=u.get(M),m?(u.forEach(g=>{const k=u.get(g.ppid);k&&(k.children||(k.children=[]),k.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((k,S)=>k.pid-S.pid))}),I(m)):w(new Error(`Root process ${M} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[m];const v=[];for(;d.length;){const u=d.shift();u&&(v.push(u.pid),u.children&&(d=d.concat(u.children)))}let l=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);l+=" "+v.join(" "),(0,E.exec)(l,{},(u,g,k)=>{if(u||k)w(u||new Error(k.toString()));else{const S=g.toString().split(`
`);for(let D=0;D<v.length;D++){const i=p.get(v[D]);i.load=parseFloat(S[D])}if(!m){w(new Error(`Root process ${M} not found`));return}I(m)}})};(0,E.exec)("which ps",{},(d,v,l)=>{if(d||l)if(process.platform!=="linux")w(d||new Error(l.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(u,{},(g,k,S)=>{g||S?w(g||new Error(S.toString())):(R(k,y),h())})}else{const u=v.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,S,D)=>{k||D&&!D.includes("screen size is bogus")?w(k||new Error(D.toString())):(R(S,y),process.platform==="linux"?h():m?I(m):w(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=P;function R(M,I){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=M.toString().split(`
`);for(const p of m){const y=w.exec(p.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ee[145],te([0,1,26,4,144,84]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(y,b){return y===1?t.isWindows?p():R.getWindowsShell(b):w(y,b)}e.getSystemShell=M;let I=null;function w(y,b){if(t.isLinux&&y===2||t.isMacintosh&&y===3)return"/bin/bash";if(!I){let h;if(t.isWindows)h="/bin/bash";else{if(h=b.SHELL,!h)try{h=(0,E.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}I=h}return I}let m=null;async function p(){return m||(m=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),m}});var pe=this&&this.__decorate||function(H,e,E,t){var P=arguments.length,R=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,E,t);else for(var I=H.length-1;I>=0;I--)(M=H[I])&&(R=(P<3?M(R):P>3?M(e,E,R):M(e,E))||R);return P>3&&R&&Object.defineProperty(e,E,R),R};define(ee[47],te([0,1,25,8,17,22,54,13,3,2,71,27,11]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(h||(h={}));function d(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function l(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function g(T){let U=0;for(let z=0;;z+=7){const Q=T.read(1);if(U|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return U}}const k=n(0);function S(T,U){if(U===0){T.write(k);return}let z=0;for(let ne=U;ne!==0;ne=ne>>>7)z++;const Q=P.VSBuffer.alloc(z);for(let ne=0;U!==0;ne++)Q.buffer[ne]=U&127,U=U>>>7,U>0&&(Q.buffer[ne]|=128);T.write(Q)}class D{constructor(U){this.b=U,this.a=0}read(U){const z=this.b.slice(this.a,this.a+U);return this.a+=z.byteLength,z}}e.BufferReader=D;class i{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=i;var r;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(r||(r={}));function n(T){const U=P.VSBuffer.alloc(1);return U.writeUInt8(T,0),U}const o={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},a=typeof Buffer<"u";function c(T,U){if(typeof U>"u")T.write(o.Undefined);else if(typeof U=="string"){const z=P.VSBuffer.fromString(U);T.write(o.String),S(T,z.byteLength),T.write(z)}else if(a&&Buffer.isBuffer(U)){const z=P.VSBuffer.wrap(U);T.write(o.Buffer),S(T,z.byteLength),T.write(z)}else if(U instanceof P.VSBuffer)T.write(o.VSBuffer),S(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(o.Array),S(T,U.length);for(const z of U)c(T,z)}else if(typeof U=="number"&&(U|0)===U)T.write(o.Uint),S(T,U);else{const z=P.VSBuffer.fromString(JSON.stringify(U));T.write(o.Object),S(T,z.byteLength),T.write(z)}}e.serialize=c;function s(T){switch(T.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return T.read(g(T)).toString();case r.Buffer:return T.read(g(T)).buffer;case r.VSBuffer:return T.read(g(T));case r.Array:{const z=g(T),Q=[];for(let ne=0;ne<z;ne++)Q.push(s(T));return Q}case r.Object:return JSON.parse(T.read(g(T)).toString());case r.Int:return g(T)}}e.deserialize=s;class f{constructor(U,z,Q=null,ne=1e3){this.h=U,this.j=z,this.k=Q,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(U,z){this.b.set(U,z),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const z=this.o([U.type]);this.k?.logOutgoing(z,0,1,l(U.type));return}case 201:case 202:case 204:case 203:{const z=this.o([U.type,U.id],U.data);this.k?.logOutgoing(z,U.id,1,l(U.type),U.data);return}}}o(U,z=void 0){const Q=new i;return c(Q,U),c(Q,z),this.p(Q.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const z=new D(U),Q=s(z),ne=s(z),x=Q[0];switch(x){case 100:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,ne),this.s({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 102:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,ne),this.t({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 101:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]});case 103:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]})}}s(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Q=new R.CancellationTokenSource;let ne;try{ne=z.call(this.j,U.name,U.arg,Q.token)}catch(F){ne=Promise.reject(F)}const x=U.id;ne.then(F=>{this.m({id:x,data:F,type:201}),this.d.delete(U.id)},F=>{F instanceof Error?this.m({id:x,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:x,data:F,type:203}),this.d.delete(U.id)});const A=(0,m.toDisposable)(()=>Q.cancel());this.d.set(U.id,A)}t(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Q=U.id,x=z.listen(this.j,U.name,U.arg)(A=>this.m({id:Q,data:A,type:204}));this.d.set(U.id,x)}u(U){const z=this.d.get(U.id);z&&(z.dispose(),this.d.delete(U.id))}v(U){let z=this.g.get(U.channelName);z||(z=[],this.g.set(U.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:U,timeoutTimer:Q})}w(U){const z=this.g.get(U);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var C;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(U,z=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=z}getChannel(U){const z=this;return{call(Q,ne,x){return z.a?Promise.reject(new I.CancellationError):z.m(U,Q,ne,x)},listen(Q,ne){return z.a?w.Event.None:z.o(U,Q,ne)}}}m(U,z,Q,ne=R.CancellationToken.None){const x=this.g++,F={id:x,type:100,channelName:U,name:z,arg:Q};if(ne.isCancellationRequested)return Promise.reject(new I.CancellationError);let W;return new Promise(($,G)=>{if(ne.isCancellationRequested)return G(new I.CancellationError);const B=()=>{const de=ke=>{switch(ke.type){case 201:this.f.delete(x),$(ke.data);break;case 202:{this.f.delete(x);const De=new Error(ke.data.message);De.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,De.name=ke.data.name,G(De);break}case 203:this.f.delete(x),G(ke.data);break}};this.f.set(x,de),this.p(F)};let X=null;this.b===u.Idle?B():(X=(0,t.createCancelablePromise)(de=>this.u()),X.then(()=>{X=null,B()}));const Z=()=>{X?(X.cancel(),X=null):this.p({id:x,type:101}),G(new I.CancellationError)},oe=ne.onCancellationRequested(Z);W=(0,m.combinedDisposable)((0,m.toDisposable)(Z),oe),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(U,z,Q){const ne=this.g++,A={id:ne,type:102,channelName:U,name:z,arg:Q};let F=null;const W=new w.Emitter({onWillAddFirstListener:()=>{F=(0,t.createCancelablePromise)($=>this.u()),F.then(()=>{F=null,this.d.add(W),this.p(A)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(W),this.p({id:ne,type:103}))}}),N=$=>W.fire($.data);return this.f.set(ne,N),W.event}p(U){switch(U.type){case 100:case 102:{const z=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(z,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const z=this.q([U.type,U.id]);this.j?.logOutgoing(z,U.id,0,d(U.type));return}}}q(U,z=void 0){const Q=new i;return c(Q,U),c(Q,z),this.r(Q.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const z=new D(U),Q=s(z),ne=s(z),x=Q[0];switch(x){case 200:return this.j?.logIncoming(U.byteLength,0,0,l(x)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Q[1],0,l(x),ne),this.t({type:Q[0],id:Q[1],data:ne})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}pe([M.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class O{get connections(){const U=[];return this.f.forEach(z=>U.push(z)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:z,onDidClientDisconnect:Q})=>{w.Event.once(z.onMessage)(x=>{const A=new D(x),F=s(A),W=new f(z,F),N=new L(z);this.a.forEach((G,B)=>W.registerChannel(B,G));const $={channelServer:W,channelClient:N,ctx:F};this.f.add($),this.g.fire($),Q(()=>{W.dispose(),N.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(U,z){const Q=this;return{call(ne,x,A){let F;if((0,b.isFunction)(z)){const N=(0,E.getRandomElement)(Q.connections.filter(z));F=N?Promise.resolve(N):w.Event.toPromise(w.Event.filter(Q.onDidAddConnection,z))}else F=z.routeCall(Q,ne,x);const W=F.then(N=>N.channelClient.getChannel(U));return K(W).call(ne,x,A)},listen(ne,x){if((0,b.isFunction)(z))return Q.j(U,z,ne,x);const A=z.routeEvent(Q,ne,x).then(F=>F.channelClient.getChannel(U));return K(A).listen(ne,x)}}}j(U,z,Q,ne){const x=this;let A=new m.DisposableStore;const F=new w.Emitter({onWillAddFirstListener:()=>{A=new m.DisposableStore;const W=new w.EventMultiplexer,N=new Map,$=B=>{const Z=B.channelClient.getChannel(U).listen(Q,ne),oe=W.add(Z);N.set(B,oe)},G=B=>{const X=N.get(B);!X||(X.dispose(),N.delete(B))};x.connections.filter(z).forEach($),w.Event.filter(x.onDidAddConnection,z)($,void 0,A),x.onDidRemoveConnection(G,void 0,A),W.event(F.fire,F,A),A.add(W)},onDidRemoveLastListener:()=>{A.dispose()}});return F.event}registerChannel(U,z){this.a.set(U,z),this.f.forEach(Q=>{Q.channelServer.registerChannel(U,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class j{constructor(U,z,Q=null){const ne=new i;c(ne,z),U.send(ne.buffer),this.a=new L(U,Q),this.d=new f(U,z,Q)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,z){this.d.registerChannel(U,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=j;function K(T){return{call(U,z,Q){return T.then(ne=>ne.call(U,z,Q))},listen(U,z){const Q=new w.Relay;return T.then(ne=>Q.input=ne.listen(U,z)),Q.event}}}e.getDelayedChannel=K;function V(T){let U=!1;return{call(z,Q,ne){return U?T.call(z,Q,ne):(0,t.timeout)(0).then(()=>U=!0).then(()=>T.call(z,Q,ne))},listen(z,Q){if(U)return T.listen(z,Q);const ne=new w.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>ne.input=T.listen(z,Q)),ne.event}}}e.getNextTickChannel=V;class J{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const z of U.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await w.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=J;var re;(function(T){function U(x,A){const F=x,W=A&&A.disableMarshalling,N=new Map;for(const $ in F)Q($)&&N.set($,w.Event.buffer(F[$],!0));return new class{listen($,G,B){const X=N.get(G);if(X)return X;if(ne(G)){const Z=F[G];if(typeof Z=="function")return Z.call(F,B)}throw new Error(`Event not found: ${G}`)}call($,G,B){const X=F[G];if(typeof X=="function"){if(!W&&Array.isArray(B))for(let Z=0;Z<B.length;Z++)B[Z]=(0,p.revive)(B[Z]);return X.apply(F,B)}throw new Error(`Method not found: ${G}`)}}}T.fromService=U;function z(x,A){const F=A&&A.disableMarshalling;return new Proxy({},{get(W,N){if(typeof N=="string")return A?.properties?.has(N)?A.properties.get(N):ne(N)?function($){return x.listen(N,$)}:Q(N)?x.listen(N):async function(...$){let G;A&&!(0,b.isUndefinedOrNull)(A.context)?G=[A.context,...$]:G=$;const B=await x.call(N,G);return F?B:(0,p.revive)(B)};throw new Error(`Property not found: ${String(N)}`)}})}T.toService=z;function Q(x){return x[0]==="o"&&x[1]==="n"&&y.isUpperAsciiLetter(x.charCodeAt(2))}function ne(x){return/^onDynamic/.test(x)&&y.isUpperAsciiLetter(x.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function fe(T){return Array.isArray(T)?T.map(ae):ae(T)}function ge(T,U,z,Q,ne,x,A){A=fe(A);const F=se[ne],W=F[Q%F.length];let N=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(x)?(N=N.concat(A),N.push(")")):N.push(A),console.log.apply(console,N)}class q{constructor(U,z){this.d=U,this.f=z,this.a=0,this.b=0}logOutgoing(U,z,Q,ne,x){this.b+=U,ge(this.d,this.b,U,z,Q,ne,x)}logIncoming(U,z,Q,ne,x){this.a+=U,ge(this.f,this.a,U,z,Q,ne,x)}}e.IPCLogger=q}),define(ee[146],te([0,1,17,3,47]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(w){this.a=w,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",m=>E.VSBuffer.wrap(m.data)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class M extends P.IPCClient{constructor(w,m){const p=new R(w);super(p,m),this.b=p}dispose(){this.b.disconnect()}}e.Client=M}),define(ee[103],te([0,1,8,17,3,2,47]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var w;(function(L){L.enableDiagnostics=!1,L.records=[];const O=new WeakMap;let j=0;function K(J,re){if(!O.has(J)){const se=String(++j);O.set(J,se)}return O.get(J)}function V(J,re,se,ae){if(!L.enableDiagnostics)return;const fe=K(J,re);if(ae instanceof t.VSBuffer||ae instanceof Uint8Array||ae instanceof ArrayBuffer||ArrayBuffer.isView(ae)){const ge=t.VSBuffer.alloc(ae.byteLength);ge.set(ae),L.records.push({timestamp:Date.now(),id:fe,label:re,type:se,buff:ge})}else L.records.push({timestamp:Date.now(),id:fe,label:re,type:se,data:ae})}L.traceSocketEvent=V})(w=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function y(){return p||(p=t.VSBuffer.alloc(0)),p}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,j){if(O===0)return y();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const re=this.a[0];return j&&(this.a.shift(),this.b-=O),re}if(this.a[0].byteLength>O){const re=this.a[0].slice(0,O);return j&&(this.a[0]=this.a[0].slice(O),this.b-=O),re}const K=t.VSBuffer.alloc(O);let V=0,J=0;for(;O>0;){const re=this.a[J];if(re.byteLength>O){const se=re.slice(0,O);K.set(se,V),V+=O,j&&(this.a[J]=re.slice(O),this.b-=O),O-=O}else K.set(re,V),V+=re.byteLength,j?(this.a.shift(),this.b-=re.byteLength):J++,O-=re.byteLength}return K}}e.ChunkStream=b;var h;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(h||(h={}));function d(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(O,j,K,V){this.type=O,this.id=j,this.ack=K,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(O){super(),this.f=this.B(new P.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new b,this.B(this.a.onData(j=>this.acceptChunk(j))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const j=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=j.readUInt32BE(9),this.g.messageType=j.readUInt8(0),this.g.id=j.readUInt32BE(1),this.g.ack=j.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,V=this.g.id,J=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",j),this.f.fire(new l(K,V,J,j)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const j=t.VSBuffer.alloc(13);j.writeUInt8(O.type,0),j.writeUInt32BE(O.id,1),j.writeUInt32BE(O.ack,5),j.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(j,O.data)}g(O,j){const K=this.f===0;return this.d.push(O,j),this.f+=O.byteLength+j.byteLength,K}h(){const O=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,j){this.g(O,j)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class k extends R.Disposable{constructor(O){super(),this.f=new P.Emitter,this.onMessage=this.f.event,this.g=new P.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(j=>{j.type===1&&this.f.fire(j.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new l(1,0,0,O))}}e.Protocol=k;class S extends M.IPCClient{static fromSocket(O,j){return new S(new k(O),j)}get onDidDispose(){return this.b.onDidDispose}constructor(O,j,K=null){super(O,j,K),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=S;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new P.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class i{constructor(O){this.data=O,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let O=0,j=this.a;for(;j;)j=j.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let j=0,K=this.a;for(;K;)O[j++]=K.data,K=K.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const j=new i(O);if(!this.a){this.a=j,this.b=j;return}this.b.next=j,this.b=j}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const O=Date.now();for(let j=0;j<n.a;j++)this.c[j]=O-1e3*j;setInterval(()=>{for(let j=n.a;j>=1;j--)this.c[j]=this.c[j-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),j=(1+n.a)*1e3;let K=0;for(let V=0;V<n.a;V++)O-this.c[V]<=j&&K++;return 1-K/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var o;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function a(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class c{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=c;class s{constructor(O,j){this.roundTripTime=O,this.recentHighRoundTripCount=j}}e.HighRoundTripTimeEvent=s;class f{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??n.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=O.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new l(5,0,0,y());this.p.write(O),this.p.flush()}sendPause(){const O=new l(7,0,0,y());this.p.write(O)}sendResume(){const O=new l(8,0,0,y());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,j){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(j)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new l(3,0,this.h,y());this.p.write(O);const j=this.b.toArray();for(let K=0,V=j.length;K<V;K++)this.p.write(j[K]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const j=this.b.peek();if(j&&j.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const j=Date.now();j-this.m>1e4&&(this.m=j,this.p.write(new l(6,0,0,y())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const j=this.b.toArray();for(let K=0,V=j.length;K<V;K++)this.p.write(j[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const j=++this.c;this.h=this.g;const K=new l(1,j,this.h,O);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(O){const j=new l(2,0,0,O);this.p.write(j)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),j=Date.now()-O.writtenTime,K=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(j>=2e4&&K>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:j,timeSinceLastReceivedSomeData:K});return}const J=Math.max(2e4-j,2e4-K,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},J)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new l(3,0,this.h,y());this.p.write(O)}I(){this.h=this.g;const O=new l(9,0,this.h,y());this.p.write(O)}J(O){this.h=this.g;const j=new l(10,0,this.h,O);this.p.write(j)}K(O){this.h=this.g;const j=new l(11,0,this.h,O);this.p.write(j)}}e.PersistentProtocol=f;class C extends R.Disposable{constructor(){super(),this.a=this.B(new P.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new P.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new P.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,j=t.VSBuffer.alloc(4);j.writeUInt32BE(O,0),this.a.fire(j)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const j=O.readUInt32BE(0);if(this.g<=0||j!==this.h)return;const K=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=K;const J=this.l,re=this.j.filter(se=>se>=1e3).length;this.l=re>=3?1:0,K>1e3&&this.b.fire(new s(K,re)),J!==this.l&&this.c.fire(this.l)}}}),define(ee[147],te([0,1,42,17,3,2,47,132]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(p,y){const b=P.Event.fromNodeEventEmitter(E.validatedIpcMain,y,(d,v)=>({event:d,message:v})),h=P.Event.filter(b,({event:d})=>d.sender.id===p);return P.Event.map(h,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends M.IPCServer{static d(){const y=P.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:b})=>b);return P.Event.map(y,b=>{const h=b.id;m.b.get(h)?.dispose();const v=new P.Emitter;m.b.set(h,(0,R.toDisposable)(()=>v.fire()));const l=w(h,"vscode:message"),u=P.Event.any(P.Event.signal(w(h,"vscode:disconnect")),v.event);return{protocol:new I.Protocol(b,l),onDidClientDisconnect:u}})}constructor(){super(m.d())}}e.Server=m,m.b=new Map}),define(ee[104],te([0,1,42,3,31,146]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(m,p){super({addEventListener:(y,b)=>m.addListener(y,b),removeEventListener:(y,b)=>m.removeListener(y,b),postMessage:y=>m.postMessage(y),start:()=>m.start(),close:()=>m.close()},p)}}e.Client=M;async function I(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,P.generateUuid)();w.webContents.send("vscode:createMessageChannel",m);const p=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(b,h)=>({nonce:h,port:b.ports[0]})),{port:y}=await t.Event.toPromise(t.Event.once(t.Event.filter(p,b=>b.nonce===m)));return y}e.connect=I}),define(ee[148],te([0,1,46,8,17,22,141,13,3,2,44,84,81,47]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends h.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",g=>P.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const k=g&&g.timeout?g.timeout:6e4;this.b=new t.Delayer(k),this.d=null,this.f=null}getChannel(u){const g=this;return{call(k,S,D){return g.k(u,k,S,D)},listen(k,S){return g.l(u,k,S)}}}k(u,g,k,S=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const D=this.n(u),i=(0,t.createCancelablePromise)(o=>D.call(g,k,o)),r=S.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,g,k){if(!this.b)return w.Event.None;this.b.cancel();let S;const D=new w.Emitter({onWillAddFirstListener:()=>{S=this.n(u).listen(g,k)(D.fire,D),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,b.removeDangerousEnvVariables)(g.env),this.d=(0,E.fork)(this.i,u,g);const k=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,M.isRemoteConsoleLog)(a)){(0,M.log)(a,`IPC Library: ${this.j.serverName}`);return}k.fire(P.VSBuffer.wrap(Buffer.from(a,"base64")))});const D=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,i=a=>this.d&&this.d.connected&&D.send(a.buffer.toString("base64")),r=k.event,n={send:i,onMessage:r};this.f=new h.ChannelClient(n);const o=()=>this.o();process.once("exit",o),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,c)=>{process.removeListener("exit",o),this.c.forEach(s=>(0,m.dispose)(s)),this.c.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:c})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(ee[85],te([0,1,17,13,3,2,9,4,31,47,103]),function(H,e,E,t,P,R,M,I,w,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(s,f){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,f)}constructor(s,f=""){this.f=!0,this.debugLabel=f,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,t.onUnexpectedError)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const f=C=>{this.traceSocketEvent("read",C),s(E.VSBuffer.wrap(C))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(s){const f=C=>{s({type:0,hadError:C,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(s){const f=()=>{s()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=b;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class v extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,f){this.socket.traceSocketEvent(s,f)}constructor(s,f,C,L){super(),this.f=this.B(new P.Emitter),this.g=this.B(new P.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:C?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new l(this,f,C,L,this.f,(O,j)=>this.k(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new p.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let C=2;s.byteLength<126?C+=0:s.byteLength<2**16?C+=2:C+=8;const L=E.VSBuffer.alloc(C);if(f?L.writeUInt8(194,0):L.writeUInt8(130,0),s.byteLength<126)L.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){L.writeUInt8(126,1);let O=1;L.writeUInt8(s.byteLength>>>8&255,++O),L.writeUInt8(s.byteLength>>>0&255,++O)}else{L.writeUInt8(127,1);let O=1;L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(s.byteLength>>>24&255,++O),L.writeUInt8(s.byteLength>>>16&255,++O),L.writeUInt8(s.byteLength>>>8&255,++O),L.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([L,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),C=f.readUInt8(0),L=(C&128)>>>7,O=(C&64)>>>6,j=f.readUInt8(1),K=(j&128)>>>7,V=j&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),C=f.readUInt8(1),L=(C&128)>>>7;let O=C&127,j=1;O===126?O=f.readUInt8(++j)*2**8+f.readUInt8(++j):O===127&&(O=f.readUInt8(++j)*0+f.readUInt8(++j)*0+f.readUInt8(++j)*0+f.readUInt8(++j)*0+f.readUInt8(++j)*2**24+f.readUInt8(++j)*2**16+f.readUInt8(++j)*2**8+f.readUInt8(++j));let K=0;L&&(K=f.readUInt8(++j)*2**24+f.readUInt8(++j)*2**16+f.readUInt8(++j)*2**8+f.readUInt8(++j)),this.j.state=3,this.j.readLen=O,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),k(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class l extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(s,f,C,L,O,j){super(),this.k=s,this.l=O,this.m=j,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,f?(this.b=this.B(new u(this.k,L,C,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const f=await this.r(this.f,s);this.m(f,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,f){return new Promise((C,L)=>{s.write(f),s.flush(O=>C(O))})}acceptFrame(s,f,C){this.h.push({data:s,isCompressed:f,isLastFrameOfMessage:C}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const f=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(f)}else this.l.fire(s.data)}this.s=!1}}u(s,f,C){return new Promise((L,O)=>{s.write(f),C&&s.write(E.VSBuffer.fromByteArray([0,0,255,255])),s.flush(j=>L(j))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(s,f,C,L){super(),this.h=s,this.j=f,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=y().zlib.createInflateRaw(L),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(E.VSBuffer.wrap(O))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=E.VSBuffer.concat(this.g);this.g.length=0,s(f)})}}class g extends R.Disposable{constructor(s,f){super(),this.g=s,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.b=y().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(E.VSBuffer.wrap(C))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=E.VSBuffer.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),s(f)})}}function k(c,s){if(s===0)return;const f=c.byteLength>>>2;for(let V=0;V<f;V++){const J=c.readUInt32BE(V*4);c.writeUInt32BE(J^s,V*4)}const C=f*4,L=c.byteLength-C,O=s>>>24&255,j=s>>>16&255,K=s>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(C)^O,C),L>=2&&c.writeUInt8(c.readUInt8(C+1)^j,C+1),L>=3&&c.writeUInt8(c.readUInt8(C+2)^K,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function D(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):s=(0,M.join)(y().os.tmpdir(),`vscode-ipc-${c}.sock`),r(s),s}e.createRandomIPCHandle=D;function i(c,s,f){const C=y().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${f}-${s}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${C.substr(0,8)}-${f}-${s}.sock`):L=(0,M.join)(c,`${f}-${s}.sock`),r(L),L}e.createStaticIPCHandle=i;function r(c){const s=S[I.platform];typeof s=="number"&&c.length>=s&&console.warn(`WARNING: IPC handle "${c}" is longer than ${s} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{static b(s){const f=P.Event.fromNodeEventEmitter(s,"connection");return P.Event.map(f,C=>({protocol:new p.Protocol(new b(C,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(C,"close"))}))}constructor(s){super(n.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function o(c){return new Promise((s,f)=>{const C=y().net.createServer();C.on("error",f),C.listen(c,()=>{C.removeListener("error",f),s(new n(C))})})}e.serve=o;function a(c,s){return new Promise((f,C)=>{const L=y().net.createConnection(c,()=>{L.removeListener("error",C),f(p.Client.fromSocket(new b(L,`ipc-client${s}`),s))});L.once("error",C)})}e.connect=a}),define(ee[105],te([0,1,8,3,2,11]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M=e.StorageHint||(e.StorageHint={}));function I(y){const b=y;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var w;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class m extends P.Disposable{constructor(b,h=Object.create(null)){super(),this.m=b,this.n=h,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new E.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((h,d)=>this.s(d,h)),b.deleted?.forEach(h=>this.s(h,void 0))}s(b,h){if(this.c===w.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(h)?d=this.f.delete(b):this.f.get(b)!==h&&(this.f.set(b,h),d=!0),d&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,h){const d=this.f.get(b);return(0,R.isUndefinedOrNull)(d)?h:d}getBoolean(b,h){const d=this.get(b);return(0,R.isUndefinedOrNull)(d)?h:d==="true"}getNumber(b,h){const d=this.get(b);return(0,R.isUndefinedOrNull)(d)?h:parseInt(d,10)}async set(b,h){if(this.c===w.Closed)return;if((0,R.isUndefinedOrNull)(h))return this.delete(b);const d=String(h);if(this.f.get(b)!==d)return this.f.set(b,d),this.j.set(b,d),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===w.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===M.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class p{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((h,d)=>this.a.set(d,h)),b.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=p}),define(ee[149],te([0,1,8,3,40,9,23]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return t.Event.None}constructor(p,y=Object.create(null)){this.g=p,this.h=y,this.c=(0,R.basename)(this.g),this.d=new w(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,y=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(h=>y.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(p){const y=await this.f;return this.j(y,p)}j(p,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,P.mapToString)(y.insert):"0"}), delete(${y.delete?(0,P.setToString)(y.delete):"0"})`),this.t(p,()=>{const b=y.insert,h=y.delete;if(b&&b.size>0){const d=[];d.push([]);let v=0;b.forEach((l,u)=>{let g=d[v];g.length>I.b&&(v++,g=[],d.push(g)),g.push(u,l)}),d.forEach(l=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(l.length/2).fill("(?,?)").join(",")}`,u=>u.run(l),()=>{const u=[];let g=0;return b.forEach((k,S)=>{u.push(S),g+=k.length}),`Keys: ${u.join(", ")} Length: ${g}`})})}if(h&&h.size){const d=[];d.push([]);let v=0;h.forEach(l=>{let u=d[v];u.length>I.b&&(v++,u=[],d.push(u)),u.push(l)}),d.forEach(l=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(l.length).fill("?").join(",")})`,u=>u.run(l),()=>{const u=[];return h.forEach(g=>{u.push(g)}),`Keys: ${u.join(", ")}`})})}})}async close(p){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,p)}k(p,y){return new Promise((b,h)=>{p.db.close(d=>(d&&this.o(p,`[storage ${this.c}] close(): ${d}`),this.g===I.IN_MEMORY_PATH?b():!p.isErroneous&&!p.isInMemory?this.l().then(b,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),b())):typeof y=="function"?M.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const l=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>l(),u=>(l(),Promise.reject(u)))})).then(b,h):h(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return M.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const y=await this.f,b=await this.r(y,p?"PRAGMA integrity_check":"PRAGMA quick_check"),h=p?b.integrity_check:b.quick_check;return y.isErroneous?`${h} (last error: ${y.lastError})`:y.isInMemory?`${h} (in-memory!)`:h}async n(p,y=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${y})`);try{return await this.p(p)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&y)return await(0,E.timeout)(I.a),this.n(p,!1);try{await M.Promises.unlink(p);try{await M.Promises.rename(this.m(p),p)}catch{}return await this.p(p)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(I.IN_MEMORY_PATH)}}}o(p,y){p.isErroneous=!0,p.lastError=y,this.d.error(y)}p(p){return new Promise((y,b)=>{new Promise((h,d)=>{H(["@vscode/sqlite3"],h,d)}).then(h=>{const d={db:new(this.d.isTracing?h.verbose().Database:h.Database)(p,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>b(v)):b(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(d),l=>d.db.close(()=>b(l)))),isInMemory:p===I.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},b)})}q(p,y){return new Promise((b,h)=>{p.db.exec(y,d=>d?(this.o(p,`[storage ${this.c}] exec(): ${d}`),h(d)):b())})}r(p,y){return new Promise((b,h)=>{p.db.get(y,(d,v)=>d?(this.o(p,`[storage ${this.c}] get(): ${d}`),h(d)):b(v))})}s(p,y){return new Promise((b,h)=>{p.db.all(y,(d,v)=>d?(this.o(p,`[storage ${this.c}] all(): ${d}`),h(d)):b(v))})}t(p,y){return new Promise((b,h)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),y(),p.db.run("END TRANSACTION",d=>d?(this.o(p,`[storage ${this.c}] transaction(): ${d}`),h(d)):b())})})}u(p,y,b,h){const d=p.db.prepare(y),v=l=>{this.o(p,`[storage ${this.c}] prepare(): ${l} (${y}). Details: ${h()}`)};d.on("error",v),b(d),d.finalize(l=>{l&&v(l),d.removeListener("error",v)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.a=2e3,I.b=256;class w{constructor(p){p&&typeof p.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.a=p.logTrace),p&&typeof p.logError=="function"&&(this.b=p.logError)}get isTracing(){return!!this.a}trace(p){this.a?.(p)}error(p){this.b?.(p)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[150],te([12,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(ee[151],te([12,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[152],te([12,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[153],te([12,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(ee[154],te([12,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(ee[155],te([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[156],te([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[157],te([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[158],te([12,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[159],te([12,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[160],te([12,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ee[161],te([12,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(ee[162],te([12,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ee[163],te([12,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[164],te([12,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[165],te([12,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[166],te([12,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[167],te([12,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[168],te([12,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ee[169],te([12,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ee[170],te([12,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[171],te([12,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[172],te([12,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[173],te([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[174],te([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[175],te([12,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ee[176],te([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[177],te([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[178],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(P){return P&&P.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(P){return P&&P.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[179],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function P(M){let I=[];try{Array.isArray(M.workspaces)&&(I=M.workspaces.map(w=>({workspace:{id:w.id,configPath:E.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=P;function R(M){let I=[];try{Array.isArray(M.folders)&&(I=M.folders.map(w=>({folderUri:E.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=R}),define(ee[180],te([0,1,3,2]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(I,w,m){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(I,w,m){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P,P.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,w,m){this.b.call("attach",[I,w,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,w){this.b.call("terminate",[I,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,w){return this.b.call("openExtensionDevelopmentHostWindow",[I,w])}}e.ExtensionHostDebugChannelClient=R}),define(ee[181],te([0,1,135,54,15,9,35,20,7]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(w.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?w.URI.file((0,R.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,R.resolve)(d)):w.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const v=M.env.VSCODE_EXTENSIONS;if(v)return v;const l=M.env.VSCODE_PORTABLE;return l?(0,R.join)(l,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?w.URI.parse(v):w.URI.file((0,R.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);l&&l[1]&&l[2]&&d.push([l[1],l[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=M.env.VSCODE_PORTABLE;return d?w.URI.file((0,R.join)(d,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,l){this.a=d,this.b=v,this.c=l,this.editSessionId=this.args.editSessionId}}pe([t.memoize],m.prototype,"appRoot",null),pe([t.memoize],m.prototype,"userHome",null),pe([t.memoize],m.prototype,"userDataPath",null),pe([t.memoize],m.prototype,"appSettingsHome",null),pe([t.memoize],m.prototype,"tmpDir",null),pe([t.memoize],m.prototype,"cacheHome",null),pe([t.memoize],m.prototype,"stateResource",null),pe([t.memoize],m.prototype,"userRoamingDataHome",null),pe([t.memoize],m.prototype,"userDataSyncHome",null),pe([t.memoize],m.prototype,"userDataSyncLogResource",null),pe([t.memoize],m.prototype,"editSessionsLogResource",null),pe([t.memoize],m.prototype,"sync",null),pe([t.memoize],m.prototype,"machineSettingsResource",null),pe([t.memoize],m.prototype,"workspaceStorageHome",null),pe([t.memoize],m.prototype,"localHistoryHome",null),pe([t.memoize],m.prototype,"keyboardLayoutResource",null),pe([t.memoize],m.prototype,"argvResource",null),pe([t.memoize],m.prototype,"isExtensionDevelopment",null),pe([t.memoize],m.prototype,"untitledWorkspacesHome",null),pe([t.memoize],m.prototype,"installSourcePath",null),pe([t.memoize],m.prototype,"builtinExtensionsPath",null),pe([t.memoize],m.prototype,"extensionsPath",null),pe([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],m.prototype,"extensionDevelopmentKind",null),pe([t.memoize],m.prototype,"extensionTestsLocationURI",null),pe([t.memoize],m.prototype,"debugExtensionHost",null),pe([t.memoize],m.prototype,"logLevel",null),pe([t.memoize],m.prototype,"extensionLogLevel",null),pe([t.memoize],m.prototype,"serviceMachineIdResource",null),pe([t.memoize],m.prototype,"telemetryLogResource",null),pe([t.memoize],m.prototype,"disableWorkspaceTrust",null),pe([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function p(h,d){return b(h["inspect-extensions"],h["inspect-brk-extensions"],5870,d,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=p;function y(h,d){return b(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,d,h.extensionEnvironment)}e.parsePtyHostPort=y;function b(h,d,v,l,u,g){const S=Number(d||h)||(l?null:v),D=S?Boolean(!!d):!1;let i;if(g)try{i=JSON.parse(g)}catch{}return{port:S,break:D,debugId:u,env:i}}}),define(ee[106],te([0,1,284,4,153]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},category:{type:"string",cat:"e",description:(0,P.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(v,l,u=M){const g=v.find(c=>c.length>0&&c[0]!=="-"),k={},S=["_"],D=[],i={};let r;for(const c in l){const s=l[c];s.type==="subcommand"?c===g&&(r=s):(s.alias&&(k[c]=s.alias),s.type==="string"||s.type==="string[]"?(S.push(c),s.deprecates&&S.push(...s.deprecates)):s.type==="boolean"&&(D.push(c),s.deprecates&&D.push(...s.deprecates)),s.global&&(i[c]=s))}if(r&&g){const c=i;for(const L in r.options)c[L]=r.options[L];const s=v.filter(L=>L!==g),f=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,C=I(s,c,f);return{[g]:C,_:[]}}const n=E(v,{string:S,boolean:D,alias:k}),o={},a=n;o._=n._.map(c=>String(c)).filter(c=>c.length>0),delete a._;for(const c in l){const s=l[c];if(s.type==="subcommand")continue;s.alias&&delete a[s.alias];let f=a[c];if(s.deprecates)for(const C of s.deprecates)a.hasOwnProperty(C)&&(f||(f=a[C],f&&u.onDeprecatedOption(C,s.deprecationMessage||(0,P.localize)(36,null,c))),delete a[C]);if(typeof f<"u"){if(s.type==="string[]"){if(Array.isArray(f)||(f=[f]),!s.allowEmptyValue){const C=f.filter(L=>L.length>0);C.length!==f.length&&(u.onEmptyValue(c),f=C.length>0?C:void 0)}}else s.type==="string"&&(Array.isArray(f)?(f=f.pop(),u.onMultipleValues(c,f)):!f&&!s.allowEmptyValue&&(u.onEmptyValue(c),f=void 0));o[c]=f,s.deprecationMessage&&u.onDeprecatedOption(c,s.deprecationMessage)}delete a[c]}for(const c in a)u.onUnknownOption(c);return o}e.parseArgs=I;function w(v,l){let u="";return l.args&&(Array.isArray(l.args)?u=` <${l.args.join("> <")}>`:u=` <${l.args}>`),l.alias?`-${l.alias} --${v}${u}`:`--${v}${u}`}function m(v,l){const u=[];for(const g in v){const k=v[g],S=w(g,k);u.push([S,k.description])}return p(u,l)}e.formatOptions=m;function p(v,l){const g=v.reduce((D,i)=>Math.max(D,i[0].length),12)+2+1;if(l-g<25)return v.reduce((D,i)=>D.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const k=l-g-1,S=[];for(const D of v){const i=D[0],r=b(D[1],k),n=y(g-i.length-2);S.push("  "+i+n+r[0]);for(let o=1;o<r.length;o++)S.push(y(g)+r[o])}return S}function y(v){return" ".repeat(v)}function b(v,l){const u=[];for(;v.length;){const g=v.length<l?v.length:v.lastIndexOf(" ",l),k=v.slice(0,g).trim();v=v.slice(g),u.push(k)}return u}function h(v,l,u,g,k){const S=process.stdout.isTTY&&process.stdout.columns||80,D=k?.noInputFiles!==!0?`[${(0,P.localize)(37,null)}...]`:"",i=[`${v} ${u}`];i.push(""),i.push(`${(0,P.localize)(38,null)}: ${l} [${(0,P.localize)(39,null)}]${D}`),i.push(""),k?.noPipe!==!0&&(t.isWindows?i.push((0,P.localize)(40,null,l)):i.push((0,P.localize)(41,null,l)),i.push(""));const r={},n=[];for(const o in g){const a=g[o];if(a.type==="subcommand")a.description&&n.push({command:o,description:a.description});else if(a.description&&a.cat){let c=r[a.cat];c||(r[a.cat]=c={}),c[o]=a}}for(const o in r){const a=o,c=r[a];c&&(i.push(R[a]),i.push(...m(c,S)),i.push(""))}return n.length&&(i.push((0,P.localize)(42,null)),i.push(...p(n.map(o=>[o.command,o.description]),S)),i.push("")),i.join(`
`)}e.buildHelpMessage=h;function d(v,l){return`${v||(0,P.localize)(43,null)}
${l||(0,P.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(ee[182],te([0,1,80,180,106]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.f=I}call(I,w,m){return w==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(I,w,m)}async g(I,w){const m=(0,P.parseArgs)(I,P.OPTIONS);m.debugRenderer=w;const p=m.extensionDevelopmentPath;if(!p)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!w)return{success:!0};const b=y.win;if(!b)return{success:!0};const h=b.webContents.debugger;let d=h.isAttached()?1/0:0;const v=(0,E.createServer)(l=>{d++===0&&h.attach();let u=!1;const g=D=>{u||l.write(JSON.stringify(D)+"\0")},k=(D,i,r,n)=>g({method:i,params:r,sessionId:n});b.on("close",()=>{h.removeListener("message",k),l.end(),u=!0}),h.addListener("message",k);let S=Buffer.alloc(0);l.on("data",D=>{S=Buffer.concat([S,D]);for(let i=S.indexOf(0);i!==-1;i=S.indexOf(0)){let r;try{const n=S.slice(0,i).toString("utf8");S=S.slice(i+1),r=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}h.sendCommand(r.method,r.params,r.sessionId).then(n=>g({id:r.id,sessionId:r.sessionId,result:n})).catch(n=>g({id:r.id,sessionId:r.sessionId,error:{code:0,message:n.message}}))}}),l.on("error",D=>{console.error("error on cdp pipe:",D)}),l.on("close",()=>{u=!0,--d===0&&h.detach()})});return await new Promise(l=>v.listen(0,l)),b.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ee[61],te([0,1,285,154,106]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(b,h){const d=(S,D)=>{console.warn((0,t.localize)(0,null,S,D))},v=S=>{console.warn((0,t.localize)(1,null,S))},l=(S,D)=>{console.warn((0,t.localize)(2,null,S,D))},u=S=>({onUnknownOption:D=>{S!=="tunnel"&&console.warn((0,t.localize)(3,null,D,S))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:l,getSubcommandReporter:S!=="tunnel"?u:void 0}),g={onUnknownOption:S=>{console.warn((0,t.localize)(4,null,S))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:l,getSubcommandReporter:u},k=(0,P.parseArgs)(b,P.OPTIONS,h?g:void 0);return k.goto&&k._.forEach(S=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,t.localize)(5,null))),k["max-memory"]&&E(parseInt(k["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),k}function I(b){const h=b.findIndex(d=>!/^-/.test(d));if(h>-1)return[...b.slice(0,h),...b.slice(h+1)]}function w(b){let[,...h]=b;process.env.VSCODE_DEV&&(h=I(h)||[]);const d=!y(process.env);return M(h,d)}e.parseMainProcessArgv=w;function m(b){let[,,...h]=b;return process.env.VSCODE_DEV&&(h=I(h)||[]),M(h,!0)}e.parseCLIProcessArgv=m;function p(b,...h){const d=b.indexOf("--");return d===-1?b.push(...h):b.splice(d,0,...h),b}e.addArg=p;function y(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function H(e,E,t){function P(M,I){const w=R(M,I),m=[w];return e.isAbsolute(w)||m.unshift(t),e.resolve(...m)}function R(M,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,I);const p=M["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(E.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,I)}return{getUserDataPath:P}}if(typeof define=="function")define(ee[183],te([184,26,35]),function(e,E,t){return H(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=H(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[185],te([0,1,26,181,183]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(I,w){super(I,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,P.getUserDataPath)(I,w.nameShort)},w)}}e.NativeEnvironmentService=R}),define(ee[186],te([0,1,41,26,32]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(M){const I=(0,P.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(I,""),M&&console.log(`Marker file for --wait created: ${I}`),I}catch(w){M&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFileSync=R}),define(ee[187],te([0,1,11,156]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(M,I,w){try{R(M,I,w)}catch(m){console.error(m?.message??m)}return M}e.localizeManifest=P;function R(M,I,w){const m=(p,y,b)=>{const h=p[y];if((0,E.isString)(h)){const d=h,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const l=d.substr(1,v-2);let u=I[l];u===void 0&&w&&(u=w[l]);const g=typeof u=="string"?u:u?.message,k=w?.[l],S=typeof k=="string"?k:k?.message;if(!g){S||console.warn(`[${M.name}]: ${(0,t.localize)(0,null,l)}`);return}if(b&&(y==="title"||y==="category")&&S&&S!==g){const D={value:g,original:S};p[y]=D}else p[y]=g}}else if((0,E.isObject)(h))for(const d in h)h.hasOwnProperty(d)&&(d==="commands"?m(h,d,!0):m(h,d,b));else if(Array.isArray(h))for(let d=0;d<h.length;d++)m(h,d,b)};for(const p in M)M.hasOwnProperty(p)&&m(M,p)}}),define(ee[188],te([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,M){this.a.set(R,M)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const M in R.contributes){const I=this.a.get(M);if(!I)continue;const w=R.contributes[M],m=Array.isArray(w)?w:[w];try{I(m,R.activationEvents)}catch(p){(0,E.onUnexpectedError)(p)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ee[189],te([0,1,20,82,158,190]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||M.test(u)}e.isValidVersionStr=w;function m(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(M);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=m;function p(u){if(!u)return null;const g=u.majorBase,k=u.majorMustEqual,S=u.minorBase;let D=u.minorMustEqual;const i=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(g===0||(D=!1),r=!1);let n=0;if(u.preRelease){const o=I.exec(u.preRelease);if(o){const[,a,c,s]=o;n=Date.UTC(Number(a),Number(c)-1,Number(s))}}return{majorBase:g,majorMustEqual:k,minorBase:S,minorMustEqual:D,patchBase:i,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=p;function y(u,g,k){let S;typeof u=="string"?S=p(m(u)):S=u;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let i;if(typeof k=="string"?i=p(m(k)):i=k,!S||!i)return!1;const r=S.majorBase,n=S.minorBase,o=S.patchBase;let a=i.majorBase,c=i.minorBase,s=i.patchBase;const f=i.notBefore;let C=i.majorMustEqual,L=i.minorMustEqual,O=i.patchMustEqual;return i.isMinimum?r>a?!0:r<a?!1:n>c?!0:n<c||D&&D<f?!1:o>=s:(r===1&&a===0&&(!C||!L||!O)&&(a=1,c=0,s=0,C=!0,L=!1,O=!1),r<a?!1:r>a?!C:n<c?!1:n>c?!L:o<s?!1:o>s?!O:!(D&&D<f))}e.isValidVersion=y;function b(u,g,k,S,D){const i=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return i.push([t.default.Error,P.localize(0,null)]),i;if(typeof S.name!="string")return i.push([t.default.Error,P.localize(1,null,"name")]),i;if(typeof S.version!="string")return i.push([t.default.Error,P.localize(2,null,"version")]),i;if(!S.engines)return i.push([t.default.Error,P.localize(3,null,"engines")]),i;if(typeof S.engines.vscode!="string")return i.push([t.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof S.extensionDependencies<"u"&&!l(S.extensionDependencies))return i.push([t.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof S.activationEvents<"u"){if(!l(S.activationEvents))return i.push([t.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof S.main>"u"&&typeof S.browser>"u")return i.push([t.default.Error,P.localize(7,null,"activationEvents","main")]),i}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&i.push([t.default.Warning,P.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return i.push([t.default.Error,P.localize(9,null,"main")]),i;{const o=(0,E.joinPath)(k,S.main);(0,E.isEqualOrParent)(o,k)||i.push([t.default.Warning,P.localize(10,null,o.path,k.path)])}if(typeof S.activationEvents>"u")return i.push([t.default.Error,P.localize(11,null,"activationEvents","main")]),i}if(typeof S.browser<"u"){if(typeof S.browser!="string")return i.push([t.default.Error,P.localize(12,null,"browser")]),i;{const o=(0,E.joinPath)(k,S.browser);(0,E.isEqualOrParent)(o,k)||i.push([t.default.Warning,P.localize(13,null,o.path,k.path)])}if(typeof S.activationEvents>"u")return i.push([t.default.Error,P.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(S.version))return i.push([t.default.Error,P.localize(15,null)]),i;const r=[];if(!h(u,g,S,D,r))for(const o of r)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=b;function h(u,g,k,S,D){return S||typeof k.main>"u"&&typeof k.browser>"u"?!0:v(u,g,k.engines.vscode,D)}e.isValidExtensionVersion=h;function d(u,g,k){return u==="*"||v(g,k,u)}e.isEngineValid=d;function v(u,g,k,S=[]){const D=p(m(k));if(!D)return S.push(P.localize(16,null,k)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return S.push(P.localize(17,null,k)),!1}else if(!D.majorMustEqual)return S.push(P.localize(18,null,k)),!1;return y(u,g,D)?!0:(S.push(P.localize(19,null,u,k)),!1)}function l(u){if(!Array.isArray(u))return!1;for(let g=0,k=u.length;g<k;g++)if(typeof u[g]!="string")return!1;return!0}}),define(ee[191],te([0,1,17,31]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(R,M,I){let w=I&&I.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const p=(await M.readFile(R.serviceMachineIdResource)).value.toString();w=(0,t.isUUID)(p)?p:null}catch{w=null}if(!w){w=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(w))}catch{}}return I?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=P}),define(ee[72],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(P,R=[],M=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=E}),define(ee[192],te([0,1,72]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function R(I,w,m){w instanceof E.SyncDescriptor||(w=new E.SyncDescriptor(w,[],Boolean(m))),t.push([I,w])}e.registerSingleton=R;function M(){return t}e.getSingletonServiceDescriptors=M}),define(ee[193],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const I=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(M);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const I of this.a.values())I.outgoing.delete(M),I.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let I=this.a.get(M);return I||(I=new E(M,R),this.a.set(M,I)),I}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,I]of this.a)R.push(`${M}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const I=new Set([R]),w=this.c(M,I);if(w)return w}}c(R,M){for(const[I,w]of R.outgoing){if(M.has(I))return[...M,I].join(" -> ");M.add(I);const m=this.c(w,M);if(m)return m;M.delete(I)}}}e.Graph=t}),define(ee[5],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=I})(E=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function t(M,I,w){I[E.DI_TARGET]===I?I[E.DI_DEPENDENCIES].push({id:M,index:w}):(I[E.DI_DEPENDENCIES]=[{id:M,index:w}],I[E.DI_TARGET]=I)}function P(M){if(E.serviceIds.has(M))return E.serviceIds.get(M);const I=function(w,m,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,w,p)};return I.toString=()=>M,E.serviceIds.set(M,I),I}e.createDecorator=P;function R(M){return M}e.refineServiceDecorator=R}),define(ee[62],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[18],te([0,1,11,7,5]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function m(u,g){const k=Object.create(null);for(const S in u)p(k,S,u[S],g);return k}e.toValuesTree=m;function p(u,g,k,S){const D=g.split("."),i=D.pop();let r=u;for(let n=0;n<D.length;n++){const o=D[n];let a=r[o];switch(typeof a){case"undefined":a=r[o]=Object.create(null);break;case"object":break;default:S(`Ignoring ${g} as ${D.slice(0,n+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[i]=k}catch{S(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(r)}`)}else S(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=p;function y(u,g){const k=g.split(".");b(u,k)}e.removeFromValueTree=y;function b(u,g){const k=g.shift();if(g.length===0){delete u[k];return}if(Object.keys(u).indexOf(k)!==-1){const S=u[k];typeof S=="object"&&!Array.isArray(S)&&(b(S,g),Object.keys(S).length===0&&delete u[k])}}function h(u,g,k){function S(r,n){let o=r;for(const a of n){if(typeof o!="object"||o===null)return;o=o[a]}return o}const D=g.split("."),i=S(u,D);return typeof i>"u"?k:i}e.getConfigurationValue=h;function d(u,g,k){Object.keys(g).forEach(S=>{S!=="__proto__"&&(S in u?E.isObject(u[S])&&E.isObject(g[S])?d(u[S],g[S],k):k&&(u[S]=g[S]):u[S]=g[S])})}e.merge=d;function v(u,g,k){const S=u.inspect(g),D=u.inspect(k);return typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:typeof D.userValue<"u"||typeof D.workspaceValue<"u"||typeof D.workspaceFolderValue<"u"?D.value:S.defaultValue}e.getMigratedSettingValue=v;function l(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=l}),define(ee[73],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(R,M){return this.a[R]?.[M]??null}async setPassword(R,M,I){this.a[R]=this.a[R]??{},this.a[R][M]=I}async deletePassword(R,M){return this.a[R]?.[M]?(delete this.a[R][M],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const M=[];for(const I of Object.keys(this.a[R]||{}))M.push({account:I,password:this.a[R][I]});return M}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ee[86],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class P{async getPerformanceInfo(M,I){return{}}async getSystemInfo(M,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,I){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=P}),define(ee[107],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[33],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,54,9,85,33,185,5]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(R.IEnvironmentService);class w extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,P.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],w.prototype,"cachedLanguagesPath",null),pe([E.memoize],w.prototype,"backupHome",null),pe([E.memoize],w.prototype,"mainIPCHandle",null),pe([E.memoize],w.prototype,"mainLockfile",null),pe([E.memoize],w.prototype,"disableUpdates",null),pe([E.memoize],w.prototype,"disableKeytar",null),pe([E.memoize],w.prototype,"crossOriginIsolated",null),pe([E.memoize],w.prototype,"codeCachePath",null),pe([E.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(ee[194],te([0,1,155,5]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function P(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function I(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function w(u,g,k){return I(g,k)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===k?!0:m(k).includes(u)}e.isTargetPlatformCompatible=w;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function p(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=p;var y;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(g,k){super(g),this.code=k,this.name=k}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[195],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[196],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[108],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[197],te([0,1,46,15,9,4,81,23,84,159,108]),function(H,e,E,t,P,R,M,I,w,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=m.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends b{openTerminal(S,D){return this.spawnTerminal(E,S,w.getWindowsShell(),D)}spawnTerminal(S,D,i,r){const n=D.windowsExec||h.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=P.basename(n).toLowerCase();if(o==="cmder"||o==="cmder.exe")return S.spawn(n,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return n.indexOf(" ")>=0&&a.push('""'),a.push(n),(o==="wt"||o==="wt.exe")&&a.push("-d ."),new Promise((c,s)=>{const f=l(process),C=S.spawn(i,a,{cwd:r,env:f});C.on("error",s),C.on("exit",()=>c())})}runInTerminal(S,D,i,r,n){const o="windowsExec"in n&&n.windowsExec?n.windowsExec:h.getDefaultTerminalWindows();return new Promise((a,c)=>{const s=`"${D} - ${y}"`,f=`""${i.join('" "')}" & pause"`,C=["/c","start",s,"/wait",o,"/c",f],L=Object.assign({},l(process),r);Object.keys(L).filter(K=>L[K]===null).forEach(K=>delete L[K]);const O={cwd:D,env:L,windowsVerbatimArguments:!0};E.spawn(h.b,C,O).on("error",K=>{c(u(K))}),a(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.WindowsExternalTerminalService=h,h.b="cmd.exe";class d extends b{openTerminal(S,D){return this.spawnTerminal(E,S,D)}runInTerminal(S,D,i,r,n){const o=n.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((a,c)=>{if(o===p.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const s=o===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",C=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",S||y,"-w",D];for(const j of i)C.push("-a"),C.push(j);if(r){const j=Object.assign({},l(process),r);for(const K in j){const V=j[K];V===null?(C.push("-u"),C.push(K)):(C.push("-e"),C.push(`${K}=${V}`))}}let L="";const O=E.spawn(d.b,C);O.on("error",j=>{c(u(j))}),O.stderr.on("data",j=>{L+=j.toString()}),O.on("exit",j=>{if(j===0)a(void 0);else if(L){const K=L.split(`
`,1);c(new Error(K[0]))}else c(new Error(m.localize(1,null,s,j)))})}else c(new Error(m.localize(2,null,o)))})}spawnTerminal(S,D,i){const r=D.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{const a=["-a",r];i&&a.push(i);const c=l(process),s=S.spawn("/usr/bin/open",a,{cwd:i,env:c});s.on("error",o),s.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.b="/usr/bin/osascript";class v extends b{openTerminal(S,D){return this.spawnTerminal(E,S,D)}runInTerminal(S,D,i,r,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,c)=>{const s=[];o.then(f=>{f.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const C=`${g(i)}; echo; read -p "${v.b}" -n1;`;s.push(`''${C}''`);const L=Object.assign({},l(process),r);Object.keys(L).filter(V=>L[V]===null).forEach(V=>delete L[V]);const O={cwd:D,env:L};let j="";const K=E.spawn(f,s,O);K.on("error",V=>{c(u(V))}),K.stderr.on("data",V=>{j+=V.toString()}),K.on("exit",V=>{if(V===0)a(void 0);else if(j){const J=j.split(`
`,1);c(new Error(J[0]))}else c(new Error(m.localize(4,null,f,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!R.isLinux)v.d=Promise.resolve("xterm");else{const S=await I.Promises.exists("/etc/debian_version");v.d=new Promise(D=>{S?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return v.d}spawnTerminal(S,D,i){const r=D.linuxExec?Promise.resolve(D.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{r.then(a=>{const c=l(process),s=S.spawn(a,[],{cwd:i,env:c});s.on("error",o),s.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.b=m.localize(3,null);function l(k){const S={...k.env};return(0,M.sanitizeProcessEnvironment)(S),S}function u(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(m.localize(5,null,k.path)):k}function g(k){let S="";for(const D of k)D.indexOf(" ")>=0?S+='"'+D+'"':S+=D,S+=" ";return S}}),define(ee[16],te([0,1,60,9,27,11,7,161,5,4]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function p(T){return T.create===!0}e.isFileOpenForWriteOptions=p;var y;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var b;(function(T){T[T.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var h;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileClone=32768]="FileClone"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=d;function v(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=v;function l(T){return!!(T.capabilities&32768)}e.hasFileCloneCapability=l;function u(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=g;function k(T){return d(T)?!!(T.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var S;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor(U,z){super(U),this.code=z}}e.FileSystemProviderError=D;function i(T,U){const z=new D(T.toString(),U);return n(z,U),z}e.createFileSystemProviderError=i;function r(T){return T||i((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=r;function n(T,U){return T.name=U?`${U} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=n;function o(T){if(!T)return S.Unknown;if(T instanceof D)return T.code;const U=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!U)return S.Unknown;switch(U[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=o;function a(T){if(T instanceof O)return T.fileOperationResult;switch(o(T)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var c;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class s{constructor(U,z,Q){this.resource=U,this.operation=z,this.target=Q}isOperation(U){return this.operation===U}}e.FileOperationEvent=s;var f;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class C{constructor(U,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Q=new Map;for(const ne of U){const x=Q.get(ne.type);switch(x?x.push([ne.resource,ne]):Q.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,x]of Q)switch(ne){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(x);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(x);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(x);break}}contains(U,...z){return this.d(U,{includeChildren:!1},...z)}affects(U,...z){return this.d(U,{includeChildren:!0},...z)}d(U,z,...Q){if(!U)return!1;const ne=Q.length>0;return!!((!ne||Q.includes(1))&&(this.a?.get(U)||z.includeChildren&&this.a?.findSuperstr(U))||(!ne||Q.includes(0))&&(this.b?.get(U)||z.includeChildren&&this.b?.findSuperstr(U))||(!ne||Q.includes(2))&&(this.c?.findSubstr(U)||z.includeChildren&&this.c?.findSuperstr(U)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=C;function L(T,U,z){return!T||!U||T===U||U.length>T.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),z?(0,P.startsWithIgnoreCase)(T,U):T.indexOf(U)===0)}e.isParent=L;class O extends Error{constructor(U,z,Q){super(U),this.fileOperationResult=z,this.options=Q}}e.FileOperationError=O;class j extends O{constructor(U,z,Q,ne){super(U,z,ne),this.fileOperationResult=z,this.size=Q}}e.TooLargeFileOperationError=j;class K extends O{constructor(U,z,Q){super(U,2,Q),this.stat=z}}e.NotModifiedSinceFileOperationError=K;var V;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=re;async function se(T,U){if(!U.hasProvider(M.URI.from({scheme:T.scheme})))return new Promise(z=>{const Q=U.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===T.scheme&&ne.added&&(Q.dispose(),z())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(U){return(0,R.isNumber)(U)||(U=0),U<ae.KB?(0,I.localize)(1,null,U.toFixed(0)):U<ae.MB?(0,I.localize)(2,null,(U/ae.KB).toFixed(2)):U<ae.GB?(0,I.localize)(3,null,(U/ae.MB).toFixed(2)):U<ae.TB?(0,I.localize)(4,null,(U/ae.GB).toFixed(2)):(0,I.localize)(5,null,(U/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var fe;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(T){return{maxFileSize:T===0?300*ae.MB:16*ae.GB,maxHeapSize:T===0?700*ae.MB:2*700*ae.MB}}e.getPlatformFileLimits=ge;function q(T){return m.isWeb?T?10*ae.MB:50*ae.MB:T?100*ae.MB:1024*ae.MB}e.getLargeFileConfirmationLimit=q}),define(ee[198],te([0,1,17,45,13,3,2,59,7,31,16]),function(H,e,E,t,P,R,M,I,w,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends M.Disposable{constructor(h,d){super(),this.a=h,this.b=d,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,d){const{buffer:v}=await this.a.call("readFile",[h,d]);return v}readFileStream(h,d,v){const l=(0,I.newWriteableStream)(g=>E.VSBuffer.concat(g.map(k=>E.VSBuffer.wrap(k))).buffer),u=this.a.listen("readFileStream",[h,d])(g=>{if(g instanceof E.VSBuffer)l.write(g.buffer);else{if(g==="end")l.end();else{let k;if(g instanceof Error)k=g;else{const S=g;k=(0,p.createFileSystemProviderError)(S.message??(0,t.toErrorMessage)(S),S.code??p.FileSystemProviderErrorCode.Unknown)}l.error(k),l.end()}u.dispose()}});return v.onCancellationRequested(()=>{l.error((0,P.canceled)()),l.end(),u.dispose()}),l}writeFile(h,d,v){return this.a.call("writeFile",[h,E.VSBuffer.wrap(d),v])}open(h,d){return this.a.call("open",[h,d])}close(h){return this.a.call("close",[h])}async read(h,d,v,l,u){const[g,k]=await this.a.call("read",[h,d,u]);return v.set(g.buffer.slice(0,k),l),k}write(h,d,v,l,u){return this.a.call("write",[h,d,E.VSBuffer.wrap(v),l,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,d){return this.a.call("delete",[h,d])}rename(h,d,v){return this.a.call("rename",[h,d,v])}copy(h,d,v){return this.a.call("copy",[h,d,v])}cloneFile(h,d){return this.a.call("cloneFile",[h,d])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const d=h;this.f.fire(d.map(v=>({resource:w.URI.revive(v.resource),type:v.type})))}else{const d=h;this.g.fire(d)}}))}watch(h,d){const v=(0,m.generateUuid)();return this.a.call("watch",[this.h,v,h,d]),(0,M.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=y}),define(ee[109],te([0,1,17,13,162,16]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(p,y,b,h,d,v){let l;try{await I(p,y,b,h,d,v)}catch(u){l=u}finally{l&&d.errorTransformer&&(l=d.errorTransformer(l)),typeof l<"u"&&b.error(l),b.end()}}e.readFileIntoStream=M;async function I(p,y,b,h,d,v){w(v);const l=await p.open(y,{create:!1});try{w(v);let u=0,g=0,k=d&&typeof d.length=="number"?d.length:void 0,S=E.VSBuffer.alloc(Math.min(d.bufferSize,typeof k=="number"?k:d.bufferSize)),D=d&&typeof d.position=="number"?d.position:0,i=0;do g=await p.read(l,D,S.buffer,i,S.byteLength-i),D+=g,i+=g,u+=g,typeof k=="number"&&(k-=g),i===S.byteLength&&(await b.write(h(S)),S=E.VSBuffer.alloc(Math.min(d.bufferSize,typeof k=="number"?k:d.bufferSize)),i=0);while(g>0&&(typeof k!="number"||k>0)&&w(v)&&m(u,d));if(i>0){let r=i;typeof k=="number"&&(r=Math.min(i,k)),b.write(h(S.slice(0,r)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await p.close(l)}}function w(p){if(p.isCancellationRequested)throw(0,t.canceled)();return!0}function m(p,y){if(y?.limits){if(typeof y.limits.memory=="number"&&p>y.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&p>y.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[74],te([0,1,100,2,9,4,7,16]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(u){return u.recursive===!0}e.isRecursiveWatchRequest=w;class m extends t.Disposable{constructor(g,k,S,D){super(),this.h=g,this.i=k,this.j=S,this.k=D,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new t.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(k=>this.h(k))),g.add(this.b.onDidLogMessage(k=>this.i(k))),g.add(this.b.onDidError(k=>this.n(k)))}n(g){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class p extends m{constructor(g,k,S){super(g,k,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class y extends m{constructor(g,k,S){super(g,k,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function b(u){return u.map(g=>({type:g.type,resource:M.URI.file(g.path)}))}e.toFileChanges=b;function h(u){const g=new l;for(const k of u)g.processEvent(k);return g.coalesce()}e.coalesceEvents=h;function d(u,g){return typeof g=="string"&&!g.startsWith(E.GLOBSTAR)&&!(0,P.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=d;function v(u,g){const k=[];for(const S of g)k.push((0,E.parse)(d(u,S)));return k}e.parseWatcherPatterns=v;class l{constructor(){this.a=new Set,this.b=new Map}c(g){return R.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const k=this.b.get(this.c(g));let S=!1;if(k){const D=k.type,i=g.type;k.path!==g.path&&(g.type===2||g.type===1)?S=!0:D===1&&i===2?(this.b.delete(this.c(g)),this.a.delete(k)):D===2&&i===1?k.type=0:D===1&&i===0||(k.type=i)}else S=!0;S&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],k=[];return Array.from(this.a).filter(S=>S.type!==2?(g.push(S),!1):!0).sort((S,D)=>S.path.length-D.path.length).filter(S=>k.some(D=>(0,I.isParent)(S.path,D,!R.isLinux))?!1:(k.push(S.path),!0)).concat(g)}}}),define(ee[199],te([0,1,41,8,22,32,2,78,9,4,101,23,74]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends M.Disposable{constructor(l,u,g,k){super(),this.j=l,this.k=u,this.l=g,this.m=k,this.c=this.B(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new t.RunOnceWorker(S=>this.u(S),h.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new P.CancellationTokenSource,this.ready=this.n()}async n(){try{const l=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await y.Promises.stat(l);this.B(await this.s(l,u.isDirectory()))}catch(l){l.code!=="ENOENT"?this.w(l):this.z(l)}}async r(l){let u=l.path;try{u=await y.Promises.realpath(l.path),l.path===u&&(u=await(0,p.realcase)(l.path)??l.path),l.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${u})`)}catch{}return u}async s(l,u){if(m.isMacintosh&&(0,R.isEqualOrParent)(l,"/Volumes/",!0))return this.w(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const g=new P.CancellationTokenSource(this.i.token),k=new M.DisposableStore;try{const S=(0,w.basename)(l),D=(0,E.watch)(l);k.add((0,M.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${l}'`);const i=new Set;if(u)try{for(const n of await y.Promises.readdir(l))i.add(n)}catch(n){this.w(n)}const r=new Map;k.add((0,M.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),D.on("error",(n,o)=>{this.w(`Failed to watch ${l} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),D.on("change",(n,o)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${o}`);let a="";if(o&&(a=o.toString(),m.isMacintosh&&(a=(0,I.normalizeNFC)(a))),!(!a||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){r.get(a)?.dispose();const c=setTimeout(async()=>{if(r.delete(a),a===S&&!await y.Promises.exists(l)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,w.join)(l,a));if(g.token.isCancellationRequested)return;let f;s?i.has(a)?f=0:(f=1,i.add(a)):(i.delete(a),f=2),this.t({path:(0,w.join)(this.j.path,a),type:f})},h.a);r.set(a,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(a)?c=0:(c=1,i.add(a)),this.t({path:(0,w.join)(this.j.path,a),type:c})}else if(n==="rename"||a!==S){const c=setTimeout(async()=>{const s=await y.Promises.exists(l);g.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(l,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);k.clear(),k.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await y.Promises.exists(l)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${l} for changes using fs.watch() (${S.toString()})`)}return(0,M.toDisposable)(()=>{g.dispose(!0),k.dispose()})}t(l,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`),!u&&this.g.some(g=>g(l.path))?this.m&&this.z(` >> ignored (excluded) ${l.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(l.path))?this.m&&this.z(` >> ignored (not included) ${l.path}`):this.f.work(l))}u(l){const u=(0,b.coalesceEvents)(l);if(u.length>0){if(this.m)for(const k of u)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(l){if(m.isLinux)return y.Promises.exists(l);try{const u=(0,w.basename)(l);return(await y.Promises.readdir((0,w.dirname)(l))).some(k=>k===u)}catch(u){return this.z(u),!1}}setVerboseLogging(l){this.m=l}w(l){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}y(l){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}z(l){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.a=100,h.b=75;async function d(v,l,u,g,k=512){const S=await y.Promises.open(v,"r"),D=Buffer.allocUnsafe(k),i=new P.CancellationTokenSource(g);let r,n=!1;const o={path:v,excludes:[],recursive:!1},a=new h(o,c=>{(async()=>{for(const{type:s}of c)if(s===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await y.Promises.read(S,D,0,k,null);if(!f||i.token.isCancellationRequested)break;l(D.slice(0,f))}}catch(f){r=new Error(f),i.dispose(!0)}finally{n=!1}}})()});return await a.ready,u(),new Promise((c,s)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(S)}catch(f){r=new Error(f)}r?s(r):c()})})}e.watchFileContents=d}),define(ee[200],te([0,1,3,100,2,4,199]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(m){const p=this.i(m),y=p.filter(h=>{const d=this.c.get(h.path);return d?!(0,t.patternsEquals)(d.request.excludes,h.excludes)||!(0,t.patternsEquals)(d.request.includes,h.includes):!0}),b=Array.from(this.c.values()).filter(({request:h})=>!p.find(d=>d.path===h.path&&(0,t.patternsEquals)(d.excludes,h.excludes)&&(0,t.patternsEquals)(d.includes,h.includes))).map(({request:h})=>h.path);y.length&&this.j(`Request to start watching: ${y.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const h of b)this.h(h);for(const h of y)this.g(h)}g(m){const p=new M.NodeJSFileWatcherLibrary(m,b=>this.a.fire(b),b=>this.b.fire(b),this.f),y={request:m,instance:p};this.c.set(m.path,y)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const p=this.c.get(m);p&&(this.c.delete(m),p.instance.dispose())}i(m){const p=new Map;for(const y of m){const b=R.isLinux?y.path:y.path.toLowerCase();p.set(b,y)}return Array.from(p.values())}async setVerboseLogging(m){this.f=m;for(const[,p]of this.c)p.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,p){return p?`[File Watcher (node.js)] ${m} (path: ${p.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=I}),define(ee[201],te([0,1,74,200]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends E.AbstractNonRecursiveWatcherClient{constructor(M,I,w){super(M,I,w),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(ee[202],te([0,1,15,47,148,74]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(w,m,p){super(w,m,p),this.m()}l(w){const m=w.add(new P.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(m.onDidProcessExit(({code:p,signal:y})=>this.n(`terminated by itself with code ${p}, signal: ${y}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[87],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...P){this.a=new Map;for(const[R,M]of P)this.set(R,M)}set(P,R){const M=this.a.get(P);return this.a.set(P,R),M}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=E}),define(ee[203],te([0,1,8,13,2,72,193,5,87,97]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class y extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class b{constructor(l=new w.ServiceCollection,u=!1,g,k=p){this.f=l,this.g=u,this.h=g,this.i=k,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=k?g?._globalGraph??new M.Graph(S=>S):void 0}createChild(l){return new b(l,this.g,this,this.i)}invokeFunction(l,...u){const g=d.traceInvocation(this.i,l);let k=!1;try{return l({get:D=>{if(k)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(D,g);if(!i)throw new Error(`[invokeFunction] unknown service '${D}'`);return i}},...u)}finally{k=!0,g.stop()}}createInstance(l,...u){let g,k;return l instanceof R.SyncDescriptor?(g=d.traceCreation(this.i,l.ctor),k=this.j(l.ctor,l.staticArguments.concat(u),g)):(g=d.traceCreation(this.i,l),k=this.j(l,u,g)),g.stop(),k}j(l,u=[],g){const k=I._util.getServiceDependencies(l).sort((i,r)=>i.index-r.index),S=[];for(const i of k){const r=this.m(i.id,g);r||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${i.id}.`,!1),S.push(r)}const D=k.length>0?k[0].index:u.length;if(u.length!==D){console.trace(`[createInstance] First service dependency of ${l.name} at position ${D+1} conflicts with ${u.length} static arguments`);const i=D-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,D)}return Reflect.construct(l,u.concat(S))}k(l,u){if(this.f.get(l)instanceof R.SyncDescriptor)this.f.set(l,u);else if(this.h)this.h.k(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const u=this.f.get(l);return!u&&this.h?this.h.l(l):u}m(l,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const g=this.l(l);return g instanceof R.SyncDescriptor?this.q(l,g,u.branch(l,!0)):(u.branch(l,!1),g)}q(l,u,g){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,u,g)}finally{this.o.delete(l)}}r(l,u,g){const k=new M.Graph(i=>i.id.toString());let S=0;const D=[{id:l,desc:u,_trace:g}];for(;D.length;){const i=D.pop();if(k.lookupOrInsertNode(i),S++>1e3)throw new y(k);for(const r of I._util.getServiceDependencies(i.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${l} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof R.SyncDescriptor){const o={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};k.insertEdge(i,o),D.push(o)}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new y(k);break}for(const{data:r}of i){if(this.l(r.id)instanceof R.SyncDescriptor){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}k.removeNode(r)}}return this.l(l)}s(l,u,g=[],k,S){if(this.f.get(l)instanceof R.SyncDescriptor)return this.t(l,u,g,k,S);if(this.h)return this.h.s(l,u,g,k,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(l,u,g=[],k,S){if(k){const D=new b(void 0,this.g,this,this.i);D.c=String(l);const i=new Map,r=new E.IdleValue(()=>{const n=D.j(u,g,S);for(const[o,a]of i){const c=n[o];if(typeof c=="function")for(const s of a)c.apply(n,s)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let s=i.get(o);return s||(s=new m.LinkedList,i.set(o,s)),(C,L,O)=>{const j=s.push([C,L,O]);return(0,P.toDisposable)(j)}}if(o in n)return n[o];const a=r.value;let c=a[o];return typeof c!="function"||(c=c.bind(a),n[o]=c),c},set(n,o,a){return r.value[o]=a,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,g,S)}u(l,u){if(u&&console.warn(l),this.g)throw new Error(l)}}e.InstantiationService=b;var h;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(h||(h={}));class d{static traceInvocation(l,u){return l?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(l,u){return l?new d(1,u.name):d.c}constructor(l,u){this.type=l,this.name=u,this.g=Date.now(),this.h=[]}branch(l,u){const g=new d(3,l.toString());return this.h.push([l,u,g]),g}stop(){const l=Date.now()-this.g;d.f+=l;let u=!1;function g(S,D){const i=[],r=new Array(S+1).join("	");for(const[n,o,a]of D.h)if(o&&a){u=!0,i.push(`${r}CREATES -> ${n}`);const c=g(S+1,a);c&&i.push(c)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(l>2||u)&&d.all.add(k.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(ee[6],te([0,1,45,3,2,40,4,7,5]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function m(){return new Date().toISOString()}var p;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function y(c,s,f){switch(s){case p.Trace:c.trace(f);break;case p.Debug:c.debug(f);break;case p.Info:c.info(f);break;case p.Warning:c.warn(f);break;case p.Error:c.error(f);break;case p.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=y;function b(c){let s="";for(let f=0;f<c.length;f++){let C=c[f];if(typeof C=="object")try{C=JSON.stringify(C)}catch{}s+=(f>0?" ":"")+C}return s}e.format=b;class h extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==p.Off&&this.b<=s}}e.AbstractLogger=h;class d extends h{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...f){this.f(p.Trace)&&this.g(p.Trace,b([s,...f]))}debug(s,...f){this.f(p.Debug)&&this.g(p.Debug,b([s,...f]))}info(s,...f){this.f(p.Info)&&this.g(p.Info,b([s,...f]))}warn(s,...f){this.f(p.Warning)&&this.g(p.Warning,b([s,...f]))}error(s,...f){if(this.f(p.Error))if(s instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=s.stack,this.g(p.Error,b(C))}else this.g(p.Error,b([s,...f]))}flush(){}}e.AbstractMessageLogger=d;class v extends h{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!M.isWindows}trace(s,...f){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,s,...f):console.log(`[main ${m()}]`,s,...f))}debug(s,...f){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,s,...f):console.log(`[main ${m()}]`,s,...f))}info(s,...f){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,s,...f):console.log(`[main ${m()}]`,s,...f))}warn(s,...f){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,s,...f):console.warn(`[main ${m()}]`,s,...f))}error(s,...f){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,s,...f):console.error(`[main ${m()}]`,s,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class l extends h{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...f){this.f(p.Trace)&&console.log("%cTRACE","color: #888",s,...f)}debug(s,...f){this.f(p.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...f)}info(s,...f){this.f(p.Info)&&console.log("%c INFO","color: #33f",s,...f)}warn(s,...f){this.f(p.Warning)&&console.log("%c WARN","color: #993",s,...f)}error(s,...f){this.f(p.Error)&&console.log("%c  ERR","color: #f33",s,...f)}dispose(){}flush(){}}e.ConsoleLogger=l;class u extends h{constructor(s,f=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(f)}trace(s,...f){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(s),...f])}debug(s,...f){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(s),...f])}info(s,...f){this.f(p.Info)&&this.g.log(p.Info,[this.h(s),...f])}warn(s,...f){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(s),...f])}error(s,...f){this.f(p.Error)&&this.g.log(p.Error,[this.h(s),...f])}h(s){return typeof s=="string"?s:(0,E.toErrorMessage)(s,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class g extends h{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const f of this.g)f.setLevel(s);super.setLevel(s)}trace(s,...f){for(const C of this.g)C.trace(s,...f)}debug(s,...f){for(const C of this.g)C.debug(s,...f)}info(s,...f){for(const C of this.g)C.info(s,...f)}warn(s,...f){for(const C of this.g)C.warn(s,...f)}error(s,...f){for(const C of this.g)C.error(s,...f)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=g;class k extends P.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...f){this.b.trace(s,...f)}debug(s,...f){this.b.debug(s,...f)}info(s,...f){this.b.info(s,...f)}warn(s,...f){this.b.warn(s,...f)}error(s,...f){this.b.error(s,...f)}flush(){this.b.flush()}}e.LogService=k;class S extends P.Disposable{constructor(s,f){super(),this.c=s,this.b=new R.ResourceMap,this.B(f(C=>this.setLevel(C)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,f,C){let L=this.b.get(s)?.logger;return L||(C=f?.always?p.Trace:C,L=this.f(s,C??this.c,f),this.b.set(s,{logger:L,logLevel:C})),L}setLevel(s,f){const C=I.URI.isUri(s)?s:void 0,L=C?f:s;if(C){const O=this.b.get(C);O&&O.logLevel!==L&&(O.logLevel=L,O.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:O,logger:j})=>{O===void 0&&j.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=S;class D{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return p.Info}trace(s,...f){}debug(s,...f){}info(s,...f){}warn(s,...f){}error(s,...f){}critical(s,...f){}dispose(){}flush(){}}e.NullLogger=D;class i extends D{}e.NullLogService=i;class r extends S{constructor(){super(p.Info,t.Event.None)}f(s,f,C){return new D}}e.NullLoggerService=r;function n(c){if(c.verbose)return p.Trace;if(typeof c.logLevel=="string"){const s=a(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function o(c){switch(c){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=o;function a(c){switch(c){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=a});var _=this&&this.__param||function(H,e){return function(E,t){e(E,t,H)}};define(ee[204],te([0,1,73,3,2,6,4,8]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class Et extends P.Disposable{constructor(p){super(),this.g=p,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(p,y){this.g.trace("Getting password from keytar:",p,y);let b;try{b=await this.h()}catch{return null}const h=await(0,I.retry)(()=>b.getPassword(p,y),50,3);if(!h)return this.g.trace("Did not get a password from keytar for account:",y),h;let d,v;try{const l=JSON.parse(h);d=l.content,v=l.hasNextChunk}catch{}if(!d||!v)return this.g.trace("Got password from keytar for account:",y),h;try{let l=1;for(;v;){const u=await(0,I.retry)(()=>b.getPassword(p,`${y}-${l}`),50,3),g=JSON.parse(u);d+=g.content,v=g.hasNextChunk,l++}return this.g.trace(`Got ${l}-chunked password from keytar for account:`,y),d}catch(l){return this.g.error(l),h}}async setPassword(p,y,b){this.g.trace("Setting password using keytar:",p,y);let h;try{h=await this.h()}catch(d){throw this.i?.(d),d}if(M.isWindows&&b.length>Et.a){let d=0,v=0,l=!0;for(;l;){const u=b.substring(d,d+Et.b);d+=Et.b,l=b.length-d>0;const g={content:u,hasNextChunk:l};await(0,I.retry)(()=>h.setPassword(p,v?`${y}-${v}`:y,JSON.stringify(g)),50,3),v++}this.g.trace(`Got${v?` ${v}-chunked`:""} password from keytar for account:`,y)}else await(0,I.retry)(()=>h.setPassword(p,y,b),50,3),this.g.trace("Got password from keytar for account:",y);this.c.fire({service:p,account:y})}async deletePassword(p,y){this.g.trace("Deleting password using keytar:",p,y);let b;try{b=await this.h()}catch(u){throw this.i?.(u),u}const h=await b.getPassword(p,y);if(!h)return this.g.trace("Did not get a password to delete from keytar for account:",y),!1;let d,v;try{const u=JSON.parse(h);d=u.content,v=u.hasNextChunk}catch{}let l=0;if(d&&v)try{for(l++;v;){const u=`${y}-${l}`,g=await b.getPassword(p,u);await b.deletePassword(p,u),v=JSON.parse(g).hasNextChunk,l++}}catch(u){this.g.error(u)}return await b.deletePassword(p,y)?(this.c.fire({service:p,account:y}),this.g.trace(`Deleted${l?` ${l}-chunked`:""} password from keytar for account:`,y),!0):(this.g.trace(`Keytar failed to delete${l?` ${l}-chunked`:""} password for account:`,y),!1)}async findPassword(p){let y;try{y=await this.h()}catch{return null}return await y.findPassword(p)}async findCredentials(p){let y;try{y=await this.h()}catch{return[]}return await y.findCredentials(p)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=pe([_(0,R.ILogService)],w),e.BaseCredentialsMainService=w}),define(ee[205],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,M){this.a=R,this.b=M}c(){return new Promise((R,M)=>H(["vscode-encrypt"],R,M))}async encrypt(R){let M;try{M=await this.c()}catch{return R}try{return M.encrypt(this.a,R)}catch(I){return this.b.error(I),R}}async decrypt(R){let M;try{M=await this.c()}catch{return R}try{return M.decrypt(this.a,R)}catch(I){return this.b.error(I),R}}};t=pe([_(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ee[206],te([0,1,25,8,13,3,2,9,74,6]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends M.Disposable{constructor(b,h){super(),this.a=b,this.b=h,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(b,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(b,h):this.u(b,h)}l(b,h){const d={path:this.C(b),excludes:h.excludes,includes:h.includes,recursive:h.recursive},v=(0,E.insert)(this.j,d);return this.m(),(0,M.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,P.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,w.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&b.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,h){const d={path:this.C(b),excludes:h.excludes,includes:h.includes,recursive:!1},v=(0,E.insert)(this.s,d);return this.v(),(0,M.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,P.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,w.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,I.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(ee[207],te([0,1,25,8,17,22,3,70,68,2,60,15,63,20,59,160,16,109,6,13]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends m.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new M.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new M.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new M.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new M.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new t.ResourceQueue)}registerProvider(i,r){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${i}`);const n=new m.DisposableStore;return this.h.set(i,r),this.c.fire({added:!0,scheme:i,provider:r}),n.add(r.onDidChangeFile(o=>this.R.fire(new l.FileChangesEvent(o,!this.O(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(o=>this.S.fire(new Error(o)))),n.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:i}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:r}),this.h.delete(i),(0,m.dispose)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const r=[];this.f.fire({scheme:i,join(n){r.push(n)}}),!this.h.has(i)&&await t.Promises.settled(r)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,r){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([i,r])=>({scheme:i,capabilities:r.capabilities}))}async j(i){if(!(0,h.isAbsolutePath)(i))throw new l.FileOperationError((0,v.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const r=this.h.get(i.scheme);if(!r){const n=new k.ErrorNoTelemetry;throw n.message=(0,v.localize)(1,null,i.toString()),n}return r}async k(i){const r=await this.j(i);if((0,l.hasOpenReadWriteCloseCapability)(r)||(0,l.hasReadWriteCapability)(r)||(0,l.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const r=await this.j(i);if((0,l.hasOpenReadWriteCloseCapability)(r)||(0,l.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,r){try{return await this.n(i,r)}catch(n){throw(0,l.toFileSystemProviderErrorCode)(n)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,v.localize)(2,null,this.nb(i)),1):(0,l.ensureFileSystemProviderError)(n)}}async n(i,r){const n=await this.j(i),o=this.O(n),a=r?.resolveTo,c=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,f=await n.stat(i);let C;return this.p(n,i,f,void 0,!!s,(L,O)=>(C||(C=p.TernarySearchTree.forUris(()=>!o),C.set(i,!0),a&&C.fill(!0,a)),C.get(L.resource)||C.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&c?O===1:!1))}async p(i,r,n,o,a,c){const{providerExtUri:s}=this.N(i),f={resource:r,name:s.basename(r),isFile:(n.type&l.FileType.File)!==0,isDirectory:(n.type&l.FileType.Directory)!==0,isSymbolicLink:(n.type&l.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&l.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,l.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(f.isDirectory&&c(f,o)){try{const C=await i.readdir(r),L=await t.Promises.settled(C.map(async([O,j])=>{try{const K=s.joinPath(r,O),V=a?await i.stat(K):{type:j};return await this.p(i,K,V,C.length,a,c)}catch(K){return this.b.trace(K),null}}));f.children=(0,E.coalesce)(L)}catch(C){this.b.trace(C),f.children=[]}return f}return f}async resolveAll(i){return t.Promises.settled(i.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const r=await this.j(i),n=await r.stat(i);return this.p(r,i,n,void 0,!0,()=>!1)}async exists(i){const r=await this.j(i);try{return!!await r.stat(i)}catch{return!1}}async canCreateFile(i,r){try{await this.r(i,r)}catch(n){return n}return!0}async r(i,r){if(!r?.overwrite&&await this.exists(i))throw new l.FileOperationError((0,v.localize)(3,null,this.nb(i)),3,r)}async createFile(i,r=P.VSBuffer.fromString(""),n){await this.r(i,n);const o=await this.writeFile(i,r);return this.m.fire(new l.FileOperationEvent(i,0,o)),o}async writeFile(i,r,n){const o=this.lb(await this.l(i),i),{providerExtUri:a}=this.N(o);try{await this.s(o,i,n)||await this.P(o,a.dirname(i));let s;if((0,l.hasReadWriteCapability)(o)&&!(r instanceof P.VSBuffer))if((0,d.isReadableStream)(r)){const f=await(0,d.peekStream)(r,3);f.ended?s=P.VSBuffer.concat(f.buffer):s=f}else s=(0,d.peekReadable)(r,f=>P.VSBuffer.concat(f),3);else s=r;!(0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasReadWriteCapability)(o)&&s instanceof P.VSBuffer?await this.cb(o,i,n,s):await this.Y(o,i,n,s instanceof P.VSBuffer?(0,P.bufferToReadable)(s):s),this.m.fire(new l.FileOperationEvent(i,4))}catch(c){throw new l.FileOperationError((0,v.localize)(4,null,this.nb(i),(0,l.ensureFileSystemProviderError)(c).toString()),(0,l.toFileOperationResult)(c),n)}return this.resolve(i,{resolveMetadata:!0})}async s(i,r,n){if(!!n?.unlock&&!(i.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(r)));let a;try{a=await i.stat(r)}catch{return}if((a.type&l.FileType.Directory)!==0)throw new l.FileOperationError((0,v.localize)(6,null,this.nb(r)),0,n);if(this.mb(r,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==l.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,l.etag)({mtime:n.mtime,size:a.size}))throw new l.FileOperationError((0,v.localize)(7,null),3,n);return a}async readFile(i,r,n){const o=await this.k(i);return r?.atomic?this.t(o,i,r,n):this.u(o,i,r,n)}async t(i,r,n,o){return new Promise((a,c)=>{this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{try{const s=await this.u(i,r,n,o);a(s)}catch(s){c(s)}})})}async u(i,r,n,o){const a=await this.v(i,r,{...n,preferUnbuffered:!0},o);return{...a,value:await(0,P.streamToBuffer)(a.value)}}async readFileStream(i,r,n){const o=await this.k(i);return this.v(o,i,r,n)}async v(i,r,n,o){const a=new R.CancellationTokenSource(o),c=this.F(r,n).then(f=>f,f=>{throw a.cancel(),f});let s;try{return typeof n?.etag=="string"&&n.etag!==l.ETAG_DISABLED&&await c,n?.atomic&&(0,l.hasFileAtomicReadCapability)(i)||!((0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasFileReadStreamCapability)(i))||(0,l.hasReadWriteCapability)(i)&&n?.preferUnbuffered?s=this.D(i,r,n):(0,l.hasFileReadStreamCapability)(i)?s=this.z(i,r,a.token,n):s=this.C(i,r,a.token,n),{...await c,value:s}}catch(f){throw s&&await(0,d.consumeStream)(s),this.w(f,r,n)}}w(i,r,n){const o=(0,v.localize)(8,null,this.nb(r),(0,l.ensureFileSystemProviderError)(i).toString());return i instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(o,i.stat,n):i instanceof l.TooLargeFileOperationError?new l.TooLargeFileOperationError(o,i.fileOperationResult,i.size,i.options):new l.FileOperationError(o,(0,l.toFileOperationResult)(i),n)}z(i,r,n,o=Object.create(null)){const a=i.readFileStream(r,o,n);return(0,d.transform)(a,{data:c=>c instanceof P.VSBuffer?c:P.VSBuffer.wrap(c),error:c=>this.w(c,r,o)},c=>P.VSBuffer.concat(c))}C(i,r,n,o=Object.create(null)){const a=(0,P.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,r,a,c=>c,{...o,bufferSize:this.a,errorTransformer:c=>this.w(c,r,o)},n),a}D(i,r,n){const o=(0,d.newWriteableStream)(a=>P.VSBuffer.concat(a));return(async()=>{try{let a;n?.atomic&&(0,l.hasFileAtomicReadCapability)(i)?a=await i.readFile(r,{atomic:!0}):a=await i.readFile(r),typeof n?.position=="number"&&(a=a.slice(n.position)),typeof n?.length=="number"&&(a=a.slice(0,n.length)),this.G(r,a.byteLength,n),o.end(P.VSBuffer.wrap(a))}catch(a){o.error(a),o.end()}})(),o}async F(i,r){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new l.FileOperationError((0,v.localize)(9,null,this.nb(i)),0,r);if(typeof r?.etag=="string"&&r.etag!==l.ETAG_DISABLED&&r.etag===n.etag)throw new l.NotModifiedSinceFileOperationError((0,v.localize)(10,null),n,r);return this.G(i,n.size,r),n}G(i,r,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&r>n.limits.size&&(o=7),typeof o=="number")throw new l.TooLargeFileOperationError((0,v.localize)(11,null,this.nb(i)),o,r,n)}}async canMove(i,r,n){return this.H(i,r,"move",n)}async canCopy(i,r,n){return this.H(i,r,"copy",n)}async H(i,r,n,o){if(i.toString()!==r.toString())try{const a=n==="move"?this.lb(await this.l(i),i):await this.k(i),c=this.lb(await this.l(r),r);await this.M(a,i,c,r,n,o)}catch(a){return a}return!0}async move(i,r,n){const o=this.lb(await this.l(i),i),a=this.lb(await this.l(r),r),c=await this.I(o,i,a,r,"move",!!n),s=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,c==="move"?2:3,s)),s}async copy(i,r,n){const o=await this.k(i),a=this.lb(await this.l(r),r),c=await this.I(o,i,a,r,"copy",!!n),s=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,c==="copy"?3:2,s)),s}async I(i,r,n,o,a,c){if(r.toString()===o.toString())return a;const{exists:s,isSameResourceWithDifferentPathCase:f}=await this.M(i,r,n,o,a,c);if(s&&!f&&c&&await this.del(o,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(o)),a==="copy"){if(i===n&&(0,l.hasFileFolderCopyCapability)(i))await i.copy(r,o,{overwrite:c});else{const C=await this.resolve(r);C.isDirectory?await this.L(i,C,n,o):await this.J(i,r,n,o)}return a}else return i===n?(await i.rename(r,o,{overwrite:c}),a):(await this.I(i,r,n,o,"copy",c),await this.del(r,{recursive:!0}),"copy")}async J(i,r,n,o){if((0,l.hasOpenReadWriteCloseCapability)(i)&&(0,l.hasOpenReadWriteCloseCapability)(n))return this.eb(i,r,n,o);if((0,l.hasOpenReadWriteCloseCapability)(i)&&(0,l.hasReadWriteCapability)(n))return this.kb(i,r,n,o);if((0,l.hasReadWriteCapability)(i)&&(0,l.hasOpenReadWriteCloseCapability)(n))return this.ib(i,r,n,o);if((0,l.hasReadWriteCapability)(i)&&(0,l.hasReadWriteCapability)(n))return this.gb(i,r,n,o)}async L(i,r,n,o){await n.mkdir(o),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async a=>{const c=this.N(n).providerExtUri.joinPath(o,a.name);return a.isDirectory?this.L(i,await this.resolve(a.resource),n,c):this.J(i,a.resource,n,c)}))}async M(i,r,n,o,a,c){let s=!1;if(i===n){const{providerExtUri:C,isPathCaseSensitive:L}=this.N(i);if(L||(s=C.isEqual(r,o)),s&&a==="copy")throw new Error((0,v.localize)(12,null,this.nb(r),this.nb(o)));if(!s&&C.isEqualOrParent(o,r))throw new Error((0,v.localize)(13,null,this.nb(r),this.nb(o)))}const f=await this.exists(o);if(f&&!s){if(!c)throw new l.FileOperationError((0,v.localize)(14,null,this.nb(r),this.nb(o)),4);if(i===n){const{providerExtUri:C}=this.N(i);if(C.isEqualOrParent(r,o))throw new Error((0,v.localize)(15,null,this.nb(r),this.nb(o)))}}return{exists:f,isSameResourceWithDifferentPathCase:s}}N(i){const r=this.O(i);return{providerExtUri:r?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:r}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const r=this.lb(await this.j(i),i);await this.P(r,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,0,n)),n}async P(i,r){const n=[],{providerExtUri:o}=this.N(i);for(;!o.isEqual(r,o.dirname(r));)try{if(((await i.stat(r)).type&l.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.nb(r)));break}catch(a){if((0,l.toFileSystemProviderErrorCode)(a)!==l.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(o.basename(r)),r=o.dirname(r)}for(let a=n.length-1;a>=0;a--){r=o.joinPath(r,n[a]);try{await i.mkdir(r)}catch(c){if((0,l.toFileSystemProviderErrorCode)(c)!==l.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(i,r){try{await this.Q(i,r)}catch(n){return n}return!0}async Q(i,r){const n=this.lb(await this.j(i),i);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,v.localize)(17,null,this.nb(i)));let a;try{a=await n.stat(i)}catch{}if(a)this.mb(i,a);else throw new l.FileOperationError((0,v.localize)(18,null,this.nb(i)),1);if(!!!r?.recursive){const s=await this.resolve(i);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,v.localize)(19,null,this.nb(i)))}return n}async del(i,r){const n=await this.Q(i,r),o=!!r?.useTrash,a=!!r?.recursive;await n.delete(i,{recursive:a,useTrash:o}),this.m.fire(new l.FileOperationEvent(i,1))}async cloneFile(i,r){const n=await this.j(i),o=this.lb(await this.l(r),r);if(n===o&&this.N(n).providerExtUri.isEqual(i,r))return;if(n===o&&(0,l.hasFileCloneCapability)(n))return n.cloneFile(i,r);await this.P(o,this.N(o).providerExtUri.dirname(r));const a=this.X.queueFor(i,this.N(n).providerExtUri);return n===o&&(0,l.hasFileFolderCopyCapability)(n)?a.queue(()=>n.copy(i,r,{overwrite:!0})):a.queue(()=>this.J(n,i,o,r))}watch(i,r={recursive:!1,excludes:[]}){const n=new m.DisposableStore;let o=!1,a=()=>{o=!0};return n.add((0,m.toDisposable)(()=>a())),(async()=>{try{const c=await this.W(i,r);o?(0,m.dispose)(c):a=()=>(0,m.dispose)(c)}catch(c){this.b.error(c)}})(),n}async W(i,r){const n=await this.j(i),o=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(i),r]);let a=this.U.get(o);return a||(a={count:0,disposable:n.watch(i,r)},this.U.set(o,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.U.delete(o)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,m.dispose)(i.disposable);this.U.clear()}async Y(i,r,n,o){return this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{const a=await i.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,d.isReadableStream)(o)||(0,d.isReadableBufferedStream)(o)?await this.Z(i,a,o):await this.ab(i,a,o)}catch(c){throw(0,l.ensureFileSystemProviderError)(c)}finally{await i.close(a)}})}async Z(i,r,n){let o=0,a;if((0,d.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=P.VSBuffer.concat(n.buffer);await this.bb(i,r,c,c.byteLength,o,0),o+=c.byteLength}if(n.ended)return;a=n.stream}else a=n;return new Promise((c,s)=>{(0,d.listenStream)(a,{onData:async f=>{a.pause();try{await this.bb(i,r,f,f.byteLength,o,0)}catch(C){return s(C)}o+=f.byteLength,setTimeout(()=>a.resume())},onError:f=>s(f),onEnd:()=>c()})})}async ab(i,r,n){let o=0,a;for(;(a=n.read())!==null;)await this.bb(i,r,a,a.byteLength,o,0),o+=a.byteLength}async bb(i,r,n,o,a,c){let s=0;for(;s<o;)s+=await i.write(r,a+s,n.buffer,c+s,o-s)}async cb(i,r,n,o){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.db(i,r,n,o))}async db(i,r,n,o){let a;o instanceof P.VSBuffer?a=o:(0,d.isReadableStream)(o)?a=await(0,P.streamToBuffer)(o):(0,d.isReadableBufferedStream)(o)?a=await(0,P.bufferedStreamToBuffer)(o):a=(0,P.readableToBuffer)(o),await i.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(i,r,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.fb(i,r,n,o))}async fb(i,r,n,o){let a,c;try{a=await i.open(r,{create:!1}),c=await n.open(o,{create:!0,unlock:!1});const s=P.VSBuffer.alloc(this.a);let f=0,C=0,L=0;do L=await i.read(a,f,s.buffer,C,s.byteLength-C),await this.bb(n,c,s,L,f,C),f+=L,C+=L,C===s.byteLength&&(C=0);while(L>0)}catch(s){throw(0,l.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof a=="number"?i.close(a):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async gb(i,r,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.hb(i,r,n,o))}async hb(i,r,n,o){return n.writeFile(o,await i.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(i,r,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.jb(i,r,n,o))}async jb(i,r,n,o){const a=await n.open(o,{create:!0,unlock:!1});try{const c=await i.readFile(r);await this.bb(n,a,P.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,l.ensureFileSystemProviderError)(c)}finally{await n.close(a)}}async kb(i,r,n,o){const a=await(0,P.streamToBuffer)(this.C(i,r,R.CancellationToken.None));await this.cb(n,o,void 0,a)}lb(i,r){if(i.capabilities&2048)throw new l.FileOperationError((0,v.localize)(20,null,this.nb(r)),6);return i}mb(i,r){if((r.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,v.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===y.Schemas.file?i.fsPath:i.toString(!0)}};S=pe([_(0,g.ILogService)],S),e.FileService=S}),define(ee[88],te([0,1,41,286,8,40,17,3,32,2,9,4,20,59,23,164,16,109,206,45,202,201]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(r)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(n,o){super(n,o),this.onDidChangeCapabilities=I.Event.None,this.H=new R.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:o,symbolicLink:a}=await d.SymlinkSupport.stat(this.C(n));return{type:this.G(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(n){try{const o=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,b.joinPath)(n,c.name))).type:s=this.G(c),a.push([c.name,s])}catch(s){this.a.trace(s)}})),a}catch(o){throw this.Y(o)}}G(n,o){let a;return o?.dangling?a=l.FileType.Unknown:n.isFile()?a=l.FileType.File:n.isDirectory()?a=l.FileType.Directory:a=l.FileType.Unknown,o&&(a|=l.FileType.SymbolicLink),a}async I(n){const o=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const c=new P.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),c.open()})}async readFile(n,o){let a;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),a=await this.I(n));const c=this.C(n);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{a?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,o,a){const c=(0,h.newWriteableStream)(s=>M.VSBuffer.concat(s.map(f=>M.VSBuffer.wrap(f))).buffer);return(0,u.readFileIntoStream)(this,n,c,s=>s.buffer,{...o,bufferSize:256*1024},a),c}async writeFile(n,o,a){let c;try{const s=this.C(n);if(!a.create||!a.overwrite){if(await d.Promises.exists(s)){if(!a.overwrite)throw(0,l.createFileSystemProviderError)((0,v.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,l.createFileSystemProviderError)((0,v.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(s){throw await this.Z(n,s)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,o){const a=this.C(n);let c;(0,l.isFileOpenForWriteOptions)(o)&&(c=await this.I(n));let s;try{if((0,l.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:C}=await d.SymlinkSupport.stat(a);C.mode&128||await d.Promises.chmod(a,C.mode|128)}catch(C){this.a.trace(C)}let f;if((0,l.isFileOpenForWriteOptions)(o)){if(y.isWindows)try{await d.Promises.truncate(a,0),f="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}f||(f="w")}else f="r";s=await d.Promises.open(a,f)}catch(f){throw c?.dispose(),(0,l.isFileOpenForWriteOptions)(o)?await this.Z(n,f):this.Y(f)}if(this.L.set(s,0),(0,l.isFileOpenForWriteOptions)(o)&&this.N.set(s,n),c){const f=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${a})`),this.M.set(s,c),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${a})`),f.dispose())}return s}async close(n){const o=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await d.Promises.fdatasync(n)}catch(a){i.configureFlushOnWrite(!1),this.a.error(a)}return await d.Promises.close(n)}catch(a){throw this.Y(a)}finally{o&&(this.M.get(n)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),o.dispose())}}async read(n,o,a,c,s){const f=this.P(n,o);let C=null;try{C=(await d.Promises.read(n,a,c,s,f)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,f,C)}return C}P(n,o){return o===this.L.get(n)?null:o}Q(n,o,a){const c=this.L.get(n);typeof c=="number"&&(typeof o=="number"||(typeof a=="number"?this.L.set(n,c+a):this.L.delete(n)))}async write(n,o,a,c,s){return(0,P.retry)(()=>this.R(n,o,a,c,s),100,3)}async R(n,o,a,c,s){const f=this.P(n,o);let C=null;try{C=(await d.Promises.write(n,a,c,s,f)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,f,C)}return C}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(o){throw this.Y(o)}}async delete(n,o){try{const a=this.C(n);o.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(n,o,a){const c=this.C(n),s=this.C(o);if(c!==s)try{await this.S(n,o,"move",a.overwrite),await d.Promises.move(c,s)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,v.localize)(2,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(s)),f.toString()))),this.Y(f)}}async copy(n,o,a){const c=this.C(n),s=this.C(o);if(c!==s)try{await this.S(n,o,"copy",a.overwrite),await d.Promises.copy(c,s,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,v.localize)(3,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(s)),f.toString()))),this.Y(f)}}async S(n,o,a,c){const s=this.C(n),f=this.C(o);let C=!1;if(!!(this.capabilities&1024)||(C=(0,w.isEqual)(s,f,!0)),C&&a==="copy")throw(0,l.createFileSystemProviderError)((0,v.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!C&&await d.Promises.exists(f)){if(!c)throw(0,l.createFileSystemProviderError)((0,v.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(n,o){return this.U(n,o,!1)}async U(n,o,a){const c=this.C(n),s=this.C(o),f=!!(this.capabilities&1024);if((0,w.isEqual)(c,s,!f))return;const C=new m.DisposableStore;try{const[L,O]=await Promise.all([this.I(n),this.I(o)]);C.add(L),C.add(O),a&&await d.Promises.mkdir((0,p.dirname)(s),{recursive:!0}),await d.Promises.copyFile(c,s)}catch(L){if(L.code==="ENOENT"&&!a)return this.U(n,o,!0);throw this.Y(L)}finally{C.dispose()}}p(n,o,a){return new S.UniversalWatcherClient(c=>n(c),c=>o(c),a)}y(n,o,a){return new D.NodeJSWatcherClient(c=>n(c),c=>o(c),a)}Y(n){if(n instanceof l.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=l.FileSystemProviderErrorCode.NoPermissions;break;default:o=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(n,o)}async Z(n,o){let a=this.Y(o);if(n&&a.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(n));c.mode&128||(a=(0,l.createFileSystemProviderError)(o,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return a}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ee[208],te([0,1,3,88,2,17,59,22]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends P.Disposable{constructor(y,b){super(),this.a=y,this.b=b,this.w=new Map,this.y=new Map}call(y,b,h){const d=this.c(y);switch(b){case"stat":return this.g(d,h[0]);case"readdir":return this.h(d,h[0]);case"open":return this.l(d,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(d,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(d,h[0],h[1],h[2]);case"rename":return this.t(d,h[0],h[1],h[2]);case"copy":return this.u(d,h[0],h[1],h[2]);case"cloneFile":return this.v(d,h[0],h[1]);case"mkdir":return this.r(d,h[0]);case"delete":return this.s(d,h[0],h[1]);case"watch":return this.C(d,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${b} not found`)}listen(y,b,h){const d=this.c(y);switch(b){case"fileChange":return this.z(d,h[0]);case"readFileStream":return this.j(d,h[0],h[1])}throw new Error(`Unknown event ${b}`)}g(y,b){const h=this.f(y,b,!0);return this.a.stat(h)}h(y,b){const h=this.f(y,b);return this.a.readdir(h)}async i(y,b,h){const d=this.f(y,b,!0),v=await this.a.readFile(d,h);return R.VSBuffer.wrap(v)}j(y,b,h){const d=this.f(y,b,!0),v=new I.CancellationTokenSource,l=new E.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),u=this.a.readFileStream(d,h,v.token);return(0,M.listenStream)(u,{onData:g=>l.fire(R.VSBuffer.wrap(g)),onError:g=>l.fire(g),onEnd:()=>{l.fire("end"),l.dispose(),v.dispose()}}),l.event}k(y,b,h,d){const v=this.f(y,b);return this.a.writeFile(v,h.buffer,d)}l(y,b,h){const d=this.f(y,b,!0);return this.a.open(d,h)}m(y){return this.a.close(y)}async n(y,b,h){const d=R.VSBuffer.alloc(h),v=0,l=await this.a.read(y,b,d.buffer,v,h);return[d,l]}p(y,b,h,d,v){return this.a.write(y,b,h.buffer,d,v)}r(y,b){const h=this.f(y,b);return this.a.mkdir(h)}s(y,b,h){const d=this.f(y,b);return this.a.delete(d,h)}t(y,b,h,d){const v=this.f(y,b),l=this.f(y,h);return this.a.rename(v,l,d)}u(y,b,h,d){const v=this.f(y,b),l=this.f(y,h);return this.a.copy(v,l,d)}v(y,b,h){const d=this.f(y,b),v=this.f(y,h);return this.a.cloneFile(d,v)}z(y,b){const h=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(y,h))},onDidRemoveLastListener:()=>{(0,P.dispose)(this.w.get(b)),this.w.delete(b)}});return h.event}async C(y,b,h,d,v){const l=this.w.get(b);if(l){const u=this.f(y,d),g=l.watch(h,u,v);this.y.set(b+h,g)}}async D(y,b){const h=y+b,d=this.y.get(h);d&&((0,P.dispose)(d),this.y.delete(h))}dispose(){super.dispose();for(const[,y]of this.y)y.dispose();this.y.clear();for(const[,y]of this.w)y.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class m extends P.Disposable{constructor(y,b,h,d){super(),this.c=y,this.f=h,this.g=d,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(y){const b=this.B(new E.Emitter);this.B(b.event(h=>{y.fire(h.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(h=>b.fire(h))),this.B(this.b.onDidWatchError(h=>y.fire(h)))}i(y){}j(y){}watch(y,b,h){const d=this.j(this.g);return Array.isArray(d)&&(h.excludes=[...h.excludes,...d]),this.a.set(y,this.b.watch(b,h)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(ee[209],te([0,1,14,163,4,7,16,9,208,142]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends w.AbstractDiskFileSystemProviderChannel{constructor(h,d,v){super(h,d),this.G=v}c(h){return m.DefaultURITransformer}f(h,d){return R.URI.revive(d)}async s(h,d,v){if(!v.useTrash)return super.s(h,d,v);const l=this.f(h,d),u=(0,I.normalize)(l.fsPath);try{await E.shell.trashItem(u)}catch{throw(0,M.createFileSystemProviderError)(P.isWindows?(0,t.localize)(0,null,(0,I.basename)(u)):(0,t.localize)(1,null,(0,I.basename)(u)),M.FileSystemProviderErrorCode.Unknown)}}F(h,d){return new y(h,d,this.b,this.G)}}e.DiskFileSystemProviderChannel=p;class y extends w.AbstractSessionFileWatcher{watch(h,d,v){if(v.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(h,d,v)}}}),define(ee[210],te([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends E.AbstractMessageLogger{constructor(R=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(M=>{this.l?.setLevel(M)}))}set logger(R){this.l=R;for(const{level:M,message:I}of this.k)(0,E.log)(R,M,I);this.k=[]}g(R,M){this.l?(0,E.log)(this.l,R,M):this.getLevel()<=R&&this.k.push({level:R,message:M})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ee[211],te([0,1,3,7,6]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(b,h){this.a=b,this.b=h,this.onDidChangeLogLevel=E.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(b,h,d){switch(h){case"setLevel":return d[1]?this.b.setLevel(t.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=R;class M{constructor(b){this.a=b}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(b,h){M.setLevel(this.a,b,h)}static setLevel(b,h,d){return b.call("setLevel",[h,d])}}e.LogLevelChannelClient=M;class I{constructor(b){this.b=b,this.a=new Map}listen(b,h){throw new Error(`Event not found: ${h}`)}async call(b,h,d){switch(h){case"createLogger":this.c(t.URI.revive(d[0]),d[1]);return;case"log":return this.e(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${h}`)}c(b,h){this.a.set(b.toString(),this.b.createLogger(b,h))}d(b,h){let d=console.log;switch(b){case P.LogLevel.Error:d=console.error;break;case P.LogLevel.Warning:d=console.warn;break;case P.LogLevel.Info:d=console.info;break}d.call(console,...h)}e(b,h){const d=this.a.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[v,l]of h)(0,P.log)(d,v,l)}}e.LoggerChannel=I;class w extends P.AbstractLoggerService{constructor(b,h,d){super(b,h),this.g=d}createConsoleMainLogger(){return new P.AdapterLogger({log:(b,h)=>{this.g.call("consoleLog",[b,h])}})}f(b,h,d){return new m(this.g,b,h,d)}}e.LoggerChannelClient=w;class m extends P.AbstractMessageLogger{constructor(b,h,d,v){super(v?.always),this.m=b,this.n=h,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[h,v]).then(()=>{this.r(this.l),this.k=!0})}g(b,h){const d=[[b,h]];this.k?this.r(d):this.l.push(...d)}r(b){this.m.call("log",[this.n,b])}}class p extends P.LogService{constructor(b,h){super(h),this.c=b,this.B(b.onDidChangeLogLevel(d=>h.setLevel(d)))}setLevel(b){super.setLevel(b),this.c.setLevel(b)}}e.FollowerLogService=p}),define(ee[212],te([0,1,16,6]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(P||(P={}));async function R(m,p,y,b,h){try{const d=await new Promise((l,u)=>{H(["spdlog"],l,u)});d.setFlushOn(P.Trace);const v=await d.createAsyncRotatingLogger(m,p,y,b);return h?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(d){console.error(d)}return null}function M(m,p,y){switch(p){case t.LogLevel.Trace:m.trace(y);break;case t.LogLevel.Debug:m.debug(y);break;case t.LogLevel.Info:m.info(y);break;case t.LogLevel.Warning:m.warn(y);break;case t.LogLevel.Error:m.error(y);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function I(m,p){switch(p){case t.LogLevel.Trace:m.setLevel(P.Trace);break;case t.LogLevel.Debug:m.setLevel(P.Debug);break;case t.LogLevel.Info:m.setLevel(P.Info);break;case t.LogLevel.Warning:m.setLevel(P.Warning);break;case t.LogLevel.Error:m.setLevel(P.Error);break;case t.LogLevel.Off:m.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class w extends t.AbstractMessageLogger{constructor(p,y,b,h,d){super(),this.k=[],this.setLevel(d),this.l=this.n(p,y,b,h),this.B(this.onDidChangeLogLevel(v=>{this.m&&I(this.m,v)}))}async n(p,y,b,h){const d=b?6:1,v=30/d*E.ByteSize.MB,l=await R(p,y,v,d,h);if(l){this.m=l,I(this.m,this.getLevel());for(const{level:u,message:g}of this.k)M(this.m,u,g);this.k=[]}}g(p,y){this.m?M(this.m,p,y):this.getLevel()<=p&&this.k.push({level:p,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=w}),define(ee[213],te([0,1,31,6,212]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(I){super(I.getLevel(),I.onDidChangeLogLevel)}f(I,w,m){return new P.SpdLogLogger(m?.name||(0,E.generateUuid)(),I.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,w)}};R=pe([_(0,t.ILogService)],R),e.LoggerService=R}),define(ee[214],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function P(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=P;function R(M){return!E(M)&&!t(M)&&!P(M)}e.isMenubarMenuItemAction=R}),define(ee[38],te([0,1,3,68,2,5]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const p=Object.keys(this.f).length;return this.f={...m,...this.f},p!==Object.keys(this.f).length&&await this.i(m),t.Iterable.reduce(this.g.entries(),(y,[b,h])=>({...y,[b]:h}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(m,[p,y])=>({...m,[p]:{definition:y,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=M;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ee[215],te([0,1,8,3,68,11,16,6,38]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(y,b){const h=[];for(const d of new Set(P.Iterable.concat(y.keys(),b.keys())))y.get(d)!==b.get(d)&&h.push(d);return h}let p=class extends w.AbstractPolicyService{constructor(b,h,d){super(),this.j=b,this.k=h,this.l=d,this.c=this.B(new E.ThrottledDelayer(500));const v=t.Event.filter(h.onDidFilesChange,l=>l.affects(b));this.B(h.watch(b)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const h=await this.k.readFile(this.j),d=JSON.parse(h.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(d))this.f[v]&&b.set(v,d[v])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return b}async p(){const b=await this.n(),h=m(this.g,b);this.g=b,h.length>0&&this.h.fire(h)}};p=pe([_(1,M.IFileService),_(2,I.ILogService)],p),e.FilePolicyService=p}),define(ee[216],te([0,1,3,2,38]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(w){this.b=w,this.a=new t.DisposableStore}listen(w,m){switch(m){case"onDidChange":return E.Event.map(this.b.onDidChange,p=>p.reduce((y,b)=>({...y,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(w,m,p){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class M extends P.AbstractPolicyService{constructor(w,m){super(),this.a=m;for(const p in w){const{definition:y,value:b}=w[p];this.f[p]=y,b!==void 0&&this.g.set(p,b)}this.a.listen("onDidChange")(p=>{for(const y in p){const b=p[y];b===null?this.g.delete(y):this.g.set(y,b)}this.h.fire(Object.keys(p))})}async i(w){const m=await this.a.call("updatePolicyDefinitions",w);for(const p in m)this.g.set(p,m[p])}}e.PolicyChannelClient=M}),define(ee[64],te([0,1,4,35]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const R=E.globals.vscode.context.configuration();if(R)P=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(P=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),!P.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(P,{version:R.version})}}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=P}),define(ee[19],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[217],te([0,1,79,6,19]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(I,w){this.b=I,this.c=w,this.a=new Map}async isExtensionUrlTrusted(I,w){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(w);if(!m)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,p,y]=m;let b=this.a.get(I);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[I],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.a.set(I,[...b])}const h=Buffer.from(decodeURIComponent(y),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=h.slice(0,6),v=h.readUIntBE(0,6),l=Date.now()-v;if(l<0||l>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const u=h.slice(6),g=E.createVerify("SHA256");g.write(d),g.write(Buffer.from(p)),g.end();for(let k=0;k<b.length;k++){let S=b[k];if(S!==null){if(typeof S=="string")try{S=E.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),b[k]=S}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${I}:`,D),b[k]=null;continue}if(g.verify(S,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};R=pe([_(0,P.IProductService),_(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ee[218],te([0,1,8,6]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let P=class{constructor(M,I,w){this.a=M,this.b=I,this.c=w}async inspect(M){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(M);const w=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),w.profile}async d(){const M=this.a.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async e(){const M=this.a.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};P=pe([_(2,t.ILogService)],P),e.WindowProfiler=P}),define(ee[65],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[48],te([0,1,123,11]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(M,I){E.ok(t.isString(M)),E.ok(t.isObject(I)),E.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,I)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.Registry=new P}),define(ee[219],te([0,1,3,48]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,m){this.a[P(w)]=m,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[66],te([0,1,25,3,11,151,18,219,48]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=w.Registry.as(I.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=new Set;this.n(i,r,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const r=new Set;this.o(i,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=new Set;this.o(r,n),this.n(i,!1,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const n=[];for(const{overrides:o,source:a}of i)for(const c in o)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const s=this.a.get(c),f=s?.valuesSources??new Map;if(a)for(const j of Object.keys(o[c]))f.set(j,a);const C={...s?.value||{},...o[c]};this.a.set(c,{source:a,value:C,valuesSources:f});const L=(0,M.getLanguageTagSettingPlainKey)(c),O={type:"object",default:C,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:P.isString(a)?void 0:a,defaultValueSource:a};n.push(...v(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:o[c],source:a});const s=this.d[c];s&&(this.w(c,s),this.r(c,s))}this.m(n)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:n,source:o}of i)for(const a in n){const c=this.a.get(a),s=P.isString(o)?o:o?.id,f=P.isString(c?.source)?c?.source:c?.source?.id;if(s===f)if(r.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const C=this.d[a];C&&(this.w(a,C),this.r(a,C))}}this.u()}deltaConfiguration(i){let r=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,n){i.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(i,r){const n=o=>{if(o.properties)for(const a in o.properties){r.add(a);const c=this.d[a];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[a],this.s(a,o.properties[a])}o.allOf?.forEach(a=>n(a))};for(const o of i){n(o);const a=this.c.indexOf(o);a!==-1&&this.c.splice(a,1)}}p(i,r=!0,n,o,a=3,c){a=P.isUndefinedOrNull(i.scope)?a:i.scope;const s=i.properties;if(s)for(const C in s){const L=s[C];if(r&&k(C,L)){delete s[C];continue}if(L.source=n,L.defaultDefaultValue=s[C].default,this.w(C,L),e.OVERRIDE_PROPERTY_REGEX.test(C)?L.scope=void 0:(L.scope=P.isUndefinedOrNull(L.scope)?a:L.scope,L.restricted=P.isUndefinedOrNull(L.restricted)?!!o?.includes(C):L.restricted),s[C].hasOwnProperty("included")&&!s[C].included){this.f[C]=s[C],delete s[C];continue}else this.d[C]=s[C],s[C].policy?.name&&this.e.set(s[C].policy.name,C);!s[C].deprecationMessage&&s[C].markdownDeprecationMessage&&(s[C].deprecationMessage=s[C].markdownDeprecationMessage),c.add(C)}const f=i.allOf;if(f)for(const C of f)this.p(C,r,n,o,a,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=n=>{const o=n.properties;if(o)for(const c in o)this.r(c,o[c]);n.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const n=this.a.get(i);let o=n?.value,a=n?.source;P.isUndefined(o)&&(o=r.defaultDefaultValue,a=void 0),P.isUndefined(o)&&(o=u(r.type)),r.default=o,r.defaultValueSource=a}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(D){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let r=d.exec(D);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=d.exec(D)}}return(0,E.distinct)(i)}e.overrideIdentifiersFromKey=v;function l(D){return D.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=l;function u(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new b;w.Registry.add(e.Extensions.Configuration,g);function k(D,i){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?R.localize(7,null,D):g.getConfigurationProperties()[D]!==void 0?R.localize(8,null,D):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,D,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=k;function S(){const D=[],i=g.getConfigurationProperties();for(const r of Object.keys(i))D.push([r,i[r].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=S}),define(ee[110],te([0,1,25,3,43,2,40,44,11,7,18,66,48]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(r={},n=[],o=[],a){this.c=r,this.d=n,this.f=o,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof h)return n;const o=new d("");return o.parseRaw(n),o.configurationModel});this.g=r.reduce((n,o)=>o===n?o:n.merge(o),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,p.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const o=this.rawConfiguration.getValue(r),a=n?this.rawConfiguration.getOverrideValue(r,n):void 0,c=n?this.rawConfiguration.override(n).getValue(r):o;return{value:o,override:a,merged:c}}getOverrideValue(r,n){const o=this.l(n);return o?r?(0,p.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return E.distinct(r)}override(r){let n=this.b.get(r);return n||(n=this.h(r),this.b.set(r,n)),n}merge(...r){const n=I.deepClone(this.contents),o=I.deepClone(this.overrides),a=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const s of r)if(c.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.j(n,s.contents);for(const f of s.overrides){const[C]=o.filter(L=>E.equals(L.identifiers,f.identifiers));C?(this.j(C.contents,f.contents),C.keys.push(...f.keys),C.keys=E.distinct(C.keys)):o.push(I.deepClone(f))}for(const f of s.keys)a.indexOf(f)===-1&&a.push(f)}return new h(n,a,o,c.every(s=>s instanceof h)?void 0:c)}freeze(){return this.a=!0,this}h(r){const n=this.l(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const a of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[a];const s=n[a];s&&(typeof c=="object"&&typeof s=="object"?(c=I.deepClone(c),this.j(c,s)):c=s),o[a]=c}return new h(o,this.keys,this.overrides)}j(r,n){for(const o of Object.keys(n)){if(o in r&&w.isObject(r[o])&&w.isObject(n[o])){this.j(r[o],n[o]);continue}r[o]=I.deepClone(n[o])}}k(r){return this.a&&!Object.isFrozen(r)?I.deepFreeze(r):r}l(r){let n=null,o=null;const a=c=>{c&&(o?this.j(o,c):o=I.deepClone(c))};for(const c of this.overrides)E.equals(c.identifiers,[r])?n=c.contents:c.identifiers.includes(r)&&a(c.contents);return a(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.m(r),(0,p.addToValueTree)(this.contents,r,n,o=>{throw new Error(o)})}removeValue(r){this.n(r)&&(0,p.removeFromValueTree)(this.contents,r)}m(r){let n=this.keys.length;for(let o=0;o<n;o++)r.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,r)}n(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,n){if(!w.isUndefinedOrNull(r)){const o=this.g(r);this.parseRaw(o,n)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,n){this.a=r;const{contents:o,keys:a,overrides:c,restricted:s,hasExcludedProperties:f}=this.h(r,n);this.b=new h(o,a,c,f?[r]:void 0),this.c=s||[]}g(r){let n={},o=null,a=[];const c=[],s=[];function f(L){Array.isArray(a)?a.push(L):o!==null&&(a[o]=L)}const C={onObjectBegin:()=>{const L={};f(L),c.push(a),a=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const L=[];f(L),c.push(a),a=L,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:f,onError:(L,O,j)=>{s.push({error:L,offset:O,length:j})}};if(r)try{P.visit(r,C),n=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(r,n){const o=b.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.j(r,o,!0,n);r=a.raw;const c=(0,p.toValuesTree)(r,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),s=Object.keys(r),f=this.l(r,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:c,keys:s,overrides:f,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(r,n,o,a){let c=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const s={},f=[];for(const C in r)if(y.OVERRIDE_PROPERTY_REGEX.test(C)&&o){const L=this.j(r[C],n,!1,a);s[C]=L.raw,c=c||L.hasExcludedProperties,f.push(...L.restricted)}else{const L=n[C],O=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&f.push(C),(O===void 0||a.scopes===void 0||a.scopes.includes(O))&&!(a.skipRestricted&&L?.restricted)?s[C]=r[C]:c=!0}return{raw:s,restricted:f,hasExcludedProperties:c}}l(r,n){const o=[];for(const a of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const s in r[a])c[s]=r[a][s];o.push({identifiers:(0,y.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,p.toValuesTree)(c,n)})}return o}}e.ConfigurationModelParser=d;class v extends R.Disposable{constructor(r,n,o,a){super(),this.f=r,this.g=n,this.h=a,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&o.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=v;class l{constructor(r,n,o,a,c,s,f,C,L,O,j,K,V){this.a=r,this.b=n,this.value=o,this.overrideIdentifiers=a,this.c=c,this.d=s,this.f=f,this.g=C,this.h=L,this.j=O,this.k=j,this.l=K,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,n,o,a,c=new h,s=new h,f=new M.ResourceMap,C=new h,L=new M.ResourceMap,O=!0){this.c=r,this.d=n,this.f=o,this.g=a,this.h=c,this.j=s,this.l=f,this.m=C,this.n=L,this.p=O,this.a=null,this.b=new M.ResourceMap,this.q=null}getValue(r,n,o){return this.s(r,n,o).getValue(r)}updateValue(r,n,o={}){let a;o.resource?(a=this.n.get(o.resource),a||(a=new h,this.n.set(o.resource,a))):a=this.m,n===void 0?a.removeValue(r):a.setValue(r,n),o.resource||(this.a=null)}inspect(r,n,o){const a=this.s(r,n,o),c=this.w(n.resource,o),s=n.resource?this.n.get(n.resource)||this.m:this.m,f=new Set;for(const C of a.overrides)for(const L of C.identifiers)a.getOverrideValue(r,L)!==void 0&&f.add(L);return new l(r,n,a.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this.j.freeze():void 0,c?c.freeze():void 0,s.inspect(r,n.overrideIdentifier))}keys(r){const n=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,n){this.l.set(r,n),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:a,updated:c,removed:s}=S(this.c,r);n=[...a,...c,...s]}for(const a of n)for(const c of(0,y.overrideIdentifiersFromKey)(a)){const s=this.c.getKeysForOverrideIdentifier(c),f=r.getKeysForOverrideIdentifier(c),C=[...f.filter(L=>s.indexOf(L)===-1),...s.filter(L=>f.indexOf(L)===-1),...s.filter(L=>!I.equals(this.c.override(c).getValue(L),r.override(c).getValue(L)))];o.push([c,C])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:o,removed:a}=S(this.d,r),c=[...n,...o,...a];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=S(this.applicationConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=S(this.localUserConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=S(this.remoteUserConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=S(this.workspaceConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:c}}compareAndUpdateFolderConfiguration(r,n){const o=this.r.get(r),{added:a,updated:c,removed:s,overrides:f}=S(o,n),C=[...a,...c,...s];return(C.length||!o)&&this.updateFolderConfiguration(r,n),{keys:C,overrides:f}}compareAndDeleteFolderConfiguration(r){const n=this.r.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:a,removed:c,overrides:s}=S(n,void 0);return{keys:[...o,...a,...c],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,n,o){let a=this.t(n,o);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}t({resource:r},n){let o=this.u();if(n&&r){const a=n.getFolder(r);a&&(o=this.v(a.uri)||o);const c=this.n.get(r);c&&(o=o.merge(c))}return o}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let n=this.b.get(r);if(!n){const o=this.u(),a=this.l.get(r);a?(n=o.merge(a),this.p&&(n=n.freeze()),this.b.set(r,n)):n=o}return n}w(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this.l.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,n)=>{const{contents:o,overrides:a,keys:c}=this.l.get(n);return r.push([n,{contents:o,overrides:a,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this.j.freeze().keys.forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.j.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}y(r){const n=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.j.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.l.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a))),[...n.values()]}static parse(r){const n=this.z(r.defaults),o=this.z(r.policy),a=this.z(r.application),c=this.z(r.user),s=this.z(r.workspace),f=r.folders.reduce((C,L)=>(C.set(m.URI.revive(L[0]),this.z(L[1])),C),new M.ResourceMap);return new u(n,o,a,c,new h,s,f,new h,new M.ResourceMap,!1)}static z(r){return new h(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function g(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const a of i)a.keys.forEach(c=>r.add(c)),a.overrides.forEach(([c,s])=>{const f=(0,M.getOrSet)(n,c,new Set);s.forEach(C=>f.add(C))});const o=[];return n.forEach((a,c)=>o.push([c,[...a.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=g;class k{constructor(r,n,o,a){this.change=r,this.f=n,this.g=o,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const s of c)this.affectedKeys.add(s);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data)),this.j}affectsConfiguration(r,n){const o=this.a+r,a=this.d.indexOf(o);if(a<0)return!1;const c=a+o.length;if(c>=this.d.length)return!1;const s=this.d.charCodeAt(c);if(s!==this.b&&s!==this.c)return!1;if(n){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.f?.workspace):void 0,C=this.g.getValue(r,n,this.h);return!I.equals(f,C)}return!0}}e.ConfigurationChangeEvent=k;function S(i,r){const{added:n,removed:o,updated:a}=D(r?.rawConfiguration,i?.rawConfiguration),c=[],s=i?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const C=f.filter(L=>!s.includes(L));for(const L of C)c.push([L,r.getKeysForOverrideIdentifier(L)])}if(i){const C=s.filter(L=>!f.includes(L));for(const L of C)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(r&&i){for(const C of s)if(f.includes(C)){const L=D({contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)},{contents:r.getOverrideValue(void 0,C)||{},keys:r.getKeysForOverrideIdentifier(C)});c.push([C,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:o,updated:a,overrides:c}}function D(i,r){const n=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],o=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],a=[];if(i&&r){for(const c of r.keys)if(i.keys.indexOf(c)!==-1){const s=(0,p.getConfigurationValue)(r.contents,c),f=(0,p.getConfigurationValue)(i.contents,c);I.equals(s,f)||a.push(c)}}return{added:n,removed:o,updated:a}}}),define(ee[220],te([0,1,25,3,2,44,11,18,110,66,6,38,48]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(b.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:k})=>this.c(Array.from(g),k))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(g,k){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}}e.DefaultConfiguration=h;class d extends w.ConfigurationModel{constructor(g={}){const k=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),S=Object.keys(k),D=Object.create(null),i=[];for(const r in k){const n=g[r],o=n!==void 0?n:k[r].default;(0,I.addToValueTree)(D,r,o,a=>console.error(`Conflict in default settings: ${a}`))}for(const r of Object.keys(D))m.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(r),keys:Object.keys(D[r]),contents:(0,I.toValuesTree)(D[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(D,S,i)}}e.DefaultConfigurationModel=d;class v{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let l=class extends P.Disposable{get configurationModel(){return this.b}constructor(g,k,S){super(),this.c=g,this.f=k,this.g=S,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const k={},S=[],D=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of g){const r=D[i];if(!r){S.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}S.push(i),k[r.policy.name]={type:r.type}}}return(0,M.isEmptyObject)(k)||await this.f.updatePolicyDefinitions(k),S}i(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const k=b.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),S=(0,E.coalesce)(g.map(D=>k.get(D)));this.j(S,!0)}j(g,k){this.g.trace("PolicyConfiguration#update",g);const S=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),D=[],i=this.b.isEmpty();for(const r of g){const n=S[r]?.policy?.name;if(n){const o=this.f.getPolicyValue(n);(i?o!==void 0:!(0,R.equals)(this.b.getValue(r),o))&&D.push([r,o])}else this.b.getValue(r)!==void 0&&D.push([r,void 0])}if(D.length){this.g.trace("PolicyConfiguration#changed",D);const r=this.b;this.b=new w.ConfigurationModel;for(const n of r.keys)this.b.setValue(n,r.getValue(n));for(const[n,o]of D)o===void 0?this.b.removeValue(n):this.b.setValue(n,o);k&&this.a.fire(this.b)}}};l=pe([_(1,y.IPolicyService),_(2,p.ILogService)],l),e.PolicyConfiguration=l}),define(ee[221],te([0,1,8,3,2,20,18,110,220,38]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends P.Disposable{constructor(b,h,d,v){super(),this.i=b,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=d instanceof m.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,d,v)),this.f=this.B(new I.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,h)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:u})=>this.k(l,u))),this.B(this.c.onDidChangeConfiguration(l=>this.l(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,h,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(b,h,new I.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(b,h){const d=typeof b=="string"?b:void 0,v=(0,M.isConfigurationOverrides)(b)?b:(0,M.isConfigurationOverrides)(h)?h:{};return this.a.getValue(d,v,void 0)}updateValue(b,h,d,v){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const h=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(d,h,2)}k(b,h){const d=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(b,h);this.m(v,d,7)}l(b){const h=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(b);this.m(d,h,7)}m(b,h,d){const v=new I.ConfigurationChangeEvent(b,{data:h},this.a);v.source=d,v.sourceConfig=this.n(d),this.h.fire(v)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(ee[222],te([0,1,13,5]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof R&&w._code===P.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof R&&w._code===P.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof R&&w._code===P.NoResolverFound}static isHandled(w){return w instanceof R&&w.isHandled}constructor(w,m=P.Unknown,p){super(w),this._message=w,this._code=m,this._detail=p,this.isHandled=m===P.NotAvailable&&p===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function M(I){const w=I.indexOf("+");return w===-1?I:I.substring(0,w)}e.getRemoteAuthorityPrefix=M}),define(ee[55],te([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===E.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function P(m){if(!m)return;const p=m.indexOf("+");return p<0?m:m.substr(0,p)}e.getRemoteName=P;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(m){const{host:p,port:y}=w(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:y}}e.parseAuthorityWithPort=M;function I(m,p){let{host:y,port:b}=w(m);return typeof b>"u"&&(b=p),{host:y,port:b}}e.parseAuthorityWithOptionalPort=I;function w(m){const p=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const b=m.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:m,port:void 0}}}),define(ee[89],te([0,1,27,5,55]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function M(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var w;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(v){this.value=v,this.c=v.toLowerCase()}static equals(v,l){if(typeof v>"u"||v===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof v=="string"||typeof l=="string"){const u=typeof v=="string"?v:v.value,g=typeof l=="string"?l:l.value;return E.equalsIgnoreCase(u,g)}return v.c===l.c}static toKey(v){return typeof v=="string"?v.toLowerCase():v.c}}e.ExtensionIdentifier=m;function p(d){return y(d)}e.isApplicationScopedExtension=p;function y(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function b(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function h(d,v){if(v){const l=`onResolveRemoteAuthority:${(0,P.getRemoteName)(v)}`;return d.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[223],te([0,1,8,17,22,13,3,2,63,69,31,103,222,55]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const d=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function l(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(W){const N=new P.CancellationTokenSource;return setTimeout(()=>N.cancel(),W),N.token}function g(W,N){if(W.isCancellationRequested||N.isCancellationRequested)return P.CancellationToken.Cancelled;const $=new P.CancellationTokenSource;return W.onCancellationRequested(()=>$.cancel()),N.onCancellationRequested(()=>$.cancel()),$.token}class k{get didTimeout(){return this.c==="timedout"}constructor(N){this.c="pending",this.d=new I.DisposableStore,this.promise=new Promise(($,G)=>{this.f=$,this.g=G}),N.isCancellationRequested?this.h():this.d.add(N.onCancellationRequested(()=>this.h()))}registerDisposable(N){this.c==="pending"?this.d.add(N):N.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(N))}reject(N){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(N))}}function S(W,N){const $=new k(N);return $.registerDisposable(W.onControlMessage(G=>{const B=JSON.parse(G.toString()),X=z(B);X?$.reject(X):$.resolve(B)})),$.promise}function D(W,N,$,G,B,X,Z,oe,de){const ke=new k(de),De=m.StopWatch.create(!1);return W.info(`Creating a socket (${oe})...`),w.mark(`code/willCreateSocket/${Z}`),N.connect($,G,B,X,oe,(Pe,Ae)=>{ke.didTimeout?(w.mark(`code/didCreateSocketError/${Z}`),W.info(`Creating a socket (${oe}) finished after ${De.elapsed()} ms, but this is too late and has timed out already.`),Pe&&W.error(Pe),Ae?.dispose()):Pe||!Ae?(w.mark(`code/didCreateSocketError/${Z}`),W.info(`Creating a socket (${oe}) returned an error after ${De.elapsed()} ms.`),ke.reject(Pe)):(w.mark(`code/didCreateSocketOK/${Z}`),W.info(`Creating a socket (${oe}) was successful after ${De.elapsed()} ms.`),ke.resolve(Ae))}),ke.promise}function i(W,N){const $=new k(N);return W.then(G=>{$.didTimeout||$.resolve(G)},G=>{$.didTimeout||$.reject(G)}),$.promise}async function r(W,N,$,G){const B=A(W,N);W.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let X;try{X=await D(W.logService,W.socketFactory,W.host,W.port,(0,h.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,l(N),`renderer-${l(N)}-${W.reconnectionToken}`,G)}catch(De){throw W.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),W.logService.error(De),De}W.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let Z,oe;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(X,null),Z=W.reconnectionProtocol,oe=!1):(Z=new y.PersistentProtocol({socket:X,measureRoundTripTime:!0}),oe=!0),W.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const de=await i(W.signService.createNewMessage((0,p.generateUuid)()),G),ke={type:"auth",auth:W.connectionToken||"00000000000000000000",data:de.data};Z.sendControl(t.VSBuffer.fromString(JSON.stringify(ke)));try{const De=await S(Z,g(G,u(1e4)));if(De.type!=="sign"||typeof De.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(W.logService.trace(`${B} 4/6. received SignRequest control message.`),!await i(W.signService.validate(de,De.signedData),G)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const Ae=await i(W.signService.sign(De.data),G),ve={type:"connectionType",commit:W.commit,signedData:Ae,desiredConnectionType:N};return $&&(ve.args=$),W.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(t.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(De){throw De&&De.code==="ETIMEDOUT"&&(W.logService.error(`${B} the handshake timed out. Error:`),W.logService.error(De)),De&&De.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${B} received error control message when negotiating connection. Error:`),W.logService.error(De)),oe&&U(Z),De}}async function n(W,N,$,G){const B=Date.now(),X=A(W,N),{protocol:Z,ownsProtocol:oe}=await r(W,N,$,G),de=new k(G);return de.registerDisposable(Z.onControlMessage(ke=>{const De=JSON.parse(ke.toString()),Pe=z(De);Pe?(W.logService.error(`${X} received error control message when negotiating connection. Error:`),W.logService.error(Pe),oe&&U(Z),de.reject(Pe)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${F(B)}!`),de.resolve({protocol:Z,firstMessage:De}))})),de.promise}async function o(W,N){const{protocol:$}=await n(W,1,void 0,N);return{protocol:$}}async function a(W,N,$){const{protocol:G,firstMessage:B}=await n(W,2,N,$),X=B&&B.debugPort;return{protocol:G,debugPort:X}}async function c(W,N,$){const G=Date.now(),B=A(W,3),{protocol:X}=await r(W,3,N,$);return W.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${F(G)}!`),X}async function s(W,N,$){const{host:G,port:B,connectionToken:X}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:G,port:B,connectionToken:X,reconnectionToken:N,reconnectionProtocol:$,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function f(W,N,$){return L(W,async G=>{const{protocol:B}=await o(G,P.CancellationToken.None);return new q(W,N,$,G.reconnectionToken,B)})}e.connectRemoteAgentManagement=f;async function C(W,N){return L(W,async $=>{const{protocol:G,debugPort:B}=await a($,N,P.CancellationToken.None);return new T(W,N,$.reconnectionToken,G,B)})}e.connectRemoteAgentExtensionHost=C;async function L(W,N){for(let G=1;;G++)try{const B=(0,p.generateUuid)(),X=await s(W,B,null);return await N(X)}catch(B){if(G<5)W.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(B);else throw W.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(B),ge.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(B)),B}}async function O(W,N,$){const G=await s(W,(0,p.generateUuid)(),null);return await c(G,{host:N,port:$},P.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function j(W){return(0,E.createCancelablePromise)(N=>new Promise(($,G)=>{const B=setTimeout($,W*1e3);N.onCancellationRequested(()=>{clearTimeout(B),$()})}))}var K;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(K=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class V{constructor(N,$){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=V;class J{constructor(N,$,G,B){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.durationSeconds=G,this.c=B,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=J;class re{constructor(N,$,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=re;class se{constructor(N,$,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.attempt=G,this.type=4}}e.ConnectionGainEvent=se;class ae{constructor(N,$){this.reconnectionToken=N,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=ae;class fe{constructor(N,$,G,B){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.attempt=G,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends I.Disposable{static triggerPermanentFailure(N,$,G){this._permanentFailure=!0,this.f=N,this.g=$,this.h=G,this.i.forEach(B=>B.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(N=>N.r())}static debugPauseSocketWriting(){this.i.forEach(N=>N.v())}get k(){return this.c||ge._permanentFailure}constructor(N,$,G,B,X){super(),this.m=N,this.n=$,this.reconnectionToken=G,this.protocol=B,this.p=X,this.j=this.B(new M.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B(B.onSocketClose(Z=>{const oe=x(this.m,this.reconnectionToken,!0);Z?Z.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.n.logService.error(Z.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.n.logService.error(Z.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(B.onSocketTimeout(Z=>{const oe=x(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(B.onHighRoundTripTime(Z=>{const oe=ne(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${Z.roundTripTime}ms (${Z.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(B.onDidChangeConnectionHealth(Z=>{this.j.fire(new ae(this.reconnectionToken,Z))})),ge.i.push(this),this.B((0,I.toDisposable)(()=>{const Z=ge.i.indexOf(this);Z>=0&&ge.i.splice(Z,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const N=x(this.m,this.reconnectionToken,!0);this.n.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const B=G<$.length?$[G]:$[$.length-1];try{if(B>0){const Z=j(B);this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,Z)),this.n.logService.info(`${N} waiting for ${B} seconds before reconnecting...`);try{await Z}catch{}}if(this.k){this.n.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.n.logService.info(`${N} resolving connection...`);const X=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${N} connecting to ${X.host}:${X.port}...`),await this.w(X,u(d)),this.n.logService.info(`${N} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.n.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this.n.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.n.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((0,R.isCancellationError)(X)){this.n.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if(X instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,b.RemoteAuthorityResolverError.isHandled(X));break}this.n.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k)}t(N,$,G){this.p?ge.triggerPermanentFailure(N,$,G):this.u(N,$,G)}u(N,$,G){this.j.fire(new fe(this.reconnectionToken,N,$,G)),U(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ge,ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[];class q extends ge{constructor(N,$,G,B,X){super(1,N,B,X,!0),this.client=this.B(new y.Client(X,{remoteAuthority:$,clientId:G},N.ipcLogger))}async w(N,$){await o(N,$)}}e.ManagementPersistentConnection=q;class T extends ge{constructor(N,$,G,B,X){super(2,N,G,B,!1),this.y=$,this.debugPort=X}async w(N,$){await a(N,this.y,$)}}e.ExtensionHostPersistentConnection=T;function U(W){try{W.acceptDisconnect();const N=W.getSocket();W.dispose(),N.dispose()}catch(N){(0,R.onUnexpectedError)(N)}}function z(W){if(W&&W.type==="error"){const N=new Error(`Connection error: ${W.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function Q(W,N){for(;W.length<N;)W+=" ";return W}function ne(W,N){return`[remote-connection][${Q(l(W),13)}][${N.substr(0,5)}\u2026]`}function x(W,N,$){return`${ne(W,N)}[${$?"reconnect":"initial"}]`}function A(W,N){return`${x(N,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function F(W){return`${Date.now()-W} ms`}}),define(ee[224],te([0,1,80,85]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,R,M,I,w,m){const p=b=>m(b,void 0),y=E.createConnection({host:P,port:R},()=>{y.removeListener("error",p);const b=Buffer.alloc(16);for(let l=0;l<16;l++)b[l]=Math.round(Math.random()*256);const h=b.toString("base64"),d=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${R}${M}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];y.write(d.join(`\r
`)+`\r
\r
`);const v=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",v),m(void 0,new t.NodeSocket(y,w)))};y.on("data",v)});y.setNoDelay(!0),y.once("error",p)}}}),define(ee[225],te([0,1,26,46,41,184]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function I(h=!1){return(M===void 0||h)&&(M=w()),M}e.hasWSLFeatureInstalled=I;async function w(){const h=m();if(h===void 0)return!1;if(h>=22e3){const d=y();if(d)return new Promise(v=>{t.execFile(d,["--status"],l=>v(!l))})}else{const d=b();if(d)try{if((await P.promises.stat(d)).isFile())return!0}catch{}}return!1}function m(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(h)return parseInt(h[3])}function p(h){const d=process.env.SystemRoot;if(d){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,v?"Sysnative":"System32",h)}}function y(){return p("wsl.exe")}function b(){return p("lxss\\LxssManager.dll")}}),define(ee[56],te([0,1,17,168,66,5,48]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function I(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=I;function w(v){return v.res.statusCode===204}async function m(v){return w(v)?null:(await(0,E.streamToBuffer)(v.stream)).toString()}e.asText=m;async function p(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}e.asTextOrError=p;async function y(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);if(w(v))return null;const u=(await(0,E.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(g){throw g.message+=`:
`+u,g}}e.asJson=y;function b(v){d(v)}e.updateProxyConfigurationsScope=b;let h;function d(v){const l=M.Registry.as(P.Extensions.Configuration),u=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},l.updateConfigurations({add:[h],remove:u?[u]:[]})}d(2)}),define(ee[226],te([0,1,17,22]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(I){this.a=I}listen(I,w){throw new Error("Invalid listen")}call(I,w,m,p=t.CancellationToken.None){switch(w){case"request":return this.a.request(m[0],p).then(async({res:y,stream:b})=>{const h=await(0,E.streamToBuffer)(b);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=P;class R{constructor(I){this.a=I}async request(I,w){const[m,p]=await this.a.call("request",[I],w);return{res:m,stream:(0,E.bufferToStream)(p)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.RequestChannelClient=R}),define(ee[227],te([0,1,228,11]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(M,I){return M.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:M.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(M,I,w={}){const m=(0,E.parse)(M),p=w.proxyUrl||P(m,I);if(!p)return null;const y=(0,E.parse)(p);if(!/^https?:$/.test(y.protocol||""))return null;const b={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,t.isBoolean)(w.strictSSL)?w.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((h,d)=>{H(["http-proxy-agent"],h,d)}))(b):new(await new Promise((h,d)=>{H(["https-proxy-agent"],h,d)}))(b)}e.getProxyAgent=R}),define(ee[111],te([0,1,46,9,169,22,45,13,4,31,145,61,8,127]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function v(u,g,k,S){return k["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(S)&&!k["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(S)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=b.Promises.withAsyncBody(async(D,i)=>{const r=new R.CancellationTokenSource;let n=1e4;const o=u.getValue("application.shellEnvironmentResolutionTimeout");typeof o=="number"&&(n=(0,h.clamp)(o,1,120)*1e3);const a=setTimeout(()=>{r.dispose(!0),i(new Error((0,P.localize)(0,null)))},n);try{D(await l(g,r.token))}catch(c){!(0,I.isCancellationError)(c)&&!r.token.isCancellationRequested?i(new Error((0,P.localize)(1,null,(0,M.toErrorMessage)(c)))):D({})}finally{clearTimeout(a),r.dispose()}})),d)}e.getResolvedShellEnv=v;async function l(u,g){const k=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",k);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",S);const D=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(D+"({.*})"+D),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",r);const n=await(0,p.getSystemShell)(w.OS,r);return u.trace("getUnixShellEnvironment#shell",n),new Promise((o,a)=>{if(g.isCancellationRequested)return a(new I.CancellationError);const c=(0,t.basename)(n);let s,f;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(s=`& '${process.execPath}' ${C} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,f=["-Login","-Command"]):(s=`'${process.execPath}' ${C} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,c==="tcsh"||c==="csh"?f=["-ic"]:f=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),s);const L=(0,E.spawn)(n,[...f,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(L.kill(),a(new I.CancellationError))),L.on("error",K=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(K)),a(K)});const O=[];L.stdout.on("data",K=>O.push(K));const j=[];L.stderr.on("data",K=>j.push(K)),L.on("close",(K,V)=>{const J=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",J);const re=Buffer.concat(j).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),K||V)return a(new Error((0,P.localize)(2,null,K,V)));const se=i.exec(J),ae=se?se[1]:"{}";try{const fe=JSON.parse(ae);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,S?fe.ELECTRON_NO_ATTACH_CONSOLE=S:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",fe),o(fe)}catch(fe){u.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(fe)),a(fe)}})})}}),define(ee[90],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[229],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((P,R)=>H(["vsda"],P,R))}async createNewMessage(P){try{const R=await this.c(),M=new R.validator;if(M){const I=String(E.a++);return this.b.set(I,M),{id:I,data:M.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const M=this.b.get(P.id);if(!M)return!1;this.b.delete(P.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(P){try{const R=await this.c(),M=new R.signer;if(M)return M.sign(P)}catch{}return P}}e.SignService=E,E.a=1}),define(ee[34],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],te([0,1,14,42,8,3,2,4,35,11,5,6,34,28]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var d;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let l=class It extends M.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(g,k,S){super(),this.v=g,this.w=k,this.y=S,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const g=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",g);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!I.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",k),E.app.once("will-quit",S=>{this.L("Lifecycle#app.on(will-quit)"),S.preventDefault(),this.D(1).finally(()=>{this.H(!1),E.app.removeListener("before-quit",g),E.app.removeListener("window-all-closed",k),E.app.quit()})})}D(g){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:g,join(S){k.push(S)}}),this.s=(async()=>{try{await P.Promises.settled(k)}catch(S){this.v.error(S)}try{await this.w.close()}catch(S){this.v.error(S)}})(),this.s}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===g)return;this.L(`lifecycle (main): phase changed (value: ${g})`),this.k=g;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(g){if(g<=this.k)return;let k=this.u.get(g);k||(k=new P.Barrier,this.u.set(g,k)),await k.wait()}registerWindow(g){const k=new M.DisposableStore;this.n++,k.add(g.onWillLoad(D=>this.g.fire({window:g,workspace:D.workspace,reason:D.reason})));const S=(0,m.assertIsDefined)(g.win);S.on("close",D=>{const i=g.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${g.id}`),D.preventDefault(),this.unload(g,1).then(r=>{if(r){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(g),g.close()})}),S.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.n--,k.dispose(),this.n===0&&(!I.isMacintosh||this.i)&&this.D(1)})}async reload(g,k){await this.unload(g,3)||g.reload(k)}unload(g,k){const S=this.t.get(g.id);if(S)return S;const D=this.F(g,k).finally(()=>{this.t.delete(g.id)});return this.t.set(g.id,D),D}async F(g,k){if(!g.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${g.id}`);const S=this.i?2:k,D=await this.I(g,S);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.G(D)):(await this.J(g,S),!1)}G(g){return g?(this.H(!0),this.i=!1,!0):!1}H(g){this.r&&(this.r(g),this.r=void 0,this.p=void 0)}I(g,k){return new Promise(S=>{const D=this.m++,i=`vscode:ok${D}`,r=`vscode:cancel${D}`;t.validatedIpcMain.once(i,()=>{S(!1)}),t.validatedIpcMain.once(r,()=>{S(!0)}),g.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:r,reason:k})})}J(g,k){return new Promise(S=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>S()),g.send("vscode:onWillUnload",{replyChannel:i,reason:k})})}quit(g){return this.L(`Lifecycle#quit() - begin (willRestart: ${g})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(g&&this.w.setItem(It.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(g){this.y.args["enable-smoke-test-driver"]?this.v.info(g):this.v.trace(g)}async relaunch(g){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(g?.addArgs&&k.push(...g.addArgs),g?.removeArgs)for(const i of g.removeArgs){const r=k.indexOf(i);r>=0&&k.splice(r,1)}const S=()=>{try{if(I.isWindows){const i=(0,w.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:k})};E.app.once("quit",S),await this.quit(!0)&&E.app.removeListener("quit",S)}async kill(g){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,P.timeout)(1e3),(async()=>{for(const k of E.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let S;k.webContents&&!k.webContents.isDestroyed()?S=new Promise(D=>k.once("closed",D)):S=Promise.resolve(),k.destroy(),await S}})()]),E.app.exit(g)}};l.b="lifecycle.quitAndRestart",l=pe([_(0,y.ILogService),_(1,b.IStateMainService),_(2,h.IEnvironmentMainService)],l),e.LifecycleMainService=l}),define(ee[230],te([0,1,4,3,2,5,21]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let I=class extends P.Disposable{constructor(p){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((y,b)=>{H(["native-keymap"],y,b)});this.c=w(p),E.isCI||p.onDidChangeKeyboardLayout(()=>{this.c=w(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};I=pe([_(0,M.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function w(m){const p=m.getKeyMap(),y=m.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:y}}}),define(ee[231],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[232],te([0,1,8,17,11,33,16,6]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class w{constructor(y,b,h){this.f=y,this.g=b,this.h=h,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.g.error(y)}}getItem(y,b){const h=this.a[y];return(0,P.isUndefinedOrNull)(h)?b:h}setItem(y,b){this.setItems([{key:y,data:b}])}setItems(y){let b=!1;for(const{key:h,data:d}of y)this.a[h]!==d&&((0,P.isUndefinedOrNull)(d)?(0,P.isUndefined)(this.a[h])||(this.a[h]=void 0,b=!0):(this.a[h]=d,b=!0));b&&this.j()}removeItem(y){(0,P.isUndefined)(this.a[y])||(this.a[y]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(y)),this.b=y}catch(b){this.g.error(b)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=w;let m=class{constructor(y,b,h){this.a=new w(y.stateResource,b,h)}async init(){await this.a.init()}getItem(y,b){return this.a.getItem(y,b)}};m=pe([_(0,R.IEnvironmentService),_(1,I.ILogService),_(2,M.IFileService)],m),e.StateService=m}),define(ee[233],te([0,1,232]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(R,M){this.a.setItem(R,M)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=t}),define(ee[91],te([0,1,4,35,7,31]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(m){if(E.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function I(m,p,y,b,h,d,v,l,u,g){const k=Object.create(null);k["common.machineId"]=v,k.sessionID=(0,R.generateUuid)()+Date.now(),k.commitHash=h,k.version=d,k["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,E.PlatformToString)(E.platform),k["common.nodePlatform"]=t.platform,k["common.nodeArch"]=b,k["common.product"]=g||"desktop",l&&(k["common.msftInternal"]=l);let S=0;const D=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),E.isLinuxSnap&&(k["common.snap"]="true");const i=M(y);i&&(k["common.platformDetail"]=i);try{const r=await m.readFile(P.URI.file(u));k["common.source"]=r.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=I;function w(m){const p=t.env.USERDNSDOMAIN;if(!p)return!1;const y=p.toLowerCase();return m.some(b=>y===b)}e.verifyMicrosoftInternalDomain=w}),define(ee[24],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[234],te([0,1,26,8,43,15,9,4,7,83,23,102,86,16,19,24]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const l=new Map;async function u(i,r){const n=`${i}::${r.join(":")}`,o=l.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,s=new Map,f=2e4;function C(O,j,K,V){const J=j.substring(O.length+1);return t.Promises.withAsyncBody(async re=>{let se;try{se=await p.Promises.readdir(j,{withFileTypes:!0})}catch{re();return}if(V.count>=f){V.count+=se.length,V.maxReached=!0,re();return}let ae=se.length;if(ae===0){re();return}let fe=se;V.count+se.length>f&&(V.maxReached=!0,ae=f-V.count,fe=se.slice(0,ae)),V.count+=se.length;for(const ge of fe)if(ge.isDirectory()){if(K.includes(ge.name)||await C(O,(0,M.join)(j,ge.name),K,V),--ae===0){re();return}}else{const q=ge.name.lastIndexOf(".");if(q>=0){const T=ge.name.substring(q+1);T&&c.set(T,(c.get(T)??0)+1)}for(const T of a)T.relativePathPattern?.test(J)!==!1&&T.filePattern.test(ge.name)&&s.set(T.tag,(s.get(T.tag)??0)+1);if(--ae===0){re();return}}})}const L=t.Promises.withAsyncBody(async O=>{const j={count:0,maxReached:!1};await C(i,i,r,j);const K=await S(i);O({configFiles:g(s),fileTypes:g(c),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:K})});return l.set(n,L),L}e.collectWorkspaceStats=u;function g(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function k(){const i={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=k;async function S(i){try{const r=new Map,n=(0,M.join)(i,".vscode","launch.json"),o=await p.Promises.readFile(n),a=[],c=(0,P.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,P.getNodeType)(c)==="object"&&c.configurations)for(const s of c.configurations){const f=s.type;f&&(r.has(f)?r.set(f,r.get(f)+1):r.set(f,1))}return g(r)}catch{return[]}}e.collectLaunchConfigs=S;let D=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const o=E.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||n.push(`Load (avg):       ${E.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.listProcesses)(r.mainPID),this.k(r)]).then(async o=>{let[a,c]=o,s=this.m(r,a);return n.forEach(f=>{if((0,b.isRemoteDiagnosticError)(f))s+=`
${f.errorMessage}`,c+=`
${f.errorMessage}`;else if(s+=`

Remote: ${f.hostName}`,f.processes&&(s+=`
${this.m(r,f.processes)}`),f.workspaceMetadata){c+=`
|  Remote: ${f.hostName}`;for(const C of Object.keys(f.workspaceMetadata)){const L=f.workspaceMetadata[C];let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${C}): ${O}`,c+=this.h(L)}}}),{processInfo:s,workspaceInfo:c}})}async getSystemInfo(r,n){const{memory:o,vmHint:a,os:c,cpus:s}=k(),f={os:c,memory:o,cpus:s,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return I.isWindows||(f.load=`${E.loadavg().map(C=>Math.round(C)).join(", ")}`),I.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(r,n){const o=[];return(0,y.listProcesses)(r.mainPID).then(async a=>(o.push(""),o.push(this.g(r)),o.push(""),o.push(this.m(r,a)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(r))),n.forEach(c=>{if((0,b.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.f(c.machineInfo)),c.processes&&o.push(this.m(r,c.processes)),c.workspaceMetadata)for(const s of Object.keys(c.workspaceMetadata)){const f=c.workspaceMetadata[s];let C=`${f.fileCount} files`;f.maxFilesReached&&(C=`more than ${C}`),o.push(`Folder (${s}): ${C}`),o.push(this.h(f))}}),o.push(""),o.push(""),o.join(`
`)))}h(r){const n=[];let a=0;const c=(L,O)=>{const j=` ${L}(${O})`;a+j.length>60?(n.push(s),s="|                 ",a=s.length):a+=j.length,s+=j};let s="|      File types:";const f=10,C=r.fileTypes.length>f?f:r.fileTypes.length;for(let L=0;L<C;L++){const O=r.fileTypes[L];c(O.name,O.count)}if(n.push(s),r.configFiles.length>=0&&(s="|      Conf files:",a=0,r.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(s)),r.launchConfigFiles.length>0){let L="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{L+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(L)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${r[o]}`).join(`
                  `)}k(r){const n=[],o=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const s=w.URI.revive(c);if(s.scheme===R.Schemas.file){const f=s.fsPath;o.push(u(f,["node_modules",".git"]).then(C=>{let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,M.basename)(f)}): ${L}`),n.push(this.h(C))}).catch(C=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${C.toString()})`)}))}else n.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(r,n){const o=new Map;r.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,o,a,n,0),a.join(`
`)}n(r,n,o,a,c){const s=c===0;let f;s?f=a.pid===r?`${this.d.applicationName} main`:"remote agent":(f=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(f=`${f} (${n.get(a.pid)})`));const C=process.platform==="win32"?a.mem:E.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(C/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(L=>this.n(r,n,o,L,c+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:o}of r.folders){const a=w.URI.revive(o);if(a.scheme!==R.Schemas.file)continue;const c=a.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(f=>n.add(f.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const o=w.URI.revive(n);if(o.scheme!==R.Schemas.file)continue;const a=o.fsPath;try{const c=await u(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};D=pe([_(0,v.ITelemetryService),_(1,d.IProductService)],D),e.DiagnosticsService=D}),define(ee[235],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.b=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:I,data:w}){return this.b.forEach(m=>m.log(I,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(R){this.b=R}log(R,M){return this.b.call("log",{eventName:R,data:M}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[51],te([0,1,44,11,3,18,55,91,24]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(s){this.value=s}}e.TelemetryTrustedValue=m;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,f){return Promise.resolve(void 0)}publicLog2(s,f){return this.publicLog(s,f)}publicLogError(s,f){return Promise.resolve(void 0)}publicLogError2(s,f){return this.publicLogError(s,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class y{async publicLog(s,f,C){}async publicLogError(s,f,C){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(c,s){return P.Event.debounce(s.onDidChangeConfiguration,(C,L)=>{const O=C?new Set([...C.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:O}},1e3,!0)(C=>{C.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(C.source),configurationKeys:S(C.affectedKeys)})})}e.configurationTelemetry=b;function h(c,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=h;function d(c,s){return!(s.isBuilt||s.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=d;function v(c){const s=c.getValue(w.TELEMETRY_SETTING_ID),f=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function l(c){const s={},f={},C={};k(c,C);for(let L in C){L=L.length>150?L.substr(L.length-149):L;const O=C[L];typeof O=="number"?f[L]=O:typeof O=="boolean"?f[L]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${O.length}`),s[L]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(s[L]=O)}return{properties:s,measurements:f}}e.validateTelemetryData=l;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(c){if(!c)return"none";const s=(0,M.getRemoteName)(c);return u.has(s)?s:"other"}e.cleanRemoteAuthority=g;function k(c,s,f=0,C){if(!!c)for(const L of Object.getOwnPropertyNames(c)){const O=c[L],j=C?C+L:L;Array.isArray(O)?s[j]=(0,E.safeStringify)(O):O instanceof Date?s[j]=O.toISOString():(0,t.isObject)(O)?f<2?k(O,s,f+1,j+"."):s[j]=(0,E.safeStringify)(O):s[j]=O}}function S(c){if(!c)return[];const s=[];return D(s,"",c),s}function D(c,s,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(C=>D(c,s?`${s}.${C}`:C,f[C])):c.push(s)}function i(c,s){const f=c.msftInternalDomains||[],C=s.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(f)||C}e.isInternalTelemetry=i;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function n(c,s){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let f=c;const C=[];for(const K of s)for(;;){const V=K.exec(c);if(!V)break;C.push([V.index,K.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(f="";;){const K=O.exec(c);if(!K)break;const V=C.some(([J,re])=>K.index<re&&J<O.lastIndex);!L.test(K[0])&&!V&&(f+=c.substring(j,K.index)+"<REDACTED: user-file-path>",j=O.lastIndex)}return j<c.length&&(f+=c.substr(j)),f}function o(c){if(!c)return c;const s=c.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const C of f)if(C.regex.test(s))return`<REDACTED: ${C.label}>`;return c}function a(c,s){return(0,E.cloneAndChange)(c,f=>{if(f instanceof m)return f.value;if(typeof f=="string"){let C=f.replaceAll("%20"," ");C=n(C,s);for(const L of s)C=C.replace(L,"");return C=o(C),C}})}e.cleanData=a}),define(ee[112],te([0,1,27,194,89,4,7,13,35,51]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,E.compareIgnoreCase)(n.id,o.id)===0}e.areSameExtensions=p;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(o){const a=o.manifest?o.manifest.version:o.version,c=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new b(o.identifier,a,c)}static parse(o){const a=y.exec(o);return a&&a[1]&&a[2]?new b({id:a[1]},a[2],a[4]||void 0):null}constructor(o,a,c="undefined"){this.version=a,this.targetPlatform=c,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof b?p(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=b;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const o=h.exec(n);return o&&o[1]?[l(o[1]),o[2]]:[l(n),void 0]}e.getIdAndVersion=d;function v(n,o){return`${n}.${o}`}e.getExtensionId=v;function l(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=l;function u(n,o){return l(v(n,o))}e.getGalleryExtensionId=u;function g(n,o){const a=[],c=s=>{for(const f of a)if(f.some(C=>p(o(C),o(s))))return f;return null};for(const s of n){const f=c(s);f?f.push(s):a.push([s])}return a}e.groupByExtension=g;function k(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function S(n){return{id:new m.TelemetryTrustedValue(n.identifier.id),name:new m.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function D(n,o){const a=[],c=o.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const s=c.shift();if(s&&a.every(f=>!p(f.identifier,{id:s}))){const f=n.filter(C=>p(C.identifier,{id:s}));f.length===1&&(a.push(f[0]),c.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=D;async function i(n,o){if(!R.isLinux)return!1;let a;try{a=(await n.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await n.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){o.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(s))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(n,o){const a=await i(n,o),c=(0,t.getTargetPlatform)(a?"alpine":R.platform,w.arch);return o.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(ee[236],te([0,1,191,51]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(R,M,I,w,m,p,y){const b={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`};if((0,t.supportsTelemetry)(M,I)&&(0,t.getTelemetryLevel)(w)===3){const h=await(0,E.getServiceMachineId)(I,m,p),{machineId:d}=await y.getTelemetryInfo();b["X-Market-User-Id"]=h,b["VSCode-SessionId"]=d||h}return b}e.resolveMarketplaceHeaders=P}),define(ee[237],te([0,1,13,44,51]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",M="https://mobile.events.data.microsoft.com/ping";async function I(m,p,y){const b=await new Promise((u,g)=>{H(["@microsoft/1ds-core-js"],u,g)}),h=await new Promise((u,g)=>{H(["@microsoft/1ds-post-js"],u,g)}),d=new b.AppInsightsCore,v=new h.PostChannel,l={instrumentationKey:m,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(y){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:y};l.extensionConfig[v.identifier]=u}return d.initialize(l,[]),d.addTelemetryInitializer(u=>{p&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class w{constructor(p,y,b,h,d){this.e=p,this.f=y,this.g=b,this.h=d,this.c=R,this.d=M,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(p){if(!!this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=I(this.a,this.e,this.h)),this.b.then(y=>{p(y)},y=>{(0,E.onUnexpectedError)(y),console.error(y)})}}log(p,y){if(!this.a)return;y=(0,t.mixin)(y,this.g),y=(0,P.validateTelemetryData)(y);const b=this.f+"/"+p;try{this.i(h=>{h.pluginVersionString=y?.properties.version??"Unknown",h.track({name:b,baseData:{name:b,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=w}),define(ee[113],te([0,1,2,44,4,27,170,18,66,64,19,48,24,51]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,g,k){this.k=g,this.l=k,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(b.TELEMETRY_SETTING_ID)||S.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,h.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const k=g.usage?3:g.error?2:0;u=Math.min(u,k)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,g=u.sessionID,k=u["common.machineId"],S=u["common.firstSessionDate"],D=u["common.msftInternal"];return{sessionId:g,machineId:k,firstSessionDate:S,msftInternal:D}}dispose(){this.i.dispose()}n(u,g,k){return this.g<g?Promise.resolve(void 0):this.c.then(S=>{k=(0,t.mixin)(k,this.d),k=(0,h.cleanData)(k,this.j),k=(0,t.mixin)(k,S),this.b.forEach(D=>D.log(u,k))},S=>{console.error(S)})}publicLog(u,g){return this.n(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this.h?this.n(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([_(1,I.IConfigurationService),_(2,p.IProductService)],d),e.TelemetryService=d;function v(){const l=(0,M.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=P.isWeb?"":(0,M.localize)(3,null),k=(0,M.localize)(4,null),S=(0,M.localize)(5,null),D=(0,M.localize)(6,null),i=(0,M.localize)(7,null),r=`
|       | ${k} | ${S} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,M.localize)(8,null);return`
${l} ${u} ${g}

&nbsp;

${i}
${r}

&nbsp;

${n}
`}y.Registry.as(w.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(w.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,M.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,M.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[238],te([0,1,287,237]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends t.AbstractOneDataSystemAppender{constructor(M,I,w,m){const p={sendPOST:(y,b)=>{const h={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const d=E.request(y.urlString,h,v=>{v.on("data",function(l){b(v.statusCode??200,v.headers,l.toString())}),v.on("error",function(l){b(0,{})})});d.write(y.data),d.end()}catch{b(0,{})}}};super(M,I,w,m,p)}}e.OneDataSystemAppender=P}),define(ee[239],te([0,1,4,83,24]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(M){let I=M.getItem(P.machineIdKey);return(typeof I!="string"||E.isMacintosh&&I==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(I=await(0,t.getMachineId)()),I}e.resolveMachineId=R}),define(ee[114],te([0,1,24,239]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function P(R){const M=await(0,t.resolveMachineId)(R);return R.setItem(E.machineIdKey,M),M}e.resolveMachineId=P}),define(ee[240],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===E.HIGH_CONTRAST_DARK||R===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function P(R){return R===E.DARK||R===E.HIGH_CONTRAST_DARK}e.isDark=P}),define(ee[241],te([0,1,121,3,2,5,48,240]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var w;(function(l){function u(g){return g&&typeof g=="object"&&typeof g.id=="string"}l.isThemeColor=u})(w=e.ThemeColor||(e.ThemeColor={}));function m(l){return{id:l}}e.themeColorFromId=m;var p;(function(l){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||w.isThemeColor(o.color))}l.isThemeIcon=u;const g=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function k(o){const a=g.exec(o);if(!a)return;const[,c]=a;return{id:c}}l.fromString=k;function S(o){return{id:o}}l.fromId=S;function D(o,a){let c=o.id;const s=c.lastIndexOf("~");return s!==-1&&(c=c.substring(0,s)),a&&(c=`${c}~${a}`),{id:c}}l.modify=D;function i(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}l.getModifier=i;function r(o,a){return o.id===a.id&&o.color?.id===a.color?.id}l.isEqual=r;function n(o,a){return{id:o.id,color:a?m(a):void 0}}l.asThemeIcon=n,l.asClassNameArray=E.CSSIcon.asClassNameArray,l.asClassName=E.CSSIcon.asClassName,l.asCSSSelector=E.CSSIcon.asCSSSelector})(p=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function y(l){switch(l){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,P.toDisposable)(()=>{const g=this.a.indexOf(u);this.a.splice(g,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const h=new b;M.Registry.add(e.Extensions.ThemingContribution,h);function d(l){return h.onColorThemeChange(l)}e.registerThemingParticipant=d;class v extends P.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(g=>this.n(g)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,g){let k=this.h.getColor(u);return k&&g&&(k=g(k,this.h)),k?k.toString():null}}e.Themable=v}),define(ee[67],te([0,1,14,3,2,4,18,5,34]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",p="#1E1E1E",y="#000000",b="#FFFFFF",h="theme",d="themeBackground",v="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let l=class extends P.Disposable{constructor(g,k){super(),this.b=g,this.c=k,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return g.dark?y:b;let k=this.b.getItem(d,null);if(!k)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":k=m;break;case"hc-black":k=y;break;case"hc-light":k=b;break;default:k=p}return R.isMacintosh&&k.toUpperCase()===p&&(k="#171717"),k}saveWindowSplash(g,k){this.b.setItems([{key:h,data:k.baseTheme},{key:d,data:k.colorInfo.background},{key:v,data:k}]),typeof g=="number"&&this.f(g,k)}f(g,k){for(const S of E.BrowserWindow.getAllWindows())if(S.id===g){S.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};l=pe([_(0,w.IStateMainService),_(1,M.IConfigurationService)],l),e.ThemeMainService=l}),define(ee[115],te([0,1,3,18,5,6]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var M;(function(v){v.Http="http",v.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=y;function b(v,l,u,g){if(u===1)return!1;if(u===2&&y(l)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(k?.length===4&&parseInt(k[1])>=18)return!1}return v<1024}e.isPortPrivileged=b;class h{constructor(l,u,g){this.remoteAddress=l,this.localAddress=u,this.b=g,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let d=class{constructor(l,u){this.i=l,this.j=u,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const l=this.j.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.e=l,l?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.f=l.elevation,this.g=l.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const l=[],u=Array.from(this.d.values());for(const g of u){const k=Array.from(g.values());for(const S of k){const D=await S.value;D&&l.push(D)}}return l}async dispose(){for(const l of this.d.values()){for(const{value:u}of l.values())await u.then(g=>g?.dispose());l.clear()}this.d.clear()}setEnvironmentTunnel(l,u,g,k,S){this.o(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:g,privacy:k,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){(y(l)||p(l))&&(l=e.LOCALHOST_ADDRESSES[0]);const g=this.q(l,u);if(g)return++g.refcount,g.value}openTunnel(l,u,g,k,S=!1,D,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${k}.`),!l)return;if(u||(u="localhost"),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(l,u,g,k,S,D,i);return r?r.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.d.get(l.tunnelRemoteHost);if(u){const g=u.get(l.tunnelRemotePort);g&&(g.refcount--,await this.n(l.tunnelRemoteHost,l.tunnelRemotePort,g))}}}}async n(l,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const k=g.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(l)&&this.d.get(l).delete(u),k}}async closeTunnel(l,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const g=this.d.get(l);if(g&&g.has(u)){const k=g.get(u);k.refcount=0,await this.n(l,u,k)}}o(l,u,g){this.d.has(l)||this.d.set(l,new Map),this.d.get(l).set(u,{refcount:1,value:g})}async p(l,u){const g=this.d.get(l);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(l))}q(l,u){const g=[l];p(l)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):y(l)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const k=g.map(S=>this.d.get(S));for(const S of k){const D=S?.get(u);if(D)return D}}canTunnel(l){return!!m(l)}s(l,u,g,k,S,D,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${k}.`);const r=g;this.h.add(r);const n=k===void 0?g:k,o={elevationRequired:S?this.isPortPrivileged(n):!1},a={remoteAddress:{host:u,port:g},localAddressPort:k,privacy:D,public:D?D!==I.Private:void 0,protocol:i},c=l.forwardPort(a,o);return c?(this.o(u,g,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};d=pe([_(0,R.ILogService),_(1,t.IConfigurationService)],d),e.AbstractTunnelService=d}),define(ee[242],te([0,1,80,26,98,224,8,2,18,6,19,223,115,90,4]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(S,D,i,r,n){let o;for(let a=3;a&&(o?.dispose(),o=await new l(S,D,i,r,n).waitForReady(),!(n&&P.BROWSER_RESTRICTED_PORTS[n]||!P.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));a--);return o}class l extends I.Disposable{constructor(D,i,r,n,o){super(),this.j=i,this.k=o,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=E.createServer(),this.c=new M.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,i=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,P.findFreePortFaster)(D,2,1e3,i),n=null;return this.b.listen(r,this.j),await this.c.wait(),n=this.b.address(),n||(r=0,this.b.listen(r,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(D){D.pause();const i=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,y.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&D.write(o.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),n.end()}),D.on("close",()=>n.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),n.destroy()}),n.on("end",()=>D.end()),n.on("close",()=>D.end()),n.on("error",()=>{D.destroy()}),D.pipe(n),n.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),n.end()})}}let u=class extends b.AbstractTunnelService{constructor(D,i,r,n,o){super(i,o),this.t=D,this.u=r,this.v=n}isPortPrivileged(D){return(0,b.isPortPrivileged)(D,this.k,d.OS,t.release())}r(D,i,r,n,o,a,c){const s=this.q(i,r);if(s)return++s.refcount,s.value;if(this.e)return this.s(this.e,i,r,n,o,a,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const f={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},C=v(f,this.k,i,r,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,C),C}}};u=pe([_(1,m.ILogService),_(2,h.ISignService),_(3,p.IProductService),_(4,w.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(D,i,r,n){super(R.nodeSocketFactory,D,i,r,n)}};g=pe([_(0,m.ILogService),_(1,h.ISignService),_(2,p.IProductService),_(3,w.IConfigurationService)],g),e.TunnelService=g;let k=class extends I.Disposable{constructor(D,i,r,n){super(),this.b=D,this.c=i,this.f=r,this.g=n,this.a=new Map}async openTunnel(D,i,r,n,o,a,c,s){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${n} on local port ${o}.`),!this.a.has(D)){const f=new g(this.b,this.f,this.c,this.g);this.B(f),this.a.set(D,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(i,r,n,o,a,c,s)}};k=pe([_(0,m.ILogService),_(1,p.IProductService),_(2,h.ISignService),_(3,w.IConfigurationService)],k),e.SharedTunnelsService=k}),define(ee[49],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var P;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(P=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[243],te([0,1,4,171,66,48]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(P.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[244],te([0,1,3,49]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class P{constructor(I){this.a=I}listen(I,w){switch(w){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${w}`)}call(I,w,m){switch(w){case"checkForUpdates":return this.a.checkForUpdates(m);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(m)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=P;class R{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(w=>this.state=w),this.c.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=R}),define(ee[92],te([0,1,8,22,3,18,28,21,6,19,56,49]),function(H,e,E,t,P,R,M,I,w,m,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,v,l){return`${l.updateUrl}/api/update/${d}/${v}/${l.commit}`}e.createUpdateURL=b;let h=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,l,u,g,k,S){this.f=v,this.g=l,this.h=u,this.i=g,this.j=k,this.k=S,this.b=y.State.Uninitialized,this.c=new P.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.l(),l=this.m(v);if(!l){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(l),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(y.State.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,R.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,E.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(v){}q(){return 1}r(){}};h=pe([_(0,I.ILifecycleMainService),_(1,R.IConfigurationService),_(2,M.IEnvironmentMainService),_(3,p.IRequestService),_(4,w.ILogService),_(5,m.IProductService)],h),e.AbstractUpdateService=h}),define(ee[245],te([0,1,14,54,3,2,18,28,21,6,19,56,24,49,92]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends d.AbstractUpdateService{get v(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"error",(u,g)=>g)}get w(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(u,g,k)=>({url:g,version:k,productVersion:k}))}get y(){return P.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(u,g,k,S)=>({releaseNotes:g,version:k,productVersion:k,date:S}))}constructor(u,g,k,S,D,i,r){super(u,g,S,D,i,r),this.z=k,this.u=new R.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(h.State.Idle(1,k))}s(u){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,d.createUpdateURL)(g,u,this.k);try{E.autoUpdater.setFeedURL({url:k})}catch(S){this.j.error("Failed to set update feed URL",S);return}return k}t(u){this.d(h.State.CheckingForUpdates(u)),E.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(h.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(h.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],v.prototype,"v",null),pe([t.memoize],v.prototype,"w",null),pe([t.memoize],v.prototype,"x",null),pe([t.memoize],v.prototype,"y",null),v=pe([_(0,w.ILifecycleMainService),_(1,M.IConfigurationService),_(2,b.ITelemetryService),_(3,I.IEnvironmentMainService),_(4,y.IRequestService),_(5,m.ILogService),_(6,p.IProductService)],v),e.DarwinUpdateService=v}),define(ee[246],te([0,1,46,41,8,3,9,28,21,6,24,49]),function(H,e,E,t,P,R,M,I,w,m,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,l,u){if(this.f=v,this.g=u,this.a=y.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,l.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.State.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(v=60*60*1e3){return(0,P.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};b=pe([_(0,w.ILifecycleMainService),_(1,I.IEnvironmentMainService),_(2,m.ILogService)],b);let h=class extends b{constructor(v,l,u,g,k,S){super(u,g,k),this.o=v,this.p=l,this.q=S;const D=(0,t.watch)(M.dirname(this.o)),i=R.Event.fromNodeEventEmitter(D,"change",(a,c)=>c),r=R.Event.filter(i,a=>a==="current"),o=R.Event.debounce(r,(a,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{o.dispose(),D.close()})}m(){this.d(y.State.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((u,g)=>(0,t.realpath)(`${M.dirname(this.o)}/current`,(k,S)=>k?g(k):u(S))),l=M.basename(v);return this.p!==l}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=pe([_(2,w.ILifecycleMainService),_(3,I.IEnvironmentMainService),_(4,m.ILogService),_(5,p.ITelemetryService)],h),e.SnapUpdateService=h}),define(ee[39],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[247],te([0,1,39,192,16,20,128,3,2]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(b){this.uri=b,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let p=class{constructor(b){this.g=b,this.c=new w.DisposableStore,this.f=2**16;const h=new Map,d=v=>{let l=h.get(v.scheme);return l===void 0&&(l=b.hasProvider(v)&&!this.g.hasCapability(v,1024),h.set(v.scheme,l)),l};this.c.add(I.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(v=>{h.delete(v.scheme)})),this.extUri=new R.ExtUri(d),this.d=new M.SkipList((v,l)=>this.extUri.compare(v,l,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,R.normalizePath)(b));const h=this.d.get(b);return h?h.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new m(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((d,v)=>d[1].touch<v[1].touch?1:d[1].touch>v[1].touch?-1:0);m._clock=0,this.d.clear();const h=this.f*.5;for(let d=0;d<h;d++)this.d.set(b[d][0],b[d][1].touch())}};p=pe([_(0,P.IFileService)],p),e.UriIdentityService=p,(0,t.registerSingleton)(E.IUriIdentityService,p,1)}),define(ee[116],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[248],te([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(I){this.a=I}listen(I,w){throw new Error(`Event not found: ${w}`)}call(I,w,m){switch(w){case"handleURL":return this.a.handleURL(E.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=t;class P{constructor(I){this.a=I}handleURL(I,w){return this.a.call("handleURL",[I.toJSON(),w])}}e.URLHandlerChannelClient=P;class R{constructor(I){this.a=I}async routeCall(I,w,m,p){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(m){const y=E.URI.revive(m);if(y&&y.query){const b=/\bwindowId=(\d+)/.exec(y.query);if(b){const h=b[1],d=new RegExp(`window:${h}`),v=I.connections.find(l=>d.test(l.ctx));if(v)return v}}}return this.a.routeCall(I,w,m,p)}routeEvent(I,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=R}),define(ee[249],te([0,1,8,2,7,19]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(m,p){const y=[...this.a.values()];return(0,E.first)(y.map(b=>()=>b.handleURL(m,p)),void 0,!1).then(b=>b||!1)}registerHandler(m){return this.a.add(m),(0,t.toDisposable)(()=>this.a.delete(m))}}e.AbstractURLService=M;let I=class extends M{constructor(m){super(),this.b=m}create(m){let{authority:p,path:y,query:b,fragment:h}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&y&&y.indexOf("/")!==0&&(y=`/${y}`),P.URI.from({scheme:this.b.urlProtocol,authority:p,path:y,query:b,fragment:h})}};I=pe([_(0,R.IProductService)],I),e.NativeURLService=I}),define(ee[250],te([0,1,14,8,3,2,4,7]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(p){try{return I.URI.parse(p)}catch{return null}}class m{constructor(y,b,h,d,v){if(this.f=b,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,this.a=y,M.isWindows){const g=d.isBuilt?[]:[`"${d.appRoot}"`];g.push("--open-url","--"),E.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,g)}const l=P.Event.map(P.Event.fromNodeEventEmitter(E.app,"open-url",(g,k)=>({event:g,url:k})),({event:g,url:k})=>(g.preventDefault(),k));this.d.add(l(g=>{const k=w(g);!k||this.f.open(k,{originalUrl:g})})),h.getWindows().filter(g=>g.isReady).length>0?this.g():P.Event.once(h.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const y=[];for(const b of this.a)await this.f.open(b.uri,{originalUrl:b.url})||y.push(b);y.length!==0&&(this.a=y,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=m}),define(ee[251],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[252],te([0,1,14,2,15,7]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const w=this.b.bind(this);E.protocol.registerFileProtocol(P.Schemas.vscodeWebview,w)}b(w,m){try{const p=R.URI.parse(w.url),y=M.a.get(p.path);if(typeof y=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${y}`,h=P.FileAccess.asFileUri(b);return m({path:decodeURIComponent(h.fsPath),headers:{...P.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=M,M.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[75],te([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(p){return!!p.workspaceUri}e.isWorkspaceToOpen=t;function P(p){return!!p.folderUri}e.isFolderToOpen=P;function R(p){return!!p.fileUri}e.isFileToOpen=R;function M(p){const y=I(p),b=p.getValue("window.menuBarVisibility");return b==="default"||y==="native"&&b==="compact"||E.isMacintosh&&E.isNative?"classic":b}e.getMenuBarVisibility=M;function I(p){if(E.isWeb)return"custom";const y=p.getValue("window");if(y){if(E.isMacintosh&&y.nativeTabs===!0||E.isMacintosh&&y.nativeFullScreen===!1)return"native";const d=y.titleBarStyle;if(d==="native"||d==="custom")return d}return E.isLinux?"native":"custom"}e.getTitleBarStyle=I;function w(p){if(!E.isWindows||E.isWeb||I(p)==="native")return!1;const y=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!0}e.useWindowControlsOverlay=w;function m(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=m}),define(ee[117],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const P=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=P;var R;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(P){P[P.CLI=0]="CLI",P[P.DOCK=1]="DOCK",P[P.MENU=2]="MENU",P[P.DIALOG=3]="DIALOG",P[P.DESKTOP=4]="DESKTOP",P[P.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[253],te([0,1,14,22,3,70,2,31,73,107,6,19,30]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let d=class extends M.Disposable{constructor(l,u,g,k,S){super(),this.g=l,this.h=u,this.i=g,this.j=k,this.k=S,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const l=P.Event.fromNodeEventEmitter(E.app,"login",(u,g,k,S,D)=>({event:u,webContents:g,req:k,authInfo:S,callback:D}));this.B(l(this.m,this))}async m({event:l,authInfo:u,req:g,callback:k}){if(!u.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}l.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{S=await this.b}finally{this.b=void 0}}k(S?.username,S?.password)}async n(l){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(l);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(l){this.g.trace("auth#doResolveProxyCredentials - enter",l);const u=String((0,R.hash)({scheme:l.scheme,host:l.host,port:l.port}));let g,k;try{const r=await this.i.getPassword(this.a,u);if(r){const n=JSON.parse(await this.j.decrypt(r));g=n.username,k=n.password}}catch(r){this.g.error(r)}if(this.c!==h.StoredCredentialsUsed&&typeof g=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:g,password:k};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const D={authInfo:l,username:this.f?.username??g,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,D),this.c=h.LoginDialogShown;const i=await new Promise(r=>{const n=async(o,a,c)=>{if(a===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",n),c){const s={username:c.username,password:c.password};try{if(c.remember){const f=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,u,f)}else await this.i.deletePassword(this.a,u)}catch(f){this.g.error(f)}r({username:s.username,password:s.password})}else r(void 0)};S.win?.webContents.on("ipc-message",n)});return this.f=i,i}};d=pe([_(0,p.ILogService),_(1,b.IWindowsMainService),_(2,w.ICredentialsMainService),_(3,m.IEncryptionMainService),_(4,y.IProductService)],d),e.ProxyAuthHandler=d}),define(ee[254],te([0,1,73,6,33,19,30,204]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let w=class extends I.BaseCredentialsMainService{constructor(p,y,b,h){super(p),this.j=y,this.k=b,this.l=h,this.i=d=>{this.l.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const p=await new Promise((y,b)=>{H(["keytar"],y,b)});return await p.findCredentials("test-keytar-loads"),this.f=p,this.f}};w=pe([_(0,t.ILogService),_(1,P.INativeEnvironmentService),_(2,R.IProductService),_(3,M.IWindowsMainService)],w),e.CredentialsNativeMainService=w}),define(ee[255],te([0,1,14,25,4,7,23,18,61,5,6,116,30]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let h=class{constructor(v,l,u,g){this.a=v,this.b=l,this.c=u,this.d=g}async start(v,l){this.a.trace("Received data from other instance: ",v,l),P.isMacintosh&&E.app.focus({steal:!0});const u=this.e(v);if(u.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(g=k.ready())}g.then(()=>{for(const{uri:k,url:S}of u)this.c.open(k,{originalUrl:S})})}else return this.f(v,l)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,t.coalesce)(v._urls.map(l=>{try{return{uri:R.URI.parse(l),url:l}}catch{return null}})):[]}async f(v,l){const u=(0,w.isLaunchedFromCli)(l)?0:4;let g=[];const k=v.wait&&v.waitMarkerFilePath?R.URI.file(v.waitMarkerFilePath):void 0,S=v.remote||void 0,D={context:u,cli:v,userEnv:l,waitMarkerFileURI:k,remoteAuthority:S,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,D);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let i=!1;if(v["new-window"]||v["unity-launch"]||D.forceProfile||D.forceTempProfile)i=!0;else if(v["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!P.isMacintosh}if(i)g=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,D),g=[r]):g=await this.b.open({...D,forceEmpty:!0})}}else g=await this.b.open({...D,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(k&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,M.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};h=pe([_(0,p.ILogService),_(1,b.IWindowsMainService),_(2,y.IURLService),_(3,I.IConfigurationService)],h),e.LaunchMainService=h}),define(ee[256],te([0,1,14,2,3,6,257,8,15,99,30,82,24]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let h=class Ut extends t.Disposable{constructor(v,l,u){super(),this.n=v,this.p=l,this.r=u,this.b=String(++Ut.a),this.c=this.B(new P.Emitter),this.onStdout=this.c.event,this.f=this.B(new P.Emitter),this.onStderr=this.f.event,this.g=this.B(new P.Emitter),this.onMessage=this.g.event,this.h=this.B(new P.Emitter),this.onExit=this.h.event,this.i=this.B(new P.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(v,l){let u;switch(this.l?.correlationId?u=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${v}`:u=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${v}`,l){case y.default.Error:this.n.error(u);break;case y.default.Warning:this.n.warn(u);break;case y.default.Info:this.n.info(u);break}}t(v){if(!m.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.j){this.s("Cannot start utility process because it is already running...",y.default.Error);return}const l=this.p.getWindowById(v.responseWindowId)?.win;if(!l||l.isDestroyed()||l.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error);return}return l}start(v){const l=this.t(v);if(!l)return;this.l=v;const u=`${this.l.type}-${this.b}`,g=w.FileAccess.asFileUri("bootstrap-fork.js").fsPath,k=[...this.l.args??[],`--type=${this.l.type}`],S=this.l.execArgv,D=this.l.allowLoadingUnsignedLibraries,i="pipe";let r=this.l.env;if(r){r={...r};for(const n of Object.keys(r))r[n]=String(r[n])}this.s("creating new...",y.default.Info),this.j=m.UtilityProcess.fork(g,k,{serviceName:u,env:r,execArgv:S,allowLoadingUnsignedLibraries:D,stdio:i}),this.u(this.j,this.l,u),this.v(this.j,this.l,l)}u(v,l,u){if(v.stdout){const g=new M.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(v.stdout,"data")(k=>this.c.fire(typeof k=="string"?k:g.write(k))))}if(v.stderr){const g=new M.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(v.stderr,"data")(k=>this.f.fire(typeof k=="string"?k:g.write(k))))}this.B(P.Event.fromNodeEventEmitter(v,"message")(g=>this.g.fire(g))),this.B(P.Event.fromNodeEventEmitter(v,"spawn")(()=>{this.k=v.pid,this.s("successfully created",y.default.Info)})),this.B(P.Event.fromNodeEventEmitter(v,"exit")(g=>{this.s(`received exit event with code ${g}`,y.default.Info),this.m=!0,this.h.fire({pid:this.k,code:g,signal:"unknown"})})),this.B(P.Event.fromNodeEventEmitter(E.app,"child-process-gone",(g,k)=>({event:g,details:k}))(({details:g})=>{g.type==="Utility"&&g.name===u&&(this.s(`crashed with code ${g.exitCode} and reason '${g.reason}'`,y.default.Error),this.r.publicLog2("utilityprocesscrash",{type:l.type,reason:g.reason,code:g.exitCode}),this.i.fire({pid:this.k,code:g.exitCode,reason:g.reason}))}))}v(v,l,u){const{port1:g,port2:k}=new E.MessageChannelMain;v.postMessage("null",[k]),u.webContents.postMessage(l.responseChannel,l.responseNonce,[g])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",y.default.Info);const v=process;return typeof v._debugProcess=="function"?(v._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",y.default.Warning);return}this.s("attempting to kill the process...",y.default.Info),this.j.kill()?this.s("successfully killed the process",y.default.Info):this.s("unable to kill the process",y.default.Warning)}async waitForExit(v){if(!this.j){this.s("no running process to wait for exit",y.default.Warning);return}this.m||(this.s("waiting to exit...",y.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.timeout)(v)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",y.default.Info),this.kill()))}};h.a=0,h=pe([_(0,R.ILogService),_(1,p.IWindowsMainService),_(2,b.ITelemetryService)],h),e.UtilityProcess=h}),define(ee[258],te([0,1,13,2,3,6,21,69,46,257,8,15,44,4,35,99,256,30,24]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let k=class Nt{constructor(i,r,n,o){this.d=i,this.f=n,this.g=o,this.c=!1,this.b=new Map,r.onWillShutdown(a=>{this.c=!0,a.join(this._waitForAllExit(6e3))})}dispose(){}h(i){const r=this.b.get(i);if(!r)throw new Error("Unknown extension host!");return r}onDynamicStdout(i){return this.h(i).onStdout}onDynamicStderr(i){return this.h(i).onStderr}onDynamicMessage(i){return this.h(i).onMessage}onDynamicError(i){const r=this.h(i);return r instanceof l.UtilityProcess?P.Event.None:r.onError}onDynamicExit(i){return this.h(i).onExit}async canUseUtilityProcess(){return v.canUseUtilityProcess}async createExtensionHost(i){if(this.c)throw(0,E.canceled)();const r=String(++Nt.a);let n;if(i){if(!v.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");n=new l.UtilityProcess(this.d,this.f,this.g)}else n=new S(r,this.d);return this.b.set(r,n),n.onExit(({pid:o,code:a,signal:c})=>{this.d.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{n.dispose(),this.b.delete(r)})}),{id:r}}async start(i,r){if(this.c)throw(0,E.canceled)();return this.h(i).start({...r,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:r.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:i})}async enableInspectPort(i){if(this.c)throw(0,E.canceled)();const r=this.b.get(i);return r?r.enableInspectPort():!1}async kill(i){if(this.c)throw(0,E.canceled)();const r=this.b.get(i);!r||r.kill()}async _killAllNow(){for(const[,i]of this.b)i.kill()}async _waitForAllExit(i){const r=[];for(const[,n]of this.b)r.push(n.waitForExit(i));return p.Promises.settled(r).then(()=>{})}};k.a=0,k=pe([_(0,R.ILogService),_(1,M.ILifecycleMainService),_(2,u.IWindowsMainService),_(3,g.ITelemetryService)],k),e.ExtensionHostStarter=k;let S=class extends t.Disposable{constructor(i,r){super(),this.id=i,this.c=r,this._onStdout=this.B(new P.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new P.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new P.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new P.Emitter),this.onError=this._onError.event,this._onExit=this.B(new P.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(i){h.isCI&&this.c.info("Calling fork to start extension host...");const r=I.StopWatch.create(!1);this.a=(0,w.fork)(y.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,d.cwd)()},i));const n=r.elapsed(),o=this.a.pid;this.c.info(`Starting extension host with pid ${o} (fork() took ${n} ms).`);const a=new m.StringDecoder("utf-8");this.a.stdout?.on("data",s=>{const f=typeof s=="string"?s:a.write(s);this._onStdout.fire(f)});const c=new m.StringDecoder("utf-8");this.a.stderr?.on("data",s=>{const f=typeof s=="string"?s:c.write(s);this._onStderr.fire(f)}),this.a.on("message",s=>{this._onMessage.fire(s)}),this.a.on("error",s=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(s)})}),this.a.on("exit",(s,f)=>{this.b=!0,this._onExit.fire({pid:o,code:s,signal:f})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):h.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(i){if(!this.a)return;const r=this.a.pid;this.c.info(`Waiting for extension host with pid ${r} to exit.`),await Promise.race([P.Event.toPromise(this.onExit),(0,p.timeout)(i)]),this.b||(this.c.info(`Extension host with pid ${r} did not exit within ${i}ms.`),this.a.kill())}};S=pe([_(1,R.ILogService)],S)}),define(ee[259],te([0,1,14,3,2,252,30]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends P.Disposable{constructor(m){super(),this.b=m,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,p){let y;if(typeof m.windowId=="number"){const{windowId:b}=m,h=this.b.getWindowById(b);if(!h?.win)throw new Error(`Invalid windowId: ${b}`);y=h.win.webContents}else{const{webContentsId:b}=m;if(y=E.webContents.fromId(b),!y)throw new Error(`Invalid webContentsId: ${b}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(p)}async findInFrame(m,p,y,b){const d=this.c(m,p);if(typeof d.findInFrame=="function"){d.findInFrame(y,{findNext:b.findNext,forward:b.forward});const v=(l,u)=>{u.finalUpdate&&(this.a.fire(u),d.removeListener("found-in-frame",v))};d.on("found-in-frame",v)}}async stopFindInFrame(m,p,y){const h=this.c(m,p);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(m,p){const y=this.b.getWindowById(m.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${m}`);const b=y.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===p);if(!b)throw new Error(`Unknown frame: ${p}`);return b}};I=pe([_(0,M.IWindowsMainService)],I),e.WebviewMainService=I}),define(ee[260],te([0,1,8,3,2]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends P.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:w,getActiveWindowId:m}){super(),this.a=this.B(new P.DisposableStore),t.Event.latch(t.Event.any(I,w))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>m()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(ee[29],te([0,1,175,9,60,20,7,5,15]),function(H,e,E,t,P,R,M,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function m(n){const o=n;return typeof o?.id=="string"&&M.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=m;function p(n){return typeof n?.id=="string"&&!m(n)&&!b(n)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=y;function b(n){const o=n;return typeof o?.id=="string"&&M.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=b;function h(n){const o=n;if(o?.uri)return{id:o.id,uri:M.URI.revive(o.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:M.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=h;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=v;function l(n){const o=n;return!!(o&&typeof o=="object"&&M.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=l;class u{constructor(o,a,c,s,f){this.h=o,this.j=c,this.k=s,this.l=f,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(o,a){this.raw=a,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function k(n){return new g({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(n,o){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function D(n){let o;return M.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=D;function i(n,o){return!S(n,o)&&!D(n)}e.isSavedWorkspace=i;function r(n){return(typeof n=="string"?(0,t.extname)(n):(0,R.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ee[57],te([0,1,14,8,70,36,2,78,4,11,23,152,5,6,29]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let v=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,g){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},g)}pickFolder(u,g){return this.e({...u,pickFolders:!0,title:(0,y.localize)(1,null)},g)}pickFile(u,g){return this.e({...u,pickFiles:!0,title:(0,y.localize)(2,null)},g)}pickWorkspace(u,g){const k=(0,y.localize)(3,null),S=(0,R.mnemonicButtonLabel)((0,y.localize)(4,null)),D=d.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:k,filters:D,buttonLabel:S},g)}async e(u,g){const k={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(k.properties=void 0,u.pickFiles&&u.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&k.properties.push("treatPackageAsDirectory");const S=await this.showOpenDialog(k,(0,m.withNullAsUndefined)(g||E.BrowserWindow.getFocusedWindow()));if(S&&S.filePaths&&S.filePaths.length>0)return S.filePaths}f(u){if(u){let g=this.b.get(u.id);return g||(g=new t.Queue,this.b.set(u.id,g)),g}else return this.c}showMessageBox(u,g){return this.f(g).queue(async()=>g?E.dialog.showMessageBox(g,u):E.dialog.showMessageBox(u))}async showSaveDialog(u,g){const k=this.i(u,g);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(g).queue(async()=>{let S;return g?S=await E.dialog.showSaveDialog(g,u):S=await E.dialog.showSaveDialog(u),S.filePath=this.g(S.filePath),S})}finally{(0,M.dispose)(k)}}g(u){return u&&w.isMacintosh&&(u=(0,I.normalizeNFC)(u)),u}h(u){return u.map(g=>this.g(g))}async showOpenDialog(u,g){u.defaultPath&&(await p.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const k=this.i(u,g);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(g).queue(async()=>{let S;return g?S=await E.dialog.showOpenDialog(g,u):S=await E.dialog.showOpenDialog(u),S.filePaths=this.h(S.filePaths),S})}finally{(0,M.dispose)(k)}}i(u,g){if(!g)return M.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let k=this.a.get(g.id);k||(k=new Set,this.a.set(g.id,k));const S=(0,P.hash)(u);if(!k.has(S))return this.d.trace("[DialogMainService]: new file dialog lock created",u),k.add(S),(0,M.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),k?.delete(S),k?.size===0&&this.a.delete(g.id)})}};v=pe([_(0,h.ILogService)],v),e.DialogMainService=v}),define(ee[261],te([0,1,3,2,71,29]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(w,m){super(),this.f=w,this.g=m,this.b=this.B(new E.Emitter),this.c=new Map,this.h(m.applicationStorage,this.b)}h(w,m){this.B(E.Event.debounce(w.onDidChangeStorage,(p,y)=>(p?p.push(y):p=[y],p),M.a)(p=>{p.length&&m.fire(this.i(p,w))}))}i(w,m){const p=new Map,y=new Set;return w.forEach(b=>{const h=m.get(b.key);typeof h=="string"?p.set(b.key,h):y.add(b.key)}),{changed:Array.from(p.entries()),deleted:Array.from(y.values())}}listen(w,m,p){switch(m){case"onDidChangeStorage":{const y=p.profile?(0,P.revive)(p.profile):void 0;if(!y)return this.b.event;let b=this.c.get(y.id);return b||(b=this.B(new E.Emitter),this.h(this.g.profileStorage(y),b),this.c.set(y.id,b)),b.event}}throw new Error(`Event not found: ${m}`)}async call(w,m,p){const y=p.profile?(0,P.revive)(p.profile):void 0,b=(0,R.reviveIdentifier)(p.workspace),h=await this.j(y,b);switch(m){case"getItems":return Array.from(h.items.entries());case"updateItems":{const d=p;if(d.insert)for(const[v,l]of d.insert)h.set(v,l);d.delete?.forEach(v=>h.delete(v));break}case"isUsed":{const d=p.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${m}`)}}async j(w,m){let p;m?p=this.g.workspaceStorage(m):w?p=this.g.profileStorage(w):p=this.g.applicationStorage;try{await p.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${m?"workspace":w?"profile":"application"} storage due to ${y}`)}return p}}e.StorageDatabaseChannel=M,M.a=100}),define(ee[37],te([0,1,70,3,2,20,7,172,33,16,5,6,29,40,39,8,31,27,11]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function k(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&M.URI.isUri(o.location)&&M.URI.isUri(o.globalStorageHome)&&M.URI.isUri(o.settingsResource)&&M.URI.isUri(o.keybindingsResource)&&M.URI.isUri(o.tasksResource)&&M.URI.isUri(o.snippetsHome)&&M.URI.isUri(o.extensionsResource))}e.isUserDataProfile=k,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function S(n,o){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:M.URI.revive(n.location).with({scheme:o}),globalStorageHome:M.URI.revive(n.globalStorageHome).with({scheme:o}),settingsResource:M.URI.revive(n.settingsResource).with({scheme:o}),keybindingsResource:M.URI.revive(n.keybindingsResource).with({scheme:o}),tasksResource:M.URI.revive(n.tasksResource).with({scheme:o}),snippetsHome:M.URI.revive(n.snippetsHome).with({scheme:o}),extensionsResource:M.URI.revive(n.extensionsResource)?.with({scheme:o}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=S;function D(n,o,a,c){return{id:n,name:o,location:a,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(a,"globalStorage"),settingsResource:(0,R.joinPath)(a,"settings.json"),keybindingsResource:(0,R.joinPath)(a,"keybindings.json"),tasksResource:(0,R.joinPath)(a,"tasks.json"),snippetsHome:(0,R.joinPath)(a,"snippets"),extensionsResource:(0,R.joinPath)(a,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=D;let i=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,a,c,s){super(),this.m=o,this.n=a,this.r=c,this.s=s,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const f of this.G()){if(!f.name||!(0,g.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}o.push(D((0,R.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}const a=new h.ResourceMap,c=new Map,s=D((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),o.length){const f=this.I();if(f.workspaces)for(const[C,L]of Object.entries(f.workspaces)){const O=M.URI.parse(C),j=M.URI.parse(L),K=o.find(V=>this.r.extUri.isEqual(V.location,j));K&&a.set(O,K)}if(f.emptyWindows)for(const[C,L]of Object.entries(f.emptyWindows)){const O=M.URI.parse(L),j=o.find(K=>this.r.extUri.isEqual(K.location,O));j&&c.set(C,j)}}this.t={profiles:o,workspaces:a,emptyWindows:c}}return this.t}async createTransientProfile(o){const a="Temp",c=new RegExp(`${(0,u.escapeRegExpCharacters)(a)}\\s(\\d+)`);let s=0;for(const C of this.profiles){const L=c.exec(C.name),O=L?parseInt(L[1]):0;s=O>s?O:s}const f=`${a} ${s+1}`;return this.createProfile((0,E.hash)((0,l.generateUuid)()).toString(16),f,{transient:!0},o)}async createNamedProfile(o,a,c){return this.createProfile((0,E.hash)((0,l.generateUuid)()).toString(16),o,a,c)}async createProfile(o,a,c,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.v(o,a,c);return s&&await this.setProfileForWorkspace(s,f),f}async v(o,a,c){if(!(0,g.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(a);return s||(s=(async()=>{try{const f=this.profiles.find(O=>O.name===a||O.id===o);if(f)return f;const C=D(o,a,(0,R.joinPath)(this.profilesHome,o),c);await this.n.createFolder(C.location);const L=[];return this.h.fire({profile:C,join(O){L.push(O)}}),await v.Promises.settled(L),this.z([C],[],[]),C}finally{this.k.delete(a)}})(),this.k.set(a,s)),s}async updateProfile(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(s=>s.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);return c=D(c.id,a.name??c.name,c.location,{shortName:a.shortName??c.shortName,transient:a.transient??c.isTransient,useDefaultFlags:a.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(s=>s.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);const c=[];this.i.fire({profile:a,join(s){c.push(s)}});try{await Promise.allSettled(c)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])a.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(s=>s.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);this.D(o,c)}unsetWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(o,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(a=>a.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(a=>!this.y(a));await Promise.allSettled(o.map(a=>this.removeProfile(a)))}getProfileForWorkspace(o){const a=this.w(o);return M.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindows.get(a)??this.u.emptyWindows.get(a)}w(o){return(0,b.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,b.isWorkspaceIdentifier)(o)?o.configPath:o.id}y(o){return!!([...this.l.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.u.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location)))}z(o,a,c){const s=[...this.profiles,...o],f=[];this.l.profiles=[];for(let C of s)C.isDefault||a.some(L=>C.id===L.id)||(C=c.find(L=>C.id===L.id)??C,C.isTransient?this.l.profiles.push(C):f.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.H(f),this.t=void 0,this.C(o,a,c)}C(o,a,c){this.g.fire({added:o,removed:a,updated:c,all:this.profiles})}D(o,a,c){c=a?.isTransient?!0:c,c||this.D(o,void 0,!0);const s=this.w(o),f=c?this.l:this.u;M.URI.isUri(s)?(f.workspaces.delete(s),a&&f.workspaces.set(s,a)):(f.emptyWindows.delete(s),a&&f.emptyWindows.set(s,a)),c||this.F()}F(){const o={};for(const[c,s]of this.u.workspaces.entries())o[c.toString()]=s.location.toString();const a={};for(const[c,s]of this.u.emptyWindows.entries())a[c.toString()]=s.location.toString();this.J({workspaces:o,emptyWindows:a}),this.t=void 0}G(){return[]}H(o){throw new Error("not implemented")}I(){return{}}J(o){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([_(0,w.IEnvironmentService),_(1,m.IFileService),_(2,d.IUriIdentityService),_(3,y.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(o){this.a=o}I(){return this.O}J(o){this.O=o}}e.InMemoryUserDataProfilesService=r}),define(ee[76],te([0,1,8,17,2,3,40,7,112,89,16,5,6,37,39,11,13,24]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class k extends Error{constructor(n,o){super(n),this.code=o}}e.ExtensionsProfileScanningError=k,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let S=class extends P.Disposable{constructor(n,o,a,c,s,f){super(),this.h=n,this.i=o,this.j=a,this.k=c,this.l=s,this.m=f,this.a=this.B(new R.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new R.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new M.ResourceMap}scanProfileExtensions(n,o){return this.n(n,void 0,o)}async addExtensionsToProfile(n,o){const a=[],c=[];try{return await this.n(o,s=>{const f=[];for(const C of s)n.some(([L])=>(0,w.areSameExtensions)(L.identifier,C.identifier)&&L.manifest.version!==C.version)?a.push(C):f.push(C);for(const[C,L]of n)if(!f.some(O=>(0,w.areSameExtensions)(O.identifier,C.identifier)&&O.version===C.manifest.version)){const O={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:L};c.push(O),f.push(O)}return c.length&&this.a.fire({extensions:c,profileLocation:o}),a.length&&this.c.fire({extensions:a,profileLocation:o}),f}),c.length&&this.b.fire({extensions:c,profileLocation:o}),a.length&&this.f.fire({extensions:a,profileLocation:o}),c}catch(s){throw c.length&&this.b.fire({extensions:c,error:s,profileLocation:o}),a.length&&this.f.fire({extensions:a,error:s,profileLocation:o}),s}}async removeExtensionFromProfile(n,o){const a=[];this.c.fire({extensions:a,profileLocation:o});try{await this.n(o,c=>{const s=[];for(const f of c)(0,w.areSameExtensions)(f.identifier,n.identifier)?a.push(f):s.push(f);return a.length&&this.c.fire({extensions:a,profileLocation:o}),s}),a.length&&this.f.fire({extensions:a,profileLocation:o})}catch(c){throw a.length&&this.f.fire({extensions:a,error:c,profileLocation:o}),c}}async n(n,o,a){return this.v(n).queue(async()=>{let c=[],s;try{const f=await this.i.readFile(n);s=JSON.parse(f.value.toString())}catch(f){if((0,p.toFileOperationResult)(f)!==1)throw f;if(this.k.extUri.isEqual(n,this.j.defaultProfile.extensionsResource)&&(s=await this.u()),!s&&a?.bailOutWhenFileNotFound)throw new k((0,l.getErrorMessage)(f),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.p(n);let f=!1;for(const C of s){D(C)||this.p(n);let L;if((0,v.isString)(C.location))L=this.s(C.location);else{L=I.URI.revive(C.location);const O=this.r(L);O&&(f=!0,C.location=O)}c.push({identifier:C.identifier,location:L,version:C.version,metadata:C.metadata})}f&&await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(s)))}if(o){c=o(c);const f=c.map(C=>({identifier:C.identifier,version:C.version,location:this.r(C.location)??C.location.toJSON(),metadata:C.metadata}));await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(f)))}return c})}p(n){const o=new k(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:o.code}),o}r(n){return this.k.extUri.isEqualOrParent(n,this.h)?this.k.extUri.relativePath(this.h,n):void 0}s(n){return this.k.extUri.joinPath(this.h,n)}async u(){return this.t||(this.t=(async()=>{const n=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let o;try{o=(await this.i.readFile(n)).value.toString()}catch(c){if((0,p.toFileOperationResult)(c)===1)return;throw c}this.m.info("Migrating extensions from old default profile location",n.toString());let a;try{const c=JSON.parse(o);Array.isArray(c)&&c.every(s=>D(s))?a=c:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.m.error(c)}if(a)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",n.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(c){if((0,p.toFileOperationResult)(c)===3)this.m.info("Migration from old default profile location to new location is done by another window",n.toString(),this.j.defaultProfile.extensionsResource.toString());else throw c}try{await this.i.del(n)}catch(c){(0,p.toFileOperationResult)(c)!==1&&this.m.error(c)}return a})()),this.t}v(n){let o=this.g.get(n);return o||(o=new E.Queue,this.g.set(n,o)),o}};S=pe([_(1,p.IFileService),_(2,h.IUserDataProfilesService),_(3,d.IUriIdentityService),_(4,u.ITelemetryService),_(5,b.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function D(r){return(0,v.isObject)(r)&&(0,m.isIExtensionIdentifier)(r.identifier)&&(i(r.location)||(0,v.isString)(r.location))&&r.version&&(0,v.isString)(r.version)}function i(r){return r?(0,v.isString)(r.path)&&(0,v.isString)(r.scheme):!1}}),define(ee[118],te([0,1,25,8,44,17,13,43,138,2,15,9,4,20,190,82,11,7,157,33,112,89,189,16,5,6,19,3,71,76,37,39,187,188]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n,o,a,c,s,f,C,L,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ge){function q(T,U){if(T===U)return!0;const z=Object.keys(T),Q=new Set;for(const ne of Object.keys(U))Q.add(ne);if(z.length!==Q.size)return!1;for(const ne of z){if(T[ne]!==U[ne])return!1;Q.delete(ne)}return Q.size===0}ge.equals=q})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let V=class extends m.Disposable{constructor(q,T,U,z,Q,ne,x,A,F,W,N,$){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=T,this.l=U,this.m=z,this.n=Q,this.p=ne,this.r=x,this.s=A,this.t=F,this.u=W,this.v=N,this.w=$,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(se,(0,h.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(se,(0,h.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(re,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(q,T,U){const[z,Q]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(T)]),ne=U?await this.scanExtensionsUnderDevelopment(q,[...z,...Q]):[];return this.F(z,Q,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const T=[];T.push(this.G(!!q.useCache,q.language)),T.push(this.H(q.language,!!q.checkControlFile));const[U,z]=await Promise.all(T);return this.D([...U,...z],0,q,!1)}async scanUserExtensions(q){const T=q.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",T);const U=this.v.extUri.isEqual(q.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(T,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,U),Q=q.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ne;try{ne=await Q.scanExtensions(z)}catch(x){if(x instanceof f.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ne=await Q.scanExtensions(z);else throw x}return ne=await this.D(ne,1,q,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(q,T){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===p.Schemas.file).map(async z=>{const Q=await this.J(z,!1,1,!0,q.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Q)).map(x=>(x.type=T.find(A=>(0,S.areSameExtensions)(A.identifier,x.identifier))?.type??x.type,this.k.validate(x,Q)))}))).flat();return this.D(U,"development",q,!0)}return[]}async scanExistingExtension(q,T,U){const z=await this.J(q,!1,T,!0,U.language,!0,void 0),Q=await this.k.scanExtension(z);return!Q||!U.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(q,T,U){const z=await this.J(q,!1,T,!0,U.language,!0,void 0),Q=await this.k.scanOneOrMultipleExtensions(z);return this.D(Q,T,U,!0)}async scanMetadata(q){const T=(0,h.joinPath)(q,"package.json"),U=(await this.r.readFile(T)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(q,T){const U=(0,h.joinPath)(q,"package.json"),z=(await this.r.readFile(U)).value.toString(),Q=JSON.parse(z);T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...T},await this.r.writeFile((0,h.joinPath)(q,"package.json"),R.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof f.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw q}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.p.addExtensionsToProfile(q.map(T=>[T,T.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(T){(0,r.toFileOperationResult)(T)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(T))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.s.error(q)}finally{this.z=void 0}})()),this.z}async D(q,T,U,z){return U.includeAllVersions||(q=this.F(T===0?q:void 0,T===1?q:void 0,T==="development"?q:void 0,await this.getTargetPlatform(),z)),U.includeInvalid||(q=q.filter(Q=>Q.isValid)),q.sort((Q,ne)=>{const x=y.basename(Q.location.fsPath),A=y.basename(ne.location.fsPath);return x<A?-1:x>A?1:0})}F(q,T,U,z,Q){const ne=(A,F,W)=>{if(A.isValid&&!F.isValid)return!1;if(A.isValid===F.isValid){if(Q&&d.gt(A.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${A.location.path} with version ${A.manifest.version}`),!1;if(d.eq(A.manifest.version,F.manifest.version)){if(A.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${A.location.path} with same version`),!1;if(A.targetPlatform===z)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${A.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${A.location.path} with ${F.location.path}.`),!0},x=new Map;return q?.forEach(A=>{const F=D.ExtensionIdentifier.toKey(A.identifier.id),W=x.get(F);(!W||ne(W,A,!1))&&x.set(F,A)}),T?.forEach(A=>{const F=D.ExtensionIdentifier.toKey(A.identifier.id),W=x.get(F);if(!W&&q&&A.type===0){this.s.debug(`Skipping obsolete system extension ${A.location.path}.`);return}(!W||ne(W,A,!1))&&x.set(F,A)}),U?.forEach(A=>{const F=D.ExtensionIdentifier.toKey(A.identifier.id),W=x.get(F);(!W||ne(W,A,!0))&&x.set(F,A),x.set(F,A)}),[...x.values()]}async G(q,T){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,T,!0,void 0),Q=await(q&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(q,T){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const z=T?await this.I():{},Q=[],ne=u.URI.file(y.normalize(y.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const A of U){const F=z[A.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":Q.push((0,h.joinPath)(ne,A.name));break;default:Q.push(u.URI.file(F));break}}const x=await Promise.all(Q.map(async A=>this.k.scanExtension(await this.J(A,!1,0,!0,q,!0,void 0))));return this.s.trace("Scanned dev system extensions:",x.length),(0,E.coalesce)(x)}async I(){try{const q=await this.r.readFile(this.l);return JSON.parse(q.value.toString())}catch{return{}}}async J(q,T,U,z,Q,ne,x){const A=await this.f(Q??b.language),F=await this.L(q),W=T&&!this.v.extUri.isEqual(q,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,N=W?await this.L(W):void 0;return new J(q,F,W,N,T,x,U,z,ne,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,A)}async L(q){try{const T=await this.r.stat(q);if(typeof T.mtime=="number")return T.mtime}catch{}}};V=pe([_(4,C.IUserDataProfilesService),_(5,f.IExtensionsProfileScannerService),_(6,r.IFileService),_(7,o.ILogService),_(8,k.IEnvironmentService),_(9,a.IProductService),_(10,L.IUriIdentityService),_(11,n.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class J{constructor(q,T,U,z,Q,ne,x,A,F,W,N,$,G,B,X){this.location=q,this.mtime=T,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=z,this.profile=Q,this.profileScanOptions=ne,this.type=x,this.excludeObsolete=A,this.validate=F,this.productVersion=W,this.productDate=N,this.productCommit=$,this.devMode=G,this.language=B,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,T){return(0,h.isEqual)(q.location,T.location)&&q.mtime===T.mtime&&(0,h.isEqual)(q.applicationExtensionslocation,T.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===T.applicationExtensionslocationMtime&&q.profile===T.profile&&P.equals(q.profileScanOptions,T.profileScanOptions)&&q.type===T.type&&q.excludeObsolete===T.excludeObsolete&&q.validate===T.validate&&q.productVersion===T.productVersion&&q.productDate===T.productDate&&q.productCommit===T.productCommit&&q.devMode===T.devMode&&q.language===T.language&&K.equals(q.translations,T.translations)}}e.ExtensionScannerInput=J;let re=class extends m.Disposable{constructor(q,T,U,z,Q){super(),this.f=q,this.g=T,this.h=U,this.i=z,this.j=Q}async scanExtensions(q){const T=q.profile?await this.l(q):await this.k(q);let U={};if(q.excludeObsolete&&q.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(z)}catch{}return(0,l.isEmptyObject)(U)?T:T.filter(z=>!U[S.ExtensionKey.create(z).toString()])}async k(q){const T=await this.i.resolve(q.location);if(!T.children?.length)return[];const U=await Promise.all(T.children.map(async z=>{if(!z.isDirectory||q.type===1&&(0,h.basename)(z.resource).indexOf(".")===0)return null;const Q=new J(z.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(U).sort((z,Q)=>z.location.path<Q.location.path?-1:1)}async l(q){let T=await this.m(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){T=T.filter(z=>!z.metadata?.isApplicationScoped);const U=await this.m(q.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,q);T.push(...U)}return T}async m(q,T,U){const z=await this.g.scanProfileExtensions(q,U.profileScanOptions);if(!z.length)return[];const Q=await Promise.all(z.map(async ne=>{if(T(ne)){const x=new J(ne.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(x,ne.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions(q){try{if(await this.i.exists((0,h.joinPath)(q.location,"package.json"))){const T=await this.scanExtension(q);return T?[T]:[]}else return await this.scanExtensions(q)}catch(T){return this.j.error(`Error scanning extensions at ${q.location.path}:`,(0,M.getErrorMessage)(T)),[]}}async scanExtension(q,T){try{let U=await this.scanExtensionManifest(q.location);if(U){U.publisher||(U.publisher=D.UNDEFINED_PUBLISHER),T=T??U.__metadata,delete U.__metadata;const z=(0,S.getGalleryExtensionId)(U.publisher,U.name),Q=T?.id?{id:z,uuid:T.id}:{id:z},ne=T?.isSystem?0:q.type,x=ne===0||!!T?.isBuiltin;j.ImplicitActivationEvents.updateManifest(U),U=await this.n(q.location,U,J.createNlsConfiguration(q));const A={type:ne,identifier:Q,manifest:U,location:q.location,isBuiltin:x,targetPlatform:T?.targetPlatform??"undefined",metadata:T,isValid:!0,validations:[]};return q.validate?this.validate(A,q):A}}catch(U){q.type!==0&&this.j.error(U)}return null}validate(q,T){let U=!0;const z=(0,i.validateExtensionManifest)(T.productVersion,T.productDate,T.location,q.manifest,q.isBuiltin);for(const[Q,ne]of z)Q===v.default.Error&&(U=!1,this.j.error(this.t(T.location,ne)));return q.isValid=U,q.validations=z,q}async scanExtensionManifest(q){const T=(0,h.joinPath)(q,"package.json");let U;try{U=(await this.i.readFile(T)).value.toString()}catch(Q){return(0,r.toFileOperationResult)(Q)!==1&&this.j.error(this.t(q,(0,g.localize)(0,null,T.path,Q.message))),null}let z;try{z=JSON.parse(U)}catch{const ne=[];(0,I.parse)(U,ne);for(const x of ne)this.j.error(this.t(q,(0,g.localize)(1,null,T.path,x.offset,x.length,(0,w.getParseErrorMessage)(x.error))));return null}return(0,I.getNodeType)(z)!=="object"?(this.j.error(this.t(q,(0,g.localize)(2,null,T.path))),null):z}async n(q,T,U){const z=await this.p(q,T,U);if(z)try{const Q=[],ne=await this.r(z.default,Q);if(Q.length>0)return Q.forEach(A=>{this.j.error(this.t(q,(0,g.localize)(3,null,z.default?.path,(0,w.getParseErrorMessage)(A.error))))}),T;if((0,I.getNodeType)(z)!=="object")return this.j.error(this.t(q,(0,g.localize)(4,null,z.default?.path))),T;const x=z.values||Object.create(null);return(0,O.localizeManifest)(T,x,ne)}catch{}return T}async p(q,T,U){const z=(0,h.joinPath)(q,"package.nls.json"),Q=(F,W)=>{W.forEach(N=>{this.j.error(this.t(q,(0,g.localize)(5,null,F?.path,(0,w.getParseErrorMessage)(N.error))))})},ne=F=>{this.j.error(this.t(q,(0,g.localize)(6,null,F?.path)))},x=`${T.publisher}.${T.name}`,A=U.translations[x];if(A)try{const F=u.URI.file(A),W=(await this.i.readFile(F)).value.toString(),N=[],$=(0,I.parse)(W,N);return N.length>0?(Q(F,N),{values:void 0,default:z}):(0,I.getNodeType)($)!=="object"?(ne(F),{values:void 0,default:z}):{values:$.contents?$.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let W;try{W=await this.s(q,U)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const N=(await this.i.readFile(W.localized)).value.toString(),$=[],G=(0,I.parse)(N,$);return $.length>0?(Q(W.localized,$),{values:void 0,default:W.original}):(0,I.getNodeType)(G)!=="object"?(ne(W.localized),{values:void 0,default:W.original}):{values:G,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(q,T){if(q)try{const U=(await this.i.readFile(q)).value.toString();return(0,I.parse)(U,T)}catch{}}s(q,T){return new Promise((U,z)=>{const Q=ne=>{const x=(0,h.joinPath)(q,`package.nls.${ne}.json`);this.i.exists(x).then(A=>{A&&U({localized:x,original:(0,h.joinPath)(q,"package.nls.json")});const F=ne.lastIndexOf("-");F===-1?U({localized:(0,h.joinPath)(q,"package.nls.json"),original:null}):(ne=ne.substring(0,F),Q(ne))})};if(T.devMode||T.pseudo||!T.language)return U({localized:(0,h.joinPath)(q,"package.nls.json"),original:null});Q(T.language)})}t(q,T){return`[${q.path}]: ${T}`}};re=pe([_(1,f.IExtensionsProfileScannerService),_(2,L.IUriIdentityService),_(3,r.IFileService),_(4,o.ILogService)],re);let se=class extends re{constructor(q,T,U,z,Q,ne){super(T,U,z,Q,ne),this.y=q,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(q){const T=await this.z();if(this.u=q,T&&T.input&&J.equals(T.input,this.u))return this.j.debug("Using cached extensions scan result",q.location.toString()),this.v.trigger(()=>this.D()),T.result.map(z=>(z.location=u.URI.revive(z.location),z));const U=await super.scanExtensions(q);return await this.C({input:q,result:U}),U}async z(){try{const q=await this.i.readFile(this.y),T=JSON.parse(q.value.toString());return{result:T.result,input:(0,s.revive)(T.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,M.getErrorMessage)(q))}return null}async C(q){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(q)))}catch(T){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,M.getErrorMessage)(T))}}async D(){if(!this.u)return;const q=await this.z();if(!q)return;const T=q.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(U,T))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};se=pe([_(2,f.IExtensionsProfileScannerService),_(3,L.IUriIdentityService),_(4,r.IFileService),_(5,o.ILogService)],se);function ae(ge,q){const T=(0,S.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:T,identifier:new D.ExtensionIdentifier(T),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:q,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ae;class fe extends V{constructor(q,T,U,z,Q,ne,x,A,F,W,N,$){super(q,T,(0,h.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(z,D.MANIFEST_CACHE_FOLDER),Q,ne,x,A,F,W,N,$),this.M=(async()=>{if(b.translationsConfigFile)try{const G=await this.r.readFile(u.URI.file(b.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(q){return this.M}}e.NativeExtensionsScannerService=fe}),define(ee[262],te([0,1,6,37,39,24,76,16,33,7]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=class extends M.AbstractExtensionsProfileScannerService{constructor(b,h,d,v,l,u){super(m.URI.file(b.extensionsPath),h,d,v,l,u)}};p=pe([_(0,w.INativeEnvironmentService),_(1,I.IFileService),_(2,t.IUserDataProfilesService),_(3,P.IUriIdentityService),_(4,R.ITelemetryService),_(5,E.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(ee[263],te([0,1,7,33,76,118,16,5,6,19,39,37]),function(H,e,E,t,P,R,M,I,w,m,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends R.NativeExtensionsScannerService{constructor(d,v,l,u,g,k,S,D){super(E.URI.file(g.builtinExtensionsPath),E.URI.file(g.extensionsPath),g.userHome,E.URI.file(g.userDataPath),d,v,l,u,g,k,S,D)}};b=pe([_(0,y.IUserDataProfilesService),_(1,P.IExtensionsProfileScannerService),_(2,M.IFileService),_(3,w.ILogService),_(4,t.INativeEnvironmentService),_(5,m.IProductService),_(6,p.IUriIdentityService),_(7,I.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ee[264],te([0,1,14,2,15,9,4,60,7,31,42,33,6,37]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends t.Disposable{constructor(l,u,g){super(),this.c=l,this.f=g,this.a=I.TernarySearchTree.forPaths(!M.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(l.appRoot),this.addValidFileRoot(l.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(l.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:l}=E.session;l.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(u,g)=>this.i(u,g)),l.protocol.interceptFileProtocol(P.Schemas.file,(u,g)=>this.h(u,g)),this.B((0,t.toDisposable)(()=>{l.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),l.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(l){const u=(0,R.normalize)(l);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(l,u){const g=w.URI.parse(l.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${P.Schemas.file}: protocol (original URL: ${l.url})`),u({error:-3})}i(l,u){const g=this.j(l);let k;return this.c.crossOriginIsolated&&((0,R.basename)(g)==="workbench.html"||(0,R.basename)(g)==="workbench-dev.html"?k=P.COI.CoopAndCoep:k=P.COI.getHeadersFromQuery(l.url)),this.a.findSubstr(g)?u({path:g,headers:k}):this.b.has((0,R.extname)(g).toLowerCase())?u({path:g}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${l.url})`),u({error:-3}))}j(l){const u=w.URI.parse(l.url),g=P.FileAccess.uriToFileUri(u);return(0,R.normalize)(g.fsPath)}createIPCObjectUrl(){let l;const u=w.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),g=u.toString(),k=async()=>l;return p.validatedIpcMain.handle(g,k),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:u,update:S=>l=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),p.validatedIpcMain.removeHandler(g)}}}};d=pe([_(0,y.INativeEnvironmentService),_(1,h.IUserDataProfilesService),_(2,b.ILogService)],d),e.ProtocolMainService=d}),define(ee[265],te([0,1,14,42,8,3,2,15,11,104,28,21,6,64,65,67,45,37,38]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let k=class extends M.Disposable{constructor(D,i,r,n,o,a,c,s,f){super(),this.g=D,this.h=i,this.i=r,this.j=n,this.k=o,this.l=a,this.m=c,this.n=s,this.p=f,this.a=new P.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(D,i)=>this.s(D,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(D,i)=>this.t(D,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(D,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect();if(D.sender.isDestroyed())return r.close();D.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[r])}t(D,i){this.l.trace("SharedProcess: onWorkerConnection",i);const r=new M.DisposableStore,n=a=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${a}')`,i),r.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},o=E.BrowserWindow.fromId(i.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}r.add(R.Event.filter(this.k.onWillLoadWindow,a=>a.window.win===o)(()=>n("load"))),r.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>n("closed"))),o.webContents.postMessage(i.reply.channel,i.reply.nonce,D.ports)}u(){const D=this.b;!D||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(D.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{D.close()}catch{}this.b=void 0},0))}v(D,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${D}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(D,...i)}catch(r){this.l.warn(`Error sending IPC message to channel '${D}' of shared process: ${(0,l.toErrorMessage)(r)}`)}}whenReady(){return this.w||(this.w=new Promise(D=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),D()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(D=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),D()}))})()),this.y}C(){const D=this.B(this.p.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${D.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),D.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:h.default,policiesData:this.m.serialize()}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=D=>{this.l.trace("SharedProcess#close prevented"),D.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(D,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(D,i,r)=>this.f.fire({type:3,details:{reason:r,exitCode:i}})))}async connect(){await this.z;const D=(0,w.assertIsDefined)(this.b);return(0,m.connect)(D)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const D=this.b;return D?!D.isDestroyed()&&!D.webContents.isDestroyed():!1}};k=pe([_(2,p.IEnvironmentMainService),_(3,u.IUserDataProfilesService),_(4,y.ILifecycleMainService),_(5,b.ILogService),_(6,g.IPolicyService),_(7,v.IThemeMainService),_(8,d.IProtocolMainService)],k),e.SharedProcess=k}),define(ee[93],te([0,1,8,3,2,63,11,105,5,37]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var p;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function h(g){const k=g.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=h;class d extends P.Disposable{constructor(k={flushInterval:d.a}){super(),this.j=k,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,S){if(S===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:S,target:this.F(k)[S]})}r(k){this.f.fire({reason:k})}get(k,S,D){return this.L(S)?.get(k,D)}getBoolean(k,S,D){return this.L(S)?.getBoolean(k,D)}getNumber(k,S,D){return this.L(S)?.getNumber(k,D)}store(k,S,D,i){if((0,M.isUndefinedOrNull)(S)){this.remove(k,D);return}this.t(()=>{this.u(k,D,i),this.L(D)?.set(k,S)})}remove(k,S){this.t(()=>{this.u(k,S,void 0),this.L(S)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,S){const D=[],i=this.F(k);for(const r of Object.keys(i))i[r]===S&&D.push(r);return D}u(k,S,D){const i=this.F(S);typeof D=="number"?i[k]!==D&&(i[k]=D,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[k]=="number"&&(delete i[k],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const S=this.L(k);return S?h(S):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=p.NONE){this.f.fire({reason:k});const S=this.L(-1),D=this.L(0),i=this.L(1);switch(k){case p.NONE:await E.Promises.settled([S?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await E.Promises.settled([S?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return u(k,S,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,S){return this.r(p.NONE),(0,m.isUserDataProfile)(k)?this.N(k,S):this.O(k,S)}H(k,S){return!(k.id===S.id||v(S)&&v(k))}I(k,S,D,i){this.t(()=>{if(i)for(const[r,n]of k)S.set(r,n);else{const r=new Set;for(const[n,o]of k)r.add(n),S.get(n)!==o&&this.n(D,n);for(const[n]of S.items)r.has(n)||this.n(D,n)}})}}e.AbstractStorageService=d,d.a=60*1e3;function v(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class l extends d{constructor(){super(),this.p=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=l;async function u(g,k,S,D,i,r){const n=j=>{try{return JSON.parse(j)}catch{return j}},o=new Map,a=new Map;g.forEach((j,K)=>{o.set(K,j),a.set(K,n(j))});const c=new Map,s=new Map;k.forEach((j,K)=>{c.set(K,j),s.set(K,n(j))});const f=new Map,C=new Map;S.forEach((j,K)=>{f.set(K,j),C.set(K,n(j))}),console.group(D!==i?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const L=[];if(o.forEach((j,K)=>{L.push({key:K,value:j})}),console.table(L),console.groupEnd(),console.log(a),D!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];c.forEach((K,V)=>{j.push({key:V,value:K})}),console.table(j),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${r})`);const O=[];f.forEach((j,K)=>{O.push({key:K,value:j})}),console.table(O),console.groupEnd(),console.log(C)}e.logStorage=u}),define(ee[266],te([0,1,25,8,3,2,9,69,7,23,105,149,6,93,24,29]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class l extends R.Disposable{get storage(){return this.f}constructor(r,n){super(),this.j=r,this.k=n,this.b=this.B(new P.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.Emitter),this.onDidCloseStorage=this.c.event,this.f=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const r=await this.n();this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(o=>this.b.fire({key:o}))),await this.m(r);const n=r.getBoolean(h.IS_NEW_KEY);n===void 0?r.set(h.IS_NEW_KEY,!0):n&&r.set(h.IS_NEW_KEY,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,n){return this.f.get(r,n)}set(r,n){return this.f.set(r,n)}delete(r){return this.f.delete(r)}async close(){const r=new I.StopWatch(!1);await this.s(),r.stop(),r.elapsed()>l.a&&await this.r(r),this.c.fire()}async r(r){if(!!this.path)try{const n=(0,E.top)(Array.from(this.f.items.entries()).map(([a,c])=>({key:a,length:c.length})),(a,c)=>c.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),o=(await this.k.stat(w.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${o}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}l.a=2e3;class u extends l{get path(){if(!this.v.useInMemoryStorage)return(0,M.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(r,n,o,a){super(o,a),this.u=r,this.v=n}async n(){return new p.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class g extends u{constructor(r,n,o,a){super(r,n,o,a)}}e.ProfileStorageMain=g;class k extends u{constructor(r,n,o,a){super(n.defaultProfile,r,o,a)}async m(r){await super.m(r),this.z(r)}z(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const o=r.get(d.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof o>"u"?null:o),r.set(d.currentSessionDateStorageKey,a)}}e.ApplicationStorageMain=k;class S extends l{get path(){if(!this.w.useInMemoryStorage)return(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(r,n,o,a,c){super(o,c),this.v=r,this.w=n,this.y=a}async n(){const{storageFilePath:r,wasCreated:n}=await this.C();return new p.Storage(new y.SQLiteStorageDatabase(r,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:n?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,M.join)(r,S.t);return await m.Promises.exists(r)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(r,{recursive:!0}),this.D(r),{storageFilePath:n,wasCreated:!0})}async D(r){let n;if((0,v.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const o=(0,M.join)(r,S.u);await m.Promises.exists(o)||await m.Promises.writeFile(o,JSON.stringify(n,void 0,2))}catch(o){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=S,S.t="state.vscdb",S.u="workspace.json";class D extends l{get path(){}async n(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(ee[267],te([0,1,3,2,93]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(I,w,m){super(),this.b=I,this.c=w,this.f=m;const p=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new t.DisposableStore;return I.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(w,m)=>(w?w.push(m.key):w=[m.key],w),100)(w=>this.h(w))),I.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(w,m)=>{w||(w=new Map);let p=w.get(m.profile.id);return p||w.set(m.profile.id,p={profile:m.profile,keys:[],storage:m.storage}),p.keys.push(m.key),w},100)(w=>this.i(w))),I}h(I){const w=I.includes(P.TARGET_KEY)?[this.c.defaultProfile]:[],m=[];if(I=I.filter(p=>p!==P.TARGET_KEY),I.length){const p=(0,P.loadKeyTargets)(this.b.applicationStorage.storage);m.push({profile:this.c.defaultProfile,changes:I.map(y=>({key:y,scope:0,target:p[y]}))})}this.j(w,m)}i(I){const w=[],m=new Map;for(const[p,y]of I.entries()){y.keys.includes(P.TARGET_KEY)&&w.push(y.profile);const b=y.keys.filter(h=>h!==P.TARGET_KEY);if(b.length){const h=(0,P.loadKeyTargets)(y.storage.storage);m.set(p,{profile:y.profile,changes:b.map(d=>({key:d,scope:0,target:h[d]}))})}}this.j(w,[...m.values()])}j(I,w){(I.length||w.length)&&this.a.fire({valueChanges:w,targetChanges:I})}listen(I,w,m){switch(w){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${w}`)}async call(I,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ee[268],te([0,1,71,7,33,16,6,231,39,37]),function(H,e,E,t,P,R,M,I,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let p=class extends m.UserDataProfilesService{constructor(h,d,v,l){super(d,v,h,l),this.a=d}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=pe([_(0,w.IUriIdentityService),_(1,P.INativeEnvironmentService),_(2,R.IFileService),_(3,M.ILogService)],p),e.ServerUserDataProfilesService=p;let y=class Lt extends p{constructor(h,d,v,l,u){super(d,v,l,u),this.N=h}G(){return(0,E.revive)(this.N.getItem(Lt.b,[]))}I(){return(0,E.revive)(this.N.getItem(Lt.c,{}))}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=pe([_(0,I.IStateService),_(1,w.IUriIdentityService),_(2,P.INativeEnvironmentService),_(3,R.IFileService),_(4,M.ILogService)],y),e.UserDataProfilesService=y}),define(ee[52],te([0,1,7,33,16,5,6,34,39,37,268]),function(H,e,E,t,P,R,M,I,w,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let y=class dt extends p.UserDataProfilesService{constructor(h,d,v,l,u){super(h,d,v,l,u),this.R=h}setEnablement(h){super.setEnablement(h),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const h=[];for(const d of this.u.emptyWindows.keys())h.push({id:d});return h}H(h){h.length?this.R.setItem(dt.b,h):this.R.removeItem(dt.b)}J(h){h.emptyWindows||h.workspaces?this.R.setItem(dt.c,h):this.R.removeItem(dt.c)}I(){const h="workspaceAndProfileInfo",d=this.R.getItem(h,void 0);if(d){this.R.removeItem(h);const v=d.reduce((l,{workspace:u,profile:g})=>(l[E.URI.revive(u).toString()]=E.URI.revive(g).toString(),l),{});this.R.setItem(dt.c,{workspaces:v})}return super.I()}};y=pe([_(0,I.IStateMainService),_(1,w.IUriIdentityService),_(2,t.INativeEnvironmentService),_(3,P.IFileService),_(4,M.ILogService)],y),e.UserDataProfilesMainService=y}),define(ee[94],te([0,1,7,50,3,2,33,16,5,21,6,93,266,37,52,39]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,w.createDecorator)("storageMainService");let l=class extends R.Disposable{constructor(k,S,D,i,r,n){super(),this.c=k,this.f=S,this.g=D,this.h=i,this.i=r,this.j=n,this.a=void 0,this.b=this.B(new P.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,S]of this.n)k.join(S.close());for(const[,S]of this.r)k.join(S.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const S=this.n.get(k.profile.id);S&&k.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,y.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let S=this.n.get(k.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),S=this.p(k),this.n.set(k.id,S);const D=this.B(S.onDidChangeStorage(i=>this.b.fire({...i,storage:S,profile:k})));(0,t.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),D.dispose()})}return S}p(k){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let S=this.r.get(k.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),S=this.s(k),this.r.set(k.id,S),(0,t.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),S}s(k){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const S=E.URI.file(k);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!D.path&&this.j.extUri.isEqualOrParent(E.URI.file(D.path),S))return!0;return!1}};l=pe([_(0,p.ILogService),_(1,M.IEnvironmentService),_(2,d.IUserDataProfilesMainService),_(3,m.ILifecycleMainService),_(4,I.IFileService),_(5,v.IUriIdentityService)],l),e.StorageMainService=l,e.IApplicationStorageMainService=(0,w.createDecorator)("applicationStorageMainService");let u=class extends y.AbstractStorageService{constructor(k,S){super(),this.p=k,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([_(0,h.IUserDataProfilesService),_(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[269],te([0,1,2,21,52,29,8,30]),function(H,e,E,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let w=class extends E.Disposable{constructor(p,y,b){super(),this.a=y,this.b=b,this.B(p.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(p.onBeforeCloseWindow(h=>this.c(h))),this.B(new M.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(p){const y=this.f(p),b=this.a.getProfileForWorkspace(y);b&&((0,R.isEmptyWorkspaceIdentifier)(y)||b.isTransient)&&(this.a.unsetWorkspace(y,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,R.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const y=this.b.getWindows().map(b=>this.f(b));for(const b of p)y.some(h=>h.id===b.id)||this.a.unsetWorkspace(b,!1)}};w=pe([_(0,t.ILifecycleMainService),_(1,P.IUserDataProfilesMainService),_(2,I.IWindowsMainService)],w),e.UserDataProfilesHandler=w}),define(ee[119],te([0,1,20,7,29]),function(H,e,E,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(w,m,p){for(const b of w){const h=b.openedWorkspace;if((0,P.isWorkspaceIdentifier)(h)){const d=await p(h);if(d){if(d.folders.some(v=>E.extUriBiasedIgnorePathCase.isEqualOrParent(m,v.uri)))return b}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(m,h.configPath))return b}}const y=w.filter(b=>(0,P.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(m,b.openedWorkspace.uri));if(y.length)return y.sort((b,h)=>-(b.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(w,m){for(const p of w)if((0,P.isWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,m)||(0,P.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,m))return p}e.findWindowOnWorkspaceOrFolder=M;function I(w,m){const p=y=>m.some(b=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(b),t.URI.file(y)));for(const y of w)if(y.config?.extensionDevelopmentPath?.some(b=>p(b)))return y}e.findWindowOnExtensionDevelopmentPath=I}),define(ee[270],te([0,1,14,2,4,20,7,18,21,6,34,30,117,29]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Ot extends t.Disposable{get state(){return this.b}constructor(S,D,i,r,n){super(),this.g=S,this.h=D,this.i=i,this.j=r,this.k=n,this.b=v(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(S=>this.p(S)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(S=>{S.newCount-S.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(S=>this.p(S))}m(){this.f=!0,this.n()}n(){const S=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(D.lastActiveWindow=this.r(n),D.lastActiveWindow.uiState.mode===3&&S.add(D.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(D.lastPluginDevelopmentHostWindow=this.r(i),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(S.has(D.lastPluginDevelopmentHostWindow.uiState.display)?P.isMacintosh&&!i.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):S.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const o=this.r(n);return o.uiState.mode===3&&(S.has(o.uiState.display)?P.isMacintosh&&o.windowId!==D.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(o.uiState.mode=1):S.add(o.uiState.display)),o}));const r=u(D);this.h.setItem(Ot.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(S){if(this.i.quitRequested)return;const D=this.r(S);S.isExtensionDevelopmentHost&&!S.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!S.isExtensionDevelopmentHost&&S.openedWorkspace&&this.b.openedWindows.forEach(i=>{const r=(0,h.isWorkspaceIdentifier)(S.openedWorkspace)&&i.workspace?.id===S.openedWorkspace.id,n=(0,h.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,S.openedWorkspace.uri);(r||n)&&(i.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(S){return{windowId:S.id,workspace:(0,h.isWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace.uri:void 0,backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.serializeWindowState()}}getNewWindowState(S){const D=this.s(S),i=this.k.getValue("window");if(D.mode===3){let r;D.hasDefaultState?r=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||i?.restoreFullscreen),r||(D.mode=1)}return D}s(S){const D=this.g.getLastActiveWindow();if(!S.extensionTestsPath){if(!!S.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=S.workspace;if((0,h.isWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===c.id).map(C=>C.uiState);if(f.length)return f[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(C=>C.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(C.folderUri,c.uri)).map(C=>C.uiState);if(f.length)return f[0]}else if(S.backupPath){const f=this.state.openedWindows.filter(C=>C.backupPath===S.backupPath).map(C=>C.uiState);if(f.length)return f[0]}const s=this.c||this.state.lastActiveWindow;if(!D&&s)return s.uiState}let i;const r=E.screen.getAllDisplays();if(r.length===1)i=r[0];else{if(P.isMacintosh){const c=E.screen.getCursorScreenPoint();i=E.screen.getDisplayNearestPoint(c)}!i&&D&&(i=E.screen.getDisplayMatching(D.getBounds())),i||(i=E.screen.getPrimaryDisplay()||r[0])}let n=(0,b.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const o=this.k.getValue("window");let a=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")n.mode=0,a=!1;else if(o.newWindowDimensions==="fullscreen")n.mode=3,a=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&D){const c=D.serializeWindowState();c.mode===3?n.mode=3:n=c,a=n.mode!==3&&o.newWindowDimensions==="offset"}}return a&&(n=this.t(n)),n.hasDefaultState=!0,n}t(S){if(this.g.getWindows().length===0)return S;S.x=typeof S.x=="number"?S.x:0,S.y=typeof S.y=="number"?S.y:0;const D=this.g.getWindows().map(i=>i.getBounds());for(;D.some(i=>i.x===S.x||i.y===S.y);)S.x+=30,S.y+=30;return S}};d.a="windowsState",d=pe([_(0,y.IWindowsMainService),_(1,p.IStateMainService),_(2,w.ILifecycleMainService),_(3,m.ILogService),_(4,I.IConfigurationService)],d),e.WindowsStateHandler=d;function v(k){const S={openedWindows:[]},D=k||{openedWindows:[]};return D.lastActiveWindow&&(S.lastActiveWindow=l(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(S.lastPluginDevelopmentHostWindow=l(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(S.openedWindows=D.openedWindows.map(i=>l(i))),S}e.restoreWindowsState=v;function l(k){const S={uiState:k.uiState};return k.backupPath&&(S.backupPath=k.backupPath),k.remoteAuthority&&(S.remoteAuthority=k.remoteAuthority),k.folder&&(S.folderUri=M.URI.parse(k.folder)),k.workspaceIdentifier&&(S.workspace={id:k.workspaceIdentifier.id,configPath:M.URI.parse(k.workspaceIdentifier.configURIPath)}),S}function u(k){return{lastActiveWindow:k.lastActiveWindow&&g(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&g(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(S=>g(S))}}e.getWindowsStateStoreData=u;function g(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[95],te([0,1,32,43,125,36,15,9,4,20,7,5,55,29]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function d(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function v(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=v;function l(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=l;function u(C){return g(C)||k(C)}e.isStoredWorkspaceFolder=u;function g(C){const L=C;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(C){const L=C;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(C,L,O,j,K){if(C.scheme!==j.scheme)return{name:O,uri:C.toString(!0)};let V=L?void 0:K.relativePath(j,C);if(V!==void 0)V.length===0?V=".":w.isWindows&&(V=D(V));else if(C.scheme===M.Schemas.file)V=C.fsPath,w.isWindows&&(V=D(V));else if(K.isEqualAuthority(C.authority,j.authority))V=C.path;else return{name:O,uri:C.toString(!0)};return{name:O,path:V}}e.getStoredWorkspaceFolder=S;function D(C){return C=(0,R.normalizeDriveLetter)(C),(0,E.isUNC)(C)||(C=(0,E.toSlashes)(C)),C}function i(C,L,O){const j=[],K=new Set,V=O.dirname(L);for(const J of C){let re;if(g(J))J.path&&(re=O.resolvePath(V,J.path));else if(k(J))try{re=p.URI.parse(J.uri),re.path[0]!==I.posix.sep&&(re=re.with({path:I.posix.sep+re.path}))}catch(se){console.warn(se)}if(re){const se=O.getComparisonKey(re);if(!K.has(se)){K.add(se);const ae=J.name||O.basenameOrAuthority(re);j.push(new h.WorkspaceFolder({uri:re,name:ae,index:j.length},J))}}}return j}e.toWorkspaceFolders=i;function r(C,L,O,j,K){const V=n(L,C),J=K.dirname(L),re=K.dirname(j),se=[];for(const q of V.folders){const T=g(q)?K.resolvePath(J,q.path):p.URI.parse(q.uri);let U;O?U=!1:U=!g(q)||(0,I.isAbsolute)(q.path),se.push(S(T,U,q.name,re,K))}const ae={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},fe=P.setProperty(C,["folders"],se,ae);let ge=P.applyEdits(C,fe);return(0,m.isEqualAuthority)(V.remoteAuthority,(0,b.getRemoteAuthority)(j))&&(ge=P.applyEdits(ge,P.removeProperty(ge,["remoteAuthority"],ae))),ge}e.rewriteWorkspaceFileForNewLocation=r;function n(C,L){const O=t.parse(L);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(j=>u(j));else throw new Error(`${C} looks like an invalid workspace file.`);return O}function o(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function a(C){return typeof C.folderUri=="string"}function c(C){return typeof C.fileUri=="string"}function s(C,L){const O={workspaces:[],files:[]};if(C){const j=function(V,J){for(let re=0;re<V.length;re++)try{J(V[re],re)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify(V[re])}: ${se.toString()}. Skip entry.`)}},K=C;Array.isArray(K.entries)&&j(K.entries,V=>{const J=V.label,re=V.remoteAuthority;o(V)?O.workspaces.push({label:J,remoteAuthority:re,workspace:{id:V.workspace.id,configPath:p.URI.parse(V.workspace.configPath)}}):a(V)?O.workspaces.push({label:J,remoteAuthority:re,folderUri:p.URI.parse(V.folderUri)}):c(V)&&O.files.push({label:J,remoteAuthority:re,fileUri:p.URI.parse(V.fileUri)})})}return O}e.restoreRecentlyOpened=s;function f(C){const L={entries:[]};for(const O of C.workspaces)v(O)?L.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):L.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of C.files)L.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return L}e.toStoreData=f}),define(ee[96],te([0,1,79,15,4,20]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(m){function p(){let y=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return P.isLinux||(y=y.toLowerCase()),(0,E.createHash)("md5").update(y).digest("hex")}return{id:p(),configPath:m}}e.getWorkspaceIdentifier=M;function I(m,p){function y(){if(m.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(m.toString()).digest("hex");if(!p)return;let h;return P.isLinux?h=p.ino:P.isMacintosh?h=p.birthtime.getTime():P.isWindows&&(typeof p.birthtimeMs=="number"?h=Math.floor(p.birthtimeMs):h=p.birthtime.getTime()),(0,E.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const b=y();if(typeof b=="string")return{id:b,uri:m}}e.getSingleFolderWorkspaceIdentifier=I;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(ee[271],te([0,1,79,32,15,9,4,20,23,179,18,28,34,16,6,178,29,96]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let g=class Tt{constructor(S,D,i,r){this.j=S,this.k=D,this.l=i,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.extUriBiasedIgnorePathCase,this.i={isEqual:(n,o)=>(0,t.isEqual)(n,o,!M.isLinux)}}async initialize(){const S=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(S.emptyWindows),this.d=await this.u((0,m.deserializeWorkspaceInfos)(S)),this.e=await this.v((0,m.deserializeFolderInfos)(S)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.HotExitConfiguration.OFF}q(){return this.s()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(S,D){this.d.some(r=>S.workspace.id===r.workspace.id)||(this.d.push(S),this.C());const i=(0,R.join)(this.c,S.workspace.id);return D?this.t(i,D).then(()=>i):i}async t(S,D){if(await w.Promises.exists(S)&&await this.z(S),await w.Promises.exists(D))try{await w.Promises.rename(D,S)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(S){return this.e.some(D=>this.h.isEqual(S.folderUri,D.folderUri))||(this.e.push(S),this.C()),(0,R.join)(this.c,this.D(S))}registerEmptyWindowBackup(S){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.backupFolder))||(this.g.push(S),this.C()),(0,R.join)(this.c,S.backupFolder)}async u(S){if(!Array.isArray(S))return[];const D=new Set,i=[];for(const r of S){const n=r.workspace;if(!(0,l.isWorkspaceIdentifier)(n))return[];if(!D.has(n.id)){D.add(n.id);const o=(0,R.join)(this.c,n.id);await this.B(o)?n.configPath.scheme!==P.Schemas.file||await w.Promises.exists(n.configPath.fsPath)?i.push(r):await this.z(o):await this.x(o)}}return i}async v(S){if(!Array.isArray(S))return[];const D=[],i=new Set;for(const r of S){const n=r.folderUri,o=this.h.getComparisonKey(n);if(!i.has(o)){i.add(o);const a=(0,R.join)(this.c,this.D(r));await this.B(a)?n.scheme!==P.Schemas.file||await w.Promises.exists(n.fsPath)?D.push(r):await this.z(a):await this.x(a)}}return D}async w(S){if(!Array.isArray(S))return[];const D=[],i=new Set;for(const r of S){const n=r.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const o=(0,R.join)(this.c,n);await this.B(o)?D.push(r):await this.x(o)}}return D}async x(S){try{await w.Promises.rm(S,w.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let S=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.id));)S=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:S.id}}async z(S){const D=this.y(),i=(0,R.join)(this.c,D.backupFolder);try{await w.Promises.rename(S,i)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const S=[];for(const D of this.d)await this.A(D)&&S.push(D);for(const D of this.e)await this.A(D)&&S.push(D);return S}A(S){let D;return(0,m.isEmptyWindowBackupInfo)(S)?D=(0,R.join)(this.c,S.backupFolder):(0,v.isFolderBackupInfo)(S)?D=(0,R.join)(this.c,this.D(S)):D=(0,R.join)(this.c,S.workspace.id),this.B(D)}async B(S){try{const D=await w.Promises.readdir(S);for(const i of D)try{if((await w.Promises.readdir((0,R.join)(S,i))).length>0)return!0}catch{}}catch{}return!1}C(){const S={workspaces:this.d.map(({workspace:D,remoteAuthority:i})=>{const r={id:D.id,configURIPath:D.configPath.toString()};return i&&(r.remoteAuthority=i),r}),folders:this.e.map(({folderUri:D,remoteAuthority:i})=>{const r={folderUri:D.toString()};return i&&(r.remoteAuthority=i),r}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:i})=>{const r={backupFolder:D};return i&&(r.remoteAuthority=i),r})};this.m.setItem(Tt.a,S)}D(S){const D=S.folderUri;let i;return D.scheme===P.Schemas.file?i=M.isLinux?D.fsPath:D.fsPath.toLowerCase():i=D.toString().toLowerCase(),(0,E.createHash)("md5").update(i).digest("hex")}};g.a="backupWorkspaces",g=pe([_(0,y.IEnvironmentMainService),_(1,p.IConfigurationService),_(2,d.ILogService),_(3,b.IStateMainService)],g),e.BackupMainService=g}),define(ee[53],te([0,1,14,3,43,36,2,15,9,20,11,23,177,62,57,28,5,6,19,52,119,29,95,96]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,l.createDecorator)("workspacesManagementMainService");let n=class extends M.Disposable{constructor(a,c,s,f,C,L){super(),this.g=a,this.h=c,this.i=s,this.j=f,this.k=C,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await y.Promises.readdir(this.c.fsPath)).map(c=>(0,m.joinPath)(this.c,c,D.UNTITLED_WORKSPACE_NAME));for(const c of a){const s=(0,r.getWorkspaceIdentifier)(c),f=await this.resolveLocalWorkspace(c);f?this.f.push({workspace:s,remoteAuthority:f.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.m(a,c=>y.Promises.readFile(c,"utf8"))}m(a,c){if(!!this.n(a)&&a.scheme===I.Schemas.file)try{const s=c(a.fsPath);return s instanceof Promise?s.then(f=>this.p(a,f),f=>{}):this.p(a,s)}catch{return}}n(a){return(0,D.isUntitledWorkspace)(a,this.g)||(0,D.hasWorkspaceFileExtension)(a)}p(a,c){try{const s=this.r(a,c),f=(0,r.getWorkspaceIdentifier)(a);return{id:f.id,configPath:f.configPath,folders:(0,i.toWorkspaceFolders)(s.folders,f.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}r(a,c){const s=(0,P.parse)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(f=>(0,i.isStoredWorkspaceFolder)(f));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(a,c){const{workspace:s,storedWorkspace:f}=this.s(a,c),C=s.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(C),{recursive:!0}),await y.Promises.writeFile(C,JSON.stringify(f,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}s(a=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),f=(0,m.joinPath)(this.c,s),C=(0,m.joinPath)(f,D.UNTITLED_WORKSPACE_NAME),L=[];for(const O of a)L.push((0,i.getStoredWorkspaceFolder)(O.uri,!0,O.name,f,m.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(C),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(a){return(0,r.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,D.isUntitledWorkspace)(a.configPath,this.g)}async deleteUntitledWorkspace(a){!this.isUntitledWorkspace(a)||(await this.t(a),this.i.isEnabled()&&this.i.unsetWorkspace(a),this.a.fire(a))}async t(a){const c=(0,m.originalFSPath)(a.configPath);try{await y.Promises.rm((0,w.dirname)(c));const s=(0,w.join)(this.g.workspaceStorageHome.fsPath,a.id);await y.Promises.exists(s)&&await y.Promises.writeFile((0,w.join)(s,"obsolete"),""),this.f=this.f.filter(f=>f.workspace.id!==a.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,c,s){if(!a||!a.win||!a.isReady||!await this.u(a,c,s))return;const C=await this.v(a,(0,r.getWorkspaceIdentifier)(s));if(!!C)return this.b.fire({window:a,workspace:C.workspace}),C}async u(a,c,s){if(!s)return!0;if((0,D.isWorkspaceIdentifier)(a.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,s))return!1;if((0,S.findWindowOnWorkspaceOrFolder)(c,s)){const f={title:this.l.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(0,null))],message:(0,b.localize)(1,null,(0,m.basename)(s)),detail:(0,b.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(f,(0,p.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(a,c){if(!a.config)return;a.focus();let s;return a.config.extensionDevelopmentPath||(a.config.backupPath?s=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:a.remoteAuthority},a.config.backupPath):s=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:a.remoteAuthority})),(0,D.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=c,a.config.backupPath=s,{workspace:c,backupPath:s}}};n=pe([_(0,v.IEnvironmentMainService),_(1,u.ILogService),_(2,k.IUserDataProfilesMainService),_(3,h.IBackupMainService),_(4,d.IDialogMainService),_(5,g.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ee[120],te([0,1,14,42,22,5,30,29,53,11,6]),function(H,e,E,t,P,R,M,I,w,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let y=class{constructor(h,d,v){this.a=h,this.b=d,this.c=v}async getRemoteDiagnostics(h){const d=this.a.getWindows();return(await Promise.all(d.map(async l=>{const u=l.remoteAuthority;if(!u)return;const g=`vscode:getDiagnosticInfoResponse${l.id}`,k={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(l):void 0};return new Promise(S=>{l.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:g,args:k}),t.validatedIpcMain.once(g,(D,i)=>{i||S({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),S(i)}),setTimeout(()=>{S({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(l=>!!l)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const d of E.BrowserWindow.getAllWindows()){const v=this.a.getWindowById(d.id);v?h.push(await this.d(v)):h.push(this.e(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(h){const d=await this.f(h),v=(0,m.assertIsDefined)(h.win);return this.e(v,d,h.remoteAuthority)}e(h,d=[],v){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:d,remoteAuthority:v}}async f(h){const d=[],v=h.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(v))d.push(v.uri);else if((0,I.isWorkspaceIdentifier)(v)){const l=await this.b.resolveLocalWorkspace(v.configPath);l&&l.folders.forEach(g=>{d.push(g.uri)})}return d}};y=pe([_(0,M.IWindowsMainService),_(1,w.IWorkspacesManagementMainService),_(2,p.ILogService)],y),e.DiagnosticsMainService=y}),define(ee[58],te([0,1,46,14,26,143,54,3,36,2,15,9,4,7,101,83,23,98,167,57,28,5,21,6,19,67,30,29,53,17,225,218,34]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n,o,a,c,s,f,C,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,D.createDecorator)("nativeHostMainService");let j=class extends m.Disposable{constructor(V,J,re,se,ae,fe,ge,q,T,U){super(),this.a=V,this.b=J,this.c=re,this.f=se,this.g=ae,this.h=fe,this.i=ge,this.j=q,this.k=T,this.l=U,this.onDidOpenWindow=I.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Q,y:ne})=>({windowId:z.id,x:Q,y:ne})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new I.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(z,Q,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),I.Event.fromNodeEventEmitter(t.screen,"display-added"),I.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(J=>({id:J.id,workspace:J.openedWorkspace??(0,c.toWorkspaceIdentifier)(J.backupPath,J.isExtensionDevelopmentHost),title:J.win?.getTitle()??"",filename:J.getRepresentedFilename(),dirty:J.isDocumentEdited()}))}async getWindowCount(V){return this.b.getWindowCount()}async getActiveWindowId(V){const J=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(J)return J.id}openWindow(V,J,re){return Array.isArray(J)?this.n(V,J,re):this.p(V,J)}async n(V,J,re=Object.create(null)){J.length>0&&await this.b.open({context:5,contextWindowId:V,urisToOpen:J,cli:this.g.args,forceNewWindow:re.forceNewWindow,forceReuseWindow:re.forceReuseWindow,preferNewWindow:re.preferNewWindow,diffMode:re.diffMode,mergeMode:re.mergeMode,addMode:re.addMode,gotoLineMode:re.gotoLineMode,noRecentEntry:re.noRecentEntry,waitMarkerFileURI:re.waitMarkerFileURI,remoteAuthority:re.remoteAuthority||void 0,forceProfile:re.forceProfile,forceTempProfile:re.forceTempProfile})}async p(V,J){await this.b.openEmptyWindow({context:5,contextWindowId:V},J)}async toggleFullScreen(V){this.w(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.w(V)?.handleTitleDoubleClick()}async isMaximized(V){const J=this.w(V);return J?.win?J.win.isMaximized():!1}async maximizeWindow(V){const J=this.w(V);J?.win&&J.win.maximize()}async unmaximizeWindow(V){const J=this.w(V);J?.win&&J.win.unmaximize()}async minimizeWindow(V){const J=this.w(V);J?.win&&J.win.minimize()}async updateWindowControls(V,J){const re=this.w(V);re&&re.updateWindowControls(J)}async focusWindow(V,J){J&&typeof J.windowId=="number"&&(V=J.windowId),this.w(V)?.focus({force:J?.force??!1})}async setMinimumSize(V,J,re){const se=this.w(V);if(se?.win){const[ae,fe]=se.win.getSize(),[ge,q]=se.win.getMinimumSize(),[T,U]=[J??ge,re??q],[z,Q]=[Math.max(ae,T),Math.max(fe,U)];(ge!==T||q!==U)&&se.win.setMinimumSize(T,U),(ae!==z||fe!==Q)&&se.win.setSize(z,Q)}}async saveWindowSplash(V,J){this.j.saveWindowSplash(V,J)}async installShellCommand(V){const{source:J,target:re}=await this.r();try{const{symbolicLink:se}=await l.SymlinkSupport.stat(J);if(se&&!se.dangling){const ae=await(0,d.realpath)(J);if(re===ae)return}await l.Promises.unlink(J)}catch(se){if(se.code!=="ENOENT")throw se}try{await l.Promises.symlink(re,J)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ae}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,g.localize)(0,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,g.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${re}' '${J}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(fe)}catch{throw new Error((0,g.localize)(3,null,J))}}}async uninstallShellCommand(V){const{source:J}=await this.r();try{await l.Promises.unlink(J)}catch(re){switch(re.code){case"EACCES":{const{response:se}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,g.localize)(4,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,g.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ae=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,J))}break}case"ENOENT":break;default:throw re}}}async r(){const V=(0,y.resolve)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.i.applicationName}`;if(!await l.Promises.exists(V))throw new Error((0,g.localize)(8,null,V));return{source:J,target:V}}async showMessageBox(V,J){return this.c.showMessageBox(J,this.s(V))}async showSaveDialog(V,J){return this.c.showSaveDialog(J,this.s(V))}async showOpenDialog(V,J){return this.c.showOpenDialog(J,this.s(V))}s(V){const J=this.w(V);if(J?.win)return J.win}async pickFileFolderAndOpen(V,J){const re=await this.c.pickFileFolder(J);re&&await this.t(await Promise.all(re.map(async se=>await l.SymlinkSupport.existsDirectory(se)?{folderUri:h.URI.file(se)}:{fileUri:h.URI.file(se)})),J,V)}async pickFolderAndOpen(V,J){const re=await this.c.pickFolder(J);re&&await this.t(re.map(se=>({folderUri:h.URI.file(se)})),J,V)}async pickFileAndOpen(V,J){const re=await this.c.pickFile(J);re&&await this.t(re.map(se=>({fileUri:h.URI.file(se)})),J,V)}async pickWorkspaceAndOpen(V,J){const re=await this.c.pickWorkspace(J);re&&await this.t(re.map(se=>({workspaceUri:h.URI.file(se)})),J,V)}async t(V,J,re){await this.b.open({context:3,contextWindowId:re,cli:this.g.args,urisToOpen:V,forceNewWindow:J.forceNewWindow})}async showItemInFolder(V,J){t.shell.showItemInFolder(J)}async setRepresentedFilename(V,J){this.w(V)?.setRepresentedFilename(J)}async setDocumentEdited(V,J){this.w(V)?.setDocumentEdited(J)}async openExternal(V,J){return b.isLinuxSnap?this.u(J):t.shell.openExternal(J),!0}u(V){const J=process.env.GDK_PIXBUF_MODULE_FILE,re=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=J,process.env.GDK_PIXBUF_MODULEDIR=re}moveItemToTrash(V,J){return t.shell.trashItem(J)}async isAdmin(){let V;return b.isWindows?V=(await new Promise((J,re)=>{H(["native-is-elevated"],J,re)}))():V=process.getuid()===0,V}async writeElevated(V,J,re,se){const ae=await new Promise((fe,ge)=>{H(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const q=[`"${this.v}"`];se?.unlock&&q.push("--file-chmod"),q.push("--file-write",`"${J.fsPath}"`,`"${re.fsPath}"`);const T={name:this.i.nameLong.replace("-",""),icns:b.isMacintosh&&this.g.isBuilt?(0,y.join)((0,y.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(q.join(" "),T,(U,z,Q)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),U?ge(U):fe(void 0)})})}get v(){return b.isWindows?this.g.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,y.join)(this.g.appRoot,"scripts","code-cli.bat"):b.isLinux?this.g.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,y.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.join)(this.g.appRoot,"bin","code"):(0,y.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return v.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,C.hasWSLFeatureInstalled)()}async killProcess(V,J,re){process.kill(J,re)}async readClipboardText(V,J){return t.clipboard.readText(J)}async writeClipboardText(V,J,re){return t.clipboard.writeText(J,re)}async readClipboardFindText(V){return t.clipboard.readFindText()}async writeClipboardFindText(V,J){return t.clipboard.writeFindText(J)}async writeClipboardBuffer(V,J,re,se){return t.clipboard.writeBuffer(J,Buffer.from(re.buffer),se)}async readClipboardBuffer(V,J){return f.VSBuffer.wrap(t.clipboard.readBuffer(J))}async hasClipboard(V,J,re){return t.clipboard.has(J,re)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,J){this.w(V)?.updateTouchBar(J)}async notifyReady(V){this.w(V)?.setReady()}async relaunch(V,J){return this.f.relaunch(J)}async reload(V,J){const re=this.w(V);if(re){if((0,c.isWorkspaceIdentifier)(re.openedWorkspace)){const se=re.openedWorkspace.configPath;if(se.scheme===p.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(re.id,{forceReuseWindow:!0})}return this.f.reload(re,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,J){const re=this.w(J);if(re?.win)return re.win.close()}async quit(V){const J=this.b.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(V,J){await this.f.kill(J)}async resolveProxy(V,J){const se=this.w(V)?.win?.webContents?.session;if(se)return se.resolveProxy(J)}findFreePort(V,J,re,se,ae=1){return(0,u.findFreePort)(J,re,se,ae)}async openDevTools(V,J){const re=this.w(V);re?.win&&re.win.webContents.openDevTools(J)}async toggleDevTools(V){const J=this.w(V);J?.win&&J.win.webContents.toggleDevTools()}async sendInputEvent(V,J){const re=this.w(V);re?.win&&(J.type==="mouseDown"||J.type==="mouseUp")&&re.win.webContents.sendInputEvent(J)}async enableSandbox(V,J){J?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(V,J,re){const se=this.w(V);if(!se||!se.win)throw new Error;return await new L.WindowProfiler(se.win,J,this.h).inspect(re)}async windowsGetStringRegKey(V,J,re,se){if(!b.isWindows)return;const ae=await new Promise((fe,ge)=>{H(["@vscode/windows-registry"],fe,ge)});try{return ae.GetStringRegKey(J,re,se)}catch{return}}w(V){if(typeof V=="number")return this.b.getWindowById(V)}};pe([M.memoize],j.prototype,"v",null),j=pe([_(1,a.IWindowsMainService),_(2,k.IDialogMainService),_(3,i.ILifecycleMainService),_(4,S.IEnvironmentMainService),_(5,r.ILogService),_(6,n.IProductService),_(7,o.IThemeMainService),_(8,O.IStateMainService),_(9,s.IWorkspacesManagementMainService)],j),e.NativeHostMainService=j}),define(ee[272],te([0,1,14,42,26,36,2,15,4,102,165,86,120,57,28,5,6,58,64,19,65,75,32,11,34]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");const o="issue.processExplorerWindowState";let a=class jt{constructor(f,C,L,O,j,K,V,J,re,se){this.g=f,this.h=C,this.i=L,this.j=O,this.k=j,this.l=K,this.m=V,this.n=J,this.o=re,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async f=>{const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(C,L);this.r(f,"vscode:issueSystemInfoResponse",O)}),t.validatedIpcMain.on("vscode:listProcesses",async f=>{const C=[];try{C.push({name:(0,p.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,y.isRemoteDiagnosticError)(O)?C.push({name:O.hostName,rootProcess:O}):O.processes&&C.push({name:O.hostName,rootProcess:O.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.r(f,"vscode:listProcessesResponse",C)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async f=>{const C={title:this.o.nameLong,message:(0,p.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,p.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,p.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const L=await this.l.showMessageBox(C,this.b);this.r(f,"vscode:issueReporterClipboardResponse",L.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async f=>{const C=await this.v();this.r(f,"vscode:issuePerformanceInfoResponse",C)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const f={title:this.o.nameLong,message:(0,p.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,p.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(f,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(f,C)=>{const{id:L,from:O,args:j}=C;let K;switch(O){case"issueReporter":K=this.c;break;case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}K?.webContents.send("vscode:runAction",{id:L,from:O,args:j})}),t.validatedIpcMain.on("vscode:openExternal",(f,C)=>{this.m.openExternal(void 0,C)}),t.validatedIpcMain.on("vscode:closeIssueReporter",f=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",f=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async f=>{const C=await this.k.getMainDiagnostics();this.r(f,"vscode:windowsInfoResponse",C.windows)})}r(f,C,...L){f.sender.isDestroyed()||f.sender.send(C,...L)}async openReporter(f){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const C=new M.DisposableStore,L=C.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,L,{backgroundColor:f.styles.backgroundColor,title:(0,p.localize)(7,null),zoomLevel:f.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:f,disableExtensions:!!this.h.disableExtensions,os:{type:(0,P.type)(),arch:(0,P.arch)(),release:(0,P.release)()},product:g.default}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,C.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,C.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(f){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const C=new M.DisposableStore,L=C.add(this.n.createIPCObjectUrl()),O=this.p.getItem(o,void 0),j=c(O)?O:this.u(this.f,800,500),K=E.screen.getDisplayNearestPoint({x:j.x,y:j.y});j.width/=K.scaleFactor,j.height/=K.scaleFactor,this.d=this.t(j,L,{backgroundColor:f.styles.backgroundColor,title:(0,p.localize)(8,null),zoomLevel:f.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:f,product:g.default}),this.d.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,C.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,C.dispose())});const V=()=>{if(!this.d)return;const J=this.d.getSize(),re=this.d.getPosition();if(!J||!re)return;const se={width:J[0],height:J[1],x:re[0],y:re[1]};this.p.setItem(o,se)};this.d.on("moved",V),this.d.on("resized",V)}this.d&&this.s(this.d)}s(f){f.isMinimized()&&f.restore(),f.focus()}t(f,C,L,O){const j=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:f.width,height:f.height,minWidth:300,minHeight:200,x:f.x,y:f.y,title:L.title,backgroundColor:L.backgroundColor||jt.a,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${C.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(L.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return j.setMenuBarVisibility(!1),j}async getSystemStatus(){const[f,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(f,C)}u(f,C,L){let O;const j=E.screen.getAllDisplays();if(j.length===1)O=j[0];else{if(w.isMacintosh){const J=E.screen.getCursorScreenPoint();O=E.screen.getDisplayNearestPoint(J)}!O&&f&&(O=E.screen.getDisplayMatching(f.getBounds())),O||(O=E.screen.getPrimaryDisplay()||j[0])}const K=O.bounds,V={width:C,height:L,x:K.x+K.width/2-C/2,y:K.y+K.height/2-L/2};return K.width>0&&K.height>0&&(V.x<K.x&&(V.x=K.x),V.y<K.y&&(V.y=K.y),V.x>K.x+K.width&&(V.x=K.x),V.y>K.y+K.height&&(V.y=K.y),V.width>K.width&&(V.width=K.width),V.height>K.height&&(V.height=K.height)),V}async v(){try{const[f,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(f,C)}catch(f){throw this.i.warn("issueService#getPerformanceInfo ",f.message),f}}async stopTracing(){if(!this.h.args.trace)return;const f=await E.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,p.localize)(9,null),detail:(0,p.localize)(10,null,f),buttons:[(0,R.mnemonicButtonLabel)((0,p.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,f)}};a.a="#1E1E1E",a=pe([_(1,d.IEnvironmentMainService),_(2,l.ILogService),_(3,y.IDiagnosticsService),_(4,b.IDiagnosticsMainService),_(5,h.IDialogMainService),_(6,u.INativeHostMainService),_(7,S.IProtocolMainService),_(8,k.IProductService),_(9,n.IStateMainService)],a),e.IssueMainService=a;function c(s){return typeof s!="object"||s===null?!1:"x"in s&&"y"in s&&"width"in s&&"height"in s}}),define(ee[273],te([0,1,22,18,28,21,6,58,19,56,24,49,92]),function(H,e,E,t,P,R,M,I,w,m,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends b.AbstractUpdateService{constructor(v,l,u,g,k,S,D,i){super(v,l,g,k,S,i),this.e=u,this.u=D}s(v){return(0,b.createUpdateURL)(`linux-${process.arch}`,v,this.k)}t(v){!this.a||(this.d(y.State.CheckingForUpdates(v)),this.i.request({url:this.a},E.CancellationToken.None).then(m.asJson).then(l=>{!l||!l.url||!l.version||!l.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.State.Idle(1))):this.d(y.State.AvailableForDownload(l))}).then(void 0,l=>{this.j.error(l),this.e.publicLog2("update:notAvailable",{explicit:!!v});const u=v?l.message||l:void 0;this.d(y.State.Idle(1,u))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.State.Idle(1))}};h=pe([_(0,R.ILifecycleMainService),_(1,t.IConfigurationService),_(2,p.ITelemetryService),_(3,P.IEnvironmentMainService),_(4,m.IRequestService),_(5,M.ILogService),_(6,I.INativeHostMainService),_(7,w.IProductService)],h),e.LinuxUpdateService=h}),define(ee[274],te([0,1,46,41,26,8,22,54,9,7,129,23,18,28,16,21,6,58,19,56,24,49,92]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(c,s=1e3){for(;!c();)await(0,R.timeout)(s)}let n;function o(){return typeof n>"u"&&(n=t.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),n}let a=class extends i.AbstractUpdateService{get cachePath(){const s=w.join((0,P.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return y.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,f,C,L,O,j,K,V,J){super(s,f,L,O,j,J),this.u=C,this.v=K,this.w=V}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(s){let f="win32";return process.arch!=="ia32"&&(f+=`-${process.arch}`),o()===1?f+="-archive":this.k.target==="user"&&(f+="-user"),(0,i.createUpdateURL)(f,s,this.k)}t(s){!this.a||(this.d(D.State.CheckingForUpdates(s)),this.i.request({url:this.a},M.CancellationToken.None).then(k.asJson).then(f=>{const C=o();return!f||!f.url||!f.version||!f.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!s}),this.d(D.State.Idle(C)),Promise.resolve(null)):C===1?(this.d(D.State.AvailableForDownload(f)),Promise.resolve(null)):(this.d(D.State.Downloading(f)),this.B(f.version).then(()=>this.A(f.version).then(L=>y.Promises.exists(L).then(O=>{if(O)return Promise.resolve(L);const j=f.url,K=f.hash,V=`${L}.tmp`;return this.i.request({url:j},M.CancellationToken.None).then(J=>this.v.writeFile(m.URI.file(V),J.stream)).then(K?()=>(0,p.checksum)(V,f.hash):()=>{}).then(()=>y.Promises.rename(V,L)).then(()=>L)})).then(L=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},O&&f.supportsFastUpdate?this.k.target==="user"?this.p():this.d(D.State.Downloaded(f)):this.d(D.State.Ready(f))})))}).then(void 0,f=>{this.j.error(f),this.u.publicLog2("update:notAvailable",{explicit:!!s});const C=s?f.message||f:void 0;this.d(D.State.Idle(o(),C))}))}async o(s){s.update.url&&this.w.openExternal(void 0,s.update.url),this.d(D.State.Idle(o()))}async A(s){const f=await this.cachePath;return w.join(f,`CodeSetup-${this.k.quality}-${s}.exe`)}async B(s=null){const f=s?j=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(j):()=>!0,C=await this.cachePath,O=(await y.Promises.readdir(C)).filter(f).map(async j=>{try{await y.Promises.unlink(w.join(C,j))}catch{}});await Promise.all(O)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(D.State.Updating(s));const f=await this.cachePath;this.e.updateFilePath=w.join(f,`CodeSetup-${this.k.quality}-${s.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(o()))});const L=`${this.k.win32MutexName}-ready`,O=await new Promise((j,K)=>{H(["windows-mutex"],j,K)});r(()=>O.isActive(L)).then(()=>this.d(D.State.Ready(s)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const f=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!f};this.d(D.State.Downloading(C)),this.e={packagePath:s},f?this.k.target==="user"?this.p():this.d(D.State.Downloaded(C)):this.d(D.State.Ready(C))}};pe([I.memoize],a.prototype,"cachePath",null),a=pe([_(0,v.ILifecycleMainService),_(1,b.IConfigurationService),_(2,S.ITelemetryService),_(3,h.IEnvironmentMainService),_(4,k.IRequestService),_(5,l.ILogService),_(6,d.IFileService),_(7,u.INativeHostMainService),_(8,g.IProductService)],a),e.Win32UpdateService=a}),define(ee[275],te([0,1,14,8,22,45,3,36,2,15,9,63,4,7,173,62,18,57,28,61,16,21,6,19,65,236,94,24,241,67,75,30,29,53,117,122,38,34,52,58,238,113,51,91,26,114]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n,o,a,c,s,f,C,L,O,j,K,V,J,re,se,ae,fe,ge,q,T,U,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(Q||(Q={}));let ne=class gt extends w.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const A=this.O.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&A?A:this.O.getProfileForWorkspace(this.config.workspace??(0,O.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(A,F,W,N,$,G,B,X,Z,oe,de,ke,De,Pe,Ae,ve,me,ye,Me,ie){super(),this.L=F,this.M=W,this.N=N,this.O=$,this.P=G,this.Q=B,this.R=X,this.S=Z,this.U=oe,this.W=de,this.X=ke,this.Y=De,this.Z=Pe,this.ab=Ae,this.bb=ve,this.db=me,this.eb=ye,this.fb=Me,this.gb=ie,this.c=this.B(new M.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new M.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new M.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new M.Emitter),this.onDidClose=this.h.event,this.j=this.B(new M.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[ue,he]=this.sb(A.state);this.r=ue,this.L.trace("window#ctor: using window state",ue);const be=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Ce=this.S.getValue("window");let We=!1;typeof Ce?.experimental?.useSandbox=="boolean"?We=Ce.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,show:!be,title:this.bb.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.zoomLevelToZoomFactor)(Ce?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?Te.icon=(0,p.join)(this.M.appRoot,"resources/linux/code.png"):b.isWindows&&!this.M.isBuilt&&(Te.icon=(0,p.join)(this.M.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),b.isMacintosh&&(Te.acceptFirstMouse=!0,Ce?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=b.isMacintosh&&Ce?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,C.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",b.isMacintosh||(Te.frame=!1),(0,C.useWindowControlsOverlay)(this.S))){const je=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=V.Color.fromHex(je).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:je,symbolColor:Xe},this.z=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Te),(0,y.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,b.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(b.isWindows&&(0,C.useWindowControlsOverlay)(this.S)||b.isMacintosh)){const je=this.fb.getItem(gt.a);je&&this.updateWindowControls({height:je})}b.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=E.screen.getCursorScreenPoint(),Y=Ke.x-Xe,ce=Ke.y-$e;return(()=>!(Y>30&&ce>=0&&ce<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:Y,y:ce})),0}),(b.isMacintosh||b.isWindows)&&he&&(!qe||E.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(je=>typeof je=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),be&&((0,y.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(A){b.isMacintosh?this.l.setRepresentedFilename(A):this.v=A}getRepresentedFilename(){return b.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(A){b.isMacintosh&&this.l.setDocumentEdited(A),this.w=A}isDocumentEdited(){return b.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(A){b.isMacintosh&&A?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.C.push(A)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(A=>{function F(){W.dispose(),N.dispose(),A()}const W=this.onDidClose(()=>F()),N=this.onWillLoad(()=>F())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(F,W)=>this.lb(2,W)),this.l.webContents.on("did-fail-load",(F,W,N)=>this.lb(3,{reason:N,exitCode:W})),this.l.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",F=>{this.n&&(this.n.maximized=!0),E.app.emit("browser-window-maximize",F,this.l)}),this.l.on("unmaximize",F=>{this.n&&(this.n.maximized=!1),E.app.emit("browser-window-unmaximize",F,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(F=>this.pb(F))),this.B(this.W.onDidDeleteUntitledWorkspace(F=>this.ob(F)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(F,W)=>{const N=await this.kb();W({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,N)})})}kb(){return this.jb||(this.jb=(0,o.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(A,F){switch(A){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:A,reason:F?.reason,code:F?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,d.localize)(5,null):void 0},this.l);if(W.response!==1){const N=W.response===0;await this.nb(N,W.checkboxChecked)}}else if(A===2)if(b.isWindows&&F?.reason==="launch-failed"&&F.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(F);else{let W;F?W=(0,d.localize)(7,null,F.reason,F.exitCode??"<unknown>"):W=(0,d.localize)(6,null);const N=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[this.n?.workspace?(0,I.mnemonicButtonLabel)((0,d.localize)(8,null)):(0,I.mnemonicButtonLabel)((0,d.localize)(9,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(10,null))],message:W,detail:this.n?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,d.localize)(13,null):void 0},this.l),$=N.response===0;await this.nb($,N.checkboxChecked)}break}}async mb(A){const F=[],W=(0,q.isInternalTelemetry)(this.bb,this.S);if((0,q.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&F.push(new fe.OneDataSystemAppender(W,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:$}=this.M,G=await(0,z.resolveMachineId)(this.fb),B={appenders:F,sendErrorTelemetry:!1,commonProperties:(0,T.resolveCommonProperties)(this.P,(0,U.release)(),(0,U.hostname)(),process.arch,this.bb.commit,this.bb.version,G,W,$),piiPaths:(0,q.getPiiPathsFromEnvironment)(this.M)};await new ge.TelemetryService(B,this.S,this.bb).publicLog2("windowadminerror",{reason:A.reason,code:A.exitCode})}(await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(14,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(15,null))],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.gb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(F.map($=>$.flush())),await this.nb(!1,!1)}async nb(A,F){const W=this.n?.workspace;if(F&&W)try{const N=this.R.workspaceStorage(W);await N.init(),N.delete("memento/workbench.parts.editor"),await N.close()}catch(N){this.L.error(N)}if(this.j.fire(),this.l?.destroy(),A&&this.n){let N,$;(0,O.isSingleFolderWorkspaceIdentifier)(W)?N={folderUri:W.uri}:(0,O.isWorkspaceIdentifier)(W)?N={workspaceUri:W.configPath}:$=!0;const[G]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:N?[N]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});G.focus()}}ob(A){this.n?.workspace?.id===A.id&&(this.n.workspace=void 0)}pb(A){const F=this.Ab();F!==this.s&&(this.s=F,this.Bb(F));let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const N=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||N!==this.G)){this.F=W,this.G=N;const $=W||"",G=N?`${N},<local>`:"<local>";this.L.trace(`Setting proxy to '${$}', bypassing '${G}'`),this.l.webContents.session.setProxy({proxyRules:$,proxyBypassRules:G,pacScript:""})}}addTabbedWindow(A){b.isMacintosh&&A.win&&this.l.addTabbedWindow(A.win)}load(A,F=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!F.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(A,F),this.hb===0?this.n=A:this.I=A,this.hb=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:A.workspace,reason:F.isReload?3:W?2:1})}qb(A,F){const W=(this.n??this.I)?.userEnv;if(W){const N=(0,k.isLaunchedFromCli)(W)&&!(0,k.isLaunchedFromCli)(A.userEnv),$=this.isExtensionDevelopmentHost;(N||$)&&(A.userEnv={...W,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(A["disable-extensions"]=F.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this.l.isMaximized(),A.partsSplash=this.U.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),A.perfMarks=(0,y.getMarks)(),this.H.update(A)}async reload(A){const F=Object.assign({},this.n);F.workspace=await this.rb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&A&&(F.verbose=A.verbose,F.debugId=A.debugId,F.extensionEnvironment=A.extensionEnvironment,F["inspect-extensions"]=A["inspect-extensions"],F["inspect-brk-extensions"]=A["inspect-brk-extensions"],F["extensions-dir"]=A["extensions-dir"]),F.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.N.serialize(),F.continueOn=this.M.continueOn,F.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},F.logLevel=this.L.getLevel(),this.load(F,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async rb(A){if((0,O.isWorkspaceIdentifier)(A.workspace)){const F=A.workspace.configPath;if(F.scheme===m.Schemas.file&&!await this.P.exists(F))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(A.workspace)){const F=A.workspace.uri;if(F.scheme===m.Schemas.file&&!await this.P.exists(F))return}return A.workspace}serializeWindowState(){if(!this.l)return(0,K.defaultWindowState)();if(this.isFullScreen){let W;try{W=E.screen.getDisplayMatching(this.getBounds())}catch{}const N=(0,K.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||N.width,height:this.r.height||N.height,x:this.r.x||0,y:this.r.y||0}}const A=Object.create(null);let F;if(!b.isMacintosh&&this.l.isMaximized()?F=0:F=1,F===0?A.mode=0:A.mode=1,F===1||F===0){let W;F===1?W=this.getBounds():W=this.l.getNormalBounds(),A.x=W.x,A.y=W.y,A.width=W.width,A.height=W.height}return A}updateWindowControls(A){if(A.height&&this.fb.setItem(gt.a,A.height),b.isWindows&&this.z)this.l.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(b.isMacintosh&&A.height!==void 0){const F=(A.height-15)/2;this.l.setTrafficLightPosition({x:F,y:F})}}sb(A){(0,y.mark)("code/willRestoreCodeWindowState");let F=!1;if(A)try{const W=E.screen.getAllDisplays();F=W.length>1,A=this.tb(A,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[A||(0,K.defaultWindowState)(),F]}tb(A,F){if(this.L.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const $=this.ub(F[0]);if($){let G=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!$||(A.x<$.x&&(A.x=$.x),A.y<$.y&&(A.y=$.y))};this.L.trace("window#validateWindowState: 1 monitor working area",$),G(),A.width>$.width&&(A.width=$.width),A.height>$.height&&(A.height=$.height),A.x>$.x+$.width-128&&(A.x=$.x+$.width-A.width),A.y>$.y+$.height-128&&(A.y=$.y+$.height-A.height),G()}return A}if(A.display&&A.mode===3){const $=F.find(G=>G.id===A.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const G=(0,K.defaultWindowState)(3);return G.x=$.bounds.x,G.y=$.bounds.y,G}}let W,N;try{W=E.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),N=this.ub(W)}catch{}if(W&&N&&A.x+A.width>N.x&&A.y+A.height>N.y&&A.x<N.x+N.width&&A.y<N.y+N.height)return this.L.trace("window#validateWindowState: multi-monitor working area",N),A}ub(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,F]=this.l.getPosition(),[W,N]=this.l.getSize();return{x:A,y:F,width:W,height:N}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(A){this.zb()?this.wb(A):this.yb(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(A){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(A)}xb(A){b.isMacintosh&&(this.t=A,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(A)}yb(A){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(A),this.l.webContents.focus()}zb(){const A=this.S.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let A=(0,C.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}Bb(A,F=!0){b.isMacintosh||(A==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),A==="hidden"?setTimeout(()=>{this.Cb(A)}):this.Cb(A))}Cb(A){const F=this.isFullScreen;switch(A){case"classic":this.l.setMenuBarVisibility(!F),this.l.autoHideMenuBar=F;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(A,F,...W){this.isReady?this.send(A,...W):this.ready().then(()=>{F.isCancellationRequested||this.send(A,...W)})}send(A,...F){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this.l.webContents.send(A,...F)}catch(W){this.L.warn(`Error sending IPC message to channel '${A}' of window ${this.k}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(A){!b.isMacintosh||this.D.forEach((F,W)=>{const N=A[W];F.segments=this.Fb(N)})}Db(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const F=this.Eb();this.D.push(F)}this.l.setTouchBar(new E.TouchBar({items:this.D}))}}Eb(A=[]){const F=this.Fb(A),W=new E.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:W.segments[N].id,from:"touchbar"})}});return W}Fb(A=[]){return A.map(W=>{let N;W.icon&&!s.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===m.Schemas.file&&(N=E.nativeImage.createFromPath(h.URI.revive(W.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:N?void 0:$,icon:N}})}dispose(){super.dispose(),this.l=null}};ne.a="windowControlHeight",ne.b=void 0,ne=pe([_(1,i.ILogService),_(2,g.IEnvironmentMainService),_(3,J.IPolicyService),_(4,se.IUserDataProfilesMainService),_(5,S.IFileService),_(6,a.IApplicationStorageMainService),_(7,a.IStorageMainService),_(8,l.IConfigurationService),_(9,f.IThemeMainService),_(10,j.IWorkspacesManagementMainService),_(11,v.IBackupMainService),_(12,c.ITelemetryService),_(13,u.IDialogMainService),_(14,D.ILifecycleMainService),_(15,r.IProductService),_(16,n.IProtocolMainService),_(17,L.IWindowsMainService),_(18,re.IStateMainService),_(19,ae.INativeHostMainService)],ne),e.CodeWindow=ne}),define(ee[77],te([0,1,14,25,8,3,36,2,15,4,20,7,23,176,5,21,6,94,95,29,53,40]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let i=class rt extends I.Disposable{constructor(n,o,a,c){super(),this.f=n,this.g=o,this.h=a,this.j=c,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new P.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let o=[],a=[];for(const s of n)if((0,g.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(o,s.workspace)&&o.push(s);else if((0,g.isRecentFolder)(s))this.s(o,s.folderUri)||o.push(s);else{const f=this.t(a,s.fileUri),C=s.fileUri.scheme===w.Schemas.file&&rt.y.indexOf((0,p.basename)(s.fileUri))>=0;!f&&!C&&(a.push(s),m.isWindows&&s.fileUri.scheme===w.Schemas.file&&E.app.addRecentDocument(s.fileUri.fsPath))}const c=await this.l({workspaces:o,files:a});o=c.workspaces,a=c.files,o.length>rt.a&&(o.length=rt.a),a.length>rt.a&&(a.length=rt.a),await this.n({workspaces:o,files:a}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const o=f=>{const C=this.p(f);for(const L of n)if(p.extUriBiasedIgnorePathCase.isEqual(L,C))return!1;return!0},a=await this.getRecentlyOpened(),c=a.workspaces.filter(o),s=a.files.filter(o);(c.length!==a.workspaces.length||s.length!==a.files.length)&&(await this.n({files:s,workspaces:c}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const o=new D.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.workspaces)for(const s of n.workspaces)o.set(this.p(s),s);const a=new D.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.files)for(const s of n.files)a.set(this.p(s),s);const c=await this.m();for(const s of c.workspaces){const f=o.get(this.p(s));f?f.label=f.label??s.label:o.set(this.p(s),s)}for(const s of c.files){const f=a.get(this.p(s));f?f.label=f.label??s.label:a.set(this.p(s),s)}return{workspaces:[...o.values()],files:[...a.values()]}}async m(){await this.j.whenReady;let n;const o=this.j.get(rt.b,-1);if(typeof o=="string")try{n=JSON.parse(o)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,g.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,g.toStoreData)(n)),-1,1)}p(n){return(0,g.isRecentFolder)(n)?n.folderUri:(0,g.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,o){return!!n.find(a=>(0,g.isRecentWorkspace)(a)&&a.workspace.id===o.id)}s(n,o){return!!n.find(a=>(0,g.isRecentFolder)(a)&&p.extUriBiasedIgnorePathCase.isEqual(a.folderUri,o))}t(n,o){return!!n.find(a=>p.extUriBiasedIgnorePathCase.isEqual(a.fileUri,o))}async C(){!m.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!m.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const s of E.app.getJumpListSettings().removedItems){const f=s.args;if(f){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(f);C&&o.push(y.URI.parse(C[2]))}}await this.removeRecentlyOpened(o);let a=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(s=>{const f=(0,g.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:C,description:L}=this.F(f,s.label);let O;return y.URI.isUri(f)?O=`--folder-uri "${f.toString()}"`:(a=!0,O=`--file-uri "${f.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:L.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:a?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}n.push({type:"recent"});try{const o=E.app.setJumpList(n);o&&o!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.f.warn("updateWindowsJumpList#setJumpList",o)}}F(n,o){if(o)return{title:(0,M.splitName)(o).name,description:o};if(y.URI.isUri(n))return{title:(0,p.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,h.localize)(4,null),description:""};let a=(0,p.basename)(n.configPath);return a.endsWith(k.WORKSPACE_EXTENSION)&&(a=a.substr(0,a.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,a),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,M.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!m.isMacintosh)return;E.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),o=[];let a=0;for(let s=0;s<n.workspaces.length&&a<rt.u;s++){const f=this.p(n.workspaces[s]);if(f.scheme===w.Schemas.file){const C=(0,p.originalFSPath)(f);await b.Promises.exists(C)&&(o.push(C),a++)}}const c=[];for(let s=0;s<n.files.length&&a<rt.v;s++){const f=this.p(n.files[s]);if(f.scheme===w.Schemas.file){const C=(0,p.originalFSPath)(f);if(rt.y.includes((0,p.basename)(f))||o.includes(C))continue;await b.Promises.exists(C)&&(c.push(C),a++)}}c.reverse().forEach(s=>E.app.addRecentDocument(s)),o.reverse().forEach(s=>E.app.addRecentDocument(s))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([_(0,l.ILogService),_(1,S.IWorkspacesManagementMainService),_(2,v.ILifecycleMainService),_(3,u.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(ee[276],te([0,1,14,8,22,36,4,7,166,18,28,21,6,214,58,19,34,24,49,75,30,77]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let r=class Ft{constructor(a,c,s,f,C,L,O,j,K,V,J){this.n=a,this.o=c,this.p=s,this.q=f,this.r=C,this.s=L,this.t=O,this.u=j,this.v=K,this.w=V,this.x=J,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(M.isMacintosh||(0,k.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(Ft.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,O,j)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(L,O,j)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(L,O,j)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,O,j)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,O,j)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.twitterUrl;a&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(a,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const f=this.x.licenseUrl;f&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=f.indexOf("?")>0?"&":"?";this.Z(`${f}${L}lang=${M.language}`,"openLicenseUrl")}else this.Z(f,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&f&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(C,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!M.isMacintosh)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,c){this.k=a.menus,this.l=a.keybindings,this.t.setItem(Ft.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){!M.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){!M.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=E.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(M.isMacintosh?new E.Menu:null);return}const c=new E.Menu;let s;if(M.isMacintosh){const C=new E.Menu;s=new E.MenuItem({label:this.x.nameShort,submenu:C}),this.I(C),c.append(s)}if(M.isMacintosh&&!this.c){this.c=!0;const C=new E.Menu;C.append(new E.MenuItem({label:this.bb(w.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(C)}if(this.K("File")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(1,null)),submenu:C});this.M(C,"File"),c.append(L)}if(this.K("Edit")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(2,null)),submenu:C});this.M(C,"Edit"),c.append(L)}if(this.K("Selection")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(3,null)),submenu:C});this.M(C,"Selection"),c.append(L)}if(this.K("View")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(4,null)),submenu:C});this.M(C,"View"),c.append(L)}if(this.K("Go")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(5,null)),submenu:C});this.M(C,"Go"),c.append(L)}if(this.K("Run")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(6,null)),submenu:C});this.M(C,"Run"),c.append(L)}if(this.K("Terminal")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(7,null)),submenu:C});this.M(C,"Terminal"),c.append(L)}let f;if(this.K("Window")){const C=new E.Menu;f=new E.MenuItem({label:this.bb(w.localize(8,null)),submenu:C,role:"window"}),this.S(C)}if(f&&c.append(f),this.K("Help")){const C=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(9,null)),submenu:C,role:"help"});this.M(C,"Help"),c.append(L)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const c=this.U(w.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let f;if(this.K("Preferences")){const re=new E.Menu;this.M(re,"Preferences"),f=new E.MenuItem({label:this.bb(w.localize(11,null)),submenu:re})}const C=new E.Menu,L=new E.MenuItem({label:w.localize(12,null),role:"services",submenu:C}),O=new E.MenuItem({label:w.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),j=new E.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new E.MenuItem({label:w.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.Y("workbench.action.quit",{label:w.localize(16,null,this.x.nameLong),click:async(re,se,ae)=>{const fe=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||fe?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),J=[c];J.push(...s),f&&J.push(n(),f),J.push(n(),L,n(),O,j,K,n(),V),J.forEach(re=>a.append(re))}async J(a){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(a)){const s={title:this.x.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(w.localize(17,null)),(0,R.mnemonicButtonLabel)(w.localize(18,null))],message:w.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,s);return f===0}return!0}K(a){if(!M.isMacintosh&&(0,k.getTitleBarStyle)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,c){c.forEach(s=>{if((0,h.isMenubarMenuItemSeparator)(s))a.append(n());else if((0,h.isMenubarMenuItemSubmenu)(s)){const f=new E.Menu,C=new E.MenuItem({label:this.bb(s.label),submenu:f});this.L(f,s.submenu.items),a.append(C)}else(0,h.isMenubarMenuItemRecentAction)(s)?a.append(this.O(s)):(0,h.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(a),M.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?a.append(new E.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):a.append(this.U(s.label,s.id,!1,s.checked)):a.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):a.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(a,c){this.k&&this.k[c]&&this.L(a,this.k[c].items)}N(a){const c=this.T();c.length&&(c.forEach(s=>a.append(s)),a.append(n()))}O(a){const c=I.URI.revive(a.uri),s=a.id,f=s==="openRecentFile"?{fileUri:c}:s==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.Y(s,{label:a.label,click:async(C,L,O)=>{const j=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[f],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(a){return!!(a&&(!M.isMacintosh&&(a.ctrlKey||a.shiftKey)||M.isMacintosh&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,c,s){const f={label:this.bb(a),role:s,enabled:!0};return new E.MenuItem(this.X(c,f))}S(a){const c=new E.MenuItem({label:w.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new E.MenuItem({label:w.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),f=new E.MenuItem({label:w.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.U(w.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(w.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(w.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(w.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(w.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(w.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,s,n(),C,...L,n(),f].forEach(O=>a.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(w.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:w.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(w.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:w.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(w.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:w.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(w.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(a,c,s,f){const C=this.bb(a),L=typeof c=="function"?c:(J,re,se)=>{const ae=J?J.userSettingsLabel:null;let fe=c;Array.isArray(c)&&(fe=this.P(se)?c[1]:c[0]),ae&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:fe})},O=typeof s=="boolean"?s:this.p.getWindowCount()>0,j=typeof f=="boolean"?f:!1,K={label:C,click:L,enabled:O};j&&(K.type="checkbox",K.checked=j);let V;return typeof c=="string"?V=c:Array.isArray(c)&&(V=c[0]),M.isMacintosh&&(V==="editor.action.clipboardCutAction"?K.role="cut":V==="editor.action.clipboardCopyAction"?K.role="copy":V==="editor.action.clipboardPasteAction"&&(K.role="paste"),V==="undo"?K.click=this.V(L,{inDevTools:J=>J.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?K.click=this.V(L,{inDevTools:J=>J.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(K.click=this.V(L,{inDevTools:J=>J.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(V,K))}V(a,c){return(s,f,C)=>{const L=E.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);a(s,f||L,C)}}W(a){let c=E.BrowserWindow.getFocusedWindow();if(!c){const f=this.p.getLastActiveWindow();f?.isMinimized()&&(c=f.win)}const s=c?this.p.getWindowById(c.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",a),M.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const f={id:a.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",P.CancellationToken.None,f)}else{const f={userSettingsLabel:a.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,f)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,c){const s=typeof a=="string"?this.l[a]:void 0;if(s?.label){if(s.isNative!==!1)c.accelerator=s.label,c.userSettingsLabel=s.userSettingsLabel;else if(typeof c.label=="string"){const f=c.label.indexOf("[");f>=0?c.label=`${c.label.substr(0,f)} [${s.label}]`:c.label=`${c.label} [${s.label}]`}}else c.accelerator=void 0;return c}Y(a,c,s=!c.accelerator){s&&(c=this.X(a,c));const f=c.click;return c.click=(C,L,O)=>{this.ab(a),f?.(C,L,O)},c}Z(a,c){this.w.openExternal(void 0,a),this.ab(c)}ab(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:i})}bb(a){return(0,R.mnemonicMenuLabel)(a,!this.B)}};r.a="lastKnownMenubarData",r=pe([_(0,g.IUpdateService),_(1,m.IConfigurationService),_(2,S.IWindowsMainService),_(3,p.IEnvironmentMainService),_(4,u.ITelemetryService),_(5,D.IWorkspacesHistoryMainService),_(6,l.IStateMainService),_(7,y.ILifecycleMainService),_(8,b.ILogService),_(9,d.INativeHostMainService),_(10,v.IProductService)],r),e.Menubar=r;function n(){return new E.MenuItem({type:"separator"})}}),define(ee[277],te([0,1,5,21,6,276]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let M=class{constructor(w,m,p){this.b=w,this.c=m,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(w,m){this.d.trace("menubarService#updateMenubar",w),(await this.a).updateMenu(m,w)}};M=pe([_(0,E.IInstantiationService),_(1,t.ILifecycleMainService),_(2,P.ILogService)],M),e.MenubarMainService=M}),define(ee[278],te([0,1,14,23,26,25,22,3,32,50,36,2,15,9,63,4,35,20,11,7,174,62,18,57,28,16,5,21,6,64,19,65,55,34,75,275,119,270,29,96,77,53,67,38,52]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n,o,a,c,s,f,C,L,O,j,K,V,J,re,se,ae,fe,ge,q,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(x){return(0,se.isWorkspaceIdentifier)(x?.workspace)}function Q(x){return(0,se.isSingleFolderWorkspaceIdentifier)(x?.workspace)}let ne=class mt extends y.Disposable{constructor(A,F,W,N,$,G,B,X,Z,oe,de,ke,De,Pe,Ae,ve,me,ye){super(),this.k=A,this.l=F,this.m=W,this.n=N,this.r=$,this.s=G,this.t=B,this.u=X,this.v=Z,this.w=oe,this.z=de,this.C=ke,this.D=De,this.F=Pe,this.G=Ae,this.H=ve,this.I=me,this.J=ye,this.b=this.B(new I.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new I.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new I.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new I.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new I.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new re.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(A=>this.c.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new y.DisposableStore;if(F.add(I.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const W of A.config.extensionDevelopmentPath)F.add(this.I.addValidFileRoot(W));A.config.extensionTestsPath&&F.add(this.I.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,F){const W=this.s.args,N=F?.remoteAuthority||void 0,$=!0,G=F?.forceReuseWindow,B=!G;return this.open({...A,cli:W,forceEmpty:$,forceNewWindow:B,forceReuseWindow:G,remoteAuthority:N})}openExistingWindow(A,F){A.focus(),this.M(F,[A])}async open(A){this.m.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],W=[],N=[],$=[],G=[];let B,X=0;const Z=await this.S(A);this.m.trace("windowsManager#open pathsToOpen",Z);for(const Pe of Z)Q(Pe)?A.addMode?F.push(Pe):W.push(Pe):z(Pe)?N.push(Pe):Pe.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),B.filesToOpenOrCreate.push(Pe)):Pe.backupPath?G.push({backupFolder:(0,h.basename)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):X++;A.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),A.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&A.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?($.push(...this.C.getUntitledWorkspaces()),N.push(...$),G.push(...this.v.getEmptyWindowBackups())):G.length=0;const{windows:oe,filesOpenedInWindow:de}=await this.N(A,N,W,G,X,B,F);if(this.m.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${W.length}, emptyToRestore: ${G.length}, emptyToOpen: ${X})`),oe.length>1)if(de)de.focus();else{const Pe=this.j.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Ae=!0,ve=!0;if(Pe){const me=oe.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,ve=!1)}if(Ae)for(let me=oe.length-1;me>=0;me--){const ye=oe[me];if(!(ye.openedWorkspace&&$.some(Me=>ye.openedWorkspace&&Me.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&G.some(Me=>ye.backupPath&&Me.backupFolder===(0,h.basename)(ye.backupPath)))){ye.focus(),ve=!1;break}}ve&&oe[oe.length-1].focus()}const ke=B&&B.filesToDiff.length>0,De=B&&B.filesToMerge.length>0;if(!oe.some(Pe=>Pe.isExtensionDevelopmentHost)&&!ke&&!De&&!A.noRecentEntry){const Pe=[];for(const Ae of Z)z(Ae)&&!Ae.transient?Pe.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):Q(Ae)?Pe.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Pe.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.z.addRecentlyOpened(Pe)}return this.M(A,oe),oe}M(A,F){const W=A.waitMarkerFileURI;A.context===0&&W&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.G.del(W)}catch{}})()}async N(A,F,W,N,$,G,B){const X=[];let Z;function oe(me,ye){X.push(me),ye&&(Z=me,G=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:ke}=this.fb(A);if(!A.initialStartup&&B.length>0){const me=B[0].remoteAuthority,ye=this.kb(me);ye&&oe(this.P(ye,B.map(Me=>Me.workspace.uri)))}const De=W.length+F.length+N.length;if(G&&De===0){const me=G.filesToOpenOrCreate[0]||G.filesToDiff[0]||G.filesToMerge[3],ye=this.getWindows().filter(ie=>G&&(0,u.isEqualAuthority)(ie.remoteAuthority,G.remoteAuthority));let Me;me?.fileUri&&!ke&&((A.context===4||A.context===0||A.context===1)&&(Me=await(0,J.findWindowOnFile)(ye,me.fileUri,async ie=>ie.configPath.scheme===b.Schemas.file?this.C.resolveLocalWorkspace(ie.configPath):void 0)),Me||(Me=this.lb(ye))),Me?(0,se.isWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?W.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):oe(this.O(A,Me,G),!0):oe(await this.gb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:G,forceNewWindow:!0,remoteAuthority:G.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Pe=(0,R.distinct)(F,me=>me.workspace.id);if(Pe.length>0){const me=(0,R.coalesce)(Pe.map(ye=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(me.length>0){const ye=me[0],Me=(0,u.isEqualAuthority)(G?.remoteAuthority,ye.remoteAuthority)?G:void 0;oe(this.O(A,ye,Me),!!Me),de=!0}for(const ye of Pe){if(me.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===ye.workspace.id))continue;const Me=ye.remoteAuthority,ie=(0,u.isEqualAuthority)(G?.remoteAuthority,Me)?G:void 0;oe(await this.R(A,ye,de,ie),!!ie),de=!0}}const Ae=(0,R.distinct)(W,me=>u.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(ye=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(me.length>0){const ye=me[0],Me=(0,u.isEqualAuthority)(G?.remoteAuthority,ye.remoteAuthority)?G:void 0;oe(this.O(A,ye,Me),!!Me),de=!0}for(const ye of Ae){if(me.some(ue=>(0,se.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,ye.workspace.uri)))continue;const Me=ye.remoteAuthority,ie=(0,u.isEqualAuthority)(G?.remoteAuthority,Me)?G:void 0;oe(await this.R(A,ye,de,ie),!!ie),de=!0}}const ve=(0,R.distinct)(N,me=>me.backupFolder);if(ve.length>0)for(const me of ve){const ye=me.remoteAuthority,Me=(0,u.isEqualAuthority)(G?.remoteAuthority,ye)?G:void 0;oe(await this.Q(A,!0,ye,Me,me),!!Me),de=!0}if(X.length===0||G){G&&!$&&$++;const me=G?G.remoteAuthority:A.remoteAuthority;for(let ye=0;ye<$;ye++)oe(await this.Q(A,de,me,G),!!G),de=!0}return{windows:(0,R.distinct)(X),filesOpenedInWindow:Z}}O(A,F,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),F.focus();const N={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",M.CancellationToken.None,N),F}P(A,F){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),A.focus();const W={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",M.CancellationToken.None,W),A}Q(A,F,W,N,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:W,filesToOpen:N,forceNewWindow:F});let G;return!F&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.gb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:G,emptyWindowBackupInfo:$,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}R(A,F,W,N,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:N}),!W&&!$&&typeof A.contextWindowId=="number"&&($=this.getWindowById(A.contextWindowId)),this.gb({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:$,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async S(A){let F,W=!1,N=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=await this.U(A),W=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=await this.W(A.cli),F.length===0&&F.push(Object.create(null)),W=!0):(F=await this.Y(),F.length===0&&F.push(Object.create(null)),N=!0),!A.addMode&&W){const $=F.filter(G=>Q(G));if($.length>1){const G=$[0].remoteAuthority;if($.every(B=>(0,u.isEqualAuthority)(B.remoteAuthority,G))){const B=await this.C.createUntitledWorkspace($.map(X=>({uri:X.workspace.uri})));F.push({workspace:B,remoteAuthority:G}),F=F.filter(X=>!Q(X))}}}if(A.initialStartup&&!N&&this.w.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();F.unshift(...$.filter(G=>z(G)||Q(G)||G.backupPath))}return F}async U(A){const F={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},W=await Promise.all((0,R.coalesce)(A.urisToOpen||[]).map(async N=>{const $=await this.ab(N,F);if($)return $.label=N.label,$;const G=this.cb(N),B={title:this.H.nameLong,type:"info",buttons:[(0,p.mnemonicButtonLabel)((0,S.localize)(0,null))],defaultId:0,message:G.scheme===b.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:G.scheme===b.Schemas.file?(0,S.localize)(3,null,(0,p.getPathLabel)(G,{os:v.OS,tildify:this.s})):(0,S.localize)(4,null,G.toString(!0)),noLink:!0};this.F.showMessageBox(B,(0,g.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async W(A){const F=[],W={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},N=A["folder-uri"];if(N){const B=await Promise.all(N.map(X=>{const Z=this.X(X);if(!!Z)return this.ab({folderUri:Z},W)}));F.push(...(0,R.coalesce)(B))}const $=A["file-uri"];if($){const B=await Promise.all($.map(X=>{const Z=this.X(X);if(!!Z)return this.ab((0,se.hasWorkspaceFileExtension)(X)?{workspaceUri:Z}:{fileUri:Z},W)}));F.push(...(0,R.coalesce)(B))}const G=await Promise.all(A._.map(B=>W.remoteAuthority?this.eb(B,W):this.db(B,W)));return F.push(...(0,R.coalesce)(G)),F}X(A){try{const F=k.URI.parse(A);if(!F.scheme){this.m.error(`Invalid URI input string, scheme missing: ${A}`);return}return F}catch(F){this.m.error(`Invalid URI input string: ${A}, ${F.message}`)}}async Y(){const A=this.Z();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];A!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const W=await Promise.all(F.map(async N=>{if(N.workspace){const $=await this.ab({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});if(z($))return $}else if(N.folderUri){const $=await this.ab({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});if(Q($))return $}else if(A!=="folders"&&N.backupPath)return{backupPath:N.backupPath,remoteAuthority:N.remoteAuthority}}));return(0,R.coalesce)(W)}}}Z(){let A;return this.u.wasRestarted?A="all":(A=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ab(A,F=Object.create(null)){const W=this.cb(A);return W.scheme===b.Schemas.file?((0,K.isFileToOpen)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,F)):this.bb(A,F)}bb(A,F){let W=this.cb(A);const N=(0,O.getRemoteAuthority)(W)||F.remoteAuthority;if(W=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(W)),(0,K.isFileToOpen)(A)){if(F.gotoLineMode){const{path:$,line:G,column:B}=(0,w.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:$}),options:{selection:G?{startLineNumber:G,startColumn:B||1}:void 0},remoteAuthority:N}}return{fileUri:W,remoteAuthority:N}}else if((0,K.isWorkspaceToOpen)(A))return{workspace:(0,ae.getWorkspaceIdentifier)(W),remoteAuthority:N};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:N}}cb(A){return(0,K.isWorkspaceToOpen)(A)?A.workspaceUri:(0,K.isFolderToOpen)(A)?A.folderUri:A.fileUri}async db(A,F){let W,N;F.gotoLineMode&&({path:A,line:W,column:N}=(0,w.parseLineAndColumnAware)(A)),A=(0,w.sanitizeFilePath)((0,h.normalize)(A),(0,l.cwd)());try{const $=await t.Promises.stat(A);if($.isFile()){if(!F.forceOpenWorkspaceAsFile){const G=await this.C.resolveLocalWorkspace(k.URI.file(A));if(G)return G.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:G.id,configPath:G.configPath},type:o.FileType.File,exists:!0,remoteAuthority:G.remoteAuthority,transient:G.transient}}return{fileUri:k.URI.file(A),type:o.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:N||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(k.URI.file(A),$),type:o.FileType.Directory,exists:!0};if(!v.isWindows&&A==="/dev/null")return{fileUri:k.URI.file(A),type:o.FileType.File,exists:!0}}}catch{const G=k.URI.file(A);if(this.z.removeRecentlyOpened([G]),F.ignoreFileNotFound)return{fileUri:G,type:o.FileType.File,exists:!1}}}eb(A,F){const W=A.charCodeAt(0),N=F.remoteAuthority;let $,G;F.gotoLineMode&&({path:A,line:$,column:G}=(0,w.parseLineAndColumnAware)(A)),W!==47&&((0,w.isWindowsDriveLetter)(W)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,w.toSlashes)(A)),A=`/${A}`);const B=k.URI.from({scheme:b.Schemas.vscodeRemote,authority:N,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return F.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:$?{startLineNumber:$,startColumn:G||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(B),remoteAuthority:N};if(F.gotoLineMode||h.posix.basename(A).indexOf(".")!==-1)return{fileUri:B,options:{selection:$?{startLineNumber:$,startColumn:G||1}:void 0},remoteAuthority:N}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:N}}fb(A){const F=this.w.getValue("window"),W=F?.openFoldersInNewWindow||"default",N=F?.openFilesInNewWindow||"off";let $=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(W==="on"||W==="off")&&($=W==="on");let G=!1;return A.forceNewWindow||A.forceReuseWindow?G=!!A.forceNewWindow&&!A.forceReuseWindow:(v.isMacintosh?A.context===1&&(G=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(G=!0),!A.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(G=N==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:G}}async openExtensionDevelopmentHostWindow(A,F){const W=(0,J.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(W)return this.u.reload(W,F.cli),W.focus(),[W];let N=F.cli["folder-uri"]||[],$=F.cli["file-uri"]||[],G=F.cli._;if(!G.length&&!N.length&&!$.length&&!F.cli.extensionTestsPath){const Z=this.j.state.lastPluginDevelopmentHostWindow,oe=Z?.workspace??Z?.folderUri;oe&&(k.URI.isUri(oe)?oe.scheme===b.Schemas.file?G=[oe.fsPath]:N=[oe.toString()]:oe.configPath.scheme===b.Schemas.file?G=[(0,u.originalFSPath)(oe.configPath)]:$=[oe.configPath.toString()])}let B=F.remoteAuthority;for(const Z of A)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=k.URI.parse(Z),de=(0,O.getRemoteAuthority)(oe);de&&(B?(0,u.isEqualAuthority)(de,B)||this.m.error("more than one extension development path authority"):B=de)}G=G.filter(Z=>{const oe=k.URI.file(Z);return(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(oe),B)}),N=N.filter(Z=>{const oe=this.X(Z);return oe&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(oe),B):!1}),$=$.filter(Z=>{const oe=this.X(Z);return oe&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(oe),B):!1}),F.cli._=G,F.cli["folder-uri"]=N,F.cli["file-uri"]=$;const X={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!G.length&&!N.length&&!$.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:B,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(X)}async gb(A){const F=this.w.getValue("window");let W;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(W=A.windowToUse||this.getLastActiveWindow(),W&&W.focus());const N={...this.s.args,...A.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,h.join)(this.s.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:this.t.defaultProfile},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.l,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:f.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,P.release)(),hostname:(0,P.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(W){const $=W.config;!N.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=$.extensionDevelopmentPath,N.extensionDevelopmentKind=$.extensionDevelopmentKind,N["enable-proposed-api"]=$["enable-proposed-api"],N.verbose=$.verbose,N["inspect-extensions"]=$["inspect-extensions"],N["inspect-brk-extensions"]=$["inspect-brk-extensions"],N.debugId=$.debugId,N.extensionEnvironment=$.extensionEnvironment,N["extensions-dir"]=$["extensions-dir"],N["disable-extensions"]=$["disable-extensions"])}else{const $=this.j.getNewWindowState(N);(0,d.mark)("code/willCreateCodeWindow");const G=W=this.D.createInstance(V.CodeWindow,{state:$,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(G),mt.a.push(G),this.b.fire(G),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(G.onDidSignalReady)(()=>this.c.fire(G)),(0,m.once)(G.onDidClose)(()=>this.jb(G)),(0,m.once)(G.onDidDestroy)(()=>this.f.fire(G)),G.onDidTriggerSystemContextMenu(({x:X,y:Z})=>this.h.fire({window:G,x:X,y:Z}));const B=(0,g.assertIsDefined)(G.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.u.reload(G)),this.u.registerWindow(G)}return N.windowId=W.id,W.isReady?this.u.unload(W,4).then(async $=>{$||await this.hb(W,N,A)}):await this.hb(W,N,A),W}async hb(A,F,W){if(F.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.v.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.v.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.v.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.t.isEnabled()){const N=F.workspace??(0,se.toWorkspaceIdentifier)(F.backupPath,!1),$=this.ib(W,N),G=$ instanceof Promise?await $:$;F.profiles.profile=G,F.extensionDevelopmentPath||await this.t.setProfileForWorkspace(N,G)}A.load(F)}ib(A,F){return A.forceProfile?this.t.profiles.find(W=>W.name===A.forceProfile)??this.t.createNamedProfile(A.forceProfile):A.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(F)??this.t.defaultProfile}jb(A){const F=mt.a.indexOf(A);mt.a.splice(F,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=E.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(A){return this.lb(this.getWindows().filter(F=>(0,u.isEqualAuthority)(F.remoteAuthority,A)))}lb(A){const F=Math.max.apply(Math,A.map(W=>W.lastFocusTime));return A.find(W=>W.lastFocusTime===F)}sendToFocused(A,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,M.CancellationToken.None,...F)}sendToAll(A,F,W){for(const N of this.getWindows())W&&W.indexOf(N.id)>=0||N.sendWhenReady(A,M.CancellationToken.None,F)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(A){const F=this.getWindows().filter(W=>W.id===A);return(0,R.firstOrDefault)(F)}getWindowByWebContents(A){const F=E.BrowserWindow.fromWebContents(A);if(!!F)return this.getWindowById(F.id)}};ne.a=[],ne=pe([_(2,s.ILogService),_(3,j.IStateMainService),_(4,T.IPolicyService),_(5,n.IEnvironmentMainService),_(6,U.IUserDataProfilesMainService),_(7,c.ILifecycleMainService),_(8,D.IBackupMainService),_(9,i.IConfigurationService),_(10,fe.IWorkspacesHistoryMainService),_(11,ge.IWorkspacesManagementMainService),_(12,a.IInstantiationService),_(13,r.IDialogMainService),_(14,o.IFileService),_(15,C.IProductService),_(16,L.IProtocolMainService),_(17,q.IThemeMainService)],ne),e.WindowsMainService=ne}),define(ee[279],te([0,1,62,30,77,53]),function(H,e,E,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(w,m,p,y){this.a=w,this.b=m,this.c=p,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(w,m){const p=this.b.getWindowById(w);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),m)}createUntitledWorkspace(w,m,p){return this.a.createUntitledWorkspace(m,p)}deleteUntitledWorkspace(w,m){return this.a.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(w,m){return this.a.getWorkspaceIdentifier(m)}getRecentlyOpened(w){return this.c.getRecentlyOpened()}addRecentlyOpened(w,m){return this.c.addRecentlyOpened(m)}removeRecentlyOpened(w,m){return this.c.removeRecentlyOpened(m)}clearRecentlyOpened(w){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};M=pe([_(0,R.IWorkspacesManagementMainService),_(1,t.IWindowsMainService),_(2,P.IWorkspacesHistoryMainService),_(3,E.IBackupMainService)],M),e.WorkspacesMainService=M}),define(ee[280],te([0,1,14,42,26,17,45,13,32,50,43,36,2,15,9,4,11,7,31,133,47,147,104,253,150,62,271,18,73,182,86,120,57,107,205,28,61,111,195,217,196,258,108,197,198,16,209,88,72,5,87,272,230,255,21,6,211,277,58,19,55,265,90,34,261,94,91,24,235,113,51,49,244,245,273,246,274,116,248,249,250,251,259,30,278,260,29,95,77,279,53,254,38,216,52,226,56,76,118,263,269,267,8,114,262]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n,o,a,c,s,f,C,L,O,j,K,V,J,re,se,ae,fe,ge,q,T,U,z,Q,ne,x,A,F,W,N,$,G,B,X,Z,oe,de,ke,De,Pe,Ae,ve,me,ye,Me,ie,ue,he,be,Ce,We,Te,qe,Ue,je,Xe,$e,Ke,Y,ce,le,we,Se,Oe,Be,it,xe,He,tt,nt,lt,at,Bt,$t,zt,qt,Ht,Vt,Gt,Pt,Kt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends b.Disposable{constructor(Ee,Re,Le,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=Re,this.g=Le,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${h.Schemas.vscodeWebview}://`),Re=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(Re.has(Ge)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Re.has(Ge):!1);const Le=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=u.URI.parse(Ne.url);return Je.scheme===h.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===h.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Le.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=u.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Le.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=E.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,d.join)(this.i.codeCachePath,"chrome"))}s(){(0,I.setUnexpectedErrorHandler)(Le=>this.u(Le)),process.on("uncaughtException",Le=>(0,I.onUnexpectedError)(Le)),process.on("unhandledRejection",Le=>(0,I.onUnexpectedError)(Le)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Le,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),E.app.on("activate",async(Le,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Le,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Re;E.app.on("open-file",(Le,Ie)=>{this.h.trace("app#open-file: ",Ie),Le.preventDefault(),Ee.push((0,Oe.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),Re!==void 0&&(clearTimeout(Re),Re=void 0),Re=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Re=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Le=>{const Ie=this.a?.getWindowByWebContents(Le.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Le,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Le,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Le=>Le.sender.reload())}t(Ee){let Re;for(const Le of Ee)typeof Le=="string"&&(typeof Re!="string"?Re=Le:Re=(0,d.join)(Re,Le));if(!(typeof Re!="string"||!(0,d.isAbsolute)(Re)||!(0,w.isEqualOrParent)(Re,this.i.cachedLanguagesPath,!v.isLinux)))return u.URI.file(Re)}u(Ee){if(Ee){const Re={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Re))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;v.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{v.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Re=new D.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Re.dispose()}),this.h.trace("Resolving machine identifier...");const Le=await(0,Kt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Le}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Le),_e=await this.y(Le,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Re,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Re)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(r.ProxyAuthHandler)),this.B(Ee.createInstance(Vt.UserDataProfilesHandler))}w(Ee){const Re=this.B(this.g.createInstance(De.SharedProcess,Ee,this.f)),Le=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Re.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Re.whenReady(),Le))();return{sharedProcess:Re,sharedProcessReady:Ie,sharedProcessClient:Le}}async y(Ee,Re,Le){const Ie=new F.ServiceCollection;switch(process.platform){case"win32":Ie.set(be.IUpdateService,new x.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":v.isLinuxSnap?Ie.set(be.IUpdateService,new x.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(be.IUpdateService,new x.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(be.IUpdateService,new x.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(le.IWindowsMainService,new x.SyncDescriptor(we.WindowsMainService,[Ee,this.f],!1));const Fe=new O.DialogMainService(this.h);Ie.set(O.IDialogMainService,Fe),Ie.set($.ILaunchMainService,new x.SyncDescriptor($.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new x.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(C.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(Le.then(et=>et.getChannel("diagnostics"))))),Ie.set(W.IIssueMainService,new x.SyncDescriptor(W.IssueMainService,[this.f])),Ie.set(j.IEncryptionMainService,new x.SyncDescriptor(K.EncryptionMainService,[Ee])),Ie.set(N.IKeyboardLayoutMainService,new x.SyncDescriptor(N.KeyboardLayoutMainService)),Ie.set(oe.INativeHostMainService,new x.SyncDescriptor(oe.NativeHostMainService,[Re],!1)),Ie.set(s.ICredentialsMainService,new x.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(Y.IWebviewManagerService,new x.SyncDescriptor(ce.WebviewMainService)),Ie.set(Z.IMenubarMainService,new x.SyncDescriptor(Z.MenubarMainService)),Ie.set(se.IExtensionUrlTrustService,new x.SyncDescriptor(ae.ExtensionUrlTrustService)),Ie.set(fe.IExtensionHostStarter,new x.SyncDescriptor(ge.ExtensionHostStarter)),Ie.set(me.IStorageMainService,new x.SyncDescriptor(me.StorageMainService)),Ie.set(me.IApplicationStorageMainService,new x.SyncDescriptor(me.ApplicationStorageMainService)),v.isWindows?Ie.set(q.IExternalTerminalMainService,new x.SyncDescriptor(T.WindowsExternalTerminalService)):v.isMacintosh?Ie.set(q.IExternalTerminalMainService,new x.SyncDescriptor(T.MacExternalTerminalService)):v.isLinux&&Ie.set(q.IExternalTerminalMainService,new x.SyncDescriptor(T.LinuxExternalTerminalService));const ze=new a.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(o.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(Be.IWorkspacesService,new x.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new x.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new x.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,he.supportsTelemetry)(this.n,this.i)){const et=(0,he.isInternalTelemetry)(this.n,this.k),Ne=(0,S.getDelayedChannel)(Le.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new ie.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,P.release)(),(0,P.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,he.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Me.ITelemetryService,new x.SyncDescriptor(ue.TelemetryService,[st],!1))}else Ie.set(Me.ITelemetryService,he.NullTelemetryService);return Ie.set(zt.IExtensionsProfileScannerService,new x.SyncDescriptor(Jt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(qt.IExtensionsScannerService,new x.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Re,Le){const Ie=S.ProxyChannel.fromService(Ee.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=S.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Re.registerChannel("policy",ze),Le.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(h.Schemas.file);(0,l.assertType)(_e instanceof ne.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(_e,this.h,this.i);Re.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Le.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=S.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Re.registerChannel("userDataProfiles",Ne),Le.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new Bt.RequestChannel(Ee.get($t.IRequestService));Le.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Ce.UpdateChannel(Ee.get(be.IUpdateService));Re.registerChannel("update",Je);const Ze=S.ProxyChannel.fromService(Ee.get(W.IIssueMainService));Re.registerChannel("issue",Ze);const st=S.ProxyChannel.fromService(Ee.get(j.IEncryptionMainService));Re.registerChannel("encryption",st);const ct=S.ProxyChannel.fromService(Ee.get(s.ICredentialsMainService));Re.registerChannel("credentials",ct);const kt=S.ProxyChannel.fromService(Ee.get(Pe.ISignService));Re.registerChannel("sign",kt);const Qe=S.ProxyChannel.fromService(Ee.get(N.IKeyboardLayoutMainService));Re.registerChannel("keyboardLayout",Qe),this.b=Ee.get(oe.INativeHostMainService);const wt=S.ProxyChannel.fromService(this.b);Re.registerChannel("nativeHost",wt),Le.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=S.ProxyChannel.fromService(Ee.get(Be.IWorkspacesService));Re.registerChannel("workspaces",pt);const yt=S.ProxyChannel.fromService(Ee.get(Z.IMenubarMainService));Re.registerChannel("menubar",yt);const Dt=S.ProxyChannel.fromService(Ee.get(je.IURLService));Re.registerChannel("url",Dt);const Rt=S.ProxyChannel.fromService(Ee.get(se.IExtensionUrlTrustService));Re.registerChannel("extensionUrlTrust",Rt);const vt=S.ProxyChannel.fromService(Ee.get(Y.IWebviewManagerService));Re.registerChannel("webview",vt);const ut=this.B(new ve.StorageDatabaseChannel(this.h,Ee.get(me.IStorageMainService)));Re.registerChannel("storage",ut),Le.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Gt.ProfileStorageChangesListenerChannel(Ee.get(me.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Le.then(Ye=>Ye.registerChannel("profileStorageListener",St));const bt=S.ProxyChannel.fromService(Ee.get(q.IExternalTerminalMainService));Re.registerChannel("externalTerminal",bt);const ht=new X.LogLevelChannel(Ee.get(B.ILogService),Ee.get(B.ILoggerService));Re.registerChannel("logLevel",ht),Le.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new X.LoggerChannel(Ee.get(B.ILoggerService));Re.registerChannel("logger",Ve),Le.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new f.ElectronExtensionHostDebugBroadcastChannel(Ee.get(le.IWindowsMainService));Re.registerChannel("extensionhostdebugservice",ot);const ft=S.ProxyChannel.fromService(Ee.get(fe.IExtensionHostStarter));Re.registerChannel(fe.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Re){const Le=this.a=Ee.get(le.IWindowsMainService),Ie=Ee.get(je.IURLService),Fe=Ee.get(oe.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:u.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:u.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=v.isMacintosh&&Le.getWindowCount()===0;const Wt=Ye.get("continueOn");Wt!==null&&(Ne.continueOn=Wt??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Mt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Mt),Mt){const[At]=await Le.open({context:5,cli:{...Ne.args},urisToOpen:[Mt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Le.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new S.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),kt=Re.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Le,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,J.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Rt=!!Qe["file-uri"],vt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,bt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Le.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Rt){if(Qe["new-window"]||bt||ht)return Le.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht});if(wt.length)return Le.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Oe.hasWorkspaceFileExtension)(Ve)?{workspaceUri:u.URI.file(Ve)}:{fileUri:u.URI.file(Ve)}),noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0})}return Le.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:vt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===h.Schemas.file&&v.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,y.getPathLabel)(Ee,{os:v.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===h.Schemas.file){const Re=u.URI.file(Ee.fsPath);return(0,Oe.hasWorkspaceFileExtension)(Re)?{workspaceUri:Re}:{fileUri:Re}}else if(Ee.authority===h.Schemas.vscodeRemote){const Re=Ee.path.indexOf(d.posix.sep,1);if(Re!==-1){const Le=Ee.path.substring(1,Re),Ie=Ee.path.substring(Re),Fe=u.URI.from({scheme:h.Schemas.vscodeRemote,authority:Le,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Oe.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Re){const Le=Ee.get(Me.ITelemetryService),Ie=Ee.get(be.IUpdateService);this.j.phase=3,this.I(Le,Re),this.H(),E.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(v.isWindows&&Ee)try{const Re=await new Promise((Ie,Fe)=>{H(["windows-mutex"],Ie,Fe)}),Le=new Re.Mutex(Ee);(0,m.once)(this.j.onWillShutdown)(()=>Le.release())}catch(Re){this.h.error(Re)}}I(Ee,Re){let Le=!1;(0,m.once)(this.j.onWillShutdown)(()=>Le=!0),this.B(Re.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Re.isVisible(),shuttingdown:Le})}))}async J(Ee,Re,Le){try{return await(0,re.getResolvedShellEnv)(this.k,this.h,Ee,Re)}catch(Ie){const Fe=(0,M.toErrorMessage)(Ie);Le?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Re=(await this.m.readFile(this.i.argvResource)).value.toString(),Le=JSON.parse((0,p.stripComments)(Re)),Fe=(0,he.getTelemetryLevel)(this.k)>=1;if(Le["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],_e=Re.substring(0,Re.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(_e))}else{const ze=Re.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Re&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([_(2,A.IInstantiationService),_(3,B.ILogService),_(4,V.IEnvironmentMainService),_(5,G.ILifecycleMainService),_(6,c.IConfigurationService),_(7,Ae.IStateMainService),_(8,z.IFileService),_(9,de.IProductService),_(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(ee[281],te([0,1,38,8,288,2,6]),function(H,e,E,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends E.AbstractPolicyService{constructor(m,p){super(),this.j=m,this.k=p,this.a=new t.Throttler,this.b=this.B(new R.MutableDisposable)}async i(m){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`),await this.a.queue(()=>new Promise((p,y)=>{try{this.b.value=(0,P.createWatcher)(this.k,m,b=>{this.m(b),p()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),y(b)}}))}m(m){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const p in m){const y=m[p];y===void 0?this.g.delete(p):this.g.set(p,y)}this.h.fire(Object.keys(m))}};I=pe([_(0,M.ILogService)],I),e.NativePolicyService=I}),define(ee[282],te([0,1,228,8,17,13,2,11,18,33,111,6,227,289]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends M.Disposable{constructor(l,u,g){super(),this.h=l,this.i=u,this.j=g,this.k(),this.B(l.onDidChangeConfiguration(k=>{k.affectsConfiguration("http")&&this.k()}))}k(){const l=this.h.getValue("http");this.a=l?.proxy,this.b=!!l?.proxyStrictSSL,this.f=l?.proxyAuthorization}async request(l,u){this.j.trace("RequestService#request (node) - begin",l.url);const{a:g,b:k}=this;let S;try{S=await(0,p.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const D={...process.env,...S},i=l.agent?l.agent:await(0,b.getProxyAgent)(l.url||"",D,{proxyUrl:g,strictSSL:k});l.agent=i,l.strictSSL=k,this.f&&(l.headers={...l.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(l,u);return this.j.trace("RequestService#request (node) - success",l.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",l.url,r),r}}async l(l){return((0,E.parse)(l.url).protocol==="https:"?await new Promise((k,S)=>{H(["https"],k,S)}):await new Promise((k,S)=>{H(["http"],k,S)})).request}m(l,u){return t.Promises.withAsyncBody(async(g,k)=>{const S=(0,E.parse)(l.url),D=l.getRawRequest?l.getRawRequest(l):await this.l(l),i={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(i.auth=l.user+":"+l.password);const r=D(i,n=>{const o=(0,I.isNumber)(l.followRedirects)?l.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)this.m({...l,url:n.headers.location,followRedirects:o-1},u).then(g,k);else{let a=n;!l.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,h.createGunzip)())),g({res:n,stream:(0,P.streamToBufferReadableStream)(a)})}});r.on("error",k),l.timeout&&r.setTimeout(l.timeout),l.isChromiumNetwork&&r.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&r.write(l.data),r.end(),u.onCancellationRequested(()=>{r.abort(),k(new R.CancellationError)})})}async resolveProxy(l){}};d=pe([_(0,w.IConfigurationService),_(1,m.INativeEnvironmentService),_(2,y.ILogService)],d),e.RequestService=d}),define(ee[283],te([0,1,14,282]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function P(M){return E.net.request}class R extends t.RequestService{request(I,w){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},w)}}e.RequestMainService=R}),define(ee[290],te([0,1,14,41,7,25,8,45,13,32,50,36,15,9,63,4,35,27,23,47,85,280,10,18,221,234,28,61,186,16,207,88,72,203,87,21,210,6,213,64,19,65,264,115,242,56,283,90,229,34,233,51,67,52,38,281,215,2,39,247,37,243]),function(H,e,E,t,P,R,M,I,w,m,p,y,b,h,d,v,l,u,g,k,S,D,i,r,n,o,a,c,s,f,C,L,O,j,K,V,J,re,se,ae,fe,ge,q,T,U,z,Q,ne,x,A,F,W,N,$,G,B,X,Z,oe,de,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class De{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,w.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,me,ye,Me,ie,ue,he,be]=this.b();try{try{await this.d(ye,be,Me,ie,he)}catch(Ce){throw this.f(ye,he.nameLong,Ce),Ce}await ve.invokeFunction(async Ce=>{const We=Ce.get(re.ILogService),Te=Ce.get(V.ILifecycleMainService),qe=Ce.get(f.IFileService),Ue=Ce.get(re.ILoggerService),je=await this.e(We,ye,Te,ve,he,!0);return g.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),ue.logger=Ue.createLogger(P.URI.file((0,h.join)(ye.logsPath,"main.log")),{name:"main"}),(0,p.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),Me.dispose(),Xe.join(g.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),ve.createInstance(D.CodeApplication,je,me).startup()})}catch(Ce){ve.invokeFunction(this.i,Ce)}}b(){const ve=new K.ServiceCollection,me=new Z.DisposableStore;process.once("exit",()=>me.dispose());const ye={_serviceBrand:void 0,...ae.default};ve.set(fe.IProductService,ye);const Me=new a.EnvironmentMainService(this.j(),ye),ie=this.c(Me);ve.set(a.IEnvironmentMainService,Me);const ue=new J.BufferLogService,he=me.add(new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(Me)),ue]));ve.set(re.ILogService,he);const be=new C.FileService(he);ve.set(f.IFileService,be);const Ce=new L.DiskFileSystemProvider(he);be.registerProvider(b.Schemas.file,Ce);const We=new de.UriIdentityService(be);ve.set(oe.IUriIdentityService,We),ve.set(re.ILoggerService,new se.LoggerService(he));const Te=new F.StateMainService(Me,he,be);ve.set(A.IStateMainService,Te);const qe=new $.UserDataProfilesMainService(Te,We,Me,be,he);ve.set($.IUserDataProfilesMainService,qe);const Ue=v.isWindows&&ye.win32RegValueName?me.add(new B.NativePolicyService(he,ye.win32RegValueName)):Me.policyFile?me.add(new X.FilePolicyService(Me.policyFile,be,he)):new G.NullPolicyService;ve.set(G.IPolicyService,Ue);const je=new n.ConfigurationService(qe.defaultProfile.settingsResource,be,Ue,he);return ve.set(r.IConfigurationService,je),ve.set(V.ILifecycleMainService,new O.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(z.IRequestService,new O.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(N.IThemeMainService,new O.SyncDescriptor(N.ThemeMainService)),ve.set(ne.ISignService,new O.SyncDescriptor(x.SignService,void 0,!1)),ve.set(T.ITunnelService,new O.SyncDescriptor(U.TunnelService)),ve.set(ge.IProtocolMainService,new q.ProtocolMainService(Me,qe,he)),[new j.InstantiationService(ve,!0),ie,Me,je,Te,ue,ye,qe]}c(ve){const me={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Me=process.env[ye];typeof Me=="string"&&(me[ye]=Me)}),Object.assign(process.env,me),me}async d(ve,me,ye,Me,ie){await M.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,me.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?g.Promises.mkdir(ue,{recursive:!0}):void 0)),Me.init(),ye.initialize()]),me.setEnablement(ie.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(ve,me,ye,Me,ie,ue){let he;try{(0,d.mark)("code/willStartMainServer"),he=await(0,S.serve)(me.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,p.once)(ye.onWillShutdown)(()=>he.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.f(me,ie.nameLong,be),be;let Ce;try{Ce=await(0,S.connect)(me.mainIPCHandle,"main")}catch(Ue){if(!ue||v.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,ie.nameShort),(0,i.localize)(1,null),ie.nameLong),Ue;try{(0,t.unlinkSync)(me.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.e(ve,me,ye,Me,ie,!1)}if(me.extensionTestsLocationURI&&!me.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${ie.nameShort} is running.`;throw ve.error(Ue),Ce.dispose(),new Error(Ue)}let We;!me.args.wait&&!me.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,ie.nameShort),(0,i.localize)(3,null),ie.nameLong)},1e4));const Te=k.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),qe=k.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(me.args.status)return Me.invokeFunction(async()=>{const Ue=new o.DiagnosticsService(W.NullTelemetryService,ie),je=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Xe);throw console.log($e),new w.ExpectedError});throw v.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(me.args,process.env),Ce.dispose(),We&&clearTimeout(We),new w.ExpectedError("Sent env to running instance. Terminating...")}if(me.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${ie.nameShort} is already running. Please run it again after {0} has started.`),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),he}f(ve,me,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Me=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,S.XDG_RUNTIME_DIR]).map(ie=>(0,y.getPathLabel)(P.URI.file(ie),{os:v.OS,tildify:ve}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,I.toErrorMessage)(ye),Me.join(`
`)),me)}}g(ve,me,ye){E.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:me,defaultId:0,noLink:!0})}async h(ve,me){if(v.isWindows){const ye=await ve.getMainProcessId();me.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Me,ie)=>{H(["windows-foreground-love"],Me,ie)})).allowSetForegroundWindow(ye)}catch(Me){me.error(Me)}}}i(ve,me){const ye=ve.get(re.ILogService),Me=ve.get(V.ILifecycleMainService);let ie=0;me&&(me.isExpected?me.message&&ye.trace(me.message):(ie=1,me.stack?ye.error(me.stack):ye.error(`Startup error: ${me.toString()}`))),Me.kill(ie)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const me=(0,s.createWaitMarkerFileSync)(ve.verbose);me&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",me),ve.waitMarkerFilePath=me)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const me=this.l(ve._,ve.goto);ve._=me}return ve}l(ve,me){const ye=(0,l.cwd)(),Me=ve.map(he=>{let be=String(he),Ce;me&&(Ce=(0,m.parseLineAndColumnAware)(be),be=Ce.path),be&&(be=this.m(ye,be));const We=(0,m.sanitizeFilePath)(be,ye),Te=(0,h.basename)(We);return Te&&!(0,m.isValidBasename)(Te)?null:me&&Ce?(Ce.path=We,this.n(Ce)):We}),ie=v.isWindows||v.isMacintosh,ue=(0,R.distinct)(Me,he=>he&&ie?he.toLowerCase():he||"");return(0,R.coalesce)(ue)}m(ve,me){return v.isWindows&&(me=(0,u.rtrim)(me,'"')),me=(0,u.trim)((0,u.trim)(me," "),"	"),v.isWindows&&(me=(0,h.resolve)(ve,me),me=(0,u.rtrim)(me,".")),me}n(ve){const me=[ve.path];return typeof ve.line=="number"&&me.push(String(ve.line)),typeof ve.column=="number"&&me.push(String(ve.column)),me.join(":")}}new De().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/04b15ff231a2c3cfcdd90d90c16075a9c1e6da15/core/vs/code/electron-main/main.js.map
