/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/path","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/codicons","vs/base/common/assert","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(te){for(var e=[],a=0,t=te.length;a<t;a++)e[a]=ye[te[a]];return e};define(ye[50],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function a(R){return R?R.replace(/\$\((.*?)\)/g,(I,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(I,A,y){this.id=I,this.definition=A,this.description=y,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var T;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function A(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=I.exec(L.id);if(!P)return A(t.error);const[,w,C]=P,v=["codicon","codicon-"+w];return C&&v.push("codicon-modifier-"+C.substring(1)),v}R.asClassNameArray=A;function y(L){return A(L).join(" ")}R.asClassName=y;function D(L){return"."+A(L).join(".")}R.asCSSSelector=D})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ye[61],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(I,A){const y=Object.create(null);for(const D of I){const L=A(D);let P=y[L];P||(P=y[L]=[]),P.push(D)}return y}e.groupBy=a;function t(I,A){const y=[],D=[];for(const L of I)A.has(L)||y.push(L);for(const L of A)I.has(L)||D.push(L);return{removed:y,added:D}}e.diffSets=t;function T(I,A){const y=[],D=[];for(const[L,P]of I)A.has(L)||y.push(P);for(const[L,P]of A)I.has(L)||D.push(P);return{removed:y,added:D}}e.diffMaps=T;class R{constructor(){this.a=new Map}add(A,y){let D=this.a.get(A);D||(D=new Set,this.a.set(A,D)),D.add(y)}delete(A,y){const D=this.a.get(A);!D||(D.delete(y),D.size===0&&this.a.delete(A))}forEach(A,y){const D=this.a.get(A);!D||D.forEach(y)}}e.SetMap=R}),define(ye[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(I){return(A,y,D)=>{let L=null,P=null;if(typeof D.value=="function"?(L="value",P=D.value):typeof D.get=="function"&&(L="get",P=D.get),!P)throw new Error("not supported");D[L]=I(P,y)}}function t(I,A,y){let D=null,L=null;if(typeof y.value=="function"?(D="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(D="get",L=y.get),!L)throw new Error("not supported");const P=`$memoize$${A}`;y[D]=function(...w){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,w)}),this[P]}}e.memoize=t;function T(I,A,y){return a((D,L)=>{const P=`$debounce$${L}`,w=`$debounce$result$${L}`;return function(...C){this[w]||(this[w]=y?y():void 0),clearTimeout(this[P]),A&&(this[w]=A(this[w],...C),C=[this[w]]),this[P]=setTimeout(()=>{D.apply(this,C),this[w]=y?y():void 0},I)}})}e.debounce=T;function R(I,A,y){return a((D,L)=>{const P=`$throttle$timer$${L}`,w=`$throttle$result$${L}`,C=`$throttle$lastRun$${L}`,v=`$throttle$pending$${L}`;return function(...m){if(this[w]||(this[w]=y?y():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[w]=A(this[w],...m)),this[v])return;const h=this[C]+I;h<=Date.now()?(this[C]=Date.now(),D.apply(this,[this[w]]),this[w]=y?y():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[C]=Date.now(),D.apply(this,[this[w]]),this[w]=y?y():void 0},h-Date.now()))}})}e.throttle=R}),define(ye[9],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?b.isErrorNoTelemetry(i)?new b(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=a,e.errorHandler=new a;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function T(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=T;function R(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=R;function I(g){if(g instanceof Error){const{name:i,message:s}=g,o=g.stacktrace||g.stack;return{$isError:!0,name:i,message:s,stack:o,noTelemetry:b.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=I;const A="Canceled";function y(g){return g instanceof D?!0:g instanceof Error&&g.name===A&&g.message===A}e.isCancellationError=y;class D extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=D;function L(){const g=new Error(A);return g.name=g.message,g}e.canceled=L;function P(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=P;function w(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=w;function C(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function v(g){const i=new Error(`${g} has been disposed`);return i.name="DISPOSED",i}e.disposed=v;function m(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=m;class h extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=h;class f extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof b)return i;const s=new b;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class S extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}e.BugIndicatingError=S}),define(ye[16],Ce([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,oe=0){return se[se.length-(1+oe)]}e.tail=t;function T(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=T;function R(se,oe,fe=(Z,ce)=>Z===ce){if(se===oe)return!0;if(!se||!oe||se.length!==oe.length)return!1;for(let Z=0,ce=se.length;Z<ce;Z++)if(!fe(se[Z],oe[Z]))return!1;return!0}e.equals=R;function I(se,oe){const fe=se.length-1;oe<fe&&(se[oe]=se[fe]),se.pop()}e.removeFastWithoutKeepingOrder=I;function A(se,oe,fe){return y(se.length,Z=>fe(se[Z],oe))}e.binarySearch=A;function y(se,oe){let fe=0,Z=se-1;for(;fe<=Z;){const ce=(fe+Z)/2|0,ie=oe(ce);if(ie<0)fe=ce+1;else if(ie>0)Z=ce-1;else return ce}return-(fe+1)}e.binarySearch2=y;function D(se,oe){let fe=0,Z=se.length;if(Z===0)return 0;for(;fe<Z;){const ce=Math.floor((fe+Z)/2);oe(se[ce])?Z=ce:fe=ce+1}return fe}e.findFirstInSorted=D;function L(se,oe,fe){if(se=se|0,se>=oe.length)throw new TypeError("invalid index");const Z=oe[Math.floor(oe.length*Math.random())],ce=[],ie=[],N=[];for(const H of oe){const Q=fe(H,Z);Q<0?ce.push(H):Q>0?ie.push(H):N.push(H)}return se<ce.length?L(se,ce,fe):se<ce.length+N.length?N[0]:L(se-(ce.length+N.length),ie,fe)}e.quickSelect=L;function P(se,oe){const fe=[];let Z;for(const ce of se.slice(0).sort(oe))!Z||oe(Z[0],ce)!==0?(Z=[ce],fe.push(Z)):Z.push(ce);return fe}e.groupBy=P;function w(se,oe,fe){const Z=[];function ce(H,Q,J){if(Q===0&&J.length===0)return;const he=Z[Z.length-1];he&&he.start+he.deleteCount===H?(he.deleteCount+=Q,he.toInsert.push(...J)):Z.push({start:H,deleteCount:Q,toInsert:J})}let ie=0,N=0;for(;;){if(ie===se.length){ce(ie,0,oe.slice(N));break}if(N===oe.length){ce(ie,se.length-ie,[]);break}const H=se[ie],Q=oe[N],J=fe(H,Q);J===0?(ie+=1,N+=1):J<0?(ce(ie,1,[]),ie+=1):J>0&&(ce(ie,0,[Q]),N+=1)}return Z}e.sortedDiff=w;function C(se,oe,fe){const Z=w(se,oe,fe),ce=[],ie=[];for(const N of Z)ce.push(...se.slice(N.start,N.start+N.deleteCount)),ie.push(...N.toInsert);return{removed:ce,added:ie}}e.delta=C;function v(se,oe,fe){if(fe===0)return[];const Z=se.slice(0,fe).sort(oe);return h(se,oe,Z,fe,se.length),Z}e.top=v;function m(se,oe,fe,Z,ce){return fe===0?Promise.resolve([]):new Promise((ie,N)=>{(async()=>{const H=se.length,Q=se.slice(0,fe).sort(oe);for(let J=fe,he=Math.min(fe+Z,H);J<H;J=he,he=Math.min(he+Z,H)){if(J>fe&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new a.CancellationError;h(se,oe,Q,J,he)}return Q})().then(ie,N)})}e.topAsync=m;function h(se,oe,fe,Z,ce){for(const ie=fe.length;Z<ce;Z++){const N=se[Z];if(oe(N,fe[ie-1])<0){fe.pop();const H=D(fe,Q=>oe(N,Q)<0);fe.splice(H,0,N)}}}function f(se){return se.filter(oe=>!!oe)}e.coalesce=f;function p(se){let oe=0;for(let fe=0;fe<se.length;fe++)se[fe]&&(se[oe]=se[fe],oe+=1);se.length=oe}e.coalesceInPlace=p;function b(se,oe,fe){se.splice(fe,0,se.splice(oe,1)[0])}e.move=b;function S(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=S;function g(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=g;function i(se,oe=fe=>fe){const fe=new Set;return se.filter(Z=>{const ce=oe(Z);return fe.has(ce)?!1:(fe.add(ce),!0)})}e.distinct=i;function s(se){const oe=new Set;return fe=>{const Z=se(fe);return oe.has(Z)?!1:(oe.add(Z),!0)}}e.uniqueFilter=s;function o(se,oe){const fe=l(se,oe);if(fe!==-1)return se[fe]}e.findLast=o;function l(se,oe){for(let fe=se.length-1;fe>=0;fe--){const Z=se[fe];if(oe(Z))return fe}return-1}e.lastIndex=l;function c(se,oe){return se.length>0?se[0]:oe}e.firstOrDefault=c;function u(se,oe){return se.length>0?se[se.length-1]:oe}e.lastOrDefault=u;function r(se,oe,fe=(Z,ce)=>Z===ce){let Z=0;for(let ce=0,ie=Math.min(se.length,oe.length);ce<ie&&fe(se[ce],oe[ce]);ce++)Z++;return Z}e.commonPrefixLength=r;function n(se){return[].concat(...se)}e.flatten=n;function d(se,oe){let fe=typeof oe=="number"?se:0;typeof oe=="number"?fe=se:(fe=0,oe=se);const Z=[];if(fe<=oe)for(let ce=fe;ce<oe;ce++)Z.push(ce);else for(let ce=fe;ce>oe;ce--)Z.push(ce);return Z}e.range=d;function E(se,oe,fe){return se.reduce((Z,ce)=>(Z[oe(ce)]=fe?fe(ce):ce,Z),Object.create(null))}e.index=E;function k(se,oe){return se.push(oe),()=>M(se,oe)}e.insert=k;function M(se,oe){const fe=se.indexOf(oe);if(fe>-1)return se.splice(fe,1),oe}e.remove=M;function K(se,oe,fe){const Z=se.slice(0,oe),ce=se.slice(oe);return Z.concat(fe,ce)}e.arrayInsert=K;function q(se,oe){let fe;if(typeof oe=="number"){let Z=oe;fe=()=>{const ce=Math.sin(Z++)*179426549;return ce-Math.floor(ce)}}else fe=Math.random;for(let Z=se.length-1;Z>0;Z-=1){const ce=Math.floor(fe()*(Z+1)),ie=se[Z];se[Z]=se[ce],se[ce]=ie}}e.shuffle=q;function F(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.unshift(oe))}e.pushToStart=F;function B(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.push(oe))}e.pushToEnd=B;function O(se,oe){for(const fe of oe)se.push(fe)}e.pushMany=O;function U(se,oe){return Array.isArray(se)?se.map(oe):oe(se)}e.mapArrayOrNot=U;function $(se){return Array.isArray(se)?se:[se]}e.asArray=$;function j(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=j;function ue(se,oe){for(const fe of se){const Z=oe(fe);if(Z!==void 0)return Z}}e.mapFind=ue;function V(se,oe,fe){const Z=Y(se,oe),ce=se.length,ie=fe.length;se.length=ce+ie;for(let N=ce-1;N>=Z;N--)se[N+ie]=se[N];for(let N=0;N<ie;N++)se[N+Z]=fe[N]}e.insertInto=V;function _(se,oe,fe,Z){const ce=Y(se,oe),ie=se.splice(ce,fe);return V(se,ce,Z),ie}e.splice=_;function Y(se,oe){return oe<0?Math.max(oe+se.length,0):Math.min(oe,se.length)}var ne;(function(se){function oe(ce){return ce<0}se.isLessThan=oe;function fe(ce){return ce>0}se.isGreaterThan=fe;function Z(ce){return ce===0}se.isNeitherLessOrGreaterThan=Z,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function ee(se,oe){return(fe,Z)=>oe(se(fe),se(Z))}e.compareBy=ee;function X(...se){return(oe,fe)=>{for(const Z of se){const ce=Z(oe,fe);if(!ne.isNeitherLessOrGreaterThan(ce))return ce}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const G=(se,oe)=>se-oe;e.numberComparator=G;function de(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>0&&(fe=ce)}return fe}e.findMaxBy=de;function be(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>=0&&(fe=ce)}return fe}e.findLastMaxBy=be;function Ee(se,oe){return de(se,(fe,Z)=>-oe(fe,Z))}e.findMinBy=Ee;class Pe{constructor(oe){this.f=oe,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(oe){let fe=this.c;for(;fe<this.f.length&&oe(this.f[fe]);)fe++;const Z=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,Z}takeFromEndWhile(oe){let fe=this.d;for(;fe>=0&&oe(this.f[fe]);)fe--;const Z=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const oe=this.f[this.c];return this.c++,oe}removeLast(){const oe=this.f[this.d];return this.d--,oe}takeCount(oe){const fe=this.f.slice(this.c,this.c+oe);return this.c+=oe,fe}}e.ArrayQueue=Pe;class Fe{constructor(oe){this.iterate=oe}forEach(oe){this.iterate(fe=>(oe(fe),!0))}toArray(){const oe=[];return this.iterate(fe=>(oe.push(fe),!0)),oe}filter(oe){return new Fe(fe=>this.iterate(Z=>oe(Z)?fe(Z):!0))}map(oe){return new Fe(fe=>this.iterate(Z=>fe(oe(Z))))}some(oe){let fe=!1;return this.iterate(Z=>(fe=oe(Z),!fe)),fe}findFirst(oe){let fe;return this.iterate(Z=>oe(Z)?(fe=Z,!1):!0),fe}findLast(oe){let fe;return this.iterate(Z=>(oe(Z)&&(fe=Z),!0)),fe}findLastMaxBy(oe){let fe,Z=!0;return this.iterate(ce=>((Z||ne.isGreaterThan(oe(ce,fe)))&&(Z=!1,fe=ce),!0)),fe}}e.CallbackIterable=Fe,Fe.empty=new Fe(se=>{})}),define(ye[51],Ce([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(y,D){if(!y)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function T(y,D="Unreachable"){throw new Error(D)}e.assertNever=T;function R(y){if(!y)throw new a.BugIndicatingError("Assertion Failed")}e.assert=R;function I(y){if(!y()){debugger;y(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function A(y,D){let L=0;for(;L<y.length-1;){const P=y[L],w=y[L+1];if(!D(P,w))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(t){const T=this;let R=!1,I;return function(){return R||(R=!0,I=t.apply(T,arguments)),I}}e.once=a}),define(ye[101],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(T){this.a=T,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[64],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function T(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}t.is=T;const R=Object.freeze([]);function I(){return R}t.empty=I;function*A(S){yield S}t.single=A;function y(S){return T(S)?S:A(S)}t.wrap=y;function D(S){return S||R}t.from=D;function L(S){return!S||S[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(S){return S[Symbol.iterator]().next().value}t.first=P;function w(S,g){for(const i of S)if(g(i))return!0;return!1}t.some=w;function C(S,g){for(const i of S)if(g(i))return i}t.find=C;function*v(S,g){for(const i of S)g(i)&&(yield i)}t.filter=v;function*m(S,g){let i=0;for(const s of S)yield g(s,i++)}t.map=m;function*h(...S){for(const g of S)for(const i of g)yield i}t.concat=h;function f(S,g,i){let s=i;for(const o of S)s=g(s,o);return s}t.reduce=f;function*p(S,g,i=S.length){for(g<0&&(g+=S.length),i<0?i+=S.length:i>S.length&&(i=S.length);g<i;g++)yield S[g]}t.slice=p;function b(S,g=Number.POSITIVE_INFINITY){const i=[];if(g===0)return[i,S];const s=S[Symbol.iterator]();for(let o=0;o<g;o++){const l=s.next();if(l.done)return[i,t.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=b})(a=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function I(i,s=!1){let o=0;const l=i.length;let c="",u=0,r=16,n=0;function d(B){let O=0,U=0;for(;O<B;){const $=i.charCodeAt(o);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;o++,O++}return O<B&&(U=-1),U}function E(B){o=B,c="",u=0,r=16,n=0}function k(){const B=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&D(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&D(i.charCodeAt(o)))for(o++;o<i.length&&D(i.charCodeAt(o));)o++;else return n=3,i.substring(B,o);let O=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&D(i.charCodeAt(o))){for(o++;o<i.length&&D(i.charCodeAt(o));)o++;O=o}else n=3;return i.substring(B,O)}function M(){let B="",O=o;for(;;){if(o>=l){B+=i.substring(O,o),n=2;break}const U=i.charCodeAt(o);if(U===34){B+=i.substring(O,o),o++;break}if(U===92){if(B+=i.substring(O,o),o++,o>=l){n=2;break}switch(i.charCodeAt(o++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=d(4);j>=0?B+=String.fromCharCode(j):n=4;break}default:n=5}O=o;continue}if(U>=0&&U<=31)if(y(U)){B+=i.substring(O,o),n=2;break}else n=6;o++}return B}function K(){if(c="",n=0,u=o,o>=l)return u=l,r=17;let B=i.charCodeAt(o);if(A(B)){do o++,c+=String.fromCharCode(B),B=i.charCodeAt(o);while(A(B));return r=15}if(y(B))return o++,c+=String.fromCharCode(B),B===13&&i.charCodeAt(o)===10&&(o++,c+=`
`),r=14;switch(B){case 123:return o++,r=1;case 125:return o++,r=2;case 91:return o++,r=3;case 93:return o++,r=4;case 58:return o++,r=6;case 44:return o++,r=5;case 34:return o++,c=M(),r=10;case 47:{const O=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<l&&!y(i.charCodeAt(o));)o++;return c=i.substring(O,o),r=12}if(i.charCodeAt(o+1)===42){o+=2;const U=l-1;let $=!1;for(;o<U;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,n=1),c=i.substring(O,o),r=13}return c+=String.fromCharCode(B),o++,r=16}case 45:if(c+=String.fromCharCode(B),o++,o===l||!D(i.charCodeAt(o)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),r=11;default:for(;o<l&&q(B);)o++,B=i.charCodeAt(o);if(u!==o){switch(c=i.substring(u,o),c){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return c+=String.fromCharCode(B),o++,r=16}}function q(B){if(A(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let B;do B=K();while(B>=12&&B<=15);return B}return{setPosition:E,getPosition:()=>o,scan:s?F:K,getToken:()=>r,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>n}}e.createScanner=I;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function P(i,s){const o=[],l=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function n(d,E,k,M){u.value=d,u.offset=E,u.length=k,u.type=M,u.colonOffset=void 0,c=u}try{b(i,{onObjectBegin:(d,E)=>{if(s<=d)throw l;c=void 0,r=s>d,o.push("")},onObjectProperty:(d,E,k)=>{if(s<E||(n(d,E,k,"property"),o[o.length-1]=d,s<=E+k))throw l},onObjectEnd:(d,E)=>{if(s<=d)throw l;c=void 0,o.pop()},onArrayBegin:(d,E)=>{if(s<=d)throw l;c=void 0,o.push(0)},onArrayEnd:(d,E)=>{if(s<=d)throw l;c=void 0,o.pop()},onLiteralValue:(d,E,k)=>{if(s<E||(n(d,E,k,g(d)),s<=E+k))throw l},onSeparator:(d,E,k)=>{if(s<=E)throw l;if(d===":"&&c&&c.type==="property")c.colonOffset=E,r=!1,c=void 0;else if(d===","){const M=o[o.length-1];typeof M=="number"?o[o.length-1]=M+1:(r=!0,o[o.length-1]=""),c=void 0}}})}catch(d){if(d!==l)throw d}return{path:o,previousNode:c,isAtPropertyKey:r,matches:d=>{let E=0;for(let k=0;E<d.length&&k<o.length;k++)if(d[E]===o[k]||d[E]==="*")E++;else if(d[E]!=="**")return!1;return E===d.length}}}e.getLocation=P;function w(i,s=[],o=R.DEFAULT){let l=null,c=[];const u=[];function r(d){Array.isArray(c)?c.push(d):l!==null&&(c[l]=d)}return b(i,{onObjectBegin:()=>{const d={};r(d),u.push(c),c=d,l=null},onObjectProperty:d=>{l=d},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const d=[];r(d),u.push(c),c=d,l=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:r,onError:(d,E,k)=>{s.push({error:d,offset:E,length:k})}},o),c[0]}e.parse=w;function C(i,s=[],o=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(d){l.type==="property"&&(l.length=d-l.offset,l=l.parent)}function u(d){return l.children.push(d),d}b(i,{onObjectBegin:d=>{l=u({type:"object",offset:d,length:-1,parent:l,children:[]})},onObjectProperty:(d,E,k)=>{l=u({type:"property",offset:E,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:d,offset:E,length:k,parent:l})},onObjectEnd:(d,E)=>{l.length=d+E-l.offset,l=l.parent,c(d+E)},onArrayBegin:(d,E)=>{l=u({type:"array",offset:d,length:-1,parent:l,children:[]})},onArrayEnd:(d,E)=>{l.length=d+E-l.offset,l=l.parent,c(d+E)},onLiteralValue:(d,E,k)=>{u({type:g(d),offset:E,length:k,parent:l,value:d}),c(E+k)},onSeparator:(d,E,k)=>{l.type==="property"&&(d===":"?l.colonOffset=E:d===","&&c(E))},onError:(d,E,k)=>{s.push({error:d,offset:E,length:k})}},o);const n=l.children[0];return n&&delete n.parent,n}e.parseTree=C;function v(i,s){if(!i)return;let o=i;for(const l of s)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let c=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===l){o=u.children[1],c=!0;break}if(!c)return}else{const c=l;if(o.type!=="array"||c<0||!Array.isArray(o.children)||c>=o.children.length)return;o=o.children[c]}return o}e.findNodeAtLocation=v;function m(i){if(!i.parent||!i.parent.children)return[];const s=m(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;s.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&s.push(o)}return s}e.getNodePath=m;function h(i){switch(i.type){case"array":return i.children.map(h);case"object":{const s=Object.create(null);for(const o of i.children){const l=o.children[1];l&&(s[o.children[0].value]=h(l))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=h;function f(i,s,o=!1){return s>=i.offset&&s<i.offset+i.length||o&&s===i.offset+i.length}e.contains=f;function p(i,s,o=!1){if(f(i,s,o)){const l=i.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=s;c++){const u=p(l[c],s,o);if(u)return u}return i}}e.findNodeAtOffset=p;function b(i,s,o=R.DEFAULT){const l=I(i,!1);function c(ee){return ee?()=>ee(l.getTokenOffset(),l.getTokenLength()):()=>!0}function u(ee){return ee?X=>ee(X,l.getTokenOffset(),l.getTokenLength()):()=>!0}const r=c(s.onObjectBegin),n=u(s.onObjectProperty),d=c(s.onObjectEnd),E=c(s.onArrayBegin),k=c(s.onArrayEnd),M=u(s.onLiteralValue),K=u(s.onSeparator),q=c(s.onComment),F=u(s.onError),B=o&&o.disallowComments,O=o&&o.allowTrailingComma;function U(){for(;;){const ee=l.scan();switch(l.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ee){case 12:case 13:B?$(10):q();break;case 16:$(1);break;case 15:case 14:break;default:return ee}}}function $(ee,X=[],G=[]){if(F(ee),X.length+G.length>0){let de=l.getToken();for(;de!==17;){if(X.indexOf(de)!==-1){U();break}else if(G.indexOf(de)!==-1)break;de=U()}}}function j(ee){const X=l.getTokenValue();return ee?M(X):n(X),U(),!0}function ue(){switch(l.getToken()){case 11:{let ee=0;try{ee=JSON.parse(l.getTokenValue()),typeof ee!="number"&&($(2),ee=0)}catch{$(2)}M(ee);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return U(),!0}function V(){return l.getToken()!==10?($(3,[],[2,5]),!1):(j(!1),l.getToken()===6?(K(":"),U(),ne()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function _(){r(),U();let ee=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ee||$(4,[],[]),K(","),U(),l.getToken()===2&&O)break}else ee&&$(6,[],[]);V()||$(4,[],[2,5]),ee=!0}return d(),l.getToken()!==2?$(7,[2],[]):U(),!0}function Y(){E(),U();let ee=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ee||$(4,[],[]),K(","),U(),l.getToken()===4&&O)break}else ee&&$(6,[],[]);ne()||$(4,[],[4,5]),ee=!0}return k(),l.getToken()!==4?$(8,[4],[]):U(),!0}function ne(){switch(l.getToken()){case 3:return Y();case 1:return _();case 10:return j(!0);default:return ue()}}return U(),l.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):ne()?(l.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=b;function S(i,s){const o=I(i),l=[];let c,u=0,r;do switch(r=o.getPosition(),c=o.scan(),c){case 12:case 13:case 17:u!==r&&l.push(i.substring(u,r)),s!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,s)),u=o.getPosition();break}while(c!==17);return l.join("")}e.stripComments=S;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ye[83],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(T){this.d=T,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(T){return new a(()=>T(this.getValue()))}}e.Lazy=a}),define(ye[6],Ce([1,0,63,64]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let R=null;function I(u){R=u}if(e.setDisposableTracker=I,T){const u="__is_disposable_tracked__";I(new class{trackDisposable(r){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[u]||console.log(n)},3e3)}setParent(r,n){if(r&&r!==p.None)try{r[u]=!0}catch{}}markAsDisposed(r){if(r&&r!==p.None)try{r[u]=!0}catch{}}markAsSingleton(r){}})}function A(u){return R?.trackDisposable(u),u}function y(u){R?.markAsDisposed(u)}function D(u,r){R?.setParent(u,r)}function L(u,r){if(!!R)for(const n of u)R.setParent(n,r)}function P(u){return R?.markAsSingleton(u),u}e.markAsSingleton=P;function w(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=w;function C(u){if(t.Iterable.is(u)){const r=[];for(const n of u)if(n)try{n.dispose()}catch(d){r.push(d)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=C;function v(u){for(const r of u)w(r)&&r.dispose();return[]}e.disposeIfDisposable=v;function m(...u){const r=h(()=>C(u));return L(u,r),r}e.combinedDisposable=m;function h(u){const r=A({dispose:(0,a.once)(()=>{y(r),u()})});return r}e.toDisposable=h;class f{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{C(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return D(r,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new f,A(this),D(this.q,this)}dispose(){y(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class b{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&D(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&D(r,null),r}}e.MutableDisposable=b;class S{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(r){let n=r;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,y(this))},this}}e.SafeDisposable=g;class i{constructor(){this.a=new Map}acquire(r,...n){let d=this.a.get(r);d||(d={counter:0,object:this.b(r,...n)},this.a.set(r,d));const{object:E}=d,k=(0,a.once)(()=>{--d.counter===0&&(this.c(r,d.object),this.a.delete(r))});return d.counter++,{object:E,dispose:k}}}e.ReferenceCollection=i;class s{constructor(r){this.a=r}async acquire(r,...n){const d=this.a.acquire(r,...n);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(E){throw d.dispose(),E}}}e.AsyncReferenceCollection=s;class o{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=o;function l(u){const r=new f;try{u(r)}finally{r.dispose()}}e.disposeOnReturn=l;class c{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{C(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,n,d=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),d||this.a.get(r)?.dispose(),this.a.set(r,n)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=c}),define(ye[65],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const I=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=I}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,I){const A=new a(R);if(this.a===a.Undefined)this.a=A,this.b=A;else if(I){const D=this.b;this.b=A,A.prev=D,D.next=A}else{const D=this.a;this.a=A,A.next=D,D.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const I=R.prev;I.next=R.next,R.next.prev=I}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(te,e){"use strict";var a,t,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(v,m,h){let f=v.get(m);return f===void 0&&(f=h,v.set(m,f)),f}e.getOrSet=R;function I(v){const m=[];return v.forEach((h,f)=>{m.push(`${f} => ${h}`)}),`Map(${v.size}) {${m.join(", ")}}`}e.mapToString=I;function A(v){const m=[];return v.forEach(h=>{m.push(h)}),`Set(${v.size}) {${m.join(", ")}}`}e.setToString=A;class y{constructor(m,h){this.uri=m,this.value=h}}class D{constructor(m,h){this[a]="ResourceMap",m instanceof D?(this.b=new Map(m.b),this.c=h??D.a):(this.b=new Map,this.c=m??D.a)}set(m,h){return this.b.set(this.c(m),new y(m,h)),this}get(m){return this.b.get(this.c(m))?.value}has(m){return this.b.has(this.c(m))}get size(){return this.b.size}clear(){this.b.clear()}delete(m){return this.b.delete(this.c(m))}forEach(m,h){typeof h<"u"&&(m=m.bind(h));for(const[f,p]of this.b)m(p.value,p.uri,this)}*values(){for(const m of this.b.values())yield m.value}*keys(){for(const m of this.b.values())yield m.uri}*entries(){for(const m of this.b.values())yield[m.uri,m.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.b)yield[m.uri,m.value]}}e.ResourceMap=D,D.a=v=>v.toString();class L{constructor(m,h){this[t]="ResourceSet",!m||typeof m=="function"?this.a=new D(m):(this.a=new D(h),m.forEach(this.add,this))}get size(){return this.a.size}add(m){return this.a.set(m,m),this}clear(){this.a.clear()}delete(m){return this.a.delete(m)}forEach(m,h){this.a.forEach((f,p)=>m.call(h,p,p,this))}has(m){return this.a.has(m)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class w{constructor(){this[T]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(m){return this.a.has(m)}get(m,h=0){const f=this.a.get(m);if(!!f)return h!==0&&this.j(f,h),f.value}set(m,h,f=0){let p=this.a.get(m);if(p)p.value=h,f!==0&&this.j(p,f);else{switch(p={key:m,value:h,next:void 0,previous:void 0},f){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(m,p),this.d++}return this}delete(m){return!!this.remove(m)}remove(m){const h=this.a.get(m);if(!!h)return this.a.delete(m),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const m=this.b;return this.a.delete(m.key),this.i(m),this.d--,m.value}forEach(m,h){const f=this.e;let p=this.b;for(;p;){if(h?m.bind(h)(p.value,p.key,this):m(p.value,p.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const m=this,h=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}values(){const m=this,h=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}entries(){const m=this,h=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(m){if(m>=this.size)return;if(m===0){this.clear();return}let h=this.b,f=this.size;for(;h&&f>m;)this.a.delete(h.key),h=h.next,f--;this.b=h,this.d=f,h&&(h.previous=void 0),this.e++}g(m){if(!this.b&&!this.c)this.c=m;else if(this.b)m.next=this.b,this.b.previous=m;else throw new Error("Invalid list");this.b=m,this.e++}h(m){if(!this.b&&!this.c)this.b=m;else if(this.c)m.previous=this.c,this.c.next=m;else throw new Error("Invalid list");this.c=m,this.e++}i(m){if(m===this.b&&m===this.c)this.b=void 0,this.c=void 0;else if(m===this.b){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.b=m.next}else if(m===this.c){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.c=m.previous}else{const h=m.next,f=m.previous;if(!h||!f)throw new Error("Invalid list");h.previous=f,f.next=h}m.next=void 0,m.previous=void 0,this.e++}j(m,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(m===this.b)return;const f=m.next,p=m.previous;m===this.c?(p.next=void 0,this.c=p):(f.previous=p,p.next=f),m.previous=void 0,m.next=this.b,this.b.previous=m,this.b=m,this.e++}else if(h===2){if(m===this.c)return;const f=m.next,p=m.previous;m===this.b?(f.previous=void 0,this.b=f):(f.previous=p,p.next=f),m.next=void 0,m.previous=this.c,this.c.next=m,this.c=m,this.e++}}}toJSON(){const m=[];return this.forEach((h,f)=>{m.push([f,h])}),m}fromJSON(m){this.clear();for(const[h,f]of m)this.set(h,f)}}e.LinkedMap=w;class C extends w{constructor(m,h=1){super(),this.k=m,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(m){this.k=m,this.m()}get ratio(){return this.l}set ratio(m){this.l=Math.min(Math.max(0,m),1),this.m()}get(m,h=2){return super.get(m,h)}peek(m){return super.get(m,0)}set(m,h){return super.set(m,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=C}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(se,oe){for(var fe=0;fe<oe.length;fe++){var Z=oe[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(se,Z.key,Z)}}function a(se,oe,fe){return oe&&e(se.prototype,oe),fe&&e(se,fe),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,oe){if(!!se){if(typeof se=="string")return T(se,oe);var fe=Object.prototype.toString.call(se).slice(8,-1);if(fe==="Object"&&se.constructor&&(fe=se.constructor.name),fe==="Map"||fe==="Set")return Array.from(se);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return T(se,oe)}}function T(se,oe){(oe==null||oe>se.length)&&(oe=se.length);for(var fe=0,Z=new Array(oe);fe<oe;fe++)Z[fe]=se[fe];return Z}function R(se,oe){var fe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(fe)return(fe=fe.call(se)).next.bind(fe);if(Array.isArray(se)||(fe=t(se))||oe&&se&&typeof se.length=="number"){fe&&(se=fe);var Z=0;return function(){return Z>=se.length?{done:!0}:{done:!1,value:se[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=I();function A(se){te.defaults=se}var y=/[&<>"']/,D=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(oe){return w[oe]};function v(se,oe){if(oe){if(y.test(se))return se.replace(D,C)}else if(L.test(se))return se.replace(P,C);return se}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(se){return se.replace(m,function(oe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function p(se,oe){se=typeof se=="string"?se:se.source,oe=oe||"";var fe={replace:function(ce,ie){return ie=ie.source||ie,ie=ie.replace(f,"$1"),se=se.replace(ce,ie),fe},getRegex:function(){return new RegExp(se,oe)}};return fe}var b=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(se,oe,fe){if(se){var Z;try{Z=decodeURIComponent(h(fe)).replace(b,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!S.test(fe)&&(fe=c(oe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},s=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(se,oe){i[" "+se]||(s.test(se)?i[" "+se]=se+"/":i[" "+se]=d(se,"/",!0)),se=i[" "+se];var fe=se.indexOf(":")===-1;return oe.substring(0,2)==="//"?fe?oe:se.replace(o,"$1")+oe:oe.charAt(0)==="/"?fe?oe:se.replace(l,"$1")+oe:se+oe}var u={exec:function(){}};function r(se){for(var oe=1,fe,Z;oe<arguments.length;oe++){fe=arguments[oe];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(se[Z]=fe[Z])}return se}function n(se,oe){var fe=se.replace(/\|/g,function(ie,N,H){for(var Q=!1,J=N;--J>=0&&H[J]==="\\";)Q=!Q;return Q?"|":" |"}),Z=fe.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function d(se,oe,fe){var Z=se.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ie=se.charAt(Z-ce-1);if(ie===oe&&!fe)ce++;else if(ie!==oe&&fe)ce++;else break}return se.slice(0,Z-ce)}function E(se,oe){if(se.indexOf(oe[1])===-1)return-1;for(var fe=se.length,Z=0,ce=0;ce<fe;ce++)if(se[ce]==="\\")ce++;else if(se[ce]===oe[0])Z++;else if(se[ce]===oe[1]&&(Z--,Z<0))return ce;return-1}function k(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(se,oe){if(oe<1)return"";for(var fe="";oe>1;)oe&1&&(fe+=se),oe>>=1,se+=se;return fe+se}function K(se,oe,fe,Z){var ce=oe.href,ie=oe.title?v(oe.title):null,N=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){Z.state.inLink=!0;var H={type:"link",raw:fe,href:ce,title:ie,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,H}return{type:"image",raw:fe,href:ce,title:ie,text:v(N)}}function q(se,oe){var fe=se.match(/^(\s+)(?:```)/);if(fe===null)return oe;var Z=fe[1];return oe.split(`
`).map(function(ce){var ie=ce.match(/^\s+/);if(ie===null)return ce;var N=ie[0];return N.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var F=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},oe.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ie=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:d(ie,`
`)}}},oe.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ie=ce[0],N=q(ie,ce[3]||"");return{type:"code",raw:ie,lang:ce[2]?ce[2].trim():ce[2],text:N}}},oe.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ie=ce[2].trim();if(/#$/.test(ie)){var N=d(ie,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ie=N.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ie,tokens:this.lexer.inline(ie)}}},oe.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},oe.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ie=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},oe.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ie,N,H,Q,J,he,we,Ae,pe,De,ke,je,Ge=ce[1].trim(),et=Ge.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(je=!1,!(!(ce=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ie=ce[0],Z=Z.substring(ie.length),Ae=ce[2].split(`
`,1)[0],pe=Z.split(`
`,1)[0],this.options.pedantic?(Q=2,ke=Ae.trimLeft()):(Q=ce[2].search(/[^ ]/),Q=Q>4?1:Q,ke=Ae.slice(Q),Q+=ce[1].length),he=!1,!Ae&&/^ *$/.test(pe)&&(ie+=pe+`
`,Z=Z.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");Z&&(De=Z.split(`
`,1)[0],Ae=De,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Ae)||it.test(Ae)||st.test(Ae)||ht.test(Z)));){if(Ae.search(/[^ ]/)>=Q||!Ae.trim())ke+=`
`+Ae.slice(Q);else if(!he)ke+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),ie+=De+`
`,Z=Z.substring(De.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(ie)&&(we=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&(H=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ie,task:!!N,checked:H,loose:!1,text:ke}),Qe.raw+=ie}Qe.items[Qe.items.length-1].raw=ie.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var ae=Qe.items.length;for(J=0;J<ae;J++){this.lexer.state.top=!1,Qe.items[J].tokens=this.lexer.blockTokens(Qe.items[J].text,[]);var z=Qe.items[J].tokens.filter(function(Ie){return Ie.type==="space"}),le=z.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,Xe=R(Le),Ze;!(Ze=Xe()).done;){var gt=Ze.value;if(gt===`
`&&(Be+=1),Be>1)return!0}return!1});!Qe.loose&&z.length&&le&&(Qe.loose=!0,Qe.items[J].loose=!0)}return Qe}},oe.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ie={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ce[0]):v(ce[0]);ie.type="paragraph",ie.text=N,ie.tokens=this.lexer.inline(N)}return ie}},oe.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ie=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ce[0],href:ce[2],title:ce[3]}}},oe.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ie={type:"table",header:n(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ce[0];var N=ie.align.length,H,Q,J,he;for(H=0;H<N;H++)/^ *-+: *$/.test(ie.align[H])?ie.align[H]="right":/^ *:-+: *$/.test(ie.align[H])?ie.align[H]="center":/^ *:-+ *$/.test(ie.align[H])?ie.align[H]="left":ie.align[H]=null;for(N=ie.rows.length,H=0;H<N;H++)ie.rows[H]=n(ie.rows[H],ie.header.length).map(function(we){return{text:we}});for(N=ie.header.length,Q=0;Q<N;Q++)ie.header[Q].tokens=this.lexer.inline(ie.header[Q].text);for(N=ie.rows.length,Q=0;Q<N;Q++)for(he=ie.rows[Q],J=0;J<he.length;J++)he[J].tokens=this.lexer.inline(he[J].text);return ie}}},oe.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},oe.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ie=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ie,tokens:this.lexer.inline(ie)}}},oe.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},oe.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:v(ce[1])}},oe.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):v(ce[0]):ce[0]}},oe.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ie=ce[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var N=d(ie.slice(0,-1),"\\");if((ie.length-N.length)%2===0)return}else{var H=E(ce[2],"()");if(H>-1){var Q=ce[0].indexOf("!")===0?5:4,J=Q+ce[1].length+H;ce[2]=ce[2].substring(0,H),ce[0]=ce[0].substring(0,J).trim(),ce[3]=""}}var he=ce[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=ce[3]?ce[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ie)?he=he.slice(1):he=he.slice(1,-1)),K(ce,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},oe.reflink=function(Z,ce){var ie;if((ie=this.rules.inline.reflink.exec(Z))||(ie=this.rules.inline.nolink.exec(Z))){var N=(ie[2]||ie[1]).replace(/\s+/g," ");if(N=ce[N.toLowerCase()],!N||!N.href){var H=ie[0].charAt(0);return{type:"text",raw:H,text:H}}return K(ie,N,ie[0],this.lexer)}},oe.emStrong=function(Z,ce,ie){ie===void 0&&(ie="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=N[1]||N[2]||"";if(!H||H&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Q=N[0].length-1,J,he,we=Q,Ae=0,pe=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Q);(N=pe.exec(ce))!=null;)if(J=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!J){if(he=J.length,N[3]||N[4]){we+=he;continue}else if((N[5]||N[6])&&Q%3&&!((Q+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(Q,he)%2){var De=Z.slice(1,Q+N.index+he);return{type:"em",raw:Z.slice(0,Q+N.index+he+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=Z.slice(2,Q+N.index+he-1);return{type:"strong",raw:Z.slice(0,Q+N.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},oe.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ie=ce[2].replace(/\n/g," "),N=/[^ ]/.test(ie),H=/^ /.test(ie)&&/ $/.test(ie);return N&&H&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:ce[0],text:ie}}},oe.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},oe.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},oe.autolink=function(Z,ce){var ie=this.rules.inline.autolink.exec(Z);if(ie){var N,H;return ie[2]==="@"?(N=v(this.options.mangle?ce(ie[1]):ie[1]),H="mailto:"+N):(N=v(ie[1]),H=N),{type:"link",raw:ie[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.url=function(Z,ce){var ie;if(ie=this.rules.inline.url.exec(Z)){var N,H;if(ie[2]==="@")N=v(this.options.mangle?ce(ie[0]):ie[0]),H="mailto:"+N;else{var Q;do Q=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Q!==ie[0]);N=v(ie[0]),ie[1]==="www."?H="http://"+N:H=N}return{type:"link",raw:ie[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.inlineText=function(Z,ce){var ie=this.rules.inline.text.exec(Z);if(ie){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:N=v(this.options.smartypants?ce(ie[0]):ie[0]),{type:"text",raw:ie[0],text:N}}},se}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=p(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=p(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=p(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=p(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=p(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=r({},B),B.gfm=r({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=p(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=r({},B.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:p(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=p(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=p(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=p(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=p(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=p(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=p(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=p(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=p(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=p(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=p(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=p(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=r({},O),O.pedantic=r({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=r({},O.normal,{escape:p(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=p(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=r({},O.gfm,{br:p(O.br).replace("{2,}","*").getRegex(),text:p(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(se){var oe="",fe,Z,ce=se.length;for(fe=0;fe<ce;fe++)Z=se.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var j=function(){function se(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||te.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:O.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=O.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=O.breaks:Z.inline=O.gfm),this.tokenizer.rules=Z}se.lex=function(Z,ce){var ie=new se(ce);return ie.lex(Z)},se.lexInline=function(Z,ce){var ie=new se(ce);return ie.inlineTokens(Z)};var oe=se.prototype;return oe.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},oe.blockTokens=function(Z,ce){var ie=this;ce===void 0&&(ce=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(we,Ae,pe){return Ae+"    ".repeat(pe.length)});for(var N,H,Q,J;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(N=we.call({lexer:ie},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=Z.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Ae),typeof pe=="number"&&pe>=0&&(we=Math.min(we,pe))}),we<1/0&&we>=0&&(Q=Z.substring(0,we+1))}(),this.state.top&&(N=this.tokenizer.paragraph(Q))){H=ce[ce.length-1],J&&H.type==="paragraph"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N),J=Q.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(Z){var he="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ce},oe.inline=function(Z,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:Z,tokens:ce}),ce},oe.inlineTokens=function(Z,ce){var ie=this;ce===void 0&&(ce=[]);var N,H,Q,J=Z,he,we,Ae;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(J))!=null;)pe.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(J=J.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(J))!=null;)J=J.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(J))!=null;)J=J.slice(0,he.index)+"++"+J.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ie},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.emStrong(Z,J,Ae)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.autolink(Z,$)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,$))){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=Z.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(Q=Z.substring(0,ke+1))}(),N=this.tokenizer.inlineText(Q,U)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),we=!0,H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(Z){var De="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ce},a(se,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),se}(),ue=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.code=function(Z,ce,ie){var N=(ce||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(Z,N);H!=null&&H!==Z&&(ie=!0,Z=H)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+v(N,!0)+'">'+(ie?Z:v(Z,!0))+`</code></pre>
`:"<pre><code>"+(ie?Z:v(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ce,ie,N){if(this.options.headerIds){var H=this.options.headerPrefix+N.slug(ie);return"<h"+ce+' id="'+H+'">'+Z+"</h"+ce+`>
`}return"<h"+ce+">"+Z+"</h"+ce+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ce,ie){var N=ce?"ol":"ul",H=ce&&ie!==1?' start="'+ie+'"':"";return"<"+N+H+`>
`+Z+"</"+N+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ce){var ie=ce.header?"th":"td",N=ce.align?"<"+ie+' align="'+ce.align+'">':"<"+ie+">";return N+Z+("</"+ie+`>
`)},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ce,ie){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ie;var N='<a href="'+v(Z)+'"';return ce&&(N+=' title="'+ce+'"'),N+=">"+ie+"</a>",N},oe.image=function(Z,ce,ie){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ie;var N='<img src="'+Z+'" alt="'+ie+'"';return ce&&(N+=' title="'+ce+'"'),N+=this.options.xhtml?"/>":">",N},oe.text=function(Z){return Z},se}(),V=function(){function se(){}var oe=se.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ce,ie){return""+ie},oe.image=function(Z,ce,ie){return""+ie},oe.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var oe=se.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ce){var ie=Z,N=0;if(this.seen.hasOwnProperty(ie)){N=this.seen[Z];do N++,ie=Z+"-"+N;while(this.seen.hasOwnProperty(ie))}return ce||(this.seen[Z]=N,this.seen[ie]=0),ie},oe.slug=function(Z,ce){ce===void 0&&(ce={});var ie=this.serialize(Z);return this.getNextSafeSlug(ie,ce.dryrun)},se}(),Y=function(){function se(fe){this.options=fe||te.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new _}se.parse=function(Z,ce){var ie=new se(ce);return ie.parse(Z)},se.parseInline=function(Z,ce){var ie=new se(ce);return ie.parseInline(Z)};var oe=se.prototype;return oe.parse=function(Z,ce){ce===void 0&&(ce=!0);var ie="",N,H,Q,J,he,we,Ae,pe,De,ke,je,Ge,et,Qe,nt,st,ht,Me,it,ae=Z.length;for(N=0;N<ae;N++){if(ke=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,h(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Ae="",J=ke.header.length,H=0;H<J;H++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Ae),De="",J=ke.rows.length,H=0;H<J;H++){for(we=ke.rows[H],Ae="",he=we.length,Q=0;Q<he;Q++)Ae+=this.renderer.tablecell(this.parseInline(we[Q].tokens),{header:!1,align:ke.align[Q]});De+=this.renderer.tablerow(Ae)}ie+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,J=ke.items.length,De="",H=0;H<J;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(nt.tokens,et),De+=this.renderer.listitem(Qe,ht,st);ie+=this.renderer.list(De,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<ae&&Z[N+1].type==="text";)ke=Z[++N],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=ce?this.renderer.paragraph(De):De;continue}default:{var z='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return ie},oe.parseInline=function(Z,ce){ce=ce||this.renderer;var ie="",N,H,Q,J=Z.length;for(N=0;N<J;N++){if(H=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(Q=this.options.extensions.renderers[H.type].call({parser:this},H),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ie+=Q||"";continue}switch(H.type){case"escape":{ie+=ce.text(H.text);break}case"html":{ie+=ce.html(H.text);break}case"link":{ie+=ce.link(H.href,H.title,this.parseInline(H.tokens,ce));break}case"image":{ie+=ce.image(H.href,H.title,H.text);break}case"strong":{ie+=ce.strong(this.parseInline(H.tokens,ce));break}case"em":{ie+=ce.em(this.parseInline(H.tokens,ce));break}case"codespan":{ie+=ce.codespan(H.text);break}case"br":{ie+=ce.br();break}case"del":{ie+=ce.del(this.parseInline(H.tokens,ce));break}case"text":{ie+=ce.text(H.text);break}default:{var he='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ie},se}();function ne(se,oe,fe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof oe=="function"&&(fe=oe,oe=null),oe=r({},ne.defaults,oe||{}),k(oe),fe){var Z=oe.highlight,ce;try{ce=j.lex(se,oe)}catch(J){return fe(J)}var ie=function(he){var we;if(!he)try{oe.walkTokens&&ne.walkTokens(ce,oe.walkTokens),we=Y.parse(ce,oe)}catch(Ae){he=Ae}return oe.highlight=Z,he?fe(he):fe(null,we)};if(!Z||Z.length<3||(delete oe.highlight,!ce.length))return ie();var N=0;ne.walkTokens(ce,function(J){J.type==="code"&&(N++,setTimeout(function(){Z(J.text,J.lang,function(he,we){if(he)return ie(he);we!=null&&we!==J.text&&(J.text=we,J.escaped=!0),N--,N===0&&ie()})},0))}),N===0&&ie();return}function H(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(J.message+"",!0)+"</pre>";throw J}try{var Q=j.lex(se,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ne.walkTokens(Q,oe.walkTokens)).then(function(){return Y.parse(Q,oe)}).catch(H);ne.walkTokens(Q,oe.walkTokens)}return Y.parse(Q,oe)}catch(J){H(J)}}ne.options=ne.setOptions=function(se){return r(ne.defaults,se),A(ne.defaults),ne},ne.getDefaults=I,ne.defaults=te.defaults,ne.use=function(){for(var se=arguments.length,oe=new Array(se),fe=0;fe<se;fe++)oe[fe]=arguments[fe];var Z=r.apply(void 0,[{}].concat(oe)),ce=ne.defaults.extensions||{renderers:{},childTokens:{}},ie;oe.forEach(function(N){if(N.extensions&&(ie=!0,N.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var J=ce.renderers?ce.renderers[Q.name]:null;J?ce.renderers[Q.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var pe=Q.renderer.apply(this,we);return pe===!1&&(pe=J.apply(this,we)),pe}:ce.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[Q.level]?ce[Q.level].unshift(Q.tokenizer):ce[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?ce.startBlock?ce.startBlock.push(Q.start):ce.startBlock=[Q.start]:Q.level==="inline"&&(ce.startInline?ce.startInline.push(Q.start):ce.startInline=[Q.start]))}Q.childTokens&&(ce.childTokens[Q.name]=Q.childTokens)})),N.renderer&&function(){var Q=ne.defaults.renderer||new ue,J=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=N.renderer[Ae].apply(Q,ke);return Ge===!1&&(Ge=pe.apply(Q,ke)),Ge}};for(var he in N.renderer)J(he);Z.renderer=Q}(),N.tokenizer&&function(){var Q=ne.defaults.tokenizer||new F,J=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=N.tokenizer[Ae].apply(Q,ke);return Ge===!1&&(Ge=pe.apply(Q,ke)),Ge}};for(var he in N.tokenizer)J(he);Z.tokenizer=Q}(),N.walkTokens){var H=ne.defaults.walkTokens;Z.walkTokens=function(Q){var J=[];return J.push(N.walkTokens.call(this,Q)),H&&(J=J.concat(H.call(this,Q))),J}}ie&&(Z.extensions=ce),ne.setOptions(Z)})},ne.walkTokens=function(se,oe){for(var fe=[],Z=function(){var H=ie.value;switch(fe=fe.concat(oe.call(ne,H)),H.type){case"table":{for(var Q=R(H.header),J;!(J=Q()).done;){var he=J.value;fe=fe.concat(ne.walkTokens(he.tokens,oe))}for(var we=R(H.rows),Ae;!(Ae=we()).done;)for(var pe=Ae.value,De=R(pe),ke;!(ke=De()).done;){var je=ke.value;fe=fe.concat(ne.walkTokens(je.tokens,oe))}break}case"list":{fe=fe.concat(ne.walkTokens(H.items,oe));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[H.type]?ne.defaults.extensions.childTokens[H.type].forEach(function(Ge){fe=fe.concat(ne.walkTokens(H[Ge],oe))}):H.tokens&&(fe=fe.concat(ne.walkTokens(H.tokens,oe)))}},ce=R(se),ie;!(ie=ce()).done;)Z();return fe},ne.parseInline=function(se,oe){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");oe=r({},ne.defaults,oe||{}),k(oe);try{var fe=j.lexInline(se,oe);return oe.walkTokens&&ne.walkTokens(fe,oe.walkTokens),Y.parseInline(fe,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(Z.message+"",!0)+"</pre>";throw Z}},ne.Parser=Y,ne.parser=Y.parse,ne.Renderer=ue,ne.TextRenderer=V,ne.Lexer=j,ne.lexer=j.lex,ne.Tokenizer=F,ne.Slugger=_,ne.parse=ne;var ee=ne.options,X=ne.setOptions,G=ne.use,de=ne.walkTokens,be=ne.parseInline,Ee=ne,Pe=Y.parse,Fe=j.lex;te.Lexer=j,te.Parser=Y,te.Renderer=ue,te.Slugger=_,te.TextRenderer=V,te.Tokenizer=F,te.getDefaults=I,te.lexer=Fe,te.marked=ne,te.options=ee,te.parse=Ee,te.parseInline=be,te.parser=Pe,te.setOptions=X,te.use=G,te.walkTokens=de,Object.defineProperty(te,"__esModule",{value:!0})}),define(ye[84],Ce([1,0,28]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new a.LRUCache(1e4);function T(D){return y(D,"NFC",t)}e.normalizeNFC=T;const R=new a.LRUCache(1e4);function I(D){return y(D,"NFD",R)}e.normalizeNFD=I;const A=/[^\u0000-\u0080]/;function y(D,L,P){if(!D)return D;const w=P.get(D);if(w)return w;let C;return A.test(D)?C=D.normalize(L):C=D,P.set(D,C),C}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(L){return I(L).replace(D,"")}}()}),define(ye[102],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(A,y,D){return Math.min(Math.max(A,y),D)}e.clamp=a;function t(A,y){return(y+A%y)%y}e.rot=t;class T{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=T;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class I{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const D=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function te(T){const R=[];typeof T=="number"&&R.push("code/timeOrigin",T);function I(y){R.push(y,Date.now())}function A(){const y=[];for(let D=0;D<R.length;D+=2)y.push({name:R[D],startTime:R[D+1]});return y}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const I of performance.getEntriesByType("mark"))R.push({name:I.name,startTime:Math.round(T+I.startTime)});return R}};if(typeof process=="object"){const T=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function a(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var t in a)(typeof exports=="object"?exports:te)[t]=a[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function a(t){if(e[t])return e[t].exports;var T=e[t]={i:t,l:!1,exports:{}};return te[t].call(T.exports,T,T.exports,a),T.l=!0,T.exports}return a.m=te,a.c=e,a.d=function(t,T,R){a.o(t,T)||Object.defineProperty(t,T,{enumerable:!0,get:R})},a.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},a.t=function(t,T){if(1&T&&(t=a(t)),8&T||4&T&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&T&&typeof t!="string")for(var I in t)a.d(R,I,function(A){return t[A]}.bind(null,I));return R},a.n=function(t){var T=t&&t.__esModule?function(){return t.default}:function(){return t};return a.d(T,"a",T),T},a.o=function(t,T){return Object.prototype.hasOwnProperty.call(t,T)},a.p="",a(a.s=0)}([function(te,e,a){(function(t){var T;e=te.exports=G,T=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],D=0,L=D++;y[L]="0|[1-9]\\d*";var P=D++;y[P]="[0-9]+";var w=D++;y[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=D++;y[C]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var v=D++;y[v]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var m=D++;y[m]="(?:"+y[L]+"|"+y[w]+")";var h=D++;y[h]="(?:"+y[P]+"|"+y[w]+")";var f=D++;y[f]="(?:-("+y[m]+"(?:\\."+y[m]+")*))";var p=D++;y[p]="(?:-?("+y[h]+"(?:\\."+y[h]+")*))";var b=D++;y[b]="[0-9A-Za-z-]+";var S=D++;y[S]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var g=D++,i="v?"+y[C]+y[f]+"?"+y[S]+"?";y[g]="^"+i+"$";var s="[v=\\s]*"+y[v]+y[p]+"?"+y[S]+"?",o=D++;y[o]="^"+s+"$";var l=D++;y[l]="((?:<|>)?=?)";var c=D++;y[c]=y[P]+"|x|X|\\*";var u=D++;y[u]=y[L]+"|x|X|\\*";var r=D++;y[r]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[f]+")?"+y[S]+"?)?)?";var n=D++;y[n]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[p]+")?"+y[S]+"?)?)?";var d=D++;y[d]="^"+y[l]+"\\s*"+y[r]+"$";var E=D++;y[E]="^"+y[l]+"\\s*"+y[n]+"$";var k=D++;y[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;y[M]="(?:~>?)";var K=D++;y[K]="(\\s*)"+y[M]+"\\s+",A[K]=new RegExp(y[K],"g");var q=D++;y[q]="^"+y[M]+y[r]+"$";var F=D++;y[F]="^"+y[M]+y[n]+"$";var B=D++;y[B]="(?:\\^)";var O=D++;y[O]="(\\s*)"+y[B]+"\\s+",A[O]=new RegExp(y[O],"g");var U=D++;y[U]="^"+y[B]+y[r]+"$";var $=D++;y[$]="^"+y[B]+y[n]+"$";var j=D++;y[j]="^"+y[l]+"\\s*("+s+")$|^$";var ue=D++;y[ue]="^"+y[l]+"\\s*("+i+")$|^$";var V=D++;y[V]="(\\s*)"+y[l]+"\\s*("+s+"|"+y[r]+")",A[V]=new RegExp(y[V],"g");var _=D++;y[_]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var Y=D++;y[Y]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var ne=D++;y[ne]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)T(ee,y[ee]),A[ee]||(A[ee]=new RegExp(y[ee]));function X(pe,De){if(pe instanceof G)return pe;if(typeof pe!="string"||pe.length>R||!(De?A[o]:A[g]).test(pe))return null;try{return new G(pe,De)}catch{return null}}function G(pe,De){if(pe instanceof G){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(pe,De);T("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?A[o]:A[g]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<I)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=X,e.valid=function(pe,De){var ke=X(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=X(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(pe){return T("SemVer.compare",this.version,this.loose,pe),pe instanceof G||(pe=new G(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},G.prototype.compareMain=function(pe){return pe instanceof G||(pe=new G(pe,this.loose)),be(this.major,pe.major)||be(this.minor,pe.minor)||be(this.patch,pe.patch)},G.prototype.comparePre=function(pe){if(pe instanceof G||(pe=new G(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],je=pe.prerelease[De];if(T("prerelease compare",De,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return be(ke,je)}while(++De)},G.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new G(pe,ke).inc(De,je).version}catch{return null}},e.diff=function(pe,De){if(se(pe,De))return null;var ke=X(pe),je=X(De);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=be;var de=/^[0-9]+$/;function be(pe,De){var ke=de.test(pe),je=de.test(De);return ke&&je&&(pe=+pe,De=+De),ke&&!je?-1:je&&!ke?1:pe<De?-1:pe>De?1:0}function Ee(pe,De,ke){return new G(pe,ke).compare(new G(De,ke))}function Pe(pe,De,ke){return Ee(pe,De,ke)>0}function Fe(pe,De,ke){return Ee(pe,De,ke)<0}function se(pe,De,ke){return Ee(pe,De,ke)===0}function oe(pe,De,ke){return Ee(pe,De,ke)!==0}function fe(pe,De,ke){return Ee(pe,De,ke)>=0}function Z(pe,De,ke){return Ee(pe,De,ke)<=0}function ce(pe,De,ke,je){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=oe(pe,ke,je);break;case">":Ge=Pe(pe,ke,je);break;case">=":Ge=fe(pe,ke,je);break;case"<":Ge=Fe(pe,ke,je);break;case"<=":Ge=Z(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function ie(pe,De){if(pe instanceof ie){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,De);T("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===N?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(pe,De){return be(De,pe)},e.major=function(pe,De){return new G(pe,De).major},e.minor=function(pe,De){return new G(pe,De).minor},e.patch=function(pe,De){return new G(pe,De).patch},e.compare=Ee,e.compareLoose=function(pe,De){return Ee(pe,De,!0)},e.rcompare=function(pe,De,ke){return Ee(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,je){return e.compare(ke,je,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,je){return e.rcompare(ke,je,De)})},e.gt=Pe,e.lt=Fe,e.eq=se,e.neq=oe,e.gte=fe,e.lte=Z,e.cmp=ce,e.Comparator=ie;var N={};function H(pe,De){if(pe instanceof H)return pe.loose===De?pe:new H(pe.raw,De);if(pe instanceof ie)return new H(pe.value,De);if(!(this instanceof H))return new H(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function Q(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function J(pe,De,ke,je,Ge,et,Qe,nt,st,ht,Me,it,ae){return((De=Q(ke)?"":Q(je)?">="+ke+".0.0":Q(Ge)?">="+ke+"."+je+".0":">="+De)+" "+(nt=Q(st)?"":Q(ht)?"<"+(+st+1)+".0.0":Q(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function he(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(T(pe[ke].semver),pe[ke].semver!==N&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===De.major&&je.minor===De.minor&&je.patch===De.patch)return!0}return!1}return!0}function we(pe,De,ke){try{De=new H(De,ke)}catch{return!1}return De.test(pe)}function Ae(pe,De,ke,je){var Ge,et,Qe,nt,st;switch(pe=new G(pe,je),De=new H(De,je),ke){case">":Ge=Pe,et=Z,Qe=Fe,nt=">",st=">=";break;case"<":Ge=Fe,et=fe,Qe=Pe,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(pe,De,je))return!1;for(var ht=0;ht<De.set.length;++ht){var Me=De.set[ht],it=null,ae=null;if(Me.forEach(function(z){z.semver===N&&(z=new ie(">=0.0.0")),it=it||z,ae=ae||z,Ge(z.semver,it.semver,je)?it=z:Qe(z.semver,ae.semver,je)&&(ae=z)}),it.operator===nt||it.operator===st||(!ae.operator||ae.operator===nt)&&et(pe,ae.semver)||ae.operator===st&&Qe(pe,ae.semver))return!1}return!0}ie.prototype.parse=function(pe){var De=this.loose?A[j]:A[ue],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new G(ke[2],this.loose):this.semver=N},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return T("Comparator.test",pe,this.loose),this.semver===N||(typeof pe=="string"&&(pe=new G(pe,this.loose)),ce(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,De){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,De),we(this.value,ke,De);if(pe.operator==="")return ke=new H(this.value,De),we(pe.semver,ke,De);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ce(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ce(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&Qe||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),T("range",pe,De);var ke=De?A[Y]:A[_];pe=pe.replace(ke,J),T("hyphen replace",pe),pe=pe.replace(A[V],"$1$2$3"),T("comparator trim",pe,A[V]),pe=(pe=(pe=pe.replace(A[K],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var je=De?A[j]:A[ue],Ge=pe.split(" ").map(function(et){return function(Qe,nt){return T("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,ae){T("caret",it,ae);var z=ae?A[$]:A[U];return it.replace(z,function(le,Ie,Le,Be,Xe){var Ze;return T("caret",it,le,Ie,Le,Be,Xe),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Xe?(T("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+Xe+" <"+(+Ie+1)+".0.0"):(T("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),T("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(Qe,nt),T("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,ae){var z=ae?A[F]:A[q];return it.replace(z,function(le,Ie,Le,Be,Xe){var Ze;return T("tilde",it,le,Ie,Le,Be,Xe),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Xe?(T("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",T("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(Qe,nt),T("tildes",Qe),Qe=function(st,ht){return T("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,ae){it=it.trim();var z=ae?A[E]:A[d];return it.replace(z,function(le,Ie,Le,Be,Xe,Ze){T("xRange",it,le,Ie,Le,Be,Xe,Ze);var gt=Q(Le),mt=gt||Q(Be),lt=mt||Q(Xe);return Ie==="="&&lt&&(Ie=""),gt?le=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(mt&&(Be=0),lt&&(Xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,Be=0,Xe=0):lt&&(Be=+Be+1,Xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:Be=+Be+1),le=Ie+Le+"."+Be+"."+Xe):mt?le=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(le=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),T("xRange return",le),le})}(Me,ht)}).join(" ")}(Qe,nt),T("xrange",Qe),Qe=function(st,ht){return T("replaceStars",st,ht),st.trim().replace(A[ne],"")}(Qe,nt),T("stars",Qe),Qe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,De)})},H.prototype.intersects=function(pe,De){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new H(pe,De).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new G(pe,this.loose));for(var De=0;De<this.set.length;De++)if(he(this.set[De],pe))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(je&&Ge.compare(Qe)!==-1||(Ge=new G(je=Qe,ke)))}),je},e.minSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(je&&Ge.compare(Qe)!==1||(Ge=new G(je=Qe,ke)))}),je},e.validRange=function(pe,De){try{return new H(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Ae(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Ae(pe,De,">",ke)},e.outside=Ae,e.prerelease=function(pe,De){var ke=X(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new H(pe,ke),De=new H(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof G)return pe;if(typeof pe!="string")return null;var De=pe.match(A[k]);return De==null?null:X((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,a(1))},function(te,e){var a,t,T=te.exports={};function R(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(h){if(a===setTimeout)return setTimeout(h,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(h,0);try{return a(h,0)}catch{try{return a.call(null,h,0)}catch{return a.call(this,h,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{t=typeof clearTimeout=="function"?clearTimeout:I}catch{t=I}})();var y,D=[],L=!1,P=-1;function w(){L&&y&&(L=!1,y.length?D=y.concat(D):P=-1,D.length&&C())}function C(){if(!L){var h=A(w);L=!0;for(var f=D.length;f;){for(y=D,D=[];++P<f;)y&&y[P].run();P=-1,f=D.length}y=null,L=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===I||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(h)}}function v(h,f){this.fun=h,this.array=f}function m(){}T.nextTick=function(h){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];D.push(new v(h,f)),D.length!==1||L||A(C)},v.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=m,T.addListener=m,T.once=m,T.off=m,T.removeListener=m,T.removeAllListeners=m,T.emit=m,T.prependListener=m,T.prependOnceListener=m,T.listeners=function(h){return[]},T.binding=function(h){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(h){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ye[103],Ce([1,0,9,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(S){const g=S;return g?typeof g.read=="function":!1}e.isReadable=T;function R(S){const g=S;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function I(S){const g=S;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(S,g){return new y(S,g)}e.newWriteableStream=A;class y{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,a.onUnexpectedError)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let s;switch(g){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const o=s.indexOf(i);o>=0&&s.splice(o,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(S,g){const i=[];let s;for(;(s=S.read())!==null;)i.push(s);return g(i)}e.consumeReadable=D;function L(S,g,i){const s=[];let o;for(;(o=S.read())!==null&&s.length<i;)s.push(o);return o===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof o<"u"){const l=o;return o=void 0,l}return S.read()}}}e.peekReadable=L;function P(S,g){return new Promise((i,s)=>{const o=[];w(S,{onData:l=>{g&&o.push(l)},onError:l=>{g?s(l):i(void 0)},onEnd:()=>{i(g?g(o):void 0)}})})}e.consumeStream=P;function w(S,g){let i=!1;return S.on("error",s=>{i||g.onError(s)}),S.on("end",()=>{i||g.onEnd()}),S.on("data",s=>{i||g.onData(s)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=w;function C(S,g){return new Promise((i,s)=>{const o=new t.DisposableStore,l=[],c=n=>{if(l.push(n),l.length>g)return o.dispose(),S.pause(),i({stream:S,buffer:l,ended:!1})},u=n=>s(n),r=()=>i({stream:S,buffer:l,ended:!0});o.add((0,t.toDisposable)(()=>S.removeListener("error",u))),S.on("error",u),o.add((0,t.toDisposable)(()=>S.removeListener("end",r))),S.on("end",r),o.add((0,t.toDisposable)(()=>S.removeListener("data",c))),S.on("data",c)})}e.peekStream=C;function v(S,g){const i=A(g);return i.end(S),i}e.toStream=v;function m(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=m;function h(S){let g=!1;return{read:()=>g?null:(g=!0,S)}}e.toReadable=h;function f(S,g,i){const s=A(i);return w(S,{onData:o=>s.write(g.data(o)),onError:o=>s.error(g.error?g.error(o):o),onEnd:()=>s.end()}),s}e.transform=f;function p(S,g,i){let s=!1;return{read:()=>{const o=g.read();return s?o:(s=!0,o!==null?i([S,o]):S)}}}e.prefixedReadable=p;function b(S,g,i){let s=!1;const o=A(i);return w(g,{onData:l=>s?o.write(l):(s=!0,o.write(i([S,l]))),onError:l=>o.error(l),onEnd:()=>{s||(s=!0,o.write(S)),o.end()}}),o}e.prefixedStream=b}),define(ye[23],Ce([1,0,103]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let T,R;class I{static alloc(n){return t?new I(Buffer.allocUnsafe(n)):new I(new Uint8Array(n))}static wrap(n){return t&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new I(n)}static fromString(n,d){return!(d?.dontUseNodeBuffer||!1)&&t?new I(Buffer.from(n)):(T||(T=new TextEncoder),new I(T.encode(n)))}static fromByteArray(n){const d=I.alloc(n.length);for(let E=0,k=n.length;E<k;E++)d.buffer[E]=n[E];return d}static concat(n,d){if(typeof d>"u"){d=0;for(let M=0,K=n.length;M<K;M++)d+=n[M].byteLength}const E=I.alloc(d);let k=0;for(let M=0,K=n.length;M<K;M++){const q=n[M];E.set(q,k),k+=q.byteLength}return E}constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}clone(){const n=I.alloc(this.byteLength);return n.set(this),n}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,d){return new I(this.buffer.subarray(n,d))}set(n,d){if(n instanceof I)this.buffer.set(n.buffer,d);else if(n instanceof Uint8Array)this.buffer.set(n,d);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),d);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(n){return D(this.buffer,n)}writeUInt32BE(n,d){L(this.buffer,n,d)}readUInt32LE(n){return P(this.buffer,n)}writeUInt32LE(n,d){w(this.buffer,n,d)}readUInt8(n){return C(this.buffer,n)}writeUInt8(n,d){v(this.buffer,n,d)}}e.VSBuffer=I;function A(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}e.readUInt16LE=A;function y(r,n,d){r[d+0]=n&255,n=n>>>8,r[d+1]=n&255}e.writeUInt16LE=y;function D(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}e.readUInt32BE=D;function L(r,n,d){r[d+3]=n,n=n>>>8,r[d+2]=n,n=n>>>8,r[d+1]=n,n=n>>>8,r[d]=n}e.writeUInt32BE=L;function P(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}e.readUInt32LE=P;function w(r,n,d){r[d+0]=n&255,n=n>>>8,r[d+1]=n&255,n=n>>>8,r[d+2]=n&255,n=n>>>8,r[d+3]=n&255}e.writeUInt32LE=w;function C(r,n){return r[n]}e.readUInt8=C;function v(r,n,d){r[d]=n}e.writeUInt8=v;function m(r){return a.consumeReadable(r,n=>I.concat(n))}e.readableToBuffer=m;function h(r){return a.toReadable(r)}e.bufferToReadable=h;function f(r){return a.consumeStream(r,n=>I.concat(n))}e.streamToBuffer=f;async function p(r){return r.ended?I.concat(r.buffer):I.concat([...r.buffer,await f(r.stream)])}e.bufferedStreamToBuffer=p;function b(r){return a.toStream(r,n=>I.concat(n))}e.bufferToStream=b;function S(r){return a.transform(r,{data:n=>typeof n=="string"?I.fromString(n):I.wrap(n)},n=>I.concat(n))}e.streamToBufferReadableStream=S;function g(r){return a.newWriteableStream(n=>I.concat(n),r)}e.newWriteableBufferStream=g;function i(r,n){return a.prefixedReadable(r,n,d=>I.concat(d))}e.prefixedBufferReadable=i;function s(r,n){return a.prefixedStream(r,n,d=>I.concat(d))}e.prefixedBufferStream=s;function o(r){let n=0,d=0,E=0;const k=new Uint8Array(Math.floor(r.length/4*3)),M=q=>{switch(d){case 3:k[E++]=n|q,d=0;break;case 2:k[E++]=n|q>>>2,n=q<<6,d=3;break;case 1:k[E++]=n|q>>>4,n=q<<4,d=2;break;default:n=q<<2,d=1}};for(let q=0;q<r.length;q++){const F=r.charCodeAt(q);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${r[q]}`)}}const K=E;for(;d>0;)M(0);return I.wrap(k).slice(0,K)}e.decodeBase64=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:r},n=!0,d=!1){const E=d?c:l;let k="";const M=r.byteLength%3;let K=0;for(;K<r.byteLength-M;K+=3){const q=r[K+0],F=r[K+1],B=r[K+2];k+=E[q>>>2],k+=E[(q<<4|F>>>4)&63],k+=E[(F<<2|B>>>6)&63],k+=E[B&63]}if(M===1){const q=r[K+0];k+=E[q>>>2],k+=E[q<<4&63],n&&(k+="==")}else if(M===2){const q=r[K+0],F=r[K+1];k+=E[q>>>2],k+=E[(q<<4|F>>>4)&63],k+=E[F<<2&63],n&&(k+="=")}return k}e.encodeBase64=u}),define(ye[10],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(s){return typeof s=="string"}e.isString=a;function t(s){return Array.isArray(s)&&s.every(o=>a(o))}e.isStringArray=t;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function R(s){const o=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof o}e.isTypedArray=R;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function A(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=A;function y(s){return s===!0||s===!1}e.isBoolean=y;function D(s){return typeof s>"u"}e.isUndefined=D;function L(s){return!P(s)}e.isDefined=L;function P(s){return D(s)||s===null}e.isUndefinedOrNull=P;function w(s,o){if(!s)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=w;function C(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=C;function v(...s){const o=[];for(let l=0;l<s.length;l++){const c=s[l];if(P(c))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);o.push(c)}return o}e.assertAllDefined=v;const m=Object.prototype.hasOwnProperty;function h(s){if(!T(s))return!1;for(const o in s)if(m.call(s,o))return!1;return!0}e.isEmptyObject=h;function f(s){return typeof s=="function"}e.isFunction=f;function p(...s){return s.length>0&&s.every(f)}e.areFunctions=p;function b(s,o){const l=Math.min(s.length,o.length);for(let c=0;c<l;c++)S(s[c],o[c])}e.validateConstraints=b;function S(s,o){if(a(o)){if(typeof s!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(f(o)){try{if(s instanceof o)return}catch{}if(!P(s)&&s.constructor===o||o.length===1&&o.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function g(s){return s===null?void 0:s}e.withNullAsUndefined=g;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ye[22],Ce([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,S])=>{p[b]=S&&typeof S=="object"?t(S):S}),p}e.deepClone=t;function T(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const S in b)if(R.call(b,S)){const g=b[S];typeof g=="object"&&!Object.isFrozen(g)&&!(0,a.isTypedArray)(g)&&p.push(g)}}return f}e.deepFreeze=T;const R=Object.prototype.hasOwnProperty;function I(f,p){return A(f,p,new Set)}e.cloneAndChange=I;function A(f,p,b){if((0,a.isUndefinedOrNull)(f))return f;const S=p(f);if(typeof S<"u")return S;if(Array.isArray(f)){const g=[];for(const i of f)g.push(A(i,p,b));return g}if((0,a.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const g={};for(const i in f)R.call(f,i)&&(g[i]=A(f[i],p,b));return b.delete(f),g}return f}function y(f,p,b=!0){return(0,a.isObject)(f)?((0,a.isObject)(p)&&Object.keys(p).forEach(S=>{S in f?b&&((0,a.isObject)(f[S])&&(0,a.isObject)(p[S])?y(f[S],p[S],b):f[S]=p[S]):f[S]=p[S]}),f):p}e.mixin=y;function D(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let b,S;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(b=0;b<f.length;b++)if(!D(f[b],p[b]))return!1}else{const g=[];for(S in f)g.push(S);g.sort();const i=[];for(S in p)i.push(S);if(i.sort(),!D(g,i))return!1;for(b=0;b<g.length;b++)if(!D(f[g[b]],p[g[b]]))return!1}return!0}e.equals=D;function L(f){const p=new Set;return JSON.stringify(f,(b,S)=>{if((0,a.isObject)(S)||Array.isArray(S)){if(p.has(S))return"[Circular]";p.add(S)}return S})}e.safeStringify=L;function P(f,p){const b=Object.create(null);return!f||!p||Object.keys(p).forEach(g=>{const i=f[g],s=p[g];D(i,s)||(b[g]=s)}),b}e.distinct=P;function w(f,p){const b=p.toLowerCase(),S=Object.keys(f).find(g=>g.toLowerCase()===b);return S?f[S]:f[p]}e.getCaseInsensitive=w;function C(f,p){const b=Object.create(null);for(const[S,g]of Object.entries(f))p(S,g)&&(b[S]=g);return b}e.filter=C;function v(f){let p=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=v;function m(f){const p=[];for(const b of v(f))typeof f[b]=="function"&&p.push(b);return p}e.getAllMethodNames=m;function h(f,p){const b=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},S={};for(const g of f)S[g]=b(g);return S}e.createProxyObject=h}),define(ye[104],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function t(R){return R<0?0:R>255?255:R|0}e.toUint8=t;function T(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=T}),define(ye[30],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(T){return a.test(T)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){T(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,D="";return D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D}}()}),define(ye[148],Ce([1,0,16,30]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function T(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=T;function R(A,y,D){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:D}),value:void 0}}e.createFileDataTransferItem=R;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,D){const L=this.a.get(y);L?L.push(D):this.a.set(this.b(y),[D])}replace(y,D){this.a.set(this.b(y),[D])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,D]of this.a.entries())for(const L of D)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[D,L]of this.entries())y(L,D)}b(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,a.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[105],Ce([1,0,104]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(A){const y=(0,a.toUint8)(A);this.c=y,this.a=t.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const D=(0,a.toUint8)(y);A>=0&&A<256?this.a[A]=D:this.b.set(A,D)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var T;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(T||(T={}));class R{constructor(){this.a=new t(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(T,R){this.lineNumber=T,this.column=R}with(T=this.lineNumber,R=this.column){return T===this.lineNumber&&R===this.column?this:new a(T,R)}delta(T=0,R=0){return this.with(this.lineNumber+T,this.column+R)}equals(T){return a.equals(this,T)}static equals(T,R){return!T&&!R?!0:!!T&&!!R&&T.lineNumber===R.lineNumber&&T.column===R.column}isBefore(T){return a.isBefore(this,T)}static isBefore(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<R.column}isBeforeOrEqual(T){return a.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<=R.column}static compare(T,R){const I=T.lineNumber|0,A=R.lineNumber|0;if(I===A){const y=T.column|0,D=R.column|0;return y-D}return I-A}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new a(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=a}),define(ye[36],Ce([1,0,52]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(R,I,A,y){R>A||R===A&&I>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=I):(this.startLineNumber=R,this.startColumn=I,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return t.containsPosition(this,R)}static containsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<R.startColumn||I.lineNumber===R.endLineNumber&&I.column>R.endColumn)}static strictContainsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<=R.startColumn||I.lineNumber===R.endLineNumber&&I.column>=R.endColumn)}containsRange(R){return t.containsRange(this,R)}static containsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>R.endColumn)}strictContainsRange(R){return t.strictContainsRange(this,R)}static strictContainsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<=R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>=R.endColumn)}plusRange(R){return t.plusRange(this,R)}static plusRange(R,I){let A,y,D,L;return I.startLineNumber<R.startLineNumber?(A=I.startLineNumber,y=I.startColumn):I.startLineNumber===R.startLineNumber?(A=I.startLineNumber,y=Math.min(I.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),I.endLineNumber>R.endLineNumber?(D=I.endLineNumber,L=I.endColumn):I.endLineNumber===R.endLineNumber?(D=I.endLineNumber,L=Math.max(I.endColumn,R.endColumn)):(D=R.endLineNumber,L=R.endColumn),new t(A,y,D,L)}intersectRanges(R){return t.intersectRanges(this,R)}static intersectRanges(R,I){let A=R.startLineNumber,y=R.startColumn,D=R.endLineNumber,L=R.endColumn;const P=I.startLineNumber,w=I.startColumn,C=I.endLineNumber,v=I.endColumn;return A<P?(A=P,y=w):A===P&&(y=Math.max(y,w)),D>C?(D=C,L=v):D===C&&(L=Math.min(L,v)),A>D||A===D&&y>L?null:new t(A,y,D,L)}equalsRange(R){return t.equalsRange(this,R)}static equalsRange(R,I){return!R&&!I?!0:!!R&&!!I&&R.startLineNumber===I.startLineNumber&&R.startColumn===I.startColumn&&R.endLineNumber===I.endLineNumber&&R.endColumn===I.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(R){return new a.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(R){return new a.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,I){return new t(this.startLineNumber,this.startColumn,R,I)}setStartPosition(R,I){return new t(R,I,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(R){return new t(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(R){return new t(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new t(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,I=R){return new t(R.lineNumber,R.column,I.lineNumber,I.column)}static lift(R){return R?new t(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn)}static areIntersecting(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,I){if(R&&I){const D=R.startLineNumber|0,L=I.startLineNumber|0;if(D===L){const P=R.startColumn|0,w=I.startColumn|0;if(P===w){const C=R.endLineNumber|0,v=I.endLineNumber|0;if(C===v){const m=R.endColumn|0,h=I.endColumn|0;return m-h}return C-v}return P-w}return D-L}return(R?1:0)-(I?1:0)}static compareRangesUsingEnds(R,I){return R.endLineNumber===I.endLineNumber?R.endColumn===I.endColumn?R.startLineNumber===I.startLineNumber?R.startColumn-I.startColumn:R.startLineNumber-I.startLineNumber:R.endColumn-I.endColumn:R.endLineNumber-I.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,52,36]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class R extends t.Range{constructor(A,y,D,L){super(A,y,D,L),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=D,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let D=0,L=A.length;D<L;D++)if(!this.selectionsEqual(A[D],y[D]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,D,L,P){return P===0?new R(A,y,D,L):new R(D,L,A,y)}}e.Selection=R}),define(ye[150],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,105]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends a.CharacterClassifier{constructor(A){super(0);for(let y=0,D=A.length;y<D;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function R(I){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=I(y)),A[y])}e.getMapForWordSeparators=R(I=>new T(I))}),define(ye[106],Ce([1,0,64,6,65]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)P.indexOf(C)>=0||(w+="\\"+C);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=R();function I(P){let w=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)w=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),w=new RegExp(P.source,C)}return w.lastIndex=0,w}e.ensureValidWordDefinition=I;const A=new T.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const w=A.unshift(P);return(0,t.toDisposable)(w)}e.setDefaultGetWordAtTextConfig=y;function D(P,w,C,v,m){if(m||(m=a.Iterable.first(A)),C.length>m.maxLen){let S=P-m.maxLen/2;return S<0?S=0:v+=S,C=C.substring(S,P+m.maxLen/2),D(P,w,C,v,m)}const h=Date.now(),f=P-1-v;let p=-1,b=null;for(let S=1;!(Date.now()-h>=m.timeBudget);S++){const g=f-m.windowSize*S;w.lastIndex=Math.max(0,g);const i=L(w,C,f,p);if(!i&&b||(b=i,g<=0))break;p=g}if(b){const S={word:b[0],startColumn:v+1+b.index,endColumn:v+1+b.index+b[0].length};return w.lastIndex=0,S}return null}e.getWordAtText=D;function L(P,w,C,v){let m;for(;m=P.exec(w);){const h=m.index||0;if(h<=C&&P.lastIndex>=C)return m;if(v>0&&h>v)return null}return null}}),define(ye[152],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,D=A.notIn.length;y<D;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const D=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(D);return this.isOK(L)}g(A,y){for(let D=A;D<=y;D++){const L=String.fromCharCode(D);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class T{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function R(I,A,y){I.has(A)?I.get(A).push(y):I.set(A,[y])}}),define(ye[153],Ce([1,0,105]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class T{constructor(v,m,h){const f=new Uint8Array(v*m);for(let p=0,b=v*m;p<b;p++)f[p]=h;this.a=f,this.rows=v,this.cols=m}get(v,m){return this.a[v*this.cols+m]}set(v,m,h){this.a[v*this.cols+m]=h}}class R{constructor(v){let m=0,h=0;for(let p=0,b=v.length;p<b;p++){const[S,g,i]=v[p];g>m&&(m=g),S>h&&(h=S),i>h&&(h=i)}m++,h++;const f=new T(h,m,0);for(let p=0,b=v.length;p<b;p++){const[S,g,i]=v[p];f.set(S,g,i)}this.a=f,this.b=m}nextState(v,m){return m<0||m>=this.b?0:this.a.get(v,m)}}e.StateMachine=R;let I=null;function A(){return I===null&&(I=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var y;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let D=null;function L(){if(D===null){D=new a.CharacterClassifier(0);const C=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<C.length;m++)D.set(C.charCodeAt(m),1);const v=".;:";for(let m=0;m<v.length;m++)D.set(v.charCodeAt(m),2)}return D}class P{static a(v,m,h,f,p){let b=p-1;do{const S=m.charCodeAt(b);if(v.get(S)!==2)break;b--}while(b>f);if(f>0){const S=m.charCodeAt(f-1),g=m.charCodeAt(b);(S===40&&g===41||S===91&&g===93||S===123&&g===125)&&b--}return{range:{startLineNumber:h,startColumn:f+1,endLineNumber:h,endColumn:b+2},url:m.substring(f,b+1)}}static computeLinks(v,m=A()){const h=L(),f=[];for(let p=1,b=v.getLineCount();p<=b;p++){const S=v.getLineContent(p),g=S.length;let i=0,s=0,o=0,l=1,c=!1,u=!1,r=!1,n=!1;for(;i<g;){let d=!1;const E=S.charCodeAt(i);if(l===13){let k;switch(E){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:r=!0,u=!0,k=0;break;case 93:r=!1,k=u?0:1;break;case 123:n=!0,k=0;break;case 125:k=n?0:1;break;case 39:case 34:case 96:o===E?k=1:o===39||o===34||o===96?k=0:k=1;break;case 42:k=o===42?1:0;break;case 124:k=o===124?1:0;break;case 32:k=r?0:1;break;default:k=h.get(E)}k===1&&(f.push(P.a(h,S,p,s,i)),d=!0)}else if(l===12){let k;E===91?(u=!0,k=0):k=h.get(E),k===1?d=!0:l=13}else l=m.nextState(l,E),l===0&&(d=!0);d&&(l=1,c=!1,u=!1,n=!1,s=i+1,o=E),i++}l===13&&f.push(P.a(h,S,p,s,g))}return f}}e.LinkComputer=P;function w(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:P.computeLinks(C)}e.computeLinks=w}),define(ye[107],Ce([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var I;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(S){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,S.tabSize|0),S.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,S.indentSize|0),this.a=!1),this.insertSpaces=Boolean(S.insertSpaces),this.defaultEOL=S.defaultEOL|0,this.trimAutoWhitespace=Boolean(S.trimAutoWhitespace),this.bracketPairColorizationOptions=S.bracketPairColorizationOptions}equals(S){return this.tabSize===S.tabSize&&this.a===S.a&&this.indentSize===S.indentSize&&this.insertSpaces===S.insertSpaces&&this.defaultEOL===S.defaultEOL&&this.trimAutoWhitespace===S.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,S.bracketPairColorizationOptions)}createChangeEvent(S){return{tabSize:this.tabSize!==S.tabSize,indentSize:this.indentSize!==S.indentSize,insertSpaces:this.insertSpaces!==S.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==S.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class L{constructor(S,g){this._findMatchBrand=void 0,this.range=S,this.matches=g}}e.FindMatch=L;var P;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function w(b){return b&&typeof b.read=="function"}e.isITextSnapshot=w;var C;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(C=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class m{constructor(S,g,i,s,o,l){this.identifier=S,this.range=g,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=o,this._isTracked=l}}e.ValidAnnotatedEditOperation=m;class h{constructor(S,g,i){this.regex=S,this.wordSeparators=g,this.simpleSearch=i}}e.SearchData=h;class f{constructor(S,g,i){this.reverseEdits=S,this.changes=g,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=f;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(ye[154],Ce([1,0,16,104]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class T{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,D){y=(0,t.toUint32)(y);const L=this.a,P=this.b,w=D.length;return w===0?!1:(this.a=new Uint32Array(L.length+w),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+w),this.a.set(D,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,D){return y=(0,t.toUint32)(y),D=(0,t.toUint32)(D),this.a[y]===D?!1:(this.a[y]=D,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,D){y=(0,t.toUint32)(y),D=(0,t.toUint32)(D);const L=this.a,P=this.b;if(y>=L.length)return!1;const w=L.length-y;return D>=w&&(D=w),D===0?!1:(this.a=new Uint32Array(L.length-D),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+D),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let D=this.c[0]+1;D===0&&(this.b[0]=this.a[0],D++),y>=this.a.length&&(y=this.a.length-1);for(let L=D;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let D=0,L=this.a.length-1,P=0,w=0,C=0;for(;D<=L;)if(P=D+(L-D)/2|0,w=this.b[P],C=w-this.a[P],y<C)L=P-1;else if(y>=w)D=P+1;else break;return new I(P,y-C)}}e.PrefixSumComputer=T;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const D=this.e[y],L=D>0?this.d[D-1]:0;return new I(D,y-L)}removeValues(y,D){this.a.splice(y,D),this.f(y)}insertValues(y,D){this.a=(0,a.arrayInsert)(this.a,y,D),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,D=this.a.length;y<D;y++){const L=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+L;for(let w=0;w<L;w++)this.e[P+w]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,D){this.a[y]!==D&&(this.a[y]=D,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class I{constructor(y,D){this.index=y,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=I}),define(ye[155],Ce([19,20]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ye[156],Ce([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ye[157],Ce([1,0,156]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,T=t*60,R=T*24,I=R*7,A=R*30,y=R*365;function D(P,w,C,v){typeof P!="number"&&(P=P.getTime());const m=Math.round((new Date().getTime()-P)/1e3);if(m<-30)return(0,a.localize)(0,null,D(new Date().getTime()+m*1e3,!1));if(!v&&m<30)return(0,a.localize)(1,null);let h;return m<t?(h=m,w?h===1?C?(0,a.localize)(2,null,h):(0,a.localize)(3,null,h):C?(0,a.localize)(4,null,h):(0,a.localize)(5,null,h):h===1?C?(0,a.localize)(6,null,h):(0,a.localize)(7,null,h):C?(0,a.localize)(8,null,h):(0,a.localize)(9,null,h)):m<T?(h=Math.floor(m/t),w?h===1?C?(0,a.localize)(10,null,h):(0,a.localize)(11,null,h):C?(0,a.localize)(12,null,h):(0,a.localize)(13,null,h):h===1?C?(0,a.localize)(14,null,h):(0,a.localize)(15,null,h):C?(0,a.localize)(16,null,h):(0,a.localize)(17,null,h)):m<R?(h=Math.floor(m/T),w?h===1?C?(0,a.localize)(18,null,h):(0,a.localize)(19,null,h):C?(0,a.localize)(20,null,h):(0,a.localize)(21,null,h):h===1?C?(0,a.localize)(22,null,h):(0,a.localize)(23,null,h):C?(0,a.localize)(24,null,h):(0,a.localize)(25,null,h)):m<I?(h=Math.floor(m/R),w?h===1?(0,a.localize)(26,null,h):(0,a.localize)(27,null,h):h===1?(0,a.localize)(28,null,h):(0,a.localize)(29,null,h)):m<A?(h=Math.floor(m/I),w?h===1?C?(0,a.localize)(30,null,h):(0,a.localize)(31,null,h):C?(0,a.localize)(32,null,h):(0,a.localize)(33,null,h):h===1?C?(0,a.localize)(34,null,h):(0,a.localize)(35,null,h):C?(0,a.localize)(36,null,h):(0,a.localize)(37,null,h)):m<y?(h=Math.floor(m/A),w?h===1?C?(0,a.localize)(38,null,h):(0,a.localize)(39,null,h):C?(0,a.localize)(40,null,h):(0,a.localize)(41,null,h):h===1?C?(0,a.localize)(42,null,h):(0,a.localize)(43,null,h):C?(0,a.localize)(44,null,h):(0,a.localize)(45,null,h)):(h=Math.floor(m/y),w?h===1?C?(0,a.localize)(46,null,h):(0,a.localize)(47,null,h):C?(0,a.localize)(48,null,h):(0,a.localize)(49,null,h):h===1?C?(0,a.localize)(50,null,h):(0,a.localize)(51,null,h):C?(0,a.localize)(52,null,h):(0,a.localize)(53,null,h))}e.fromNow=D;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[158],Ce([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ye[45],Ce([1,0,16,10,158]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,w){return w&&(P.stack||P.stacktrace)?T.localize(0,null,A(P),I(P.stack)||I(P.stacktrace)):A(P)}function I(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?T.localize(1,null,P.message):P.message||T.localize(2,null)}function y(P=null,w=!1){if(!P)return T.localize(3,null);if(Array.isArray(P)){const C=a.coalesce(P),v=y(C[0],w);return C.length>1?T.localize(4,null,v,C.length):v}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return R(C.error,w);if(C.exception)return R(C.exception,w)}return P.stack?R(P,w):P.message?P.message:T.localize(5,null)}e.toErrorMessage=y;function D(P){const w=P;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=D;function L(P,w){let C;return typeof P=="string"?C=new Error(P):C=P,C.actions=w,C}e.createErrorWithActions=L}),define(ye[159],Ce([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,159]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,T=!1,R=!1,I=!1,A=!1,y=!1,D=!1,L=!1,P=!1,w=!1,C,v=e.LANGUAGE_DEFAULT,m,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const p=typeof f?.versions?.electron=="string",b=p&&f?.type==="renderer";if(typeof navigator=="object"&&!b)h=navigator.userAgent,t=h.indexOf("Windows")>=0,T=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,w=h?.indexOf("Mobi")>=0,y=!0,C=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,v=C;else if(typeof f=="object"){t=f.platform==="win32",T=f.platform==="darwin",R=f.platform==="linux",I=R&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,D=p,P=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const r=f.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),d=n.availableLanguages["*"];C=n.locale,v=d||e.LANGUAGE_DEFAULT,m=n._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function g(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let i=0;T?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=T,e.isLinux=R,e.isLinuxSnap=I,e.isNative=A,e.isElectron=D,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=w,e.isCI=P,e.platform=i,e.userAgent=h,e.language=v;var s;(function(r){function n(){return e.language}r.value=n;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=d;function E(){return e.language==="en"}r.isDefault=E})(s=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let E=0,k=r.length;E<k;E++){const M=r[E];if(M.id===d.data.vscodeScheduleAsyncWork){r.splice(E,1),M.callback();return}}});let n=0;return d=>{const E=++n;r.push({id:E,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||L?2:t?1:3;let l=!0,c=!1;function u(){if(!c){c=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[37],Ce([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const T=a.globals.vscode.process;t={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[11],Ce([1,0,37]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,T=97,R=90,I=122,A=46,y=47,D=92,L=58,P=63;class w extends Error{constructor(s,o,l){let c;typeof o=="string"&&o.indexOf("not ")===0?(c="must not be",o=o.replace(/^not /,"")):c="must be";const u=s.indexOf(".")!==-1?"property":"argument";let r=`The "${s}" ${u} ${c} of type ${o}`;r+=`. Received type ${typeof l}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,s){if(i===null||typeof i!="object")throw new w(s,"Object",i)}function v(i,s){if(typeof i!="string")throw new w(s,"string",i)}const m=a.platform==="win32";function h(i){return i===y||i===D}function f(i){return i===y}function p(i){return i>=t&&i<=R||i>=T&&i<=I}function b(i,s,o,l){let c="",u=0,r=-1,n=0,d=0;for(let E=0;E<=i.length;++E){if(E<i.length)d=i.charCodeAt(E);else{if(l(d))break;d=y}if(l(d)){if(!(r===E-1||n===1))if(n===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const k=c.lastIndexOf(o);k===-1?(c="",u=0):(c=c.slice(0,k),u=c.length-1-c.lastIndexOf(o)),r=E,n=0;continue}else if(c.length!==0){c="",u=0,r=E,n=0;continue}}s&&(c+=c.length>0?`${o}..`:"..",u=2)}else c.length>0?c+=`${o}${i.slice(r+1,E)}`:c=i.slice(r+1,E),u=E-r-1;r=E,n=0}else d===A&&n!==-1?++n:n=-1}return c}function S(i,s){C(s,"pathObject");const o=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${l}`:`${o}${i}${l}`:l}e.win32={resolve(...i){let s="",o="",l=!1;for(let c=i.length-1;c>=-1;c--){let u;if(c>=0){if(u=i[c],v(u,"path"),u.length===0)continue}else s.length===0?u=a.cwd():(u=a.env[`=${s}`]||a.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==s.toLowerCase()&&u.charCodeAt(2)===D)&&(u=`${s}\\`));const r=u.length;let n=0,d="",E=!1;const k=u.charCodeAt(0);if(r===1)h(k)&&(n=1,E=!0);else if(h(k))if(E=!0,h(u.charCodeAt(1))){let M=2,K=M;for(;M<r&&!h(u.charCodeAt(M));)M++;if(M<r&&M!==K){const q=u.slice(K,M);for(K=M;M<r&&h(u.charCodeAt(M));)M++;if(M<r&&M!==K){for(K=M;M<r&&!h(u.charCodeAt(M));)M++;(M===r||M!==K)&&(d=`\\\\${q}\\${u.slice(K,M)}`,n=M)}}}else n=1;else p(k)&&u.charCodeAt(1)===L&&(d=u.slice(0,2),n=2,r>2&&h(u.charCodeAt(2))&&(E=!0,n=3));if(d.length>0)if(s.length>0){if(d.toLowerCase()!==s.toLowerCase())continue}else s=d;if(l){if(s.length>0)break}else if(o=`${u.slice(n)}\\${o}`,l=E,E&&s.length>0)break}return o=b(o,!l,"\\",h),l?`${s}\\${o}`:`${s}${o}`||"."},normalize(i){v(i,"path");const s=i.length;if(s===0)return".";let o=0,l,c=!1;const u=i.charCodeAt(0);if(s===1)return f(u)?"\\":i;if(h(u))if(c=!0,h(i.charCodeAt(1))){let n=2,d=n;for(;n<s&&!h(i.charCodeAt(n));)n++;if(n<s&&n!==d){const E=i.slice(d,n);for(d=n;n<s&&h(i.charCodeAt(n));)n++;if(n<s&&n!==d){for(d=n;n<s&&!h(i.charCodeAt(n));)n++;if(n===s)return`\\\\${E}\\${i.slice(d)}\\`;n!==d&&(l=`\\\\${E}\\${i.slice(d,n)}`,o=n)}}}else o=1;else p(u)&&i.charCodeAt(1)===L&&(l=i.slice(0,2),o=2,s>2&&h(i.charCodeAt(2))&&(c=!0,o=3));let r=o<s?b(i.slice(o),!c,"\\",h):"";return r.length===0&&!c&&(r="."),r.length>0&&h(i.charCodeAt(s-1))&&(r+="\\"),l===void 0?c?`\\${r}`:r:c?`${l}\\${r}`:`${l}${r}`},isAbsolute(i){v(i,"path");const s=i.length;if(s===0)return!1;const o=i.charCodeAt(0);return h(o)||s>2&&p(o)&&i.charCodeAt(1)===L&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,o;for(let u=0;u<i.length;++u){const r=i[u];v(r,"path"),r.length>0&&(s===void 0?s=o=r:s+=`\\${r}`)}if(s===void 0)return".";let l=!0,c=0;if(typeof o=="string"&&h(o.charCodeAt(0))){++c;const u=o.length;u>1&&h(o.charCodeAt(1))&&(++c,u>2&&(h(o.charCodeAt(2))?++c:l=!1))}if(l){for(;c<s.length&&h(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.win32.normalize(s)},relative(i,s){if(v(i,"from"),v(s,"to"),i===s)return"";const o=e.win32.resolve(i),l=e.win32.resolve(s);if(o===l||(i=o.toLowerCase(),s=l.toLowerCase(),i===s))return"";let c=0;for(;c<i.length&&i.charCodeAt(c)===D;)c++;let u=i.length;for(;u-1>c&&i.charCodeAt(u-1)===D;)u--;const r=u-c;let n=0;for(;n<s.length&&s.charCodeAt(n)===D;)n++;let d=s.length;for(;d-1>n&&s.charCodeAt(d-1)===D;)d--;const E=d-n,k=r<E?r:E;let M=-1,K=0;for(;K<k;K++){const F=i.charCodeAt(c+K);if(F!==s.charCodeAt(n+K))break;F===D&&(M=K)}if(K!==k){if(M===-1)return l}else{if(E>k){if(s.charCodeAt(n+K)===D)return l.slice(n+K+1);if(K===2)return l.slice(n+K)}r>k&&(i.charCodeAt(c+K)===D?M=K:K===2&&(M=3)),M===-1&&(M=0)}let q="";for(K=c+M+1;K<=u;++K)(K===u||i.charCodeAt(K)===D)&&(q+=q.length===0?"..":"\\..");return n+=M,q.length>0?`${q}${l.slice(n,d)}`:(l.charCodeAt(n)===D&&++n,l.slice(n,d))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===D){if(s.charCodeAt(1)===D){const o=s.charCodeAt(2);if(o!==P&&o!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(p(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===D)return`\\\\?\\${s}`;return i},dirname(i){v(i,"path");const s=i.length;if(s===0)return".";let o=-1,l=0;const c=i.charCodeAt(0);if(s===1)return h(c)?i:".";if(h(c)){if(o=l=1,h(i.charCodeAt(1))){let n=2,d=n;for(;n<s&&!h(i.charCodeAt(n));)n++;if(n<s&&n!==d){for(d=n;n<s&&h(i.charCodeAt(n));)n++;if(n<s&&n!==d){for(d=n;n<s&&!h(i.charCodeAt(n));)n++;if(n===s)return i;n!==d&&(o=l=n+1)}}}}else p(c)&&i.charCodeAt(1)===L&&(o=s>2&&h(i.charCodeAt(2))?3:2,l=o);let u=-1,r=!0;for(let n=s-1;n>=l;--n)if(h(i.charCodeAt(n))){if(!r){u=n;break}}else r=!1;if(u===-1){if(o===-1)return".";u=o}return i.slice(0,u)},basename(i,s){s!==void 0&&v(s,"ext"),v(i,"path");let o=0,l=-1,c=!0,u;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(o=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let r=s.length-1,n=-1;for(u=i.length-1;u>=o;--u){const d=i.charCodeAt(u);if(h(d)){if(!c){o=u+1;break}}else n===-1&&(c=!1,n=u+1),r>=0&&(d===s.charCodeAt(r)?--r===-1&&(l=u):(r=-1,l=n))}return o===l?l=n:l===-1&&(l=i.length),i.slice(o,l)}for(u=i.length-1;u>=o;--u)if(h(i.charCodeAt(u))){if(!c){o=u+1;break}}else l===-1&&(c=!1,l=u+1);return l===-1?"":i.slice(o,l)},extname(i){v(i,"path");let s=0,o=-1,l=0,c=-1,u=!0,r=0;i.length>=2&&i.charCodeAt(1)===L&&p(i.charCodeAt(0))&&(s=l=2);for(let n=i.length-1;n>=s;--n){const d=i.charCodeAt(n);if(h(d)){if(!u){l=n+1;break}continue}c===-1&&(u=!1,c=n+1),d===A?o===-1?o=n:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||c===-1||r===0||r===1&&o===c-1&&o===l+1?"":i.slice(o,c)},format:S.bind(null,"\\"),parse(i){v(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const o=i.length;let l=0,c=i.charCodeAt(0);if(o===1)return h(c)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(h(c)){if(l=1,h(i.charCodeAt(1))){let M=2,K=M;for(;M<o&&!h(i.charCodeAt(M));)M++;if(M<o&&M!==K){for(K=M;M<o&&h(i.charCodeAt(M));)M++;if(M<o&&M!==K){for(K=M;M<o&&!h(i.charCodeAt(M));)M++;M===o?l=M:M!==K&&(l=M+1)}}}}else if(p(c)&&i.charCodeAt(1)===L){if(o<=2)return s.root=s.dir=i,s;if(l=2,h(i.charCodeAt(2))){if(o===3)return s.root=s.dir=i,s;l=3}}l>0&&(s.root=i.slice(0,l));let u=-1,r=l,n=-1,d=!0,E=i.length-1,k=0;for(;E>=l;--E){if(c=i.charCodeAt(E),h(c)){if(!d){r=E+1;break}continue}n===-1&&(d=!1,n=E+1),c===A?u===-1?u=E:k!==1&&(k=1):u!==-1&&(k=-1)}return n!==-1&&(u===-1||k===0||k===1&&u===n-1&&u===r+1?s.base=s.name=i.slice(r,n):(s.name=i.slice(r,u),s.base=i.slice(r,n),s.ext=i.slice(u,n))),r>0&&r!==l?s.dir=i.slice(0,r-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(m){const i=/\\/g;return()=>{const s=a.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let s="",o=!1;for(let l=i.length-1;l>=-1&&!o;l--){const c=l>=0?i[l]:g();v(c,"path"),c.length!==0&&(s=`${c}/${s}`,o=c.charCodeAt(0)===y)}return s=b(s,!o,"/",f),o?`/${s}`:s.length>0?s:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y,o=i.charCodeAt(i.length-1)===y;return i=b(i,!s,"/",f),i.length===0?s?"/":o?"./":".":(o&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===y},join(...i){if(i.length===0)return".";let s;for(let o=0;o<i.length;++o){const l=i[o];v(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(v(i,"from"),v(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const o=1,l=i.length,c=l-o,u=1,r=s.length-u,n=c<r?c:r;let d=-1,E=0;for(;E<n;E++){const M=i.charCodeAt(o+E);if(M!==s.charCodeAt(u+E))break;M===y&&(d=E)}if(E===n)if(r>n){if(s.charCodeAt(u+E)===y)return s.slice(u+E+1);if(E===0)return s.slice(u+E)}else c>n&&(i.charCodeAt(o+E)===y?d=E:E===0&&(d=0));let k="";for(E=o+d+1;E<=l;++E)(E===l||i.charCodeAt(E)===y)&&(k+=k.length===0?"..":"/..");return`${k}${s.slice(u+d)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y;let o=-1,l=!0;for(let c=i.length-1;c>=1;--c)if(i.charCodeAt(c)===y){if(!l){o=c;break}}else l=!1;return o===-1?s?"/":".":s&&o===1?"//":i.slice(0,o)},basename(i,s){s!==void 0&&v(s,"ext"),v(i,"path");let o=0,l=-1,c=!0,u;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let r=s.length-1,n=-1;for(u=i.length-1;u>=0;--u){const d=i.charCodeAt(u);if(d===y){if(!c){o=u+1;break}}else n===-1&&(c=!1,n=u+1),r>=0&&(d===s.charCodeAt(r)?--r===-1&&(l=u):(r=-1,l=n))}return o===l?l=n:l===-1&&(l=i.length),i.slice(o,l)}for(u=i.length-1;u>=0;--u)if(i.charCodeAt(u)===y){if(!c){o=u+1;break}}else l===-1&&(c=!1,l=u+1);return l===-1?"":i.slice(o,l)},extname(i){v(i,"path");let s=-1,o=0,l=-1,c=!0,u=0;for(let r=i.length-1;r>=0;--r){const n=i.charCodeAt(r);if(n===y){if(!c){o=r+1;break}continue}l===-1&&(c=!1,l=r+1),n===A?s===-1?s=r:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||l===-1||u===0||u===1&&s===l-1&&s===o+1?"":i.slice(s,l)},format:S.bind(null,"/"),parse(i){v(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const o=i.charCodeAt(0)===y;let l;o?(s.root="/",l=1):l=0;let c=-1,u=0,r=-1,n=!0,d=i.length-1,E=0;for(;d>=l;--d){const k=i.charCodeAt(d);if(k===y){if(!n){u=d+1;break}continue}r===-1&&(n=!1,r=d+1),k===A?c===-1?c=d:E!==1&&(E=1):c!==-1&&(E=-1)}if(r!==-1){const k=u===0&&o?1:u;c===-1||E===0||E===1&&c===r-1&&c===u+1?s.base=s.name=i.slice(k,r):(s.name=i.slice(k,c),s.base=i.slice(k,r),s.ext=i.slice(c,r))}return u>0?s.dir=i.slice(0,u-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(ye[85],Ce([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,a.extname)(L),w=t[P.toLowerCase()];return w!==void 0?w:I(L)}e.getMediaOrTextMime=R;function I(L){const P=(0,a.extname)(L);return T[P.toLowerCase()]}e.getMediaMime=I;function A(L){for(const P in T)if(T[P]===L)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function D(L,P){const w=y.exec(L);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:P?void 0:L}e.normalizeMimeType=D}),define(ye[108],Ce([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const D=y.reduce((w,C)=>(w[C]=!0,w),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(w=>!D[w]).forEach(w=>{for(let C=0;C<L.length;C++)if(w.search(L[C])!==-1){delete A[w];break}})}e.sanitizeProcessEnvironment=R;function I(A){!A||(delete A.DEBUG,a.isMacintosh&&delete A.DYLD_LIBRARY_PATH,a.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ye[44],Ce([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=a.globals.performance&&typeof a.globals.performance.now=="function";class T{static create(I=!0){return new T(I)}constructor(I){this.a=t&&I,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ye[3],Ce([1,0,9,63,6,65,44]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var D;(function(u){u.None=()=>T.Disposable.None;function r(Ee){if(y){const{onDidAddListener:Pe}=Ee,Fe=v.create();let se=0;Ee.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Fe.print()),Pe?.()}}}function n(Ee,Pe){return O(Ee,()=>{},0,void 0,void 0,Pe)}u.defer=n;function d(Ee){return(Pe,Fe=null,se)=>{let oe=!1,fe;return fe=Ee(Z=>{if(!oe)return fe?fe.dispose():oe=!0,Pe.call(Fe,Z)},null,se),oe&&fe.dispose(),fe}}u.once=d;function E(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>se.call(oe,Pe(Z)),null,fe),Fe)}u.map=E;function k(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>{Pe(Z),se.call(oe,Z)},null,fe),Fe)}u.forEach=k;function M(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>Pe(Z)&&se.call(oe,Z),null,fe),Fe)}u.filter=M;function K(Ee){return Ee}u.signal=K;function q(...Ee){return(Pe,Fe=null,se)=>(0,T.combinedDisposable)(...Ee.map(oe=>oe(fe=>Pe.call(Fe,fe),null,se)))}u.any=q;function F(Ee,Pe,Fe,se){let oe=Fe;return E(Ee,fe=>(oe=Pe(oe,fe),oe),se)}u.reduce=F;function B(Ee,Pe){let Fe;const se={onWillAddFirstListener(){Fe=Ee(oe.fire,oe)},onDidRemoveLastListener(){Fe?.dispose()}};Pe||r(se);const oe=new h(se);return Pe?.add(oe),oe.event}function O(Ee,Pe,Fe=100,se=!1,oe,fe){let Z,ce,ie,N=0;const H={leakWarningThreshold:oe,onWillAddFirstListener(){Z=Ee(J=>{N++,ce=Pe(ce,J),se&&!ie&&(Q.fire(ce),ce=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=ce;ce=void 0,ie=void 0,(!se||N>1)&&Q.fire(he),N=0},Fe)})},onDidRemoveLastListener(){Z.dispose()}};fe||r(H);const Q=new h(H);return fe?.add(Q),Q.event}u.debounce=O;function U(Ee,Pe=0,Fe){return u.debounce(Ee,(se,oe)=>se?(se.push(oe),se):[oe],Pe,void 0,void 0,Fe)}u.accumulate=U;function $(Ee,Pe=(se,oe)=>se===oe,Fe){let se=!0,oe;return M(Ee,fe=>{const Z=se||!Pe(fe,oe);return se=!1,oe=fe,Z},Fe)}u.latch=$;function j(Ee,Pe,Fe){return[u.filter(Ee,Pe,Fe),u.filter(Ee,se=>!Pe(se),Fe)]}u.split=j;function ue(Ee,Pe=!1,Fe=[]){let se=Fe.slice(),oe=Ee(ce=>{se?se.push(ce):Z.fire(ce)});const fe=()=>{se?.forEach(ce=>Z.fire(ce)),se=null},Z=new h({onWillAddFirstListener(){oe||(oe=Ee(ce=>Z.fire(ce)))},onDidAddFirstListener(){se&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){oe&&oe.dispose(),oe=null}});return Z.event}u.buffer=ue;class V{constructor(Pe){this.event=Pe,this.c=new T.DisposableStore}map(Pe){return new V(E(this.event,Pe,this.c))}forEach(Pe){return new V(k(this.event,Pe,this.c))}filter(Pe){return new V(M(this.event,Pe,this.c))}reduce(Pe,Fe){return new V(F(this.event,Pe,Fe,this.c))}latch(){return new V($(this.event,void 0,this.c))}debounce(Pe,Fe=100,se=!1,oe){return new V(O(this.event,Pe,Fe,se,oe,this.c))}on(Pe,Fe,se){return this.event(Pe,Fe,se)}once(Pe,Fe,se){return d(this.event)(Pe,Fe,se)}dispose(){this.c.dispose()}}function _(Ee){return new V(Ee)}u.chain=_;function Y(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.on(Pe,se),fe=()=>Ee.removeListener(Pe,se),Z=new h({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}u.fromNodeEventEmitter=Y;function ne(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.addEventListener(Pe,se),fe=()=>Ee.removeEventListener(Pe,se),Z=new h({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}u.fromDOMEventEmitter=ne;function ee(Ee){return new Promise(Pe=>d(Ee)(Pe))}u.toPromise=ee;function X(Ee,Pe){return Pe(void 0),Ee(Fe=>Pe(Fe))}u.runAndSubscribe=X;function G(Ee,Pe){let Fe=null;function se(fe){Fe?.dispose(),Fe=new T.DisposableStore,Pe(fe,Fe)}se(void 0);const oe=Ee(fe=>se(fe));return(0,T.toDisposable)(()=>{oe.dispose(),Fe?.dispose()})}u.runAndSubscribeWithStore=G;class de{constructor(Pe,Fe){this.obs=Pe,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Fe||r(se),this.emitter=new h(se),Fe&&Fe.add(this.emitter)}beginUpdate(Pe){this.c++}handleChange(Pe,Fe){this.d=!0}endUpdate(Pe){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function be(Ee,Pe){return new de(Ee,Pe).emitter.event}u.fromObservable=be})(D=e.Event||(e.Event={}));class L{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${L.c++}`,L.all.add(this)}start(r){this.d=new I.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function w(u){const r=P;return P=u,{dispose(){P=r}}}e.setGlobalLeakWarningThreshold=w;class C{constructor(r,n=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=n,this.d=0}dispose(){this.c?.clear()}check(r,n){const d=this.threshold;if(d<=0||n<d)return;this.c||(this.c=new Map);const E=this.c.get(r.value)||0;if(this.c.set(r.value,E+1),this.d-=1,this.d<=0){this.d=d*.5;let k,M=0;for(const[K,q]of this.c)(!k||M<q)&&(k=K,M=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${M}):`),console.warn(k)}return()=>{const k=this.c.get(r.value)||0;this.c.set(r.value,k-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(r,n,d){this.callback=r,this.callbackThis=n,this.stack=d,this.subscription=new T.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class h{constructor(r){this.j=!1,this.d=r,this.f=P>0||this.d?.leakWarningThreshold?new C(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const r=Array.from(this.q);queueMicrotask(()=>{for(const n of r)n.subscription.isset()&&(n.subscription.unset(),n.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,n,d)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let k,M;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(M=v.create(),k=this.f.check(M,this.q.size+1)),A&&(M=M??v.create());const K=new m(r,n,M),q=this.q.push(K);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,n);const F=K.subscription.set(()=>{k?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return d instanceof T.DisposableStore?d.add(F):Array.isArray(d)&&d.push(F),F}),this.l}fire(r){if(this.q){this.m||(this.m=new p);for(const n of this.q)this.m.push(this,n,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class f{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(r,n,d){this.c.push(new b(r,n,d))}clear(r){const n=new R.LinkedList;for(const d of this.c)d.emitter!==r&&n.push(d);this.c=n}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(n){(0,a.onUnexpectedError)(n)}}}}e.EventDeliveryQueue=f;class p extends f{clear(r){this.c.clear()}}class b{constructor(r,n,d){this.emitter=r,this.listener=n,this.event=d}}class S extends h{async fireAsync(r,n,d){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,r]);for(;this.c.size>0&&!n.isCancellationRequested;){const[E,k]=this.c.shift(),M=[],K={...k,token:n,waitUntil:q=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");d&&(q=d(q,E.callback)),M.push(q)}};try{E.invoke(K)}catch(q){(0,a.onUnexpectedError)(q);continue}Object.freeze(M),await Promise.allSettled(M).then(q=>{for(const F of q)F.status==="rejected"&&(0,a.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=S;class g extends h{constructor(r){super(r),this.h=0,this.s=new R.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=g;class i extends g{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=i;class s extends h{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(n=>super.fire(n)),this.c=[]}))}}e.MicrotaskEmitter=s;class o{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const n={event:r,listener:null};this.f.push(n),this.d&&this.j(n);const d=()=>{this.d&&this.k(n);const E=this.f.indexOf(n);this.f.splice(E,1)};return(0,T.toDisposable)((0,t.once)(d))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(n=>this.c.fire(n))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=o;class l{constructor(){this.c=[]}wrapEvent(r){return(n,d,E)=>r(k=>{const M=this.c[this.c.length-1];M?M.push(()=>n.call(d,k)):n.call(d,k)},void 0,E)}bufferEvents(r){const n=[];this.c.push(n);const d=r();return this.c.pop(),n.forEach(E=>E()),d}}e.EventBufferer=l;class c{constructor(){this.c=!1,this.d=D.None,this.f=T.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=c}),define(ye[160],Ce([1,0,3,6,155]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends t.Disposable{constructor(w,C="",v="",m=!0,h){super(),this.h=this.B(new a.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=C,this.u=v,this.w=m,this.C=h}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,C){this.C&&await this.C(w)}}e.Action=R;class I extends t.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(w,C){if(!w.enabled)return;this.f.fire({action:w});let v;try{await this.runAction(w,C)}catch(m){v=m}this.h.fire({action:w,error:v})}async runAction(w,C){await w.run(C)}}e.ActionRunner=I;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let C=[];for(const v of w)v.length&&(C.length?C=[...C,new A,...v]:C=v);return C}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(w,C,v,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=C,this.class=m,this.a=v}async run(){}}e.SubmenuAction=y;class D extends R{constructor(){super(D.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=D,D.ID="vs.actions.empty";function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=L}),define(ye[21],Ce([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,y){const D=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(D)}}});var T;(function(A){function y(D){return D===A.None||D===A.Cancelled||D instanceof R?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(T=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=T.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=T.None}}e.CancellationTokenSource=I}),define(ye[161],Ce([1,0,21]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new a.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class T{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=T;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[8],Ce([1,0,161,83]),function(te,e,a,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=R;const I=/{(\d+)}/g;function A(z,...le){return le.length===0?z:z.replace(I,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=le.length?Ie:le[Be]})}e.format=A;const y=/{([^}]+)}/g;function D(z,le){return z.replace(y,(Ie,Le)=>le[Le]??Ie)}e.format2=D;function L(z){return z.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=L;function P(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function w(z,le){let Ie=0;const Le=le.charCodeAt(0);for(let Be=z.length-1;Be>=0;Be--)z.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=w;function C(z,le,Ie="\u2026"){return z.length<=le?z:`${z.substr(0,le)}${Ie}`}e.truncate=C;function v(z,le=" "){const Ie=m(z,le);return h(Ie,le)}e.trim=v;function m(z,le){if(!z||!le)return z;const Ie=le.length;if(Ie===0||z.length===0)return z;let Le=0;for(;z.indexOf(le,Le)===Le;)Le=Le+Ie;return z.substring(Le)}e.ltrim=m;function h(z,le){if(!z||!le)return z;const Ie=le.length,Le=z.length;if(Ie===0||Le===0)return z;let Be=Le,Xe=-1;for(;Xe=z.lastIndexOf(le,Be-1),!(Xe===-1||Xe+Ie!==Be);){if(Xe===0)return"";Be=Xe}return z.substring(0,Be)}e.rtrim=h;function f(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p(z){return z.replace(/\*/g,"")}e.stripWildcards=p;function b(z,le,Ie={}){if(!z)throw new Error("Cannot create regex from empty string");le||(z=P(z)),Ie.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp(z,Le)}e.createRegExp=b;function S(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function g(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function i(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=i;function s(z){return z.split(/\r\n|\r|\n/)}e.splitLines=s;function o(z){for(let le=0,Ie=z.length;le<Ie;le++){const Le=z.charCodeAt(le);if(Le!==32&&Le!==9)return le}return-1}e.firstNonWhitespaceIndex=o;function l(z,le=0,Ie=z.length){for(let Le=le;Le<Ie;Le++){const Be=z.charCodeAt(Le);if(Be!==32&&Be!==9)return z.substring(le,Le)}return z.substring(le,Ie)}e.getLeadingWhitespace=l;function c(z,le=z.length-1){for(let Ie=le;Ie>=0;Ie--){const Le=z.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=c;function u(z,le,Ie){const Le=[];let Be=0;for(const Xe of z.matchAll(le)){if(Le.push(z.slice(Be,Xe.index)),Xe.index===void 0)throw new Error("match.index should be defined");Be=Xe.index+Xe[0].length,Le.push(Ie(Xe[0],...Xe.slice(1),Xe.index,z,Xe.groups))}return Le.push(z.slice(Be)),Promise.all(Le).then(Xe=>Xe.join(""))}e.replaceAsync=u;function r(z,le){return z<le?-1:z>le?1:0}e.compare=r;function n(z,le,Ie=0,Le=z.length,Be=0,Xe=le.length){for(;Ie<Le&&Be<Xe;Ie++,Be++){const mt=z.charCodeAt(Ie),lt=le.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ie,gt=Xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstring=n;function d(z,le){return E(z,le,0,z.length,0,le.length)}e.compareIgnoreCase=d;function E(z,le,Ie=0,Le=z.length,Be=0,Xe=le.length){for(;Ie<Le&&Be<Xe;Ie++,Be++){let mt=z.charCodeAt(Ie),lt=le.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return n(z.toLowerCase(),le.toLowerCase(),Ie,Le,Be,Xe);M(mt)&&(mt-=32),M(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ie,gt=Xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstringIgnoreCase=E;function k(z){return z>=48&&z<=57}e.isAsciiDigit=k;function M(z){return z>=97&&z<=122}e.isLowerAsciiLetter=M;function K(z){return z>=65&&z<=90}e.isUpperAsciiLetter=K;function q(z,le){return z.length===le.length&&E(z,le)===0}e.equalsIgnoreCase=q;function F(z,le){const Ie=le.length;return le.length>z.length?!1:E(z,le,0,Ie)===0}e.startsWithIgnoreCase=F;function B(z,le){const Ie=Math.min(z.length,le.length);let Le;for(Le=0;Le<Ie;Le++)if(z.charCodeAt(Le)!==le.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=B;function O(z,le){const Ie=Math.min(z.length,le.length);let Le;const Be=z.length-1,Xe=le.length-1;for(Le=0;Le<Ie;Le++)if(z.charCodeAt(Be-Le)!==le.charCodeAt(Xe-Le))return Le;return Ie}e.commonSuffixLength=O;function U(z){return 55296<=z&&z<=56319}e.isHighSurrogate=U;function $(z){return 56320<=z&&z<=57343}e.isLowSurrogate=$;function j(z,le){return(z-55296<<10)+(le-56320)+65536}e.computeCodePoint=j;function ue(z,le,Ie){const Le=z.charCodeAt(Ie);if(U(Le)&&Ie+1<le){const Be=z.charCodeAt(Ie+1);if($(Be))return j(Le,Be)}return Le}e.getNextCodePoint=ue;function V(z,le){const Ie=z.charCodeAt(le-1);if($(Ie)&&le>1){const Le=z.charCodeAt(le-2);if(U(Le))return j(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(le,Ie=0){this.c=le,this.d=le.length,this.e=Ie}setOffset(le){this.e=le}prevCodePoint(){const le=V(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=ue(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=_;class Y{get offset(){return this.c.offset}constructor(le,Ie=0){this.c=new _(le,Ie)}nextGraphemeLength(){const le=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=le.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Xe=Ie.offset,Ze=le.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(Xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const le=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=le.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Xe=Ie.offset,Ze=le.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(Xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Y;function ne(z,le){return new Y(z,le).nextGraphemeLength()}e.nextCharLength=ne;function ee(z,le){return new Y(z,le).prevGraphemeLength()}e.prevCharLength=ee;function X(z,le){le>0&&$(z.charCodeAt(le))&&le--;const Ie=le+ne(z,le);return[Ie-ee(z,Ie),Ie]}e.getCharContainingOffset=X;function G(z){const le=new Y(z);let Ie=0;for(;!le.eol();)Ie++,le.nextGraphemeLength();return Ie}e.charCount=G;let de;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee(z){return de||(de=be()),de.test(z)}e.containsRTL=Ee;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Fe(z){return Pe.test(z)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=se;function oe(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=oe;function fe(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=fe;function Z(z,le){if(z.length<le)return z;const Ie=/\b/g;let Le=0;for(;Ie.test(z)&&!(z.length-Ie.lastIndex<le);)Le=Ie.lastIndex,Ie.lastIndex+=1;return z.substring(Le).replace(/^\s/,"")}e.lcut=Z;const ce=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function H(z){return z&&(z=z.replace(ce,""),z=z.replace(ie,""),z=z.replace(N,"")),z}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function J(z){return Q(z)?z.substr(1):z}e.stripUTF8BOM=J;function he(z,le){if(!z||!le||z.length<le.length)return!1;const Ie=le.length,Le=z.toLowerCase();let Be=0,Xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(le[Be],Xe+1);if(Ze<0)return!1;Xe=Ze,Be++}return!0}e.fuzzyContains=he;function we(z,le=!1){return z?(le&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=we;function Ae(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ae;function pe(z,le=1){if(le===0)return"";let Ie=-1;do Ie=z.indexOf(`
`,Ie+1),le--;while(le>0&&Ie>=0);return Ie===-1?z:(z[Ie-1]==="\r"&&Ie--,z.substr(0,Ie))}e.getNLines=pe;function De(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=De;function ke(z){return et.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=ke;function je(z,le){return z===0?le!==5&&le!==7:z===2&&le===3?!1:z===4||z===2||z===3||le===4||le===2||le===3?!0:!(z===8&&(le===8||le===9||le===11||le===12)||(z===11||z===9)&&(le===9||le===10)||(z===12||z===10)&&le===10||le===5||le===13||le===7||z===1||z===13&&le===14||z===6&&le===6)}var Ge;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(le<Ie[3*Be])Be=2*Be;else if(le>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(z,le){if(z===0)return 0;const Ie=st(z,le);if(Ie!==void 0)return Ie;const Le=new _(le,z);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st(z,le){const Ie=new _(le,z);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht(z){return 127995<=z&&z<=127999}var Me;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(le){return it.d.get(Array.from(le))}static getLocales(){return it.e.getValue()}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,T=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new a.LRUCachedFunction(z=>{function le(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[kt,Tt]of ot)rt.set(kt,Tt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[kt,Tt]of lt)ot.has(kt)&&rt.set(kt,Tt);return rt}const Be=T.c.getValue();let Xe=z.filter(lt=>!lt.startsWith("_")&&lt in Be);Xe.length===0&&(Xe=["_default"]);let Ze;for(const lt of Xe){const ot=le(Be[lt]);Ze=Le(Ze,ot)}const gt=le(Be._common),mt=Ie(gt,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter(z=>!z.startsWith("_")));class ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ae.c())),this.d}static isInvisibleCharacter(le){return ae.e().has(le)}static get codePoints(){return ae.e()}}e.InvisibleCharacters=ae,ae.d=void 0}),define(ye[32],Ce([1,0,11,12,8,10]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(c){return c===47||c===92}e.isPathSeparator=I;function A(c){return c.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=A;function y(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function D(c,u=a.posix.sep){if(!c)return"";const r=c.length,n=c.charCodeAt(0);if(I(n)){if(I(c.charCodeAt(1))&&!I(c.charCodeAt(2))){let E=3;const k=E;for(;E<r&&!I(c.charCodeAt(E));E++);if(k!==E&&!I(c.charCodeAt(E+1))){for(E+=1;E<r;E++)if(I(c.charCodeAt(E)))return c.slice(0,E+1).replace(/[\\/]/g,u)}}return u}else if(f(n)&&c.charCodeAt(1)===58)return I(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let d=c.indexOf("://");if(d!==-1){for(d+=3;d<r;d++)if(I(c.charCodeAt(d)))return c.slice(0,d+1)}return""}e.getRoot=D;function L(c){if(!t.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let r=2;const n=r;for(;r<c.length&&(u=c.charCodeAt(r),u!==92);r++);return!(n===r||(u=c.charCodeAt(r+1),isNaN(u)||u===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(c,u=t.isWindows){const r=u?P:w;return!(!c||c.length===0||/^\s+$/.test(c)||(r.lastIndex=0,r.test(c))||u&&C.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=v;function m(c,u,r){const n=c===u;return!r||n?n:!c||!u?!1:(0,T.equalsIgnoreCase)(c,u)}e.isEqual=m;function h(c,u,r,n=a.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(r){if(!(0,T.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let E=u.length;return u.charAt(u.length-1)===n&&E--,c.charAt(E)===n}return u.charAt(u.length-1)!==n&&(u+=n),c.indexOf(u)===0}e.isEqualOrParent=h;function f(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=f;function p(c,u){return t.isWindows&&c.endsWith(":")&&(c+=a.sep),(0,a.isAbsolute)(c)||(c=(0,a.join)(u,c)),c=(0,a.normalize)(c),t.isWindows?(c=(0,T.rtrim)(c,a.sep),c.endsWith(":")&&(c+=a.sep)):(c=(0,T.rtrim)(c,a.sep),c||(c=a.sep)),c}e.sanitizeFilePath=p;function b(c){const u=(0,a.normalize)(c);return t.isWindows?c.length>3?!1:S(u)&&(c.length===2||u.charCodeAt(2)===92):u===a.posix.sep}e.isRootOrDriveLetter=b;function S(c,u=t.isWindows){return u?f(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function g(c){return S(c)?c[0]:void 0}e.getDriveLetter=g;function i(c,u,r){return u.length>c.length?-1:c===u?0:(r&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=i;function s(c){const u=c.split(":");let r,n,d;for(const E of u){const k=Number(E);(0,R.isNumber)(k)?n===void 0?n=k:d===void 0&&(d=k):r=r?[r,E].join(":"):E}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:n!==void 0?n:void 0,column:d!==void 0?d:n!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(c,u,r=8){let n="";for(let E=0;E<r;E++)n+=o.charAt(Math.floor(Math.random()*o.length));let d;return u?d=`${u}-${n}`:d=n,c?(0,a.join)(c,d):d}e.randomPath=l}),define(ye[109],Ce([1,0,28,8]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...ie){return function(N,H){for(let Q=0,J=ie.length;Q<J;Q++){const he=ie[Q](N,H);if(he)return he}return null}}e.or=T,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ie,N,H){if(!H||H.length<N.length)return null;let Q;return ie?Q=t.startsWithIgnoreCase(H,N):Q=H.indexOf(N)===0,Q?N.length>0?[{start:0,end:N.length}]:[]:null}function I(ie,N){const H=N.toLowerCase().indexOf(ie.toLowerCase());return H===-1?null:[{start:H,end:H+ie.length}]}e.matchesContiguousSubString=I;function A(ie,N){return y(ie.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=A;function y(ie,N,H,Q){if(H===ie.length)return[];if(Q===N.length)return null;if(ie[H]===N[Q]){let J=null;return(J=y(ie,N,H+1,Q+1))?f({start:Q,end:Q+1},J):null}return y(ie,N,H,Q+1)}function D(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function w(ie){return ie===32||ie===9||ie===10||ie===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>C.add(ie.charCodeAt(0)));function v(ie){return w(ie)||C.has(ie)}function m(ie,N){return ie===N||v(ie)&&v(N)}function h(ie){return D(ie)||L(ie)||P(ie)}function f(ie,N){return N.length===0?N=[ie]:ie.end===N[0].start?N[0].start=ie.start:N.unshift(ie),N}function p(ie,N){for(let H=N;H<ie.length;H++){const Q=ie.charCodeAt(H);if(L(Q)||P(Q)||H>0&&!h(ie.charCodeAt(H-1)))return H}return ie.length}function b(ie,N,H,Q){if(H===ie.length)return[];if(Q===N.length)return null;if(ie[H]!==N[Q].toLowerCase())return null;{let J=null,he=Q+1;for(J=b(ie,N,H+1,Q+1);!J&&(he=p(N,he))<N.length;)J=b(ie,N,H+1,he),he++;return J===null?null:f({start:Q,end:Q+1},J)}}function S(ie){let N=0,H=0,Q=0,J=0,he=0;for(let ke=0;ke<ie.length;ke++)he=ie.charCodeAt(ke),L(he)&&N++,D(he)&&H++,h(he)&&Q++,P(he)&&J++;const we=N/ie.length,Ae=H/ie.length,pe=Q/ie.length,De=J/ie.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:pe,numericPercent:De}}function g(ie){const{upperPercent:N,lowerPercent:H}=ie;return H===0&&N>.6}function i(ie){const{upperPercent:N,lowerPercent:H,alphaPercent:Q,numericPercent:J}=ie;return H>.2&&N<.8&&Q>.6&&J<.2}function s(ie){let N=0,H=0,Q=0,J=0;for(let he=0;he<ie.length;he++)Q=ie.charCodeAt(he),L(Q)&&N++,D(Q)&&H++,w(Q)&&J++;return(N===0||H===0)&&J===0?ie.length<=30:N<=5}function o(ie,N){if(!N||(N=N.trim(),N.length===0)||!s(ie)||N.length>60)return null;const H=S(N);if(!i(H)){if(!g(H))return null;N=N.toLowerCase()}let Q=null,J=0;for(ie=ie.toLowerCase();J<N.length&&(Q=b(ie,N,0,J))===null;)J=p(N,J+1);return Q}e.matchesCamelCase=o;function l(ie,N,H=!1){if(!N||N.length===0)return null;let Q=null,J=0;for(ie=ie.toLowerCase(),N=N.toLowerCase();J<N.length&&(Q=c(ie,N,0,J,H))===null;)J=u(N,J+1);return Q}e.matchesWords=l;function c(ie,N,H,Q,J){if(H===ie.length)return[];if(Q===N.length)return null;if(m(ie.charCodeAt(H),N.charCodeAt(Q))){let he=null,we=Q+1;if(he=c(ie,N,H+1,Q+1,J),!J)for(;!he&&(we=u(N,we))<N.length;)he=c(ie,N,H+1,we,J),we++;return he?ie.charCodeAt(H)!==N.charCodeAt(Q)?he:f({start:Q,end:Q+1},he):null}else return null}function u(ie,N){for(let H=N;H<ie.length;H++)if(v(ie.charCodeAt(H))||H>0&&v(ie.charCodeAt(H-1)))return H;return ie.length}const r=T(e.matchesPrefix,o,I),n=T(e.matchesPrefix,o,A),d=new a.LRUCache(1e4);function E(ie,N,H=!1){if(typeof ie!="string"||typeof N!="string")return null;let Q=d.get(ie);Q||(Q=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),d.set(ie,Q));const J=Q.exec(N);return J?[{start:J.index,end:J.index+J[0].length}]:H?n(ie,N):r(ie,N)}e.matchesFuzzy=E;function k(ie,N){const H=Pe(ie,ie.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?K(H):null}e.matchesFuzzy2=k;function M(ie,N,H,Q,J,he){const we=Math.min(13,ie.length);for(;H<we;H++){const Ae=Pe(ie,N,H,Q,J,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=M;function K(ie){if(typeof ie>"u")return[];const N=[],H=ie[1];for(let Q=ie.length-1;Q>1;Q--){const J=ie[Q]+H,he=N[N.length-1];he&&he.end===J?he.end=J+1:N.push({start:J,end:J+1})}return N}e.createMatches=K;const q=128;function F(){const ie=[],N=[];for(let H=0;H<=q;H++)N[H]=0;for(let H=0;H<=q;H++)ie.push(N.slice(0));return ie}function B(ie){const N=[];for(let H=0;H<=ie;H++)N[H]=0;return N}const O=B(2*q),U=B(2*q),$=F(),j=F(),ue=F(),V=!1;function _(ie,N,H,Q,J){function he(Ae,pe,De=" "){for(;Ae.length<pe;)Ae=De+Ae;return Ae}let we=` |   |${Q.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?we+=" |":we+=`${N[Ae-1]}|`,we+=ie[Ae].slice(0,J+1).map(pe=>he(pe.toString(),3)).join("|")+`
`;return we}function Y(ie,N,H,Q){ie=ie.substr(N),H=H.substr(Q),console.log(_(j,ie,ie.length,H,H.length)),console.log(_(ue,ie,ie.length,H,H.length)),console.log(_($,ie,ie.length,H,H.length))}function ne(ie,N){if(N<0||N>=ie.length)return!1;const H=ie.codePointAt(N);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function ee(ie,N){if(N<0||N>=ie.length)return!1;switch(ie.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function X(ie,N,H){return N[ie]!==H[ie]}function G(ie,N,H,Q,J,he,we=!1){for(;N<H&&J<he;)ie[N]===Q[J]&&(we&&(O[N]=J),N+=1),J+=1;return N===H}e.isPatternInWord=G;var de;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(de||(de={}));var be;(function(ie){ie.Default=[-100,0];function N(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ie.isDefault=N})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(N,H){this.firstMatchCanBeWeak=N,this.boostFullMatch=H}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Pe(ie,N,H,Q,J,he,we=Ee.default){const Ae=ie.length>q?q:ie.length,pe=Q.length>q?q:Q.length;if(H>=Ae||he>=pe||Ae-H>pe-he||!G(N,H,Ae,J,he,pe,!0))return;Fe(Ae,pe,H,he,N,J);let De=1,ke=1,je=H,Ge=he;const et=[!1];for(De=1,je=H;je<Ae;De++,je++){const Me=O[je],it=U[je],ae=je+1<Ae?U[je+1]:pe;for(ke=Me-he+1,Ge=Me;Ge<ae;ke++,Ge++){let z=Number.MIN_SAFE_INTEGER,le=!1;Ge<=it&&(z=se(ie,N,je,H,Q,J,Ge,pe,he,$[De-1][ke-1]===0,et));let Ie=0;z!==Number.MAX_SAFE_INTEGER&&(le=!0,Ie=z+j[De-1][ke-1]);const Le=Ge>Me,Be=Le?j[De][ke-1]+($[De][ke-1]>0?-5:0):0,Xe=Ge>Me+1&&$[De][ke-1]>0,Ze=Xe?j[De][ke-2]+($[De][ke-2]>0?-5:0):0;if(Xe&&(!Le||Ze>=Be)&&(!le||Ze>=Ie))j[De][ke]=Ze,ue[De][ke]=3,$[De][ke]=0;else if(Le&&(!le||Be>=Ie))j[De][ke]=Be,ue[De][ke]=2,$[De][ke]=0;else if(le)j[De][ke]=Ie,ue[De][ke]=1,$[De][ke]=$[De-1][ke-1]+1;else throw new Error("not possible")}}if(V&&Y(ie,H,Q,he),!et[0]&&!we.firstMatchCanBeWeak)return;De--,ke--;const Qe=[j[De][ke],he];let nt=0,st=0;for(;De>=1;){let Me=ke;do{const it=ue[De][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&N[H+De-1]===J[he+ke-1]&&!X(Me+he-1,Q,J)&&nt+1>$[De][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),De--,ke=Me-1,Qe.push(ke)}pe===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=Pe;function Fe(ie,N,H,Q,J,he){let we=ie-1,Ae=N-1;for(;we>=H&&Ae>=Q;)J[we]===he[Ae]&&(U[we]=Ae,we--),Ae--}function se(ie,N,H,Q,J,he,we,Ae,pe,De,ke){if(N[H]!==he[we])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return we===H-Q?je=ie[H]===J[we]?7:5:X(we,J,he)&&(we===0||!X(we-1,J,he))?(je=ie[H]===J[we]?7:5,Ge=!0):ne(he,we)&&(we===0||!ne(he,we-1))?je=5:(ne(he,we-1)||ee(he,we-1))&&(je=5,Ge=!0),je>1&&H===Q&&(ke[0]=!0),Ge||(Ge=X(we,J,he)||ne(he,we-1)||ee(he,we-1)),H===Q?we>pe&&(je-=Ge?3:5):De?je+=Ge?2:0:je+=Ge?0:1,we+1===Ae&&(je-=Ge?3:5),je}function oe(ie,N,H,Q,J,he,we){return Z(ie,N,H,Q,J,he,!0,we)}e.fuzzyScoreGracefulAggressive=oe;function fe(ie,N,H,Q,J,he,we){return Z(ie,N,H,Q,J,he,!1,we)}e.fuzzyScoreGraceful=fe;function Z(ie,N,H,Q,J,he,we,Ae){let pe=Pe(ie,N,H,Q,J,he,Ae);if(pe&&!we)return pe;if(ie.length>=3){const De=Math.min(7,ie.length-1);for(let ke=H+1;ke<De;ke++){const je=ce(ie,ke);if(je){const Ge=Pe(je,je.toLowerCase(),H,Q,J,he,Ae);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ce(ie,N){if(N+1>=ie.length)return;const H=ie[N],Q=ie[N+1];if(H!==Q)return ie.slice(0,N)+Q+H+ie.slice(N+2)}}),define(ye[86],Ce([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return T(f,0)}e.hash=t;function T(f,p){switch(typeof f){case"object":return f===null?R(349,p):Array.isArray(f)?y(f,p):D(f,p);case"string":return A(f,p);case"boolean":return I(f,p);case"number":return R(f,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=T;function R(f,p){return(p<<5)-p+f|0}e.numberHash=R;function I(f,p){return R(f?433:863,p)}function A(f,p){p=R(149417,p);for(let b=0,S=f.length;b<S;b++)p=R(f.charCodeAt(b),p);return p}e.stringHash=A;function y(f,p){return p=R(104579,p),f.reduce((b,S)=>T(S,b),p)}function D(f,p){return p=R(181387,p),Object.keys(f).sort().reduce((b,S)=>(b=A(S,b),T(f[S],b)),p)}class L{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=T(p,this.g),this.g}}e.Hasher=L;var P;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function w(f,p,b=32){const S=b-p,g=~((1<<S)-1);return(f<<p|(g&f)>>>S)>>>0}function C(f,p=0,b=f.byteLength,S=0){for(let g=0;g<b;g++)f[p+g]=S}function v(f,p,b="0"){for(;f.length<p;)f=b+f;return f}function m(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),p/4)}e.toHexString=m;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const S=this.p;let g=this.r,i=this.u,s,o;for(i!==0?(s=i,o=-1,i=0):(s=p.charCodeAt(0),o=0);;){let l=s;if(a.isHighSurrogate(s))if(o+1<b){const c=p.charCodeAt(o+1);a.isLowSurrogate(c)?(o++,l=a.computeCodePoint(s,c)):l=65533}else{i=s;break}else a.isLowSurrogate(s)&&(l=65533);if(g=this.w(S,g,l),o++,o<b)s=p.charCodeAt(o);else break}this.r=g,this.u=i}w(p,b,S){return S<128?p[b++]=S:S<2048?(p[b++]=192|(S&1984)>>>6,p[b++]=128|(S&63)>>>0):S<65536?(p[b++]=224|(S&61440)>>>12,p[b++]=128|(S&4032)>>>6,p[b++]=128|(S&63)>>>0):(p[b++]=240|(S&1835008)>>>18,p[b++]=128|(S&258048)>>>12,p[b++]=128|(S&4032)>>>6,p[b++]=128|(S&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=h.g,b=this.q;for(let r=0;r<64;r+=4)p.setUint32(r,b.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)p.setUint32(r,w(p.getUint32(r-12,!1)^p.getUint32(r-32,!1)^p.getUint32(r-56,!1)^p.getUint32(r-64,!1),1),!1);let S=this.h,g=this.l,i=this.m,s=this.n,o=this.o,l,c,u;for(let r=0;r<80;r++)r<20?(l=g&i|~g&s,c=1518500249):r<40?(l=g^i^s,c=1859775393):r<60?(l=g&i|g&s|i&s,c=2400959708):(l=g^i^s,c=3395469782),u=w(S,5)+l+o+c+p.getUint32(r*4,!1)&4294967295,o=s,s=i,i=w(g,30),g=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}e.StringSHA1=h,h.g=new DataView(new ArrayBuffer(320))}),define(ye[162],Ce([1,0,50,109,8]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",I=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${I.source}`,"g");function y(h){return h.replace(A,(f,p)=>p?f:`\\${f}`)}e.escapeIcons=y;const D=new RegExp(`\\\\${I.source}`,"g");function L(h){return h.replace(D,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function w(h){return h.indexOf(R)===-1?h:h.replace(P,(f,p,b,S)=>b?f:p||S||"")}e.stripIcons=w;const C=new RegExp(`\\$\\(${a.CSSIcon.iconNameCharacter}+\\)`,"g");function v(h){C.lastIndex=0;let f="";const p=[];let b=0;for(;;){const S=C.lastIndex,g=C.exec(h),i=h.substring(S,g?.index);if(i.length>0){f+=i;for(let s=0;s<i.length;s++)p.push(b)}if(!g)break;b+=g[0].length}return{text:f,iconOffsets:p}}e.parseLabelWithIcons=v;function m(h,f,p=!1){const{text:b,iconOffsets:S}=f;if(!S||S.length===0)return(0,t.matchesFuzzy)(h,b,p);const g=(0,T.ltrim)(b," "),i=b.length-g.length,s=(0,t.matchesFuzzy)(h,g,p);if(s)for(const o of s){const l=S[o.start+i]+i;o.start+=l,o.end+=l}return s}e.matchesFuzzyIconAware=m}),define(ye[38],Ce([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(t||(t={})),function(T){const R="error",I="warning",A="warn",y="info",D="ignore";function L(w){return w?a.equalsIgnoreCase(R,w)?T.Error:a.equalsIgnoreCase(I,w)||a.equalsIgnoreCase(A,w)?T.Warning:a.equalsIgnoreCase(y,w)?T.Info:T.Ignore:T.Ignore}T.fromValue=L;function P(w){switch(w){case T.Error:return R;case T.Warning:return I;case T.Info:return y;default:return D}}T.toString=P}(t||(t={})),e.default=t}),define(ye[66],Ce([1,0,16,8]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const v=C.charCodeAt(0),m=this.b.charCodeAt(this.c);return v-m}value(){return this.b[this.c]}}e.StringIterator=T;class R{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,t.compareSubstring)(C,this.b,0,C.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class I{constructor(C=!0,v=!0){this.f=C,this.g=v}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let v=C.length-1;v>=0;v--,this.c--){const m=this.b.charCodeAt(v);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,t.compareSubstring)(C,this.b,0,C.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var A;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(C,v){this.f=C,this.g=v,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(C,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,t.compare)(C,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(L||(L={}));class P{static forUris(C=()=>!1,v=()=>!1){return new P(new y(C,v))}static forPaths(C=!1){return new P(new I(void 0,!C))}static forStrings(){return new P(new T)}static forConfigKeys(){return new P(new R)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,v){if(v){const m=v.slice(0);(0,a.shuffle)(m);for(const h of m)this.set(h,C)}else{const m=C.slice(0);(0,a.shuffle)(m);for(const h of m)this.set(h[0],h[1])}}set(C,v){const m=this.b.reset(C);let h;this.c||(this.c=new D,this.c.segment=m.value());const f=[];for(h=this.c;;){const b=m.cmp(h.segment);if(b>0)h.left||(h.left=new D,h.left.segment=m.value()),f.push([-1,h]),h=h.left;else if(b<0)h.right||(h.right=new D,h.right.segment=m.value()),f.push([1,h]),h=h.right;else if(m.hasNext())m.next(),h.mid||(h.mid=new D,h.mid.segment=m.value()),f.push([0,h]),h=h.mid;else break}const p=h.value;h.value=v,h.key=C;for(let b=f.length-1;b>=0;b--){const S=f[b][1];S.updateHeight();const g=S.balanceFactor();if(g<-1||g>1){const i=f[b][0],s=f[b+1][0];if(i===1&&s===1)f[b][1]=S.rotateLeft();else if(i===-1&&s===-1)f[b][1]=S.rotateRight();else if(i===1&&s===-1)S.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=S.rotateLeft();else if(i===-1&&s===1)S.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=S.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this.c=f[0][1]}}return p}get(C){return this.d(C)?.value}d(C){const v=this.b.reset(C);let m=this.c;for(;m;){const h=v.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(C){const v=this.d(C);return!(v?.value===void 0&&v?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,v){const m=this.b.reset(C),h=[];let f=this.c;for(;f;){const p=m.cmp(f.segment);if(p>0)h.push([-1,f]),f=f.left;else if(p<0)h.push([1,f]),f=f.right;else if(m.hasNext())m.next(),h.push([0,f]),f=f.mid;else break}if(!!f){if(v?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this.f(f.right);if(p.key){const{key:b,value:S,segment:g}=p;this.e(p.key,!1),f.key=b,f.value=S,f.segment=g}}else{const p=f.left??f.right;if(h.length>0){const[b,S]=h[h.length-1];switch(b){case-1:S.left=p;break;case 0:S.mid=p;break;case 1:S.right=p;break}}else this.c=p}for(let p=h.length-1;p>=0;p--){const b=h[p][1];b.updateHeight();const S=b.balanceFactor();if(S>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),h[p][1]=b.rotateLeft()):S<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),h[p][1]=b.rotateRight()),p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const v=this.b.reset(C);let m=this.c,h;for(;m;){const f=v.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(v.hasNext())v.next(),h=m.value||h,m=m.mid;else break}return m&&m.value||h}findSuperstr(C){return this.g(C,!1)}g(C,v){const m=this.b.reset(C);let h=this.c;for(;h;){const f=m.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(m.hasNext())m.next(),h=h.mid;else return h.mid?this.h(h.mid):v?h.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[v,m]of this)C(m,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const v=[];return this.j(C,v),v[Symbol.iterator]()}j(C,v){!C||(C.left&&this.j(C.left,v),C.value&&v.push([C.key,C.value]),C.mid&&this.j(C.mid,v),C.right&&this.j(C.right,v))}_isBalanced(){const C=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:C(v.left)&&C(v.right)};return C(this.c)}}e.TernarySearchTree=P}),define(ye[2],Ce([1,0,11,12]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,R=/^\//,I=/^\/\//;function A(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!R.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,l){return!o&&!l?"file":o}function D(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==P&&(l=P+l):l=P;break}return l}const L="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(l){return l instanceof C?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,c,u,r,n,d=!1){typeof l=="object"?(this.scheme=l.scheme||L,this.authority=l.authority||L,this.path=l.path||L,this.query=l.query||L,this.fragment=l.fragment||L):(this.scheme=y(l,d),this.authority=c||L,this.path=D(this.scheme,u||L),this.query=r||L,this.fragment=n||L,A(this,d))}get fsPath(){return b(this,!1)}with(l){if(!l)return this;let{scheme:c,authority:u,path:r,query:n,fragment:d}=l;return c===void 0?c=this.scheme:c===null&&(c=L),u===void 0?u=this.authority:u===null&&(u=L),r===void 0?r=this.path:r===null&&(r=L),n===void 0?n=this.query:n===null&&(n=L),d===void 0?d=this.fragment:d===null&&(d=L),c===this.scheme&&u===this.authority&&r===this.path&&n===this.query&&d===this.fragment?this:new m(c,u,r,n,d)}static parse(l,c=!1){const u=w.exec(l);return u?new m(u[2]||L,s(u[4]||L),s(u[5]||L),s(u[7]||L),s(u[9]||L),c):new m(L,L,L,L,L)}static file(l){let c=L;if(t.isWindows&&(l=l.replace(/\\/g,P)),l[0]===P&&l[1]===P){const u=l.indexOf(P,2);u===-1?(c=l.substring(2),l=P):(c=l.substring(2,u),l=l.substring(u)||P)}return new m("file",c,l,L,L)}static from(l){const c=new m(l.scheme,l.authority,l.path,l.query,l.fragment);return A(c,!0),c}static joinPath(l,...c){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&l.scheme==="file"?u=C.file(a.win32.join(b(l,!0),...c)).path:u=a.posix.join(l.path,...c),l.with({path:u})}toString(l=!1){return S(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof C)return l;{const c=new m(l);return c._formatted=l.external,c._fsPath=l._sep===v?l.fsPath:null,c}}else return l}}e.URI=C;const v=t.isWindows?1:void 0;class m extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(l=!1){return l?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=v),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(o,l,c){let u,r=-1;for(let n=0;n<o.length;n++){const d=o.charCodeAt(n);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||l&&d===47||c&&d===91||c&&d===93||c&&d===58)r!==-1&&(u+=encodeURIComponent(o.substring(r,n)),r=-1),u!==void 0&&(u+=o.charAt(n));else{u===void 0&&(u=o.substr(0,n));const E=h[d];E!==void 0?(r!==-1&&(u+=encodeURIComponent(o.substring(r,n)),r=-1),u+=E):r===-1&&(r=n)}}return r!==-1&&(u+=encodeURIComponent(o.substring(r))),u!==void 0?u:o}function p(o){let l;for(let c=0;c<o.length;c++){const u=o.charCodeAt(c);u===35||u===63?(l===void 0&&(l=o.substr(0,c)),l+=h[u]):l!==void 0&&(l+=o[c])}return l!==void 0?l:o}function b(o,l){let c;return o.authority&&o.path.length>1&&o.scheme==="file"?c=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?c=o.path.substr(1):c=o.path[1].toLowerCase()+o.path.substr(2):c=o.path,t.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=b;function S(o,l){const c=l?p:f;let u="",{scheme:r,authority:n,path:d,query:E,fragment:k}=o;if(r&&(u+=r,u+=":"),(n||r==="file")&&(u+=P,u+=P),n){let M=n.indexOf("@");if(M!==-1){const K=n.substr(0,M);n=n.substr(M+1),M=K.lastIndexOf(":"),M===-1?u+=c(K,!1,!1):(u+=c(K.substr(0,M),!1,!1),u+=":",u+=c(K.substr(M+1),!1,!0)),u+="@"}n=n.toLowerCase(),M=n.lastIndexOf(":"),M===-1?u+=c(n,!1,!0):(u+=c(n.substr(0,M),!1,!0),u+=n.substr(M))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const M=d.charCodeAt(1);M>=65&&M<=90&&(d=`/${String.fromCharCode(M+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const M=d.charCodeAt(0);M>=65&&M<=90&&(d=`${String.fromCharCode(M+32)}:${d.substr(2)}`)}u+=c(d,!0,!1)}return E&&(u+="?",u+=c(E,!1,!1)),k&&(u+="#",u+=l?k:f(k,!1,!1)),u}function g(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+g(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(o){return o.match(i)?o.replace(i,l=>g(l)):o}}),define(ye[87],Ce([1,0,23,8,2]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(D){return JSON.stringify(D,A)}e.stringify=R;function I(D){let L=JSON.parse(D);return L=y(L),L}e.parse=I;function A(D,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function y(D,L=0){if(!D||L>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return T.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 16:return new Date(D.source)}if(D instanceof a.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=y(D[P],L+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=y(D[P],L+1))}return D}e.revive=y}),define(ye[17],Ce([1,0,9,12,2]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls",D.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,P,w){this.a[L]=P,this.b[L]=w}setConnectionToken(L,P){this.c[L]=P}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(h){return a.onUnexpectedError(h),L}const P=L.authority;let w=this.a[P];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const C=this.b[P],v=this.c[P];let m=`path=${encodeURIComponent(L.path)}`;return typeof v=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),T.URI.from({scheme:t.isWeb?this.d:R.vscodeRemoteResource,authority:`${w}:${C}`,path:this.f,query:m})}}e.RemoteAuthorities=new I,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(L){const P=this.b(L,te);return this.uriToBrowserUri(P)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${R.vscodeFileResource}://${A.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||A.a,query:null,fragment:null}):L}asFileUri(L){const P=this.b(L,te);return this.uriToFileUri(P)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==A.a?L.authority:null,query:null,fragment:null}):L}b(L,P){return T.URI.isUri(L)?L:T.URI.parse(P.toUrl(L))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(D){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);D.CoopAndCoep=Object.freeze(L.get("3"));const P="vscode-coi";function w(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:T.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const h=m?.get(P);if(!!h)return L.get(h)}D.getHeadersFromQuery=w;function C(v,m,h){if(!globalThis.crossOriginIsolated)return;const f=m&&h?"3":h?"2":"1";v instanceof URLSearchParams?v.set(P,f):v[P]=f}D.addSearchParam=C})(y=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,17,11,12,8,2]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(C){return(0,A.uriToFsPath)(C,!0)}e.originalFSPath=y;class D{constructor(v){this.a=v}compare(v,m,h=!1){return v===m?0:(0,I.compare)(this.getComparisonKey(v,h),this.getComparisonKey(m,h))}isEqual(v,m,h=!1){return v===m?!0:!v||!m?!1:this.getComparisonKey(v,h)===this.getComparisonKey(m,h)}getComparisonKey(v,m=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,m,h=!1){if(v.scheme===m.scheme){if(v.scheme===t.Schemas.file)return a.isEqualOrParent(y(v),y(m),this.a(v))&&v.query===m.query&&(h||v.fragment===m.fragment);if((0,e.isEqualAuthority)(v.authority,m.authority))return a.isEqualOrParent(v.path,m.path,this.a(v),"/")&&v.query===m.query&&(h||v.fragment===m.fragment)}return!1}joinPath(v,...m){return A.URI.joinPath(v,...m)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return T.posix.basename(v.path)}extname(v){return T.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let m;return v.scheme===t.Schemas.file?m=A.URI.file(T.dirname(y(v))).path:(m=T.posix.dirname(v.path),v.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),m="/")),v.with({path:m})}normalizePath(v){if(!v.path.length)return v;let m;return v.scheme===t.Schemas.file?m=A.URI.file(T.normalize(y(v))).path:m=T.posix.normalize(v.path),v.with({path:m})}relativePath(v,m){if(v.scheme!==m.scheme||!(0,e.isEqualAuthority)(v.authority,m.authority))return;if(v.scheme===t.Schemas.file){const p=T.relative(y(v),y(m));return R.isWindows?a.toSlashes(p):p}let h=v.path||"/";const f=m.path||"/";if(this.a(v)){let p=0;for(const b=Math.min(h.length,f.length);p<b&&!(h.charCodeAt(p)!==f.charCodeAt(p)&&h.charAt(p).toLowerCase()!==f.charAt(p).toLowerCase());p++);h=f.substr(0,p)+h.substr(p)}return T.posix.relative(h,f)}resolvePath(v,m){if(v.scheme===t.Schemas.file){const h=A.URI.file(T.resolve(y(v),m));return v.with({authority:h.authority,path:h.path})}return m=a.toPosixPath(m),v.with({path:T.posix.resolve(v.path,m)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,m){return v===m||v!==void 0&&m!==void 0&&(0,I.equalsIgnoreCase)(v,m)}hasTrailingPathSeparator(v,m=T.sep){if(v.scheme===t.Schemas.file){const h=y(v);return h.length>a.getRoot(h).length&&h[h.length-1]===m}else{const h=v.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,m=T.sep){return(0,e.hasTrailingPathSeparator)(v,m)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,m=T.sep){let h=!1;if(v.scheme===t.Schemas.file){const f=y(v);h=f!==void 0&&f.length===a.getRoot(f).length&&f[f.length-1]===m}else{m="/";const f=v.path;h=f.length===1&&f.charCodeAt(f.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(v,m)?v.with({path:v.path+"/"}):v}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(C=>C.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new D(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(C,v){const m=[];for(let h=0;h<C.length;h++){const f=v(C[h]);C.some((p,b)=>b===h?!1:(0,e.isEqualOrParent)(f,v(p)))||m.push(C[h])}return m}e.distinctParents=L;var P;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function v(m){const h=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[S,g]=b.split(":");S&&g&&h.set(S,g)});const p=m.path.substring(0,m.path.indexOf(";"));return p&&h.set(C.META_DATA_MIME,p),h}C.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function w(C,v,m){if(v){let h=C.path;return h&&h[0]!==T.posix.sep&&(h=T.posix.sep+h),C.with({scheme:m,authority:v,path:h})}return C.with({scheme:m})}e.toLocalResource=w}),define(ye[14],Ce([1,0,21,9,3,6,24,12]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(X){return!!X&&typeof X.then=="function"}e.isThenable=y;function D(X){const G=new a.CancellationTokenSource,de=X(G.token),be=new Promise((Ee,Pe)=>{const Fe=G.token.onCancellationRequested(()=>{Fe.dispose(),G.dispose(),Pe(new t.CancellationError)});Promise.resolve(de).then(se=>{Fe.dispose(),G.dispose(),Ee(se)},se=>{Fe.dispose(),G.dispose(),Pe(se)})});return new class{cancel(){G.cancel()}then(Ee,Pe){return be.then(Ee,Pe)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return be.finally(Ee)}}}e.createCancelablePromise=D;function L(X,G,de){return new Promise((be,Ee)=>{const Pe=G.onCancellationRequested(()=>{Pe.dispose(),be(de)});X.then(be,Ee).finally(()=>Pe.dispose())})}e.raceCancellation=L;function P(X,G){return new Promise((de,be)=>{const Ee=G.onCancellationRequested(()=>{Ee.dispose(),be(new t.CancellationError)});X.then(de,be).finally(()=>Ee.dispose())})}e.raceCancellationError=P;async function w(X){let G=-1;const de=X.map((Ee,Pe)=>Ee.then(Fe=>(G=Pe,Fe))),be=await Promise.race(de);return X.forEach((Ee,Pe)=>{Pe!==G&&Ee.cancel()}),be}e.raceCancellablePromises=w;function C(X,G,de){let be;const Ee=setTimeout(()=>{be?.(void 0),de?.()},G);return Promise.race([X.finally(()=>clearTimeout(Ee)),new Promise(Pe=>be=Pe)])}e.raceTimeout=C;function v(X){return new Promise((G,de)=>{const be=X();y(be)?be.then(G,de):G(be)})}e.asPromise=v;class m{constructor(){this.a=null,this.b=null,this.d=null}queue(G){if(this.a){if(this.d=G,!this.b){const de=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(de,de).then(be)})}return new Promise((de,be)=>{this.b.then(de,be)})}return this.a=G(),new Promise((de,be)=>{this.a.then(Ee=>{this.a=null,de(Ee)},Ee=>{this.a=null,be(Ee)})})}}e.Throttler=m;class h{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.Sequencer=h;class f{constructor(){this.a=new Map}queue(G,de){const Ee=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(G)===Ee&&this.a.delete(G)});return this.a.set(G,Ee),Ee}}e.SequencerByKey=f;const p=(X,G)=>{let de=!0;const be=setTimeout(()=>{de=!1,G()},X);return{isTriggered:()=>de,dispose:()=>{clearTimeout(be),de=!1}}},b=X=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,X())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,de=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((Ee,Pe)=>{this.d=Ee,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=de===e.MicrotaskDelay?b(be):p(de,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=S;class g{constructor(G){this.a=new S(G),this.b=new m}trigger(G,de){return this.a.trigger(()=>this.b.queue(G),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=g;class i{constructor(){this.a=!1,this.b=new Promise((G,de)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class s extends i{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function o(X,G){return G?new Promise((de,be)=>{const Ee=setTimeout(()=>{Pe.dispose(),de()},X),Pe=G.onCancellationRequested(()=>{clearTimeout(Ee),Pe.dispose(),be(new t.CancellationError)})}):D(de=>o(X,de))}e.timeout=o;function l(X,G=0){const de=setTimeout(X,G);return(0,R.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=l;function c(X){const G=[];let de=0;const be=X.length;function Ee(){return de<be?X[de++]():null}function Pe(Fe){Fe!=null&&G.push(Fe);const se=Ee();return se?se.then(Pe):Promise.resolve(G)}return Promise.resolve(null).then(Pe)}e.sequence=c;function u(X,G=be=>!!be,de=null){let be=0;const Ee=X.length,Pe=()=>{if(be>=Ee)return Promise.resolve(de);const Fe=X[be++];return Promise.resolve(Fe()).then(oe=>G(oe)?Promise.resolve(oe):Pe())};return Pe()}e.first=u;function r(X,G=be=>!!be,de=null){if(X.length===0)return Promise.resolve(de);let be=X.length;const Ee=()=>{be=-1;for(const Pe of X)Pe.cancel?.()};return new Promise((Pe,Fe)=>{for(const se of X)se.then(oe=>{--be>=0&&G(oe)?(Ee(),Pe(oe)):be===0&&Pe(de)}).catch(oe=>{--be>=0&&(Ee(),Fe(oe))})})}e.firstParallel=r;class n{constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new T.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((de,be)=>{this.f.push({factory:G,c:de,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const de=G.factory();de.then(G.c,G.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=n;class d extends n{constructor(){super(1)}}e.Queue=d;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const G=new ue;return this.b.add(G),G.p}d(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,de=I.extUri){const be=de.getComparisonKey(G);let Ee=this.a.get(be);return Ee||(Ee=new d,T.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class k{constructor(G,de){this.a=-1,typeof G=="function"&&typeof de=="number"&&this.setIfNotSet(G,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},de)}setIfNotSet(G,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},de))}}e.TimeoutTimer=k;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setInterval(()=>{G()},de)}}e.IntervalTimer=M;class K{constructor(G,de){this.b=-1,this.a=G,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class q{constructor(G,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=G,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class F extends K{constructor(G,de){super(G,de),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class B extends R.Disposable{constructor(G,de){super(),this.g=G,this.h=de,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of G)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,A.setTimeout0)(()=>{if(G)return;const de=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(X,G)=>{const de=requestIdleCallback(X,typeof G=="number"?{timeout:G}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(de))}}}}();class O{constructor(G){this.d=!1,this.a=()=>{try{this.f=G()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=O;async function U(X,G,de){let be;for(let Ee=0;Ee<de;Ee++)try{return await X()}catch(Pe){be=Pe,await o(G)}throw be}e.retry=U;class ${hasPending(G){return this.a?typeof G=="number"?this.a.taskId===G:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(G,de,be){return this.a={taskId:G,cancel:()=>be?.(),promise:de},de.then(()=>this.d(G),()=>this.d(G)),de}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this.b)this.b.run=G;else{let de,be;const Ee=new Promise((Pe,Fe)=>{de=Pe,be=Fe});this.b={run:G,promise:Ee,promiseResolve:de,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=$;class j{constructor(G,de=()=>Date.now()){this.d=G,this.f=de,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class ue{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((G,de)=>{this.a=G,this.b=de})}complete(G){return new Promise(de=>{this.a(G),this.f=!0,de()})}error(G){return new Promise(de=>{this.b(G),this.d=!0,de()})}cancel(){new Promise(G=>{this.b(new t.CancellationError),this.d=!0,G()})}}e.DeferredPromise=ue;var V;(function(X){async function G(be){let Ee;const Pe=await Promise.all(be.map(Fe=>Fe.then(se=>se,se=>{Ee||(Ee=se)})));if(typeof Ee<"u")throw Ee;return Pe}X.settled=G;function de(be){return new Promise(async(Ee,Pe)=>{try{await be(Ee,Pe)}catch(Fe){Pe(Fe)}})}X.withAsyncBody=de})(V=e.Promises||(e.Promises={}));var _;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(_||(_={}));class Y{static fromArray(G){return new Y(de=>{de.emitMany(G)})}static fromPromise(G){return new Y(async de=>{de.emitMany(await G)})}static fromPromises(G){return new Y(async de=>{await Promise.all(G.map(async be=>de.emitOne(await be)))})}static merge(G){return new Y(async de=>{await Promise.all(G.map(async be=>{for await(const Ee of be)de.emitOne(Ee)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new T.Emitter,queueMicrotask(async()=>{const de={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(G(de)),this.j()}catch(be){this.k(be)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await T.Event.toPromise(this.f.event)}while(!0)}}}static map(G,de){return new Y(async be=>{for await(const Ee of G)be.emitOne(de(Ee))})}map(G){return Y.map(this,G)}static filter(G,de){return new Y(async be=>{for await(const Ee of G)de(Ee)&&be.emitOne(Ee)})}filter(G){return Y.filter(this,G)}static coalesce(G){return Y.filter(G,de=>!!de)}coalesce(){return Y.coalesce(this)}static async toPromise(G){const de=[];for await(const be of G)de.push(be);return de}toPromise(){return Y.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ne extends Y{constructor(G,de){super(de),this.l=G}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function ee(X){const G=new a.CancellationTokenSource,de=X(G.token);return new ne(G,async be=>{const Ee=G.token.onCancellationRequested(()=>{Ee.dispose(),G.dispose(),be.reject(new t.CancellationError)});try{for await(const Pe of de){if(G.token.isCancellationRequested)return;be.emitOne(Pe)}Ee.dispose(),G.dispose()}catch(Pe){Ee.dispose(),G.dispose(),be.reject(Pe)}})}e.createCancelableAsyncIterable=ee}),define(ye[110],Ce([1,0,14,11]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new a.IdleValue(()=>{const n=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:n,collatorIsNumeric:n.resolvedOptions().numeric}}),R=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(n,d,E=!1){const k=n||"",M=d||"",K=T.value.collator.compare(k,M);return T.value.collatorIsNumeric&&K===0&&k!==M?k<M?-1:1:K}e.compareFileNames=A;function y(n,d){const E=R.value.collator;return n=n||"",d=d||"",S(E,n,d)}e.compareFileNamesDefault=y;function D(n,d){const E=R.value.collator;return n=n||"",d=d||"",o(n,d)||S(E,n,d)}e.compareFileNamesUpper=D;function L(n,d){const E=R.value.collator;return n=n||"",d=d||"",s(n,d)||S(E,n,d)}e.compareFileNamesLower=L;function P(n,d){return n=n||"",d=d||"",n===d?0:n<d?-1:1}e.compareFileNamesUnicode=P;function w(n,d){const[E,k]=p(n),[M,K]=p(d);let q=T.value.collator.compare(k,K);if(q===0){if(T.value.collatorIsNumeric&&k!==K)return k<K?-1:1;if(q=T.value.collator.compare(E,M),T.value.collatorIsNumeric&&q===0&&E!==M)return E<M?-1:1}return q}e.compareFileExtensions=w;function C(n,d){n=n||"",d=d||"";const E=b(n),k=b(d),M=R.value.collator,K=I.value.collator;return S(K,E,k)||S(M,n,d)}e.compareFileExtensionsDefault=C;function v(n,d){n=n||"",d=d||"";const E=b(n),k=b(d),M=R.value.collator,K=I.value.collator;return S(K,E,k)||o(n,d)||S(M,n,d)}e.compareFileExtensionsUpper=v;function m(n,d){n=n||"",d=d||"";const E=b(n),k=b(d),M=R.value.collator,K=I.value.collator;return S(K,E,k)||s(n,d)||S(M,n,d)}e.compareFileExtensionsLower=m;function h(n,d){n=n||"",d=d||"";const E=b(n).toLowerCase(),k=b(d).toLowerCase();return E!==k?E<k?-1:1:n!==d?n<d?-1:1:0}e.compareFileExtensionsUnicode=h;const f=/^(.*?)(\.([^.]*))?$/;function p(n,d=!1){const E=n?f.exec(n):[];let k=[E&&E[1]||"",E&&E[3]||""];return d&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function b(n){const d=n?f.exec(n):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function S(n,d,E){const k=n.compare(d,E);return k!==0?k:d.length!==E.length?d.length<E.length?-1:1:0}function g(n){const d=n.charAt(0);return d.toLocaleUpperCase()!==d}function i(n){const d=n.charAt(0);return d.toLocaleLowerCase()!==d}function s(n,d){return g(n)&&i(d)?-1:i(n)&&g(d)?1:0}function o(n,d){return i(n)&&g(d)?-1:g(n)&&i(d)?1:0}function l(n,d,E=!1){return E||(n=n&&n.toLowerCase(),d=d&&d.toLowerCase()),n===d?0:n<d?-1:1}function c(n,d,E=!1){const k=n.split(t.sep),M=d.split(t.sep),K=k.length-1,q=M.length-1;let F,B;for(let O=0;;O++){if(F=K===O,B=q===O,F&&B)return A(k[O],M[O],E);if(F)return-1;if(B)return 1;const U=l(k[O],M[O],E);if(U!==0)return U}}e.comparePaths=c;function u(n,d,E){const k=n.toLowerCase(),M=d.toLowerCase(),K=r(n,d,E);if(K)return K;const q=k.endsWith(E),F=M.endsWith(E);if(q!==F)return q?-1:1;const B=A(k,M);return B!==0?B:k.localeCompare(M)}e.compareAnything=u;function r(n,d,E){const k=n.toLowerCase(),M=d.toLowerCase(),K=k.startsWith(E),q=M.startsWith(E);if(K!==q)return K?-1:1;if(K&&q){if(k.length<M.length)return-1;if(k.length>M.length)return 1}return 0}e.compareByPrefix=r}),define(ye[111],Ce([1,0,110,109,86,11,12,8]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,D=[y,[]];function L($,j,ue,V){if(!$||!j)return D;const _=$.length,Y=j.length;if(_<Y)return D;const ne=$.toLowerCase();return P(j,ue,Y,$,ne,_,V)}e.scoreFuzzy=L;function P($,j,ue,V,_,Y,ne){const ee=[],X=[];for(let Ee=0;Ee<ue;Ee++){const Pe=Ee*Y,Fe=Pe-Y,se=Ee>0,oe=$[Ee],fe=j[Ee];for(let Z=0;Z<Y;Z++){const ce=Z>0,ie=Pe+Z,N=ie-1,H=Fe+Z-1,Q=ce?ee[N]:0,J=se&&ce?ee[H]:0,he=se&&ce?X[H]:0;let we;!J&&se?we=0:we=w(oe,fe,V,_,Z,he),we&&J+we>=Q&&(ne||se||_.startsWith(j,Z))?(X[ie]=he+1,ee[ie]=J+we):(X[ie]=y,ee[ie]=Q)}}const G=[];let de=ue-1,be=Y-1;for(;de>=0&&be>=0;){const Ee=de*Y+be;X[Ee]===y||(G.push(be),de--),be--}return[ee[ue*Y-1],G.reverse()]}function w($,j,ue,V,_,Y){let ne=0;if(!C(j,V[_]))return ne;if(ne+=1,Y>0&&(ne+=Y*5),$===ue[_]&&(ne+=1),_===0)ne+=8;else{const ee=v(ue.charCodeAt(_-1));ee?ne+=ee:(0,t.isUpper)(ue.charCodeAt(_))&&Y===0&&(ne+=2)}return ne}function C($,j){return $===j?!0:$==="/"||$==="\\"?j==="/"||j==="\\":!1}function v($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function h($,j,ue=0,V=0){const _=j;return _.values&&_.values.length>1?f($,_.values,ue,V):p($,j,ue,V)}e.scoreFuzzy2=h;function f($,j,ue,V){let _=0;const Y=[];for(const ne of j){const[ee,X]=p($,ne,ue,V);if(typeof ee!="number")return m;_+=ee,Y.push(...X)}return[_,n(Y)]}function p($,j,ue,V){const _=(0,t.fuzzyScore)(j.original,j.originalLowercase,ue,$,$.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,t.createMatches)(_)]:m}const b=Object.freeze({score:0}),S=1<<18,g=1<<17,i=1<<16;function s($,j,ue,V){const _=V.values?V.values:[V];return(0,T.hash)({[V.normalized]:{values:_.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:$,description:j,allowNonContiguousMatches:ue}})}function o($,j,ue,V,_){if(!$||!j.normalized)return b;const Y=V.getItemLabel($);if(!Y)return b;const ne=V.getItemDescription($),ee=s(Y,ne,ue,j),X=_[ee];if(X)return X;const G=l(Y,ne,V.getItemPath($),j,ue);return _[ee]=G,G}e.scoreItemFuzzy=o;function l($,j,ue,V,_){const Y=!ue||!V.containsPathSeparator;return ue&&(I.isLinux?V.pathNormalized===ue:(0,A.equalsIgnoreCase)(V.pathNormalized,ue))?{score:S,labelMatch:[{start:0,end:$.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:V.values&&V.values.length>1?c($,j,ue,V.values,Y,_):u($,j,ue,V,Y,_)}function c($,j,ue,V,_,Y){let ne=0;const ee=[],X=[];for(const G of V){const{score:de,labelMatch:be,descriptionMatch:Ee}=u($,j,ue,G,_,Y);if(de===y)return b;ne+=de,be&&ee.push(...be),Ee&&X.push(...Ee)}return{score:ne,labelMatch:n(ee),descriptionMatch:n(X)}}function u($,j,ue,V,_,Y){if(_||!j){const[ne,ee]=L($,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(ne){const X=(0,t.matchesPrefix)(V.normalized,$);let G;return X?(G=g,G+=Math.round(V.normalized.length/$.length*100)):G=i,{score:G+ne,labelMatch:X||r(ee)}}}if(j){let ne=j;ue&&(ne=`${j}${R.sep}`);const ee=ne.length,X=`${ne}${$}`,[G,de]=L(X,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(G){const be=r(de),Ee=[],Pe=[];return be.forEach(Fe=>{Fe.start<ee&&Fe.end>ee?(Ee.push({start:0,end:Fe.end-ee}),Pe.push({start:Fe.start,end:ee})):Fe.start>=ee?Ee.push({start:Fe.start-ee,end:Fe.end-ee}):Pe.push(Fe)}),{score:G,labelMatch:Ee,descriptionMatch:Pe}}}return b}function r($){const j=[];if(!$)return j;let ue;for(const V of $)ue&&ue.end===V?ue.end+=1:(ue={start:V,end:V+1},j.push(ue));return j}function n($){const j=$.sort((_,Y)=>_.start-Y.start),ue=[];let V;for(const _ of j)!V||!d(V,_)?(V=_,ue.push(_)):(V.start=Math.min(V.start,_.start),V.end=Math.max(V.end,_.end));return ue}function d($,j){return!($.end<j.start||j.end<$.start)}function E($,j,ue,V,_,Y){const ne=o($,ue,V,_,Y),ee=o(j,ue,V,_,Y),X=ne.score,G=ee.score;if((X===S||G===S)&&X!==G)return X===S?-1:1;if(X>i||G>i){if(X!==G)return X>G?-1:1;if(X<g&&G<g){const oe=M(ne.labelMatch,ee.labelMatch);if(oe!==0)return oe}const Fe=_.getItemLabel($)||"",se=_.getItemLabel(j)||"";if(Fe.length!==se.length)return Fe.length-se.length}if(X!==G)return X>G?-1:1;const de=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ee=k($,ne,_),Pe=k(j,ee,_);return Ee&&Pe&&Ee!==Pe?Pe>Ee?-1:1:K($,j,ue,_)}e.compareItemsByFuzzyScore=E;function k($,j,ue){let V=-1,_=-1;if(j.descriptionMatch&&j.descriptionMatch.length?V=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(V=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(_=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const Y=ue.getItemDescription($);Y&&(_+=Y.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(_=j.descriptionMatch[j.descriptionMatch.length-1].end);return _-V}function M($,j){if(!$&&!j||(!$||!$.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!$||!$.length)return 1;const ue=$[0].start,_=$[$.length-1].end-ue,Y=j[0].start,ee=j[j.length-1].end-Y;return _===ee?0:ee<_?1:-1}function K($,j,ue,V){const _=V.getItemLabel($)||"",Y=V.getItemLabel(j)||"",ne=V.getItemDescription($),ee=V.getItemDescription(j),X=_.length+(ne?ne.length:0),G=Y.length+(ee?ee.length:0);if(X!==G)return X-G;const de=V.getItemPath($),be=V.getItemPath(j);return de&&be&&de.length!==be.length?de.length-be.length:_!==Y?(0,a.compareAnything)(_,Y,ue.normalized):ne&&ee&&ne!==ee?(0,a.compareAnything)(ne,ee,ue.normalized):de&&be&&de!==be?(0,a.compareAnything)(de,be,ue.normalized):0}function q($){return $.startsWith('"')&&$.endsWith('"')}const F=" ";function B($){typeof $!="string"&&($="");const j=$.toLowerCase(),{pathNormalized:ue,normalized:V,normalizedLowercase:_}=O($),Y=ue.indexOf(R.sep)>=0,ne=q($);let ee;const X=$.split(F);if(X.length>1)for(const G of X){const de=q(G),{pathNormalized:be,normalized:Ee,normalizedLowercase:Pe}=O(G);Ee&&(ee||(ee=[]),ee.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:be,normalized:Ee,normalizedLowercase:Pe,expectContiguousMatch:de}))}return{original:$,originalLowercase:j,pathNormalized:ue,normalized:V,normalizedLowercase:_,values:ee,containsPathSeparator:Y,expectContiguousMatch:ne}}e.prepareQuery=B;function O($){let j;I.isWindows?j=$.replace(/\//g,R.sep):j=$.replace(/\\/g,R.sep);const ue=(0,A.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function U($){return Array.isArray($)?B($.map(j=>j.original).join(F)):B($.original)}e.pieceToQuery=U}),define(ye[39],Ce([1,0,16,14,32,28,11,12,8]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",w=/\//g;function C(ue,V){switch(ue){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${V?`|${L}${P}+`:""})*?`}}function v(ue,V){if(!ue)return[];const _=[];let Y=!1,ne=!1,ee="";for(const X of ue){switch(X){case V:if(!Y&&!ne){_.push(ee),ee="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ee+=X}return ee&&_.push(ee),_}e.splitGlobAware=v;function m(ue){if(!ue)return"";let V="";const _=v(ue,e.GLOB_SPLIT);if(_.every(Y=>Y===e.GLOBSTAR))V=".*";else{let Y=!1;_.forEach((ne,ee)=>{if(ne===e.GLOBSTAR){if(Y)return;V+=C(2,ee===_.length-1)}else{let X=!1,G="",de=!1,be="";for(const Ee of ne){if(Ee!=="}"&&X){G+=Ee;continue}if(de&&(Ee!=="]"||!be)){let Pe;Ee==="-"?Pe=Ee:(Ee==="^"||Ee==="!")&&!be?Pe="^":Ee===e.GLOB_SPLIT?Pe="":Pe=(0,y.escapeRegExpCharacters)(Ee),be+=Pe;continue}switch(Ee){case"{":X=!0;continue;case"[":de=!0;continue;case"}":{V+=`(?:${v(G,",").map(se=>m(se)).join("|")})`,X=!1,G="";break}case"]":{V+="["+be+"]",de=!1,be="";break}case"?":V+=P;continue;case"*":V+=C(1);continue;default:V+=(0,y.escapeRegExpCharacters)(Ee)}}ee<_.length-1&&(_[ee+1]!==e.GLOBSTAR||ee+2<_.length)&&(V+=L)}Y=ne===e.GLOBSTAR})}return V}const h=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},o=function(){return null};function l(ue,V){if(!ue)return o;let _;typeof ue!="string"?_=ue.pattern:_=ue,_=_.trim();const Y=`${_}_${!!V.trimForExclusions}`;let ne=i.get(Y);if(ne)return c(ne,ue);let ee;return h.test(_)?ne=r(_.substr(4),_):(ee=f.exec(u(_,V)))?ne=n(ee[1],_):(V.trimForExclusions?b:p).test(_)?ne=d(_,V):(ee=S.exec(u(_,V)))?ne=E(ee[1].substr(1),_,!0):(ee=g.exec(u(_,V)))?ne=E(ee[1],_,!1):ne=k(_),i.set(Y,ne),c(ne,ue)}function c(ue,V){if(typeof V=="string")return ue;const _=function(Y,ne){return(0,T.isEqualOrParent)(Y,V.base,!A.isLinux)?ue((0,y.ltrim)(Y.substr(V.base.length),I.sep),ne):null};return _.allBasenames=ue.allBasenames,_.allPaths=ue.allPaths,_.basenames=ue.basenames,_.patterns=ue.patterns,_}function u(ue,V){return V.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function r(ue,V){return function(_,Y){return typeof _=="string"&&_.endsWith(ue)?V:null}}function n(ue,V){const _=`/${ue}`,Y=`\\${ue}`,ne=function(X,G){return typeof X!="string"?null:G?G===ue?V:null:X===ue||X.endsWith(_)||X.endsWith(Y)?V:null},ee=[ue];return ne.basenames=ee,ne.patterns=[V],ne.allBasenames=ee,ne}function d(ue,V){const _=$(ue.slice(1,-1).split(",").map(G=>l(G,V)).filter(G=>G!==o),ue),Y=_.length;if(!Y)return o;if(Y===1)return _[0];const ne=function(G,de){for(let be=0,Ee=_.length;be<Ee;be++)if(_[be](G,de))return ue;return null},ee=_.find(G=>!!G.allBasenames);ee&&(ne.allBasenames=ee.allBasenames);const X=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return X.length&&(ne.allPaths=X),ne}function E(ue,V,_){const Y=I.sep===I.posix.sep,ne=Y?ue:ue.replace(w,I.sep),ee=I.sep+ne,X=I.posix.sep+ue;let G;return _?G=function(de,be){return typeof de=="string"&&(de===ne||de.endsWith(ee)||!Y&&(de===ue||de.endsWith(X)))?V:null}:G=function(de,be){return typeof de=="string"&&(de===ne||!Y&&de===ue)?V:null},G.allPaths=[(_?"*/":"./")+ue],G}function k(ue){try{const V=new RegExp(`^${m(ue)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?ue:null}}catch{return o}}function M(ue,V,_){return!ue||typeof V!="string"?!1:K(ue)(V,void 0,_)}e.match=M;function K(ue,V={}){if(!ue)return s;if(typeof ue=="string"||q(ue)){const _=l(ue,V);if(_===o)return s;const Y=function(ne,ee){return!!_(ne,ee)};return _.allBasenames&&(Y.allBasenames=_.allBasenames),_.allPaths&&(Y.allPaths=_.allPaths),Y}return O(ue,V)}e.parse=K;function q(ue){const V=ue;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function F(ue){return ue.allBasenames||[]}e.getBasenameTerms=F;function B(ue){return ue.allPaths||[]}e.getPathTerms=B;function O(ue,V){const _=$(Object.getOwnPropertyNames(ue).map(G=>U(G,ue[G],V)).filter(G=>G!==o)),Y=_.length;if(!Y)return o;if(!_.some(G=>!!G.requiresSiblings)){if(Y===1)return _[0];const G=function(Ee,Pe){let Fe;for(let se=0,oe=_.length;se<oe;se++){const fe=_[se](Ee,Pe);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Fe||(Fe=[]),Fe.push(fe))}return Fe?(async()=>{for(const se of Fe){const oe=await se;if(typeof oe=="string")return oe}return null})():null},de=_.find(Ee=>!!Ee.allBasenames);de&&(G.allBasenames=de.allBasenames);const be=_.reduce((Ee,Pe)=>Pe.allPaths?Ee.concat(Pe.allPaths):Ee,[]);return be.length&&(G.allPaths=be),G}const ne=function(G,de,be){let Ee,Pe;for(let Fe=0,se=_.length;Fe<se;Fe++){const oe=_[Fe];oe.requiresSiblings&&be&&(de||(de=(0,I.basename)(G)),Ee||(Ee=de.substr(0,de.length-(0,I.extname)(G).length)));const fe=oe(G,de,Ee,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Pe||(Pe=[]),Pe.push(fe))}return Pe?(async()=>{for(const Fe of Pe){const se=await Fe;if(typeof se=="string")return se}return null})():null},ee=_.find(G=>!!G.allBasenames);ee&&(ne.allBasenames=ee.allBasenames);const X=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return X.length&&(ne.allPaths=X),ne}function U(ue,V,_){if(V===!1)return o;const Y=l(ue,_);if(Y===o)return o;if(typeof V=="boolean")return Y;if(V){const ne=V.when;if(typeof ne=="string"){const ee=(X,G,de,be)=>{if(!be||!Y(X,G))return null;const Ee=ne.replace("$(basename)",()=>de),Pe=be(Ee);return(0,t.isThenable)(Pe)?Pe.then(Fe=>Fe?ue:null):Pe?ue:null};return ee.requiresSiblings=!0,ee}}return Y}function $(ue,V){const _=ue.filter(G=>!!G.basenames);if(_.length<2)return ue;const Y=_.reduce((G,de)=>{const be=de.basenames;return be?G.concat(be):G},[]);let ne;if(V){ne=[];for(let G=0,de=Y.length;G<de;G++)ne.push(V)}else ne=_.reduce((G,de)=>{const be=de.patterns;return be?G.concat(be):G},[]);const ee=function(G,de){if(typeof G!="string")return null;if(!de){let Ee;for(Ee=G.length;Ee>0;Ee--){const Pe=G.charCodeAt(Ee-1);if(Pe===47||Pe===92)break}de=G.substr(Ee)}const be=Y.indexOf(de);return be!==-1?ne[be]:null};ee.basenames=Y,ee.patterns=ne,ee.allBasenames=Y;const X=ue.filter(G=>!G.basenames);return X.push(ee),X}function j(ue,V){return(0,a.equals)(ue,V,(_,Y)=>typeof _=="string"&&typeof Y=="string"?_===Y:typeof _!="string"&&typeof Y!="string"?_.base===Y.base&&_.pattern===Y.pattern:!1)}e.patternsEquals=j}),define(ye[112],Ce([1,0,9,162,24,8,2]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=w(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(b,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(f),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(f,p){const b=new RegExp((0,R.escapeRegExpCharacters)(p),"g");return f.replace(b,(S,g)=>f.charAt(g-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=y;function D(h){return L(h)?!h.value:Array.isArray(h)?h.every(D):!0}e.isEmptyMarkdownString=D;function L(h){return h instanceof y?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(h,f){return h===f?!0:!h||!f?!1:h.value===f.value&&h.isTrusted===f.isTrusted&&h.supportThemeIcons===f.supportThemeIcons&&h.supportHtml===f.supportHtml&&(h.baseUri===f.baseUri||!!h.baseUri&&!!f.baseUri&&(0,T.isEqual)(I.URI.from(h.baseUri),I.URI.from(f.baseUri)))}e.markdownStringEqual=P;function w(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function C(h){return h.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function v(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=v;function m(h){const f=[],p=h.split("|").map(S=>S.trim());h=p[0];const b=p[1];if(b){const S=/height=(\d+)/.exec(b),g=/width=(\d+)/.exec(b),i=S?S[1]:"",s=g?g[1]:"",o=isFinite(parseInt(s)),l=isFinite(parseInt(i));o&&f.push(`width="${s}"`),l&&f.push(`height="${i}"`)}return{href:h,dimensions:f}}e.parseHrefAndDimensions=m}),define(ye[113],Ce([1,0,16,32,11,12,24,8]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,l){const{os:c,tildify:u,relative:r}=l;if(r){const E=D(o,r,c);if(typeof E=="string")return E}let n=o.fsPath;if(c===1&&!R.isWindows?n=n.replace(/\//g,"\\"):c!==1&&R.isWindows&&(n=n.replace(/\\/g,"/")),c!==1&&u?.userHome){const E=u.userHome.fsPath;let k;o.scheme!==u.userHome.scheme&&o.path.startsWith(T.posix.sep)?k=u.userHome.with({path:o.path}).fsPath:k=o.fsPath,n=w(k,E,c)}return(c===1?T.win32:T.posix).normalize(L(n,c===1))}e.getPathLabel=y;function D(o,l,c){const u=c===1?T.win32:T.posix,r=c===3?I.extUri:I.extUriIgnorePathCase,n=l.getWorkspace(),d=(0,a.firstOrDefault)(n.folders);if(!d)return;o.scheme!==d.uri.scheme&&o.path.startsWith(T.posix.sep)&&(o=d.uri.with({path:o.path}));const E=l.getWorkspaceFolder(o);if(!E)return;let k;if(r.isEqual(E.uri,o)?k="":k=r.relativePath(E.uri,o)??"",k&&(k=u.normalize(k)),n.folders.length>1&&!l.noPrefix){const M=E.name?E.name:r.basenameOrAuthority(E.uri);k=k?`${M} \u2022 ${k}`:M}return k}function L(o,l=R.isWindows){return(0,t.hasDriveLetter)(o,l)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=L;let P=Object.create(null);function w(o,l,c=R.OS){if(c===1||!o||!l)return o;let u=P.original===l?P.normalized:void 0;u||(u=l,R.isWindows&&(u=(0,t.toSlashes)(u)),u=`${(0,A.rtrim)(u,T.posix.sep)}${T.posix.sep}`,P={original:l,normalized:u});let r=o;return R.isWindows&&(r=(0,t.toSlashes)(r)),(c===3?r.startsWith(u):(0,A.startsWithIgnoreCase)(r,u))?`~/${r.substr(u.length)}`:o}e.tildify=w;function C(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=C;const v="\u2026",m="\\\\",h="~";function f(o,l=T.sep){const c=new Array(o.length);let u=!1;for(let r=0;r<o.length;r++){const n=o[r];if(n===""){c[r]=`.${l}`;continue}if(!n){c[r]=n;continue}u=!0;let d="",E=n;E.indexOf(m)===0?(d=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length)):E.indexOf(l)===0?(d=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(h)===0&&(d=E.substr(0,E.indexOf(h)+h.length),E=E.substr(E.indexOf(h)+h.length));const k=E.split(l);for(let M=1;u&&M<=k.length;M++)for(let K=k.length-M;u&&K>=0;K--){u=!1;let q=k.slice(K,K+M).join(l);for(let F=0;!u&&F<o.length;F++)if(F!==r&&o[F]&&o[F].indexOf(q)>-1){const B=K+M===k.length,O=K>0&&o[F].indexOf(l)>-1?l+q:q,U=o[F].endsWith(O);u=!B||U}if(!u){let F="";(k[0].endsWith(":")||d!=="")&&(K===1&&(K=0,M++,q=k[0]+l+q),K>0&&(F=k[0]+l),F=d+F),K>0&&(F=F+v+l),F=F+q,K+M<k.length&&(F=F+l+v),c[r]=F}}u&&(c[r]=n)}return c}e.shorten=f;var p;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(o,l=Object.create(null)){const c=[];let u=!1,r="";for(const n of o)if(n==="$"||u&&n==="{")r&&c.push({value:r,type:p.TEXT}),r="",u=!0;else if(n==="}"&&u){const d=l[r];if(typeof d=="string")d.length&&c.push({value:d,type:p.VARIABLE});else if(d){const E=c[c.length-1];(!E||E.type!==p.SEPARATOR)&&c.push({value:d.label,type:p.SEPARATOR})}r="",u=!1}else r+=n;return r&&!u&&c.push({value:r,type:p.TEXT}),c.filter((n,d)=>{if(n.type===p.SEPARATOR){const E=c[d-1],k=c[d+1];return[E,k].every(M=>M&&(M.type===p.VARIABLE||M.type===p.TEXT)&&M.value.length>0)}return!0}).map(n=>n.value).join("")}e.template=b;function S(o,l){return R.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):o.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function g(o,l){return R.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):R.isWindows?o.replace(/&&|&/g,c=>c==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(o){const l=o.indexOf("/")!==-1?T.posix:T.win32,c=l.basename(o),u=l.dirname(o);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=s}),define(ye[114],Ce([1,0,2]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class T{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:t(a.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:t(a.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:a.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function R(L,P,w){if(!L||w>200)return null;if(typeof L=="object"){if(L instanceof a.URI)return P.transformOutgoing(L);for(const C in L)if(Object.hasOwnProperty.call(L,C)){const v=R(L[C],P,w+1);v!==null&&(L[C]=v)}}return null}function I(L,P){const w=R(L,P,0);return w===null?L:w}e.transformOutgoingURIs=I;function A(L,P,w,C){if(!L||C>200)return null;if(typeof L=="object"){if(L.$mid===1)return w?a.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const v in L)if(Object.hasOwnProperty.call(L,v)){const m=A(L[v],P,w,C+1);m!==null&&(L[v]=m)}}return null}function y(L,P){const w=A(L,P,!1,0);return w===null?L:w}e.transformIncomingURIs=y;function D(L,P){const w=A(L,P,!0,0);return w===null?L:w}e.transformAndReviveIncomingURIs=D}),define(ye[29],Ce([1,0,67,88,315,14,32,84,11,12,24,2]),function(te,e,a,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function C(O,U=w.UNLINK){if((0,I.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===w.UNLINK?m(O):v(O)}async function v(O){try{const U=(0,I.randomPath)((0,t.tmpdir)());try{await a.promises.rename(O,U)}catch($){return $.code==="ENOENT"?void 0:m(O)}m(U).catch($=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function m(O){return(0,T.promisify)(a.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function h(O){if((0,I.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function f(O,U){return S(await(U?p(O):(0,T.promisify)(a.readdir)(O)))}async function p(O){try{return await(0,T.promisify)(a.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],$=await f(O);for(const j of $){let ue=!1,V=!1,_=!1;try{const Y=await e.Promises.lstat((0,y.join)(O,j));ue=Y.isFile(),V=Y.isDirectory(),_=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}U.push({name:j,isFile:()=>ue,isDirectory:()=>V,isSymbolicLink:()=>_})}return U}function b(O){return S(a.readdirSync(O))}e.readdirSync=b;function S(O){return O.map(U=>typeof U=="string"?D.isMacintosh?(0,A.normalizeNFC)(U):U:(U.name=D.isMacintosh?(0,A.normalizeNFC)(U.name):U.name,U))}async function g(O){const U=await f(O),$=[];for(const j of U)await s.existsDirectory((0,y.join)(O,j))&&$.push(j);return $}function i(O,U=1e3){return new Promise($=>{let j=!1;const ue=setInterval(()=>{j||(j=!0,a.access(O,V=>{j=!1,V&&(clearInterval(ue),$(void 0))}))},U)})}e.whenDeleted=i;var s;(function(O){async function U(ue){let V;try{if(V=await e.Promises.lstat(ue),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(ue),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(D.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ue)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Y}throw _}}O.stat=U;async function $(ue){try{const{stat:V,symbolicLink:_}=await O.stat(ue);return V.isFile()&&_?.dangling!==!0}catch{}return!1}O.existsFile=$;async function j(ue){try{const{stat:V,symbolicLink:_}=await O.stat(ue);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new R.ResourceQueue;function l(O,U,$){return o.queueFor(P.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=d($);return new Promise((ue,V)=>r(O,U,j,_=>_?V(_):ue()))})}let c=!0;function u(O){c=O}e.configureFlushOnWrite=u;function r(O,U,$,j){if(!c)return a.writeFile(O,U,{mode:$.mode,flag:$.flag},j);a.open(O,$.flag,$.mode,(ue,V)=>{if(ue)return j(ue);a.writeFile(V,U,_=>{if(_)return a.close(V,()=>j(_));a.fdatasync(V,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),u(!1)),a.close(V,ne=>j(ne))))})})}function n(O,U,$){const j=d($);if(!c)return a.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const ue=a.openSync(O,j.flag,j.mode);try{a.writeFileSync(ue,U);try{a.fdatasyncSync(ue)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),u(!1)}}finally{a.closeSync(ue)}}e.writeFileSync=n;function d(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function E(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch($){if(O.toLowerCase()!==U.toLowerCase()&&$.code==="EXDEV"||O.endsWith("."))await k(O,U,{preserveSymlinks:!1}),await C(O,w.MOVE);else throw $}}async function k(O,U,$){return K(O,U,{root:{source:O,target:U},options:$,handledSourcePaths:new Set})}const M=511;async function K(O,U,$){if($.handledSourcePaths.has(O))return;$.handledSourcePaths.add(O);const{stat:j,symbolicLink:ue}=await s.stat(O);if(ue){if($.options.preserveSymlinks)try{return await B(O,U,$)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(ue.dangling)return}return j.isDirectory()?q(O,U,j.mode&M,$):F(O,U,j.mode&M)}async function q(O,U,$,j){await e.Promises.mkdir(U,{recursive:!0,mode:$});const ue=await f(O);for(const V of ue)await K((0,y.join)(O,V),(0,y.join)(U,V),j)}async function F(O,U,$){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,$)}async function B(O,U,$){let j=await e.Promises.readlink(O);(0,I.isEqualOrParent)(j,$.root.source,!D.isLinux)&&(j=(0,y.join)($.root.target,j.substr($.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,T.promisify)(a.access)}get stat(){return(0,T.promisify)(a.stat)}get lstat(){return(0,T.promisify)(a.lstat)}get utimes(){return(0,T.promisify)(a.utimes)}get read(){return(O,U,$,j,ue)=>new Promise((V,_)=>{a.read(O,U,$,j,ue,(Y,ne,ee)=>Y?_(Y):V({bytesRead:ne,buffer:ee}))})}get readFile(){return(0,T.promisify)(a.readFile)}get write(){return(O,U,$,j,ue)=>new Promise((V,_)=>{a.write(O,U,$,j,ue,(Y,ne,ee)=>Y?_(Y):V({bytesWritten:ne,buffer:ee}))})}get appendFile(){return(0,T.promisify)(a.appendFile)}get fdatasync(){return(0,T.promisify)(a.fdatasync)}get truncate(){return(0,T.promisify)(a.truncate)}get rename(){return(0,T.promisify)(a.rename)}get copyFile(){return(0,T.promisify)(a.copyFile)}get open(){return(0,T.promisify)(a.open)}get close(){return(0,T.promisify)(a.close)}get symlink(){return(0,T.promisify)(a.symlink)}get readlink(){return(0,T.promisify)(a.readlink)}get chmod(){return(0,T.promisify)(a.chmod)}get mkdir(){return(0,T.promisify)(a.mkdir)}get unlink(){return(0,T.promisify)(a.unlink)}get rmdir(){return(0,T.promisify)(a.rmdir)}get realpath(){return(0,T.promisify)(a.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return g}get writeFile(){return l}get rm(){return C}get move(){return E}get copy(){return k}}}),define(ye[115],Ce([1,0,67,11,12,8,29]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(w){if(T.isLinux)return w;const C=(0,t.dirname)(w);if(w===C)return w;const v=((0,t.basename)(w)||w).toLowerCase();try{const h=(0,I.readdirSync)(C).filter(f=>f.toLowerCase()===v);if(h.length===1){const f=A(C);if(f)return(0,t.join)(f,h[0])}else if(h.length>1){const f=h.indexOf(v);if(f>=0){const p=A(C);if(p)return(0,t.join)(p,h[f])}}}catch{}return null}e.realcaseSync=A;async function y(w){if(T.isLinux)return w;const C=(0,t.dirname)(w);if(w===C)return w;const v=((0,t.basename)(w)||w).toLowerCase();try{const h=(await I.Promises.readdir(C)).filter(f=>f.toLowerCase()===v);if(h.length===1){const f=await y(C);if(f)return(0,t.join)(f,h[0])}else if(h.length>1){const f=h.indexOf(v);if(f>=0){const p=await y(C);if(p)return(0,t.join)(p,h[f])}}}catch{}return null}e.realcase=y;async function D(w){try{return await I.Promises.realpath(w)}catch{const v=P(w);return await I.Promises.access(v,a.constants.R_OK),v}}e.realpath=D;function L(w){try{return a.realpathSync(w)}catch{const v=P(w);return a.accessSync(v,a.constants.R_OK),v}}e.realpathSync=L;function P(w){return(0,R.rtrim)((0,t.normalize)(w),t.sep)}}),define(ye[116],Ce([1,0,11,12,37,108,10,29]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=T.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function D(P){let w=[],C=!1;const v=function(m){if(C){w.push(m);return}(!P.send(m,f=>{if(f&&console.error(f),C=!1,w.length>0){const p=w.slice(0);w=[],p.forEach(b=>v(b))}})||t.isWindows)&&(C=!0)};return{send:v}}e.createQueuedSender=D;var L;(function(P){async function w(C,v,m){if(a.isAbsolute(C))return C;if(v===void 0&&(v=T.cwd()),a.dirname(C)!=="."||(m===void 0&&I.isString(T.env.PATH)&&(m=T.env.PATH.split(a.delimiter)),m===void 0||m.length===0))return a.join(v,C);async function f(p){if(await A.Promises.exists(p)){let b;try{b=await A.Promises.stat(p)}catch(S){S.message.startsWith("EACCES")&&(b=await A.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of m){let b;if(a.isAbsolute(p)?b=a.join(p,C):b=a.join(v,p,C),await f(b))return b;let S=b+".com";if(await f(S)||(S=b+".exe",await f(S)))return S}return a.join(v,C)}P.findExecutable=w})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(te,e,a,t){var T=arguments.length,R=T<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(te,e,a,t);else for(var A=te.length-1;A>=0;A--)(I=te[A])&&(R=(T<3?I(R):T>3?I(e,a,R):I(e,a))||R);return T>3&&R&&Object.defineProperty(e,a,R),R};define(ye[117],Ce([1,0,16,14,23,21,62,9,3,6,87,8,10]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(C||(C={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(m||(m={}));function h(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function p(V){let _=0;for(let Y=0;;Y+=7){const ne=V.read(1);if(_|=(ne.buffer[0]&127)<<Y,!(ne.buffer[0]&128))return _}}const b=o(0);function S(V,_){if(_===0){V.write(b);return}let Y=0;for(let ee=_;ee!==0;ee=ee>>>7)Y++;const ne=T.VSBuffer.alloc(Y);for(let ee=0;_!==0;ee++)ne.buffer[ee]=_&127,_=_>>>7,_>0&&(ne.buffer[ee]|=128);V.write(ne)}class g{constructor(_){this.b=_,this.a=0}read(_){const Y=this.b.slice(this.a,this.a+_);return this.a+=Y.byteLength,Y}}e.BufferReader=g;class i{constructor(){this.a=[]}get buffer(){return T.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=i;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function o(V){const _=T.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const l={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object),Uint:o(s.Int)},c=typeof Buffer<"u";function u(V,_){if(typeof _>"u")V.write(l.Undefined);else if(typeof _=="string"){const Y=T.VSBuffer.fromString(_);V.write(l.String),S(V,Y.byteLength),V.write(Y)}else if(c&&Buffer.isBuffer(_)){const Y=T.VSBuffer.wrap(_);V.write(l.Buffer),S(V,Y.byteLength),V.write(Y)}else if(_ instanceof T.VSBuffer)V.write(l.VSBuffer),S(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(l.Array),S(V,_.length);for(const Y of _)u(V,Y)}else if(typeof _=="number"&&(_|0)===_)V.write(l.Uint),S(V,_);else{const Y=T.VSBuffer.fromString(JSON.stringify(_));V.write(l.Object),S(V,Y.byteLength),V.write(Y)}}e.serialize=u;function r(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(p(V)).toString();case s.Buffer:return V.read(p(V)).buffer;case s.VSBuffer:return V.read(p(V));case s.Array:{const Y=p(V),ne=[];for(let ee=0;ee<Y;ee++)ne.push(r(V));return ne}case s.Object:return JSON.parse(V.read(p(V)).toString());case s.Int:return p(V)}}e.deserialize=r;class n{constructor(_,Y,ne=null,ee=1e3){this.h=_,this.j=Y,this.k=ne,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(_,Y){this.b.set(_,Y),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const Y=this.o([_.type]);this.k?.logOutgoing(Y,0,1,h(_.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([_.type,_.id],_.data);this.k?.logOutgoing(Y,_.id,1,h(_.type),_.data);return}}}o(_,Y=void 0){const ne=new i;return u(ne,_),u(ne,Y),this.p(ne.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const Y=new g(_),ne=r(Y),ee=r(Y),X=ne[0];switch(X){case 100:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}: ${ne[2]}.${ne[3]}`,ee),this.s({type:X,id:ne[1],channelName:ne[2],name:ne[3],arg:ee});case 102:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}: ${ne[2]}.${ne[3]}`,ee),this.t({type:X,id:ne[1],channelName:ne[2],name:ne[3],arg:ee});case 101:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}`),this.u({type:X,id:ne[1]});case 103:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}`),this.u({type:X,id:ne[1]})}}s(_){const Y=this.b.get(_.channelName);if(!Y){this.v(_);return}const ne=new R.CancellationTokenSource;let ee;try{ee=Y.call(this.j,_.name,_.arg,ne.token)}catch(de){ee=Promise.reject(de)}const X=_.id;ee.then(de=>{this.m({id:X,data:de,type:201}),this.d.delete(_.id)},de=>{de instanceof Error?this.m({id:X,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.m({id:X,data:de,type:203}),this.d.delete(_.id)});const G=(0,D.toDisposable)(()=>ne.cancel());this.d.set(_.id,G)}t(_){const Y=this.b.get(_.channelName);if(!Y){this.v(_);return}const ne=_.id,X=Y.listen(this.j,_.name,_.arg)(G=>this.m({id:ne,data:G,type:204}));this.d.set(_.id,X)}u(_){const Y=this.d.get(_.id);Y&&(Y.dispose(),this.d.delete(_.id))}v(_){let Y=this.g.get(_.channelName);Y||(Y=[],this.g.set(_.channelName,Y));const ne=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:_,timeoutTimer:ne})}w(_){const Y=this.g.get(_);if(Y){for(const ne of Y)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,D.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var d;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(_,Y=null){this.l=_,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=Y}getChannel(_){const Y=this;return{call(ne,ee,X){return Y.a?Promise.reject(new A.CancellationError):Y.m(_,ne,ee,X)},listen(ne,ee){return Y.a?y.Event.None:Y.o(_,ne,ee)}}}m(_,Y,ne,ee=R.CancellationToken.None){const X=this.g++,de={id:X,type:100,channelName:_,name:Y,arg:ne};if(ee.isCancellationRequested)return Promise.reject(new A.CancellationError);let be;return new Promise((Pe,Fe)=>{if(ee.isCancellationRequested)return Fe(new A.CancellationError);const se=()=>{const ce=ie=>{switch(ie.type){case 201:this.f.delete(X),Pe(ie.data);break;case 202:{this.f.delete(X);const N=new Error(ie.data.message);N.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,N.name=ie.data.name,Fe(N);break}case 203:this.f.delete(X),Fe(ie.data);break}};this.f.set(X,ce),this.p(de)};let oe=null;this.b===f.Idle?se():(oe=(0,t.createCancelablePromise)(ce=>this.u()),oe.then(()=>{oe=null,se()}));const fe=()=>{oe?(oe.cancel(),oe=null):this.p({id:X,type:101}),Fe(new A.CancellationError)},Z=ee.onCancellationRequested(fe);be=(0,D.combinedDisposable)((0,D.toDisposable)(fe),Z),this.d.add(be)}).finally(()=>{this.d.delete(be)})}o(_,Y,ne){const ee=this.g++,G={id:ee,type:102,channelName:_,name:Y,arg:ne};let de=null;const be=new y.Emitter({onWillAddFirstListener:()=>{de=(0,t.createCancelablePromise)(Pe=>this.u()),de.then(()=>{de=null,this.d.add(be),this.p(G)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(be),this.p({id:ee,type:103}))}}),Ee=Pe=>be.fire(Pe.data);return this.f.set(ee,Ee),be.event}p(_){switch(_.type){case 100:case 102:{const Y=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(Y,_.id,0,`${v(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const Y=this.q([_.type,_.id]);this.j?.logOutgoing(Y,_.id,0,v(_.type));return}}}q(_,Y=void 0){const ne=new i;return u(ne,_),u(ne,Y),this.r(ne.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const Y=new g(_),ne=r(Y),ee=r(Y),X=ne[0];switch(X){case 200:return this.j?.logIncoming(_.byteLength,0,0,h(X)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,ne[1],0,h(X),ee),this.t({type:ne[0],id:ne[1],data:ee})}}t(_){if(_.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,D.dispose)(this.d.values()),this.d.clear()}}qe([I.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class k{get connections(){const _=[];return this.f.forEach(Y=>_.push(Y)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:Y,onDidClientDisconnect:ne})=>{y.Event.once(Y.onMessage)(X=>{const G=new g(X),de=r(G),be=new n(Y,de),Ee=new E(Y);this.a.forEach((Fe,se)=>be.registerChannel(se,Fe));const Pe={channelServer:be,channelClient:Ee,ctx:de};this.f.add(Pe),this.g.fire(Pe),ne(()=>{be.dispose(),Ee.dispose(),this.f.delete(Pe),this.h.fire(Pe)})})})}getChannel(_,Y){const ne=this;return{call(ee,X,G){let de;if((0,w.isFunction)(Y)){const Ee=(0,a.getRandomElement)(ne.connections.filter(Y));de=Ee?Promise.resolve(Ee):y.Event.toPromise(y.Event.filter(ne.onDidAddConnection,Y))}else de=Y.routeCall(ne,ee,X);const be=de.then(Ee=>Ee.channelClient.getChannel(_));return K(be).call(ee,X,G)},listen(ee,X){if((0,w.isFunction)(Y))return ne.j(_,Y,ee,X);const G=Y.routeEvent(ne,ee,X).then(de=>de.channelClient.getChannel(_));return K(G).listen(ee,X)}}}j(_,Y,ne,ee){const X=this;let G=new D.DisposableStore;const de=new y.Emitter({onWillAddFirstListener:()=>{G=new D.DisposableStore;const be=new y.EventMultiplexer,Ee=new Map,Pe=se=>{const fe=se.channelClient.getChannel(_).listen(ne,ee),Z=be.add(fe);Ee.set(se,Z)},Fe=se=>{const oe=Ee.get(se);!oe||(oe.dispose(),Ee.delete(se))};X.connections.filter(Y).forEach(Pe),y.Event.filter(X.onDidAddConnection,Y)(Pe,void 0,G),X.onDidRemoveConnection(Fe,void 0,G),be.event(de.fire,de,G),G.add(be)},onDidRemoveLastListener:()=>{G.dispose()}});return de.event}registerChannel(_,Y){this.a.set(_,Y),this.f.forEach(ne=>{ne.channelServer.registerChannel(_,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class M{constructor(_,Y,ne=null){const ee=new i;u(ee,Y),_.send(ee.buffer),this.a=new E(_,ne),this.d=new n(_,Y,ne)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,Y){this.d.registerChannel(_,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=M;function K(V){return{call(_,Y,ne){return V.then(ee=>ee.call(_,Y,ne))},listen(_,Y){const ne=new y.Relay;return V.then(ee=>ne.input=ee.listen(_,Y)),ne.event}}}e.getDelayedChannel=K;function q(V){let _=!1;return{call(Y,ne,ee){return _?V.call(Y,ne,ee):(0,t.timeout)(0).then(()=>_=!0).then(()=>V.call(Y,ne,ee))},listen(Y,ne){if(_)return V.listen(Y,ne);const ee=new y.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>ee.input=V.listen(Y,ne)),ee.event}}}e.getNextTickChannel=q;class F{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const Y of _.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await y.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=F;var B;(function(V){function _(X,G){const de=X,be=G&&G.disableMarshalling,Ee=new Map;for(const Pe in de)ne(Pe)&&Ee.set(Pe,y.Event.buffer(de[Pe],!0));return new class{listen(Pe,Fe,se){const oe=Ee.get(Fe);if(oe)return oe;if(ee(Fe)){const fe=de[Fe];if(typeof fe=="function")return fe.call(de,se)}throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,se){const oe=de[Fe];if(typeof oe=="function"){if(!be&&Array.isArray(se))for(let fe=0;fe<se.length;fe++)se[fe]=(0,L.revive)(se[fe]);return oe.apply(de,se)}throw new Error(`Method not found: ${Fe}`)}}}V.fromService=_;function Y(X,G){const de=G&&G.disableMarshalling;return new Proxy({},{get(be,Ee){if(typeof Ee=="string")return G?.properties?.has(Ee)?G.properties.get(Ee):ee(Ee)?function(Pe){return X.listen(Ee,Pe)}:ne(Ee)?X.listen(Ee):async function(...Pe){let Fe;G&&!(0,w.isUndefinedOrNull)(G.context)?Fe=[G.context,...Pe]:Fe=Pe;const se=await X.call(Ee,Fe);return de?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=Y;function ne(X){return X[0]==="o"&&X[1]==="n"&&P.isUpperAsciiLetter(X.charCodeAt(2))}function ee(X){return/^onDynamic/.test(X)&&P.isUpperAsciiLetter(X.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function $(V){return Array.isArray(V)?V.map(U):U(V)}function j(V,_,Y,ne,ee,X,G){G=$(G);const de=O[ee],be=de[ne%de.length];let Ee=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(X)?(Ee=Ee.concat(G),Ee.push(")")):Ee.push(G),console.log.apply(console,Ee)}class ue{constructor(_,Y){this.d=_,this.f=Y,this.a=0,this.b=0}logOutgoing(_,Y,ne,ee,X){this.b+=_,j(this.d,this.b,_,Y,ne,ee,X)}logIncoming(_,Y,ne,ee,X){this.a+=_,j(this.f,this.a,_,Y,ne,ee,X)}}e.IPCLogger=ue}),define(ye[118],Ce([1,0,14,23,3,6,117]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(E){E.enableDiagnostics=!1,E.records=[];const k=new WeakMap;let M=0;function K(F,B){if(!k.has(F)){const O=String(++M);k.set(F,O)}return k.get(F)}function q(F,B,O,U){if(!E.enableDiagnostics)return;const $=K(F,B);if(U instanceof t.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=t.VSBuffer.alloc(U.byteLength);j.set(U),E.records.push({timestamp:Date.now(),id:$,label:B,type:O,buff:j})}else E.records.push({timestamp:Date.now(),id:$,label:B,type:O,data:U})}E.traceSocketEvent=q})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function P(){return L||(L=t.VSBuffer.alloc(0)),L}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(k){this.a.push(k),this.b+=k.byteLength}read(k){return this.c(k,!0)}peek(k){return this.c(k,!1)}c(k,M){if(k===0)return P();if(k>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===k){const B=this.a[0];return M&&(this.a.shift(),this.b-=k),B}if(this.a[0].byteLength>k){const B=this.a[0].slice(0,k);return M&&(this.a[0]=this.a[0].slice(k),this.b-=k),B}const K=t.VSBuffer.alloc(k);let q=0,F=0;for(;k>0;){const B=this.a[F];if(B.byteLength>k){const O=B.slice(0,k);K.set(O,q),q+=k,M&&(this.a[F]=B.slice(k),this.b-=k),k-=k}else K.set(B,q),q+=B.byteLength,M?(this.a.shift(),this.b-=B.byteLength):F++,k-=B.byteLength}return K}}e.ChunkStream=w;var C;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(C||(C={}));function v(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(k,M,K,q){this.type=k,this.id=M,this.ack=K,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(k){super(),this.f=this.B(new T.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=k,this.b=!1,this.c=new w,this.B(this.a.onData(M=>this.acceptChunk(M))),this.lastReadTime=Date.now()}acceptChunk(k){if(!(!k||k.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(k);this.c.byteLength>=this.g.readLen;){const M=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=M.readUInt32BE(9),this.g.messageType=M.readUInt8(0),this.g.id=M.readUInt32BE(1),this.g.ack=M.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,q=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",M),this.f.fire(new h(K,q,F,M)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(k){this.k=null,this.a=!1,this.b=!1,this.c=k,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(k){if(this.a)return;k.writtenTime=Date.now(),this.lastWriteTime=Date.now();const M=t.VSBuffer.alloc(13);M.writeUInt8(k.type,0),M.writeUInt32BE(k.id,1),M.writeUInt32BE(k.ack,5),M.writeUInt32BE(k.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(k.type),id:k.id,ack:k.ack,messageSize:k.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",k.data),this.j(M,k.data)}g(k,M){const K=this.f===0;return this.d.push(k,M),this.f+=k.byteLength+M.byteLength,K}h(){const k=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,k}j(k,M){this.g(k,M)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const k=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:k.byteLength}),this.c.write(k)}}class b extends R.Disposable{constructor(k){super(),this.f=new T.Emitter,this.onMessage=this.f.event,this.g=new T.Emitter,this.onDidDispose=this.g.event,this.a=k,this.b=this.B(new p(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(M=>{M.type===1&&this.f.fire(M.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(k){this.b.write(new h(1,0,0,k))}}e.Protocol=b;class S extends I.IPCClient{static fromSocket(k,M){return new S(new b(k),M)}get onDidDispose(){return this.b.onDidDispose}constructor(k,M,K=null){super(k,M,K),this.b=k}dispose(){super.dispose();const k=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),k.end()}}e.Client=S;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(k){this.b?this.d.length>0?this.d.push(k):this.a.fire(k):this.d.push(k)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class i{constructor(k){this.data=k,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let k=0,M=this.a;for(;M;)M=M.next,k++;return k}peek(){return this.a?this.a.data:null}toArray(){const k=[];let M=0,K=this.a;for(;K;)k[M++]=K.data,K=K.next;return k}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(k){const M=new i(k);if(!this.a){this.a=M,this.b=M;return}this.b.next=M,this.b=M}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const k=Date.now();for(let M=0;M<o.a;M++)this.c[M]=k-1e3*M;setInterval(()=>{for(let M=o.a;M>=1;M--)this.c[M]=this.c[M-1];this.c[0]=Date.now()},1e3)}d(){const k=Date.now(),M=(1+o.a)*1e3;let K=0;for(let q=0;q<o.a;q++)k-this.c[q]<=M&&K++;return 1-K/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;var l;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(l=e.ConnectionHealth||(e.ConnectionHealth={}));function c(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class u{constructor(k){this.connectionHealth=k}}e.ConnectionHealthChangedEvent=u;class r{constructor(k,M){this.roundTripTime=k,this.recentHighRoundTripCount=M}}e.HighRoundTripTimeEvent=r;class n{get unacknowledgedCount(){return this.c-this.d}constructor(k){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=k.loadEstimator??o.getInstance(),this.v=k.measureRoundTripTime??!1,this.w=k.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=k.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.v&&this.r.start(),k.initialChunk&&this.q.acceptChunk(k.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const k=new h(5,0,0,P());this.p.write(k),this.p.flush()}sendPause(){const k=new h(7,0,0,P());this.p.write(k)}sendResume(){const k=new h(8,0,0,P());this.p.write(k)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(k,M){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=k,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(M)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const k=new h(3,0,this.h,P());this.p.write(k);const M=this.b.toArray();for(let K=0,q=M.length;K<q;K++)this.p.write(M[K]);this.G()}acceptDisconnect(){this.z.fire()}E(k){if(k.ack>this.d){this.d=k.ack;do{const M=this.b.peek();if(M&&M.id<=k.ack)this.b.pop();else break}while(!0)}switch(k.type){case 0:break;case 1:{if(k.id>this.g)if(k.id!==this.g+1){const M=Date.now();M-this.m>1e4&&(this.m=M,this.p.write(new h(6,0,0,P())))}else this.g=k.id,this.j=Date.now(),this.F(),this.y.fire(k.data);break}case 2:{this.x.fire(k.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const M=this.b.toArray();for(let K=0,q=M.length;K<q;K++)this.p.write(M[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(k.data);break}case 11:{this.r.handleResponse(k.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(k){const M=++this.c;this.h=this.g;const K=new h(1,M,this.h,k);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(k){const M=new h(2,0,0,k);this.p.write(M)}F(){if(this.g<=this.h||this.k)return;const k=Date.now()-this.j;if(k>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-k+5)}G(){if(this.c<=this.d||this.f||this.a)return;const k=this.b.peek(),M=Date.now()-k.writtenTime,K=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(M>=2e4&&K>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:M,timeSinceLastReceivedSomeData:K});return}const F=Math.max(2e4-M,2e4-K,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const k=new h(3,0,this.h,P());this.p.write(k)}I(){this.h=this.g;const k=new h(9,0,this.h,P());this.p.write(k)}J(k){this.h=this.g;const M=new h(10,0,this.h,k);this.p.write(M)}K(k){this.h=this.g;const M=new h(11,0,this.h,k);this.p.write(M)}}e.PersistentProtocol=n;class d extends R.Disposable{constructor(){super(),this.a=this.B(new T.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new T.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new T.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},k=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const k=++this.h,M=t.VSBuffer.alloc(4);M.writeUInt32BE(k,0),this.a.fire(M)},6e4)}handleResponse(k){if(k.byteLength!==4)return;const M=k.readUInt32BE(0);if(this.g<=0||M!==this.h)return;const K=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=K;const F=this.l,B=this.j.filter(O=>O>=1e3).length;this.l=B>=3?1:0,K>1e3&&this.b.fire(new r(K,B)),F!==this.l&&this.c.fire(this.l)}}}),define(ye[119],Ce([1,0,23,9,3,6,11,12,30,117,118]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(r,n){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,n)}constructor(r,n=""){this.f=!0,this.debugLabel=n,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=d=>{if(this.traceSocketEvent("error",{code:d?.code,message:d?.message}),d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}},this.socket.on("error",this.a),this.b=d=>{this.traceSocketEvent("close",{hadError:d}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const n=d=>{this.traceSocketEvent("read",d),r(a.VSBuffer.wrap(d))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(r){const n=d=>{r({type:0,hadError:d,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(r){const n=()=>{r()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,t.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,t.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=w;var C;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(C||(C={}));var v;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(v||(v={}));class m extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,n){this.socket.traceSocketEvent(r,n)}constructor(r,n,d,E){super(),this.f=this.B(new T.Emitter),this.g=this.B(new T.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:d?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new h(this,n,d,E,this.f,(k,M)=>this.k(k,M))),this.B(this.a.onError(k=>{console.error(k),(0,t.onUnexpectedError)(k),this.g.fire({type:0,hadError:!0,error:k})})),this.b=new L.ChunkStream,this.B(this.socket.onData(k=>this.l(k))),this.B(this.socket.onClose(k=>this.g.fire(k)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let d=2;r.byteLength<126?d+=0:r.byteLength<2**16?d+=2:d+=8;const E=a.VSBuffer.alloc(d);if(n?E.writeUInt8(194,0):E.writeUInt8(130,0),r.byteLength<126)E.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){E.writeUInt8(126,1);let k=1;E.writeUInt8(r.byteLength>>>8&255,++k),E.writeUInt8(r.byteLength>>>0&255,++k)}else{E.writeUInt8(127,1);let k=1;E.writeUInt8(0,++k),E.writeUInt8(0,++k),E.writeUInt8(0,++k),E.writeUInt8(0,++k),E.writeUInt8(r.byteLength>>>24&255,++k),E.writeUInt8(r.byteLength>>>16&255,++k),E.writeUInt8(r.byteLength>>>8&255,++k),E.writeUInt8(r.byteLength>>>0&255,++k)}this.socket.write(a.VSBuffer.concat([E,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),d=n.readUInt8(0),E=(d&128)>>>7,k=(d&64)>>>6,M=n.readUInt8(1),K=(M&128)>>>7,q=M&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(k)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),d=n.readUInt8(1),E=(d&128)>>>7;let k=d&127,M=1;k===126?k=n.readUInt8(++M)*2**8+n.readUInt8(++M):k===127&&(k=n.readUInt8(++M)*0+n.readUInt8(++M)*0+n.readUInt8(++M)*0+n.readUInt8(++M)*0+n.readUInt8(++M)*2**24+n.readUInt8(++M)*2**16+n.readUInt8(++M)*2**8+n.readUInt8(++M));let K=0;E&&(K=n.readUInt8(++M)*2**24+n.readUInt8(++M)*2**16+n.readUInt8(++M)*2**8+n.readUInt8(++M)),this.j.state=3,this.j.readLen=k,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),b(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await T.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class h extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(r,n,d,E,k,M){super(),this.k=r,this.l=k,this.m=M,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new T.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,n?(this.b=this.B(new f(this.k,E,d,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const n=await this.r(this.f,r);this.m(n,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,n){return new Promise((d,E)=>{r.write(n),r.flush(k=>d(k))})}acceptFrame(r,n,d){this.h.push({data:r,isCompressed:n,isLastFrameOfMessage:d}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const n=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(n)}else this.l.fire(r.data)}this.s=!1}}u(r,n,d){return new Promise((E,k)=>{r.write(n),d&&r.write(a.VSBuffer.fromByteArray([0,0,255,255])),r.flush(M=>E(M))})}}class f extends R.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(r,n,d,E){super(),this.h=r,this.j=n,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(E),this.b.on("error",k=>{this.h.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.h.traceSocketEvent("zlibInflateData",k),this.g.push(a.VSBuffer.wrap(k))}),d&&(this.h.traceSocketEvent("zlibInflateInitialWrite",d.buffer),this.b.write(d.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=a.VSBuffer.concat(this.g);this.g.length=0,r(n)})}}class p extends R.Disposable{constructor(r,n){super(),this.g=r,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",d=>{this.g.traceSocketEvent("zlibDeflateError",{message:d?.message,code:d?.code}),this.a.fire(d)}),this.b.on("data",d=>{this.g.traceSocketEvent("zlibDeflateData",d),this.f.push(a.VSBuffer.wrap(d))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=a.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),r(n)})}}function b(u,r){if(r===0)return;const n=u.byteLength>>>2;for(let q=0;q<n;q++){const F=u.readUInt32BE(q*4);u.writeUInt32BE(F^r,q*4)}const d=n*4,E=u.byteLength-d,k=r>>>24&255,M=r>>>16&255,K=r>>>8&255;E>=1&&u.writeUInt8(u.readUInt8(d)^k,d),E>=2&&u.writeUInt8(u.readUInt8(d+1)^M,d+1),E>=3&&u.writeUInt8(u.readUInt8(d+2)^K,d+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function g(){const u=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):r=(0,I.join)(P().os.tmpdir(),`vscode-ipc-${u}.sock`),s(r),r}e.createRandomIPCHandle=g;function i(u,r,n){const d=P().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${n}-${r}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${n}-${r}.sock`):E=(0,I.join)(u,`${n}-${r}.sock`),s(E),E}e.createStaticIPCHandle=i;function s(u){const r=S[A.platform];typeof r=="number"&&u.length>=r&&console.warn(`WARNING: IPC handle "${u}" is longer than ${r} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{static b(r){const n=T.Event.fromNodeEventEmitter(r,"connection");return T.Event.map(n,d=>({protocol:new L.Protocol(new w(d,"ipc-server-connection")),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(d,"close"))}))}constructor(r){super(o.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=o;function l(u){return new Promise((r,n)=>{const d=P().net.createServer();d.on("error",n),d.listen(u,()=>{d.removeListener("error",n),r(new o(d))})})}e.serve=l;function c(u,r){return new Promise((n,d)=>{const E=P().net.createConnection(u,()=>{E.removeListener("error",d),n(L.Client.fromSocket(new w(E,`ipc-client${r}`),r))});E.once("error",d)})}e.connect=c}),define(ye[163],Ce([1,0,39,11]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(R,I,A,y,D,L){if(Array.isArray(R)){let P=0;for(const w of R){const C=T(w,I,A,y,D,L);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:w,scheme:C,hasAccessToAllModels:v,notebookType:m}=R;if(!y&&!v)return 0;m&&D&&(I=D);let h=0;if(C)if(C===I.scheme)h=10;else if(C==="*")h=5;else return 0;if(P)if(P===A)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(m)if(m===L)h=10;else if(m==="*"&&L!==void 0)h=Math.max(h,5);else return 0;if(w){let f;if(typeof w=="string"?f=w:f={...w,base:(0,t.normalize)(w.base)},f===I.fsPath||(0,a.match)(f,I.fsPath))h=10;else return 0}return h}else return 0}}e.score=T}),define(ye[164],Ce([1,0,8,52,154]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,D,L){this.c=A,this.d=y,this.f=D,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const D of y)this.n(D.range),this.o(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,D=new Uint32Array(y);for(let L=0;L<y;L++)D[L]=this.d[L].length+A;this.h=new T.PrefixSumComputer(D)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const D=(0,a.splitLines)(y);if(D.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]+this.d[A.lineNumber-1].substring(A.column-1));return}D[D.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]);const L=new Uint32Array(D.length-1);for(let P=1;P<D.length;P++)this.d.splice(A.lineNumber+P-1,0,D[P]),L[P-1]=D[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[165],Ce([1,0,8,151,52,36,107]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(p,b,S,g){this.searchString=p,this.isRegex=b,this.matchCase=S,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=D(this.searchString):p=this.searchString.indexOf(`
`)>=0;let b=null;try{b=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!b)return null;let S=!this.isRegex&&!p;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new I.SearchData(b,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function D(f){if(!f||f.length===0)return!1;for(let p=0,b=f.length;p<b;p++){const S=f.charCodeAt(p);if(S===10)return!0;if(S===92){if(p++,p>=b)break;const g=f.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=D;function L(f,p,b){if(!b)return new I.FindMatch(f,null);const S=[];for(let g=0,i=p.length;g<i;g++)S[g]=p[g];return new I.FindMatch(f,S)}e.createFindMatch=L;class P{constructor(p){const b=[];let S=0;for(let g=0,i=p.length;g<i;g++)p.charCodeAt(g)===10&&(b[S++]=g);this.a=b}findLineFeedCountBeforeOffset(p){const b=this.a;let S=0,g=b.length-1;if(g===-1||p<=b[0])return 0;for(;S<g;){const i=S+((g-S)/2>>0);b[i]>=p?g=i-1:b[i+1]>=p?(S=i,g=i):S=i+1}return S+1}}class w{static findMatches(p,b,S,g,i){const s=b.parseSearchRequest();return s?s.regex.multiline?this.b(p,S,new h(s.wordSeparators,s.regex),g,i):this.c(p,S,s,g,i):[]}static a(p,b,S,g,i,s){let o,l=0;g?(l=g.findLineFeedCountBeforeOffset(i),o=b+i+l):o=b+i;let c;if(g){const d=g.findLineFeedCountBeforeOffset(i+s.length)-l;c=o+s.length+d}else c=o+s.length;const u=p.getPositionAt(o),r=p.getPositionAt(c);return new R.Range(u.lineNumber,u.column,r.lineNumber,r.column)}static b(p,b,S,g,i){const s=p.getOffsetAt(b.getStartPosition()),o=p.getValueInRange(b,1),l=p.getEOL()===`\r
`?new P(o):null,c=[];let u=0,r;for(S.reset(0);r=S.next(o);)if(c[u++]=L(this.a(p,s,o,l,r.index,r[0]),r,g),u>=i)return c;return c}static c(p,b,S,g,i){const s=[];let o=0;if(b.startLineNumber===b.endLineNumber){const c=p.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return o=this.d(S,c,b.startLineNumber,b.startColumn-1,o,s,g,i),s}const l=p.getLineContent(b.startLineNumber).substring(b.startColumn-1);o=this.d(S,l,b.startLineNumber,b.startColumn-1,o,s,g,i);for(let c=b.startLineNumber+1;c<b.endLineNumber&&o<i;c++)o=this.d(S,p.getLineContent(c),c,0,o,s,g,i);if(o<i){const c=p.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);o=this.d(S,c,b.endLineNumber,0,o,s,g,i)}return s}static d(p,b,S,g,i,s,o,l){const c=p.wordSeparators;if(!o&&p.simpleSearch){const n=p.simpleSearch,d=n.length,E=b.length;let k=-d;for(;(k=b.indexOf(n,k+d))!==-1;)if((!c||m(c,b,E,k,d))&&(s[i++]=new I.FindMatch(new R.Range(S,k+1+g,S,k+1+d+g),null),i>=l))return i;return i}const u=new h(p.wordSeparators,p.regex);let r;u.reset(0);do if(r=u.next(b),r&&(s[i++]=L(new R.Range(S,r.index+1+g,S,r.index+1+r[0].length+g),r,o),i>=l))return i;while(r);return i}static findNextMatch(p,b,S,g){const i=b.parseSearchRequest();if(!i)return null;const s=new h(i.wordSeparators,i.regex);return i.regex.multiline?this.e(p,S,s,g):this.f(p,S,s,g)}static e(p,b,S,g){const i=new T.Position(b.lineNumber,1),s=p.getOffsetAt(i),o=p.getLineCount(),l=p.getValueInRange(new R.Range(i.lineNumber,i.column,o,p.getLineMaxColumn(o)),1),c=p.getEOL()===`\r
`?new P(l):null;S.reset(b.column-1);const u=S.next(l);return u?L(this.a(p,s,l,c,u.index,u[0]),u,g):b.lineNumber!==1||b.column!==1?this.e(p,new T.Position(1,1),S,g):null}static f(p,b,S,g){const i=p.getLineCount(),s=b.lineNumber,o=p.getLineContent(s),l=this.g(S,o,s,b.column,g);if(l)return l;for(let c=1;c<=i;c++){const u=(s+c-1)%i,r=p.getLineContent(u+1),n=this.g(S,r,u+1,1,g);if(n)return n}return null}static g(p,b,S,g,i){p.reset(g-1);const s=p.next(b);return s?L(new R.Range(S,s.index+1,S,s.index+1+s[0].length),s,i):null}static findPreviousMatch(p,b,S,g){const i=b.parseSearchRequest();if(!i)return null;const s=new h(i.wordSeparators,i.regex);return i.regex.multiline?this.h(p,S,s,g):this.j(p,S,s,g)}static h(p,b,S,g){const i=this.b(p,new R.Range(1,1,b.lineNumber,b.column),S,g,10*A);if(i.length>0)return i[i.length-1];const s=p.getLineCount();return b.lineNumber!==s||b.column!==p.getLineMaxColumn(s)?this.h(p,new T.Position(s,p.getLineMaxColumn(s)),S,g):null}static j(p,b,S,g){const i=p.getLineCount(),s=b.lineNumber,o=p.getLineContent(s).substring(0,b.column-1),l=this.k(S,o,s,g);if(l)return l;for(let c=1;c<=i;c++){const u=(i+s-c-1)%i,r=p.getLineContent(u+1),n=this.k(S,r,u+1,g);if(n)return n}return null}static k(p,b,S,g){let i=null,s;for(p.reset(0);s=p.next(b);)i=L(new R.Range(S,s.index+1,S,s.index+1+s[0].length),s,g);return i}}e.TextModelSearch=w;function C(f,p,b,S,g){if(S===0)return!0;const i=p.charCodeAt(S-1);if(f.get(i)!==0||i===13||i===10)return!0;if(g>0){const s=p.charCodeAt(S);if(f.get(s)!==0)return!0}return!1}function v(f,p,b,S,g){if(S+g===b)return!0;const i=p.charCodeAt(S+g);if(f.get(i)!==0||i===13||i===10)return!0;if(g>0){const s=p.charCodeAt(S+g-1);if(f.get(s)!==0)return!0}return!1}function m(f,p,b,S,g){return C(f,p,b,S,g)&&v(f,p,b,S,g)}e.isValidMatch=m;class h{constructor(p,b){this._wordSeparators=p,this.a=b,this.b=-1,this.c=0}reset(p){this.a.lastIndex=p,this.b=-1,this.c=0}next(p){const b=p.length;let S;do{if(this.b+this.c===b||(S=this.a.exec(p),!S))return null;const g=S.index,i=S[0].length;if(g===this.b&&i===this.c){if(i===0){a.getNextCodePoint(p,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=i,!this._wordSeparators||m(this._wordSeparators,p,b,g,i))return S}while(S);return null}}e.Searcher=h}),define(ye[120],Ce([1,0,23,12]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(T||(T={}));function R(P){for(let w=0,C=P.length;w<C;w+=4){const v=P[w+0],m=P[w+1],h=P[w+2],f=P[w+3];P[w+0]=f,P[w+1]=h,P[w+2]=m,P[w+3]=v}}function I(P){const w=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||R(w),a.VSBuffer.wrap(w)}function A(P){const w=P.buffer;if(t.isLittleEndian()||R(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const C=new Uint8Array(w.byteLength);return C.set(w),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function y(P){const w=new Uint32Array(D(P));let C=0;if(w[C++]=P.id,P.type==="full")w[C++]=1,w[C++]=P.data.length,w.set(P.data,C),C+=P.data.length;else{w[C++]=2,w[C++]=P.deltas.length;for(const v of P.deltas)w[C++]=v.start,w[C++]=v.deleteCount,v.data?(w[C++]=v.data.length,w.set(v.data,C),C+=v.data.length):w[C++]=0}return I(w)}e.encodeSemanticTokensDto=y;function D(P){let w=0;if(w+=1+1,P.type==="full")w+=1+P.data.length;else{w+=1,w+=(1+1+1)*P.deltas.length;for(const C of P.deltas)C.data&&(w+=C.data.length)}return w}function L(P){const w=A(P);let C=0;const v=w[C++];if(w[C++]===1){const p=w[C++],b=w.subarray(C,C+p);return C+=p,{id:v,type:"full",data:b}}const h=w[C++],f=[];for(let p=0;p<h;p++){const b=w[C++],S=w[C++],g=w[C++];let i;g>0&&(i=w.subarray(C,C+g),C+=g),f[p]={start:b,deleteCount:S,data:i}}return{id:v,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(ye[166],Ce([1,0,3,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const D=new R(this,A,y);return this.b.set(A,D),(0,t.toDisposable)(()=>{const L=this.b.get(A);!L||L!==D||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const D=this.b.get(A);return!D||D.isResolved?null:(await D.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const D=this.b.get(A);return!!(!D||D.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=T;class R extends t.Disposable{get isResolved(){return this.c}constructor(A,y,D){super(),this.f=A,this.g=y,this.h=D,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[68],Ce([1,0,50,2,36,166]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class I{constructor(d,E,k){this._tokenBrand=void 0,this.offset=d,this.type=E,this.language=k}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=I;class A{constructor(d,E){this._tokenizationResultBrand=void 0,this.tokens=d,this.endState=E}}e.TokenizationResult=A;class y{constructor(d,E){this._encodedTokenizationResultBrand=void 0,this.tokens=d,this.endState=E}}e.EncodedTokenizationResult=y;var D;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(n){const d=new Map;d.set(0,a.Codicon.symbolMethod),d.set(1,a.Codicon.symbolFunction),d.set(2,a.Codicon.symbolConstructor),d.set(3,a.Codicon.symbolField),d.set(4,a.Codicon.symbolVariable),d.set(5,a.Codicon.symbolClass),d.set(6,a.Codicon.symbolStruct),d.set(7,a.Codicon.symbolInterface),d.set(8,a.Codicon.symbolModule),d.set(9,a.Codicon.symbolProperty),d.set(10,a.Codicon.symbolEvent),d.set(11,a.Codicon.symbolOperator),d.set(12,a.Codicon.symbolUnit),d.set(13,a.Codicon.symbolValue),d.set(15,a.Codicon.symbolEnum),d.set(14,a.Codicon.symbolConstant),d.set(15,a.Codicon.symbolEnum),d.set(16,a.Codicon.symbolEnumMember),d.set(17,a.Codicon.symbolKeyword),d.set(27,a.Codicon.symbolSnippet),d.set(18,a.Codicon.symbolText),d.set(19,a.Codicon.symbolColor),d.set(20,a.Codicon.symbolFile),d.set(21,a.Codicon.symbolReference),d.set(22,a.Codicon.symbolCustomColor),d.set(23,a.Codicon.symbolFolder),d.set(24,a.Codicon.symbolTypeParameter),d.set(25,a.Codicon.account),d.set(26,a.Codicon.issues);function E(K){let q=d.get(K);return q||(console.info("No codicon found for CompletionItemKind "+K),q=a.Codicon.symbolProperty),q}n.toIcon=E;const k=new Map;k.set("method",0),k.set("function",1),k.set("constructor",2),k.set("field",3),k.set("variable",4),k.set("class",5),k.set("struct",6),k.set("interface",7),k.set("module",8),k.set("property",9),k.set("event",10),k.set("operator",11),k.set("unit",12),k.set("value",13),k.set("constant",14),k.set("enum",15),k.set("enum-member",16),k.set("enumMember",16),k.set("keyword",17),k.set("snippet",27),k.set("text",18),k.set("color",19),k.set("file",20),k.set("reference",21),k.set("customcolor",22),k.set("folder",23),k.set("type-parameter",24),k.set("typeParameter",24),k.set("account",25),k.set("issue",26);function M(K,q){let F=k.get(K);return typeof F>"u"&&!q&&(F=9),F}n.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(n){n[n.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(n){return n&&t.URI.isUri(n.uri)&&T.Range.isIRange(n.range)&&(T.Range.isIRange(n.originSelectionRange)||T.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=p;var b;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var S;(function(n){n[n.Deprecated=1]="Deprecated"})(S=e.SymbolTag||(e.SymbolTag={}));var g;(function(n){const d=new Map;d.set(0,a.Codicon.symbolFile),d.set(1,a.Codicon.symbolModule),d.set(2,a.Codicon.symbolNamespace),d.set(3,a.Codicon.symbolPackage),d.set(4,a.Codicon.symbolClass),d.set(5,a.Codicon.symbolMethod),d.set(6,a.Codicon.symbolProperty),d.set(7,a.Codicon.symbolField),d.set(8,a.Codicon.symbolConstructor),d.set(9,a.Codicon.symbolEnum),d.set(10,a.Codicon.symbolInterface),d.set(11,a.Codicon.symbolFunction),d.set(12,a.Codicon.symbolVariable),d.set(13,a.Codicon.symbolConstant),d.set(14,a.Codicon.symbolString),d.set(15,a.Codicon.symbolNumber),d.set(16,a.Codicon.symbolBoolean),d.set(17,a.Codicon.symbolArray),d.set(18,a.Codicon.symbolObject),d.set(19,a.Codicon.symbolKey),d.set(20,a.Codicon.symbolNull),d.set(21,a.Codicon.symbolEnumMember),d.set(22,a.Codicon.symbolStruct),d.set(23,a.Codicon.symbolEvent),d.set(24,a.Codicon.symbolOperator),d.set(25,a.Codicon.symbolTypeParameter);function E(k){let M=d.get(k);return M||(console.info("No codicon found for SymbolKind "+k),M=a.Codicon.symbolProperty),M}n.toIcon=E})(g=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(d){this.value=d}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(n){function d(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}n.is=d})(s=e.Command||(e.Command={}));var o;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var c;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var u;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var r;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(r=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[167],Ce([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],Ce([1,0,167,12,106,16,22,150]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(z){this.c=z}hasChanged(z){return this.c[z]}}e.ConfigurationChangedEvent=D;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor(z,le,Ie,Le){this.id=z,this.name=le,this.defaultValue=Ie,this.schema=Le}applyUpdate(z,le){return C(z,le)}compute(z,le,Ie){return Ie}}class w{constructor(z,le){this.newValue=z,this.didChange=le}}e.ApplyUpdateResult=w;function C(ae,z){if(typeof ae!="object"||typeof z!="object"||!ae||!z)return new w(z,ae!==z);if(Array.isArray(ae)||Array.isArray(z)){const Ie=Array.isArray(ae)&&Array.isArray(z)&&R.equals(ae,z);return new w(z,!Ie)}let le=!1;for(const Ie in z)if(z.hasOwnProperty(Ie)){const Le=C(ae[Ie],z[Ie]);Le.didChange&&(ae[Ie]=Le.newValue,le=!0)}return new w(ae,le)}class v{constructor(z){this.schema=void 0,this.id=z,this.name="_never_",this.defaultValue=void 0}applyUpdate(z,le){return C(z,le)}validate(z){return this.defaultValue}}class m{constructor(z,le,Ie,Le){this.id=z,this.name=le,this.defaultValue=Ie,this.schema=Le}applyUpdate(z,le){return C(z,le)}validate(z){return typeof z>"u"?this.defaultValue:z}compute(z,le,Ie){return Ie}}function h(ae,z){return typeof ae>"u"?z:ae==="false"?!1:Boolean(ae)}e.boolean=h;class f extends m{constructor(z,le,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super(z,le,Ie,Le)}validate(z){return h(z,this.defaultValue)}}function p(ae,z,le,Ie){if(typeof ae>"u")return z;let Le=parseInt(ae,10);return isNaN(Le)?z:(Le=Math.max(le,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=p;class b extends m{static clampedInt(z,le,Ie,Le){return p(z,le,Ie,Le)}constructor(z,le,Ie,Le,Be,Xe=void 0){typeof Xe<"u"&&(Xe.type="integer",Xe.default=Ie,Xe.minimum=Le,Xe.maximum=Be),super(z,le,Ie,Xe),this.minimum=Le,this.maximum=Be}validate(z){return b.clampedInt(z,this.defaultValue,this.minimum,this.maximum)}}class S extends m{static clamp(z,le,Ie){return z<le?le:z>Ie?Ie:z}static float(z,le){if(typeof z=="number")return z;if(typeof z>"u")return le;const Ie=parseFloat(z);return isNaN(Ie)?le:Ie}constructor(z,le,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super(z,le,Ie,Be),this.validationFn=Le}validate(z){return this.validationFn(S.float(z,this.defaultValue))}}class g extends m{static string(z,le){return typeof z!="string"?le:z}constructor(z,le,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super(z,le,Ie,Le)}validate(z){return g.string(z,this.defaultValue)}}function i(ae,z,le){return typeof ae!="string"||le.indexOf(ae)===-1?z:ae}e.stringSet=i;class s extends m{constructor(z,le,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super(z,le,Ie,Be),this.c=Le}validate(z){return i(z,this.defaultValue,this.c)}}class o extends P{constructor(z,le,Ie,Le,Be,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super(z,le,Ie,Ze),this.c=Be,this.d=Xe}validate(z){return typeof z!="string"?this.defaultValue:this.c.indexOf(z)===-1?this.defaultValue:this.d(z)}}function l(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(z){switch(z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(z,le,Ie){return Ie===0?z.accessibilitySupport:Ie}}class u extends P{constructor(){const z={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",z,{"editor.comments.insertSpace":{type:"boolean",default:z.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:z.ignoreEmptyLines,description:a.localize(5,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{insertSpace:h(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(ae){switch(ae){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function k(ae){switch(ae){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class M extends v{constructor(){super(135)}compute(z,le,Ie){const Le=["monaco-editor"];return le.get(36)&&Le.push(le.get(36)),z.extraEditorClassName&&Le.push(z.extraEditorClassName),le.get(70)==="default"?Le.push("mouse-default"):le.get(70)==="copy"&&Le.push("mouse-copy"),le.get(105)&&Le.push("showUnused"),le.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class K extends f{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(z,le,Ie){return Ie&&z.emptySelectionClipboard}}class q extends P{constructor(){const z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",z,{"editor.find.cursorMoveOnType":{type:"boolean",default:z.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:z.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:z.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:z.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:z.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:z.loop,description:a.localize(18,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{cursorMoveOnType:h(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof z.seedSearchStringFromSelection=="boolean"?z.seedSearchStringFromSelection?"always":"never":i(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof z.autoFindInSelection=="boolean"?z.autoFindInSelection?"always":"never":i(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(le.loop,this.defaultValue.loop)}}}class F extends P{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(z){return typeof z>"u"?this.defaultValue:typeof z=="string"?z==="false"?F.OFF:z==="true"?F.ON:z:Boolean(z)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class B extends P{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(z){return typeof z>"u"?this.defaultValue:typeof z=="string"?z==="false"?B.OFF:z==="true"?B.TRANSLATE:z:Boolean(z)?B.TRANSLATE:B.OFF}compute(z,le,Ie){return z.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class O extends v{constructor(){super(47)}compute(z,le,Ie){return z.fontInfo}}class U extends m{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(z){const le=S.float(z,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(le,6,100)}compute(z,le,Ie){return z.fontInfo.fontSize}}class $ extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.d,maximum:$.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(z){return z==="normal"||z==="bold"?z:String(b.clampedInt(z,e.EDITOR_FONT_DEFAULTS.fontWeight,$.d,$.e))}}$.c=["normal","bold","100","200","300","400","500","600","700","800","900"],$.d=1,$.e=1e3;class j extends P{constructor(){const z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:z.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",z,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...le},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...le},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...le},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:z.alternativeDefinitionCommand,enum:Ie,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:z.alternativeTypeDefinitionCommand,enum:Ie,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:z.alternativeDeclarationCommand,enum:Ie,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:z.alternativeImplementationCommand,enum:Ie,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:z.alternativeReferenceCommand,enum:Ie,description:a.localize(41,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{multiple:i(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??i(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??i(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??i(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??i(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??i(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ue extends P{constructor(){const z={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",z,{"editor.hover.enabled":{type:"boolean",default:z.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:z.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:z.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:z.above,description:a.localize(45,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{enabled:h(le.enabled,this.defaultValue.enabled),delay:b.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:h(le.sticky,this.defaultValue.sticky),above:h(le.above,this.defaultValue.above)}}}var V;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class _ extends v{constructor(){super(138)}compute(z,le,Ie){return _.computeLayout(le,{memory:z.memory,outerWidth:z.outerWidth,outerHeight:z.outerHeight,isDominatedByLongLines:z.isDominatedByLongLines,lineHeight:z.fontInfo.lineHeight,viewLineCount:z.viewLineCount,lineNumbersDigitCount:z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:z.fontInfo.maxDigitWidth,pixelRatio:z.pixelRatio})}static computeContainedMinimapLineCount(z){const le=z.height/z.lineHeight,Ie=Math.floor(z.paddingTop/z.lineHeight);let Le=Math.floor(z.paddingBottom/z.lineHeight);z.scrollBeyondLastLine&&(Le=Math.max(Le,le-1));const Be=(Ie+z.viewLineCount+Le)/(z.pixelRatio*z.height),Xe=Math.floor(z.viewLineCount/Be);return{typicalViewportLineCount:le,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:Xe}}static c(z,le){const Ie=z.outerWidth,Le=z.outerHeight,Be=z.pixelRatio;if(!z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Xe=le.stableMinimapLayoutInput,Ze=Xe&&z.outerHeight===Xe.outerHeight&&z.lineHeight===Xe.lineHeight&&z.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&z.pixelRatio===Xe.pixelRatio&&z.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&z.paddingTop===Xe.paddingTop&&z.paddingBottom===Xe.paddingBottom&&z.minimap.enabled===Xe.minimap.enabled&&z.minimap.side===Xe.minimap.side&&z.minimap.size===Xe.minimap.size&&z.minimap.showSlider===Xe.minimap.showSlider&&z.minimap.renderCharacters===Xe.minimap.renderCharacters&&z.minimap.maxColumn===Xe.minimap.maxColumn&&z.minimap.scale===Xe.minimap.scale&&z.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&z.isViewportWrapping===Xe.isViewportWrapping,gt=z.lineHeight,mt=z.typicalHalfwidthCharacterWidth,lt=z.scrollBeyondLastLine,ot=z.minimap.renderCharacters;let rt=Be>=2?Math.round(z.minimap.scale*2):z.minimap.scale;const kt=z.minimap.maxColumn,Tt=z.minimap.size,Nt=z.minimap.side,pt=z.verticalScrollbarWidth,Dt=z.viewLineCount,zt=z.remainingWidth,Ft=z.isViewportWrapping,xe=ot?2:3;let Mt=Math.floor(Be*Le);const Ut=Mt/Be;let Bt=!1,wt=!1,Pt=xe*rt,Re=rt/Be,Oe=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:Et,desiredRatio:Lt,minimapLineCount:vt}=_.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,paddingTop:z.paddingTop,paddingBottom:z.paddingBottom,height:Le,lineHeight:gt,pixelRatio:Be});if(Dt/vt>1)Bt=!0,wt=!0,rt=1,Pt=1,Re=rt/Be;else{let ft=!1,Gt=rt+1;if(Tt==="fit"){const jt=Math.ceil((St+Dt+Et)*Pt);Ft&&Ze&&zt<=le.stableFitRemainingWidth?(ft=!0,Gt=le.stableFitMaxMinimapScale):ft=jt>Mt}if(Tt==="fill"||ft){Bt=!0;const jt=rt;Pt=Math.min(gt*Be,Math.max(1,Math.floor(1/Lt))),Ft&&Ze&&zt<=le.stableFitRemainingWidth&&(Gt=le.stableFitMaxMinimapScale),rt=Math.min(Gt,Math.max(1,Math.floor(Pt/xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Re=rt/Be/Oe,Mt=Math.ceil(Math.max(tt,St+Dt+Et)*Pt),Ft?(le.stableMinimapLayoutInput=z,le.stableFitRemainingWidth=zt,le.stableFitMaxMinimapScale=rt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const Se=Math.floor(kt*Re),re=Math.min(Se,Math.max(0,Math.floor((zt-pt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*re);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const _e=ot?1:2,Ve=Nt==="left"?0:Ie-re-pt;return{renderMinimap:_e,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Bt,minimapIsSampling:wt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout(z,le){const Ie=le.outerWidth|0,Le=le.outerHeight|0,Be=le.lineHeight|0,Xe=le.lineNumbersDigitCount|0,Ze=le.typicalHalfwidthCharacterWidth,gt=le.maxDigitWidth,mt=le.pixelRatio,lt=le.viewLineCount,ot=z.get(130),rt=ot==="inherit"?z.get(129):ot,kt=rt==="inherit"?z.get(125):rt,Tt=z.get(128),Nt=le.isDominatedByLongLines,pt=z.get(54),Dt=z.get(64).renderType!==0,zt=z.get(65),Ft=z.get(99),xe=z.get(80),Mt=z.get(69),Ut=z.get(97),Bt=Ut.verticalScrollbarSize,wt=Ut.verticalHasArrows,Pt=Ut.arrowSize,Re=Ut.horizontalScrollbarSize,Oe=z.get(40),Se=z.get(104)!=="never";let re=z.get(62);Oe&&Se&&(re+=16);let Ne=0;if(Dt){const Qt=Math.max(Xe,zt);Ne=Math.round(Qt*gt)}let $e=0;pt&&($e=Be);let _e=0,Ve=_e+$e,tt=Ve+Ne,St=tt+re;const Et=Ie-$e-Ne-re;let Lt=!1,vt=!1,It=-1;rt==="inherit"&&Nt?(Lt=!0,vt=!0):kt==="on"||kt==="bounded"?vt=!0:kt==="wordWrapColumn"&&(It=Tt);const ft=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ft,paddingTop:xe.top,paddingBottom:xe.bottom,minimap:Mt,verticalScrollbarWidth:Bt,viewLineCount:lt,remainingWidth:Et,isViewportWrapping:vt},le.memory||new L);ft.renderMinimap!==0&&ft.minimapLeft===0&&(_e+=ft.minimapWidth,Ve+=ft.minimapWidth,tt+=ft.minimapWidth,St+=ft.minimapWidth);const Gt=Et-ft.minimapWidth,jt=Math.max(1,Math.floor((Gt-Bt-2)/Ze)),yt=wt?Pt:0;return vt&&(It=Math.max(1,jt),kt==="bounded"&&(It=Math.min(It,Tt))),{width:Ie,height:Le,glyphMarginLeft:_e,glyphMarginWidth:$e,lineNumbersLeft:Ve,lineNumbersWidth:Ne,decorationsLeft:tt,decorationsWidth:re,contentLeft:St,contentWidth:Gt,minimap:ft,viewportColumn:jt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:It,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Re,overviewRuler:{top:yt,width:Bt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=_;class Y extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(z){return i(z,"simple",["simple","advanced"])}compute(z,le,Ie){return le.get(2)===2?"advanced":Ie}}class ne extends P{constructor(){const z={enabled:!0};super(61,"lightbulb",z,{"editor.lightbulb.enabled":{type:"boolean",default:z.enabled,description:a.localize(49,null)}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{enabled:h(z.enabled,this.defaultValue.enabled)}}}class ee extends P{constructor(){const z={enabled:!1,maxLineCount:5};super(109,"stickyScroll",z,{"editor.stickyScroll.enabled":{type:"boolean",default:z.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:z.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{enabled:h(le.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(le.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends P{constructor(){const z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",z,{"editor.inlayHints.enabled":{type:"string",default:z.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:z.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:z.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:z.padding,description:a.localize(59,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return typeof le.enabled=="boolean"&&(le.enabled=le.enabled?"on":"off"),{enabled:i(le.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(le.fontFamily,this.defaultValue.fontFamily),padding:h(le.padding,this.defaultValue.padding)}}}class G extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate(z){return typeof z=="string"&&/^\d+(\.\d+)?ch$/.test(z)?-parseFloat(z.substring(0,z.length-2)):b.clampedInt(z,this.defaultValue,0,1e3)}compute(z,le,Ie){return Ie<0?b.clampedInt(-Ie*z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class de extends S{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,z=>S.clamp(z,0,150),{markdownDescription:a.localize(60,null)})}compute(z,le,Ie){return z.fontInfo.lineHeight}}class be extends P{constructor(){const z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",z,{"editor.minimap.enabled":{type:"boolean",default:z.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:z.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:z.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:z.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:z.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:z.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:z.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:z.maxColumn,description:a.localize(71,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{enabled:h(le.enabled,this.defaultValue.enabled),autohide:h(le.autohide,this.defaultValue.autohide),size:i(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(le.side,this.defaultValue.side,["right","left"]),showSlider:i(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(le.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(le.scale,1,1,3),maxColumn:b.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(ae){return ae==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Pe extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{top:b.clampedInt(le.top,0,0,1e3),bottom:b.clampedInt(le.bottom,0,0,1e3)}}}class Fe extends P{constructor(){const z={enabled:!0,cycle:!0};super(81,"parameterHints",z,{"editor.parameterHints.enabled":{type:"boolean",default:z.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:z.cycle,description:a.localize(75,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{enabled:h(le.enabled,this.defaultValue.enabled),cycle:h(le.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(136)}compute(z,le,Ie){return z.pixelRatio}}class oe extends P{constructor(){const z={other:"on",comments:"off",strings:"off"},le=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:le,default:z.strings,description:a.localize(79,null)},comments:{anyOf:le,default:z.comments,description:a.localize(80,null)},other:{anyOf:le,default:z.other,description:a.localize(81,null)}},default:z,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=z}validate(z){if(typeof z=="boolean"){const mt=z?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!z||typeof z!="object")return this.defaultValue;const{other:le,comments:Ie,strings:Le}=z,Be=["on","inline","off"];let Xe,Ze,gt;return typeof le=="boolean"?Xe=le?"on":"off":Xe=i(le,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?gt=Le?"on":"off":gt=i(Le,this.defaultValue.strings,Be),{other:Xe,comments:Ze,strings:gt}}}var fe;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(z){let le=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof z<"u"&&(typeof z=="function"?(le=4,Ie=z):z==="interval"?le=3:z==="relative"?le=2:z==="on"?le=1:le=0),{renderType:le,renderFn:Ie}}}function ce(ae){const z=ae.get(92);return z==="editable"?ae.get(86):z!=="on"}e.filterValidationDecorations=ce;class ie extends P{constructor(){const z=[],le={type:"number",description:a.localize(88,null)};super(96,"rulers",z,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:z,description:a.localize(90,null)})}validate(z){if(Array.isArray(z)){const le=[];for(const Ie of z)if(typeof Ie=="number")le.push({column:b.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;le.push({column:b.clampedInt(Le.column,0,0,1e4),color:Le.color})}return le.sort((Ie,Le)=>Ie.column-Le.column),le}return this.defaultValue}}function N(ae,z){if(typeof ae!="string")return z;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends P{constructor(){const z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:z.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:z.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:z.scrollByPage,description:a.localize(101,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z,Ie=b.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=b.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(le.vertical,this.defaultValue.vertical),horizontal:N(le.horizontal,this.defaultValue.horizontal),useShadows:h(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:b.clampedInt(le.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:b.clampedInt(le.verticalSliderSize,Le,0,1e3),scrollByPage:h(le.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends P{constructor(){const z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:z.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:z.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:z.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:z.allowedLocales,description:a.localize(108,null)}})}applyUpdate(z,le){let Ie=!1;le.allowedCharacters&&z&&(I.equals(z.allowedCharacters,le.allowedCharacters)||(z={...z,allowedCharacters:le.allowedCharacters},Ie=!0)),le.allowedLocales&&z&&(I.equals(z.allowedLocales,le.allowedLocales)||(z={...z,allowedLocales:le.allowedLocales},Ie=!0));const Le=super.applyUpdate(z,le);return Ie?new w(Le.newValue,!0):Le}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{nonBasicASCII:Ae(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(z.allowedLocales,this.defaultValue.allowedLocales)}}c(z,le){if(typeof z!="object"||!z)return le;const Ie={};for(const[Le,Be]of Object.entries(z))Be===!0&&(Ie[Le]=!0);return Ie}}class J extends P{constructor(){const z={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",z,{"editor.inlineSuggest.enabled":{type:"boolean",default:z.enabled,description:a.localize(109,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{enabled:h(le.enabled,this.defaultValue.enabled),mode:i(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class he extends P{constructor(){const z={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:z.enabled,markdownDescription:a.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:z.independentColorPoolPerBracketType,description:a.localize(111,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{enabled:h(le.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(le.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends P{constructor(){const z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(112,null),a.localize(113,null),a.localize(114,null)],default:z.bracketPairs,description:a.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(116,null),a.localize(117,null),a.localize(118,null)],default:z.bracketPairsHorizontal,description:a.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:z.highlightActiveBracketPair,description:a.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:z.indentation,description:a.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(122,null),a.localize(123,null),a.localize(124,null)],default:z.highlightActiveIndentation,description:a.localize(125,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{bracketPairs:Ae(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ae,z,le){const Ie=le.indexOf(ae);return Ie===-1?z:le[Ie]}class pe extends P{constructor(){const z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(126,null),a.localize(127,null)],default:z.insertMode,description:a.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:z.filterGraceful,description:a.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:z.localityBonus,description:a.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:z.shareSuggestSelections,markdownDescription:a.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(132,null),a.localize(133,null),a.localize(134,null),a.localize(135,null)],default:z.selectionMode,markdownDescription:a.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:z.snippetsPreventQuickSuggestions,description:a.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:z.showIcons,description:a.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:z.showStatusBar,description:a.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:z.preview,description:a.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:z.showInlineDetails,description:a.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const le=z;return{insertMode:i(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(le.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(le.showIcons,this.defaultValue.showIcons),showStatusBar:h(le.showStatusBar,this.defaultValue.showStatusBar),preview:h(le.preview,this.defaultValue.preview),previewMode:i(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(le.showMethods,this.defaultValue.showMethods),showFunctions:h(le.showFunctions,this.defaultValue.showFunctions),showConstructors:h(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(le.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(le.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(le.showFields,this.defaultValue.showFields),showVariables:h(le.showVariables,this.defaultValue.showVariables),showClasses:h(le.showClasses,this.defaultValue.showClasses),showStructs:h(le.showStructs,this.defaultValue.showStructs),showInterfaces:h(le.showInterfaces,this.defaultValue.showInterfaces),showModules:h(le.showModules,this.defaultValue.showModules),showProperties:h(le.showProperties,this.defaultValue.showProperties),showEvents:h(le.showEvents,this.defaultValue.showEvents),showOperators:h(le.showOperators,this.defaultValue.showOperators),showUnits:h(le.showUnits,this.defaultValue.showUnits),showValues:h(le.showValues,this.defaultValue.showValues),showConstants:h(le.showConstants,this.defaultValue.showConstants),showEnums:h(le.showEnums,this.defaultValue.showEnums),showEnumMembers:h(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(le.showKeywords,this.defaultValue.showKeywords),showWords:h(le.showWords,this.defaultValue.showWords),showColors:h(le.showColors,this.defaultValue.showColors),showFiles:h(le.showFiles,this.defaultValue.showFiles),showReferences:h(le.showReferences,this.defaultValue.showReferences),showFolders:h(le.showFolders,this.defaultValue.showFolders),showTypeParameters:h(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(le.showSnippets,this.defaultValue.showSnippets),showUsers:h(le.showUsers,this.defaultValue.showUsers),showIssues:h(le.showIssues,this.defaultValue.showIssues)}}}class De extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(174,null),default:!0,type:"boolean"}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(137)}compute(z,le,Ie){return le.get(86)?!0:z.tabFocusMode}}var je;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(175,null),a.localize(176,null),a.localize(177,null),a.localize(178,null)],description:a.localize(179,null),default:"same"}})}validate(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(z,le,Ie){return le.get(2)===2?0:Ie}}class et extends v{constructor(){super(139)}compute(z,le,Ie){const Le=le.get(138);return{isDominatedByLongLines:z.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends P{constructor(){const z={enabled:!0};super(33,"dropIntoEditor",z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:z.enabled,markdownDescription:a.localize(180,null)}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{enabled:h(z.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var it;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.autoClosingBrackets=5]="autoClosingBrackets",ae[ae.autoClosingDelete=6]="autoClosingDelete",ae[ae.autoClosingOvertype=7]="autoClosingOvertype",ae[ae.autoClosingQuotes=8]="autoClosingQuotes",ae[ae.autoIndent=9]="autoIndent",ae[ae.automaticLayout=10]="automaticLayout",ae[ae.autoSurround=11]="autoSurround",ae[ae.bracketPairColorization=12]="bracketPairColorization",ae[ae.guides=13]="guides",ae[ae.codeLens=14]="codeLens",ae[ae.codeLensFontFamily=15]="codeLensFontFamily",ae[ae.codeLensFontSize=16]="codeLensFontSize",ae[ae.colorDecorators=17]="colorDecorators",ae[ae.colorDecoratorsLimit=18]="colorDecoratorsLimit",ae[ae.columnSelection=19]="columnSelection",ae[ae.comments=20]="comments",ae[ae.contextmenu=21]="contextmenu",ae[ae.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=23]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=25]="cursorStyle",ae[ae.cursorSurroundingLines=26]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=28]="cursorWidth",ae[ae.disableLayerHinting=29]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ae[ae.domReadOnly=31]="domReadOnly",ae[ae.dragAndDrop=32]="dragAndDrop",ae[ae.dropIntoEditor=33]="dropIntoEditor",ae[ae.emptySelectionClipboard=34]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=36]="extraEditorClassName",ae[ae.fastScrollSensitivity=37]="fastScrollSensitivity",ae[ae.find=38]="find",ae[ae.fixedOverflowWidgets=39]="fixedOverflowWidgets",ae[ae.folding=40]="folding",ae[ae.foldingStrategy=41]="foldingStrategy",ae[ae.foldingHighlight=42]="foldingHighlight",ae[ae.foldingImportsByDefault=43]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=44]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=46]="fontFamily",ae[ae.fontInfo=47]="fontInfo",ae[ae.fontLigatures=48]="fontLigatures",ae[ae.fontSize=49]="fontSize",ae[ae.fontWeight=50]="fontWeight",ae[ae.fontVariations=51]="fontVariations",ae[ae.formatOnPaste=52]="formatOnPaste",ae[ae.formatOnType=53]="formatOnType",ae[ae.glyphMargin=54]="glyphMargin",ae[ae.gotoLocation=55]="gotoLocation",ae[ae.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ae[ae.hover=57]="hover",ae[ae.inDiffEditor=58]="inDiffEditor",ae[ae.inlineSuggest=59]="inlineSuggest",ae[ae.letterSpacing=60]="letterSpacing",ae[ae.lightbulb=61]="lightbulb",ae[ae.lineDecorationsWidth=62]="lineDecorationsWidth",ae[ae.lineHeight=63]="lineHeight",ae[ae.lineNumbers=64]="lineNumbers",ae[ae.lineNumbersMinChars=65]="lineNumbersMinChars",ae[ae.linkedEditing=66]="linkedEditing",ae[ae.links=67]="links",ae[ae.matchBrackets=68]="matchBrackets",ae[ae.minimap=69]="minimap",ae[ae.mouseStyle=70]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=72]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=74]="multiCursorModifier",ae[ae.multiCursorPaste=75]="multiCursorPaste",ae[ae.multiCursorLimit=76]="multiCursorLimit",ae[ae.occurrencesHighlight=77]="occurrencesHighlight",ae[ae.overviewRulerBorder=78]="overviewRulerBorder",ae[ae.overviewRulerLanes=79]="overviewRulerLanes",ae[ae.padding=80]="padding",ae[ae.parameterHints=81]="parameterHints",ae[ae.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=84]="quickSuggestions",ae[ae.quickSuggestionsDelay=85]="quickSuggestionsDelay",ae[ae.readOnly=86]="readOnly",ae[ae.renameOnType=87]="renameOnType",ae[ae.renderControlCharacters=88]="renderControlCharacters",ae[ae.renderFinalNewline=89]="renderFinalNewline",ae[ae.renderLineHighlight=90]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=92]="renderValidationDecorations",ae[ae.renderWhitespace=93]="renderWhitespace",ae[ae.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ae[ae.roundedSelection=95]="roundedSelection",ae[ae.rulers=96]="rulers",ae[ae.scrollbar=97]="scrollbar",ae[ae.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=99]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=100]="scrollPredominantAxis",ae[ae.selectionClipboard=101]="selectionClipboard",ae[ae.selectionHighlight=102]="selectionHighlight",ae[ae.selectOnLineNumbers=103]="selectOnLineNumbers",ae[ae.showFoldingControls=104]="showFoldingControls",ae[ae.showUnused=105]="showUnused",ae[ae.snippetSuggestions=106]="snippetSuggestions",ae[ae.smartSelect=107]="smartSelect",ae[ae.smoothScrolling=108]="smoothScrolling",ae[ae.stickyScroll=109]="stickyScroll",ae[ae.stickyTabStops=110]="stickyTabStops",ae[ae.stopRenderingLineAfter=111]="stopRenderingLineAfter",ae[ae.suggest=112]="suggest",ae[ae.suggestFontSize=113]="suggestFontSize",ae[ae.suggestLineHeight=114]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ae[ae.suggestSelection=116]="suggestSelection",ae[ae.tabCompletion=117]="tabCompletion",ae[ae.tabIndex=118]="tabIndex",ae[ae.unicodeHighlighting=119]="unicodeHighlighting",ae[ae.unusualLineTerminators=120]="unusualLineTerminators",ae[ae.useShadowDOM=121]="useShadowDOM",ae[ae.useTabStops=122]="useTabStops",ae[ae.wordBreak=123]="wordBreak",ae[ae.wordSeparators=124]="wordSeparators",ae[ae.wordWrap=125]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=128]="wordWrapColumn",ae[ae.wordWrapOverride1=129]="wordWrapOverride1",ae[ae.wordWrapOverride2=130]="wordWrapOverride2",ae[ae.wrappingIndent=131]="wrappingIndent",ae[ae.wrappingStrategy=132]="wrappingStrategy",ae[ae.showDeprecated=133]="showDeprecated",ae[ae.inlayHints=134]="inlayHints",ae[ae.editorClassName=135]="editorClassName",ae[ae.pixelRatio=136]="pixelRatio",ae[ae.tabFocusMode=137]="tabFocusMode",ae[ae.layoutInfo=138]="layoutInfo",ae[ae.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(181,null)})),acceptSuggestionOnEnter:Me(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(182,null),""],markdownDescription:a.localize(183,null)})),accessibilitySupport:Me(new c),accessibilityPageSize:Me(new b(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(184,null),tags:["accessibility"]})),ariaLabel:Me(new g(4,"ariaLabel",a.localize(185,null))),autoClosingBrackets:Me(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(186,null),a.localize(187,null),""],description:a.localize(188,null)})),autoClosingDelete:Me(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(189,null),""],description:a.localize(190,null)})),autoClosingOvertype:Me(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(191,null),""],description:a.localize(192,null)})),autoClosingQuotes:Me(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(193,null),a.localize(194,null),""],description:a.localize(195,null)})),autoIndent:Me(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[a.localize(196,null),a.localize(197,null),a.localize(198,null),a.localize(199,null),a.localize(200,null)],description:a.localize(201,null)})),automaticLayout:Me(new f(10,"automaticLayout",!1)),autoSurround:Me(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),""],description:a.localize(205,null)})),bracketPairColorization:Me(new he),bracketPairGuides:Me(new we),stickyTabStops:Me(new f(110,"stickyTabStops",!1,{description:a.localize(206,null)})),codeLens:Me(new f(14,"codeLens",!0,{description:a.localize(207,null)})),codeLensFontFamily:Me(new g(15,"codeLensFontFamily","",{description:a.localize(208,null)})),codeLensFontSize:Me(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(209,null)})),colorDecorators:Me(new f(17,"colorDecorators",!0,{description:a.localize(210,null)})),colorDecoratorsLimit:Me(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(211,null)})),columnSelection:Me(new f(19,"columnSelection",!1,{description:a.localize(212,null)})),comments:Me(new u),contextmenu:Me(new f(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new f(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(213,null)})),cursorBlinking:Me(new o(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:a.localize(214,null)})),cursorSmoothCaretAnimation:Me(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(215,null),a.localize(216,null),a.localize(217,null)],description:a.localize(218,null)})),cursorStyle:Me(new o(25,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:a.localize(219,null)})),cursorSurroundingLines:Me(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(220,null)})),cursorSurroundingLinesStyle:Me(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(221,null),a.localize(222,null)],description:a.localize(223,null)})),cursorWidth:Me(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(224,null)})),disableLayerHinting:Me(new f(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new f(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new f(31,"domReadOnly",!1)),dragAndDrop:Me(new f(32,"dragAndDrop",!0,{description:a.localize(225,null)})),emptySelectionClipboard:Me(new K),dropIntoEditor:Me(new Qe),stickyScroll:Me(new ee),experimentalWhitespaceRendering:Me(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(226,null),a.localize(227,null),a.localize(228,null)],description:a.localize(229,null)})),extraEditorClassName:Me(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new S(37,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:a.localize(230,null)})),find:Me(new q),fixedOverflowWidgets:Me(new f(39,"fixedOverflowWidgets",!1)),folding:Me(new f(40,"folding",!0,{description:a.localize(231,null)})),foldingStrategy:Me(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(232,null),a.localize(233,null)],description:a.localize(234,null)})),foldingHighlight:Me(new f(42,"foldingHighlight",!0,{description:a.localize(235,null)})),foldingImportsByDefault:Me(new f(43,"foldingImportsByDefault",!1,{description:a.localize(236,null)})),foldingMaximumRegions:Me(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(237,null)})),unfoldOnClickAfterEndOfLine:Me(new f(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(238,null)})),fontFamily:Me(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(239,null)})),fontInfo:Me(new O),fontLigatures2:Me(new F),fontSize:Me(new U),fontWeight:Me(new $),fontVariations:Me(new B),formatOnPaste:Me(new f(52,"formatOnPaste",!1,{description:a.localize(240,null)})),formatOnType:Me(new f(53,"formatOnType",!1,{description:a.localize(241,null)})),glyphMargin:Me(new f(54,"glyphMargin",!0,{description:a.localize(242,null)})),gotoLocation:Me(new j),hideCursorInOverviewRuler:Me(new f(56,"hideCursorInOverviewRuler",!1,{description:a.localize(243,null)})),hover:Me(new ue),inDiffEditor:Me(new f(58,"inDiffEditor",!1)),letterSpacing:Me(new S(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>S.clamp(ae,-5,20),{description:a.localize(244,null)})),lightbulb:Me(new ne),lineDecorationsWidth:Me(new G),lineHeight:Me(new de),lineNumbers:Me(new Z),lineNumbersMinChars:Me(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new f(66,"linkedEditing",!1,{description:a.localize(245,null)})),links:Me(new f(67,"links",!0,{description:a.localize(246,null)})),matchBrackets:Me(new s(68,"matchBrackets","always",["always","near","never"],{description:a.localize(247,null)})),minimap:Me(new be),mouseStyle:Me(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new S(71,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:a.localize(248,null)})),mouseWheelZoom:Me(new f(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(249,null)})),multiCursorMergeOverlapping:Me(new f(73,"multiCursorMergeOverlapping",!0,{description:a.localize(250,null)})),multiCursorModifier:Me(new o(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[a.localize(251,null),a.localize(252,null)],markdownDescription:a.localize(253,null)})),multiCursorPaste:Me(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorLimit:Me(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(257,null)})),occurrencesHighlight:Me(new f(77,"occurrencesHighlight",!0,{description:a.localize(258,null)})),overviewRulerBorder:Me(new f(78,"overviewRulerBorder",!0,{description:a.localize(259,null)})),overviewRulerLanes:Me(new b(79,"overviewRulerLanes",3,0,3)),padding:Me(new Pe),parameterHints:Me(new Fe),peekWidgetDefaultFocus:Me(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(260,null),a.localize(261,null)],description:a.localize(262,null)})),definitionLinkOpensInPeek:Me(new f(83,"definitionLinkOpensInPeek",!1,{description:a.localize(263,null)})),quickSuggestions:Me(new oe),quickSuggestionsDelay:Me(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(264,null)})),readOnly:Me(new f(86,"readOnly",!1)),renameOnType:Me(new f(87,"renameOnType",!1,{description:a.localize(265,null),markdownDeprecationMessage:a.localize(266,null)})),renderControlCharacters:Me(new f(88,"renderControlCharacters",!0,{description:a.localize(267,null),restricted:!0})),renderFinalNewline:Me(new s(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(268,null)})),renderLineHighlight:Me(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(269,null)],description:a.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Me(new f(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(271,null)})),renderValidationDecorations:Me(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(272,null),a.localize(273,null),a.localize(274,null),""],description:a.localize(275,null)})),revealHorizontalRightPadding:Me(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new f(95,"roundedSelection",!0,{description:a.localize(276,null)})),rulers:Me(new ie),scrollbar:Me(new H),scrollBeyondLastColumn:Me(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(277,null)})),scrollBeyondLastLine:Me(new f(99,"scrollBeyondLastLine",!0,{description:a.localize(278,null)})),scrollPredominantAxis:Me(new f(100,"scrollPredominantAxis",!0,{description:a.localize(279,null)})),selectionClipboard:Me(new f(101,"selectionClipboard",!0,{description:a.localize(280,null),included:t.isLinux})),selectionHighlight:Me(new f(102,"selectionHighlight",!0,{description:a.localize(281,null)})),selectOnLineNumbers:Me(new f(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(282,null),a.localize(283,null),a.localize(284,null)],description:a.localize(285,null)})),showUnused:Me(new f(105,"showUnused",!0,{description:a.localize(286,null)})),showDeprecated:Me(new f(133,"showDeprecated",!0,{description:a.localize(287,null)})),inlayHints:Me(new X),snippetSuggestions:Me(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null),a.localize(291,null)],description:a.localize(292,null)})),smartSelect:Me(new De),smoothScrolling:Me(new f(108,"smoothScrolling",!1,{description:a.localize(293,null)})),stopRenderingLineAfter:Me(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new J),suggestFontSize:Me(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new f(115,"suggestOnTriggerCharacters",!0,{description:a.localize(296,null)})),suggestSelection:Me(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null),a.localize(299,null)],description:a.localize(300,null)})),tabCompletion:Me(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],description:a.localize(304,null)})),tabIndex:Me(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Q),unusualLineTerminators:Me(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(305,null),a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),useShadowDOM:Me(new f(121,"useShadowDOM",!0)),useTabStops:Me(new f(122,"useTabStops",!0,{description:a.localize(309,null)})),wordBreak:Me(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(310,null),a.localize(311,null)],description:a.localize(312,null)})),wordSeparators:Me(new g(124,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:a.localize(313,null)})),wordWrap:Me(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(314,null),a.localize(315,null),a.localize(316,null),a.localize(317,null)],description:a.localize(318,null)})),wordWrapBreakAfterCharacters:Me(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(319,null)})),wordWrapOverride1:Me(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new M),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new _),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new Y)}}),define(ye[168],Ce([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],Ce([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],Ce([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],Ce([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],Ce([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ye[173],Ce([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ye[174],Ce([19,20]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[175],Ce([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ye[176],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[177],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[178],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[179],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[180],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[181],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[182],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[183],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[184],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[185],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ye[186],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(ye[187],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[188],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[189],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[190],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[191],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[192],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[193],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[194],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[195],Ce([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,I){this.a.set(R,I)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const I in R.contributes){const A=this.a.get(I);if(!A)continue;const y=R.contributes[I],D=Array.isArray(y)?y:[y];try{A(D,R.activationEvents)}catch(L){(0,a.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[196],Ce([1,0,24,38,170,316]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(f){return f=f.trim(),f==="*"||I.test(f)}e.isValidVersionStr=y;function D(f){if(!y(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(I);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=D;function L(f){if(!f)return null;const p=f.majorBase,b=f.majorMustEqual,S=f.minorBase;let g=f.minorMustEqual;const i=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(p===0||(g=!1),s=!1);let o=0;if(f.preRelease){const l=A.exec(f.preRelease);if(l){const[,c,u,r]=l;o=Date.UTC(Number(c),Number(u)-1,Number(r))}}return{majorBase:p,majorMustEqual:b,minorBase:S,minorMustEqual:g,patchBase:i,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:o}}e.normalizeVersion=L;function P(f,p,b){let S;typeof f=="string"?S=L(D(f)):S=f;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof b=="string"?i=L(D(b)):i=b,!S||!i)return!1;const s=S.majorBase,o=S.minorBase,l=S.patchBase;let c=i.majorBase,u=i.minorBase,r=i.patchBase;const n=i.notBefore;let d=i.majorMustEqual,E=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?s>c?!0:s<c?!1:o>u?!0:o<u||g&&g<n?!1:l>=r:(s===1&&c===0&&(!d||!E||!k)&&(c=1,u=0,r=0,d=!0,E=!1,k=!1),s<c?!1:s>c?!d:o<u?!1:o>u?!E:l<r?!1:l>r?!k:!(g&&g<n))}e.isValidVersion=P;function w(f,p,b,S,g){const i=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return i.push([t.default.Error,T.localize(0,null)]),i;if(typeof S.name!="string")return i.push([t.default.Error,T.localize(1,null,"name")]),i;if(typeof S.version!="string")return i.push([t.default.Error,T.localize(2,null,"version")]),i;if(!S.engines)return i.push([t.default.Error,T.localize(3,null,"engines")]),i;if(typeof S.engines.vscode!="string")return i.push([t.default.Error,T.localize(4,null,"engines.vscode")]),i;if(typeof S.extensionDependencies<"u"&&!h(S.extensionDependencies))return i.push([t.default.Error,T.localize(5,null,"extensionDependencies")]),i;if(typeof S.activationEvents<"u"){if(!h(S.activationEvents))return i.push([t.default.Error,T.localize(6,null,"activationEvents")]),i;if(typeof S.main>"u"&&typeof S.browser>"u")return i.push([t.default.Error,T.localize(7,null,"activationEvents","main")]),i}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&i.push([t.default.Warning,T.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return i.push([t.default.Error,T.localize(9,null,"main")]),i;{const l=(0,a.joinPath)(b,S.main);(0,a.isEqualOrParent)(l,b)||i.push([t.default.Warning,T.localize(10,null,l.path,b.path)])}if(typeof S.activationEvents>"u")return i.push([t.default.Error,T.localize(11,null,"activationEvents","main")]),i}if(typeof S.browser<"u"){if(typeof S.browser!="string")return i.push([t.default.Error,T.localize(12,null,"browser")]),i;{const l=(0,a.joinPath)(b,S.browser);(0,a.isEqualOrParent)(l,b)||i.push([t.default.Warning,T.localize(13,null,l.path,b.path)])}if(typeof S.activationEvents>"u")return i.push([t.default.Error,T.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(S.version))return i.push([t.default.Error,T.localize(15,null)]),i;const s=[];if(!C(f,p,S,g,s))for(const l of s)i.push([t.default.Error,l]);return i}e.validateExtensionManifest=w;function C(f,p,b,S,g){return S||typeof b.main>"u"&&typeof b.browser>"u"?!0:m(f,p,b.engines.vscode,g)}e.isValidExtensionVersion=C;function v(f,p,b){return f==="*"||m(p,b,f)}e.isEngineValid=v;function m(f,p,b,S=[]){const g=L(D(b));if(!g)return S.push(T.localize(16,null,b)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return S.push(T.localize(17,null,b)),!1}else if(!g.majorMustEqual)return S.push(T.localize(18,null,b)),!1;return P(f,p,g)?!0:(S.push(T.localize(19,null,f,b)),!1)}function h(f){if(!Array.isArray(f))return!1;for(let p=0,b=f.length;p<b;p++)if(typeof f[p]!="string")return!1;return!0}}),define(ye[122],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(T,R=[],I=!1){this.ctor=T,this.staticArguments=R,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=a}),define(ye[89],Ce([1,0,122]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var T;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(T=e.InstantiationType||(e.InstantiationType={}));function R(A,y,D){y instanceof a.SyncDescriptor||(y=new a.SyncDescriptor(y,[],Boolean(D))),t.push([A,y])}e.registerSingleton=R;function I(){return t}e.getSingletonServiceDescriptors=I}),define(ye[197],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(R,I){this.key=R,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const I of this.a.values())I.outgoing.size===0&&R.push(I);return R}insertEdge(R,I){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(I);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const I=this.b(R);this.a.delete(I);for(const A of this.a.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(R){const I=this.b(R);let A=this.a.get(I);return A||(A=new a(I,R),this.a.set(I,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[I,A]of this.a)R.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,I]of this.a){const A=new Set([R]),y=this.c(I,A);if(y)return y}}c(R,I){for(const[A,y]of R.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const D=this.c(y,I);if(D)return D;I.delete(A)}}}e.Graph=t}),define(ye[4],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(a=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function t(I,A,y){A[a.DI_TARGET]===A?A[a.DI_DEPENDENCIES].push({id:I,index:y}):(A[a.DI_DEPENDENCIES]=[{id:I,index:y}],A[a.DI_TARGET]=A)}function T(I){if(a.serviceIds.has(I))return a.serviceIds.get(I);const A=function(y,D,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,y,L)};return A.toString=()=>I,a.serviceIds.set(I,A),A}e.createDecorator=T;function R(I){return I}e.refineServiceDecorator=R}),define(ye[53],Ce([1,0,10,2,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function R(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=R;function I(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function D(f,p){const b=Object.create(null);for(const S in f)L(b,S,f[S],p);return b}e.toValuesTree=D;function L(f,p,b,S){const g=p.split("."),i=g.pop();let s=f;for(let o=0;o<g.length;o++){const l=g[o];let c=s[l];switch(typeof c){case"undefined":c=s[l]=Object.create(null);break;case"object":break;default:S(`Ignoring ${p} as ${g.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}s=c}if(typeof s=="object"&&s!==null)try{s[i]=b}catch{S(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(s)}`)}else S(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=L;function P(f,p){const b=p.split(".");w(f,b)}e.removeFromValueTree=P;function w(f,p){const b=p.shift();if(p.length===0){delete f[b];return}if(Object.keys(f).indexOf(b)!==-1){const S=f[b];typeof S=="object"&&!Array.isArray(S)&&(w(S,p),Object.keys(S).length===0&&delete f[b])}}function C(f,p,b){function S(s,o){let l=s;for(const c of o){if(typeof l!="object"||l===null)return;l=l[c]}return l}const g=p.split("."),i=S(f,g);return typeof i>"u"?b:i}e.getConfigurationValue=C;function v(f,p,b){Object.keys(p).forEach(S=>{S!=="__proto__"&&(S in f?a.isObject(f[S])&&a.isObject(p[S])?v(f[S],p[S],b):b&&(f[S]=p[S]):f[S]=p[S])})}e.merge=v;function m(f,p,b){const S=f.inspect(p),g=f.inspect(b);return typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:S.defaultValue}e.getMigratedSettingValue=m;function h(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(ye[54],Ce([1,0,12,8,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",a.isMacintosh),R.set("isLinux",a.isLinux),R.set("isWindows",a.isWindows),R.set("isWeb",a.isWeb),R.set("isMacNative",a.isMacintosh&&!a.isWeb),R.set("isEdge",a.isEdge),R.set("isFirefox",a.isFirefox),R.set("isChrome",a.isChrome),R.set("isSafari",a.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return P.INSTANCE}static true(){return w.INSTANCE}static has(F){return C.create(F)}static equals(F,B){return v.create(F,B)}static notEquals(F,B){return f.create(F,B)}static regex(F,B){return o.create(F,B)}static in(F,B){return m.create(F,B)}static notIn(F,B){return h.create(F,B)}static not(F){return p.create(F)}static and(...F){return u.create(F,null,!0)}static or(...F){return r.create(F,null,!0)}static greater(F,B){return S.create(F,B)}static greaterEquals(F,B){return g.create(F,B)}static smaller(F,B){return i.create(F,B)}static smallerEquals(F,B){return s.create(F,B)}static deserialize(F,B=!1){if(!!F)return this.c(F,B)}static c(F,B){const O=F.split("||");return r.create(O.map(U=>this.d(U,B)),null,!0)}static d(F,B){const O=F.split("&&");return u.create(O.map(U=>this.f(U,B)),null,!0)}static f(F,B){if(F=F.trim(),F.indexOf("!=")>=0){const O=F.split("!=");return f.create(O[0].trim(),this.g(O[1],B))}if(F.indexOf("==")>=0){const O=F.split("==");return v.create(O[0].trim(),this.g(O[1],B))}if(F.indexOf("=~")>=0){const O=F.split("=~");return o.create(O[0].trim(),this.h(O[1],B))}if(F.indexOf(" not in ")>=0){const O=F.split(" not in ");return h.create(O[0].trim(),this.g(O[1],B))}if(F.indexOf(" in ")>=0){const O=F.split(" in ");return m.create(O[0].trim(),this.g(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const O=F.split(">=");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const O=F.split(">");return S.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const O=F.split("<=");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const O=F.split("<");return i.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(F)?p.create(F.substr(1).trim()):C.create(F)}static g(F,B){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const O=/^'([^']*)'$/.exec(F);return O?O[1].trim():F}static h(F,B){if((0,t.isFalsyOrWhitespace)(F)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=F.indexOf("/"),U=F.lastIndexOf("/");if(O===U||O<0){if(B)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const $=F.slice(O+1,U),j=F[U+1]==="i"?"i":"";try{return new RegExp($,j)}catch(ue){if(B)throw new Error(`bad regexp-value '${F}', parse error: ${ue}`);return console.warn(`bad regexp-value '${F}', parse error: ${ue}`),null}}}e.ContextKeyExpr=y;function D(q,F){const B=q?q.substituteConstants():void 0,O=F?F.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=D;function L(q,F){return q.cmp(F)}class P{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class w{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class C{static create(F,B=null){const O=R.get(F);return typeof O=="boolean"?O?w.INSTANCE:P.INSTANCE:new C(F,B)}constructor(F,B){this.key=F,this.c=B,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=R.get(this.key);return typeof F=="boolean"?F?w.INSTANCE:P.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=C;class v{static create(F,B,O=null){if(typeof B=="boolean")return B?C.create(F,O):p.create(F,O);const U=R.get(F);return typeof U=="boolean"?B===(U?"true":"false")?w.INSTANCE:P.INSTANCE:new v(F,B,O)}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const B=F?"true":"false";return this.d===B?w.INSTANCE:P.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class m{static create(F,B){return new m(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:E(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.f),O=F.getValue(this.d);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?I.call(B,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class h{static create(F,B){return new h(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=11,this.c=m.create(F,B)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=h;class f{static create(F,B,O=null){if(typeof B=="boolean")return B?p.create(F,O):C.create(F,O);const U=R.get(F);return typeof U=="boolean"?B===(U?"true":"false")?P.INSTANCE:w.INSTANCE:new f(F,B,O)}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const B=F?"true":"false";return this.d===B?P.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class p{static create(F,B=null){const O=R.get(F);return typeof O=="boolean"?O?P.INSTANCE:w.INSTANCE:new p(F,B)}constructor(F,B){this.c=F,this.d=B,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:d(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=R.get(this.c);return typeof F=="boolean"?F?P.INSTANCE:w.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function b(q,F){if(typeof q=="string"){const B=parseFloat(q);isNaN(B)||(q=B)}return typeof q=="string"||typeof q=="number"?F(q):P.INSTANCE}class S{static create(F,B,O=null){return b(B,U=>new S(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=S;class g{static create(F,B,O=null){return b(B,U=>new g(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=g;class i{static create(F,B,O=null){return b(B,U=>new i(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class s{static create(F,B,O=null){return b(B,U=>new s(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class o{static create(F,B){return new o(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const B=this.f?this.f.source:"",O=F.f?F.f.source:"";return B<O?-1:B>O?1:0}equals(F){if(F.type===this.type){const B=this.f?this.f.source:"",O=F.f?F.f.source:"";return this.d===F.d&&B===O}return!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=l.create(this)),this.c}}e.ContextKeyRegexExpr=o;class l{static create(F){return new l(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new l(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=l;function c(q){let F=null;for(let B=0,O=q.length;B<O;B++){const U=q[B].substituteConstants();if(q[B]!==U&&F===null){F=[];for(let $=0;$<B;$++)F[$]=q[$]}F!==null&&(F[B]=U)}return F===null?q:F}class u{static create(F,B,O){return u.d(F,B,O)}constructor(F,B){this.expr=F,this.c=B,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],F.expr[B]);if(U!==0)return U}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=c(this.expr);return F===this.expr?this:u.create(F,this.c,!1)}evaluate(F){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(F))return!1;return!0}static d(F,B,O){const U=[];let $=!1;for(const j of F)if(!!j){if(j.type===1){$=!0;continue}if(j.type===0)return P.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&$)return w.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const ue=U.pop(),V=U.length===0,_=r.create(j.expr.map(Y=>u.create([Y,ue],null,O)),null,V);_&&(U.push(_),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let ue=j+1;ue<U.length;ue++)if(U[j].negate().equals(U[ue]))return P.INSTANCE;if(U.length===1)return U[0]}return new u(U,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const B of this.expr)F.push(...B.keys());return F}map(F){return new u(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.c){const F=[];for(const B of this.expr)F.push(B.negate());this.c=r.create(F,this,!0)}return this.c}}class r{static create(F,B,O){return r.d(F,B,O)}constructor(F,B){this.expr=F,this.c=B,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],F.expr[B]);if(U!==0)return U}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=c(this.expr);return F===this.expr?this:r.create(F,this.c,!1)}evaluate(F){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(F))return!0;return!1}static d(F,B,O){let U=[],$=!1;if(F){for(let j=0,ue=F.length;j<ue;j++){const V=F[j];if(!!V){if(V.type===0){$=!0;continue}if(V.type===1)return w.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&$)return P.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let ue=j+1;ue<U.length;ue++)if(U[j].negate().equals(U[ue]))return w.INSTANCE;if(U.length===1)return U[0]}return new r(U,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const B of this.expr)F.push(...B.keys());return F}map(F){return new r(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.c){const F=[];for(const B of this.expr)F.push(B.negate());for(;F.length>1;){const B=F.shift(),O=F.shift(),U=[];for(const $ of K(B))for(const j of K(O))U.push(u.create([$,j],null,!1));F.unshift(r.create(U,null,!1))}this.c=r.create(F,this,!0)}return this.c}}class n extends C{static all(){return n.d.values()}constructor(F,B,O){super(F,null),this.f=B,typeof O=="object"?n.d.push({...O,key:F}):O!==!0&&n.d.push({key:F,description:O,type:B!=null?typeof B:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return f.create(this.key,F)}}e.RawContextKey=n,n.d=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function d(q,F){return q<F?-1:q>F?1:0}function E(q,F,B,O){return q<B?-1:q>B?1:F<O?-1:F>O?1:0}function k(q,F){if(q.type===0||F.type===1)return!0;if(q.type===9)return F.type===9?M(q.expr,F.expr):!1;if(F.type===9){for(const B of F.expr)if(k(q,B))return!0;return!1}if(q.type===6){if(F.type===6)return M(F.expr,q.expr);for(const B of q.expr)if(k(B,F))return!0;return!1}return q.equals(F)}e.implies=k;function M(q,F){let B=0,O=0;for(;B<q.length&&O<F.length;){const U=q[B].cmp(F[O]);if(U<0)return!1;U===0&&B++,O++}return B===q.length}function K(q){return q.type===9?q.expr:[q]}}),define(ye[198],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],Ce([1,0,169,4]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function I(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(f,p,b){return A(p,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:D(b).includes(f)}e.isTargetPlatformCompatible=y;function D(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var w;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var C;(function(f){f.Install="install",f.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[199],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(ye[200],Ce([1,0,46,17,11,12,108,29,116,171,199]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=D.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends w{openTerminal(S,g){return this.spawnTerminal(a,S,y.getWindowsShell(),g)}spawnTerminal(S,g,i,s){const o=g.windowsExec||C.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=T.basename(o).toLowerCase();if(l==="cmder"||l==="cmder.exe")return S.spawn(o,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return o.indexOf(" ")>=0&&c.push('""'),c.push(o),(l==="wt"||l==="wt.exe")&&c.push("-d ."),new Promise((u,r)=>{const n=h(process),d=S.spawn(i,c,{cwd:s,env:n});d.on("error",r),d.on("exit",()=>u())})}runInTerminal(S,g,i,s,o){const l="windowsExec"in o&&o.windowsExec?o.windowsExec:C.getDefaultTerminalWindows();return new Promise((c,u)=>{const r=`"${g} - ${P}"`,n=`""${i.join('" "')}" & pause"`,d=["/c","start",r,"/wait",l,"/c",n],E=Object.assign({},h(process),s);Object.keys(E).filter(K=>E[K]===null).forEach(K=>delete E[K]);const k={cwd:g,env:E,windowsVerbatimArguments:!0};a.spawn(C.b,d,k).on("error",K=>{u(f(K))}),c(void 0)})}static getDefaultTerminalWindows(){if(!C.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return C.d}}e.WindowsExternalTerminalService=C,C.b="cmd.exe";class v extends w{openTerminal(S,g){return this.spawnTerminal(a,S,g)}runInTerminal(S,g,i,s,o){const l=o.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((c,u)=>{if(l===L.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const r=l===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",S||P,"-w",g];for(const M of i)d.push("-a"),d.push(M);if(s){const M=Object.assign({},h(process),s);for(const K in M){const q=M[K];q===null?(d.push("-u"),d.push(K)):(d.push("-e"),d.push(`${K}=${q}`))}}let E="";const k=a.spawn(v.b,d);k.on("error",M=>{u(f(M))}),k.stderr.on("data",M=>{E+=M.toString()}),k.on("exit",M=>{if(M===0)c(void 0);else if(E){const K=E.split(`
`,1);u(new Error(K[0]))}else u(new Error(D.localize(1,null,r,M)))})}else u(new Error(D.localize(2,null,l)))})}spawnTerminal(S,g,i){const s=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{const c=["-a",s];i&&c.push(i);const u=h(process),r=S.spawn("/usr/bin/open",c,{cwd:i,env:u});r.on("error",l),r.on("exit",()=>o())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class m extends w{openTerminal(S,g){return this.spawnTerminal(a,S,g)}runInTerminal(S,g,i,s,o){const l=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((c,u)=>{const r=[];l.then(n=>{n.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const d=`${p(i)}; echo; read -p "${m.b}" -n1;`;r.push(`''${d}''`);const E=Object.assign({},h(process),s);Object.keys(E).filter(q=>E[q]===null).forEach(q=>delete E[q]);const k={cwd:g,env:E};let M="";const K=a.spawn(n,r,k);K.on("error",q=>{u(f(q))}),K.stderr.on("data",q=>{M+=q.toString()}),K.on("exit",q=>{if(q===0)c(void 0);else if(M){const F=M.split(`
`,1);u(new Error(F[0]))}else u(new Error(D.localize(4,null,n,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.isLinux)m.d=Promise.resolve("xterm");else{const S=await A.Promises.exists("/etc/debian_version");m.d=new Promise(g=>{S?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return m.d}spawnTerminal(S,g,i){const s=g.linuxExec?Promise.resolve(g.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{s.then(c=>{const u=h(process),r=S.spawn(c,[],{cwd:i,env:u});r.on("error",l),r.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=m,m.b=D.localize(3,null);function h(b){const S={...b.env};return(0,I.sanitizeProcessEnvironment)(S),S}function f(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(D.localize(5,null,b.path)):b}function p(b){let S="";for(const g of b)g.indexOf(" ")>=0?S+='"'+g+'"':S+=g,S+=" ";return S}}),define(ye[40],Ce([1,0,66,11,8,10,2,172,4,12]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function L(V){return V.create===!0}e.isFileOpenForWriteOptions=L;var P;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var w;(function(V){V[V.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=v;function m(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=m;function h(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=h;function f(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function b(V){return v(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var S;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(_,Y){super(_),this.code=Y}}e.FileSystemProviderError=g;function i(V,_){const Y=new g(V.toString(),_);return o(Y,_),Y}e.createFileSystemProviderError=i;function s(V){return V||i((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=s;function o(V,_){return V.name=_?`${_} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=o;function l(V){if(!V)return S.Unknown;if(V instanceof g)return V.code;const _=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!_)return S.Unknown;switch(_[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=l;function c(V){if(V instanceof k)return V.fileOperationResult;switch(l(V)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(u=e.FileOperation||(e.FileOperation={}));class r{constructor(_,Y,ne){this.resource=_,this.operation=Y,this.target=ne}isOperation(_){return this.operation===_}}e.FileOperationEvent=r;var n;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class d{constructor(_,Y){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const ee of _){const X=ne.get(ee.type);switch(X?X.push([ee.resource,ee]):ne.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,X]of ne)switch(ee){case 1:this.a=a.TernarySearchTree.forUris(()=>Y),this.a.fill(X);break;case 0:this.b=a.TernarySearchTree.forUris(()=>Y),this.b.fill(X);break;case 2:this.c=a.TernarySearchTree.forUris(()=>Y),this.c.fill(X);break}}contains(_,...Y){return this.d(_,{includeChildren:!1},...Y)}affects(_,...Y){return this.d(_,{includeChildren:!0},...Y)}d(_,Y,...ne){if(!_)return!1;const ee=ne.length>0;return!!((!ee||ne.includes(1))&&(this.a?.get(_)||Y.includeChildren&&this.a?.findSuperstr(_))||(!ee||ne.includes(0))&&(this.b?.get(_)||Y.includeChildren&&this.b?.findSuperstr(_))||(!ee||ne.includes(2))&&(this.c?.findSubstr(_)||Y.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=d;function E(V,_,Y){return!V||!_||V===_||_.length>V.length?!1:(_.charAt(_.length-1)!==t.sep&&(_+=t.sep),Y?(0,T.startsWithIgnoreCase)(V,_):V.indexOf(_)===0)}e.isParent=E;class k extends Error{constructor(_,Y,ne){super(_),this.fileOperationResult=Y,this.options=ne}}e.FileOperationError=k;class M extends k{constructor(_,Y,ne,ee){super(_,Y,ee),this.fileOperationResult=Y,this.size=ne}}e.TooLargeFileOperationError=M;class K extends k{constructor(_,Y,ne){super(_,2,ne),this.stat=Y}}e.NotModifiedSinceFileOperationError=K;var q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=B;async function O(V,_){if(!_.hasProvider(I.URI.from({scheme:V.scheme})))return new Promise(Y=>{const ne=_.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===V.scheme&&ee.added&&(ne.dispose(),Y())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<U.KB?(0,A.localize)(1,null,_.toFixed(0)):_<U.MB?(0,A.localize)(2,null,(_/U.KB).toFixed(2)):_<U.GB?(0,A.localize)(3,null,(_/U.MB).toFixed(2)):_<U.TB?(0,A.localize)(4,null,(_/U.GB).toFixed(2)):(0,A.localize)(5,null,(_/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function j(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=j;function ue(V){return D.isWeb?V?10*U.MB:50*U.MB:V?100*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=ue}),define(ye[90],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...T){this.a=new Map;for(const[R,I]of T)this.set(R,I)}set(T,R){const I=this.a.get(T);return this.a.set(T,R),I}has(T){return this.a.has(T)}get(T){return this.a.get(T)}}e.ServiceCollection=a}),define(ye[201],Ce([1,0,14,9,6,122,197,4,90,65]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class w{constructor(h=new y.ServiceCollection,f=!1,p,b=L){this.f=h,this.g=f,this.h=p,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new I.Graph(S=>S):void 0}createChild(h){return new w(h,this.g,this,this.i)}invokeFunction(h,...f){const p=v.traceInvocation(this.i,h);let b=!1;try{return h({get:g=>{if(b)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...f)}finally{b=!0,p.stop()}}createInstance(h,...f){let p,b;return h instanceof R.SyncDescriptor?(p=v.traceCreation(this.i,h.ctor),b=this.j(h.ctor,h.staticArguments.concat(f),p)):(p=v.traceCreation(this.i,h),b=this.j(h,f,p)),p.stop(),b}j(h,f=[],p){const b=A._util.getServiceDependencies(h).sort((i,s)=>i.index-s.index),S=[];for(const i of b){const s=this.m(i.id,p);s||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${i.id}.`,!1),S.push(s)}const g=b.length>0?b[0].index:f.length;if(f.length!==g){console.trace(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${f.length} static arguments`);const i=g-f.length;i>0?f=f.concat(new Array(i)):f=f.slice(0,g)}return Reflect.construct(h,f.concat(S))}k(h,f){if(this.f.get(h)instanceof R.SyncDescriptor)this.f.set(h,f);else if(this.h)this.h.k(h,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const f=this.f.get(h);return!f&&this.h?this.h.l(h):f}m(h,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const p=this.l(h);return p instanceof R.SyncDescriptor?this.q(h,p,f.branch(h,!0)):(f.branch(h,!1),p)}q(h,f,p){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,f,p)}finally{this.o.delete(h)}}r(h,f,p){const b=new I.Graph(i=>i.id.toString());let S=0;const g=[{id:h,desc:f,_trace:p}];for(;g.length;){const i=g.pop();if(b.lookupOrInsertNode(i),S++>1e3)throw new P(b);for(const s of A._util.getServiceDependencies(i.desc.ctor)){const o=this.l(s.id);if(o||this.u(`[createInstance] ${h} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),o instanceof R.SyncDescriptor){const l={id:s.id,desc:o,_trace:i._trace.branch(s.id,!0)};b.insertEdge(i,l),g.push(l)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new P(b);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const l=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,l)}b.removeNode(s)}}return this.l(h)}s(h,f,p=[],b,S){if(this.f.get(h)instanceof R.SyncDescriptor)return this.t(h,f,p,b,S);if(this.h)return this.h.s(h,f,p,b,S);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(h,f,p=[],b,S){if(b){const g=new w(void 0,this.g,this,this.i);g.c=String(h);const i=new Map,s=new a.IdleValue(()=>{const o=g.j(f,p,S);for(const[l,c]of i){const u=o[l];if(typeof u=="function")for(const r of c)u.apply(o,r)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,l){if(!s.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let r=i.get(l);return r||(r=new D.LinkedList,i.set(l,r)),(d,E,k)=>{const M=r.push([d,E,k]);return(0,T.toDisposable)(M)}}if(l in o)return o[l];const c=s.value;let u=c[l];return typeof u!="function"||(u=u.bind(c),o[l]=u),u},set(o,l,c){return s.value[l]=c,!0},getPrototypeOf(o){return f.prototype}})}else return this.j(f,p,S)}u(h,f){if(f&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=w;var C;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(C||(C={}));class v{static traceInvocation(h,f){return h?new v(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(h,f){return h?new v(1,f.name):v.c}constructor(h,f){this.type=h,this.name=f,this.g=Date.now(),this.h=[]}branch(h,f){const p=new v(3,h.toString());return this.h.push([h,f,p]),p}stop(){const h=Date.now()-this.g;v.f+=h;let f=!1;function p(S,g){const i=[],s=new Array(S+1).join("	");for(const[o,l,c]of g.h)if(l&&c){f=!0,i.push(`${s}CREATES -> ${o}`);const u=p(S+1,c);u&&i.push(u)}else i.push(`${s}uses -> ${o}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(h>2||f)&&v.all.add(b.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(ye[13],Ce([1,0,45,3,6,28,12,2,4]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function D(){return new Date().toISOString()}var L;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(u,r,n){switch(r){case L.Trace:u.trace(n);break;case L.Debug:u.debug(n);break;case L.Info:u.info(n);break;case L.Warning:u.warn(n);break;case L.Error:u.error(n);break;case L.Off:break;default:throw new Error(`Invalid log level ${r}`)}}e.log=P;function w(u){let r="";for(let n=0;n<u.length;n++){let d=u[n];if(typeof d=="object")try{d=JSON.stringify(d)}catch{}r+=(n>0?" ":"")+d}return r}e.format=w;class C extends T.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(r){this.b!==r&&(this.b=r,this.c.fire(this.b))}getLevel(){return this.b}f(r){return this.b!==L.Off&&this.b<=r}}e.AbstractLogger=C;class v extends C{constructor(r){super(),this.h=r}f(r){return this.h||super.f(r)}trace(r,...n){this.f(L.Trace)&&this.g(L.Trace,w([r,...n]))}debug(r,...n){this.f(L.Debug)&&this.g(L.Debug,w([r,...n]))}info(r,...n){this.f(L.Info)&&this.g(L.Info,w([r,...n]))}warn(r,...n){this.f(L.Warning)&&this.g(L.Warning,w([r,...n]))}error(r,...n){if(this.f(L.Error))if(r instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=r.stack,this.g(L.Error,w(d))}else this.g(L.Error,w([r,...n]))}flush(){}}e.AbstractMessageLogger=v;class m extends C{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.g=!I.isWindows}trace(r,...n){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.log(`[main ${D()}]`,r,...n))}debug(r,...n){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.log(`[main ${D()}]`,r,...n))}info(r,...n){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,r,...n):console.log(`[main ${D()}]`,r,...n))}warn(r,...n){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,r,...n):console.warn(`[main ${D()}]`,r,...n))}error(r,...n){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,r,...n):console.error(`[main ${D()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class h extends C{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...n){this.f(L.Trace)&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.f(L.Info)&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.f(L.Warning)&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.f(L.Error)&&console.log("%c  ERR","color: #f33",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class f extends C{constructor(r,n=e.DEFAULT_LOG_LEVEL){super(),this.g=r,this.setLevel(n)}trace(r,...n){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(r),...n])}debug(r,...n){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(r),...n])}info(r,...n){this.f(L.Info)&&this.g.log(L.Info,[this.h(r),...n])}warn(r,...n){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(r),...n])}error(r,...n){this.f(L.Error)&&this.g.log(L.Error,[this.h(r),...n])}h(r){return typeof r=="string"?r:(0,a.toErrorMessage)(r,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=f;class p extends C{constructor(r){super(),this.g=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.g)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const d of this.g)d.trace(r,...n)}debug(r,...n){for(const d of this.g)d.debug(r,...n)}info(r,...n){for(const d of this.g)d.info(r,...n)}warn(r,...n){for(const d of this.g)d.warn(r,...n)}error(r,...n){for(const d of this.g)d.error(r,...n)}flush(){for(const r of this.g)r.flush()}dispose(){for(const r of this.g)r.dispose()}}e.MultiplexLogService=p;class b extends T.Disposable{constructor(r){super(),this.b=r,this.B(r)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(r){this.b.setLevel(r)}getLevel(){return this.b.getLevel()}trace(r,...n){this.b.trace(r,...n)}debug(r,...n){this.b.debug(r,...n)}info(r,...n){this.b.info(r,...n)}warn(r,...n){this.b.warn(r,...n)}error(r,...n){this.b.error(r,...n)}flush(){this.b.flush()}}e.LogService=b;class S extends T.Disposable{constructor(r,n){super(),this.c=r,this.b=new R.ResourceMap,this.B(n(d=>this.setLevel(d)))}getLoggers(){return[...this.b.values()].map(({logger:r})=>r)}getLogger(r){return this.b.get(r)?.logger}createLogger(r,n,d){let E=this.b.get(r)?.logger;return E||(d=n?.always?L.Trace:d,E=this.f(r,d??this.c,n),this.b.set(r,{logger:E,logLevel:d})),E}setLevel(r,n){const d=A.URI.isUri(r)?r:void 0,E=d?n:r;if(d){const k=this.b.get(d);k&&k.logLevel!==E&&(k.logLevel=E,k.logger.setLevel(E))}else this.c=E,this.b.forEach(({logLevel:k,logger:M})=>{k===void 0&&M.setLevel(this.c)})}getLogLevel(r){return this.b.get(r)?.logLevel}dispose(){this.b.forEach(({logger:r})=>r.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=S;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return L.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogger=g;class i extends g{}e.NullLogService=i;class s extends S{constructor(){super(L.Info,t.Event.None)}f(r,n,d){return new g}}e.NullLoggerService=s;function o(u){if(u.verbose)return L.Trace;if(typeof u.logLevel=="string"){const r=c(u.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(u){switch(u){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=l;function c(u){switch(u){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=c}),define(ye[202],Ce([1,0,40,13]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var T;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(T||(T={}));async function R(D,L,P,w,C){try{const v=await new Promise((h,f)=>{te(["spdlog"],h,f)});v.setFlushOn(T.Trace);const m=await v.createAsyncRotatingLogger(D,L,P,w);return C?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(v){console.error(v)}return null}function I(D,L,P){switch(L){case t.LogLevel.Trace:D.trace(P);break;case t.LogLevel.Debug:D.debug(P);break;case t.LogLevel.Info:D.info(P);break;case t.LogLevel.Warning:D.warn(P);break;case t.LogLevel.Error:D.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(D,L){switch(L){case t.LogLevel.Trace:D.setLevel(T.Trace);break;case t.LogLevel.Debug:D.setLevel(T.Debug);break;case t.LogLevel.Info:D.setLevel(T.Info);break;case t.LogLevel.Warning:D.setLevel(T.Warning);break;case t.LogLevel.Error:D.setLevel(T.Error);break;case t.LogLevel.Off:D.setLevel(T.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends t.AbstractMessageLogger{constructor(L,P,w,C,v){super(),this.k=[],this.setLevel(v),this.l=this.n(L,P,w,C),this.B(this.onDidChangeLogLevel(m=>{this.m&&A(this.m,m)}))}async n(L,P,w,C){const v=w?6:1,m=30/v*a.ByteSize.MB,h=await R(L,P,m,v,C);if(h){this.m=h,A(this.m,this.getLevel());for(const{level:f,message:p}of this.k)I(this.m,f,p);this.k=[]}}g(L,P){this.m?I(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[124],Ce([1,0,38,173,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function D(v,m){return m-v}y.compare=D;const L=Object.create(null);L[y.Error]=(0,t.localize)(0,null),L[y.Warning]=(0,t.localize)(1,null),L[y.Info]=(0,t.localize)(2,null);function P(v){return L[v]||""}y.toString=P;function w(v){switch(v){case a.default.Error:return y.Error;case a.default.Warning:return y.Warning;case a.default.Info:return y.Info;case a.default.Ignore:return y.Hint}}y.fromSeverity=w;function C(v){switch(v){case y.Error:return a.default.Error;case y.Warning:return a.default.Warning;case y.Info:return a.default.Info;case y.Hint:return a.default.Ignore}}y.toSeverity=C}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const D="";function L(w){return P(w,!0)}y.makeKey=L;function P(w,C){const v=[D];return w.source?v.push(w.source.replace("\xA6","\\\xA6")):v.push(D),w.code?typeof w.code=="string"?v.push(w.code.replace("\xA6","\\\xA6")):v.push(w.code.value.replace("\xA6","\\\xA6")):v.push(D),w.severity!==void 0&&w.severity!==null?v.push(I.toString(w.severity)):v.push(D),w.message&&C?v.push(w.message.replace("\xA6","\\\xA6")):v.push(D),w.startLineNumber!==void 0&&w.startLineNumber!==null?v.push(w.startLineNumber.toString()):v.push(D),w.startColumn!==void 0&&w.startColumn!==null?v.push(w.startColumn.toString()):v.push(D),w.endLineNumber!==void 0&&w.endLineNumber!==null?v.push(w.endLineNumber.toString()):v.push(D),w.endColumn!==void 0&&w.endColumn!==null?v.push(w.endColumn.toString()):v.push(D),v.push(D),v.join("\xA6")}y.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,T.createDecorator)("markerService")}),define(ye[203],Ce([1,0,3,38,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,T.createDecorator)("notificationService");var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ye[125],Ce([1,0,8,2,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService");function R(D,L){return t.URI.isUri(D)?(0,a.equalsIgnoreCase)(D.scheme,L):(0,a.startsWithIgnoreCase)(D,L+":")}e.matchesScheme=R;function I(D,...L){return L.some(P=>R(D,P))}e.matchesSomeScheme=I;function A(D,L){return D.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function y(D){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(D.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},D=D.with({fragment:""})),{selection:L,uri:D}}e.extractSelection=y}),define(ye[204],Ce([1,0,12,37]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const R=a.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:R.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ye[205],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(a,t){e(a,t,te)}};define(ye[126],Ce([1,0,14,21,6,4]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var I;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(P,w){super(),this.a=new a.DeferredPromise,w.withProgress(P,C=>(this.b=C,this.c&&C.report(this.c),this.a.p)),this.B((0,T.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};y=qe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class D extends T.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new T.DisposableStore)}start(P){this.stop();const w=++this.a,C=new t.CancellationTokenSource;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,T.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,T.toDisposable)(()=>C.cancel())),this.b.add((0,T.toDisposable)(()=>this.c?this.c.done():void 0)),{id:w,token:C.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[33],Ce([1,0,51,10]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.a=new Map}add(I,A){a.ok(t.isString(I)),a.ok(t.isObject(A)),a.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,A)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new T}),define(ye[91],Ce([1,0,3,33]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,D){this.a[T(y)]=D,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const I=new R;t.Registry.add(e.Extensions.JSONContribution,I)}),define(ye[127],Ce([1,0,16,3,10,168,53,91,33]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const o=new Set;this.n(i,s,o),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const s=new Set;this.o(i,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const o=new Set;this.o(s,o),this.n(i,!1,o),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const o=[];for(const{overrides:l,source:c}of i)for(const u in l)if(s.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const r=this.a.get(u),n=r?.valuesSources??new Map;if(c)for(const M of Object.keys(l[u]))n.set(M,c);const d={...r?.value||{},...l[u]};this.a.set(u,{source:c,value:d,valuesSources:n});const E=(0,I.getLanguageTagSettingPlainKey)(u),k={type:"object",default:d,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:T.isString(c)?void 0:c,defaultValueSource:c};o.push(...m(u)),this.d[u]=k,this.b.properties[u]=k}else{this.a.set(u,{value:l[u],source:c});const r=this.d[u];r&&(this.w(u,r),this.r(u,r))}this.m(o)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:o,source:l}of i)for(const c in o){const u=this.a.get(c),r=T.isString(l)?l:l?.id,n=T.isString(u?.source)?u?.source:u?.source?.id;if(r===n)if(s.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const d=this.d[c];d&&(this.w(c,d),this.r(c,d))}}this.u()}deltaConfiguration(i){let s=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,o){i.forEach(l=>{this.p(l,s,l.extensionInfo,l.restrictedProperties,void 0,o),this.c.push(l),this.q(l)})}o(i,s){const o=l=>{if(l.properties)for(const c in l.properties){s.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>o(c))};for(const l of i){o(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(i,s=!0,o,l,c=3,u){c=T.isUndefinedOrNull(i.scope)?c:i.scope;const r=i.properties;if(r)for(const d in r){const E=r[d];if(s&&b(d,E)){delete r[d];continue}if(E.source=o,E.defaultDefaultValue=r[d].default,this.w(d,E),e.OVERRIDE_PROPERTY_REGEX.test(d)?E.scope=void 0:(E.scope=T.isUndefinedOrNull(E.scope)?c:E.scope,E.restricted=T.isUndefinedOrNull(E.restricted)?!!l?.includes(d):E.restricted),r[d].hasOwnProperty("included")&&!r[d].included){this.f[d]=r[d],delete r[d];continue}else this.d[d]=r[d],r[d].policy?.name&&this.e.set(r[d].policy.name,d);!r[d].deprecationMessage&&r[d].markdownDeprecationMessage&&(r[d].deprecationMessage=r[d].markdownDeprecationMessage),u.add(d)}const n=i.allOf;if(n)for(const d of n)this.p(d,s,o,l,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=o=>{const l=o.properties;if(l)for(const u in l)this.r(u,l[u]);o.allOf?.forEach(s)};s(i)}r(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,o),e.allSettings.properties[s]=o,e.applicationSettings.properties[s]=o,e.machineSettings.properties[s]=o,e.machineOverridableSettings.properties[s]=o,e.windowSettings.properties[s]=o,e.resourceSettings.properties[s]=o}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,s){const o=this.a.get(i);let l=o?.value,c=o?.source;T.isUndefined(l)&&(l=s.defaultDefaultValue,c=void 0),T.isUndefined(l)&&(l=f(s.type)),s.default=l,s.defaultValueSource=c}}const C="\\[([^\\]]+)\\]",v=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=v.exec(g);for(;s?.length;){const o=s[1].trim();o&&i.push(o),s=v.exec(g)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=m;function h(g){return g.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=h;function f(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new w;y.Registry.add(e.Extensions.Configuration,p);function b(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?R.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?R.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function S(){const g=[],i=p.getConfigurationProperties();for(const s of Object.keys(i))g.push([s,i[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=S}),define(ye[206],Ce([1,0,16,3,146,6,28,22,10,2,53,127,33]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(s={},o=[],l=[],c){this.c=s,this.d=o,this.f=l,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof C)return o;const l=new v("");return l.parseRaw(o),l.configurationModel});this.g=s.reduce((o,l)=>l===o?l:o.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,o){const l=this.rawConfiguration.getValue(s),c=o?this.rawConfiguration.getOverrideValue(s,o):void 0,u=o?this.rawConfiguration.override(o).getValue(s):l;return{value:l,override:c,merged:u}}getOverrideValue(s,o){const l=this.l(o);return l?s?(0,L.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const l of this.overrides)l.identifiers.includes(s)&&o.push(...l.keys);return a.distinct(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return a.distinct(s)}override(s){let o=this.b.get(s);return o||(o=this.h(s),this.b.set(s,o)),o}merge(...s){const o=A.deepClone(this.contents),l=A.deepClone(this.overrides),c=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const r of s)if(u.push(...r.raw?.length?r.raw:[r]),!r.isEmpty()){this.j(o,r.contents);for(const n of r.overrides){const[d]=l.filter(E=>a.equals(E.identifiers,n.identifiers));d?(this.j(d.contents,n.contents),d.keys.push(...n.keys),d.keys=a.distinct(d.keys)):l.push(A.deepClone(n))}for(const n of r.keys)c.indexOf(n)===-1&&c.push(n)}return new C(o,c,l,u.every(r=>r instanceof C)?void 0:u)}freeze(){return this.a=!0,this}h(s){const o=this.l(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const l={};for(const c of a.distinct([...Object.keys(this.contents),...Object.keys(o)])){let u=this.contents[c];const r=o[c];r&&(typeof u=="object"&&typeof r=="object"?(u=A.deepClone(u),this.j(u,r)):u=r),l[c]=u}return new C(l,this.keys,this.overrides)}j(s,o){for(const l of Object.keys(o)){if(l in s&&y.isObject(s[l])&&y.isObject(o[l])){this.j(s[l],o[l]);continue}s[l]=A.deepClone(o[l])}}k(s){return this.a&&!Object.isFrozen(s)?A.deepFreeze(s):s}l(s){let o=null,l=null;const c=u=>{u&&(l?this.j(l,u):l=A.deepClone(u))};for(const u of this.overrides)a.equals(u.identifiers,[s])?o=u.contents:u.identifiers.includes(s)&&c(u.contents);return c(o),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,o){this.m(s),(0,L.addToValueTree)(this.contents,s,o,l=>{throw new Error(l)})}removeValue(s){this.n(s)&&(0,L.removeFromValueTree)(this.contents,s)}m(s){let o=this.keys.length;for(let l=0;l<o;l++)s.indexOf(this.keys[l])===0&&(o=l);this.keys.splice(o,1,s)}n(s){const o=this.keys.indexOf(s);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=C;class v{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!y.isUndefinedOrNull(s)){const l=this.g(s);this.parseRaw(l,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:l,keys:c,overrides:u,restricted:r,hasExcludedProperties:n}=this.h(s,o);this.b=new C(l,c,u,n?[s]:void 0),this.c=r||[]}g(s){let o={},l=null,c=[];const u=[],r=[];function n(E){Array.isArray(c)?c.push(E):l!==null&&(c[l]=E)}const d={onObjectBegin:()=>{const E={};n(E),u.push(c),c=E,l=null},onObjectProperty:E=>{l=E},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const E=[];n(E),u.push(c),c=E,l=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:n,onError:(E,k,M)=>{r.push({error:E,offset:k,length:M})}};if(s)try{T.visit(s,d),o=c[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return o}h(s,o){const l=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),c=this.j(s,l,!0,o);s=c.raw;const u=(0,L.toValuesTree)(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),r=Object.keys(s),n=this.l(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:u,keys:r,overrides:n,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(s,o,l,c){let u=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:u};const r={},n=[];for(const d in s)if(P.OVERRIDE_PROPERTY_REGEX.test(d)&&l){const E=this.j(s[d],o,!1,c);r[d]=E.raw,u=u||E.hasExcludedProperties,n.push(...E.restricted)}else{const E=o[d],k=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&n.push(d),(k===void 0||c.scopes===void 0||c.scopes.includes(k))&&!(c.skipRestricted&&E?.restricted)?r[d]=s[d]:u=!0}return{raw:r,restricted:n,hasExcludedProperties:u}}l(s,o){const l=[];for(const c of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const r in s[c])u[r]=s[c][r];l.push({identifiers:(0,P.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,L.toValuesTree)(u,o)})}return l}}e.ConfigurationModelParser=v;class m extends R.Disposable{constructor(s,o,l,c){super(),this.f=s,this.g=o,this.h=c,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(l.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&l.isEqual(u.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=m;class h{constructor(s,o,l,c,u,r,n,d,E,k,M,K,q){this.a=s,this.b=o,this.value=l,this.overrideIdentifiers=c,this.c=u,this.d=r,this.f=n,this.g=d,this.h=E,this.j=k,this.k=M,this.l=K,this.m=q}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class f{constructor(s,o,l,c,u=new C,r=new C,n=new I.ResourceMap,d=new C,E=new I.ResourceMap,k=!0){this.c=s,this.d=o,this.f=l,this.g=c,this.h=u,this.j=r,this.l=n,this.m=d,this.n=E,this.p=k,this.a=null,this.b=new I.ResourceMap,this.q=null}getValue(s,o,l){return this.s(s,o,l).getValue(s)}updateValue(s,o,l={}){let c;l.resource?(c=this.n.get(l.resource),c||(c=new C,this.n.set(l.resource,c))):c=this.m,o===void 0?c.removeValue(s):c.setValue(s,o),l.resource||(this.a=null)}inspect(s,o,l){const c=this.s(s,o,l),u=this.w(o.resource,l),r=o.resource?this.n.get(o.resource)||this.m:this.m,n=new Set;for(const d of c.overrides)for(const E of d.identifiers)c.getOverrideValue(s,E)!==void 0&&n.add(E);return new h(s,o,c.getValue(s),n.size?[...n]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this.j.freeze():void 0,u?u.freeze():void 0,r.inspect(s,o.overrideIdentifier))}keys(s){const o=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.l.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const l=[];if(!o){const{added:c,updated:u,removed:r}=S(this.c,s);o=[...c,...u,...r]}for(const c of o)for(const u of(0,P.overrideIdentifiersFromKey)(c)){const r=this.c.getKeysForOverrideIdentifier(u),n=s.getKeysForOverrideIdentifier(u),d=[...n.filter(E=>r.indexOf(E)===-1),...r.filter(E=>n.indexOf(E)===-1),...r.filter(E=>!A.equals(this.c.override(u).getValue(E),s.override(u).getValue(E)))];l.push([u,d])}return this.updateDefaultConfiguration(s),{keys:o,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:l,removed:c}=S(this.d,s),u=[...o,...l,...c];return u.length&&this.updatePolicyConfiguration(s),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:l,removed:c,overrides:u}=S(this.applicationConfiguration,s),r=[...o,...l,...c];return r.length&&this.updateApplicationConfiguration(s),{keys:r,overrides:u}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:l,removed:c,overrides:u}=S(this.localUserConfiguration,s),r=[...o,...l,...c];return r.length&&this.updateLocalUserConfiguration(s),{keys:r,overrides:u}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:l,removed:c,overrides:u}=S(this.remoteUserConfiguration,s),r=[...o,...l,...c];return r.length&&this.updateRemoteUserConfiguration(s),{keys:r,overrides:u}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:l,removed:c,overrides:u}=S(this.workspaceConfiguration,s),r=[...o,...l,...c];return r.length&&this.updateWorkspaceConfiguration(s),{keys:r,overrides:u}}compareAndUpdateFolderConfiguration(s,o){const l=this.r.get(s),{added:c,updated:u,removed:r,overrides:n}=S(l,o),d=[...c,...u,...r];return(d.length||!l)&&this.updateFolderConfiguration(s,o),{keys:d,overrides:n}}compareAndDeleteFolderConfiguration(s){const o=this.r.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:c,removed:u,overrides:r}=S(o,void 0);return{keys:[...l,...c,...u],overrides:r}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,o,l){let c=this.t(o,l);return o.overrideIdentifier&&(c=c.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(c=c.merge(this.d)),c}t({resource:s},o){let l=this.u();if(o&&s){const c=o.getFolder(s);c&&(l=this.v(c.uri)||l);const u=this.n.get(s);u&&(l=l.merge(u))}return l}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let o=this.b.get(s);if(!o){const l=this.u(),c=this.l.get(s);c?(o=l.merge(c),this.p&&(o=o.freeze()),this.b.set(s,o)):o=l}return o}w(s,o){if(o&&s){const l=o.getFolder(s);if(l)return this.l.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,o)=>{const{contents:l,overrides:c,keys:u}=this.l.get(o);return s.push([o,{contents:l,overrides:c,keys:u}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(o=>s.add(o)),this.userConfiguration.freeze().keys.forEach(o=>s.add(o)),this.j.freeze().keys.forEach(o=>s.add(o)),this.l.forEach(o=>o.freeze().keys.forEach(l=>s.add(l))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.l.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}y(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>o.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>o.add(l)),this.j.getKeysForOverrideIdentifier(s).forEach(l=>o.add(l)),this.l.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(c=>o.add(c))),[...o.values()]}static parse(s){const o=this.z(s.defaults),l=this.z(s.policy),c=this.z(s.application),u=this.z(s.user),r=this.z(s.workspace),n=s.folders.reduce((d,E)=>(d.set(D.URI.revive(E[0]),this.z(E[1])),d),new I.ResourceMap);return new f(o,l,c,u,new C,r,n,new C,new I.ResourceMap,!1)}static z(s){return new C(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=f;function p(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,o=new Map;for(const c of i)c.keys.forEach(u=>s.add(u)),c.overrides.forEach(([u,r])=>{const n=(0,I.getOrSet)(o,u,new Set);r.forEach(d=>n.add(d))});const l=[];return o.forEach((c,u)=>l.push([u,[...c.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=p;class b{constructor(s,o,l,c){this.change=s,this.f=o,this.g=l,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const u of s.keys)this.affectedKeys.add(u);for(const[,u]of s.overrides)for(const r of u)this.affectedKeys.add(r);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=f.parse(this.f.data)),this.j}affectsConfiguration(s,o){const l=this.a+s,c=this.d.indexOf(l);if(c<0)return!1;const u=c+l.length;if(u>=this.d.length)return!1;const r=this.d.charCodeAt(u);if(r!==this.b&&r!==this.c)return!1;if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,d=this.g.getValue(s,o,this.h);return!A.equals(n,d)}return!0}}e.ConfigurationChangeEvent=b;function S(i,s){const{added:o,removed:l,updated:c}=g(s?.rawConfiguration,i?.rawConfiguration),u=[],r=i?.getAllOverrideIdentifiers()||[],n=s?.getAllOverrideIdentifiers()||[];if(s){const d=n.filter(E=>!r.includes(E));for(const E of d)u.push([E,s.getKeysForOverrideIdentifier(E)])}if(i){const d=r.filter(E=>!n.includes(E));for(const E of d)u.push([E,i.getKeysForOverrideIdentifier(E)])}if(s&&i){for(const d of r)if(n.includes(d)){const E=g({contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)},{contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)});u.push([d,[...E.added,...E.removed,...E.updated]])}}return{added:o,removed:l,updated:c,overrides:u}}function g(i,s){const o=i?s?i.keys.filter(u=>s.keys.indexOf(u)===-1):[...i.keys]:[],l=s?i?s.keys.filter(u=>i.keys.indexOf(u)===-1):[...s.keys]:[],c=[];if(i&&s){for(const u of s.keys)if(i.keys.indexOf(u)!==-1){const r=(0,L.getConfigurationValue)(s.contents,u),n=(0,L.getConfigurationValue)(i.contents,u);A.equals(r,n)||c.push(u)}}return{added:o,removed:l,updated:c}}}),define(ye[128],Ce([1,0,9,4]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends a.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===T.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,D=T.Unknown,L){super(y),this._message=y,this._code=D,this._detail=L,this.isHandled=D===T.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function I(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=I}),define(ye[69],Ce([1,0,17]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===a.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function T(D){if(!D)return;const L=D.indexOf("+");return L<0?D:D.substr(0,L)}e.getRemoteName=T;function R(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=R;function I(D){const{host:L,port:P}=y(D);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=I;function A(D,L){let{host:P,port:w}=y(D);return typeof w>"u"&&(w=L),{host:P,port:w}}e.parseAuthorityWithOptionalPort=A;function y(D){const L=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=D.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const w=D.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:D,port:void 0}}}),define(ye[27],Ce([1,0,8,4,69]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=R;function I(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,h){if(typeof m>"u"||m===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof m=="string"||typeof h=="string"){const f=typeof m=="string"?m:m.value,p=typeof h=="string"?h:h.value;return a.equalsIgnoreCase(f,p)}return m.c===h.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=D;function L(v){return P(v)}e.isApplicationScopedExtension=L;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function w(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function C(v,m){if(m){const h=`onResolveRemoteAuthority:${(0,T.getRemoteName)(m)}`;return v.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[207],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((T,R)=>te(["vsda"],T,R))}async createNewMessage(T){try{const R=await this.c(),I=new R.validator;if(I){const A=String(a.a++);return this.b.set(A,I),{id:A,data:I.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,R){if(!T.id)return!0;const I=this.b.get(T.id);if(!I)return!1;this.b.delete(T.id);try{return I.validate(R)==="ok"}catch{return!1}}async sign(T){try{const R=await this.c(),I=new R.signer;if(I)return I.sign(T)}catch{}return T}}e.SignService=a,a.a=1}),define(ye[208],Ce([1,0,12,37,2,30]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(D){if(a.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function A(D,L,P,w,C,v,m,h,f,p){const b=Object.create(null);b["common.machineId"]=m,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=C,b.version=v,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,a.PlatformToString)(a.platform),b["common.nodePlatform"]=t.platform,b["common.nodeArch"]=w,b["common.product"]=p||"desktop",h&&(b["common.msftInternal"]=h);let S=0;const g=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),a.isLinuxSnap&&(b["common.snap"]="true");const i=I(P);i&&(b["common.platformDetail"]=i);try{const s=await D.readFile(T.URI.file(f));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(D){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return D.some(w=>P===w)}e.verifyMicrosoftInternalDomain=y}),define(ye[209],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[70],Ce([1,0,22,10,3,53,69,208,209]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class D{constructor(r){this.value=r}}e.TelemetryTrustedValue=D;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,n){return Promise.resolve(void 0)}publicLog2(r,n){return this.publicLog(r,n)}publicLogError(r,n){return Promise.resolve(void 0)}publicLogError2(r,n){return this.publicLogError(r,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class P{async publicLog(r,n,d){}async publicLogError(r,n,d){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(u,r){return T.Event.debounce(r.onDidChangeConfiguration,(d,E)=>{const k=d?new Set([...d.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:k}},1e3,!0)(d=>{d.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(d.source),configurationKeys:S(d.affectedKeys)})})}e.configurationTelemetry=w;function C(u,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!u.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=C;function v(u,r){return!(r.isBuilt||r.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=v;function m(u){const r=u.getValue(y.TELEMETRY_SETTING_ID),n=u.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function h(u){const r={},n={},d={};b(u,d);for(let E in d){E=E.length>150?E.substr(E.length-149):E;const k=d[E];typeof k=="number"?n[E]=k:typeof k=="boolean"?n[E]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${k.length}`),r[E]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(r[E]=k)}return{properties:r,measurements:n}}e.validateTelemetryData=h;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(u){if(!u)return"none";const r=(0,I.getRemoteName)(u);return f.has(r)?r:"other"}e.cleanRemoteAuthority=p;function b(u,r,n=0,d){if(!!u)for(const E of Object.getOwnPropertyNames(u)){const k=u[E],M=d?d+E:E;Array.isArray(k)?r[M]=(0,a.safeStringify)(k):k instanceof Date?r[M]=k.toISOString():(0,t.isObject)(k)?n<2?b(k,r,n+1,M+"."):r[M]=(0,a.safeStringify)(k):r[M]=k}}function S(u){if(!u)return[];const r=[];return g(r,"",u),r}function g(u,r,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(d=>g(u,r?`${r}.${d}`:d,n[d])):u.push(r)}function i(u,r){const n=u.msftInternalDomains||[],d=r.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||d}e.isInternalTelemetry=i;function s(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=s;function o(u,r){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const d=[];for(const K of r)for(;;){const q=K.exec(u);if(!q)break;d.push([q.index,K.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(n="";;){const K=k.exec(u);if(!K)break;const q=d.some(([F,B])=>K.index<B&&F<k.lastIndex);!E.test(K[0])&&!q&&(n+=u.substring(M,K.index)+"<REDACTED: user-file-path>",M=k.lastIndex)}return M<u.length&&(n+=u.substr(M)),n}function l(u){if(!u)return u;const r=u.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(r))return`<REDACTED: ${d.label}>`;return u}function c(u,r){return(0,a.cloneAndChange)(u,n=>{if(n instanceof D)return n.value;if(typeof n=="string"){let d=n.replaceAll("%20"," ");d=o(d,r);for(const E of r)d=d.replace(E,"");return d=l(d),d}})}e.cleanData=c}),define(ye[210],Ce([1,0,8,123,27,12,2,9,37,70]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(o,l){return o.uuid&&l.uuid?o.uuid===l.uuid:o.id===l.id?!0:(0,a.compareIgnoreCase)(o.id,l.id)===0}e.areSameExtensions=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(l){const c=l.manifest?l.manifest.version:l.version,u=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new w(l.identifier,c,u)}static parse(l){const c=P.exec(l);return c&&c[1]&&c[2]?new w({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,u="undefined"){this.version=c,this.targetPlatform=u,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof w?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=w;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const l=C.exec(o);return l&&l[1]?[h(l[1]),l[2]]:[h(o),void 0]}e.getIdAndVersion=v;function m(o,l){return`${o}.${l}`}e.getExtensionId=m;function h(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function f(o,l){return h(m(o,l))}e.getGalleryExtensionId=f;function p(o,l){const c=[],u=r=>{for(const n of c)if(n.some(d=>L(l(d),l(r))))return n;return null};for(const r of o){const n=u(r);n?n.push(r):c.push([r])}return c}e.groupByExtension=p;function b(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function S(o){return{id:new D.TelemetryTrustedValue(o.identifier.id),name:new D.TelemetryTrustedValue(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function g(o,l){const c=[],u=l.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const r=u.shift();if(r&&c.every(n=>!L(n.identifier,{id:r}))){const n=o.filter(d=>L(d.identifier,{id:r}));n.length===1&&(c.push(n[0]),u.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=g;async function i(o,l){if(!R.isLinux)return!1;let c;try{c=(await o.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){l.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(r))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function s(o,l){const c=await i(o,l),u=(0,t.getTargetPlatform)(c?"alpine":R.platform,y.arch);return l.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=s}),define(ye[211],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(T){this.b=T,this.a=new Map}dispose(){for(const T of this.a.values())T.dispose()}startBuffering(T,R,I=5){const A=R(y=>{const D=typeof y=="string"?y:y.data;let L=this.a.get(T);if(L){L.data.push(D);return}const P=setTimeout(()=>this.flushBuffer(T),I);L={data:[D],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(T),A.dispose()}},this.a.set(T,L)});return A}stopBuffering(T){this.a.get(T)?.dispose()}flushBuffer(T){const R=this.a.get(T);R&&(this.a.delete(T),this.b(T,R.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[212],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===a.HIGH_CONTRAST_DARK||R===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function T(R){return R===a.DARK||R===a.HIGH_CONTRAST_DARK}e.isDark=T}),define(ye[71],Ce([1,0,50,3,6,4,33,212]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var y;(function(h){function f(p){return p&&typeof p=="object"&&typeof p.id=="string"}h.isThemeColor=f})(y=e.ThemeColor||(e.ThemeColor={}));function D(h){return{id:h}}e.themeColorFromId=D;var L;(function(h){function f(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||y.isThemeColor(l.color))}h.isThemeIcon=f;const p=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function b(l){const c=p.exec(l);if(!c)return;const[,u]=c;return{id:u}}h.fromString=b;function S(l){return{id:l}}h.fromId=S;function g(l,c){let u=l.id;const r=u.lastIndexOf("~");return r!==-1&&(u=u.substring(0,r)),c&&(u=`${u}~${c}`),{id:u}}h.modify=g;function i(l){const c=l.id.lastIndexOf("~");if(c!==-1)return l.id.substring(c+1)}h.getModifier=i;function s(l,c){return l.id===c.id&&l.color?.id===c.color?.id}h.isEqual=s;function o(l,c){return{id:l.id,color:c?D(c):void 0}}h.asThemeIcon=o,h.asClassNameArray=a.CSSIcon.asClassNameArray,h.asClassName=a.CSSIcon.asClassName,h.asCSSSelector=a.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function P(h){switch(h){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(f){return this.a.push(f),this.b.fire(f),(0,T.toDisposable)(()=>{const p=this.a.indexOf(f);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const C=new w;I.Registry.add(e.Extensions.ThemingContribution,C);function v(h){return C.onColorThemeChange(h)}e.registerThemingParticipant=v;class m extends T.Disposable{constructor(f){super(),this.k=f,this.h=f.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(f){this.h=f,this.updateStyles()}updateStyles(){}w(f,p){let b=this.h.getColor(f);return b&&p&&(b=p(b,this.h)),b?b.toString():null}}e.Themable=m}),define(ye[213],Ce([1,0,14,50,3,10,2,174,91,33,71]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var P;(function(S){function g(i,s){let o=i.defaults;for(;L.ThemeIcon.isThemeIcon(o);){const l=v.getIcon(o.id);if(!l)return;o=l.defaults}return o}S.getDefinition=g})(P=e.IconContribution||(e.IconContribution={}));var w;(function(S){function g(s){return{weight:s.weight,style:s.style,src:s.src.map(o=>({format:o.format,location:o.location.toString()}))}}S.toJSONObject=g;function i(s){const o=l=>(0,R.isString)(l)?l:void 0;if(s&&Array.isArray(s.src)&&s.src.every(l=>(0,R.isString)(l.format)&&(0,R.isString)(l.location)))return{weight:o(s.weight),style:o(s.style),src:s.src.map(l=>({format:l.format,location:I.URI.parse(l.location)}))}}S.fromJSONObject=i})(w=e.IconFontDefinition||(e.IconFontDefinition={}));class C{constructor(){this.a=new T.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${t.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,i,s,o){const l=this.b[g];if(l){if(s&&!l.description){l.description=s,this.d.properties[g].markdownDescription=`${s} $(${g})`;const r=this.e.enum.indexOf(g);r!==-1&&(this.e.enumDescriptions[r]=s),this.a.fire()}return l}const c={id:g,description:s,defaults:i,deprecationMessage:o};this.b[g]=c;const u={$ref:"#/definitions/icons"};return o&&(u.deprecationMessage=o),s&&(u.markdownDescription=`${s}: $(${g})`),this.d.properties[g]=u,this.e.enum.push(g),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,i){const s=this.f[g];return s||(this.f[g]=i,this.a.fire(),i)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(l,c)=>l.id.localeCompare(c.id),i=l=>{for(;L.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(l=>this.b[l]);for(const l of o.filter(c=>!!c.description).sort(g))s.push(`|<i class="${i(l)}"></i>|${l.id}|${L.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const l of o.filter(c=>!L.ThemeIcon.isThemeIcon(c.defaults)).sort(g))s.push(`|<i class="${i(l)}"></i>|${l.id}|`);return s.join(`
`)}}const v=new C;D.Registry.add(e.Extensions.IconContribution,v);function m(S,g,i,s){return v.registerIcon(S,g,i,s)}e.registerIcon=m;function h(){return v}e.getIconRegistry=h;function f(){for(const S of t.Codicon.getAll())v.registerIcon(S.id,S.definition,S.description)}f(),e.iconsSchemaId="vscode://schemas/icons";const p=D.Registry.as(y.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,v.getIconSchema());const b=new a.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);v.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=m("widget-close",t.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=m("goto-previous-location",t.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=m("goto-next-location",t.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=L.ThemeIcon.modify(t.Codicon.sync,"spin"),e.spinningLoading=L.ThemeIcon.modify(t.Codicon.loading,"spin")}),define(ye[129],Ce([1,0,3,53,4,13]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var I;(function(m){m.Http="http",m.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=P;function w(m,h,f,p){if(f===1)return!1;if(f===2&&P(h)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return m<1024}e.isPortPrivileged=w;class C{constructor(h,f,p){this.remoteAddress=h,this.localAddress=f,this.b=p,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=C;let v=class{constructor(h,f){this.i=h,this.j=f,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],f=Array.from(this.d.values());for(const p of f){const b=Array.from(p.values());for(const S of b){const g=await S.value;g&&h.push(g)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:f}of h.values())await f.then(p=>p?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,f,p,b,S){this.o(h,f,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:f,localAddress:p,privacy:b,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,f){(P(h)||L(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const p=this.q(h,f);if(p)return++p.refcount,p.value}openTunnel(h,f,p,b,S=!1,g,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${b}.`),!h)return;if(f||(f="localhost"),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(h,f,p,b,S,g,i);return s?s.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(o);return(o.tunnelRemoteHost!==f||o.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this.d.get(h.tunnelRemoteHost);if(f){const p=f.get(h.tunnelRemotePort);p&&(p.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,p))}}}}async n(h,f,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const b=p.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(f),b}}async closeTunnel(h,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const p=this.d.get(h);if(p&&p.has(f)){const b=p.get(f);b.refcount=0,await this.n(h,f,b)}}o(h,f,p){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(f,{refcount:1,value:p})}async p(h,f){const p=this.d.get(h);p&&(await p.get(f)||p.delete(f),p.size===0&&this.d.delete(h))}q(h,f){const p=[h];L(h)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):P(h)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(S=>this.d.get(S));for(const S of b){const g=S?.get(f);if(g)return g}}canTunnel(h){return!!D(h)}s(h,f,p,b,S,g,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${b}.`);const s=p;this.h.add(s);const o=b===void 0?p:b,l={elevationRequired:S?this.isPortPrivileged(o):!1},c={remoteAddress:{host:f,port:p},localAddressPort:b,privacy:g,public:g?g!==A.Private:void 0,protocol:i},u=h.forwardPort(c,l);return u?(this.o(f,p,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),u}};v=qe([We(0,R.ILogService),We(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(ye[214],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var t;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[215],Ce([1,0,17]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(y){return y.scheme!==a.Schemas.file&&y.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=t;function T(y){if(y.folders.length)return y.folders.every(D=>t(D.uri))?y.folders[0].uri:void 0;if(y.configuration&&t(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=T;function R(y){return T(y)?.scheme}e.getVirtualWorkspaceScheme=R;function I(y){return T(y)?.authority}e.getVirtualWorkspaceAuthority=I;function A(y){return T(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],Ce([1,0,175,11,66,24,2,4,17]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function D(o){const l=o;return typeof l?.id=="string"&&I.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=D;function L(o){return typeof o?.id=="string"&&!D(o)&&!w(o)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(o,l){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=o;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=P;function w(o){const l=o;return typeof l?.id=="string"&&I.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=w;function C(o){const l=o;if(l?.uri)return{id:l.id,uri:I.URI.revive(l.uri)};const c=o;if(c?.configPath)return{id:c.id,configPath:I.URI.revive(c.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=C;var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function m(o){const l=o;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=m;function h(o){const l=o;return!!(l&&typeof l=="object"&&I.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=h;class f{constructor(l,c,u,r,n){this.h=l,this.j=u,this.k=r,this.l=n,this.c=T.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=T.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(l,c){this.raw=c,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(o){return new p({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(o,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,l.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function g(o){let l;return I.URI.isUri(o)?l=o:l=o.configuration,l?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=g;function i(o,l){return!S(o,l)&&!g(o)}e.isSavedWorkspace=i;function s(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[72],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(T){this.d=T,this.b=new Map,this.c=1}add(T){const R=this.c++;return this.b.set(R,T),this.e(),R}get(T,R){return this.b.has(T)?this.b.get(T)[R]:void 0}delete(T){this.b.delete(T),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=a,a.a=!1}),define(ye[48],Ce([1,0,17,24,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[216],Ce([1,0,14]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(I,A,y){this.h=new Map,this.a=I,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new a.RunOnceScheduler(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of D.values())L.complete()}catch(L){for(const P of D.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,A){let y=this.f[I];return typeof y>"u"&&(y=A),y}update(I,A){this.f[I]=A;const y=this.h.get(I);if(y!==void 0)return y.p;const D=new a.DeferredPromise;return this.h.set(I,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class T extends t{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,A){super(I.identifier.value,!0,A),this.j=I}}e.ExtensionGlobalMemento=T}),define(ye[217],Ce([1,0,3,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(I){this.c=I,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,A,y,D){const P=this.c.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(A.value,y,D);this.b.fire(P)}$acceptDirtyStateChanged(I,A){this.c.getNotebookDocument(t.URI.revive(I)).acceptDirty(A)}$acceptModelSaved(I){const A=this.c.getNotebookDocument(t.URI.revive(I));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(ye[18],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=t});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[218],Ce([1,0,27,3]),function(te,e,a,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){T.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(A.identifier),Ye(this,T,y,"f"),Ue(this,T,"f").onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return Ue(this,T,"f").get(this.a,A)}store(A,y){return Ue(this,T,"f").store(this.a,A,y)}delete(A){return Ue(this,T,"f").delete(this.a,A)}}e.ExtensionSecrets=R,T=new WeakMap}),define(ye[55],Ce([1,0,4,129,3,18]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function D(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=D;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=L})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,L){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,L){return{dispose:()=>{}}}async $providePortAttributes(D,L,P,w,C){return[]}async $forwardPort(D,L){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[56],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=t}),define(ye[219],Ce([1,0,23]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let D=this.buffers.indexOf(y);return D<0&&(D=this.buffers.length,this.buffers.push(y)),D}}function T(A,y){if(y.serializeBuffersForPostMessage){const D=new t,L=(C,v)=>{if(v instanceof ArrayBuffer){const m=D.add(v);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(v)){const m=R(v);if(m){const h=D.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:m,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(A,L),w=D.buffers.map(C=>{const v=new Uint8Array(C);return a.VSBuffer.wrap(v)});return{message:P,buffers:w}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=T;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,y){const D=y.map(w=>{const C=new ArrayBuffer(w.byteLength);return new Uint8Array(C).set(w.buffer),C}),L=y.length?(w,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const v=C,{index:m}=v,h=D[m];if(v.view)switch(v.view.type){case 1:return new Int8Array(h,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return C}:void 0;return{message:JSON.parse(A,L),arrayBuffers:D}}e.deserializeWebviewMessage=I}),define(ye[220],Ce([1,0,114]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(R){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:R,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function T(R){return new a.URITransformer(t(R))}e.createURITransformer=T}),define(ye[130],Ce([1,0,185,10,2,6,4,33,40,17,45,160,38]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(C=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var v;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(v=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(X){const G=X;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=m;function h(X,G,de){for(const be of de.visibleEditorPanes)if(be.group.id===G&&X.matches(be.input))return be.getViewState()}e.findViewStateForEditor=h;function f(X){if(n(X))return!1;const G=X;return T.URI.isUri(G?.resource)}e.isResourceEditorInput=f;function p(X){if(n(X))return!1;const G=X;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=p;function b(X){if(n(X)||p(X))return!1;const G=X;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function S(X){if(n(X))return!1;const G=X;return G?G.resource===void 0||G.resource.scheme===D.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;const g=/Untitled-\d+/;function i(X){return X.scheme===D.Schemas.untitled&&X.path.length>1&&!g.test(X.path)}e.isUntitledWithAssociatedResource=i;function s(X){if(n(X))return!1;const G=X;return T.URI.isUri(G?.base?.resource)&&T.URI.isUri(G?.input1?.resource)&&T.URI.isUri(G?.input2?.resource)&&T.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=s;var o;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var l;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.a=new Map}registerSource(G,de){let be=this.a.get(G);return be||(be={source:G,label:de},this.a.set(G,be)),be.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.SaveSourceRegistry=new c;var u;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends R.Disposable{}e.AbstractEditorInput=r;function n(X){return X instanceof r}e.isEditorInput=n;function d(X){const G=X;return T.URI.isUri(G?.preferredResource)}function E(X){const G=X;return n(G?.primary)&&n(G?.secondary)}e.isSideBySideEditorInput=E;function k(X){const G=X;return n(G?.modified)&&n(G?.original)}e.isDiffEditorInput=k;function M(X,G,de,be,Ee){return ee(be,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const Pe={...de,limits:{size:Number.MAX_VALUE}};X.openEditor(G,Pe)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.createTooLargeFileError=M;function K(X){return n(X?.editor)}e.isEditorInputWithOptions=K;function q(X){const G=X;return K(X)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function F(X){const G=X;return typeof G?.groupId=="number"&&n(G.editor)}e.isEditorIdentifier=F;var B;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(G,de){if(!G)return;if(s(G))return e.EditorResourceAccessor.getOriginalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||s(G))return;const be=d(G)?G.preferredResource:G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}a(G){return E(G)||b(G)?{primary:G.primary,secondary:G.secondary}:k(G)||p(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,de){if(!G)return;if(s(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||s(G))return;const be=G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}b(G,de){if(Array.isArray(de)){if(de.some(be=>G.scheme===be))return G}else if(de===G.scheme)return G}}e.EditorResourceAccessor=new $;var j;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class ue{constructor(){this.c=new Map,this.d=new Map}start(G){const de=this.a=G.get(I.IInstantiationService);for(const[be,Ee]of this.c)this.e(be,Ee,de);this.c.clear()}e(G,de,be){const Ee=be.createInstance(de);this.d.set(G,Ee)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(G,de){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,de,this.a):this.c.set(G,de),(0,R.toDisposable)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new ue);async function V(X,G,de){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Ee=T.URI.revive(be.fileUri);if(!Ee){de.info("Cannot resolve the path because it is not valid.",be);return}if(!await G.canHandleResource(Ee)){de.info("Cannot resolve the path because it cannot be handled",be);return}let Fe=be.exists,se=be.type;if(typeof Fe!="boolean"||typeof se!="number")try{se=(await G.stat(Ee)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Fe=!0}catch(fe){de.error(fe),Fe=!1}if(!Fe&&be.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",be);return}if(se===y.FileType.Directory){de.info("Cannot resolve the path because it is a directory",be);return}const oe={...be.options,pinned:!0};return Fe?{resource:Ee,options:oe}:{resource:Ee,options:oe,forceUntitled:!0}}))}e.pathsToEditors=V;var _;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(_=e.EditorsOrder||(e.EditorsOrder={}));function Y(X){const G=X;if(!G)return!1;const de=G;if(de.modified)return Y(de.modified);const be=G;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}e.isTextEditorViewState=Y;function ne(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=ne;function ee(X,G,de){const be=(0,L.createErrorWithActions)(X,G);return be.forceMessage=de?.forceMessage,be.forceSeverity=de?.forceSeverity,be.allowDialog=de?.allowDialog,be}e.createEditorOpenError=ee}),define(ye[221],Ce([1,0,3,186,4,6,28,33,16,61,22,50,213]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,w.registerIcon)("default-view-icon",P.Codicon.window,(0,t.localize)(0,null));var C;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(C=e.Extensions||(e.Extensions={}));var v;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function m(o){switch(o){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=m;class h extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(l,c,u){const r=this.get(l.id);if(r)return r;const n=l;return n.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,I.getOrSet)(this.g,c,[]).push(n),u?.isDefault&&this.h.push(n),this.c.fire({viewContainer:n,viewContainerLocation:c}),n}deregisterViewContainer(l){for(const c of this.g.keys()){const u=this.g.get(c),r=u?.indexOf(l);if(r!==-1){u?.splice(r,1),u.length===0&&this.g.delete(c),this.f.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(u=>u?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(c=>this.getViewContainerLocation(c)===l)}}A.Registry.add(C.ViewContainersRegistry,new h);var f;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function p(o,l){const c=o.group??f.More,u=l.group??f.More;return c!==u?c.localeCompare(u):(o.order??5)-(l.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new D.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:u})=>this.l(c,u)),this.c.fire(l)}deregisterViews(l,c){const u=this.m(l,c);u.length&&this.f.fire({views:u,viewContainer:c})}moveViews(l,c){for(const u of this.j.keys())if(u!==c){const r=this.m(l,u);r.length&&(this.l(r,c),this.g.fire({views:r,from:u,to:c}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const c of this.i){const u=(this.j.get(c)||[]).filter(r=>r.id===l)[0];if(u)return u}return null}getViewContainer(l){for(const c of this.i)if((this.j.get(c)||[]).filter(r=>r.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this.k.add(l,c),this.h.fire(l),(0,R.toDisposable)(()=>{this.k.delete(l,c),this.h.fire(l)})}registerViewWelcomeContent2(l,c){const u=new Map;for(const[r,n]of c)this.k.add(l,n),u.set(r,(0,R.toDisposable)(()=>{this.k.delete(l,n),this.h.fire(l)}));return this.h.fire(l),u}getViewWelcomeContent(l){const c=[];return this.k.forEach(l,u=>c.push(u)),c.sort(p)}l(l,c){let u=this.j.get(c);u||(u=[],this.j.set(c,u),this.i.push(c));for(const r of l){if(this.getView(r.id)!==null)throw new Error((0,t.localize)(1,null,r.id));u.push(r)}}m(l,c){const u=this.j.get(c);if(!u)return[];const r=[],n=[];for(const d of u)l.includes(d)?r.push(d):n.push(d);return r.length&&(n.length?this.j.set(c,n):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),r}}A.Registry.add(C.ViewsRegistry,new b),e.IViewsService=(0,T.createDecorator)("viewsService"),e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var S;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(S=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,c){this.c=!1,this.d=!1,(0,L.mixin)(this,l),this.d=!!c,this.resolve=async u=>{if(c&&!this.c){const r=await c(u);r&&(this.tooltip=this.tooltip??r.tooltip,this.command=this.command??r.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class s extends Error{constructor(l){super((0,t.localize)(2,null,l))}}e.NoTreeViewError=s}),define(ye[131],Ce([1,0,3,14,187]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,D,L){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof L=="number"){const w=setTimeout(()=>{clearTimeout(w);const C=this.f.get(P.seq);if(C){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,T.localize)(0,null,L,A)};C(v)}},L)}return D&&this.f.set(P.seq,D),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,t.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,D=this.f.get(y.request_seq);D&&(this.f.delete(y.request_seq),D(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,D)=>A.set(D,y)),await(0,t.timeout)(500),A.forEach((y,D)=>{y({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[222],Ce([1,0,188,54,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const R=w=>a.localize(51,null,w);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var I;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(I=e.State||(e.State={}));function A(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,T.createDecorator)("debugService");var P;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[223],Ce([1,0,8,2,11,22,17]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(o,l,c){return o.replace(A,function(u,r){return l&&r.length>0&&r[0]!=="_"?u:c&&c.hasOwnProperty(r)?c[r]:u})}e.formatPII=y;function D(o){const l={};for(const c of Object.keys(o))c.startsWith("!")||(l[c]=o[c]);return l}e.filterExceptionsFromTelemetry=D;function L(o){return o.configuration.request==="attach"&&!P(o)&&(!o.parentSession||L(o.parentSession))}e.isSessionAttach=L;function P(o){let l=o.configuration.type;if(!!l)return l==="vslsShare"&&(l=o.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(l,"extensionhost")||(0,a.equalsIgnoreCase)(l,"pwa-extensionhost")?o:o.parentSession?P(o.parentSession):void 0}e.getExtensionHostDebugSession=P;function w(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=w;function C(o,l,c){let u,r=0;const n=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=n.exec(o);){const E=d.index+1,k=E+d[0].length;if(E<=l&&k>=c){u=d[0],r=E;break}}if(u){const E=/\w+/g;let k=null;for(;(k=E.exec(u))&&!(k.index+1+r+k[0].length>=c););k&&(u=u.substring(0,E.lastIndex))}return u?{start:r,end:r+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=C;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(o){return!!(o&&o.match(v))}e.isUri=m;function h(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(m(o.path))return t.URI.parse(o.path);if((0,T.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function f(o){if(typeof o.path=="object"){const l=t.URI.revive(o.path);if(l)return l.scheme===I.Schemas.file?l.fsPath:l.toString()}return o.path}function p(o,l){const c=l?h:f,u=(0,R.deepClone)(o);return S(u,(r,n)=>{r&&n&&(n.path=c(n))}),u}e.convertToDAPaths=p;function b(o,l){const c=l?h:f,u=(0,R.deepClone)(o);return S(u,(r,n)=>{!r&&n&&(n.path=c(n))}),u}e.convertToVSCPaths=b;function S(o,l){switch(o.type){case"event":{const c=o;switch(c.event){case"output":l(!1,c.body.source);break;case"loadedSource":l(!1,c.body.source);break;case"breakpoint":l(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=o;switch(c.command){case"setBreakpoints":l(!0,c.arguments.source);break;case"breakpointLocations":l(!0,c.arguments.source);break;case"source":l(!0,c.arguments.source);break;case"gotoTargets":l(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(u=>l(!1,u));break;default:break}break}case"response":{const c=o;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(u=>l(!1,u.source));break;case"loadedSources":c.body.sources.forEach(u=>l(!1,u));break;case"scopes":c.body.scopes.forEach(u=>l(!1,u.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(u=>l(!1,u.source));break;case"setBreakpoints":c.body.breakpoints.forEach(u=>l(!1,u.source));break;case"disassemble":c.body?.instructions.forEach(r=>l(!1,r.location));break;default:break}break}}}function g(o){return o.filter(l=>!l.presentation?.hidden).sort((l,c)=>l.presentation?c.presentation?l.presentation.group?c.presentation.group?l.presentation.group!==c.presentation.group?l.presentation.group.localeCompare(c.presentation.group):i(l.presentation.order,c.presentation.order):-1:c.presentation.group?1:i(l.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=g;function i(o,l){return typeof o!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:o-l}async function s(o,l){const c=o.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(c!=="none"&&(await l.saveAll(),c==="allEditorsInActiveGroup")){const u=l.activeEditorPane;u&&u.input.resource?.scheme===I.Schemas.untitled&&await l.save({editor:u.input,groupId:u.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(ye[224],Ce([1,0,46,225,22,11,12,8,29,189,131]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(f,p){this.p=p,this.r=Buffer.allocUnsafe(0),this.t=-1,f.on("data",b=>this.w(b))}sendMessage(f){if(this.p){const p=JSON.stringify(f);this.p.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${P.a}${p}`,"utf8")}}w(f){for(this.r=Buffer.concat([this.r,f]);;){if(this.t>=0){if(this.r.length>=this.t){const p=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(b){this.m.fire(new Error((b.message||b)+`
`+p))}continue}}else{const p=this.r.indexOf(P.a);if(p!==-1){const S=this.r.toString("utf8",0,p).split(P.b);for(const g of S){const i=g.split(P.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(p+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class w extends P{startSession(){return new Promise((f,p)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),f(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.x.on("error",S=>{b?this.m.fire(S):p(S)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=w;class C extends w{constructor(f){super(),this.z=f}y(f){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.SocketDebugAdapter=C;class v extends w{constructor(f){super(),this.z=f}y(f){return t.createConnection(this.z.path,f)}}e.NamedPipeDebugAdapter=v;class m extends P{constructor(f,p){super(),this.y=f,this.z=p}async startSession(){const f=this.y.command,p=this.y.args,b=this.y.options||{};try{if(f)if(R.isAbsolute(f)){if(!await y.Promises.exists(f))throw new Error(D.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.z));let S=process.env;if(b.env&&Object.keys(b.env).length>0&&(S=T.mixin(T.deepClone(process.env),b.env)),f==="node")if(Array.isArray(p)&&p.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:S,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(i.cwd=b.cwd);const s=a.fork(p[0],p.slice(1),i);if(!s.pid)throw new Error(D.localize(2,null,p[0]));this.x=s}else throw new Error(D.localize(3,null));else{const g={env:S};b.cwd&&(g.cwd=b.cwd),this.x=a.spawn(f,p,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,i)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(S){this.m.fire(S)}}async stopSession(){return this.x?(await this.u(),I.isWindows?new Promise((f,p)=>{const b=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(S,g,i){if(S)return p(S)});b.on("exit",f),b.on("error",p)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,p){if(!f)return;const b=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?b.runtime=R.join(p,f.runtime):b.runtime=f.runtime),f.runtimeArgs&&(b.runtimeArgs=f.runtimeArgs),f.program&&(R.isAbsolute(f.program)?b.program=f.program:b.program=R.join(p,f.program)),f.args&&(b.args=f.args);const S=f;return S.win&&(b.win=m.A(S.win,p)),S.winx86&&(b.winx86=m.A(S.winx86,p)),S.windows&&(b.windows=m.A(S.windows,p)),S.osx&&(b.osx=m.A(S.osx,p)),S.linux&&(b.linux=m.A(S.linux,p)),b}static platformAdapterExecutable(f,p){let b=Object.create(null);p=p.toLowerCase();for(const l of f)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(u=>typeof u.type=="string"&&A.equalsIgnoreCase(u.type,p)).forEach(u=>{const r=m.A(u,l.extensionLocation.fsPath);b=T.mixin(b,r,l.isBuiltin)})}let S;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?S=b.winx86||b.win||b.windows:I.isWindows?S=b.win||b.windows:I.isMacintosh?S=b.osx:I.isLinux&&(S=b.linux),S=S||b;const g=S.program||b.program,i=S.args||b.args,s=S.runtime||b.runtime,o=S.runtimeArgs||b.runtimeArgs;if(s)return{type:"executable",command:s,args:(o||[]).concat(typeof g=="string"?[g]:[]).concat(i||[])};if(g)return{type:"executable",command:g,args:i||[]}}}e.ExecutableDebugAdapter=m}),define(ye[226],Ce([1,0,46,32,12]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(D,L){return new Promise((P,w)=>{let C="";const v=a.spawn(D,L);v.pid&&v.stdout.on("data",m=>{C+=m.toString()}),v.on("error",m=>{w(m)}),v.on("close",m=>{P(C)})})}async function I(D){if(D)if(T.isWindows){const L=await new Promise((P,w)=>{te(["windows-process-tree"],P,w)});return new Promise(P=>{L.getProcessTree(D,w=>{P(!!w&&w.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(D)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var A;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(A||(A={}));function y(D,L,P,w,C){D=D.trim().toLowerCase();let v;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?v=1:D.indexOf("cmd.exe")>=0?v=0:D.indexOf("bash")>=0?v=2:T.isWindows?v=0:v=2;let m,h=" ";switch(v){case 1:if(m=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),w){const f=(0,t.getDriveLetter)(w);f&&(h+=`${f}:; `),h+=`cd ${m(w)}; `}if(C)for(const f in C){const p=C[f];p===null?h+=`Remove-Item env:${f}; `:h+=`\${env:${f}}='${p}'; `}if(L.length>0){const f=L.shift(),p=P?f:m(f);h+=p[0]==="'"?`& ${p} `:`${p} `;for(const b of L)h+=b==="<"||b===">"||P?b:m(b),h+=" "}break;case 0:if(m=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>f.includes(p))||f.length===0?`"${f}"`:f),w){const f=(0,t.getDriveLetter)(w);f&&(h+=`${f}: && `),h+=`cd ${m(w)} && `}if(C){h+='cmd /C "';for(const f in C){let p=C[f];p===null?h+=`set "${f}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),h+=`set "${f}=${p}" && `)}}for(const f of L)h+=f==="<"||f===">"||P?f:m(f),h+=" ";C&&(h+='"');break;case 2:{m=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const f=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(w&&(h+=`cd ${m(w)} ; `),C){h+="/usr/bin/env";for(const p in C){const b=C[p];b===null?h+=` -u ${f(p)}`:h+=` ${f(`${p}=${b}`)}`}h+=" "}for(const p of L)h+=p==="<"||p===">"||P?p:m(p),h+=" ";break}}return h}e.prepareCommand=y}),define(ye[92],Ce([1,0,23,39,64,85,17,11,12,54]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var p;(function(U){U.scheme=I.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${$.join("")}]+`),ue=7;function V(G,de){const be=de.toString(ue),Pe=`${be.length<$.length?$[be.length-1]:"z"}${be}s${(0,a.encodeBase64)(a.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:U.scheme,fragment:Pe})}U.generate=V;function _(G){if(G.scheme!==U.scheme)return;const de=G.fragment.indexOf("s");if(de<0)return;const be=parseInt(G.fragment.substring(0,de).replace(j,""),ue),Ee=(0,a.decodeBase64)(G.fragment.substring(de+1)).toString();if(!isNaN(be))return{handle:be,notebook:G.with({scheme:Ee,fragment:null})}}U.parse=_;function Y(G,de){return G.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${G.scheme!==I.Schemas.file?G.scheme:""}`})}U.generateCellOutputUri=Y;function ne(G){if(G.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!de)return;const be=de[1]&&de[1]!==""?de[1]:void 0,Ee=de[2];return{outputId:be,notebook:G.with({scheme:Ee||I.Schemas.file,fragment:null})}}U.parseCellOutputUri=ne;function ee(G,de,be){return U.generate(G,de).with({scheme:be})}U.generateCellPropertyUri=ee;function X(G,de){if(G.scheme===de)return U.parse(G.with({scheme:U.scheme}))}U.parseCellPropertyUri=X})(p=e.CellUri||(e.CellUri={}));const b=U=>y.isWindows?U.replace(/\//g,"\\"):U;class S{constructor($=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set($)].map(ue=>({pattern:ue,matches:t.parse(b(ue))}))}sort($){const j=new Map(T.Iterable.map($,V=>[V,b(V)]));let ue=[];for(const{matches:V}of this.d)for(const[_,Y]of j)if(V(Y)){ue.push(_),j.delete(_);break}return j.size&&(ue=ue.concat([...j.keys()].sort((V,_)=>this.e.indexOf(V)-this.e.indexOf(_)))),ue}prioritize($,j){const ue=this.f($);if(ue===-1){this.d.unshift({pattern:$,matches:t.parse(b($))});return}const V=new Set(j.map(Y=>this.f(Y,ue)));V.delete(-1);const _=Array.from(V).sort();this.d.splice(ue+1,0,..._.map(Y=>this.d[Y]));for(let Y=_.length-1;Y>=0;Y--)this.d.splice(_[Y],1)}toArray(){return this.d.map($=>$.pattern)}f($,j=this.d.length){const ue=b($);for(let V=0;V<j;V++)if(this.d[V].matches(ue))return V;return-1}}e.MimeTypeDisplayOrder=S;function g(U,$,j,ue=(V,_)=>V===_){const V=[];function _(ee,X,G){if(X===0&&G.length===0)return;const de=V[V.length-1];de&&de.start+de.deleteCount===ee?(de.deleteCount+=X,de.toInsert.push(...G)):V.push({start:ee,deleteCount:X,toInsert:G})}let Y=0,ne=0;for(;;){if(Y===U.length){_(Y,0,$.slice(ne));break}if(ne===$.length){_(Y,U.length-Y,[]);break}const ee=U[Y],X=$[ne];if(ue(ee,X)){Y+=1,ne+=1;continue}j(X)?(_(Y,1,[]),Y+=1):(_(Y,0,[X]),ne+=1)}return V}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(U){const $=U;return!!((typeof $.include=="string"||t.isRelativePattern($.include))&&(typeof $.exclude=="string"||t.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=s;function o(U,$,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf($)>=0||U.viewType===$)return!0;if(U.filenamePattern){const ue=s(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,V=s(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(t.match(ue,(0,A.basename)(j.fsPath).toLowerCase()))return!(V&&t.match(V,(0,A.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var l;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create($){return`${c.d}${$}`}static parse($){if($.startsWith(c.d))return $.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function u(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=u;const r=new TextDecoder;function n(U){const $=[];let j=!1;for(const ue of U)($.length===0||j)&&($.push(ue),j=!0);return M($),O(a.VSBuffer.concat($.map(ue=>a.VSBuffer.wrap(ue))))}e.compressOutputItemStreams=n;const d=`${String.fromCharCode(27)}[A`,E=d.split("").map(U=>U.charCodeAt(0)),k=10;function M(U){U.forEach(($,j)=>{if(j===0||$.length<d.length)return;const ue=U[j-1],V=$.subarray(0,d.length);if(V[0]===E[0]&&V[1]===E[1]&&V[2]===E[2]){const _=ue.lastIndexOf(k);if(_===-1)return;U[j-1]=ue.subarray(0,_),U[j]=$.subarray(d.length)}})}function K(U){let $=U;do U=$,$=U.replace(/[^\n]\x08/gm,"");while($.length<U.length);return U}function q(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const $=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+$.slice(j.length,$.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const F="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(U){return!U.buffer.includes(F)&&!U.buffer.includes(B)?U:a.VSBuffer.fromString(q(K(r.decode(U.buffer))))}}),define(ye[227],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[228],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=a;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t;function T(I){return Array.from(I.entries()).map(A=>[A[0],a(A[1].map)])}e.serializeEnvironmentVariableCollections=T;function R(I){return new Map(I.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[57],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class T{static fromExtHostTestItem(I,A,y=I.parent){if(I._isRoot)return new T([A]);const D=[I.id];for(let L=y;L&&L.id!==A;L=L.parent)D.push(L.id);return D.push(A),new T(D.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new T(I.split("\0"))}static join(I,A){return new T([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static localId(I){const A=I.lastIndexOf("\0");return A===-1?I:I.slice(A+1)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.d=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new T(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new T(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new T(this.path,I)}compare(I){if(typeof I=="string")return T.compare(this.toString(),I);for(let A=0;A<I.d&&A<this.d;A++)if(I.path[A]!==this.path[A])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=T}),define(ye[73],Ce([1,0,2,36,57]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var I;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable",r[r.SupportsContinuousRun=64]="SupportsContinuousRun"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=r=>"runIn"in r;e.isStartControllerTests=A;var y;(function(r){r.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),r.deserialize=n=>({range:t.Range.lift(n.range),uri:a.URI.revive(n.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var D;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var L;(function(r){r.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.deserialize(n.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const P=(r,n)=>`${n?"s":"e"}${r}`;e.getMarkId=P;var w;(function(r){r.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.serialize(n.location)}),r.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.deserialize(n.location)})})(w=e.ITestOutputMessage||(e.ITestOutputMessage={}));var C;(function(r){r.serialize=n=>n.type===0?L.serialize(n):w.serialize(n),r.deserialize=n=>n.type===0?L.deserialize(n):w.deserialize(n)})(C=e.ITestMessage||(e.ITestMessage={}));var v;(function(r){r.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),r.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(C.serialize)}),r.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(C.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",h=(r,n)=>r+m+n;e.namespaceTestTag=h;const f=r=>{const n=r.indexOf(m);return{ctrlId:r.slice(0,n),tagId:r.slice(n+1)}};e.denamespaceTestTag=f;var p;(function(r){r.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),r.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?a.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(r){r.serialize=n=>({expand:n.expand,item:p.serialize(n.item)}),r.deserialize=n=>({controllerId:T.TestId.root(n.item.extId),expand:n.expand,item:p.deserialize(n.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=n=>{let d;return n.item&&(d={},n.item.label!==void 0&&(d.label=n.item.label),n.item.tags!==void 0&&(d.tags=n.item.tags),n.item.busy!==void 0&&(d.busy=n.item.busy),n.item.uri!==void 0&&(d.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(d.range=n.item.range?.toJSON()),n.item.description!==void 0&&(d.description=n.item.description),n.item.error!==void 0&&(d.error=n.item.error),n.item.sortText!==void 0&&(d.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:d}},r.deserialize=n=>{let d;return n.item&&(d={},n.item.label!==void 0&&(d.label=n.item.label),n.item.tags!==void 0&&(d.tags=n.item.tags),n.item.busy!==void 0&&(d.busy=n.item.busy),n.item.range!==void 0&&(d.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(d.description=n.item.description),n.item.error!==void 0&&(d.error=n.item.error),n.item.sortText!==void 0&&(d.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:d}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(r,n)=>{n.expand!==void 0&&(r.expand=n.expand),n.item!==void 0&&(r.item=r.item?Object.assign(r.item,n.item):n.item)};e.applyTestItemUpdate=i;var s;(function(r){r.serializeWithoutMessages=n=>({...S.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serializeWithoutMessages),retired:n.retired}),r.serialize=n=>({...S.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serialize),retired:n.retired}),r.deserialize=n=>({...S.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var o;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var l;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(r){r.deserialize=n=>n.op===0?{op:n.op,item:S.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n.op===2?{op:n.op,uri:a.URI.revive(n.uri),docv:n.docv}:n,r.serialize=n=>n.op===0?{op:n.op,item:S.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class u{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const d=this.o();for(const E of n)switch(E.op){case 0:this.j(S.deserialize(E.item),d);break;case 1:this.k(g.deserialize(E.item),d);break;case 3:this.l(E.itemId,d);break;case 5:this.m(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this.c.set(E.tag.id,E.tag);break;case 7:this.c.delete(E.id);break}d.complete?.()}j(n,d){const E=T.TestId.parentId(n.item.extId)?.toString();let k;if(!E)k=this.p(n),this.f.add(k),this.d.set(n.item.extId,k);else if(this.d.has(E)){const M=this.d.get(E);M.children.add(n.item.extId),k=this.p(n,M),this.d.set(n.item.extId,k)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return d.add?.(k),n.expand===2&&this.g++,k}k(n,d){const E=this.d.get(n.extId);if(!!E)return n.expand!==void 0&&(E.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(E,n),d.update?.(E),E}l(n,d){const E=this.d.get(n);if(!E)return;const k=T.TestId.parentId(E.item.extId)?.toString();k?this.d.get(k).children.delete(E.item.extId):this.f.delete(E);const M=[[n]];for(;M.length;)for(const K of M.pop()){const q=this.d.get(K);q&&(M.push(q.children),this.d.delete(K),d.remove?.(q,q!==E),q.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=u}),define(ye[93],Ce([1,0,14,3,6,51,73,57]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(p,b)=>p===b,P=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:D,label:D,description:D,error:D,sortText:D,tags:(p,b)=>!(p.length!==b.length||p.some(S=>!b.includes(S)))}),w=(p,b)=>{let S;for(const[g,i]of P)i(p[g],b[g])||(S?S[g]=b[g]:S={[g]:b[g]});return S};class C extends T.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const S of this.tree.values())this.G(S)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===b.uri){S.docv=b.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===b.item.extId){(0,I.applyTestItemUpdate)(S.item,b.item);return}if(S.op===0&&S.item.item.extId===b.item.extId){(0,I.applyTestItemUpdate)(S.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,S){const g=this.tree.get(b);if(!!g){if((g.expandLevels===void 0||S>g.expandLevels)&&(g.expandLevels=S),g.expand===1){const i=this.I(g);return i.isOpen()?this.H(g,S-1):i.wait().then(()=>this.H(g,S-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,S-1)):this.H(g,S-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,S){switch(S.op){case 3:this.L(A.TestId.joinToString(b.fullId,S.id));break;case 0:this.u(S.item,b);break;case 5:for(const g of S.ops)this.p(b,g);break;case 1:this.w(S.new,S.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:S.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(S)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,S){const g=A.TestId.fromExtHostTestItem(b,this.root.id,S?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==S?.actual&&this.m.getChildren(i.parent).delete(b.id);let s=this.tree.get(g.toString());if(!s){s={fullId:g,actual:b,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(b,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(b)}}),this.F(b,s,S);return}if(s.actual===b){this.D(b,s,S);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.L(g.toString()),this.u(b,S);const o=this.m.getChildren(s.actual),l=s.actual,c=w(this.m.toITestItem(l),this.m.toITestItem(b));this.m.getApiFor(l).listener=void 0,s.actual=b,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,l.tags,g.toString()),delete c.tags),this.p(s,{op:4,update:c})),this.F(b,s,S);for(const[u,r]of o)this.m.getChildren(b).get(r.id)||this.L(A.TestId.joinToString(g,r.id));this.s(s.actual.uri)}w(b,S,g){const i=new Set(S.map(s=>s.id));for(const s of b)i.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:g,item:{tags:b.map(s=>(0,I.namespaceTestTag)(this.m.controllerId,s.id))}}}),i.forEach(this.z,this)}y(b){const S=this.j.get(b.id);S?S.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const S=this.j.get(b);S&&!--S.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,b)}))}C(b,S){this.m.getApiFor(b).parent=S&&S.actual!==this.root?S.actual:void 0}D(b,S,g){this.C(b,g);const i=this.m.getApiFor(b);i.parent=g?.actual,i.listener=s=>this.p(S,s),this.G(S)}F(b,S,g){this.D(b,S,g);for(const[i,s]of this.m.getChildren(b))this.u(s,S)}G(b){let S;this.h?b.resolveBarrier?S=b.resolveBarrier.isOpen()?3:2:S=b.actual.canResolveChildren?1:0:S=0,S!==b.expand&&(b.expand=S,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:S}}),S===1&&b.expandLevels!==void 0&&this.I(b))}H(b,S){if(S<0)return;const g=[];for(const[i,s]of this.m.getChildren(b.actual)){const o=this.expand(A.TestId.joinToString(b.fullId,s.id),S);(0,a.isThenable)(o)&&g.push(o)}if(g.length)return Promise.all(g).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new a.Barrier;return s.open(),s}b.expand=2,this.J(b);const S=b.resolveBarrier=new a.Barrier,g=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(s){g(s)}return(0,a.isThenable)(i)?i.catch(g).then(()=>{S.open(),this.G(b)}):(S.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const S=this.tree.get(b);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const g=[S];for(;g.length;){const i=g.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.z(s.id);this.tree.delete(i.fullId.toString());for(const[s,o]of this.m.getChildren(i.actual))g.push(this.tree.get(A.TestId.joinToString(i.fullId,o.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=C;class v extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=v;class m extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class h extends Error{constructor(b,S,g){super(`TestItem with ID "${b}" is from controller "${S}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const f=(p,b,S)=>{let g=new Map;return{get size(){return g.size},forEach(i,s){for(const o of g.values())i.call(s,o,this)},[Symbol.iterator](){return g.entries()},replace(i){const s=new Map,o=new Set(g.keys()),l={op:5,ops:[]};for(const c of i){if(!(c instanceof S))throw new m(c.id);const u=b(c).controllerId;if(u!==p.controllerId)throw new h(c.id,u,p.controllerId);if(s.has(c.id))throw new v(c.id);s.set(c.id,c),o.delete(c.id),l.ops.push({op:0,item:c})}for(const c of o.keys())l.ops.push({op:3,id:c});p.listener?.(l),g=s},add(i){if(!(i instanceof S))throw new m(i.id);g.set(i.id,i),p.listener?.({op:0,item:i})},delete(i){g.delete(i)&&p.listener?.({op:3,id:i})},get(i){return g.get(i)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=f}),define(ye[132],Ce([1,0,93]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,T=(I,A)=>{const y={controllerId:A};return t.set(I,y),y};e.createPrivateApiFor=T;const R=I=>{const A=t.get(I);if(!A)throw new a.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[94],Ce([1,0,17,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function T(A,y){return A.scheme===a.Schemas.http||A.scheme===a.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===a.Schemas.file&&(A=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:y.authority,path:A.path})),t.URI.from({scheme:a.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=T;function R(A){return A.replace(/./g,y=>{const D=y.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?y:"-"+D.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(y,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=I}),define(ye[229],Ce([1,0,3,6,94]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,D){this.d=A,this.e=y,this.f=D,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,D,L,P){let w;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){w=b;break}if(!w)throw new Error("not a visible editor");const C=this,v=this.a++,m=new a.Emitter,h=new a.Emitter,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,T.asWebviewUri)(b,C.f)}get cspSource(){return T.webviewGenericCspSource}set options(b){this.b=b,C.d.$setOptions(v,b)}get options(){return this.b}set html(b){this.a=b,C.d.$setHtml(v,b)}get html(){return this.a}get onDidReceiveMessage(){return m.event}postMessage(b){return C.d.$postMessage(v,b)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=D,this.webview=f,this.onDidDispose=h.event}dispose(){C.c.has(v)&&(C.c.delete(v),C.d.$disposeEditorInset(v),h.fire(),h.dispose(),m.dispose())}};return this.d.$createEditorInset(v,w.id,w.value.document.uri,y+1,D,L||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:A,inset:p,onDidReceiveMessage:m}),p}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[230],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var t;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class T extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=T}),define(ye[231],Ce([1,0,11,37,10,22,12,113,192,230,8]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,v,m,h){this.g=new Map,this.a=C,this.b=v,this.d=m,h&&(this.c=h.then(f=>this.h(f)))}h(C){if(I.isWindows){const v=Object.create(null);return Object.keys(C).forEach(m=>{v[m.toLowerCase()]=C[m]}),v}return C}resolveWithEnvironment(C,v,m){return this.j({env:this.h(C),userHome:void 0},v?v.uri:void 0,m)}async resolveAsync(C,v){const m={env:await this.c,userHome:await this.d};return this.j(m,C?C.uri:void 0,v)}async i(C,v,m,h){const f=R.deepClone(v);I.isWindows&&f.windows?Object.keys(f.windows).forEach(b=>f[b]=f.windows[b]):I.isMacintosh&&f.osx?Object.keys(f.osx).forEach(b=>f[b]=f.osx[b]):I.isLinux&&f.linux&&Object.keys(f.linux).forEach(b=>f[b]=f.linux[b]),delete f.windows,delete f.osx,delete f.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,C?C.uri:void 0,f,m,h)}async resolveAnyAsync(C,v,m){return this.i(C,v,m)}async resolveAnyMap(C,v,m){const h=new Map;return{newConfig:await this.i(C,v,m,h),resolvedVariables:h}}resolveWithInteractionReplace(C,v,m,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,v,m,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,v){if(this.g.has(C))throw new Error("Variable "+C+" is contributed twice.");this.g.set(C,v)}async j(C,v,m,h,f){if(T.isString(m))return this.l(C,v,m,h,f);if(Array.isArray(m))return Promise.all(m.map(p=>this.j(C,v,p,h,f)));if(T.isObject(m)){const p=Object.create(null),b=await Promise.all(Object.keys(m).map(async S=>[await this.l(C,v,S,h,f),await this.j(C,v,m[S],h,f)]));for(const[S,g]of b)p[S]=g;return p}return m}l(C,v,m,h,f){return(0,L.replaceAsync)(m,P.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(P.VARIABLE_LHS))return p;let S=await this.n(C,p,b,v,h);return f?.set(b,S),S!==p&&T.isString(S)&&S.match(P.VARIABLE_REGEXP)&&(S=await this.l(C,v,S,h,f)),S})}m(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async n(C,v,m,h,f){let p;const b=m.split(":");b.length>1&&(m=b[0],p=b[1]);const S=s=>{const o=this.a.getFilePath();if(o)return(0,A.normalizeDriveLetter)(o);throw new D.VariableError(s,(0,y.localize)(0,null,v))},g=s=>{const o=S(s);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,A.normalizeDriveLetter)(l)}throw new D.VariableError(s,(0,y.localize)(1,null,v,a.basename(o)))},i=s=>{if(p){const o=this.a.getFolderUri(p);if(o)return o;throw new D.VariableError(s,(0,y.localize)(2,null,v,p))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new D.VariableError(s,(0,y.localize)(3,null,v)):new D.VariableError(s,(0,y.localize)(4,null,v))};switch(m){case"env":if(p){if(C.env){const s=C.env[I.isWindows?p.toLowerCase():p];if(T.isString(s))return s}return""}throw new D.VariableError(D.VariableKind.Env,(0,y.localize)(5,null,v));case"config":if(p){const s=this.a.getConfigurationValue(h,p);if(T.isUndefinedOrNull(s))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(6,null,v,p));if(T.isObject(s))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(7,null,v,p));return s}throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(8,null,v));case"command":return this.o(D.VariableKind.Command,v,p,f,"command");case"input":return this.o(D.VariableKind.Input,v,p,f,"input");case"extensionInstallFolder":if(p){const s=await this.a.getExtension(p);if(!s)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,v,p));return this.m(s.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,v));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(D.VariableKind.WorkspaceFolder)));case"cwd":return h||p?(0,A.normalizeDriveLetter)(this.m(i(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(a.basename(this.m(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,y.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new D.VariableError(D.VariableKind.LineNumber,(0,y.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new D.VariableError(D.VariableKind.SelectedText,(0,y.localize)(13,null,v))}case"file":return S(D.VariableKind.File);case"fileWorkspaceFolder":return g(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||p?a.relative(this.m(i(D.VariableKind.RelativeFile)),S(D.VariableKind.RelativeFile)):S(D.VariableKind.RelativeFile);case"relativeFileDirname":{const s=a.dirname(S(D.VariableKind.RelativeFileDirname));if(h||p){const o=a.relative(this.m(i(D.VariableKind.RelativeFileDirname)),s);return o.length===0?".":o}return s}case"fileDirname":return a.dirname(S(D.VariableKind.FileDirname));case"fileExtname":return a.extname(S(D.VariableKind.FileExtname));case"fileBasename":return a.basename(S(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=a.basename(S(D.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-a.extname(s).length)}case"fileDirnameBasename":return a.basename(a.dirname(S(D.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return a.sep;default:try{const s=p?`${m}:${p}`:m;return this.o(D.VariableKind.Unknown,v,s,f,void 0)}catch{return v}}}}o(C,v,m,h,f){if(m&&h){const p=f===void 0?h[m]:h[f+":"+m];if(typeof p=="string")return p;throw new D.VariableError(C,(0,y.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,4,130]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var T;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function D(v){const m=v;return(0,t.isEditorInput)(m?.editor)&&(0,t.isEditorInput)(m?.replacement)}e.isEditorReplacement=D;var L;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function w(v){const m=v;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=w;function C(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ye[232],Ce([1,0,4,133]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function T(R){const I=R;return typeof R=="number"||(0,t.isEditorGroup)(I)}e.isPreferredGroup=T}),define(ye[233],Ce([1,0,4,198]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,27,3,11]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class I{static isHostExtension(P,w,C){if(w.getExtensionDescription(P))return!1;const v=C.getExtensionDescription(P);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let w of P.activationEvents)w==="onUri"&&(w=`onUri:${a.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(w)||this.g.set(w,[]),this.g.get(w).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,w){this.d=D(this.d,w),this.d=this.d.concat(P);const C=I.j(this.d);return this.d=D(this.d,C.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new R(C)}static j(P){const w=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,p){this.addNode(f),this.addNode(p),this.c.has(f)?this.c.get(f).push(p):this.c.set(f,[p])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,p){const b=w.getArcs(f);for(let S=0;S<b.length;S++)if(!p.has(b[S]))return!1;return!0}getNodes(){return this.e}},C=new Map;for(const f of P){const p=a.ExtensionIdentifier.toKey(f.identifier);if(C.set(p,f),f.extensionDependencies)for(const b of f.extensionDependencies){const S=a.ExtensionIdentifier.toKey(b);w.addArc(p,S)}}const v=new Set;w.getNodes().filter(f=>w.getArcs(f).length===0).forEach(f=>v.add(f));const m=w.getNodes().filter(f=>!v.has(f));let h;do{h=!1;for(let f=0;f<m.length;f++){const p=m[f];w.hasOnlyGoodArcs(p,v)&&(m.splice(f,1),f--,v.add(p),h=!0)}}while(h);return m.map(f=>C.get(f))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(a.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const w=this.g.get(P);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const w=this.e.get(a.ExtensionIdentifier.toKey(P));return w||void 0}getExtensionDescriptionByUUID(P){for(const w of this.f)if(w.uuid===P)return w}getExtensionDescriptionByIdOrUUID(P,w){return this.getExtensionDescription(P)??(w?this.getExtensionDescriptionByUUID(w):void 0)}}e.ExtensionDescriptionRegistry=I;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function y(L,P){const w=L.isBuiltin?0:L.isUnderDevelopment?2:1,C=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(w!==C)return w-C;const v=T.posix.basename(L.extensionLocation.path),m=T.posix.basename(P.extensionLocation.path);return v<m?-1:v>m?1:0}function D(L,P){const w=new Set;return P.forEach(C=>w.add(a.ExtensionIdentifier.toKey(C))),L.filter(C=>!w.has(a.ExtensionIdentifier.toKey(C.identifier)))}}),define(ye[234],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class T{constructor(){this.type=2}serialize(P){P[T.ENV_KEY]="1"}}e.SocketExtHostConnection=T,T.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(L){delete L[t.ENV_KEY],delete L[T.ENV_KEY],delete L[R.ENV_KEY]}function A(L,P){I(P),L.serialize(P)}e.writeExtHostConnection=A;function y(L){if(L[t.ENV_KEY])return D(L,new t(L[t.ENV_KEY]));if(L[T.ENV_KEY])return D(L,new T);if(L[R.ENV_KEY])return D(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function D(L,P){return I(L),P}}),define(ye[95],Ce([1,0,23]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(D){const L=a.VSBuffer.alloc(1);switch(D){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=I;function A(D,L){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var y;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],Ce([1,0,4,3,13,25,95,69,70,22,2]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(m,h){this.i=m,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=h.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(m,h,f){const p=this.getTelemetryDetails(),b=new w(h,f,m,this.g,this.f,this.getBuiltInCommonProperties(m),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled});return this.h.set(m.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(m,h,f){this.d=m,this.f=h,this.c=f??{usage:!0,error:!0}}getBuiltInCommonProperties(m){const h={};switch(h["common.extname"]=m.name,h["common.extversion"]=m.version,h["common.vscodemachineid"]=this.i.telemetryInfo.machineId,h["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,h["common.vscodeversion"]=this.i.version,h["common.isnewappinstall"]=C(this.i.telemetryInfo.firstSessionDate),h["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:h["common.uikind"]="web";break;case I.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),h}$onDidChangeTelemetryLevel(m){this.e=this.getTelemetryConfiguration(),this.d=m;const h=this.getTelemetryDetails();this.h.forEach(f=>{f.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(m,h){const f=this.h.get(m.value);return!f||f.ignoreUnhandledExtHostErrors?!1:(f.logError(h),!0)}};P=qe([We(0,R.IExtHostInitDataService),We(1,T.ILoggerService)],P),e.ExtHostTelemetry=P;class w{constructor(m,h,f,p,b,S,g){this.g=f,this.h=p,this.i=b,this.j=S,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.e=h?.ignoreBuiltInCommonProperties??!1,this.f=h?.additionalCommonProperties,this.a=m,this.c={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(m,h){this.d&&(this.c={isUsageEnabled:m,isErrorsEnabled:h},this.b.fire(this.d))}mixInCommonPropsAndCleanData(m){let h=m.properties??m;return h=(0,y.cleanData)(h,[]),this.f&&(h=(0,D.mixin)(h,this.f)),this.e||(h=(0,D.mixin)(h,this.j)),m.properties?m.properties=h:m=h,m}k(m,h){this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.a.sendEventData(m,h),this.h.trace(m,h)}logUsage(m,h){!this.c.isUsageEnabled||this.k(m,h)}logError(m,h){!this.c.isErrorsEnabled||(typeof m=="string"?this.k(m,h):this.a.sendErrorData(m,h))}get apiTelemetryLogger(){if(!this.d){const m=this,h={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.c.isUsageEnabled},get isErrorsEnabled(){return m.c.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.b.event.bind(m)};this.d=Object.freeze(h)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=w;function C(v){const m=Date.now()-new Date(v).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.isNewAppInstall=C,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[26],Ce([1,0,3,2,4,27,210]),function(te,e,a,t,T,R,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class y{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class D{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=D;class L{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(u){this.dependency=u}}e.MissingExtensionDependency=P;var w;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(w=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=C;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,r){const n=[],d=[],E=[],k=[],M=f(this.c),K=f(u),q=(U,$)=>U.extensionLocation.toString()===$.extensionLocation.toString()||U.isBuiltin===$.isBuiltin||U.isUserBuiltin===$.isUserBuiltin||U.isUnderDevelopment===$.isUnderDevelopment;for(const U of this.c){const $=K.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){n.push(U.identifier),M.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!q(U,$)){n.push(U.identifier),M.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of u){const $=M.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){d.push(U);continue}if(!q($,U)){n.push($.identifier),M.delete(R.ExtensionIdentifier.toKey($.identifier));continue}}const F=h(this.d),B=h(r);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||E.push(U);for(const U of r)F.has(R.ExtensionIdentifier.toKey(U))||k.push(U);const O={toRemove:n,toAdd:d,myToRemove:E,myToAdd:k};return this.delta(O),O}delta(u){const{toRemove:r,toAdd:n,myToRemove:d,myToAdd:E}=u,k=h(r),M=h(d);for(let K=0;K<this.c.length;K++)k.has(R.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)M.has(R.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of n)this.c.push(K);for(const K of E)this.d.push(K)}containsExtension(u){for(const r of this.d)if(R.ExtensionIdentifier.equals(r,u))return!0;return!1}}e.ExtensionHostExtensions=v;class m{constructor(u){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,u)for(const r of u)this.add(r)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,r){this.c.forEach(n=>u.call(r,n,n,this))}*entries(){for(const[u,r]of this.c)yield[r,r]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=m;function h(c){const u=new Set;for(const r of c)u.add(R.ExtensionIdentifier.toKey(r));return u}e.extensionIdentifiersArrayToSet=h;function f(c){const u=new Map;for(const r of c)u.set(R.ExtensionIdentifier.toKey(r.identifier),r);return u}function p(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=p;function b(c,u){if(!p(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class S{constructor(u,r,n,d){this.codeLoadingTime=u,this.activateCallTime=r,this.activateResolvedTime=n,this.activationReason=d}}e.ActivationTimes=S;class g{constructor(u,r){this.description=u,this.value=r}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function o(c,u){return{identifier:new R.ExtensionIdentifier((0,I.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=o;class l{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,r){return Promise.resolve(0)}getInspectPorts(u,r){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(ye[235],Ce([1,0,9,134,27,26,13,14]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(f,p,b,S){this.startup=f,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=S}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,p){return f===-1||p===-1?-1:p-f}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=D;class L{constructor(f,p,b,S,g,i){this.activationFailed=f,this.activationFailedError=p,this.activationTimes=b,this.module=S,this.exports=g,this.subscriptions=i}}e.ActivatedExtension=L;class P extends L{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class w extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class C extends L{constructor(f){super(!0,f,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(f,p,b,S){this.g=S,this.a=f,this.b=p,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[f,p]of this.d)p.dispose()}isActivated(f){const p=this.d.get(T.ExtensionIdentifier.toKey(f));return Boolean(p&&p.value)}getActivatedExtension(f){const p=this.d.get(T.ExtensionIdentifier.toKey(f));if(!p||!p.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return p.value}async activateByEvent(f,p){if(this.f[f])return;const b=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(b.map(S=>({id:S.identifier,reason:{startup:p,extensionId:S.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,p){const b=this.a.getExtensionDescription(f);if(!b)throw new Error(`Extension '${f}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(f){const p=f.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(f){if(this.d.has(T.ExtensionIdentifier.toKey(f.id)))return this.d.get(T.ExtensionIdentifier.toKey(f.id));if(this.l(f.id))return this.k(f,null,[],null);const p=this.a.getExtensionDescription(f.id);if(!p){const g=new Error(`Cannot activate unknown extension '${f.id.value}'`),i=this.k(f,null,[],new C(g));return this.c.onExtensionActivationError(f.id,g,new R.MissingExtensionDependency(f.id.value)),i}const b=[],S=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const g of S){if(this.m(g))continue;const i=this.d.get(T.ExtensionIdentifier.toKey(g));if(i){b.push(i);continue}if(this.l(g)){b.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:f.reason}));continue}const s=this.a.getExtensionDescription(g);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:f.reason}));continue}const o=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${g}'`),c=this.k(f,p.displayName,[],new C(l));return this.c.onExtensionActivationError(p.identifier,l,new R.MissingExtensionDependency(g)),c}return this.k(f,p.displayName,b,null)}k(f,p,b,S){const g=new m(f.id,p,f.reason,b,S,this.c,this.g);return this.d.set(T.ExtensionIdentifier.toKey(f.id),g),g}l(f){return t.ExtensionDescriptionRegistry.isHostExtension(f,this.a,this.b)}m(f){const p=this.b.getExtensionDescription(f);return p?!p.main&&!p.browser:!1}};v=qe([We(3,I.ILogService)],v),e.ExtensionsActivator=v;let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,p,b,S,g,i,s){this.c=f,this.d=p,this.f=b,this.g=S,this.h=g,this.j=i,this.k=s,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const p=this.g[f];if(p.value&&!p.value.activationFailed){this.g.splice(f,1),f--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new C(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const p=new Error;if(f&&f.name&&(p.name=f.name),f&&f.message?p.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(p.stack=f.stack),this.h=new C(p),this.b&&a.isCancellationError(f))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=qe([We(6,I.ILogService)],m)}),define(ye[236],Ce([1,0,13,25,26]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends a.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:T.ExtensionHostLogFileName}))}};R=qe([We(0,a.ILoggerService),We(1,t.IExtHostInitDataService)],R),e.ExtHostLogService=R});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[7],Ce([1,0,16,9,112,28,85,8,10,2,30,40,128,92,26]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v){"use strict";var m,h,f,p,b,S,g,i,s,o,l,c,u,r,n,d,E,k,M,K,q,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(x){return Object.assign(x,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(x,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[me,...Te]=arguments;return Reflect.construct(x,Te,me.constructor)}}})}var U;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var $;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})($=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=S=class{static from(...W){let me=W;return new S(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(W){m.set(this,void 0),Ye(this,m,W,"f")}dispose(){typeof Ue(this,m,"f")=="function"&&(Ue(this,m,"f").call(this),Ye(this,m,void 0,"f"))}};m=new WeakMap,j=S=qe([O],j),e.Disposable=j;let ue=g=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(me)&&(me=Ke)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(me)&&(me=Ke)}return me}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:me,character:Te}=W;return typeof me=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(me<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&me===0?this:new g(this.line+Te,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Te===this.line&&me===this.character?this:new g(Te,me)}toJSON(){return{line:this.line,character:this.character}}};ue=g=qe([O],ue),e.Position=ue;let V=i=class{static isRange(W){return W instanceof i?!0:W?ue.isPosition(W.start)&&ue.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Te,Ke){let Je,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new ue(W,me),ct=new ue(Te,Ke)):ue.isPosition(W)&&ue.isPosition(me)&&(Je=ue.of(W),ct=ue.of(me)),!Je||!ct)throw new Error("Invalid arguments");Je.isBefore(ct)?(this.c=Je,this.e=ct):(this.c=ct,this.e=Je)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):ue.isPosition(W)?!(ue.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=ue.Max(W.start,this.c),Te=ue.Min(W.end,this.e);if(!me.isAfter(Te))return new i(me,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=ue.Min(W.start,this.c),Te=ue.Max(W.end,this.end);return new i(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return W?ue.isPosition(W)?Te=W:(Te=W.start||this.start,me=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new i(Te,me)}toJSON(){return[this.start,this.end]}};V=i=qe([O],V),e.Range=V;let _=s=class extends V{static isSelection(W){return W instanceof s?!0:W?V.isRange(W)&&ue.isPosition(W.anchor)&&ue.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Te,Ke){let Je,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new ue(W,me),ct=new ue(Te,Ke)):ue.isPosition(W)&&ue.isPosition(me)&&(Je=ue.of(W),ct=ue.of(me)),!Je||!ct)throw new Error("Invalid arguments");super(Je,ct),this.f=Je,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=s=qe([O],_),e.Selection=_;class Y{constructor(W,me,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=Y;class ne extends Error{static NotAvailable(W,me){return new ne(W,w.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new ne(W,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=w.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=me,this._detail=Te,Object.setPrototypeOf(this,ne.prototype)}}e.RemoteAuthorityResolverError=ne;var ee;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var X;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=o=class{static isTextEdit(W){return W instanceof o?!0:W?V.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new o(W,me)}static insert(W,me){return o.replace(new V(W,W),me)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const me=new o(new V(new ue(0,0),new ue(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!V.isRange(W))throw(0,t.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};G=o=qe([O],G),e.TextEdit=G;let de=l=class{static isNotebookCellEdit(W){return W instanceof l?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new l(W,me)}static insertCells(W,me){return new l(new Xt(W,W),me)}static deleteCells(W){return new l(W,[])}static updateCellMetadata(W,me){const Te=new l(new Xt(W,W),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(W){const me=new l(new Xt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};de=l=qe([O],de),e.NotebookEdit=de;class be{static isSnippetTextEdit(W){return W instanceof be?!0:W?V.isRange(W.range)&&Fe.isSnippetString(W.snippet):!1}static replace(W,me){return new be(W,me)}static insert(W,me){return be.replace(new V(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=be;var Ee;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Te,Ke){this.c.push({_type:1,from:W,to:me,options:Te,metadata:Ke})}createFile(W,me,Te){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Te})}deleteFile(W,me,Te){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Te})}e(W,me,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Te,Ke){const Je=me.start,ct=me.end;(Je!==ct||Te.length>0)&&this.c.push({_type:5,uri:W,index:Je,count:ct-Je,cells:Te,metadata:Ke})}g(W,me,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:me,metadata:Te}})}replace(W,me,Te,Ke){this.c.push({_type:2,uri:W,edit:new G(me,Te),metadata:Ke})}insert(W,me,Te,Ke){this.replace(W,new V(me,me),Te,Ke)}delete(W,me,Te){this.replace(W,me,"",Te)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Te of me){if(!Te)continue;let Ke,Je;Array.isArray(Te)?(Ke=Te[0],Je=Te[1]):Ke=Te,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Je):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Je):this.f(W,Ke.range,Ke.newCells,Je):be.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Je}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&me.push(Te.edit);return me}entries(){const W=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Te=W.get(me.uri);Te||(Te=[me.uri,[]],W.set(me.uri,Te)),Te[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=qe([O],Pe),e.WorkspaceEdit=Pe;let Fe=c=class{static isSnippetString(W){return W instanceof c?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=c.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Te=new c;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=c.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Te=new c;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Fe=c=qe([O],Fe),e.SnippetString=Fe;var se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=u=class{static isLocation(W){return W instanceof u?!0:W?V.isRange(W.range)&&D.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(V.isRange(me))this.range=V.of(me);else if(ue.isPosition(me))this.range=new V(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=u=qe([O],fe),e.Location=fe;let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&V.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};Z=qe([O],Z),e.DiagnosticRelatedInformation=Z;let ce=class{constructor(W,me,Te=oe.Error){if(!V.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Te}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,a.equals)(W.tags,me.tags)&&(0,a.equals)(W.relatedInformation,me.relatedInformation,Z.isEqual)}};ce=qe([O],ce),e.Diagnostic=ce;let ie=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};ie=qe([O],ie),e.Hover=ie;var N;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(W,me=N.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};H=qe([O],H),e.DocumentHighlight=H;var Q;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Q=e.SymbolKind||(e.SymbolKind={}));var J;(function(x){x[x.Deprecated=1]="Deprecated"})(J=e.SymbolTag||(e.SymbolTag={}));let he=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Te,Ke,Je){this.name=W,this.kind=me,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),Ke instanceof fe?this.location=Ke:Te instanceof V&&(this.location=new fe(Ke,Te)),r.validate(this)}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};he=r=qe([O],he),e.SymbolInformation=he;let we=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}constructor(W,me,Te,Ke,Je){this.name=W,this.detail=me,this.kind=Te,this.range=Ke,this.selectionRange=Je,this.children=[],n.validate(this)}};we=n=qe([O],we),e.DocumentSymbol=we;var Ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,me){this.title=W,this.kind=me}};pe=qe([O],pe),e.CodeAction=pe;let De=d=class{constructor(W){this.value=W}append(W){return new d(this.value?this.value+d.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+d.c)}};De.c=".",De=d=qe([O],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([O],ke),e.SelectionRange=ke;class je{constructor(W,me,Te,Ke,Je,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=Ge;class et{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=et;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=E=class{static isMarkdownString(W){return W instanceof E?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){h.set(this,void 0),Ye(this,h,new T.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Ue(this,h,"f").value}set value(W){Ue(this,h,"f").value=W}get isTrusted(){return Ue(this,h,"f").isTrusted}set isTrusted(W){Ue(this,h,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,h,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,h,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,h,"f").supportHtml}set supportHtml(W){Ue(this,h,"f").supportHtml=W}get baseUri(){return Ue(this,h,"f").baseUri}set baseUri(W){Ue(this,h,"f").baseUri=W}appendText(W){return Ue(this,h,"f").appendText(W),this}appendMarkdown(W){return Ue(this,h,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Ue(this,h,"f").appendCodeblock(me??"",W),this}};h=new WeakMap,st=E=qe([O],st),e.MarkdownString=st;let ht=class{constructor(W,me){this.label=W,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Me=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};Me=qe([O],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([O],it),e.SignatureHelp=it;var ae;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var z;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(z=e.InlayHintKind||(e.InlayHintKind={}));let le=class{constructor(W){this.value=W}};le=qe([O],le),e.InlayHintLabelPart=le;let Ie=class{constructor(W,me,Te){this.position=W,this.label=me,this.kind=Te}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(x){x[x.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let gt=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};gt=qe([O],gt),e.CompletionList=gt;let mt=class{constructor(W,me,Te){this.insertText=W,this.range=me,this.command=Te}};mt=qe([O],mt),e.InlineSuggestion=mt;let lt=class{constructor(W){this.commands=void 0,this.items=W}};lt=qe([O],lt),e.InlineSuggestionList=lt;var ot;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(me){switch(me){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,me){if(me&&!D.URI.isUri(me))throw(0,t.illegalArgument)("target");if(!V.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=me}};Ft=qe([O],Ft),e.DocumentLink=Ft;let xe=class{constructor(W,me,Te,Ke){this.red=W,this.green=me,this.blue=Te,this.alpha=Ke}};xe=qe([O],xe),e.Color=xe;let Mt=class{constructor(W,me){if(me&&!(me instanceof xe))throw(0,t.illegalArgument)("color");if(!V.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=me}};Mt=qe([O],Mt),e.ColorInformation=Mt;let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};Ut=qe([O],Ut),e.ColorPresentation=Ut;var Bt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var wt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(W,me,Te){if(this.startIndex=W,this.length=me,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var re;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var $e;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=k=class{static from(W){switch(W){case"clean":return k.Clean;case"build":return k.Build;case"rebuild":return k.Rebuild;case"test":return k.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,t.illegalArgument)("name");this.c=W}get id(){return this.c}};Ve.Clean=new k("clean","Clean"),Ve.Build=new k("build","Build"),Ve.Rebuild=new k("rebuild","Rebuild"),Ve.Test=new k("test","Test"),Ve=k=qe([O],Ve),e.TaskGroup=Ve;function tt(x){let W="";for(let me=0;me<x.length;me++)W+=x[me].replace(/,/g,",,")+",";return W}let St=class{constructor(W,me,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return tt(W)}};St=qe([O],St),e.ProcessExecution=St;let Et=class{constructor(W,me,Te){if(this.f=[],Array.isArray(me)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W,this.f=me,this.g=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return tt(W)}};Et=qe([O],Et),e.ShellExecution=Et;var Lt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Lt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class It{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=It;let ft=M=class{constructor(W,me,Te,Ke,Je,ct){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Te,this.execution=Ke,dt=Je,this.j=!0):me===vt.Global||me===vt.Workspace?(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,dt=ct):(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:M.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:M.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:M.c,id:this.n.computeId()}:this.k={type:M.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(M.g===me||M.e===me||M.f===me||M.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};ft.c="customExecution",ft.e="process",ft.f="shell",ft.g="$empty",ft=M=qe([O],ft),e.Task=ft;var Gt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Gt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(x){function W(me){const Te=me;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}x.isViewBadge=W})(jt=e.ViewBadge||(e.ViewBadge={}));let yt=K=class{static isTreeItem(W,me){if(W instanceof K)return!0;const Te=W;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Qt.None&&Te.collapsibleState>Qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==sn.Checked&&Ke!==sn.Unchecked||Je!==void 0&&!(0,y.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,me=Qt.None){this.collapsibleState=me,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};yt=K=qe([O],yt),e.TreeItem=yt;var Qt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var sn;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(sn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let en=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,L.generateUuid)()}};en=qe([O],en),e.DataTransferItem=en;let vn=class{constructor(W){f.set(this,new Map);for(const[me,Te]of W??[]){const Ke=Ue(this,f,"f").get(me);Ke?Ke.push(Te):Ue(this,f,"f").set(me,[Te])}}get(W){return Ue(this,f,"f").get(W)?.[0]}set(W,me){Ue(this,f,"f").set(W,[me])}forEach(W,me){for(const[Te,Ke]of Ue(this,f,"f"))for(const Je of Ke)W.call(me,Je,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,me]of Ue(this,f,"f"))for(const Te of me)yield[W,Te]}};vn=qe([O],vn),e.DataTransfer=vn;let At=class{constructor(W){this.insertText=W}};At=qe([O],At),e.DocumentDropEdit=At;let on=class{constructor(W){this.insertText=W}};on=qe([O],on),e.DocumentPasteEdit=on;let Vt=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Vt=qe([O],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let tn=class{constructor(W){this.id=W}};tn=qe([O],tn),e.ThemeColor=tn;var an;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(an=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(W){this.c=W,this.e=D.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof me!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=D.URI.file(W):D.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([O],ut),e.RelativePattern=ut;const On=new WeakMap;function _t(x,W){On.set(x,W)}e.setBreakpointId=_t;let Wt=class{constructor(W,me,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=On.get(this)??(0,L.generateUuid)()),this.c}};Wt=qe([O],Wt),e.Breakpoint=Wt;let cn=class extends Wt{constructor(W,me,Te,Ke,Je){if(super(me,Te,Ke,Je),W===null)throw(0,t.illegalArgument)("location");this.location=W}};cn=qe([O],cn),e.SourceBreakpoint=cn;let En=class extends Wt{constructor(W,me,Te,Ke,Je){super(me,Te,Ke,Je),this.functionName=W}};En=qe([O],En),e.FunctionBreakpoint=En;let ln=class extends Wt{constructor(W,me,Te,Ke,Je,ct,dt){if(super(Ke,Je,ct,dt),!me)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Te}};ln=qe([O],ln),e.DataBreakpoint=ln;let Sn=class{constructor(W,me,Te){this.command=W,this.args=me||[],this.options=Te}};Sn=qe([O],Sn),e.DebugAdapterExecutable=Sn;let un=class{constructor(W,me){this.port=W,this.host=me}};un=qe([O],un),e.DebugAdapterServer=un;let nn=class{constructor(W){this.path=W}};nn=qe([O],nn),e.DebugAdapterNamedPipeServer=nn;let yn=class{constructor(W){this.implementation=W}};yn=qe([O],yn),e.DebugAdapterInlineImplementation=yn;let rn=class{constructor(W,me){this.range=W,this.expression=me}};rn=qe([O],rn),e.EvaluatableExpression=rn;var Cn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dn=class{constructor(W,me){this.range=W,this.text=me}};Dn=qe([O],Dn),e.InlineValueText=Dn;let In=class{constructor(W,me,Te=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Te}};In=qe([O],In),e.InlineValueVariableLookup=In;let Jt=class{constructor(W,me){this.range=W,this.expression=me}};Jt=qe([O],Jt),e.InlineValueEvaluatableExpression=Jt;let kn=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};kn=qe([O],kn),e.InlineValueContext=kn;var $n;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})($n=e.FileChangeType||(e.FileChangeType={}));let Tn=q=class extends Error{static FileExists(W){return new q(W,P.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(W){return new q(W,P.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(W){return new q(W,P.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(W){return new q(W,P.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(W){return new q(W,P.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(W){return new q(W,P.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(W,me=P.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Tn=q=qe([O],Tn),e.FileSystemError=Tn;let Pn=class{constructor(W,me,Te){this.start=W,this.end=me,this.kind=Te}};Pn=qe([O],Pn),e.FoldingRange=Pn;var Wn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var An;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(An=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Nn;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Nn=e.CommentMode||(e.CommentMode={}));var Fn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Fn=e.CommentThreadState||(e.CommentThreadState={}));class He{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=He;function Kt(x){return typeof x>"u"||(0,y.isStringArray)(x)}class dn{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Te=W.tokenTypes.length;me<Te;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Te=W.tokenModifiers.length;me<Te;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Te,Ke,Je){if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(W,me,Te,Ke,Je);if(V.isRange(W)&&typeof me=="string"&&Kt(Te))return this.m(W,me,Te);throw(0,t.illegalArgument)()}m(W,me,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Je=W.start.character,ct=W.end.character-W.start.character,dt=this.j.get(me);let Ot=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Ot|=1<<qt>>>0}this.n(Ke,Je,ct,dt,Ot)}n(W,me,Te,Ke,Je){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,qt=0;for(let xt=0;xt<Ot;xt++){let Yt=this.g[5*xt],Rn=this.g[5*xt+1];Yt===0?(Yt=Ht,Rn+=qt):Yt+=Ht,this.g[5*xt]=Yt,this.g[5*xt+1]=Rn,Ht=Yt,qt=Rn}}let ct=W,dt=me;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Je,this.c=W,this.e=me}static o(W){const me=[],Te=W.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Ot)=>{const Ht=W[5*dt],qt=W[5*Ot];if(Ht===qt){const xt=W[5*dt+1],Yt=W[5*Ot+1];return xt-Yt}return Ht-qt});const Ke=new Uint32Array(W.length);let Je=0,ct=0;for(let dt=0;dt<Te;dt++){const Ot=5*me[dt],Ht=W[Ot+0],qt=W[Ot+1],xt=W[Ot+2],Yt=W[Ot+3],Rn=W[Ot+4],ii=Ht-Je,Ri=ii===0?qt-ct:qt,Ln=5*dt;Ke[Ln+0]=ii,Ke[Ln+1]=Ri,Ke[Ln+2]=xt,Ke[Ln+3]=Yt,Ke[Ln+4]=Rn,Je=Ht,ct=qt}return Ke}build(W){return this.f?new bt(new Uint32Array(this.g),W):new bt(dn.o(this.g),W)}}e.SemanticTokensBuilder=dn;class bt{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=bt;class Hn{constructor(W,me,Te){this.start=W,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=Hn;class jn{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=jn;var Mn;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Mn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hn=class{constructor(){}};hn.Back={iconPath:new Vt("arrow-left")},hn=qe([O],hn),e.QuickInputButtons=hn;var fn;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vn;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Vn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var qn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(qn=e.ExtensionKind||(e.ExtensionKind={}));class Gn{static validate(W){if(typeof W.badge=="string"){let me=(0,A.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,A.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Vt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Te){this.badge=W,this.tooltip=me,this.color=Te}}e.FileDecoration=Gn;let mn=class{constructor(W){this.kind=W}};mn=qe([O],mn),e.ColorTheme=mn;var Kn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Kn=e.ColorThemeKind||(e.ColorThemeKind={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(me<0)throw(0,t.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Te=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Te=W.end),me===this.c&&Te===this.e?this:new Xt(me,Te)}}e.NotebookRange=Xt;class gn{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>gn.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Te,Ke,Je,ct,dt){this.kind=W,this.value=me,this.languageId=Te,this.mime=Ke,this.outputs=Je??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class Xn{constructor(W){this.cells=W}}e.NotebookData=Xn;class $t{static isNotebookCellOutputItem(W){return W instanceof $t?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return $t.json(me,"application/vnd.code.notebook.error")}static stdout(W){return $t.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return $t.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new $t(W,me)}static text(W,me=I.Mimes.text){const Te=Ue($t,p,"f",b).encode(String(W));return new $t(Te,me)}static json(W,me="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return $t.text(Te,me)}constructor(W,me){this.data=W,this.mime=me;const Te=(0,I.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,p=$t,b={value:new TextEncoder};class pn{static isNotebookCellOutput(W){return W instanceof pn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Te=new Set,Ke=new Set;for(let Je=0;Je<W.length;Je++){const ct=W[Je],dt=(0,I.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,C.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Je),me&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Je,ct)=>!Ke.has(ct))}constructor(W,me,Te){this.items=pn.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=pn;var ge;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(ge=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ze=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var at;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(at=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ct{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Ct;var Rt;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(ai=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ci{constructor(W,me=[]){this.uri=W,this.provides=(0,a.asArray)(me)}}e.NotebookRendererScript=ci;class li{constructor(W){this.label=W}}e.NotebookKernelSourceAction=li;let xn=class{constructor(W,me){this.label=W,this.timestamp=me}};xn=qe([O],xn),e.TimelineItem=xn;var ui;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(ui=e.ExtensionMode||(e.ExtensionMode={}));var di;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(di=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hi=e.StandardTokenType||(e.StandardTokenType={}));class fi{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=fi;class mi{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mi;var gi;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gi=e.TestResultState||(e.TestResultState={}));var pi;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Un=class{constructor(W=void 0,me=void 0,Te=void 0){this.include=W,this.exclude=me,this.profile=Te}};Un=qe([O],Un),e.TestRunRequest=Un;let Qn=class extends Un{constructor(W=void 0,me=void 0,Te=void 0,Ke=!1){super(W,me,Te),this.continuous=Ke}};Qn=qe([O],Qn),e.TestRunRequest2=Qn;let _n=F=class{static diff(W,me,Te){const Ke=new F(W);return Ke.expectedOutput=me,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};_n=F=qe([O],_n),e.TestMessage=_n;let Jn=class{constructor(W){this.id=W}};Jn=qe([O],Jn),e.TestTag=Jn;let bn=class{constructor(W,me){this.covered=W,this.total=me}};bn=qe([O],bn),e.CoveredCount=bn;let Yn=B=class{static fromDetails(W,me){const Te=new bn(0,0),Ke=new bn(0,0),Je=new bn(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ot of dt.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else Je.total+=1,Je.covered+=dt.executionCount>0?1:0;const ct=new B(W,Te,Ke.total>0?Ke:void 0,Je.total>0?Je:void 0);return ct.detailedCoverage=me,ct}constructor(W,me,Te,Ke){this.uri=W,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=Ke}};Yn=B=qe([O],Yn),e.FileCoverage=Yn;let Zn=class{constructor(W,me,Te=[]){this.executionCount=W,this.location=me,this.branches=Te}};Zn=qe([O],Zn),e.StatementCoverage=Zn;let ei=class{constructor(W,me){this.executionCount=W,this.location=me}};ei=qe([O],ei),e.BranchCoverage=ei;let ti=class{constructor(W,me){this.executionCount=W,this.location=me}};ti=qe([O],ti),e.FunctionCoverage=ti;var bi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(bi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(wi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var vi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Ei{constructor(W,me,Te,Ke,Je,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.TypeHierarchyItem=Ei;class Si{constructor(W){this.uri=W}}e.TextTabInput=Si;class yi{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=yi;class Ci{constructor(W,me,Te,Ke){this.base=W,this.input1=me,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Ci;class Di{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Di;class Ii{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ii;class ki{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=ki;class Ti{constructor(W,me,Te){this.original=W,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Ti;class Pi{constructor(){}}e.TerminalEditorTabInput=Pi;class Ai{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=Ai}),define(ye[135],Ce([1,0,51,17,8,164,106,7,16]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const D=new Map;function L(v,m){m?D.set(v,m):D.delete(v)}e.setWordDefinitionFor=L;function P(v){return D.get(v)}class w extends R.MirrorTextModel{constructor(m,h,f,p,b,S,g,i){super(h,f,p,b),this.m=m,this.p=S,this.q=g,this.notebook=i,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(m){return(0,y.equals)(this.d,m)}get document(){if(!this.a){const m=this;this.a={get uri(){return m.c},get fileName(){return m.c.fsPath},get isUntitled(){return m.c.scheme===t.Schemas.untitled},get languageId(){return m.p},get version(){return m.g},get isClosed(){return m.b},get isDirty(){return m.q},save(){return m.r()},getText(h){return h?m.s(h):m.getText()},get eol(){return m.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return m.d.length},lineAt(h){return m.t(h)},offsetAt(h){return m.u(h)},positionAt(h){return m.v(h)},validateRange(h){return m.w(h)},validatePosition(h){return m.x(h)},getWordRangeAtPosition(h,f){return m.y(h,f)}}}return Object.freeze(this.a)}_acceptLanguageId(m){(0,a.ok)(!this.b),this.p=m}_acceptIsDirty(m){(0,a.ok)(!this.b),this.q=m}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(m){const h=this.w(m);if(h.isEmpty)return"";if(h.isSingleLine)return this.d[h.start.line].substring(h.start.character,h.end.character);const f=this.f,p=h.start.line,b=h.end.line,S=[];S.push(this.d[p].substring(h.start.character));for(let g=p+1;g<b;g++)S.push(this.d[g]);return S.push(this.d[b].substring(0,h.end.character)),S.join(f)}t(m){let h;if(m instanceof A.Position?h=m.line:typeof m=="number"&&(h=m),typeof h!="number"||h<0||h>=this.d.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new C(h,this.d[h],h===this.d.length-1)}u(m){return m=this.x(m),this.k(),this.h.getPrefixSum(m.line-1)+m.character}v(m){m=Math.floor(m),m=Math.max(0,m),this.k();const h=this.h.getIndexOf(m),f=this.d[h.index].length;return new A.Position(h.index,Math.min(h.remainder,f))}w(m){if(!(m instanceof A.Range))throw new Error("Invalid argument");const h=this.x(m.start),f=this.x(m.end);return h===m.start&&f===m.end?m:new A.Range(h.line,h.character,f.line,f.character)}x(m){if(!(m instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return m.with(0,0);let{line:h,character:f}=m,p=!1;if(h<0)h=0,f=0,p=!0;else if(h>=this.d.length)h=this.d.length-1,f=this.d[h].length,p=!0;else{const b=this.d[h].length;f<0?(f=0,p=!0):f>b&&(f=b,p=!0)}return p?new A.Position(h,f):m}y(m,h){const f=this.x(m);if(!h)h=P(this.p);else if((0,T.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const p=(0,I.getWordAtText)(f.character+1,(0,I.ensureValidWordDefinition)(h),this.d[f.line],0);if(p)return new A.Range(f.line,p.startColumn-1,f.line,p.endColumn-1)}}e.ExtHostDocumentData=w;class C{constructor(m,h,f){this.a=m,this.b=h,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=C}),define(ye[237],Ce([1,0,7,18,3]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new T.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=a.ColorThemeKind.Light;break;case"hcDark":y=a.ColorThemeKind.HighContrast;break;case"hcLight":y=a.ColorThemeKind.HighContrastLight;break;default:y=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[15],Ce([1,0,16,23,148,63,112,28,147,87,85,22,10,2,36,68,124,132,130,92,57,73,232,7]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Re){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:_e,positionColumn:Ve}=re,tt=new s.Position(Ne-1,$e-1),St=new s.Position(_e-1,Ve-1);return new s.Selection(tt,St)}Re.to=Oe;function Se(re){const{anchor:Ne,active:$e}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Re.from=Se})(o=e.Selection||(e.Selection={}));var l;(function(Re){function Oe(re){if(!re)return;const{start:Ne,end:$e}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:_e,endColumn:Ve}=re;return new s.Range(Ne-1,$e-1,_e-1,Ve-1)}Re.to=Se})(l=e.Range||(e.Range={}));var c;(function(Re){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Oe})(c=e.TokenType||(e.TokenType={}));var u;(function(Re){function Oe(re){return new s.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(u=e.Position||(e.Position={}));var r;(function(Re){function Oe(Ne,$e){return(0,a.coalesce)((0,a.asArray)(Ne).map(_e=>Se(_e,$e)))}Re.from=Oe;function Se(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,$e),pattern:z.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(r=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Re){function Oe(re){switch(re){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(Re){function Oe(re){let Ne;return re.code&&((0,w.isString)(re.code)||(0,w.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...l.from(re.range),message:re.message,source:re.source,code:Ne,severity:k.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,a.coalesce)(re.tags.map(n.from)):void 0}}Re.from=Oe;function Se(re){const Ne=new s.Diagnostic(l.to(re),re.message,k.to(re.severity));return Ne.source=re.source,Ne.code=(0,w.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Ne.tags=re.tags&&(0,a.coalesce)(re.tags.map(n.to)),Ne}Re.to=Se})(d=e.Diagnostic||(e.Diagnostic={}));var E;(function(Re){function Oe(re){return{...l.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new s.DiagnosticRelatedInformation(new s.Location(re.resource,l.to(re)),re.message)}Re.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var k;(function(Re){function Oe(re){switch(re){case s.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case h.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Se})(k=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var M;(function(Re){function Oe(re){return typeof re=="number"&&re>=s.ViewColumn.One?re-1:re===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(M=e.ViewColumn||(e.ViewColumn={}));function K(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!K(Re[0])}e.isDecorationOptionsArr=q;var F;(function(Re){function Oe(Ve){return Ve.map(Re.from)}Re.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Se(Ve)){const{language:vt,value:It}=Ve;tt={value:"```"+vt+`
`+It+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const Et=vt=>{try{let It=C.URI.parse(vt,!0);It=It.with({query:Ne(It.query,St)}),St[vt]=It}catch{}return""},Lt=new y.marked.Renderer;return Lt.link=Et,Lt.image=vt=>typeof vt=="string"?Et(I.parseHrefAndDimensions(vt).href):"",(0,y.marked)(tt.value,{renderer:Lt}),tt}Re.from=re;function Ne(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,D.parse)(Ve)}catch{}if(!St)return Ve;let Et=!1;return St=(0,P.cloneAndChange)(St,Lt=>{if(C.URI.isUri(Lt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=Lt,Et=!0,vt}else return}),Et?JSON.stringify(St):Ve}function $e(Ve){const tt=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?C.URI.from(Ve.baseUri):void 0,tt}Re.to=$e;function _e(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Re.from(Ve)}Re.fromStrict=_e})(F=e.MarkdownString||(e.MarkdownString={}));function B(Re){return q(Re)?Re.map(Oe=>({range:l.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?F.fromMany(Oe.hoverMessage):Oe.hoverMessage?F.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:l.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?C.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ue;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?$.from(Se.light):void 0,dark:Se.dark?$.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(ue=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:l.from(re.range)}}Re.from=Oe;function Se(re){const Ne=new s.TextEdit(l.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Re.to=Se})(V=e.TextEdit||(e.TextEdit={}));var _;(function(Re){function Oe(re,Ne){const $e={edits:[]};if(re instanceof s.WorkspaceEdit){const _e=new A.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&C.URI.isUri(Ve.to)&&Ve.from===void 0&&_e.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:V.from(Ve.edit),versionId:_e.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:l.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:_e.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(gt.from)}})}return $e}Re.from=Oe;function Se(re){const Ne=new s.WorkspaceEdit;for(const $e of re.edits)$e.textEdit?Ne.replace(C.URI.revive($e.resource),l.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(C.URI.revive($e.oldResource),C.URI.revive($e.newResource),$e.options);return Ne}Re.to=Se})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Y;(function(Re){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function re(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return s.SymbolKind.Property}Re.to=re})(Y=e.SymbolKind||(e.SymbolKind={}));var ne;(function(Re){function Oe(re){switch(re){case s.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return s.SymbolTag.Deprecated}}Re.to=Se})(ne=e.SymbolTag||(e.SymbolTag={}));var ee;(function(Re){function Oe(re){return{name:re.name,kind:Y.from(re.kind),tags:re.tags&&re.tags.map(ne.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Oe;function Se(re){const Ne=new s.SymbolInformation(re.name,Y.to(re.kind),re.containerName,Ee.to(re.location));return Ne.tags=re.tags&&re.tags.map(ne.to),Ne}Re.to=Se})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:l.from(re.range),selectionRange:l.from(re.selectionRange),kind:Y.from(re.kind),tags:re.tags?.map(ne.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Re.from=Oe;function Se(re){const Ne=new s.DocumentSymbol(re.name,re.detail,Y.to(re.kind),l.to(re.range),l.to(re.selectionRange));return(0,a.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(ne.to)),re.children&&(Ne.children=re.children.map(Se)),Ne}Re.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(Re){function Oe(re){const Ne=new s.CallHierarchyItem(Y.to(re.kind),re.name,re.detail||"",C.URI.revive(re.uri),l.to(re.range),l.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:re.name,detail:re.detail,kind:Y.from(re.kind),uri:re.uri,range:l.from(re.range),selectionRange:l.from(re.selectionRange),tags:re.tags?.map(ne.from)}}Re.from=Se})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(Re){function Oe(Se){return new s.CallHierarchyIncomingCall(G.to(Se.from),Se.fromRanges.map(re=>l.to(re)))}Re.to=Oe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Re){function Oe(Se){return new s.CallHierarchyOutgoingCall(G.to(Se.to),Se.fromRanges.map(re=>l.to(re)))}Re.to=Oe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(re){return{range:re.range&&l.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new s.Location(C.URI.revive(re.uri),l.to(re.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Pe;(function(Re){function Oe(re){const Ne=re,$e=re;return{originSelectionRange:Ne.originSelectionRange?l.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:l.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?l.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:C.URI.revive(re.uri),targetRange:l.to(re.range),targetSelectionRange:re.targetSelectionRange?l.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?l.to(re.originSelectionRange):void 0}}Re.to=Se})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Re){function Oe(re){return{range:l.from(re.range),contents:F.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new s.Hover(re.contents.map(F.to),l.to(re.range))}Re.to=Se})(Fe=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:l.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new s.EvaluatableExpression(l.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var oe;(function(Re){function Oe(re){if(re instanceof s.InlineValueText)return{type:"text",range:l.from(re.range),text:re.text};if(re instanceof s.InlineValueVariableLookup)return{type:"variable",range:l.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:l.to(re.range),text:re.text};case"variable":return{range:l.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:l.to(re.range),expression:re.expression}}}Re.to=Se})(oe=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:l.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new s.InlineValueContext(re.frameId,l.to(re.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Re){function Oe(re){return{range:l.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new s.DocumentHighlight(l.to(re.range),re.kind)}Re.to=Se})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Re){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Oe(re){switch(re){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se($e){return Oe.get($e)??9}Re.from=Se;const re=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ne($e){return re.get($e)??s.CompletionItemKind.Property}Re.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Re){function Oe(Se,re){const Ne=new s.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=H.to(Se.kind),Ne.tags=Se.tags?.map(N.to),Ne.detail=Se.detail,Ne.documentation=I.isMarkdownString(Se.documentation)?F.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,v.Range.isIRange(Se.range)?Ne.range=l.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:l.to(Se.range.insert),replacing:l.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new s.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof s.Range?new s.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map($e=>V.to($e))),Ne.command=re&&Se.command?re.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(Q=e.CompletionItem||(e.CompletionItem={}));var J;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation}}Re.to=Se})(J=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Oe(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(J.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(J.to):[],activeParameter:re.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Oe(Se,re){const Ne=new s.InlayHint(u.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&De.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=I.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Re.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Ne=new s.InlayHintLabelPart(re.label);return Ne.tooltip=I.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,m.Command.is(re.command)&&(Ne.command=Se.fromInternal(re.command)),re.location&&(Ne.location=Ee.to(re.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:l.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?C.URI.parse(re.url,!0):C.URI.revive(re.url)}catch{}return new s.DocumentLink(l.to(re.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Re){function Oe(re){const Ne=new s.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map($e=>V.to($e))),Ne}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Re.from=Se})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(re){return new s.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:l.from(re.range)}}Re.from=Oe;function Se(re){return new s.SelectionRange(l.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===s.EndOfLine.CRLF)return 1;if(re===s.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return s.EndOfLine.CRLF;if(re===0)return s.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=it.from(Se.kind)),re}Re.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Re){function Oe(Se){if(Se)switch(Se){case s.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Re.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?l.from(Se.selection):void 0,override:typeof Se.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var z;(function(Re){function Oe($e){return $e instanceof s.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Se($e)||re($e)?new s.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Re.from=Oe;function Se($e){const _e=$e;return _e?C.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re($e){const _e=$e;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new s.RelativePattern(C.URI.revive($e.baseUri),$e.pattern)}Re.to=Ne})(z=e.GlobPattern||(e.GlobPattern={}));var le;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:z.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(le=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new s.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Re){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Oe(re){switch(re){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Se})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const $e of re.cells)s.NotebookCellData.validate($e),Ne.cells.push(gt.from($e));return Ne}Re.from=Oe;function Se(re){const Ne=new s.NotebookData(re.cells.map(gt.to));return(0,w.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var gt;(function(Re){function Oe(re){return{cellKind:Xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Re.from=Oe;function Se(re){return new s.NotebookCellData(Xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(gt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new s.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Ne=re.items.map(mt.to);return new s.NotebookCellOutput(Ne,re.outputId,re.metadata)}Re.to=Se})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Re){function Oe(Ne){return re(Ne)?{include:(0,w.withNullAsUndefined)(z.from(Ne.include)),exclude:(0,w.withNullAsUndefined)(z.from(Ne.exclude))}:(0,w.withNullAsUndefined)(z.from(Ne))}Re.from=Oe;function Se(Ne){return re(Ne)?{include:z.to(Ne.include),exclude:z.to(Ne.exclude)}:z.to(Ne)}Re.to=Se;function re(Ne){const $e=Ne;return $e?!(0,w.isUndefinedOrNull)($e.include)&&!(0,w.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Re){function Oe(Se,re,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal($e,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Re){function Oe(Se,re,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal($e,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(kt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Tt;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new s.NotebookRendererScript(C.URI.revive(re.uri),re.provides)}Re.to=Se})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Re){function Oe(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:l.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Ne=new s.TestMessage(typeof re.message=="string"?re.message:F.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?Ee.to(re.location):void 0,Ne}Re.to=Se})(pt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=g.namespaceTestTag,Re.denamespace=g.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var zt;(function(Re){function Oe(re){const Ne=(0,f.getPrivateApiFor)(re).controllerId;return{extId:S.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:C.URI.revive(re.uri),busy:re.busy,tags:re.tags.map($e=>Dt.namespace(Ne,$e.id)),range:v.Range.lift(l.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:S.TestId.fromString(re.extId).localId,label:re.label,uri:C.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:$e}=Dt.denamespace(Ne);return new s.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(zt=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new s.TestTag(re.id)}Re.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Re){const Oe=(re,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)S.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const _e={...zt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of _e.children)Ve.parent=_e;return _e};function Se(re){const Ne=[],$e=new Map;for(const _e of re.items){$e.set(_e.item.extId,_e);const Ve=S.TestId.root(_e.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:re.completedAt,results:Ne.map(_e=>Oe(_e,$e))}}Re.to=Se})(Ft=e.TestResults||(e.TestResults={}));var xe;(function(Re){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Se($e){return"line"in $e?u.from($e):l.from($e)}function re($e){return"branches"in $e?{count:$e.executionCount,location:Se($e.location),type:1,branches:$e.branches.length?$e.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:$e.executionCount,location:Se($e.location)}}Re.fromDetailed=re;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(re)}}Re.fromFile=Ne})(xe=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Re){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Re){function Oe(re){const Ne=new s.TypeHierarchyItem(Y.to(re.kind),re.name,re.detail||"",C.URI.revive(re.uri),l.to(re.range),l.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Y.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:l.from(re.range),selectionRange:l.from(re.selectionRange),tags:re.tags?.map(ne.from)}}Re.from=Se})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Bt=e.ViewBadge||(e.ViewBadge={}));var wt;(function(Re){function Oe($e,_e,Ve){const tt=_e.fileData;return tt?new class extends s.DataTransferItem{asFile(){return{name:tt.name,uri:C.URI.revive(tt.uri),data:(0,R.once)(()=>Ve())}}}("",_e.id):$e===L.Mimes.uriList&&_e.uriListData?new s.DataTransferItem(Ne(_e.uriListData)):new s.DataTransferItem(_e.asString)}Re.to=Oe;async function Se($e,_e){const Ve=await _e.asString();if($e===L.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=_e.asFile();return{id:_e.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=Se;function re($e){return T.UriList.split($e).map(_e=>{if(_e.startsWith("#"))return _e;try{return C.URI.parse(_e)}catch{}return _e})}function Ne($e){return T.UriList.create($e.map(_e=>typeof _e=="string"?_e:C.URI.revive(_e)))}})(wt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Re){function Oe(re,Ne){const $e=re.items.map(([_e,Ve])=>[_e,wt.to(_e,Ve,()=>Ne(Ve.id))]);return new s.DataTransfer($e)}Re.toDataTransfer=Oe;async function Se(re){const Ne={items:[]},$e=[];return re.forEach((_e,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await wt.from(Ve,_e)])})())}),await Promise.all($e),Ne}Re.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[238],Ce([1,0,2,9,7,15,65]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(D,L,P,w={timeout:1500,errors:3}){this.c=D,this.d=L,this.f=P,this.g=w,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(L,P,w)=>{const v={dispose:this.a.push([L,P,D])};return Array.isArray(w)&&w.push(v),v}}async $participateInSave(D,L){const P=a.URI.revive(D);let w=!1;const C=setTimeout(()=>w=!0,this.g.timeout),v=[];try{for(const m of[...this.a]){if(w)break;const h=this.d.getDocument(P),f=await this.h(m,{document:h,reason:R.TextDocumentSaveReason.to(L)});v.push(f)}}finally{clearTimeout(C)}return v}h([D,L,P],w){const C=this.b.get(D);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(P,D,L,w).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const m=this.b.get(D);this.b.set(D,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,L,P,w){const C=[],v=Date.now(),{document:m,reason:h}=w,{version:f}=m,p=Object.freeze({document:m,reason:h,waitUntil(b){if(Object.isFrozen(C))throw(0,t.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(b))}});try{L.apply(P,[p])}catch(b){return Promise.reject(b)}return Object.freeze(C),new Promise((b,S)=>{const g=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(C).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(g),b(i)}).catch(i=>{clearTimeout(g),S(i)})}).then(b=>{const S={edits:[]};for(const g of b)if(Array.isArray(g)&&g.every(i=>i instanceof T.TextEdit))for(const{newText:i,newEol:s,range:o}of g)S.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:o&&R.Range.from(o),text:i,eol:s&&R.EndOfLine.from(s)}});if(S.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[239],Ce([1,0,17,2,15,7,92]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,w,C,v){this.start=P,this.deletedCount=w,this.deletedItems=C,this.items=v}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,w,C){this.notebook=P,this.h=w,this.j=C,this.handle=C.handle,this.uri=t.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(T.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(T.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:T.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(C)}return this.f}setOutputs(P){this.a=P.map(T.NotebookCellOutput.to)}setOutputItems(P,w,C){const v=C.map(T.NotebookCellOutputItem.to),m=this.a.find(h=>h.id===P);if(m&&(w||(m.items.length=0),m.items.push(...v),m.items.length>1&&m.items.every(h=>I.isTextStreamMime(h.mime)))){const h=new Map,f=[];m.items.forEach(p=>{let b;h.has(p.mime)?b=h.get(p.mime):(b=[],h.set(p.mime,b),f.push(p.mime)),b.push(p.data)}),m.items.length=0,f.forEach(p=>{const b=I.compressOutputItemStreams(h.get(p));m.items.push({mime:p,data:b.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(T.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class D{constructor(P,w,C,v,m){this.k=P,this.l=w,this.m=C,this.uri=v,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=m.viewType,this.f=Object.freeze(m.metadata??Object.create(null)),this.r([[0,0,m.cells]],!0,void 0),this.g=m.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,w={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===a.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(C){return C=P.n(C),P.b[C].apiCell},getCells(C){return(C?P.p(C):P.b).map(m=>m.apiCell)},save(){return P.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,w,C){this.g=P.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:C});const v={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},m=[];for(const f of P.rawEvents)f.kind===I.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,v.contentChanges):f.kind===I.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,v.contentChanges):f.kind===I.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),m.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===I.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),m.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),m.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===I.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),m.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),m.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const h=new Map;for(let f=0;f<m.length;f++){const p=m[f],b=h.get(p.cell);if(b===void 0){const S=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});h.set(p.cell,S-1)}else v.cellChanges[b]={...v.cellChanges[b],...p}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let w=P.start|0,C=P.end|0;return w<0&&(w=0),C>this.b.length&&(C=this.b.length),P.with({start:w,end:C})}p(P){P=this.o(P);const w=[];for(let C=P.start;C<P.end;C++)w.push(this.b[C]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,w,C){if(this.j)return;const v=[],m=[],h=[];if(P.reverse().forEach(f=>{const b=f[2].map(i=>{const s=new y(this,this.l,i);return w||m.push(y.asModelAddData(this.apiNotebook,i)),s}),S=new A(f[0],f[1],[],b),g=this.b.splice(f[0],f[1],...b);for(const i of g)h.push(i.uri),S.deletedItems.push(i.apiCell);v.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:h}),C)for(const f of v)C.push(f.asApiEvent())}s(P,w,C,v){const m=this.b.splice(P,w);this.b.splice(C,0,...m);const h=[new A(P,w,m.map(f=>f.apiCell),[]),new A(C,0,[],m)];for(const f of h)v.push(f.asApiEvent())}t(P,w){this.b[P].setOutputs(w)}u(P,w,C,v){this.b[P].setOutputItems(w,C,v)}v(P,w){const C=this.b[P];C.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(C.uri,w)}w(P,w){const C=this.b[P];C.apiCell.mime=w}x(P,w){this.b[P].setMetadata(w)}y(P,w){this.b[P].setInternalMetadata(w)}getCellFromApiCell(P){return this.b.find(w=>w.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(w=>w.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=D,D.a=0}),define(ye[136],Ce([1,0,9,15,7]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,D,L,P,w){this.id=A,this.f=y,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=w}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(T.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,D){A.f.$tryRevealRange(A.id,t.NotebookRange.from(y),D??T.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(t.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ye[240],Ce([1,0,3,13,15]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const D=this.d.getEditorById(A);y.visibleRanges&&D._acceptVisibleRanges(y.visibleRanges.ranges.map(T.NotebookRange.to)),y.selections&&D._acceptSelections(y.selections.selections.map(T.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(T.ViewColumn.to(A[y]))}};R=qe([We(0,t.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[241],Ce([1,0,15,126,178,21,62,9]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,C,v){const m=this.b++,{title:h,location:f,cancellable:p}=C,b={label:(0,T.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(m,{location:a.ProgressLocation.from(f),title:h,source:b,cancellable:p},w.isUnderDevelopment?void 0:w.identifier.value).catch(A.onUnexpectedExternalError),this.d(m,v,!!p)}d(w,C,v){let m;v&&(m=new R.CancellationTokenSource,this.c.set(w,m));const h=p=>{this.a.$progressEnd(p),this.c.delete(p),m?.dispose()};let f;try{f=C(new L(this.a,w),v&&m?m.token:R.CancellationToken.None)}catch(p){throw h(w),p}return f.then(p=>h(w),p=>h(w)),f}$acceptProgressCanceled(w){const C=this.c.get(w);C&&(C.cancel(),this.c.delete(w))}}e.ExtHostProgress=y;function D(P,w){return P.message=w.message,typeof w.increment=="number"&&(typeof P.increment=="number"?P.increment+=w.increment:P.increment=w.increment),P}class L extends t.Progress{constructor(w,C){super(v=>this.throttledReport(v)),this.c=w,this.d=C}throttledReport(w){this.c.$progressReport(this.d,w)}}qe([(0,I.throttle)(100,(P,w)=>D(P,w),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,36,132,57,93,73,15,2]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(b,S,g,i)=>{let s=S;return{enumerable:!0,configurable:!1,get(){return s},set(o){if(!g(s,o)){const l=s;s=o,b.listener?.(i(o,l))}}}},L=(b,S)=>b===S,P={range:(b,S)=>b===S?!0:!b||!S?!1:b.isEqual(S),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,S)=>!(b.length!==S.length||b.some(g=>!S.find(i=>g.id===i.id)))},w=b=>S=>({op:4,update:b(S)}),C=(b,S)=>({range:(()=>{let g;const i=w(s=>({range:a.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return g},set(s){b.listener?.({op:6}),P.range(g,s)||(g=s,b.listener?.(i(s)))}}})(),label:D(b,S,P.label,w(g=>({label:g}))),description:D(b,void 0,P.description,w(g=>({description:g}))),sortText:D(b,void 0,P.sortText,w(g=>({sortText:g}))),canResolveChildren:D(b,!1,P.canResolveChildren,g=>({op:2,state:g})),busy:D(b,!1,P.busy,w(g=>({busy:g}))),error:D(b,void 0,P.error,w(g=>({error:A.MarkdownString.fromStrict(g)||null}))),tags:D(b,[],P.tags,(g,i)=>({op:1,new:g.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),v=b=>{const S=T.TestId.fromString(b.extId),g=new h(S.controllerId,S.localId,b.label,y.URI.revive(b.uri)||void 0);return g.range=A.Range.to(b.range||void 0),g.description=b.description||void 0,g.sortText=b.sortText||void 0,g.tags=b.tags.map(i=>A.TestTag.to({id:(0,I.denamespaceTestTag)(i).tagId})),g},m=b=>{let S;for(const g of b.tests){const i=v(g.item);(0,t.getPrivateApiFor)(i).parent=S,S=i}return S};e.toItemFromContext=m;class h{constructor(S,g,i,s){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const o=(0,t.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof f?void 0:o.parent}},children:{value:(0,R.createTestItemChildren)(o,t.getPrivateApiFor,h),enumerable:!0,writable:!1},...C(o,i)})}}e.TestItemImpl=h;class f extends h{constructor(S,g){super(S,S,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class p extends R.TestItemCollection{constructor(S,g,i){super({controllerId:S,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:t.getPrivateApiFor,getChildren:s=>s.children,root:new f(S,g),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ye[138],Ce([1,0,51,9,101,15,7]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(w,C,v){const m=A.c.nextId();w.$registerTextEditorDecorationType(C.identifier,m,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:m,dispose(){w.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=A,A.c=new T.IdGenerator("TextEditorDecorationType");class y{constructor(w,C){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,C){this.k();let v=null;if(w instanceof I.Position)v=new I.Range(w,w);else if(w instanceof I.Range)v=w;else throw new Error("Unrecognized location");this.l(v,C,!1)}insert(w,C){this.k(),this.l(new I.Range(w,w),C,!0)}delete(w){this.k();let C=null;if(w instanceof I.Range)C=w;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(w,C,v){const m=this.c.validateRange(w);this.g.push({range:m,text:C,forceMoveMarkers:v})}setEndOfLine(w){if(this.k(),w!==I.EndOfLine.LF&&w!==I.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=w}}class D{constructor(w,C,v,m){this.c=w,this.d=C,this._accept(v),this.e=m;const h=this;this.value={get tabSize(){return h.f},set tabSize(f){h.m(f)},get indentSize(){return h.g},set indentSize(f){h.o(f)},get insertSpaces(){return h.h},set insertSpaces(f){h.q(f)},get cursorStyle(){return h.j},set cursorStyle(f){h.s(f)},get lineNumbers(){return h.k},set lineNumbers(f){h.t(f)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const C=Math.floor(w);return C>0?C:null}if(typeof w=="string"){const C=parseInt(w,10);return isNaN(C)?null:C>0?C:null}return null}m(w){const C=this.l(w);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const C=Math.floor(w);return C>0?C:null}if(typeof w=="string"){const C=parseInt(w,10);return isNaN(C)?null:C>0?C:null}return null}o(w){const C=this.n(w);if(C!==null){if(typeof C=="number"){if(this.g===C)return;this.g=C}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}p(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}q(w){const C=this.p(w);if(typeof C=="boolean"){if(this.h===C)return;this.h=C}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(w)})))}assign(w){const C={};let v=!1;if(typeof w.tabSize<"u"){const m=this.l(w.tabSize);m==="auto"?(v=!0,C.tabSize=m):typeof m=="number"&&this.f!==m&&(this.f=m,v=!0,C.tabSize=m)}if(typeof w.indentSize<"u"){const m=this.n(w.indentSize);m==="tabSize"?(v=!0,C.indentSize=m):typeof m=="number"&&this.g!==m&&(this.g=m,v=!0,C.indentSize=m)}if(typeof w.insertSpaces<"u"){const m=this.p(w.insertSpaces);m==="auto"?(v=!0,C.insertSpaces=m):this.h!==m&&(this.h=m,v=!0,C.insertSpaces=m)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,v=!0,C.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,v=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(w.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,C))}u(w,C){C.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=D;class L{constructor(w,C,v,m,h,f,p,b){this.id=w,this.j=C,this.k=v,this.g=!1,this.h=new Set,this.c=h,this.d=new D(this.j,this.id,f,v),this.e=p,this.f=b;const S=this;this.value=Object.freeze({get document(){return m.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return S.c&&S.c[0]},set selection(g){if(!(g instanceof I.Selection))throw(0,t.illegalArgument)("selection");S.c=[g],S.l()},get selections(){return S.c},set selections(g){if(!Array.isArray(g)||g.some(i=>!(i instanceof I.Selection)))throw(0,t.illegalArgument)("selections");S.c=g,S.l()},get visibleRanges(){return S.e},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return S.d.value},set options(g){S.g||S.d.assign(g)},get viewColumn(){return S.f},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,i={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(m.getValue(),i);return g(s),S.m(s)},insertSnippet(g,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!i||Array.isArray(i)&&i.length===0)o=S.c.map(l=>R.Range.from(l));else if(i instanceof I.Position){const{lineNumber:l,column:c}=R.Position.from(i);o=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(i instanceof I.Range)o=[R.Range.from(i)];else{o=[];for(const l of i)if(l instanceof I.Range)o.push(R.Range.from(l));else{const{lineNumber:c,column:u}=R.Position.from(l);o.push({startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u})}}return C.$tryInsertSnippet(w,m.getValue().version,g.value,o,s)},setDecorations(g,i){const s=i.length===0;s&&!S.h.has(g.key)||(s?S.h.delete(g.key):S.h.add(g.key),S.n(()=>{if(R.isDecorationOptionsArr(i))return C.$trySetDecorations(w,g.key,R.fromRangeOrRangeWithMessage(i));{const o=new Array(4*i.length);for(let l=0,c=i.length;l<c;l++){const u=i[l];o[4*l]=u.start.line+1,o[4*l+1]=u.start.character+1,o[4*l+2]=u.end.line+1,o[4*l+3]=u.end.character+1}return C.$trySetDecorationsFast(w,g.key,o)}}))},revealRange(g,i){S.n(()=>C.$tryRevealRange(w,R.Range.from(g),i||I.TextEditorRevealType.Default))},show(g){C.$tryShowEditor(w,R.ViewColumn.from(g))},hide(){C.$tryHideEditor(w)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,a.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,a.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,a.ok)(!this.g),this.f=w}_acceptSelections(w){(0,a.ok)(!this.g),this.c=w}async l(){const w=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const C=w.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const v=C.edits.map(h=>h.range);v.sort((h,f)=>h.end.line===f.end.line?h.end.character===f.end.character?h.start.line===f.start.line?h.start.character-f.start.character:h.start.line-f.start.line:h.end.character-f.end.character:h.end.line-f.end.line);for(let h=0,f=v.length-1;h<f;h++){const p=v[h].end;if(v[h+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=C.edits.map(h=>({range:R.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,m,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.ExtHostTextEditor=L}),define(ye[242],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[243],Ce([1,0,193,9,38,123,91,33,27,242,205,195]),function(te,e,a,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=A.Registry.as(I.Extensions.JSONContribution);class C{constructor(g,i,s){this.a=g,this.b=i,this.c=s}d(g,i){this.a({type:g,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(T.default.Error,g)}warn(g){this.d(T.default.Warning,g)}info(g){this.d(T.default.Info,g)}}e.ExtensionMessageCollector=C;class v{static a(g){const i=new Set;for(let s=0,o=g.length;s<o;s++)i.add(y.ExtensionIdentifier.toKey(g[s].description.identifier));return i}static compute(g,i){if(!g||!g.length)return new v(i,[]);if(!i||!i.length)return new v([],g);const s=this.a(g),o=this.a(i),l=i.filter(u=>!s.has(y.ExtensionIdentifier.toKey(u.description.identifier))),c=g.filter(u=>!o.has(y.ExtensionIdentifier.toKey(u.description.identifier)));return new v(l,c)}constructor(g,i){this.added=g,this.removed=i}}e.ExtensionPointUserDelta=v;class m{constructor(g,i){this.name=g,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=v.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,t.onUnexpectedError)(g)}}}e.ExtensionPoint=m;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const i=new m(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,i),g.activationEventsGenerator&&P.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,w.registerSchema(f,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),w.registerSchema(f,e.schema),w.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(ye[244],Ce([1,0,190,10,22,243,54,3]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var D;(function(w){function C(v,m,h){if(!v)return;const f=t.isString(v.type)?v.type:void 0;if(!f||f.length===0){h.error(a.localize(3,null));return}const p=[];if(Array.isArray(v.required))for(const b of v.required)t.isString(b)&&p.push(b);return{extensionId:m.value,taskType:f,required:p,properties:v.properties?T.deepClone(v.properties):{},when:v.when?I.ContextKeyExpr.deserialize(v.when):void 0}}w.from=C})(D||(D={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,v)=>{L.setHandler((m,h)=>{this.c=void 0;try{for(const f of h.removed){const p=f.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const f of h.added){const p=f.value;for(const b of p){const S=D.from(b,f.description.identifier,f.collector);S&&(this.a[S.taskType]=S)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const v of this.all()){const m={type:"object",additionalProperties:!1};v.required.length>0&&(m.required=v.required.slice(0)),v.properties!==void 0?m.properties=T.deepClone(v.properties):m.properties=Object.create(null),m.properties.type={type:"string",enum:[v.taskType]},C.push(m)}this.c={oneOf:C}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[245],Ce([1,0,191,10,24,22,54,244]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U($){if(!$)return O.Strong;switch($.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(y=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U($){switch($.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var P;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U($){switch($.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var w;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(w=e.PanelKind||(e.PanelKind={})),function(O){function U($){switch($.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(w=e.PanelKind||(e.PanelKind={}));var C;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function $(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=$}(v=e.RuntimeType||(e.RuntimeType={}));var m;(function(O){function U($){return t.isString($)?$:$.value}O.value=U})(m=e.CommandString||(e.CommandString={}));var h;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function $(j){if(j!==void 0)return t.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=$})(h=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var p;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U($){switch($){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var S;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(S=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class i{constructor(U,$,j,ue,V,_){this._label="",this._id=U,$&&(this._label=$),j&&(this.type=j),this.runOptions=ue,this.configurationProperties=V,this._source=_}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,$=!1){if(U===void 0)return!1;if(t.isString(U))return U===this._label||U===this.configurationProperties.identifier||$&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class s extends i{constructor(U,$,j,ue,V,_,Y,ne){super(U,j,void 0,Y,ne,$),this.command={},this._source=$,this.hasDefinedMatchers=_,V&&(this.command=V)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case v.Shell:$="shell";break;case v.Process:$="process";break;case v.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(U){return U instanceof s}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&($+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new s(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=s;class o extends i{constructor(U,$,j,ue,V,_,Y){super(U,j,ue,_,Y,$),this._source=$,this.configures=V}static is(U){return U instanceof o}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&($+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(j)}}e.ConfiguringTask=o;class l extends i{constructor(U,$,j,ue,V,_,Y,ne,ee){super(U,j,ue,ne,ee,$),this.defines=V,this.hasDefinedMatchers=Y,this.command=_,this.icon=ee.icon,this.hide=ee.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof l}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new l(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=l;class c extends i{constructor(U,$,j,ue,V,_){super(U,j,ue,V,_,$),this._source=$}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new c(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=c;var u;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class n{constructor(U){this.c=new Map;for(let $=0;$<U.length;$++)this.c.set(U[$].uri.toString(),$)}compare(U,$){const j=U.getWorkspaceFolder(),ue=$.getWorkspaceFolder();if(j&&ue){let V=this.c.get(j.uri.toString());V=V===void 0?0:V+1;let _=this.c.get(ue.uri.toString());return _=_===void 0?0:_+1,V===_?U._label.localeCompare($._label):V-_}else return!j&&ue?-1:j&&!ue?1:0}}e.TaskSorter=n;var d;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(O){O.SingleRun="singleRun",O.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var k;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(k=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(O){function U($,j,ue,V){if(j){const _={kind:$,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ue,__task:j};return $==="start"?_.resolvedVariables=V:$==="processStarted"?_.processId=V:$==="processEnded"&&(_.exitCode=V),Object.freeze(_)}else return Object.freeze({kind:"changed"})}O.create=U})(M=e.TaskEvent||(e.TaskEvent={}));var K;(function(O){function U(j){const ue=Object.keys(j).sort();let V="";for(const _ of ue){let Y=j[_];Y instanceof Object?Y=U(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),V+=_+","+Y+","}return V}function $(j){const V={_key:U(j),type:j.taskType};return Object.assign(V,j),V}O.create=$})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function U($,j){const ue=A.TaskDefinitionRegistry.get($.type);if(ue===void 0){const ne=R.deepClone($);return delete ne._key,K.create(ne)}const V=Object.create(null);V.type=ue.taskType;const _=new Set;ue.required.forEach(ne=>_.add(ne));const Y=ue.properties;for(const ne of Object.keys(Y)){const ee=$[ne];if(ee!=null)V[ne]=ee;else if(_.has(ne)){const X=Y[ne];if(X.default!==void 0)V[ne]=R.deepClone(X.default);else switch(X.type){case"boolean":V[ne]=!1;break;case"number":case"integer":V[ne]=0;break;case"string":V[ne]="";break;default:j.error(a.localize(2,null,JSON.stringify($,void 0,0),ne));return}}}return K.create(V)}O.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[246],Ce([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,A)=>{this.b=I,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,a.onUnexpectedError)(I))}then(I,A){return this.j().then(I,A)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=t;class T extends t{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=T}),define(ye[58],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function T(A){const y=new a(A);return t[y.nid]=y,y}e.createProxyIdentifier=T;function R(A){return t[A].sid}e.getStringIdentifierForProxy=R;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(ye[5],Ce([1,0,58]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var R;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(h){return h._id=P.a++,h}}e.IdObject=P,P.a=0;var w;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(w=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[74],Ce([1,0,4,13,5,18]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,D){this.c=D,this.a=new Set,this.b=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,D,L){const P=this.d(y,D);this.a.has(P)||(this.a.add(P),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:y}))}d(y,D){return`${y}-${D.identifier.value}`}};I=qe([We(0,R.IExtHostRpcService),We(1,t.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,D){}})}),define(ye[247],Ce([1,0,3,5,7,27]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,D,L,P={}){const w=R.ExtensionIdentifier.toKey(y.identifier),C=this.f.get(w)||[],v=[...L].sort().join(" ");let m=C.find(h=>h.providerId===D&&h.scopes===v);if(m)return m.result;{const h=this.g(y,w,D,L,P);m={providerId:D,scopes:v,result:h},C.push(m),this.f.set(w,C);try{await h}finally{const f=C.findIndex(p=>p.providerId===D&&p.scopes===v);f>-1&&(C.splice(f),this.f.set(w,C))}return h}}async g(y,D,L,P,w={}){await this.a.$ensureProvider(L);const C=y.displayName||y.name;return this.a.$getSession(L,P,D,C,w)}async removeSession(y,D){const L=this.b.get(y);return L?L.provider.removeSession(D):this.a.$removeSession(y,D)}registerAuthenticationProvider(y,D,L,P){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:D,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===y)||this.c.push({id:y,label:D});const w=L.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(y,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(y,D,P?.supportsMultipleAccounts??!1),new T.Disposable(()=>{w.dispose(),this.b.delete(y);const C=this.c.findIndex(v=>v.id===y);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,D){return this.d.fire({provider:{id:y,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(ye[248],Ce([1,0,5,18,15]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>y.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,D){const L=T.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,D?.isRefactoring??!1)}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[249],Ce([1,0,5]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(R){const I=R.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=t});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[41],Ce([1,0,10,7,15,22,5,16,13,87,36,52,2,6,4,18,137,23,58,45,44,70]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(d,E){i.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Ye(this,i,d.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=E,Ye(this,s,d.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,k=>{const M=this.c.get(k);return M?.result===u.Void?M:void 0},E),this.f=[{processArgument(k){return(0,D.revive)(k)}},{processArgument(k){return(0,R.cloneAndChange)(k,function(M){if(L.Range.isIRange(M))return T.Range.to(M);if(P.Position.isIPosition(M))return T.Position.to(M);if(L.Range.isIRange(M.range)&&w.URI.isUri(M.uri))return T.location.to(M);if(M instanceof f.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const E=this.registerCommand(!1,d.id,async(...k)=>{const M=d.args.map((q,F)=>{if(!q.validate(k[F]))throw new Error(`Invalid argument '${q.name}' when running '${d.id}', received: ${k[F]}`);return q.convert(k[F])}),K=await this.executeCommand(d.internalId,...M);return d.result.convert(K,k,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new t.Disposable(()=>{E.dispose(),this.c.delete(d.id)})}registerCommand(d,E,k,M,K,q){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:M,description:K,extension:q}),d&&Ue(this,i,"f").$registerCommand(E),new t.Disposable(()=>{this.b.delete(E)&&d&&Ue(this,i,"f").$unregisterCommand(E)})}executeCommand(d,...E){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,E,!0)}async g(d,E,k){if(this.b.has(d))return Ue(this,i,"f").$fireCommandActivationEvent(d),this.h(d,E,!1);{let M=!1;const K=(0,R.cloneAndChange)(E,function(q){if(q instanceof t.Position)return T.Position.from(q);if(q instanceof t.Range)return T.Range.from(q);if(q instanceof t.Location)return T.location.from(q);if(t.NotebookRange.isNotebookRange(q))return T.NotebookRange.from(q);if(q instanceof ArrayBuffer)return M=!0,f.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return M=!0,f.VSBuffer.wrap(q);if(q instanceof f.VSBuffer)return M=!0,q;if(!Array.isArray(q))return q});try{const q=await Ue(this,i,"f").$executeCommand(d,M?new p.SerializableObjectWithBuffers(K):K,k);return(0,D.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(d,E,!1);throw q}}}async h(d,E,k){const M=this.b.get(d);if(!M)throw new Error("Unknown command");const{callback:K,thisArg:q,description:F}=M;if(F)for(let O=0;O<F.args.length;O++)try{(0,a.validateConstraint)(E[O],F.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${F.args[O].name}' - ${F.args[O].description}`)}const B=S.StopWatch.create();try{return await K.apply(q,E)}catch(O){if(d===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...E);U&&(d=U.command)}throw this.d.error(O,d,M.extension?.identifier),k?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=d,this.source=M.extension?.displayName??M.extension?.name}}:O}finally{this.j(M,d,B.elapsed())}}j(d,E,k){!d.extension||Ue(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new g.TelemetryTrustedValue(E),duration:k})}$executeContributedCommand(d,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const k=this.b.get(d);return k?(E=E.map(M=>this.f.reduce((K,q)=>q.processArgument(K,k.extension?.identifier),M)),this.h(d,E,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),Ue(this,i,"f").$getCommands().then(E=>(d&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[E,k]of this.b){const{description:M}=k;M&&(d[E]=M)}return Promise.resolve(d)}};i=new WeakMap,s=new WeakMap,o=qe([We(0,m.IExtHostRpcService),We(1,y.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class l{constructor(d,E,k){this.d=d,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,E){if(!d)return;const k={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return k;const M=this.f(d.command);if(M)k.id=M.internalId,k.arguments=M.args.map((K,q)=>K.convert(d.arguments&&d.arguments[q]));else if((0,A.isNonEmptyArray)(d.arguments)){const K=`${d.command}/${++this.c}`;this.b.set(K,d),E.add((0,C.toDisposable)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),k.$ident=K,k.id=this.delegatingCommandId,k.arguments=[K],this.g.trace("CommandsConverter#CREATE",d.command,K)}return k}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const E=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.CommandsConverter=l;class c{constructor(d,E,k,M){this.name=d,this.description=E,this.validate=k,this.convert=M}optional(){return new c(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,E){return new c(d??this.name,E??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",n=>w.URI.isUri(n),n=>n),c.Position=new c("position","A position in a text document",n=>t.Position.isPosition(n),T.Position.from),c.Range=new c("range","A range in a text document",n=>t.Range.isRange(n),T.Range.from),c.Selection=new c("selection","A selection in a text document",n=>t.Selection.isSelection(n),T.Selection.from),c.Number=new c("number","",n=>typeof n=="number",n=>n),c.String=new c("string","",n=>typeof n=="string",n=>n),c.CallHierarchyItem=new c("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,T.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,T.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",n=>n instanceof h.TestItemImpl,T.TestItem.from);class u{constructor(d,E){this.description=d,this.convert=E}}e.ApiCommandResult=u,u.Void=new u("no result",n=>n);class r{constructor(d,E,k,M,K){this.id=d,this.internalId=E,this.description=k,this.args=M,this.result=K}}e.ApiCommand=r}),define(ye[250],Ce([1,0,2,15,7,68,41,16,120,125,17]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(t.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,h)=>{if((0,A.isFalsyOrEmpty)(m))return;class f extends T.SymbolInformation{static to(b){const S=new f(b.name,t.SymbolKind.to(b.kind),b.containerName||"",new T.Location(h[0],t.Range.to(b.range)));return S.detail=b.detail,S.range=S.location.range,S.selectionRange=t.Range.to(b.selectionRange),S.children=b.children?b.children.map(f.to):[],S}}return m.map(f.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new I.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(t.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(t.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(h=>T.Position.isPosition(h)),m=>m.map(t.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(h=>{let f;for(const p of h.reverse())f=new T.SelectionRange(t.Range.to(p),f);return f}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(t.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",m=>m.map(t.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",m=>m.map(t.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",m=>m.map(t.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:t.Range.to(m.range),placeholder:m.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return t.WorkspaceEdit.to(m)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(t.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new T.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const h=(0,y.decodeSemanticTokensDto)(m);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new T.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const h=(0,y.decodeSemanticTokensDto)(m);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,h,f)=>{if(!m)return new T.CompletionList([]);const p=m.suggestions.map(b=>t.CompletionItem.to(b,f));return new T.CompletionList(p,m.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return t.SignatureHelp.to(m)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,h,f)=>C(p=>new T.CodeLens(t.Range.to(p.range),p.command&&f.fromInternal(p.command)))(m))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>T.Range.isRange(m),m=>T.Selection.isSelection(m)?t.Selection.from(m):t.Range.from(m)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,h,f)=>C(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(p.command)}else{const b=new T.CodeAction(p.title,p.kind?new T.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=t.WorkspaceEdit.to(p.edit)),p.command&&(b.command=f.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(m))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(h=>new T.ColorInformation(t.Range.to(h.range),t.Color.to(h.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",m=>m instanceof T.Color,t.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:t.Range.from(m.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(t.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,h,f)=>m.map(t.InlayHint.to.bind(void 0,f)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(h=>t.NotebookExclusiveDocumentPattern.to(h))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(t.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>a.URI.isUri(m)||typeof m=="string"&&(0,D.matchesSomeScheme)(m,L.Schemas.http,L.Schemas.https),m=>m),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[t.ViewColumn.from(m),void 0]:[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[t.ViewColumn.from(m),void 0]:[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,m=>m)],I.ApiCommandResult.Void)];class w{static register(h){P.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=w;function C(m){return h=>{if(Array.isArray(h))return h.map(m)}}function v(m){if(!Array.isArray(m))return;const h=[];for(const f of m)R.isLocationLink(f)?h.push(t.DefinitionLink.to(f)):h.push(t.location.to(f));return h}}),define(ye[251],Ce([1,0,14,62,3,6,2,68,27,15,7,26,5]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(v,m,h){const f=v.getProxy(w.MainContext.MainThreadComments);class p{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const r=this.b.get(u.handle);return r?r.value:u}else if(u&&u.$mid===7){const r=this.b.get(u.commentControlHandle);if(!r)return u;const n=r.getCommentThread(u.commentThreadHandle);return n?n.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const r=this.b.get(u.thread.commentControlHandle);if(!r)return u;const n=r.getCommentThread(u.thread.commentThreadHandle);return n?u.$mid===8?n.value:{thread:n.value,text:u.text}:u}else if(u&&u.$mid===10){const r=this.b.get(u.thread.commentControlHandle);if(!r)return u;const n=r.getCommentThread(u.thread.commentThreadHandle);if(!n)return u;const d=u.commentUniqueId,E=n.getCommentByUniqueId(d);return E||u}else if(u&&u.$mid===11){const r=this.b.get(u.thread.commentControlHandle);if(!r)return u;const n=r.getCommentThread(u.thread.commentThreadHandle);if(!n)return u;const d=u.text,E=u.commentUniqueId,k=n.getCommentByUniqueId(E);return k?(typeof k.body=="string"?k.body=d:k.body=new L.MarkdownString(d),k):u}return u}})}createCommentController(u,r,n){const d=p.a++,E=new S(u,d,r,n);this.b.set(E.handle,E);const k=this.c.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return k.push(E),this.c.set(y.ExtensionIdentifier.toKey(u.identifier),k),E.value}$createCommentThreadTemplate(u,r,n){const d=this.b.get(u);!d||d.$createCommentThreadTemplate(r,n)}async $updateCommentThreadTemplate(u,r,n){const d=this.b.get(u);!d||d.$updateCommentThreadTemplate(r,n)}$deleteCommentThread(u,r){this.b.get(u)?.$deleteCommentThread(r)}$provideCommentingRanges(u,r,n){const d=this.b.get(u);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const E=h.getDocument(I.URI.revive(r));return(0,a.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(E,n)).then(k=>k?k.map(M=>D.Range.from(M)):void 0)}$toggleReaction(u,r,n,d,E){const k=this.b.get(u);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const M=k.getCommentThread(r);if(M){const K=M.getCommentByUniqueId(d.uniqueIdInThread);if(k!==void 0&&K&&k.reactionHandler)return k.reactionHandler(K,s(E))}return Promise.resolve(void 0)})}dispose(){}}p.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,r,n,d,E,k,M,K){this.m=r,this.n=n,this.o=d,this.p=E,this.q=k,this.extensionDescription=M,this.r=K,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new T.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),f.$createCommentThread(r,this.handle,this.n,this.o,D.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{f.$deleteCommentThread(r,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(F){q.range=F},get comments(){return q.comments},set comments(F){q.comments=F},get collapsibleState(){return q.collapsibleState},set collapsibleState(F){q.collapsibleState=F},get canReply(){return q.canReply},set canReply(F){q.canReply=F},get contextValue(){return q.contextValue},set contextValue(F){q.contextValue=F},get label(){return q.label},set label(F){q.label=F},get state(){return q.state},set state(F){q.state=F},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const u=n=>Object.prototype.hasOwnProperty.call(this.b,n),r={};u("range")&&(r.range=D.Range.from(this.p)),u("label")&&(r.label=this.label),u("contextValue")&&(r.contextValue=this.contextValue??null),u("comments")&&(r.comments=this.q.map(n=>g(this,n,this.k))),u("collapsibleState")&&(r.collapseState=o(this.g)),u("canReply")&&(r.canReply=this.canReply),u("state")&&(r.state=l(this.h)),u("isTemplate")&&(r.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,r)}getCommentByUniqueId(u){for(const r of this.k){const n=r[0],d=r[1];if(u===d)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,qe([(0,t.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,r,n,d){this.f=u,this.g=r,this.h=n,this.i=d,this.a=new Map,f.$registerCommentController(this.handle,n,d);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(k){E.options=k},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(k){E.commentingRangeProvider=k},get reactionHandler(){return E.reactionHandler},set reactionHandler(k){E.reactionHandler=k},createCommentThread(k,M,K){return E.createCommentThread(k,M,K).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(u,r,n,d){if(typeof u=="string"){const E=new b(this.id,this.handle,u,r,n,d,this.f,!1);return this.a.set(E.handle,E),E}else{const E=new b(this.id,this.handle,void 0,u,r,n,this.f,!1);return this.a.set(E.handle,E),E}}$createCommentThreadTemplate(u,r){const n=new b(this.id,this.handle,void 0,I.URI.revive(u),D.Range.to(r),[],this.f,!0);return n.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(u,r){const n=this.a.get(u);n&&(n.range=D.Range.to(r))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function g(c,u,r){let n=r.get(u);n||(n=++c.commentHandle,r.set(u,n));const d=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:n,body:typeof u.body=="string"?u.body:D.MarkdownString.from(u.body),userName:u.author.name,userIconPath:d,label:u.label,commentReactions:u.reactions?u.reactions.map(E=>i(E)):void 0,timestamp:u.timestamp?.toJSON()}}function i(c){return{label:c.label,iconPath:c.iconPath?D.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function s(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?I.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function l(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new p}e.createExtHostComments=C}),define(ye[252],Ce([1,0,22,5,25,18]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const w=this,C=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){w.e(L,P,C,arguments)}})}e(L,P,w,C){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(C,this.b)}),this.c&&this.f(L,w,C)}};I=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const A=1e5;function y(D,L){const P=[];if(D.length)for(let w=0;w<D.length;w++){let C=D[w];if(typeof C>"u")C="undefined";else if(C instanceof Error){const v=C;v.stack?C=v.stack:C=v.toString()}P.push(C)}if(L){const w=new Error().stack;w&&P.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,a.safeStringify)(P);return w.length>A?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,4,18,13,16,8,11,26]),function(te,e,a,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Bn{constructor(v,m){this.h=m,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,m){const h=Bn.c++;this.f.set(h,{provider:v,extensionDescription:m}),this.g.$registerDecorationProvider(h,m.identifier.value);const f=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(h,null);return}const b=(0,y.asArray)(p);if(b.length<=Bn.d){this.g.$onDidChange(h,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,b.length);const S=b.map(s=>({uri:s,rank:(0,D.count)(s.path,"/")})),g=(0,y.groupBy)(S,(s,o)=>s.rank-o.rank||(0,D.compare)(s.uri.path,o.uri.path)),i=[];e:for(const s of g){let o;for(const l of s){const c=(0,L.dirname)(l.uri.path);if(o!==c&&(o=c,i.push(l.uri)>=Bn.d))break e}}this.g.$onDidChange(h,i)});return new T.Disposable(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(h),this.f.delete(h)})}async $provideDecorations(v,m,h){if(!this.f.has(v))return Object.create(null);const f=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(v);return await Promise.all(m.map(async S=>{try{const{uri:g,id:i}=S,s=await Promise.resolve(p.provideFileDecoration(a.URI.revive(g),h));if(!s)return;try{T.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(b,"codiconDecoration"),f[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${b}': ${o}`)}}catch(g){this.h.error(g)}})),f}};w.c=0,w.d=250,w=qe([We(0,I.IExtHostRpcService),We(1,A.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[253],Ce([1,0,176,124,2,5,7,15,3,13,28,48]),function(te,e,a,t,T,R,I,A,y,D,L,P){"use strict";var w,C,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(p,b,S,g,i,s,o){this.d=p,this.e=b,this.f=S,this.g=g,w.set(this,void 0),C.set(this,void 0),v.set(this,void 0),this.c=!1,Ye(this,v,new L.ResourceMap(l=>i.getComparisonKey(l)),"f"),Ye(this,w,s,"f"),Ye(this,C,o,"f")}dispose(){this.c||(Ue(this,C,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,w,"f")?.$clear(this.e),Ue(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let S=[];if(T.URI.isUri(p)){if(!b){this.delete(p);return}Ue(this,v,"f").set(p,b.slice()),S=[p]}else if(Array.isArray(p)){S=[];let i;p=[...p].sort(m.j);for(const s of p){const[o,l]=s;if((!i||o.toString()!==i.toString())&&(i&&Ue(this,v,"f").get(i).length===0&&Ue(this,v,"f").delete(i),i=o,S.push(o),Ue(this,v,"f").set(o,[])),l)Ue(this,v,"f").get(o)?.push(...l);else{const c=Ue(this,v,"f").get(o);c&&(c.length=0)}}}if(Ue(this,C,"f").fire(S),!Ue(this,w,"f"))return;const g=[];for(const i of S){let s=[];const o=Ue(this,v,"f").get(i);if(o)if(o.length>this.f){s=[];const l=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of o)if(u.severity===l[c]&&s.push({...A.Diagnostic.from(u),modelVersionId:this.g(i)})===this.f)break e;s.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,o.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=o.map(l=>({...A.Diagnostic.from(l),modelVersionId:this.g(i)}));g.push([i,s])}Ue(this,w,"f").$changeMany(this.e,g)}delete(p){this.h(),Ue(this,C,"f").fire([p]),Ue(this,v,"f").delete(p),Ue(this,w,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Ue(this,C,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,v,"f").clear(),Ue(this,w,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[S,g]of this)p.call(b,S,g,this)}*[(w=new WeakMap,C=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const p of Ue(this,v,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Ue(this,v,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Ue(this,v,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=m;let h=class wn{static _mapper(p){const b=new L.ResourceMap;for(const S of p)b.set(S,S);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,S,g){this.h=b,this.j=S,this.k=g,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,wn._mapper),this.e=p.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:S,e:g,g:i,h:s,j:o,k:l}=this,c=new class{$changeMany(n,d){g.$changeMany(n,d),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,n,d.length===0?"CLEARING":d)}$clear(n){g.$clear(n),s.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,n)}dispose(){g.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+wn.c++,u=b;else if(!S.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+wn.c++;while(S.has(u))}return new class extends m{constructor(){super(b,u,wn.d,n=>l.getDocument(n)?.version,o.extUri,c,i),S.set(u,this)}dispose(){super.dispose(),S.delete(u)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,S=[];for(const g of this.f.values())g.forEach((i,s)=>{let o=b.get(i.toString());typeof o>"u"&&(o=S.length,b.set(i.toString(),o),S.push([i,[]])),S[o][1]=S[o][1].concat(...s)});return S}}l(p){let b=[];for(const S of this.f.values())S.has(p)&&(b=b.concat(S.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",S=new m(b,b,wn.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(b,S),this.m=S}for(const[b,S]of p)this.m.set(T.URI.revive(b),S.map(A.Diagnostic.to))}};h.c=0,h.d=1e3,h=qe([We(1,D.ILogService),We(2,P.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(ye[254],Ce([1,0,2,5]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(I){this.a=I.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(A=>A?A.map(y=>a.URI.revive(y)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(A=>A?a.URI.revive(A):void 0)}}e.ExtHostDialogs=T}),define(ye[255],Ce([1,0,9,2,7,5,17,21,8]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(P,w,C){this.d=w,this.e=C,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,w){if(Object.keys(I.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const C=D.a++;this.b.set(C,w),this.c.$registerTextContentProvider(C,P);let v;return typeof w.onDidChange=="function"&&(v=w.onDidChange(m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this.d.getDocument(m)&&this.$provideTextDocumentContent(C,m).then(h=>{if(!h&&typeof h!="string")return;const f=this.d.getDocument(m);if(!f)return;const p=(0,y.splitLines)(h);if(!f.equalLines(p))return this.c.$onVirtualDocumentChange(m,h)},a.onUnexpectedError)})),new T.Disposable(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,w){const C=this.b.get(P);return C?Promise.resolve(C.provideTextDocumentContent(t.URI.revive(w),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=D,D.a=0}),define(ye[256],Ce([1,0,3,6,2,5,135,15,10,22,7]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(C,v){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=C.getProxy(R.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(m=>{for(const h of m)this.b.fire(h.document)},void 0,this.e),this.g.onDidAddDocuments(m=>{for(const h of m)this.a.fire(h.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const v=this.g.getDocument(C);if(v)return v}getDocument(C){const v=this.getDocumentData(C);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return v.document}ensureDocumentData(C){const v=this.g.getDocument(C);if(v)return Promise.resolve(v);let m=this.h.get(C.toString());return m||(m=this.f.$tryOpenDocument(C).then(h=>{this.h.delete(C.toString());const f=T.URI.revive(h);return(0,y.assertIsDefined)(this.g.getDocument(f))},h=>(this.h.delete(C.toString()),Promise.reject(h))),this.h.set(C.toString(),m)),m}createDocumentData(C){return this.f.$tryCreateDocument(C).then(v=>T.URI.revive(v))}$acceptModelLanguageChanged(C,v){const m=T.URI.revive(C),h=this.g.getDocument(m);if(!h)throw new Error("unknown document");this.b.fire(h.document),h._acceptLanguageId(v),this.a.fire(h.document)}$acceptModelSaved(C){const v=T.URI.revive(C),m=this.g.getDocument(v);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(m.document)}$acceptDirtyStateChanged(C,v){const m=T.URI.revive(C),h=this.g.getDocument(m);if(!h)throw new Error("unknown document");h._acceptIsDirty(v),this.c.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,v,m){const h=T.URI.revive(C),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");f._acceptIsDirty(m),f.onEvents(v);let p;v.isUndoing?p=L.TextDocumentChangeReason.Undo:v.isRedoing&&(p=L.TextDocumentChangeReason.Redo),this.c.fire((0,D.deepFreeze)({document:f.document,contentChanges:v.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(C,v){(0,I.setWordDefinitionFor)(C,v)}}e.ExtHostDocuments=P}),define(ye[59],Ce([1,0,51,3,6,2,4,5,135,18,138,15,13,28,17,64,83]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(S,g){this.h=S,this.i=g,this.a=null,this.b=new Map,this.c=new C.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const g=[],i=[],s=[];if(S.removedDocuments)for(const o of S.removedDocuments){const l=R.URI.revive(o),c=this.c.get(l);c?.unref()&&(this.c.delete(l),g.push(c.value))}if(S.addedDocuments)for(const o of S.addedDocuments){const l=R.URI.revive(o.uri);let c=this.c.get(l);if(c&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new f(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),l,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(l,c),i.push(c.value)),c.ref()}if(S.removedEditors)for(const o of S.removedEditors){const l=this.b.get(o);this.b.delete(o),l&&s.push(l)}if(S.addedEditors)for(const o of S.addedEditors){const l=R.URI.revive(o.documentUri);a.ok(this.c.has(l),`document '${l}' does not exist`),a.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const c=this.c.get(l).value,u=new L.ExtHostTextEditor(o.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new h.Lazy(()=>c.document),o.selections.map(P.Selection.to),o.options,o.visibleRanges.map(r=>P.Range.to(r)),typeof o.editorPosition=="number"?P.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,u)}S.newActiveEditor!==void 0&&(a.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,T.dispose)(g),(0,T.dispose)(s),S.removedDocuments&&this.e.fire(g),S.addedDocuments&&this.d.fire(i),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return m.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const g=this.b.get(this.a);return S?g:g?.value}allEditors(){return[...this.b.values()]}};p=qe([We(0,D.IExtHostRpcService),We(1,w.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],Ce([1,0,15,5,2,3,4,7,18,10,61]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class P{constructor(h,f,p){this.e=p,this.d=f,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,f={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(T.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(h,f){this.c=[],this.d="",this.b=h,this.e=f;for(const p of h.tabs)p.isActive&&(this.d=p.id),this.c.push(new P(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,f={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return a.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(p=>p.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(p=>p.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const p=new P(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,p),h.tabDto.isActive&&(this.d=p.tabId),p}else if(h.kind===1){const p=this.c.splice(h.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(h.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,p),p}const f=this.c.find(p=>p.tabId===h.tabDto.id);if(!f)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(h.tabDto),f}activeTabId(){return this.d}}let C=class{constructor(h){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=h.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,f={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(p=>p.apiObject))},get activeTabGroup(){const p=h.d;return(0,D.assertIsDefined)(h.e.find(S=>S.groupId===p)?.apiObject)},close:async(p,b)=>{const S=Array.isArray(p)?p:[p];return S.length?v(S[0])?this.j(S,b):this.i(S,b):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(h){const f=new Set(this.e.map(o=>o.groupId)),p=new Set(h.map(o=>o.groupId)),b=(0,L.diffSets)(f,p),S=this.e.filter(o=>b.removed.includes(o.groupId)).map(o=>o.apiObject),g=[],i=[];this.e=h.map(o=>{const l=new w(o,()=>this.d);return b.added.includes(l.groupId)?g.push(l.apiObject):i.push(l.apiObject),l});const s=(0,D.assertIsDefined)(h.find(o=>o.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:g,closed:S,changed:i}))}$acceptTabGroupUpdate(h){const f=this.e.find(p=>p.groupId===h.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const f=this.e.find(b=>b.groupId===h.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const p=f.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(h){for(const f of this.e)for(const p of f.tabs)if(p.apiObject===h)return p}h(h){return this.e.find(f=>f.apiObject===h)}async i(h,f){const p=[];for(const b of h){const S=this.g(b);if(!S)throw new Error("Tab close: Invalid tab not found!");p.push(S.tabId)}return this.a.$closeTab(p,f)}async j(h,f){const p=[];for(const b of h){const S=this.h(b);if(!S)throw new Error("Group close: Invalid group not found!");p.push(S.groupId)}return this.a.$closeGroup(p,f)}};C=qe([We(0,y.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function v(m){return m.tabs!==void 0}}),define(ye[257],Ce([1,0,2,5,6,7,15,153,8,23,26]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const m=this.a.indexOf(v);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),m=[];let h,f,p=14,b=14;for(const S of v){let g=h?(0,y.commonPrefixLength)(h,S):0;for(g===0?f=1:f=b;g<S.length;g++)g+1===S.length?(p=b,b=9):b+=1,m.push([f,S.toUpperCase().charCodeAt(g),b]),m.push([f,S.toLowerCase().charCodeAt(g),b]),f=b;h=S,b=p}m.push([9,58,10]),m.push([10,47,12]),this.b=new A.StateMachine(m)}}provideDocumentLinks(v){this.c();const m=[],h=A.LinkComputer.computeLinks({getLineContent(f){return v.lineAt(f-1).text},getLineCount(){return v.lineCount}},this.b);for(const f of h){const p=I.DocumentLink.to(f);p.target&&m.push(p)}return m}}class w{constructor(v,m){this.i=m,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,m,h,f={}){if(this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const p=this.h++;this.b.add(m),this.d.add(m),this.c.set(p,h);let b=2;f.isCaseSensitive&&(b+=1024),f.isReadonly&&(b+=2048),typeof h.copy=="function"&&(b+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,L.checkProposedApiEnabled)(v,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,m,b).catch(g=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${m}`),console.error(g)});const S=h.onDidChangeFile(g=>{const i=[];for(const s of g){const{uri:o,type:l}=s;if(o.scheme!==m)continue;let c;switch(l){case R.FileChangeType.Changed:c=0;break;case R.FileChangeType.Created:c=1;break;case R.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:o,type:c})}this.a.$onFileSystemChange(p,i)});return(0,T.toDisposable)(()=>{S.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(v){const{type:m,ctime:h,mtime:f,size:p,permissions:b}=v;return{type:m,ctime:h,mtime:f,size:p,permissions:b}}$stat(v,m){return Promise.resolve(this.k(v).stat(a.URI.revive(m))).then(h=>w.j(h))}$readdir(v,m){return Promise.resolve(this.k(v).readDirectory(a.URI.revive(m)))}$readFile(v,m){return Promise.resolve(this.k(v).readFile(a.URI.revive(m))).then(h=>D.VSBuffer.wrap(h))}$writeFile(v,m,h,f){return Promise.resolve(this.k(v).writeFile(a.URI.revive(m),h.buffer,f))}$delete(v,m,h){return Promise.resolve(this.k(v).delete(a.URI.revive(m),h))}$rename(v,m,h,f){return Promise.resolve(this.k(v).rename(a.URI.revive(m),a.URI.revive(h),f))}$copy(v,m,h,f){const p=this.k(v);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(a.URI.revive(m),a.URI.revive(h),f))}$mkdir(v,m){return Promise.resolve(this.k(v).createDirectory(a.URI.revive(m)))}$watch(v,m,h,f){const p=this.k(v).watch(a.URI.revive(h),f);this.f.set(m,p)}$unwatch(v,m){const h=this.f.get(m);h&&(h.dispose(),this.f.delete(m))}$open(v,m,h){const f=this.k(v);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(a.URI.revive(m),h))}$close(v,m){const h=this.k(v);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(m))}$read(v,m,h,f){const p=this.k(v);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=D.VSBuffer.alloc(f);return Promise.resolve(p.read(m,h,b.buffer,0,f)).then(S=>b.slice(0,S))}$write(v,m,h,f){const p=this.k(v);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(m,h,f.buffer,0,f.byteLength))}k(v){const m=this.c.get(v);if(!m){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return m}}e.ExtHostFileSystem=w}),define(ye[75],Ce([1,0,5,40,7,23,4,18,48,6]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Zt{constructor(w,C){this.b=new Map,this.a=w.getProxy(a.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(m){try{const h=v.b.get(m.scheme);if(!h)return await v.a.$stat(m);await v.a.$ensureActivation(m.scheme);const f=await h.stat(m);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(h){Zt.c(h)}},async readDirectory(m){try{const h=v.b.get(m.scheme);return h?(await v.a.$ensureActivation(m.scheme),(await h.readDirectory(m)).slice()):await v.a.$readdir(m)}catch(h){return Zt.c(h)}},async createDirectory(m){try{return await v.a.$mkdir(m)}catch(h){return Zt.c(h)}},async readFile(m){try{const h=v.b.get(m.scheme);return h?(await v.a.$ensureActivation(m.scheme),(await h.readFile(m)).slice()):(await v.a.$readFile(m)).buffer}catch(h){return Zt.c(h)}},async writeFile(m,h){try{return await v.a.$writeFile(m,R.VSBuffer.wrap(h))}catch(f){return Zt.c(f)}},async delete(m,h){try{const f=v.b.get(m.scheme);return f?(await v.a.$ensureActivation(m.scheme),await f.delete(m,{recursive:!1,...h})):await v.a.$delete(m,{recursive:!1,useTrash:!1,...h})}catch(f){return Zt.c(f)}},async rename(m,h,f){try{return await v.a.$rename(m,h,{overwrite:!1,...f})}catch(p){return Zt.c(p)}},async copy(m,h,f){try{return await v.a.$copy(m,h,{overwrite:!1,...f})}catch(p){return Zt.c(p)}},isWritableFileSystem(m){const h=C.getCapabilities(m);if(typeof h=="number")return!(h&2048)}})}static c(w){if(w instanceof T.FileSystemError)throw w;if(!(w instanceof Error))throw new T.FileSystemError(String(w));if(w.name==="ENOPRO"||w.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(w.message);switch(w.name){case t.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(w.message);case t.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(w.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(w.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(w.message);case t.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(w.message);case t.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(w.message);default:throw new T.FileSystemError(w.message,w.name)}}addFileSystemProvider(w,C){return this.b.set(w,C),(0,D.toDisposable)(()=>this.b.delete(w))}};L=qe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[258],Ce([1,0,3,39,2,5,15,7]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,w,C,v,m,h,f,p){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const b=this.h(P,C,m);this.g=0,h&&(this.g+=1),f&&(this.g+=2),p&&(this.g+=4);const S=(0,t.parse)(m),g=typeof m=="string",i=v(s=>{if(!h)for(const o of s.created){const l=T.URI.revive(o);S(l.fsPath)&&(!g||w.getWorkspaceFolder(l))&&this.a.fire(l)}if(!f)for(const o of s.changed){const l=T.URI.revive(o);S(l.fsPath)&&(!g||w.getWorkspaceFolder(l))&&this.b.fire(l)}if(!p)for(const o of s.deleted){const l=T.URI.revive(o);S(l.fsPath)&&(!g||w.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,i)}h(P,w,C){const v=A.Disposable.from();if(typeof C=="string")return v;const m=P.getProxy(R.MainContext.MainThreadFileSystem);let h=!1;(C.pattern.includes(t.GLOBSTAR)||C.pattern.includes(t.GLOB_SPLIT))&&(h=!0);const f=Math.random();return m.$watch(w.identifier.value,f,C.baseUri,{recursive:h,excludes:[]}),A.Disposable.from({dispose:()=>m.$unwatch(f)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class D{constructor(P,w,C){this.j=P,this.k=w,this.l=C,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,w,C,v,m,h){return new y(this.j,P,w,this.a.event,I.GlobPattern.from(C),v,m,h)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,w){switch(P){case 2:this.b.fire(Object.freeze({files:w.map(C=>({oldUri:T.URI.revive(C.source),newUri:T.URI.revive(C.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(C=>T.URI.revive(C.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(C=>T.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,w){return(C,v,m)=>{const h=function(p){C.call(v,p)};return h.extension=P,w.event(h,void 0,m)}}async $onWillRunFileOperation(P,w,C,v){switch(P){case 2:return await this.n(this.g,{files:w.map(m=>({oldUri:T.URI.revive(m.source),newUri:T.URI.revive(m.target)}))},C,v);case 1:return await this.n(this.i,{files:w.map(m=>T.URI.revive(m.target))},C,v);case 0:case 3:return await this.n(this.h,{files:w.map(m=>T.URI.revive(m.target))},C,v)}}async n(P,w,C,v){const m=new Set,h=[];if(await P.fireAsync(w,v,async(p,b)=>{const S=Date.now(),g=await Promise.resolve(p);g instanceof A.WorkspaceEdit&&(h.push([b.extension,g]),m.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-S>C&&this.k.warn("SLOW file-participant",b.extension.identifier)}),v.isCancellationRequested||h.length===0)return;const f={edits:[]};for(const[,p]of h){const{edits:b}=I.WorkspaceEdit.from(p,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(b)}return{edit:f,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=D}),define(ye[259],Ce([1,0,2,41]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(I,A,y,D,L){this.a=A,this.b=y,this.c=D;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const C=this.a.getEditorById(w.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:a.URI.revive(w.notebookUri),inputUri:a.URI.revive(w.inputUri),notebookEditor:C.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:a.URI.revive(w.notebookUri),inputUri:a.URI.revive(w.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(I,A,y,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=T}),define(ye[260],Ce([1,0,6,5]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(I){this.b=0,this.a=I.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,I),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(ye[261],Ce([1,0,2,22,15,7,68,5,8,36,16,10,149,21,6,120,101,72,44,9,14,26]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(N,H){this.d=N,this.e=H}async provideDocumentSymbols(N,H){const Q=this.d.getDocument(N),J=await this.e.provideDocumentSymbols(Q,H);if(!(0,L.isFalsyOrEmpty)(J))return J[0]instanceof R.DocumentSymbol?J.map(T.DocumentSymbol.from):i.f(J)}static f(N){N=N.slice(0).sort((J,he)=>{let we=J.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(J.location.range.end)),we});const H=[],Q=[];for(const J of N){const he={name:J.name||"!!MISSING: name!!",kind:T.SymbolKind.from(J.kind),tags:J.tags?.map(T.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:T.Range.from(J.location.range),selectionRange:T.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),H.push(he);break}const we=Q[Q.length-1];if(D.Range.containsRange(we.range,he.range)&&!D.Range.equalsRange(we.range,he.range)){we.children?.push(he),Q.push(he);break}Q.pop()}}return H}}class s{constructor(N,H,Q){this.g=N,this.h=H,this.j=Q,this.e=new f.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,H){const Q=this.g.getDocument(N),J=await this.j.provideCodeLenses(Q,H);if(!J||H.isCancellationRequested)return;const he=this.e.add(J),we=new v.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let pe=0;pe<J.length;pe++)Ae.lenses.push({cacheId:[he,pe],range:T.Range.from(J[pe].range),command:this.h.toInternal(J[pe].command,we)});return Ae}async resolveCodeLens(N,H){const Q=N.cacheId&&this.e.get(...N.cacheId);if(!Q)return;let J;if(typeof this.j.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.j.resolveCodeLens(Q,H),J||(J=Q),H.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(J.command??s.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}s.d={command:"missing",title:"!!MISSING: command!!"};function o(ie){return Array.isArray(ie)?ie.map(T.DefinitionLink.from):ie?[T.DefinitionLink.from(ie)]:[]}class l{constructor(N,H){this.d=N,this.e=H}async provideDefinition(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideDefinition(J,he,Q);return o(we)}}class c{constructor(N,H){this.d=N,this.e=H}async provideDeclaration(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideDeclaration(J,he,Q);return o(we)}}class u{constructor(N,H){this.d=N,this.e=H}async provideImplementation(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideImplementation(J,he,Q);return o(we)}}class r{constructor(N,H){this.d=N,this.e=H}async provideTypeDefinition(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideTypeDefinition(J,he,Q);return o(we)}}class n{constructor(N,H){this.d=N,this.e=H}async provideHover(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideHover(J,he,Q);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=J.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),T.Hover.from(we)}}class d{constructor(N,H){this.d=N,this.e=H}async provideEvaluatableExpression(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideEvaluatableExpression(J,he,Q);if(we)return T.EvaluatableExpression.from(we)}}class E{constructor(N,H){this.d=N,this.e=H}async provideInlineValues(N,H,Q,J){const he=this.d.getDocument(N),we=await this.e.provideInlineValues(he,T.Range.to(H),T.InlineValueContext.to(Q),J);if(Array.isArray(we))return we.map(Ae=>T.InlineValue.from(Ae))}}class k{constructor(N,H){this.d=N,this.e=H}async provideDocumentHighlights(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideDocumentHighlights(J,he,Q);if(Array.isArray(we))return we.map(T.DocumentHighlight.from)}}class M{constructor(N,H){this.d=N,this.e=H}async provideLinkedEditingRanges(N,H,Q){const J=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideLinkedEditingRanges(J,he,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(T.Range.from)),wordPattern:we.wordPattern}}}class K{constructor(N,H){this.d=N,this.e=H}async provideReferences(N,H,Q,J){const he=this.d.getDocument(N),we=T.Position.to(H),Ae=await this.e.provideReferences(he,we,Q,J);if(Array.isArray(Ae))return Ae.map(T.location.from)}}class q{constructor(N,H,Q,J,he,we,Ae){this.g=N,this.h=H,this.j=Q,this.k=J,this.l=he,this.m=we,this.n=Ae,this.e=new f.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,H,Q,J){const he=this.g.getDocument(N),we=w.Selection.isISelection(H)?T.Selection.to(H):T.Range.to(H),Ae=[];for(const et of this.j.getDiagnostics(N))if(we.intersection(et.range)&&Ae.push(et)>q.d)break;const pe={diagnostics:Ae,only:Q.only?new R.CodeActionKind(Q.only):void 0,triggerKind:T.CodeActionTriggerKind.to(Q.trigger)},De=await this.k.provideCodeActions(he,we,pe,J);if(!(0,L.isNonEmptyArray)(De)||J.isCancellationRequested)return;const ke=this.e.add(De),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<De.length;et++){const Qe=De[et];!Qe||(q.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,je)})):(pe.only&&(Qe.kind?pe.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,je),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(T.Diagnostic.from),edit:Qe.edit&&T.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(N,H){const[Q,J]=N,he=this.e.get(Q,J);if(!he||q.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,H)??he;return we?.edit?T.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}q.d=1e3;class F{constructor(N,H,Q,J){this.d=N,this.e=H,this.f=Q,this.g=J}async prepareDocumentPaste(N,H,Q,J){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),we=H.map(pe=>T.Range.to(pe)),Ae=T.DataTransfer.toDataTransfer(Q,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,J),T.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,H,Q,J,he){const we=this.e.getDocument(H),Ae=Q.map(ke=>T.Range.to(ke)),pe=T.DataTransfer.toDataTransfer(J,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),De=await this.f.provideDocumentPasteEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?T.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class B{constructor(N,H){this.d=N,this.e=H}async provideDocumentFormattingEdits(N,H,Q){const J=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(J,H,Q);if(Array.isArray(he))return he.map(T.TextEdit.from)}}class O{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeFormattingEdits(N,H,Q,J){const he=this.d.getDocument(N),we=T.Range.to(H),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,Q,J);if(Array.isArray(Ae))return Ae.map(T.TextEdit.from)}}class U{constructor(N,H){this.d=N,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,H,Q,J,he){const we=this.d.getDocument(N),Ae=T.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(we,Ae,Q,J,he);if(Array.isArray(pe))return pe.map(T.TextEdit.from)}}class ${constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,H){const Q=await this.e.provideWorkspaceSymbols(N,H);if(!(0,L.isNonEmptyArray)(Q))return{symbols:[]};const J=this.d.add(Q),he={cacheId:J,symbols:[]};for(let we=0;we<Q.length;we++){const Ae=Q[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...T.WorkspaceSymbol.from(Ae),cacheId:[J,we]})}return he}async resolveWorkspaceSymbol(N,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const Q=this.d.get(...N.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,H);return J&&(0,t.mixin)(N,T.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideRenameEdits(N,H,Q,J){const he=this.d.getDocument(N),we=T.Position.to(H);try{const Ae=await this.e.provideRenameEdits(he,we,Q,J);return Ae?T.WorkspaceEdit.from(Ae):void 0}catch(Ae){const pe=j.g(Ae);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,H,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(N),he=T.Position.to(H);try{const we=await this.e.prepareRename(J,he,Q);let Ae,pe;if(R.Range.isRange(we)?(Ae=we,pe=J.getText(we)):(0,P.isObject)(we)&&(Ae=we.range,pe=we.placeholder),!Ae||!pe)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Ae),text:pe}}catch(we){const Ae=j.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ue{constructor(N,H){this.resultId=N,this.tokens=H}}class V{constructor(N,H){this.f=N,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,H,Q){const J=this.f.getDocument(N),he=H!==0?this.d.get(H):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,he.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return he&&this.d.delete(H),we?(we=V.h(we),this.o(V.n(he,we),we)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return V.j(N)?V.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):V.l(N)?V.m(N)?N:new R.SemanticTokensEdits(N.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const H of N.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(N,H){if(!V.j(H)||!N||!N.tokens)return H;const Q=N.tokens,J=Q.length,he=H.data,we=he.length;let Ae=0;const pe=Math.min(J,we);for(;Ae<pe&&Q[Ae]===he[Ae];)Ae++;if(Ae===J&&Ae===we)return new R.SemanticTokensEdits([],H.resultId);let De=0;const ke=pe-Ae;for(;De<ke&&Q[J-De-1]===he[we-De-1];)De++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:J-Ae-De,data:he.subarray(Ae,we-De)}],H.resultId)}o(N,H){if(V.j(N)){const Q=this.e++;return this.d.set(Q,new ue(N.resultId,N.data)),(0,m.encodeSemanticTokensDto)({id:Q,type:"full",data:N.data})}if(V.l(N)){const Q=this.e++;return V.j(H)?this.d.set(Q,new ue(H.resultId,H.data)):this.d.set(Q,new ue(N.resultId)),(0,m.encodeSemanticTokensDto)({id:Q,type:"delta",deltas:(N.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class _{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeSemanticTokens(N,H,Q){const J=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(J,T.Range.to(H),Q);return he?this.f(he):null}f(N){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Y{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,H,Q,J,he){this.f=N,this.g=H,this.h=Q,this.j=J,this.k=he,this.d=new f.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,H,Q,J){const he=this.f.getDocument(N),we=T.Position.to(H),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),pe=Ae.with({end:we}),De=new p.StopWatch(!0),ke=await this.h.provideCompletionItems(he,we,J,T.CompletionContext.to(Q));if(!ke||J.isCancellationRequested)return;const je=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=Y.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const Qe=[],nt={x:Ge,b:Qe,a:{replace:T.Range.from(Ae),insert:T.Range.from(pe)},c:je.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],pe,Ae);Qe.push(Me)}return nt}async resolveCompletionItem(N,H){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...N);if(!Q)return;const J=await this.h.resolveCompletionItem(Q,H);if(!!J)return this.l(J,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H,Q,J){const he=this.e.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(N.command,he),Ae={x:H,a:N.label,b:N.kind!==void 0?T.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(T.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:T.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(T.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let pe;return N.textEdit?pe=N.textEdit.range:N.range&&(pe=N.range),R.Range.isRange(pe)?Ae.j=T.Range.from(pe):pe&&(!Q?.isEqual(pe.inserting)||!J?.isEqual(pe.replacing))&&(Ae.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Ae}}class ne{async provideInlineCompletions(N,H,Q,J){}disposeCompletions(N){}handleDidShowCompletionItem(N,H){}}class ee extends ne{constructor(N,H,Q,J){super(),this.f=N,this.g=H,this.h=Q,this.j=J,this.d=new X,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,H,Q,J){const he=this.g.getDocument(N),we=T.Position.to(H),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:T.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!Ae||J.isCancellationRequested)return;const pe=Array.isArray(Ae)?Ae:Ae.items,De=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let Qe;Ge.command&&(ke||(ke=new v.DisposableStore),Qe=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?T.Range.from(Ge.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,H){const Q=this.d.get(N)?.items[H];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const H=this.e++;return this.d.set(H,N),H}disposeReferenceId(N){const H=this.d.get(N);return this.d.delete(N),H}get(N){return this.d.get(N)}}class G{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,H,Q,J){const he=this.e.getDocument(N),we=T.Position.to(H),Ae=this.g(Q),pe=await this.f.provideSignatureHelp(he,we,J,Ae);if(pe){const De=this.d.add([pe]);return{...T.SignatureHelp.from(pe),id:De}}}g(N){let H;if(N.activeSignatureHelp){const Q=T.SignatureHelp.to(N.activeSignatureHelp),J=this.d.get(N.activeSignatureHelp.id,0);J?(H=J,H.activeSignature=Q.activeSignature,H.activeParameter=Q.activeParameter):H=Q}return{...N,activeSignatureHelp:H}}releaseSignatureHelp(N){this.d.delete(N)}}class de{constructor(N,H,Q,J,he){this.f=N,this.g=H,this.h=Q,this.j=J,this.k=he,this.d=new f.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,H,Q){const J=this.f.getDocument(N),he=T.Range.to(H),we=await this.h.provideInlayHints(J,he,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(Q.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new v.DisposableStore);const pe={hints:[],cacheId:Ae};for(let De=0;De<we.length;De++)this.l(we[De],he)&&pe.hints.push(this.m(we[De],[Ae,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(N,H){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...N);if(!Q)return;const J=await this.h.resolveInlayHint(Q,H);if(!!J&&!!this.l(J))return this.m(J,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H){return N.label.length===0||Array.isArray(N.label)&&N.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(H&&!H.contains(N.position))}m(N,H){const Q=this.e.get(H[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:H,tooltip:T.MarkdownString.fromStrict(N.tooltip),position:T.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(T.TextEdit.from),kind:N.kind&&T.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?J.label=N.label:J.label=N.label.map(he=>{const we={label:he.value};return we.tooltip=T.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=T.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,Q)),we}),J}}class be{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("DocumentLink")}async provideLinks(N,H){const Q=this.e.getDocument(N),J=await this.f.provideDocumentLinks(Q,H);if(!(!Array.isArray(J)||J.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(be.g).map(T.DocumentLink.from)};{const he=this.d.add(J),we={links:[],cacheId:he};for(let Ae=0;Ae<J.length;Ae++){if(!be.g(J[Ae]))continue;const pe=T.DocumentLink.from(J[Ae]);pe.cacheId=[he,Ae],we.links.push(pe)}return we}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,H){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...N);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,H);if(!(!J||!be.g(J)))return T.DocumentLink.from(J)}releaseLinks(N){this.d.delete(N)}}class Ee{constructor(N,H){this.d=N,this.e=H}async provideColors(N,H){const Q=this.d.getDocument(N),J=await this.e.provideDocumentColors(Q,H);return Array.isArray(J)?J.map(we=>({color:T.Color.from(we.color),range:T.Range.from(we.range)})):[]}async provideColorPresentations(N,H,Q){const J=this.d.getDocument(N),he=T.Range.to(H.range),we=T.Color.to(H.color),Ae=await this.e.provideColorPresentations(we,{document:J,range:he},Q);if(!!Array.isArray(Ae))return Ae.map(T.ColorPresentation.from)}}class Pe{constructor(N,H){this.d=N,this.e=H}async provideFoldingRanges(N,H,Q){const J=this.d.getDocument(N),he=await this.e.provideFoldingRanges(J,H,Q);if(!!Array.isArray(he))return he.map(T.FoldingRange.from)}}class Fe{constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideSelectionRanges(N,H,Q){const J=this.d.getDocument(N),he=H.map(T.Position.to),we=await this.e.provideSelectionRanges(J,he,Q);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let pe=0;pe<he.length;pe++){const De=[];Ae.push(De);let ke=he[pe],je=we[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(T.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Ae}}class se{constructor(N,H){this.f=N,this.g=H,this.d=new h.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const J=this.f.getDocument(N),he=T.Position.to(H),we=await this.g.prepareCallHierarchy(J,he,Q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideCallsTo(N,H,Q){const J=this.j(N,H);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(!!he)return he.map(we=>({from:this.h(N,we.from),fromRanges:we.fromRanges.map(Ae=>T.Range.from(Ae))}))}async provideCallsFrom(N,H,Q){const J=this.j(N,H);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(!!he)return he.map(we=>({to:this.h(N,we.to),fromRanges:we.fromRanges.map(Ae=>T.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),J=T.CallHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(J._itemId,H),J}j(N,H){return this.e.get(N)?.get(H)}}class oe{constructor(N,H){this.f=N,this.g=H,this.d=new h.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const J=this.f.getDocument(N),he=T.Position.to(H),we=await this.g.prepareTypeHierarchy(J,he,Q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideSupertypes(N,H,Q){const J=this.j(N,H);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(J,Q);if(!!he)return he.map(we=>this.h(N,we))}async provideSubtypes(N,H,Q){const J=this.j(N,H);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(J,Q);if(!!he)return he.map(we=>this.h(N,we))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),J=T.TypeHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(J._itemId,H),J}j(N,H){return this.e.get(N)?.get(H)}}class fe{constructor(N,H,Q,J){this.d=N,this.e=H,this.f=Q,this.g=J}async provideDocumentOnDropEdits(N,H,Q,J,he){const we=this.e.getDocument(H),Ae=T.Position.to(Q),pe=T.DataTransfer.toDataTransfer(J,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),De=await this.f.provideDocumentDropEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?T.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class Z{constructor(N,H){this.adapter=N,this.extension=H}}class ce{constructor(N,H,Q,J,he,we,Ae,pe){this.g=H,this.h=Q,this.j=J,this.k=he,this.l=we,this.m=Ae,this.n=pe,this.f=new Map,this.e=N.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(N){return T.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ce.d++}async s(N,H,Q,J,he,we=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof H))return J;const pe=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const De=Q(Ae.adapter,Ae.extension);return Promise.resolve(De).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),C.CancellationToken.isCancellationToken(he)?(0,S.raceCancellationError)(De,he):De}t(N,H){const Q=this.q();return this.f.set(Q,new Z(N,H)),Q}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,H,Q,J){const he=this.t(new i(this.h,Q),N),we=J&&J.label||ce.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(H),we),this.p(he)}$provideDocumentSymbols(N,H,Q){return this.s(N,i,J=>J.provideDocumentSymbols(a.URI.revive(H),Q),void 0,Q)}registerCodeLensProvider(N,H,Q){const J=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Z(new s(this.h,this.j.converter,Q),N)),this.e.$registerCodeLensSupport(J,this.o(H),he);let we=this.p(J);if(he!==void 0){const Ae=Q.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(N,H,Q){return this.s(N,s,J=>J.provideCodeLenses(a.URI.revive(H),Q),void 0,Q)}$resolveCodeLens(N,H,Q){return this.s(N,s,J=>J.resolveCodeLens(H,Q),void 0,void 0)}$releaseCodeLenses(N,H){this.s(N,s,Q=>Promise.resolve(Q.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(N,H,Q){const J=this.t(new l(this.h,Q),N);return this.e.$registerDefinitionSupport(J,this.o(H)),this.p(J)}$provideDefinition(N,H,Q,J){return this.s(N,l,he=>he.provideDefinition(a.URI.revive(H),Q,J),[],J)}registerDeclarationProvider(N,H,Q){const J=this.t(new c(this.h,Q),N);return this.e.$registerDeclarationSupport(J,this.o(H)),this.p(J)}$provideDeclaration(N,H,Q,J){return this.s(N,c,he=>he.provideDeclaration(a.URI.revive(H),Q,J),[],J)}registerImplementationProvider(N,H,Q){const J=this.t(new u(this.h,Q),N);return this.e.$registerImplementationSupport(J,this.o(H)),this.p(J)}$provideImplementation(N,H,Q,J){return this.s(N,u,he=>he.provideImplementation(a.URI.revive(H),Q,J),[],J)}registerTypeDefinitionProvider(N,H,Q){const J=this.t(new r(this.h,Q),N);return this.e.$registerTypeDefinitionSupport(J,this.o(H)),this.p(J)}$provideTypeDefinition(N,H,Q,J){return this.s(N,r,he=>he.provideTypeDefinition(a.URI.revive(H),Q,J),[],J)}registerHoverProvider(N,H,Q,J){const he=this.t(new n(this.h,Q),N);return this.e.$registerHoverProvider(he,this.o(H)),this.p(he)}$provideHover(N,H,Q,J){return this.s(N,n,he=>he.provideHover(a.URI.revive(H),Q,J),void 0,J)}registerEvaluatableExpressionProvider(N,H,Q,J){const he=this.t(new d(this.h,Q),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(H)),this.p(he)}$provideEvaluatableExpression(N,H,Q,J){return this.s(N,d,he=>he.provideEvaluatableExpression(a.URI.revive(H),Q,J),void 0,J)}registerInlineValuesProvider(N,H,Q,J){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,Q),N);this.e.$registerInlineValuesProvider(we,this.o(H),he);let Ae=this.p(we);if(he!==void 0){const pe=Q.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideInlineValues(N,H,Q,J,he){return this.s(N,E,we=>we.provideInlineValues(a.URI.revive(H),Q,J,he),void 0,he)}registerDocumentHighlightProvider(N,H,Q){const J=this.t(new k(this.h,Q),N);return this.e.$registerDocumentHighlightProvider(J,this.o(H)),this.p(J)}$provideDocumentHighlights(N,H,Q,J){return this.s(N,k,he=>he.provideDocumentHighlights(a.URI.revive(H),Q,J),void 0,J)}registerLinkedEditingRangeProvider(N,H,Q){const J=this.t(new M(this.h,Q),N);return this.e.$registerLinkedEditingRangeProvider(J,this.o(H)),this.p(J)}$provideLinkedEditingRanges(N,H,Q,J){return this.s(N,M,async he=>{const we=await he.provideLinkedEditingRanges(a.URI.revive(H),Q,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(N,H,Q){const J=this.t(new K(this.h,Q),N);return this.e.$registerReferenceSupport(J,this.o(H)),this.p(J)}$provideReferences(N,H,Q,J,he){return this.s(N,K,we=>we.provideReferences(a.URI.revive(H),Q,J,he),void 0,he)}registerCodeActionProvider(N,H,Q,J){const he=new v.DisposableStore,we=this.t(new q(this.h,this.j.converter,this.k,Q,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(we,this.o(H),{providedKinds:J?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:J?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},ce.u(N),Boolean(Q.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(N,H,Q,J,he){return this.s(N,q,we=>we.provideCodeActions(a.URI.revive(H),Q,J,he),void 0,he)}$resolveCodeAction(N,H,Q){return this.s(N,q,J=>J.resolveCodeAction(H,Q),void 0,void 0)}$releaseCodeActions(N,H){this.s(N,q,Q=>Promise.resolve(Q.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(N,H,Q){const J=this.t(new B(this.h,Q),N);return this.e.$registerDocumentFormattingSupport(J,this.o(H),N.identifier,N.displayName||N.name),this.p(J)}$provideDocumentFormattingEdits(N,H,Q,J){return this.s(N,B,he=>he.provideDocumentFormattingEdits(a.URI.revive(H),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(N,H,Q){const J=this.t(new O(this.h,Q),N);return this.e.$registerRangeFormattingSupport(J,this.o(H),N.identifier,N.displayName||N.name),this.p(J)}$provideDocumentRangeFormattingEdits(N,H,Q,J,he){return this.s(N,O,we=>we.provideDocumentRangeFormattingEdits(a.URI.revive(H),Q,J,he),void 0,he)}registerOnTypeFormattingEditProvider(N,H,Q,J){const he=this.t(new U(this.h,Q),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(H),J,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,H,Q,J,he,we){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive(H),Q,J,he,we),void 0,we)}registerWorkspaceSymbolProvider(N,H){const Q=this.t(new $(H,this.l),N);return this.e.$registerNavigateTypeSupport(Q,typeof H.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(N,H,Q){return this.s(N,$,J=>J.provideWorkspaceSymbols(H,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(N,H,Q){return this.s(N,$,J=>J.resolveWorkspaceSymbol(H,Q),void 0,void 0)}$releaseWorkspaceSymbols(N,H){this.s(N,$,Q=>Q.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(N,H,Q){const J=this.t(new j(this.h,Q,this.l),N);return this.e.$registerRenameSupport(J,this.o(H),j.supportsResolving(Q)),this.p(J)}$provideRenameEdits(N,H,Q,J,he){return this.s(N,j,we=>we.provideRenameEdits(a.URI.revive(H),Q,J,he),void 0,he)}$resolveRenameLocation(N,H,Q,J){return this.s(N,j,he=>he.resolveRenameLocation(a.URI.revive(H),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(N,H,Q,J){const he=this.t(new V(this.h,Q),N),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(H),J,we);let Ae=this.p(he);if(we){const pe=Q.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideDocumentSemanticTokens(N,H,Q,J){return this.s(N,V,he=>he.provideDocumentSemanticTokens(a.URI.revive(H),Q,J),null,J)}$releaseDocumentSemanticTokens(N,H){this.s(N,V,Q=>Q.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,H,Q,J){const he=this.t(new _(this.h,Q),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(H),J),this.p(he)}$provideDocumentRangeSemanticTokens(N,H,Q,J){return this.s(N,_,he=>he.provideDocumentRangeSemanticTokens(a.URI.revive(H),Q,J),null,J)}registerCompletionItemProvider(N,H,Q,J){const he=this.t(new Y(this.h,this.j.converter,Q,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(H),J,Y.supportsResolving(Q),`${N.identifier.value}(${J.join("")})`),this.p(he)}$provideCompletionItems(N,H,Q,J,he){return this.s(N,Y,we=>we.provideCompletionItems(a.URI.revive(H),Q,J,he),void 0,he)}$resolveCompletionItem(N,H,Q){return this.s(N,Y,J=>J.resolveCompletionItem(H,Q),void 0,Q)}$releaseCompletionItems(N,H){this.s(N,Y,Q=>Q.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(N,H,Q){const J=new ee(N,this.h,Q,this.j.converter),he=this.t(J,N);return this.e.$registerInlineCompletionsSupport(he,this.o(H),J.supportsHandleDidShowCompletionItem),this.p(he)}$provideInlineCompletions(N,H,Q,J,he){return this.s(N,ne,we=>we.provideInlineCompletions(a.URI.revive(H),Q,J,he),void 0,he)}$handleInlineCompletionDidShow(N,H,Q){this.s(N,ne,async J=>{J.handleDidShowCompletionItem(H,Q)},void 0,void 0)}$freeInlineCompletionsList(N,H){this.s(N,ne,async Q=>{Q.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(N,H,Q,J){const he=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this.t(new G(this.h,Q),N);return this.e.$registerSignatureHelpProvider(we,this.o(H),he),this.p(we)}$provideSignatureHelp(N,H,Q,J,he){return this.s(N,G,we=>we.provideSignatureHelp(a.URI.revive(H),Q,J,he),void 0,he)}$releaseSignatureHelp(N,H){this.s(N,G,Q=>Q.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(N,H,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new de(this.h,this.j.converter,Q,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(H),typeof Q.resolveInlayHint=="function",J,ce.u(N));let we=this.p(he);if(J!==void 0){const Ae=Q.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(J));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(N,H,Q,J){return this.s(N,de,he=>he.provideInlayHints(a.URI.revive(H),Q,J),void 0,J)}$resolveInlayHint(N,H,Q){return this.s(N,de,J=>J.resolveInlayHint(H,Q),void 0,Q)}$releaseInlayHints(N,H){this.s(N,de,Q=>Q.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(N,H,Q){const J=this.t(new be(this.h,Q),N);return this.e.$registerDocumentLinkProvider(J,this.o(H),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(N,H,Q){return this.s(N,be,J=>J.provideLinks(a.URI.revive(H),Q),void 0,Q,H.scheme==="output")}$resolveDocumentLink(N,H,Q){return this.s(N,be,J=>J.resolveLink(H,Q),void 0,void 0,!0)}$releaseDocumentLinks(N,H){this.s(N,be,Q=>Q.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(N,H,Q){const J=this.t(new Ee(this.h,Q),N);return this.e.$registerDocumentColorProvider(J,this.o(H)),this.p(J)}$provideDocumentColors(N,H,Q){return this.s(N,Ee,J=>J.provideColors(a.URI.revive(H),Q),[],Q)}$provideColorPresentations(N,H,Q,J){return this.s(N,Ee,he=>he.provideColorPresentations(a.URI.revive(H),Q,J),void 0,J)}registerFoldingRangeProvider(N,H,Q){const J=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Z(new Pe(this.h,Q),N)),this.e.$registerFoldingRangeProvider(J,this.o(H),N.identifier,he);let we=this.p(J);if(he!==void 0){const Ae=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(N,H,Q,J){return this.s(N,Pe,he=>he.provideFoldingRanges(a.URI.revive(H),Q,J),void 0,J)}registerSelectionRangeProvider(N,H,Q){const J=this.t(new Fe(this.h,Q,this.l),N);return this.e.$registerSelectionRangeProvider(J,this.o(H)),this.p(J)}$provideSelectionRanges(N,H,Q,J){return this.s(N,Fe,he=>he.provideSelectionRanges(a.URI.revive(H),Q,J),[],J)}registerCallHierarchyProvider(N,H,Q){const J=this.t(new se(this.h,Q),N);return this.e.$registerCallHierarchyProvider(J,this.o(H)),this.p(J)}$prepareCallHierarchy(N,H,Q,J){return this.s(N,se,he=>Promise.resolve(he.prepareSession(a.URI.revive(H),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(N,H,Q,J){return this.s(N,se,he=>he.provideCallsTo(H,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(N,H,Q,J){return this.s(N,se,he=>he.provideCallsFrom(H,Q,J),void 0,J)}$releaseCallHierarchy(N,H){this.s(N,se,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(N,H,Q){const J=this.t(new oe(this.h,Q),N);return this.e.$registerTypeHierarchyProvider(J,this.o(H)),this.p(J)}$prepareTypeHierarchy(N,H,Q,J){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(a.URI.revive(H),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(N,H,Q,J){return this.s(N,oe,he=>he.provideSupertypes(H,Q,J),void 0,J)}$provideTypeHierarchySubtypes(N,H,Q,J){return this.s(N,oe,he=>he.provideSubtypes(H,Q,J),void 0,J)}$releaseTypeHierarchy(N,H){this.s(N,oe,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(N,H,Q){const J=this.q();return this.f.set(J,new Z(new fe(this.e,this.h,Q,J),N)),this.e.$registerDocumentOnDropEditProvider(J,this.o(H)),this.p(J)}$provideDocumentOnDropEdits(N,H,Q,J,he,we){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(H,a.URI.revive(Q),J,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,H,Q,J){const he=this.q();return this.f.set(he,new Z(new F(this.e,this.h,Q,he),N)),this.e.$registerPasteEditProvider(he,this.o(H),!!Q.prepareDocumentPaste,J.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,H,Q,J,he){return this.s(N,F,we=>we.prepareDocumentPaste(a.URI.revive(H),Q,J,he),void 0,he)}$providePasteEdits(N,H,Q,J,he,we){return this.s(N,F,Ae=>Ae.providePasteEdits(H,a.URI.revive(Q),J,he,we),void 0,we)}static w(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ce.w(N.decreaseIndentPattern),increaseIndentPattern:ce.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ce.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ce.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ce.w(N.beforeText),afterText:N.afterText?ce.w(N.afterText):void 0,previousLineText:N.previousLineText?ce.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ce.z)}setLanguageConfiguration(N,H,Q){const{wordPattern:J}=Q;if(J&&(0,y.regExpLeadsToEndlessLoop)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(H,J):this.h.setWordDefinitionFor(H,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?ce.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?ce.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?ce.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport};return this.e.$setLanguageConfiguration(he,H,we),this.p(he)}$setWordDefinitions(N){for(const H of N)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(ye[262],Ce([1,0,5,15,7,38,14,6]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,P,w,C){this.c=P,this.d=w,this.e=C,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const w=this.c.getDocumentData(L);if(!w)throw new Error(`document '${L.toString()}' NOT found`);return w.document}async tokenAtPosition(L,P){const w=L.version,C=t.Position.from(P),v=await this.a.$tokensAtPosition(L.uri,C),m={type:T.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new T.Range(P.line,P.character,P.line,P.character)};if(!v)return m;const h={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!h.range.contains(P)||w!==L.version?m:h}createLanguageStatusItem(L,P,w){const C=this.f++,v=this.a,m=this.g,h=`${L.identifier.value}/${P}`;if(m.has(h))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);m.add(h);const f={selector:w,id:P,name:L.displayName??L.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new A.DisposableStore,S=()=>{p?.dispose(),p=(0,I.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(C,{id:h,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===T.LanguageStatusSeverity.Error?R.default.Error:f.severity===T.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,b),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},g={dispose(){b.dispose(),p?.dispose(),v.$removeLanguageStatus(C),m.delete(h)},get id(){return f.id},get name(){return f.name},set name(i){f.name=i,S()},get selector(){return f.selector},set selector(i){f.selector=i,S()},get text(){return f.text},set text(i){f.text=i,S()},get detail(){return f.detail},set detail(i){f.detail=i,S()},get severity(){return f.severity},set severity(i){f.severity=i,S()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(i){f.accessibilityInformation=i,S()},get command(){return f.command},set command(i){f.command=i,S()},get busy(){return f.busy},set busy(i){f.busy=i,S()}};return S(),g}}e.ExtHostLanguages=y}),define(ye[97],Ce([1,0,12,8,2,4,13,5,25,18]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(w,C,v){this.f=v,this.d=new Map,this.a=C.getProxy(A.MainContext.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(w,C){const{message:v,args:m,comment:h}=C;if(this.c)return(0,t.format2)(v,m??{});let f=v;h&&h.length>0&&(f+=`/${Array.isArray(h)?h.join():h}`);const p=this.d.get(w)?.contents[f];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(p??v,m??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let C;const v=await this.g(w);if(!v){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const m=await this.a.$fetchBundleContents(v),h=JSON.parse(m);C=w.isBuiltin?h.contents?.bundle:h}catch(m){this.f.error(`Failed to load translations for ${w.identifier.value} from ${v}: ${m.message}`);return}C&&this.d.set(w.identifier.value,{contents:C,uri:v})}async g(w){if(w.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(w.identifier.value);return T.URI.revive(C)}return w.l10n?T.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,y.IExtHostInitDataService),We(1,D.IExtHostRpcService),We(2,I.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,18,2,3,10]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends a.AbstractLoggerService{constructor(w,C){super(C.logLevel,A.Event.None),this.g=w.getProxy(t.MainContext.MainThreadLogger)}$setLevel(w,C){C?this.setLevel(I.URI.revive(C),w):(0,y.isUndefined)(w)||this.setLevel(w)}f(w,C,v){return new L(this.g,w,C,v)}};D=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class L extends a.AbstractMessageLogger{constructor(w,C,v,m){super(m?.always),this.m=w,this.n=C,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(C,m).then(()=>{this.r(this.l),this.k=!0})}g(w,C){const v=[[w,C]];this.k?this.r(v):this.l.push(...v)}r(w){this.m.$log(this.n,w)}}}),define(ye[263],Ce([1,0,5,13,26]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let I=class{constructor(y,D){this.b=D,this.a=y.getProxy(a.MainContext.MainThreadMessageService)}showMessage(y,D,L,P,w){const C={source:{identifier:y.identifier,label:y.displayName||y.name}};let v;typeof P=="string"||R(P)?v=[P,...w]:(C.modal=P?.modal,C.useCustom=P?.useCustom,C.detail=P?.detail,v=w),C.useCustom&&(0,T.checkProposedApiEnabled)(y,"resolvers");const m=[];for(let h=0;h<v.length;h++){const f=v[h];if(typeof f=="string")m.push({title:f,handle:h,isCloseAffordance:!1});else if(typeof f=="object"){const{title:p,isCloseAffordance:b}=f;m.push({title:p,isCloseAffordance:!!b,handle:h})}else this.b.warn("Invalid message item:",f)}return this.a.$showMessage(D,L,C,m).then(h=>{if(typeof h=="number")return v[h]})}};I=qe([We(1,t.ILogService)],I),e.ExtHostMessageService=I}),define(ye[264],Ce([1,0,23,3,6,28,8,10,2,72,5,41,15,7,58,239,136]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,S,g,i){this.q=g,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const o=s.notebookEditor?.notebookUri,l=s.cell.handle,u=this.g.get(o)?.getCell(l);if(u)return u.apiCell}if(s&&s.$mid===14){const o=s.uri,l=this.g.get(o);if(l)return l.apiNotebook}return s}}),f.x(S)}getEditorById(b){const S=this.h.get(b);if(!S)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(b){for(const[S,g]of this.h)if(g.apiEditor===b)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,S){const g=this.g.get(b);if(!g&&!S)throw new Error(`NO notebook document for '${b}'`);return g}static s(b,S){if(!S)return;const g=S.filenamePattern.map(i=>w.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(S.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:S.displayName,filenamePattern:g,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,S,g){const i=f.a++,s=typeof g.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(i,g),this.b.$registerNotebookCellStatusBarItemProvider(i,s,S);let o;return s!==void 0&&(o=g.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(s))),new C.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,s),o?.dispose()})}async createNotebookDocument(b){const S=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&w.NotebookData.from(b.content)});return y.URI.revive(S)}async openNotebookDocument(b){const S=this.g.get(b);if(S)return S.apiNotebook;const g=await this.c.$tryOpenNotebook(b),i=this.g.get(y.URI.revive(g));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,S){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof S=="object"?g={position:w.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(w.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:g={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,g),s=i&&this.h.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,S,g,i){const s=this.f.get(b),o=y.URI.revive(S),l=this.g.get(o);if(!l||!s)return;const c=l.getCellFromIndex(g);if(!c)return;const u=await s.provideCellStatusBarItems(c.apiCell,i);if(!u)return;const r=new T.DisposableStore,n=this.p.add([r]),E=(Array.isArray(u)?u:[u]).map(k=>w.NotebookStatusBarItem.from(k,this.i,r));return{cacheId:n,items:E}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,S,g,i,s){if((0,I.isFalsyOrWhitespace)(S))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,g),this.b.$registerNotebookSerializer(o,{id:b.identifier,location:b.extensionLocation},S,w.NotebookDocumentContentOptions.from(i),f.s(b,s)),(0,T.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(b,S,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(S.buffer,g);return new v.SerializableObjectWithBuffers(w.NotebookData.from(s))}async $notebookToData(b,S,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(w.NotebookData.to(S.value),g);return a.VSBuffer.wrap(s)}w(b,S,g){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const i=new h.ExtHostNotebookEditor(S,this.d,b,g.visibleRanges.map(w.NotebookRange.to),g.selections.map(w.NotebookRange.to),typeof g.viewColumn=="number"?w.ViewColumn.to(g.viewColumn):void 0);this.h.set(S,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const g of b.value.removedDocuments){const i=y.URI.revive(g),s=this.g.get(i);s&&(s.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(s.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===i.toString()&&this.h.delete(o.id)}if(b.value.addedDocuments){const g=[];for(const i of b.value.addedDocuments){const s=y.URI.revive(i.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const o=new m.ExtHostNotebookDocument(this.c,this.q,this.r,s,i);g.push(...i.cells.map(l=>m.ExtHostCell.asModelAddData(o.apiNotebook,l))),this.g.get(s)?.dispose(),this.g.set(s,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(o.apiNotebook)}}if(b.value.addedEditors)for(const g of b.value.addedEditors){if(this.h.has(g.id))return;const i=y.URI.revive(g.documentUri),s=this.g.get(i);s&&this.w(s,g.id,g)}const S=[];if(b.value.removedEditors)for(const g of b.value.removedEditors){const i=this.h.get(g);i&&(this.h.delete(g),this.k?.id===i.id&&(this.k=void 0),S.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const g=new Set;this.l.forEach(i=>g.add(i.id));for(const i of this.h.values()){const s=g.has(i.id);i._acceptVisibility(s)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const S=P.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new P.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>a.VSBuffer.wrap(s))],new P.ApiCommandResult("Notebook Data",s=>w.NotebookData.to(s.value))),i=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new v.SerializableObjectWithBuffers(w.NotebookData.from(s)))],new P.ApiCommandResult("Bytes",s=>s.buffer));b.registerApiCommand(g),b.registerApiCommand(i)}}e.ExtHostNotebookController=f,f.a=0}),define(ye[265],Ce([1,0,16,14,21,3,6,28,2,27,13,72,5,41,15,7,94,227,26,58]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(c,u,r,n,d){this.k=u,this.l=r,this.m=n,this.n=d,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(w.MainContext.MainThreadNotebookKernels);const E=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",k=>!0,k=>{if(k&&"notebookEditor"in k&&"id"in k){const M=this.l.getIdByEditor(k.notebookEditor);return{id:k.id,extension:k.extension,notebookEditorId:M}}else if(k&&"notebookEditor"in k){const M=this.l.getIdByEditor(k.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${k.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return k})],C.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(c,u,r,n,d,E){for(const ne of this.h.values())if(ne.controller.id===u&&D.ExtensionIdentifier.equals(c.identifier,ne.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const k=this.i++,M=this;this.n.trace(`NotebookController[${k}], CREATED by ${c.identifier.value}, ${u}`);const K=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${c.identifier}'`);let q=!1;const F=new I.DisposableStore,B=new R.Emitter,O=new R.Emitter,U={id:o(c.identifier,u),notebookType:r,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:n||c.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let $=d??K,j;this.a.$addKernel(k,U).catch(ne=>{console.log(ne),q=!0});let ue=0;const V=()=>{if(q)return;const ne=++ue;Promise.resolve().then(()=>{ne===ue&&this.a.$updateKernel(k,U)})},_=new A.ResourceMap,Y={get id(){return u},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ne){U.label=ne??c.displayName??c.name,V()},get detail(){return U.detail??""},set detail(ne){U.detail=ne,V()},get description(){return U.description??""},set description(ne){U.description=ne,V()},get kind(){return(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),U.kind??""},set kind(ne){(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),U.kind=ne,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ne){U.supportedLanguages=ne,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){U.supportsExecutionOrder=ne,V()},get rendererScripts(){return U.preloads?U.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return $},set executeHandler(ne){$=ne??K},get interruptHandler(){return j},set interruptHandler(ne){j=ne,U.supportsInterrupt=Boolean(ne),V()},createNotebookCellExecution(ne){if(q)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.notebook.uri))throw M.n.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return M._createNotebookCellExecution(ne,o(c.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${k}], DISPOSED`),q=!0,this.h.delete(k),F.dispose(),B.dispose(),O.dispose(),this.a.$removeKernel(k))},updateNotebookAffinity(ne,ee){ee===m.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),M.a.$updateNotebookPriority(k,ne.uri,ee)},onDidReceiveMessage:O.event,postMessage(ne,ee){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),M.a.$postMessage(k,ee&&M.l.getIdByEditor(ee),ne)},asWebviewUri(ne){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),(0,h.asWebviewUri)(ne,M.k.remote)}};return this.h.set(k,{extensionId:c.identifier,controller:Y,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:_}),Y}getIdByController(c){for(const[u,r]of this.h)if(r.controller===c)return o(r.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const r=this.d++,n=this;this.n.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(r,u);const d={dispose:()=>{this.c.delete(r),n.a.$removeKernelDetectionTask(r)}};return this.c.set(r,d),d}registerKernelSourceActionProvider(c,u,r){const n=this.f++,d=this;return this.e.set(n,r),this.n.trace(`NotebookKernelSourceActionProvider[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(n,u),{dispose:()=>{this.e.delete(n),d.a.$removeKernelSourceActionProvider(n)}}}async $provideKernelSourceActions(c,u){const r=this.e.get(c);if(r){const n=new I.DisposableStore;return this.g.add([n]),(await r.provideNotebookKernelSourceActions(u)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.m.converter,n))}return[]}$acceptNotebookAssociation(c,u,r){const n=this.h.get(c);if(n){const d=this.l.getNotebookDocument(y.URI.revive(u));r?n.associatedNotebooks.set(d.uri,!0):n.associatedNotebooks.delete(d.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,d.uri.toString(),r),n.onDidChangeSelection.fire({selected:r,notebook:d.apiNotebook})}}async $executeCells(c,u,r){const n=this.h.get(c);if(!n)return;const d=this.l.getNotebookDocument(y.URI.revive(u)),E=[];for(const k of r){const M=d.getCell(k);M&&E.push(M.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,d.uri.toString(),E.length),await n.controller.executeHandler.call(n.controller,E,d.apiNotebook,n.controller)}catch(k){this.n.error(`NotebookController[${c}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(c,u,r){const n=this.h.get(c);if(!n)return;const d=this.l.getNotebookDocument(y.URI.revive(u));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,d.apiNotebook);else for(const E of r){const k=d.getCell(E);k&&this.b.get(k.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,u,r){const n=this.h.get(c);if(!n)return;const d=this.l.getEditorById(u);n.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:r}))}$cellExecutionChanged(c,u,r){const d=this.l.getNotebookDocument(y.URI.revive(c)).getCell(u);if(d){const E=r?v.NotebookCellExecutionState.to(r):m.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:d.apiCell,state:E})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!n)throw new Error("invalid cell");if(this.b.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const d=new i(u,n,this.a);this.b.set(n.uri,d);const E=d.onDidChangeState(()=>{d.state===g.Resolved&&(d.dispose(),E.dispose(),this.b.delete(n.uri))});return d.asApiObject()}};S=qe([We(4,L.ILogService)],S),e.ExtHostNotebookKernels=S;var g;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(g||(g={}));class i extends I.Disposable{get state(){return this.f}constructor(c,u,r){super(),this.j=u,this.k=r,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new T.CancellationTokenSource),this.h=new s(10,n=>this.m(n)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const r=m.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return r===u.items?v.NotebookCellOutput.from(u):v.NotebookCellOutput.from({items:r,id:u.id,metadata:u.metadata})})}async t(c,u,r){const n=this.r(u),d=this.s((0,a.asArray)(c));return this.l({editType:f.CellExecutionUpdateType.Output,cellHandle:n,append:r,outputs:d})}async w(c,u,r){return c=m.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(c),!0),this.l({editType:f.CellExecutionUpdateType.OutputItems,items:c.map(v.NotebookCellOutputItem.from),outputId:u.id,append:r})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(r){c.i=r,c.m([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(r){if(c.f===g.Resolved||c.f===g.Started)throw new Error("Cannot call start again");c.f=g.Started,c.c.fire(),c.m({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,n){if(c.f===g.Resolved)throw new Error("Cannot call resolve twice");c.f=g.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:r}))},clearOutput(r){return c.n(),c.t([],r,!1)},appendOutput(r,n){return c.n(),c.t(r,n,!0)},replaceOutput(r,n){return c.n(),c.t(r,n,!1)},appendOutputItems(r,n){return c.n(),c.w(r,n,!0)},replaceOutputItems(r,n){return c.n(),c.w(r,n,!1)}})}}i.a=0;class s{constructor(c,u){this.d=c,this.e=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>c.complete())}}function o(l,c){return`${l.value}/${c}`}e.createKernelId=o}),define(ye[266],Ce([1,0,3,5,136]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,D){const L=this.c.getEditorById(A);this.a.get(y)?.fire({editor:L.apiEditor,message:D})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,P,w)=>this.d(y).event(L,P,w),postMessage:(L,P)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const w=P&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(w?.id,y,L)}}}d(A){let y=this.a.get(A);return y||(y=new a.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[267],Ce([1,0,6,10,2,26,5]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(D){this.b=new Map,this.a=D.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(D,L,P){if((0,R.checkProposedApiEnabled)(D,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,D.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(D,L,P,w){const C=this.b.get(D);if(!C)throw new Error(`Unknown handler with id: ${D}`);return C.saveProfile(L,P,w)}async $readProfile(D,L,P){const w=this.b.get(D);if(!w)throw new Error(`Unknown handler with id: ${D}`);return w.readProfile((0,t.isString)(L)?L:T.URI.revive(L),P)}}e.ExtHostProfileContentHandlers=A}),define(ye[268],Ce([1,0,21,3,6,5,2,7,9,16,38,71]),function(te,e,a,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(C,v,m){const h=C.getProxy(R.MainContext.MainThreadQuickOpen);class f{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,r=a.CancellationToken.None){this.c=void 0;const n=Promise.resolve(c),d=++this.f,E=h.$show(d,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},r),k={},M=E.then(()=>k);return Promise.race([M,n]).then(K=>{if(K!==k)return n.then(q=>{const F=[];for(let B=0;B<q.length;B++){const O=q[B];typeof O=="string"?F.push({label:O,handle:B}):O.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:O.label}):F.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=B=>{u.onDidSelectItem(q[B])}),h.$setItems(d,F),E.then(B=>{if(typeof B=="number")return q[B];if(Array.isArray(B))return B.map(O=>q[O])})})}).then(void 0,K=>{if(!(0,y.isCancellationError)(K))return h.$setError(d,K),Promise.reject(K)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=a.CancellationToken.None){return this.d=c?.validateInput,h.$input(c,typeof this.d=="function",u).then(void 0,r=>{if(!(0,y.isCancellationError)(r))return Promise.reject(r)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let r;switch(u.severity){case A.InputBoxValidationSeverity.Info:r=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:r=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:r=L.default.Error;break;default:r=u.message?L.default.Error:L.default.Ignore;break}return{content:u.message,severity:r}}async showWorkspaceFolderPick(c,u=a.CancellationToken.None){const r=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!r)return;const n=await this.a.getWorkspaceFolders2();if(!!n)return n.find(d=>d.uri.toString()===r.uri.toString())}createQuickPick(c){const u=new s(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new o(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const r=this.e.get(c);r instanceof s&&r._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const r=this.e.get(c);r instanceof s&&r._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,r){const n=this.e.get(c);n instanceof s&&n._fireDidTriggerItemButton(u,r)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class p{constructor(c,u){this.x=c,this.y=u,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,r)=>{const n=u===A.QuickInputButtons.Back?-1:r;this.o.set(n,u)}),this.z({buttons:c.map((u,r)=>({...i(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:r}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,T.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const r=c[u];this.u[u]=r===void 0?null:r}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function b(l){if(l instanceof A.ThemeIcon)return{id:l.id};const c=g(l),u=S(l);return{dark:typeof c=="string"?I.URI.file(c):c,light:typeof u=="string"?I.URI.file(u):u}}function S(l){return typeof l=="object"&&"light"in l?l.light:l}function g(l){return typeof l=="object"&&"dark"in l?l.dark:l}function i(l){const c=b(l.iconPath);let u,r;return"id"in c?r=P.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:r}}class s extends p{constructor(c,u){super(c.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((r,n)=>{this.C.set(n,r),this.D.set(r,n)});const u=[];for(let r=0;r<c.length;r++){const n=c[r];n.kind===A.QuickPickItemKind.Separator?u.push({type:"separator",label:n.label}):u.push({handle:r,label:n.label,description:n.description,detail:n.detail,picked:n.picked,alwaysShow:n.alwaysShow,buttons:n.buttons?.map((d,E)=>({...i(d),tooltip:d.tooltip,handle:E}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,D.coalesce)(c.map(r=>this.C.get(r)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,D.coalesce)(c.map(r=>this.C.get(r)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const r=this.C.get(c);if(!r||!r.buttons||!r.buttons.length)return;const n=r.buttons[u];n&&this.N.fire({button:n,item:r})}}class o extends p{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:L.default.Error}):this.z({validationMessage:c.message,severity:c.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new f(v,m)}e.createExtHostQuickOpen=w});var Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a};define(ye[269],Ce([1,0,2,3,62,6,14,5,16,110,13,27,71,15,26]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v){"use strict";var m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(n){if(n)return typeof n.iconPath=="string"?a.URI.file(n.iconPath):a.URI.isUri(n.iconPath)||w.ThemeIcon.isThemeIcon(n.iconPath)?n.iconPath:void 0}function p(n,d){if(!n.iconPath&&!d.iconPath)return 0;if(n.iconPath){if(!d.iconPath)return 1}else return-1;const E=typeof n.iconPath=="string"?n.iconPath:a.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id,k=typeof d.iconPath=="string"?d.iconPath:a.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,D.comparePaths)(E,k)}function b(n,d){let E=0;if(n.strikeThrough!==d.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==d.faded)return n.faded?1:-1;if(n.tooltip!==d.tooltip)return(n.tooltip||"").localeCompare(d.tooltip||"");if(E=p(n,d),E!==0)return E;if(n.light&&d.light)E=p(n.light,d.light);else{if(n.light)return 1;if(d.light)return-1}if(E!==0)return E;if(n.dark&&d.dark)E=p(n.dark,d.dark);else{if(n.dark)return 1;if(d.dark)return-1}return E}function S(n,d){if(n.command!==d.command)return n.command<d.command?-1:1;if(n.title!==d.title)return n.title<d.title?-1:1;if(n.tooltip!==d.tooltip){if(n.tooltip!==void 0&&d.tooltip!==void 0)return n.tooltip<d.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(n.arguments===d.arguments)return 0;if(n.arguments)if(d.arguments){if(n.arguments.length!==d.arguments.length)return n.arguments.length-d.arguments.length}else return 1;else return-1;for(let E=0;E<n.arguments.length;E++){const k=n.arguments[E],M=d.arguments[E];if(k!==M)return k<M?-1:1}return 0}function g(n,d){let E=(0,D.comparePaths)(n.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(E!==0)return E;if(n.command&&d.command)E=S(n.command,d.command);else{if(n.command)return 1;if(d.command)return-1}if(E!==0)return E;if(n.decorations&&d.decorations)E=b(n.decorations,d.decorations);else{if(n.decorations)return 1;if(d.decorations)return-1}return E}function i(n,d){for(let E=0;E<n.length;E++)if(n[E]!==d[E])return!1;return!0}function s(n,d){return n.command===d.command&&n.title===d.title&&n.tooltip===d.tooltip&&(n.arguments&&d.arguments?i(n.arguments,d.arguments):n.arguments===d.arguments)}function o(n,d){return(0,y.equals)(n,d,s)}class l{get value(){return this.d}set value(d){d=d??"",Ue(this,m,"f").$setInputBoxValue(this.l,d),this.m(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){Ue(this,m,"f").$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,Ue(this,m,"f").$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,Ue(this,m,"f").$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,Ue(this,m,"f").$setInputBoxVisibility(this.l,d))}constructor(d,E,k){this.k=d,this.l=k,m.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,m,E,"f")}showValidationMessage(d,E){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,m,"f").$showValidationMessage(this.l,d,E)}$onInputBoxValueChange(d){this.m(d)}m(d){this.d=d,this.e.fire(d)}}e.ExtHostSCMInputBox=l,m=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,E,k,M,K){this.q=d,this.s=E,this.t=k,this.u=M,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,E){const k=this.h.get(d);return k?(0,I.asPromise)(()=>this.s.executeCommand(k.command,...k.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(g),k=(0,y.sortedDiff)(this.o,d,g).map(q=>{const F=q.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const U=B.resourceUri;let $;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const de=new R.DisposableStore;$=this.s.converter.toInternal(B.command,de),this.j.set(O,de)}else this.h.set(O,B.command);const j=f(B.decorations),ue=B.decorations&&f(B.decorations.light)||j,V=B.decorations&&f(B.decorations.dark)||j,_=[ue,V],Y=B.decorations&&B.decorations.tooltip||"",ne=B.decorations&&!!B.decorations.strikeThrough,ee=B.decorations&&!!B.decorations.faded,X=B.contextValue||"";return{rawResource:[O,U,_,Y,ne,ee,X,$],handle:O}});return{start:q.start,deleteCount:q.deleteCount,toInsert:F}}),M=k.map(({start:q,deleteCount:F,toInsert:B})=>[q,F,B.map(O=>O.rawResource)]),K=k.reverse();for(const{start:q,deleteCount:F,toInsert:B}of K){const O=B.map($=>$.handle),U=this.n.splice(q,F,...O);for(const $ of U)this.g.delete($),this.h.delete($),this.j.get($)?.dispose(),this.j.delete($)}return this.o=d,M}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,Ue(this,h,"f").$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d,Ue(this,h,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,Ue(this,h,"f").$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new R.DisposableStore,this.l=d;const E=this.v.converter.toInternal(d,this.k.value);Ue(this,h,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=d;const E=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(k=>k.map(M=>this.v.converter.toInternal(M,this.m.value))),description:d.description,enabled:d.enabled}:void 0;Ue(this,h,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&o(this.p,d))return;this.o.value=new R.DisposableStore,this.p=d;const E=(d||[]).map(k=>this.v.converter.toInternal(k,this.o.value));Ue(this,h,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(d,E,k,M,K,q){this.u=d,this.v=k,this.w=M,this.x=K,this.y=q,h.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Ye(this,h,E,"f"),this.f=new l(d,Ue(this,h,"f"),this.t),Ue(this,h,"f").$registerSourceControl(this.t,M,K,q)}createResourceGroup(d,E){const k=new c(Ue(this,h,"f"),this.v,this.t,d,E),M=t.Event.once(k.onDidDispose)(()=>this.z.delete(k));return this.z.set(k,M),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const d=[],E=[];for(const[k,M]of this.z){M.dispose();const K=k.onDidUpdateResourceStates(()=>{this.A.add(k),this.eventuallyUpdateResourceStates()});t.Event.once(k.onDidDispose)(()=>{this.A.delete(k),K.dispose(),this.e.delete(k.handle),Ue(this,h,"f").$unregisterGroup(this.t,k.handle)}),d.push([k.handle,k.id,k.label,k.features]);const q=k._takeResourceStateSnapshot();q.length>0&&E.push([k.handle,q]),this.e.set(k.handle,k)}Ue(this,h,"f").$registerGroups(this.t,d,E),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(E=>{const k=E._takeResourceStateSnapshot();k.length!==0&&d.push([E.handle,k])}),d.length>0&&Ue(this,h,"f").$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),Ue(this,h,"f").$unregisterSourceControl(this.t)}}h=new WeakMap,u.d=0,qe([(0,T.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,T.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let r=class ri{get onDidChangeActiveProvider(){return this.j.event}constructor(d,E,k){this.l=E,this.m=k,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=d.getProxy(A.MainContext.MainThreadSCM),this.f=d.getProxy(A.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const K=this.g.get(M.sourceControlHandle);if(!K)return M;const q=K.getResourceGroup(M.groupHandle);return q?q.getResourceState(M.handle):M}else if(M&&M.$mid===4){const K=this.g.get(M.sourceControlHandle);return K?K.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const K=this.g.get(M.handle);return K||M}return M}})}createSourceControl(d,E,k,M){this.m.trace("ExtHostSCM#createSourceControl",d.identifier.value,E,k,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const K=ri.d++,q=new u(d,this.e,this.l,E,k,M);this.g.set(K,q);const F=this.h.get(P.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(q),this.h.set(P.ExtensionIdentifier.toKey(d.identifier),F),q}getLastInputBox(d){this.m.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const E=this.h.get(P.ExtensionIdentifier.toKey(d.identifier)),k=E&&E[E.length-1];return k&&k.inputBox}$provideOriginalResource(d,E,k){const M=a.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",d,M.toString());const K=this.g.get(d);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(M,k)).then(q=>q||null)}$onInputBoxValueChange(d,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",d);const k=this.g.get(d);return k&&k.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(d,E,k,M){this.m.trace("ExtHostSCM#$executeResourceCommand",d,E,k);const K=this.g.get(d);if(!K)return Promise.resolve(void 0);const q=K.getResourceGroup(E);return q?q.$executeResourceCommand(k,M):Promise.resolve(void 0)}$validateInput(d,E,k){this.m.trace("ExtHostSCM#$validateInput",d);const M=this.g.get(d);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>M.inputBox.validateInput(E,k)).then(K=>{if(!K)return Promise.resolve(void 0);const q=C.MarkdownString.fromStrict(K.message);return q?Promise.resolve([q,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};r.d=0,r=qe([We(2,L.ILogService)],r),e.ExtHostSCM=r}),define(ye[98],Ce([1,0,5,3,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,D){return this.a.$setPassword(A,y,D)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[270],Ce([1,0,7,5,179,6,15,10]),function(te,e,a,t,T,R,I,A){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(v,m,h,f,p=a.StatusBarAlignment.Left,b){y.set(this,void 0),D.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Ye(this,y,v,"f"),Ye(this,D,m,"f"),this.c=L.a++,this.e=h,this.f=f,this.g=p,this.h=this.u(b)}u(v){if(!!(0,A.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!L.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof v=="string"?this.r={fromApi:v,internal:Ue(this,D,"f").toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:Ue(this,D,"f").toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let m;this.m?m=this.m:m=(0,T.localize)(0,null,this.e.displayName||this.e.name);let h=this.n;this.o&&(h=L.b.get(this.o.id));const f=I.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,v,m,this.k,f,this.r?.internal,h,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,D=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,T.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const m={message:v};return this.b.unshift(m),this.c(),new a.Disposable(()=>{const h=this.b.indexOf(m);h>=0&&(this.b.splice(h,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class w{constructor(v,m){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=m,this.c=new P(this)}createStatusBarEntry(v,m,h,f){return new L(this.a,this.b,v,m,h,f)}setStatusBarMessage(v,m){const h=this.c.setMessage(v);let f;return typeof m=="number"?f=setTimeout(()=>h.dispose(),m):typeof m<"u"&&m.then(()=>h.dispose(),()=>h.dispose()),new a.Disposable(()=>{h.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=w}),define(ye[99],Ce([1,0,5,3,4]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,D){const L=await this.a.$initializeExtensionStorage(A,y);let P;return L&&(P=this.d(A,y,L)),P||D}setValue(A,y,D){return this.a.$setValue(A,y,D)}$acceptValue(A,y,D){const L=this.d(A,y,D);L&&this.b.fire({shared:A,key:y,value:L})}d(A,y,D){try{return JSON.parse(D)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ye[76],Ce([1,0,4,25,13,75,2]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let A=class{constructor(D,L,P){this.d=L,this.f=P,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(D){return I.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,L=await this.g(D);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(I.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(D){if(this.c)return I.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return I.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([We(0,t.IExtHostInitDataService),We(1,T.ILogService),We(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[42],Ce([1,0,3,5,4,2,18,6,7,180,9,228,21,30,211,71,10,14,15]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class b{constructor(r,n,d,E){this.k=r,this._id=n,this.l=d,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(M=>this.f=M);const k=this;this.value={get name(){return k.m||""},get processId(){return k.b},get creationOptions(){return k.l},get exitStatus(){return k.h},get state(){return k.j},sendText(M,K=!0){k.o(),k.k.$sendText(k._id,M,K)},show(M){k.o(),k.k.$show(k._id,M)},hide(){k.o(),k.k.$hide(k._id)},dispose(){k.a||(k.a=!0,k.k.$dispose(k._id))},get dimensions(){if(!(k.d===void 0||k.g===void 0))return{columns:k.d,rows:k.g}}}}async create(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:(0,h.withNullAsUndefined)(r.shellPath),shellArgs:(0,h.withNullAsUndefined)(r.shellArgs),cwd:(0,h.withNullAsUndefined)(r.cwd),env:(0,h.withNullAsUndefined)(r.env),icon:(0,h.withNullAsUndefined)(l(r.iconPath)),color:m.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,h.withNullAsUndefined)(r.message),strictEnv:(0,h.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this.n(r.location,n?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,n,d,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:d,color:m.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(r,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,n){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in r?{viewColumn:p.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,n){this.h=Object.freeze({code:r,reason:n})}setDimensions(r,n){return r===this.d&&n===this.g||r===0||n===0?!1:(this.d=r,this.g=n,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(n=>{n!==r&&(this.b=Promise.resolve(r))})}}e.ExtHostTerminal=b;class S{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${n}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,n){this.g.setDimensions?.({columns:r,rows:n})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this.g.onDidWrite(n=>this.a.fire(n)),this.g.onDidClose?.((n=void 0)=>{this.f.fire(n===void 0?void 0:n)}),this.g.onDidOverrideDimensions?.(n=>{n&&this.d.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this.g.onDidChangeName?.(n=>{this.d.fire({type:"title",value:n})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:""})}}let g=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}get onDidWriteTerminalData(){return this.I.event}constructor(r,n){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=n.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[d,E]of this.g)E.shutdown(!0)}})}getDefaultShell(r){return(r?this.n:this.m)?.path||""}getDefaultShellArgs(r){return(r?this.n:this.m)?.args||[]}createExtensionTerminal(r,n){const d=new b(this.a,(0,C.generateUuid)(),r,r.name),E=new S(r.pty);return d.createExtensionTerminal(r.location,this.L(r,n).resolvedExtHostIdentifier,l(r.iconPath),c(r.color)).then(k=>{const M=this.M(k,E);this.h[k]=M}),this.f.push(d),d.value}L(r,n){if(n=n||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const d=r.location.parentTerminal;if(d){const E=this.f.find(k=>k.value===d);E&&(n.resolvedExtHostIdentifier=E._id)}}else r.location&&typeof r.location!="object"?n.location=r.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(r,n){if(!this.O(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const E=new S(n),k=this.M(r,E);this.h[r]=k}async $acceptActiveTerminalChanged(r){const n=this.b;if(r===null){this.b=void 0,n!==this.b&&this.F.fire(this.b);return}const d=this.O(r);d&&(this.b=d,n!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(r,n){const d=this.O(r);d&&this.I.fire({terminal:d.value,data:n})}async $acceptTerminalDimensions(r,n,d){const E=this.O(r);E&&E.setDimensions(n,d)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(r,n,d){this.g.get(r)?.resize(n,d)}async $acceptTerminalTitleChange(r,n){const d=this.O(r);d&&(d.name=n)}async $acceptTerminalClosed(r,n,d){const E=this.Q(this.f,r);if(E!==null){const k=this.f.splice(E,1)[0];k.setExitStatus(n,d),this.C.fire(k.value)}}$acceptTerminalOpened(r,n,d,E){if(n){const K=this.Q(this.f,n);if(K!==null){this.f[K]._id=r,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const k={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},M=new b(this.a,r,k,d);this.f.push(M),this.D.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(r,n){this.O(r)?._setProcessId(n)}async $startExtensionTerminal(r,n){const d=this.O(r);if(!d)return{message:(0,D.localize)(0,null,r)};d.isOpen||await new Promise(k=>{const M=this.onDidOpenTerminal(async K=>{K===d.value&&(M.dispose(),k())})});const E=this.g.get(r);E?E.startSendingEvents(n):this.j[r]={initialDimensions:n}}M(r,n){const d=new A.DisposableStore;d.add(n.onProcessReady(k=>this.a.$sendProcessReady(r,k.pid,k.cwd))),d.add(n.onDidChangeProperty(k=>this.a.$sendProcessProperty(r,k))),this.s.startBuffering(r,n.onProcessData),d.add(n.onProcessExit(k=>this.N(r,k))),this.g.set(r,n);const E=this.j[r];return E&&n instanceof S&&(n.startSendingEvents(E.initialDimensions),delete this.j[r]),d}$acceptProcessAckDataEvent(r,n){this.g.get(r)?.acknowledgeDataEvent(n)}$acceptProcessInput(r,n){this.g.get(r)?.input(n)}$acceptTerminalInteraction(r){const n=this.O(r);n?.setInteractedWith()&&this.H.fire(n.value)}$acceptProcessResize(r,n,d){try{this.g.get(r)?.resize(n,d)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(r,n){this.g.get(r)?.shutdown(n)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(n=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(n=>this.a.$sendProcessProperty(r,{type:"cwd",value:n}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.u.add(r),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(r),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,n,d){if(this.v.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this.v.set(n,d),this.a.$registerProfileProvider(n,r.identifier.value),new y.Disposable(()=>{this.v.delete(n),this.a.$unregisterProfileProvider(n)})}registerTerminalQuickFixProvider(r,n,d){if(this.w.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.w.set(r,d),this.a.$registerQuickFixProvider(r,n),new y.Disposable(()=>{this.w.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,n){const d=new w.CancellationTokenSource().token;if(d.isCancellationRequested)return;const E=this.w.get(r);if(!E)return;const k=await E.provideTerminalQuickFixes(n,d);if(k!==null)return k}async $createContributedProfileTerminal(r,n){const d=new w.CancellationTokenSource().token;let E=await this.v.get(r)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,n);return}this.createTerminalFromOptions(E.options,n)}}async $provideLinks(r,n){const d=this.O(r);if(!d)return[];this.y.delete(r),this.z.get(r)?.dispose(!0);const k=new w.CancellationTokenSource;this.z.set(r,k);const M=[],K={terminal:d.value,line:n},q=[];for(const O of this.u)q.push(f.Promises.withAsyncBody(async U=>{k.token.onCancellationRequested(()=>U({provider:O,links:[]}));const $=await O.provideTerminalLinks(K,k.token)||[];k.token.isCancellationRequested||U({provider:O,links:$})}));const F=await Promise.all(q);if(k.token.isCancellationRequested)return[];const B=new Map;for(const O of F)O&&O.links.length>0&&M.push(...O.links.map(U=>{const $={id:g++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set($.id,{provider:O.provider,link:U}),$}));return this.y.set(r,B),M}$activateLink(r,n){const d=this.y.get(r)?.get(n);!d||d.provider.handleTerminalLink(d.link)}N(r,n){this.s.stopBuffering(r),this.g.delete(r),delete this.j[r];const d=this.h[r];d&&(d.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,n)}O(r){return this.P(this.f,r)}P(r,n){const d=this.Q(r,n);return d!==null?r[d]:null}Q(r,n){let d=null;return r.some((E,k)=>E._id===n?(d=k,!0):!1),d}getEnvironmentVariableCollection(r){let n=this.l.get(r.identifier.value);return n||(n=new s,this.S(r.identifier.value,n)),n}R(r,n){const d=(0,P.serializeEnvironmentVariableCollection)(n.map);this.a.$setEnvironmentVariableCollection(r,n.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(r){r.forEach(n=>{const d=n[0],E=new s(n[1]);this.S(d,E)})}$acceptDefaultProfile(r,n){const d=this.m;this.m=r,this.n=n,d?.path!==r.path&&this.J.fire(r.path)}S(r,n){this.l.set(r,n),n.onDidChangeCollection(()=>{this.R(r,n)})}};i=qe([We(1,I.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class s{get persistent(){return this.a}set persistent(r){this.a=r,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(r){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,n){this.d(r,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(r,n){this.d(r,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(r,n){this.d(r,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}d(r,n){const d=this.map.get(r);(!d||d.value!==n.value||d.type!==n.type)&&(this.map.set(r,n),this.b.fire())}get(r){return this.map.get(r)}forEach(r,n){this.map.forEach((d,E)=>r.call(n,E,d,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let o=class extends i{constructor(r){super(!1,r)}createTerminal(r,n,d){throw new L.NotSupportedError}createTerminalFromOptions(r,n){throw new L.NotSupportedError}};o=qe([We(0,I.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function l(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function c(u){return m.ThemeColor.isThemeColor(u)?u:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)},Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a};define(ye[271],Ce([1,0,16,14,23,21,3,63,86,6,22,10,30,5,18,137,15,7,57,93,73,26]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(O,U,$){this.j=$,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(C.MainContext.MainThreadTesting),this.h=new K(this.f),this.g=new r(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const ue=j,V=ue.tests[ue.tests.length-1].item.extId;return this.d.get(p.TestId.root(V))?.collection.tree.get(V)?.actual??(0,m.toItemFromContext)(j)}})}createTestController(O,U,$,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const ue=new D.DisposableStore,V=ue.add(new m.ExtHostTestItemCollection(U,$,this.j));V.root.label=$;const _=new Map,Y=this.f,ne={items:V.root.children,get label(){return $},set label(X){$=X,V.root.label=X,Y.$updateController(U,{label:$})},get refreshHandler(){return j},set refreshHandler(X){j=X,Y.$updateController(U,{canRefresh:!!X})},get id(){return U},createRunProfile:(X,G,de,be,Ee,Pe)=>{let Fe=(0,y.hash)(X);for(;_.has(Fe);)Fe++;return Pe!==void 0&&(0,g.checkProposedApiEnabled)(O,"testContinuousRun"),new q(this.f,_,U,Fe,X,G,de,be,Ee,Pe)},createTestItem(X,G,de){return new m.TestItemImpl(U,X,G,de)},createTestRun:(X,G,de=!0)=>this.g.createTestRun(U,V,X,G,de),set resolveHandler(X){V.resolveHandler=X},get resolveHandler(){return V.resolveHandler},dispose:()=>{ue.dispose()}};Y.$registerTestController(U,$,!!j),ue.add((0,D.toDisposable)(()=>Y.$unregisterTestController(U)));const ee={controller:ne,collection:V,profiles:_};return this.d.set(U,ee),ue.add((0,D.toDisposable)(()=>this.d.delete(U))),ue.add(V.onDidGenerateDiff(X=>Y.$publishDiff(U,X.map(S.TestsDiffOp.serialize)))),ne}createTestObserver(){return this.h.checkout()}async runTests(O,U=R.CancellationToken.None){const $=n(O);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get($.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(ue=>p.TestId.fromExtHostTestItem(ue,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:F[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:O.exclude?.map(ue=>ue.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,$){return(0,a.mapFind)(this.g.trackers,ue=>ue.id===O?ue.getCoverage(U):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(O,U,$,j){return(0,a.mapFind)(this.g.trackers,V=>V.id===O?V.getCoverage(U):void 0)?.resolveFileCoverage($,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(h.TestResults.to(U))).concat(this.results).sort((U,$)=>$.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const $=this.d.get(p.TestId.fromString(O).controllerId)?.collection;$&&(await $.expand(O,U<0?1/0:U),$.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(S.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map($=>this.k($,!1,U)))}async $startContinuousRun(O,U){const $=new R.CancellationTokenSource(U),j=await Promise.all(O.map(ue=>this.k(ue,!0,$.token)));return!U.isCancellationRequested&&!j.some(ue=>ue.error)&&await new Promise(ue=>U.onCancellationRequested(ue)),$.dispose(!0),j}async k(O,U,$){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:ue,profiles:V}=j,_=V.get(O.profileId);if(!_)return{};const Y=O.testIds.map(G=>ue.tree.get(G)).filter(P.isDefined),ne=O.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(P.isDefined).filter(G=>Y.some(de=>de.fullId.compare(G.fullId)===2));if(!Y.length)return{};const ee=new f.TestRunRequest2(Y.some(G=>G.actual instanceof m.TestItemRootImpl)?void 0:Y.map(G=>G.actual),ne.map(G=>G.actual),_,U),X=(0,S.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(ee,d.fromInternal(O,j.collection),$);try{return await _.runHandler(ee,$),{}}catch(G){return{error:String(G)}}finally{X&&(X.hasRunningTasks&&!$.isCancellationRequested&&await I.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};o=qe([We(0,v.IExtHostRpcService)],o),e.ExtHostTesting=o;const l=1e4;var c;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(c||(c={}));class u extends D.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,$){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource($));const j=this.B(new t.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,$=this.k.controllerId,j=(0,w.generateUuid)(),ue=new E(this.l,U,j),V=ee=>(X,...G)=>{if(Y){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),ee(X,...G))},_=(ee,X)=>{const G=X instanceof Array?X.map(h.TestMessage.from):[h.TestMessage.from(X)];if(ee.uri&&ee.range){const de={range:h.Range.from(ee.range),uri:ee.uri};for(const be of G)be.location=be.location||de}this.l.$appendTestMessagesInRun(U,j,p.TestId.fromExtHostTestItem(ee,$).toString(),G)};let Y=!1;const ne={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return ue.coverageProvider},set coverageProvider(ee){ue.coverageProvider=ee},enqueued:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,$).toString(),1)}),skipped:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,$).toString(),5)}),started:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,$).toString(),2)}),errored:V((ee,X,G)=>{_(ee,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,$).toString(),6,G)}),failed:V((ee,X,G)=>{_(ee,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,$).toString(),4,G)}),passed:V((ee,X)=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,X)}),appendOutput:(ee,X,G)=>{Y||(G&&(this.k.isIncluded(G)?this.s(G):G=void 0),this.l.$appendOutputToRun(U,j,T.VSBuffer.fromString(ee),X&&h.location.from(X),G&&p.TestId.fromExtHostTestItem(G,$).toString()))},end:()=>{Y||(Y=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ne,coverage:ue}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),ne}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof m.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.g.has(p.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],$=this.k.colllection.root;for(;;){const j=h.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===$))break;O=O.parent||$}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class r{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,$){return this.f(O,U,$)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,$,j,ue){const V=this.c.get($);if(V)return V.createRun(j);const _=d.fromPublic(O,U,$,ue),Y=n($);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!$.continuous,profile:Y&&{group:F[Y.kind],id:Y.profileId},exclude:$.exclude?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[],id:_.id,include:$.include?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[U.root.id],persist:ue});const ne=this.f($,_);return ne.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),ne.dispose()}),ne.createRun(j)}f(O,U,$){const j=new u(U,this.d,$);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=r;const n=B=>{if(!!B.profile){if(!(B.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class d{static fromPublic(O,U,$,j){return new d(O,(0,w.generateUuid)(),$.include?.map(ue=>p.TestId.fromExtHostTestItem(ue,O).toString())??[O],$.exclude?.map(ue=>p.TestId.fromExtHostTestItem(ue,O).toString())??[],j,U)}static fromInternal(O,U){return new d(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,$,j,ue,V){this.controllerId=O,this.id=U,this.isPersisted=ue,this.colllection=V,this.c=$.map(_=>_+"\0"),this.d=j.map(_=>_+"\0")}isIncluded(O){const U=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const $ of this.d)if(U===$||U.startsWith($))return!1;for(const $ of this.c)if(U===$||U.startsWith($))return!0;return!1}}e.TestRunDto=d;class E{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,$){this.f=O,this.g=U,this.h=$}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const $=await this.d;let j=$?.[O];return!this.c||!$||!j?[]:(j.detailedCoverage||(j=$[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class k{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,h.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=p.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:$}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...$].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class M extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:h.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new k(this.q)}}class K{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,A.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new M;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class q{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?h.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,$,j,ue,V,_,Y=!1,ne=void 0,ee=!1){this.controllerId=$,this.profileId=j,this.d=ue,this.kind=V,this.runHandler=_,this.f=Y,this._tag=ne,this.g=ee,i.set(this,void 0),s.set(this,void 0),Ye(this,i,O,"f"),Ye(this,s,U,"f"),U.set(j,this);const X=F[V];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Ue(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:$,tag:ne?h.TestTag.namespace(this.controllerId,ne.id):null,label:ue,group:X,isDefault:Y,hasConfigurationHandler:!1,supportsContinuousRun:ee})}dispose(){Ue(this,s,"f")?.delete(this.profileId)&&(Ye(this,s,void 0,"f"),Ue(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,i=new WeakMap,s=new WeakMap;const F={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ye[272],Ce([1,0,16,3,5,138,15,7]),function(te,e,a,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(T.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(w=>w.value)}async showTextDocument(L,P,w){let C;typeof P=="number"?C={position:I.ViewColumn.from(P),preserveFocus:w}:typeof P=="object"?C={position:I.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?I.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:C={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(L.uri,C),m=v&&this.i.getEditor(v);if(m)return m.value;throw v?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new R.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const w=this.i.getEditor(L);if(!w)throw new Error("unknown text editor");if(P.options&&w._acceptOptions(P.options),P.selections){const C=P.selections.selections.map(I.Selection.to);w._acceptSelections(C)}if(P.visibleRanges){const C=a.coalesce(P.visibleRanges.map(I.Range.to));w._acceptVisibleRanges(C)}if(P.options&&this.b.fire({textEditor:w.value,options:{...P.options,lineNumbers:I.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const C=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(I.Selection.to);this.a.fire({textEditor:w.value,selections:v,kind:C})}if(P.visibleRanges){const C=a.coalesce(P.visibleRanges.map(I.Range.to));this.c.fire({textEditor:w.value,visibleRanges:C})}}$acceptEditorPositionData(L){for(const P in L){const w=this.i.getEditor(P);if(!w)throw new Error("Unknown text editor");const C=I.ViewColumn.to(L[P]);w.value.viewColumn!==C&&(w._acceptViewColumn(C),this.d.fire({textEditor:w.value,viewColumn:C}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ye[273],Ce([1,0,2,4,5,6,7,15,27,10]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class L{constructor(C,v){this.b=new Map,this.c=new Map,this.a=C.getProxy(T.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(m,h)=>{if(m&&m.$mid===12)if(this.b.get(m.source)&&y.ExtensionIdentifier.equals(h,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:a.URI.revive(m.uri);return this.c.get(m.source)?.get(P(f))?.get(m.handle)}else return;return m}})}async $getTimeline(C,v,m,h){return this.b.get(C)?.provider.provideTimeline(a.URI.revive(v),m,h)}registerTimelineProvider(C,v,m,h){const f=new R.DisposableStore,p=this.d(v.id,h,f).bind(this);let b;v.onDidChange&&(b=v.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:v.id}),this));const S=this.c;return this.f({...v,scheme:C,onDidChange:void 0,async provideTimeline(g,i,s){i?.resetCache&&(f.clear(),S.get(v.id)?.clear());const o=await v.provideTimeline(g,i,s);if(o==null)return;const l=p(g,i);return{...o,source:v.id,items:o.items.map(l)}},dispose(){for(const g of S.values())g.get(v.id)?.clear();b?.dispose(),f.dispose()}},m)}d(C,v,m){return(h,f)=>{let p;if(f?.cacheResults){let b=this.c.get(C);b===void 0&&(b=new Map,this.c.set(C,b));const S=P(h);p=b.get(S),p===void 0&&(p=new Map,b.set(S,p))}return b=>{const{iconPath:S,...g}=b,i=`${C}|${b.id??b.timestamp}`;p?.set(i,b);let s,o,l;b.iconPath&&(S instanceof I.ThemeIcon?l={id:S.id,color:S.color}:a.URI.isUri(S)?(s=S,o=S):{light:s,dark:o}=S);let c;return I.MarkdownString.isMarkdownString(g.tooltip)?c=A.MarkdownString.from(g.tooltip):(0,D.isString)(g.tooltip)?c=g.tooltip:I.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=A.MarkdownString.from(g.detail)):(0,D.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=g.detail),{...g,id:g.id??void 0,handle:i,source:C,command:b.command?v.toInternal(b.command,m):void 0,icon:s,iconDark:o,themeIcon:l,tooltip:c,accessibilityInformation:b.accessibilityInformation}}}}f(C,v){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:v}),(0,R.toDisposable)(()=>{for(const h of this.c.values())h.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=L;function P(w){return w?.toString()}}),define(ye[274],Ce([1,0,6,17,2,5]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,D,L,P){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const w=P.schemes.find(C=>!I.a.has(C));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(D,L),this.b.$registerUriOpener(D,P.schemes,y,P.label),(0,a.toDisposable)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const w=T.URI.revive(D);return P.canOpenExternalUri(w,L)}async $openUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(T.URI.revive(D.resolvedUri),{sourceUri:T.URI.revive(D.sourceUri)},L)}}e.ExtHostUriOpeners=I,I.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[275],Ce([1,0,5,2,6,9,27]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(D){this.c=new Set,this.d=new Map,this.b=D.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(D,L){if(this.c.has(I.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const P=A.a++;return this.c.add(I.ExtensionIdentifier.toKey(D)),this.d.set(P,L),this.b.$registerUriHandler(P,D),(0,T.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(D)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(D,L){const P=this.d.get(D);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(w){(0,R.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this.b.$createAppUri(D))}}e.ExtHostUrls=A,A.a=0});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[77],Ce([1,0,3,17,22,2,196,219,94,5]),function(te,e,a,t,T,R,I,A,y,D){"use strict";var L,P,w,C,v,m,h,f,p,b,S,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(k,M,K,q,F,B,O){L.set(this,void 0),P.set(this,void 0),w.set(this,void 0),C.set(this,void 0),v.set(this,void 0),m.set(this,void 0),h.set(this,""),f.set(this,void 0),p.set(this,!1),b.set(this,!1),S.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new a.Emitter),this._onDidDispose=Ue(this,i,"f").event,Ye(this,L,k,"f"),Ye(this,P,M,"f"),Ye(this,f,K,"f"),Ye(this,C,q,"f"),Ye(this,v,F,"f"),Ye(this,m,B,"f"),Ye(this,S,o(B),"f"),Ye(this,g,l(B),"f"),Ye(this,w,O,"f")}dispose(){Ye(this,p,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(k){return Ye(this,b,!0,"f"),(0,y.asWebviewUri)(k,Ue(this,C,"f"))}get cspSource(){const k=Ue(this,m,"f").extensionLocation;if(k.scheme===t.Schemas.https||k.scheme===t.Schemas.http){let M=k.toString();return M.endsWith("/")||(M+="/"),M+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,h,"f")}set html(k){this.a(),Ue(this,h,"f")!==k&&(Ye(this,h,k,"f"),Ue(this,g,"f")&&!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(k)&&(Ye(this,b,!0,"f"),Ue(this,w,"f").report("Webview vscode-resource: uris",Ue(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,L,"f"),this.b(k)))}get options(){return this.a(),Ue(this,f,"f")}set options(k){this.a(),T.equals(Ue(this,f,"f"),k)||Ue(this,P,"f").$setOptions(Ue(this,L,"f"),r(Ue(this,m,"f"),Ue(this,v,"f"),k)),Ye(this,f,k,"f")}async postMessage(k){if(Ue(this,p,"f"))return!1;const M=(0,A.serializeWebviewMessage)(k,{serializeBuffersForPostMessage:Ue(this,S,"f")});return Ue(this,P,"f").$postMessage(Ue(this,L,"f"),M.message,...M.buffers)}a(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}b(k){if(!Ue(this,g,"f"))return k;const M=Ue(this,m,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,K=Ue(this,m,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,m,"f").extensionLocation.authority:void 0;return k.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,F,B,O,U,$)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),ue=(0,y.asWebviewUri)(j,{isRemote:M,authority:K}).toString();return`${F}${ue}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,F,B,O,U,$)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),ue=(0,y.asWebviewUri)(j,{isRemote:M,authority:K}).toString();return`${F}${ue}${$}`})}}e.ExtHostWebview=s,L=new WeakMap,P=new WeakMap,w=new WeakMap,C=new WeakMap,v=new WeakMap,m=new WeakMap,h=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,S=new WeakMap,g=new WeakMap,i=new WeakMap;function o(E){try{const k=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return!!k&&k.majorBase>=1&&k.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function l(E){try{const k=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return k?k.majorBase<1||k.majorBase===1&&k.minorBase<60:!1}catch{return!1}}class c{constructor(k,M,K,q,F){this.c=M,this.d=K,this.e=q,this.f=F,this.b=new Map,this.a=k.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(k,M,K){const q=this.g(k);if(q){const{message:F}=(0,A.deserializeWebviewMessage)(M,K.value);q._onMessageEmitter.fire(F)}}$onMissingCsp(k,M){this.e.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(k,M,K){const q=new s(k,this.a,n(M),this.c,this.d,K,this.f);return this.b.set(k,q),q._onDidDispose(()=>{this.b.delete(k)}),q}deleteWebview(k){this.b.delete(k)}g(k){return this.b.get(k)}}e.ExtHostWebviews=c;function u(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=u;function r(E,k,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||d(E,k)}}e.serializeWebviewOptions=r;function n(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(k=>R.URI.from(k))}}function d(E,k){return[...(k?.getWorkspaceFolders()||[]).map(M=>M.uri),E.extensionLocation]}}),define(ye[276],Ce([1,0,21,86,6,17,24,2,15,77,72,5,7]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(s,o){this.document=s,this.b=o,this.a=1,this.c=new L.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,o){await this.f(s).undo(),o||this.disposeBackup()}async redo(s,o){await this.f(s).redo(),o||this.disposeBackup()}disposeEdits(s){for(const o of s)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=g(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const o=this.c.get(s,0);if(!o)throw new Error("No edit found");return o}}class v{constructor(){this.a=new Map}get(s,o){return this.a.get(this.b(s,o))}add(s,o,l){const c=this.b(s,o.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${s} resource:${o.uri}`);const u=new C(o,l);return this.a.set(c,u),u}delete(s,o){const l=this.b(s,o.uri);this.a.delete(l)}b(s,o){return`${s}@@@${o}`}}var m;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(m||(m={}));class h{constructor(){this.a=new Map}addTextProvider(s,o,l){return this.b(0,s,o,l)}addCustomProvider(s,o,l){return this.b(1,s,o,l)}get(s){return this.a.get(s)}b(s,o,l,c){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:s,extension:l,provider:c}),new w.Disposable(()=>this.a.delete(o))}}class f{constructor(s,o,l,c,u){this.d=o,this.f=l,this.g=c,this.h=u,this.b=new h,this.c=new v,this.a=s.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,o,l,c){const u=new T.DisposableStore;return b(l)?(u.add(this.b.addTextProvider(o,s,l)),this.a.$registerTextEditorProvider((0,D.toExtensionData)(s),o,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(s))):(u.add(this.b.addCustomProvider(o,s,l)),p(l)&&u.add(l.onDidChangeCustomDocument(r=>{const n=this.i(o,r.document.uri);if(S(r)){const d=n.addEdit(r);this.a.$onDidEdit(r.document.uri,o,d,r.label)}else this.a.$onContentChange(r.document.uri,o)})),this.a.$registerCustomEditorProvider((0,D.toExtensionData)(s),o,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(s))),w.Disposable.from(u,new w.Disposable(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(s,o,l,c,u){const r=this.b.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${o}'`);const n=A.URI.revive(s),d=await r.provider.openCustomDocument(n,{backupId:l,untitledDocumentData:c?.buffer},u);let E;return p(r.provider)&&this.f&&(E=this.f.workspaceValue(r.extension)??this.f.globalValue(r.extension)),this.c.add(o,d,E),{editable:p(r.provider)}}async $disposeCustomDocument(s,o){const l=this.b.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${o}'`);const c=A.URI.revive(s),{document:u}=this.i(o,c);this.c.delete(o,u),u.dispose()}async $resolveCustomEditor(s,o,l,c,u,r){console.log("xxxx");const n=this.b.get(l);if(!n)throw new Error(`No provider found for '${l}'`);const d=y.ViewColumn.to(u),E=this.g.createNewWebview(o,c.contentOptions,n.extension),k=this.h.createNewWebviewPanel(o,l,c.title,d,c.options,E,!0),M=A.URI.revive(s);switch(n.type){case 1:{const{document:K}=this.i(l,M);return n.provider.resolveCustomEditor(K,k,r)}case 0:{const K=this.d.getDocument(M);return n.provider.resolveCustomTextEditor(K,k,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,o,l){this.i(o,s).disposeEdits(l)}async $onMoveCustomEditor(s,o,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const u=this.h.getWebviewPanel(s);if(!u)throw new Error("No webview found");const r=A.URI.revive(o),n=this.d.getDocument(r);await c.provider.moveCustomTextEditor(n,u,a.CancellationToken.None)}async $undo(s,o,l,c){return this.i(o,s).undo(l,c)}async $redo(s,o,l,c){return this.i(o,s).redo(l,c)}async $revert(s,o,l){const c=this.i(o,s);await this.j(o).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(s,o,l){const c=this.i(o,s);await this.j(o).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(s,o,l,c){const u=this.i(o,s);return this.j(o).saveCustomDocumentAs(u.document,A.URI.revive(l),c)}async $backup(s,o,l){const c=this.i(o,s),r=await this.j(o).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(r),r.id}i(s,o){const l=this.c.get(s,A.URI.revive(o));if(!l)throw new Error("No custom document found");return l}j(s){const l=this.b.get(s)?.provider;if(!l||!p(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=f;function p(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function S(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function g(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(s)+""}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[277],Ce([1,0,3,6,2,30,15,77,5,7]),function(te,e,a,t,T,R,I,A,y,D){"use strict";var L,P,w,C,v,m,h,f,p,b,S,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends t.Disposable{constructor(u,r,n,d){super(),L.set(this,void 0),P.set(this,void 0),w.set(this,void 0),C.set(this,void 0),v.set(this,void 0),m.set(this,void 0),h.set(this,void 0),f.set(this,void 0),p.set(this,!0),b.set(this,void 0),S.set(this,!1),g.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,g,"f").event,i.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Ye(this,L,u,"f"),Ye(this,P,r,"f"),Ye(this,C,n,"f"),Ye(this,w,d.viewType,"f"),Ye(this,v,d.panelOptions,"f"),Ye(this,f,d.viewColumn,"f"),Ye(this,m,d.title,"f"),Ye(this,b,d.active,"f")}dispose(){Ue(this,S,"f")||(Ye(this,S,!0,"f"),Ue(this,g,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,C,"f")}get viewType(){return this.c(),Ue(this,w,"f")}get title(){return this.c(),Ue(this,m,"f")}set title(u){this.c(),Ue(this,m,"f")!==u&&(Ye(this,m,u,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),u))}get iconPath(){return this.c(),Ue(this,h,"f")}set iconPath(u){this.c(),Ue(this,h,"f")!==u&&(Ye(this,h,u,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),T.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Ue(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.c(),Ue(this,b,"f")}get visible(){return this.c(),Ue(this,p,"f")}_updateViewState(u){Ue(this,S,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ye(this,b,u.active,"f"),Ye(this,p,u.visible,"f"),Ye(this,f,u.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(u,r){this.c(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof u>"u"?void 0:I.ViewColumn.from(u),preserveFocus:!!r})}c(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,w=new WeakMap,C=new WeakMap,v=new WeakMap,m=new WeakMap,h=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,S=new WeakMap,g=new WeakMap,i=new WeakMap;class o{static c(){return(0,R.generateUuid)()}constructor(u,r,n){this.g=r,this.h=n,this.e=new Map,this.f=new Map,this.d=u.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,r,n,d,E={}){const k=typeof d=="object"?d.viewColumn:d,M={viewColumn:I.ViewColumn.from(k),preserveFocus:typeof d=="object"&&!!d.preserveFocus},K=(0,A.shouldSerializeBuffersForPostMessage)(u),q=o.c();this.d.$createWebviewPanel((0,A.toExtensionData)(u),q,r,{title:n,panelOptions:l(E),webviewOptions:(0,A.serializeWebviewOptions)(u,this.h,E),serializeBuffersForPostMessage:K},M);const F=this.g.createNewWebview(q,E,u);return this.createNewWebviewPanel(q,r,n,k,E,F,!0)}$onDidChangeWebviewPanelViewStates(u){const r=Object.keys(u);r.sort((n,d)=>{const E=u[n],k=u[d];return E.active?1:k.active?-1:+E.visible-+k.visible});for(const n of r){const d=this.getWebviewPanel(n);if(!d)continue;const E=u[n];d._updateViewState({active:E.active,visible:E.visible,viewColumn:I.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,r,n){if(this.f.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.f.set(r,{serializer:n,extension:u}),this.d.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(u)}),new D.Disposable(()=>{this.f.delete(r),this.d.$unregisterSerializer(r)})}async $deserializeWebviewPanel(u,r,n,d){const E=this.f.get(r);if(!E)throw new Error(`No serializer found for '${r}'`);const{serializer:k,extension:M}=E,K=this.g.createNewWebview(u,n.webviewOptions,M),q=this.createNewWebviewPanel(u,r,n.title,d,n.panelOptions,K,n.active);await k.deserializeWebviewPanel(q,n.state)}createNewWebviewPanel(u,r,n,d,E,k,M){const K=new s(u,this.d,k,{viewType:r,title:n,viewColumn:d,panelOptions:E,active:M});return this.e.set(u,K),K}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=o;function l(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[278],Ce([1,0,3,6,77,15,5,7]),function(te,e,a,t,T,R,I,A){"use strict";var y,D,L,P,w,C,v,m,h,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends t.Disposable{constructor(i,s,o,l,c,u){super(),y.set(this,void 0),D.set(this,void 0),L.set(this,void 0),P.set(this,void 0),w.set(this,!1),C.set(this,void 0),v.set(this,void 0),m.set(this,void 0),h.set(this,void 0),f.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,p.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,p,"f").event,Ye(this,L,o,"f"),Ye(this,v,l,"f"),Ye(this,y,i,"f"),Ye(this,D,s,"f"),Ye(this,P,c,"f"),Ye(this,C,u,"f")}dispose(){Ue(this,w,"f")||(Ye(this,w,!0,"f"),Ue(this,p,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,v,"f")}set title(i){this.a(),Ue(this,v,"f")!==i&&(Ye(this,v,i,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,y,"f"),i))}get description(){return this.a(),Ue(this,m,"f")}set description(i){this.a(),Ue(this,m,"f")!==i&&(Ye(this,m,i,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,y,"f"),i))}get visible(){return Ue(this,C,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(i){i===Ue(this,C,"f")||Ue(this,w,"f")||(Ye(this,C,i,"f"),Ue(this,f,"f").fire())}get badge(){return this.a(),Ue(this,h,"f")}set badge(i){this.a(),!(i?.value===Ue(this,h,"f")?.value&&i?.tooltip===Ue(this,h,"f")?.tooltip)&&(Ye(this,h,R.ViewBadge.from(i),"f"),Ue(this,D,"f").$setWebviewViewBadge(Ue(this,y,"f"),i))}show(i){this.a(),Ue(this,D,"f").$show(Ue(this,y,"f"),!!i)}a(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,D=new WeakMap,L=new WeakMap,P=new WeakMap,w=new WeakMap,C=new WeakMap,v=new WeakMap,m=new WeakMap,h=new WeakMap,f=new WeakMap,p=new WeakMap;class S{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,o,l){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:o,extension:i}),this.a.$registerWebviewViewProvider((0,T.toExtensionData)(i),s,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,o,l,c){const u=this.b.get(s);if(!u)throw new Error(`No view provider found for '${s}'`);const{provider:r,extension:n}=u,d=this.d.createNewWebview(i,{},n),E=new b(i,this.a,s,o,d,!0);this.c.set(i,E),await r.resolveWebviewView(E,{state:l},c)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=S}),define(ye[141],Ce([1,0,3,5,2,17,8,4,18]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class si{get state(){return this.d}constructor(P){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=si.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,w){let C;if(typeof P=="string"){C=P;try{P=T.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,I.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,C,w)}async asExternalUri(P,w){if((0,I.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(P,w);return T.URI.from(C)}};D.a={focused:!0},D=qe([We(0,y.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[279],Ce([1,0,119,280,67,41,2,13,47]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(w,C,v){this.b=w,this.c=C,this.f=v,this.a=t.createServer((m,h)=>this.h(m,h)),this.g().catch(m=>(C.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,C){const v=(h,f)=>{C.writeHead(h,{"content-type":"application/json"}),C.end(JSON.stringify(f||null),p=>p&&this.c.error(p))},m=[];w.setEncoding("utf8"),w.on("data",h=>m.push(h)),w.on("end",async()=>{try{const h=JSON.parse(m.join(""));let f;switch(h.type){case"open":f=await this.i(h);break;case"openExternal":f=await this.j(h);break;case"status":f=await this.l(h);break;case"extensionManagement":f=await this.k(h);break;default:v(404,`Unknown message type: ${h.type}`);break}v(200,f)}catch(h){const f=h instanceof Error?h.message:JSON.stringify(h);v(500,f),this.c.error("Error while processing pipe request",h)}})}async i(w){const{fileURIs:C,folderURIs:v,forceNewWindow:m,diffMode:h,mergeMode:f,addMode:p,forceReuseWindow:b,gotoLineMode:S,waitMarkerFilePath:g,remoteAuthority:i}=w,s=[];if(Array.isArray(v))for(const u of v)try{s.push({folderUri:I.URI.parse(u)})}catch{}if(Array.isArray(C))for(const u of C)try{(0,y.hasWorkspaceFileExtension)(u)?s.push({workspaceUri:I.URI.parse(u)}):s.push({fileUri:I.URI.parse(u)})}catch{}const o=g?I.URI.file(g):void 0,c={forceNewWindow:m,diffMode:h,mergeMode:f,addMode:p,gotoLineMode:S,forceReuseWindow:b,preferNewWindow:!b&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",s,c),""}async j(w){for(const C of w.uris){const v=I.URI.parse(C),m=v.scheme==="file"?v:C;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(w){const C=m=>m?.map(h=>/\.vsix$/i.test(h)?I.URI.parse(h):h),v={list:w.list,install:C(w.install),uninstall:C(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&T.existsSync(this.f)&&T.unlinkSync(this.f)}}e.CLIServerBase=D;let L=class extends D{constructor(w,C){super(w,C,(0,a.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,A.ILogService)],L),e.CLIServer=L}),define(ye[281],Ce([1,0,252,25,18]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let I=class extends a.AbstractExtHostConsoleForwarder{constructor(y,D){super(y,D),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,D,L){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),D.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,D){const L=process[y],P=L.write;let w="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(C,v,m)=>{if(!this.g){w+=C.toString(v);const h=w.length>R?w.length:w.lastIndexOf(`
`);h!==-1&&(console[D](w.slice(0,h)),w=w.slice(h+1))}P.call(L,C,v,m)}})}};I=qe([We(0,T.IExtHostRpcService),We(1,t.IExtHostInitDataService)],I),e.ExtHostConsoleForwarder=I}),define(ye[282],Ce([1,0,11,88,30,41,6,5,2,18]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends I.Disposable{constructor(w,C){super();const v=w.getProxy(A.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async m=>{const h=y.URI.file((0,a.join)((0,t.tmpdir)(),(0,T.generateUuid)()));return await v.$download(m,h),h})}};L=qe([We(0,D.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[283],Ce([1,0,140,17,202,30]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class I extends a.ExtHostLoggerService{f(y,D,L){return y.scheme===t.Schemas.file?new T.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,D):super.f(y,D,L)}}e.ExtHostLoggerService=I}),define(ye[284],Ce([1,0,67,11,2,76,6,17,14,29]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==A.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const o=s.fsPath;let l=0;do{let c;l===0?c=o:c=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${l}`:`${o}-${l}`,await P(c);const u=t.join(c,"vscode.lock"),r=await m(this.d,u,!1);if(r)return this.i=r,process.on("exit",()=>{r.dispose()}),T.URI.file(c);l++}while(l<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(g){try{await D.Promises.stat(g);return}catch{}try{await D.Promises.mkdir(g,{recursive:!0})}catch{}}const w=1e3,C=10*60*1e3;class v extends I.Disposable{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const o=await h(i,s);(!o||o.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await D.Promises.utimes(s,new Date,new Date)}catch(l){i.error(l),i.info(`Lock '${s}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await D.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function m(g,i,s){try{const l={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(i,JSON.stringify(l),{flag:"wx"})}catch(l){g.error(l)}const o=await h(g,i);return!o||o.pid!==process.pid?s?(g.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),b(g,i)):(g.info(`Lock '${i}': Lock acquired.`),new v(g,i))}async function h(g,i){let s;try{s=await D.Promises.readFile(i)}catch(o){return g.error(o),null}try{return JSON.parse(String(s))}catch(o){return g.error(o),null}}async function f(g,i){let s;try{s=await D.Promises.stat(i)}catch(o){return g.error(o),0}return s.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function b(g,i){const s=await h(g,i);if(!s)return g.info(`Lock '${i}': Could not read pid of lock holder.`),S(g,i);if(s.willReleaseAt){let r=s.willReleaseAt-Date.now();if(r<5e3){for(r>0?g.info(`Lock '${i}': The lockfile is scheduled to be released in ${r} ms.`):g.info(`Lock '${i}': The lockfile is scheduled to have been released.`);r>0;){if(await(0,y.timeout)(Math.min(100,r)),await f(g,i)===0)return S(g,i);r=s.willReleaseAt-Date.now()}return S(g,i)}}if(!p(s.pid))return g.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),S(g,i);const o=await f(g,i),l=Date.now()-o;if(l<=C)return g.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;g.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const c=await f(g,i),u=Date.now()-c;return u<=C?(g.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(g.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),S(g,i))}async function S(g,i){g.info(`Lock '${i}': Deleting a stale lock.`);try{await D.Promises.unlink(i)}catch{}return m(g,i,!0)}}),define(ye[285],Ce([1,0,30,18,42]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends T.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,D){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:D})}createTerminalFromOptions(A,y){const D=new T.ExtHostTerminal(this.a,(0,a.generateUuid)(),A,A.name);return this.f.push(D),D.create(A,this.L(A,y)),D.value}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[286],Ce([1,0,5,18,184,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class p extends m.DisposableTunnel{}function b(r){const n=r.trim().split(`
`),d=[];return n.forEach(k=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(k);M&&M.length>=3&&d.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),d.reduce((k,M)=>(k[M.socket]=M,k),{})}e.getSockets=b;function S(...r){const n=[].concat(...r.map(i));return[...new Map(n.filter(d=>d.st==="0A").map(d=>{const E=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:g(E[0]),port:parseInt(E[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=S;function g(r){let n="";if(r.length===8)for(let d=r.length-2;d>=0;d-=2)n+=parseInt(r.substr(d,2),16),d!==0&&(n+=".");else for(let d=r.length-4;d>=0;d-=4)n+=parseInt(r.substr(d,4),16).toString(16),d!==0&&(n+=":");return n}function i(r){const n=r.trim().split(`
`),d=n.shift().trim().split(/\s+/).filter(k=>k!=="rx_queue"&&k!=="tm->when");return n.map(k=>k.trim().split(/\s+/).reduce((M,K,q)=>(M[d[q]||q]=K,M),{}))}e.loadConnectionTable=i;function s(r){return!!r.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||r.indexOf("out/server-main.js")!==-1||r.indexOf("_productName=VSCode")!==-1}function o(r){const n=r.trim().split(`
`),d=[];return n.forEach(E=>{const k=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);k&&k.length>=4&&d.push({pid:parseInt(k[1],10),ppid:parseInt(k[2]),cmd:k[3]})}),d}e.getRootProcesses=o;async function l(r,n,d){const E=d.reduce((M,K)=>(M[K.pid]=K,M),{}),k=[];return r.forEach(({socket:M,ip:K,port:q})=>{const F=n[M]?n[M].pid:void 0,B=F?E[F]?.cmd:void 0;F&&B&&!s(B)&&k.push({host:K,port:q,detail:B,pid:F})}),k}e.findPorts=l;function c(r,n,d){const E=new Map,k=o(n);for(const M of r){const K=d.get(M.port);if(K){E.set(M.port,K);continue}const q=k.find(F=>F.cmd.includes(`${M.port}`));if(q){let F=q,B;do B=k.find(O=>O.ppid===F.pid),B&&(F=B);while(B);E.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=c;let u=class extends R.Disposable{constructor(n,d,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=n.getProxy(a.MainContext.MainThreadTunnelService),w.isLinux&&d.remote.isRemote&&d.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(n,d){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const E=await this.a.$openTunnel(d,n.displayName);if(E){const k=new p(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(k),k}}async getTunnels(){return this.a.$getTunnels()}p(n){return Math.max(n*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(n,d){const E=this.r();return this.l.set(E,{selector:n,provider:d}),this.a.$registerPortsAttributesProvider(n,E),new P.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(n,d,E,k,M){const K=[];for(const F of n){const B=this.l.get(F);if(!B)return[];K.push(...await Promise.all(d.map(async O=>B.provider.providePortAttributes(O,E,k,M))))}const q=K.filter(F=>!!F);return q.length>0?q.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(n){if(n&&this.h)return;this.h=n;const d=new h.MovingAverage;let E;for(;this.h;){const k=new Date().getTime(),M=(await this.findCandidatePorts()).filter(q=>(0,m.isLocalhost)(q.host)||(0,m.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(q=>q.port).join(", ")}`);const K=new Date().getTime()-k;d.update(K),(!E||JSON.stringify(E)!==JSON.stringify(M))&&(E=M,await this.a.$onFoundNewCandidates(E)),await new Promise(q=>setTimeout(()=>q(),this.p(d.value)))}}async setTunnelFactory(n){if(n){if(n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.c=n.showCandidatePort,this.a.$setCandidateFilter()),n.tunnelFactory){this.b=n.tunnelFactory;let d=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const E=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:d}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(n,d){if(this.f.has(n.host)){const E=this.f.get(n.host);E.has(n.port)&&(d&&E.get(n.port).disposeListener.dispose(),await E.get(n.port).tunnel.dispose(),E.delete(n.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(n,d){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(n,d);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const k=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(n.remoteAddress.host)||this.f.set(n.remoteAddress.host,new Map);const M=this.B(k.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(k.remoteAddress))));return this.f.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:k,disposeListener:M}),C.TunnelDtoConverter.fromApiTunnel(k)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(n){const d=await Promise.all(n.map(k=>this.c(k.host,k.port,k.detail??""))),E=n.filter((k,M)=>d[M]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(k=>k.port).join(", ")} to ${E.map(k=>k.port).join(", ")}`),E}async findCandidatePorts(){let n="",d="";try{n=await L.Promises.readFile("/proc/net/tcp","utf8"),d=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=S(n,d),k=await new Promise($=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,ue,V)=>{$(ue)})}),M=b(k),K=await L.Promises.readdir("/proc"),q=[];for(const $ of K)try{const j=Number($),ue=D.joinPath(A.URI.file("/proc"),$);if((await L.Promises.stat(ue.fsPath)).isDirectory()&&!isNaN(j)){const _=await L.Promises.readlink(D.joinPath(ue,"cwd").fsPath),Y=await L.Promises.readFile(D.joinPath(ue,"cmdline").fsPath,"utf8");q.push({pid:j,cwd:_,cmd:Y})}}catch{}const F=[],B=E.filter($=>{const j=M[$.socket];return j||F.push($),j}),O=l(B,M,q);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const $=await new Promise(j=>{(0,y.exec)("ps -F -A -l | grep root",(ue,V,_)=>{j(V)})});this.j=c(F,$,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then($=>U?$.concat(U):$)}};u=qe([We(0,t.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,f.ILogService)],u),e.ExtHostTunnelService=u}),define(ye[287],Ce([1,0,14,23,21,9,3,6,114,246,58]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function w(E,k){try{return JSON.stringify(E,k)}catch{return"null"}}const C="$$ref$$",v={[C]:-1};class m{constructor(k,M){this.jsonString=k,this.referencedBuffers=M}}function h(E,k=null,M=!1){const K=[];return{jsonString:(M?w:JSON.stringify)(E,(F,B)=>{if(typeof B>"u")return v;if(typeof B=="object"){if(B instanceof t.VSBuffer){const O=K.push(B)-1;return{[C]:O}}if(k)return k(F,B)}return B}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=h;function f(E,k,M){return JSON.parse(E,(K,q)=>{if(q){const F=q[C];if(typeof F=="number")return k[F];if(M&&q.$mid===1)return M.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=f;function p(E,k){return JSON.stringify(E,k)}function b(E){return E?(k,M)=>M&&M.$mid===1?E.transformOutgoing(M):M:null}var S;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class l extends A.Disposable{constructor(k,M=null,K=null){super(),this[P]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=k,this.f=M,this.g=K,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,F=L.ProxyIdentifier.count;q<F;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(k=>{this.s[k].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(k){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(k){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(k){this.t!==k&&(this.t=k,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(k){return this.g?(0,y.transformIncomingURIs)(k,this.g):k}getProxy(k){const{nid:M,sid:K}=k;return this.l[M]||(this.l[M]=this.F(M,K)),this.l[M]}F(k,M){const K={get:(q,F)=>(typeof F=="string"&&!q[F]&&F.charCodeAt(0)===36&&(q[F]=(...B)=>this.O(k,F,B)),F===o?M:q[F])};return new Proxy(Object.create(null),K)}set(k,M){return this.k[k.nid]=M,M}assertRegistered(k){for(let M=0,K=k.length;M<K;M++){const q=k[M];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(k){if(this.j)return;const M=k.byteLength,K=c.read(k,0),q=K.readUInt8(),F=K.readUInt32();switch(q){case 1:case 2:{let{rpcId:B,method:O,args:U}=r.deserializeRequestJSONArgs(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(M,F,B,O,U,q===2);break}case 3:case 4:{let{rpcId:B,method:O,args:U}=r.deserializeRequestMixedArgs(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(M,F,B,O,U,q===4);break}case 5:{this.f?.logIncoming(M,F,0,"ack"),this.z(F);break}case 6:{this.I(M,F);break}case 7:{this.J(M,F,void 0);break}case 9:{let B=r.deserializeReplyOKJSON(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(M,F,B);break}case 10:{const B=r.deserializeReplyOKJSONWithBuffers(K,this.g);this.J(M,F,B);break}case 8:{const B=r.deserializeReplyOKVSBuffer(K);this.J(M,F,B);break}case 11:{let B=r.deserializeReplyErrError(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(M,F,B);break}case 12:{this.L(M,F,void 0);break}default:console.error("received unexpected message"),console.error(k)}}H(k,M,K,q,F,B){this.f?.logIncoming(k,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(K)}.${q}(`,F);const O=String(M);let U,$;if(B){const ue=new T.CancellationTokenSource;F.push(ue.token),U=this.M(K,q,F),$=()=>ue.cancel()}else U=this.M(K,q,F),$=i;this.p[O]=$;const j=r.serializeAcknowledged(M);this.f?.logOutgoing(j.byteLength,M,1,"ack"),this.c.send(j),U.then(ue=>{delete this.p[O];const V=r.serializeReplyOK(M,ue,this.h);this.f?.logOutgoing(V.byteLength,M,1,"reply:",ue),this.c.send(V)},ue=>{delete this.p[O];const V=r.serializeReplyErr(M,ue);this.f?.logOutgoing(V.byteLength,M,1,"replyErr:",ue),this.c.send(V)})}I(k,M){this.f?.logIncoming(k,M,1,"receiveCancel");const K=String(M);this.p[K]?.()}J(k,M,K){this.f?.logIncoming(k,M,0,"receiveReply:",K);const q=String(M);if(!this.s.hasOwnProperty(q))return;const F=this.s[q];delete this.s[q],F.resolveOk(K)}L(k,M,K){this.f?.logIncoming(k,M,0,"receiveReplyErr:",K);const q=String(M);if(!this.s.hasOwnProperty(q))return;const F=this.s[q];delete this.s[q];let B;K&&(K.$isError?(B=new Error,B.name=K.name,B.message=K.message,B.stack=K.stack):B=K),F.resolveErr(B)}M(k,M,K){try{return Promise.resolve(this.N(k,M,K))}catch(q){return Promise.reject(q)}}N(k,M,K){const q=this.k[k];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(k));const F=q[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(k));return F.apply(q,K)}O(k,M,K){if(this.j)return new D.CanceledLazyPromise;let q=null;if(K.length>0&&T.CancellationToken.isCancellationToken(K[K.length-1])&&(q=K.pop()),q&&q.isCancellationRequested)return Promise.reject(R.canceled());const F=r.serializeRequestArguments(K,this.h),B=++this.m,O=String(B),U=new D.LazyPromise;q&&q.onCancellationRequested(()=>{const j=r.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(r.serializeCancel(B))}),this.s[O]=U,this.y(B);const $=r.serializeRequest(B,k,M,F,!!q);return this.f?.logOutgoing($.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(k)}.${M}(`,K),this.c.send($),U}}e.RPCProtocol=l,P=s,l.a=3*1e3;class c{static alloc(k,M,K){const q=new c(t.VSBuffer.alloc(K+1+4),0);return q.writeUInt8(k),q.writeUInt32(M),q}static read(k,M){return new c(k,M)}get buffer(){return this.a}constructor(k,M){this.a=k,this.b=M}static sizeUInt8(){return 1}writeUInt8(k){this.a.writeUInt8(k,this.b),this.b+=1}readUInt8(){const k=this.a.readUInt8(this.b);return this.b+=1,k}writeUInt32(k){this.a.writeUInt32BE(k,this.b),this.b+=4}readUInt32(){const k=this.a.readUInt32BE(this.b);return this.b+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this.a.writeUInt8(k.byteLength,this.b),this.b+=1,this.a.set(k,this.b),this.b+=k.byteLength}readShortString(){const k=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+k).toString();return this.b+=k,K}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this.a.writeUInt32BE(k.byteLength,this.b),this.b+=4,this.a.set(k,this.b),this.b+=k.byteLength}readLongString(){const k=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+k).toString();return this.b+=k,K}writeBuffer(k){this.a.writeUInt32BE(k.byteLength,this.b),this.b+=4,this.a.set(k,this.b),this.b+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this.a.writeUInt32BE(k.byteLength,this.b),this.b+=4,this.a.set(k,this.b),this.b+=k.byteLength}readVSBuffer(){const k=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+k);return this.b+=k,M}static sizeMixedArray(k){let M=0;M+=1;for(let K=0,q=k.length;K<q;K++){const F=k[K];switch(M+=1,F.type){case 1:M+=this.sizeLongString(F.value);break;case 2:M+=this.sizeVSBuffer(F.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)M+=this.sizeVSBuffer(F.buffers[B]);break;case 4:break}}return M}writeMixedArray(k){this.a.writeUInt8(k.length,this.b),this.b+=1;for(let M=0,K=k.length;M<K;M++){const q=k[M];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let F=0;F<q.buffers.length;++F)this.writeBuffer(q.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this.a.readUInt8(this.b);this.b+=1;const M=new Array(k);for(let K=0;K<k;K++)switch(this.readUInt8()){case 1:M[K]=this.readLongString();break;case 2:M[K]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),B=this.readLongString(),O=[];for(let U=0;U<F;++U)O.push(this.readVSBuffer());M[K]=new L.SerializableObjectWithBuffers(f(B,O,null));break}case 4:M[K]=void 0;break}return M}}c.sizeUInt32=4;var u;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(u||(u={}));class r{static a(k){for(let M=0,K=k.length;M<K;M++)if(k[M]instanceof t.VSBuffer||k[M]instanceof L.SerializableObjectWithBuffers||typeof k[M]>"u")return!0;return!1}static serializeRequestArguments(k,M){if(this.a(k)){const K=[];for(let q=0,F=k.length;q<F;q++){const B=k[q];if(B instanceof t.VSBuffer)K[q]={type:2,value:B};else if(typeof B>"u")K[q]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=h(B.value,M);K[q]={type:3,value:t.VSBuffer.fromString(O),buffers:U}}else K[q]={type:1,value:t.VSBuffer.fromString(p(B,M))}}return{type:1,args:K}}return{type:0,args:p(k,M)}}static serializeRequest(k,M,K,q,F){switch(q.type){case 0:return this.b(k,M,K,q.args,F);case 1:return this.c(k,M,K,q.args,F)}}static b(k,M,K,q,F){const B=t.VSBuffer.fromString(K),O=t.VSBuffer.fromString(q);let U=0;U+=c.sizeUInt8(),U+=c.sizeShortString(B),U+=c.sizeLongString(O);const $=c.alloc(F?2:1,k,U);return $.writeUInt8(M),$.writeShortString(B),$.writeLongString(O),$.buffer}static deserializeRequestJSONArgs(k){const M=k.readUInt8(),K=k.readShortString(),q=k.readLongString();return{rpcId:M,method:K,args:JSON.parse(q)}}static c(k,M,K,q,F){const B=t.VSBuffer.fromString(K);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(B),O+=c.sizeMixedArray(q);const U=c.alloc(F?4:3,k,O);return U.writeUInt8(M),U.writeShortString(B),U.writeMixedArray(q),U.buffer}static deserializeRequestMixedArgs(k){const M=k.readUInt8(),K=k.readShortString(),q=k.readMixedArray(),F=new Array(q.length);for(let B=0,O=q.length;B<O;B++){const U=q[B];typeof U=="string"?F[B]=JSON.parse(U):F[B]=U}return{rpcId:M,method:K,args:F}}static serializeAcknowledged(k){return c.alloc(5,k,0).buffer}static serializeCancel(k){return c.alloc(6,k,0).buffer}static serializeReplyOK(k,M,K){if(typeof M>"u")return this.d(k);if(M instanceof t.VSBuffer)return this.e(k,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:F}=h(M.value,K,!0);return this.g(k,q,F)}else return this.f(k,w(M,K))}static d(k){return c.alloc(7,k,0).buffer}static e(k,M){let K=0;K+=c.sizeVSBuffer(M);const q=c.alloc(8,k,K);return q.writeVSBuffer(M),q.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static f(k,M){const K=t.VSBuffer.fromString(M);let q=0;q+=c.sizeLongString(K);const F=c.alloc(9,k,q);return F.writeLongString(K),F.buffer}static g(k,M,K){const q=t.VSBuffer.fromString(M);let F=0;F+=c.sizeUInt32,F+=c.sizeLongString(q);for(const O of K)F+=c.sizeVSBuffer(O);const B=c.alloc(10,k,F);B.writeUInt32(K.length),B.writeLongString(q);for(const O of K)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(k){const M=k.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(k,M){const K=k.readUInt32(),q=k.readLongString(),F=[];for(let B=0;B<K;++B)F.push(k.readVSBuffer());return new L.SerializableObjectWithBuffers(f(q,F,M))}static serializeReplyErr(k,M){const K=M?w(R.transformErrorForSerialization(M),null):void 0;if(typeof K!="string")return this.h(k);const q=t.VSBuffer.fromString(K);let F=0;F+=c.sizeLongString(q);const B=c.alloc(11,k,F);return B.writeLongString(q),B.buffer}static deserializeReplyErrError(k){const M=k.readLongString();return JSON.parse(M)}static h(k){return c.alloc(12,k,0).buffer}}var n;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(n||(n={}));var d;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(d||(d={}))}),define(ye[288],Ce([1,0,3,33,54,4,40,9,14]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(m=>v.push(m)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(C,v,m,h,f){return(0,y.createCancelablePromise)(async p=>{await(0,I.whenProviderRegistered)(m,h);const b=t.Registry.as(e.Extensions.OutputChannels);try{await w(m,1,h,f,p),b.registerChannel({id:C,label:v,file:m,log:!0})}catch(S){(0,A.isCancellationError)(S)||f.error("Error while registering log channel",m.toString(),(0,A.getErrorMessage)(S))}})}e.registerLogChannel=P;async function w(C,v,m,h,f){if(!await m.exists(C)){if(f.isCancellationRequested)throw new A.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");h.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",C.toString()),await(0,y.timeout)(1e3,f),await w(C,v+1,m,h,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,4,18,27,13,288,75,25,48,157,23,10,40,3,6]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(g,i,s,o,l){super(),this.id=g,this.name=i,this.m=s,this.n=o,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const i=this.k;this.info(g),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(g,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:i))}hide(){this.n.$close(this.id)}g(g,i){this.k+=w.VSBuffer.fromString(i).byteLength,(0,I.log)(this.m,g,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends f{appendLine(g){this.append(g)}}let b=class{constructor(g,i,s,o,l,c){this.i=i,this.j=s,this.k=o,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(g,i,s){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const o=typeof i=="object"&&i.log,l=(0,C.isString)(i)?i:void 0;if((0,C.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const u=this.i.environment.extensionLogLevel?.find(([n])=>R.ExtensionIdentifier.equals(s.identifier,n))?.[1];u&&(c=(0,I.parseLogLevel)(u));const r=o?this.o(g,c,s):this.n(g,l,s);return r.then(n=>{this.g.set(n.id,n),n.visible=n.id===this.h}),o?this.r(g,c??this.m.getLevel(),r):this.q(g,r)}async n(g,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,l=this.k.extUri.joinPath(o,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(g,l,!1,i,s.identifier.value);return new f(u,g,c,this.a,s)}async o(g,i,s){const o=await this.p(s),l=this.k.extUri.joinPath(o,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{name:g},i),u=await this.a.$register(g,l,!0,void 0,s.identifier.value);return new p(u,g,c,this.a,s)}p(g){let i=this.d.get(g.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}return s})())}return i}q(g,i){let s=!1;const o=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return g},append(l){o(),i.then(c=>c.append(l))},appendLine(l){o(),i.then(c=>c.appendLine(l))},clear(){o(),i.then(l=>l.clear())},replace(l){o(),i.then(c=>c.replace(l))},show(l,c){o(),i.then(u=>u.show(l,c))},hide(){o(),i.then(l=>l.hide())},dispose(){s=!0,i.then(l=>l.dispose())}}}r(g,i,s){const o=new h.DisposableStore,l=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},c=o.add(new m.Emitter);return s.then(u=>{o.add(u),o.add(u.onDidChangeLogLevel(r=>{i=r,c.fire(r)}))}),{...this.q(g,s),get logLevel(){return i},onDidChangeLogLevel:c.event,trace(u,...r){l(),s.then(n=>n.trace(u,...r))},debug(u,...r){l(),s.then(n=>n.debug(u,...r))},info(u,...r){l(),s.then(n=>n.info(u,...r))},warn(u,...r){l(),s.then(n=>n.warn(u,...r))},error(u,...r){l(),s.then(n=>n.error(u,...r))},dispose(){o.dispose()}}}};b=qe([We(0,T.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,I.ILoggerService),We(5,I.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[289],Ce([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[290],Ce([1,0,32,17,11,12,24,2,4,215,47,233,289]),function(te,e,a,t,T,R,I,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let C=class oi{constructor(m,h,f,p){this.d=m,this.e=h,this.f=f,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??m})()}hasValidBasename(m,h,f){return typeof h=="string"||typeof h>"u"?this.a.then(p=>this.h(m,p,h)):this.h(m,h,f)}h(m,h,f){return m.scheme===t.Schemas.file||m.scheme===t.Schemas.vscodeRemote?(0,a.isValidBasename)(f??(0,I.basename)(m),h===1):!0}get defaultUriScheme(){return oi.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,h){if(m.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,D.getVirtualWorkspaceScheme)(h.getWorkspace());if(f)return f;const p=h.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=h.getWorkspace().configuration;return b?b.scheme:t.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?T.win32:T.posix)}async fileURI(m){let h="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(h=m.substring(2),m="/"):(h=m.substring(2,p),m=m.substring(p)||"/")}return A.URI.from({scheme:t.Schemas.file,authority:h,path:m,query:"",fragment:""})}};C=qe([We(1,w.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(ye[78],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new a(0,0)}with(I){return new a(0,0)}}e.Position=a;class t{constructor(I,A,y,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(I,A),this.end=new a(y,D)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new t(0,0,0,0)}with(I){return new t(0,0,0,0)}}e.Range=t;var T;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,16,39,22,32,8,4,11,9,78,14]),function(te,e,a,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const w="\u27EA ",C=" characters skipped \u27EB",v=(w.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var m;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function f(Y){return!!Y.preview}e.resultIsMatch=f;function p(Y){return!!Y.resource}e.isFileMatch=p;function b(Y){return!!Y.message}e.isProgressMessage=b;var S;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(S=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=g;class i{constructor(ne,ee,X){this.ranges=ee;const G=Array.isArray(ee)?ee:[ee];if(X&&X.matchLines===1&&s(G)){ne=(0,I.getNLines)(ne,X.matchLines);let de="",be=0,Ee=0;const Pe=Math.floor(X.charsPerLine/5),Fe=[];for(const se of G){const oe=Math.max(se.startColumn-Pe,0),fe=se.startColumn+X.charsPerLine;if(oe>Ee+Pe+v){const Z=w+(oe-Ee)+C;de+=Z+ne.slice(oe,fe),be+=oe-(Ee+Z.length)}else de+=ne.slice(Ee,fe);Fe.push(new l(0,se.startColumn-be,se.endColumn-be)),Ee=fe}this.preview={text:de,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const de=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ne,matches:(0,a.mapArrayOrNot)(ee,be=>new o(be.startLineNumber-de,be.startColumn,be.endLineNumber-de,be.endColumn))}}}}e.TextSearchMatch=i;function s(Y){const ne=Y[0].startLineNumber;for(const ee of Y)if(ee.startLineNumber!==ne||ee.endLineNumber!==ne)return!1;return!0}class o{constructor(ne,ee,X,G){this.startLineNumber=ne,this.startColumn=ee,this.endLineNumber=X,this.endColumn=G}}e.SearchRange=o;class l extends o{constructor(ne,ee,X){super(ne,ee,ne,X)}}e.OneLineRange=l;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var u;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function r(Y,ne=!0){const ee=Y&&Y.files&&Y.files.exclude,X=ne&&Y&&Y.search&&Y.search.exclude;if(!ee&&!X)return;if(!ee||!X)return ee||X;let G=Object.create(null);return G=T.mixin(G,T.deepClone(ee)),G=T.mixin(G,T.deepClone(X),!0),G}e.getExcludes=r;function n(Y,ne){return Y.excludePattern&&t.match(Y.excludePattern,ne)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&t.match(Y.includePattern,ne)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ee=>{const X=ee.folder.fsPath;if(R.isEqualOrParent(ne,X)){const G=y.relative(X,ne);return!ee.includePattern||!!t.match(ee.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var d;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ne,ee){super(ne),this.code=ee}}e.SearchError=E;function k(Y){const ne=Y.message;if((0,D.isCancellationError)(Y))return new E(ne,d.canceled);try{const ee=JSON.parse(ne);return new E(ee.message,ee.code)}catch{return new E(ne,d.other)}}e.deserializeSearchError=k;function M(Y){const ne={message:Y.message,code:Y.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=M;function K(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=K;function q(Y){return Y.type==="success"}e.isSerializedSearchSuccess=q;function F(Y){return!!Y.path}e.isSerializedFileMatch=F;function B(Y,ne){const ee=Y.searchPath?Y.searchPath:Y.relativePath;return(0,I.fuzzyContains)(ee,ne)}e.isFilePatternMatch=B;class O{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(Y,ne){const ee={...Y||{},...ne||{}};return Object.keys(ee).filter(X=>{const G=ee[X];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=U;class ${constructor(ne,ee){this.c=null,this.a={...ne.excludePattern||{},...ee.excludePattern||{}},this.b=t.parse(this.a);let X=ne.includePattern;ee.includePattern&&(X?X={...X,...ee.includePattern}:X=ee.includePattern),X&&(this.c=t.parse(X))}matchesExcludesSync(ne,ee,X){return!!(this.b&&this.b(ne,ee,X))}includedInQuerySync(ne,ee,X){return!(this.b&&this.b(ne,ee,X)||this.c&&!this.c(ne,ee,X))}includedInQuery(ne,ee,X){const G=this.b(ne,ee,X),de=()=>this.c?!!this.c(ne,ee,X):!0;return(0,P.isThenable)(G)?G.then(be=>be?!1:de()):de()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=$;function j(Y){for(const ne in Y)if(typeof Y[ne]!="boolean")return!0;return!1}function ue(Y){if(!Y)return;let ne;return ee=>(ne||(ne=(Y()||Promise.resolve([])).then(X=>X?_(X):{})),ne.then(X=>!!X[ee]))}e.hasSiblingPromiseFn=ue;function V(Y){if(!Y)return;let ne;return ee=>{if(!ne){const X=Y();ne=X?_(X):{}}return!!ne[ee]}}e.hasSiblingFn=V;function _(Y){const ne={};for(const ee of Y)ne[ee]=!0;return ne}}),define(ye[34],Ce([1,0,16,14,21,3,6,66,17,102,24,8,10,2,182,4,13,203,47,48,25,18,15,7,56,31,5]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g,i,s,o,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(q,F,B){return new L.ExtUri(O=>E(O,B)).isEqual(q,F)}function r(q,F,B){return u(q.uri,F.uri,B)?0:(0,P.compare)(q.uri.toString(),F.uri.toString())}function n(q,F,B){return q.index!==F.index?q.index<F.index?-1:1:u(q.uri,F.uri,B)?(0,P.compare)(q.name,F.name):(0,P.compare)(q.uri.toString(),F.uri.toString())}function d(q,F,B,O){const U=q.slice(0).sort((j,ue)=>B(j,ue,O)),$=F.slice(0).sort((j,ue)=>B(j,ue,O));return(0,a.delta)(U,$,(j,ue)=>B(j,ue,O))}function E(q,F){const B=F.getCapabilities(q.scheme);return!(B&&B&1024)}class k extends p.Workspace{static toExtHostWorkspace(F,B,O,U){if(!F)return{workspace:null,added:[],removed:[]};const{id:$,name:j,folders:ue,configuration:V,transient:_,isUntitled:Y}=F,ne=[],ee=B;B?ue.forEach((be,Ee)=>{const Pe=C.URI.revive(be.uri),Fe=k.e(O||B,Pe,U);Fe?(Fe.name=be.name,Fe.index=be.index,ne.push(Fe)):ne.push({uri:Pe,name:be.name,index:Ee})}):ne.push(...ue.map(({uri:be,name:Ee,index:Pe})=>({uri:C.URI.revive(be),name:Ee,index:Pe}))),ne.sort((be,Ee)=>be.index<Ee.index?-1:1);const X=new k($,j,ne,!!_,V?C.URI.revive(V):null,!!Y,be=>E(be,U)),{added:G,removed:de}=d(ee?ee.workspaceFolders:[],X.workspaceFolders,r,U);return{workspace:X,added:G,removed:de}}static e(F,B,O){for(let U=0;U<F.folders.length;U++){const $=F.workspaceFolders[U];if(u($.uri,B,O))return $}}constructor(F,B,O,U,$,j,ue){super(F,O.map(V=>new p.WorkspaceFolder(V)),U,$,ue),this.s=B,this.t=j,this.o=[],this.q=A.TernarySearchTree.forUris(ue),O.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,B){return B&&this.q.get(F)&&(F=(0,L.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let M=class{constructor(F,B,O,U,$){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new R.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=U,this.q=O,this.s=$,this.h=new D.Counter,this.j=new t.Barrier,this.n=F.getProxy(c.MainContext.MainThreadWorkspace),this.o=F.getProxy(c.MainContext.MainThreadMessageService);const j=B.workspace;this.k=j?new k(j.id,j.name,[],!!j.transient,j.configuration?C.URI.revive(j.configuration):null,!!j.isUntitled,ue=>E(ue,O)):void 0}$initializeWorkspace(F,B){this.u=B,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?C.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,O,...U){const $=[];if(Array.isArray(U)&&U.forEach(Y=>{C.URI.isUri(Y.uri)&&!$.some(ne=>u(ne.uri,Y.uri,this.q))&&$.push({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri)})}),this.l||[B,O].some(Y=>typeof Y!="number"||Y<0)||O===0&&$.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if(B+O>j.length)return!1;const ue=j.slice(0);ue.splice(B,O,...$.map(Y=>({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<ue.length;Y++){const ne=ue[Y];if(ue.some((ee,X)=>X!==Y&&u(ne.uri,ee.uri,this.q)))return!1}ue.forEach((Y,ne)=>Y.index=ne);const{added:V,removed:_}=d(j,ue,n,this.q);if(V.length===0&&_.length===0)return!1;if(this.n){const Y=F.displayName||F.name;this.n.$updateWorkspaceFolders(Y,B,O,$).then(void 0,ne=>{this.l=void 0;const ee={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(f.Severity.Error,(0,v.localize)(0,null,Y,ne.toString()),ee,[])})}return this.x(ue),!0}getWorkspaceFolder(F,B){if(!!this.w)return this.w.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,B){let O,U="";if(typeof F=="string"?(O=C.URI.file(F),U=F):typeof F<"u"&&(O=F,U=F.fsPath),!O)return U;const $=this.getWorkspaceFolder(O,!0);if(!$)return U;typeof B>"u"&&this.w&&(B=this.w.folders.length>1);let j=(0,L.relativePath)($.uri,O);return B&&$.name&&(j=`${$.name}/${j}`),j}x(F){this.w&&(this.l=k.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:O,removed:U}=k.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=B||void 0,this.l=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(F,B,O,U,$=T.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:V}=K(i.GlobPattern.from(F));return this.n.$startFileSearch((0,w.withUndefinedAsNull)(ue),(0,w.withUndefinedAsNull)(V),(0,w.withUndefinedAsNull)(j),(0,w.withUndefinedAsNull)(O),$).then(_=>Array.isArray(_)?_.map(Y=>C.URI.revive(Y)):[])}async findTextInFiles(F,B,O,U,$=T.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),ue=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:V,folder:_}=K(i.GlobPattern.from(B.include)),Y=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ne={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ue,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:V,excludePattern:Y},ee=!1;if(this.t[j]=X=>{if(ee)return;const G=C.URI.revive(X.resource);X.results.forEach(de=>{(0,l.resultIsMatch)(de)?O({uri:G,preview:{text:de.preview.text,matches:(0,a.mapArrayOrNot)(de.preview.matches,be=>new s.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,a.mapArrayOrNot)(de.ranges,be=>new s.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):O({uri:G,text:de.text,lineNumber:de.lineNumber})})},$.isCancellationRequested)return{};try{const X=await this.n.$startTextSearch(F,(0,w.withUndefinedAsNull)(_),ne,j,$);return delete this.t[j],X||{}}catch(X){throw delete this.t[j],X}}$handleTextSearchResult(F,B){this.t[B]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,B){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,B);const O=this.s.transformOutgoingScheme(F),U=this.y++;return this.n.$registerEditSessionIdentityProvider(U,O),(0,I.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(F,B){this.g.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!O){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.v.get(O.uri.scheme);if(this.g.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const $=await U.provideEditSessionIdentity(O,B);if(this.g.info("Provider returned edit session identifier: ",$),!!$)return $}async $provideEditSessionIdentityMatch(F,B,O,U){this.g.info("Getting edit session identifier for workspaceFolder",F);const $=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!$){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const j=this.v.get($.uri.scheme);if(this.g.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!j),!j)return;const ue=await j.provideEditSessionIdentityMatch?.(B,O,U);if(this.g.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}};M=qe([We(0,g.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,h.ILogService),We(4,o.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,m.createDecorator)("IExtHostWorkspace");function K(q){let F,B;return q&&(typeof q=="string"?F=q:(F=q.pattern,B=C.URI.revive(q.baseUri))),{includePattern:F,folder:B}}}),define(ye[35],Ce([1,0,22,3,34,5,7,206,127,10,14,4,18,13,2]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(s,o){if(o){const l=o.split(".");let c=s;for(let u=0;c&&u<l.length;u++)c=c[l[u]];return c}}function h(s){return s instanceof v.URI}function f(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function p(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function S(s){if(h(s))return{resource:s};if(f(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(p(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let g=class{constructor(o,l,c){this.a=o.getProxy(R.MainContext.MainThreadConfiguration),this.c=l,this.b=c,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new i(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(o,l))}};g=qe([We(0,w.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,C.ILogService)],g),e.ExtHostConfiguration=g;class i{constructor(o,l,c,u){this.a=new t.Emitter,this.b=o,this.f=u,this.c=l,this.e=A.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(o,l,c){const u=S(l)||{},r=this.g(o?m(this.e.getValue(void 0,u,this.c.workspace),o):this.e.getValue(void 0,u,this.c.workspace));o&&this.h(o,u,c?.identifier);function n(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(E){return typeof m(r,E)<"u"},get:(E,k)=>{this.h(o?`${o}.${E}`:E,u,c?.identifier);let M=m(r,E);if(typeof M>"u")M=k;else{let K;const q=(F,B)=>{let O;const U=()=>{K=K||(0,a.deepClone)(r),O=O||m(K,B)};return(0,D.isObject)(F)?new Proxy(F,{get:($,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(K)return O=O||m(K,B),O[j];const ue=$[j];return typeof j=="string"?q(ue,`${B}.${j}`):ue},set:($,j,ue)=>(U(),O&&(O[j]=ue),!0),deleteProperty:($,j)=>(U(),O&&delete O[j],!0),defineProperty:($,j,ue)=>(U(),O&&Object.defineProperty(O,j,ue),!0)}):F};M=q(M,E)}return M},update:(E,k,M,K)=>{E=o?`${o}.${E}`:E;const q=n(M);return k!==void 0?this.b.$updateConfigurationOption(q,E,k,u,K):this.b.$removeConfigurationOption(q,E,u,K)},inspect:E=>{E=o?`${o}.${E}`:E;const k=this.e.inspect(E,u,this.c.workspace);if(k)return{key:E,defaultValue:(0,a.deepClone)(k.policy?.value??k.default?.value),globalValue:(0,a.deepClone)(k.user?.value??k.application?.value),workspaceValue:(0,a.deepClone)(k.workspace?.value),workspaceFolderValue:(0,a.deepClone)(k.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(k.default?.override),globalLanguageValue:(0,a.deepClone)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,a.deepClone)(k.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(k.workspaceFolder?.override),languageIds:(0,a.deepClone)(k.overrideIdentifiers)}}};return typeof r=="object"&&(0,a.mixin)(d,r,!1),Object.freeze(d)}g(o){const l=c=>(0,D.isObject)(c)?new Proxy(c,{get:(u,r)=>l(u[r]),set:(u,r,n)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(u,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(u,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(o)}h(o,l,c){const u=y.OVERRIDE_PROPERTY_REGEX.test(o)?4:this.d.get(o),r=c?`[${c.value}] `:"";if(u===4){typeof l?.resource>"u"&&this.f.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){l?.resource&&this.f.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,l){const c=new A.ConfigurationChangeEvent(o,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,r)=>c.affectsConfiguration(u,S(r))})}k(o){return o.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[79],Ce([1,0,2,14,3,5,7,34,59,35,21,42,18,25,4,17,12,13,74,245,9]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(i||(i={}));var s;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(s||(s={}));var o;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(o||(o={}));var l;(function(F){function B($){if($){const j=$;return j&&!!j.process}else return!1}F.is=B;function O($){if($==null)return;const j={process:$.process,args:$.args};return $.options&&(j.options=o.from($.options)),j}F.from=O;function U($){if($!=null)return new I.ProcessExecution($.process,$.args,$.options)}F.to=U})(l||(l={}));var c;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(c||(c={}));var u;(function(F){function B($){if($){const j=$;return j&&(!!j.commandLine||!!j.command)}else return!1}F.is=B;function O($){if($==null)return;const j={};return $.commandLine!==void 0?j.commandLine=$.commandLine:(j.command=$.command,j.args=$.args),$.options&&(j.options=c.from($.options)),j}F.from=O;function U($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new I.ShellExecution($.commandLine,$.options):new I.ShellExecution($.command,$.args?$.args:[],$.options)}F.to=U})(u||(u={}));var r;(function(F){function B($){if($){const j=$;return j&&j.customExecution==="customExecution"}else return!1}F.is=B;function O($){return{customExecution:"customExecution"}}F.from=O;function U($,j){return j.get($)}F.to=U})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var n;(function(F){function B(O,U){let $;return O.scope!==void 0&&typeof O.scope!="number"?$=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===I.TaskScope.Workspace&&U&&U.workspaceFile?$=U.workspaceFile:$=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:$}}F.from=B})(n=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(F){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}F.from=B})(d||(d={}));var E;(function(F){function B($,j){if($==null)return[];const ue=[];for(const V of $){const _=O(V,j);_&&ue.push(_)}return ue}F.fromMany=B;function O($,j){if($==null)return;let ue;$.execution instanceof I.ProcessExecution?ue=l.from($.execution):$.execution instanceof I.ShellExecution?ue=u.from($.execution):$.execution&&$.execution instanceof I.CustomExecution&&(ue=r.from($.execution));const V=i.from($.definition);let _;return $.scope?typeof $.scope=="number"?_=$.scope:_=$.scope.uri:_=I.TaskScope.Workspace,!V||!_?void 0:{_id:$._id,definition:V,name:$.name,source:{extensionId:j.identifier.value,label:$.source,scope:_},execution:ue,isBackground:$.isBackground,group:d.from($.group),presentationOptions:s.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}F.from=O;async function U($,j,ue){if($==null)return;let V;l.is($.execution)?V=l.to($.execution):u.is($.execution)?V=u.to($.execution):r.is($.execution)&&(V=r.to($._id,ue));const _=i.to($.definition);let Y;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?Y=$.source.scope:Y=await j.resolveWorkspaceFolder(a.URI.revive($.source.scope)):Y=I.TaskScope.Workspace),!_||!Y)return;const ne=new I.Task(_,Y,$.name,$.source.label,V,$.problemMatchers);return $.isBackground!==void 0&&(ne.isBackground=$.isBackground),$.group!==void 0&&(ne.group=I.TaskGroup.from($.group._id),ne.group&&$.group.isDefault&&(ne.group=new I.TaskGroup(ne.group.id,ne.group.label),$.group.isDefault===!0&&(ne.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ne.presentationOptions=s.to($.presentationOptions)),$._id&&(ne._id=$._id),$.detail&&(ne.detail=$.detail),ne}F.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var k;(function(F){function B(U){return U}F.from=B;function O(U){if(!!U)return Object.assign(Object.create(null),U)}F.to=O})(k||(k={}));class M{constructor(B,O,U){this._id=O,this.a=U,g.set(this,void 0),Ye(this,g,B,"f")}get task(){return this.a}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}g=new WeakMap;let K=class{constructor(B,O,U,$,j,ue,V,_){this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.t=new T.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=$,this.d=j,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,U){if(!U)return new I.Disposable(()=>{});const $=this.w();return this.j.set($,{type:O,provider:U,extension:B}),this.a.$registerTaskProvider($,O),new I.Disposable(()=>{this.j.delete($),this.a.$unregisterTaskProvider($)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(k.from(B)).then(async O=>{const U=[];for(const $ of O){const j=await E.to($,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,U){const $=this.m.get(B.id);$&&(this.o.set(B.id,$),this.e.attachPtyToTerminal(O,await $.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const $=[],j=(0,t.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(ue=>this.u(O,$,U,ue));return new Promise(ue=>{j.then(V=>{Promise.all($).then(()=>{ue(V)})})})}async $resolveTask(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const $=await E.to(O,this.b,this.m);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask($,L.CancellationToken.None);if(!j)return;this.z(j,U);const ue=E.from(j,U.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(ue.execution)&&await this.x(ue,j,!0),await this.v(ue)}w(){return this.h++}async x(B,O,U){const $=await this.a.$createTaskId(B);!U&&!this.m.has($)&&(this.n.add($),this.o.set($,O.execution)),this.m.set($,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new S.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get(B.id);if(U)return U;const $=new Promise((j,ue)=>{function V(_,Y,ne){ne?j(new M(_,Y.id,ne)):ue("Unexpected: Task does not exist.")}O?V(this,B,O):E.to(B.task,this.b,this.m).then(_=>V(this,B,_))});return this.l.set(B.id,$),$.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let $=U.next();for(;!$.done;)!this.o.has($.value)&&this.p!==$.value&&(this.m.delete($.value),this.n.delete($.value)),$=U.next()}};K=qe([We(0,w.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let q=class extends K{constructor(B,O,U,$,j,ue,V,_){super(B,O,U,$,j,ue,V,_),this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(O,B);if(U===void 0)throw new Error("Task is not valid");if(r.is(U.execution))await this.x(U,O,!1);else throw new S.NotSupportedError;const $=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),$}u(B,O,U,$){const j=[];if($)for(const ue of $){this.z(ue,U),(!ue.definition||!B[ue.definition.type])&&this.f.warn(`The task [${ue.source}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`);const V=E.from(ue,U.extension);V&&r.is(V.execution)?(j.push(V),O.push(this.x(V,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v(B){if(r.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,U){}};q=qe([We(0,w.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ye[291],Ce([1,0,11,21,45,39,24,44,31]),function(te,e,a,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(w,C,v){this.k=w,this.l=C,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&R.parse(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&R.parse(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const C=this.k.folderQueries||[];return new Promise((v,m)=>{const h=f=>{this.f++,w(f)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const p=f.toString(),b=a.basename(p);this.j&&this.j(p,b)||this.v(h,{base:f,basename:b})}),Promise.all(C.map(f=>this.p(f,h))).then(f=>{v({limitHit:this.e,stats:f[0]||void 0})},f=>{m(new Error((0,T.toErrorMessage)(f)))})})}async p(w,C){const v=new t.CancellationTokenSource,m=this.q(w),h=this.r(),f=new y.QueryGlobTester(this.k,w),p=!f.hasSiblingExcludeClauses();let b;try{this.h.add(v),b=A.StopWatch.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},m,v.token),g=b.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(S&&S.forEach(s=>{const o=a.posix.relative(w.folder.path,s.path);if(p){const l=a.basename(s.path);this.v(C,{base:w.folder,relativePath:o,basename:l});return}this.s(h,w.folder,o,C)}),this.g&&!this.e)?null:(this.u(h,f,C),{providerTime:g,postProcessTime:i.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(w){const C=(0,y.resolvePatternsForProvider)(this.k.includePattern,w.includePattern),v=(0,y.resolvePatternsForProvider)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:v,includes:C,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},C,v,m){if(v===this.a){const f=a.basename(this.a);this.v(m,{base:C,relativePath:this.a,basename:f})}function h(f){const p=a.basename(f),b=a.dirname(f);let S=w[b];S||(S=w[b]=[],h(b)),S.push({base:C,relativePath:f,basename:p})}h(v)}u({rootEntries:w,pathToEntries:C},v,m){const h=this,f=this.a;function p(b){const S=(0,y.hasSiblingFn)(()=>b.map(g=>g.basename));for(let g=0,i=b.length;g<i;g++){const s=b[g],{relativePath:o,basename:l}=s;if(v.matchesExcludesSync(o,l,f!==l?S:void 0))continue;const c=C[o];if(c)p(c);else{if(o===f)continue;h.v(m,s)}if(h.e)break}}p(w)}v(w,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(C))}}class L{constructor(){this.b=new Map}fileSearch(w,C,v,m){const h=this.c(w.cacheKey),f=new D(w,C,h&&h.token);let p=0;const b=S=>{p+=S.length,v(S.map(g=>this.d(g)))};return this.e(f,L.a,b,m).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:S.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(!!w)return this.b.has(w)||this.b.set(w,new t.CancellationTokenSource),this.b.get(w)}d(w){return w.relativePath?{resource:I.joinPath(w.base,w.relativePath)}:{resource:w.base}}e(w,C,v,m){m.onCancellationRequested(()=>{w.cancel()});const h=p=>{p&&(f.push(p),C>0&&f.length>=C&&(v(f),f=[]))};let f=[];return w.search(h).then(p=>(f.length&&v(f),p),p=>(f.length&&v(f),Promise.reject(p)))}}e.FileSearchManager=L,L.a=512}),define(ye[292],Ce([1,0,16,61,39,113,28,17,11,24,8,10,2,165,194,53,13,47,133,290,31]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(d,E,k,M,K){this.a=d,this.b=E,this.c=k,this.d=M,this.e=K}text(d,E,k={}){d=this.f(d,k);const M=this.a.getValue(),K=E&&E.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(E?.map(f.toWorkspaceFolder),k),type:2,contentPattern:d,previewOptions:k.previewOptions,maxFileSize:k.maxFileSize,usePCRE2:M.search.usePCRE2||K||!1,beforeContext:k.beforeContext,afterContext:k.afterContext,userDisabledExcludesAndIgnoreFiles:k.disregardExcludeSettings&&k.disregardIgnoreFiles}}f(d,E){const k=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const M={...d,wordSeparators:k.editor.wordSeparators};return this.j(d,E)&&(M.isCaseSensitive=!0),this.k(d)&&(M.isMultiline=!0),M}file(d,E={}){return{...this.h(d,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(d,E){return d?(d=Array.isArray(d)?d.map(c):c(d),E?this.parseSearchPaths(d):{pattern:s(...Array.isArray(d)?d:[d])}):{}}h(d=[],E={}){const k=this.g(E.includePattern,E.expandPatterns),M=this.g(E.excludePattern,E.expandPatterns),K=d.length>1,q=(k.searchPaths&&k.searchPaths.length?k.searchPaths.map(O=>this.q(O,E,M)):d.map(O=>this.r(O,E,M,K))).filter(O=>!!O),F={_reason:E._reason,folderQueries:q,usingSearchPaths:!!(k.searchPaths&&k.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:k.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=a.coalesce(a.flatten(this.c.groups.map(j=>j.editors.map(ue=>ue.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(j=>(0,S.pathIncludedInQuery)(F,j.fsPath)),$=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($)),{...F,...$}}const B=E.extraFileResources&&E.extraFileResources.filter(O=>(0,S.pathIncludedInQuery)(F,O.fsPath));return F.extraFileResources=B&&B.length?B:void 0,F}i(d){const E=[],k=new I.ResourceMap,M={};let K=!1;return d.forEach(q=>{if(q.scheme===A.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(q)){const B=this.b.getWorkspaceFolder(q)?.uri??q.with({path:y.dirname(q.fsPath)});let O=k.get(B);O||(K=!0,O={folder:B,includePattern:{}},E.push(O),k.set(B,O));const U=y.relative(B.fsPath,q.fsPath);(0,P.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else q.fsPath&&(K=!0,M[q.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(d,E){if(E.isSmartCase){if(d.isRegExp){if(L.containsUppercaseCharacter(d.pattern,!0))return!0}else if(L.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,C.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const E=$=>y.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),M=(Array.isArray(d)?d:o(d)).map($=>{const j=this.e.resolvedUserHome;return j?(0,R.untildify)($,j.scheme===A.Schemas.file?j.fsPath:j.path):$}),K=t.groupBy(M,$=>E($)?"searchPaths":"exprSegments"),q=(K.exprSegments||[]).map($=>L.rtrim($,"/")).map($=>L.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),l($))),F={},B=this.m(K.searchPaths||[]);B&&B.length&&(F.searchPaths=B);const O=a.flatten(q),U=s(...O);return U&&(F.pattern=U),F}l(d,E){return E.disregardExcludeSettings?void 0:(0,S.getExcludes)(d,!E.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const E=d.flatMap(M=>{let{pathPortion:K,globPortion:q}=i(M);return q&&(q=u(q)),this.n(K).flatMap(B=>this.o(B,q))}),k=new Map;return E.forEach(M=>{const K=M.searchPath.toString(),q=k.get(K);q?M.pattern&&(q.pattern=q.pattern||{},q.pattern[M.pattern]=!0):k.set(K,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(k.values())}n(d){if(y.isAbsolute(d)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==A.Schemas.file?[{searchPath:E[0].uri.with({path:d})}]:[{searchPath:w.URI.file(y.normalize(d))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(d=c(d),d.startsWith("../")||d===".."){const M=y.posix.resolve(E.path,d);return[{searchPath:E.with({path:M})}]}const k=u(d);return[{searchPath:E,pattern:k}]}else{if(d==="./"||d===".\\")return[];{const E=d.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(K=>{const q=E.match(new RegExp(`^${L.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return q?{match:q,folder:K}:null}).filter(P.isDefined);if(M.length)return M.map(K=>{const q=K.match[1];return{searchPath:K.folder.uri,pattern:q&&u(q)}});{const K=d.match(/\.[\/\\](.+)[\/\\]?/),q=K?K[1]:d,F=v.localize(0,null,q);throw new Error(F)}}}}o(d,E){const k=d.pattern&&E?`${d.pattern}/${E}`:d.pattern||E,M=[{searchPath:d.searchPath,pattern:k}];return k&&!k.endsWith("**")&&M.push({searchPath:d.searchPath,pattern:k+"/**"}),M}q(d,E,k){const M=this.r((0,f.toWorkspaceFolder)(d.searchPath),E,k,!1);return M?{...M,includePattern:d.pattern}:null}r(d,E,k,M){let K;const q=w.URI.isUri(d)?d:d.uri;if(k.searchPaths){const $=k.searchPaths.filter(j=>(0,D.isEqual)(j.searchPath,q))[0];if($&&!$.pattern)return null;$&&(K=$.pattern)}const F=this.a.getValue({resource:q}),O={...this.l(F,E)||{},...K||{}},U=w.URI.isUri(d)?(0,D.basename)(d):d.name;return{folder:q,folderName:M?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!F.search.followSymlinks}}};g=qe([We(0,m.IConfigurationService),We(1,f.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,h.ILogService),We(4,b.IPathService)],g),e.QueryBuilder=g;function i(n){const d=n.match(/[\*\{\}\(\)\[\]\?]/);if(d){const E=d.index,k=n.substr(0,E).match(/[/|\\][^/\\]*$/);if(k){let M=n.substr(0,k.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:n.substr((k.index||0)+1)}}}return{pathPortion:n}}function s(...n){return n.length?n.reduce((d,E)=>(d[E]=!0,d),Object.create(null)):void 0}function o(n){return T.splitGlobAware(n,",").map(d=>d.trim()).filter(d=>!!d.length)}function l(n){return[`**/${n}/**`,`**/${n}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(n){return n.replace(/\\/g,"/")}function u(n){return c(n).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(n,d){n=a.distinct(n,M=>M.toString());const E=[],k=d.getWorkspace();return n&&n.forEach(M=>{let K;if(d.getWorkbenchState()===2)K=(0,D.relativePath)(k.folders[0].uri,M),K&&K!=="."&&(K="./"+K);else{const q=d.getWorkspaceFolder(M);if(q){const F=q.name;if(k.folders.filter(O=>O.name===F).length===1){const O=(0,D.relativePath)(q.uri,M);O===""?K=`./${q.name}`:K=`./${q.name}/${O}`}else K=M.fsPath}}K&&E.push(K)}),E}e.resolveResourcesForSearchIncludes=r}),define(ye[293],Ce([1,0,24,2,21,9,4,292,31,47]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(m,h){const f=h.activationEvents;if(!f)return Promise.resolve(void 0);const p=[],b=[];for(const l of f)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||m.forceUsingSearch?b.push(c):p.push(c)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let S;const g=new Promise((l,c)=>{S=l}),i=l=>S({activationEvent:l}),s=Promise.all(p.map(l=>w(m,l,i))).then(()=>{}),o=C(m,h.identifier,b,i);return Promise.all([s,o]).then(()=>{S(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function w(m,h,f){for(const p of m.folders)if(await m.exists(a.joinPath(t.URI.revive(p),h))){f(`workspaceContains:${h}`);return}}async function C(m,h,f,p){if(f.length===0)return Promise.resolve(void 0);const b=new T.CancellationTokenSource,S=m.checkExists(m.folders,f,b.token),g=setTimeout(async()=>{b.cancel(),m.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let i=!1;try{i=await S}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}b.dispose(),clearTimeout(g),i&&p(`workspaceContains:${f.join(",")}`)}function v(m,h,f,p){const b=m.get(I.IInstantiationService),S=m.get(y.ISearchService),i=b.createInstance(A.QueryBuilder).file(h.map(s=>(0,D.toWorkspaceFolder)(t.URI.revive(s))),{_reason:"checkExists",includePattern:f,exists:!0});return S.fileSearch(i,p).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=v});var Ye=this&&this.__classPrivateFieldSet||function(te,e,a,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Ue=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(ye[43],Ce([1,0,177,11,80,24,14,6,66,2,13,5,35,235,99,34,26,134,9,27,23,216,7,128,4,25,76,18,90,55,42,3,293,98,218,17,97,44]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g,i,s,o,l,c,u,r,n,d,E,k,M,K,q,F,B){"use strict";var O,U,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let j=class zn extends A.Disposable{constructor(ee,X,G,de,be,Ee,Pe,Fe,se,oe,fe){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=G,this.f=Pe,this.j=de,this.k=be,this.l=Ee,this.m=se,this.p=oe,this.s=fe,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new f.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,h.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new f.ExtensionDescriptionRegistry(_(this.F,Z)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new M.ExtHostSecretState(this.g),this.I=Fe,this.h=ee.createChild(new r.ServiceCollection([v.IExtHostStorage,this.G],[M.IExtHostSecretState,this.H])),this.J=this.B(new C.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,ie,N)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(ie),N)},actualActivateExtension:async(ce,ie)=>{if(f.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,ie),new C.HostExtension;const N=this.D.getExtensionDescription(ce);return this.Y(N,ie)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),T.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ee){p.onUnexpectedError(ee)}}async Q(){this.I.onWillDeactivateAll();let ee=[];try{ee=this.D.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.X(be))}catch{}await Promise.all(ee)}terminate(ee,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ee}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const G=this.Q();Promise.race([(0,I.timeout)(5e3),G]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(ee){return this.z.isOpen()?this.J.isActivated(ee):!1}async getExtension(ee){const X=await this.v.$getExtension(ee);let G;if(X?.browserNlsBundleUris){G={};for(const de of Object.keys(X.browserNlsBundleUris))G[de]=D.URI.revive(X.browserNlsBundleUris[de])}return X&&{...X,identifier:new b.ExtensionIdentifier(X.identifier.value),extensionLocation:D.URI.revive(X.extensionLocation),browserNlsBundleUris:G}}R(ee,X){return this.J.activateByEvent(ee,X)}S(ee,X){return this.J.activateById(ee,X)}activateByIdWithErrors(ee,X){return this.S(ee,X).then(()=>{const G=this.J.getActivatedExtension(ee);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ee=>this.D)}getExtensionExports(ee){return this.z.isOpen()?this.J.getActivatedExtension(ee).exports:null}async U(ee){if(ee.scheme!==q.Schemas.file)return ee;const X=await this.c.realpath(ee.fsPath);return D.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ee=>new Y(ee))),this.L}async W(ee){const X=y.TernarySearchTree.forUris(G=>R.extUriBiasedIgnorePathCase.ignorePathCasing(G));return await Promise.all(ee.map(async G=>{if(this.ob(G)){const de=await this.U(G.extensionLocation);X.set(de,G)}})),X}X(ee){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ee))return X;const G=this.J.getActivatedExtension(ee);if(!G)return X;try{typeof G.module.deactivate=="function"&&(X=Promise.resolve(G.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${ee.value}':`),this.l.error(de)}try{(0,A.dispose)(G.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.l.error(de)}return X}async Y(ee,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ee.identifier):await this.v.$onWillActivateExtension(ee.identifier),this.ab(ee,X).then(G=>{const de=G.activationTimes;return this.v.$onDidActivateExtension(ee.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,X),this.Z(ee,X,"success",de),G},G=>{throw this.Z(ee,X,"failure"),G})}Z(ee,X,G,de){const be=ue(ee,X);this.u.$publicLog2("extensionActivationTimes",{...be,...de||{},outcome:G})}ab(ee,X){const G=ue(ee,X);this.u.$publicLog2("activatePlugin",G);const de=this.ob(ee);if(!de)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${ee.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const be=new C.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.pb(ee,(0,R.joinPath)(ee.extensionLocation,de),be),this.bb(ee)]).then(Ee=>(T.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),zn.cb(this.l,ee.identifier,Ee[0],Ee[1],be))).then(Ee=>(T.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),Ee))}bb(ee){const X=new g.ExtensionGlobalMemento(ee,this.G),G=new g.ExtensionMemento(ee.identifier.value,!1,this.G),de=new K.ExtensionSecrets(ee,this.H),be=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ee=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([X.whenReady,G.whenReady,this.I.whenReady]).then(()=>{const Pe=this;let Fe,se;const oe=(0,h.isProposedApiEnabled)(ee,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:G,secrets:de,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(ee.extensionLocation.fsPath,fe)},get storagePath(){return Pe.I.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Pe.I.globalValue(ee).fsPath},get logPath(){return t.join(Pe.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return D.URI.joinPath(Pe.f.logsLocation,ee.identifier.value)},get storageUri(){return Pe.I.workspaceValue(ee)},get globalStorageUri(){return Pe.I.globalValue(ee)},get extensionMode(){return be},get extension(){return Fe===void 0&&(Fe=new V(Pe,ee.identifier,ee,Ee,!1)),Fe},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(ee,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe.p.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!se){if(!oe)return;const fe=E.Event.buffer(E.Event.fromDOMEventEmitter(oe,"message",Z=>Z.data));oe.start(),se={onDidReceiveMessage:fe,postMessage:oe.postMessage.bind(oe)}}return se}})})}static cb(ee,X,G,de,be){return G=G||{activate:void 0,deactivate:void 0},this.db(ee,X,G,de,be).then(Ee=>new C.ActivatedExtension(!1,null,be.build(),G,Ee,de.subscriptions))}static db(ee,X,G,de,be){if(typeof G.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${X.value}`);const Ee=typeof global=="object"?global:self,Pe=G.activate.apply(Ee,[de]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Pe).then(Fe=>(be.activateResolveStop(),Fe))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(G)}eb(ee,X){this.S(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:X}).then(void 0,G=>{this.l.error(G)})}fb(){this.v.$setPerformanceMarks(T.getMarks());for(const ee of this.D.getAllExtensionDescriptions())if(ee.activationEvents)for(const X of ee.activationEvents)X==="onStartupFinished"&&this.eb(ee,X)}gb(){const ee=this.R("*",!0).then(void 0,be=>{this.l.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.hb(be.added)));const X=this.j.workspace?this.j.workspace.folders:[],G=this.hb(X),de=Promise.all([ee,G]).then(()=>{});return Promise.race([de,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),de}hb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.ib(ee,X))).then(()=>{})}async ib(ee,X){if(this.isActivated(X.identifier))return;const G=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:ee.map(Ee=>Ee.uri),forceUsingSearch:G,exists:Ee=>this.c.exists(Ee.fsPath),checkExists:(Ee,Pe,Fe)=>this.t.$checkExists(Ee,Pe,Fe)},be=await(0,k.checkActivateWorkspaceContainsExtension)(de,X);if(!!be)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:be.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ee){throw console.error(ee),ee}}async jb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:X}=this.f.environment;if(!ee||!X)throw new Error(a.localize(0,null));const G=await this.pb(null,X,new C.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(a.localize(1,null,X.toString()));return new Promise((de,be)=>{const Ee=(se,oe)=>{se?be(se):de(typeof oe=="number"&&oe>0?1:0)},Pe=(0,R.originalFSPath)(X),Fe=G.run(Pe,Ee);Fe&&Fe.then&&Fe.then(()=>{de(0)}).catch(se=>{be(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,X){return this.M[ee]=X,(0,A.toDisposable)(()=>{delete this.M[ee]})}async lb(ee){const X=ee.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const G=ee.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this.M[G]}}async $resolveAuthority(ee,X){const G=B.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(ee)},${X})][${G.elapsed()}ms] `,be=oe=>this.l.info(`${de()}${oe}`),Ee=(oe,fe=void 0)=>this.l.error(`${de()}${oe}`,fe);be("activating resolver...");const{authorityPrefix:Pe,resolver:Fe}=await this.lb(ee);if(!Fe)return Ee("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Pe}.`,detail:void 0}};const se=new I.IntervalTimer;try{be("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Fe)),se.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),T.mark(`code/extHost/willResolveAuthority/${Pe}`);const oe=await Fe.resolve(ee,{resolveAttempt:X});T.mark(`code/extHost/didResolveAuthorityOK/${Pe}`),se.dispose(),be(`returned ${oe.host}:${oe.port}`);const fe={authority:ee,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Z={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:Z,tunnelInformation:{environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures}}}}catch(oe){if(T.mark(`code/extHost/didResolveAuthorityError/${Pe}`),se.dispose(),Ee("returned an error",oe),oe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(ee,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(ee)})`);const{resolver:G}=await this.lb(ee);if(!G)return null;const de=D.URI.revive(X);if(typeof G.getCanonicalURI>"u")return de;const be=await(0,I.asPromise)(()=>G.getCanonicalURI(de));return be||de}static mb(ee,X,G){const de=new f.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());de.deltaExtensions(G.toAdd,G.toRemove);const be=(0,h.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of G.myToRemove)be.delete(b.ExtensionIdentifier.toKey(Pe));for(const Pe of G.myToAdd)be.add(b.ExtensionIdentifier.toKey(Pe));const Ee=_(de,be);return{globalRegistry:de,myExtensions:Ee}}$startExtensionHost(ee){ee.toAdd.forEach(de=>de.extensionLocation=D.URI.revive(de.extensionLocation));const{globalRegistry:X,myExtensions:G}=zn.mb(this.F,this.D,ee);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(G),this.kb()}$activateByEvent(ee,X){return X===1?this.R(ee,!1):this.z.wait().then(G=>this.R(ee,!1))}async $activate(ee,X){return await this.z.wait(),this.D.getExtensionDescription(ee)?(await this.S(ee,X),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(Ee=>Ee.extensionLocation=D.URI.revive(Ee.extensionLocation));const{globalRegistry:X,myExtensions:G}=zn.mb(this.F,this.D,ee),de=await this.W(G);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(X.getAllExtensionDescriptions()),this.D.set(G),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const X=S.VSBuffer.alloc(ee),G=Math.random()%256;for(let de=0;de<ee;de++)X.writeUInt8(G,de);return X}async $updateRemoteConnectionData(ee){this.P=ee,this.a.fire()}};j=qe([We(0,o.IInstantiationService),We(1,e.IHostUtils),We(2,u.IExtHostRpcService),We(3,m.IExtHostWorkspace),We(4,w.IExtHostConfiguration),We(5,L.ILogService),We(6,l.IExtHostInitDataService),We(7,c.IExtensionStoragePaths),We(8,n.IExtHostTunnelService),We(9,d.IExtHostTerminalService),We(10,F.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function ue(ne,ee){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class V{constructor(ee,X,G,de,be){O.set(this,void 0),U.set(this,void 0),$.set(this,void 0),Ye(this,O,ee,"f"),Ye(this,U,X,"f"),Ye(this,$,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=t.normalize((0,R.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=de,this.isFromDifferentExtensionHost=be}get isActive(){return Ue(this,O,"f").isActivated(Ue(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,O,"f").getExtensionExports(Ue(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,O,"f").activateByIdWithErrors(Ue(this,$,"f"),{startup:!1,extensionId:Ue(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,O=new WeakMap,U=new WeakMap,$=new WeakMap;function _(ne,ee){return ne.getAllExtensionDescriptions().filter(X=>ee.has(b.ExtensionIdentifier.toKey(X.identifier)))}class Y{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.ExtensionPaths=Y}),define(ye[294],Ce([1,0,80,2,5,35,26,27,18,25,4,43,37,13,8]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(g,i,s,o,l,c,u){this.c=g,this.d=i,this.e=s,this.f=o,this.g=l,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new f(this.c,i,this.d,g,this.i)),this.register(this.e.createInstance(p,i)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const i of g.nodeModuleName)this.a.set(i,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(i=>g.alternativeModuleName(i))}};m=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,D.IExtHostInitDataService),We(6,C.ILogService)],m),e.RequireInterceptor=m;let h=class ni{constructor(g){if(g.environment.appRoot&&ni.a.size){const i=(0,v.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),s="[a-z0-9_.-]",o=`@${s}+\\/${s}+|${s}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${l}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const i=this.b.exec(this.c(g));if(!i)return;const[,s,o,l]=i,c=ni.a.get(o);if(c!==void 0)return console.warn(`${o} as been renamed to ${c}, please update your imports`),s+c+l}c(g){return g.replace(/\\/g,"/")}};h.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=qe([We(0,D.IExtHostInitDataService)],h);class f{constructor(g,i,s,o,l){this.c=g,this.d=i,this.e=s,this.f=o,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(g,i){const s=this.d.findSubstr(i);if(s){let o=this.a.get(A.ExtensionIdentifier.toKey(s.identifier));return o||(o=this.c(s,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(s.identifier),o)),o}if(!this.b){let o="";this.d.forEach((l,c)=>o+=`	${c} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${o}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(g,i,s){this.d=g,this.nodeModuleName="keytar",this.a=i.getProxy(T.MainContext.MainThreadTelemetry);const{environment:o}=s,l=i.getProxy(T.MainContext.MainThreadKeytar);if(o.appRoot){let c=o.appRoot.fsPath;w.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,u)=>l.$getPassword(c,u),setPassword:(c,u,r)=>l.$setPassword(c,u,r),deletePassword:(c,u)=>l.$deletePassword(c,u),findPassword:c=>l.$findPassword(c),findCredentials(c){return l.$findCredentials(c)}}}load(g,i){const s=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const i=g.length;if(i<=7||!this.b)return;const s=i-7;if((g.charAt(s)==="/"||g.charAt(s)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};p=qe([We(1,y.IExtHostRpcService),We(2,D.IExtHostInitDataService)],p);let b=class{constructor(g,i,s){this.e=g,this.f=i,this.nodeModuleName=["open","opn"],this.d=s.getProxy(T.MainContext.MainThreadTelemetry);const o=s.getProxy(T.MainContext.MainThreadWindow);this.c=(l,c)=>{const u=t.URI.parse(l);return c?this.g(l,c):u.scheme==="http"||u.scheme==="https"?o.$openUri(u,l,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?o.$openUri(u,l,{}):this.g(l,c)}}load(g,i,s){const o=this.e.findSubstr(i);return o&&(this.a=o.identifier.value,this.h()),this.b=s(g),this.c}g(g,i){return this.i(),this.b(g,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([We(2,y.IExtHostRpcService)],b)}),define(ye[49],Ce([1,0,83,6,11,37,4,59,60,43,7,34,231,35]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class v extends w.AbstractVariableResolverService{constructor(f,p,b,S,g,i,s){function o(){if(b){const l=b.activeEditor();if(l)return l.document.uri;const c=S.tabGroups.all.find(u=>u.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof L.TextDiffTabInput||c.input instanceof L.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof L.TextTabInput||c.input instanceof L.NotebookEditorTabInput||c.input instanceof L.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:l=>{const c=i.folders.filter(u=>u.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,c)=>g.getConfiguration(void 0,l).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=o();if(l)return T.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const l=o();if(l){const c=p.getWorkspaceFolder(l);if(c)return T.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const l=b.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(b){const l=b.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>f.getExtension(l)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let m=class extends t.Disposable{constructor(f,p,b,S,g){super(),this.b=f,this.c=p,this.g=b,this.h=S,this.i=g,this.a=new a.Lazy(async()=>{const i=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,i,o,this.j())})}getResolver(){return this.a.getValue()}j(){}};m=qe([We(0,D.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,C.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(ye[81],Ce([1,0,14,3,10,2,4,5,60,43,18,7,34,131,223,35,49]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,l,c,u,r,n){this.D=l,this.E=c,this.F=u,this.G=r,this.H=n,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=o.getProxy(A.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(d=>{d.onDidChange(E=>{this.I(d)}),this.I(d)})}asDebugSourceUri(o,l){const c=o;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,r="?";return l&&(u+=`${r}session=${encodeURIComponent(l.id)}`,r="&"),u+=`${r}ref=${c.sourceReference}`,R.URI.parse(u)}else{if(c.path)return R.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(o){const l=[];for(const c of o.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const r of u)(0,v.isDebuggerMainContribution)(r)&&l.push(r.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const o=[];return this.w.forEach(l=>o.push(l)),o}addBreakpoints(o){this.T();const l=o.filter(r=>{const n=r.id;return this.w.has(n)?!1:(this.w.set(n,r),!0)});this.U(l,[],[]);const c=[],u=new Map;for(const r of l)if(r instanceof P.SourceBreakpoint){let n=u.get(r.location.uri.toString());n||(n={type:"sourceMulti",uri:r.location.uri,lines:[]},u.set(r.location.uri.toString(),n),c.push(n)),n.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof P.FunctionBreakpoint&&c.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(o){this.T();const l=o.filter(n=>this.w.delete(n.id));this.U([],l,[]);const c=l.filter(n=>n instanceof P.SourceBreakpoint).map(n=>n.id),u=l.filter(n=>n instanceof P.FunctionBreakpoint).map(n=>n.id),r=l.filter(n=>n instanceof P.DataBreakpoint).map(n=>n.id);return this.k.$unregisterBreakpoints(c,u,r)}startDebugging(o,l,c){return this.k.$startDebugging(o?o.uri:void 0,l,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,l,c){if(!l)return new P.Disposable(()=>{});const u=this.d++;return this.f.push({type:o,handle:u,provider:l}),this.k.$registerDebugConfigurationProvider(o,c,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,u),new P.Disposable(()=>{this.f=this.f.filter(r=>r.provider!==l),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(o,l,c){if(!c)return new P.Disposable(()=>{});if(!this.P(o,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:l,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(l,u),new P.Disposable(()=>{this.h=this.h.filter(r=>r.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(o,l){if(!l)return new P.Disposable(()=>{});const c=this.i++;return this.j.push({type:o,handle:c,factory:l}),new P.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==l)})}async $runInTerminal(o,l){return Promise.resolve(void 0)}async $substituteVariables(o,l){let c;const u=await this.W(o);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,l)}J(o,l){if(o.type==="implementation")return new g(o.implementation)}K(){}async $startDASession(o,l){const c=this,u=await this.V(l);return this.R(this.M(u.type),u).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const n=this.L(r),d=this.J(n,u);if(!d)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const E=d;return this.A.set(o,E),this.Q(u).then(k=>(k&&this.B.set(o,k),E.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const K=M,q={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(K.arguments.value);q.body={signature:F},E.sendResponse(q)}else throw new Error("no signer")}catch(F){q.success=!1,q.message=F.message,E.sendResponse(q)}}else k&&k.onDidSendMessage&&k.onDidSendMessage(M),M=(0,v.convertToVSCPaths)(M,!0),c.k.$acceptDAMessage(o,M)}),E.onError(M=>{k&&k.onError&&k.onError(M),this.k.$acceptDAError(o,M.name,M.message,M.stack)}),E.onExit(M=>{k&&k.onExit&&k.onExit((0,T.withNullAsUndefined)(M),void 0),this.k.$acceptDAExit(o,(0,T.withNullAsUndefined)(M),void 0)}),k&&k.onWillStartSession&&k.onWillStartSession(),E.startSession()))})}$sendDAMessage(o,l){l=(0,v.convertToDAPaths)(l,!1);const c=this.B.get(o);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(l),this.A.get(o)?.sendMessage(l)}$stopDASession(o){const l=this.B.get(o);this.B.delete(o),l&&l.onWillStopSession&&l.onWillStopSession();const c=this.A.get(o);return this.A.delete(o),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const l=[],c=[],u=[];if(o.added)for(const r of o.added){const n=r.id;if(n&&!this.w.has(n)){let d;if(r.type==="function")d=new P.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")d=new P.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const E=R.URI.revive(r.uri);d=new P.SourceBreakpoint(new P.Location(E,new P.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}(0,P.setBreakpointId)(d,n),this.w.set(n,d),l.push(d)}}if(o.removed)for(const r of o.removed){const n=this.w.get(r);n&&(this.w.delete(r),c.push(n))}if(o.changed){for(const r of o.changed)if(r.id){const n=this.w.get(r.id);if(n){if(n instanceof P.FunctionBreakpoint&&r.type==="function"){const d=n;d.enabled=r.enabled,d.condition=r.condition,d.hitCondition=r.hitCondition,d.logMessage=r.logMessage,d.functionName=r.functionName}else if(n instanceof P.SourceBreakpoint&&r.type==="source"){const d=n;d.enabled=r.enabled,d.condition=r.condition,d.hitCondition=r.hitCondition,d.logMessage=r.logMessage,d.location=new P.Location(R.URI.revive(r.uri),new P.Position(r.line,r.character))}u.push(n)}}}this.U(l,c,u)}$provideDebugConfigurations(o,l,c){return(0,a.asPromise)(async()=>{const u=this.O(o);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.W(l);return u.provideDebugConfigurations(r,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(o,l,c,u){return(0,a.asPromise)(async()=>{const r=this.O(o);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const n=await this.W(l);return r.resolveDebugConfiguration(n,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(o,l,c,u){return(0,a.asPromise)(async()=>{const r=this.O(o);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const n=await this.W(l);return r.resolveDebugConfigurationWithSubstitutedVariables(n,c,u)})}async $provideDebugAdapter(o,l){const c=this.N(o);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(l);return this.R(c,u).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(r)})}async $acceptDebugSessionStarted(o){const l=await this.V(o);this.m.fire(l)}async $acceptDebugSessionTerminated(o){const l=await this.V(o);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,l){(await this.V(o))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(o,l){const u={session:await this.V(o),event:l.event,body:l.body};this.u.fire(u)}L(o){if(o instanceof P.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof P.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}M(o){const l=this.h.filter(c=>c.type===o);if(l.length>0)return l[0].factory}N(o){const l=this.h.filter(c=>c.handle===o);if(l.length>0)return l[0].factory}O(o){const l=this.f.filter(c=>c.handle===o);if(l.length>0)return l[0].provider}P(o,l){if(o.contributes){const c=o.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===l)return!0}}return!1}Q(o){const c=o.configuration.type,u=this.j.filter(r=>r.type===c||r.type==="*").map(r=>(0,a.asPromise)(()=>r.factory.createDebugAdapterTracker(o)).then(n=>n,n=>null));return Promise.race([Promise.all(u).then(r=>{const n=r.filter(d=>!!d);if(n.length>0)return new S(n)}),new Promise(r=>setTimeout(()=>r(void 0),1e3))]).catch(r=>{})}async R(o,l){const c=l.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new P.DebugAdapterServer(c));if(o){const r=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>o.createDebugAdapterDescriptor(l,this.S(l,r))).then(n=>{if(n)return n})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,u))}S(o,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(o,l,c){(o.length>0||l.length>0||c.length>0)&&this.z.fire(Object.freeze({added:o,removed:l,changed:c}))}async V(o){if(o)if(typeof o=="string"){const l=this.l.get(o);if(l)return l}else{let l=this.l.get(o.id);if(!l){const c=await this.W(o.folderUri),u=o.parent?this.l.get(o.parent):void 0;l=new p(this.k,o.id,o.type,o.name,c,o.configuration,u),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(o){if(o){const l=R.URI.revive(o);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};f=qe([We(0,L.IExtHostRpcService),We(1,w.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,h.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class p{constructor(o,l,c,u,r,n,d){this.d=o,this.f=l,this.g=c,this.h=u,this.i=r,this.j=n,this.k=d}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,l){return this.d.$customDebugAdapterRequest(this.f,o,l)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.ExtHostDebugSession=p;class b{constructor(o){this.value=Object.freeze({append(l){o.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=b;class S{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(l=>l.onError?l.onError(o):void 0)}onExit(o,l){this.d.forEach(c=>c.onExit?c.onExit(o,l):void 0)}}class g extends C.AbstractDebugAdapter{constructor(o){super(),this.h=o,o.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends f{constructor(o,l,c,u,r,n){super(o,l,c,u,r,n)}};i=qe([We(0,L.IExtHostRpcService),We(1,w.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,h.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[295],Ce([1,0,9,80,2,5,287,13,89,90,25,201,18,56,43,96]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{static async installEarlyHandler(b){const S=b.get(A.ILogService),i=b.get(w.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(s=>{S.error(s);const o=a.transformErrorForSerialization(s);i.$onUnexpectedError(o)})}static async installFullHandler(b){const S=b.get(A.ILogService),g=b.get(w.IExtHostRpcService),i=b.get(v.IExtHostExtensionService),s=b.get(m.IExtHostTelemetry),o=g.getProxy(R.MainContext.MainThreadExtensionService),l=g.getProxy(R.MainContext.MainThreadErrors),c=await i.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(r,n)=>{let d="",E,k;for(const M of n)d+=`
	at ${M.toString()}`,k=M.getFileName(),!E&&k&&(E=c.findSubstr(T.URI.file(k)));return u.set(r,E?.identifier),`${r.name||"Error"}: ${r.message||""}${d}`},a.setUnexpectedErrorHandler(r=>{S.error(r);const n=a.transformErrorForSerialization(r),d=u.get(r);if(!d){l.$onUnexpectedError(n);return}o.$onExtensionRuntimeError(d,n);const E=s.onExtensionError(d,r);S.trace("forwarded error to extension?",E,d)})}}Error.stackTraceLimit=100;class f{constructor(b,S,g,i,s){this.a=g,this.b=new I.RPCProtocol(b,null,i),S=f.e(S,this.b);const o=new D.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:s}),o.set(w.IExtHostRpcService,new w.ExtHostRpcService(this.b)),o.set(C.IURITransformerService,new C.URITransformerService(i)),o.set(v.IHostUtils,g);const l=new P.InstantiationService(o,!0);l.invokeFunction(h.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(A.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=l.invokeFunction(c=>c.get(v.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(h.installFullHandler)}async asBrowserUri(b){const S=this.b.getProxy(R.MainContext.MainThreadExtensionService);return T.URI.revive(await S.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,S){b.allExtensions.forEach(i=>{i.extensionLocation=T.URI.revive(S.transformIncomingURIs(i.extensionLocation));const s={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(o=>s[o]=T.URI.revive(S.transformIncomingURIs(i.browserNlsBundleUris[o]))),i.browserNlsBundleUris=s)}),b.environment.appRoot=T.URI.revive(S.transformIncomingURIs(b.environment.appRoot));const g=b.environment.extensionDevelopmentLocationURI;return g&&(b.environment.extensionDevelopmentLocationURI=g.map(i=>T.URI.revive(S.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=T.URI.revive(S.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=T.URI.revive(S.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=T.URI.revive(S.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=T.URI.revive(S.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=T.URI.revive(S.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=T.URI.revive(S.transformIncomingURIs(b.logsLocation)),b.logFile=T.URI.revive(S.transformIncomingURIs(b.logFile)),b.workspace=S.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=f}),define(ye[296],Ce([1,0,14,12,183,200,207,81,60,43,18,42,7,49,34,224,226,35]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let p=class extends A.ExtHostDebugServiceBase{constructor(s,o,l,c,u,r,n){super(s,o,l,c,r,n),this.Z=u,this.X=new g}J(s,o){switch(s.type){case"server":return new m.SocketDebugAdapter(s);case"pipeServer":return new m.NamedPipeDebugAdapter(s);case"executable":return new m.ExecutableDebugAdapter(s,o.type)}return super.J(s,o)}S(s,o){const l=m.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),s.type);if(l)return new w.DebugAdapterExecutable(l.command,l.args,l.options)}K(){return new I.SignService}async $runInTerminal(s,o){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const l=await this.F.getConfigProvider(),c=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),r=s.title||T.localize(0,null),n=JSON.stringify({shell:c,shellArgs:u});let d=await this.X.checkout(n,r),E,k=!1;if(d)E=s.cwd;else{const F={shellPath:c,shellArgs:u,cwd:s.cwd,name:r,iconPath:new w.ThemeIcon("debug")};k=!0,d=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(d,n)}d.show(!0);const M=await d.processId;k?await new Promise(F=>setTimeout(F,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?d.sendText("cls"):c.indexOf("bash")>=0?d.sendText("clear"):t.isWindows?d.sendText("cls"):d.sendText("clear"));const K=(0,h.prepareCommand)(c,s.args,!!s.argsCanBeInterpretedByShell,E,s.env);d.sendText(K);const q=this.onDidTerminateDebugSession(F=>{F.id===o&&(this.X.free(d),q.dispose())});return M}else if(s.kind==="external")return S(s,await this.F.getConfigProvider());return super.$runInTerminal(s,o)}};p=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,C.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let b;function S(i,s){if(!b)if(t.isWindows)b=new R.WindowsExternalTerminalService;else if(t.isMacintosh)b=new R.MacExternalTerminalService;else if(t.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=s.getConfiguration("terminal");return b.runInTerminal(i.title,i.cwd,i.args,i.env||{},o.external||{})}class g{constructor(){this.b=new Map}async checkout(s,o){const c=[...this.b.entries()].map(([u,r])=>(0,a.createCancelablePromise)(async n=>{if(u.name!==o||r.lastUsedAt!==-1&&await(0,h.hasChildProcesses)(await u.processId))return null;const d=Date.now();return r.lastUsedAt+g.a>d||n.isCancellationRequested||r.config!==s?null:(r.lastUsedAt=d,u)}));return await(0,a.firstParallel)(c,u=>!!u)}insert(s,o){this.b.set(s,{lastUsedAt:Date.now(),config:o})}free(s){const o=this.b.get(s);o&&(o.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}g.a=1e3}),define(ye[297],Ce([1,0,11,2,116,34,59,35,47,42,18,25,79,17,13,74,24,88,49]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends w.ExtHostTaskBase{constructor(g,i,s,o,l,c,u,r,n){super(g,i,s,o,l,c,u,r),this.B=s,this.C=n,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const o=w.TaskHandleDTO.from(s,this.B),l=await this.a.$getTaskExecution(o);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(l,i);return this.a.$executeTask(o).catch(()=>{}),c}else{const o=w.TaskDTO.from(i,g);if(o===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(o.execution)&&await this.x(o,i,!1);const l=await this.y(await this.a.$getTaskExecution(o),i);return this.a.$executeTask(o).catch(()=>{}),l}}u(g,i,s,o){const l=[];if(o)for(const c of o){this.z(c,s),(!c.definition||!g[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const u=w.TaskDTO.from(c,s.extension);u&&(l.push(u),w.CustomExecutionDTO.is(u.execution)&&i.push(this.x(u,c,!0)))}return{tasks:l,extension:s.extension}}async v(g){return g}async F(g){let i=g&&g.length>0?g[0]:void 0;if(!i){const s=t.URI.file((0,f.homedir)());i=new y.WorkspaceFolder({uri:s,name:h.basename(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,i){const s=t.URI.revive(g),o={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(s),c=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),r=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const n of i.variables)o.variables[n]=await u.resolveAsync(r,n);if(i.process!==void 0){let n;if(i.process.path!==void 0){n=i.process.path.split(a.delimiter);for(let d=0;d<n.length;d++)n[d]=await u.resolveAsync(r,n[d])}o.process=await T.win32.findExecutable(await u.resolveAsync(r,i.process.name),i.process.cwd!==void 0?await u.resolveAsync(r,i.process.cwd):void 0,n)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(g,i,s){return T.win32.findExecutable(g,i,s)}};b=qe([We(0,L.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,I.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,v.ILogService),We(7,m.IExtHostApiDeprecationService),We(8,p.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[298],Ce([1,0,88,49]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class T extends t.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=T}),define(ye[143],Ce([1,0,16,14,21,45,17,11,24,2,31]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(p,b,S,g){this.d=p,this.e=b,this.f=S,this.g=g,this.a=null,this.b=!1,this.c=0}search(p,b){const S=this.d.folderQueries||[],g=new T.CancellationTokenSource;return b.onCancellationRequested(()=>g.cancel()),new Promise((i,s)=>{this.a=new C(p);let o=!1;const l=(c,u)=>{if(!o&&!this.b){const r=this.h(c);m(c)&&typeof this.d.maxResults=="number"&&this.c+r>this.d.maxResults&&(this.b=!0,o=!0,g.cancel(),c=this.j(c,this.d.maxResults-this.c));const n=this.h(c);this.c+=n,(n>0||!m(c))&&this.a.add(c,u)}};Promise.all(S.map((c,u)=>this.k(c,r=>l(r,u),g.token))).then(c=>{g.dispose(),this.a.flush();const u=c.some(r=>!!r&&!!r.limitHit);i({limitHit:this.b||u,messages:(0,a.flatten)(c.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.g}})},c=>{g.dispose();const u=(0,R.toErrorMessage)(c);s(new Error(u))})})}h(p){return m(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const S=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:S.slice(0,b),preview:{matches:g.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,S){const g=new L.QueryGlobTester(this.d,p),i=[],s={report:c=>{if(!this.l(c))return;const u=p.folder.scheme===I.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(c.uri))):void 0,r=y.relativePath(p.folder,c.uri);if(r){const n=g.includedInQuery(r,A.basename(r),u);(0,t.isThenable)(n)?i.push(n.then(d=>{d&&b(c)})):n&&b(c)}}},o=this.n(p),l=await this.e.provideTextSearchResults(w(this.d.contentPattern),o,s,S);return i.length&&await Promise.all(i),l}l(p){if(m(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),S=(0,L.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),g={folder:D.URI.from(p.folder),excludes:S,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=P;function w(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class C{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new h(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(v(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=C;function v(f){return m(f)?{preview:{matches:(0,a.mapArrayOrNot)(f.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:f.preview.text},ranges:(0,a.mapArrayOrNot)(f.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function m(f){return!!f.preview}e.extensionResultIsMatch=m;class h{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=h,h.a=4e3,h.b=50}),define(ye[82],Ce([1,0,6,5,4,291,18,56,13,2,143]),function(te,e,a,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let P=class{constructor(m,h,f){this.k=m,this.l=h,this.n=f,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(m){return this.l.transformOutgoingScheme(m)}registerTextSearchProvider(m,h){if(this.g.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this.g.add(m);const f=this.d++;return this.e.set(f,h),this.c.$registerTextSearchProvider(f,this.o(m)),(0,a.toDisposable)(()=>{this.g.delete(m),this.e.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(m,h){if(this.i.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this.i.add(m);const f=this.d++;return this.h.set(f,h),this.c.$registerFileSearchProvider(f,this.o(m)),(0,a.toDisposable)(()=>{this.i.delete(m),this.h.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(m,h,f,p){const b=w(f),S=this.h.get(m);if(S)return this.j.fileSearch(b,S,g=>{this.c.$handleFileMatch(m,h,g.map(i=>i.resource))},p);throw new Error("unknown provider: "+m)}$clearCache(m){return this.j.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,h,f,p){const b=this.e.get(m);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const S=w(f);return this.q(S,b).search(i=>this.c.$handleTextMatch(m,h,i),p)}$enableExtensionHostSearch(){}q(m,h){return new L.TextSearchManager(m,h,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};P=qe([We(0,I.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],P),e.ExtHostSearch=P;function w(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(C),extraFileResources:v.extraFileResources&&v.extraFileResources.map(m=>D.URI.revive(m))}}e.reviveQuery=w;function C(v){return{...v,folder:D.URI.revive(v.folder)}}}),define(ye[299],Ce([1,0,89,142,34,139,35,41,59,42,79,81,82,99,55,74,141,75,48,98,96,60,140,13,236,49,97]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g,i,s,o,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,a.registerSingleton)(s.ILoggerService,i.ExtHostLoggerService,1),(0,a.registerSingleton)(s.ILogService,o.ExtHostLogService,1),(0,a.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,a.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,a.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,a.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,a.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,a.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch,0),(0,a.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,a.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,a.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,a.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow,0),(0,a.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,0),(0,a.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,a.registerSingleton)(S.IExtHostTelemetry,S.ExtHostTelemetry,0),(0,a.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,a.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(ye[100],Ce([1,0,16,13,31,78]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function I(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=I;function A(P,w,C,v){const m=(0,a.mapArrayOrNot)(C,y),h=new T.TextSearchMatch(w,m,v),f=h.preview.matches;return{ranges:(0,a.mapArrayOrNot)(m,D),uri:P,preview:{text:h.preview.text,matches:(0,a.mapArrayOrNot)(f,D)}}}e.createTextSearchResult=A;function y(P){return new T.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function D(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(w,C){this.a=w,this.b=C}appendLine(w){this.b.debug(`${this.a}#search`,w)}};L=qe([We(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[300],Ce([1,0,46,11,84,32,12,8,100,301]),function(te,e,a,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(b,S,g,i){const s=w(b,S,g,i),o=S.folder.fsPath;return{cmd:a.spawn(L,s.args,{cwd:o}),rgDiskPath:L,siblingClauses:s.siblingClauses,rgArgs:s,cwd:o}}e.spawnRipgrepCmd=P;function w(b,S,g,i){const s=["--files","--hidden","--case-sensitive"];v([S],g,!1).forEach(l=>{const c=(0,y.anchorGlob)(l);if(s.push("-g",c),I.isMacintosh){const u=(0,T.normalizeNFD)(c);u!==c&&s.push("-g",u)}});const o=C([S],i,void 0,!1);return o.globArgs.forEach(l=>{const c=`!${(0,y.anchorGlob)(l)}`;if(s.push("-g",c),I.isMacintosh){const u=(0,T.normalizeNFD)(c);u!==c&&s.push("-g",u)}}),S.disregardIgnoreFiles!==!1?s.push("--no-ignore"):S.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),S.ignoreSymlinks||s.push("--follow"),b.exists&&s.push("--quiet"),s.push("--no-config"),S.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:o.siblingClauses}}function C(b,S,g,i=!0){const s=[];let o={};return b.forEach(l=>{const c=Object.assign({},l.excludePattern||{},S||{}),u=m(c,i?l.folder.fsPath:void 0,g);s.push(...u.globArgs),u.siblingClauses&&(o=Object.assign(o,u.siblingClauses))}),{globArgs:s,siblingClauses:o}}function v(b,S,g=!0){const i=[];return b.forEach(s=>{const o=Object.assign({},S||{},s.includePattern||{}),l=m(o,g?s.folder.fsPath:void 0);i.push(...l.globArgs)}),i}function m(b,S,g){const i=[],s={};return Object.keys(b).forEach(o=>{if(g&&g.has(o)||!o)return;const l=b[o];o=f(S?h(S,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof l=="boolean"&&l?(o.startsWith("\\\\")&&(o+="**"),i.push(p(o))):l&&l.when&&(s[o]=l)}),{globArgs:i,siblingClauses:s}}function h(b,S){return t.isAbsolute(S)?S:t.join(b,S)}e.getAbsoluteGlob=h;function f(b){return b=A.rtrim(b,"\\"),A.rtrim(b,"/")}function p(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=p}),define(ye[302],Ce([1,0,46,67,11,303,16,45,39,84,32,12,44,8,10,29,31,300,111]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(o=>o())});class S{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&y.parse(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,p.prepareQuery)(this.b).normalizedLowercase),this.u=l.excludePattern&&y.parse(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const u=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),r=c.folder.fsPath;l.folderQueries.map(n=>n.folder.fsPath).filter(n=>n!==r).forEach(n=>{(0,L.isEqualOrParent)(n,r)&&(u[T.relative(r,n)]=!0)}),this.t.set(r,new i(u,r))})}cancel(){this.l=!0,b.forEach(l=>l())}walk(l,c,u,r,n){if(this.m=w.StopWatch.create(!1),this.l)return n(null,this.j);c.forEach(d=>{const E=T.basename(d.fsPath);this.u&&this.u(d.fsPath,E)||this.J(u,{relativePath:d.fsPath,searchPath:void 0})}),this.r=w.StopWatch.create(!1),this.w(l,(d,E)=>{this.x(this.y,this,d,u,r,k=>{if(k){const M=(0,A.toErrorMessage)(k);console.error(M),this.q.push(M),E(k,void 0)}else E(null,void 0)})},(d,E)=>{this.m.stop();const k=d?I.coalesce(d)[0]:null;n(k,this.j)})}w(l,c,u){const r=new Array(l.length),n=new Array(l.length);let d=!1,E=0;if(l.length===0)return u(null,[]);l.forEach((k,M)=>{c(k,(K,q)=>{if(K?(d=!0,r[M]=null,n[M]=K):(r[M]=q,n[M]=null),++E===l.length)return u(d?n:null,r)})})}x(l,c,...u){try{l.apply(c,u)}catch(r){u[u.length-1](r)}}y(l,c,u,r){const n=l.folder.fsPath,d=P.isMacintosh,E=()=>F&&F.kill();b.add(E);let k=$=>{b.delete(E),k=()=>{},r($)},M="";const K=this.D(),q=(0,f.spawnRipgrepCmd)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),F=q.cmd,B=!Object.keys(q.siblingClauses).length,O=q.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let U=`${q.rgDiskPath} ${O}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),u({message:U}),this.s=0,this.z(F,"utf8",u,($,j,ue)=>{if($){k($);return}if(this.j){k();return}const _=(M+(d?D.normalizeNFC(j||""):j)).split(`
`);if(ue){const Y=_.length;_[Y-1]=_[Y-1].trim(),_[Y-1]||_.pop()}else M=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=_.length,B){for(const Y of _)if(this.J(c,{base:n,relativePath:Y,searchPath:this.N(l,Y)}),this.j){E();break}(ue||this.j)&&k();return}this.G(l,K,n,_,c),ue&&(this.H(K,n,c),k())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),u=c.getBasenameTerms(),r=c.getPathTerms(),n=["-L","."];if(u.length||r.length){n.push("-not","(","(");for(const d of u)n.push("-name",d),n.push("-o");for(const d of r)n.push("-path",d),n.push("-o");n.pop(),n.push(")","-prune",")")}return n.push("-type","f"),a.spawn("find",n,{cwd:l.folder.fsPath})}readStdout(l,c,u){let r="";this.z(l,c,()=>{},(n,d,E)=>{if(n){u(n);return}r+=d,E&&u(null,r)})}z(l,c,u,r){let n=(k,M,K)=>{(k||K)&&(n=()=>{},this.r?.stop()),r(k,M,K)},d=!1;l.stdout?(this.A(l.stdout,c,n),l.stdout.once("data",()=>d=!0)):u({message:"stdout is null"});let E;l.stderr?E=this.B(l.stderr):u({message:"stderr is null"}),l.on("error",k=>{n(k)}),l.on("close",k=>{let M;!d&&(M=this.C(E,c))&&s(M)?n(new Error(`command failed with error code ${k}: ${this.C(E,c)}`)):(this.g&&k===0&&(this.j=!0),n(null,"",!0))})}A(l,c,u){const r=new R.StringDecoder(c);return l.on("data",n=>{u(null,r.write(n))}),r}B(l){const c=[];return l.on("data",u=>{c.push(u)}),c}C(l,c){const u=new R.StringDecoder(c);return l.map(r=>u.write(r)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},u,r,n){r.indexOf(this.b)!==-1&&this.J(n,{base:u,relativePath:this.b,searchPath:this.N(l,this.b)});const d=E=>{const k=T.basename(E),M=T.dirname(E);let K=c[M];K||(K=c[M]=[],d(M)),K.push({base:u,relativePath:E,basename:k,searchPath:this.N(l,E)})};r.forEach(d)}H({rootEntries:l,pathToEntries:c},u,r){const n=this,d=this.t.get(u),E=this.b;function k(M){n.o++;const K=(0,h.hasSiblingFn)(()=>M.map(q=>q.basename));for(let q=0,F=M.length;q<F;q++){const B=M[q],{relativePath:O,basename:U}=B;if(d.test(O,U,E!==U?K:void 0))continue;const $=c[O];if($)k($);else{if(n.p++,O===E)continue;n.J(r,B)}if(n.j)break}}k(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,u,r,n){const d=l.folder,E=(0,h.hasSiblingFn)(()=>u);this.w(u,(k,M)=>{if(this.l||this.j)return M(null);const K=c?[c,k].join(T.sep):k;if(this.t.get(l.folder.fsPath).test(K,k,this.a.filePattern!==k?E:void 0))return M(null);const q=[d.fsPath,K].join(T.sep);t.lstat(q,(F,B)=>{if(F||this.l||this.j)return M(null);this.L(q,B,(O,U)=>O||this.l||this.j?M(null):U.isDirectory()?(this.o++,this.M(q,B,($,j)=>$||this.l||this.j||(j=j||"",this.v[j])?M(null):(this.v[j]=!0,m.Promises.readdir(q).then(ue=>{if(this.l||this.j)return M(null);this.I(l,K,ue,r,V=>M(V||null))},ue=>{M(null)})))):(this.p++,K===this.b||this.h&&v.isNumber(U.size)&&U.size>this.h||this.J(r,{base:d.fsPath,relativePath:K,searchPath:this.N(l,K)}),M(null,void 0)))})},k=>{const M=k&&I.coalesce(k);return n(M&&M.length>0?M[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,T.basename(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.isFilePatternMatch)(l,this.c)}return!0}L(l,c,u){return c.isSymbolicLink()?t.stat(l,u):u(null,c)}M(l,c,u){return c.isSymbolicLink()?t.realpath(l,(r,n)=>r?u(r):u(null,n)):u(null,l)}N(l,c){return l.folderName?T.join(l.folderName,c):c}}e.FileWalker=S;class g{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new S(l)}search(l,c,u){this.c.walk(this.a,this.b,l,c,(r,n)=>{u(r,{limitHit:n,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class i{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,u;Object.keys(l).filter(r=>l[r]).forEach(r=>{T.isAbsolute(r)?(c=c||y.getEmptyExpression(),c[r]=l[r]):(u=u||y.getEmptyExpression(),u[r]=l[r])}),this.a=c&&y.parse(c,{trimForExclusions:!0}),this.b=u&&y.parse(u,{trimForExclusions:!0})}test(l,c,u){return this.b&&this.b(l,c,u)||this.a&&this.a(T.join(this.c,l),c,u)}getBasenameTerms(){const l=[];return this.a&&l.push(...y.getBasenameTerms(this.a)),this.b&&l.push(...y.getBasenameTerms(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...y.getPathTerms(this.a)),this.b&&l.push(...y.getPathTerms(this.b)),l}}function s(o){const l=o.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return C.uppercaseFirstLetter(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ye[304],Ce([1,0,103,23]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===o)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,I=512,A=512*8,y=512*128;var D;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(l,c){super(l),this.decodeStreamErrorKind=c}}e.DecodeStreamError=L;class P{static async create(l){let c;if(l!==e.UTF8)c=(await new Promise((r,n)=>{te(["@vscode/iconv-lite-umd"],r,n)})).getDecoder(m(l));else{const u=new TextDecoder;c={write(r){return u.decode(r,{stream:!0})},end(){return u.decode()}}}return new P(c)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function w(o,l){const c=l.minBytesRequiredForDetection??l.guessEncoding?A:I;return new Promise((u,r)=>{const n=(0,a.newWriteableStream)(q=>q.join("")),d=[];let E=0,k,M;const K=async()=>{try{const q=await s({buffer:t.VSBuffer.concat(d),bytesRead:E},l.guessEncoding);if(q.seemsBinary&&l.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await l.overwriteEncoding(q.encoding),k=await P.create(q.encoding);const F=k.write(t.VSBuffer.concat(d).buffer);n.write(F),d.length=0,E=0,u({stream:n,detected:q})}catch(q){M?.dispose(),n.destroy(),r(q)}};M=(0,a.listenStream)(o,{onData:async q=>{k?n.write(k.write(q.buffer)):(d.push(q),E+=q.byteLength,E>=c&&(o.pause(),await K(),setTimeout(()=>o.resume())))},onError:q=>n.error(q),onEnd:async()=>{k||await K(),n.end(k?.end())}})})}e.toDecodeStream=w;async function C(o,l,c){const r=(await new Promise((E,k)=>{te(["@vscode/iconv-lite-umd"],E,k)})).getEncoder(m(l),c);let n=!1,d=!1;return{read(){if(d)return null;const E=o.read();if(typeof E!="string"){if(d=!0,!n&&c?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const k=r.end();return k&&k.length>0?(n=!0,t.VSBuffer.wrap(k)):null}return n=!0,t.VSBuffer.wrap(r.write(E))}}}e.toEncodeReadable=C;async function v(o){return(await new Promise((c,u)=>{te(["@vscode/iconv-lite-umd"],c,u)})).encodingExists(m(o))}e.encodingExists=v;function m(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=m;function h(o,l){if(!o||l<e.UTF16be_BOM.length)return null;const c=o.readUInt8(0),u=o.readUInt8(1);if(c===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(c===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const r=o.readUInt8(2);return c===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&r===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const f=["ascii","utf-16","utf-32"];async function p(o){const l=await new Promise((d,E)=>{te(["jschardet"],d,E)}),c=o.slice(0,y),u=g(c.buffer),r=l.detect(u);if(!r||!r.encoding)return null;const n=r.encoding.toLowerCase();return 0<=f.indexOf(n)?null:S(r.encoding)}const b={ibm866:"cp866",big5:"cp950"};function S(o){const l=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[l]||l}function g(o){let l="";for(let c=0;c<o.length;c++)l+=String.fromCharCode(o[c]);return l}function i(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=o.match(/windows(\d+)/);return l?"windows-"+l[1]:o}}}e.toCanonicalName=i;function s({buffer:o,bytesRead:l},c){let u=h(o,l),r=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&o){let n=!0,d=!0,E=!1;for(let k=0;k<l&&k<R;k++){const M=k%2===1,K=o.readUInt8(k)===0;if(K&&(E=!0),n&&(M&&!K||!M&&K)&&(n=!1),d&&(M&&K||!M&&!K)&&(d=!1),K&&!n&&!d)break}E&&(n?u=e.UTF16le:d?u=e.UTF16be:r=!0)}return c&&!r&&!u&&o?p(o.slice(0,l)).then(n=>({seemsBinary:!1,encoding:n})):{seemsBinary:r,encoding:u}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,304,29,143]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends T.TextSearchManager{constructor(A,y,D=t,L="searchProcess"){super(A,y,{readdir:P=>D.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,a.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=R}),define(ye[305],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const R=this.a.get(T);return this.a.delete(T),R}}addDragOperationTransfer(T,R){this.a.set(T,R)}getRenderedTreeElement(T){if(this.b.has(T))return this.b.get(T)}addRenderedTreeItemElement(T,R){this.b.set(T,R)}removeRenderedTreeItemElement(T){this.b.has(T)&&this.b.delete(T)}}e.TreeviewsService=a}),define(ye[306],Ce([1,0,181,7,24,2,3,6,221,14,7,10,16,15,21,305,26]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(S,g){if((0,P.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let i;return Array.isArray(S.highlights)&&(i=S.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:S.label,highlights:i}}}class p{constructor(g,i,s){this.d=g,this.e=i,this.f=s,this.a=new Map,this.b=new m.TreeviewsService;function o(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>o(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(c=>o(c)?this.i(c):c):l})}registerTreeDataProvider(g,i,s){const o=this.createTreeView(g,{treeDataProvider:i},s);return{dispose:()=>o.dispose()}}createTreeView(g,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],c=!!i.dragAndDropController?.handleDrag,u=!!i.dragAndDropController?.handleDrop,r=this.h(g,i,s),n=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:o,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:u});return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,h.checkProposedApiEnabled)(s,"treeItemCheckbox"),r.onDidChangeCheckboxState},get message(){return r.message},set message(d){r.message=d},get title(){return r.title},set title(d){r.title=d},get description(){return r.description},set description(d){r.description=d},get badge(){return r.badge},set badge(d){d!==void 0&&L.ViewBadge.isViewBadge(d)?r.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(r.badge=void 0)},reveal:(d,E)=>r.reveal(d,E),dispose:async()=>{await n,this.a.delete(g),r.dispose()}}}$getChildren(g,i){const s=this.a.get(g);return s?s.getChildren(i):Promise.reject(new y.NoTreeViewError(g))}async $handleDrop(g,i,s,o,l,c,u,r){const n=this.a.get(g);if(!n)return Promise.reject(new y.NoTreeViewError(g));const d=C.DataTransfer.toDataTransfer(s,async E=>(await this.d.$resolveDropFileData(g,i,E)).buffer);return u===g&&r&&await this.g(d,n,r,l,c),n.onDrop(d,o,l)}async g(g,i,s,o,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((u,r)=>{u&&g.set(r,u)});else if(l&&i.handleDrag){const u=i.handleDrag(s,g,o);this.b.addDragOperationTransfer(l,u),await u}return g}async $handleDrag(g,i,s,o){const l=this.a.get(g);if(!l)return Promise.reject(new y.NoTreeViewError(g));const c=await this.g(new t.DataTransfer,l,i,o,s);if(!!c)return C.DataTransfer.toDataTransferDTO(c)}async $hasResolve(g){const i=this.a.get(g);if(!i)throw new y.NoTreeViewError(g);return i.hasResolve}$resolve(g,i,s){const o=this.a.get(g);if(!o)throw new y.NoTreeViewError(g);return o.resolveTreeItem(i,s)}$setExpanded(g,i,s){const o=this.a.get(g);if(!o)throw new y.NoTreeViewError(g);o.setExpanded(i,s)}$setSelection(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setSelection(i)}$setFocus(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setFocus(i)}$setVisible(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setVisible(i)}$changeCheckboxState(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setCheckboxState(i)}h(g,i,s){const o=new b(g,i,this.d,this.e.converter,this.f,s);return this.a.set(g,o),o}i(g){const i=this.a.get(g.$treeViewId);return i&&"$treeItemHandle"in g?i.getExtensionElement(g.$treeItemHandle):i&&"$focusedTreeItem"in g&&g.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=p;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,P.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,i,s,o,l,c){if(super(),this.C=g,this.D=s,this.F=o,this.G=l,this.H=c,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new v.CancellationTokenSource,c.contributes&&c.contributes.views)for(const n in c.contributes.views)for(const d of c.contributes.views[n])d.id===g&&(this.J=d.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let u,r;this.B(I.Event.debounce(this.w.event,(n,d)=>(n||(n={message:!1,elements:[]}),d.element!==!1&&(u||(u=new Promise(E=>r=E),this.y=this.y.then(()=>u)),Array.isArray(d.element)?n.elements.push(...d.element):n.elements.push(d.element)),d.message&&(n.message=!0),n),200,!0)(({message:n,elements:d})=>{d.length&&(this.z=this.z.then(()=>{const E=r;return u=null,this.U(d).then(()=>E())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const i=g?this.getExtensionElement(g):void 0;if(g&&!i)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let s=this.Q(g);return s||(s=await this.R(i)),s?s.map(o=>o.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,i){i=i||{select:!0,focus:!1};const s=(0,P.isUndefinedOrNull)(i.select)?!0:i.select,o=(0,P.isUndefinedOrNull)(i.focus)?!1:i.focus,l=(0,P.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(c=>this.P(g,c[c.length-1]).then(u=>this.D.$reveal(this.C,{item:u.item,parentChain:c.map(r=>r.item)},{select:s,focus:o,expand:l})),c=>this.G.error(c)):this.D.$reveal(this.C,void 0,{select:s,focus:o,expand:l})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=C.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,i){const s=this.getExtensionElement(g);s&&(i?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(g){(0,w.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const i=(await Promise.all(g.map(async s=>{const o=this.getExtensionElement(s.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:s.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(g,i,s){const o=[];for(const l of g){const c=this.getExtensionElement(l);c&&o.push(c)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,i,s){const o=i?this.getExtensionElement(i):void 0;if(!(!o&&i||!this.g?.handleDrop))return(0,D.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,g,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,i){if(!this.f.resolveTreeItem)return;const s=this.i.get(g);if(s){const o=this.j.get(s);if(o){const l=await this.f.resolveTreeItem(o.extensionItem,s,i)??o.extensionItem;return this.db(l),o.item.tooltip=this.ab(l.tooltip),o.item.command=this.bb(o.disposableStore,l.command),o.item}}}N(g){return this.O(g).then(i=>i?this.N(i).then(s=>this.P(i,s[s.length-1]).then(o=>(s.push(o),s))):Promise.resolve([]))}O(g){const i=this.j.get(g);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,D.asPromise)(()=>this.f.getParent(g))}P(g,i){const s=this.j.get(g);return s?Promise.resolve(s):(0,D.asPromise)(()=>this.f.getTreeItem(g)).then(o=>this.gb(g,o,i,!0)).then(o=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(o);if(l){const c=this.j.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(g){if(g){let i;if(typeof g=="string"){const s=this.getExtensionElement(g);i=s?this.j.get(s):void 0}else i=g;return i&&i.children||void 0}return this.h}async R(g){this.nb(g);const i=new v.CancellationTokenSource(this.S.token);try{const s=g?this.j.get(g):void 0,o=await this.f.getChildren(g);if(i.token.isCancellationRequested)return;const l=await Promise.all((0,w.coalesce)(o||[]).map(async c=>{const u=await this.f.getTreeItem(c);return u&&!i.token.isCancellationRequested?this.Z(c,u,s):null}));return i.token.isCancellationRequested?void 0:(0,w.coalesce)(l)}finally{i.dispose()}}U(g){if(g.some(s=>!s))return this.S.dispose(!0),this.S=new v.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(g);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(g){const i=new Set,s=g.map(l=>this.j.get(l));for(const l of s)if(l&&!i.has(l.item.handle)){let c=l;for(;c&&c.parent&&s.findIndex(u=>c&&c.parent&&u&&u.item.handle===c.parent.item.handle)===-1;){const u=this.i.get(c.parent.item.handle);c=u?this.j.get(u):void 0}c&&!c.parent&&i.add(l.item.handle)}const o=[];return i.forEach(l=>{const c=this.i.get(l);if(c){const u=this.j.get(c);u&&(!u.parent||!i.has(u.parent.item.handle))&&o.push(l)}}),o}X(g){const i={};return Promise.all(g.map(s=>this.Y(s).then(o=>{o&&(i[s]=o.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(g){const i=this.getExtensionElement(g);if(i){const s=this.j.get(i);if(s)return this.nb(i),(0,D.asPromise)(()=>this.f.getTreeItem(i)).then(o=>{if(o){const l=this.eb(i,o,s.parent);return this.lb(i,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}Z(g,i,s){const o=this.eb(g,i,s);if(i.id&&this.i.has(o.item.handle))throw new Error((0,a.localize)(0,null,i.id));return this.kb(g,o),this.mb(o,s),o}ab(g){return L.MarkdownString.isMarkdownString(g)?C.MarkdownString.from(g):g}bb(g,i){return i?{...this.F.toInternal(i,g),originalId:i.command}:void 0}cb(g){if(!g.checkboxState)return;let i,s;return typeof g.checkboxState=="number"?i=g.checkboxState:(i=g.checkboxState.state,s=g.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:s}}db(g){if(!L.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,i,s){this.db(i);const o=new A.DisposableStore,l=this.gb(g,i,s),c=this.hb(i);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:f(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(o,i.command),contextValue:i.contextValue,icon:c,iconDark:this.ib(i)||c,themeIcon:this.fb(i),collapsibleState:(0,P.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(g){return g.iconPath instanceof L.ThemeIcon?g.iconPath:void 0}gb(g,{id:i,label:s,resourceUri:o},l,c){if(i)return`${b.b}/${i}`;const u=f(s,this.H),r=l?l.item.handle:b.a;let n=u?u.label:o?(0,T.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const d=this.j.has(g)?this.j.get(g).item.handle:void 0,E=this.Q(l)||[];let k,M=0;do{if(k=`${r}/${M}:${n}`,c||!this.i.has(k)||d===k)break;M++}while(M<=E.length);return k}hb(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return R.URI.isUri(g)?g:R.URI.file(g)}kb(g,i){this.i.set(i.item.handle,g),this.j.set(g,i)}lb(g,i,s,o){this.i.delete(i.item.handle),this.j.delete(g),i.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(g,i);const l=this.Q(o)||[],c=l.filter(u=>u.item.handle===s.item.handle)[0];c&&l.splice(l.indexOf(c),1,i)}mb(g,i){i?(i.children||(i.children=[]),i.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const i=this.j.get(g);if(i){if(i.children)for(const s of i.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}i.children=void 0}}else this.pb()}ob(g){const i=this.j.get(g);if(i){if(i.children)for(const s of i.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}this.j.delete(g),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[307],Ce([1,0,21,9,3,38,2,121,107,152,163,40,5,95,250,249,41,251,35,253,254,255,238,256,59,43,257,258,261,262,263,142,241,268,269,270,99,42,272,306,15,7,70,275,77,141,34,229,260,69,139,79,81,82,13,56,18,25,264,237,55,74,247,273,76,75,278,276,277,248,48,271,274,98,60,96,265,78,266,17,125,240,217,259,6,26,222,97,214,267]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S,g,i,s,o,l,c,u,r,n,d,E,k,M,K,q,F,B,O,U,$,j,ue,V,_,Y,ne,ee,X,G,de,be,Ee,Pe,Fe,se,oe,fe,Z,ce,ie,N,H,Q,J,he,we,Ae,pe,De,ke,je,Ge,et,Qe,nt,st,ht,Me,it,ae,z,le,Ie,Le,Be,Xe,Ze,gt,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(fe.IExtHostInitDataService),kt=ot.get(ke.IExtHostFileSystemInfo),Tt=ot.get(he.IExtHostConsumerFileSystem),Nt=ot.get(l.IExtHostExtensionService),pt=ot.get(ne.IExtHostWorkspace),Dt=ot.get(nt.IExtHostTelemetry),zt=ot.get(p.IExtHostConfiguration),Ft=ot.get(se.IURITransformerService),xe=ot.get(oe.IExtHostRpcService),Mt=ot.get(F.IExtHostStorage),Ut=ot.get(J.IExtensionStoragePaths),Bt=ot.get(Fe.ILoggerService),wt=ot.get(Fe.ILogService),Pt=ot.get(ie.IExtHostTunnelService),Re=ot.get(N.IExtHostApiDeprecationService),Oe=ot.get(Y.IExtHostWindow),Se=ot.get(et.IExtHostSecretState),re=ot.get(Qe.IExtHostEditorTabs);xe.set(w.ExtHostContext.ExtHostFileSystemInfo,kt),xe.set(w.ExtHostContext.ExtHostLogLevelServiceShape,Bt),xe.set(w.ExtHostContext.ExtHostWorkspace,pt),xe.set(w.ExtHostContext.ExtHostConfiguration,zt),xe.set(w.ExtHostContext.ExtHostExtensionService,Nt),xe.set(w.ExtHostContext.ExtHostStorage,Mt),xe.set(w.ExtHostContext.ExtHostTunnelService,Pt),xe.set(w.ExtHostContext.ExtHostWindow,Oe),xe.set(w.ExtHostContext.ExtHostSecretState,Se),xe.set(w.ExtHostContext.ExtHostTelemetry,Dt),xe.set(w.ExtHostContext.ExtHostEditorTabs,re);const Ne=xe.set(w.ExtHostContext.ExtHostDecorations,ot.get(de.IExtHostDecorations)),$e=xe.set(w.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(o.IExtHostDocumentsAndEditors)),_e=xe.set(w.ExtHostContext.ExtHostCommands,ot.get(h.IExtHostCommands)),Ve=xe.set(w.ExtHostContext.ExtHostTerminalService,ot.get(B.IExtHostTerminalService)),tt=xe.set(w.ExtHostContext.ExtHostDebugService,ot.get(Ee.IExtHostDebugService)),St=xe.set(w.ExtHostContext.ExtHostSearch,ot.get(Pe.IExtHostSearch)),Et=xe.set(w.ExtHostContext.ExtHostTask,ot.get(be.IExtHostTask)),Lt=xe.set(w.ExtHostContext.ExtHostOutputService,ot.get(E.IExtHostOutputService)),vt=xe.set(w.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),It=xe.set(w.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(xe)),ft=xe.set(w.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(xe,$e)),Gt=xe.set(w.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(xe,$e,wt)),jt=xe.set(w.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(wt,ft,xe.getProxy(w.MainContext.MainThreadBulkEdits))),yt=xe.set(w.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(xe,_e,$e,ft)),Qt=xe.set(w.ExtHostContext.ExtHostNotebookDocuments,new le.ExtHostNotebookDocuments(yt)),sn=xe.set(w.ExtHostContext.ExtHostNotebookEditors,new z.ExtHostNotebookEditors(wt,yt)),en=xe.set(w.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(xe,rt,yt,_e,wt)),vn=xe.set(w.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(xe,yt)),At=xe.set(w.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(xe,$e)),on=xe.set(w.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(xe.getProxy(w.MainContext.MainThreadTreeViews),_e,wt)),Vt=xe.set(w.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(xe.getProxy(w.MainContext.MainThreadEditorInsets),At,rt.remote)),tn=xe.set(w.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,wt,kt,$e)),an=xe.set(w.ExtHostContext.ExtHostLanguages,new n.ExtHostLanguages(xe,ft,_e.converter,Ft)),ut=xe.set(w.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(xe,Ft,ft,_e,tn,wt,Re,Dt)),On=xe.set(w.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(xe,ut)),_t=xe.set(w.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(xe,wt,$e)),Wt=xe.set(w.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(xe,pt,_e)),cn=xe.set(w.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(xe,_e,wt)),En=xe.set(w.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(xe,_e,ft)),ln=xe.set(w.ExtHostContext.ExtHostProgress,new k.ExtHostProgress(xe.getProxy(w.MainContext.MainThreadProgress))),Sn=xe.set(w.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(xe)),un=xe.set(w.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(xe)),nn=xe.set(w.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(xe)),yn=xe.set(w.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(xe,_e)),rn=xe.set(w.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(xe,rt.remote,pt,wt,Re)),Cn=xe.set(w.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(xe,rn,pt)),Dn=xe.set(w.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(xe,ft,Ut,rn,Cn)),In=xe.set(w.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(xe,rn)),Jt=xe.set(w.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(xe,_e,$e)),kn=xe.set(w.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(xe)),$n=xe.set(w.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(xe));xe.set(w.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(xe,yt,$e,_e,wt));const Tn=Object.values(w.ExtHostContext);xe.assertRegistered(Tn);const Pn=new De.ExtHostBulkEdits(xe,$e),Wn=new m.ExtHostClipboard(xe),An=new d.ExtHostMessageService(xe,wt),Nn=new S.ExtHostDialogs(xe),Fn=new q.ExtHostStatusBar(xe,_e.converter);return v.ExtHostApiCommands.register(_e),function(He,Kt,dn){const bt=function(){let ge=!He.isUnderDevelopment;function ve(){ge||(wt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")ve();else{const Ct=at;typeof Ct.scheme>"u"&&ve(),typeof Ct.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Hn={getSession(ge,ve,ze){return nn.getSession(He,ge,ve,ze)},async hasSession(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await nn.getSession(He,ge,ve,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ge,ve,ze,at){return nn.registerAuthenticationProvider(ge,ve,ze,at)}},jn={registerCommand(ge,ve,ze){return _e.registerCommand(!0,ge,ve,ze,void 0,He)},registerTextEditorCommand(ge,ve,ze){return _e.registerCommand(!0,ge,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){wt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Ct.edit(Rt=>{ve.apply(ze,[Ct,Rt,...at])}).then(Rt=>{Rt||wt.warn("Edits from command "+ge+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+ge,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,ve,ze)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),_e.registerCommand(!0,ge,async(...at)=>{const Ct=$e.activeEditor(!0);if(!Ct){wt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);ve.apply(ze,[Rt,...at])},void 0,void 0,He)),executeCommand(ge,...ve){return _e.executeCommand(ge,...ve)},getCommands(ge=!1){return _e.getCommands(ge)}},Mn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Wn.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),Dt.instantiateLogger(He,ge)},openExternal(ge,ve){return Oe.openUri(ge,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===rt.environment.appUriScheme)return It.createAppUri(ge);try{return await Oe.asExternalUri(ge,{allowTunneling:!!rt.remote.authority})}catch(ve){if((0,ae.matchesScheme)(ge,it.Schemas.http)||(0,ae.matchesScheme)(ge,it.Schemas.https))return ge;throw ve}},get remoteName(){return(0,G.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return wt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Mn);const hn={createTestController(ge,ve,ze){return Jt.createTestController(He,ge,ve,ze)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Jt.createTestObserver()},runTests(ge){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Jt.runTests(ge)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Jt.results}},fn=rt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Vn={getExtension(ge,ve){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(ve=!1);const ze=Kt.mine.getExtensionDescription(ge);if(ze)return new l.Extension(Nt,He.identifier,ze,fn,!1);if(ve){const at=Kt.all.getExtensionDescription(ge);if(at)return new l.Extension(Nt,He.identifier,at,fn,!0)}},get all(){const ge=[];for(const ve of Kt.mine.getAllExtensionDescriptions())ge.push(new l.Extension(Nt,He.identifier,ve,fn,!1));return ge},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const ge=new Be.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ve=[];for(const ze of Kt.all.getAllExtensionDescriptions()){const at=!ge.has(ze.identifier);ve.push(new l.Extension(Nt,He.identifier,ze,fn,at))}return ve},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?T.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},qn={createDiagnosticCollection(ge){return tn.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return tn.onDidChangeDiagnostics},getDiagnostics:ge=>tn.getDiagnostics(ge),getLanguages(){return an.getLanguages()},setTextDocumentLanguage(ge,ve){return an.changeLanguage(ge.uri,ve)},match(ge,ve){const ze=ft.getDocumentData(ve.uri)?.notebook;return(0,L.score)($.LanguageSelector.from(ge),ve.uri,ve.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(ge,ve,ze){return ut.registerCodeActionProvider(He,bt(ge),ve,ze)},registerDocumentPasteEditProvider(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,bt(ge),ve,ze)},registerCodeLensProvider(ge,ve){return ut.registerCodeLensProvider(He,bt(ge),ve)},registerDefinitionProvider(ge,ve){return ut.registerDefinitionProvider(He,bt(ge),ve)},registerDeclarationProvider(ge,ve){return ut.registerDeclarationProvider(He,bt(ge),ve)},registerImplementationProvider(ge,ve){return ut.registerImplementationProvider(He,bt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return ut.registerTypeDefinitionProvider(He,bt(ge),ve)},registerHoverProvider(ge,ve){return ut.registerHoverProvider(He,bt(ge),ve,He.identifier)},registerEvaluatableExpressionProvider(ge,ve){return ut.registerEvaluatableExpressionProvider(He,bt(ge),ve,He.identifier)},registerInlineValuesProvider(ge,ve){return ut.registerInlineValuesProvider(He,bt(ge),ve,He.identifier)},registerDocumentHighlightProvider(ge,ve){return ut.registerDocumentHighlightProvider(He,bt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return ut.registerLinkedEditingRangeProvider(He,bt(ge),ve)},registerReferenceProvider(ge,ve){return ut.registerReferenceProvider(He,bt(ge),ve)},registerRenameProvider(ge,ve){return ut.registerRenameProvider(He,bt(ge),ve)},registerDocumentSymbolProvider(ge,ve,ze){return ut.registerDocumentSymbolProvider(He,bt(ge),ve,ze)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,ve){return ut.registerDocumentFormattingEditProvider(He,bt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return ut.registerDocumentRangeFormattingEditProvider(He,bt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,ze,...at){return ut.registerOnTypeFormattingEditProvider(He,bt(ge),ve,[ze].concat(at))},registerDocumentSemanticTokensProvider(ge,ve,ze){return ut.registerDocumentSemanticTokensProvider(He,bt(ge),ve,ze)},registerDocumentRangeSemanticTokensProvider(ge,ve,ze){return ut.registerDocumentRangeSemanticTokensProvider(He,bt(ge),ve,ze)},registerSignatureHelpProvider(ge,ve,ze,...at){return typeof ze=="object"?ut.registerSignatureHelpProvider(He,bt(ge),ve,ze):ut.registerSignatureHelpProvider(He,bt(ge),ve,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(ge,ve,...ze){return ut.registerCompletionItemProvider(He,bt(ge),ve,ze)},registerInlineCompletionItemProvider(ge,ve){return ve.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,bt(ge),ve)},registerDocumentLinkProvider(ge,ve){return ut.registerDocumentLinkProvider(He,bt(ge),ve)},registerColorProvider(ge,ve){return ut.registerColorProvider(He,bt(ge),ve)},registerFoldingRangeProvider(ge,ve){return ut.registerFoldingRangeProvider(He,bt(ge),ve)},registerSelectionRangeProvider(ge,ve){return ut.registerSelectionRangeProvider(He,ge,ve)},registerCallHierarchyProvider(ge,ve){return ut.registerCallHierarchyProvider(He,ge,ve)},registerTypeHierarchyProvider(ge,ve){return ut.registerTypeHierarchyProvider(He,ge,ve)},setLanguageConfiguration:(ge,ve)=>ut.setLanguageConfiguration(He,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),an.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return ut.registerInlayHintsProvider(He,ge,ve)},createLanguageStatusItem(ge,ve){return an.createLanguageStatusItem(He,ge,ve)},registerDocumentDropEditProvider(ge,ve){return ut.registerDocumentOnDropEditProvider(He,ge,ve)}},Gn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(ge,ve,ze){const at=await(I.URI.isUri(ge)?Promise.resolve(mn.openTextDocument(ge)):Promise.resolve(ge));return At.showTextDocument(at,ve,ze)},createTextEditorDecorationType(ge){return At.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,ve,ze){return At.onDidChangeActiveTextEditor(ge,ve,ze)},onDidChangeVisibleTextEditors(ge,ve,ze){return At.onDidChangeVisibleTextEditors(ge,ve,ze)},onDidChangeTextEditorSelection(ge,ve,ze){return At.onDidChangeTextEditorSelection(ge,ve,ze)},onDidChangeTextEditorOptions(ge,ve,ze){return At.onDidChangeTextEditorOptions(ge,ve,ze)},onDidChangeTextEditorVisibleRanges(ge,ve,ze){return At.onDidChangeTextEditorVisibleRanges(ge,ve,ze)},onDidChangeTextEditorViewColumn(ge,ve,ze){return At.onDidChangeTextEditorViewColumn(ge,ve,ze)},onDidCloseTerminal(ge,ve,ze){return Ve.onDidCloseTerminal(ge,ve,ze)},onDidOpenTerminal(ge,ve,ze){return Ve.onDidOpenTerminal(ge,ve,ze)},onDidChangeActiveTerminal(ge,ve,ze){return Ve.onDidChangeActiveTerminal(ge,ve,ze)},onDidChangeTerminalDimensions(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(ge,ve,ze)},onDidChangeTerminalState(ge,ve,ze){return Ve.onDidChangeTerminalState(ge,ve,ze)},onDidWriteTerminalData(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(ge,ve,ze)},get state(){return Oe.state},onDidChangeWindowState(ge,ve,ze){return Oe.onDidChangeWindowState(ge,ve,ze)},showInformationMessage(ge,...ve){return An.showMessage(He,R.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return An.showMessage(He,R.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return An.showMessage(He,R.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,ze){return Wt.showQuickPick(ge,ve,ze)},showWorkspaceFolderPick(ge){return Wt.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return Wt.showInput(ge,ve)},showOpenDialog(ge){return Nn.showOpenDialog(ge)},showSaveDialog(ge){return Nn.showSaveDialog(ge)},createStatusBarItem(ge,ve,ze){let at,Ct,Rt;return typeof ge=="string"?(at=ge,Ct=ve,Rt=ze):(Ct=ge,Rt=ve),Fn.createStatusBarEntry(He,at,Ct,Rt)},setStatusBarMessage(ge,ve){return Fn.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),ln.withProgress(He,{location:j.ProgressLocation.SourceControl},(ve,ze)=>ge({report(at){}}))},withProgress(ge,ve){return ln.withProgress(He,ge,ve)},createOutputChannel(ge,ve){return Lt.createOutputChannel(ge,ve,He)},createWebviewPanel(ge,ve,ze,at){return Cn.createWebviewPanel(He,ge,ve,ze,at)},createWebviewTextEditorInset(ge,ve,ze,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),Vt.createWebviewEditorInset(ge,ve,ze,at,He)},createTerminal(ge,ve,ze){return typeof ge=="object"?"pty"in ge?Ve.createExtensionTerminal(ge):Ve.createTerminalFromOptions(ge):Ve.createTerminal(ge,ve,ze)},registerTerminalLinkProvider(ge){return Ve.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return Ve.registerProfileProvider(He,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(ge,He.identifier.value,ve)},registerTreeDataProvider(ge,ve){return on.registerTreeDataProvider(ge,ve,He)},createTreeView(ge,ve){return on.createTreeView(ge,ve,He)},registerWebviewPanelSerializer:(ge,ve)=>Cn.registerWebviewPanelSerializer(He,ge,ve),registerCustomEditorProvider:(ge,ve,ze={})=>Dn.registerCustomEditorProvider(He,ge,ve,ze),registerFileDecorationProvider(ge){return Ne.registerFileDecorationProvider(ge,He)},registerUriHandler(ge){return It.registerUriHandler(He.identifier,ge)},createQuickPick(){return Wt.createQuickPick(He)},createInputBox(){return Wt.createInputBox(He)},get activeColorTheme(){return un.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,ze){return un.onDidChangeActiveColorTheme(ge,ve,ze)},registerWebviewViewProvider(ge,ve,ze){return In.registerWebviewViewProvider(He,ge,ve,ze?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,ze){return yt.onDidChangeActiveNotebookEditor(ge,ve,ze)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,ve,ze){return sn.onDidChangeNotebookEditorSelection(ge,ve,ze)},onDidChangeNotebookEditorVisibleRanges(ge,ve,ze){return sn.onDidChangeNotebookEditorVisibleRanges(ge,ve,ze)},showNotebookDocument(ge,ve){return yt.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),kn.registerExternalUriOpener(He.identifier,ge,ve,ze)},registerProfileContentHandler(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),$n.registrProfileContentHandler(He,ge,ve)},get tabGroups(){return re.tabGroups}},mn={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return pt.getWorkspaceFolder(ge)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ge){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,ve,...ze)=>pt.updateWorkspaceFolders(He,ge,ve||0,...ze),onDidChangeWorkspaceFolders:function(ge,ve,ze){return pt.onDidChangeWorkspace(ge,ve,ze)},asRelativePath:(ge,ve)=>pt.getRelativePath(ge,ve),findFiles:(ge,ve,ze,at)=>pt.findFiles(ge,ve,ze,He.identifier,at),findTextInFiles:(ge,ve,ze,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Ct,Rt;return typeof ve=="object"?(Ct=ve,Rt=ze):(Ct={},Rt=ve,at=ze),pt.findTextInFiles(ge,Ct||{},Rt,He.identifier,at)},saveAll:ge=>pt.saveAll(ge),applyEdit(ge,ve){return Pn.applyWorkspaceEdit(ge,He,ve)},createFileSystemWatcher:(ge,ve,ze,at)=>_t.createFileSystemWatcher(pt,He,ge,ve,ze,at),get textDocuments(){return ft.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let ve;const ze=ge;if(typeof ge=="string")ve=Promise.resolve(I.URI.file(ge));else if(I.URI.isUri(ge))ve=Promise.resolve(ge);else if(!ze||typeof ze=="object")ve=ft.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(at=>ft.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(ge,ve,ze)=>ft.onDidAddDocument(ge,ve,ze),onDidCloseTextDocument:(ge,ve,ze)=>ft.onDidRemoveDocument(ge,ve,ze),onDidChangeTextDocument:(ge,ve,ze)=>ft.onDidChangeDocument(ge,ve,ze),onDidSaveTextDocument:(ge,ve,ze)=>ft.onDidSaveDocument(ge,ve,ze),onWillSaveTextDocument:(ge,ve,ze)=>jt.getOnWillSaveTextDocumentEvent(He)(ge,ve,ze),get notebookDocuments(){return yt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let ze;if(I.URI.isUri(ge))ze=ge,await yt.openNotebookDocument(ge);else if(typeof ge=="string")ze=I.URI.revive(await yt.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(ge,ve,ze){return Qt.onDidSaveNotebookDocument(ge,ve,ze)},onDidChangeNotebookDocument(ge,ve,ze){return Qt.onDidChangeNotebookDocument(ge,ve,ze)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,ve,ze,at){return yt.registerNotebookSerializer(He,ge,ve,ze,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ge,ve,ze)=>dn.onDidChangeConfiguration(ge,ve,ze),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,dn.getConfiguration(ge,ve,He)},registerTextDocumentContentProvider(ge,ve){return Gt.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,ge,ve)),registerFileSystemProvider(ge,ve,ze){return(0,Le.combinedDisposable)(On.registerFileSystemProvider(He,ge,ve,ze),Tt.addFileSystemProvider(ge,ve))},get fs(){return Tt.value},registerFileSearchProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),St.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),St.registerTextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Nt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Sn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,ve,ze)=>_t.onDidCreateFile(ge,ve,ze),onDidDeleteFiles:(ge,ve,ze)=>_t.onDidDeleteFile(ge,ve,ze),onDidRenameFiles:(ge,ve,ze)=>_t.onDidRenameFile(ge,ve,ze),onWillCreateFiles:(ge,ve,ze)=>_t.getOnWillCreateFileEvent(He)(ge,ve,ze),onWillDeleteFiles:(ge,ve,ze)=>_t.getOnWillDeleteFileEvent(He)(ge,ve,ze),onWillRenameFiles:(ge,ve,ze)=>_t.getOnWillRenameFileEvent(He)(ge,ve,ze),openTunnel:ge=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.openTunnel(He,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(ge,ve,ze)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.onDidChangeTunnels(ge,ve,ze)),registerPortAttributesProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Pt.registerPortsAttributesProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),yn.registerTimelineProvider(ge,ve,He.identifier,_e.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ge=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,ze)=>pt.onDidGrantWorkspaceTrust(ge,ve,ze),registerEditSessionIdentityProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ge,ve))},Kn={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(He)},createSourceControl(ge,ve,ze){return cn.createSourceControl(He,ge,ve,ze)}},Xt={createCommentController(ge,ve){return En.createCommentController(He,ge,ve)}},gn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(ge,ve,ze){return tt.onDidStartDebugSession(ge,ve,ze)},onDidTerminateDebugSession(ge,ve,ze){return tt.onDidTerminateDebugSession(ge,ve,ze)},onDidChangeActiveDebugSession(ge,ve,ze){return tt.onDidChangeActiveDebugSession(ge,ve,ze)},onDidReceiveDebugSessionCustomEvent(ge,ve,ze){return tt.onDidReceiveDebugSessionCustomEvent(ge,ve,ze)},onDidChangeBreakpoints(ge,ve,ze){return tt.onDidChangeBreakpoints(ge,ve,ze)},registerDebugConfigurationProvider(ge,ve,ze){return tt.registerDebugConfigurationProvider(ge,ve,ze||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return tt.registerDebugAdapterDescriptorFactory(He,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return tt.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,ze){return!ze||typeof ze=="object"&&"configuration"in ze?tt.startDebugging(ge,ve,{parentSession:ze}):tt.startDebugging(ge,ve,ze||{})},stopDebugging(ge){return tt.stopDebugging(ge)},addBreakpoints(ge){return tt.addBreakpoints(ge)},removeBreakpoints(ge){return tt.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return tt.asDebugSourceUri(ge,ve)}},Xn={registerTaskProvider:(ge,ve)=>Et.registerTaskProvider(He,ge,ve),fetchTasks:ge=>Et.fetchTasks(ge),executeTask:ge=>Et.executeTask(He,ge),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ge,ve,ze)=>Et.onDidStartTask(ge,ve,ze),onDidEndTask:(ge,ve,ze)=>Et.onDidEndTask(ge,ve,ze),onDidStartTaskProcess:(ge,ve,ze)=>Et.onDidStartTaskProcess(ge,ve,ze),onDidEndTaskProcess:(ge,ve,ze)=>Et.onDidEndTaskProcess(ge,ve,ze)},$t={createNotebookController(ge,ve,ze,at,Ct){return en.createNotebookController(He,ge,ve,ze,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>yt.registerNotebookCellStatusBarItemProvider(He,ge,ve),createRendererMessaging(ge){return vn.createRendererMessaging(He,ge)},createNotebookControllerDetectionTask(ge){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.createNotebookControllerDetectionTask(He,ge)},registerKernelSourceActionProvider(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.registerKernelSourceActionProvider(He,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),en.onDidChangeNotebookCellExecutionState(ge,ve,ze)}},pn={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),ze=!ge||typeof ge[0]!="object"?ge:ge[0];return vt.getMessage(He.identifier.value,{message:ve,args:ze})}return vt.getMessage(He.identifier.value,ge[0])},get bundle(){return vt.getBundle(He.identifier.value)},get uri(){return vt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:Hn,commands:jn,comments:Xt,debug:gn,env:Mn,extensions:Vn,l10n:pn,languages:qn,notebooks:$t,scm:Kn,tasks:Xn,tests:hn,window:Gn,workspace:mn,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:w.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:D.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:C.UIKind,Uri:I.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:ue.TelemetryTrustedValue,LogLevel:Fe.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(ye[308],Ce([1,0,280,317,318,2,319]),function(te,e,a,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,w,C,v,m,h){const f=h.environment.useHostProxy,p=typeof f=="boolean"?f:!h.remote.isRemote,b=(0,I.createProxyResolver)({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(g,i,...s)=>{switch(g){case I.LogLevel.Trace:v.trace(i,...s);break;case I.LogLevel.Debug:v.debug(i,...s);break;case I.LogLevel.Info:v.info(i,...s);break;case I.LogLevel.Warning:v.warn(i,...s);break;case I.LogLevel.Error:v.error(i,...s);break;case I.LogLevel.Critical:v.error(i,...s);break;case I.LogLevel.Off:break;default:o(g,i,s);break}function o(l,c,...u){v.error("Unknown log level",l),v.error(c,...u)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),S=y(w,b);return L(C,S)}e.connectProxyResolver=A;function y(P,w){const C={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(m=>{C.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(m=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,I.createHttpPatch)(a,w,{config:"off"},v,!0)),on:Object.assign({},a,(0,I.createHttpPatch)(a,w,{config:"on"},v,!0)),override:Object.assign({},a,(0,I.createHttpPatch)(a,w,{config:"override"},v,!0)),onRequest:Object.assign({},a,(0,I.createHttpPatch)(a,w,C,v,!0)),default:Object.assign(a,(0,I.createHttpPatch)(a,w,C,v,!1))},https:{off:Object.assign({},t,(0,I.createHttpPatch)(t,w,{config:"off"},v,!0)),on:Object.assign({},t,(0,I.createHttpPatch)(t,w,{config:"on"},v,!0)),override:Object.assign({},t,(0,I.createHttpPatch)(t,w,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,I.createHttpPatch)(t,w,C,v,!0)),default:Object.assign(t,(0,I.createHttpPatch)(t,w,C,v,!1))},tls:Object.assign(T,(0,I.createTlsPatch)(T))}}const D=new Map;function L(P,w){return P.getExtensionPathIndex().then(C=>{const v=globalThis._VSCODE_NODE_MODULES.module,m=v._load;v._load=function(f,p,b){if(f==="tls")return w.tls;if(f!=="http"&&f!=="https")return m.apply(this,arguments);const S=w[f],g=C.findSubstr(R.URI.file(p.filename));let i=D.get(g);if(i||D.set(g,i={}),!i[f]){const s=S.default;i[f]={...s}}return i[f]}})}}),define(ye[309],Ce([1,0,80,307,294,308,43,282,2,17,7,279,115,281]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends T.RequireInterceptor{j(){const f=this,p=globalThis._VSCODE_NODE_MODULES.module,b=p._load;p._load=function(s,o,l){return s=g(s),f.a.has(s)?f.a.get(s).load(s,y.URI.file((0,w.realpathSync)(o.filename)),c=>b.apply(this,[c,o,l])):b.apply(this,arguments)};const S=p._resolveLookupPaths;p._resolveLookupPaths=(i,s)=>S.call(this,g(i),s);const g=i=>{for(const s of f.b){const o=s(i);if(o){i=o;break}}return i}}}class m extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(C.ExtHostConsoleForwarder);const f=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const S=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=S.ipcHandlePath}await this.h.createInstance(v,f,{mine:this.D,all:this.F}).install(),a.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}ob(f){return f.main}async pb(f,p,b){if(p.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let S=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this.l.flush();const g=f?.identifier.value;f&&await this.s.initializeLocalizedMessages(f);try{g&&a.mark(`code/extHost/willLoadExtensionCode/${g}`),S=te.__$__nodeRequire(p.fsPath)}finally{g&&a.mark(`code/extHost/didLoadExtensionCode/${g}`),b.codeLoadingStop()}return S}async $setRemoteEnvironment(f){if(!!this.f.remote.isRemote)for(const p in f){const b=f[p];b===null?delete process.env[p]:process.env[p]=b}}}e.ExtHostExtensionService=m}),define(ye[145],Ce([1,0,46,320,303,16,61,39,11,8,2,31,78,321,301,100]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const h=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(d){this.a=d}provideTextSearchResults(d,E,k,M){return this.a.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((K,q)=>{M.onCancellationRequested(()=>V());const F=s(d,E),B=E.folder.fsPath,O=F.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${h} ${O}
 - cwd: ${B}`);let U=a.spawn(h,F,{cwd:B});U.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),q((0,P.serializeSearchError)(new P.SearchError(X&&X.message,P.SearchErrorCode.rgProcessError)))});let $=!1;const j=new S(E.maxResults,B,E.previewOptions);j.on("result",X=>{$=!0,Y="",k.report(X)});let ue=!1;const V=()=>{ue=!0,U?.kill(),j?.cancel()};let _=!1;j.on("hitLimit",()=>{_=!0,V()});let Y="";U.stdout.on("data",X=>{j.handleData(X),$||(Y+=X)});let ne=!1;U.stdout.once("data",()=>ne=!0);let ee="";U.stderr.on("data",X=>{const G=X.toString();this.a.appendLine(G),ee.length+G.length<1e6&&(ee+=G)}),U.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine($?"Got result from parser":"No result from parser"),Y&&this.a.appendLine(`Got data without result: ${Y}`),this.a.appendLine(""),ue)K({limitHit:_});else{j.flush(),U=null;let X;ee&&!ne&&(X=p(ee))?q((0,P.serializeSearchError)(new P.SearchError(X.message,X.code))):K({limitHit:_})}})})}}e.RipgrepTextSearchEngine=f;function p(n){const d=n.split(`
`),E=d[0].trim();if(d.some(M=>M.startsWith("regex parse error")))return new P.SearchError(b(d),P.SearchErrorCode.regexParseError);const k=E.match(/grep config error: unknown encoding: (.*)/);if(k)return new P.SearchError(`Unknown encoding: ${k[1]}`,P.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(E,P.SearchErrorCode.regexParseError)}function b(n){const d=["Regex parse error"],E=n.filter(k=>k.startsWith("PCRE2:"));if(E.length>=1){const k=E[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const M=k.split(":")[1];d.push(":"+M)}}return d.join("")}class S extends t.EventEmitter{constructor(d,E,k){super(),this.g=d,this.h=E,this.j=k,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new T.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(d,E){return super.on(d,E),this}handleData(d){if(this.b)return;const E=typeof d=="string"?d:this.d.write(d);this.k(E)}k(d){let E=d.indexOf(`
`);const k=this.a+d;if(E>=0)E+=this.a.length;else{this.a=k;return}let M=0;for(;E>=0;)this.m(k.substring(M,E).trim()),M=E+1,E=k.indexOf(`
`,M);this.a=k.substring(M)}m(d){if(this.b||!d)return;let E;try{E=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(E.type==="match"){const k=g(E.data.path),M=L.URI.file(y.join(this.h,k)),K=this.n(E.data,M);this.p(K),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const k=g(E.data.path),M=L.URI.file(y.join(this.h,k));this.o(E.data,M).forEach(q=>this.p(q))}}n(d,E){const k=d.line_number-1,M=g(d.lines),K=Buffer.from(M);let q=0,F=0,B=k;d.submatches.length===0&&d.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(d.submatches.map((U,$)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=g(U.match),ue=K.slice(q,U.start).toString(),V=i(ue),_=V.numLines>0?V.lastLineLength:V.lastLineLength+F,Y=i(j),ne=V.numLines+B,ee=Y.numLines+ne,X=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+_;return q=U.end,F=X,B=ee,new w.Range(ne,_,ee,X)}));return(0,m.createTextSearchResult)(E,M,O,this.j)}o(d,E){const k=g(d.lines),M=d.line_number;return k.replace(/\r?\n$/,"").split(`
`).map((K,q)=>({text:K,uri:E,lineNumber:M+q}))}p(d){this.emit("result",d)}}e.RipgrepParser=S;function g(n){return n.bytes?Buffer.from(n.bytes,"base64").toString():n.text}function i(n){const d=/\n/g;let E=0,k=-1,M;for(;M=d.exec(n);)E++,k=M.index;const K=k>=0?n.length-k-1:n.length;return{numLines:E,lastLineLength:K}}function s(n,d){const E=["--hidden"];E.push(n.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:M}=(0,I.groupBy)(d.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const q=new Set;M.forEach(F=>{q.add(F)}),E.push("-g","!*"),q.forEach(F=>{o(F).map(m.anchorGlob).forEach(B=>{E.push("-g",B)})})}k&&k.length&&k.forEach(q=>{E.push("-g",q)}),d.excludes.map(m.anchorGlob).forEach(q=>E.push("-g",`!${q}`)),d.maxFileSize&&E.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),d.followSymlinks&&E.push("--follow"),d.encoding&&d.encoding!=="utf8"&&E.push("--encoding",d.encoding),n.pattern==="--"&&(n.isRegExp=!0,n.pattern="\\-\\-"),n.isMultiline&&!n.isRegExp&&(n.pattern=(0,D.escapeRegExpCharacters)(n.pattern),n.isRegExp=!0),d.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),n.isRegExp&&(n.pattern=l(n.pattern),E.push("--engine","auto"));let K;if(n.isWordMatch){const F=(0,D.createRegExp)(n.pattern,!!n.isRegExp,{wholeWord:n.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(n.isRegExp){let q=u(n.pattern);q=r(q),E.push("--regexp",q)}else K=n.pattern,E.push("--fixed-strings");return E.push("--no-config"),d.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),n.isMultiline&&E.push("--multiline"),d.beforeContext&&E.push("--before-context",d.beforeContext+""),d.afterContext&&E.push("--after-context",d.afterContext+""),E.push("--"),K&&E.push(K),E.push("."),E}function o(n){const d=(0,A.splitGlobAware)(n,"/");return d.map((E,k)=>d.slice(0,k+1).join("/"))}function l(n){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;n.match(d);)n=n.replace(d,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;n.match(E);)n=n.replace(E,"$1\\x{$2}");return n}e.unicodeEscapesToPCRE2=l;const c=n=>n.type==="Assertion"&&n.kind==="lookbehind";function u(n){let d;try{d=new C.RegExpParser().parsePattern(n)}catch{return n}let E="",k=0;const M=(F,B,O)=>{E+=n.slice(k,F)+O,k=B},K=[];return new C.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const B=K[0];if(!B)M(F.start,F.end,"\\r?\\n");else if(!K.some(c))if(B.type==="CharacterClass")if(B.negate){const O=n.slice(B.start+2,F.start)+n.slice(F.end,B.end-1);B.parent?.type==="Quantifier"?M(B.start,B.end,O?`[^${O}]`:"."):M(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=n.slice(B.start+1,F.start)+n.slice(F.end,B.end-1);M(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&M(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){K.unshift(F)},onQuantifierLeave(){K.shift()},onCharacterClassRangeEnter(F){K.unshift(F)},onCharacterClassRangeLeave(){K.shift()},onCharacterClassEnter(F){K.unshift(F)},onCharacterClassLeave(){K.shift()},onAssertionEnter(F){c(F)&&K.push(F)},onAssertionLeave(F){K[0]===F&&K.shift()}}).visit(d),E+=n.slice(k),E}e.fixRegexNewline=u;function r(n){return n.replace(/\n/g,"\\r?\\n")}e.fixNewline=r}),define(ye[310],Ce([1,0,21,145,126,17]),function(te,e,a,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class I{constructor(D){this.b=D,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(D,L,P,w){const C=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const v={...L,folder:L.folder.with({scheme:R.Schemas.file})},m=new T.Progress(h=>P.report({...h,uri:h.uri.with({scheme:L.folder.scheme})}));return this.c(w,h=>C.provideTextSearchResults(D,v,m,h))}else return this.c(w,v=>C.provideTextSearchResults(D,L,P,v))}async c(D,L){const P=A(D);this.a.add(P);const w=await L(P.token);return this.a.delete(P),w}d(){this.a.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=I;function A(y){const D=new a.CancellationTokenSource;return y.onCancellationRequested(()=>D.cancel()),D}}),define(ye[311],Ce([1,0,29,145,144]),function(te,e,a,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,D,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(C){L({message:C})}},w=new T.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),a);return new Promise((C,v)=>w.search(m=>{D(m.map(I))},y).then(m=>C({limitHit:m.limitHit,type:"success",stats:m.stats}),v))}}e.TextSearchEngineAdapter=R;function I(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,D)=>{if(D.ranges){const L=D;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ye[312],Ce([1,0,16,14,9,3,111,11,44,2,40,31,302,311]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(S="searchProcess"){this.d=S,this.b=Object.create(null)}fileSearch(S){let g;const i=f(S),s=new R.Emitter({onDidAddFirstListener:()=>{g=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(w.Engine,i,l=>s.fire(l),o)),g.then(o=>s.fire(o),o=>s.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}textSearch(S){let g;const i=f(S),s=new R.Emitter({onDidAddFirstListener:()=>{g=(0,t.createCancelablePromise)(o=>this.f(i,l=>s.fire(l),o)),g.then(o=>s.fire(o),o=>s.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}f(S,g,i){return S.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(S).search(i,g,g)}doFileSearch(S,g,i){return this.doFileSearchWithEngine(w.Engine,S,g,i)}doFileSearchWithEngine(S,g,i,s,o=v.a){let l=0;const c=r=>{Array.isArray(r)?(l+=r.length,i(r.map(n=>this.g(n)))):r.relativePath?(l++,i(this.g(r))):i(r)};if(g.sortByScore){let r=this.k(g,c,s);if(!r){const n=g.maxResults?Object.assign({},g,{maxResults:null}):g,d=new S(n);r=this.h(d,g,i,c,s)}return new Promise((n,d)=>{r.then(([E,k])=>{const M=k.map(K=>this.g(K));this.n(M,i,o),n(E)},d)})}const u=new S(g);return this.q(u,c,o,s).then(r=>({limitHit:r.limitHit,type:"success",stats:{detailStats:r.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}g(S){return{path:S.base?(0,A.join)(S.base,S.relativePath):S.relativePath}}h(S,g,i,s,o){const l=new R.Emitter;let c=(0,t.createCancelablePromise)(r=>{let n=[];const d=E=>{Array.isArray(E)?n=E:(s(E),l.fire(E))};return this.q(S,d,-1,r).then(E=>[E,n])}),u;if(g.cacheKey){u=this.j(g.cacheKey);const r={promise:c,event:l.event,resolved:!1};u.resultsToSearchCache[g.filePattern||""]=r,c.then(()=>{r.resolved=!0},n=>{delete u.resultsToSearchCache[g.filePattern||""]}),c=this.r(c)}return c.then(([r,n])=>{const d=u?u.scorerCache:Object.create(null),E=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.l(g,n,d,o).then(k=>{const M=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:r.stats,sortingTime:M,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:k.length},messages:r.messages,limitHit:r.limitHit||typeof g.maxResults=="number"&&n.length>g.maxResults},k]})})}j(S){const g=this.b[S];return g||(this.b[S]=new m)}k(S,g,i){const s=S.cacheKey&&this.b[S.cacheKey];if(!s)return;const o=this.o(s,S.filePattern||"",g,i);if(o)return o.then(([l,c,u])=>{const r=y.StopWatch.create(!1);return this.l(S,c,s.scorerCache,i).then(n=>{const d=r.elapsed(),E={fromCache:!0,detailStats:u,type:this.d,resultCount:c.length,sortingTime:d};return[{type:"success",limitHit:l.limitHit||typeof S.maxResults=="number"&&c.length>S.maxResults,stats:E},n]})})}l(S,g,i,s){const o=(0,I.prepareQuery)(S.filePattern||""),l=(u,r)=>(0,I.compareItemsByFuzzyScore)(u,r,o,!0,h,i),c=typeof S.maxResults=="number"?S.maxResults:Number.MAX_VALUE;return a.topAsync(g,l,c,1e4,s)}n(S,g,i){if(i&&i>0)for(let s=0;s<S.length;s+=i)g(S.slice(s,s+i));else g(S)}o(S,g,i,s){const o=y.StopWatch.create(!1),l=g.indexOf(A.sep)>=0;let c;for(const d in S.resultsToSearchCache)if(g.startsWith(d)){if(l&&d.indexOf(A.sep)<0&&d!=="")continue;const E=S.resultsToSearchCache[d];c={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!c)return null;const u=o.elapsed(),r=y.StopWatch.create(!1),n=c.event(i);return s&&s.onCancellationRequested(()=>{n.dispose()}),c.promise.then(([d,E])=>{if(s&&s.isCancellationRequested)throw(0,T.canceled)();const k=[],M=(0,I.prepareQuery)(g).normalizedLowercase;for(const K of E)!(0,P.isFilePatternMatch)(K,M)||k.push(K);return[d,k,{cacheWasResolved:c.resolved,cacheLookupTime:u,cacheFilterTime:r.elapsed(),cacheEntryCount:E.length}]})}q(S,g,i,s){return new Promise((o,l)=>{let c=[];s?.onCancellationRequested(()=>S.cancel()),S.search(u=>{u&&(i?(c.push(u),i>0&&c.length>=i&&(g(c),c=[])):g(u))},u=>{g(u)},(u,r)=>{c.length&&g(c),u?l(u):o(r)})})}clearCache(S){return delete this.b[S],Promise.resolve(void 0)}r(S){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,i){return S.then(g,i)}catch(g){return this.then(void 0,g)}finally(g){return S.finally(g)}}}}e.SearchService=v,v.a=512;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(b){return(0,A.basename)(b.relativePath)}getItemDescription(b){return(0,A.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function f(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(S=>D.URI.revive(S))}}function p(b){return{...b,folder:D.URI.revive(b.folder)}}}),define(ye[313],Ce([1,0,6,17,2,29,13,25,18,82,56,31,312,310,100,144]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let h=class extends D.ExtHostSearch{constructor(p,b,S,g){super(p,S,g),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new C.RipgrepSearchProvider(i)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const p=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new C.RipgrepSearchProvider(p)),this.y(t.Schemas.file,new w.SearchService("fileSearchProvider"))}y(p,b){const S=this.d++;return this.v=b,this.t=S,this.c.$registerFileSearchProvider(S,this.o(p)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(S)})}$provideFileSearchResults(p,b,S,g){const i=(0,D.reviveQuery)(S);return p===this.t?this.z(p,b,i,g):super.$provideFileSearchResults(p,b,S,g)}z(p,b,S,g){const i=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(p,b,s.map(o=>T.URI.file(o.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(S,i,g)}$clearCache(p){return this.v?.clearCache(p),super.$clearCache(p)}q(p,b){return new m.NativeTextSearchManager(p,b,void 0,"textSearchProvider")}};h=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,I.ILogService)],h),e.NativeExtHostSearch=h}),define(ye[314],Ce([1,0,89,285,297,296,313,309,286,81,43,82,79,42,55,76,284,283,13,298,49]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,a.registerSingleton)(p.ILoggerService,f.ExtHostLoggerService,1),(0,a.registerSingleton)(m.IExtensionStoragePaths,h.ExtensionStoragePaths,0),(0,a.registerSingleton)(D.IExtHostDebugService,R.ExtHostDebugService,0),(0,a.registerSingleton)(P.IExtHostSearch,I.NativeExtHostSearch,0),(0,a.registerSingleton)(w.IExtHostTask,T.ExtHostTask,0),(0,a.registerSingleton)(C.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(S.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[322],Ce([1,0,225,323,80,9,118,119,204,95,295,23,29,115,14,121,220,234,299,314]),function(te,e,a,t,T,R,I,A,y,D,L,P,w,C,v,m,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const p=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,u=c._load;c._load=function(r){if(r==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const b=process.exit.bind(process);function S(c){process.exit=function(u){if(c)b(u);else{const r=new Error("An extension called process.exit() and this was prevented.");console.warn(r.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(c){b()};function i(){const c=(0,f.readExtHostConnection)(process.env);if(c.type===3)return new Promise((u,r)=>{const n=d=>{const E=d[0],k=new I.BufferedEmitter;E.on("message",M=>k.fire(P.VSBuffer.wrap(M.data))),E.on("close",()=>{g("renderer closed the MessagePort")}),E.start(),u({onMessage:k.event,send:M=>E.postMessage(M.buffer)})};process.parentPort.on("message",d=>n(d.ports))});if(c.type===2)return new Promise((u,r)=>{let n=null;const d=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,k=3e5,M=new v.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),E),K=new v.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),k);process.on("message",(F,B)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let U;if(F.skipWebSocketFrames)U=new A.NodeSocket(B,"extHost-socket");else{const $=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));U=new A.WebSocketNodeSocket(new A.NodeSocket(B,"extHost-socket"),F.permessageDeflate,$,!1)}n?(M.cancel(),K.cancel(),n.beginAcceptReconnection(U,O),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(d),n=new I.PersistentProtocol({socket:U,initialChunk:O}),n.sendResume(),n.onDidDispose(()=>g("renderer disconnected")),u(n),n.onSocketClose(()=>{M.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(K.isScheduled())return;M.isScheduled()&&K.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const u=c.pipeName;return new Promise((r,n)=>{const d=a.createConnection(u,()=>{d.removeListener("error",n);const E=new I.PersistentProtocol({socket:new A.NodeSocket(d,"extHost-renderer")});E.sendResume(),r(E)});d.once("error",n),d.on("close",()=>{g("renderer closed the socket")})})}}async function s(){const c=await i();return new class{constructor(){this.a=new I.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,c.onMessage(u=>{(0,D.isMessageOfType)(u,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||c.send(u)}async drain(){if(c.drain)return c.drain()}}}function o(c){return new Promise(u=>{const r=c.onMessage(n=>{r.dispose();const d=JSON.parse(n.toString()),E=d.commit,k=y.default.commit;if(E&&k&&E!==k&&b(55),d.parentPid){let M=0;setInterval(function(){try{process.kill(d.parentPid,0),M=0}catch(q){q&&q.code==="EPERM"?(M++,M>=3&&g(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):g(`parent process ${d.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let K;try{K=globalThis._VSCODE_NODE_MODULES["native-watchdog"],K.start(d.parentPid)}catch(q){(0,R.onUnexpectedError)(q)}}c.send((0,D.createMessageOfType)(0)),u({protocol:c,initData:d})});c.send((0,D.createMessageOfType)(1))})}async function l(){const c=[];process.on("unhandledRejection",(M,K)=>{c.push(K),setTimeout(()=>{const q=c.indexOf(K);q>=0&&K.catch(F=>{c.splice(q,1),(0,R.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),M&&(0,R.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const K=c.indexOf(M);K>=0&&c.splice(K,1)}),process.on("uncaughtException",function(M){(0,R.onUnexpectedError)(M)}),T.mark("code/extHost/willConnectToRenderer");const u=await s();T.mark("code/extHost/didConnectToRenderer");const r=await o(u);T.mark("code/extHost/didWaitForInitData");const{initData:n}=r;S(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,n.environment.skipWorkspaceStorageLock=(0,m.boolean)(p.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(K){b(K)}exists(K){return w.Promises.exists(K)}realpath(K){return(0,C.realpath)(K)}};let E=null;n.remote.authority&&p.transformURIs&&(E=(0,h.createURITransformer)(n.remote.authority));const k=new L.ExtensionHostMain(r.protocol,n,d,E);g=M=>k.terminate(M)}l().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/04b15ff231a2c3cfcdd90d90c16075a9c1e6da15/core/vs/workbench/api/node/extensionHostProcess.js.map
