/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/async","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/codicons","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ee){for(var e=[],i=0,C=ee.length;i<C;i++)e[i]=Ie[ee[i]];return e};define(Ie[62],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(I,R){const y=Object.create(null);for(const k of I){const O=R(k);let w=y[O];w||(w=y[O]=[]),w.push(k)}return y}e.groupBy=i;function C(I,R){const y=[],k=[];for(const O of I)R.has(O)||y.push(O);for(const O of R)I.has(O)||k.push(O);return{removed:y,added:k}}e.diffSets=C;function S(I,R){const y=[],k=[];for(const[O,w]of I)R.has(O)||y.push(w);for(const[O,w]of R)I.has(O)||k.push(w);return{removed:y,added:k}}e.diffMaps=S;class L{constructor(){this.a=new Map}add(R,y){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(y)}delete(R,y){const k=this.a.get(R);!k||(k.delete(y),k.size===0&&this.a.delete(R))}forEach(R,y){const k=this.a.get(R);!k||k.forEach(y)}}e.SetMap=L}),define(Ie[63],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(I){return(R,y,k)=>{let O=null,w=null;if(typeof k.value=="function"?(O="value",w=k.value):typeof k.get=="function"&&(O="get",w=k.get),!w)throw new Error("not supported");k[O]=I(w,y)}}function C(I,R,y){let k=null,O=null;if(typeof y.value=="function"?(k="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",O=y.get),!O)throw new Error("not supported");const w=`$memoize$${R}`;y[k]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[w]}}e.memoize=C;function S(I,R,y){return i((k,O)=>{const w=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...p){this[m]||(this[m]=y?y():void 0),clearTimeout(this[w]),R&&(this[m]=R(this[m],...p),p=[this[m]]),this[w]=setTimeout(()=>{k.apply(this,p),this[m]=y?y():void 0},I)}})}e.debounce=S;function L(I,R,y){return i((k,O)=>{const w=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,p=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...n){if(this[m]||(this[m]=y?y():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...n)),this[f])return;const r=this[p]+I;r<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0},r-Date.now()))}})}e.throttle=L}),define(Ie[83],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(S){this.a=S,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ie[110],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function I(t,s=!1){let o=0;const l=t.length;let a="",h=0,c=16,u=0;function g($){let T=0,M=0;for(;T<$;){const V=t.charCodeAt(o);if(V>=48&&V<=57)M=M*16+V-48;else if(V>=65&&V<=70)M=M*16+V-65+10;else if(V>=97&&V<=102)M=M*16+V-97+10;else break;o++,T++}return T<$&&(M=-1),M}function A($){o=$,a="",h=0,c=16,u=0}function N(){const $=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return u=3,t.substring($,o);let T=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;T=o}else u=3;return t.substring($,T)}function q(){let $="",T=o;for(;;){if(o>=l){$+=t.substring(T,o),u=2;break}const M=t.charCodeAt(o);if(M===34){$+=t.substring(T,o),o++;break}if(M===92){if($+=t.substring(T,o),o++,o>=l){u=2;break}switch(t.charCodeAt(o++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const j=g(4);j>=0?$+=String.fromCharCode(j):u=4;break}default:u=5}T=o;continue}if(M>=0&&M<=31)if(y(M)){$+=t.substring(T,o),u=2;break}else u=6;o++}return $}function te(){if(a="",u=0,h=o,o>=l)return h=l,c=17;let $=t.charCodeAt(o);if(R($)){do o++,a+=String.fromCharCode($),$=t.charCodeAt(o);while(R($));return c=15}if(y($))return o++,a+=String.fromCharCode($),$===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),c=14;switch($){case 123:return o++,c=1;case 125:return o++,c=2;case 91:return o++,c=3;case 93:return o++,c=4;case 58:return o++,c=6;case 44:return o++,c=5;case 34:return o++,a=q(),c=10;case 47:{const T=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<l&&!y(t.charCodeAt(o));)o++;return a=t.substring(T,o),c=12}if(t.charCodeAt(o+1)===42){o+=2;const M=l-1;let V=!1;for(;o<M;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,V=!0;break}o++}return V||(o++,u=1),a=t.substring(T,o),c=13}return a+=String.fromCharCode($),o++,c=16}case 45:if(a+=String.fromCharCode($),o++,o===l||!k(t.charCodeAt(o)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),c=11;default:for(;o<l&&x($);)o++,$=t.charCodeAt(o);if(h!==o){switch(a=t.substring(h,o),a){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return a+=String.fromCharCode($),o++,c=16}}function x($){if(R($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=te();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>o,scan:s?F:te,getToken:()=>c,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>u}}e.createScanner=I;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function w(t,s){const o=[],l=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(g,A,N,q){h.value=g,h.offset=A,h.length=N,h.type=q,h.colonOffset=void 0,a=h}try{E(t,{onObjectBegin:(g,A)=>{if(s<=g)throw l;a=void 0,c=s>g,o.push("")},onObjectProperty:(g,A,N)=>{if(s<A||(u(g,A,N,"property"),o[o.length-1]=g,s<=A+N))throw l},onObjectEnd:(g,A)=>{if(s<=g)throw l;a=void 0,o.pop()},onArrayBegin:(g,A)=>{if(s<=g)throw l;a=void 0,o.push(0)},onArrayEnd:(g,A)=>{if(s<=g)throw l;a=void 0,o.pop()},onLiteralValue:(g,A,N)=>{if(s<A||(u(g,A,N,v(g)),s<=A+N))throw l},onSeparator:(g,A,N)=>{if(s<=A)throw l;if(g===":"&&a&&a.type==="property")a.colonOffset=A,c=!1,a=void 0;else if(g===","){const q=o[o.length-1];typeof q=="number"?o[o.length-1]=q+1:(c=!0,o[o.length-1]=""),a=void 0}}})}catch(g){if(g!==l)throw g}return{path:o,previousNode:a,isAtPropertyKey:c,matches:g=>{let A=0;for(let N=0;A<g.length&&N<o.length;N++)if(g[A]===o[N]||g[A]==="*")A++;else if(g[A]!=="**")return!1;return A===g.length}}}e.getLocation=w;function m(t,s=[],o=L.DEFAULT){let l=null,a=[];const h=[];function c(g){Array.isArray(a)?a.push(g):l!==null&&(a[l]=g)}return E(t,{onObjectBegin:()=>{const g={};c(g),h.push(a),a=g,l=null},onObjectProperty:g=>{l=g},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const g=[];c(g),h.push(a),a=g,l=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:c,onError:(g,A,N)=>{s.push({error:g,offset:A,length:N})}},o),a[0]}e.parse=m;function p(t,s=[],o=L.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(g){l.type==="property"&&(l.length=g-l.offset,l=l.parent)}function h(g){return l.children.push(g),g}E(t,{onObjectBegin:g=>{l=h({type:"object",offset:g,length:-1,parent:l,children:[]})},onObjectProperty:(g,A,N)=>{l=h({type:"property",offset:A,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:g,offset:A,length:N,parent:l})},onObjectEnd:(g,A)=>{l.length=g+A-l.offset,l=l.parent,a(g+A)},onArrayBegin:(g,A)=>{l=h({type:"array",offset:g,length:-1,parent:l,children:[]})},onArrayEnd:(g,A)=>{l.length=g+A-l.offset,l=l.parent,a(g+A)},onLiteralValue:(g,A,N)=>{h({type:v(g),offset:A,length:N,parent:l,value:g}),a(A+N)},onSeparator:(g,A,N)=>{l.type==="property"&&(g===":"?l.colonOffset=A:g===","&&a(A))},onError:(g,A,N)=>{s.push({error:g,offset:A,length:N})}},o);const u=l.children[0];return u&&delete u.parent,u}e.parseTree=p;function f(t,s){if(!t)return;let o=t;for(const l of s)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===l){o=h.children[1],a=!0;break}if(!a)return}else{const a=l;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=f;function n(t){if(!t.parent||!t.parent.children)return[];const s=n(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}e.getNodePath=n;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const s=Object.create(null);for(const o of t.children){const l=o.children[1];l&&(s[o.children[0].value]=r(l))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function d(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}e.contains=d;function b(t,s,o=!1){if(d(t,s,o)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=s;a++){const h=b(l[a],s,o);if(h)return h}return t}}e.findNodeAtOffset=b;function E(t,s,o=L.DEFAULT){const l=I(t,!1);function a(re){return re?()=>re(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(re){return re?G=>re(G,l.getTokenOffset(),l.getTokenLength()):()=>!0}const c=a(s.onObjectBegin),u=h(s.onObjectProperty),g=a(s.onObjectEnd),A=a(s.onArrayBegin),N=a(s.onArrayEnd),q=h(s.onLiteralValue),te=h(s.onSeparator),x=a(s.onComment),F=h(s.onError),$=o&&o.disallowComments,T=o&&o.allowTrailingComma;function M(){for(;;){const re=l.scan();switch(l.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(re){case 12:case 13:$?V(10):x();break;case 16:V(1);break;case 15:case 14:break;default:return re}}}function V(re,G=[],H=[]){if(F(re),G.length+H.length>0){let oe=l.getToken();for(;oe!==17;){if(G.indexOf(oe)!==-1){M();break}else if(H.indexOf(oe)!==-1)break;oe=M()}}}function j(re){const G=l.getTokenValue();return re?q(G):u(G),M(),!0}function le(){switch(l.getToken()){case 11:{let re=0;try{re=JSON.parse(l.getTokenValue()),typeof re!="number"&&(V(2),re=0)}catch{V(2)}q(re);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return M(),!0}function Y(){return l.getToken()!==10?(V(3,[],[2,5]),!1):(j(!1),l.getToken()===6?(te(":"),M(),de()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function pe(){c(),M();let re=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(re||V(4,[],[]),te(","),M(),l.getToken()===2&&T)break}else re&&V(6,[],[]);Y()||V(4,[],[2,5]),re=!0}return g(),l.getToken()!==2?V(7,[2],[]):M(),!0}function ue(){A(),M();let re=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(re||V(4,[],[]),te(","),M(),l.getToken()===4&&T)break}else re&&V(6,[],[]);de()||V(4,[],[4,5]),re=!0}return N(),l.getToken()!==4?V(8,[4],[]):M(),!0}function de(){switch(l.getToken()){case 3:return ue();case 1:return pe();case 10:return j(!0);default:return le()}}return M(),l.getToken()===17?o.allowEmptyContent?!0:(V(4,[],[]),!1):de()?(l.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=E;function P(t,s){const o=I(t),l=[];let a,h=0,c;do switch(c=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:h!==c&&l.push(t.substring(h,c)),s!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,s)),h=o.getPosition();break}while(a!==17);return l.join("")}e.stripComments=P;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ie[28],Ce([1,0]),function(ee,e){"use strict";var i,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,n,r){let d=f.get(n);return d===void 0&&(d=r,f.set(n,d)),d}e.getOrSet=L;function I(f){const n=[];return f.forEach((r,d)=>{n.push(`${d} => ${r}`)}),`Map(${f.size}) {${n.join(", ")}}`}e.mapToString=I;function R(f){const n=[];return f.forEach(r=>{n.push(r)}),`Set(${f.size}) {${n.join(", ")}}`}e.setToString=R;class y{constructor(n,r){this.uri=n,this.value=r}}class k{constructor(n,r){this[i]="ResourceMap",n instanceof k?(this.b=new Map(n.b),this.c=r??k.a):(this.b=new Map,this.c=n??k.a)}set(n,r){return this.b.set(this.c(n),new y(n,r)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[d,b]of this.b)n(b.value,b.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.ResourceMap=k,k.a=f=>f.toString();class O{constructor(n,r){this[C]="ResourceSet",!n||typeof n=="function"?this.a=new k(n):(this.a=new k(r),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,r){this.a.forEach((d,b)=>n.call(r,b,b,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class m{constructor(){this[S]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,r=0){const d=this.a.get(n);if(!!d)return r!==0&&this.j(d,r),d.value}set(n,r,d=0){let b=this.a.get(n);if(b)b.value=r,d!==0&&this.j(b,d);else{switch(b={key:n,value:r,next:void 0,previous:void 0},d){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(n,b),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.a.get(n);if(!!r)return this.a.delete(n),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,r){const d=this.e;let b=this.b;for(;b;){if(r?n.bind(r)(b.value,b.key,this):n(b.value,b.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const n=this,r=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const E={value:d.key,done:!1};return d=d.next,E}else return{value:void 0,done:!0}}};return b}values(){const n=this,r=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const E={value:d.value,done:!1};return d=d.next,E}else return{value:void 0,done:!0}}};return b}entries(){const n=this,r=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const E={value:[d.key,d.value],done:!1};return d=d.next,E}else return{value:void 0,done:!0}}};return b}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.b,d=this.size;for(;r&&d>n;)this.a.delete(r.key),r=r.next,d--;this.b=r,this.d=d,r&&(r.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const r=n.next,d=n.previous;if(!r||!d)throw new Error("Invalid list");r.previous=d,d.next=r}n.next=void 0,n.previous=void 0,this.e++}j(n,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this.b)return;const d=n.next,b=n.previous;n===this.c?(b.next=void 0,this.c=b):(d.previous=b,b.next=d),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(r===2){if(n===this.c)return;const d=n.next,b=n.previous;n===this.b?(d.previous=void 0,this.b=d):(d.previous=b,b.next=d),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((r,d)=>{n.push([d,r])}),n}fromJSON(n){this.clear();for(const[r,d]of n)this.set(r,d)}}e.LinkedMap=m;class p extends m{constructor(n,r=1){super(),this.k=n,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[111],Ce([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,Se){for(var ke=0;ke<Se.length;ke++){var se=Se[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function i(Te,Se,ke){return Se&&e(Te.prototype,Se),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function C(Te,Se){if(!!Te){if(typeof Te=="string")return S(Te,Se);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return S(Te,Se)}}function S(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var ke=0,se=new Array(Se);ke<Se;ke++)se[ke]=Te[ke];return se}function L(Te,Se){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=C(Te))||Se&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=I();function R(Te){ee.defaults=Te}var y=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(Se){return m[Se]};function f(Te,Se){if(Se){if(y.test(Te))return Te.replace(k,p)}else if(O.test(Te))return Te.replace(w,p);return Te}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(Te){return Te.replace(n,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var d=/(^|[^\[])\^/g;function b(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var ke={replace:function(ce,J){return J=J.source||J,J=J.replace(d,"$1"),Te=Te.replace(ce,J),ke},getRegex:function(){return new RegExp(Te,Se)}};return ke}var E=/[^\w:]/g,P=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Te,Se,ke){if(Te){var se;try{se=decodeURIComponent(r(ke)).replace(E,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!P.test(ke)&&(ke=a(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var t={},s=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(Te,Se){t[" "+Te]||(s.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=g(Te,"/",!0)),Te=t[" "+Te];var ke=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Te.replace(o,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Te.replace(l,"$1")+Se:Te+Se}var h={exec:function(){}};function c(Te){for(var Se=1,ke,se;Se<arguments.length;Se++){ke=arguments[Se];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Te[se]=ke[se])}return Te}function u(Te,Se){var ke=Te.replace(/\|/g,function(J,D,B){for(var W=!1,K=D;--K>=0&&B[K]==="\\";)W=!W;return W?"|":" |"}),se=ke.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function g(Te,Se,ke){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var J=Te.charAt(se-ce-1);if(J===Se&&!ke)ce++;else if(J!==Se&&ke)ce++;else break}return Te.slice(0,se-ce)}function A(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var ke=Te.length,se=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Se[0])se++;else if(Te[ce]===Se[1]&&(se--,se<0))return ce;return-1}function N(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Te,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Te),Se>>=1,Te+=Te;return ke+Te}function te(Te,Se,ke,se){var ce=Se.href,J=Se.title?f(Se.title):null,D=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var B={type:"link",raw:ke,href:ce,title:J,text:D,tokens:se.inlineTokens(D)};return se.state.inLink=!1,B}return{type:"image",raw:ke,href:ce,title:J,text:f(D)}}function x(Te,Se){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return Se;var se=ke[1];return Se.split(`
`).map(function(ce){var J=ce.match(/^\s+/);if(J===null)return ce;var D=J[0];return D.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var F=function(){function Te(ke){this.options=ke||ee.defaults}var Se=Te.prototype;return Se.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var J=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?J:g(J,`
`)}}},Se.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var J=ce[0],D=x(J,ce[3]||"");return{type:"code",raw:J,lang:ce[2]?ce[2].trim():ce[2],text:D}}},Se.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var J=ce[2].trim();if(/#$/.test(J)){var D=g(J,"#");(this.options.pedantic||!D||/ $/.test(D))&&(J=D.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var J=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var J,D,B,W,K,Z,he,ye,ae,be,Ee,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(J=ce[0],se=se.substring(J.length),ye=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),Z=!1,!ye&&/^ *$/.test(ae)&&(J+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(be=se.split(`
`,1)[0],ye=be,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||st.test(ye)||it.test(ye)||dt.test(se)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!Z)Ee+=`
`+ye;else break;!Z&&!ye.trim()&&(Z=!0),J+=be+`
`,se=se.substring(be.length+1)}Xe.loose||(he?Xe.loose=!0:/\n *\n *$/.test(J)&&(he=!0)),this.options.gfm&&(D=/^\[[ xX]\] /.exec(Ee),D&&(B=D[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:J,task:!!D,checked:B,loose:!1,text:Ee}),Xe.raw+=J}Xe.items[Xe.items.length-1].raw=J.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var _=Xe.items.length;for(K=0;K<_;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var Q=Xe.items[K].tokens.filter(function(Me){return Me.type==="space"}),ge=Q.every(function(Me){for(var $e=Me.raw.split(""),je=0,_e=L($e),nt;!(nt=_e()).done;){var wt=nt.value;if(wt===`
`&&(je+=1),je>1)return!0}return!1});!Xe.loose&&Q.length&&ge&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},Se.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var J={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var D=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);J.type="paragraph",J.text=D,J.tokens=this.lexer.inline(D)}return J}},Se.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var J=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var J={type:"table",header:u(ce[1]).map(function(he){return{text:he}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ce[0];var D=J.align.length,B,W,K,Z;for(B=0;B<D;B++)/^ *-+: *$/.test(J.align[B])?J.align[B]="right":/^ *:-+: *$/.test(J.align[B])?J.align[B]="center":/^ *:-+ *$/.test(J.align[B])?J.align[B]="left":J.align[B]=null;for(D=J.rows.length,B=0;B<D;B++)J.rows[B]=u(J.rows[B],J.header.length).map(function(he){return{text:he}});for(D=J.header.length,W=0;W<D;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(D=J.rows.length,W=0;W<D;W++)for(Z=J.rows[W],K=0;K<Z.length;K++)Z[K].tokens=this.lexer.inline(Z[K].text);return J}}},Se.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var J=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Se.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Se.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var J=ce[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var D=g(J.slice(0,-1),"\\");if((J.length-D.length)%2===0)return}else{var B=A(ce[2],"()");if(B>-1){var W=ce[0].indexOf("!")===0?5:4,K=W+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,K).trim(),ce[3]=""}}var Z=ce[2],he="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);ye&&(Z=ye[1],he=ye[3])}else he=ce[3]?ce[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(J)?Z=Z.slice(1):Z=Z.slice(1,-1)),te(ce,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(se,ce){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var D=(J[2]||J[1]).replace(/\s+/g," ");if(D=ce[D.toLowerCase()],!D||!D.href){var B=J[0].charAt(0);return{type:"text",raw:B,text:B}}return te(J,D,J[0],this.lexer)}},Se.emStrong=function(se,ce,J){J===void 0&&(J="");var D=this.rules.inline.emStrong.lDelim.exec(se);if(!!D&&!(D[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=D[1]||D[2]||"";if(!B||B&&(J===""||this.rules.inline.punctuation.exec(J))){var W=D[0].length-1,K,Z,he=W,ye=0,ae=D[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+W);(D=ae.exec(ce))!=null;)if(K=D[1]||D[2]||D[3]||D[4]||D[5]||D[6],!!K){if(Z=K.length,D[3]||D[4]){he+=Z;continue}else if((D[5]||D[6])&&W%3&&!((W+Z)%3)){ye+=Z;continue}if(he-=Z,!(he>0)){if(Z=Math.min(Z,Z+he+ye),Math.min(W,Z)%2){var be=se.slice(1,W+D.index+Z);return{type:"em",raw:se.slice(0,W+D.index+Z+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=se.slice(2,W+D.index+Z-1);return{type:"strong",raw:se.slice(0,W+D.index+Z+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var J=ce[2].replace(/\n/g," "),D=/[^ ]/.test(J),B=/^ /.test(J)&&/ $/.test(J);return D&&B&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ce[0],text:J}}},Se.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(se,ce){var J=this.rules.inline.autolink.exec(se);if(J){var D,B;return J[2]==="@"?(D=f(this.options.mangle?ce(J[1]):J[1]),B="mailto:"+D):(D=f(J[1]),B=D),{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Se.url=function(se,ce){var J;if(J=this.rules.inline.url.exec(se)){var D,B;if(J[2]==="@")D=f(this.options.mangle?ce(J[0]):J[0]),B="mailto:"+D;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);D=f(J[0]),J[1]==="www."?B="http://"+D:B=D}return{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Se.inlineText=function(se,ce){var J=this.rules.inline.text.exec(se);if(J){var D;return this.lexer.state.inRawBlock?D=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:D=f(this.options.smartypants?ce(J[0]):J[0]),{type:"text",raw:J[0],text:D}}},Te}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=b($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=b(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=b($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=b($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=b($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=b($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=c({},$),$.gfm=c({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=b($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=b($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=c({},$.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:b($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=b(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=b($._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=b(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=b(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=b(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=b(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=b(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=b(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=b(T.reflink).replace("label",T._label).replace("ref",$._label).getRegex(),T.nolink=b(T.nolink).replace("ref",$._label).getRegex(),T.reflinkSearch=b(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=c({},T),T.pedantic=c({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=c({},T.normal,{escape:b(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=b(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=c({},T.gfm,{br:b(T.br).replace("{2,}","*").getRegex(),text:b(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Te){var Se="",ke,se,ce=Te.length;for(ke=0;ke<ce;ke++)se=Te.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var j=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ee.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:$.normal,inline:T.normal};this.options.pedantic?(se.block=$.pedantic,se.inline=T.pedantic):this.options.gfm&&(se.block=$.gfm,this.options.breaks?se.inline=T.breaks:se.inline=T.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var J=new Te(ce);return J.lex(se)},Te.lexInline=function(se,ce){var J=new Te(ce);return J.inlineTokens(se)};var Se=Te.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(he,ye,ae){return ye+"    ".repeat(ae.length)});for(var D,B,W,K;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(D=he.call({lexer:J},se,ce))?(se=se.substring(D.raw.length),ce.push(D),!0):!1}))){if(D=this.tokenizer.space(se)){se=se.substring(D.raw.length),D.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(D);continue}if(D=this.tokenizer.code(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D);continue}if(D=this.tokenizer.fences(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.heading(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.hr(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.blockquote(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.list(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.html(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.def(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[D.tag]||(this.tokens.links[D.tag]={href:D.href,title:D.title});continue}if(D=this.tokenizer.table(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.lheading(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,ye=se.slice(1),ae=void 0;J.options.extensions.startBlock.forEach(function(be){ae=be.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(he=Math.min(he,ae))}),he<1/0&&he>=0&&(W=se.substring(0,he+1))}(),this.state.top&&(D=this.tokenizer.paragraph(W))){B=ce[ce.length-1],K&&B.type==="paragraph"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D),K=W.length!==se.length,se=se.substring(D.raw.length);continue}if(D=this.tokenizer.text(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D);continue}if(se){var Z="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ce},Se.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Se.inlineTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]);var D,B,W,K=se,Z,he,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ae.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,Z.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(he||(ye=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(D=Ee.call({lexer:J},se,ce))?(se=se.substring(D.raw.length),ce.push(D),!0):!1}))){if(D=this.tokenizer.escape(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.tag(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(D=this.tokenizer.link(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(D=this.tokenizer.emStrong(se,K,ye)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.codespan(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.br(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.del(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.autolink(se,V)){se=se.substring(D.raw.length),ce.push(D);continue}if(!this.state.inLink&&(D=this.tokenizer.url(se,V))){se=se.substring(D.raw.length),ce.push(D);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=se.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&(W=se.substring(0,Ee+1))}(),D=this.tokenizer.inlineText(W,M)){se=se.substring(D.raw.length),D.raw.slice(-1)!=="_"&&(ye=D.raw.slice(-1)),he=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ce},i(Te,null,[{key:"rules",get:function(){return{block:$,inline:T}}}]),Te}(),le=function(){function Te(ke){this.options=ke||ee.defaults}var Se=Te.prototype;return Se.code=function(se,ce,J){var D=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,D);B!=null&&B!==se&&(J=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,D?'<pre><code class="'+this.options.langPrefix+f(D,!0)+'">'+(J?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:f(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ce,J,D){if(this.options.headerIds){var B=this.options.headerPrefix+D.slug(J);return"<h"+ce+' id="'+B+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ce,J){var D=ce?"ol":"ul",B=ce&&J!==1?' start="'+J+'"':"";return"<"+D+B+`>
`+se+"</"+D+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ce){var J=ce.header?"th":"td",D=ce.align?"<"+J+' align="'+ce.align+'">':"<"+J+">";return D+se+("</"+J+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ce,J){if(se=v(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var D='<a href="'+f(se)+'"';return ce&&(D+=' title="'+ce+'"'),D+=">"+J+"</a>",D},Se.image=function(se,ce,J){if(se=v(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var D='<img src="'+se+'" alt="'+J+'"';return ce&&(D+=' title="'+ce+'"'),D+=this.options.xhtml?"/>":">",D},Se.text=function(se){return se},Te}(),Y=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ce,J){return""+J},Se.image=function(se,ce,J){return""+J},Se.br=function(){return""},Te}(),pe=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ce){var J=se,D=0;if(this.seen.hasOwnProperty(J)){D=this.seen[se];do D++,J=se+"-"+D;while(this.seen.hasOwnProperty(J))}return ce||(this.seen[se]=D,this.seen[J]=0),J},Se.slug=function(se,ce){ce===void 0&&(ce={});var J=this.serialize(se);return this.getNextSafeSlug(J,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||ee.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new pe}Te.parse=function(se,ce){var J=new Te(ce);return J.parse(se)},Te.parseInline=function(se,ce){var J=new Te(ce);return J.parseInline(se)};var Se=Te.prototype;return Se.parse=function(se,ce){ce===void 0&&(ce=!0);var J="",D,B,W,K,Z,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,_=se.length;for(D=0;D<_;D++){if(Ee=se[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(st=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=st||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,r(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",K=Ee.header.length,B=0;B<K;B++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[B].tokens),{header:!0,align:Ee.align[B]});for(ae+=this.renderer.tablerow(ye),be="",K=Ee.rows.length,B=0;B<K;B++){for(he=Ee.rows[B],ye="",Z=he.length,W=0;W<Z;W++)ye+=this.renderer.tablecell(this.parseInline(he[W].tokens),{header:!1,align:Ee.align[W]});be+=this.renderer.tablerow(ye)}J+=this.renderer.table(ae,be);continue}case"blockquote":{be=this.parse(Ee.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(We=Ee.ordered,He=Ee.start,tt=Ee.loose,K=Ee.items.length,be="",B=0;B<K;B++)et=Ee.items[B],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),be+=this.renderer.listitem(Xe,dt,it);J+=this.renderer.list(be,We,He);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;D+1<_&&se[D+1].type==="text";)Ee=se[++D],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=ce?this.renderer.paragraph(be):be;continue}default:{var Q='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return J},Se.parseInline=function(se,ce){ce=ce||this.renderer;var J="",D,B,W,K=se.length;for(D=0;D<K;D++){if(B=se[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(W=this.options.extensions.renderers[B.type].call({parser:this},B),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){J+=W||"";continue}switch(B.type){case"escape":{J+=ce.text(B.text);break}case"html":{J+=ce.html(B.text);break}case"link":{J+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{J+=ce.image(B.href,B.title,B.text);break}case"strong":{J+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{J+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{J+=ce.codespan(B.text);break}case"br":{J+=ce.br();break}case"del":{J+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{J+=ce.text(B.text);break}default:{var Z='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return J},Te}();function de(Te,Se,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=c({},de.defaults,Se||{}),N(Se),ke){var se=Se.highlight,ce;try{ce=j.lex(Te,Se)}catch(K){return ke(K)}var J=function(Z){var he;if(!Z)try{Se.walkTokens&&de.walkTokens(ce,Se.walkTokens),he=ue.parse(ce,Se)}catch(ye){Z=ye}return Se.highlight=se,Z?ke(Z):ke(null,he)};if(!se||se.length<3||(delete Se.highlight,!ce.length))return J();var D=0;de.walkTokens(ce,function(K){K.type==="code"&&(D++,setTimeout(function(){se(K.text,K.lang,function(Z,he){if(Z)return J(Z);he!=null&&he!==K.text&&(K.text=he,K.escaped=!0),D--,D===0&&J()})},0))}),D===0&&J();return}function B(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(K.message+"",!0)+"</pre>";throw K}try{var W=j.lex(Te,Se);if(Se.walkTokens){if(Se.async)return Promise.all(de.walkTokens(W,Se.walkTokens)).then(function(){return ue.parse(W,Se)}).catch(B);de.walkTokens(W,Se.walkTokens)}return ue.parse(W,Se)}catch(K){B(K)}}de.options=de.setOptions=function(Te){return c(de.defaults,Te),R(de.defaults),de},de.getDefaults=I,de.defaults=ee.defaults,de.use=function(){for(var Te=arguments.length,Se=new Array(Te),ke=0;ke<Te;ke++)Se[ke]=arguments[ke];var se=c.apply(void 0,[{}].concat(Se)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(D){if(D.extensions&&(J=!0,D.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var K=ce.renderers?ce.renderers[W.name]:null;K?ce.renderers[W.name]=function(){for(var Z=arguments.length,he=new Array(Z),ye=0;ye<Z;ye++)he[ye]=arguments[ye];var ae=W.renderer.apply(this,he);return ae===!1&&(ae=K.apply(this,he)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),D.renderer&&function(){var W=de.defaults.renderer||new le,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=D.renderer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var Z in D.renderer)K(Z);se.renderer=W}(),D.tokenizer&&function(){var W=de.defaults.tokenizer||new F,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=D.tokenizer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var Z in D.tokenizer)K(Z);se.tokenizer=W}(),D.walkTokens){var B=de.defaults.walkTokens;se.walkTokens=function(W){var K=[];return K.push(D.walkTokens.call(this,W)),B&&(K=K.concat(B.call(this,W))),K}}J&&(se.extensions=ce),de.setOptions(se)})},de.walkTokens=function(Te,Se){for(var ke=[],se=function(){var B=J.value;switch(ke=ke.concat(Se.call(de,B)),B.type){case"table":{for(var W=L(B.header),K;!(K=W()).done;){var Z=K.value;ke=ke.concat(de.walkTokens(Z.tokens,Se))}for(var he=L(B.rows),ye;!(ye=he()).done;)for(var ae=ye.value,be=L(ae),Ee;!(Ee=be()).done;){var We=Ee.value;ke=ke.concat(de.walkTokens(We.tokens,Se))}break}case"list":{ke=ke.concat(de.walkTokens(B.items,Se));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[B.type]?de.defaults.extensions.childTokens[B.type].forEach(function(He){ke=ke.concat(de.walkTokens(B[He],Se))}):B.tokens&&(ke=ke.concat(de.walkTokens(B.tokens,Se)))}},ce=L(Te),J;!(J=ce()).done;)se();return ke},de.parseInline=function(Te,Se){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=c({},de.defaults,Se||{}),N(Se);try{var ke=j.lexInline(Te,Se);return Se.walkTokens&&de.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},de.Parser=ue,de.parser=ue.parse,de.Renderer=le,de.TextRenderer=Y,de.Lexer=j,de.lexer=j.lex,de.Tokenizer=F,de.Slugger=pe,de.parse=de;var re=de.options,G=de.setOptions,H=de.use,oe=de.walkTokens,ve=de.parseInline,Ae=de,Be=ue.parse,xe=j.lex;ee.Lexer=j,ee.Parser=ue,ee.Renderer=le,ee.Slugger=pe,ee.TextRenderer=Y,ee.Tokenizer=F,ee.getDefaults=I,ee.lexer=xe,ee.marked=de,ee.options=re,ee.parse=Ae,ee.parseInline=ve,ee.parser=Be,ee.setOptions=G,ee.use=H,ee.walkTokens=oe,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ie[112],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(R,y,k){return Math.min(Math.max(R,y),k)}e.clamp=i;function C(R,y){return(y+R%y)%y}e.rot=C;class S{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=S;class L{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class I{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const k=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function ee(S){const L=[];typeof S=="number"&&L.push("code/timeOrigin",S);function I(y){L.push(y,Date.now())}function R(){const y=[];for(let k=0;k<L.length;k+=2)y.push({name:L[k],startTime:L[k+1]});return y}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(S+I.startTime)});return L}};if(typeof process=="object"){const S=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=i(C))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var C in i)(typeof exports=="object"?exports:ee)[C]=i[C]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return ee[C].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=ee,i.c=e,i.d=function(C,S,L){i.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:L})},i.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},i.t=function(C,S){if(1&S&&(C=i(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var I in C)i.d(L,I,function(R){return C[R]}.bind(null,I));return L},i.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return i.d(S,"a",S),S},i.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},i.p="",i(i.s=0)}([function(ee,e,i){(function(C){var S;e=ee.exports=H,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],k=0,O=k++;y[O]="0|[1-9]\\d*";var w=k++;y[w]="[0-9]+";var m=k++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=k++;y[p]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var f=k++;y[f]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var n=k++;y[n]="(?:"+y[O]+"|"+y[m]+")";var r=k++;y[r]="(?:"+y[w]+"|"+y[m]+")";var d=k++;y[d]="(?:-("+y[n]+"(?:\\."+y[n]+")*))";var b=k++;y[b]="(?:-?("+y[r]+"(?:\\."+y[r]+")*))";var E=k++;y[E]="[0-9A-Za-z-]+";var P=k++;y[P]="(?:\\+("+y[E]+"(?:\\."+y[E]+")*))";var v=k++,t="v?"+y[p]+y[d]+"?"+y[P]+"?";y[v]="^"+t+"$";var s="[v=\\s]*"+y[f]+y[b]+"?"+y[P]+"?",o=k++;y[o]="^"+s+"$";var l=k++;y[l]="((?:<|>)?=?)";var a=k++;y[a]=y[w]+"|x|X|\\*";var h=k++;y[h]=y[O]+"|x|X|\\*";var c=k++;y[c]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[d]+")?"+y[P]+"?)?)?";var u=k++;y[u]="[v=\\s]*("+y[a]+")(?:\\.("+y[a]+")(?:\\.("+y[a]+")(?:"+y[b]+")?"+y[P]+"?)?)?";var g=k++;y[g]="^"+y[l]+"\\s*"+y[c]+"$";var A=k++;y[A]="^"+y[l]+"\\s*"+y[u]+"$";var N=k++;y[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=k++;y[q]="(?:~>?)";var te=k++;y[te]="(\\s*)"+y[q]+"\\s+",R[te]=new RegExp(y[te],"g");var x=k++;y[x]="^"+y[q]+y[c]+"$";var F=k++;y[F]="^"+y[q]+y[u]+"$";var $=k++;y[$]="(?:\\^)";var T=k++;y[T]="(\\s*)"+y[$]+"\\s+",R[T]=new RegExp(y[T],"g");var M=k++;y[M]="^"+y[$]+y[c]+"$";var V=k++;y[V]="^"+y[$]+y[u]+"$";var j=k++;y[j]="^"+y[l]+"\\s*("+s+")$|^$";var le=k++;y[le]="^"+y[l]+"\\s*("+t+")$|^$";var Y=k++;y[Y]="(\\s*)"+y[l]+"\\s*("+s+"|"+y[c]+")",R[Y]=new RegExp(y[Y],"g");var pe=k++;y[pe]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var ue=k++;y[ue]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var de=k++;y[de]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)S(re,y[re]),R[re]||(R[re]=new RegExp(y[re]));function G(ae,be){if(ae instanceof H)return ae;if(typeof ae!="string"||ae.length>L||!(be?R[o]:R[v]).test(ae))return null;try{return new H(ae,be)}catch{return null}}function H(ae,be){if(ae instanceof H){if(ae.loose===be)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof H))return new H(ae,be);S("SemVer",ae,be),this.loose=be;var Ee=ae.trim().match(be?R[o]:R[v]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<I)return He}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,be){var Ee=G(ae,be);return Ee?Ee.version:null},e.clean=function(ae,be){var Ee=G(ae.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(ae){return S("SemVer.compare",this.version,this.loose,ae),ae instanceof H||(ae=new H(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},H.prototype.compareMain=function(ae){return ae instanceof H||(ae=new H(ae,this.loose)),ve(this.major,ae.major)||ve(this.minor,ae.minor)||ve(this.patch,ae.patch)},H.prototype.comparePre=function(ae){if(ae instanceof H||(ae=new H(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],We=ae.prerelease[be];if(S("prerelease compare",be,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return ve(Ee,We)}while(++be)},H.prototype.inc=function(ae,be){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,be,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new H(ae,Ee).inc(be,We).version}catch{return null}},e.diff=function(ae,be){if(Te(ae,be))return null;var Ee=G(ae),We=G(be);if(Ee.prerelease.length||We.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return He},e.compareIdentifiers=ve;var oe=/^[0-9]+$/;function ve(ae,be){var Ee=oe.test(ae),We=oe.test(be);return Ee&&We&&(ae=+ae,be=+be),Ee&&!We?-1:We&&!Ee?1:ae<be?-1:ae>be?1:0}function Ae(ae,be,Ee){return new H(ae,Ee).compare(new H(be,Ee))}function Be(ae,be,Ee){return Ae(ae,be,Ee)>0}function xe(ae,be,Ee){return Ae(ae,be,Ee)<0}function Te(ae,be,Ee){return Ae(ae,be,Ee)===0}function Se(ae,be,Ee){return Ae(ae,be,Ee)!==0}function ke(ae,be,Ee){return Ae(ae,be,Ee)>=0}function se(ae,be,Ee){return Ae(ae,be,Ee)<=0}function ce(ae,be,Ee,We){var He;switch(be){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae!==Ee;break;case"":case"=":case"==":He=Te(ae,Ee,We);break;case"!=":He=Se(ae,Ee,We);break;case">":He=Be(ae,Ee,We);break;case">=":He=ke(ae,Ee,We);break;case"<":He=xe(ae,Ee,We);break;case"<=":He=se(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+be)}return He}function J(ae,be){if(ae instanceof J){if(ae.loose===be)return ae;ae=ae.value}if(!(this instanceof J))return new J(ae,be);S("comparator",ae,be),this.loose=be,this.parse(ae),this.semver===D?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(ae,be){return ve(be,ae)},e.major=function(ae,be){return new H(ae,be).major},e.minor=function(ae,be){return new H(ae,be).minor},e.patch=function(ae,be){return new H(ae,be).patch},e.compare=Ae,e.compareLoose=function(ae,be){return Ae(ae,be,!0)},e.rcompare=function(ae,be,Ee){return Ae(be,ae,Ee)},e.sort=function(ae,be){return ae.sort(function(Ee,We){return e.compare(Ee,We,be)})},e.rsort=function(ae,be){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,be)})},e.gt=Be,e.lt=xe,e.eq=Te,e.neq=Se,e.gte=ke,e.lte=se,e.cmp=ce,e.Comparator=J;var D={};function B(ae,be){if(ae instanceof B)return ae.loose===be?ae:new B(ae.raw,be);if(ae instanceof J)return new B(ae.value,be);if(!(this instanceof B))return new B(ae,be);if(this.loose=be,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function K(ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,_){return((be=W(Ee)?"":W(We)?">="+Ee+".0.0":W(He)?">="+Ee+"."+We+".0":">="+be)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function Z(ae,be){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(S(ae[Ee].semver),ae[Ee].semver!==D&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===be.major&&We.minor===be.minor&&We.patch===be.patch)return!0}return!1}return!0}function he(ae,be,Ee){try{be=new B(be,Ee)}catch{return!1}return be.test(ae)}function ye(ae,be,Ee,We){var He,tt,Xe,et,it;switch(ae=new H(ae,We),be=new B(be,We),Ee){case">":He=Be,tt=se,Xe=xe,et=">",it=">=";break;case"<":He=xe,tt=ke,Xe=Be,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ae,be,We))return!1;for(var dt=0;dt<be.set.length;++dt){var Fe=be.set[dt],st=null,_=null;if(Fe.forEach(function(Q){Q.semver===D&&(Q=new J(">=0.0.0")),st=st||Q,_=_||Q,He(Q.semver,st.semver,We)?st=Q:Xe(Q.semver,_.semver,We)&&(_=Q)}),st.operator===et||st.operator===it||(!_.operator||_.operator===et)&&tt(ae,_.semver)||_.operator===it&&Xe(ae,_.semver))return!1}return!0}J.prototype.parse=function(ae){var be=this.loose?R[j]:R[le],Ee=ae.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new H(Ee[2],this.loose):this.semver=D},J.prototype.toString=function(){return this.value},J.prototype.test=function(ae){return S("Comparator.test",ae,this.loose),this.semver===D||(typeof ae=="string"&&(ae=new H(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ae,be){if(!(ae instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new B(ae.value,be),he(this.value,Ee,be);if(ae.operator==="")return Ee=new B(this.value,be),he(ae.semver,Ee,be);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,be)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(ae){var be=this.loose;ae=ae.trim(),S("range",ae,be);var Ee=be?R[ue]:R[pe];ae=ae.replace(Ee,K),S("hyphen replace",ae),ae=ae.replace(R[Y],"$1$2$3"),S("comparator trim",ae,R[Y]),ae=(ae=(ae=ae.replace(R[te],"$1~")).replace(R[T],"$1^")).split(/\s+/).join(" ");var We=be?R[j]:R[le],He=ae.split(" ").map(function(tt){return function(Xe,et){return S("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){S("caret",st,_);var Q=_?R[V]:R[M];return st.replace(Q,function(ge,Me,$e,je,_e){var nt;return S("caret",st,ge,Me,$e,je,_e),W(Me)?nt="":W($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(je)?nt=Me==="0"?">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+".0 <"+(+Me+1)+".0.0":_e?(S("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+je+_e+" <"+Me+"."+$e+"."+(+je+1):">="+Me+"."+$e+"."+je+_e+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+je+_e+" <"+(+Me+1)+".0.0"):(S("no pr"),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+je+" <"+Me+"."+$e+"."+(+je+1):">="+Me+"."+$e+"."+je+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+je+" <"+(+Me+1)+".0.0"),S("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),S("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){var Q=_?R[F]:R[x];return st.replace(Q,function(ge,Me,$e,je,_e){var nt;return S("tilde",st,ge,Me,$e,je,_e),W(Me)?nt="":W($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(je)?nt=">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":_e?(S("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=">="+Me+"."+$e+"."+je+_e+" <"+Me+"."+(+$e+1)+".0"):nt=">="+Me+"."+$e+"."+je+" <"+Me+"."+(+$e+1)+".0",S("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),S("tildes",Xe),Xe=function(it,dt){return S("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,_){st=st.trim();var Q=_?R[A]:R[g];return st.replace(Q,function(ge,Me,$e,je,_e,nt){S("xRange",st,ge,Me,$e,je,_e,nt);var wt=W($e),St=wt||W(je),Ct=St||W(_e);return Me==="="&&Ct&&(Me=""),wt?ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(St&&(je=0),Ct&&(_e=0),Me===">"?(Me=">=",St?($e=+$e+1,je=0,_e=0):Ct&&(je=+je+1,_e=0)):Me==="<="&&(Me="<",St?$e=+$e+1:je=+je+1),ge=Me+$e+"."+je+"."+_e):St?ge=">="+$e+".0.0 <"+(+$e+1)+".0.0":Ct&&(ge=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),S("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),S("xrange",Xe),Xe=function(it,dt){return S("replaceStars",it,dt),it.trim().replace(R[de],"")}(Xe,et),S("stars",Xe),Xe}(tt,be)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new J(tt,be)})},B.prototype.intersects=function(ae,be){if(!(ae instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,be)})})})})},e.toComparators=function(ae,be){return new B(ae,be).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},B.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new H(ae,this.loose));for(var be=0;be<this.set.length;be++)if(Z(this.set[be],ae))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new H(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new H(We=Xe,Ee)))}),We},e.validRange=function(ae,be){try{return new B(ae,be).range||"*"}catch{return null}},e.ltr=function(ae,be,Ee){return ye(ae,be,"<",Ee)},e.gtr=function(ae,be,Ee){return ye(ae,be,">",Ee)},e.outside=ye,e.prerelease=function(ae,be){var Ee=G(ae,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,be,Ee){return ae=new B(ae,Ee),be=new B(be,Ee),ae.intersects(be)},e.coerce=function(ae){if(ae instanceof H)return ae;if(typeof ae!="string")return null;var be=ae.match(R[N]);return be==null?null:G((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,C,S=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(r){if(i===setTimeout)return setTimeout(r,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(r,0);try{return i(r,0)}catch{try{return i.call(null,r,0)}catch{return i.call(this,r,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var y,k=[],O=!1,w=-1;function m(){O&&y&&(O=!1,y.length?k=y.concat(k):w=-1,k.length&&p())}function p(){if(!O){var r=R(m);O=!0;for(var d=k.length;d;){for(y=k,k=[];++w<d;)y&&y[w].run();w=-1,d=k.length}y=null,O=!1,function(b){if(C===clearTimeout)return clearTimeout(b);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(b);try{C(b)}catch{try{return C.call(null,b)}catch{return C.call(this,b)}}}(r)}}function f(r,d){this.fun=r,this.array=d}function n(){}S.nextTick=function(r){var d=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)d[b-1]=arguments[b];k.push(new f(r,d)),k.length!==1||O||R(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=n,S.addListener=n,S.once=n,S.off=n,S.removeListener=n,S.removeAllListeners=n,S.emit=n,S.prependListener=n,S.prependOnceListener=n,S.listeners=function(r){return[]},S.binding=function(r){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(r){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ie[113],Ce([1,0,11,6]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(P){const v=P;return v?typeof v.read=="function":!1}e.isReadable=S;function L(P){const v=P;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function I(P){const v=P;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=I;function R(P,v){return new y(P,v)}e.newWriteableStream=R;class y{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,i.onUnexpectedError)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let s;switch(v){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const o=s.indexOf(t);o>=0&&s.splice(o,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(P,v){const t=[];let s;for(;(s=P.read())!==null;)t.push(s);return v(t)}e.consumeReadable=k;function O(P,v,t){const s=[];let o;for(;(o=P.read())!==null&&s.length<t;)s.push(o);return o===null&&s.length>0?v(s):{read:()=>{if(s.length>0)return s.shift();if(typeof o<"u"){const l=o;return o=void 0,l}return P.read()}}}e.peekReadable=O;function w(P,v){return new Promise((t,s)=>{const o=[];m(P,{onData:l=>{v&&o.push(l)},onError:l=>{v?s(l):t(void 0)},onEnd:()=>{t(v?v(o):void 0)}})})}e.consumeStream=w;function m(P,v){let t=!1;return P.on("error",s=>{t||v.onError(s)}),P.on("end",()=>{t||v.onEnd()}),P.on("data",s=>{t||v.onData(s)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=m;function p(P,v){return new Promise((t,s)=>{const o=new C.DisposableStore,l=[],a=u=>{if(l.push(u),l.length>v)return o.dispose(),P.pause(),t({stream:P,buffer:l,ended:!1})},h=u=>s(u),c=()=>t({stream:P,buffer:l,ended:!0});o.add((0,C.toDisposable)(()=>P.removeListener("error",h))),P.on("error",h),o.add((0,C.toDisposable)(()=>P.removeListener("end",c))),P.on("end",c),o.add((0,C.toDisposable)(()=>P.removeListener("data",a))),P.on("data",a)})}e.peekStream=p;function f(P,v){const t=R(v);return t.end(P),t}e.toStream=f;function n(){const P=R(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=n;function r(P){let v=!1;return{read:()=>v?null:(v=!0,P)}}e.toReadable=r;function d(P,v,t){const s=R(t);return m(P,{onData:o=>s.write(v.data(o)),onError:o=>s.error(v.error?v.error(o):o),onEnd:()=>s.end()}),s}e.transform=d;function b(P,v,t){let s=!1;return{read:()=>{const o=v.read();return s?o:(s=!0,o!==null?t([P,o]):P)}}}e.prefixedReadable=b;function E(P,v,t){let s=!1;const o=R(t);return m(v,{onData:l=>s?o.write(l):(s=!0,o.write(t([P,l]))),onError:l=>o.error(l),onEnd:()=>{s||(s=!0,o.write(P)),o.end()}}),o}e.prefixedStream=E}),define(Ie[25],Ce([1,0,113]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let S,L;class I{static alloc(u){return C?new I(Buffer.allocUnsafe(u)):new I(new Uint8Array(u))}static wrap(u){return C&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new I(u)}static fromString(u,g){return!(g?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(u)):(S||(S=new TextEncoder),new I(S.encode(u)))}static fromByteArray(u){const g=I.alloc(u.length);for(let A=0,N=u.length;A<N;A++)g.buffer[A]=u[A];return g}static concat(u,g){if(typeof g>"u"){g=0;for(let q=0,te=u.length;q<te;q++)g+=u[q].byteLength}const A=I.alloc(g);let N=0;for(let q=0,te=u.length;q<te;q++){const x=u[q];A.set(x,N),N+=x.byteLength}return A}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=I.alloc(this.byteLength);return u.set(this),u}toString(){return C?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(u,g){return new I(this.buffer.subarray(u,g))}set(u,g){if(u instanceof I)this.buffer.set(u.buffer,g);else if(u instanceof Uint8Array)this.buffer.set(u,g);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),g);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return k(this.buffer,u)}writeUInt32BE(u,g){O(this.buffer,u,g)}readUInt32LE(u){return w(this.buffer,u)}writeUInt32LE(u,g){m(this.buffer,u,g)}readUInt8(u){return p(this.buffer,u)}writeUInt8(u,g){f(this.buffer,u,g)}}e.VSBuffer=I;function R(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=R;function y(c,u,g){c[g+0]=u&255,u=u>>>8,c[g+1]=u&255}e.writeUInt16LE=y;function k(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=k;function O(c,u,g){c[g+3]=u,u=u>>>8,c[g+2]=u,u=u>>>8,c[g+1]=u,u=u>>>8,c[g]=u}e.writeUInt32BE=O;function w(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=w;function m(c,u,g){c[g+0]=u&255,u=u>>>8,c[g+1]=u&255,u=u>>>8,c[g+2]=u&255,u=u>>>8,c[g+3]=u&255}e.writeUInt32LE=m;function p(c,u){return c[u]}e.readUInt8=p;function f(c,u,g){c[g]=u}e.writeUInt8=f;function n(c){return i.consumeReadable(c,u=>I.concat(u))}e.readableToBuffer=n;function r(c){return i.toReadable(c)}e.bufferToReadable=r;function d(c){return i.consumeStream(c,u=>I.concat(u))}e.streamToBuffer=d;async function b(c){return c.ended?I.concat(c.buffer):I.concat([...c.buffer,await d(c.stream)])}e.bufferedStreamToBuffer=b;function E(c){return i.toStream(c,u=>I.concat(u))}e.bufferToStream=E;function P(c){return i.transform(c,{data:u=>typeof u=="string"?I.fromString(u):I.wrap(u)},u=>I.concat(u))}e.streamToBufferReadableStream=P;function v(c){return i.newWriteableStream(u=>I.concat(u),c)}e.newWriteableBufferStream=v;function t(c,u){return i.prefixedReadable(c,u,g=>I.concat(g))}e.prefixedBufferReadable=t;function s(c,u){return i.prefixedStream(c,u,g=>I.concat(g))}e.prefixedBufferStream=s;function o(c){let u=0,g=0,A=0;const N=new Uint8Array(Math.floor(c.length/4*3)),q=x=>{switch(g){case 3:N[A++]=u|x,g=0;break;case 2:N[A++]=u|x>>>2,u=x<<6,g=3;break;case 1:N[A++]=u|x>>>4,u=x<<4,g=2;break;default:u=x<<2,g=1}};for(let x=0;x<c.length;x++){const F=c.charCodeAt(x);if(F>=65&&F<=90)q(F-65);else if(F>=97&&F<=122)q(F-97+26);else if(F>=48&&F<=57)q(F-48+52);else if(F===43||F===45)q(62);else if(F===47||F===95)q(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${c[x]}`)}}const te=A;for(;g>0;)q(0);return I.wrap(N).slice(0,te)}e.decodeBase64=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:c},u=!0,g=!1){const A=g?a:l;let N="";const q=c.byteLength%3;let te=0;for(;te<c.byteLength-q;te+=3){const x=c[te+0],F=c[te+1],$=c[te+2];N+=A[x>>>2],N+=A[(x<<4|F>>>4)&63],N+=A[(F<<2|$>>>6)&63],N+=A[$&63]}if(q===1){const x=c[te+0];N+=A[x>>>2],N+=A[x<<4&63],u&&(N+="==")}else if(q===2){const x=c[te+0],F=c[te+1];N+=A[x>>>2],N+=A[(x<<4|F>>>4)&63],N+=A[F<<2&63],u&&(N+="=")}return N}e.encodeBase64=h}),define(Ie[34],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return i.test(S)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){S(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,k="";return k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k}}()}),define(Ie[114],Ce([1,0,18,34]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function S(R){return{id:(0,C.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=S;function L(R,y,k){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:y,data:k}),value:void 0}}e.createFileDataTransferItem=L;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,k){const O=this.a.get(y);O?O.push(k):this.a.set(this.b(y),[k])}replace(y,k){this.a.set(this.b(y),[k])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,k]of this.a.entries())for(const O of k)yield[y,O]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[k,O]of this.entries())y(O,k)}b(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:R=>(0,i.distinct)(R.map(y=>y.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(y=>!y.startsWith("#"))})}),define(Ie[115],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[116],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class C{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let y=0,k=R.notIn.length;y<k;y++)switch(R.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,y){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(y-2),O=R.getStandardTokenType(k);return this.isOK(O)}g(R,y){for(let k=R;k<=y;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=C;class S{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of R)L(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),L(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),L(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),L(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&L(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function L(I,R,y){I.has(R)?I.get(R).push(y):I.set(R,[y])}}),define(Ie[117],Ce([14,15]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ie[118],Ce([14,15]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ie[119],Ce([1,0,118]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,S=C*60,L=S*24,I=L*7,R=L*30,y=L*365;function k(w,m,p,f){typeof w!="number"&&(w=w.getTime());const n=Math.round((new Date().getTime()-w)/1e3);if(n<-30)return(0,i.localize)(0,null,k(new Date().getTime()+n*1e3,!1));if(!f&&n<30)return(0,i.localize)(1,null);let r;return n<C?(r=n,m?r===1?p?(0,i.localize)(2,null,r):(0,i.localize)(3,null,r):p?(0,i.localize)(4,null,r):(0,i.localize)(5,null,r):r===1?p?(0,i.localize)(6,null,r):(0,i.localize)(7,null,r):p?(0,i.localize)(8,null,r):(0,i.localize)(9,null,r)):n<S?(r=Math.floor(n/C),m?r===1?p?(0,i.localize)(10,null,r):(0,i.localize)(11,null,r):p?(0,i.localize)(12,null,r):(0,i.localize)(13,null,r):r===1?p?(0,i.localize)(14,null,r):(0,i.localize)(15,null,r):p?(0,i.localize)(16,null,r):(0,i.localize)(17,null,r)):n<L?(r=Math.floor(n/S),m?r===1?p?(0,i.localize)(18,null,r):(0,i.localize)(19,null,r):p?(0,i.localize)(20,null,r):(0,i.localize)(21,null,r):r===1?p?(0,i.localize)(22,null,r):(0,i.localize)(23,null,r):p?(0,i.localize)(24,null,r):(0,i.localize)(25,null,r)):n<I?(r=Math.floor(n/L),m?r===1?(0,i.localize)(26,null,r):(0,i.localize)(27,null,r):r===1?(0,i.localize)(28,null,r):(0,i.localize)(29,null,r)):n<R?(r=Math.floor(n/I),m?r===1?p?(0,i.localize)(30,null,r):(0,i.localize)(31,null,r):p?(0,i.localize)(32,null,r):(0,i.localize)(33,null,r):r===1?p?(0,i.localize)(34,null,r):(0,i.localize)(35,null,r):p?(0,i.localize)(36,null,r):(0,i.localize)(37,null,r)):n<y?(r=Math.floor(n/R),m?r===1?p?(0,i.localize)(38,null,r):(0,i.localize)(39,null,r):p?(0,i.localize)(40,null,r):(0,i.localize)(41,null,r):r===1?p?(0,i.localize)(42,null,r):(0,i.localize)(43,null,r):p?(0,i.localize)(44,null,r):(0,i.localize)(45,null,r)):(r=Math.floor(n/y),m?r===1?p?(0,i.localize)(46,null,r):(0,i.localize)(47,null,r):p?(0,i.localize)(48,null,r):(0,i.localize)(49,null,r):r===1?p?(0,i.localize)(50,null,r):(0,i.localize)(51,null,r):p?(0,i.localize)(52,null,r):(0,i.localize)(53,null,r))}e.fromNow=k;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ie[120],Ce([14,15]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ie[39],Ce([1,0,18,9,120]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,m){return m&&(w.stack||w.stacktrace)?S.localize(0,null,R(w),I(w.stack)||I(w.stacktrace)):R(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function y(w=null,m=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const p=i.coalesce(w),f=y(p[0],m);return p.length>1?S.localize(4,null,f,p.length):f}if(C.isString(w))return w;if(w.detail){const p=w.detail;if(p.error)return L(p.error,m);if(p.exception)return L(p.exception,m)}return w.stack?L(w,m):w.message?w.message:S.localize(5,null)}e.toErrorMessage=y;function k(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function O(w,m){let p;return typeof w=="string"?p=new Error(w):p=w,p.actions=m,p}e.createErrorWithActions=O}),define(Ie[64],Ce([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(O){const w=(0,i.extname)(O),m=C[w.toLowerCase()];return m!==void 0?m:I(O)}e.getMediaOrTextMime=L;function I(O){const w=(0,i.extname)(O);return S[w.toLowerCase()]}e.getMediaMime=I;function R(O){for(const w in S)if(S[w]===O)return w}e.getExtensionForMimeType=R;const y=/^(.+)\/(.+?)(;.+)?$/;function k(O,w){const m=y.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:O}e.normalizeMimeType=k}),define(Ie[121],Ce([1,0,4,6,117]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends C.Disposable{constructor(m,p="",f="",n=!0,r){super(),this.h=this.B(new i.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=p,this.u=f,this.w=n,this.C=r}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,p){this.C&&await this.C(m)}}e.Action=L;class I extends C.Disposable{constructor(){super(...arguments),this.f=this.B(new i.Emitter),this.onWillRun=this.f.event,this.h=this.B(new i.Emitter),this.onDidRun=this.h.event}async run(m,p){if(!m.enabled)return;this.f.fire({action:m});let f;try{await this.runAction(m,p)}catch(n){f=n}this.h.fire({action:m,error:f})}async runAction(m,p){await m.run(p)}}e.ActionRunner=I;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let p=[];for(const f of m)f.length&&(p.length?p=[...p,new R,...f]:p=f);return p}async run(){}}e.Separator=R,R.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(m,p,f,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=p,this.class=n,this.a=f}async run(){}}e.SubmenuAction=y;class k extends L{constructor(){super(k.ID,S.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=k,k.ID="vs.actions.empty";function O(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=O}),define(Ie[40],Ce([1,0,19,20,10,9]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(a){return a===47||a===92}e.isPathSeparator=I;function R(a){return a.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=R;function y(a){return a.indexOf("/")===-1&&(a=R(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=y;function k(a,h=i.posix.sep){if(!a)return"";const c=a.length,u=a.charCodeAt(0);if(I(u)){if(I(a.charCodeAt(1))&&!I(a.charCodeAt(2))){let A=3;const N=A;for(;A<c&&!I(a.charCodeAt(A));A++);if(N!==A&&!I(a.charCodeAt(A+1))){for(A+=1;A<c;A++)if(I(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,h)}}return h}else if(d(u)&&a.charCodeAt(1)===58)return I(a.charCodeAt(2))?a.slice(0,2)+h:a.slice(0,2);let g=a.indexOf("://");if(g!==-1){for(g+=3;g<c;g++)if(I(a.charCodeAt(g)))return a.slice(0,g+1)}return""}e.getRoot=k;function O(a){if(!C.isWindows||!a||a.length<5)return!1;let h=a.charCodeAt(0);if(h!==92||(h=a.charCodeAt(1),h!==92))return!1;let c=2;const u=c;for(;c<a.length&&(h=a.charCodeAt(c),h!==92);c++);return!(u===c||(h=a.charCodeAt(c+1),isNaN(h)||h===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(a,h=C.isWindows){const c=h?w:m;return!(!a||a.length===0||/^\s+$/.test(a)||(c.lastIndex=0,c.test(a))||h&&p.test(a)||a==="."||a===".."||h&&a[a.length-1]==="."||h&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=f;function n(a,h,c){const u=a===h;return!c||u?u:!a||!h?!1:(0,S.equalsIgnoreCase)(a,h)}e.isEqual=n;function r(a,h,c,u=i.sep){if(a===h)return!0;if(!a||!h||h.length>a.length)return!1;if(c){if(!(0,S.startsWithIgnoreCase)(a,h))return!1;if(h.length===a.length)return!0;let A=h.length;return h.charAt(h.length-1)===u&&A--,a.charAt(A)===u}return h.charAt(h.length-1)!==u&&(h+=u),a.indexOf(h)===0}e.isEqualOrParent=r;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=d;function b(a,h){return C.isWindows&&a.endsWith(":")&&(a+=i.sep),(0,i.isAbsolute)(a)||(a=(0,i.join)(h,a)),a=(0,i.normalize)(a),C.isWindows?(a=(0,S.rtrim)(a,i.sep),a.endsWith(":")&&(a+=i.sep)):(a=(0,S.rtrim)(a,i.sep),a||(a=i.sep)),a}e.sanitizeFilePath=b;function E(a){const h=(0,i.normalize)(a);return C.isWindows?a.length>3?!1:P(h)&&(a.length===2||h.charCodeAt(2)===92):h===i.posix.sep}e.isRootOrDriveLetter=E;function P(a,h=C.isWindows){return h?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function v(a){return P(a)?a[0]:void 0}e.getDriveLetter=v;function t(a,h,c){return h.length>a.length?-1:a===h?0:(c&&(a=a.toLowerCase(),h=h.toLowerCase()),a.indexOf(h))}e.indexOfPath=t;function s(a){const h=a.split(":");let c,u,g;for(const A of h){const N=Number(A);(0,L.isNumber)(N)?u===void 0?u=N:g===void 0&&(g=N):c=c?[c,A].join(":"):A}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:g!==void 0?g:u!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(a,h,c=8){let u="";for(let A=0;A<c;A++)u+=o.charAt(Math.floor(Math.random()*o.length));let g;return h?g=`${h}-${u}`:g=u,a?(0,i.join)(a,g):g}e.randomPath=l}),define(Ie[122],Ce([1,0,28,10]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...J){return function(D,B){for(let W=0,K=J.length;W<K;W++){const Z=J[W](D,B);if(Z)return Z}return null}}e.or=S,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(J,D,B){if(!B||B.length<D.length)return null;let W;return J?W=C.startsWithIgnoreCase(B,D):W=B.indexOf(D)===0,W?D.length>0?[{start:0,end:D.length}]:[]:null}function I(J,D){const B=D.toLowerCase().indexOf(J.toLowerCase());return B===-1?null:[{start:B,end:B+J.length}]}e.matchesContiguousSubString=I;function R(J,D){return y(J.toLowerCase(),D.toLowerCase(),0,0)}e.matchesSubString=R;function y(J,D,B,W){if(B===J.length)return[];if(W===D.length)return null;if(J[B]===D[W]){let K=null;return(K=y(J,D,B+1,W+1))?d({start:W,end:W+1},K):null}return y(J,D,B,W+1)}function k(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function w(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>p.add(J.charCodeAt(0)));function f(J){return m(J)||p.has(J)}function n(J,D){return J===D||f(J)&&f(D)}function r(J){return k(J)||O(J)||w(J)}function d(J,D){return D.length===0?D=[J]:J.end===D[0].start?D[0].start=J.start:D.unshift(J),D}function b(J,D){for(let B=D;B<J.length;B++){const W=J.charCodeAt(B);if(O(W)||w(W)||B>0&&!r(J.charCodeAt(B-1)))return B}return J.length}function E(J,D,B,W){if(B===J.length)return[];if(W===D.length)return null;if(J[B]!==D[W].toLowerCase())return null;{let K=null,Z=W+1;for(K=E(J,D,B+1,W+1);!K&&(Z=b(D,Z))<D.length;)K=E(J,D,B+1,Z),Z++;return K===null?null:d({start:W,end:W+1},K)}}function P(J){let D=0,B=0,W=0,K=0,Z=0;for(let Ee=0;Ee<J.length;Ee++)Z=J.charCodeAt(Ee),O(Z)&&D++,k(Z)&&B++,r(Z)&&W++,w(Z)&&K++;const he=D/J.length,ye=B/J.length,ae=W/J.length,be=K/J.length;return{upperPercent:he,lowerPercent:ye,alphaPercent:ae,numericPercent:be}}function v(J){const{upperPercent:D,lowerPercent:B}=J;return B===0&&D>.6}function t(J){const{upperPercent:D,lowerPercent:B,alphaPercent:W,numericPercent:K}=J;return B>.2&&D<.8&&W>.6&&K<.2}function s(J){let D=0,B=0,W=0,K=0;for(let Z=0;Z<J.length;Z++)W=J.charCodeAt(Z),O(W)&&D++,k(W)&&B++,m(W)&&K++;return(D===0||B===0)&&K===0?J.length<=30:D<=5}function o(J,D){if(!D||(D=D.trim(),D.length===0)||!s(J)||D.length>60)return null;const B=P(D);if(!t(B)){if(!v(B))return null;D=D.toLowerCase()}let W=null,K=0;for(J=J.toLowerCase();K<D.length&&(W=E(J,D,0,K))===null;)K=b(D,K+1);return W}e.matchesCamelCase=o;function l(J,D,B=!1){if(!D||D.length===0)return null;let W=null,K=0;for(J=J.toLowerCase(),D=D.toLowerCase();K<D.length&&(W=a(J,D,0,K,B))===null;)K=h(D,K+1);return W}e.matchesWords=l;function a(J,D,B,W,K){if(B===J.length)return[];if(W===D.length)return null;if(n(J.charCodeAt(B),D.charCodeAt(W))){let Z=null,he=W+1;if(Z=a(J,D,B+1,W+1,K),!K)for(;!Z&&(he=h(D,he))<D.length;)Z=a(J,D,B+1,he,K),he++;return Z?J.charCodeAt(B)!==D.charCodeAt(W)?Z:d({start:W,end:W+1},Z):null}else return null}function h(J,D){for(let B=D;B<J.length;B++)if(f(J.charCodeAt(B))||B>0&&f(J.charCodeAt(B-1)))return B;return J.length}const c=S(e.matchesPrefix,o,I),u=S(e.matchesPrefix,o,R),g=new i.LRUCache(1e4);function A(J,D,B=!1){if(typeof J!="string"||typeof D!="string")return null;let W=g.get(J);W||(W=new RegExp(C.convertSimple2RegExpPattern(J),"i"),g.set(J,W));const K=W.exec(D);return K?[{start:K.index,end:K.index+K[0].length}]:B?u(J,D):c(J,D)}e.matchesFuzzy=A;function N(J,D){const B=Be(J,J.toLowerCase(),0,D,D.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?te(B):null}e.matchesFuzzy2=N;function q(J,D,B,W,K,Z){const he=Math.min(13,J.length);for(;B<he;B++){const ye=Be(J,D,B,W,K,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,Z]}e.anyScore=q;function te(J){if(typeof J>"u")return[];const D=[],B=J[1];for(let W=J.length-1;W>1;W--){const K=J[W]+B,Z=D[D.length-1];Z&&Z.end===K?Z.end=K+1:D.push({start:K,end:K+1})}return D}e.createMatches=te;const x=128;function F(){const J=[],D=[];for(let B=0;B<=x;B++)D[B]=0;for(let B=0;B<=x;B++)J.push(D.slice(0));return J}function $(J){const D=[];for(let B=0;B<=J;B++)D[B]=0;return D}const T=$(2*x),M=$(2*x),V=F(),j=F(),le=F(),Y=!1;function pe(J,D,B,W,K){function Z(ye,ae,be=" "){for(;ye.length<ae;)ye=be+ye;return ye}let he=` |   |${W.split("").map(ye=>Z(ye,3)).join("|")}
`;for(let ye=0;ye<=B;ye++)ye===0?he+=" |":he+=`${D[ye-1]}|`,he+=J[ye].slice(0,K+1).map(ae=>Z(ae.toString(),3)).join("|")+`
`;return he}function ue(J,D,B,W){J=J.substr(D),B=B.substr(W),console.log(pe(j,J,J.length,B,B.length)),console.log(pe(le,J,J.length,B,B.length)),console.log(pe(V,J,J.length,B,B.length))}function de(J,D){if(D<0||D>=J.length)return!1;const B=J.codePointAt(D);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(B)}}function re(J,D){if(D<0||D>=J.length)return!1;switch(J.charCodeAt(D)){case 32:case 9:return!0;default:return!1}}function G(J,D,B){return D[J]!==B[J]}function H(J,D,B,W,K,Z,he=!1){for(;D<B&&K<Z;)J[D]===W[K]&&(he&&(T[D]=K),D+=1),K+=1;return D===B}e.isPatternInWord=H;var oe;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var ve;(function(J){J.Default=[-100,0];function D(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}J.isDefault=D})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(D,B){this.firstMatchCanBeWeak=D,this.boostFullMatch=B}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(J,D,B,W,K,Z,he=Ae.default){const ye=J.length>x?x:J.length,ae=W.length>x?x:W.length;if(B>=ye||Z>=ae||ye-B>ae-Z||!H(D,B,ye,K,Z,ae,!0))return;xe(ye,ae,B,Z,D,K);let be=1,Ee=1,We=B,He=Z;const tt=[!1];for(be=1,We=B;We<ye;be++,We++){const Fe=T[We],st=M[We],_=We+1<ye?M[We+1]:ae;for(Ee=Fe-Z+1,He=Fe;He<_;Ee++,He++){let Q=Number.MIN_SAFE_INTEGER,ge=!1;He<=st&&(Q=Te(J,D,We,B,W,K,He,ae,Z,V[be-1][Ee-1]===0,tt));let Me=0;Q!==Number.MAX_SAFE_INTEGER&&(ge=!0,Me=Q+j[be-1][Ee-1]);const $e=He>Fe,je=$e?j[be][Ee-1]+(V[be][Ee-1]>0?-5:0):0,_e=He>Fe+1&&V[be][Ee-1]>0,nt=_e?j[be][Ee-2]+(V[be][Ee-2]>0?-5:0):0;if(_e&&(!$e||nt>=je)&&(!ge||nt>=Me))j[be][Ee]=nt,le[be][Ee]=3,V[be][Ee]=0;else if($e&&(!ge||je>=Me))j[be][Ee]=je,le[be][Ee]=2,V[be][Ee]=0;else if(ge)j[be][Ee]=Me,le[be][Ee]=1,V[be][Ee]=V[be-1][Ee-1]+1;else throw new Error("not possible")}}if(Y&&ue(J,B,W,Z),!tt[0]&&!he.firstMatchCanBeWeak)return;be--,Ee--;const Xe=[j[be][Ee],Z];let et=0,it=0;for(;be>=1;){let Fe=Ee;do{const st=le[be][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&D[B+be-1]===K[Z+Ee-1]&&!G(Fe+Z-1,W,K)&&et+1>V[be][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),be--,Ee=Fe-1,Xe.push(Ee)}ae===ye&&he.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Be;function xe(J,D,B,W,K,Z){let he=J-1,ye=D-1;for(;he>=B&&ye>=W;)K[he]===Z[ye]&&(M[he]=ye,he--),ye--}function Te(J,D,B,W,K,Z,he,ye,ae,be,Ee){if(D[B]!==Z[he])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return he===B-W?We=J[B]===K[he]?7:5:G(he,K,Z)&&(he===0||!G(he-1,K,Z))?(We=J[B]===K[he]?7:5,He=!0):de(Z,he)&&(he===0||!de(Z,he-1))?We=5:(de(Z,he-1)||re(Z,he-1))&&(We=5,He=!0),We>1&&B===W&&(Ee[0]=!0),He||(He=G(he,K,Z)||de(Z,he-1)||re(Z,he-1)),B===W?he>ae&&(We-=He?3:5):be?We+=He?2:0:We+=He?0:1,he+1===ye&&(We-=He?3:5),We}function Se(J,D,B,W,K,Z,he){return se(J,D,B,W,K,Z,!0,he)}e.fuzzyScoreGracefulAggressive=Se;function ke(J,D,B,W,K,Z,he){return se(J,D,B,W,K,Z,!1,he)}e.fuzzyScoreGraceful=ke;function se(J,D,B,W,K,Z,he,ye){let ae=Be(J,D,B,W,K,Z,ye);if(ae&&!he)return ae;if(J.length>=3){const be=Math.min(7,J.length-1);for(let Ee=B+1;Ee<be;Ee++){const We=ce(J,Ee);if(We){const He=Be(We,We.toLowerCase(),B,W,K,Z,ye);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(J,D){if(D+1>=J.length)return;const B=J[D],W=J[D+1];if(B!==W)return J.slice(0,D)+W+B+J.slice(D+2)}}),define(Ie[123],Ce([1,0,65,122,10]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",I=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${I.source}`,"g");function y(r){return r.replace(R,(d,b)=>b?d:`\\${d}`)}e.escapeIcons=y;const k=new RegExp(`\\\\${I.source}`,"g");function O(r){return r.replace(k,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function m(r){return r.indexOf(L)===-1?r:r.replace(w,(d,b,E,P)=>E?d:b||P||"")}e.stripIcons=m;const p=new RegExp(`\\$\\(${i.CSSIcon.iconNameCharacter}+\\)`,"g");function f(r){p.lastIndex=0;let d="";const b=[];let E=0;for(;;){const P=p.lastIndex,v=p.exec(r),t=r.substring(P,v?.index);if(t.length>0){d+=t;for(let s=0;s<t.length;s++)b.push(E)}if(!v)break;E+=v[0].length}return{text:d,iconOffsets:b}}e.parseLabelWithIcons=f;function n(r,d,b=!1){const{text:E,iconOffsets:P}=d;if(!P||P.length===0)return(0,C.matchesFuzzy)(r,E,b);const v=(0,S.ltrim)(E," "),t=E.length-v.length,s=(0,C.matchesFuzzy)(r,v,b);if(s)for(const o of s){const l=P[o.start+t]+t;o.start+=l,o.end+=l}return s}e.matchesFuzzyIconAware=n}),define(Ie[30],Ce([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const L="error",I="warning",R="warn",y="info",k="ignore";function O(m){return m?i.equalsIgnoreCase(L,m)?S.Error:i.equalsIgnoreCase(I,m)||i.equalsIgnoreCase(R,m)?S.Warning:i.equalsIgnoreCase(y,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function w(m){switch(m){case S.Error:return L;case S.Warning:return I;case S.Info:return y;default:return k}}S.toString=w}(C||(C={})),e.default=C}),define(Ie[46],Ce([1,0,18,10]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const f=p.charCodeAt(0),n=this.b.charCodeAt(this.c);return f-n}value(){return this.b[this.c]}}e.StringIterator=S;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,C.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,C.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class I{constructor(p=!0,f=!0){this.f=p,this.g=f}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let f=p.length-1;f>=0;f--,this.c--){const n=this.b.charCodeAt(f);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,C.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,C.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class y{constructor(p,f){this.f=p,this.g=f,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,C.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,C.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,C.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,C.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(O||(O={}));class w{static forUris(p=()=>!1,f=()=>!1){return new w(new y(p,f))}static forPaths(p=!1){return new w(new I(void 0,!p))}static forStrings(){return new w(new S)}static forConfigKeys(){return new w(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,f){if(f){const n=f.slice(0);(0,i.shuffle)(n);for(const r of n)this.set(r,p)}else{const n=p.slice(0);(0,i.shuffle)(n);for(const r of n)this.set(r[0],r[1])}}set(p,f){const n=this.b.reset(p);let r;this.c||(this.c=new k,this.c.segment=n.value());const d=[];for(r=this.c;;){const E=n.cmp(r.segment);if(E>0)r.left||(r.left=new k,r.left.segment=n.value()),d.push([-1,r]),r=r.left;else if(E<0)r.right||(r.right=new k,r.right.segment=n.value()),d.push([1,r]),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new k,r.mid.segment=n.value()),d.push([0,r]),r=r.mid;else break}const b=r.value;r.value=f,r.key=p;for(let E=d.length-1;E>=0;E--){const P=d[E][1];P.updateHeight();const v=P.balanceFactor();if(v<-1||v>1){const t=d[E][0],s=d[E+1][0];if(t===1&&s===1)d[E][1]=P.rotateLeft();else if(t===-1&&s===-1)d[E][1]=P.rotateRight();else if(t===1&&s===-1)P.right=d[E+1][1]=d[E+1][1].rotateRight(),d[E][1]=P.rotateLeft();else if(t===-1&&s===1)P.left=d[E+1][1]=d[E+1][1].rotateLeft(),d[E][1]=P.rotateRight();else throw new Error;if(E>0)switch(d[E-1][0]){case-1:d[E-1][1].left=d[E][1];break;case 1:d[E-1][1].right=d[E][1];break;case 0:d[E-1][1].mid=d[E][1];break}else this.c=d[0][1]}}return b}get(p){return this.d(p)?.value}d(p){const f=this.b.reset(p);let n=this.c;for(;n;){const r=f.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(f.hasNext())f.next(),n=n.mid;else break}return n}has(p){const f=this.d(p);return!(f?.value===void 0&&f?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,f){const n=this.b.reset(p),r=[];let d=this.c;for(;d;){const b=n.cmp(d.segment);if(b>0)r.push([-1,d]),d=d.left;else if(b<0)r.push([1,d]),d=d.right;else if(n.hasNext())n.next(),r.push([0,d]),d=d.mid;else break}if(!!d){if(f?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const b=this.f(d.right);if(b.key){const{key:E,value:P,segment:v}=b;this.e(b.key,!1),d.key=E,d.value=P,d.segment=v}}else{const b=d.left??d.right;if(r.length>0){const[E,P]=r[r.length-1];switch(E){case-1:P.left=b;break;case 0:P.mid=b;break;case 1:P.right=b;break}}else this.c=b}for(let b=r.length-1;b>=0;b--){const E=r[b][1];E.updateHeight();const P=E.balanceFactor();if(P>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),r[b][1]=E.rotateLeft()):P<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),r[b][1]=E.rotateRight()),b>0)switch(r[b-1][0]){case-1:r[b-1][1].left=r[b][1];break;case 1:r[b-1][1].right=r[b][1];break;case 0:r[b-1][1].mid=r[b][1];break}else this.c=r[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const f=this.b.reset(p);let n=this.c,r;for(;n;){const d=f.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(f.hasNext())f.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(p){return this.g(p,!1)}g(p,f){const n=this.b.reset(p);let r=this.c;for(;r;){const d=n.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else return r.mid?this.h(r.mid):f?r.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[f,n]of this)p(n,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const f=[];return this.j(p,f),f[Symbol.iterator]()}j(p,f){!p||(p.left&&this.j(p.left,f),p.value&&f.push([p.key,p.value]),p.mid&&this.j(p.mid,f),p.right&&this.j(p.right,f))}_isBalanced(){const p=f=>{if(!f)return!0;const n=f.balanceFactor();return n<-1||n>1?!1:p(f.left)&&p(f.right)};return p(this.c)}}e.TernarySearchTree=w}),define(Ie[84],Ce([1,0,25,10,2]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,R)}e.stringify=L;function I(k){let O=JSON.parse(k);return O=y(O),O}e.parse=I;function R(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function y(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=y(k[w],O+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=y(k[w],O+1))}return k}e.revive=y}),define(Ie[16],Ce([1,0,11,20,2]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${L.vscodeRemoteResource}`}set(O,w,m){this.a[O]=w,this.b[O]=m}setConnectionToken(O,w){this.c[O]=w}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(r){return i.onUnexpectedError(r),O}const w=O.authority;let m=this.a[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[w],f=this.c[w];let n=`path=${encodeURIComponent(O.path)}`;return typeof f=="string"&&(n+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),S.URI.from({scheme:C.isWeb?this.d:L.vscodeRemoteResource,authority:`${m}:${p}`,path:this.f,query:n})}}e.RemoteAuthorities=new I,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(O){const w=this.b(O,ee);return this.uriToBrowserUri(w)}uriToBrowserUri(O){return O.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===L.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${L.vscodeFileResource}://${R.a}`)?O.with({scheme:L.vscodeFileResource,authority:O.authority||R.a,query:null,fragment:null}):O}asFileUri(O){const w=this.b(O,ee);return this.uriToFileUri(w)}uriToFileUri(O){return O.scheme===L.vscodeFileResource?O.with({scheme:L.file,authority:O.authority!==R.a?O.authority:null,query:null,fragment:null}):O}b(O,w){return S.URI.isUri(O)?O:S.URI.parse(w.toUrl(O))}}R.a="vscode-app",e.FileAccess=new R;var y;(function(k){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(O.get("3"));const w="vscode-coi";function m(f){let n;typeof f=="string"?n=new URL(f).searchParams:f instanceof URL?n=f.searchParams:S.URI.isUri(f)&&(n=new URL(f.toString(!0)).searchParams);const r=n?.get(w);if(!!r)return O.get(r)}k.getHeadersFromQuery=m;function p(f,n,r){if(!globalThis.crossOriginIsolated)return;const d=n&&r?"3":r?"2":"1";f instanceof URLSearchParams?f.set(w,d):f[w]=d}k.addSearchParam=p})(y=e.COI||(e.COI={}))}),define(Ie[23],Ce([1,0,40,16,19,20,10,2]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=y;class k{constructor(f){this.a=f}compare(f,n,r=!1){return f===n?0:(0,I.compare)(this.getComparisonKey(f,r),this.getComparisonKey(n,r))}isEqual(f,n,r=!1){return f===n?!0:!f||!n?!1:this.getComparisonKey(f,r)===this.getComparisonKey(n,r)}getComparisonKey(f,n=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,n,r=!1){if(f.scheme===n.scheme){if(f.scheme===C.Schemas.file)return i.isEqualOrParent(y(f),y(n),this.a(f))&&f.query===n.query&&(r||f.fragment===n.fragment);if((0,e.isEqualAuthority)(f.authority,n.authority))return i.isEqualOrParent(f.path,n.path,this.a(f),"/")&&f.query===n.query&&(r||f.fragment===n.fragment)}return!1}joinPath(f,...n){return R.URI.joinPath(f,...n)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return S.posix.basename(f.path)}extname(f){return S.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let n;return f.scheme===C.Schemas.file?n=R.URI.file(S.dirname(y(f))).path:(n=S.posix.dirname(f.path),f.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),n="/")),f.with({path:n})}normalizePath(f){if(!f.path.length)return f;let n;return f.scheme===C.Schemas.file?n=R.URI.file(S.normalize(y(f))).path:n=S.posix.normalize(f.path),f.with({path:n})}relativePath(f,n){if(f.scheme!==n.scheme||!(0,e.isEqualAuthority)(f.authority,n.authority))return;if(f.scheme===C.Schemas.file){const b=S.relative(y(f),y(n));return L.isWindows?i.toSlashes(b):b}let r=f.path||"/";const d=n.path||"/";if(this.a(f)){let b=0;for(const E=Math.min(r.length,d.length);b<E&&!(r.charCodeAt(b)!==d.charCodeAt(b)&&r.charAt(b).toLowerCase()!==d.charAt(b).toLowerCase());b++);r=d.substr(0,b)+r.substr(b)}return S.posix.relative(r,d)}resolvePath(f,n){if(f.scheme===C.Schemas.file){const r=R.URI.file(S.resolve(y(f),n));return f.with({authority:r.authority,path:r.path})}return n=i.toPosixPath(n),f.with({path:S.posix.resolve(f.path,n)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,n){return f===n||f!==void 0&&n!==void 0&&(0,I.equalsIgnoreCase)(f,n)}hasTrailingPathSeparator(f,n=S.sep){if(f.scheme===C.Schemas.file){const r=y(f);return r.length>i.getRoot(r).length&&r[r.length-1]===n}else{const r=f.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,n=S.sep){return(0,e.hasTrailingPathSeparator)(f,n)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,n=S.sep){let r=!1;if(f.scheme===C.Schemas.file){const d=y(f);r=d!==void 0&&d.length===i.getRoot(d).length&&d[d.length-1]===n}else{n="/";const d=f.path;r=d.length===1&&d.charCodeAt(d.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(f,n)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===C.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(p,f){const n=[];for(let r=0;r<p.length;r++){const d=f(p[r]);p.some((b,E)=>E===r?!1:(0,e.isEqualOrParent)(d,f(b)))||n.push(p[r])}return n}e.distinctParents=O;var w;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(E=>{const[P,v]=E.split(":");P&&v&&r.set(P,v)});const b=n.path.substring(0,n.path.indexOf(";"));return b&&r.set(p.META_DATA_MIME,b),r}p.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function m(p,f,n){if(f){let r=p.path;return r&&r[0]!==S.posix.sep&&(r=S.posix.sep+r),p.with({scheme:n,authority:f,path:r})}return p.with({scheme:n})}e.toLocalResource=m}),define(Ie[12],Ce([1,0,21,11,4,6,23,20]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(G){return!!G&&typeof G.then=="function"}e.isThenable=y;function k(G){const H=new i.CancellationTokenSource,oe=G(H.token),ve=new Promise((Ae,Be)=>{const xe=H.token.onCancellationRequested(()=>{xe.dispose(),H.dispose(),Be(new C.CancellationError)});Promise.resolve(oe).then(Te=>{xe.dispose(),H.dispose(),Ae(Te)},Te=>{xe.dispose(),H.dispose(),Be(Te)})});return new class{cancel(){H.cancel()}then(Ae,Be){return ve.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ve.finally(Ae)}}}e.createCancelablePromise=k;function O(G,H,oe){return new Promise((ve,Ae)=>{const Be=H.onCancellationRequested(()=>{Be.dispose(),ve(oe)});G.then(ve,Ae).finally(()=>Be.dispose())})}e.raceCancellation=O;function w(G,H){return new Promise((oe,ve)=>{const Ae=H.onCancellationRequested(()=>{Ae.dispose(),ve(new C.CancellationError)});G.then(oe,ve).finally(()=>Ae.dispose())})}e.raceCancellationError=w;async function m(G){let H=-1;const oe=G.map((Ae,Be)=>Ae.then(xe=>(H=Be,xe))),ve=await Promise.race(oe);return G.forEach((Ae,Be)=>{Be!==H&&Ae.cancel()}),ve}e.raceCancellablePromises=m;function p(G,H,oe){let ve;const Ae=setTimeout(()=>{ve?.(void 0),oe?.()},H);return Promise.race([G.finally(()=>clearTimeout(Ae)),new Promise(Be=>ve=Be)])}e.raceTimeout=p;function f(G){return new Promise((H,oe)=>{const ve=G();y(ve)?ve.then(H,oe):H(ve)})}e.asPromise=f;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(H){if(this.a){if(this.d=H,!this.b){const oe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(oe,oe).then(ve)})}return new Promise((oe,ve)=>{this.b.then(oe,ve)})}return this.a=H(),new Promise((oe,ve)=>{this.a.then(Ae=>{this.a=null,oe(Ae)},Ae=>{this.a=null,ve(Ae)})})}}e.Throttler=n;class r{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.Sequencer=r;class d{constructor(){this.a=new Map}queue(H,oe){const Ae=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(H)===Ae&&this.a.delete(H)});return this.a.set(H,Ae),Ae}}e.SequencerByKey=d;const b=(G,H)=>{let oe=!0;const ve=setTimeout(()=>{oe=!1,H()},G);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ve),oe=!1}}},E=G=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,G())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class P{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,oe=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((Ae,Be)=>{this.d=Ae,this.f=Be}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=oe===e.MicrotaskDelay?E(ve):b(oe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=P;class v{constructor(H){this.a=new P(H),this.b=new n}trigger(H,oe){return this.a.trigger(()=>this.b.queue(H),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=v;class t{constructor(){this.a=!1,this.b=new Promise((H,oe)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=t;class s extends t{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function o(G,H){return H?new Promise((oe,ve)=>{const Ae=setTimeout(()=>{Be.dispose(),oe()},G),Be=H.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),ve(new C.CancellationError)})}):k(oe=>o(G,oe))}e.timeout=o;function l(G,H=0){const oe=setTimeout(G,H);return(0,L.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=l;function a(G){const H=[];let oe=0;const ve=G.length;function Ae(){return oe<ve?G[oe++]():null}function Be(xe){xe!=null&&H.push(xe);const Te=Ae();return Te?Te.then(Be):Promise.resolve(H)}return Promise.resolve(null).then(Be)}e.sequence=a;function h(G,H=ve=>!!ve,oe=null){let ve=0;const Ae=G.length,Be=()=>{if(ve>=Ae)return Promise.resolve(oe);const xe=G[ve++];return Promise.resolve(xe()).then(Se=>H(Se)?Promise.resolve(Se):Be())};return Be()}e.first=h;function c(G,H=ve=>!!ve,oe=null){if(G.length===0)return Promise.resolve(oe);let ve=G.length;const Ae=()=>{ve=-1;for(const Be of G)Be.cancel?.()};return new Promise((Be,xe)=>{for(const Te of G)Te.then(Se=>{--ve>=0&&H(Se)?(Ae(),Be(Se)):ve===0&&Be(oe)}).catch(Se=>{--ve>=0&&(Ae(),xe(Se))})})}e.firstParallel=c;class u{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new S.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((oe,ve)=>{this.f.push({factory:H,c:oe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const oe=H.factory();oe.then(H.c,H.e),oe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class g extends u{constructor(){super(1)}}e.Queue=g;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const H=new le;return this.b.add(H),H.p}d(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,oe=I.extUri){const ve=oe.getComparisonKey(H);let Ae=this.a.get(ve);return Ae||(Ae=new g,S.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class N{constructor(H,oe){this.a=-1,typeof H=="function"&&typeof oe=="number"&&this.setIfNotSet(H,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},oe)}setIfNotSet(H,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},oe))}}e.TimeoutTimer=N;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setInterval(()=>{H()},oe)}}e.IntervalTimer=q;class te{constructor(H,oe){this.b=-1,this.a=H,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=te;class x{constructor(H,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=H,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class F extends te{constructor(H,oe){super(H,oe),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class $ extends L.Disposable{constructor(H,oe){super(),this.g=H,this.h=oe,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of H)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,R.setTimeout0)(()=>{if(H)return;const oe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(G,H)=>{const oe=requestIdleCallback(G,typeof H=="number"?{timeout:H}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(oe))}}}}();class T{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(oe){this.g=oe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function M(G,H,oe){let ve;for(let Ae=0;Ae<oe;Ae++)try{return await G()}catch(Be){ve=Be,await o(H)}throw ve}e.retry=M;class V{hasPending(H){return this.a?typeof H=="number"?this.a.taskId===H:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(H,oe,ve){return this.a={taskId:H,cancel:()=>ve?.(),promise:oe},oe.then(()=>this.d(H),()=>this.d(H)),oe}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this.b)this.b.run=H;else{let oe,ve;const Ae=new Promise((Be,xe)=>{oe=Be,ve=xe});this.b={run:H,promise:Ae,promiseResolve:oe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class j{constructor(H,oe=()=>Date.now()){this.d=H,this.f=oe,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((H,oe)=>{this.a=H,this.b=oe})}complete(H){return new Promise(oe=>{this.a(H),this.f=!0,oe()})}error(H){return new Promise(oe=>{this.b(H),this.d=!0,oe()})}cancel(){new Promise(H=>{this.b(new C.CancellationError),this.d=!0,H()})}}e.DeferredPromise=le;var Y;(function(G){async function H(ve){let Ae;const Be=await Promise.all(ve.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Be}G.settled=H;function oe(ve){return new Promise(async(Ae,Be)=>{try{await ve(Ae,Be)}catch(xe){Be(xe)}})}G.withAsyncBody=oe})(Y=e.Promises||(e.Promises={}));var pe;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(pe||(pe={}));class ue{static fromArray(H){return new ue(oe=>{oe.emitMany(H)})}static fromPromise(H){return new ue(async oe=>{oe.emitMany(await H)})}static fromPromises(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>oe.emitOne(await ve)))})}static merge(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>{for await(const Ae of ve)oe.emitOne(Ae)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new S.Emitter,queueMicrotask(async()=>{const oe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(H(oe)),this.j()}catch(ve){this.k(ve)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(H,oe){return new ue(async ve=>{for await(const Ae of H)ve.emitOne(oe(Ae))})}map(H){return ue.map(this,H)}static filter(H,oe){return new ue(async ve=>{for await(const Ae of H)oe(Ae)&&ve.emitOne(Ae)})}filter(H){return ue.filter(this,H)}static coalesce(H){return ue.filter(H,oe=>!!oe)}coalesce(){return ue.coalesce(this)}static async toPromise(H){const oe=[];for await(const ve of H)oe.push(ve);return oe}toPromise(){return ue.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class de extends ue{constructor(H,oe){super(oe),this.l=H}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function re(G){const H=new i.CancellationTokenSource,oe=G(H.token);return new de(H,async ve=>{const Ae=H.token.onCancellationRequested(()=>{Ae.dispose(),H.dispose(),ve.reject(new C.CancellationError)});try{for await(const Be of oe){if(H.token.isCancellationRequested)return;ve.emitOne(Be)}Ae.dispose(),H.dispose()}catch(Be){Ae.dispose(),H.dispose(),ve.reject(Be)}})}e.createCancelableAsyncIterable=re}),define(Ie[124],Ce([1,0,12,19]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new i.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(u,g,A=!1){const N=u||"",q=g||"",te=S.value.collator.compare(N,q);return S.value.collatorIsNumeric&&te===0&&N!==q?N<q?-1:1:te}e.compareFileNames=R;function y(u,g){const A=L.value.collator;return u=u||"",g=g||"",P(A,u,g)}e.compareFileNamesDefault=y;function k(u,g){const A=L.value.collator;return u=u||"",g=g||"",o(u,g)||P(A,u,g)}e.compareFileNamesUpper=k;function O(u,g){const A=L.value.collator;return u=u||"",g=g||"",s(u,g)||P(A,u,g)}e.compareFileNamesLower=O;function w(u,g){return u=u||"",g=g||"",u===g?0:u<g?-1:1}e.compareFileNamesUnicode=w;function m(u,g){const[A,N]=b(u),[q,te]=b(g);let x=S.value.collator.compare(N,te);if(x===0){if(S.value.collatorIsNumeric&&N!==te)return N<te?-1:1;if(x=S.value.collator.compare(A,q),S.value.collatorIsNumeric&&x===0&&A!==q)return A<q?-1:1}return x}e.compareFileExtensions=m;function p(u,g){u=u||"",g=g||"";const A=E(u),N=E(g),q=L.value.collator,te=I.value.collator;return P(te,A,N)||P(q,u,g)}e.compareFileExtensionsDefault=p;function f(u,g){u=u||"",g=g||"";const A=E(u),N=E(g),q=L.value.collator,te=I.value.collator;return P(te,A,N)||o(u,g)||P(q,u,g)}e.compareFileExtensionsUpper=f;function n(u,g){u=u||"",g=g||"";const A=E(u),N=E(g),q=L.value.collator,te=I.value.collator;return P(te,A,N)||s(u,g)||P(q,u,g)}e.compareFileExtensionsLower=n;function r(u,g){u=u||"",g=g||"";const A=E(u).toLowerCase(),N=E(g).toLowerCase();return A!==N?A<N?-1:1:u!==g?u<g?-1:1:0}e.compareFileExtensionsUnicode=r;const d=/^(.*?)(\.([^.]*))?$/;function b(u,g=!1){const A=u?d.exec(u):[];let N=[A&&A[1]||"",A&&A[3]||""];return g&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function E(u){const g=u?d.exec(u):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function P(u,g,A){const N=u.compare(g,A);return N!==0?N:g.length!==A.length?g.length<A.length?-1:1:0}function v(u){const g=u.charAt(0);return g.toLocaleUpperCase()!==g}function t(u){const g=u.charAt(0);return g.toLocaleLowerCase()!==g}function s(u,g){return v(u)&&t(g)?-1:t(u)&&v(g)?1:0}function o(u,g){return t(u)&&v(g)?-1:v(u)&&t(g)?1:0}function l(u,g,A=!1){return A||(u=u&&u.toLowerCase(),g=g&&g.toLowerCase()),u===g?0:u<g?-1:1}function a(u,g,A=!1){const N=u.split(C.sep),q=g.split(C.sep),te=N.length-1,x=q.length-1;let F,$;for(let T=0;;T++){if(F=te===T,$=x===T,F&&$)return R(N[T],q[T],A);if(F)return-1;if($)return 1;const M=l(N[T],q[T],A);if(M!==0)return M}}e.comparePaths=a;function h(u,g,A){const N=u.toLowerCase(),q=g.toLowerCase(),te=c(u,g,A);if(te)return te;const x=N.endsWith(A),F=q.endsWith(A);if(x!==F)return x?-1:1;const $=R(N,q);return $!==0?$:N.localeCompare(q)}e.compareAnything=h;function c(u,g,A){const N=u.toLowerCase(),q=g.toLowerCase(),te=N.startsWith(A),x=q.startsWith(A);if(te!==x)return te?-1:1;if(te&&x){if(N.length<q.length)return-1;if(N.length>q.length)return 1}return 0}e.compareByPrefix=c}),define(Ie[35],Ce([1,0,18,12,40,28,19,20,10]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",m=/\//g;function p(le,Y){switch(le){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${Y?`|${O}${w}+`:""})*?`}}function f(le,Y){if(!le)return[];const pe=[];let ue=!1,de=!1,re="";for(const G of le){switch(G){case Y:if(!ue&&!de){pe.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=G}return re&&pe.push(re),pe}e.splitGlobAware=f;function n(le){if(!le)return"";let Y="";const pe=f(le,e.GLOB_SPLIT);if(pe.every(ue=>ue===e.GLOBSTAR))Y=".*";else{let ue=!1;pe.forEach((de,re)=>{if(de===e.GLOBSTAR){if(ue)return;Y+=p(2,re===pe.length-1)}else{let G=!1,H="",oe=!1,ve="";for(const Ae of de){if(Ae!=="}"&&G){H+=Ae;continue}if(oe&&(Ae!=="]"||!ve)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!ve?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,y.escapeRegExpCharacters)(Ae),ve+=Be;continue}switch(Ae){case"{":G=!0;continue;case"[":oe=!0;continue;case"}":{Y+=`(?:${f(H,",").map(Te=>n(Te)).join("|")})`,G=!1,H="";break}case"]":{Y+="["+ve+"]",oe=!1,ve="";break}case"?":Y+=w;continue;case"*":Y+=p(1);continue;default:Y+=(0,y.escapeRegExpCharacters)(Ae)}}re<pe.length-1&&(pe[re+1]!==e.GLOBSTAR||re+2<pe.length)&&(Y+=O)}ue=de===e.GLOBSTAR})}return Y}const r=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),s=function(){return!1},o=function(){return null};function l(le,Y){if(!le)return o;let pe;typeof le!="string"?pe=le.pattern:pe=le,pe=pe.trim();const ue=`${pe}_${!!Y.trimForExclusions}`;let de=t.get(ue);if(de)return a(de,le);let re;return r.test(pe)?de=c(pe.substr(4),pe):(re=d.exec(h(pe,Y)))?de=u(re[1],pe):(Y.trimForExclusions?E:b).test(pe)?de=g(pe,Y):(re=P.exec(h(pe,Y)))?de=A(re[1].substr(1),pe,!0):(re=v.exec(h(pe,Y)))?de=A(re[1],pe,!1):de=N(pe),t.set(ue,de),a(de,le)}function a(le,Y){if(typeof Y=="string")return le;const pe=function(ue,de){return(0,S.isEqualOrParent)(ue,Y.base,!R.isLinux)?le((0,y.ltrim)(ue.substr(Y.base.length),I.sep),de):null};return pe.allBasenames=le.allBasenames,pe.allPaths=le.allPaths,pe.basenames=le.basenames,pe.patterns=le.patterns,pe}function h(le,Y){return Y.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function c(le,Y){return function(pe,ue){return typeof pe=="string"&&pe.endsWith(le)?Y:null}}function u(le,Y){const pe=`/${le}`,ue=`\\${le}`,de=function(G,H){return typeof G!="string"?null:H?H===le?Y:null:G===le||G.endsWith(pe)||G.endsWith(ue)?Y:null},re=[le];return de.basenames=re,de.patterns=[Y],de.allBasenames=re,de}function g(le,Y){const pe=V(le.slice(1,-1).split(",").map(H=>l(H,Y)).filter(H=>H!==o),le),ue=pe.length;if(!ue)return o;if(ue===1)return pe[0];const de=function(H,oe){for(let ve=0,Ae=pe.length;ve<Ae;ve++)if(pe[ve](H,oe))return le;return null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function A(le,Y,pe){const ue=I.sep===I.posix.sep,de=ue?le:le.replace(m,I.sep),re=I.sep+de,G=I.posix.sep+le;let H;return pe?H=function(oe,ve){return typeof oe=="string"&&(oe===de||oe.endsWith(re)||!ue&&(oe===le||oe.endsWith(G)))?Y:null}:H=function(oe,ve){return typeof oe=="string"&&(oe===de||!ue&&oe===le)?Y:null},H.allPaths=[(pe?"*/":"./")+le],H}function N(le){try{const Y=new RegExp(`^${n(le)}$`);return function(pe){return Y.lastIndex=0,typeof pe=="string"&&Y.test(pe)?le:null}}catch{return o}}function q(le,Y,pe){return!le||typeof Y!="string"?!1:te(le)(Y,void 0,pe)}e.match=q;function te(le,Y={}){if(!le)return s;if(typeof le=="string"||x(le)){const pe=l(le,Y);if(pe===o)return s;const ue=function(de,re){return!!pe(de,re)};return pe.allBasenames&&(ue.allBasenames=pe.allBasenames),pe.allPaths&&(ue.allPaths=pe.allPaths),ue}return T(le,Y)}e.parse=te;function x(le){const Y=le;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=x;function F(le){return le.allBasenames||[]}e.getBasenameTerms=F;function $(le){return le.allPaths||[]}e.getPathTerms=$;function T(le,Y){const pe=V(Object.getOwnPropertyNames(le).map(H=>M(H,le[H],Y)).filter(H=>H!==o)),ue=pe.length;if(!ue)return o;if(!pe.some(H=>!!H.requiresSiblings)){if(ue===1)return pe[0];const H=function(Ae,Be){let xe;for(let Te=0,Se=pe.length;Te<Se;Te++){const ke=pe[Te](Ae,Be);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(xe||(xe=[]),xe.push(ke))}return xe?(async()=>{for(const Te of xe){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},oe=pe.find(Ae=>!!Ae.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const ve=pe.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return ve.length&&(H.allPaths=ve),H}const de=function(H,oe,ve){let Ae,Be;for(let xe=0,Te=pe.length;xe<Te;xe++){const Se=pe[xe];Se.requiresSiblings&&ve&&(oe||(oe=(0,I.basename)(H)),Ae||(Ae=oe.substr(0,oe.length-(0,I.extname)(H).length)));const ke=Se(H,oe,Ae,ve);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(Be||(Be=[]),Be.push(ke))}return Be?(async()=>{for(const xe of Be){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function M(le,Y,pe){if(Y===!1)return o;const ue=l(le,pe);if(ue===o)return o;if(typeof Y=="boolean")return ue;if(Y){const de=Y.when;if(typeof de=="string"){const re=(G,H,oe,ve)=>{if(!ve||!ue(G,H))return null;const Ae=de.replace("$(basename)",()=>oe),Be=ve(Ae);return(0,C.isThenable)(Be)?Be.then(xe=>xe?le:null):Be?le:null};return re.requiresSiblings=!0,re}}return ue}function V(le,Y){const pe=le.filter(H=>!!H.basenames);if(pe.length<2)return le;const ue=pe.reduce((H,oe)=>{const ve=oe.basenames;return ve?H.concat(ve):H},[]);let de;if(Y){de=[];for(let H=0,oe=ue.length;H<oe;H++)de.push(Y)}else de=pe.reduce((H,oe)=>{const ve=oe.patterns;return ve?H.concat(ve):H},[]);const re=function(H,oe){if(typeof H!="string")return null;if(!oe){let Ae;for(Ae=H.length;Ae>0;Ae--){const Be=H.charCodeAt(Ae-1);if(Be===47||Be===92)break}oe=H.substr(Ae)}const ve=ue.indexOf(oe);return ve!==-1?de[ve]:null};re.basenames=ue,re.patterns=de,re.allBasenames=ue;const G=le.filter(H=>!H.basenames);return G.push(re),G}function j(le,Y){return(0,i.equals)(le,Y,(pe,ue)=>typeof pe=="string"&&typeof ue=="string"?pe===ue:typeof pe!="string"&&typeof ue!="string"?pe.base===ue.base&&pe.pattern===ue.pattern:!1)}e.patternsEquals=j}),define(Ie[85],Ce([1,0,11,123,23,10,2]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",b=!1){if(this.value=d,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(d,b=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(d):d).replace(/([ \t]+)/g,(E,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,b){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(d,b,E){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(d),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(d,b){const E=new RegExp((0,L.escapeRegExpCharacters)(b),"g");return d.replace(E,(P,v)=>d.charAt(v-1)!=="\\"?`\\${P}`:P)}}e.MarkdownString=y;function k(r){return O(r)?!r.value:Array.isArray(r)?r.every(k):!0}e.isEmptyMarkdownString=k;function O(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(r,d){return r===d?!0:!r||!d?!1:r.value===d.value&&r.isTrusted===d.isTrusted&&r.supportThemeIcons===d.supportThemeIcons&&r.supportHtml===d.supportHtml&&(r.baseUri===d.baseUri||!!r.baseUri&&!!d.baseUri&&(0,S.isEqual)(I.URI.from(r.baseUri),I.URI.from(d.baseUri)))}e.markdownStringEqual=w;function m(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function p(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function f(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function n(r){const d=[],b=r.split("|").map(P=>P.trim());r=b[0];const E=b[1];if(E){const P=/height=(\d+)/.exec(E),v=/width=(\d+)/.exec(E),t=P?P[1]:"",s=v?v[1]:"",o=isFinite(parseInt(s)),l=isFinite(parseInt(t));o&&d.push(`width="${s}"`),l&&d.push(`height="${t}"`)}return{href:r,dimensions:d}}e.parseHrefAndDimensions=n}),define(Ie[86],Ce([1,0,18,40,19,20,23,10]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,l){const{os:a,tildify:h,relative:c}=l;if(c){const A=k(o,c,a);if(typeof A=="string")return A}let u=o.fsPath;if(a===1&&!L.isWindows?u=u.replace(/\//g,"\\"):a!==1&&L.isWindows&&(u=u.replace(/\\/g,"/")),a!==1&&h?.userHome){const A=h.userHome.fsPath;let N;o.scheme!==h.userHome.scheme&&o.path.startsWith(S.posix.sep)?N=h.userHome.with({path:o.path}).fsPath:N=o.fsPath,u=m(N,A,a)}return(a===1?S.win32:S.posix).normalize(O(u,a===1))}e.getPathLabel=y;function k(o,l,a){const h=a===1?S.win32:S.posix,c=a===3?I.extUri:I.extUriIgnorePathCase,u=l.getWorkspace(),g=(0,i.firstOrDefault)(u.folders);if(!g)return;o.scheme!==g.uri.scheme&&o.path.startsWith(S.posix.sep)&&(o=g.uri.with({path:o.path}));const A=l.getWorkspaceFolder(o);if(!A)return;let N;if(c.isEqual(A.uri,o)?N="":N=c.relativePath(A.uri,o)??"",N&&(N=h.normalize(N)),u.folders.length>1&&!l.noPrefix){const q=A.name?A.name:c.basenameOrAuthority(A.uri);N=N?`${q} \u2022 ${N}`:q}return N}function O(o,l=L.isWindows){return(0,C.hasDriveLetter)(o,l)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=O;let w=Object.create(null);function m(o,l,a=L.OS){if(a===1||!o||!l)return o;let h=w.original===l?w.normalized:void 0;h||(h=l,L.isWindows&&(h=(0,C.toSlashes)(h)),h=`${(0,R.rtrim)(h,S.posix.sep)}${S.posix.sep}`,w={original:l,normalized:h});let c=o;return L.isWindows&&(c=(0,C.toSlashes)(c)),(a===3?c.startsWith(h):(0,R.startsWithIgnoreCase)(c,h))?`~/${c.substr(h.length)}`:o}e.tildify=m;function p(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=p;const f="\u2026",n="\\\\",r="~";function d(o,l=S.sep){const a=new Array(o.length);let h=!1;for(let c=0;c<o.length;c++){const u=o[c];if(u===""){a[c]=`.${l}`;continue}if(!u){a[c]=u;continue}h=!0;let g="",A=u;A.indexOf(n)===0?(g=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(l)===0?(g=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(r)===0&&(g=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length));const N=A.split(l);for(let q=1;h&&q<=N.length;q++)for(let te=N.length-q;h&&te>=0;te--){h=!1;let x=N.slice(te,te+q).join(l);for(let F=0;!h&&F<o.length;F++)if(F!==c&&o[F]&&o[F].indexOf(x)>-1){const $=te+q===N.length,T=te>0&&o[F].indexOf(l)>-1?l+x:x,M=o[F].endsWith(T);h=!$||M}if(!h){let F="";(N[0].endsWith(":")||g!=="")&&(te===1&&(te=0,q++,x=N[0]+l+x),te>0&&(F=N[0]+l),F=g+F),te>0&&(F=F+f+l),F=F+x,te+q<N.length&&(F=F+l+f),a[c]=F}}h&&(a[c]=u)}return a}e.shorten=d;var b;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function E(o,l=Object.create(null)){const a=[];let h=!1,c="";for(const u of o)if(u==="$"||h&&u==="{")c&&a.push({value:c,type:b.TEXT}),c="",h=!0;else if(u==="}"&&h){const g=l[c];if(typeof g=="string")g.length&&a.push({value:g,type:b.VARIABLE});else if(g){const A=a[a.length-1];(!A||A.type!==b.SEPARATOR)&&a.push({value:g.label,type:b.SEPARATOR})}c="",h=!1}else c+=u;return c&&!h&&a.push({value:c,type:b.TEXT}),a.filter((u,g)=>{if(u.type===b.SEPARATOR){const A=a[g-1],N=a[g+1];return[A,N].every(q=>q&&(q.type===b.VARIABLE||q.type===b.TEXT)&&q.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=E;function P(o,l){return L.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):o.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function v(o,l){return L.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):L.isWindows?o.replace(/&&|&/g,a=>a==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=t;function s(o){const l=o.indexOf("/")!==-1?S.posix:S.win32,a=l.basename(o),h=l.dirname(o);return a.length?{name:a,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(Ie[125],Ce([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class S{constructor(w){this.a=w}transformIncoming(w){const m=this.a.transformIncoming(w);return m===w?w:C(i.URI.from(m))}transformOutgoing(w){const m=this.a.transformOutgoing(w);return m===w?w:C(i.URI.from(m))}transformOutgoingURI(w){const m=this.a.transformOutgoing(w);return m===w?w:i.URI.from(m)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function L(O,w,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return w.transformOutgoing(O);for(const p in O)if(Object.hasOwnProperty.call(O,p)){const f=L(O[p],w,m+1);f!==null&&(O[p]=f)}}return null}function I(O,w){const m=L(O,w,0);return m===null?O:m}e.transformOutgoingURIs=I;function R(O,w,m,p){if(!O||p>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?i.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const n=R(O[f],w,m,p+1);n!==null&&(O[f]=n)}}return null}function y(O,w){const m=R(O,w,!1,0);return m===null?O:m}e.transformIncomingURIs=y;function k(O,w){const m=R(O,w,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=k}),define(Ie[126],Ce([1,0,35,19]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(L,I,R,y,k,O){if(Array.isArray(L)){let w=0;for(const m of L){const p=S(m,I,R,y,k,O);if(p===10)return p;p>w&&(w=p)}return w}else{if(typeof L=="string")return y?L==="*"?5:L===R?10:0:0;if(L){const{language:w,pattern:m,scheme:p,hasAccessToAllModels:f,notebookType:n}=L;if(!y&&!f)return 0;n&&k&&(I=k);let r=0;if(p)if(p===I.scheme)r=10;else if(p==="*")r=5;else return 0;if(w)if(w===R)r=10;else if(w==="*")r=Math.max(r,5);else return 0;if(n)if(n===O)r=10;else if(n==="*"&&O!==void 0)r=Math.max(r,5);else return 0;if(m){let d;if(typeof m=="string"?d=m:d={...m,base:(0,C.normalize)(m.base)},d===I.fsPath||(0,i.match)(d,I.fsPath))r=10;else return 0}return r}else return 0}}e.score=S}),define(Ie[87],Ce([1,0,25,20]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(S||(S={}));function L(w){for(let m=0,p=w.length;m<p;m+=4){const f=w[m+0],n=w[m+1],r=w[m+2],d=w[m+3];w[m+0]=d,w[m+1]=r,w[m+2]=n,w[m+3]=f}}function I(w){const m=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||L(m),i.VSBuffer.wrap(m)}function R(w){const m=w.buffer;if(C.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const p=new Uint8Array(m.byteLength);return p.set(m),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function y(w){const m=new Uint32Array(k(w));let p=0;if(m[p++]=w.id,w.type==="full")m[p++]=1,m[p++]=w.data.length,m.set(w.data,p),p+=w.data.length;else{m[p++]=2,m[p++]=w.deltas.length;for(const f of w.deltas)m[p++]=f.start,m[p++]=f.deleteCount,f.data?(m[p++]=f.data.length,m.set(f.data,p),p+=f.data.length):m[p++]=0}return I(m)}e.encodeSemanticTokensDto=y;function k(w){let m=0;if(m+=1+1,w.type==="full")m+=1+w.data.length;else{m+=1,m+=(1+1+1)*w.deltas.length;for(const p of w.deltas)p.data&&(m+=p.data.length)}return m}function O(w){const m=R(w);let p=0;const f=m[p++];if(m[p++]===1){const b=m[p++],E=m.subarray(p,p+b);return p+=b,{id:f,type:"full",data:E}}const r=m[p++],d=[];for(let b=0;b<r;b++){const E=m[p++],P=m[p++],v=m[p++];let t;v>0&&(t=m.subarray(p,p+v),p+=v),d[b]={start:E,deleteCount:P,data:t}}return{id:f,type:"delta",deltas:d}}e.decodeSemanticTokensDto=O}),define(Ie[127],Ce([14,15]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ie[128],Ce([1,0,127,20,129,18,22,115]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(Q,ge,Me,$e){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(Q,ge){return p(Q,ge)}compute(Q,ge,Me){return Me}}class m{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=m;function p(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new m(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const Me=Array.isArray(_)&&Array.isArray(Q)&&L.equals(_,Q);return new m(Q,!Me)}let ge=!1;for(const Me in Q)if(Q.hasOwnProperty(Me)){const $e=p(_[Me],Q[Me]);$e.didChange&&(_[Me]=$e.newValue,ge=!0)}return new m(_,ge)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return p(Q,ge)}validate(Q){return this.defaultValue}}class n{constructor(Q,ge,Me,$e){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(Q,ge){return p(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Me){return Me}}function r(_,Q){return typeof _>"u"?Q:_==="false"?!1:Boolean(_)}e.boolean=r;class d extends n{constructor(Q,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Me),super(Q,ge,Me,$e)}validate(Q){return r(Q,this.defaultValue)}}function b(_,Q,ge,Me){if(typeof _>"u")return Q;let $e=parseInt(_,10);return isNaN($e)?Q:($e=Math.max(ge,$e),$e=Math.min(Me,$e),$e|0)}e.clampedInt=b;class E extends n{static clampedInt(Q,ge,Me,$e){return b(Q,ge,Me,$e)}constructor(Q,ge,Me,$e,je,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Me,_e.minimum=$e,_e.maximum=je),super(Q,ge,Me,_e),this.minimum=$e,this.maximum=je}validate(Q){return E.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class P extends n{static clamp(Q,ge,Me){return Q<ge?ge:Q>Me?Me:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Me=parseFloat(Q);return isNaN(Me)?ge:Me}constructor(Q,ge,Me,$e,je){typeof je<"u"&&(je.type="number",je.default=Me),super(Q,ge,Me,je),this.validationFn=$e}validate(Q){return this.validationFn(P.float(Q,this.defaultValue))}}class v extends n{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Me),super(Q,ge,Me,$e)}validate(Q){return v.string(Q,this.defaultValue)}}function t(_,Q,ge){return typeof _!="string"||ge.indexOf(_)===-1?Q:_}e.stringSet=t;class s extends n{constructor(Q,ge,Me,$e,je=void 0){typeof je<"u"&&(je.type="string",je.enum=$e,je.default=Me),super(Q,ge,Me,je),this.c=$e}validate(Q){return t(Q,this.defaultValue,this.c)}}class o extends w{constructor(Q,ge,Me,$e,je,_e,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=$e),super(Q,ge,Me,nt),this.c=je,this.d=_e}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function l(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Me){return Me===0?Q.accessibilitySupport:Me}}class h extends w{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:r(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(_){switch(_){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function N(_){switch(_){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class q extends f{constructor(){super(135)}compute(Q,ge,Me){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),Q.extraEditorClassName&&$e.push(Q.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class te extends d{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,ge,Me){return Me&&Q.emptySelectionClipboard}}class x extends w{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:r(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(ge.loop,this.defaultValue.loop)}}}class F extends w{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.ON:Q:Boolean(Q)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class $ extends w{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?$.OFF:Q==="true"?$.TRANSLATE:Q:Boolean(Q)?$.TRANSLATE:$.OFF}compute(Q,ge,Me){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=$,$.OFF="normal",$.TRANSLATE="translate";class T extends f{constructor(){super(47)}compute(Q,ge,Me){return Q.fontInfo}}class M extends n{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(Q){const ge=P.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:P.clamp(ge,6,100)}compute(Q,ge,Me){return Q.fontInfo.fontSize}}class V extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(E.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class j extends w{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Me,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Me,description:i.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:t(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??t(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??t(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??t(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??t(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??t(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends w{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),delay:E.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:r(ge.sticky,this.defaultValue.sticky),above:r(ge.above,this.defaultValue.above)}}}var Y;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class pe extends f{constructor(){super(138)}compute(Q,ge,Me){return pe.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Me=Math.floor(Q.paddingTop/Q.lineHeight);let $e=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const je=(Me+Q.viewLineCount+$e)/(Q.pixelRatio*Q.height),_e=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:$e,desiredRatio:je,minimapLineCount:_e}}static c(Q,ge){const Me=Q.outerWidth,$e=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const _e=ge.stableMinimapLayoutInput,nt=_e&&Q.outerHeight===_e.outerHeight&&Q.lineHeight===_e.lineHeight&&Q.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&Q.pixelRatio===_e.pixelRatio&&Q.scrollBeyondLastLine===_e.scrollBeyondLastLine&&Q.paddingTop===_e.paddingTop&&Q.paddingBottom===_e.paddingBottom&&Q.minimap.enabled===_e.minimap.enabled&&Q.minimap.side===_e.minimap.side&&Q.minimap.size===_e.minimap.size&&Q.minimap.showSlider===_e.minimap.showSlider&&Q.minimap.renderCharacters===_e.minimap.renderCharacters&&Q.minimap.maxColumn===_e.minimap.maxColumn&&Q.minimap.scale===_e.minimap.scale&&Q.verticalScrollbarWidth===_e.verticalScrollbarWidth&&Q.isViewportWrapping===_e.isViewportWrapping,wt=Q.lineHeight,St=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let at=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Bt=Q.minimap.maxColumn,Ot=Q.minimap.size,Ft=Q.minimap.side,ft=Q.verticalScrollbarWidth,Dt=Q.viewLineCount,$t=Q.remainingWidth,Nt=Q.isViewportWrapping,Ge=lt?2:3;let Mt=Math.floor(je*$e);const Lt=Mt/je;let Ut=!1,gt=!1,kt=Ge*at,De=at/je,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:vt,desiredRatio:At,minimapLineCount:pt}=pe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Ct,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:$e,lineHeight:wt,pixelRatio:je});if(Dt/pt>1)Ut=!0,gt=!0,at=1,kt=1,De=at/je;else{let ht=!1,Kt=at+1;if(Ot==="fit"){const Vt=Math.ceil((bt+Dt+vt)*kt);Nt&&nt&&$t<=ge.stableFitRemainingWidth?(ht=!0,Kt=ge.stableFitMaxMinimapScale):ht=Vt>Mt}if(Ot==="fill"||ht){Ut=!0;const Vt=at;kt=Math.min(wt*je,Math.max(1,Math.floor(1/At))),Nt&&nt&&$t<=ge.stableFitRemainingWidth&&(Kt=ge.stableFitMaxMinimapScale),at=Math.min(Kt,Math.max(1,Math.floor(kt/Ge))),at>Vt&&(Pe=Math.min(2,at/Vt)),De=at/je/Pe,Mt=Math.ceil(Math.max(Ze,bt+Dt+vt)*kt),Nt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=$t,ge.stableFitMaxMinimapScale=at):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const me=Math.floor(Bt*De),X=Math.min(me,Math.max(0,Math.floor(($t-ft-2)*De/(St+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(je*X);const Le=Re/je;Re=Math.floor(Re*Pe);const Qe=lt?1:2,ze=Ft==="left"?0:Me-X-ft;return{renderMinimap:Qe,minimapLeft:ze,minimapWidth:X,minimapHeightIsEditorHeight:Ut,minimapIsSampling:gt,minimapScale:at,minimapLineHeight:kt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(Q,ge){const Me=ge.outerWidth|0,$e=ge.outerHeight|0,je=ge.lineHeight|0,_e=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,St=ge.pixelRatio,Ct=ge.viewLineCount,lt=Q.get(130),at=lt==="inherit"?Q.get(129):lt,Bt=at==="inherit"?Q.get(125):at,Ot=Q.get(128),Ft=ge.isDominatedByLongLines,ft=Q.get(54),Dt=Q.get(64).renderType!==0,$t=Q.get(65),Nt=Q.get(99),Ge=Q.get(80),Mt=Q.get(69),Lt=Q.get(97),Ut=Lt.verticalScrollbarSize,gt=Lt.verticalHasArrows,kt=Lt.arrowSize,De=Lt.horizontalScrollbarSize,Pe=Q.get(40),me=Q.get(104)!=="never";let X=Q.get(62);Pe&&me&&(X+=16);let Re=0;if(Dt){const Qt=Math.max(_e,$t);Re=Math.round(Qt*wt)}let Le=0;ft&&(Le=je);let Qe=0,ze=Qe+Le,Ze=ze+Re,bt=Ze+X;const vt=Me-Le-Re-X;let At=!1,pt=!1,It=-1;at==="inherit"&&Ft?(At=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(It=Ot);const ht=pe.c({outerWidth:Me,outerHeight:$e,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:St,scrollBeyondLastLine:Nt,paddingTop:Ge.top,paddingBottom:Ge.bottom,minimap:Mt,verticalScrollbarWidth:Ut,viewLineCount:Ct,remainingWidth:vt,isViewportWrapping:pt},ge.memory||new O);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Qe+=ht.minimapWidth,ze+=ht.minimapWidth,Ze+=ht.minimapWidth,bt+=ht.minimapWidth);const Kt=vt-ht.minimapWidth,Vt=Math.max(1,Math.floor((Kt-Ut-2)/nt)),Et=gt?kt:0;return pt&&(It=Math.max(1,Vt),Bt==="bounded"&&(It=Math.min(It,Ot))),{width:Me,height:$e,glyphMarginLeft:Qe,glyphMarginWidth:Le,lineNumbersLeft:ze,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:X,contentLeft:bt,contentWidth:Kt,minimap:ht,viewportColumn:Vt,isWordWrapMinified:At,isViewportWrapping:pt,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:De,overviewRuler:{top:Et,width:Ut,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=pe;class ue extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(Q){return t(Q,"simple",["simple","advanced"])}compute(Q,ge,Me){return ge.get(2)===2?"advanced":Me}}class de extends w{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:r(Q.enabled,this.defaultValue.enabled)}}}class re extends w{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends w{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:i.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:t(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ge.fontFamily,this.defaultValue.fontFamily),padding:r(ge.padding,this.defaultValue.padding)}}}class H extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):E.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Me){return Me<0?E.clampedInt(-Me*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class oe extends P{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>P.clamp(Q,0,150),{markdownDescription:i.localize(60,null)})}compute(Q,ge,Me){return Q.fontInfo.lineHeight}}class ve extends w{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:Q.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),autohide:r(ge.autohide,this.defaultValue.autohide),size:t(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ge.side,this.defaultValue.side,["right","left"]),showSlider:t(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(ge.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(ge.scale,1,1,3),maxColumn:E.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(_){return _==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:E.clampedInt(ge.top,0,0,1e3),bottom:E.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends w{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),cycle:r(ge.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(Q,ge,Me){return Q.pixelRatio}}class Se extends w{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:i.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:i.localize(80,null)},other:{anyOf:ge,default:Q.other,description:i.localize(81,null)}},default:Q,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const St=Q?"on":"off";return{comments:St,strings:St,other:St}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Me,strings:$e}=Q,je=["on","inline","off"];let _e,nt,wt;return typeof ge=="boolean"?_e=ge?"on":"off":_e=t(ge,this.defaultValue.other,je),typeof Me=="boolean"?nt=Me?"on":"off":nt=t(Me,this.defaultValue.comments,je),typeof $e=="boolean"?wt=$e?"on":"off":wt=t($e,this.defaultValue.strings,je),{other:_e,comments:nt,strings:wt}}}var ke;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Me=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function ce(_){const Q=_.get(92);return Q==="editable"?_.get(86):Q!=="on"}e.filterValidationDecorations=ce;class J extends w{constructor(){const Q=[],ge={type:"number",description:i.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:Q,description:i.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Me of Q)if(typeof Me=="number")ge.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const $e=Me;ge.push({column:E.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((Me,$e)=>Me.column-$e.column),ge}return this.defaultValue}}function D(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends w{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Me=E.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=E.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:D(ge.vertical,this.defaultValue.vertical),horizontal:D(ge.horizontal,this.defaultValue.horizontal),useShadows:r(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:E.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:r(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(108,null)}})}applyUpdate(Q,ge){let Me=!1;ge.allowedCharacters&&Q&&(I.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Me=!0)),ge.allowedLocales&&Q&&(I.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Me=!0));const $e=super.applyUpdate(Q,ge);return Me?new m($e.newValue,!0):$e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:ye(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Me={};for(const[$e,je]of Object.entries(Q))je===!0&&(Me[$e]=!0);return Me}}class K extends w{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),mode:t(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Z extends w{constructor(){const Q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class he extends w{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:Q.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:Q.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:Q.highlightActiveIndentation,description:i.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:ye(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(_,Q,ge){const Me=ge.indexOf(_);return Me===-1?Q:ge[Me]}class ae extends w{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:Q.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(132,null),i.localize(133,null),i.localize(134,null),i.localize(135,null)],default:Q.selectionMode,markdownDescription:i.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:t(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(ge.showIcons,this.defaultValue.showIcons),showStatusBar:r(ge.showStatusBar,this.defaultValue.showStatusBar),preview:r(ge.preview,this.defaultValue.preview),previewMode:t(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(ge.showMethods,this.defaultValue.showMethods),showFunctions:r(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:r(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(ge.showFields,this.defaultValue.showFields),showVariables:r(ge.showVariables,this.defaultValue.showVariables),showClasses:r(ge.showClasses,this.defaultValue.showClasses),showStructs:r(ge.showStructs,this.defaultValue.showStructs),showInterfaces:r(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:r(ge.showModules,this.defaultValue.showModules),showProperties:r(ge.showProperties,this.defaultValue.showProperties),showEvents:r(ge.showEvents,this.defaultValue.showEvents),showOperators:r(ge.showOperators,this.defaultValue.showOperators),showUnits:r(ge.showUnits,this.defaultValue.showUnits),showValues:r(ge.showValues,this.defaultValue.showValues),showConstants:r(ge.showConstants,this.defaultValue.showConstants),showEnums:r(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:r(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(ge.showKeywords,this.defaultValue.showKeywords),showWords:r(ge.showWords,this.defaultValue.showWords),showColors:r(ge.showColors,this.defaultValue.showColors),showFiles:r(ge.showFiles,this.defaultValue.showFiles),showReferences:r(ge.showReferences,this.defaultValue.showReferences),showFolders:r(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:r(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(ge.showSnippets,this.defaultValue.showSnippets),showUsers:r(ge.showUsers,this.defaultValue.showUsers),showIssues:r(ge.showIssues,this.defaultValue.showIssues)}}}class be extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(174,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends f{constructor(){super(137)}compute(Q,ge,Me){return ge.get(86)?!0:Q.tabFocusMode}}var We;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(175,null),i.localize(176,null),i.localize(177,null),i.localize(178,null)],description:i.localize(179,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Me){return ge.get(2)===2?0:Me}}class tt extends f{constructor(){super(139)}compute(Q,ge,Me){const $e=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Xe extends w{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(180,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:r(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.autoClosingBrackets=5]="autoClosingBrackets",_[_.autoClosingDelete=6]="autoClosingDelete",_[_.autoClosingOvertype=7]="autoClosingOvertype",_[_.autoClosingQuotes=8]="autoClosingQuotes",_[_.autoIndent=9]="autoIndent",_[_.automaticLayout=10]="automaticLayout",_[_.autoSurround=11]="autoSurround",_[_.bracketPairColorization=12]="bracketPairColorization",_[_.guides=13]="guides",_[_.codeLens=14]="codeLens",_[_.codeLensFontFamily=15]="codeLensFontFamily",_[_.codeLensFontSize=16]="codeLensFontSize",_[_.colorDecorators=17]="colorDecorators",_[_.colorDecoratorsLimit=18]="colorDecoratorsLimit",_[_.columnSelection=19]="columnSelection",_[_.comments=20]="comments",_[_.contextmenu=21]="contextmenu",_[_.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",_[_.cursorBlinking=23]="cursorBlinking",_[_.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",_[_.cursorStyle=25]="cursorStyle",_[_.cursorSurroundingLines=26]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",_[_.cursorWidth=28]="cursorWidth",_[_.disableLayerHinting=29]="disableLayerHinting",_[_.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",_[_.domReadOnly=31]="domReadOnly",_[_.dragAndDrop=32]="dragAndDrop",_[_.dropIntoEditor=33]="dropIntoEditor",_[_.emptySelectionClipboard=34]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",_[_.extraEditorClassName=36]="extraEditorClassName",_[_.fastScrollSensitivity=37]="fastScrollSensitivity",_[_.find=38]="find",_[_.fixedOverflowWidgets=39]="fixedOverflowWidgets",_[_.folding=40]="folding",_[_.foldingStrategy=41]="foldingStrategy",_[_.foldingHighlight=42]="foldingHighlight",_[_.foldingImportsByDefault=43]="foldingImportsByDefault",_[_.foldingMaximumRegions=44]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=46]="fontFamily",_[_.fontInfo=47]="fontInfo",_[_.fontLigatures=48]="fontLigatures",_[_.fontSize=49]="fontSize",_[_.fontWeight=50]="fontWeight",_[_.fontVariations=51]="fontVariations",_[_.formatOnPaste=52]="formatOnPaste",_[_.formatOnType=53]="formatOnType",_[_.glyphMargin=54]="glyphMargin",_[_.gotoLocation=55]="gotoLocation",_[_.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",_[_.hover=57]="hover",_[_.inDiffEditor=58]="inDiffEditor",_[_.inlineSuggest=59]="inlineSuggest",_[_.letterSpacing=60]="letterSpacing",_[_.lightbulb=61]="lightbulb",_[_.lineDecorationsWidth=62]="lineDecorationsWidth",_[_.lineHeight=63]="lineHeight",_[_.lineNumbers=64]="lineNumbers",_[_.lineNumbersMinChars=65]="lineNumbersMinChars",_[_.linkedEditing=66]="linkedEditing",_[_.links=67]="links",_[_.matchBrackets=68]="matchBrackets",_[_.minimap=69]="minimap",_[_.mouseStyle=70]="mouseStyle",_[_.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=72]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",_[_.multiCursorModifier=74]="multiCursorModifier",_[_.multiCursorPaste=75]="multiCursorPaste",_[_.multiCursorLimit=76]="multiCursorLimit",_[_.occurrencesHighlight=77]="occurrencesHighlight",_[_.overviewRulerBorder=78]="overviewRulerBorder",_[_.overviewRulerLanes=79]="overviewRulerLanes",_[_.padding=80]="padding",_[_.parameterHints=81]="parameterHints",_[_.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",_[_.quickSuggestions=84]="quickSuggestions",_[_.quickSuggestionsDelay=85]="quickSuggestionsDelay",_[_.readOnly=86]="readOnly",_[_.renameOnType=87]="renameOnType",_[_.renderControlCharacters=88]="renderControlCharacters",_[_.renderFinalNewline=89]="renderFinalNewline",_[_.renderLineHighlight=90]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=92]="renderValidationDecorations",_[_.renderWhitespace=93]="renderWhitespace",_[_.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",_[_.roundedSelection=95]="roundedSelection",_[_.rulers=96]="rulers",_[_.scrollbar=97]="scrollbar",_[_.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=99]="scrollBeyondLastLine",_[_.scrollPredominantAxis=100]="scrollPredominantAxis",_[_.selectionClipboard=101]="selectionClipboard",_[_.selectionHighlight=102]="selectionHighlight",_[_.selectOnLineNumbers=103]="selectOnLineNumbers",_[_.showFoldingControls=104]="showFoldingControls",_[_.showUnused=105]="showUnused",_[_.snippetSuggestions=106]="snippetSuggestions",_[_.smartSelect=107]="smartSelect",_[_.smoothScrolling=108]="smoothScrolling",_[_.stickyScroll=109]="stickyScroll",_[_.stickyTabStops=110]="stickyTabStops",_[_.stopRenderingLineAfter=111]="stopRenderingLineAfter",_[_.suggest=112]="suggest",_[_.suggestFontSize=113]="suggestFontSize",_[_.suggestLineHeight=114]="suggestLineHeight",_[_.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",_[_.suggestSelection=116]="suggestSelection",_[_.tabCompletion=117]="tabCompletion",_[_.tabIndex=118]="tabIndex",_[_.unicodeHighlighting=119]="unicodeHighlighting",_[_.unusualLineTerminators=120]="unusualLineTerminators",_[_.useShadowDOM=121]="useShadowDOM",_[_.useTabStops=122]="useTabStops",_[_.wordBreak=123]="wordBreak",_[_.wordSeparators=124]="wordSeparators",_[_.wordWrap=125]="wordWrap",_[_.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=128]="wordWrapColumn",_[_.wordWrapOverride1=129]="wordWrapOverride1",_[_.wordWrapOverride2=130]="wordWrapOverride2",_[_.wrappingIndent=131]="wrappingIndent",_[_.wrappingStrategy=132]="wrappingStrategy",_[_.showDeprecated=133]="showDeprecated",_[_.inlayHints=134]="inlayHints",_[_.editorClassName=135]="editorClassName",_[_.pixelRatio=136]="pixelRatio",_[_.tabFocusMode=137]="tabFocusMode",_[_.layoutInfo=138]="layoutInfo",_[_.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(181,null)})),acceptSuggestionOnEnter:Fe(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(182,null),""],markdownDescription:i.localize(183,null)})),accessibilitySupport:Fe(new a),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(184,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",i.localize(185,null))),autoClosingBrackets:Fe(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(186,null),i.localize(187,null),""],description:i.localize(188,null)})),autoClosingDelete:Fe(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(189,null),""],description:i.localize(190,null)})),autoClosingOvertype:Fe(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(191,null),""],description:i.localize(192,null)})),autoClosingQuotes:Fe(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(193,null),i.localize(194,null),""],description:i.localize(195,null)})),autoIndent:Fe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[i.localize(196,null),i.localize(197,null),i.localize(198,null),i.localize(199,null),i.localize(200,null)],description:i.localize(201,null)})),automaticLayout:Fe(new d(10,"automaticLayout",!1)),autoSurround:Fe(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(202,null),i.localize(203,null),i.localize(204,null),""],description:i.localize(205,null)})),bracketPairColorization:Fe(new Z),bracketPairGuides:Fe(new he),stickyTabStops:Fe(new d(110,"stickyTabStops",!1,{description:i.localize(206,null)})),codeLens:Fe(new d(14,"codeLens",!0,{description:i.localize(207,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:i.localize(208,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(209,null)})),colorDecorators:Fe(new d(17,"colorDecorators",!0,{description:i.localize(210,null)})),colorDecoratorsLimit:Fe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(211,null)})),columnSelection:Fe(new d(19,"columnSelection",!1,{description:i.localize(212,null)})),comments:Fe(new h),contextmenu:Fe(new d(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new d(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(213,null)})),cursorBlinking:Fe(new o(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:i.localize(214,null)})),cursorSmoothCaretAnimation:Fe(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(215,null),i.localize(216,null),i.localize(217,null)],description:i.localize(218,null)})),cursorStyle:Fe(new o(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:i.localize(219,null)})),cursorSurroundingLines:Fe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(220,null)})),cursorSurroundingLinesStyle:Fe(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(221,null),i.localize(222,null)],description:i.localize(223,null)})),cursorWidth:Fe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(224,null)})),disableLayerHinting:Fe(new d(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new d(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new d(31,"domReadOnly",!1)),dragAndDrop:Fe(new d(32,"dragAndDrop",!0,{description:i.localize(225,null)})),emptySelectionClipboard:Fe(new te),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new re),experimentalWhitespaceRendering:Fe(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(226,null),i.localize(227,null),i.localize(228,null)],description:i.localize(229,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new P(37,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:i.localize(230,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new d(39,"fixedOverflowWidgets",!1)),folding:Fe(new d(40,"folding",!0,{description:i.localize(231,null)})),foldingStrategy:Fe(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(232,null),i.localize(233,null)],description:i.localize(234,null)})),foldingHighlight:Fe(new d(42,"foldingHighlight",!0,{description:i.localize(235,null)})),foldingImportsByDefault:Fe(new d(43,"foldingImportsByDefault",!1,{description:i.localize(236,null)})),foldingMaximumRegions:Fe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(237,null)})),unfoldOnClickAfterEndOfLine:Fe(new d(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(238,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(239,null)})),fontInfo:Fe(new T),fontLigatures2:Fe(new F),fontSize:Fe(new M),fontWeight:Fe(new V),fontVariations:Fe(new $),formatOnPaste:Fe(new d(52,"formatOnPaste",!1,{description:i.localize(240,null)})),formatOnType:Fe(new d(53,"formatOnType",!1,{description:i.localize(241,null)})),glyphMargin:Fe(new d(54,"glyphMargin",!0,{description:i.localize(242,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new d(56,"hideCursorInOverviewRuler",!1,{description:i.localize(243,null)})),hover:Fe(new le),inDiffEditor:Fe(new d(58,"inDiffEditor",!1)),letterSpacing:Fe(new P(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>P.clamp(_,-5,20),{description:i.localize(244,null)})),lightbulb:Fe(new de),lineDecorationsWidth:Fe(new H),lineHeight:Fe(new oe),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new d(66,"linkedEditing",!1,{description:i.localize(245,null)})),links:Fe(new d(67,"links",!0,{description:i.localize(246,null)})),matchBrackets:Fe(new s(68,"matchBrackets","always",["always","near","never"],{description:i.localize(247,null)})),minimap:Fe(new ve),mouseStyle:Fe(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new P(71,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:i.localize(248,null)})),mouseWheelZoom:Fe(new d(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(249,null)})),multiCursorMergeOverlapping:Fe(new d(73,"multiCursorMergeOverlapping",!0,{description:i.localize(250,null)})),multiCursorModifier:Fe(new o(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[i.localize(251,null),i.localize(252,null)],markdownDescription:i.localize(253,null)})),multiCursorPaste:Fe(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(254,null),i.localize(255,null)],markdownDescription:i.localize(256,null)})),multiCursorLimit:Fe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(257,null)})),occurrencesHighlight:Fe(new d(77,"occurrencesHighlight",!0,{description:i.localize(258,null)})),overviewRulerBorder:Fe(new d(78,"overviewRulerBorder",!0,{description:i.localize(259,null)})),overviewRulerLanes:Fe(new E(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(260,null),i.localize(261,null)],description:i.localize(262,null)})),definitionLinkOpensInPeek:Fe(new d(83,"definitionLinkOpensInPeek",!1,{description:i.localize(263,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(264,null)})),readOnly:Fe(new d(86,"readOnly",!1)),renameOnType:Fe(new d(87,"renameOnType",!1,{description:i.localize(265,null),markdownDeprecationMessage:i.localize(266,null)})),renderControlCharacters:Fe(new d(88,"renderControlCharacters",!0,{description:i.localize(267,null),restricted:!0})),renderFinalNewline:Fe(new s(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(268,null)})),renderLineHighlight:Fe(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(269,null)],description:i.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Fe(new d(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(271,null)})),renderValidationDecorations:Fe(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(272,null),i.localize(273,null),i.localize(274,null),""],description:i.localize(275,null)})),revealHorizontalRightPadding:Fe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new d(95,"roundedSelection",!0,{description:i.localize(276,null)})),rulers:Fe(new J),scrollbar:Fe(new B),scrollBeyondLastColumn:Fe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(277,null)})),scrollBeyondLastLine:Fe(new d(99,"scrollBeyondLastLine",!0,{description:i.localize(278,null)})),scrollPredominantAxis:Fe(new d(100,"scrollPredominantAxis",!0,{description:i.localize(279,null)})),selectionClipboard:Fe(new d(101,"selectionClipboard",!0,{description:i.localize(280,null),included:C.isLinux})),selectionHighlight:Fe(new d(102,"selectionHighlight",!0,{description:i.localize(281,null)})),selectOnLineNumbers:Fe(new d(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(282,null),i.localize(283,null),i.localize(284,null)],description:i.localize(285,null)})),showUnused:Fe(new d(105,"showUnused",!0,{description:i.localize(286,null)})),showDeprecated:Fe(new d(133,"showDeprecated",!0,{description:i.localize(287,null)})),inlayHints:Fe(new G),snippetSuggestions:Fe(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null),i.localize(291,null)],description:i.localize(292,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new d(108,"smoothScrolling",!1,{description:i.localize(293,null)})),stopRenderingLineAfter:Fe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new K),suggestFontSize:Fe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new d(115,"suggestOnTriggerCharacters",!0,{description:i.localize(296,null)})),suggestSelection:Fe(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(297,null),i.localize(298,null),i.localize(299,null)],description:i.localize(300,null)})),tabCompletion:Fe(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null)],description:i.localize(304,null)})),tabIndex:Fe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(305,null),i.localize(306,null),i.localize(307,null)],description:i.localize(308,null)})),useShadowDOM:Fe(new d(121,"useShadowDOM",!0)),useTabStops:Fe(new d(122,"useTabStops",!0,{description:i.localize(309,null)})),wordBreak:Fe(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null)],description:i.localize(312,null)})),wordSeparators:Fe(new v(124,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:i.localize(313,null)})),wordWrap:Fe(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(314,null),i.localize(315,null),i.localize(316,null),i.localize(317,null)],description:i.localize(318,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(319,null)})),wordWrapOverride1:Fe(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new q),pixelRatio:Fe(new Te),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new pe),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(Ie[130],Ce([14,15]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[131],Ce([14,15]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[132],Ce([14,15]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[133],Ce([14,15]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ie[134],Ce([14,15]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ie[135],Ce([14,15]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[136],Ce([14,15]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ie[137],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[138],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[139],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[140],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[141],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[142],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[143],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[144],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ie[145],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ie[146],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[147],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[148],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[149],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[150],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[151],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[152],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[153],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map}register(L,I){this.a.set(L,I)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const I in L.contributes){const R=this.a.get(I);if(!R)continue;const y=L.contributes[I],k=Array.isArray(y)?y:[y];try{R(k,L.activationEvents)}catch(O){(0,i.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ie[154],Ce([1,0,23,30,132,254]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function y(d){return d=d.trim(),d==="*"||I.test(d)}e.isValidVersionStr=y;function k(d){if(!y(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=d.match(I);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=k;function O(d){if(!d)return null;const b=d.majorBase,E=d.majorMustEqual,P=d.minorBase;let v=d.minorMustEqual;const t=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(b===0||(v=!1),s=!1);let o=0;if(d.preRelease){const l=R.exec(d.preRelease);if(l){const[,a,h,c]=l;o=Date.UTC(Number(a),Number(h)-1,Number(c))}}return{majorBase:b,majorMustEqual:E,minorBase:P,minorMustEqual:v,patchBase:t,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:o}}e.normalizeVersion=O;function w(d,b,E){let P;typeof d=="string"?P=O(k(d)):P=d;let v;b instanceof Date?v=b.getTime():typeof b=="string"&&(v=new Date(b).getTime());let t;if(typeof E=="string"?t=O(k(E)):t=E,!P||!t)return!1;const s=P.majorBase,o=P.minorBase,l=P.patchBase;let a=t.majorBase,h=t.minorBase,c=t.patchBase;const u=t.notBefore;let g=t.majorMustEqual,A=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?s>a?!0:s<a?!1:o>h?!0:o<h||v&&v<u?!1:l>=c:(s===1&&a===0&&(!g||!A||!N)&&(a=1,h=0,c=0,g=!0,A=!1,N=!1),s<a?!1:s>a?!g:o<h?!1:o>h?!A:l<c?!1:l>c?!N:!(v&&v<u))}e.isValidVersion=w;function m(d,b,E,P,v){const t=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return t.push([C.default.Error,S.localize(0,null)]),t;if(typeof P.name!="string")return t.push([C.default.Error,S.localize(1,null,"name")]),t;if(typeof P.version!="string")return t.push([C.default.Error,S.localize(2,null,"version")]),t;if(!P.engines)return t.push([C.default.Error,S.localize(3,null,"engines")]),t;if(typeof P.engines.vscode!="string")return t.push([C.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof P.extensionDependencies<"u"&&!r(P.extensionDependencies))return t.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof P.activationEvents<"u"){if(!r(P.activationEvents))return t.push([C.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof P.main>"u"&&typeof P.browser>"u")return t.push([C.default.Error,S.localize(7,null,"activationEvents","main")]),t}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&t.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return t.push([C.default.Error,S.localize(9,null,"main")]),t;{const l=(0,i.joinPath)(E,P.main);(0,i.isEqualOrParent)(l,E)||t.push([C.default.Warning,S.localize(10,null,l.path,E.path)])}if(typeof P.activationEvents>"u")return t.push([C.default.Error,S.localize(11,null,"activationEvents","main")]),t}if(typeof P.browser<"u"){if(typeof P.browser!="string")return t.push([C.default.Error,S.localize(12,null,"browser")]),t;{const l=(0,i.joinPath)(E,P.browser);(0,i.isEqualOrParent)(l,E)||t.push([C.default.Warning,S.localize(13,null,l.path,E.path)])}if(typeof P.activationEvents>"u")return t.push([C.default.Error,S.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(P.version))return t.push([C.default.Error,S.localize(15,null)]),t;const s=[];if(!p(d,b,P,v,s))for(const l of s)t.push([C.default.Error,l]);return t}e.validateExtensionManifest=m;function p(d,b,E,P,v){return P||typeof E.main>"u"&&typeof E.browser>"u"?!0:n(d,b,E.engines.vscode,v)}e.isValidExtensionVersion=p;function f(d,b,E){return d==="*"||n(b,E,d)}e.isEngineValid=f;function n(d,b,E,P=[]){const v=O(k(E));if(!v)return P.push(S.localize(16,null,E)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return P.push(S.localize(17,null,E)),!1}else if(!v.majorMustEqual)return P.push(S.localize(18,null,E)),!1;return w(d,b,v)?!0:(P.push(S.localize(19,null,d,E)),!1)}function r(d){if(!Array.isArray(d))return!1;for(let b=0,E=d.length;b<E;b++)if(typeof d[b]!="string")return!1;return!0}}),define(Ie[88],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(S,L=[],I=!1){this.ctor=S,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=i}),define(Ie[66],Ce([1,0,88]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var S;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function L(R,y,k){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(k))),C.push([R,y])}e.registerSingleton=L;function I(){return C}e.getSingletonServiceDescriptors=I}),define(Ie[155],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,I){this.key=L,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class C{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const I of this.a.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const R=this.lookupOrInsertNode(L),y=this.lookupOrInsertNode(I);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(L){const I=this.b(L);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(L){const I=this.b(L);let R=this.a.get(I);return R||(R=new i(I,L),this.a.set(I,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[I,R]of this.a)L.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,I]of this.a){const R=new Set([L]),y=this.c(I,R);if(y)return y}}c(L,I){for(const[R,y]of L.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const k=this.c(y,I);if(k)return k;I.delete(R)}}}e.Graph=C}),define(Ie[3],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(i=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function C(I,R,y){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:I,index:y}):(R[i.DI_DEPENDENCIES]=[{id:I,index:y}],R[i.DI_TARGET]=R)}function S(I){if(i.serviceIds.has(I))return i.serviceIds.get(I);const R=function(y,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(R,y,O)};return R.toString=()=>I,i.serviceIds.set(I,R),R}e.createDecorator=S;function L(I){return I}e.refineServiceDecorator=L}),define(Ie[41],Ce([1,0,9,2,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationOverrides=L;function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=I;var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(d,b){const E=Object.create(null);for(const P in d)O(E,P,d[P],b);return E}e.toValuesTree=k;function O(d,b,E,P){const v=b.split("."),t=v.pop();let s=d;for(let o=0;o<v.length;o++){const l=v[o];let a=s[l];switch(typeof a){case"undefined":a=s[l]=Object.create(null);break;case"object":break;default:P(`Ignoring ${b} as ${v.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}s=a}if(typeof s=="object"&&s!==null)try{s[t]=E}catch{P(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(s)}`)}else P(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=O;function w(d,b){const E=b.split(".");m(d,E)}e.removeFromValueTree=w;function m(d,b){const E=b.shift();if(b.length===0){delete d[E];return}if(Object.keys(d).indexOf(E)!==-1){const P=d[E];typeof P=="object"&&!Array.isArray(P)&&(m(P,b),Object.keys(P).length===0&&delete d[E])}}function p(d,b,E){function P(s,o){let l=s;for(const a of o){if(typeof l!="object"||l===null)return;l=l[a]}return l}const v=b.split("."),t=P(d,v);return typeof t>"u"?E:t}e.getConfigurationValue=p;function f(d,b,E){Object.keys(b).forEach(P=>{P!=="__proto__"&&(P in d?i.isObject(d[P])&&i.isObject(b[P])?f(d[P],b[P],E):E&&(d[P]=b[P]):d[P]=b[P])})}e.merge=f;function n(d,b,E){const P=d.inspect(b),v=d.inspect(E);return typeof P.userValue<"u"||typeof P.workspaceValue<"u"||typeof P.workspaceFolderValue<"u"?P.value:typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:P.defaultValue}e.getMigratedSettingValue=n;function r(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=r}),define(Ie[42],Ce([1,0,20,10,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const I=Object.prototype.hasOwnProperty;var R;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(F){return p.create(F)}static equals(F,$){return f.create(F,$)}static notEquals(F,$){return d.create(F,$)}static regex(F,$){return o.create(F,$)}static in(F,$){return n.create(F,$)}static notIn(F,$){return r.create(F,$)}static not(F){return b.create(F)}static and(...F){return h.create(F,null,!0)}static or(...F){return c.create(F,null,!0)}static greater(F,$){return P.create(F,$)}static greaterEquals(F,$){return v.create(F,$)}static smaller(F,$){return t.create(F,$)}static smallerEquals(F,$){return s.create(F,$)}static deserialize(F,$=!1){if(!!F)return this.c(F,$)}static c(F,$){const T=F.split("||");return c.create(T.map(M=>this.d(M,$)),null,!0)}static d(F,$){const T=F.split("&&");return h.create(T.map(M=>this.f(M,$)),null,!0)}static f(F,$){if(F=F.trim(),F.indexOf("!=")>=0){const T=F.split("!=");return d.create(T[0].trim(),this.g(T[1],$))}if(F.indexOf("==")>=0){const T=F.split("==");return f.create(T[0].trim(),this.g(T[1],$))}if(F.indexOf("=~")>=0){const T=F.split("=~");return o.create(T[0].trim(),this.h(T[1],$))}if(F.indexOf(" not in ")>=0){const T=F.split(" not in ");return r.create(T[0].trim(),this.g(T[1],$))}if(F.indexOf(" in ")>=0){const T=F.split(" in ");return n.create(T[0].trim(),this.g(T[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const T=F.split(">=");return v.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const T=F.split(">");return P.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const T=F.split("<=");return s.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const T=F.split("<");return t.create(T[0].trim(),T[1].trim())}return/^\!\s*/.test(F)?b.create(F.substr(1).trim()):p.create(F)}static g(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const T=/^'([^']*)'$/.exec(F);return T?T[1].trim():F}static h(F,$){if((0,C.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const T=F.indexOf("/"),M=F.lastIndexOf("/");if(T===M||T<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const V=F.slice(T+1,M),j=F[M+1]==="i"?"i":"";try{return new RegExp(V,j)}catch(le){if($)throw new Error(`bad regexp-value '${F}', parse error: ${le}`);return console.warn(`bad regexp-value '${F}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function k(x,F){const $=x?x.substituteConstants():void 0,T=F?F.substituteConstants():void 0;return!$&&!T?!0:!$||!T?!1:$.equals(T)}e.expressionsAreEqualWithConstantSubstitution=k;function O(x,F){return x.cmp(F)}class w{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class p{static create(F,$=null){const T=L.get(F);return typeof T=="boolean"?T?m.INSTANCE:w.INSTANCE:new p(F,$)}constructor(F,$){this.key=F,this.c=$,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:g(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=L.get(this.key);return typeof F=="boolean"?F?m.INSTANCE:w.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class f{static create(F,$,T=null){if(typeof $=="boolean")return $?p.create(F,T):b.create(F,T);const M=L.get(F);return typeof M=="boolean"?$===(M?"true":"false")?m.INSTANCE:w.INSTANCE:new f(F,$,T)}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:A(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=L.get(this.c);if(typeof F=="boolean"){const $=F?"true":"false";return this.d===$?m.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class n{static create(F,$){return new n(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:A(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.f),T=F.getValue(this.d);return Array.isArray($)?$.includes(T):typeof T=="string"&&typeof $=="object"&&$!==null?I.call($,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=r.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=n;class r{static create(F,$){return new r(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=11,this.c=n.create(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=r;class d{static create(F,$,T=null){if(typeof $=="boolean")return $?b.create(F,T):p.create(F,T);const M=L.get(F);return typeof M=="boolean"?$===(M?"true":"false")?w.INSTANCE:m.INSTANCE:new d(F,$,T)}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:A(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=L.get(this.c);if(typeof F=="boolean"){const $=F?"true":"false";return this.d===$?w.INSTANCE:m.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=d;class b{static create(F,$=null){const T=L.get(F);return typeof T=="boolean"?T?w.INSTANCE:m.INSTANCE:new b(F,$)}constructor(F,$){this.c=F,this.d=$,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:g(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=L.get(this.c);return typeof F=="boolean"?F?w.INSTANCE:m.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function E(x,F){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?F(x):w.INSTANCE}class P{static create(F,$,T=null){return E($,M=>new P(F,M,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:A(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=P;class v{static create(F,$,T=null){return E($,M=>new v(F,M,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:A(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=v;class t{static create(F,$,T=null){return E($,M=>new t(F,M,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:A(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class s{static create(F,$,T=null){return E($,M=>new s(F,M,T))}constructor(F,$,T){this.c=F,this.d=$,this.f=T,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:A(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class o{static create(F,$){return new o(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const $=this.f?this.f.source:"",T=F.f?F.f.source:"";return $<T?-1:$>T?1:0}equals(F){if(F.type===this.type){const $=this.f?this.f.source:"",T=F.f?F.f.source:"";return this.d===F.d&&$===T}return!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=l.create(this)),this.c}}e.ContextKeyRegexExpr=o;class l{static create(F){return new l(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new l(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=l;function a(x){let F=null;for(let $=0,T=x.length;$<T;$++){const M=x[$].substituteConstants();if(x[$]!==M&&F===null){F=[];for(let V=0;V<$;V++)F[V]=x[V]}F!==null&&(F[$]=M)}return F===null?x:F}class h{static create(F,$,T){return h.d(F,$,T)}constructor(F,$){this.expr=F,this.c=$,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const M=O(this.expr[$],F.expr[$]);if(M!==0)return M}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:h.create(F,this.c,!1)}evaluate(F){for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static d(F,$,T){const M=[];let V=!1;for(const j of F)if(!!j){if(j.type===1){V=!0;continue}if(j.type===0)return w.INSTANCE;if(j.type===6){M.push(...j.expr);continue}M.push(j)}if(M.length===0&&V)return m.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(O);for(let j=1;j<M.length;j++)M[j-1].equals(M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0];for(;M.length>1;){const j=M[M.length-1];if(j.type!==9)break;M.pop();const le=M.pop(),Y=M.length===0,pe=c.create(j.expr.map(ue=>h.create([ue,le],null,T)),null,Y);pe&&(M.push(pe),M.sort(O))}if(M.length===1)return M[0];if(T){for(let j=0;j<M.length;j++)for(let le=j+1;le<M.length;le++)if(M[j].negate().equals(M[le]))return w.INSTANCE;if(M.length===1)return M[0]}return new h(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const $ of this.expr)F.push(...$.keys());return F}map(F){return new h(this.expr.map($=>$.map(F)),null)}negate(){if(!this.c){const F=[];for(const $ of this.expr)F.push($.negate());this.c=c.create(F,this,!0)}return this.c}}class c{static create(F,$,T){return c.d(F,$,T)}constructor(F,$){this.expr=F,this.c=$,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const M=O(this.expr[$],F.expr[$]);if(M!==0)return M}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:c.create(F,this.c,!1)}evaluate(F){for(let $=0,T=this.expr.length;$<T;$++)if(this.expr[$].evaluate(F))return!0;return!1}static d(F,$,T){let M=[],V=!1;if(F){for(let j=0,le=F.length;j<le;j++){const Y=F[j];if(!!Y){if(Y.type===0){V=!0;continue}if(Y.type===1)return m.INSTANCE;if(Y.type===9){M=M.concat(Y.expr);continue}M.push(Y)}}if(M.length===0&&V)return w.INSTANCE;M.sort(O)}if(M.length!==0){if(M.length===1)return M[0];for(let j=1;j<M.length;j++)M[j-1].equals(M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0];if(T){for(let j=0;j<M.length;j++)for(let le=j+1;le<M.length;le++)if(M[j].negate().equals(M[le]))return m.INSTANCE;if(M.length===1)return M[0]}return new c(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const $ of this.expr)F.push(...$.keys());return F}map(F){return new c(this.expr.map($=>$.map(F)),null)}negate(){if(!this.c){const F=[];for(const $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),T=F.shift(),M=[];for(const V of te($))for(const j of te(T))M.push(h.create([V,j],null,!1));F.unshift(c.create(M,null,!1))}this.c=c.create(F,this,!0)}return this.c}}class u extends p{static all(){return u.d.values()}constructor(F,$,T){super(F,null),this.f=$,typeof T=="object"?u.d.push({...T,key:F}):T!==!0&&u.d.push({key:F,description:T,type:$!=null?typeof $:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return f.create(this.key,F)}notEqualsTo(F){return d.create(this.key,F)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService");function g(x,F){return x<F?-1:x>F?1:0}function A(x,F,$,T){return x<$?-1:x>$?1:F<T?-1:F>T?1:0}function N(x,F){if(x.type===0||F.type===1)return!0;if(x.type===9)return F.type===9?q(x.expr,F.expr):!1;if(F.type===9){for(const $ of F.expr)if(N(x,$))return!0;return!1}if(x.type===6){if(F.type===6)return q(F.expr,x.expr);for(const $ of x.expr)if(N($,F))return!0;return!1}return x.equals(F)}e.implies=N;function q(x,F){let $=0,T=0;for(;$<x.length&&T<F.length;){const M=x[$].cmp(F[T]);if(M<0)return!1;M===0&&$++,T++}return $===x.length}function te(x){return x.type===9?x.expr:[x]}}),define(Ie[156],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[89],Ce([1,0,131,3]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function I(d,b){switch(d){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function R(d,b){return b==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function y(d,b,E){return R(b,E)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===E?!0:k(E).includes(d)}e.isTargetPlatformCompatible=y;function k(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var p;(function(d){d.Install="install",d.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var n;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(n=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class r extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,133,3,20]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function O(Y){return Y.create===!0}e.isFileOpenForWriteOptions=O;var w;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var m;(function(Y){Y[Y.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var p;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=f;function n(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=n;function r(Y){return!!(Y.capabilities&32768)}e.hasFileCloneCapability=r;function d(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function b(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=b;function E(Y){return f(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var P;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.FileSystemProviderError=v;function t(Y,pe){const ue=new v(Y.toString(),pe);return o(ue,pe),ue}e.createFileSystemProviderError=t;function s(Y){return Y||t((0,R.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=s;function o(Y,pe){return Y.name=pe?`${pe} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=o;function l(Y){if(!Y)return P.Unknown;if(Y instanceof v)return Y.code;const pe=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!pe)return P.Unknown;switch(pe[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=l;function a(Y){if(Y instanceof N)return Y.fileOperationResult;switch(l(Y)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var h;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(h=e.FileOperation||(e.FileOperation={}));class c{constructor(pe,ue,de){this.resource=pe,this.operation=ue,this.target=de}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=c;var u;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class g{constructor(pe,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const re of pe){const G=de.get(re.type);switch(G?G.push([re.resource,re]):de.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,G]of de)switch(re){case 1:this.a=i.TernarySearchTree.forUris(()=>ue),this.a.fill(G);break;case 0:this.b=i.TernarySearchTree.forUris(()=>ue),this.b.fill(G);break;case 2:this.c=i.TernarySearchTree.forUris(()=>ue),this.c.fill(G);break}}contains(pe,...ue){return this.d(pe,{includeChildren:!1},...ue)}affects(pe,...ue){return this.d(pe,{includeChildren:!0},...ue)}d(pe,ue,...de){if(!pe)return!1;const re=de.length>0;return!!((!re||de.includes(1))&&(this.a?.get(pe)||ue.includeChildren&&this.a?.findSuperstr(pe))||(!re||de.includes(0))&&(this.b?.get(pe)||ue.includeChildren&&this.b?.findSuperstr(pe))||(!re||de.includes(2))&&(this.c?.findSubstr(pe)||ue.includeChildren&&this.c?.findSuperstr(pe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function A(Y,pe,ue){return!Y||!pe||Y===pe||pe.length>Y.length?!1:(pe.charAt(pe.length-1)!==C.sep&&(pe+=C.sep),ue?(0,S.startsWithIgnoreCase)(Y,pe):Y.indexOf(pe)===0)}e.isParent=A;class N extends Error{constructor(pe,ue,de){super(pe),this.fileOperationResult=ue,this.options=de}}e.FileOperationError=N;class q extends N{constructor(pe,ue,de,re){super(pe,ue,re),this.fileOperationResult=ue,this.size=de}}e.TooLargeFileOperationError=q;class te extends N{constructor(pe,ue,de){super(pe,2,de),this.stat=ue}}e.NotModifiedSinceFileOperationError=te;var x;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",Y[Y.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=$;async function T(Y,pe){if(!pe.hasProvider(I.URI.from({scheme:Y.scheme})))return new Promise(ue=>{const de=pe.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===Y.scheme&&re.added&&(de.dispose(),ue())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(pe){return(0,L.isNumber)(pe)||(pe=0),pe<M.KB?(0,R.localize)(1,null,pe.toFixed(0)):pe<M.MB?(0,R.localize)(2,null,(pe/M.KB).toFixed(2)):pe<M.GB?(0,R.localize)(3,null,(pe/M.MB).toFixed(2)):pe<M.TB?(0,R.localize)(4,null,(pe/M.GB).toFixed(2)):(0,R.localize)(5,null,(pe/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var V;(function(Y){Y[Y.IA32=0]="IA32",Y[Y.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function j(Y){return{maxFileSize:Y===0?300*M.MB:16*M.GB,maxHeapSize:Y===0?700*M.MB:2*700*M.MB}}e.getPlatformFileLimits=j;function le(Y){return k.isWeb?Y?10*M.MB:50*M.MB:Y?100*M.MB:1024*M.MB}e.getLargeFileConfirmationLimit=le}),define(Ie[67],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...S){this.a=new Map;for(const[L,I]of S)this.set(L,I)}set(S,L){const I=this.a.get(S);return this.a.set(S,L),I}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.ServiceCollection=i}),define(Ie[157],Ce([1,0,12,11,6,88,155,3,67,158]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class w extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class m{constructor(r=new y.ServiceCollection,d=!1,b,E=O){this.f=r,this.g=d,this.h=b,this.i=E,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=E?b?._globalGraph??new I.Graph(P=>P):void 0}createChild(r){return new m(r,this.g,this,this.i)}invokeFunction(r,...d){const b=f.traceInvocation(this.i,r);let E=!1;try{return r({get:v=>{if(E)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(v,b);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...d)}finally{E=!0,b.stop()}}createInstance(r,...d){let b,E;return r instanceof L.SyncDescriptor?(b=f.traceCreation(this.i,r.ctor),E=this.j(r.ctor,r.staticArguments.concat(d),b)):(b=f.traceCreation(this.i,r),E=this.j(r,d,b)),b.stop(),E}j(r,d=[],b){const E=R._util.getServiceDependencies(r).sort((t,s)=>t.index-s.index),P=[];for(const t of E){const s=this.m(t.id,b);s||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),P.push(s)}const v=E.length>0?E[0].index:d.length;if(d.length!==v){console.trace(`[createInstance] First service dependency of ${r.name} at position ${v+1} conflicts with ${d.length} static arguments`);const t=v-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,v)}return Reflect.construct(r,d.concat(P))}k(r,d){if(this.f.get(r)instanceof L.SyncDescriptor)this.f.set(r,d);else if(this.h)this.h.k(r,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const d=this.f.get(r);return!d&&this.h?this.h.l(r):d}m(r,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const b=this.l(r);return b instanceof L.SyncDescriptor?this.q(r,b,d.branch(r,!0)):(d.branch(r,!1),b)}q(r,d,b){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,d,b)}finally{this.o.delete(r)}}r(r,d,b){const E=new I.Graph(t=>t.id.toString());let P=0;const v=[{id:r,desc:d,_trace:b}];for(;v.length;){const t=v.pop();if(E.lookupOrInsertNode(t),P++>1e3)throw new w(E);for(const s of R._util.getServiceDependencies(t.desc.ctor)){const o=this.l(s.id);if(o||this.u(`[createInstance] ${r} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),o instanceof L.SyncDescriptor){const l={id:s.id,desc:o,_trace:t._trace.branch(s.id,!0)};E.insertEdge(t,l),v.push(l)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:s}of t){if(this.l(s.id)instanceof L.SyncDescriptor){const l=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,l)}E.removeNode(s)}}return this.l(r)}s(r,d,b=[],E,P){if(this.f.get(r)instanceof L.SyncDescriptor)return this.t(r,d,b,E,P);if(this.h)return this.h.s(r,d,b,E,P);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(r,d,b=[],E,P){if(E){const v=new m(void 0,this.g,this,this.i);v.c=String(r);const t=new Map,s=new i.IdleValue(()=>{const o=v.j(d,b,P);for(const[l,a]of t){const h=o[l];if(typeof h=="function")for(const c of a)h.apply(o,c)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,l){if(!s.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let c=t.get(l);return c||(c=new k.LinkedList,t.set(l,c)),(g,A,N)=>{const q=c.push([g,A,N]);return(0,S.toDisposable)(q)}}if(l in o)return o[l];const a=s.value;let h=a[l];return typeof h!="function"||(h=h.bind(a),o[l]=h),h},set(o,l,a){return s.value[l]=a,!0},getPrototypeOf(o){return d.prototype}})}else return this.j(d,b,P)}u(r,d){if(d&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=m;var p;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(p||(p={}));class f{static traceInvocation(r,d){return r?new f(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(r,d){return r?new f(1,d.name):f.c}constructor(r,d){this.type=r,this.name=d,this.g=Date.now(),this.h=[]}branch(r,d){const b=new f(3,r.toString());return this.h.push([r,d,b]),b}stop(){const r=Date.now()-this.g;f.f+=r;let d=!1;function b(P,v){const t=[],s=new Array(P+1).join("	");for(const[o,l,a]of v.h)if(l&&a){d=!0,t.push(`${s}CREATES -> ${o}`);const h=b(P+1,a);h&&t.push(h)}else t.push(`${s}uses -> ${o}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(r>2||d)&&f.all.add(E.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ie[13],Ce([1,0,39,4,6,28,20,2,3]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function w(h,c,u){switch(c){case O.Trace:h.trace(u);break;case O.Debug:h.debug(u);break;case O.Info:h.info(u);break;case O.Warning:h.warn(u);break;case O.Error:h.error(u);break;case O.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=w;function m(h){let c="";for(let u=0;u<h.length;u++){let g=h[u];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}c+=(u>0?" ":"")+g}return c}e.format=m;class p extends S.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new C.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==O.Off&&this.b<=c}}e.AbstractLogger=p;class f extends p{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...u){this.f(O.Trace)&&this.g(O.Trace,m([c,...u]))}debug(c,...u){this.f(O.Debug)&&this.g(O.Debug,m([c,...u]))}info(c,...u){this.f(O.Info)&&this.g(O.Info,m([c,...u]))}warn(c,...u){this.f(O.Warning)&&this.g(O.Warning,m([c,...u]))}error(c,...u){if(this.f(O.Error))if(c instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=c.stack,this.g(O.Error,m(g))}else this.g(O.Error,m([c,...u]))}flush(){}}e.AbstractMessageLogger=f;class n extends p{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!I.isWindows}trace(c,...u){this.f(O.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,c,...u):console.log(`[main ${k()}]`,c,...u))}debug(c,...u){this.f(O.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,c,...u):console.log(`[main ${k()}]`,c,...u))}info(c,...u){this.f(O.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,c,...u):console.log(`[main ${k()}]`,c,...u))}warn(c,...u){this.f(O.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,c,...u):console.warn(`[main ${k()}]`,c,...u))}error(c,...u){this.f(O.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,c,...u):console.error(`[main ${k()}]`,c,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=n;class r extends p{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...u){this.f(O.Trace)&&console.log("%cTRACE","color: #888",c,...u)}debug(c,...u){this.f(O.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...u)}info(c,...u){this.f(O.Info)&&console.log("%c INFO","color: #33f",c,...u)}warn(c,...u){this.f(O.Warning)&&console.log("%c WARN","color: #993",c,...u)}error(c,...u){this.f(O.Error)&&console.log("%c  ERR","color: #f33",c,...u)}dispose(){}flush(){}}e.ConsoleLogger=r;class d extends p{constructor(c,u=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(u)}trace(c,...u){this.f(O.Trace)&&this.g.log(O.Trace,[this.h(c),...u])}debug(c,...u){this.f(O.Debug)&&this.g.log(O.Debug,[this.h(c),...u])}info(c,...u){this.f(O.Info)&&this.g.log(O.Info,[this.h(c),...u])}warn(c,...u){this.f(O.Warning)&&this.g.log(O.Warning,[this.h(c),...u])}error(c,...u){this.f(O.Error)&&this.g.log(O.Error,[this.h(c),...u])}h(c){return typeof c=="string"?c:(0,i.toErrorMessage)(c,this.f(O.Trace))}dispose(){}flush(){}}e.AdapterLogger=d;class b extends p{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const u of this.g)u.setLevel(c);super.setLevel(c)}trace(c,...u){for(const g of this.g)g.trace(c,...u)}debug(c,...u){for(const g of this.g)g.debug(c,...u)}info(c,...u){for(const g of this.g)g.info(c,...u)}warn(c,...u){for(const g of this.g)g.warn(c,...u)}error(c,...u){for(const g of this.g)g.error(c,...u)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogService=b;class E extends S.Disposable{constructor(c){super(),this.b=c,this.B(c)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(c){this.b.setLevel(c)}getLevel(){return this.b.getLevel()}trace(c,...u){this.b.trace(c,...u)}debug(c,...u){this.b.debug(c,...u)}info(c,...u){this.b.info(c,...u)}warn(c,...u){this.b.warn(c,...u)}error(c,...u){this.b.error(c,...u)}flush(){this.b.flush()}}e.LogService=E;class P extends S.Disposable{constructor(c,u){super(),this.c=c,this.b=new L.ResourceMap,this.B(u(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:c})=>c)}getLogger(c){return this.b.get(c)?.logger}createLogger(c,u,g){let A=this.b.get(c)?.logger;return A||(g=u?.always?O.Trace:g,A=this.f(c,g??this.c,u),this.b.set(c,{logger:A,logLevel:g})),A}setLevel(c,u){const g=R.URI.isUri(c)?c:void 0,A=g?u:c;if(g){const N=this.b.get(g);N&&N.logLevel!==A&&(N.logLevel=A,N.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:N,logger:q})=>{N===void 0&&q.setLevel(this.c)})}getLogLevel(c){return this.b.get(c)?.logLevel}dispose(){this.b.forEach(({logger:c})=>c.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=P;class v{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(c){}getLevel(){return O.Info}trace(c,...u){}debug(c,...u){}info(c,...u){}warn(c,...u){}error(c,...u){}critical(c,...u){}dispose(){}flush(){}}e.NullLogger=v;class t extends v{}e.NullLogService=t;class s extends P{constructor(){super(O.Info,C.Event.None)}f(c,u,g){return new v}}e.NullLoggerService=s;function o(h){if(h.verbose)return O.Trace;if(typeof h.logLevel=="string"){const c=a(h.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(h){switch(h){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=l;function a(h){switch(h){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=a}),define(Ie[90],Ce([1,0,30,134,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(f,n){return n-f}y.compare=k;const O=Object.create(null);O[y.Error]=(0,C.localize)(0,null),O[y.Warning]=(0,C.localize)(1,null),O[y.Info]=(0,C.localize)(2,null);function w(f){return O[f]||""}y.toString=w;function m(f){switch(f){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=m;function p(f){switch(f){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=p}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const k="";function O(m){return w(m,!0)}y.makeKey=O;function w(m,p){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(I.toString(m.severity)):f.push(k),m.message&&p?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}y.makeKeyOptionalMessage=w})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ie[159],Ce([1,0,4,30,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,S.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(Ie[91],Ce([1,0,10,2,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService");function L(k,O){return C.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,O):(0,i.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=L;function I(k,...O){return O.some(w=>L(k,w))}e.matchesSomeScheme=I;function R(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=R;function y(k){let O;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return w&&(O={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=y}),define(Ie[160],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,C){var S=arguments.length,L=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,i):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,C);else for(var R=ee.length-1;R>=0;R--)(I=ee[R])&&(L=(S<3?I(L):S>3?I(e,i,L):I(e,i))||L);return S>3&&L&&Object.defineProperty(e,i,L),L},Ve=this&&this.__param||function(ee,e){return function(i,C){e(i,C,ee)}};define(Ie[161],Ce([1,0,12,21,6,3]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(w,m){super(),this.a=new i.DeferredPromise,m.withProgress(w,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,S.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};y=qe([Ve(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends S.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new S.DisposableStore)}start(w){this.stop();const m=++this.a,p=new C.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,S.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,S.toDisposable)(()=>p.cancel())),this.b.add((0,S.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:p.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ie[29],Ce([1,0,47,9]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.a=new Map}add(I,R){i.ok(C.isString(I)),i.ok(C.isObject(R)),i.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new S}),define(Ie[68],Ce([1,0,4,29]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,k){this.a[S(y)]=k,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const I=new L;C.Registry.add(e.Extensions.JSONContribution,I)}),define(Ie[92],Ce([1,0,18,4,9,130,41,68,29]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new C.Emitter,this.onDidSchemaChange=this.i.event,this.j=new C.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const o=new Set;this.n(t,s,o),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const s=new Set;this.o(t,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const o=new Set;this.o(s,o),this.n(t,!1,o),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const o=[];for(const{overrides:l,source:a}of t)for(const h in l)if(s.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const c=this.a.get(h),u=c?.valuesSources??new Map;if(a)for(const q of Object.keys(l[h]))u.set(q,a);const g={...c?.value||{},...l[h]};this.a.set(h,{source:a,value:g,valuesSources:u});const A=(0,I.getLanguageTagSettingPlainKey)(h),N={type:"object",default:g,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:S.isString(a)?void 0:a,defaultValueSource:a};o.push(...n(h)),this.d[h]=N,this.b.properties[h]=N}else{this.a.set(h,{value:l[h],source:a});const c=this.d[h];c&&(this.w(h,c),this.r(h,c))}this.m(o)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:o,source:l}of t)for(const a in o){const h=this.a.get(a),c=S.isString(l)?l:l?.id,u=S.isString(h?.source)?h?.source:h?.source?.id;if(c===u)if(s.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const g=this.d[a];g&&(this.w(a,g),this.r(a,g))}}this.u()}deltaConfiguration(t){let s=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,o){t.forEach(l=>{this.p(l,s,l.extensionInfo,l.restrictedProperties,void 0,o),this.c.push(l),this.q(l)})}o(t,s){const o=l=>{if(l.properties)for(const a in l.properties){s.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,l.properties[a])}l.allOf?.forEach(a=>o(a))};for(const l of t){o(l);const a=this.c.indexOf(l);a!==-1&&this.c.splice(a,1)}}p(t,s=!0,o,l,a=3,h){a=S.isUndefinedOrNull(t.scope)?a:t.scope;const c=t.properties;if(c)for(const g in c){const A=c[g];if(s&&E(g,A)){delete c[g];continue}if(A.source=o,A.defaultDefaultValue=c[g].default,this.w(g,A),e.OVERRIDE_PROPERTY_REGEX.test(g)?A.scope=void 0:(A.scope=S.isUndefinedOrNull(A.scope)?a:A.scope,A.restricted=S.isUndefinedOrNull(A.restricted)?!!l?.includes(g):A.restricted),c[g].hasOwnProperty("included")&&!c[g].included){this.f[g]=c[g],delete c[g];continue}else this.d[g]=c[g],c[g].policy?.name&&this.e.set(c[g].policy.name,g);!c[g].deprecationMessage&&c[g].markdownDeprecationMessage&&(c[g].deprecationMessage=c[g].markdownDeprecationMessage),h.add(g)}const u=t.allOf;if(u)for(const g of u)this.p(g,s,o,l,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=o=>{const l=o.properties;if(l)for(const h in l)this.r(h,l[h]);o.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,o={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,o),e.allSettings.properties[s]=o,e.applicationSettings.properties[s]=o,e.machineSettings.properties[s]=o,e.machineOverridableSettings.properties[s]=o,e.windowSettings.properties[s]=o,e.resourceSettings.properties[s]=o}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const o=this.a.get(t);let l=o?.value,a=o?.source;S.isUndefined(l)&&(l=s.defaultDefaultValue,a=void 0),S.isUndefined(l)&&(l=d(s.type)),s.default=l,s.defaultValueSource=a}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function n(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let s=f.exec(v);for(;s?.length;){const o=s[1].trim();o&&t.push(o),s=f.exec(v)}}return(0,i.distinct)(t)}e.overrideIdentifiersFromKey=n;function r(v){return v.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=r;function d(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const b=new m;y.Registry.add(e.Extensions.Configuration,b);function E(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?L.localize(7,null,v):b.getConfigurationProperties()[v]!==void 0?L.localize(8,null,v):t.policy?.name&&b.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,v,t.policy?.name,b.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=E;function P(){const v=[],t=b.getConfigurationProperties();for(const s of Object.keys(t))v.push([s,t[s].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=P}),define(Ie[162],Ce([1,0,18,4,110,6,28,22,9,2,41,92,29]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(s={},o=[],l=[],a){this.c=s,this.d=o,this.f=l,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof p)return o;const l=new f("");return l.parseRaw(o),l.configurationModel});this.g=s.reduce((o,l)=>l===o?l:o.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,O.getConfigurationValue)(this.contents,s):this.contents}inspect(s,o){const l=this.rawConfiguration.getValue(s),a=o?this.rawConfiguration.getOverrideValue(s,o):void 0,h=o?this.rawConfiguration.override(o).getValue(s):l;return{value:l,override:a,merged:h}}getOverrideValue(s,o){const l=this.l(o);return l?s?(0,O.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const l of this.overrides)l.identifiers.includes(s)&&o.push(...l.keys);return i.distinct(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return i.distinct(s)}override(s){let o=this.b.get(s);return o||(o=this.h(s),this.b.set(s,o)),o}merge(...s){const o=R.deepClone(this.contents),l=R.deepClone(this.overrides),a=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const c of s)if(h.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.j(o,c.contents);for(const u of c.overrides){const[g]=l.filter(A=>i.equals(A.identifiers,u.identifiers));g?(this.j(g.contents,u.contents),g.keys.push(...u.keys),g.keys=i.distinct(g.keys)):l.push(R.deepClone(u))}for(const u of c.keys)a.indexOf(u)===-1&&a.push(u)}return new p(o,a,l,h.every(c=>c instanceof p)?void 0:h)}freeze(){return this.a=!0,this}h(s){const o=this.l(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const l={};for(const a of i.distinct([...Object.keys(this.contents),...Object.keys(o)])){let h=this.contents[a];const c=o[a];c&&(typeof h=="object"&&typeof c=="object"?(h=R.deepClone(h),this.j(h,c)):h=c),l[a]=h}return new p(l,this.keys,this.overrides)}j(s,o){for(const l of Object.keys(o)){if(l in s&&y.isObject(s[l])&&y.isObject(o[l])){this.j(s[l],o[l]);continue}s[l]=R.deepClone(o[l])}}k(s){return this.a&&!Object.isFrozen(s)?R.deepFreeze(s):s}l(s){let o=null,l=null;const a=h=>{h&&(l?this.j(l,h):l=R.deepClone(h))};for(const h of this.overrides)i.equals(h.identifiers,[s])?o=h.contents:h.identifiers.includes(s)&&a(h.contents);return a(o),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,o){this.m(s),(0,O.addToValueTree)(this.contents,s,o,l=>{throw new Error(l)})}removeValue(s){this.n(s)&&(0,O.removeFromValueTree)(this.contents,s)}m(s){let o=this.keys.length;for(let l=0;l<o;l++)s.indexOf(this.keys[l])===0&&(o=l);this.keys.splice(o,1,s)}n(s){const o=this.keys.indexOf(s);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=p;class f{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!y.isUndefinedOrNull(s)){const l=this.g(s);this.parseRaw(l,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:l,keys:a,overrides:h,restricted:c,hasExcludedProperties:u}=this.h(s,o);this.b=new p(l,a,h,u?[s]:void 0),this.c=c||[]}g(s){let o={},l=null,a=[];const h=[],c=[];function u(A){Array.isArray(a)?a.push(A):l!==null&&(a[l]=A)}const g={onObjectBegin:()=>{const A={};u(A),h.push(a),a=A,l=null},onObjectProperty:A=>{l=A},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const A=[];u(A),h.push(a),a=A,l=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:u,onError:(A,N,q)=>{c.push({error:A,offset:N,length:q})}};if(s)try{S.visit(s,g),o=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return o}h(s,o){const l=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.j(s,l,!0,o);s=a.raw;const h=(0,O.toValuesTree)(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),c=Object.keys(s),u=this.l(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:h,keys:c,overrides:u,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(s,o,l,a){let h=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:h};const c={},u=[];for(const g in s)if(w.OVERRIDE_PROPERTY_REGEX.test(g)&&l){const A=this.j(s[g],o,!1,a);c[g]=A.raw,h=h||A.hasExcludedProperties,u.push(...A.restricted)}else{const A=o[g],N=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&u.push(g),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&A?.restricted)?c[g]=s[g]:h=!0}return{raw:c,restricted:u,hasExcludedProperties:h}}l(s,o){const l=[];for(const a of Object.keys(s))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const h={};for(const c in s[a])h[c]=s[a][c];l.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(h),contents:(0,O.toValuesTree)(h,o)})}return l}}e.ConfigurationModelParser=f;class n extends L.Disposable{constructor(s,o,l,a){super(),this.f=s,this.g=o,this.h=a,this.c=this.B(new C.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(l.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,h=>h.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&l.isEqual(h.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=n;class r{constructor(s,o,l,a,h,c,u,g,A,N,q,te,x){this.a=s,this.b=o,this.value=l,this.overrideIdentifiers=a,this.c=h,this.d=c,this.f=u,this.g=g,this.h=A,this.j=N,this.k=q,this.l=te,this.m=x}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class d{constructor(s,o,l,a,h=new p,c=new p,u=new I.ResourceMap,g=new p,A=new I.ResourceMap,N=!0){this.c=s,this.d=o,this.f=l,this.g=a,this.h=h,this.j=c,this.l=u,this.m=g,this.n=A,this.p=N,this.a=null,this.b=new I.ResourceMap,this.q=null}getValue(s,o,l){return this.s(s,o,l).getValue(s)}updateValue(s,o,l={}){let a;l.resource?(a=this.n.get(l.resource),a||(a=new p,this.n.set(l.resource,a))):a=this.m,o===void 0?a.removeValue(s):a.setValue(s,o),l.resource||(this.a=null)}inspect(s,o,l){const a=this.s(s,o,l),h=this.w(o.resource,l),c=o.resource?this.n.get(o.resource)||this.m:this.m,u=new Set;for(const g of a.overrides)for(const A of g.identifiers)a.getOverrideValue(s,A)!==void 0&&u.add(A);return new r(s,o,a.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this.j.freeze():void 0,h?h.freeze():void 0,c.inspect(s,o.overrideIdentifier))}keys(s){const o=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.l.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const l=[];if(!o){const{added:a,updated:h,removed:c}=P(this.c,s);o=[...a,...h,...c]}for(const a of o)for(const h of(0,w.overrideIdentifiersFromKey)(a)){const c=this.c.getKeysForOverrideIdentifier(h),u=s.getKeysForOverrideIdentifier(h),g=[...u.filter(A=>c.indexOf(A)===-1),...c.filter(A=>u.indexOf(A)===-1),...c.filter(A=>!R.equals(this.c.override(h).getValue(A),s.override(h).getValue(A)))];l.push([h,g])}return this.updateDefaultConfiguration(s),{keys:o,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:l,removed:a}=P(this.d,s),h=[...o,...l,...a];return h.length&&this.updatePolicyConfiguration(s),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:l,removed:a,overrides:h}=P(this.applicationConfiguration,s),c=[...o,...l,...a];return c.length&&this.updateApplicationConfiguration(s),{keys:c,overrides:h}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:l,removed:a,overrides:h}=P(this.localUserConfiguration,s),c=[...o,...l,...a];return c.length&&this.updateLocalUserConfiguration(s),{keys:c,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:l,removed:a,overrides:h}=P(this.remoteUserConfiguration,s),c=[...o,...l,...a];return c.length&&this.updateRemoteUserConfiguration(s),{keys:c,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:l,removed:a,overrides:h}=P(this.workspaceConfiguration,s),c=[...o,...l,...a];return c.length&&this.updateWorkspaceConfiguration(s),{keys:c,overrides:h}}compareAndUpdateFolderConfiguration(s,o){const l=this.r.get(s),{added:a,updated:h,removed:c,overrides:u}=P(l,o),g=[...a,...h,...c];return(g.length||!l)&&this.updateFolderConfiguration(s,o),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(s){const o=this.r.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:a,removed:h,overrides:c}=P(o,void 0);return{keys:[...l,...a,...h],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,o,l){let a=this.t(o,l);return o.overrideIdentifier&&(a=a.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(a=a.merge(this.d)),a}t({resource:s},o){let l=this.u();if(o&&s){const a=o.getFolder(s);a&&(l=this.v(a.uri)||l);const h=this.n.get(s);h&&(l=l.merge(h))}return l}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let o=this.b.get(s);if(!o){const l=this.u(),a=this.l.get(s);a?(o=l.merge(a),this.p&&(o=o.freeze()),this.b.set(s,o)):o=l}return o}w(s,o){if(o&&s){const l=o.getFolder(s);if(l)return this.l.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,o)=>{const{contents:l,overrides:a,keys:h}=this.l.get(o);return s.push([o,{contents:l,overrides:a,keys:h}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(o=>s.add(o)),this.userConfiguration.freeze().keys.forEach(o=>s.add(o)),this.j.freeze().keys.forEach(o=>s.add(o)),this.l.forEach(o=>o.freeze().keys.forEach(l=>s.add(l))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.l.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}y(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>o.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>o.add(l)),this.j.getKeysForOverrideIdentifier(s).forEach(l=>o.add(l)),this.l.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(a=>o.add(a))),[...o.values()]}static parse(s){const o=this.z(s.defaults),l=this.z(s.policy),a=this.z(s.application),h=this.z(s.user),c=this.z(s.workspace),u=s.folders.reduce((g,A)=>(g.set(k.URI.revive(A[0]),this.z(A[1])),g),new I.ResourceMap);return new d(o,l,a,h,new p,c,u,new p,new I.ResourceMap,!1)}static z(s){return new p(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=d;function b(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const s=new Set,o=new Map;for(const a of t)a.keys.forEach(h=>s.add(h)),a.overrides.forEach(([h,c])=>{const u=(0,I.getOrSet)(o,h,new Set);c.forEach(g=>u.add(g))});const l=[];return o.forEach((a,h)=>l.push([h,[...a.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=b;class E{constructor(s,o,l,a){this.change=s,this.f=o,this.g=l,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const h of s.keys)this.affectedKeys.add(h);for(const[,h]of s.overrides)for(const c of h)this.affectedKeys.add(c);this.d=this.a;for(const h of this.affectedKeys)this.d+=h+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data)),this.j}affectsConfiguration(s,o){const l=this.a+s,a=this.d.indexOf(l);if(a<0)return!1;const h=a+l.length;if(h>=this.d.length)return!1;const c=this.d.charCodeAt(h);if(c!==this.b&&c!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,g=this.g.getValue(s,o,this.h);return!R.equals(u,g)}return!0}}e.ConfigurationChangeEvent=E;function P(t,s){const{added:o,removed:l,updated:a}=v(s?.rawConfiguration,t?.rawConfiguration),h=[],c=t?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const g=u.filter(A=>!c.includes(A));for(const A of g)h.push([A,s.getKeysForOverrideIdentifier(A)])}if(t){const g=c.filter(A=>!u.includes(A));for(const A of g)h.push([A,t.getKeysForOverrideIdentifier(A)])}if(s&&t){for(const g of c)if(u.includes(g)){const A=v({contents:t.getOverrideValue(void 0,g)||{},keys:t.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});h.push([g,[...A.added,...A.removed,...A.updated]])}}return{added:o,removed:l,updated:a,overrides:h}}function v(t,s){const o=t?s?t.keys.filter(h=>s.keys.indexOf(h)===-1):[...t.keys]:[],l=s?t?s.keys.filter(h=>t.keys.indexOf(h)===-1):[...s.keys]:[],a=[];if(t&&s){for(const h of s.keys)if(t.keys.indexOf(h)!==-1){const c=(0,O.getConfigurationValue)(s.contents,h),u=(0,O.getConfigurationValue)(t.contents,h);R.equals(c,u)||a.push(h)}}return{added:o,removed:l,updated:a}}}),define(Ie[93],Ce([1,0,11,3]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var S;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof L&&y._code===S.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof L&&y._code===S.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof L&&y._code===S.NoResolverFound}static isHandled(y){return y instanceof L&&y.isHandled}constructor(y,k=S.Unknown,O){super(y),this._message=y,this._code=k,this._detail=O,this.isHandled=k===S.NotAvailable&&O===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function I(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=I}),define(Ie[48],Ce([1,0,16]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=C;function S(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=S;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function I(k){const{host:O,port:w}=y(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=I;function R(k,O){let{host:w,port:m}=y(k);return typeof m>"u"&&(m=O),{host:w,port:m}}e.parseAuthorityWithOptionalPort=R;function y(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,48]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var y;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(n){this.value=n,this.c=n.toLowerCase()}static equals(n,r){if(typeof n>"u"||n===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof n=="string"||typeof r=="string"){const d=typeof n=="string"?n:n.value,b=typeof r=="string"?r:r.value;return i.equalsIgnoreCase(d,b)}return n.c===r.c}static toKey(n){return typeof n=="string"?n.toLowerCase():n.c}}e.ExtensionIdentifier=k;function O(f){return w(f)}e.isApplicationScopedExtension=O;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function p(f,n){if(n){const r=`onResolveRemoteAuthority:${(0,S.getRemoteName)(n)}`;return f.activationEvents?.indexOf(r)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[163],Ce([1,0,20,49,2,34]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,O,w,m,p,f,n,r,d,b){const E=Object.create(null);E["common.machineId"]=n,E.sessionID=(0,L.generateUuid)()+Date.now(),E.commitHash=p,E.version=f,E["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=m,E["common.product"]=b||"desktop",r&&(E["common.msftInternal"]=r);let P=0;const v=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const t=I(w);t&&(E["common.platformDetail"]=t);try{const s=await k.readFile(S.URI.file(d));E["common.source"]=s.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=R;function y(k){const O=C.env.USERDNSDOMAIN;if(!O)return!1;const w=O.toLowerCase();return k.some(m=>w===m)}e.verifyMicrosoftInternalDomain=y}),define(Ie[164],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var S;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(S=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[50],Ce([1,0,22,9,4,41,48,163,164]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(c){this.value=c}}e.TelemetryTrustedValue=k;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,u){return Promise.resolve(void 0)}publicLog2(c,u){return this.publicLog(c,u)}publicLogError(c,u){return Promise.resolve(void 0)}publicLogError2(c,u){return this.publicLogError(c,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class w{async publicLog(c,u,g){}async publicLogError(c,u,g){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(h,c){return S.Event.debounce(c.onDidChangeConfiguration,(g,A)=>{const N=g?new Set([...g.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:N}},1e3,!0)(g=>{g.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(g.source),configurationKeys:P(g.affectedKeys)})})}e.configurationTelemetry=m;function p(h,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!h.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=p;function f(h,c){return!(c.isBuilt||c.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.isLoggingOnly=f;function n(h){const c=h.getValue(y.TELEMETRY_SETTING_ID),u=h.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(h.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=n;function r(h){const c={},u={},g={};E(h,g);for(let A in g){A=A.length>150?A.substr(A.length-149):A;const N=g[A];typeof N=="number"?u[A]=N:typeof N=="boolean"?u[A]=N?1:0:typeof N=="string"?(N.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${N.length}`),c[A]=N.substring(0,8191)):typeof N<"u"&&N!==null&&(c[A]=N)}return{properties:c,measurements:u}}e.validateTelemetryData=r;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function b(h){if(!h)return"none";const c=(0,I.getRemoteName)(h);return d.has(c)?c:"other"}e.cleanRemoteAuthority=b;function E(h,c,u=0,g){if(!!h)for(const A of Object.getOwnPropertyNames(h)){const N=h[A],q=g?g+A:A;Array.isArray(N)?c[q]=(0,i.safeStringify)(N):N instanceof Date?c[q]=N.toISOString():(0,C.isObject)(N)?u<2?E(N,c,u+1,q+"."):c[q]=(0,i.safeStringify)(N):c[q]=N}}function P(h){if(!h)return[];const c=[];return v(c,"",h),c}function v(h,c,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(g=>v(h,c?`${c}.${g}`:g,u[g])):h.push(c)}function t(h,c){const u=h.msftInternalDomains||[],g=c.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||g}e.isInternalTelemetry=t;function s(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=s;function o(h,c){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let u=h;const g=[];for(const te of c)for(;;){const x=te.exec(h);if(!x)break;g.push([x.index,te.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,N=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let q=0;for(u="";;){const te=N.exec(h);if(!te)break;const x=g.some(([F,$])=>te.index<$&&F<N.lastIndex);!A.test(te[0])&&!x&&(u+=h.substring(q,te.index)+"<REDACTED: user-file-path>",q=N.lastIndex)}return q<h.length&&(u+=h.substr(q)),u}function l(h){if(!h)return h;const c=h.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of u)if(g.regex.test(c))return`<REDACTED: ${g.label}>`;return h}function a(h,c){return(0,i.cloneAndChange)(h,u=>{if(u instanceof k)return u.value;if(typeof u=="string"){let g=u.replaceAll("%20"," ");g=o(g,c);for(const A of c)g=g.replace(A,"");return g=l(g),g}})}e.cleanData=a}),define(Ie[165],Ce([1,0,10,89,26,20,2,11,49,50]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(o,l){return o.uuid&&l.uuid?o.uuid===l.uuid:o.id===l.id?!0:(0,i.compareIgnoreCase)(o.id,l.id)===0}e.areSameExtensions=O;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(l){const a=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new m(l.identifier,a,h)}static parse(l){const a=w.exec(l);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(l,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof m?O(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const l=p.exec(o);return l&&l[1]?[r(l[1]),l[2]]:[r(o),void 0]}e.getIdAndVersion=f;function n(o,l){return`${o}.${l}`}e.getExtensionId=n;function r(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function d(o,l){return r(n(o,l))}e.getGalleryExtensionId=d;function b(o,l){const a=[],h=c=>{for(const u of a)if(u.some(g=>O(l(g),l(c))))return u;return null};for(const c of o){const u=h(c);u?u.push(c):a.push([c])}return a}e.groupByExtension=b;function E(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function P(o){return{id:new k.TelemetryTrustedValue(o.identifier.id),name:new k.TelemetryTrustedValue(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function v(o,l){const a=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const c=h.shift();if(c&&a.every(u=>!O(u.identifier,{id:c}))){const u=o.filter(g=>O(g.identifier,{id:c}));u.length===1&&(a.push(u[0]),h.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=v;async function t(o,l){if(!L.isLinux)return!1;let a;try{a=(await o.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){l.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function s(o,l){const a=await t(o,l),h=(0,C.getTargetPlatform)(a?"alpine":L.platform,y.arch);return l.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=s}),define(Ie[166],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,L,I=5){const R=L(y=>{const k=typeof y=="string"?y:y.data;let O=this.a.get(S);if(O){O.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(S),I);O={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(S),R.dispose()}},this.a.set(S,O)});return R}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const L=this.a.get(S);L&&(this.a.delete(S),this.b(S,L.data.join("")))}}e.TerminalDataBufferer=i}),define(Ie[167],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function C(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function S(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ie[51],Ce([1,0,65,4,6,3,29,167]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var y;(function(r){function d(b){return b&&typeof b=="object"&&typeof b.id=="string"}r.isThemeColor=d})(y=e.ThemeColor||(e.ThemeColor={}));function k(r){return{id:r}}e.themeColorFromId=k;var O;(function(r){function d(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||y.isThemeColor(l.color))}r.isThemeIcon=d;const b=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function E(l){const a=b.exec(l);if(!a)return;const[,h]=a;return{id:h}}r.fromString=E;function P(l){return{id:l}}r.fromId=P;function v(l,a){let h=l.id;const c=h.lastIndexOf("~");return c!==-1&&(h=h.substring(0,c)),a&&(h=`${h}~${a}`),{id:h}}r.modify=v;function t(l){const a=l.id.lastIndexOf("~");if(a!==-1)return l.id.substring(a+1)}r.getModifier=t;function s(l,a){return l.id===a.id&&l.color?.id===a.color?.id}r.isEqual=s;function o(l,a){return{id:l.id,color:a?k(a):void 0}}r.asThemeIcon=o,r.asClassNameArray=i.CSSIcon.asClassNameArray,r.asClassName=i.CSSIcon.asClassName,r.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function w(r){switch(r){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new C.Emitter}onColorThemeChange(d){return this.a.push(d),this.b.fire(d),(0,S.toDisposable)(()=>{const b=this.a.indexOf(d);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new m;I.Registry.add(e.Extensions.ThemingContribution,p);function f(r){return p.onColorThemeChange(r)}e.registerThemingParticipant=f;class n extends S.Disposable{constructor(d){super(),this.k=d,this.h=d.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(d){this.h=d,this.updateStyles()}updateStyles(){}w(d,b){let E=this.h.getColor(d);return E&&b&&(E=b(E,this.h)),E?E.toString():null}}e.Themable=n}),define(Ie[168],Ce([1,0,12,65,4,9,2,135,68,29,51]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(P){function v(t,s){let o=t.defaults;for(;O.ThemeIcon.isThemeIcon(o);){const l=f.getIcon(o.id);if(!l)return;o=l.defaults}return o}P.getDefinition=v})(w=e.IconContribution||(e.IconContribution={}));var m;(function(P){function v(s){return{weight:s.weight,style:s.style,src:s.src.map(o=>({format:o.format,location:o.location.toString()}))}}P.toJSONObject=v;function t(s){const o=l=>(0,L.isString)(l)?l:void 0;if(s&&Array.isArray(s.src)&&s.src.every(l=>(0,L.isString)(l.format)&&(0,L.isString)(l.location)))return{weight:o(s.weight),style:o(s.style),src:s.src.map(l=>({format:l.format,location:I.URI.parse(l.location)}))}}P.fromJSONObject=t})(m=e.IconFontDefinition||(e.IconFontDefinition={}));class p{constructor(){this.a=new S.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,R.localize)(0,null)},fontCharacter:{type:"string",description:(0,R.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,t,s,o){const l=this.b[v];if(l){if(s&&!l.description){l.description=s,this.d.properties[v].markdownDescription=`${s} $(${v})`;const c=this.e.enum.indexOf(v);c!==-1&&(this.e.enumDescriptions[c]=s),this.a.fire()}return l}const a={id:v,description:s,defaults:t,deprecationMessage:o};this.b[v]=a;const h={$ref:"#/definitions/icons"};return o&&(h.deprecationMessage=o),s&&(h.markdownDescription=`${s}: $(${v})`),this.d.properties[v]=h,this.e.enum.push(v),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const t=this.e.enum.indexOf(v);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,t){const s=this.f[v];return s||(this.f[v]=t,this.a.fire(),t)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(l,a)=>l.id.localeCompare(a.id),t=l=>{for(;O.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(l=>this.b[l]);for(const l of o.filter(a=>!!a.description).sort(v))s.push(`|<i class="${t(l)}"></i>|${l.id}|${O.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const l of o.filter(a=>!O.ThemeIcon.isThemeIcon(a.defaults)).sort(v))s.push(`|<i class="${t(l)}"></i>|${l.id}|`);return s.join(`
`)}}const f=new p;k.Registry.add(e.Extensions.IconContribution,f);function n(P,v,t,s){return f.registerIcon(P,v,t,s)}e.registerIcon=n;function r(){return f}e.getIconRegistry=r;function d(){for(const P of C.Codicon.getAll())f.registerIcon(P.id,P.definition,P.description)}d(),e.iconsSchemaId="vscode://schemas/icons";const b=k.Registry.as(y.Extensions.JSONContribution);b.registerSchema(e.iconsSchemaId,f.getIconSchema());const E=new i.RunOnceScheduler(()=>b.notifySchemaChanged(e.iconsSchemaId),200);f.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=n("widget-close",C.Codicon.close,(0,R.localize)(2,null)),e.gotoPreviousLocation=n("goto-previous-location",C.Codicon.arrowUp,(0,R.localize)(3,null)),e.gotoNextLocation=n("goto-next-location",C.Codicon.arrowDown,(0,R.localize)(4,null)),e.syncing=O.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ie[169],Ce([1,0,4,41,3,13]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var I;(function(n){n.Http="http",n.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}e.isAllInterfaces=w;function m(n,r,d,b){if(d===1)return!1;if(d===2&&w(r)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return n<1024}e.isPortPrivileged=m;class p{constructor(r,d,b){this.remoteAddress=r,this.localAddress=d,this.b=b,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let f=class{constructor(r,d){this.i=r,this.j=d,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],d=Array.from(this.d.values());for(const b of d){const E=Array.from(b.values());for(const P of E){const v=await P.value;v&&r.push(v)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:d}of r.values())await d.then(b=>b?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,d,b,E,P){this.o(r,d,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:d,localAddress:b,privacy:E,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,d){(w(r)||O(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const b=this.q(r,d);if(b)return++b.refcount,b.value}openTunnel(r,d,b,E,P=!1,v,t){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${b} on local port ${E}.`),!r)return;if(d||(d="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(r,d,b,E,P,v,t);return s?s.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const d=this.d.get(r.tunnelRemoteHost);if(d){const b=d.get(r.tunnelRemotePort);b&&(b.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,b))}}}}async n(r,d,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${d}.`);const E=b.value.then(async P=>{P&&(await P.dispose(!0),this.b.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(d),E}}async closeTunnel(r,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${d} `);const b=this.d.get(r);if(b&&b.has(d)){const E=b.get(d);E.refcount=0,await this.n(r,d,E)}}o(r,d,b){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(d,{refcount:1,value:b})}async p(r,d){const b=this.d.get(r);b&&(await b.get(d)||b.delete(d),b.size===0&&this.d.delete(r))}q(r,d){const b=[r];O(r)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):w(r)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const E=b.map(P=>this.d.get(P));for(const P of E){const v=P?.get(d);if(v)return v}}canTunnel(r){return!!k(r)}s(r,d,b,E,P,v,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${b} on local port ${E}.`);const s=b;this.h.add(s);const o=E===void 0?b:E,l={elevationRequired:P?this.isPortPrivileged(o):!1},a={remoteAddress:{host:d,port:b},localAddressPort:E,privacy:v,public:v?v!==R.Private:void 0,protocol:t},h=r.forwardPort(a,l);return h?(this.o(d,b,h),h.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),h}};f=qe([Ve(0,L.ILogService),Ve(1,C.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ie[170],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var C;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[171],Ce([1,0,16]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=C;function S(y){if(y.folders.length)return y.folders.every(k=>C(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function L(y){return S(y)?.scheme}e.getVirtualWorkspaceScheme=L;function I(y){return S(y)?.authority}e.getVirtualWorkspaceAuthority=I;function R(y){return S(y)!==void 0}e.isVirtualWorkspace=R}),define(Ie[52],Ce([1,0,136,19,46,23,2,3,16]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(o){const l=o;return typeof l?.id=="string"&&I.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=k;function O(o){return typeof o?.id=="string"&&!k(o)&&!m(o)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(o,l){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,C.basename)(o)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=o;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=w;function m(o){const l=o;return typeof l?.id=="string"&&I.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=m;function p(o){const l=o;if(l?.uri)return{id:l.id,uri:I.URI.revive(l.uri)};const a=o;if(a?.configPath)return{id:a.id,configPath:I.URI.revive(a.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=p;var f;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function n(o){const l=o;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=n;function r(o){const l=o;return!!(l&&typeof l=="object"&&I.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=r;class d{constructor(l,a,h,c,u){this.h=l,this.j=h,this.k=c,this.l=u,this.c=S.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=S.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class b{constructor(l,a){this.raw=a,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,L.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function E(o){return new b({uri:o,index:0,name:(0,L.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(o,l){return L.extUriBiasedIgnorePathCase.isEqualOrParent(o,l.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function v(o){let l;return I.URI.isUri(o)?l=o:l=o.configuration,l?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=v;function t(o,l){return!P(o,l)&&!v(o)}e.isSavedWorkspace=t;function s(o){return(typeof o=="string"?(0,C.extname)(o):(0,L.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ie[53],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(S){this.d=S,this.b=new Map,this.c=1}add(S){const L=this.c++;return this.b.set(L,S),this.e(),L}get(S,L){return this.b.has(S)?this.b.get(S)[L]:void 0}delete(S){this.b.delete(S),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Ie[37],Ce([1,0,16,23,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new C.ExtUri(R=>{const y=this.b.get(R.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(R,y){y===null?this.b.delete(R.scheme):this.b.set(R.scheme,y)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ie[172],Ce([1,0,12]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(I,R,y){this.h=new Map,this.a=I,this.b=R,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const w of k.values())w.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,R){let y=this.f[I];return typeof y>"u"&&(y=R),y}update(I,R){this.f[I]=R;const y=this.h.get(I);if(y!==void 0)return y.p;const k=new i.DeferredPromise;return this.h.set(I,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=C;class S extends C{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,R){super(I.identifier.value,!0,R),this.j=I}}e.ExtensionGlobalMemento=S}),define(Ie[173],Ce([1,0,4,2]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(I){this.c=I,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,R,y,k){const w=this.c.getNotebookDocument(C.URI.revive(I)).acceptModelChanged(R.value,y,k);this.b.fire(w)}$acceptDirtyStateChanged(I,R){this.c.getNotebookDocument(C.URI.revive(I)).acceptDirty(R)}$acceptModelSaved(I){const R=this.c.getNotebookDocument(C.URI.revive(I));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ie[17],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class C{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[174],Ce([1,0,26,4]),function(ee,e,i,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(R,y){S.set(this,void 0),this.b=new C.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(R.identifier),Je(this,S,y,"f"),Oe(this,S,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Oe(this,S,"f").get(this.a,R)}store(R,y){return Oe(this,S,"f").store(this.a,R,y)}delete(R){return Oe(this,S,"f").delete(this.a,R)}}e.ExtensionSecrets=L,S=new WeakMap}),define(Ie[69],Ce([1,0,3,169,4,17]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=k;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=O})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,w,m,p){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([Ve(0,L.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ie[54],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class C{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=C}),define(Ie[175],Ce([1,0,25]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function S(R,y){if(y.serializeBuffersForPostMessage){const k=new C,O=(p,f)=>{if(f instanceof ArrayBuffer){const n=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:n}}else if(ArrayBuffer.isView(f)){const n=L(f);if(n){const r=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:r,view:{type:n,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},w=JSON.stringify(R,O),m=k.buffers.map(p=>{const f=new Uint8Array(p);return i.VSBuffer.wrap(f)});return{message:w,buffers:m}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=S;function L(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(R,y){const k=y.map(m=>{const p=new ArrayBuffer(m.byteLength);return new Uint8Array(p).set(m.buffer),p}),O=y.length?(m,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const f=p,{index:n}=f,r=k[n];if(f.view)switch(f.view.type){case 1:return new Int8Array(r,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return p}:void 0;return{message:JSON.parse(R,O),arrayBuffers:k}}e.deserializeWebviewMessage=I}),define(Ie[94],Ce([1,0,144,9,2,6,3,29,36,16,39,121,30]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(p=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function n(G){const H=G;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=n;function r(G,H,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===H&&G.matches(ve.input))return ve.getViewState()}e.findViewStateForEditor=r;function d(G){if(u(G))return!1;const H=G;return S.URI.isUri(H?.resource)}e.isResourceEditorInput=d;function b(G){if(u(G))return!1;const H=G;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=b;function E(G){if(u(G)||b(G))return!1;const H=G;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function P(G){if(u(G))return!1;const H=G;return H?H.resource===void 0||H.resource.scheme===k.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;const v=/Untitled-\d+/;function t(G){return G.scheme===k.Schemas.untitled&&G.path.length>1&&!v.test(G.path)}e.isUntitledWithAssociatedResource=t;function s(G){if(u(G))return!1;const H=G;return S.URI.isUri(H?.base?.resource)&&S.URI.isUri(H?.input1?.resource)&&S.URI.isUri(H?.input2?.resource)&&S.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=s;var o;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var l;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class a{constructor(){this.a=new Map}registerSource(H,oe){let ve=this.a.get(H);return ve||(ve={source:H,label:oe},this.a.set(H,ve)),ve.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new a;var h;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends L.Disposable{}e.AbstractEditorInput=c;function u(G){return G instanceof c}e.isEditorInput=u;function g(G){const H=G;return S.URI.isUri(H?.preferredResource)}function A(G){const H=G;return u(H?.primary)&&u(H?.secondary)}e.isSideBySideEditorInput=A;function N(G){const H=G;return u(H?.modified)&&u(H?.original)}e.isDiffEditorInput=N;function q(G,H,oe,ve,Ae){return re(ve,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const Be={...oe,limits:{size:Number.MAX_VALUE}};G.openEditor(H,Be)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=q;function te(G){return u(G?.editor)}e.isEditorInputWithOptions=te;function x(G){const H=G;return te(G)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function F(G){const H=G;return typeof H?.groupId=="number"&&u(H.editor)}e.isEditorIdentifier=F;var $;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var T;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(H,oe){if(!H)return;if(s(H))return e.EditorResourceAccessor.getOriginalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Be}=this.a(H);if(Ae&&Be){if(oe?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(Be,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===M.ANY)return this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(Be,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===M.PRIMARY?Ae:Be}}if(b(H)||E(H)||s(H))return;const ve=g(H)?H.preferredResource:H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(H){return A(H)||E(H)?{primary:H.primary,secondary:H.secondary}:N(H)||b(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,oe){if(!H)return;if(s(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Be}=this.a(H);if(Ae&&Be){if(oe?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(Be,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===M.ANY)return this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(Be,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===M.PRIMARY?Ae:Be}}if(b(H)||E(H)||s(H))return;const ve=H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(H,oe){if(Array.isArray(oe)){if(oe.some(ve=>H.scheme===ve))return H}else if(oe===H.scheme)return H}}e.EditorResourceAccessor=new V;var j;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(H){const oe=this.a=H.get(I.IInstantiationService);for(const[ve,Ae]of this.c)this.e(ve,Ae,oe);this.c.clear()}e(H,oe,ve){const Ae=ve.createInstance(oe);this.d.set(H,Ae)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,C.assertIsDefined)(this.b)}registerEditorSerializer(H,oe){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,oe,this.a):this.c.set(H,oe),(0,L.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new le);async function Y(G,H,oe){return!G||!G.length?[]:await Promise.all(G.map(async ve=>{const Ae=S.URI.revive(ve.fileUri);if(!Ae){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await H.canHandleResource(Ae)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let xe=ve.exists,Te=ve.type;if(typeof xe!="boolean"||typeof Te!="number")try{Te=(await H.stat(Ae)).isDirectory?y.FileType.Directory:y.FileType.Unknown,xe=!0}catch(ke){oe.error(ke),xe=!1}if(!xe&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(Te===y.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const Se={...ve.options,pinned:!0};return xe?{resource:Ae,options:Se}:{resource:Ae,options:Se,forceUntitled:!0}}))}e.pathsToEditors=Y;var pe;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(pe=e.EditorsOrder||(e.EditorsOrder={}));function ue(G){const H=G;if(!H)return!1;const oe=H;if(oe.modified)return ue(oe.modified);const ve=H;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}e.isTextEditorViewState=ue;function de(G){return(0,O.isErrorWithActions)(G)}e.isEditorOpenError=de;function re(G,H,oe){const ve=(0,O.createErrorWithActions)(G,H);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}e.createEditorOpenError=re}),define(Ie[176],Ce([1,0,4,145,3,6,28,29,18,62,22,65,168]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var p;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(p=e.Extensions||(e.Extensions={}));var f;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function n(o){switch(o){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=n;class r extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new i.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(l,a,h){const c=this.get(l.id);if(c)return c;const u=l;return u.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,I.getOrSet)(this.g,a,[]).push(u),h?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:a}),u}deregisterViewContainer(l){for(const a of this.g.keys()){const h=this.g.get(a),c=h?.indexOf(l);if(c!==-1){h?.splice(c,1),h.length===0&&this.g.delete(a),this.f.fire({viewContainer:l,viewContainerLocation:a});return}}}get(l){return this.all.filter(a=>a.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(h=>h?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(a=>this.getViewContainerLocation(a)===l)}}R.Registry.add(p.ViewContainersRegistry,new r);var d;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function b(o,l){const a=o.group??d.More,h=l.group??d.More;return a!==h?a.localeCompare(h):(o.order??5)-(l.order??5)}class E extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new i.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new i.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new i.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(l,a){this.registerViews2([{views:l,viewContainer:a}])}registerViews2(l){l.forEach(({views:a,viewContainer:h})=>this.l(a,h)),this.c.fire(l)}deregisterViews(l,a){const h=this.m(l,a);h.length&&this.f.fire({views:h,viewContainer:a})}moveViews(l,a){for(const h of this.j.keys())if(h!==a){const c=this.m(l,h);c.length&&(this.l(c,a),this.g.fire({views:c,from:h,to:a}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const a of this.i){const h=(this.j.get(a)||[]).filter(c=>c.id===l)[0];if(h)return h}return null}getViewContainer(l){for(const a of this.i)if((this.j.get(a)||[]).filter(c=>c.id===l)[0])return a;return null}registerViewWelcomeContent(l,a){return this.k.add(l,a),this.h.fire(l),(0,L.toDisposable)(()=>{this.k.delete(l,a),this.h.fire(l)})}registerViewWelcomeContent2(l,a){const h=new Map;for(const[c,u]of a)this.k.add(l,u),h.set(c,(0,L.toDisposable)(()=>{this.k.delete(l,u),this.h.fire(l)}));return this.h.fire(l),h}getViewWelcomeContent(l){const a=[];return this.k.forEach(l,h=>a.push(h)),a.sort(b)}l(l,a){let h=this.j.get(a);h||(h=[],this.j.set(a,h),this.i.push(a));for(const c of l){if(this.getView(c.id)!==null)throw new Error((0,C.localize)(1,null,c.id));h.push(c)}}m(l,a){const h=this.j.get(a);if(!h)return[];const c=[],u=[];for(const g of h)l.includes(g)?c.push(g):u.push(g);return c.length&&(u.length?this.j.set(a,u):(this.j.delete(a),this.i.splice(this.i.indexOf(a),1))),c}}R.Registry.add(p.ViewsRegistry,new E),e.IViewsService=(0,S.createDecorator)("viewsService"),e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var P;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(P=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,a){this.c=!1,this.d=!1,(0,O.mixin)(this,l),this.d=!!a,this.resolve=async h=>{if(a&&!this.c){const c=await a(h);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class s extends Error{constructor(l){super((0,C.localize)(2,null,l))}}e.NoTreeViewError=s}),define(Ie[177],Ce([1,0,4,12,146]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,y,k,O){const w={command:R};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.s("request",w),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const p=this.f.get(w.seq);if(p){this.f.delete(w.seq);const f={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,S.localize)(0,null,O,R)};p(f)}},O)}return k&&this.f.set(w.seq,k),w.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,y){return R.type!=="event"||y.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,C.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const y=R,k=this.f.get(y.request_seq);k&&(this.f.delete(y.request_seq),k(y));break}}}}s(R,y){y.type=R,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((y,k)=>R.set(k,y)),await(0,C.timeout)(500),R.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ie[178],Ce([1,0,147,42,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const L=m=>i.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var I;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(I=e.State||(e.State={}));function R(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)("debugService");var w;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[179],Ce([1,0,10,2,19,22,16]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function y(o,l,a){return o.replace(R,function(h,c){return l&&c.length>0&&c[0]!=="_"?h:a&&a.hasOwnProperty(c)?a[c]:h})}e.formatPII=y;function k(o){const l={};for(const a of Object.keys(o))a.startsWith("!")||(l[a]=o[a]);return l}e.filterExceptionsFromTelemetry=k;function O(o){return o.configuration.request==="attach"&&!w(o)&&(!o.parentSession||O(o.parentSession))}e.isSessionAttach=O;function w(o){let l=o.configuration.type;if(!!l)return l==="vslsShare"&&(l=o.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(l,"extensionhost")||(0,i.equalsIgnoreCase)(l,"pwa-extensionhost")?o:o.parentSession?w(o.parentSession):void 0}e.getExtensionHostDebugSession=w;function m(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=m;function p(o,l,a){let h,c=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=u.exec(o);){const A=g.index+1,N=A+g[0].length;if(A<=l&&N>=a){h=g[0],c=A;break}}if(h){const A=/\w+/g;let N=null;for(;(N=A.exec(h))&&!(N.index+1+c+N[0].length>=a););N&&(h=h.substring(0,A.lastIndex))}return h?{start:c,end:c+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(o){return!!(o&&o.match(f))}e.isUri=n;function r(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(n(o.path))return C.URI.parse(o.path);if((0,S.isAbsolute)(o.path))return C.URI.file(o.path)}return o.path}function d(o){if(typeof o.path=="object"){const l=C.URI.revive(o.path);if(l)return l.scheme===I.Schemas.file?l.fsPath:l.toString()}return o.path}function b(o,l){const a=l?r:d,h=(0,L.deepClone)(o);return P(h,(c,u)=>{c&&u&&(u.path=a(u))}),h}e.convertToDAPaths=b;function E(o,l){const a=l?r:d,h=(0,L.deepClone)(o);return P(h,(c,u)=>{!c&&u&&(u.path=a(u))}),h}e.convertToVSCPaths=E;function P(o,l){switch(o.type){case"event":{const a=o;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=o;switch(a.command){case"setBreakpoints":l(!0,a.arguments.source);break;case"breakpointLocations":l(!0,a.arguments.source);break;case"source":l(!0,a.arguments.source);break;case"gotoTargets":l(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(h=>l(!1,h));break;default:break}break}case"response":{const a=o;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(h=>l(!1,h.source));break;case"loadedSources":a.body.sources.forEach(h=>l(!1,h));break;case"scopes":a.body.scopes.forEach(h=>l(!1,h.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(h=>l(!1,h.source));break;case"setBreakpoints":a.body.breakpoints.forEach(h=>l(!1,h.source));break;case"disassemble":a.body?.instructions.forEach(c=>l(!1,c.location));break;default:break}break}}}function v(o){return o.filter(l=>!l.presentation?.hidden).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):t(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=v;function t(o,l){return typeof o!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:o-l}async function s(o,l){const a=o.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(a!=="none"&&(await l.saveAll(),a==="allEditorsInActiveGroup")){const h=l.activeEditorPane;h&&h.input.resource?.scheme===I.Schemas.untitled&&await l.save({editor:h.input,groupId:h.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(Ie[70],Ce([1,0,25,35,180,64,16,19,20,42]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var n;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(n=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var r;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(r=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var b;(function(M){M.scheme=I.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${V.join("")}]+`),le=7;function Y(H,oe){const ve=oe.toString(le),Be=`${ve.length<V.length?V[ve.length-1]:"z"}${ve}s${(0,i.encodeBase64)(i.VSBuffer.fromString(H.scheme),!0,!0)}`;return H.with({scheme:M.scheme,fragment:Be})}M.generate=Y;function pe(H){if(H.scheme!==M.scheme)return;const oe=H.fragment.indexOf("s");if(oe<0)return;const ve=parseInt(H.fragment.substring(0,oe).replace(j,""),le),Ae=(0,i.decodeBase64)(H.fragment.substring(oe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:H.with({scheme:Ae,fragment:null})}}M.parse=pe;function ue(H,oe){return H.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${H.scheme!==I.Schemas.file?H.scheme:""}`})}M.generateCellOutputUri=ue;function de(H){if(H.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!oe)return;const ve=oe[1]&&oe[1]!==""?oe[1]:void 0,Ae=oe[2];return{outputId:ve,notebook:H.with({scheme:Ae||I.Schemas.file,fragment:null})}}M.parseCellOutputUri=de;function re(H,oe,ve){return M.generate(H,oe).with({scheme:ve})}M.generateCellPropertyUri=re;function G(H,oe){if(H.scheme===oe)return M.parse(H.with({scheme:M.scheme}))}M.parseCellPropertyUri=G})(b=e.CellUri||(e.CellUri={}));const E=M=>y.isWindows?M.replace(/\//g,"\\"):M;class P{constructor(V=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(V)].map(le=>({pattern:le,matches:C.parse(E(le))}))}sort(V){const j=new Map(S.Iterable.map(V,Y=>[Y,E(Y)]));let le=[];for(const{matches:Y}of this.d)for(const[pe,ue]of j)if(Y(ue)){le.push(pe),j.delete(pe);break}return j.size&&(le=le.concat([...j.keys()].sort((Y,pe)=>this.e.indexOf(Y)-this.e.indexOf(pe)))),le}prioritize(V,j){const le=this.f(V);if(le===-1){this.d.unshift({pattern:V,matches:C.parse(E(V))});return}const Y=new Set(j.map(ue=>this.f(ue,le)));Y.delete(-1);const pe=Array.from(Y).sort();this.d.splice(le+1,0,...pe.map(ue=>this.d[ue]));for(let ue=pe.length-1;ue>=0;ue--)this.d.splice(pe[ue],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,j=this.d.length){const le=E(V);for(let Y=0;Y<j;Y++)if(this.d[Y].matches(le))return Y;return-1}}e.MimeTypeDisplayOrder=P;function v(M,V,j,le=(Y,pe)=>Y===pe){const Y=[];function pe(re,G,H){if(G===0&&H.length===0)return;const oe=Y[Y.length-1];oe&&oe.start+oe.deleteCount===re?(oe.deleteCount+=G,oe.toInsert.push(...H)):Y.push({start:re,deleteCount:G,toInsert:H})}let ue=0,de=0;for(;;){if(ue===M.length){pe(ue,0,V.slice(de));break}if(de===V.length){pe(ue,M.length-ue,[]);break}const re=M[ue],G=V[de];if(le(re,G)){ue+=1,de+=1;continue}j(G)?(pe(ue,1,[]),ue+=1):(pe(ue,0,[G]),de+=1)}return Y}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(M){M.default="default",M.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(M){const V=M;return!!((typeof V.include=="string"||C.isRelativePattern(V.include))&&(typeof V.exclude=="string"||C.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=s;function o(M,V,j){if(Array.isArray(M.viewType)&&M.viewType.indexOf(V)>=0||M.viewType===V)return!0;if(M.filenamePattern){const le=s(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,Y=s(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(C.match(le,(0,R.basename)(j.fsPath).toLowerCase()))return!(Y&&C.match(Y,(0,R.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var l;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(V){return`${a.d}${V}`}static parse(V){if(V.startsWith(a.d))return V.substring(a.d.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a.d="notebook/";function h(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.isTextStreamMime=h;const c=new TextDecoder;function u(M){const V=[];let j=!1;for(const le of M)(V.length===0||j)&&(V.push(le),j=!0);return q(V),T(i.VSBuffer.concat(V.map(le=>i.VSBuffer.wrap(le))))}e.compressOutputItemStreams=u;const g=`${String.fromCharCode(27)}[A`,A=g.split("").map(M=>M.charCodeAt(0)),N=10;function q(M){M.forEach((V,j)=>{if(j===0||V.length<g.length)return;const le=M[j-1],Y=V.subarray(0,g.length);if(Y[0]===A[0]&&Y[1]===A[1]&&Y[2]===A[2]){const pe=le.lastIndexOf(N);if(pe===-1)return;M[j-1]=le.subarray(0,pe),M[j]=V.subarray(g.length)}})}function te(M){let V=M;do M=V,V=M.replace(/[^\n]\x08/gm,"");while(V.length<M.length);return M}function x(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const V=M.match(/^(.*)\r+/m)[1];let j=M.match(/\r+(.*)$/m)[1];j=j+V.slice(j.length,V.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return M}const F="\b".charCodeAt(0),$="\r".charCodeAt(0);function T(M){return!M.buffer.includes(F)&&!M.buffer.includes($)?M:i.VSBuffer.fromString(x(te(c.decode(M.buffer))))}}),define(Ie[181],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ie[182],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=i;function C(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=C;function S(I){return Array.from(I.entries()).map(R=>[R[0],i(R[1].map)])}e.serializeEnvironmentVariableCollections=S;function L(I){return new Map(I.map(R=>[R[0],{map:C(R[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ie[43],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(I,R,y=I.parent){if(I._isRoot)return new S([R]);const k=[I.id];for(let O=y;O&&O.id!==R;O=O.parent)k.push(O.id);return k.push(R),new S(k.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const R=I.indexOf("\0");return R===-1?I:I.slice(0,R)}static fromString(I){return new S(I.split("\0"))}static join(I,R){return new S([...I.path,R])}static joinToString(I,R){return I.toString()+"\0"+R}static parentId(I){const R=I.lastIndexOf("\0");return R===-1?void 0:I.slice(0,R)}static localId(I){const R=I.lastIndexOf("\0");return R===-1?I:I.slice(R+1)}static compare(I,R){return I===R?0:R.startsWith(I+"\0")?2:I.startsWith(R+"\0")?3:1}constructor(I,R=I.length){if(this.path=I,this.d=R,I.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new S(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new S(this.path,I)}compare(I){if(typeof I=="string")return S.compare(this.toString(),I);for(let R=0;R<I.d&&R<this.d;R++)if(I.path[R]!==this.path[R])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=S}),define(Ie[55],Ce([1,0,2,56,43]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var I;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable",c[c.SupportsContinuousRun=64]="SupportsContinuousRun"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=c=>"runIn"in c;e.isStartControllerTests=R;var y;(function(c){c.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),c.deserialize=u=>({range:C.Range.lift(u.range),uri:i.URI.revive(u.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var k;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var O;(function(c){c.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.serialize(u.location)}),c.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.deserialize(u.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(c,u)=>`${u?"s":"e"}${c}`;e.getMarkId=w;var m;(function(c){c.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.serialize(u.location)}),c.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.deserialize(u.location)})})(m=e.ITestOutputMessage||(e.ITestOutputMessage={}));var p;(function(c){c.serialize=u=>u.type===0?O.serialize(u):m.serialize(u),c.deserialize=u=>u.type===0?O.deserialize(u):m.deserialize(u)})(p=e.ITestMessage||(e.ITestMessage={}));var f;(function(c){c.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),c.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(p.serialize)}),c.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(p.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const n="\0",r=(c,u)=>c+n+u;e.namespaceTestTag=r;const d=c=>{const u=c.indexOf(n);return{ctrlId:c.slice(0,u),tagId:c.slice(u+1)}};e.denamespaceTestTag=d;var b;(function(c){c.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),c.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?i.URI.revive(u.uri):void 0,range:u.range?C.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(b=e.ITestItem||(e.ITestItem={}));var E;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(c){c.serialize=u=>({expand:u.expand,item:b.serialize(u.item)}),c.deserialize=u=>({controllerId:S.TestId.root(u.item.extId),expand:u.expand,item:b.deserialize(u.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(c){c.serialize=u=>{let g;return u.item&&(g={},u.item.label!==void 0&&(g.label=u.item.label),u.item.tags!==void 0&&(g.tags=u.item.tags),u.item.busy!==void 0&&(g.busy=u.item.busy),u.item.uri!==void 0&&(g.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(g.range=u.item.range?.toJSON()),u.item.description!==void 0&&(g.description=u.item.description),u.item.error!==void 0&&(g.error=u.item.error),u.item.sortText!==void 0&&(g.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:g}},c.deserialize=u=>{let g;return u.item&&(g={},u.item.label!==void 0&&(g.label=u.item.label),u.item.tags!==void 0&&(g.tags=u.item.tags),u.item.busy!==void 0&&(g.busy=u.item.busy),u.item.range!==void 0&&(g.range=u.item.range?C.Range.lift(u.item.range):null),u.item.description!==void 0&&(g.description=u.item.description),u.item.error!==void 0&&(g.error=u.item.error),u.item.sortText!==void 0&&(g.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:g}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(c,u)=>{u.expand!==void 0&&(c.expand=u.expand),u.item!==void 0&&(c.item=c.item?Object.assign(c.item,u.item):u.item)};e.applyTestItemUpdate=t;var s;(function(c){c.serializeWithoutMessages=u=>({...P.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages),retired:u.retired}),c.serialize=u=>({...P.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize),retired:u.retired}),c.deserialize=u=>({...P.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var o;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var l;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var a;(function(c){c.deserialize=u=>u.op===0?{op:u.op,item:P.deserialize(u.item)}:u.op===1?{op:u.op,item:v.deserialize(u.item)}:u.op===2?{op:u.op,uri:i.URI.revive(u.uri),docv:u.docv}:u,c.serialize=u=>u.op===0?{op:u.op,item:P.serialize(u.item)}:u.op===1?{op:u.op,item:v.serialize(u.item)}:u})(a=e.TestsDiffOp||(e.TestsDiffOp={}));class h{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const g=this.o();for(const A of u)switch(A.op){case 0:this.j(P.deserialize(A.item),g);break;case 1:this.k(v.deserialize(A.item),g);break;case 3:this.l(A.itemId,g);break;case 5:this.m(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.c.set(A.tag.id,A.tag);break;case 7:this.c.delete(A.id);break}g.complete?.()}j(u,g){const A=S.TestId.parentId(u.item.extId)?.toString();let N;if(!A)N=this.p(u),this.f.add(N),this.d.set(u.item.extId,N);else if(this.d.has(A)){const q=this.d.get(A);q.children.add(u.item.extId),N=this.p(u,q),this.d.set(u.item.extId,N)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return g.add?.(N),u.expand===2&&this.g++,N}k(u,g){const A=this.d.get(u.extId);if(!!A)return u.expand!==void 0&&(A.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(A,u),g.update?.(A),A}l(u,g){const A=this.d.get(u);if(!A)return;const N=S.TestId.parentId(A.item.extId)?.toString();N?this.d.get(N).children.delete(A.item.extId):this.f.delete(A);const q=[[u]];for(;q.length;)for(const te of q.pop()){const x=this.d.get(te);x&&(q.push(x.children),this.d.delete(te),g.remove?.(x,x!==A),x.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=h}),define(Ie[71],Ce([1,0,12,4,6,47,55,43]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(b,E)=>b===E,w=Object.entries({range:(b,E)=>b===E?!0:!b||!E?!1:b.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(b,E)=>!(b.length!==E.length||b.some(P=>!E.includes(P)))}),m=(b,E)=>{let P;for(const[v,t]of w)t(b[v],E[v])||(P?P[v]=E[v]:P={[v]:E[v]});return P};class p extends S.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new C.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const P of this.tree.values())this.G(P)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const P of this.k)if(P.op===2&&P.uri===E.uri){P.docv=E.docv;return}break}case 1:{const P=this.k[this.k.length-1];if(P){if(P.op===1&&P.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(P.item,E.item);return}if(P.op===0&&P.item.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(P.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,P){const v=this.tree.get(E);if(!!v){if((v.expandLevels===void 0||P>v.expandLevels)&&(v.expandLevels=P),v.expand===1){const t=this.I(v);return t.isOpen()?this.H(v,P-1):t.wait().then(()=>this.H(v,P-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,P-1)):this.H(v,P-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,P){switch(P.op){case 3:this.L(R.TestId.joinToString(E.fullId,P.id));break;case 0:this.u(P.item,E);break;case 5:for(const v of P.ops)this.p(E,v);break;case 1:this.w(P.new,P.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:P.update}});break;case 6:this.s(E.actual.uri);break;default:(0,L.assertNever)(P)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,P){const v=R.TestId.fromExtHostTestItem(E,this.root.id,P?.actual),t=this.m.getApiFor(E);t.parent&&t.parent!==P?.actual&&this.m.getChildren(t.parent).delete(E.id);let s=this.tree.get(v.toString());if(!s){s={fullId:v,actual:E,expandLevels:P?.expandLevels?P.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(E,P),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(E)}}),this.F(E,s,P);return}if(s.actual===E){this.D(E,s,P);return}if(s.actual.uri?.toString()!==E.uri?.toString())return this.L(v.toString()),this.u(E,P);const o=this.m.getChildren(s.actual),l=s.actual,a=m(this.m.toITestItem(l),this.m.toITestItem(E));this.m.getApiFor(l).listener=void 0,s.actual=E,s.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(E.tags,l.tags,v.toString()),delete a.tags),this.p(s,{op:4,update:a})),this.F(E,s,P);for(const[h,c]of o)this.m.getChildren(E).get(c.id)||this.L(R.TestId.joinToString(v,c.id));this.s(s.actual.uri)}w(E,P,v){const t=new Set(P.map(s=>s.id));for(const s of E)t.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:v,item:{tags:E.map(s=>(0,I.namespaceTestTag)(this.m.controllerId,s.id))}}}),t.forEach(this.z,this)}y(E){const P=this.j.get(E.id);P?P.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const P=this.j.get(E);P&&!--P.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,E)}))}C(E,P){this.m.getApiFor(E).parent=P&&P.actual!==this.root?P.actual:void 0}D(E,P,v){this.C(E,v);const t=this.m.getApiFor(E);t.parent=v?.actual,t.listener=s=>this.p(P,s),this.G(P)}F(E,P,v){this.D(E,P,v);for(const[t,s]of this.m.getChildren(E))this.u(s,P)}G(E){let P;this.h?E.resolveBarrier?P=E.resolveBarrier.isOpen()?3:2:P=E.actual.canResolveChildren?1:0:P=0,P!==E.expand&&(E.expand=P,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:P}}),P===1&&E.expandLevels!==void 0&&this.I(E))}H(E,P){if(P<0)return;const v=[];for(const[t,s]of this.m.getChildren(E.actual)){const o=this.expand(R.TestId.joinToString(E.fullId,s.id),P);(0,i.isThenable)(o)&&v.push(o)}if(v.length)return Promise.all(v).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const s=new i.Barrier;return s.open(),s}E.expand=2,this.J(E);const P=E.resolveBarrier=new i.Barrier,v=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let t;try{t=this.h(E.actual===this.root?void 0:E.actual)}catch(s){v(s)}return(0,i.isThenable)(t)?t.catch(v).then(()=>{P.open(),this.G(E)}):(P.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const P=this.tree.get(E);if(!P)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const v=[P];for(;v.length;){const t=v.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.z(s.id);this.tree.delete(t.fullId.toString());for(const[s,o]of this.m.getChildren(t.actual))v.push(this.tree.get(R.TestId.joinToString(t.fullId,o.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=p;class f extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=f;class n extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=n;class r extends Error{constructor(E,P,v){super(`TestItem with ID "${E}" is from controller "${P}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=r;const d=(b,E,P)=>{let v=new Map;return{get size(){return v.size},forEach(t,s){for(const o of v.values())t.call(s,o,this)},[Symbol.iterator](){return v.entries()},replace(t){const s=new Map,o=new Set(v.keys()),l={op:5,ops:[]};for(const a of t){if(!(a instanceof P))throw new n(a.id);const h=E(a).controllerId;if(h!==b.controllerId)throw new r(a.id,h,b.controllerId);if(s.has(a.id))throw new f(a.id);s.set(a.id,a),o.delete(a.id),l.ops.push({op:0,item:a})}for(const a of o.keys())l.ops.push({op:3,id:a});b.listener?.(l),v=s},add(t){if(!(t instanceof P))throw new n(t.id);v.set(t.id,t),b.listener?.({op:0,item:t})},delete(t){v.delete(t)&&b.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=d}),define(Ie[95],Ce([1,0,71]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,S=(I,R)=>{const y={controllerId:R};return C.set(I,y),y};e.createPrivateApiFor=S;const L=I=>{const R=C.get(I);if(!R)throw new i.InvalidTestItemError(I?.id||"<unknown>");return R};e.getPrivateApiFor=L}),define(Ie[72],Ce([1,0,16,2]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(R,y){return R.scheme===i.Schemas.http||R.scheme===i.Schemas.https?R:(y&&y.authority&&y.isRemote&&R.scheme===i.Schemas.file&&(R=C.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:R.path})),C.URI.from({scheme:i.Schemas.https,authority:`${R.scheme}+${L(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=S;function L(R){return R.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function I(R){return R.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=I}),define(Ie[183],Ce([1,0,4,6,72]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(R,y,k){this.d=R,this.e=y,this.f=k,this.a=0,this.b=new C.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const w of this.c.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,y,k,O,w){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===R){m=E;break}if(!m)throw new Error("not a visible editor");const p=this,f=this.a++,n=new i.Emitter,r=new i.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,S.asWebviewUri)(E,p.f)}get cspSource(){return S.webviewGenericCspSource}set options(E){this.b=E,p.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,p.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(E){return p.d.$postMessage(f,E)}},b=new class{constructor(){this.editor=R,this.line=y,this.height=k,this.webview=d,this.onDidDispose=r.event}dispose(){p.c.has(f)&&(p.c.delete(f),p.d.$disposeEditorInset(f),r.fire(),r.dispose(),n.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,y+1,k,O||{},w.identifier,w.extensionLocation),this.c.set(f,{editor:R,inset:b,onDidReceiveMessage:n}),b}$onDidDispose(R){const y=this.c.get(R);y&&y.inset.dispose()}$onDidReceiveMessage(R,y){this.c.get(R)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=L}),define(Ie[184],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var C;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(I,R){super(R),this.variable=I}}e.VariableError=S}),define(Ie[185],Ce([1,0,19,49,9,22,20,86,150,184,10]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(p,f,n,r){this.g=new Map,this.a=p,this.b=f,this.d=n,r&&(this.c=r.then(d=>this.h(d)))}h(p){if(I.isWindows){const f=Object.create(null);return Object.keys(p).forEach(n=>{f[n.toLowerCase()]=p[n]}),f}return p}resolveWithEnvironment(p,f,n){return this.j({env:this.h(p),userHome:void 0},f?f.uri:void 0,n)}async resolveAsync(p,f){const n={env:await this.c,userHome:await this.d};return this.j(n,p?p.uri:void 0,f)}async i(p,f,n,r){const d=L.deepClone(f);I.isWindows&&d.windows?Object.keys(d.windows).forEach(E=>d[E]=d.windows[E]):I.isMacintosh&&d.osx?Object.keys(d.osx).forEach(E=>d[E]=d.osx[E]):I.isLinux&&d.linux&&Object.keys(d.linux).forEach(E=>d[E]=d.linux[E]),delete d.windows,delete d.osx,delete d.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,p?p.uri:void 0,d,n,r)}async resolveAnyAsync(p,f,n){return this.i(p,f,n)}async resolveAnyMap(p,f,n){const r=new Map;return{newConfig:await this.i(p,f,n,r),resolvedVariables:r}}resolveWithInteractionReplace(p,f,n,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,f,n,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,f){if(this.g.has(p))throw new Error("Variable "+p+" is contributed twice.");this.g.set(p,f)}async j(p,f,n,r,d){if(S.isString(n))return this.l(p,f,n,r,d);if(Array.isArray(n))return Promise.all(n.map(b=>this.j(p,f,b,r,d)));if(S.isObject(n)){const b=Object.create(null),E=await Promise.all(Object.keys(n).map(async P=>[await this.l(p,f,P,r,d),await this.j(p,f,n[P],r,d)]));for(const[P,v]of E)b[P]=v;return b}return n}l(p,f,n,r,d){return(0,O.replaceAsync)(n,w.VARIABLE_REGEXP,async(b,E)=>{if(E.includes(w.VARIABLE_LHS))return b;let P=await this.n(p,b,E,f,r);return d?.set(E,P),P!==b&&S.isString(P)&&P.match(w.VARIABLE_REGEXP)&&(P=await this.l(p,f,P,r,d)),P})}m(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async n(p,f,n,r,d){let b;const E=n.split(":");E.length>1&&(n=E[0],b=E[1]);const P=s=>{const o=this.a.getFilePath();if(o)return(0,R.normalizeDriveLetter)(o);throw new k.VariableError(s,(0,y.localize)(0,null,f))},v=s=>{const o=P(s);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,R.normalizeDriveLetter)(l)}throw new k.VariableError(s,(0,y.localize)(1,null,f,i.basename(o)))},t=s=>{if(b){const o=this.a.getFolderUri(b);if(o)return o;throw new k.VariableError(s,(0,y.localize)(2,null,f,b))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(s,(0,y.localize)(3,null,f)):new k.VariableError(s,(0,y.localize)(4,null,f))};switch(n){case"env":if(b){if(p.env){const s=p.env[I.isWindows?b.toLowerCase():b];if(S.isString(s))return s}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,f));case"config":if(b){const s=this.a.getConfigurationValue(r,b);if(S.isUndefinedOrNull(s))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,f,b));if(S.isObject(s))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,f,b));return s}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,b,d,"command");case"input":return this.o(k.VariableKind.Input,f,b,d,"input");case"extensionInstallFolder":if(b){const s=await this.a.getExtension(b);if(!s)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,f,b));return this.m(s.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,f));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(t(k.VariableKind.WorkspaceFolder)));case"cwd":return r||b?(0,R.normalizeDriveLetter)(this.m(t(k.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(i.basename(this.m(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,f))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,f))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,f))}case"file":return P(k.VariableKind.File);case"fileWorkspaceFolder":return v(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||b?i.relative(this.m(t(k.VariableKind.RelativeFile)),P(k.VariableKind.RelativeFile)):P(k.VariableKind.RelativeFile);case"relativeFileDirname":{const s=i.dirname(P(k.VariableKind.RelativeFileDirname));if(r||b){const o=i.relative(this.m(t(k.VariableKind.RelativeFileDirname)),s);return o.length===0?".":o}return s}case"fileDirname":return i.dirname(P(k.VariableKind.FileDirname));case"fileExtname":return i.extname(P(k.VariableKind.FileExtname));case"fileBasename":return i.basename(P(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=i.basename(P(k.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-i.extname(s).length)}case"fileDirnameBasename":return i.basename(i.dirname(P(k.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||f}case"execInstallFolder":{const s=this.a.getAppRoot();return s||f}case"pathSeparator":return i.sep;default:try{const s=b?`${n}:${b}`:n;return this.o(k.VariableKind.Unknown,f,s,d,void 0)}catch{return f}}}}o(p,f,n,r,d){if(n&&r){const b=d===void 0?r[n]:r[d+":"+n];if(typeof b=="string")return b;throw new k.VariableError(p,(0,y.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[96],Ce([1,0,3,94]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var S;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var R;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const n=f;return(0,C.isEditorInput)(n?.editor)&&(0,C.isEditorInput)(n?.replacement)}e.isEditorReplacement=k;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const n=f;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=m;function p(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ie[186],Ce([1,0,3,96]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(L){const I=L;return typeof L=="number"||(0,C.isEditorGroup)(I)}e.isPreferredGroup=S}),define(Ie[187],Ce([1,0,3,156]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(C.IEnvironmentService)}),define(Ie[97],Ce([1,0,26,4,19]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=L;class I{static isHostExtension(w,m,p){if(m.getExtensionDescription(w))return!1;const f=p.getExtensionDescription(w);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(w){this.c=new C.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let m of w.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,m){this.d=k(this.d,m),this.d=this.d.concat(w);const p=I.j(this.d);return this.d=k(this.d,p.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new L(p)}static j(w){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,b){this.addNode(d),this.addNode(b),this.c.has(d)?this.c.get(d).push(b):this.c.set(d,[b])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,b){const E=m.getArcs(d);for(let P=0;P<E.length;P++)if(!b.has(E[P]))return!1;return!0}getNodes(){return this.e}},p=new Map;for(const d of w){const b=i.ExtensionIdentifier.toKey(d.identifier);if(p.set(b,d),d.extensionDependencies)for(const E of d.extensionDependencies){const P=i.ExtensionIdentifier.toKey(E);m.addArc(b,P)}}const f=new Set;m.getNodes().filter(d=>m.getArcs(d).length===0).forEach(d=>f.add(d));const n=m.getNodes().filter(d=>!f.has(d));let r;do{r=!1;for(let d=0;d<n.length;d++){const b=n[d];m.hasOnlyGoodArcs(b,f)&&(n.splice(d,1),d--,f.add(b),r=!0)}}while(r);return n.map(d=>p.get(d))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(i.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const m=this.g.get(w);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const m=this.e.get(i.ExtensionIdentifier.toKey(w));return m||void 0}getExtensionDescriptionByUUID(w){for(const m of this.f)if(m.uuid===w)return m}getExtensionDescriptionByIdOrUUID(w,m){return this.getExtensionDescription(w)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=I;var R;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(R||(R={}));function y(O,w){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,p=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(m!==p)return m-p;const f=S.posix.basename(O.extensionLocation.path),n=S.posix.basename(w.extensionLocation.path);return f<n?-1:f>n?1:0}function k(O,w){const m=new Set;return w.forEach(p=>m.add(i.ExtensionIdentifier.toKey(p))),O.filter(p=>!m.has(i.ExtensionIdentifier.toKey(p.identifier)))}}),define(Ie[73],Ce([1,0,25]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function I(k){const O=i.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=I;function R(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=R;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[74],Ce([1,0,3,4,13,27,73,48,50,22,2]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class{constructor(n,r){this.i=n,this.a=new C.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new C.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=r.createLogger(O.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(n,r,d){const b=this.getTelemetryDetails(),E=new m(r,d,n,this.g,this.f,this.getBuiltInCommonProperties(n),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled});return this.h.set(n.identifier.value,E),E.apiTelemetryLogger}$initializeTelemetryLevel(n,r,d){this.d=n,this.f=r,this.c=d??{usage:!0,error:!0}}getBuiltInCommonProperties(n){const r={};switch(r["common.extname"]=n.name,r["common.extversion"]=n.version,r["common.vscodemachineid"]=this.i.telemetryInfo.machineId,r["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,r["common.vscodeversion"]=this.i.version,r["common.isnewappinstall"]=p(this.i.telemetryInfo.firstSessionDate),r["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:r["common.uikind"]="web";break;case I.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,R.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),r}$onDidChangeTelemetryLevel(n){this.e=this.getTelemetryConfiguration(),this.d=n;const r=this.getTelemetryDetails();this.h.forEach(d=>{d.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(n,r){const d=this.h.get(n.value);return!d||d.ignoreUnhandledExtHostErrors?!1:(d.logError(r),!0)}};w=qe([Ve(0,L.IExtHostInitDataService),Ve(1,S.ILoggerService)],w),e.ExtHostTelemetry=w;class m{constructor(n,r,d,b,E,P,v){this.g=d,this.h=b,this.i=E,this.j=P,this.b=new C.Emitter,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.e=r?.ignoreBuiltInCommonProperties??!1,this.f=r?.additionalCommonProperties,this.a=n,this.c={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(n,r){this.d&&(this.c={isUsageEnabled:n,isErrorsEnabled:r},this.b.fire(this.d))}mixInCommonPropsAndCleanData(n){let r=n.properties??n;return r=(0,y.cleanData)(r,[]),this.f&&(r=(0,k.mixin)(r,this.f)),this.e||(r=(0,k.mixin)(r,this.j)),n.properties?n.properties=r:n=r,n}k(n,r){this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.a.sendEventData(n,r),this.h.trace(n,r)}logUsage(n,r){!this.c.isUsageEnabled||this.k(n,r)}logError(n,r){!this.c.isErrorsEnabled||(typeof n=="string"?this.k(n,r):this.a.sendErrorData(n,r))}get apiTelemetryLogger(){if(!this.d){const n=this,r={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.c.isUsageEnabled},get isErrorsEnabled(){return n.c.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.b.event.bind(n)};this.d=Object.freeze(r)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function p(f){const n=Date.now()-new Date(f).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ie[24],Ce([1,0,4,2,3,26,165]),function(ee,e,i,C,S,L,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(h){this.affinity=h,this.kind=1}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(h){this.affinity=h,this.kind=2}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(h){return this.kind===h.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(h){this.dependency=h}}e.MissingExtensionDependency=w;var m;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=p;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(h,c){const u=[],g=[],A=[],N=[],q=d(this.c),te=d(h),x=(M,V)=>M.extensionLocation.toString()===V.extensionLocation.toString()||M.isBuiltin===V.isBuiltin||M.isUserBuiltin===V.isUserBuiltin||M.isUnderDevelopment===V.isUnderDevelopment;for(const M of this.c){const V=te.get(L.ExtensionIdentifier.toKey(M.identifier));if(!V){u.push(M.identifier),q.delete(L.ExtensionIdentifier.toKey(M.identifier));continue}if(!x(M,V)){u.push(M.identifier),q.delete(L.ExtensionIdentifier.toKey(M.identifier));continue}}for(const M of h){const V=q.get(L.ExtensionIdentifier.toKey(M.identifier));if(!V){g.push(M);continue}if(!x(V,M)){u.push(V.identifier),q.delete(L.ExtensionIdentifier.toKey(V.identifier));continue}}const F=r(this.d),$=r(c);for(const M of this.d)$.has(L.ExtensionIdentifier.toKey(M))||A.push(M);for(const M of c)F.has(L.ExtensionIdentifier.toKey(M))||N.push(M);const T={toRemove:u,toAdd:g,myToRemove:A,myToAdd:N};return this.delta(T),T}delta(h){const{toRemove:c,toAdd:u,myToRemove:g,myToAdd:A}=h,N=r(c),q=r(g);for(let te=0;te<this.c.length;te++)N.has(L.ExtensionIdentifier.toKey(this.c[te].identifier))&&(this.c.splice(te,1),te--);for(let te=0;te<this.d.length;te++)q.has(L.ExtensionIdentifier.toKey(this.d[te]))&&(this.d.splice(te,1),te--);for(const te of u)this.c.push(te);for(const te of A)this.d.push(te)}containsExtension(h){for(const c of this.d)if(L.ExtensionIdentifier.equals(c,h))return!0;return!1}}e.ExtensionHostExtensions=f;class n{constructor(h){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,h)for(const c of h)this.add(c)}get size(){return this.c.size}add(h){return this.c.set(this.d(h),h),this}clear(){this.c.clear()}delete(h){return this.c.delete(this.d(h))}has(h){return this.c.has(this.d(h))}forEach(h,c){this.c.forEach(u=>h.call(c,u,u,this))}*entries(){for(const[h,c]of this.c)yield[c,c]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=n;function r(a){const h=new Set;for(const c of a)h.add(L.ExtensionIdentifier.toKey(c));return h}e.extensionIdentifiersArrayToSet=r;function d(a){const h=new Map;for(const c of a)h.set(L.ExtensionIdentifier.toKey(c.identifier),c);return h}function b(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}e.isProposedApiEnabled=b;function E(a,h){if(!b(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=E;class P{constructor(h,c,u,g){this.codeLoadingTime=h,this.activateCallTime=c,this.activateResolvedTime=u,this.activationReason=g}}e.ActivationTimes=P;class v{constructor(h,c){this.description=h,this.value=c}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var t;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function o(a,h){return{identifier:new L.ExtensionIdentifier((0,I.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=o;class l{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(h,c){return Promise.resolve(0)}getInspectPorts(h,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(Ie[188],Ce([1,0,11,97,26,24,13,12]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(d,b,E,P){this.startup=d,this.codeLoadingTime=b,this.activateCallTime=E,this.activateResolvedTime=P}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,b){return d===-1||b===-1?-1:b-d}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class O{constructor(d,b,E,P,v,t){this.activationFailed=d,this.activationFailedError=b,this.activationTimes=E,this.module=P,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=O;class w extends O{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class m extends O{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class p extends O{constructor(d){super(!0,d,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(d,b,E,P){this.g=P,this.a=d,this.b=b,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[d,b]of this.d)b.dispose()}isActivated(d){const b=this.d.get(S.ExtensionIdentifier.toKey(d));return Boolean(b&&b.value)}getActivatedExtension(d){const b=this.d.get(S.ExtensionIdentifier.toKey(d));if(!b||!b.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return b.value}async activateByEvent(d,b){if(this.f[d])return;const E=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(E.map(P=>({id:P.identifier,reason:{startup:b,extensionId:P.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,b){const E=this.a.getExtensionDescription(d);if(!E)throw new Error(`Extension '${d}' is not known`);return this.h([{id:E.identifier,reason:b}])}async h(d){const b=d.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(b.map(E=>E.wait()))}j(d){if(this.d.has(S.ExtensionIdentifier.toKey(d.id)))return this.d.get(S.ExtensionIdentifier.toKey(d.id));if(this.l(d.id))return this.k(d,null,[],null);const b=this.a.getExtensionDescription(d.id);if(!b){const v=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new p(v));return this.c.onExtensionActivationError(d.id,v,new L.MissingExtensionDependency(d.id.value)),t}const E=[],P=typeof b.extensionDependencies>"u"?[]:b.extensionDependencies;for(const v of P){if(this.m(v))continue;const t=this.d.get(S.ExtensionIdentifier.toKey(v));if(t){E.push(t);continue}if(this.l(v)){E.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(v);if(s){if(!s.main&&!s.browser)continue;E.push(this.j({id:s.identifier,reason:d.reason}));continue}const o=b.displayName||b.identifier.value,l=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${v}'`),a=this.k(d,b.displayName,[],new p(l));return this.c.onExtensionActivationError(b.identifier,l,new L.MissingExtensionDependency(v)),a}return this.k(d,b.displayName,E,null)}k(d,b,E,P){const v=new n(d.id,b,d.reason,E,P,this.c,this.g);return this.d.set(S.ExtensionIdentifier.toKey(d.id),v),v}l(d){return C.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const b=this.b.getExtensionDescription(d);return b?!b.main&&!b.browser:!1}};f=qe([Ve(3,I.ILogService)],f),e.ExtensionsActivator=f;let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,b,E,P,v,t,s){this.c=d,this.d=b,this.f=E,this.g=P,this.h=v,this.j=t,this.k=s,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const b=this.g[d];if(b.value&&!b.value.activationFailed){this.g.splice(d,1),d--;continue}if(b.value&&b.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${b.friendlyName}' failed to activate`);E.detail=b.value.activationFailedError,this.h=new p(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const b=new Error;if(d&&d.name&&(b.name=d.name),d&&d.message?b.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:b.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(b.stack=d.stack),this.h=new p(b),this.b&&i.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,b,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};n=qe([Ve(6,I.ILogService)],n)}),define(Ie[189],Ce([1,0,13,27,24]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(R,y){super(R.createLogger(y.logFile,{name:S.ExtensionHostLogFileName}))}};L=qe([Ve(0,i.ILoggerService),Ve(1,C.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[7],Ce([1,0,18,11,85,28,64,10,9,2,34,36,93,70,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f){"use strict";var n,r,d,b,E,P,v,t,s,o,l,a,h,c,u,g,A,N,q,te,x,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...we]=arguments;return Reflect.construct(z,we,ie.constructor)}}})}var M;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(M=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=P=class{static from(...U){let ie=U;return new P(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(U){n.set(this,void 0),Je(this,n,U,"f")}dispose(){typeof Oe(this,n,"f")=="function"&&(Oe(this,n,"f").call(this),Je(this,n,void 0,"f"))}};n=new WeakMap,j=P=qe([T],j),e.Disposable=j;let le=v=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:ie,character:we}=U;return typeof ie=="number"&&typeof we=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ie===0?this:new v(this.line+we,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),we===this.line&&ie===this.character?this:new v(we,ie)}toJSON(){return{line:this.line,character:this.character}}};le=v=qe([T],le),e.Position=le;let Y=t=class{static isRange(U){return U instanceof t?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof t)return U;if(this.isRange(U))return new t(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,we,Ke){let Ye,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(Ye=new le(U,ie),ot=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(Ye=le.of(U),ot=le.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(U){return t.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ie.isAfter(we))return new t(ie,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new t(ie,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ie=U.end||this.end):we=this.start,we.isEqual(this.c)&&ie.isEqual(this.end)?this:new t(we,ie)}toJSON(){return[this.start,this.end]}};Y=t=qe([T],Y),e.Range=Y;let pe=s=class extends Y{static isSelection(U){return U instanceof s?!0:U?Y.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,we,Ke){let Ye,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(Ye=new le(U,ie),ot=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(Ye=le.of(U),ot=le.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};pe=s=qe([T],pe),e.Selection=pe;class ue{constructor(U,ie,we){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=ue;class de extends Error{static NotAvailable(U,ie){return new de(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new de(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ie,this._detail=we,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=o=class{static isTextEdit(U){return U instanceof o?!0:U?Y.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new o(U,ie)}static insert(U,ie){return o.replace(new Y(U,U),ie)}static delete(U){return o.replace(U,"")}static setEndOfLine(U){const ie=new o(new Y(new le(0,0),new le(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!Y.isRange(U))throw(0,C.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,C.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,C.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};H=o=qe([T],H),e.TextEdit=H;let oe=l=class{static isNotebookCellEdit(U){return U instanceof l?!0:U?xt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new l(U,ie)}static insertCells(U,ie){return new l(new xt(U,U),ie)}static deleteCells(U){return new l(U,[])}static updateCellMetadata(U,ie){const we=new l(new xt(U,U),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(U){const ie=new l(new xt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};oe=l=qe([T],oe),e.NotebookEdit=oe;class ve{static isSnippetTextEdit(U){return U instanceof ve?!0:U?Y.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,ie){return new ve(U,ie)}static insert(U,ie){return ve.replace(new Y(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=ve;var Ae;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,we,Ke){this.c.push({_type:1,from:U,to:ie,options:we,metadata:Ke})}createFile(U,ie,we){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:we})}deleteFile(U,ie,we){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:we})}e(U,ie,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,we,Ke){const Ye=ie.start,ot=ie.end;(Ye!==ot||we.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:ot-Ye,cells:we,metadata:Ke})}g(U,ie,we,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:ie,metadata:we}})}replace(U,ie,we,Ke){this.c.push({_type:2,uri:U,edit:new H(ie,we),metadata:Ke})}insert(U,ie,we,Ke){this.replace(U,new Y(ie,ie),we,Ke)}delete(U,ie,we){this.replace(U,ie,"",we)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const we of ie){if(!we)continue;let Ke,Ye;Array.isArray(we)?(Ke=we[0],Ye=we[1]):Ke=we,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,Ye):this.f(U,Ke.range,Ke.newCells,Ye):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:Ke,metadata:Ye})}else{for(let we=0;we<this.c.length;we++){const Ke=this.c[we];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ie.push(we.edit);return ie}entries(){const U=new L.ResourceMap;for(const ie of this.c)if(ie._type===2){let we=U.get(ie.uri);we||(we=[ie.uri,[]],U.set(ie.uri,we)),we[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Be=qe([T],Be),e.WorkspaceEdit=Be;let xe=a=class{static isSnippetString(U){return U instanceof a?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=a.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const we=new a;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=a.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const we=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const we=new a;we.e=this.e,ie(we),this.e=we.e,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};xe=a=qe([T],xe),e.SnippetString=xe;var Te;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=h=class{static isLocation(U){return U instanceof h?!0:U?Y.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(Y.isRange(ie))this.range=Y.of(ie);else if(le.isPosition(ie))this.range=new Y(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=h=qe([T],ke),e.Location=ke;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&Y.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};se=qe([T],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,ie,we=Se.Error){if(!Y.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,i.equals)(U.tags,ie.tags)&&(0,i.equals)(U.relatedInformation,ie.relatedInformation,se.isEqual)}};ce=qe([T],ce),e.Diagnostic=ce;let J=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};J=qe([T],J),e.Hover=J;var D;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(U,ie=D.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:D[this.kind]}}};B=qe([T],B),e.DocumentHighlight=B;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var K;(function(z){z[z.Deprecated=1]="Deprecated"})(K=e.SymbolTag||(e.SymbolTag={}));let Z=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,we,Ke,Ye){this.name=U,this.kind=ie,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),Ke instanceof ke?this.location=Ke:we instanceof Y&&(this.location=new ke(Ke,we)),c.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};Z=c=qe([T],Z),e.SymbolInformation=Z;let he=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(u.validate)}constructor(U,ie,we,Ke,Ye){this.name=U,this.detail=ie,this.kind=we,this.range=Ke,this.selectionRange=Ye,this.children=[],u.validate(this)}};he=u=qe([T],he),e.DocumentSymbol=he;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ie){this.title=U,this.kind=ie}};ae=qe([T],ae),e.CodeAction=ae;let be=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};be.c=".",be=g=qe([T],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let Ee=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([T],Ee),e.SelectionRange=Ee;class We{constructor(U,ie,we,Ke,Ye,ot){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=We;class He{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([T],et),e.CodeLens=et;let it=A=class{static isMarkdownString(U){return U instanceof A?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){r.set(this,void 0),Je(this,r,new S.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,r,"f").value}set value(U){Oe(this,r,"f").value=U}get isTrusted(){return Oe(this,r,"f").isTrusted}set isTrusted(U){Oe(this,r,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,r,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,r,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,r,"f").supportHtml}set supportHtml(U){Oe(this,r,"f").supportHtml=U}get baseUri(){return Oe(this,r,"f").baseUri}set baseUri(U){Oe(this,r,"f").baseUri=U}appendText(U){return Oe(this,r,"f").appendText(U),this}appendMarkdown(U){return Oe(this,r,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Oe(this,r,"f").appendCodeblock(ie??"",U),this}};r=new WeakMap,it=A=qe([T],it),e.MarkdownString=it;let dt=class{constructor(U,ie){this.label=U,this.documentation=ie}};dt=qe([T],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Fe=qe([T],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([T],st),e.SignatureHelp=st;var _;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(_=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([T],ge),e.InlayHintLabelPart=ge;let Me=class{constructor(U,ie,we){this.position=U,this.label=ie,this.kind=we}};Me=qe([T],Me),e.InlayHint=Me;var $e;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([T],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};wt=qe([T],wt),e.CompletionList=wt;let St=class{constructor(U,ie,we){this.insertText=U,this.range=ie,this.command=we}};St=qe([T],St),e.InlineSuggestion=St;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([T],Ct),e.InlineSuggestionList=Ct;var lt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Bt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,ie){if(ie&&!k.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!Y.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.target=ie}};Nt=qe([T],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,ie,we,Ke){this.red=U,this.green=ie,this.blue=we,this.alpha=Ke}};Ge=qe([T],Ge),e.Color=Ge;let Mt=class{constructor(U,ie){if(ie&&!(ie instanceof Ge))throw(0,C.illegalArgument)("color");if(!Y.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.color=ie}};Mt=qe([T],Mt),e.ColorInformation=Mt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,C.illegalArgument)("label");this.label=U}};Lt=qe([T],Lt),e.ColorPresentation=Lt;var Ut;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var gt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var kt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(kt=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ie,we){if(this.startIndex=U,this.length=ie,this.tooltip=we,typeof U!="number"||U<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=De;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class me{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=me;var X;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(X=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Re;var Le;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=N=class{static from(U){switch(U){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this.c=U}get id(){return this.c}};ze.Clean=new N("clean","Clean"),ze.Build=new N("build","Build"),ze.Rebuild=new N("rebuild","Rebuild"),ze.Test=new N("test","Test"),ze=N=qe([T],ze),e.TaskGroup=ze;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,ie,we){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=we):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};bt=qe([T],bt),e.ProcessExecution=bt;let vt=class{constructor(U,ie,we){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U,this.f=ie,this.g=we}else{if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};vt=qe([T],vt),e.ShellExecution=vt;var At;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let ht=q=class{constructor(U,ie,we,Ke,Ye,ot){this.j=!1,this.k=this.definition=U;let ut;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=we,this.execution=Ke,ut=Ye,this.j=!0):ie===pt.Global||ie===pt.Workspace?(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=Ye,ut=ot):(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=Ye,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,C.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(q.g===ie||q.e===ie||q.f===ie||q.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};ht.c="customExecution",ht.e="process",ht.f="shell",ht.g="$empty",ht=q=qe([T],ht),e.Task=ht;var Kt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Kt=e.ProgressLocation||(e.ProgressLocation={}));var Vt;(function(z){function U(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(Vt=e.ViewBadge||(e.ViewBadge={}));let Et=te=class{static isTreeItem(U,ie){if(U instanceof te)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const Ke=we.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<Qt.None&&we.collapsibleState>Qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Ye=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==ri.Checked&&Ke!==ri.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ie=Qt.None){this.collapsibleState=ie,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Et=te=qe([T],Et),e.TreeItem=Et;var Qt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ri;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(ri=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ei=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,O.generateUuid)()}};ei=qe([T],ei),e.DataTransferItem=ei;let bi=class{constructor(U){d.set(this,new Map);for(const[ie,we]of U??[]){const Ke=Oe(this,d,"f").get(ie);Ke?Ke.push(we):Oe(this,d,"f").set(ie,[we])}}get(U){return Oe(this,d,"f").get(U)?.[0]}set(U,ie){Oe(this,d,"f").set(U,[ie])}forEach(U,ie){for(const[we,Ke]of Oe(this,d,"f"))for(const Ye of Ke)U.call(ie,Ye,we,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Oe(this,d,"f"))for(const we of ie)yield[U,we]}};bi=qe([T],bi),e.DataTransfer=bi;let Tt=class{constructor(U){this.insertText=U}};Tt=qe([T],Tt),e.DocumentDropEdit=Tt;let si=class{constructor(U){this.insertText=U}};si=qe([T],si),e.DocumentPasteEdit=si;let jt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};jt=qe([T],jt),e.ThemeIcon=jt,jt.File=new jt("file"),jt.Folder=new jt("folder");let ti=class{constructor(U){this.id=U}};ti=qe([T],ti),e.ThemeColor=ti;var oi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([T],ct),e.RelativePattern=ct;const Oi=new WeakMap;function _t(z,U){Oi.set(z,U)}e.setBreakpointId=_t;let Wt=class{constructor(U,ie,we,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=Oi.get(this)??(0,O.generateUuid)()),this.c}};Wt=qe([T],Wt),e.Breakpoint=Wt;let ai=class extends Wt{constructor(U,ie,we,Ke,Ye){if(super(ie,we,Ke,Ye),U===null)throw(0,C.illegalArgument)("location");this.location=U}};ai=qe([T],ai),e.SourceBreakpoint=ai;let Ei=class extends Wt{constructor(U,ie,we,Ke,Ye){super(ie,we,Ke,Ye),this.functionName=U}};Ei=qe([T],Ei),e.FunctionBreakpoint=Ei;let ci=class extends Wt{constructor(U,ie,we,Ke,Ye,ot,ut){if(super(Ke,Ye,ot,ut),!ie)throw(0,C.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=we}};ci=qe([T],ci),e.DataBreakpoint=ci;let wi=class{constructor(U,ie,we){this.command=U,this.args=ie||[],this.options=we}};wi=qe([T],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([T],ui),e.DebugAdapterServer=ui;let ii=class{constructor(U){this.path=U}};ii=qe([T],ii),e.DebugAdapterNamedPipeServer=ii;let Si=class{constructor(U){this.implementation=U}};Si=qe([T],Si),e.DebugAdapterInlineImplementation=Si;let ni=class{constructor(U,ie){this.range=U,this.expression=ie}};ni=qe([T],ni),e.EvaluatableExpression=ni;var yi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Di=class{constructor(U,ie){this.range=U,this.text=ie}};Di=qe([T],Di),e.InlineValueText=Di;let Ii=class{constructor(U,ie,we=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=we}};Ii=qe([T],Ii),e.InlineValueVariableLookup=Ii;let Yt=class{constructor(U,ie){this.range=U,this.expression=ie}};Yt=qe([T],Yt),e.InlineValueEvaluatableExpression=Yt;let Ci=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Ci=qe([T],Ci),e.InlineValueContext=Ci;var $i;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let ki=x=class extends Error{static FileExists(U){return new x(U,w.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,w.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,w.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,w.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,w.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,w.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,ie=w.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};ki=x=qe([T],ki),e.FileSystemError=ki;let Ti=class{constructor(U,ie,we){this.start=U,this.end=ie,this.kind=we}};Ti=qe([T],Ti),e.FoldingRange=Ti;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Pi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Pi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Fi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Fi=e.CommentMode||(e.CommentMode={}));var Ni;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Ni=e.CommentThreadState||(e.CommentThreadState={}));class Ue{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ue;function Gt(z){return typeof z>"u"||(0,y.isStringArray)(z)}class li{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,we=U.tokenTypes.length;ie<we;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,we=U.tokenModifiers.length;ie<we;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,we,Ke,Ye){if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,ie,we,Ke,Ye);if(Y.isRange(U)&&typeof ie=="string"&&Gt(we))return this.m(U,ie,we);throw(0,C.illegalArgument)()}m(U,ie,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Ye=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(ie);let Rt=0;if(we)for(const Ht of we){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Rt|=1<<qt>>>0}this.n(Ke,Ye,ot,ut,Rt)}n(U,ie,we,Ke,Ye){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Rt=this.g.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Rt;Xt++){let Jt=this.g[5*Xt],Ai=this.g[5*Xt+1];Jt===0?(Jt=Ht,Ai+=qt):Jt+=Ht,this.g[5*Xt]=Jt,this.g[5*Xt+1]=Ai,Ht=Jt,qt=Ai}}let ot=U,ut=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=we,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=U,this.e=ie}static o(U){const ie=[],we=U.length/5|0;for(let ut=0;ut<we;ut++)ie[ut]=ut;ie.sort((ut,Rt)=>{const Ht=U[5*ut],qt=U[5*Rt];if(Ht===qt){const Xt=U[5*ut+1],Jt=U[5*Rt+1];return Xt-Jt}return Ht-qt});const Ke=new Uint32Array(U.length);let Ye=0,ot=0;for(let ut=0;ut<we;ut++){const Rt=5*ie[ut],Ht=U[Rt+0],qt=U[Rt+1],Xt=U[Rt+2],Jt=U[Rt+3],Ai=U[Rt+4],nn=Ht-Ye,Rn=nn===0?qt-ot:qt,Ri=5*ut;Ke[Ri+0]=nn,Ke[Ri+1]=Rn,Ke[Ri+2]=Xt,Ke[Ri+3]=Jt,Ke[Ri+4]=Ai,Ye=Ht,ot=qt}return Ke}build(U){return this.f?new mt(new Uint32Array(this.g),U):new mt(li.o(this.g),U)}}e.SemanticTokensBuilder=li;class mt{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=mt;class Wi{constructor(U,ie,we){this.start=U,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Wi;class Hi{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Hi;var Mi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Mi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new jt("arrow-left")},di=qe([T],di),e.QuickInputButtons=di;var hi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(hi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,R.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,R.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!jt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,we){this.badge=U,this.tooltip=ie,this.color=we}}e.FileDecoration=qi;let fi=class{constructor(U){this.kind=U}};fi=qe([T],fi),e.ColorTheme=fi;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(U){return U instanceof xt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,we=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(we=U.end),ie===this.c&&we===this.e?this:new xt(ie,we)}}e.NotebookRange=xt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>mi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,we,Ke,Ye,ot,ut){this.kind=U,this.value=ie,this.languageId=we,this.mime=Ke,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class Gi{constructor(U){this.cells=U}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return zt.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new zt(U,ie)}static text(U,ie=I.Mimes.text){const we=Oe(zt,b,"f",E).encode(String(U));return new zt(we,ie)}static json(U,ie="text/x-json"){const we=JSON.stringify(U,void 0,"	");return zt.text(we,ie)}constructor(U,ie){this.data=U,this.mime=ie;const we=(0,I.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=zt,b=zt,E={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const we=new Set,Ke=new Set;for(let Ye=0;Ye<U.length;Ye++){const ot=U[Ye],ut=(0,I.normalizeMimeType)(ot.mime);if(!we.has(ut)||(0,p.isTextStreamMime)(ut)){we.add(ut);continue}Ke.add(Ye),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Ye,ot)=>!Ke.has(ot))}constructor(U,ie,we){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=gi;var ne;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(ne=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(fe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var rt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(rt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class yt{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=yt;var Pt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Pt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var an;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(an=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class cn{constructor(U,ie=[]){this.uri=U,this.provides=(0,i.asArray)(ie)}}e.NotebookRendererScript=cn;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let xi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};xi=qe([T],xi),e.TimelineItem=xi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Li=class{constructor(U=void 0,ie=void 0,we=void 0){this.include=U,this.exclude=ie,this.profile=we}};Li=qe([T],Li),e.TestRunRequest=Li;let Xi=class extends Li{constructor(U=void 0,ie=void 0,we=void 0,Ke=!1){super(U,ie,we),this.continuous=Ke}};Xi=qe([T],Xi),e.TestRunRequest2=Xi;let Qi=F=class{static diff(U,ie,we){const Ke=new F(U);return Ke.expectedOutput=ie,Ke.actualOutput=we,Ke}constructor(U){this.message=U}};Qi=F=qe([T],Qi),e.TestMessage=Qi;let _i=class{constructor(U){this.id=U}};_i=qe([T],_i),e.TestTag=_i;let pi=class{constructor(U,ie){this.covered=U,this.total=ie}};pi=qe([T],pi),e.CoveredCount=pi;let Yi=$=class{static fromDetails(U,ie){const we=new pi(0,0),Ke=new pi(0,0),Ye=new pi(0,0);for(const ut of ie)if("branches"in ut){we.total+=1,we.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const ot=new $(U,we,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ie,ot}constructor(U,ie,we,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=Ke}};Yi=$=qe([T],Yi),e.FileCoverage=Yi;let Ji=class{constructor(U,ie,we=[]){this.executionCount=U,this.location=ie,this.branches=we}};Ji=qe([T],Ji),e.StatementCoverage=Ji;let Zi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Zi=qe([T],Zi),e.BranchCoverage=Zi;let en=class{constructor(U,ie){this.executionCount=U,this.location=ie}};en=qe([T],en),e.FunctionCoverage=en;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,we,Ke,Ye,ot){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,we,Ke){this.base=U,this.input1=ie,this.input2=we,this.result=Ke}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,we){this.original=U,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(Ie[98],Ce([1,0,47,16,10,255,129,7,18]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(f,n){n?k.set(f,n):k.delete(f)}e.setWordDefinitionFor=O;function w(f){return k.get(f)}class m extends L.MirrorTextModel{constructor(n,r,d,b,E,P,v,t){super(r,d,b,E),this.m=n,this.p=P,this.q=v,this.notebook=t,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,y.equals)(this.d,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.c},get fileName(){return n.c.fsPath},get isUntitled(){return n.c.scheme===C.Schemas.untitled},get languageId(){return n.p},get version(){return n.g},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(r){return r?n.s(r):n.getText()},get eol(){return n.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return n.d.length},lineAt(r){return n.t(r)},offsetAt(r){return n.u(r)},positionAt(r){return n.v(r)},validateRange(r){return n.w(r)},validatePosition(r){return n.x(r)},getWordRangeAtPosition(r,d){return n.y(r,d)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,i.ok)(!this.b),this.p=n}_acceptIsDirty(n){(0,i.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(n){const r=this.w(n);if(r.isEmpty)return"";if(r.isSingleLine)return this.d[r.start.line].substring(r.start.character,r.end.character);const d=this.f,b=r.start.line,E=r.end.line,P=[];P.push(this.d[b].substring(r.start.character));for(let v=b+1;v<E;v++)P.push(this.d[v]);return P.push(this.d[E].substring(0,r.end.character)),P.join(d)}t(n){let r;if(n instanceof R.Position?r=n.line:typeof n=="number"&&(r=n),typeof r!="number"||r<0||r>=this.d.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new p(r,this.d[r],r===this.d.length-1)}u(n){return n=this.x(n),this.k(),this.h.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.k();const r=this.h.getIndexOf(n),d=this.d[r.index].length;return new R.Position(r.index,Math.min(r.remainder,d))}w(n){if(!(n instanceof R.Range))throw new Error("Invalid argument");const r=this.x(n.start),d=this.x(n.end);return r===n.start&&d===n.end?n:new R.Range(r.line,r.character,d.line,d.character)}x(n){if(!(n instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return n.with(0,0);let{line:r,character:d}=n,b=!1;if(r<0)r=0,d=0,b=!0;else if(r>=this.d.length)r=this.d.length-1,d=this.d[r].length,b=!0;else{const E=this.d[r].length;d<0?(d=0,b=!0):d>E&&(d=E,b=!0)}return b?new R.Position(r,d):n}y(n,r){const d=this.x(n);if(!r)r=w(this.p);else if((0,S.regExpLeadsToEndlessLoop)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const b=(0,I.getWordAtText)(d.character+1,(0,I.ensureValidWordDefinition)(r),this.d[d.line],0);if(b)return new R.Range(d.line,b.startColumn-1,d.line,b.endColumn-1)}}e.ExtHostDocumentData=m;class p{constructor(n,r,d){this.a=n,this.b=r,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=p}),define(Ie[190],Ce([1,0,7,17,4]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(R){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new S.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let y;switch(R){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,C.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ie[8],Ce([1,0,18,25,114,191,85,28,111,84,64,22,9,2,56,75,90,95,94,70,43,55,186,7]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(De){function Pe(X){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:Qe,positionColumn:ze}=X,Ze=new s.Position(Re-1,Le-1),bt=new s.Position(Qe-1,ze-1);return new s.Selection(Ze,bt)}De.to=Pe;function me(X){const{anchor:Re,active:Le}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}De.from=me})(o=e.Selection||(e.Selection={}));var l;(function(De){function Pe(X){if(!X)return;const{start:Re,end:Le}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}De.from=Pe;function me(X){if(!X)return;const{startLineNumber:Re,startColumn:Le,endLineNumber:Qe,endColumn:ze}=X;return new s.Range(Re-1,Le-1,Qe-1,ze-1)}De.to=me})(l=e.Range||(e.Range={}));var a;(function(De){function Pe(me){switch(me){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}De.to=Pe})(a=e.TokenType||(e.TokenType={}));var h;(function(De){function Pe(X){return new s.Position(X.lineNumber-1,X.column-1)}De.to=Pe;function me(X){return{lineNumber:X.line+1,column:X.character+1}}De.from=me})(h=e.Position||(e.Position={}));var c;(function(De){function Pe(Re,Le){return(0,i.coalesce)((0,i.asArray)(Re).map(Qe=>me(Qe,Le)))}De.from=Pe;function me(Re,Le){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:X(Re.scheme,Le),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function X(Re,Le){return Le&&typeof Re=="string"?Le.transformOutgoingScheme(Re):Re}})(c=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(De){function Pe(X){switch(X){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}De.from=Pe;function me(X){switch(X){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}De.to=me})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(De){function Pe(X){let Re;return X.code&&((0,m.isString)(X.code)||(0,m.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),{...l.from(X.range),message:X.message,source:X.source,code:Re,severity:N.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(A.from),tags:Array.isArray(X.tags)?(0,i.coalesce)(X.tags.map(u.from)):void 0}}De.from=Pe;function me(X){const Re=new s.Diagnostic(l.to(X),X.message,N.to(X.severity));return Re.source=X.source,Re.code=(0,m.isString)(X.code)?X.code:X.code?.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(A.to),Re.tags=X.tags&&(0,i.coalesce)(X.tags.map(u.to)),Re}De.to=me})(g=e.Diagnostic||(e.Diagnostic={}));var A;(function(De){function Pe(X){return{...l.from(X.location.range),message:X.message,resource:X.location.uri}}De.from=Pe;function me(X){return new s.DiagnosticRelatedInformation(new s.Location(X.resource,l.to(X)),X.message)}De.to=me})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var N;(function(De){function Pe(X){switch(X){case s.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}De.from=Pe;function me(X){switch(X){case r.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}De.to=me})(N=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(De){function Pe(X){return typeof X=="number"&&X>=s.ViewColumn.One?X-1:X===s.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}De.from=Pe;function me(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=me})(q=e.ViewColumn||(e.ViewColumn={}));function te(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!te(De[0])}e.isDecorationOptionsArr=x;var F;(function(De){function Pe(ze){return ze.map(De.from)}De.fromMany=Pe;function me(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function X(ze){let Ze;if(me(ze)){const{language:pt,value:It}=ze;Ze={value:"```"+pt+`
`+It+"\n```\n"}}else s.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const vt=pt=>{try{let It=p.URI.parse(pt,!0);It=It.with({query:Re(It.query,bt)}),bt[pt]=It}catch{}return""},At=new y.marked.Renderer;return At.link=vt,At.image=pt=>typeof pt=="string"?vt(I.parseHrefAndDimensions(pt).href):"",(0,y.marked)(Ze.value,{renderer:At}),Ze}De.from=X;function Re(ze,Ze){if(!ze)return ze;let bt;try{bt=(0,k.parse)(ze)}catch{}if(!bt)return ze;let vt=!1;return bt=(0,w.cloneAndChange)(bt,At=>{if(p.URI.isUri(At)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=At,vt=!0,pt}else return}),vt?JSON.stringify(bt):ze}function Le(ze){const Ze=new s.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?p.URI.from(ze.baseUri):void 0,Ze}De.to=Le;function Qe(ze){if(!!ze)return typeof ze=="string"?ze:De.from(ze)}De.fromStrict=Qe})(F=e.MarkdownString||(e.MarkdownString={}));function $(De){return x(De)?De.map(Pe=>({range:l.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?F.fromMany(Pe.hoverMessage):Pe.hoverMessage?F.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):De.map(Pe=>({range:l.from(Pe)}))}e.fromRangeOrRangeWithMessage=$;function T(De){return typeof De>"u"?De:typeof De=="string"?p.URI.file(De):De}e.pathOrURIToURI=T;var M;(function(De){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?T(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}De.from=Pe})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(De){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?M.from(me.before):void 0,after:me.after?M.from(me.after):void 0}}De.from=Pe})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Pe(me){if(typeof me>"u")return me;switch(me){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Pe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?j.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?V.from(me.light):void 0,dark:me.dark?V.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?M.from(me.before):void 0,after:me.after?M.from(me.after):void 0}}De.from=Pe})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(De){function Pe(X){return{text:X.newText,eol:X.newEol&&it.from(X.newEol),range:l.from(X.range)}}De.from=Pe;function me(X){const Re=new s.TextEdit(l.to(X.range),X.text);return Re.newEol=typeof X.eol>"u"?void 0:it.to(X.eol),Re}De.to=me})(Y=e.TextEdit||(e.TextEdit={}));var pe;(function(De){function Pe(X,Re){const Le={edits:[]};if(X instanceof s.WorkspaceEdit){const Qe=new R.ResourceSet;for(const ze of X._allEntries())ze._type===1&&p.URI.isUri(ze.to)&&ze.from===void 0&&Qe.add(ze.to);for(const ze of X._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:Y.from(ze.edit),versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:l.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(wt.from)}})}return Le}De.from=Pe;function me(X){const Re=new s.WorkspaceEdit;for(const Le of X.edits)Le.textEdit?Re.replace(p.URI.revive(Le.resource),l.to(Le.textEdit.range),Le.textEdit.text):Re.renameFile(p.URI.revive(Le.oldResource),p.URI.revive(Le.newResource),Le.options);return Re}De.to=me})(pe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(De){const Pe=Object.create(null);Pe[s.SymbolKind.File]=0,Pe[s.SymbolKind.Module]=1,Pe[s.SymbolKind.Namespace]=2,Pe[s.SymbolKind.Package]=3,Pe[s.SymbolKind.Class]=4,Pe[s.SymbolKind.Method]=5,Pe[s.SymbolKind.Property]=6,Pe[s.SymbolKind.Field]=7,Pe[s.SymbolKind.Constructor]=8,Pe[s.SymbolKind.Enum]=9,Pe[s.SymbolKind.Interface]=10,Pe[s.SymbolKind.Function]=11,Pe[s.SymbolKind.Variable]=12,Pe[s.SymbolKind.Constant]=13,Pe[s.SymbolKind.String]=14,Pe[s.SymbolKind.Number]=15,Pe[s.SymbolKind.Boolean]=16,Pe[s.SymbolKind.Array]=17,Pe[s.SymbolKind.Object]=18,Pe[s.SymbolKind.Key]=19,Pe[s.SymbolKind.Null]=20,Pe[s.SymbolKind.EnumMember]=21,Pe[s.SymbolKind.Struct]=22,Pe[s.SymbolKind.Event]=23,Pe[s.SymbolKind.Operator]=24,Pe[s.SymbolKind.TypeParameter]=25;function me(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}De.from=me;function X(Re){for(const Le in Pe)if(Pe[Le]===Re)return Number(Le);return s.SymbolKind.Property}De.to=X})(ue=e.SymbolKind||(e.SymbolKind={}));var de;(function(De){function Pe(X){switch(X){case s.SymbolTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return s.SymbolTag.Deprecated}}De.to=me})(de=e.SymbolTag||(e.SymbolTag={}));var re;(function(De){function Pe(X){return{name:X.name,kind:ue.from(X.kind),tags:X.tags&&X.tags.map(de.from),containerName:X.containerName,location:Ae.from(X.location)}}De.from=Pe;function me(X){const Re=new s.SymbolInformation(X.name,ue.to(X.kind),X.containerName,Ae.to(X.location));return Re.tags=X.tags&&X.tags.map(de.to),Re}De.to=me})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(De){function Pe(X){const Re={name:X.name||"!!MISSING: name!!",detail:X.detail,range:l.from(X.range),selectionRange:l.from(X.selectionRange),kind:ue.from(X.kind),tags:X.tags?.map(de.from)??[]};return X.children&&(Re.children=X.children.map(Pe)),Re}De.from=Pe;function me(X){const Re=new s.DocumentSymbol(X.name,X.detail,ue.to(X.kind),l.to(X.range),l.to(X.selectionRange));return(0,i.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(de.to)),X.children&&(Re.children=X.children.map(me)),Re}De.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(De){function Pe(X){const Re=new s.CallHierarchyItem(ue.to(X.kind),X.name,X.detail||"",p.URI.revive(X.uri),l.to(X.range),l.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Le){if(Re=Re??X._sessionId,Le=Le??X._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,name:X.name,detail:X.detail,kind:ue.from(X.kind),uri:X.uri,range:l.from(X.range),selectionRange:l.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(De){function Pe(me){return new s.CallHierarchyIncomingCall(H.to(me.from),me.fromRanges.map(X=>l.to(X)))}De.to=Pe})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(De){function Pe(me){return new s.CallHierarchyOutgoingCall(H.to(me.to),me.fromRanges.map(X=>l.to(X)))}De.to=Pe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(De){function Pe(X){return{range:X.range&&l.from(X.range),uri:X.uri}}De.from=Pe;function me(X){return new s.Location(p.URI.revive(X.uri),l.to(X.range))}De.to=me})(Ae=e.location||(e.location={}));var Be;(function(De){function Pe(X){const Re=X,Le=X;return{originSelectionRange:Re.originSelectionRange?l.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:l.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?l.from(Re.targetSelectionRange):void 0}}De.from=Pe;function me(X){return{targetUri:p.URI.revive(X.uri),targetRange:l.to(X.range),targetSelectionRange:X.targetSelectionRange?l.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?l.to(X.originSelectionRange):void 0}}De.to=me})(Be=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(De){function Pe(X){return{range:l.from(X.range),contents:F.fromMany(X.contents)}}De.from=Pe;function me(X){return new s.Hover(X.contents.map(F.to),l.to(X.range))}De.to=me})(xe=e.Hover||(e.Hover={}));var Te;(function(De){function Pe(X){return{range:l.from(X.range),expression:X.expression}}De.from=Pe;function me(X){return new s.EvaluatableExpression(l.to(X.range),X.expression)}De.to=me})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Pe(X){if(X instanceof s.InlineValueText)return{type:"text",range:l.from(X.range),text:X.text};if(X instanceof s.InlineValueVariableLookup)return{type:"variable",range:l.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Pe;function me(X){switch(X.type){case"text":return{range:l.to(X.range),text:X.text};case"variable":return{range:l.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:l.to(X.range),expression:X.expression}}}De.to=me})(Se=e.InlineValue||(e.InlineValue={}));var ke;(function(De){function Pe(X){return{frameId:X.frameId,stoppedLocation:l.from(X.stoppedLocation)}}De.from=Pe;function me(X){return new s.InlineValueContext(X.frameId,l.to(X.stoppedLocation))}De.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(De){function Pe(X){return{range:l.from(X.range),kind:X.kind}}De.from=Pe;function me(X){return new s.DocumentHighlight(l.to(X.range),X.kind)}De.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Pe(me){switch(me){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}De.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(De){function Pe(me){return{triggerKind:ce.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}De.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var D;(function(De){function Pe(X){switch(X){case s.CompletionItemTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return s.CompletionItemTag.Deprecated}}De.to=me})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(De){const Pe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function me(Le){return Pe.get(Le)??9}De.from=me;const X=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Re(Le){return X.get(Le)??s.CompletionItemKind.Property}De.to=Re})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Pe(me,X){const Re=new s.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=B.to(me.kind),Re.tags=me.tags?.map(D.to),Re.detail=me.detail,Re.documentation=I.isMarkdownString(me.documentation)?F.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,f.Range.isIRange(me.range)?Re.range=l.to(me.range):typeof me.range=="object"&&(Re.range={inserting:l.to(me.range.insert),replacing:l.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new s.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof s.Range?new s.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Le=>Y.to(Le))),Re.command=X&&me.command?X.fromInternal(me.command):void 0,Re}De.to=Pe})(W=e.CompletionItem||(e.CompletionItem={}));var K;(function(De){function Pe(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:F.fromStrict(X.documentation)}}De.from=Pe;function me(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?F.to(X.documentation):X.documentation}}De.to=me})(K=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(De){function Pe(X){return{label:X.label,documentation:F.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(K.from):[],activeParameter:X.activeParameter}}De.from=Pe;function me(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?F.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(K.to):[],activeParameter:X.activeParameter}}De.to=me})(Z=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(De){function Pe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Z.from):[]}}De.from=Pe;function me(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Z.to):[]}}De.to=me})(he=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Pe(me,X){const Re=new s.InlayHint(h.to(X.position),typeof X.label=="string"?X.label:X.label.map(ae.to.bind(void 0,me)),X.kind&&be.to(X.kind));return Re.textEdits=X.textEdits&&X.textEdits.map(Y.to),Re.tooltip=I.isMarkdownString(X.tooltip)?F.to(X.tooltip):X.tooltip,Re.paddingLeft=X.paddingLeft,Re.paddingRight=X.paddingRight,Re}De.to=Pe})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Pe(me,X){const Re=new s.InlayHintLabelPart(X.label);return Re.tooltip=I.isMarkdownString(X.tooltip)?F.to(X.tooltip):X.tooltip,n.Command.is(X.command)&&(Re.command=me.fromInternal(X.command)),X.location&&(Re.location=Ae.to(X.location)),Re}De.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(De){function Pe(X){return X}De.from=Pe;function me(X){return X}De.to=me})(be=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Pe(X){return{range:l.from(X.range),url:X.target,tooltip:X.tooltip}}De.from=Pe;function me(X){let Re;if(X.url)try{Re=typeof X.url=="string"?p.URI.parse(X.url,!0):p.URI.revive(X.url)}catch{}return new s.DocumentLink(l.to(X.range),Re)}De.to=me})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Pe(X){const Re=new s.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=Y.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Le=>Y.to(Le))),Re}De.to=Pe;function me(X){return{label:X.label,textEdit:X.textEdit?Y.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>Y.from(Re)):void 0}}De.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(De){function Pe(X){return new s.Color(X[0],X[1],X[2],X[3])}De.to=Pe;function me(X){return[X.red,X.green,X.blue,X.alpha]}De.from=me})(He=e.Color||(e.Color={}));var tt;(function(De){function Pe(X){return{range:l.from(X.range)}}De.from=Pe;function me(X){return new s.SelectionRange(l.to(X.range))}De.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Pe(me){switch(me){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}De.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Pe(X){switch(X){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Pe;function me(X){switch(X){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}De.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Pe(X){if(X===s.EndOfLine.CRLF)return 1;if(X===s.EndOfLine.LF)return 0}De.from=Pe;function me(X){if(X===1)return s.EndOfLine.CRLF;if(X===0)return s.EndOfLine.LF}De.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Pe(me){const X={start:me.start+1,end:me.end+1};return me.kind&&(X.kind=st.from(me.kind)),X}De.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(De){function Pe(me){if(me)switch(me){case s.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}De.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(De){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?l.from(me.selection):void 0,override:typeof me.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Pe})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(De){function Pe(Le){return Le instanceof s.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||X(Le)?new s.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}De.from=Pe;function me(Le){const Qe=Le;return Qe?p.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function X(Le){const Qe=Le;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Le){return typeof Le=="string"?Le:new s.RelativePattern(p.URI.revive(Le.baseUri),Le.pattern)}De.to=Re})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(De){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const X=me;return{language:X.language,scheme:X.scheme,pattern:Q.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}De.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Pe(X){return{start:X.start,end:X.end}}De.from=Pe;function me(X){return new s.NotebookRange(X.start,X.end)}De.to=me})(Me=e.NotebookRange||(e.NotebookRange={}));var $e;(function(De){function Pe(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}De.to=Pe;function me(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}De.from=me})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(De){function Pe(me){if(me===E.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(me===E.NotebookCellExecutionState.Pending)return;if(me===E.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}De.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _e;(function(De){function Pe(X){switch(X){case s.NotebookCellKind.Markup:return E.CellKind.Markup;case s.NotebookCellKind.Code:default:return E.CellKind.Code}}De.from=Pe;function me(X){switch(X){case E.CellKind.Markup:return s.NotebookCellKind.Markup;case E.CellKind.Code:default:return s.NotebookCellKind.Code}}De.to=me})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Pe(X){const Re={metadata:X.metadata??Object.create(null),cells:[]};for(const Le of X.cells)s.NotebookCellData.validate(Le),Re.cells.push(wt.from(Le));return Re}De.from=Pe;function me(X){const Re=new s.NotebookData(X.cells.map(wt.to));return(0,m.isEmptyObject)(X.metadata)||(Re.metadata=X.metadata),Re}De.to=me})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(De){function Pe(X){return{cellKind:_e.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:$e.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ct.from):[]}}De.from=Pe;function me(X){return new s.NotebookCellData(_e.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ct.to):void 0,X.metadata,X.internalMetadata?$e.to(X.internalMetadata):void 0)}De.to=me})(wt=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(De){function Pe(X){return{mime:X.mime,valueBytes:C.VSBuffer.wrap(X.data)}}De.from=Pe;function me(X){return new s.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}De.to=me})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Pe(X){return{outputId:X.id,items:X.items.map(St.from),metadata:X.metadata}}De.from=Pe;function me(X){const Re=X.items.map(St.to);return new s.NotebookCellOutput(Re,X.outputId,X.metadata)}De.to=me})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(De){function Pe(Re){return X(Re)?{include:(0,m.withNullAsUndefined)(Q.from(Re.include)),exclude:(0,m.withNullAsUndefined)(Q.from(Re.exclude))}:(0,m.withNullAsUndefined)(Q.from(Re))}De.from=Pe;function me(Re){return X(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}De.to=me;function X(Re){const Le=Re;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(De){function Pe(me,X,Re){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}De.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(De){function Pe(me,X,Re){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:X.toInternal(Le,Re),label:me.label,description:me.description,detail:me.detail}}De.from=Pe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ot;(function(De){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}De.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(De){function Pe(X){return{uri:X.uri,provides:X.provides}}De.from=Pe;function me(X){return new s.NotebookRendererScript(p.URI.revive(X.uri),X.provides)}De.to=me})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(De){function Pe(X){return{message:F.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:l.from(X.location.range),uri:X.location.uri}}}De.from=Pe;function me(X){const Re=new s.TestMessage(typeof X.message=="string"?X.message:F.to(X.message));return Re.actualOutput=X.actual,Re.expectedOutput=X.expected,Re.location=X.location?Ae.to(X.location):void 0,Re}De.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(De){De.namespace=v.namespaceTestTag,De.denamespace=v.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(De){function Pe(X){const Re=(0,d.getPrivateApiFor)(X).controllerId;return{extId:P.TestId.fromExtHostTestItem(X,Re).toString(),label:X.label,uri:p.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Le=>Dt.namespace(Re,Le.id)),range:f.Range.lift(l.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&F.fromStrict(X.error)||null}}De.from=Pe;function me(X){return{parent:void 0,error:void 0,id:P.TestId.fromString(X.extId).localId,label:X.label,uri:p.URI.revive(X.uri),tags:(X.tags||[]).map(Re=>{const{tagId:Le}=Dt.denamespace(Re);return new s.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}De.toPlain=me})($t=e.TestItem||(e.TestItem={})),function(De){function Pe(X){return{id:X.id}}De.from=Pe;function me(X){return new s.TestTag(X.id)}De.to=me}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(De){const Pe=(X,Re)=>{const Le=[];for(const[ze,Ze]of Re)P.TestId.compare(Ze.item.extId,ze)===2&&(Re.delete(ze),Le.push(Ze));const Qe={...$t.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Re))};for(const ze of Qe.children)ze.parent=Qe;return Qe};function me(X){const Re=[],Le=new Map;for(const Qe of X.items){Le.set(Qe.item.extId,Qe);const ze=P.TestId.root(Qe.item.extId);X.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:X.completedAt,results:Re.map(Qe=>Pe(Qe,Le))}}De.to=me})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(De){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?h.from(Le):l.from(Le)}function X(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}De.fromDetailed=X;function Re(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(X)}}De.fromFile=Re})(Ge=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(De){function Pe(me){switch(me){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}De.to=Pe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(De){function Pe(X){const Re=new s.TypeHierarchyItem(ue.to(X.kind),X.name,X.detail||"",p.URI.revive(X.uri),l.to(X.range),l.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Le){if(Re=Re??X._sessionId,Le=Le??X._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,kind:ue.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:l.from(X.range),selectionRange:l.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(De){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}De.from=Pe})(Ut=e.ViewBadge||(e.ViewBadge={}));var gt;(function(De){function Pe(Le,Qe,ze){const Ze=Qe.fileData;return Ze?new class extends s.DataTransferItem{asFile(){return{name:Ze.name,uri:p.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",Qe.id):Le===O.Mimes.uriList&&Qe.uriListData?new s.DataTransferItem(Re(Qe.uriListData)):new s.DataTransferItem(Qe.asString)}De.to=Pe;async function me(Le,Qe){const ze=await Qe.asString();if(Le===O.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:X(ze)};const Ze=Qe.asFile();return{id:Qe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=me;function X(Le){return S.UriList.split(Le).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return p.URI.parse(Qe)}catch{}return Qe})}function Re(Le){return S.UriList.create(Le.map(Qe=>typeof Qe=="string"?Qe:p.URI.revive(Qe)))}})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(De){function Pe(X,Re){const Le=X.items.map(([Qe,ze])=>[Qe,gt.to(Qe,ze,()=>Re(ze.id))]);return new s.DataTransfer(Le)}De.toDataTransfer=Pe;async function me(X){const Re={items:[]},Le=[];return X.forEach((Qe,ze)=>{Le.push((async()=>{Re.items.push([ze,await gt.from(ze,Qe)])})())}),await Promise.all(Le),Re}De.toDataTransferDTO=me})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[192],Ce([1,0,2,11,7,8,158]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,O,w,m={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=w,this.g=m,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,w,m)=>{const f={dispose:this.a.push([O,w,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,O){const w=i.URI.revive(k);let m=!1;const p=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const n of[...this.a]){if(m)break;const r=this.d.getDocument(w),d=await this.h(n,{document:r,reason:L.TextDocumentSaveReason.to(O)});f.push(d)}}finally{clearTimeout(p)}return f}h([k,O,w],m){const p=this.b.get(k);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(w,k,O,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const n=this.b.get(k);this.b.set(k,n?n+1:1),typeof n=="number"&&n>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,w,m){const p=[],f=Date.now(),{document:n,reason:r}=m,{version:d}=n,b=Object.freeze({document:n,reason:r,waitUntil(E){if(Object.isFrozen(p))throw(0,C.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(E))}});try{O.apply(w,[b])}catch(E){return Promise.reject(E)}return Object.freeze(p),new Promise((E,P)=>{const v=setTimeout(()=>P(new Error("timeout")),this.g.timeout);return Promise.all(p).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(v),E(t)}).catch(t=>{clearTimeout(v),P(t)})}).then(E=>{const P={edits:[]};for(const v of E)if(Array.isArray(v)&&v.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:s,range:o}of v)P.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:o&&L.Range.from(o),text:t,eol:s&&L.EndOfLine.from(s)}});if(P.edits.length!==0)return d===n.version?this.f.$tryApplyWorkspaceEdit(P):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ie[193],Ce([1,0,16,2,8,7,70]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(w,m,p,f){this.start=w,this.deletedCount=m,this.deletedItems=p,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,m,p){this.notebook=w,this.h=m,this.j=p,this.handle=p.handle,this.uri=C.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(S.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(S.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:S.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return w.g},set mime(f){w.g=f},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(p)}return this.f}setOutputs(w){this.a=w.map(S.NotebookCellOutput.to)}setOutputItems(w,m,p){const f=p.map(S.NotebookCellOutputItem.to),n=this.a.find(r=>r.id===w);if(n&&(m||(n.items.length=0),n.items.push(...f),n.items.length>1&&n.items.every(r=>I.isTextStreamMime(r.mime)))){const r=new Map,d=[];n.items.forEach(b=>{let E;r.has(b.mime)?E=r.get(b.mime):(E=[],r.set(b.mime,E),d.push(b.mime)),E.push(b.data)}),n.items.length=0,d.forEach(b=>{const E=I.compressOutputItemStreams(r.get(b));n.items.push({mime:b,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(S.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class k{constructor(w,m,p,f,n){this.k=w,this.l=m,this.m=p,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,m={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===i.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(p){return p=w.n(p),w.b[p].apiCell},getCells(p){return(p?w.p(p):w.b).map(n=>n.apiCell)},save(){return w.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,m,p){this.g=w.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:p});const f={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},n=[];for(const d of w.rawEvents)d.kind===I.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,f.contentChanges):d.kind===I.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,f.contentChanges):d.kind===I.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),n.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===I.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),n.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),n.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===I.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),n.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),n.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const r=new Map;for(let d=0;d<n.length;d++){const b=n[d],E=r.get(b.cell);if(E===void 0){const P=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});r.set(b.cell,P-1)}else f.cellChanges[E]={...f.cellChanges[E],...b}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let m=w.start|0,p=w.end|0;return m<0&&(m=0),p>this.b.length&&(p=this.b.length),w.with({start:m,end:p})}p(w){w=this.o(w);const m=[];for(let p=w.start;p<w.end;p++)m.push(this.b[p]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,m,p){if(this.j)return;const f=[],n=[],r=[];if(w.reverse().forEach(d=>{const E=d[2].map(t=>{const s=new y(this,this.l,t);return m||n.push(y.asModelAddData(this.apiNotebook,t)),s}),P=new R(d[0],d[1],[],E),v=this.b.splice(d[0],d[1],...E);for(const t of v)r.push(t.uri),P.deletedItems.push(t.apiCell);f.push(P)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:r}),p)for(const d of f)p.push(d.asApiEvent())}s(w,m,p,f){const n=this.b.splice(w,m);this.b.splice(p,0,...n);const r=[new R(w,m,n.map(d=>d.apiCell),[]),new R(p,0,[],n)];for(const d of r)f.push(d.asApiEvent())}t(w,m){this.b[w].setOutputs(m)}u(w,m,p,f){this.b[w].setOutputItems(m,p,f)}v(w,m){const p=this.b[w];p.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(p.uri,m)}w(w,m){const p=this.b[w];p.apiCell.mime=m}x(w,m){this.b[w].setMetadata(m)}y(w,m){this.b[w].setInternalMetadata(m)}getCellFromApiCell(w){return this.b.find(m=>m.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(m=>m.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[99],Ce([1,0,11,8,7]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(R,y,k,O,w,m){this.id=R,this.f=y,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=O,this.c=m}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(y){this.selections=[y]},get selections(){return R.a},set selections(y){if(!Array.isArray(y)||!y.every(S.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");R.a=y,R.g(y)},get visibleRanges(){return R.b},revealRange(y,k){R.f.$tryRevealRange(R.id,C.NotebookRange.from(y),k??S.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(C.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ie[194],Ce([1,0,4,13,8]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(R,y){this.c=R,this.d=y,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,y);const k=this.d.getEditorById(R);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(S.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(S.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const y in R)this.d.getEditorById(y)._acceptViewColumn(S.ViewColumn.to(R[y]))}};L=qe([Ve(0,C.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ie[195],Ce([1,0,8,161,139,21,63,11]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,p,f){const n=this.b++,{title:r,location:d,cancellable:b}=p,E={label:(0,S.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(n,{location:i.ProgressLocation.from(d),title:r,source:E,cancellable:b},m.isUnderDevelopment?void 0:m.identifier.value).catch(R.onUnexpectedExternalError),this.d(n,f,!!b)}d(m,p,f){let n;f&&(n=new L.CancellationTokenSource,this.c.set(m,n));const r=b=>{this.a.$progressEnd(b),this.c.delete(b),n?.dispose()};let d;try{d=p(new O(this.a,m),f&&n?n.token:L.CancellationToken.None)}catch(b){throw r(m),b}return d.then(b=>r(m),b=>r(m)),d}$acceptProgressCanceled(m){const p=this.c.get(m);p&&(p.cancel(),this.c.delete(m))}}e.ExtHostProgress=y;function k(w,m){return w.message=m.message,typeof m.increment=="number"&&(typeof w.increment=="number"?w.increment+=m.increment:w.increment=m.increment),w}class O extends C.Progress{constructor(m,p){super(f=>this.throttledReport(f)),this.c=m,this.d=p}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,I.throttle)(100,(w,m)=>k(w,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ie[100],Ce([1,0,56,95,43,71,55,8,2]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,P,v,t)=>{let s=P;return{enumerable:!0,configurable:!1,get(){return s},set(o){if(!v(s,o)){const l=s;s=o,E.listener?.(t(o,l))}}}},O=(E,P)=>E===P,w={range:(E,P)=>E===P?!0:!E||!P?!1:E.isEqual(P),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(E,P)=>!(E.length!==P.length||E.some(v=>!P.find(t=>v.id===t.id)))},m=E=>P=>({op:4,update:E(P)}),p=(E,P)=>({range:(()=>{let v;const t=m(s=>({range:i.Range.lift(R.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return v},set(s){E.listener?.({op:6}),w.range(v,s)||(v=s,E.listener?.(t(s)))}}})(),label:k(E,P,w.label,m(v=>({label:v}))),description:k(E,void 0,w.description,m(v=>({description:v}))),sortText:k(E,void 0,w.sortText,m(v=>({sortText:v}))),canResolveChildren:k(E,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:k(E,!1,w.busy,m(v=>({busy:v}))),error:k(E,void 0,w.error,m(v=>({error:R.MarkdownString.fromStrict(v)||null}))),tags:k(E,[],w.tags,(v,t)=>({op:1,new:v.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),f=E=>{const P=S.TestId.fromString(E.extId),v=new r(P.controllerId,P.localId,E.label,y.URI.revive(E.uri)||void 0);return v.range=R.Range.to(E.range||void 0),v.description=E.description||void 0,v.sortText=E.sortText||void 0,v.tags=E.tags.map(t=>R.TestTag.to({id:(0,I.denamespaceTestTag)(t).tagId})),v},n=E=>{let P;for(const v of E.tests){const t=f(v.item);(0,C.getPrivateApiFor)(t).parent=P,P=t}return P};e.toItemFromContext=n;class r{constructor(P,v,t,s){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const o=(0,C.createPrivateApiFor)(this,P);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof d?void 0:o.parent}},children:{value:(0,L.createTestItemChildren)(o,C.getPrivateApiFor,r),enumerable:!0,writable:!1},...p(o,t)})}}e.TestItemImpl=r;class d extends r{constructor(P,v){super(P,P,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class b extends L.TestItemCollection{constructor(P,v,t){super({controllerId:P,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:C.getPrivateApiFor,getChildren:s=>s.children,root:new d(P,v),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(Ie[101],Ce([1,0,47,11,83,8,7]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(m,p,f){const n=R.c.nextId();m.$registerTextEditorDecorationType(p.identifier,n,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:n,dispose(){m.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=R,R.c=new S.IdGenerator("TextEditorDecorationType");class y{constructor(m,p){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,p){this.k();let f=null;if(m instanceof I.Position)f=new I.Range(m,m);else if(m instanceof I.Range)f=m;else throw new Error("Unrecognized location");this.l(f,p,!1)}insert(m,p){this.k(),this.l(new I.Range(m,m),p,!0)}delete(m){this.k();let p=null;if(m instanceof I.Range)p=m;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(m,p,f){const n=this.c.validateRange(m);this.g.push({range:n,text:p,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==I.EndOfLine.LF&&m!==I.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this.h=m}}class k{constructor(m,p,f,n){this.c=m,this.d=p,this._accept(f),this.e=n;const r=this;this.value={get tabSize(){return r.f},set tabSize(d){r.m(d)},get indentSize(){return r.g},set indentSize(d){r.o(d)},get insertSpaces(){return r.h},set insertSpaces(d){r.q(d)},get cursorStyle(){return r.j},set cursorStyle(d){r.s(d)},get lineNumbers(){return r.k},set lineNumbers(d){r.t(d)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}m(m){const p=this.l(m);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}o(m){const p=this.n(m);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const p=this.p(m);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const p={};let f=!1;if(typeof m.tabSize<"u"){const n=this.l(m.tabSize);n==="auto"?(f=!0,p.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,f=!0,p.tabSize=n)}if(typeof m.indentSize<"u"){const n=this.n(m.indentSize);n==="tabSize"?(f=!0,p.indentSize=n):typeof n=="number"&&this.g!==n&&(this.g=n,f=!0,p.indentSize=n)}if(typeof m.insertSpaces<"u"){const n=this.p(m.insertSpaces);n==="auto"?(f=!0,p.insertSpaces=n):this.h!==n&&(this.h=n,f=!0,p.insertSpaces=n)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,p.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(m,p){p.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class O{constructor(m,p,f,n,r,d,b,E){this.id=m,this.j=p,this.k=f,this.g=!1,this.h=new Set,this.c=r,this.d=new k(this.j,this.id,d,f),this.e=b,this.f=E;const P=this;this.value=Object.freeze({get document(){return n.getValue()},set document(v){throw(0,C.readonly)("document")},get selection(){return P.c&&P.c[0]},set selection(v){if(!(v instanceof I.Selection))throw(0,C.illegalArgument)("selection");P.c=[v],P.l()},get selections(){return P.c},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof I.Selection)))throw(0,C.illegalArgument)("selections");P.c=v,P.l()},get visibleRanges(){return P.e},set visibleRanges(v){throw(0,C.readonly)("visibleRanges")},get options(){return P.d.value},set options(v){P.g||P.d.assign(v)},get viewColumn(){return P.f},set viewColumn(v){throw(0,C.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(n.getValue(),t);return v(s),P.m(s)},insertSnippet(v,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=P.c.map(l=>L.Range.from(l));else if(t instanceof I.Position){const{lineNumber:l,column:a}=L.Position.from(t);o=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(t instanceof I.Range)o=[L.Range.from(t)];else{o=[];for(const l of t)if(l instanceof I.Range)o.push(L.Range.from(l));else{const{lineNumber:a,column:h}=L.Position.from(l);o.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return p.$tryInsertSnippet(m,n.getValue().version,v.value,o,s)},setDecorations(v,t){const s=t.length===0;s&&!P.h.has(v.key)||(s?P.h.delete(v.key):P.h.add(v.key),P.n(()=>{if(L.isDecorationOptionsArr(t))return p.$trySetDecorations(m,v.key,L.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let l=0,a=t.length;l<a;l++){const h=t[l];o[4*l]=h.start.line+1,o[4*l+1]=h.start.character+1,o[4*l+2]=h.end.line+1,o[4*l+3]=h.end.character+1}return p.$trySetDecorationsFast(m,v.key,o)}}))},revealRange(v,t){P.n(()=>p.$tryRevealRange(m,L.Range.from(v),t||I.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(m,L.ViewColumn.from(v))},hide(){p.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const p=m.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const f=p.edits.map(r=>r.range);f.sort((r,d)=>r.end.line===d.end.line?r.end.character===d.end.character?r.start.line===d.start.line?r.start.character-d.start.character:r.start.line-d.start.line:r.end.character-d.end.character:r.end.line-d.end.line);for(let r=0,d=f.length-1;r<d;r++){const b=f[r].end;if(f[r+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=p.edits.map(r=>({range:L.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,n,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.ExtHostTextEditor=O}),define(Ie[196],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[197],Ce([1,0,151,11,30,89,68,29,26,196,160,153]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=R.Registry.as(I.Extensions.JSONContribution);class p{constructor(v,t,s){this.a=v,this.b=t,this.c=s}d(v,t){this.a({type:v,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(S.default.Error,v)}warn(v){this.d(S.default.Warning,v)}info(v){this.d(S.default.Info,v)}}e.ExtensionMessageCollector=p;class f{static a(v){const t=new Set;for(let s=0,o=v.length;s<o;s++)t.add(y.ExtensionIdentifier.toKey(v[s].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new f(t,[]);if(!t||!t.length)return new f([],v);const s=this.a(v),o=this.a(t),l=t.filter(h=>!s.has(y.ExtensionIdentifier.toKey(h.description.identifier))),a=v.filter(h=>!o.has(y.ExtensionIdentifier.toKey(h.description.identifier)));return new f(l,a)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=f;class n{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=f.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,C.onUnexpectedError)(v)}}}e.ExtensionPoint=n;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new n(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,t),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,m.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const E={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(E.ExtensionsRegistry,new b),e.ExtensionsRegistry=R.Registry.as(E.ExtensionsRegistry),m.registerSchema(d,e.schema),m.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[198],Ce([1,0,148,9,22,197,42,4]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(m){function p(f,n,r){if(!f)return;const d=C.isString(f.type)?f.type:void 0;if(!d||d.length===0){r.error(i.localize(3,null));return}const b=[];if(Array.isArray(f.required))for(const E of f.required)C.isString(E)&&b.push(E);return{extensionId:n.value,taskType:d,required:b,properties:f.properties?S.deepClone(f.properties):{},when:f.when?I.ContextKeyExpr.deserialize(f.when):void 0}}m.from=p})(k||(k={}));const O=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class w{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,f)=>{O.setHandler((n,r)=>{this.c=void 0;try{for(const d of r.removed){const b=d.value;for(const E of b)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const d of r.added){const b=d.value;for(const E of b){const P=k.from(E,d.description.identifier,d.collector);P&&(this.a[P.taskType]=P)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const f of this.all()){const n={type:"object",additionalProperties:!1};f.required.length>0&&(n.required=f.required.slice(0)),f.properties!==void 0?n.properties=S.deepClone(f.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[f.taskType]},p.push(n)}this.c={oneOf:p}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Ie[199],Ce([1,0,149,9,23,22,42,198]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(T){function M(V){if(!V)return T.Strong;switch(V.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=M}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(T){function M(V){switch(V.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=M}(O=e.RevealKind||(e.RevealKind={}));var w;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(T){function M(V){switch(V.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=M}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(T){function M(V){switch(V.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=M}(m=e.PanelKind||(e.PanelKind={}));var p;(function(T){T.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(p=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(T){function M(j){switch(j.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=M;function V(j){switch(j){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=V}(f=e.RuntimeType||(e.RuntimeType={}));var n;(function(T){function M(V){return C.isString(V)?V:V.value}T.value=M})(n=e.CommandString||(e.CommandString={}));var r;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function M(j){return j===T.Clean._id||j===T.Build._id||j===T.Rebuild._id||j===T.Test._id}T.is=M;function V(j){if(j!==void 0)return C.isString(j)?M(j)?{_id:j,isDefault:!1}:void 0:j}T.from=V})(r=e.TaskGroup||(e.TaskGroup={}));var d;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var b;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function M(V){switch(V){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=M})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(T){T.parallel="parallel",T.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var P;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(P=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:P.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(M,V,j,le,Y,pe){this._label="",this._id=M,V&&(this._label=V),j&&(this.type=j),this.runOptions=le,this.configurationProperties=Y,this._source=pe}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,V=!1){if(M===void 0)return!1;if(C.isString(M))return M===this._label||M===this.configurationProperties.identifier||V&&M===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class s extends t{constructor(M,V,j,le,Y,pe,ue,de){super(M,j,void 0,ue,de,V),this.command={},this._source=V,this.hasDefinedMatchers=pe,Y&&(this.command=Y)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case f.Shell:V="shell";break;case f.Process:V="process";break;case f.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(M){return M instanceof s}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let V=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:V};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new s(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=s;class o extends t{constructor(M,V,j,le,Y,pe,ue){super(M,j,le,pe,ue,V),this._source=V,this.configures=Y}static is(M){return M instanceof o}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let V=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:V};return JSON.stringify(j)}}e.ConfiguringTask=o;class l extends t{constructor(M,V,j,le,Y,pe,ue,de,re){super(M,j,le,de,re,V),this.defines=Y,this.hasDefinedMatchers=ue,this.command=pe,this.icon=re.icon,this.hide=re.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof l}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new l(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=l;class a extends t{constructor(M,V,j,le,Y,pe){super(M,j,le,Y,pe,V),this._source=V}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new a(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=a;var h;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(h=e.ExecutionEngine||(e.ExecutionEngine={})),function(T){T._default=T.Terminal}(h=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor(M){this.c=new Map;for(let V=0;V<M.length;V++)this.c.set(M[V].uri.toString(),V)}compare(M,V){const j=M.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(j&&le){let Y=this.c.get(j.uri.toString());Y=Y===void 0?0:Y+1;let pe=this.c.get(le.uri.toString());return pe=pe===void 0?0:pe+1,Y===pe?M._label.localeCompare(V._label):Y-pe}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=u;var g;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(T){T.SingleRun="singleRun",T.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var N;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(T){function M(V,j,le,Y){if(j){const pe={kind:V,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return V==="start"?pe.resolvedVariables=Y:V==="processStarted"?pe.processId=Y:V==="processEnded"&&(pe.exitCode=Y),Object.freeze(pe)}else return Object.freeze({kind:"changed"})}T.create=M})(q=e.TaskEvent||(e.TaskEvent={}));var te;(function(T){function M(j){const le=Object.keys(j).sort();let Y="";for(const pe of le){let ue=j[pe];ue instanceof Object?ue=M(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),Y+=pe+","+ue+","}return Y}function V(j){const Y={_key:M(j),type:j.taskType};return Object.assign(Y,j),Y}T.create=V})(te=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(T){function M(V,j){const le=R.TaskDefinitionRegistry.get(V.type);if(le===void 0){const de=L.deepClone(V);return delete de._key,te.create(de)}const Y=Object.create(null);Y.type=le.taskType;const pe=new Set;le.required.forEach(de=>pe.add(de));const ue=le.properties;for(const de of Object.keys(ue)){const re=V[de];if(re!=null)Y[de]=re;else if(pe.has(de)){const G=ue[de];if(G.default!==void 0)Y[de]=L.deepClone(G.default);else switch(G.type){case"boolean":Y[de]=!1;break;case"number":case"integer":Y[de]=0;break;case"string":Y[de]="";break;default:j.error(i.localize(2,null,JSON.stringify(V,void 0,0),de));return}}}return te.create(Y)}T.createTaskIdentifier=M})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[200],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,R)=>{this.b=I,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,i.onUnexpectedError)(I))}then(I,R){return this.j().then(I,R)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=C;class S extends C{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=S}),define(Ie[44],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const C=[];function S(R){const y=new i(R);return C[y.nid]=y,y}e.createProxyIdentifier=S;function L(R){return C[R].sid}e.getStringIdentifierForProxy=L;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(Ie[5],Ce([1,0,44]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var L;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(r){return r._id=w.a++,r}}e.IdObject=w,w.a=0;var m;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[76],Ce([1,0,3,13,5,17]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,k){this.c=k,this.a=new Set,this.b=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,k,O){const w=this.d(y,k);this.a.has(w)||(this.a.add(w),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}d(y,k){return`${y}-${k.identifier.value}`}};I=qe([Ve(0,L.IExtHostRpcService),Ve(1,C.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(R,y,k){}})}),define(Ie[201],Ce([1,0,4,5,7,26]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,k,O,w={}){const m=L.ExtensionIdentifier.toKey(y.identifier),p=this.f.get(m)||[],f=[...O].sort().join(" ");let n=p.find(r=>r.providerId===k&&r.scopes===f);if(n)return n.result;{const r=this.g(y,m,k,O,w);n={providerId:k,scopes:f,result:r},p.push(n),this.f.set(m,p);try{await r}finally{const d=p.findIndex(b=>b.providerId===k&&b.scopes===f);d>-1&&(p.splice(d),this.f.set(m,p))}return r}}async g(y,k,O,w,m={}){await this.a.$ensureProvider(O);const p=y.displayName||y.name;return this.a.$getSession(O,w,k,p,m)}async removeSession(y,k){const O=this.b.get(y);return O?O.provider.removeSession(k):this.a.$removeSession(y,k)}registerAuthenticationProvider(y,k,O,w){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:k,provider:O,options:w??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===y)||this.c.push({id:y,label:k});const m=O.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(y,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(y,k,w?.supportsMultipleAccounts??!1),new S.Disposable(()=>{m.dispose(),this.b.delete(y);const p=this.c.findIndex(f=>f.id===y);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this.d.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Ie[202],Ce([1,0,5,17,8]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(R,y){this.a=R.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,y,k){const O=S.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};L=qe([Ve(0,C.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ie[203],Ce([1,0,5]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(L){const I=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(R){return I.$writeText(R)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[38],Ce([1,0,9,7,8,22,5,18,13,84,56,256,2,6,3,17,100,25,44,39,77,50]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v){"use strict";var t,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(g,A){t.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Je(this,t,g.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=A,Je(this,s,g.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,N=>{const q=this.c.get(N);return q?.result===h.Void?q:void 0},A),this.f=[{processArgument(N){return(0,k.revive)(N)}},{processArgument(N){return(0,L.cloneAndChange)(N,function(q){if(O.Range.isIRange(q))return S.Range.to(q);if(w.Position.isIPosition(q))return S.Position.to(q);if(O.Range.isIRange(q.range)&&m.URI.isUri(q.uri))return S.location.to(q);if(q instanceof d.VSBuffer)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const A=this.registerCommand(!1,g.id,async(...N)=>{const q=g.args.map((x,F)=>{if(!x.validate(N[F]))throw new Error(`Invalid argument '${x.name}' when running '${g.id}', received: ${N[F]}`);return x.convert(N[F])}),te=await this.executeCommand(g.internalId,...q);return g.result.convert(te,N,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new C.Disposable(()=>{A.dispose(),this.c.delete(g.id)})}registerCommand(g,A,N,q,te,x){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:N,thisArg:q,description:te,extension:x}),g&&Oe(this,t,"f").$registerCommand(A),new C.Disposable(()=>{this.b.delete(A)&&g&&Oe(this,t,"f").$unregisterCommand(A)})}executeCommand(g,...A){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,A,!0)}async g(g,A,N){if(this.b.has(g))return Oe(this,t,"f").$fireCommandActivationEvent(g),this.h(g,A,!1);{let q=!1;const te=(0,L.cloneAndChange)(A,function(x){if(x instanceof C.Position)return S.Position.from(x);if(x instanceof C.Range)return S.Range.from(x);if(x instanceof C.Location)return S.location.from(x);if(C.NotebookRange.isNotebookRange(x))return S.NotebookRange.from(x);if(x instanceof ArrayBuffer)return q=!0,d.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return q=!0,d.VSBuffer.wrap(x);if(x instanceof d.VSBuffer)return q=!0,x;if(!Array.isArray(x))return x});try{const x=await Oe(this,t,"f").$executeCommand(g,q?new b.SerializableObjectWithBuffers(te):te,N);return(0,k.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(g,A,!1);throw x}}}async h(g,A,N){const q=this.b.get(g);if(!q)throw new Error("Unknown command");const{callback:te,thisArg:x,description:F}=q;if(F)for(let T=0;T<F.args.length;T++)try{(0,i.validateConstraint)(A[T],F.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${F.args[T].name}' - ${F.args[T].description}`)}const $=P.StopWatch.create();try{return await te.apply(x,A)}catch(T){if(g===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...A);M&&(g=M.command)}throw this.d.error(T,g,q.extension?.identifier),N?new class extends Error{constructor(){super((0,E.toErrorMessage)(T)),this.id=g,this.source=q.extension?.displayName??q.extension?.name}}:T}finally{this.j(q,g,$.elapsed())}}j(g,A,N){!g.extension||Oe(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new v.TelemetryTrustedValue(A),duration:N})}$executeContributedCommand(g,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const N=this.b.get(g);return N?(A=A.map(q=>this.f.reduce((te,x)=>x.processArgument(te,N.extension?.identifier),q)),this.h(g,A,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Oe(this,t,"f").$getCommands().then(A=>(g&&(A=A.filter(N=>N[0]!=="_")),A))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[A,N]of this.b){const{description:q}=N;q&&(g[A]=q)}return Promise.resolve(g)}};t=new WeakMap,s=new WeakMap,o=qe([Ve(0,n.IExtHostRpcService),Ve(1,y.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class l{constructor(g,A,N){this.d=g,this.f=A,this.g=N,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,A){if(!g)return;const N={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return N;const q=this.f(g.command);if(q)N.id=q.internalId,N.arguments=q.args.map((te,x)=>te.convert(g.arguments&&g.arguments[x]));else if((0,R.isNonEmptyArray)(g.arguments)){const te=`${g.command}/${++this.c}`;this.b.set(te,g),A.add((0,p.toDisposable)(()=>{this.b.delete(te),this.g.trace("CommandsConverter#DISPOSE",te)})),N.$ident=te,N.id=this.delegatingCommandId,N.arguments=[te],this.g.trace("CommandsConverter#CREATE",g.command,te)}return N}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const A=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=l;class a{constructor(g,A,N,q){this.name=g,this.description=A,this.validate=N,this.convert=q}optional(){return new a(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,A){return new a(g??this.name,A??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",u=>m.URI.isUri(u),u=>u),a.Position=new a("position","A position in a text document",u=>C.Position.isPosition(u),S.Position.from),a.Range=new a("range","A range in a text document",u=>C.Range.isRange(u),S.Range.from),a.Selection=new a("selection","A selection in a text document",u=>C.Selection.isSelection(u),S.Selection.from),a.Number=new a("number","",u=>typeof u=="number",u=>u),a.String=new a("string","",u=>typeof u=="string",u=>u),a.CallHierarchyItem=new a("item","A call hierarchy item",u=>u instanceof C.CallHierarchyItem,S.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",u=>u instanceof C.TypeHierarchyItem,S.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",u=>u instanceof r.TestItemImpl,S.TestItem.from);class h{constructor(g,A){this.description=g,this.convert=A}}e.ApiCommandResult=h,h.Void=new h("no result",u=>u);class c{constructor(g,A,N,q,te){this.id=g,this.internalId=A,this.description=N,this.args=q,this.result=te}}e.ApiCommand=c}),define(Ie[204],Ce([1,0,2,8,7,75,38,18,87,91,16]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(C.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,r)=>{if((0,R.isFalsyOrEmpty)(n))return;class d extends S.SymbolInformation{static to(E){const P=new d(E.name,C.SymbolKind.to(E.kind),E.containerName||"",new S.Location(r[0],C.Range.to(E.range)));return P.detail=E.detail,P.range=P.location.range,P.selectionRange=C.Range.to(E.selectionRange),P.children=E.children?E.children.map(d.to):[],P}}return n.map(d.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(C.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(C.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(C.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(r=>S.Position.isPosition(r)),n=>n.map(C.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(r=>{let d;for(const b of r.reverse())d=new S.SelectionRange(C.Range.to(b),d);return d}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(C.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(C.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(C.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(C.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:C.Range.to(n.range),placeholder:n.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return C.WorkspaceEdit.to(n)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(C.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new S.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const r=(0,y.decodeSemanticTokensDto)(n);if(r.type==="full")return new S.SemanticTokens(r.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new S.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const r=(0,y.decodeSemanticTokensDto)(n);if(r.type==="full")return new S.SemanticTokens(r.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,r,d)=>{if(!n)return new S.CompletionList([]);const b=n.suggestions.map(E=>C.CompletionItem.to(E,d));return new S.CompletionList(b,n.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return C.SignatureHelp.to(n)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,r,d)=>p(b=>new S.CodeLens(C.Range.to(b.range),b.command&&d.fromInternal(b.command)))(n))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>S.Range.isRange(n),n=>S.Selection.isSelection(n)?C.Selection.from(n):C.Range.from(n)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,r,d)=>p(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(b.command)}else{const E=new S.CodeAction(b.title,b.kind?new S.CodeActionKind(b.kind):void 0);return b.edit&&(E.edit=C.WorkspaceEdit.to(b.edit)),b.command&&(E.command=d.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(n))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(r=>new S.ColorInformation(C.Range.to(r.range),C.Color.to(r.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",n=>n instanceof S.Color,C.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:C.Range.from(n.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(C.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,r,d)=>n.map(C.InlayHint.to.bind(void 0,d)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(r=>C.NotebookExclusiveDocumentPattern.to(r))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(C.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>i.URI.isUri(n)||typeof n=="string"&&(0,k.matchesSomeScheme)(n,O.Schemas.http,O.Schemas.https),n=>n),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[C.ViewColumn.from(n),void 0]:[C.ViewColumn.from(n.viewColumn),C.TextEditorOpenOptions.from(n)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[C.ViewColumn.from(n),void 0]:[C.ViewColumn.from(n.viewColumn),C.TextEditorOpenOptions.from(n)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[C.ViewColumn.from(n.viewColumn),C.TextEditorOpenOptions.from(n)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],I.ApiCommandResult.Void)];class m{static register(r){w.forEach(r.registerApiCommand,r)}}e.ExtHostApiCommands=m;function p(n){return r=>{if(Array.isArray(r))return r.map(n)}}function f(n){if(!Array.isArray(n))return;const r=[];for(const d of n)L.isLocationLink(d)?r.push(C.DefinitionLink.to(d)):r.push(C.location.to(d));return r}}),define(Ie[205],Ce([1,0,12,63,4,6,2,75,26,8,7,24,5]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(f,n,r){const d=f.getProxy(m.MainContext.MainThreadComments);class b{constructor(){this.b=new Map,this.c=new Map,n.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const c=this.b.get(h.handle);return c?c.value:h}else if(h&&h.$mid===7){const c=this.b.get(h.commentControlHandle);if(!c)return h;const u=c.getCommentThread(h.commentThreadHandle);return u?u.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const c=this.b.get(h.thread.commentControlHandle);if(!c)return h;const u=c.getCommentThread(h.thread.commentThreadHandle);return u?h.$mid===8?u.value:{thread:u.value,text:h.text}:h}else if(h&&h.$mid===10){const c=this.b.get(h.thread.commentControlHandle);if(!c)return h;const u=c.getCommentThread(h.thread.commentThreadHandle);if(!u)return h;const g=h.commentUniqueId,A=u.getCommentByUniqueId(g);return A||h}else if(h&&h.$mid===11){const c=this.b.get(h.thread.commentControlHandle);if(!c)return h;const u=c.getCommentThread(h.thread.commentThreadHandle);if(!u)return h;const g=h.text,A=h.commentUniqueId,N=u.getCommentByUniqueId(A);return N?(typeof N.body=="string"?N.body=g:N.body=new O.MarkdownString(g),N):h}return h}})}createCommentController(h,c,u){const g=b.a++,A=new P(h,g,c,u);this.b.set(A.handle,A);const N=this.c.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return N.push(A),this.c.set(y.ExtensionIdentifier.toKey(h.identifier),N),A.value}$createCommentThreadTemplate(h,c,u){const g=this.b.get(h);!g||g.$createCommentThreadTemplate(c,u)}async $updateCommentThreadTemplate(h,c,u){const g=this.b.get(h);!g||g.$updateCommentThreadTemplate(c,u)}$deleteCommentThread(h,c){this.b.get(h)?.$deleteCommentThread(c)}$provideCommentingRanges(h,c,u){const g=this.b.get(h);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const A=r.getDocument(I.URI.revive(c));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(A,u)).then(N=>N?N.map(q=>k.Range.from(q)):void 0)}$toggleReaction(h,c,u,g,A){const N=this.b.get(h);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const q=N.getCommentThread(c);if(q){const te=q.getCommentByUniqueId(g.uniqueIdInThread);if(N!==void 0&&te&&N.reactionHandler)return N.reactionHandler(te,s(A))}return Promise.resolve(void 0)})}dispose(){}}b.a=0;class E{set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){h.isEqual(this.p)||(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(h){(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,c,u,g,A,N,q,te){this.m=c,this.n=u,this.o=g,this.p=A,this.q=N,this.extensionDescription=q,this.r=te,this.handle=E.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new S.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${h}.${this.handle}`),d.$createCommentThread(c,this.handle,this.n,this.o,k.Range.from(this.p),q.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{d.$deleteCommentThread(c,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(F){x.range=F},get comments(){return x.comments},set comments(F){x.comments=F},get collapsibleState(){return x.collapsibleState},set collapsibleState(F){x.collapsibleState=F},get canReply(){return x.canReply},set canReply(F){x.canReply=F},get contextValue(){return x.contextValue},set contextValue(F){x.contextValue=F},get label(){return x.label},set label(F){x.label=F},get state(){return x.state},set state(F){x.state=F},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const h=u=>Object.prototype.hasOwnProperty.call(this.b,u),c={};h("range")&&(c.range=k.Range.from(this.p)),h("label")&&(c.label=this.label),h("contextValue")&&(c.contextValue=this.contextValue??null),h("comments")&&(c.comments=this.q.map(u=>v(this,u,this.k))),h("collapsibleState")&&(c.collapseState=o(this.g)),h("canReply")&&(c.canReply=this.canReply),h("state")&&(c.state=l(this.h)),h("isTemplate")&&(c.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,c)}getCommentByUniqueId(h){for(const c of this.k){const u=c[0],g=c[1];if(h===g)return u}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}E.a=0,qe([(0,C.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class P{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,c,u,g){this.f=h,this.g=c,this.h=u,this.i=g,this.a=new Map,d.$registerCommentController(this.handle,u,g);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(N){A.options=N},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(N){A.commentingRangeProvider=N},get reactionHandler(){return A.reactionHandler},set reactionHandler(N){A.reactionHandler=N},createCommentThread(N,q,te){return A.createCommentThread(N,q,te).value},dispose:()=>{A.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(h,c,u,g){if(typeof h=="string"){const A=new E(this.id,this.handle,h,c,u,g,this.f,!1);return this.a.set(A.handle,A),A}else{const A=new E(this.id,this.handle,void 0,h,c,u,this.f,!1);return this.a.set(A.handle,A),A}}$createCommentThreadTemplate(h,c){const u=new E(this.id,this.handle,void 0,I.URI.revive(h),k.Range.to(c),[],this.f,!0);return u.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(u.handle,u),u}$updateCommentThreadTemplate(h,c){const u=this.a.get(h);u&&(u.range=k.Range.to(c))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function v(a,h,c){let u=c.get(h);u||(u=++a.commentHandle,c.set(h,u));const g=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:u,body:typeof h.body=="string"?h.body:k.MarkdownString.from(h.body),userName:h.author.name,userIconPath:g,label:h.label,commentReactions:h.reactions?h.reactions.map(A=>t(A)):void 0,timestamp:h.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?k.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function s(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?I.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case O.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case O.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new b}e.createExtHostComments=p}),define(Ie[206],Ce([1,0,22,5,27,17]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(O,w){this.a=O.getProxy(C.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,w){const m=this,p=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m.e(O,w,p,arguments)}})}e(O,w,m,p){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(p,this.b)}),this.c&&this.f(O,m,p)}};I=qe([Ve(0,L.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const R=1e5;function y(k,O){const w=[];if(k.length)for(let m=0;m<k.length;m++){let p=k[m];if(typeof p>"u")p="undefined";else if(p instanceof Error){const f=p;f.stack?p=f.stack:p=f.toString()}w.push(p)}if(O){const m=new Error().stack;m&&w.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(w);return m.length>R?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[102],Ce([1,0,2,5,7,3,17,13,18,10,19,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ui{constructor(f,n){this.h=n,this.f=new Map,this.g=f.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,n){const r=Ui.c++;this.f.set(r,{provider:f,extensionDescription:n}),this.g.$registerDecorationProvider(r,n.identifier.value);const d=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(r,null);return}const E=(0,y.asArray)(b);if(E.length<=Ui.d){this.g.$onDidChange(r,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",n.identifier.value,E.length);const P=E.map(s=>({uri:s,rank:(0,k.count)(s.path,"/")})),v=(0,y.groupBy)(P,(s,o)=>s.rank-o.rank||(0,k.compare)(s.uri.path,o.uri.path)),t=[];e:for(const s of v){let o;for(const l of s){const a=(0,O.dirname)(l.uri.path);if(o!==a&&(o=a,t.push(l.uri)>=Ui.d))break e}}this.g.$onDidChange(r,t)});return new S.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(f,n,r){if(!this.f.has(f))return Object.create(null);const d=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(f);return await Promise.all(n.map(async P=>{try{const{uri:v,id:t}=P,s=await Promise.resolve(b.provideFileDecoration(i.URI.revive(v),r));if(!s)return;try{S.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),d[t]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E}': ${o}`)}}catch(v){this.h.error(v)}})),d}};m.c=0,m.d=250,m=qe([Ve(0,I.IExtHostRpcService),Ve(1,R.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[207],Ce([1,0,137,90,2,5,7,8,4,13,28,37]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";var m,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class n{constructor(b,E,P,v,t,s,o){this.d=b,this.e=E,this.f=P,this.g=v,m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new O.ResourceMap(l=>t.getComparisonKey(l)),"f"),Je(this,m,s,"f"),Je(this,p,o,"f")}dispose(){this.c||(Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this.e),Oe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,E){if(!b){this.clear();return}this.h();let P=[];if(S.URI.isUri(b)){if(!E){this.delete(b);return}Oe(this,f,"f").set(b,E.slice()),P=[b]}else if(Array.isArray(b)){P=[];let t;b=[...b].sort(n.j);for(const s of b){const[o,l]=s;if((!t||o.toString()!==t.toString())&&(t&&Oe(this,f,"f").get(t).length===0&&Oe(this,f,"f").delete(t),t=o,P.push(o),Oe(this,f,"f").set(o,[])),l)Oe(this,f,"f").get(o)?.push(...l);else{const a=Oe(this,f,"f").get(o);a&&(a.length=0)}}}if(Oe(this,p,"f").fire(P),!Oe(this,m,"f"))return;const v=[];for(const t of P){let s=[];const o=Oe(this,f,"f").get(t);if(o)if(o.length>this.f){s=[];const l=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const h of o)if(h.severity===l[a]&&s.push({...R.Diagnostic.from(h),modelVersionId:this.g(t)})===this.f)break e;s.push({severity:C.MarkerSeverity.Info,message:(0,i.localize)(0,null,o.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=o.map(l=>({...R.Diagnostic.from(l),modelVersionId:this.g(t)}));v.push([t,s])}Oe(this,m,"f").$changeMany(this.e,v)}delete(b){this.h(),Oe(this,p,"f").fire([b]),Oe(this,f,"f").delete(b),Oe(this,m,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this.e)}forEach(b,E){this.h();for(const[P,v]of this)b.call(E,P,v,this)}*[(m=new WeakMap,p=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const b of Oe(this,f,"f").keys())yield[b,this.get(b)]}get(b){this.h();const E=Oe(this,f,"f").get(b);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(b){return this.h(),Array.isArray(Oe(this,f,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,E){return b[0].toString()<E[0].toString()?-1:b[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=n;let r=class vi{static _mapper(b){const E=new O.ResourceMap;for(const P of b)E.set(P,P);return{uris:Object.freeze(Array.from(E.values()))}}constructor(b,E,P,v){this.h=E,this.j=P,this.k=v,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,vi._mapper),this.e=b.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,E){const{f:P,e:v,g:t,h:s,j:o,k:l}=this,a=new class{$changeMany(u,g){v.$changeMany(u,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,u,g.length===0?"CLEARING":g)}$clear(u){v.$clear(u),s.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,u)}dispose(){v.dispose()}};let h;if(!E)E="_generated_diagnostic_collection_name_#"+vi.c++,h=E;else if(!P.has(E))h=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do h=E+vi.c++;while(P.has(h))}return new class extends n{constructor(){super(E,h,vi.d,u=>l.getDocument(u)?.version,o.extUri,a,t),P.set(h,this)}dispose(){super.dispose(),P.delete(h)}}}getDiagnostics(b){if(b)return this.l(b);{const E=new Map,P=[];for(const v of this.f.values())v.forEach((t,s)=>{let o=E.get(t.toString());typeof o>"u"&&(o=P.length,E.set(t.toString(),o),P.push([t,[]])),P[o][1]=P[o][1].concat(...s)});return P}}l(b){let E=[];for(const P of this.f.values())P.has(b)&&(E=E.concat(P.get(b)));return E}$acceptMarkersChange(b){if(!this.m){const E="_generated_mirror",P=new n(E,E,vi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(E,P),this.m=P}for(const[E,P]of b)this.m.set(S.URI.revive(E),P.map(R.Diagnostic.to))}};r.c=0,r.d=1e3,r=qe([Ve(1,k.ILogService),Ve(2,w.IExtHostFileSystemInfo)],r),e.ExtHostDiagnostics=r}),define(Ie[208],Ce([1,0,2,5]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(I){this.a=I.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(R=>R?R.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(R=>R?i.URI.revive(R):void 0)}}e.ExtHostDialogs=S}),define(Ie[209],Ce([1,0,11,2,7,5,16,21,10]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,m,p){this.d=m,this.e=p,this.b=new Map,this.c=w.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,m){if(Object.keys(I.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const p=k.a++;this.b.set(p,m),this.c.$registerTextContentProvider(p,w);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(n=>{if(n.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this.d.getDocument(n)&&this.$provideTextDocumentContent(p,n).then(r=>{if(!r&&typeof r!="string")return;const d=this.d.getDocument(n);if(!d)return;const b=(0,y.splitLines)(r);if(!d.equalLines(b))return this.c.$onVirtualDocumentChange(n,r)},i.onUnexpectedError)})),new S.Disposable(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(w,m){const p=this.b.get(w);return p?Promise.resolve(p.provideTextDocumentContent(C.URI.revive(m),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[210],Ce([1,0,4,6,2,5,98,8,9,22,7]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(p,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.DisposableStore,this.h=new Map,this.f=p.getProxy(L.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(n=>{for(const r of n)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const r of n)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let n=this.h.get(p.toString());return n||(n=this.f.$tryOpenDocument(p).then(r=>{this.h.delete(p.toString());const d=S.URI.revive(r);return(0,y.assertIsDefined)(this.g.getDocument(d))},r=>(this.h.delete(p.toString()),Promise.reject(r))),this.h.set(p.toString(),n)),n}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>S.URI.revive(f))}$acceptModelLanguageChanged(p,f){const n=S.URI.revive(p),r=this.g.getDocument(n);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(f),this.a.fire(r.document)}$acceptModelSaved(p){const f=S.URI.revive(p),n=this.g.getDocument(f);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(p,f){const n=S.URI.revive(p),r=this.g.getDocument(n);if(!r)throw new Error("unknown document");r._acceptIsDirty(f),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,n){const r=S.URI.revive(p),d=this.g.getDocument(r);if(!d)throw new Error("unknown document");d._acceptIsDirty(n),d.onEvents(f);let b;f.isUndoing?b=O.TextDocumentChangeReason.Undo:f.isRedoing&&(b=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:d.document,contentChanges:f.changes.map(E=>({range:R.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor(p,f){(0,I.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=w}),define(Ie[57],Ce([1,0,47,4,6,2,3,5,98,17,101,8,13,28,16,180,211]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(P){this.value=P,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(P,v){this.h=P,this.i=v,this.a=null,this.b=new Map,this.c=new p.ResourceMap,this.d=new C.Emitter,this.e=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(P){this.acceptDocumentsAndEditorsDelta(P)}acceptDocumentsAndEditorsDelta(P){const v=[],t=[],s=[];if(P.removedDocuments)for(const o of P.removedDocuments){const l=L.URI.revive(o),a=this.c.get(l);a?.unref()&&(this.c.delete(l),v.push(a.value))}if(P.addedDocuments)for(const o of P.addedDocuments){const l=L.URI.revive(o.uri);let a=this.c.get(l);if(a&&l.scheme!==f.Schemas.vscodeNotebookCell&&l.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new d(new y.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),l,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(l,a),t.push(a.value)),a.ref()}if(P.removedEditors)for(const o of P.removedEditors){const l=this.b.get(o);this.b.delete(o),l&&s.push(l)}if(P.addedEditors)for(const o of P.addedEditors){const l=L.URI.revive(o.documentUri);i.ok(this.c.has(l),`document '${l}' does not exist`),i.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const a=this.c.get(l).value,h=new O.ExtHostTextEditor(o.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new r.Lazy(()=>a.document),o.selections.map(w.Selection.to),o.options,o.visibleRanges.map(c=>w.Range.to(c)),typeof o.editorPosition=="number"?w.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,h)}P.newActiveEditor!==void 0&&(i.ok(P.newActiveEditor===null||this.b.has(P.newActiveEditor),`active editor '${P.newActiveEditor}' does not exist`),this.a=P.newActiveEditor),(0,S.dispose)(v),(0,S.dispose)(s),P.removedDocuments&&this.e.fire(v),P.addedDocuments&&this.d.fire(t),(P.removedEditors||P.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),P.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(P){return this.c.get(P)?.value}allDocuments(){return n.Iterable.map(this.c.values(),P=>P.value)}getEditor(P){return this.b.get(P)}activeEditor(P){if(!this.a)return;const v=this.b.get(this.a);return P?v:v?.value}allEditors(){return[...this.b.values()]}};b=qe([Ve(0,k.IExtHostRpcService),Ve(1,m.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[58],Ce([1,0,8,5,2,4,3,7,17,9,62]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class w{constructor(r,d,b){this.e=b,this.d=d,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,d={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(S.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(S.URI.revive(this.b.input.base),S.URI.revive(this.b.input.input1),S.URI.revive(this.b.input.input2),S.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(S.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(S.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(S.URI.revive(this.b.input.uri),S.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(r,d){this.c=[],this.d="",this.b=r,this.e=d;for(const b of r.tabs)b.isActive&&(this.d=b.id),this.c.push(new w(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,d={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return i.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(b=>b.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(b=>b.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const b=new w(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,b),r.tabDto.isActive&&(this.d=b.tabId),b}else if(r.kind===1){const b=this.c.splice(r.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(r.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,b),b}const d=this.c.find(b=>b.tabId===r.tabDto.id);if(!d)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(r.tabDto),d}activeTabId(){return this.d}}let p=class{constructor(r){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=r.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,d={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(b=>b.apiObject))},get activeTabGroup(){const b=r.d;return(0,k.assertIsDefined)(r.e.find(P=>P.groupId===b)?.apiObject)},close:async(b,E)=>{const P=Array.isArray(b)?b:[b];return P.length?f(P[0])?this.j(P,E):this.i(P,E):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(r){const d=new Set(this.e.map(o=>o.groupId)),b=new Set(r.map(o=>o.groupId)),E=(0,O.diffSets)(d,b),P=this.e.filter(o=>E.removed.includes(o.groupId)).map(o=>o.apiObject),v=[],t=[];this.e=r.map(o=>{const l=new m(o,()=>this.d);return E.added.includes(l.groupId)?v.push(l.apiObject):t.push(l.apiObject),l});const s=(0,k.assertIsDefined)(r.find(o=>o.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:v,closed:P,changed:t}))}$acceptTabGroupUpdate(r){const d=this.e.find(b=>b.groupId===r.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const d=this.e.find(E=>E.groupId===r.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const b=d.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(r){for(const d of this.e)for(const b of d.tabs)if(b.apiObject===r)return b}h(r){return this.e.find(d=>d.apiObject===r)}async i(r,d){const b=[];for(const E of r){const P=this.g(E);if(!P)throw new Error("Tab close: Invalid tab not found!");b.push(P.tabId)}return this.a.$closeTab(b,d)}async j(r,d){const b=[];for(const E of r){const P=this.h(E);if(!P)throw new Error("Group close: Invalid group not found!");b.push(P.groupId)}return this.a.$closeGroup(b,d)}};p=qe([Ve(0,y.IExtHostRpcService)],p),e.ExtHostEditorTabs=p;function f(n){return n.tabs!==void 0}}),define(Ie[212],Ce([1,0,2,5,6,7,8,257,10,25,24]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const n=this.a.indexOf(f);n>=0&&(this.a.splice(n,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),n=[];let r,d,b=14,E=14;for(const P of f){let v=r?(0,y.commonPrefixLength)(r,P):0;for(v===0?d=1:d=E;v<P.length;v++)v+1===P.length?(b=E,E=9):E+=1,n.push([d,P.toUpperCase().charCodeAt(v),E]),n.push([d,P.toLowerCase().charCodeAt(v),E]),d=E;r=P,E=b}n.push([9,58,10]),n.push([10,47,12]),this.b=new R.StateMachine(n)}}provideDocumentLinks(f){this.c();const n=[],r=R.LinkComputer.computeLinks({getLineContent(d){return f.lineAt(d-1).text},getLineCount(){return f.lineCount}},this.b);for(const d of r){const b=I.DocumentLink.to(d);b.target&&n.push(b)}return n}}class m{constructor(f,n){this.i=n,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,n,r,d={}){if(this.d.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const b=this.h++;this.b.add(n),this.d.add(n),this.c.set(b,r);let E=2;d.isCaseSensitive&&(E+=1024),d.isReadonly&&(E+=2048),typeof r.copy=="function"&&(E+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(b,n,E).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${n}`),console.error(v)});const P=r.onDidChangeFile(v=>{const t=[];for(const s of v){const{uri:o,type:l}=s;if(o.scheme!==n)continue;let a;switch(l){case L.FileChangeType.Changed:a=0;break;case L.FileChangeType.Created:a=1;break;case L.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:o,type:a})}this.a.$onFileSystemChange(b,t)});return(0,S.toDisposable)(()=>{P.dispose(),this.b.delete(n),this.d.delete(n),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(f){const{type:n,ctime:r,mtime:d,size:b,permissions:E}=f;return{type:n,ctime:r,mtime:d,size:b,permissions:E}}$stat(f,n){return Promise.resolve(this.k(f).stat(i.URI.revive(n))).then(r=>m.j(r))}$readdir(f,n){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(n)))}$readFile(f,n){return Promise.resolve(this.k(f).readFile(i.URI.revive(n))).then(r=>k.VSBuffer.wrap(r))}$writeFile(f,n,r,d){return Promise.resolve(this.k(f).writeFile(i.URI.revive(n),r.buffer,d))}$delete(f,n,r){return Promise.resolve(this.k(f).delete(i.URI.revive(n),r))}$rename(f,n,r,d){return Promise.resolve(this.k(f).rename(i.URI.revive(n),i.URI.revive(r),d))}$copy(f,n,r,d){const b=this.k(f);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(i.URI.revive(n),i.URI.revive(r),d))}$mkdir(f,n){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(n)))}$watch(f,n,r,d){const b=this.k(f).watch(i.URI.revive(r),d);this.f.set(n,b)}$unwatch(f,n){const r=this.f.get(n);r&&(r.dispose(),this.f.delete(n))}$open(f,n,r){const d=this.k(f);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(i.URI.revive(n),r))}$close(f,n){const r=this.k(f);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(n))}$read(f,n,r,d){const b=this.k(f);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(d);return Promise.resolve(b.read(n,r,E.buffer,0,d)).then(P=>E.slice(0,P))}$write(f,n,r,d){const b=this.k(f);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(n,r,d.buffer,0,d.byteLength))}k(f){const n=this.c.get(f);if(!n){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return n}}e.ExtHostFileSystem=m}),define(Ie[59],Ce([1,0,5,36,7,25,3,17,37,6]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Zt{constructor(m,p){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(n){try{const r=f.b.get(n.scheme);if(!r)return await f.a.$stat(n);await f.a.$ensureActivation(n.scheme);const d=await r.stat(n);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(r){Zt.c(r)}},async readDirectory(n){try{const r=f.b.get(n.scheme);return r?(await f.a.$ensureActivation(n.scheme),(await r.readDirectory(n)).slice()):await f.a.$readdir(n)}catch(r){return Zt.c(r)}},async createDirectory(n){try{return await f.a.$mkdir(n)}catch(r){return Zt.c(r)}},async readFile(n){try{const r=f.b.get(n.scheme);return r?(await f.a.$ensureActivation(n.scheme),(await r.readFile(n)).slice()):(await f.a.$readFile(n)).buffer}catch(r){return Zt.c(r)}},async writeFile(n,r){try{return await f.a.$writeFile(n,L.VSBuffer.wrap(r))}catch(d){return Zt.c(d)}},async delete(n,r){try{const d=f.b.get(n.scheme);return d?(await f.a.$ensureActivation(n.scheme),await d.delete(n,{recursive:!1,...r})):await f.a.$delete(n,{recursive:!1,useTrash:!1,...r})}catch(d){return Zt.c(d)}},async rename(n,r,d){try{return await f.a.$rename(n,r,{overwrite:!1,...d})}catch(b){return Zt.c(b)}},async copy(n,r,d){try{return await f.a.$copy(n,r,{overwrite:!1,...d})}catch(b){return Zt.c(b)}},isWritableFileSystem(n){const r=p.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}static c(m){if(m instanceof S.FileSystemError)throw m;if(!(m instanceof Error))throw new S.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw S.FileSystemError.Unavailable(m.message);switch(m.name){case C.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(m.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(m.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(m.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(m.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(m.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(m.message);default:throw new S.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,p){return this.b.set(m,p),(0,k.toDisposable)(()=>this.b.delete(m))}};O=qe([Ve(0,R.IExtHostRpcService),Ve(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[213],Ce([1,0,4,35,2,5,8,7]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,m,p,f,n,r,d,b){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(w,p,n);this.g=0,r&&(this.g+=1),d&&(this.g+=2),b&&(this.g+=4);const P=(0,C.parse)(n),v=typeof n=="string",t=f(s=>{if(!r)for(const o of s.created){const l=S.URI.revive(o);P(l.fsPath)&&(!v||m.getWorkspaceFolder(l))&&this.a.fire(l)}if(!d)for(const o of s.changed){const l=S.URI.revive(o);P(l.fsPath)&&(!v||m.getWorkspaceFolder(l))&&this.b.fire(l)}if(!b)for(const o of s.deleted){const l=S.URI.revive(o);P(l.fsPath)&&(!v||m.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=R.Disposable.from(E,this.a,this.b,this.c,t)}h(w,m,p){const f=R.Disposable.from();if(typeof p=="string")return f;const n=w.getProxy(L.MainContext.MainThreadFileSystem);let r=!1;(p.pattern.includes(C.GLOBSTAR)||p.pattern.includes(C.GLOB_SPLIT))&&(r=!0);const d=Math.random();return n.$watch(m.identifier.value,d,p.baseUri,{recursive:r,excludes:[]}),R.Disposable.from({dispose:()=>n.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(w,m,p){this.j=w,this.k=m,this.l=p,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,p,f,n,r){return new y(this.j,w,m,this.a.event,I.GlobPattern.from(p),f,n,r)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(p=>({oldUri:S.URI.revive(p.source),newUri:S.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(p=>S.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(p=>S.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(p,f,n)=>{const r=function(b){p.call(f,b)};return r.extension=w,m.event(r,void 0,n)}}async $onWillRunFileOperation(w,m,p,f){switch(w){case 2:return await this.n(this.g,{files:m.map(n=>({oldUri:S.URI.revive(n.source),newUri:S.URI.revive(n.target)}))},p,f);case 1:return await this.n(this.i,{files:m.map(n=>S.URI.revive(n.target))},p,f);case 0:case 3:return await this.n(this.h,{files:m.map(n=>S.URI.revive(n.target))},p,f)}}async n(w,m,p,f){const n=new Set,r=[];if(await w.fireAsync(m,f,async(b,E)=>{const P=Date.now(),v=await Promise.resolve(b);v instanceof R.WorkspaceEdit&&(r.push([E.extension,v]),n.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-P>p&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||r.length===0)return;const d={edits:[]};for(const[,b]of r){const{edits:E}=I.WorkspaceEdit.from(b,{getTextDocumentVersion:P=>this.l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(E)}return{edit:d,extensionNames:Array.from(n)}}}e.ExtHostFileSystemEventService=k}),define(Ie[214],Ce([1,0,2,38]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(I,R,y,k,O){this.a=R,this.b=y,this.c=k;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new C.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new C.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new C.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new C.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const p=this.a.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:p.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(I,R,y,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=S}),define(Ie[215],Ce([1,0,6,5]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(I){this.b=0,this.a=I.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,I),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=S}),define(Ie[216],Ce([1,0,2,22,8,7,75,5,10,56,18,9,258,21,6,87,83,53,77,11,12,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(D,B){this.d=D,this.e=B}async provideDocumentSymbols(D,B){const W=this.d.getDocument(D),K=await this.e.provideDocumentSymbols(W,B);if(!(0,O.isFalsyOrEmpty)(K))return K[0]instanceof L.DocumentSymbol?K.map(S.DocumentSymbol.from):t.f(K)}static f(D){D=D.slice(0).sort((K,Z)=>{let he=K.location.range.start.compareTo(Z.location.range.start);return he===0&&(he=Z.location.range.end.compareTo(K.location.range.end)),he});const B=[],W=[];for(const K of D){const Z={name:K.name||"!!MISSING: name!!",kind:S.SymbolKind.from(K.kind),tags:K.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:S.Range.from(K.location.range),selectionRange:S.Range.from(K.location.range),children:[]};for(;;){if(W.length===0){W.push(Z),B.push(Z);break}const he=W[W.length-1];if(k.Range.containsRange(he.range,Z.range)&&!k.Range.equalsRange(he.range,Z.range)){he.children?.push(Z),W.push(Z);break}W.pop()}}return B}}class s{constructor(D,B,W){this.g=D,this.h=B,this.j=W,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(D,B){const W=this.g.getDocument(D),K=await this.j.provideCodeLenses(W,B);if(!K||B.isCancellationRequested)return;const Z=this.e.add(K),he=new f.DisposableStore;this.f.set(Z,he);const ye={cacheId:Z,lenses:[]};for(let ae=0;ae<K.length;ae++)ye.lenses.push({cacheId:[Z,ae],range:S.Range.from(K[ae].range),command:this.h.toInternal(K[ae].command,he)});return ye}async resolveCodeLens(D,B){const W=D.cacheId&&this.e.get(...D.cacheId);if(!W)return;let K;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?K=W:K=await this.j.resolveCodeLens(W,B),K||(K=W),B.isCancellationRequested)return;const Z=D.cacheId&&this.f.get(D.cacheId[0]);if(!!Z)return D.command=this.h.toInternal(K.command??s.d,Z),D}releaseCodeLenses(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}}s.d={command:"missing",title:"!!MISSING: command!!"};function o(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class l{constructor(D,B){this.d=D,this.e=B}async provideDefinition(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideDefinition(K,Z,W);return o(he)}}class a{constructor(D,B){this.d=D,this.e=B}async provideDeclaration(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideDeclaration(K,Z,W);return o(he)}}class h{constructor(D,B){this.d=D,this.e=B}async provideImplementation(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideImplementation(K,Z,W);return o(he)}}class c{constructor(D,B){this.d=D,this.e=B}async provideTypeDefinition(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideTypeDefinition(K,Z,W);return o(he)}}class u{constructor(D,B){this.d=D,this.e=B}async provideHover(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideHover(K,Z,W);if(!(!he||(0,O.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=K.getWordRangeAtPosition(Z)),he.range||(he.range=new L.Range(Z,Z)),S.Hover.from(he)}}class g{constructor(D,B){this.d=D,this.e=B}async provideEvaluatableExpression(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideEvaluatableExpression(K,Z,W);if(he)return S.EvaluatableExpression.from(he)}}class A{constructor(D,B){this.d=D,this.e=B}async provideInlineValues(D,B,W,K){const Z=this.d.getDocument(D),he=await this.e.provideInlineValues(Z,S.Range.to(B),S.InlineValueContext.to(W),K);if(Array.isArray(he))return he.map(ye=>S.InlineValue.from(ye))}}class N{constructor(D,B){this.d=D,this.e=B}async provideDocumentHighlights(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideDocumentHighlights(K,Z,W);if(Array.isArray(he))return he.map(S.DocumentHighlight.from)}}class q{constructor(D,B){this.d=D,this.e=B}async provideLinkedEditingRanges(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideLinkedEditingRanges(K,Z,W);if(he&&Array.isArray(he.ranges))return{ranges:(0,O.coalesce)(he.ranges.map(S.Range.from)),wordPattern:he.wordPattern}}}class te{constructor(D,B){this.d=D,this.e=B}async provideReferences(D,B,W,K){const Z=this.d.getDocument(D),he=S.Position.to(B),ye=await this.e.provideReferences(Z,he,W,K);if(Array.isArray(ye))return ye.map(S.location.from)}}class x{constructor(D,B,W,K,Z,he,ye){this.g=D,this.h=B,this.j=W,this.k=K,this.l=Z,this.m=he,this.n=ye,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(D,B,W,K){const Z=this.g.getDocument(D),he=m.Selection.isISelection(B)?S.Selection.to(B):S.Range.to(B),ye=[];for(const tt of this.j.getDiagnostics(D))if(he.intersection(tt.range)&&ye.push(tt)>x.d)break;const ae={diagnostics:ye,only:W.only?new L.CodeActionKind(W.only):void 0,triggerKind:S.CodeActionTriggerKind.to(W.trigger)},be=await this.k.provideCodeActions(Z,he,ae,K);if(!(0,O.isNonEmptyArray)(be)||K.isCancellationRequested)return;const Ee=this.e.add(be),We=new f.DisposableStore;this.f.set(Ee,We);const He=[];for(let tt=0;tt<be.length;tt++){const Xe=be[tt];!Xe||(x.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(S.Diagnostic.from),edit:Xe.edit&&S.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(D,B){const[W,K]=D,Z=this.e.get(W,K);if(!Z||x.o(Z)||!this.k.resolveCodeAction)return;const he=await this.k.resolveCodeAction(Z,B)??Z;return he?.edit?S.WorkspaceEdit.from(he.edit,void 0):void 0}releaseCodeActions(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}static o(D){return typeof D.command=="string"&&typeof D.title=="string"}}x.d=1e3;class F{constructor(D,B,W,K){this.d=D,this.e=B,this.f=W,this.g=K}async prepareDocumentPaste(D,B,W,K){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(D),he=B.map(ae=>S.Range.to(ae)),ye=S.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(Z,he,ye,K),S.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(D,B,W,K,Z){const he=this.e.getDocument(B),ye=W.map(Ee=>S.Range.to(Ee)),ae=S.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolvePasteFileData(this.g,D,Ee)).buffer),be=await this.f.provideDocumentPasteEdits(he,ye,ae,Z);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?S.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class ${constructor(D,B){this.d=D,this.e=B}async provideDocumentFormattingEdits(D,B,W){const K=this.d.getDocument(D),Z=await this.e.provideDocumentFormattingEdits(K,B,W);if(Array.isArray(Z))return Z.map(S.TextEdit.from)}}class T{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeFormattingEdits(D,B,W,K){const Z=this.d.getDocument(D),he=S.Range.to(B),ye=await this.e.provideDocumentRangeFormattingEdits(Z,he,W,K);if(Array.isArray(ye))return ye.map(S.TextEdit.from)}}class M{constructor(D,B){this.d=D,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,B,W,K,Z){const he=this.d.getDocument(D),ye=S.Position.to(B),ae=await this.e.provideOnTypeFormattingEdits(he,ye,W,K,Z);if(Array.isArray(ae))return ae.map(S.TextEdit.from)}}class V{constructor(D,B){this.e=D,this.f=B,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,B){const W=await this.e.provideWorkspaceSymbols(D,B);if(!(0,O.isNonEmptyArray)(W))return{symbols:[]};const K=this.d.add(W),Z={cacheId:K,symbols:[]};for(let he=0;he<W.length;he++){const ye=W[he];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Z.symbols.push({...S.WorkspaceSymbol.from(ye),cacheId:[K,he]})}return Z}async resolveWorkspaceSymbol(D,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const W=this.d.get(...D.cacheId);if(W){const K=await this.e.resolveWorkspaceSymbol(W,B);return K&&(0,C.mixin)(D,S.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(D){this.d.delete(D)}}class j{static supportsResolving(D){return typeof D.prepareRename=="function"}constructor(D,B,W){this.d=D,this.e=B,this.f=W}async provideRenameEdits(D,B,W,K){const Z=this.d.getDocument(D),he=S.Position.to(B);try{const ye=await this.e.provideRenameEdits(Z,he,W,K);return ye?S.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=j.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(D,B,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(D),Z=S.Position.to(B);try{const he=await this.e.prepareRename(K,Z,W);let ye,ae;if(L.Range.isRange(he)?(ye=he,ae=K.getText(he)):(0,w.isObject)(he)&&(ye=he.range,ae=he.placeholder),!ye||!ae)return;if(ye.start.line>Z.line||ye.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ye),text:ae}}catch(he){const ye=j.g(he);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(he)}}static g(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class le{constructor(D,B){this.resultId=D,this.tokens=B}}class Y{constructor(D,B){this.f=D,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(D,B,W){const K=this.f.getDocument(D),Z=B!==0?this.d.get(B):null;let he=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,Z.resultId,W):await this.g.provideDocumentSemanticTokens(K,W);return Z&&this.d.delete(B),he?(he=Y.h(he),this.o(Y.n(Z,he),he)):null}async releaseDocumentSemanticColoring(D){this.d.delete(D)}static h(D){return Y.j(D)?Y.k(D)?D:new L.SemanticTokens(new Uint32Array(D.data),D.resultId):Y.l(D)?Y.m(D)?D:new L.SemanticTokensEdits(D.edits.map(B=>new L.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),D.resultId):D}static j(D){return D&&!!D.data}static k(D){return D.data instanceof Uint32Array}static l(D){return D&&Array.isArray(D.edits)}static m(D){for(const B of D.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(D,B){if(!Y.j(B)||!D||!D.tokens)return B;const W=D.tokens,K=W.length,Z=B.data,he=Z.length;let ye=0;const ae=Math.min(K,he);for(;ye<ae&&W[ye]===Z[ye];)ye++;if(ye===K&&ye===he)return new L.SemanticTokensEdits([],B.resultId);let be=0;const Ee=ae-ye;for(;be<Ee&&W[K-be-1]===Z[he-be-1];)be++;return new L.SemanticTokensEdits([{start:ye,deleteCount:K-ye-be,data:Z.subarray(ye,he-be)}],B.resultId)}o(D,B){if(Y.j(D)){const W=this.e++;return this.d.set(W,new le(D.resultId,D.data)),(0,n.encodeSemanticTokensDto)({id:W,type:"full",data:D.data})}if(Y.l(D)){const W=this.e++;return Y.j(B)?this.d.set(W,new le(B.resultId,B.data)):this.d.set(W,new le(D.resultId)),(0,n.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(D.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class pe{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeSemanticTokens(D,B,W){const K=this.d.getDocument(D),Z=await this.e.provideDocumentRangeSemanticTokens(K,S.Range.to(B),W);return Z?this.f(Z):null}f(D){return(0,n.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}class ue{static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}constructor(D,B,W,K,Z){this.f=D,this.g=B,this.h=W,this.j=K,this.k=Z,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(D,B,W,K){const Z=this.f.getDocument(D),he=S.Position.to(B),ye=Z.getWordRangeAtPosition(he)||new L.Range(he,he),ae=ye.with({end:he}),be=new b.StopWatch(!0),Ee=await this.h.provideCompletionItems(Z,he,K,S.CompletionContext.to(W));if(!Ee||K.isCancellationRequested)return;const We=Array.isArray(Ee)?new L.CompletionList(Ee):Ee,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:S.Range.from(ye),insert:S.Range.from(ae)},c:We.isIncomplete||void 0,d:be.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,ye);Xe.push(Fe)}return et}async resolveCompletionItem(D,B){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.h.resolveCompletionItem(W,B);if(!!K)return this.l(K,D)}releaseCompletionItems(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B,W,K){const Z=this.e.get(B[0]);if(!Z)throw Error("DisposableStore is missing...");const he=this.g.toInternal(D.command,Z),ye={x:B,a:D.label,b:D.kind!==void 0?S.CompletionItemKind.from(D.kind):void 0,m:D.tags&&D.tags.map(S.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:S.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters?.join(""),l:D.additionalTextEdits&&D.additionalTextEdits.map(S.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};D.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=D.textEdit.newText):typeof D.insertText=="string"?ye.h=D.insertText:D.insertText instanceof L.SnippetString&&(ye.h=D.insertText.value,ye.i|=4);let ae;return D.textEdit?ae=D.textEdit.range:D.range&&(ae=D.range),L.Range.isRange(ae)?ye.j=S.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!K?.isEqual(ae.replacing))&&(ye.j={insert:S.Range.from(ae.inserting),replace:S.Range.from(ae.replacing)}),ye}}class de{async provideInlineCompletions(D,B,W,K){}disposeCompletions(D){}handleDidShowCompletionItem(D,B){}}class re extends de{constructor(D,B,W,K){super(),this.f=D,this.g=B,this.h=W,this.j=K,this.d=new G,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(D,B,W,K){const Z=this.g.getDocument(D),he=S.Position.to(B),ye=await this.h.provideInlineCompletionItems(Z,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:S.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},K);if(!ye||K.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(Ee||(Ee=new f.DisposableStore),Xe=this.j.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?S.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:be.map(He=>(Ee||(Ee=new f.DisposableStore),this.j.toInternal(He,Ee)))}}disposeCompletions(D){this.d.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,B){const W=this.d.get(D)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(D){const B=this.e++;return this.d.set(B,D),B}disposeReferenceId(D){const B=this.d.get(D);return this.d.delete(D),B}get(D){return this.d.get(D)}}class H{constructor(D,B){this.e=D,this.f=B,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(D,B,W,K){const Z=this.e.getDocument(D),he=S.Position.to(B),ye=this.g(W),ae=await this.f.provideSignatureHelp(Z,he,K,ye);if(ae){const be=this.d.add([ae]);return{...S.SignatureHelp.from(ae),id:be}}}g(D){let B;if(D.activeSignatureHelp){const W=S.SignatureHelp.to(D.activeSignatureHelp),K=this.d.get(D.activeSignatureHelp.id,0);K?(B=K,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...D,activeSignatureHelp:B}}releaseSignatureHelp(D){this.d.delete(D)}}class oe{constructor(D,B,W,K,Z){this.f=D,this.g=B,this.h=W,this.j=K,this.k=Z,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(D,B,W){const K=this.f.getDocument(D),Z=S.Range.to(B),he=await this.h.provideInlayHints(K,Z,W);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(he);this.e.set(ye,new f.DisposableStore);const ae={hints:[],cacheId:ye};for(let be=0;be<he.length;be++)this.l(he[be],Z)&&ae.hints.push(this.m(he[be],[ye,be]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),ae}async resolveInlayHint(D,B){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.h.resolveInlayHint(W,B);if(!!K&&!!this.l(K))return this.m(K,D)}releaseHints(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B){return D.label.length===0||Array.isArray(D.label)&&D.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(B&&!B.contains(D.position))}m(D,B){const W=this.e.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const K={label:"",cacheId:B,tooltip:S.MarkdownString.fromStrict(D.tooltip),position:S.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(S.TextEdit.from),kind:D.kind&&S.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?K.label=D.label:K.label=D.label.map(Z=>{const he={label:Z.value};return he.tooltip=S.MarkdownString.fromStrict(Z.tooltip),L.Location.isLocation(Z.location)&&(he.location=S.location.from(Z.location)),Z.command&&(he.command=this.g.toInternal(Z.command,W)),he}),K}}class ve{constructor(D,B){this.e=D,this.f=B,this.d=new d.Cache("DocumentLink")}async provideLinks(D,B){const W=this.e.getDocument(D),K=await this.f.provideDocumentLinks(W,B);if(!(!Array.isArray(K)||K.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ve.g).map(S.DocumentLink.from)};{const Z=this.d.add(K),he={links:[],cacheId:Z};for(let ye=0;ye<K.length;ye++){if(!ve.g(K[ye]))continue;const ae=S.DocumentLink.from(K[ye]);ae.cacheId=[Z,ye],he.links.push(ae)}return he}}}static g(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,B){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.f.resolveDocumentLink(W,B);if(!(!K||!ve.g(K)))return S.DocumentLink.from(K)}releaseLinks(D){this.d.delete(D)}}class Ae{constructor(D,B){this.d=D,this.e=B}async provideColors(D,B){const W=this.d.getDocument(D),K=await this.e.provideDocumentColors(W,B);return Array.isArray(K)?K.map(he=>({color:S.Color.from(he.color),range:S.Range.from(he.range)})):[]}async provideColorPresentations(D,B,W){const K=this.d.getDocument(D),Z=S.Range.to(B.range),he=S.Color.to(B.color),ye=await this.e.provideColorPresentations(he,{document:K,range:Z},W);if(!!Array.isArray(ye))return ye.map(S.ColorPresentation.from)}}class Be{constructor(D,B){this.d=D,this.e=B}async provideFoldingRanges(D,B,W){const K=this.d.getDocument(D),Z=await this.e.provideFoldingRanges(K,B,W);if(!!Array.isArray(Z))return Z.map(S.FoldingRange.from)}}class xe{constructor(D,B,W){this.d=D,this.e=B,this.f=W}async provideSelectionRanges(D,B,W){const K=this.d.getDocument(D),Z=B.map(S.Position.to),he=await this.e.provideSelectionRanges(K,Z,W);if(!(0,O.isNonEmptyArray)(he))return[];if(he.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<Z.length;ae++){const be=[];ye.push(be);let Ee=Z[ae],We=he[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(be.push(S.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Te{constructor(D,B){this.f=D,this.g=B,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(D,B,W){const K=this.f.getDocument(D),Z=S.Position.to(B),he=await this.g.prepareCallHierarchy(K,Z,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideCallsTo(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(K,W);if(!!Z)return Z.map(he=>({from:this.h(D,he.from),fromRanges:he.fromRanges.map(ye=>S.Range.from(ye))}))}async provideCallsFrom(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(K,W);if(!!Z)return Z.map(he=>({to:this.h(D,he.to),fromRanges:he.fromRanges.map(ye=>S.Range.from(ye))}))}releaseSession(D){this.e.delete(D)}h(D,B){const W=this.e.get(D),K=S.CallHierarchyItem.from(B,D,W.size.toString(36));return W.set(K._itemId,B),K}j(D,B){return this.e.get(D)?.get(B)}}class Se{constructor(D,B){this.f=D,this.g=B,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(D,B,W){const K=this.f.getDocument(D),Z=S.Position.to(B),he=await this.g.prepareTypeHierarchy(K,Z,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideSupertypes(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(K,W);if(!!Z)return Z.map(he=>this.h(D,he))}async provideSubtypes(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(K,W);if(!!Z)return Z.map(he=>this.h(D,he))}releaseSession(D){this.e.delete(D)}h(D,B){const W=this.e.get(D),K=S.TypeHierarchyItem.from(B,D,W.size.toString(36));return W.set(K._itemId,B),K}j(D,B){return this.e.get(D)?.get(B)}}class ke{constructor(D,B,W,K){this.d=D,this.e=B,this.f=W,this.g=K}async provideDocumentOnDropEdits(D,B,W,K,Z){const he=this.e.getDocument(B),ye=S.Position.to(W),ae=S.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,D,Ee)).buffer),be=await this.f.provideDocumentDropEdits(he,ye,ae,Z);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?S.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class se{constructor(D,B){this.adapter=D,this.extension=B}}class ce{constructor(D,B,W,K,Z,he,ye,ae){this.g=B,this.h=W,this.j=K,this.k=Z,this.l=he,this.m=ye,this.n=ae,this.f=new Map,this.e=D.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(D){return S.DocumentSelector.from(D,this.g)}p(D){return new L.Disposable(()=>{this.f.delete(D),this.e.$unregister(D)})}q(){return ce.d++}async s(D,B,W,K,Z,he=!1){const ye=this.f.get(D);if(!ye||!(ye.adapter instanceof B))return K;const ae=Date.now();he||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const be=W(ye.adapter,ye.extension);return Promise.resolve(be).catch(Ee=>{(0,E.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{he||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),p.CancellationToken.isCancellationToken(Z)?(0,P.raceCancellationError)(be,Z):be}t(D,B){const W=this.q();return this.f.set(W,new se(D,B)),W}static u(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,B,W,K){const Z=this.t(new t(this.h,W),D),he=K&&K.label||ce.u(D);return this.e.$registerDocumentSymbolProvider(Z,this.o(B),he),this.p(Z)}$provideDocumentSymbols(D,B,W){return this.s(D,t,K=>K.provideDocumentSymbols(i.URI.revive(B),W),void 0,W)}registerCodeLensProvider(D,B,W){const K=this.q(),Z=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new se(new s(this.h,this.j.converter,W),D)),this.e.$registerCodeLensSupport(K,this.o(B),Z);let he=this.p(K);if(Z!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(Z));he=L.Disposable.from(he,ye)}return he}$provideCodeLenses(D,B,W){return this.s(D,s,K=>K.provideCodeLenses(i.URI.revive(B),W),void 0,W)}$resolveCodeLens(D,B,W){return this.s(D,s,K=>K.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(D,B){this.s(D,s,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(D,B,W){const K=this.t(new l(this.h,W),D);return this.e.$registerDefinitionSupport(K,this.o(B)),this.p(K)}$provideDefinition(D,B,W,K){return this.s(D,l,Z=>Z.provideDefinition(i.URI.revive(B),W,K),[],K)}registerDeclarationProvider(D,B,W){const K=this.t(new a(this.h,W),D);return this.e.$registerDeclarationSupport(K,this.o(B)),this.p(K)}$provideDeclaration(D,B,W,K){return this.s(D,a,Z=>Z.provideDeclaration(i.URI.revive(B),W,K),[],K)}registerImplementationProvider(D,B,W){const K=this.t(new h(this.h,W),D);return this.e.$registerImplementationSupport(K,this.o(B)),this.p(K)}$provideImplementation(D,B,W,K){return this.s(D,h,Z=>Z.provideImplementation(i.URI.revive(B),W,K),[],K)}registerTypeDefinitionProvider(D,B,W){const K=this.t(new c(this.h,W),D);return this.e.$registerTypeDefinitionSupport(K,this.o(B)),this.p(K)}$provideTypeDefinition(D,B,W,K){return this.s(D,c,Z=>Z.provideTypeDefinition(i.URI.revive(B),W,K),[],K)}registerHoverProvider(D,B,W,K){const Z=this.t(new u(this.h,W),D);return this.e.$registerHoverProvider(Z,this.o(B)),this.p(Z)}$provideHover(D,B,W,K){return this.s(D,u,Z=>Z.provideHover(i.URI.revive(B),W,K),void 0,K)}registerEvaluatableExpressionProvider(D,B,W,K){const Z=this.t(new g(this.h,W),D);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(B)),this.p(Z)}$provideEvaluatableExpression(D,B,W,K){return this.s(D,g,Z=>Z.provideEvaluatableExpression(i.URI.revive(B),W,K),void 0,K)}registerInlineValuesProvider(D,B,W,K){const Z=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new A(this.h,W),D);this.e.$registerInlineValuesProvider(he,this.o(B),Z);let ye=this.p(he);if(Z!==void 0){const ae=W.onDidChangeInlineValues(be=>this.e.$emitInlineValuesEvent(Z));ye=L.Disposable.from(ye,ae)}return ye}$provideInlineValues(D,B,W,K,Z){return this.s(D,A,he=>he.provideInlineValues(i.URI.revive(B),W,K,Z),void 0,Z)}registerDocumentHighlightProvider(D,B,W){const K=this.t(new N(this.h,W),D);return this.e.$registerDocumentHighlightProvider(K,this.o(B)),this.p(K)}$provideDocumentHighlights(D,B,W,K){return this.s(D,N,Z=>Z.provideDocumentHighlights(i.URI.revive(B),W,K),void 0,K)}registerLinkedEditingRangeProvider(D,B,W){const K=this.t(new q(this.h,W),D);return this.e.$registerLinkedEditingRangeProvider(K,this.o(B)),this.p(K)}$provideLinkedEditingRanges(D,B,W,K){return this.s(D,q,async Z=>{const he=await Z.provideLinkedEditingRanges(i.URI.revive(B),W,K);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ce.w(he.wordPattern):void 0}},void 0,K)}registerReferenceProvider(D,B,W){const K=this.t(new te(this.h,W),D);return this.e.$registerReferenceSupport(K,this.o(B)),this.p(K)}$provideReferences(D,B,W,K,Z){return this.s(D,te,he=>he.provideReferences(i.URI.revive(B),W,K,Z),void 0,Z)}registerCodeActionProvider(D,B,W,K){const Z=new f.DisposableStore,he=this.t(new x(this.h,this.j.converter,this.k,W,this.l,D,this.m),D);return this.e.$registerQuickFixSupport(he,this.o(B),{providedKinds:K?.providedCodeActionKinds?.map(ye=>ye.value),documentation:K?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Z)}))},ce.u(D),Boolean(W.resolveCodeAction)),Z.add(this.p(he)),Z}$provideCodeActions(D,B,W,K,Z){return this.s(D,x,he=>he.provideCodeActions(i.URI.revive(B),W,K,Z),void 0,Z)}$resolveCodeAction(D,B,W){return this.s(D,x,K=>K.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(D,B){this.s(D,x,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(D,B,W){const K=this.t(new $(this.h,W),D);return this.e.$registerDocumentFormattingSupport(K,this.o(B),D.identifier,D.displayName||D.name),this.p(K)}$provideDocumentFormattingEdits(D,B,W,K){return this.s(D,$,Z=>Z.provideDocumentFormattingEdits(i.URI.revive(B),W,K),void 0,K)}registerDocumentRangeFormattingEditProvider(D,B,W){const K=this.t(new T(this.h,W),D);return this.e.$registerRangeFormattingSupport(K,this.o(B),D.identifier,D.displayName||D.name),this.p(K)}$provideDocumentRangeFormattingEdits(D,B,W,K,Z){return this.s(D,T,he=>he.provideDocumentRangeFormattingEdits(i.URI.revive(B),W,K,Z),void 0,Z)}registerOnTypeFormattingEditProvider(D,B,W,K){const Z=this.t(new M(this.h,W),D);return this.e.$registerOnTypeFormattingSupport(Z,this.o(B),K,D.identifier),this.p(Z)}$provideOnTypeFormattingEdits(D,B,W,K,Z,he){return this.s(D,M,ye=>ye.provideOnTypeFormattingEdits(i.URI.revive(B),W,K,Z,he),void 0,he)}registerWorkspaceSymbolProvider(D,B){const W=this.t(new V(B,this.l),D);return this.e.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(D,B,W){return this.s(D,V,K=>K.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(D,B,W){return this.s(D,V,K=>K.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(D,B){this.s(D,V,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(D,B,W){const K=this.t(new j(this.h,W,this.l),D);return this.e.$registerRenameSupport(K,this.o(B),j.supportsResolving(W)),this.p(K)}$provideRenameEdits(D,B,W,K,Z){return this.s(D,j,he=>he.provideRenameEdits(i.URI.revive(B),W,K,Z),void 0,Z)}$resolveRenameLocation(D,B,W,K){return this.s(D,j,Z=>Z.resolveRenameLocation(i.URI.revive(B),W,K),void 0,K)}registerDocumentSemanticTokensProvider(D,B,W,K){const Z=this.t(new Y(this.h,W),D),he=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(B),K,he);let ye=this.p(Z);if(he){const ae=W.onDidChangeSemanticTokens(be=>this.e.$emitDocumentSemanticTokensEvent(he));ye=L.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(D,B,W,K){return this.s(D,Y,Z=>Z.provideDocumentSemanticTokens(i.URI.revive(B),W,K),null,K)}$releaseDocumentSemanticTokens(D,B){this.s(D,Y,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,B,W,K){const Z=this.t(new pe(this.h,W),D);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(B),K),this.p(Z)}$provideDocumentRangeSemanticTokens(D,B,W,K){return this.s(D,pe,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive(B),W,K),null,K)}registerCompletionItemProvider(D,B,W,K){const Z=this.t(new ue(this.h,this.j.converter,W,this.m,D),D);return this.e.$registerCompletionsProvider(Z,this.o(B),K,ue.supportsResolving(W),`${D.identifier.value}(${K.join("")})`),this.p(Z)}$provideCompletionItems(D,B,W,K,Z){return this.s(D,ue,he=>he.provideCompletionItems(i.URI.revive(B),W,K,Z),void 0,Z)}$resolveCompletionItem(D,B,W){return this.s(D,ue,K=>K.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(D,B){this.s(D,ue,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(D,B,W){const K=new re(D,this.h,W,this.j.converter),Z=this.t(K,D);return this.e.$registerInlineCompletionsSupport(Z,this.o(B),K.supportsHandleDidShowCompletionItem),this.p(Z)}$provideInlineCompletions(D,B,W,K,Z){return this.s(D,de,he=>he.provideInlineCompletions(i.URI.revive(B),W,K,Z),void 0,Z)}$handleInlineCompletionDidShow(D,B,W){this.s(D,de,async K=>{K.handleDidShowCompletionItem(B,W)},void 0,void 0)}$freeInlineCompletionsList(D,B){this.s(D,de,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(D,B,W,K){const Z=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,he=this.t(new H(this.h,W),D);return this.e.$registerSignatureHelpProvider(he,this.o(B),Z),this.p(he)}$provideSignatureHelp(D,B,W,K,Z){return this.s(D,H,he=>he.provideSignatureHelp(i.URI.revive(B),W,K,Z),void 0,Z)}$releaseSignatureHelp(D,B){this.s(D,H,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(D,B,W){const K=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new oe(this.h,this.j.converter,W,this.l,D),D);this.e.$registerInlayHintsProvider(Z,this.o(B),typeof W.resolveInlayHint=="function",K,ce.u(D));let he=this.p(Z);if(K!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(K));he=L.Disposable.from(he,ye)}return he}$provideInlayHints(D,B,W,K){return this.s(D,oe,Z=>Z.provideInlayHints(i.URI.revive(B),W,K),void 0,K)}$resolveInlayHint(D,B,W){return this.s(D,oe,K=>K.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(D,B){this.s(D,oe,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(D,B,W){const K=this.t(new ve(this.h,W),D);return this.e.$registerDocumentLinkProvider(K,this.o(B),typeof W.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(D,B,W){return this.s(D,ve,K=>K.provideLinks(i.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(D,B,W){return this.s(D,ve,K=>K.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(D,B){this.s(D,ve,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(D,B,W){const K=this.t(new Ae(this.h,W),D);return this.e.$registerDocumentColorProvider(K,this.o(B)),this.p(K)}$provideDocumentColors(D,B,W){return this.s(D,Ae,K=>K.provideColors(i.URI.revive(B),W),[],W)}$provideColorPresentations(D,B,W,K){return this.s(D,Ae,Z=>Z.provideColorPresentations(i.URI.revive(B),W,K),void 0,K)}registerFoldingRangeProvider(D,B,W){const K=this.q(),Z=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new se(new Be(this.h,W),D)),this.e.$registerFoldingRangeProvider(K,this.o(B),D.identifier,Z);let he=this.p(K);if(Z!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));he=L.Disposable.from(he,ye)}return he}$provideFoldingRanges(D,B,W,K){return this.s(D,Be,Z=>Z.provideFoldingRanges(i.URI.revive(B),W,K),void 0,K)}registerSelectionRangeProvider(D,B,W){const K=this.t(new xe(this.h,W,this.l),D);return this.e.$registerSelectionRangeProvider(K,this.o(B)),this.p(K)}$provideSelectionRanges(D,B,W,K){return this.s(D,xe,Z=>Z.provideSelectionRanges(i.URI.revive(B),W,K),[],K)}registerCallHierarchyProvider(D,B,W){const K=this.t(new Te(this.h,W),D);return this.e.$registerCallHierarchyProvider(K,this.o(B)),this.p(K)}$prepareCallHierarchy(D,B,W,K){return this.s(D,Te,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(B),W,K)),void 0,K)}$provideCallHierarchyIncomingCalls(D,B,W,K){return this.s(D,Te,Z=>Z.provideCallsTo(B,W,K),void 0,K)}$provideCallHierarchyOutgoingCalls(D,B,W,K){return this.s(D,Te,Z=>Z.provideCallsFrom(B,W,K),void 0,K)}$releaseCallHierarchy(D,B){this.s(D,Te,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(D,B,W){const K=this.t(new Se(this.h,W),D);return this.e.$registerTypeHierarchyProvider(K,this.o(B)),this.p(K)}$prepareTypeHierarchy(D,B,W,K){return this.s(D,Se,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(B),W,K)),void 0,K)}$provideTypeHierarchySupertypes(D,B,W,K){return this.s(D,Se,Z=>Z.provideSupertypes(B,W,K),void 0,K)}$provideTypeHierarchySubtypes(D,B,W,K){return this.s(D,Se,Z=>Z.provideSubtypes(B,W,K),void 0,K)}$releaseTypeHierarchy(D,B){this.s(D,Se,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(D,B,W){const K=this.q();return this.f.set(K,new se(new ke(this.e,this.h,W,K),D)),this.e.$registerDocumentOnDropEditProvider(K,this.o(B)),this.p(K)}$provideDocumentOnDropEdits(D,B,W,K,Z,he){return this.s(D,ke,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(B,i.URI.revive(W),K,Z,he)),void 0,void 0)}registerDocumentPasteEditProvider(D,B,W,K){const Z=this.q();return this.f.set(Z,new se(new F(this.e,this.h,W,Z),D)),this.e.$registerPasteEditProvider(Z,this.o(B),!!W.prepareDocumentPaste,K.pasteMimeTypes),this.p(Z)}$prepareDocumentPaste(D,B,W,K,Z){return this.s(D,F,he=>he.prepareDocumentPaste(i.URI.revive(B),W,K,Z),void 0,Z)}$providePasteEdits(D,B,W,K,Z,he){return this.s(D,F,ye=>ye.providePasteEdits(B,i.URI.revive(W),K,Z,he),void 0,he)}static w(D){return{pattern:D.source,flags:(0,y.regExpFlags)(D)}}static y(D){return{decreaseIndentPattern:ce.w(D.decreaseIndentPattern),increaseIndentPattern:ce.w(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?ce.w(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?ce.w(D.unIndentedLinePattern):void 0}}static z(D){return{beforeText:ce.w(D.beforeText),afterText:D.afterText?ce.w(D.afterText):void 0,previousLineText:D.previousLineText?ce.w(D.previousLineText):void 0,action:D.action}}static B(D){return D.map(ce.z)}setLanguageConfiguration(D,B,W){const{wordPattern:K}=W;if(K&&(0,y.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(B,K):this.h.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const Z=this.q(),he={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(Z,B,he),this.p(Z)}$setWordDefinitions(D){for(const B of D)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[217],Ce([1,0,5,8,7,30,12,6]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,w,m,p){this.c=w,this.d=m,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,w){await this.a.$changeLanguage(O,w);const m=this.c.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,w){const m=O.version,p=C.Position.from(w),f=await this.a.$tokensAtPosition(O.uri,p),n={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new S.Range(w.line,w.character,w.line,w.character)};if(!f)return n;const r={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!r.range.contains(w)||m!==O.version?n:r}createLanguageStatusItem(O,w,m){const p=this.f++,f=this.a,n=this.g,r=`${O.identifier.value}/${w}`;if(n.has(r))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);n.add(r);const d={selector:m,id:w,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const E=new R.DisposableStore,P=()=>{b?.dispose(),b=(0,I.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(p,{id:r,name:d.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===S.LanguageStatusSeverity.Error?L.default.Error:d.severity===S.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:d.command&&this.d.toInternal(d.command,E),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},v={dispose(){E.dispose(),b?.dispose(),f.$removeLanguageStatus(p),n.delete(r)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,P()},get selector(){return d.selector},set selector(t){d.selector=t,P()},get text(){return d.text},set text(t){d.text=t,P()},get detail(){return d.detail},set detail(t){d.detail=t,P()},get severity(){return d.severity},set severity(t){d.severity=t,P()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,P()},get command(){return d.command},set command(t){d.command=t,P()},get busy(){return d.busy},set busy(t){d.busy=t,P()}};return P(),v}}e.ExtHostLanguages=y}),define(Ie[78],Ce([1,0,20,10,2,3,13,5,27,17]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(m,p,f){this.f=f,this.d=new Map,this.a=p.getProxy(R.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,p){const{message:f,args:n,comment:r}=p;if(this.c)return(0,C.format2)(f,n??{});let d=f;r&&r.length>0&&(d+=`/${Array.isArray(r)?r.join():r}`);const b=this.d.get(m)?.contents[d];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,C.format2)(b??f,n??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let p;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(f),r=JSON.parse(n);p=m.isBuiltin?r.contents?.bundle:r}catch(n){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${n.message}`);return}p&&this.d.set(m.identifier.value,{contents:p,uri:f})}async g(m){if(m.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return S.URI.revive(p)}return m.l10n?S.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([Ve(0,y.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,I.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ie[218],Ce([1,0,13,5,27,17,2,4,9]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(m,p){super(p.logLevel,R.Event.None),this.g=m.getProxy(C.MainContext.MainThreadLogger)}$setLevel(m,p){p?this.setLevel(I.URI.revive(p),m):(0,y.isUndefined)(m)||this.setLevel(m)}f(m,p,f){return new O(this.g,m,p,f)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends i.AbstractMessageLogger{constructor(m,p,f,n){super(n?.always),this.m=m,this.n=p,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(p,n).then(()=>{this.r(this.l),this.k=!0})}g(m,p){const f=[[m,p]];this.k?this.r(f):this.l.push(...f)}r(m){this.m.$log(this.n,m)}}}),define(Ie[219],Ce([1,0,5,13,24]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(R){return R&&R.title}let I=class{constructor(y,k){this.b=k,this.a=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,k,O,w,m){const p={source:{identifier:y.identifier,label:y.displayName||y.name}};let f;typeof w=="string"||L(w)?f=[w,...m]:(p.modal=w?.modal,p.useCustom=w?.useCustom,p.detail=w?.detail,f=m),p.useCustom&&(0,S.checkProposedApiEnabled)(y,"resolvers");const n=[];for(let r=0;r<f.length;r++){const d=f[r];if(typeof d=="string")n.push({title:d,handle:r,isCloseAffordance:!1});else if(typeof d=="object"){const{title:b,isCloseAffordance:E}=d;n.push({title:b,isCloseAffordance:!!E,handle:r})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(k,O,p,n).then(r=>{if(typeof r=="number")return f[r]})}};I=qe([Ve(1,C.ILogService)],I),e.ExtHostMessageService=I}),define(Ie[220],Ce([1,0,25,4,6,28,10,9,2,53,5,38,8,7,44,193,99]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,P,v,t){this.q=v,this.r=t,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new C.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(O.MainContext.MainThreadNotebook),this.c=E.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=P.converter,P.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const o=s.notebookEditor?.notebookUri,l=s.cell.handle,h=this.g.get(o)?.getCell(l);if(h)return h.apiCell}if(s&&s.$mid===14){const o=s.uri,l=this.g.get(o);if(l)return l.apiNotebook}return s}}),d.x(P)}getEditorById(E){const P=this.h.get(E);if(!P)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return P}getIdByEditor(E){for(const[P,v]of this.h)if(v.apiEditor===E)return P}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,P){const v=this.g.get(E);if(!v&&!P)throw new Error(`NO notebook document for '${E}'`);return v}static s(E,P){if(!P)return;const v=P.filenamePattern.map(t=>m.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(P.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${P.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:P.displayName,filenamePattern:v,exclusive:P.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,P,v){const t=d.a++,s=typeof v.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(t,v),this.b.$registerNotebookCellStatusBarItemProvider(t,s,P);let o;return s!==void 0&&(o=v.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(s))),new p.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,s),o?.dispose()})}async createNotebookDocument(E){const P=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return y.URI.revive(P)}async openNotebookDocument(E){const P=this.g.get(E);if(P)return P.apiNotebook;const v=await this.c.$tryOpenNotebook(E),t=this.g.get(y.URI.revive(v));return(0,R.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(E,P){y.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let v;typeof P=="object"?v={position:m.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selections:P.selections&&P.selections.map(m.NotebookRange.from),pinned:typeof P.preview=="boolean"?!P.preview:void 0}:v={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,v),s=t&&this.h.get(t)?.apiEditor;if(s)return s;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,P,v,t){const s=this.f.get(E),o=y.URI.revive(P),l=this.g.get(o);if(!l||!s)return;const a=l.getCellFromIndex(v);if(!a)return;const h=await s.provideCellStatusBarItems(a.apiCell,t);if(!h)return;const c=new S.DisposableStore,u=this.p.add([c]),A=(Array.isArray(h)?h:[h]).map(N=>m.NotebookStatusBarItem.from(N,this.i,c));return{cacheId:u,items:A}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,P,v,t,s){if((0,I.isFalsyOrWhitespace)(P))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,v),this.b.$registerNotebookSerializer(o,{id:E.identifier,location:E.extensionLocation},P,m.NotebookDocumentContentOptions.from(t),d.s(E,s)),(0,S.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(E,P,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const s=await t.deserializeNotebook(P.buffer,v);return new f.SerializableObjectWithBuffers(m.NotebookData.from(s))}async $notebookToData(E,P,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const s=await t.serializeNotebook(m.NotebookData.to(P.value),v);return i.VSBuffer.wrap(s)}w(E,P,v){if(this.h.has(P))throw new Error(`editor with id ALREADY EXSIST: ${P}`);const t=new r.ExtHostNotebookEditor(P,this.d,E,v.visibleRanges.map(m.NotebookRange.to),v.selections.map(m.NotebookRange.to),typeof v.viewColumn=="number"?m.ViewColumn.to(v.viewColumn):void 0);this.h.set(P,t)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const v of E.value.removedDocuments){const t=y.URI.revive(v),s=this.g.get(t);s&&(s.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(s.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===t.toString()&&this.h.delete(o.id)}if(E.value.addedDocuments){const v=[];for(const t of E.value.addedDocuments){const s=y.URI.revive(t.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const o=new n.ExtHostNotebookDocument(this.c,this.q,this.r,s,t);v.push(...t.cells.map(l=>n.ExtHostCell.asModelAddData(o.apiNotebook,l))),this.g.get(s)?.dispose(),this.g.set(s,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(o.apiNotebook)}}if(E.value.addedEditors)for(const v of E.value.addedEditors){if(this.h.has(v.id))return;const t=y.URI.revive(v.documentUri),s=this.g.get(t);s&&this.w(s,v.id,v)}const P=[];if(E.value.removedEditors)for(const v of E.value.removedEditors){const t=this.h.get(v);t&&(this.h.delete(v),this.k?.id===t.id&&(this.k=void 0),P.push(t))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const v=new Set;this.l.forEach(t=>v.add(t.id));for(const t of this.h.values()){const s=v.has(t.id);t._acceptVisibility(s)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const P=w.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[P,new w.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>i.VSBuffer.wrap(s))],new w.ApiCommandResult("Notebook Data",s=>m.NotebookData.to(s.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[P,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new f.SerializableObjectWithBuffers(m.NotebookData.from(s)))],new w.ApiCommandResult("Bytes",s=>s.buffer));E.registerApiCommand(v),E.registerApiCommand(t)}}e.ExtHostNotebookController=d,d.a=0}),define(Ie[221],Ce([1,0,18,12,21,4,6,28,2,26,13,53,5,38,8,7,72,181,24,44]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let P=class{constructor(a,h,c,u,g){this.k=h,this.l=c,this.m=u,this.n=g,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=a.getProxy(m.MainContext.MainThreadNotebookKernels);const A=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const q=this.l.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:q}}else if(N&&"notebookEditor"in N){const q=this.l.getIdByEditor(N.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return N})],p.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(a,h,c,u,g,A){for(const de of this.h.values())if(de.controller.id===h&&k.ExtensionIdentifier.equals(a.identifier,de.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const N=this.i++,q=this;this.n.trace(`NotebookController[${N}], CREATED by ${a.identifier.value}, ${h}`);const te=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${a.identifier}'`);let x=!1;const F=new I.DisposableStore,$=new L.Emitter,T=new L.Emitter,M={id:o(a.identifier,h),notebookType:c,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:u||a.identifier.value,preloads:A?A.map(f.NotebookRendererScript.from):[]};let V=g??te,j;this.a.$addKernel(N,M).catch(de=>{console.log(de),x=!0});let le=0;const Y=()=>{if(x)return;const de=++le;Promise.resolve().then(()=>{de===le&&this.a.$updateKernel(N,M)})},pe=new R.ResourceMap,ue={get id(){return h},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return M.label},set label(de){M.label=de??a.displayName??a.name,Y()},get detail(){return M.detail??""},set detail(de){M.detail=de,Y()},get description(){return M.description??""},set description(de){M.description=de,Y()},get kind(){return(0,b.checkProposedApiEnabled)(a,"notebookControllerKind"),M.kind??""},set kind(de){(0,b.checkProposedApiEnabled)(a,"notebookControllerKind"),M.kind=de,Y()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(de){M.supportedLanguages=de,Y()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(de){M.supportsExecutionOrder=de,Y()},get rendererScripts(){return M.preloads?M.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(de){V=de??te},get interruptHandler(){return j},set interruptHandler(de){j=de,M.supportsInterrupt=Boolean(de),Y()},createNotebookCellExecution(de){if(x)throw new Error("notebook controller is DISPOSED");if(!pe.has(de.notebook.uri))throw q.n.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return q._createNotebookCellExecution(de,o(a.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${N}], DISPOSED`),x=!0,this.h.delete(N),F.dispose(),$.dispose(),T.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(de,re){re===n.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(a,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(N,de.uri,re)},onDidReceiveMessage:T.event,postMessage(de,re){return(0,b.checkProposedApiEnabled)(a,"notebookMessaging"),q.a.$postMessage(N,re&&q.l.getIdByEditor(re),de)},asWebviewUri(de){return(0,b.checkProposedApiEnabled)(a,"notebookMessaging"),(0,r.asWebviewUri)(de,q.k.remote)}};return this.h.set(N,{extensionId:a.identifier,controller:ue,onDidReceiveMessage:T,onDidChangeSelection:$,associatedNotebooks:pe}),ue}getIdByController(a){for(const[h,c]of this.h)if(c.controller===a)return o(c.extensionId,a.id);return null}createNotebookControllerDetectionTask(a,h){const c=this.d++,u=this;this.n.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${a.identifier.value}`),this.a.$addKernelDetectionTask(c,h);const g={dispose:()=>{this.c.delete(c),u.a.$removeKernelDetectionTask(c)}};return this.c.set(c,g),g}registerKernelSourceActionProvider(a,h,c){const u=this.f++,g=this;return this.e.set(u,c),this.n.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${a.identifier.value}`),this.a.$addKernelSourceActionProvider(u,h),{dispose:()=>{this.e.delete(u),g.a.$removeKernelSourceActionProvider(u)}}}async $provideKernelSourceActions(a,h){const c=this.e.get(a);if(c){const u=new I.DisposableStore;return this.g.add([u]),(await c.provideNotebookKernelSourceActions(h)??[]).map(A=>f.NotebookKernelSourceAction.from(A,this.m.converter,u))}return[]}$acceptNotebookAssociation(a,h,c){const u=this.h.get(a);if(u){const g=this.l.getNotebookDocument(y.URI.revive(h));c?u.associatedNotebooks.set(g.uri,!0):u.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${a}] ASSOCIATE notebook`,g.uri.toString(),c),u.onDidChangeSelection.fire({selected:c,notebook:g.apiNotebook})}}async $executeCells(a,h,c){const u=this.h.get(a);if(!u)return;const g=this.l.getNotebookDocument(y.URI.revive(h)),A=[];for(const N of c){const q=g.getCell(N);q&&A.push(q.apiCell)}try{this.n.trace(`NotebookController[${a}] EXECUTE cells`,g.uri.toString(),A.length),await u.controller.executeHandler.call(u.controller,A,g.apiNotebook,u.controller)}catch(N){this.n.error(`NotebookController[${a}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(a,h,c){const u=this.h.get(a);if(!u)return;const g=this.l.getNotebookDocument(y.URI.revive(h));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,g.apiNotebook);else for(const A of c){const N=g.getCell(A);N&&this.b.get(N.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,h,c){const u=this.h.get(a);if(!u)return;const g=this.l.getEditorById(h);u.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:c}))}$cellExecutionChanged(a,h,c){const g=this.l.getNotebookDocument(y.URI.revive(a)).getCell(h);if(g){const A=c?f.NotebookCellExecutionState.to(c):n.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:g.apiCell,state:A})}}_createNotebookCellExecution(a,h){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.l.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const g=new t(h,u,this.a);this.b.set(u.uri,g);const A=g.onDidChangeState(()=>{g.state===v.Resolved&&(g.dispose(),A.dispose(),this.b.delete(u.uri))});return g.asApiObject()}};P=qe([Ve(4,O.ILogService)],P),e.ExtHostNotebookKernels=P;var v;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(v||(v={}));class t extends I.Disposable{get state(){return this.f}constructor(a,h,c){super(),this.j=h,this.k=c,this.b=t.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new S.CancellationTokenSource),this.h=new s(10,u=>this.m(u)),this.i=h.internalMetadata.executionOrder,this.k.$createExecution(this.b,a,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(a){await this.h.addItem(a)}async m(a){const h=Array.isArray(a)?a:[a];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(h))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(a){let h=this.j;if(a&&(h=this.j.notebook.getCellFromApiCell(a)),!h)throw new Error("INVALID cell");return h.handle}s(a){return a.map(h=>{const c=n.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return c===h.items?f.NotebookCellOutput.from(h):f.NotebookCellOutput.from({items:c,id:h.id,metadata:h.metadata})})}async t(a,h,c){const u=this.r(h),g=this.s((0,i.asArray)(a));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:u,append:c,outputs:g})}async w(a,h,c){return a=n.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(a),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:a.map(f.NotebookCellOutputItem.from),outputId:h.id,append:c})}asApiObject(){const a=this;return Object.freeze({get token(){return a.g.token},get cell(){return a.j.apiCell},get executionOrder(){return a.i},set executionOrder(c){a.i=c,a.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:a.i}])},start(c){if(a.f===v.Resolved||a.f===v.Started)throw new Error("Cannot call start again");a.f=v.Started,a.c.fire(),a.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,u){if(a.f===v.Resolved)throw new Error("Cannot call resolve twice");a.f=v.Resolved,a.c.fire(),a.h.flush(),a.k.$completeExecution(a.b,new E.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:c}))},clearOutput(c){return a.n(),a.t([],c,!1)},appendOutput(c,u){return a.n(),a.t(c,u,!0)},replaceOutput(c,u){return a.n(),a.t(c,u,!1)},appendOutputItems(c,u){return a.n(),a.w(c,u,!0)},replaceOutputItems(c,u){return a.n(),a.w(c,u,!1)}})}}t.a=0;class s{constructor(a,h){this.d=a,this.e=h,this.a=[],this.b=Date.now()}addItem(a){return this.a.push(a),this.c||(this.c=new C.DeferredPromise,this.b=Date.now(),(0,C.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const a=this.c;this.c=void 0;const h=this.a;return this.a=[],this.e(h).finally(()=>a.complete())}}function o(l,a){return`${l.value}/${a}`}e.createKernelId=o}),define(Ie[222],Ce([1,0,4,5,99]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(R,y){this.c=y,this.a=new Map,this.b=R.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,y,k){const O=this.c.getEditorById(R);this.a.get(y)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(R,y){if(!R.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,w,m)=>this.d(y).event(O,w,m),postMessage:(O,w)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const m=w&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(m?.id,y,O)}}}d(R){let y=this.a.get(R);return y||(y=new i.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(R)}}),this.a.set(R,y),y)}}e.ExtHostNotebookRenderers=L}),define(Ie[223],Ce([1,0,6,9,2,24,5]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(k){this.b=new Map,this.a=k.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,O,w){if((0,L.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,w),this.a.$registerProfileContentHandler(O,w.name,w.description,k.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,w,m){const p=this.b.get(k);if(!p)throw new Error(`Unknown handler with id: ${k}`);return p.saveProfile(O,w,m)}async $readProfile(k,O,w){const m=this.b.get(k);if(!m)throw new Error(`Unknown handler with id: ${k}`);return m.readProfile((0,C.isString)(O)?O:S.URI.revive(O),w)}}e.ExtHostProfileContentHandlers=R}),define(Ie[224],Ce([1,0,21,4,6,5,2,7,11,18,30,51]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(p,f,n){const r=p.getProxy(L.MainContext.MainThreadQuickOpen);class d{constructor(a,h){this.e=new Map,this.f=0,this.a=a,this.b=h}showQuickPick(a,h,c=i.CancellationToken.None){this.c=void 0;const u=Promise.resolve(a),g=++this.f,A=r.$show(g,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},c),N={},q=A.then(()=>N);return Promise.race([q,u]).then(te=>{if(te!==N)return u.then(x=>{const F=[];for(let $=0;$<x.length;$++){const T=x[$];typeof T=="string"?F.push({label:T,handle:$}):T.kind===R.QuickPickItemKind.Separator?F.push({type:"separator",label:T.label}):F.push({label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,handle:$})}return h&&typeof h.onDidSelectItem=="function"&&(this.c=$=>{h.onDidSelectItem(x[$])}),r.$setItems(g,F),A.then($=>{if(typeof $=="number")return x[$];if(Array.isArray($))return $.map(T=>x[T])})})}).then(void 0,te=>{if(!(0,y.isCancellationError)(te))return r.$setError(g,te),Promise.reject(te)})}$onItemSelected(a){this.c?.(a)}showInput(a,h=i.CancellationToken.None){return this.d=a?.validateInput,r.$input(a,typeof this.d=="function",h).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(a){if(!this.d)return;const h=await this.d(a);if(!h||typeof h=="string")return h;let c;switch(h.severity){case R.InputBoxValidationSeverity.Info:c=O.default.Info;break;case R.InputBoxValidationSeverity.Warning:c=O.default.Warning;break;case R.InputBoxValidationSeverity.Error:c=O.default.Error;break;default:c=h.message?O.default.Error:O.default.Ignore;break}return{content:h.message,severity:c}}async showWorkspaceFolderPick(a,h=i.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!c)return;const u=await this.a.getWorkspaceFolders2();if(!!u)return u.find(g=>g.uri.toString()===c.uri.toString())}createQuickPick(a){const h=new s(a,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}createInputBox(a){const h=new o(a,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}$onDidChangeValue(a,h){this.e.get(a)?._fireDidChangeValue(h)}$onDidAccept(a){this.e.get(a)?._fireDidAccept()}$onDidChangeActive(a,h){const c=this.e.get(a);c instanceof s&&c._fireDidChangeActive(h)}$onDidChangeSelection(a,h){const c=this.e.get(a);c instanceof s&&c._fireDidChangeSelection(h)}$onDidTriggerButton(a,h){this.e.get(a)?._fireDidTriggerButton(h)}$onDidTriggerItemButton(a,h,c){const u=this.e.get(a);u instanceof s&&u._fireDidTriggerItemButton(h,c)}$onDidHide(a){this.e.get(a)?._fireDidHide()}}class b{constructor(a,h){this.x=a,this.y=h,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.Emitter,this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(a){this.b=a,this.z({title:a})}get step(){return this.c}set step(a){this.c=a,this.z({step:a})}get totalSteps(){return this.d}set totalSteps(a){this.d=a,this.z({totalSteps:a})}get enabled(){return this.g}set enabled(a){this.g=a,this.z({enabled:a})}get busy(){return this.j}set busy(a){this.j=a,this.z({busy:a})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(a){this.k=a,this.z({ignoreFocusOut:a})}get value(){return this.l}set value(a){this.l=a,this.z({value:a})}get placeholder(){return this.m}set placeholder(a){this.m=a,this.z({placeholder:a})}get buttons(){return this.n}set buttons(a){this.n=a.slice(),this.o.clear(),a.forEach((h,c)=>{const u=h===R.QuickInputButtons.Back?-1:c;this.o.set(u,h)}),this.z({buttons:a.map((h,c)=>({...t(h),tooltip:h.tooltip,handle:h===R.QuickInputButtons.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(a){this.l=a,this.q.fire(a)}_fireDidTriggerButton(a){const h=this.o.get(a);h&&this.r.fire(h)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,S.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(a){if(!this.v){for(const h of Object.keys(a)){const c=a[h];this.u[h]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function E(l){if(l instanceof R.ThemeIcon)return{id:l.id};const a=v(l),h=P(l);return{dark:typeof a=="string"?I.URI.file(a):a,light:typeof h=="string"?I.URI.file(h):h}}function P(l){return typeof l=="object"&&"light"in l?l.light:l}function v(l){return typeof l=="object"&&"dark"in l?l.dark:l}function t(l){const a=E(l.iconPath);let h,c;return"id"in a?c=w.ThemeIcon.asClassName(a):h=a,{iconPath:h,iconClass:c}}class s extends b{constructor(a,h){super(a.identifier,h),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.Emitter,this.L=[],this.M=new C.Emitter,this.N=new C.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(a){this.B=a.slice(),this.C.clear(),this.D.clear(),a.forEach((c,u)=>{this.C.set(u,c),this.D.set(c,u)});const h=[];for(let c=0;c<a.length;c++){const u=a[c];u.kind===R.QuickPickItemKind.Separator?h.push({type:"separator",label:u.label}):h.push({handle:c,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((g,A)=>({...t(g),tooltip:g.tooltip,handle:A}))})}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(a){this.E=a,this.z({canSelectMany:a})}get matchOnDescription(){return this.F}set matchOnDescription(a){this.F=a,this.z({matchOnDescription:a})}get matchOnDetail(){return this.G}set matchOnDetail(a){this.G=a,this.z({matchOnDetail:a})}get sortByLabel(){return this.H}set sortByLabel(a){this.H=a,this.z({sortByLabel:a})}get keepScrollPosition(){return this.I}set keepScrollPosition(a){this.I=a,this.z({keepScrollPosition:a})}get activeItems(){return this.J}set activeItems(a){this.J=a.filter(h=>this.D.has(h)),this.z({activeItems:this.J.map(h=>this.D.get(h))})}get selectedItems(){return this.L}set selectedItems(a){this.L=a.filter(h=>this.D.has(h)),this.z({selectedItems:this.L.map(h=>this.D.get(h))})}_fireDidChangeActive(a){const h=(0,k.coalesce)(a.map(c=>this.C.get(c)));this.J=h,this.K.fire(h)}_fireDidChangeSelection(a){const h=(0,k.coalesce)(a.map(c=>this.C.get(c)));this.L=h,this.M.fire(h)}_fireDidTriggerItemButton(a,h){const c=this.C.get(a);if(!c||!c.buttons||!c.buttons.length)return;const u=c.buttons[h];u&&this.N.fire({button:u,item:c})}}class o extends b{constructor(a,h){super(a.identifier,h),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(a){this.B=a,this.z({password:a})}get prompt(){return this.C}set prompt(a){this.C=a,this.z({prompt:a})}get valueSelection(){return this.D}set valueSelection(a){this.D=a,this.z({valueSelection:a})}get validationMessage(){return this.E}set validationMessage(a){this.E=a,a?typeof a=="string"?this.z({validationMessage:a,severity:O.default.Error}):this.z({validationMessage:a.message,severity:a.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new d(f,n)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i};define(Ie[225],Ce([1,0,2,4,63,6,12,5,18,124,13,26,51,8,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f){"use strict";var n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(u){if(u)return typeof u.iconPath=="string"?i.URI.file(u.iconPath):i.URI.isUri(u.iconPath)||m.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function b(u,g){if(!u.iconPath&&!g.iconPath)return 0;if(u.iconPath){if(!g.iconPath)return 1}else return-1;const A=typeof u.iconPath=="string"?u.iconPath:i.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,N=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(A,N)}function E(u,g){let A=0;if(u.strikeThrough!==g.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==g.faded)return u.faded?1:-1;if(u.tooltip!==g.tooltip)return(u.tooltip||"").localeCompare(g.tooltip||"");if(A=b(u,g),A!==0)return A;if(u.light&&g.light)A=b(u.light,g.light);else{if(u.light)return 1;if(g.light)return-1}if(A!==0)return A;if(u.dark&&g.dark)A=b(u.dark,g.dark);else{if(u.dark)return 1;if(g.dark)return-1}return A}function P(u,g){if(u.command!==g.command)return u.command<g.command?-1:1;if(u.title!==g.title)return u.title<g.title?-1:1;if(u.tooltip!==g.tooltip){if(u.tooltip!==void 0&&g.tooltip!==void 0)return u.tooltip<g.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(u.arguments===g.arguments)return 0;if(u.arguments)if(g.arguments){if(u.arguments.length!==g.arguments.length)return u.arguments.length-g.arguments.length}else return 1;else return-1;for(let A=0;A<u.arguments.length;A++){const N=u.arguments[A],q=g.arguments[A];if(N!==q)return N<q?-1:1}return 0}function v(u,g){let A=(0,k.comparePaths)(u.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(A!==0)return A;if(u.command&&g.command)A=P(u.command,g.command);else{if(u.command)return 1;if(g.command)return-1}if(A!==0)return A;if(u.decorations&&g.decorations)A=E(u.decorations,g.decorations);else{if(u.decorations)return 1;if(g.decorations)return-1}return A}function t(u,g){for(let A=0;A<u.length;A++)if(u[A]!==g[A])return!1;return!0}function s(u,g){return u.command===g.command&&u.title===g.title&&u.tooltip===g.tooltip&&(u.arguments&&g.arguments?t(u.arguments,g.arguments):u.arguments===g.arguments)}function o(u,g){return(0,y.equals)(u,g,s)}class l{get value(){return this.d}set value(g){g=g??"",Oe(this,n,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Oe(this,n,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Oe(this,n,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Oe(this,n,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Oe(this,n,"f").$setInputBoxVisibility(this.l,g))}constructor(g,A,N){this.k=g,this.l=N,n.set(this,void 0),this.d="",this.e=new C.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,n,A,"f")}showValidationMessage(g,A){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,n,"f").$showValidationMessage(this.l,g,A)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=l,n=new WeakMap;class a{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,A,N,q,te){this.q=g,this.s=A,this.t=N,this.u=q,this.v=te,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=a.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,A){const N=this.h.get(g);return N?(0,I.asPromise)(()=>this.s.executeCommand(N.command,...N.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(v),N=(0,y.sortedDiff)(this.o,g,v).map(x=>{const F=x.toInsert.map($=>{const T=this.e++;this.g.set(T,$);const M=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const oe=new L.DisposableStore;V=this.s.converter.toInternal($.command,oe),this.j.set(T,oe)}else this.h.set(T,$.command);const j=d($.decorations),le=$.decorations&&d($.decorations.light)||j,Y=$.decorations&&d($.decorations.dark)||j,pe=[le,Y],ue=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,re=$.decorations&&!!$.decorations.faded,G=$.contextValue||"";return{rawResource:[T,M,pe,ue,de,re,G,V],handle:T}});return{start:x.start,deleteCount:x.deleteCount,toInsert:F}}),q=N.map(({start:x,deleteCount:F,toInsert:$})=>[x,F,$.map(T=>T.rawResource)]),te=N.reverse();for(const{start:x,deleteCount:F,toInsert:$}of te){const T=$.map(V=>V.handle),M=this.n.splice(x,F,...T);for(const V of M)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=g,q}dispose(){this.l=!0,this.m.fire()}}a.d=0;class h{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Oe(this,r,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Oe(this,r,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Oe(this,r,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new L.DisposableStore,this.l=g;const A=this.v.converter.toInternal(g,this.k.value);Oe(this,r,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=g;const A=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(N=>N.map(q=>this.v.converter.toInternal(q,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,r,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&o(this.p,g))return;this.o.value=new L.DisposableStore,this.p=g;const A=(g||[]).map(N=>this.v.converter.toInternal(N,this.o.value));Oe(this,r,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(g,A,N,q,te,x){this.u=g,this.v=N,this.w=q,this.x=te,this.y=x,r.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new C.Emitter,this.onDidChangeSelection=this.s.event,this.t=h.d++,this.z=new Map,this.A=new Set,Je(this,r,A,"f"),this.f=new l(g,Oe(this,r,"f"),this.t),Oe(this,r,"f").$registerSourceControl(this.t,q,te,x)}createResourceGroup(g,A){const N=new a(Oe(this,r,"f"),this.v,this.t,g,A),q=C.Event.once(N.onDidDispose)(()=>this.z.delete(N));return this.z.set(N,q),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const g=[],A=[];for(const[N,q]of this.z){q.dispose();const te=N.onDidUpdateResourceStates(()=>{this.A.add(N),this.eventuallyUpdateResourceStates()});C.Event.once(N.onDidDispose)(()=>{this.A.delete(N),te.dispose(),this.e.delete(N.handle),Oe(this,r,"f").$unregisterGroup(this.t,N.handle)}),g.push([N.handle,N.id,N.label,N.features]);const x=N._takeResourceStateSnapshot();x.length>0&&A.push([N.handle,x]),this.e.set(N.handle,N)}Oe(this,r,"f").$registerGroups(this.t,g,A),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(A=>{const N=A._takeResourceStateSnapshot();N.length!==0&&g.push([A.handle,N])}),g.length>0&&Oe(this,r,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Oe(this,r,"f").$unregisterSourceControl(this.t)}}r=new WeakMap,h.d=0,qe([(0,S.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),qe([(0,S.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let c=class rn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,A,N){this.l=A,this.m=N,this.g=new Map,this.h=new Map,this.j=new C.Emitter,this.e=g.getProxy(R.MainContext.MainThreadSCM),this.f=g.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const te=this.g.get(q.sourceControlHandle);if(!te)return q;const x=te.getResourceGroup(q.groupHandle);return x?x.getResourceState(q.handle):q}else if(q&&q.$mid===4){const te=this.g.get(q.sourceControlHandle);return te?te.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const te=this.g.get(q.handle);return te||q}return q}})}createSourceControl(g,A,N,q){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,A,N,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const te=rn.d++,x=new h(g,this.e,this.l,A,N,q);this.g.set(te,x);const F=this.h.get(w.ExtensionIdentifier.toKey(g.identifier))||[];return F.push(x),this.h.set(w.ExtensionIdentifier.toKey(g.identifier),F),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const A=this.h.get(w.ExtensionIdentifier.toKey(g.identifier)),N=A&&A[A.length-1];return N&&N.inputBox}$provideOriginalResource(g,A,N){const q=i.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",g,q.toString());const te=this.g.get(g);return!te||!te.quickDiffProvider||!te.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>te.quickDiffProvider.provideOriginalResource(q,N)).then(x=>x||null)}$onInputBoxValueChange(g,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const N=this.g.get(g);return N&&N.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(g,A,N,q){this.m.trace("ExtHostSCM#$executeResourceCommand",g,A,N);const te=this.g.get(g);if(!te)return Promise.resolve(void 0);const x=te.getResourceGroup(A);return x?x.$executeResourceCommand(N,q):Promise.resolve(void 0)}$validateInput(g,A,N){this.m.trace("ExtHostSCM#$validateInput",g);const q=this.g.get(g);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>q.inputBox.validateInput(A,N)).then(te=>{if(!te)return Promise.resolve(void 0);const x=p.MarkdownString.fromStrict(te.message);return x?Promise.resolve([x,te.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};c.d=0,c=qe([Ve(2,O.ILogService)],c),e.ExtHostSCM=c}),define(Ie[79],Ce([1,0,5,4,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(R){this.b=new C.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,y){return this.a.$getPassword(R,y)}store(R,y,k){return this.a.$setPassword(R,y,k)}delete(R,y){return this.a.$deletePassword(R,y)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[226],Ce([1,0,7,5,140,6,8,9]),function(ee,e,i,C,S,L,I,R){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,n,r,d,b=i.StatusBarAlignment.Left,E){y.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new L.DisposableStore,Je(this,y,f,"f"),Je(this,k,n,"f"),this.c=O.a++,this.e=r,this.f=d,this.g=b,this.h=this.u(E)}u(f){if(!!(0,R.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!O.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new L.DisposableStore,typeof f=="string"?this.r={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Oe(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let n;this.m?n=this.m:n=(0,S.localize)(0,null,this.e.displayName||this.e.name);let r=this.n;this.o&&(r=O.b.get(this.o.id));const d=I.MarkdownString.fromStrict(this.l);Oe(this,y,"f").$setEntry(this.c,f,n,this.k,d,this.r?.internal,r,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,k=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,S.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const n={message:f};return this.b.unshift(n),this.c(),new i.Disposable(()=>{const r=this.b.indexOf(n);r>=0&&(this.b.splice(r,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,n){this.a=f.getProxy(C.MainContext.MainThreadStatusBar),this.b=n,this.c=new w(this)}createStatusBarEntry(f,n,r,d){return new O(this.a,this.b,f,n,r,d)}setStatusBarMessage(f,n){const r=this.c.setMessage(f);let d;return typeof n=="number"?d=setTimeout(()=>r.dispose(),n):typeof n<"u"&&n.then(()=>r.dispose(),()=>r.dispose()),new i.Disposable(()=>{r.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=m}),define(Ie[80],Ce([1,0,5,4,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(R,y){this.c=y,this.b=new C.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,y){this.a.$registerExtensionStorageKeysToSync(R,y)}async initializeExtensionStorage(R,y,k){const O=await this.a.$initializeExtensionStorage(R,y);let w;return O&&(w=this.d(R,y,O)),w||k}setValue(R,y,k){return this.a.$setValue(R,y,k)}$acceptValue(R,y,k){const O=this.d(R,y,k);O&&this.b.fire({shared:R,key:y,value:O})}d(R,y,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${R}): ${O}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ie[81],Ce([1,0,3,27,13,59,2]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,O,w){this.d=O,this.f=w,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return I.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this.c)return I.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return I.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([Ve(0,C.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ie[60],Ce([1,0,4,5,3,2,17,6,7,141,11,182,21,34,166,51,9,12,8]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class E{constructor(c,u,g,A){this.k=c,this._id=u,this.l=g,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.j},sendText(q,te=!0){N.o(),N.k.$sendText(N._id,q,te)},show(q){N.o(),N.k.$show(N._id,q)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(c,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:c.name,shellPath:(0,r.withNullAsUndefined)(c.shellPath),shellArgs:(0,r.withNullAsUndefined)(c.shellArgs),cwd:(0,r.withNullAsUndefined)(c.cwd),env:(0,r.withNullAsUndefined)(c.env),icon:(0,r.withNullAsUndefined)(l(c.iconPath)),color:n.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,r.withNullAsUndefined)(c.message),strictEnv:(0,r.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,r.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,r.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this.n(c.location,u?.resolvedExtHostIdentifier),isTransient:(0,r.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,u,g,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:n.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(c,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(c,u){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in c?{viewColumn:b.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.m=c}setExitStatus(c,u){this.h=Object.freeze({code:c,reason:u})}setDimensions(c,u){return c===this.d&&u===this.g||c===0||u===0?!1:(this.d=c,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(u=>{u!==c&&(this.b=Promise.resolve(c))})}}e.ExtHostTerminal=E;class P{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,u){this.g.setDimensions?.({columns:c,rows:u})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:""})}}let v=1,t=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}get onDidWriteTerminalData(){return this.I.event}constructor(c,u){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=u.getProxy(C.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(c),this.B({dispose:()=>{for(const[g,A]of this.g)A.shutdown(!0)}})}getDefaultShell(c){return(c?this.n:this.m)?.path||""}getDefaultShellArgs(c){return(c?this.n:this.m)?.args||[]}createExtensionTerminal(c,u){const g=new E(this.a,(0,p.generateUuid)(),c,c.name),A=new P(c.pty);return g.createExtensionTerminal(c.location,this.L(c,u).resolvedExtHostIdentifier,l(c.iconPath),a(c.color)).then(N=>{const q=this.M(N,A);this.h[N]=q}),this.f.push(g),g.value}L(c,u){if(u=u||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const g=c.location.parentTerminal;if(g){const A=this.f.find(N=>N.value===g);A&&(u.resolvedExtHostIdentifier=A._id)}}else c.location&&typeof c.location!="object"?u.location=c.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(c,u){if(!this.O(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const A=new P(u),N=this.M(c,A);this.h[c]=N}async $acceptActiveTerminalChanged(c){const u=this.b;if(c===null){this.b=void 0,u!==this.b&&this.F.fire(this.b);return}const g=this.O(c);g&&(this.b=g,u!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(c,u){const g=this.O(c);g&&this.I.fire({terminal:g.value,data:u})}async $acceptTerminalDimensions(c,u,g){const A=this.O(c);A&&A.setDimensions(u,g)&&this.G.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(c,u,g){this.g.get(c)?.resize(u,g)}async $acceptTerminalTitleChange(c,u){const g=this.O(c);g&&(g.name=u)}async $acceptTerminalClosed(c,u,g){const A=this.Q(this.f,c);if(A!==null){const N=this.f.splice(A,1)[0];N.setExitStatus(u,g),this.C.fire(N.value)}}$acceptTerminalOpened(c,u,g,A){if(u){const te=this.Q(this.f,u);if(te!==null){this.f[te]._id=c,this.D.fire(this.terminals[te]),this.f[te].isOpen=!0;return}}const N={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},q=new E(this.a,c,N,g);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(c,u){this.O(c)?._setProcessId(u)}async $startExtensionTerminal(c,u){const g=this.O(c);if(!g)return{message:(0,k.localize)(0,null,c)};g.isOpen||await new Promise(N=>{const q=this.onDidOpenTerminal(async te=>{te===g.value&&(q.dispose(),N())})});const A=this.g.get(c);A?A.startSendingEvents(u):this.j[c]={initialDimensions:u}}M(c,u){const g=new R.DisposableStore;g.add(u.onProcessReady(N=>this.a.$sendProcessReady(c,N.pid,N.cwd))),g.add(u.onDidChangeProperty(N=>this.a.$sendProcessProperty(c,N))),this.s.startBuffering(c,u.onProcessData),g.add(u.onProcessExit(N=>this.N(c,N))),this.g.set(c,u);const A=this.j[c];return A&&u instanceof P&&(u.startSendingEvents(A.initialDimensions),delete this.j[c]),g}$acceptProcessAckDataEvent(c,u){this.g.get(c)?.acknowledgeDataEvent(u)}$acceptProcessInput(c,u){this.g.get(c)?.input(u)}$acceptTerminalInteraction(c){const u=this.O(c);u?.setInteractedWith()&&this.H.fire(u.value)}$acceptProcessResize(c,u,g){try{this.g.get(c)?.resize(u,g)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(c,u){this.g.get(c)?.shutdown(u)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(u=>this.a.$sendProcessProperty(c,{type:"cwd",value:u}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.u.add(c),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(c),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,u,g){if(this.v.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.v.set(u,g),this.a.$registerProfileProvider(u,c.identifier.value),new y.Disposable(()=>{this.v.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(c,u,g){if(this.w.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.w.set(c,g),this.a.$registerQuickFixProvider(c,u),new y.Disposable(()=>{this.w.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,u){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const A=this.w.get(c);if(!A)return;const N=await A.provideTerminalQuickFixes(u,g);if(N!==null)return N}async $createContributedProfileTerminal(c,u){const g=new m.CancellationTokenSource().token;let A=await this.v.get(c)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,u);return}this.createTerminalFromOptions(A.options,u)}}async $provideLinks(c,u){const g=this.O(c);if(!g)return[];this.y.delete(c),this.z.get(c)?.dispose(!0);const N=new m.CancellationTokenSource;this.z.set(c,N);const q=[],te={terminal:g.value,line:u},x=[];for(const T of this.u)x.push(d.Promises.withAsyncBody(async M=>{N.token.onCancellationRequested(()=>M({provider:T,links:[]}));const V=await T.provideTerminalLinks(te,N.token)||[];N.token.isCancellationRequested||M({provider:T,links:V})}));const F=await Promise.all(x);if(N.token.isCancellationRequested)return[];const $=new Map;for(const T of F)T&&T.links.length>0&&q.push(...T.links.map(M=>{const V={id:v++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return $.set(V.id,{provider:T.provider,link:M}),V}));return this.y.set(c,$),q}$activateLink(c,u){const g=this.y.get(c)?.get(u);!g||g.provider.handleTerminalLink(g.link)}N(c,u){this.s.stopBuffering(c),this.g.delete(c),delete this.j[c];const g=this.h[c];g&&(g.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,u)}O(c){return this.P(this.f,c)}P(c,u){const g=this.Q(c,u);return g!==null?c[g]:null}Q(c,u){let g=null;return c.some((A,N)=>A._id===u?(g=N,!0):!1),g}getEnvironmentVariableCollection(c){let u=this.l.get(c.identifier.value);return u||(u=new s,this.S(c.identifier.value,u)),u}R(c,u){const g=(0,w.serializeEnvironmentVariableCollection)(u.map);this.a.$setEnvironmentVariableCollection(c,u.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(c){c.forEach(u=>{const g=u[0],A=new s(u[1]);this.S(g,A)})}$acceptDefaultProfile(c,u){const g=this.m;this.m=c,this.n=u,g?.path!==c.path&&this.J.fire(c.path)}S(c,u){this.l.set(c,u),u.onDidChangeCollection(()=>{this.R(c,u)})}};t=qe([Ve(1,I.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class s{get persistent(){return this.a}set persistent(c){this.a=c,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(c){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(c)}get size(){return this.map.size}replace(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Replace})}append(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,u){this.d(c,{value:u,type:y.EnvironmentVariableMutatorType.Prepend})}d(c,u){const g=this.map.get(c);(!g||g.value!==u.value||g.type!==u.type)&&(this.map.set(c,u),this.b.fire())}get(c){return this.map.get(c)}forEach(c,u){this.map.forEach((g,A)=>c.call(u,A,g,this))}[Symbol.iterator](){return this.map.entries()}delete(c){this.map.delete(c),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let o=class extends t{constructor(c){super(!1,c)}createTerminal(c,u,g){throw new O.NotSupportedError}createTerminalFromOptions(c,u){throw new O.NotSupportedError}};o=qe([Ve(0,I.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function l(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function a(h){return n.ThemeColor.isThemeColor(h)?h:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i};define(Ie[227],Ce([1,0,18,12,25,21,4,191,228,6,22,9,34,5,17,100,8,7,43,71,55,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v){"use strict";var t,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(T,M,V){this.j=V,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(p.MainContext.MainThreadTesting),this.h=new te(this.f),this.g=new c(this.f),M.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,Y=le.tests[le.tests.length-1].item.extId;return this.d.get(b.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,n.toItemFromContext)(j)}})}createTestController(T,M,V,j){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const le=new k.DisposableStore,Y=le.add(new n.ExtHostTestItemCollection(M,V,this.j));Y.root.label=V;const pe=new Map,ue=this.f,de={items:Y.root.children,get label(){return V},set label(G){V=G,Y.root.label=G,ue.$updateController(M,{label:V})},get refreshHandler(){return j},set refreshHandler(G){j=G,ue.$updateController(M,{canRefresh:!!G})},get id(){return M},createRunProfile:(G,H,oe,ve,Ae,Be)=>{let xe=(0,y.hash)(G);for(;pe.has(xe);)xe++;return Be!==void 0&&(0,v.checkProposedApiEnabled)(T,"testContinuousRun"),new x(this.f,pe,M,xe,G,H,oe,ve,Ae,Be)},createTestItem(G,H,oe){return new n.TestItemImpl(M,G,H,oe)},createTestRun:(G,H,oe=!0)=>this.g.createTestRun(M,Y,G,H,oe),set resolveHandler(G){Y.resolveHandler=G},get resolveHandler(){return Y.resolveHandler},dispose:()=>{le.dispose()}};ue.$registerTestController(M,V,!!j),le.add((0,k.toDisposable)(()=>ue.$unregisterTestController(M)));const re={controller:de,collection:Y,profiles:pe};return this.d.set(M,re),le.add((0,k.toDisposable)(()=>this.d.delete(M))),le.add(Y.onDidGenerateDiff(G=>ue.$publishDiff(M,G.map(P.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(T,M=L.CancellationToken.None){const V=u(T);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(V.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(le=>b.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:F[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:T.exclude?.map(le=>le.id)},M)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,M,V){return(0,i.mapFind)(this.g.trackers,le=>le.id===T?le.getCoverage(M):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(T,M,V,j){return(0,i.mapFind)(this.g.trackers,Y=>Y.id===T?Y.getCoverage(M):void 0)?.resolveFileCoverage(V,j)??Promise.resolve([])}$configureRunProfile(T,M){this.d.get(T)?.profiles.get(M)?.configureHandler?.()}async $refreshTests(T,M){await this.d.get(T)?.controller.refreshHandler?.(M)}$publishTestResults(T){this.results=Object.freeze(T.map(M=>(0,O.deepFreeze)(r.TestResults.to(M))).concat(this.results).sort((M,V)=>V.completedAt-M.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,M){const V=this.d.get(b.TestId.fromString(T).controllerId)?.collection;V&&(await V.expand(T,M<0?1/0:M),V.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(P.TestsDiffOp.deserialize))}async $runControllerTests(T,M){return Promise.all(T.map(V=>this.k(V,!1,M)))}async $startContinuousRun(T,M){const V=new L.CancellationTokenSource(M),j=await Promise.all(T.map(le=>this.k(le,!0,V.token)));return!M.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>M.onCancellationRequested(le)),V.dispose(!0),j}async k(T,M,V){const j=this.d.get(T.controllerId);if(!j)return{};const{collection:le,profiles:Y}=j,pe=Y.get(T.profileId);if(!pe)return{};const ue=T.testIds.map(H=>le.tree.get(H)).filter(w.isDefined),de=T.excludeExtIds.map(H=>j.collection.tree.get(H)).filter(w.isDefined).filter(H=>ue.some(oe=>oe.fullId.compare(H.fullId)===2));if(!ue.length)return{};const re=new d.TestRunRequest2(ue.some(H=>H.actual instanceof n.TestItemRootImpl)?void 0:ue.map(H=>H.actual),de.map(H=>H.actual),pe,M),G=(0,P.isStartControllerTests)(T)&&this.g.prepareForMainThreadTestRun(re,g.fromInternal(T,j.collection),V);try{return await pe.runHandler(re,V),{}}catch(H){return{error:String(H)}}finally{G&&(G.hasRunningTasks&&!V.isCancellationRequested&&await I.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};o=qe([Ve(0,f.IExtHostRpcService)],o),e.ExtHostTesting=o;const l=1e4;var a;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(a||(a={}));class h extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(T,M,V){super(),this.k=T,this.l=M,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(V));const j=this.B(new C.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const M=this.k.id,V=this.k.controllerId,j=(0,m.generateUuid)(),le=new A(this.l,M,j),Y=re=>(G,...H)=>{if(ue){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(G)||(this.s(G),re(G,...H))},pe=(re,G)=>{const H=G instanceof Array?G.map(r.TestMessage.from):[r.TestMessage.from(G)];if(re.uri&&re.range){const oe={range:r.Range.from(re.range),uri:re.uri};for(const ve of H)ve.location=ve.location||oe}this.l.$appendTestMessagesInRun(M,j,b.TestId.fromExtHostTestItem(re,V).toString(),H)};let ue=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:T,get coverageProvider(){return le.coverageProvider},set coverageProvider(re){le.coverageProvider=re},enqueued:Y(re=>{this.l.$updateTestStateInRun(M,j,b.TestId.fromExtHostTestItem(re,V).toString(),1)}),skipped:Y(re=>{this.l.$updateTestStateInRun(M,j,b.TestId.fromExtHostTestItem(re,V).toString(),5)}),started:Y(re=>{this.l.$updateTestStateInRun(M,j,b.TestId.fromExtHostTestItem(re,V).toString(),2)}),errored:Y((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(M,j,b.TestId.fromExtHostTestItem(re,V).toString(),6,H)}),failed:Y((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(M,j,b.TestId.fromExtHostTestItem(re,V).toString(),4,H)}),passed:Y((re,G)=>{this.l.$updateTestStateInRun(M,j,b.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,G)}),appendOutput:(re,G,H)=>{ue||(H&&(this.k.isIncluded(H)?this.s(H):H=void 0),this.l.$appendOutputToRun(M,j,S.VSBuffer.fromString(re),G&&r.location.from(G),H&&b.TestId.fromExtHostTestItem(H,V).toString()))},end:()=>{ue||(ue=!0,this.l.$finishedTestRunTask(M,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:de,coverage:le}),this.l.$startedTestRunTask(M,{id:j,name:T,running:!0}),de}m(){for(const{run:T}of this.f.values())T.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(T){if(!(T instanceof n.TestItemImpl))throw new E.InvalidTestItemError(T.id);if(this.g.has(b.TestId.fromExtHostTestItem(T,this.k.controllerId).toString()))return;const M=[],V=this.k.colllection.root;for(;;){const j=r.TestItem.from(T);if(M.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),T===V))break;T=T.parent||V}this.l.$addTestsToRun(this.k.controllerId,this.k.id,M)}}class c{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,M,V){return this.f(T,M,V)}cancelRunById(T){for(const M of this.c.values())if(M.id===T){M.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,M,V,j,le){const Y=this.c.get(V);if(Y)return Y.createRun(j);const pe=g.fromPublic(T,M,V,le),ue=u(V);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!V.continuous,profile:ue&&{group:F[ue.kind],id:ue.profileId},exclude:V.exclude?.map(re=>b.TestId.fromExtHostTestItem(re,M.root.id).toString())??[],id:pe.id,include:V.include?.map(re=>b.TestId.fromExtHostTestItem(re,M.root.id).toString())??[M.root.id],persist:le});const de=this.f(V,pe);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(pe.id),de.dispose()}),de.createRun(j)}f(T,M,V){const j=new h(M,this.d,V);return this.c.set(T,j),j.onEnd(()=>this.c.delete(T)),j}}e.TestRunCoordinator=c;const u=$=>{if(!!$.profile){if(!($.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class g{static fromPublic(T,M,V,j){return new g(T,(0,m.generateUuid)(),V.include?.map(le=>b.TestId.fromExtHostTestItem(le,T).toString())??[T],V.exclude?.map(le=>b.TestId.fromExtHostTestItem(le,T).toString())??[],j,M)}static fromInternal(T,M){return new g(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,M)}constructor(T,M,V,j,le,Y){this.controllerId=T,this.id=M,this.isPersisted=le,this.colllection=Y,this.c=V.map(pe=>pe+"\0"),this.d=j.map(pe=>pe+"\0")}isIncluded(T){const M=b.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const V of this.d)if(M===V||M.startsWith(V))return!1;for(const V of this.c)if(M===V||M.startsWith(V))return!0;return!1}}e.TestRunDto=g;class A{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,M,V){this.f=T,this.g=M,this.h=V}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(r.TestCoverage.fromFile)??[]}catch(M){throw this.d=void 0,M}}async resolveFileCoverage(T,M){const V=await this.d;let j=V?.[T];return!this.c||!V||!j?[]:(j.detailedCoverage||(j=V[T]=await this.c.resolveFileCoverage?.(j,M)??j),j.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class N{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,r.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const M=b.TestId.parentId(T.item.extId);if(M&&this.g.has(M.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:M,f:V}=this;return{get added(){return[...T].map(j=>j.revived)},get updated(){return[...M].map(j=>j.revived)},get removed(){return[...V].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class q extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,M){return{...T,revived:r.TestItem.toPlain(T.item),depth:M?M.depth+1:0,children:new Set}}o(){return new N(this.q)}}class te{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(M=>M.revived)},dispose:(0,R.once)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new q;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class x{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?r.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,Oe(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,M,V,j,le,Y,pe,ue=!1,de=void 0,re=!1){this.controllerId=V,this.profileId=j,this.d=le,this.kind=Y,this.runHandler=pe,this.f=ue,this._tag=de,this.g=re,t.set(this,void 0),s.set(this,void 0),Je(this,t,T,"f"),Je(this,s,M,"f"),M.set(j,this);const G=F[Y];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Oe(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:V,tag:de?r.TestTag.namespace(this.controllerId,de.id):null,label:le,group:G,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:re})}dispose(){Oe(this,s,"f")?.delete(this.profileId)&&(Je(this,s,void 0,"f"),Oe(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,t=new WeakMap,s=new WeakMap;const F={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ie[229],Ce([1,0,18,4,5,101,8,7]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,w){this.i=w,this.a=new C.Emitter,this.b=new C.Emitter,this.c=new C.Emitter,this.d=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(S.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const w=this.i.allEditors();return O?w:w.map(m=>m.value)}async showTextDocument(O,w,m){let p;typeof w=="number"?p={position:I.ViewColumn.from(w),preserveFocus:m}:typeof w=="object"?p={position:I.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?I.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(O.uri,p),n=f&&this.i.getEditor(f);if(n)return n.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new L.TextEditorDecorationType(this.h,O,w).value}$acceptEditorPropertiesChanged(O,w){const m=this.i.getEditor(O);if(!m)throw new Error("unknown text editor");if(w.options&&m._acceptOptions(w.options),w.selections){const p=w.selections.selections.map(I.Selection.to);m._acceptSelections(p)}if(w.visibleRanges){const p=i.coalesce(w.visibleRanges.map(I.Range.to));m._acceptVisibleRanges(p)}if(w.options&&this.b.fire({textEditor:m.value,options:{...w.options,lineNumbers:I.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const p=R.TextEditorSelectionChangeKind.fromValue(w.selections.source),f=w.selections.selections.map(I.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:p})}if(w.visibleRanges){const p=i.coalesce(w.visibleRanges.map(I.Range.to));this.c.fire({textEditor:m.value,visibleRanges:p})}}$acceptEditorPositionData(O){for(const w in O){const m=this.i.getEditor(w);if(!m)throw new Error("Unknown text editor");const p=I.ViewColumn.to(O[w]);m.value.viewColumn!==p&&(m._acceptViewColumn(p),this.d.fire({textEditor:m.value,viewColumn:p}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(Ie[230],Ce([1,0,2,3,5,6,7,8,26,9]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class O{constructor(p,f){this.b=new Map,this.c=new Map,this.a=p.getProxy(S.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(n,r)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&y.ExtensionIdentifier.equals(r,this.b.get(n.source)?.extension)){const d=n.uri===void 0?void 0:i.URI.revive(n.uri);return this.c.get(n.source)?.get(w(d))?.get(n.handle)}else return;return n}})}async $getTimeline(p,f,n,r){return this.b.get(p)?.provider.provideTimeline(i.URI.revive(f),n,r)}registerTimelineProvider(p,f,n,r){const d=new L.DisposableStore,b=this.d(f.id,r,d).bind(this);let E;f.onDidChange&&(E=f.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:f.id}),this));const P=this.c;return this.f({...f,scheme:p,onDidChange:void 0,async provideTimeline(v,t,s){t?.resetCache&&(d.clear(),P.get(f.id)?.clear());const o=await f.provideTimeline(v,t,s);if(o==null)return;const l=b(v,t);return{...o,source:f.id,items:o.items.map(l)}},dispose(){for(const v of P.values())v.get(f.id)?.clear();E?.dispose(),d.dispose()}},n)}d(p,f,n){return(r,d)=>{let b;if(d?.cacheResults){let E=this.c.get(p);E===void 0&&(E=new Map,this.c.set(p,E));const P=w(r);b=E.get(P),b===void 0&&(b=new Map,E.set(P,b))}return E=>{const{iconPath:P,...v}=E,t=`${p}|${E.id??E.timestamp}`;b?.set(t,E);let s,o,l;E.iconPath&&(P instanceof I.ThemeIcon?l={id:P.id,color:P.color}:i.URI.isUri(P)?(s=P,o=P):{light:s,dark:o}=P);let a;return I.MarkdownString.isMarkdownString(v.tooltip)?a=R.MarkdownString.from(v.tooltip):(0,k.isString)(v.tooltip)?a=v.tooltip:I.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=R.MarkdownString.from(v.detail)):(0,k.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=v.detail),{...v,id:v.id??void 0,handle:t,source:p,command:E.command?f.toInternal(E.command,n):void 0,icon:s,iconDark:o,themeIcon:l,tooltip:a,accessibilityInformation:E.accessibilityInformation}}}}f(p,f){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:f}),(0,L.toDisposable)(()=>{for(const r of this.c.values())r.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=O;function w(m){return m?.toString()}}),define(Ie[231],Ce([1,0,6,16,2,5]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this.c=new Map,this.b=y.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,O,w){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=w.schemes.find(p=>!I.a.has(p));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,w.schemes,y,w.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(y,k,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const m=S.URI.revive(k);return w.canOpenExternalUri(m,O)}async $openUri(y,k,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=I,I.a=new Set([C.Schemas.http,C.Schemas.https])}),define(Ie[232],Ce([1,0,5,2,6,11,26]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.c.has(I.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=R.a++;return this.c.add(I.ExtensionIdentifier.toKey(k)),this.d.set(w,O),this.b.$registerUriHandler(w,k),(0,S.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(k)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,O){const w=this.d.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(O))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return C.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=R,R.a=0});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[61],Ce([1,0,4,16,22,2,154,175,72,5]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";var O,w,m,p,f,n,r,d,b,E,P,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(N,q,te,x,F,$,T){O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),n.set(this,void 0),r.set(this,""),d.set(this,void 0),b.set(this,!1),E.set(this,!1),P.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new i.Emitter),this._onDidDispose=Oe(this,t,"f").event,Je(this,O,N,"f"),Je(this,w,q,"f"),Je(this,d,te,"f"),Je(this,p,x,"f"),Je(this,f,F,"f"),Je(this,n,$,"f"),Je(this,P,o($),"f"),Je(this,v,l($),"f"),Je(this,m,T,"f")}dispose(){Je(this,b,!0,"f"),Oe(this,t,"f").fire(),Oe(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(N){return Je(this,E,!0,"f"),(0,y.asWebviewUri)(N,Oe(this,p,"f"))}get cspSource(){const N=Oe(this,n,"f").extensionLocation;if(N.scheme===C.Schemas.https||N.scheme===C.Schemas.http){let q=N.toString();return q.endsWith("/")||(q+="/"),q+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Oe(this,r,"f")}set html(N){this.a(),Oe(this,r,"f")!==N&&(Je(this,r,N,"f"),Oe(this,v,"f")&&!Oe(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(N)&&(Je(this,E,!0,"f"),Oe(this,m,"f").report("Webview vscode-resource: uris",Oe(this,n,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,w,"f").$setHtml(Oe(this,O,"f"),this.b(N)))}get options(){return this.a(),Oe(this,d,"f")}set options(N){this.a(),S.equals(Oe(this,d,"f"),N)||Oe(this,w,"f").$setOptions(Oe(this,O,"f"),c(Oe(this,n,"f"),Oe(this,f,"f"),N)),Je(this,d,N,"f")}async postMessage(N){if(Oe(this,b,"f"))return!1;const q=(0,R.serializeWebviewMessage)(N,{serializeBuffersForPostMessage:Oe(this,P,"f")});return Oe(this,w,"f").$postMessage(Oe(this,O,"f"),q.message,...q.buffers)}a(){if(Oe(this,b,"f"))throw new Error("Webview is disposed")}b(N){if(!Oe(this,v,"f"))return N;const q=Oe(this,n,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,te=Oe(this,n,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Oe(this,n,"f").extensionLocation.authority:void 0;return N.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,F,$,T,M,V)=>{const j=L.URI.from({scheme:T||"file",path:decodeURIComponent(M)}),le=(0,y.asWebviewUri)(j,{isRemote:q,authority:te}).toString();return`${F}${le}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,F,$,T,M,V)=>{const j=L.URI.from({scheme:T||"file",path:decodeURIComponent(M)}),le=(0,y.asWebviewUri)(j,{isRemote:q,authority:te}).toString();return`${F}${le}${V}`})}}e.ExtHostWebview=s,O=new WeakMap,w=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,n=new WeakMap,r=new WeakMap,d=new WeakMap,b=new WeakMap,E=new WeakMap,P=new WeakMap,v=new WeakMap,t=new WeakMap;function o(A){try{const N=(0,I.normalizeVersion)((0,I.parseVersion)(A.engines.vscode));return!!N&&N.majorBase>=1&&N.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function l(A){try{const N=(0,I.normalizeVersion)((0,I.parseVersion)(A.engines.vscode));return N?N.majorBase<1||N.majorBase===1&&N.minorBase<60:!1}catch{return!1}}class a{constructor(N,q,te,x,F){this.c=q,this.d=te,this.e=x,this.f=F,this.b=new Map,this.a=N.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(N,q,te){const x=this.g(N);if(x){const{message:F}=(0,R.deserializeWebviewMessage)(q,te.value);x._onMessageEmitter.fire(F)}}$onMissingCsp(N,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(N,q,te){const x=new s(N,this.a,u(q),this.c,this.d,te,this.f);return this.b.set(N,x),x._onDidDispose(()=>{this.b.delete(N)}),x}deleteWebview(N){this.b.delete(N)}g(N){return this.b.get(N)}}e.ExtHostWebviews=a;function h(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=h;function c(A,N,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||g(A,N)}}e.serializeWebviewOptions=c;function u(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(N=>L.URI.from(N))}}function g(A,N){return[...(N?.getWorkspaceFolders()||[]).map(q=>q.uri),A.extensionLocation]}}),define(Ie[233],Ce([1,0,21,228,6,16,23,2,8,61,53,5,7]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(s,o){this.document=s,this.b=o,this.a=1,this.c=new O.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,o){await this.f(s).undo(),o||this.disposeBackup()}async redo(s,o){await this.f(s).redo(),o||this.disposeBackup()}disposeEdits(s){for(const o of s)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=v(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const o=this.c.get(s,0);if(!o)throw new Error("No edit found");return o}}class f{constructor(){this.a=new Map}get(s,o){return this.a.get(this.b(s,o))}add(s,o,l){const a=this.b(s,o.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${s} resource:${o.uri}`);const h=new p(o,l);return this.a.set(a,h),h}delete(s,o){const l=this.b(s,o.uri);this.a.delete(l)}b(s,o){return`${s}@@@${o}`}}var n;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(n||(n={}));class r{constructor(){this.a=new Map}addTextProvider(s,o,l){return this.b(0,s,o,l)}addCustomProvider(s,o,l){return this.b(1,s,o,l)}get(s){return this.a.get(s)}b(s,o,l,a){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:s,extension:l,provider:a}),new m.Disposable(()=>this.a.delete(o))}}class d{constructor(s,o,l,a,h){this.d=o,this.f=l,this.g=a,this.h=h,this.b=new r,this.c=new f,this.a=s.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,o,l,a){const h=new S.DisposableStore;return E(l)?(h.add(this.b.addTextProvider(o,s,l)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(s),o,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(s))):(h.add(this.b.addCustomProvider(o,s,l)),b(l)&&h.add(l.onDidChangeCustomDocument(c=>{const u=this.i(o,c.document.uri);if(P(c)){const g=u.addEdit(c);this.a.$onDidEdit(c.document.uri,o,g,c.label)}else this.a.$onContentChange(c.document.uri,o)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(s),o,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(s))),m.Disposable.from(h,new m.Disposable(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(s,o,l,a,h){const c=this.b.get(o);if(!c)throw new Error(`No provider found for '${o}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${o}'`);const u=R.URI.revive(s),g=await c.provider.openCustomDocument(u,{backupId:l,untitledDocumentData:a?.buffer},h);let A;return b(c.provider)&&this.f&&(A=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(o,g,A),{editable:b(c.provider)}}async $disposeCustomDocument(s,o){const l=this.b.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${o}'`);const a=R.URI.revive(s),{document:h}=this.i(o,a);this.c.delete(o,h),h.dispose()}async $resolveCustomEditor(s,o,l,a,h,c){console.log("xxxx");const u=this.b.get(l);if(!u)throw new Error(`No provider found for '${l}'`);const g=y.ViewColumn.to(h),A=this.g.createNewWebview(o,a.contentOptions,u.extension),N=this.h.createNewWebviewPanel(o,l,a.title,g,a.options,A,!0),q=R.URI.revive(s);switch(u.type){case 1:{const{document:te}=this.i(l,q);return u.provider.resolveCustomEditor(te,N,c)}case 0:{const te=this.d.getDocument(q);return u.provider.resolveCustomTextEditor(te,N,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,o,l){this.i(o,s).disposeEdits(l)}async $onMoveCustomEditor(s,o,l){const a=this.b.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(s);if(!h)throw new Error("No webview found");const c=R.URI.revive(o),u=this.d.getDocument(c);await a.provider.moveCustomTextEditor(u,h,i.CancellationToken.None)}async $undo(s,o,l,a){return this.i(o,s).undo(l,a)}async $redo(s,o,l,a){return this.i(o,s).redo(l,a)}async $revert(s,o,l){const a=this.i(o,s);await this.j(o).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(s,o,l){const a=this.i(o,s);await this.j(o).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(s,o,l,a){const h=this.i(o,s);return this.j(o).saveCustomDocumentAs(h.document,R.URI.revive(l),a)}async $backup(s,o,l){const a=this.i(o,s),c=await this.j(o).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(c),c.id}i(s,o){const l=this.c.get(s,R.URI.revive(o));if(!l)throw new Error("No custom document found");return l}j(s){const l=this.b.get(s)?.provider;if(!l||!b(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=d;function b(t){return!!t.onDidChangeCustomDocument}function E(t){return typeof t.resolveCustomTextEditor=="function"}function P(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const s=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,C.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[234],Ce([1,0,4,6,2,34,8,61,5,7]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";var O,w,m,p,f,n,r,d,b,E,P,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends C.Disposable{constructor(h,c,u,g){super(),O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),n.set(this,void 0),r.set(this,void 0),d.set(this,void 0),b.set(this,!0),E.set(this,void 0),P.set(this,!1),v.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,v,"f").event,t.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,O,h,"f"),Je(this,w,c,"f"),Je(this,p,u,"f"),Je(this,m,g.viewType,"f"),Je(this,f,g.panelOptions,"f"),Je(this,d,g.viewColumn,"f"),Je(this,n,g.title,"f"),Je(this,E,g.active,"f")}dispose(){Oe(this,P,"f")||(Je(this,P,!0,"f"),Oe(this,v,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,p,"f")}get viewType(){return this.c(),Oe(this,m,"f")}get title(){return this.c(),Oe(this,n,"f")}set title(h){this.c(),Oe(this,n,"f")!==h&&(Je(this,n,h,"f"),Oe(this,w,"f").$setTitle(Oe(this,O,"f"),h))}get iconPath(){return this.c(),Oe(this,r,"f")}set iconPath(h){this.c(),Oe(this,r,"f")!==h&&(Je(this,r,h,"f"),Oe(this,w,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,d,"f")=="number"&&Oe(this,d,"f")<0))return Oe(this,d,"f")}get active(){return this.c(),Oe(this,E,"f")}get visible(){return this.c(),Oe(this,b,"f")}_updateViewState(h){Oe(this,P,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Je(this,E,h.active,"f"),Je(this,b,h.visible,"f"),Je(this,d,h.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(h,c){this.c(),Oe(this,w,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof h>"u"?void 0:I.ViewColumn.from(h),preserveFocus:!!c})}c(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,n=new WeakMap,r=new WeakMap,d=new WeakMap,b=new WeakMap,E=new WeakMap,P=new WeakMap,v=new WeakMap,t=new WeakMap;class o{static c(){return(0,L.generateUuid)()}constructor(h,c,u){this.g=c,this.h=u,this.e=new Map,this.f=new Map,this.d=h.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(h,c,u,g,A={}){const N=typeof g=="object"?g.viewColumn:g,q={viewColumn:I.ViewColumn.from(N),preserveFocus:typeof g=="object"&&!!g.preserveFocus},te=(0,R.shouldSerializeBuffersForPostMessage)(h),x=o.c();this.d.$createWebviewPanel((0,R.toExtensionData)(h),x,c,{title:u,panelOptions:l(A),webviewOptions:(0,R.serializeWebviewOptions)(h,this.h,A),serializeBuffersForPostMessage:te},q);const F=this.g.createNewWebview(x,A,h);return this.createNewWebviewPanel(x,c,u,N,A,F,!0)}$onDidChangeWebviewPanelViewStates(h){const c=Object.keys(h);c.sort((u,g)=>{const A=h[u],N=h[g];return A.active?1:N.active?-1:+A.visible-+N.visible});for(const u of c){const g=this.getWebviewPanel(u);if(!g)continue;const A=h[u];g._updateViewState({active:A.active,visible:A.visible,viewColumn:I.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this.e.delete(h),this.g.deleteWebview(h)}registerWebviewPanelSerializer(h,c,u){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:u,extension:h}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(h)}),new k.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(h,c,u,g){const A=this.f.get(c);if(!A)throw new Error(`No serializer found for '${c}'`);const{serializer:N,extension:q}=A,te=this.g.createNewWebview(h,u.webviewOptions,q),x=this.createNewWebviewPanel(h,c,u.title,g,u.panelOptions,te,u.active);await N.deserializeWebviewPanel(x,u.state)}createNewWebviewPanel(h,c,u,g,A,N,q){const te=new s(h,this.d,N,{viewType:c,title:u,viewColumn:g,panelOptions:A,active:q});return this.e.set(h,te),te}getWebviewPanel(h){return this.e.get(h)}}e.ExtHostWebviewPanels=o;function l(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[235],Ce([1,0,4,6,61,8,5,7]),function(ee,e,i,C,S,L,I,R){"use strict";var y,k,O,w,m,p,f,n,r,d,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends C.Disposable{constructor(t,s,o,l,a,h){super(),y.set(this,void 0),k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),m.set(this,!1),p.set(this,void 0),f.set(this,void 0),n.set(this,void 0),r.set(this,void 0),d.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Oe(this,d,"f").event,b.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,b,"f").event,Je(this,O,o,"f"),Je(this,f,l,"f"),Je(this,y,t,"f"),Je(this,k,s,"f"),Je(this,w,a,"f"),Je(this,p,h,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,b,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,f,"f")}set title(t){this.a(),Oe(this,f,"f")!==t&&(Je(this,f,t,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,y,"f"),t))}get description(){return this.a(),Oe(this,n,"f")}set description(t){this.a(),Oe(this,n,"f")!==t&&(Je(this,n,t,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,y,"f"),t))}get visible(){return Oe(this,p,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(t){t===Oe(this,p,"f")||Oe(this,m,"f")||(Je(this,p,t,"f"),Oe(this,d,"f").fire())}get badge(){return this.a(),Oe(this,r,"f")}set badge(t){this.a(),!(t?.value===Oe(this,r,"f")?.value&&t?.tooltip===Oe(this,r,"f")?.tooltip)&&(Je(this,r,L.ViewBadge.from(t),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,y,"f"),t))}show(t){this.a(),Oe(this,k,"f").$show(Oe(this,y,"f"),!!t)}a(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,O=new WeakMap,w=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,n=new WeakMap,r=new WeakMap,d=new WeakMap,b=new WeakMap;class P{constructor(t,s){this.d=s,this.b=new Map,this.c=new Map,this.a=t.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,s,o,l){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:o,extension:t}),this.a.$registerWebviewViewProvider((0,S.toExtensionData)(t),s,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(t,s,o,l,a){const h=this.b.get(s);if(!h)throw new Error(`No view provider found for '${s}'`);const{provider:c,extension:u}=h,g=this.d.createNewWebview(t,{},u),A=new E(t,this.a,s,o,g,!0);this.c.set(t,A),await c.resolveWebviewView(A,{state:l},a)}async $onDidChangeWebviewViewVisibility(t,s){this.e(t)._setVisible(s)}async $disposeWebviewView(t){const s=this.e(t);this.c.delete(t),s.dispose(),this.d.deleteWebview(t)}e(t){const s=this.c.get(t);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=P}),define(Ie[103],Ce([1,0,4,5,2,16,10,3,17]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class sn{get state(){return this.d}constructor(w){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=sn.a,this.b=w.getProxy(C.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,m){let p;if(typeof w=="string"){p=w;try{w=S.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,I.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,p,m)}async asExternalUri(w,m){if((0,I.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(w,m);return S.URI.from(p)}};k.a={focused:!0},k=qe([Ve(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ie[236],Ce([1,0,206,27,17]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(R,y){super(R,y)}f(R,y,k){y.apply(console,k)}};L=qe([Ve(0,S.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ie[237],Ce([1,0,12,25,21,11,4,6,125,200,44]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(A,N){try{return JSON.stringify(A,N)}catch{return"null"}}const p="$$ref$$",f={[p]:-1};class n{constructor(N,q){this.jsonString=N,this.referencedBuffers=q}}function r(A,N=null,q=!1){const te=[];return{jsonString:(q?m:JSON.stringify)(A,(F,$)=>{if(typeof $>"u")return f;if(typeof $=="object"){if($ instanceof C.VSBuffer){const T=te.push($)-1;return{[p]:T}}if(N)return N(F,$)}return $}),referencedBuffers:te}}e.stringifyJsonWithBufferRefs=r;function d(A,N,q){return JSON.parse(A,(te,x)=>{if(x){const F=x[p];if(typeof F=="number")return N[F];if(q&&x.$mid===1)return q.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=d;function b(A,N){return JSON.stringify(A,N)}function E(A){return A?(N,q)=>q&&q.$mid===1?A.transformOutgoing(q):q:null}var P;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},s=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class l extends R.Disposable{constructor(N,q=null,te=null){super(),this[w]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=q,this.g=te,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,F=O.ProxyIdentifier.count;x<F;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(N=>{this.s[N].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(N){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(N){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(N){this.t!==N&&(this.t=N,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(N){return this.g?(0,y.transformIncomingURIs)(N,this.g):N}getProxy(N){const{nid:q,sid:te}=N;return this.l[q]||(this.l[q]=this.F(q,te)),this.l[q]}F(N,q){const te={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...$)=>this.O(N,F,$)),F===o?q:x[F])};return new Proxy(Object.create(null),te)}set(N,q){return this.k[N.nid]=q,q}assertRegistered(N){for(let q=0,te=N.length;q<te;q++){const x=N[q];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(N){if(this.j)return;const q=N.byteLength,te=a.read(N,0),x=te.readUInt8(),F=te.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:T,args:M}=c.deserializeRequestJSONArgs(te);this.g&&(M=(0,y.transformIncomingURIs)(M,this.g)),this.H(q,F,$,T,M,x===2);break}case 3:case 4:{let{rpcId:$,method:T,args:M}=c.deserializeRequestMixedArgs(te);this.g&&(M=(0,y.transformIncomingURIs)(M,this.g)),this.H(q,F,$,T,M,x===4);break}case 5:{this.f?.logIncoming(q,F,0,"ack"),this.z(F);break}case 6:{this.I(q,F);break}case 7:{this.J(q,F,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(te);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.J(q,F,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(te,this.g);this.J(q,F,$);break}case 8:{const $=c.deserializeReplyOKVSBuffer(te);this.J(q,F,$);break}case 11:{let $=c.deserializeReplyErrError(te);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.L(q,F,$);break}case 12:{this.L(q,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}H(N,q,te,x,F,$){this.f?.logIncoming(N,q,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(te)}.${x}(`,F);const T=String(q);let M,V;if($){const le=new S.CancellationTokenSource;F.push(le.token),M=this.M(te,x,F),V=()=>le.cancel()}else M=this.M(te,x,F),V=t;this.p[T]=V;const j=c.serializeAcknowledged(q);this.f?.logOutgoing(j.byteLength,q,1,"ack"),this.c.send(j),M.then(le=>{delete this.p[T];const Y=c.serializeReplyOK(q,le,this.h);this.f?.logOutgoing(Y.byteLength,q,1,"reply:",le),this.c.send(Y)},le=>{delete this.p[T];const Y=c.serializeReplyErr(q,le);this.f?.logOutgoing(Y.byteLength,q,1,"replyErr:",le),this.c.send(Y)})}I(N,q){this.f?.logIncoming(N,q,1,"receiveCancel");const te=String(q);this.p[te]?.()}J(N,q,te){this.f?.logIncoming(N,q,0,"receiveReply:",te);const x=String(q);if(!this.s.hasOwnProperty(x))return;const F=this.s[x];delete this.s[x],F.resolveOk(te)}L(N,q,te){this.f?.logIncoming(N,q,0,"receiveReplyErr:",te);const x=String(q);if(!this.s.hasOwnProperty(x))return;const F=this.s[x];delete this.s[x];let $;te&&(te.$isError?($=new Error,$.name=te.name,$.message=te.message,$.stack=te.stack):$=te),F.resolveErr($)}M(N,q,te){try{return Promise.resolve(this.N(N,q,te))}catch(x){return Promise.reject(x)}}N(N,q,te){const x=this.k[N];if(!x)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(N));const F=x[q];if(typeof F!="function")throw new Error("Unknown method "+q+" on actor "+(0,O.getStringIdentifierForProxy)(N));return F.apply(x,te)}O(N,q,te){if(this.j)return new k.CanceledLazyPromise;let x=null;if(te.length>0&&S.CancellationToken.isCancellationToken(te[te.length-1])&&(x=te.pop()),x&&x.isCancellationRequested)return Promise.reject(L.canceled());const F=c.serializeRequestArguments(te,this.h),$=++this.m,T=String($),M=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const j=c.serializeCancel($);this.f?.logOutgoing(j.byteLength,$,0,"cancel"),this.c.send(c.serializeCancel($))}),this.s[T]=M,this.y($);const V=c.serializeRequest($,N,q,F,!!x);return this.f?.logOutgoing(V.byteLength,$,0,`request: ${(0,O.getStringIdentifierForProxy)(N)}.${q}(`,te),this.c.send(V),M}}e.RPCProtocol=l,w=s,l.a=3*1e3;class a{static alloc(N,q,te){const x=new a(C.VSBuffer.alloc(te+1+4),0);return x.writeUInt8(N),x.writeUInt32(q),x}static read(N,q){return new a(N,q)}get buffer(){return this.a}constructor(N,q){this.a=N,this.b=q}static sizeUInt8(){return 1}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const te=this.a.slice(this.b,this.b+N).toString();return this.b+=N,te}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const te=this.a.slice(this.b,this.b+N).toString();return this.b+=N,te}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+N);return this.b+=N,q}static sizeMixedArray(N){let q=0;q+=1;for(let te=0,x=N.length;te<x;te++){const F=N[te];switch(q+=1,F.type){case 1:q+=this.sizeLongString(F.value);break;case 2:q+=this.sizeVSBuffer(F.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)q+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return q}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let q=0,te=N.length;q<te;q++){const x=N[q];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const q=new Array(N);for(let te=0;te<N;te++)switch(this.readUInt8()){case 1:q[te]=this.readLongString();break;case 2:q[te]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),$=this.readLongString(),T=[];for(let M=0;M<F;++M)T.push(this.readVSBuffer());q[te]=new O.SerializableObjectWithBuffers(d($,T,null));break}case 4:q[te]=void 0;break}return q}}a.sizeUInt32=4;var h;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(h||(h={}));class c{static a(N){for(let q=0,te=N.length;q<te;q++)if(N[q]instanceof C.VSBuffer||N[q]instanceof O.SerializableObjectWithBuffers||typeof N[q]>"u")return!0;return!1}static serializeRequestArguments(N,q){if(this.a(N)){const te=[];for(let x=0,F=N.length;x<F;x++){const $=N[x];if($ instanceof C.VSBuffer)te[x]={type:2,value:$};else if(typeof $>"u")te[x]={type:4};else if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:M}=r($.value,q);te[x]={type:3,value:C.VSBuffer.fromString(T),buffers:M}}else te[x]={type:1,value:C.VSBuffer.fromString(b($,q))}}return{type:1,args:te}}return{type:0,args:b(N,q)}}static serializeRequest(N,q,te,x,F){switch(x.type){case 0:return this.b(N,q,te,x.args,F);case 1:return this.c(N,q,te,x.args,F)}}static b(N,q,te,x,F){const $=C.VSBuffer.fromString(te),T=C.VSBuffer.fromString(x);let M=0;M+=a.sizeUInt8(),M+=a.sizeShortString($),M+=a.sizeLongString(T);const V=a.alloc(F?2:1,N,M);return V.writeUInt8(q),V.writeShortString($),V.writeLongString(T),V.buffer}static deserializeRequestJSONArgs(N){const q=N.readUInt8(),te=N.readShortString(),x=N.readLongString();return{rpcId:q,method:te,args:JSON.parse(x)}}static c(N,q,te,x,F){const $=C.VSBuffer.fromString(te);let T=0;T+=a.sizeUInt8(),T+=a.sizeShortString($),T+=a.sizeMixedArray(x);const M=a.alloc(F?4:3,N,T);return M.writeUInt8(q),M.writeShortString($),M.writeMixedArray(x),M.buffer}static deserializeRequestMixedArgs(N){const q=N.readUInt8(),te=N.readShortString(),x=N.readMixedArray(),F=new Array(x.length);for(let $=0,T=x.length;$<T;$++){const M=x[$];typeof M=="string"?F[$]=JSON.parse(M):F[$]=M}return{rpcId:q,method:te,args:F}}static serializeAcknowledged(N){return a.alloc(5,N,0).buffer}static serializeCancel(N){return a.alloc(6,N,0).buffer}static serializeReplyOK(N,q,te){if(typeof q>"u")return this.d(N);if(q instanceof C.VSBuffer)return this.e(N,q);if(q instanceof O.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=r(q.value,te,!0);return this.g(N,x,F)}else return this.f(N,m(q,te))}static d(N){return a.alloc(7,N,0).buffer}static e(N,q){let te=0;te+=a.sizeVSBuffer(q);const x=a.alloc(8,N,te);return x.writeVSBuffer(q),x.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,q){const te=C.VSBuffer.fromString(q);let x=0;x+=a.sizeLongString(te);const F=a.alloc(9,N,x);return F.writeLongString(te),F.buffer}static g(N,q,te){const x=C.VSBuffer.fromString(q);let F=0;F+=a.sizeUInt32,F+=a.sizeLongString(x);for(const T of te)F+=a.sizeVSBuffer(T);const $=a.alloc(10,N,F);$.writeUInt32(te.length),$.writeLongString(x);for(const T of te)$.writeBuffer(T);return $.buffer}static deserializeReplyOKJSON(N){const q=N.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(N,q){const te=N.readUInt32(),x=N.readLongString(),F=[];for(let $=0;$<te;++$)F.push(N.readVSBuffer());return new O.SerializableObjectWithBuffers(d(x,F,q))}static serializeReplyErr(N,q){const te=q?m(L.transformErrorForSerialization(q),null):void 0;if(typeof te!="string")return this.h(N);const x=C.VSBuffer.fromString(te);let F=0;F+=a.sizeLongString(x);const $=a.alloc(11,N,F);return $.writeLongString(x),$.buffer}static deserializeReplyErrError(N){const q=N.readLongString();return JSON.parse(q)}static h(N){return a.alloc(12,N,0).buffer}}var u;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var g;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[238],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const I=R=>{self.removeEventListener("message",I);const y=R.data;Object.defineProperties(self,{postMessage:{value(k,O){y.postMessage(k,O)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",I)}.toString();class C extends EventTarget{constructor(L,I,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${I}'))`,k=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(k),w=new MessageChannel,m=O,p={type:"_newWorker",id:m,port:w.port2,url:O,options:R};L(p,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(f){w.port1.onmessage=f}},onmessageerror:{get(){return w.port1.onmessageerror},set(f){w.port1.onmessageerror=f}}}),w.port1.addEventListener("messageerror",f=>{const n=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(n)}),w.port1.addEventListener("message",f=>{const n=new MessageEvent("message",{data:f.data});this.dispatchEvent(n)}),w.port1.start()}}e.NestedWorker=C}),define(Ie[239],Ce([1,0,4,29,42,3,36,11,12]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(n=>f.push(n)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}C.Registry.add(e.Extensions.OutputChannels,new O);function w(p,f,n,r,d){return(0,y.createCancelablePromise)(async b=>{await(0,I.whenProviderRegistered)(n,r);const E=C.Registry.as(e.Extensions.OutputChannels);try{await m(n,1,r,d,b),E.registerChannel({id:p,label:f,file:n,log:!0})}catch(P){(0,R.isCancellationError)(P)||d.error("Error while registering log channel",n.toString(),(0,R.getErrorMessage)(P))}})}e.registerLogChannel=w;async function m(p,f,n,r,d){if(!await n.exists(p)){if(d.isCancellationRequested)throw new R.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");r.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",p.toString()),await(0,y.timeout)(1e3,d),await m(p,f+1,n,r,d)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new S.RawContextKey("activeOutputChannel","")}),define(Ie[104],Ce([1,0,5,3,17,26,13,239,59,27,37,119,25,9,36,4,6]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(v,t,s,o,l){super(),this.id=v,this.name=t,this.m=s,this.n=o,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.k;this.info(v),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(v,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.n.$close(this.id)}g(v,t){this.k+=m.VSBuffer.fromString(t).byteLength,(0,I.log)(this.m,v,t),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends d{appendLine(v){this.append(v)}}let E=class{constructor(v,t,s,o,l,a){this.i=t,this.j=s,this.k=o,this.l=l,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(v,t,s){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,l=(0,p.isString)(t)?t:void 0;if((0,p.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([u])=>L.ExtensionIdentifier.equals(s.identifier,u))?.[1];h&&(a=(0,I.parseLogLevel)(h));const c=o?this.o(v,a,s):this.n(v,l,s);return c.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),o?this.r(v,a??this.m.getLevel(),c):this.q(v,c)}async n(v,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,l=this.k.extUri.joinPath(o,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.a.$register(v,l,!1,t,s.identifier.value);return new d(h,v,a,this.a,s)}async o(v,t,s){const o=await this.p(s),l=this.k.extUri.joinPath(o,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{name:v},t),h=await this.a.$register(v,l,!0,void 0,s.identifier.value);return new b(h,v,a,this.a,s)}p(v){let t=this.d.get(v.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileExists)throw o}return s})())}return t}q(v,t){let s=!1;const o=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return v},append(l){o(),t.then(a=>a.append(l))},appendLine(l){o(),t.then(a=>a.appendLine(l))},clear(){o(),t.then(l=>l.clear())},replace(l){o(),t.then(a=>a.replace(l))},show(l,a){o(),t.then(h=>h.show(l,a))},hide(){o(),t.then(l=>l.hide())},dispose(){s=!0,t.then(l=>l.dispose())}}}r(v,t,s){const o=new r.DisposableStore,l=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},a=o.add(new n.Emitter);return s.then(h=>{o.add(h),o.add(h.onDidChangeLogLevel(c=>{t=c,a.fire(c)}))}),{...this.q(v,s),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(h,...c){l(),s.then(u=>u.trace(h,...c))},debug(h,...c){l(),s.then(u=>u.debug(h,...c))},info(h,...c){l(),s.then(u=>u.info(h,...c))},warn(h,...c){l(),s.then(u=>u.warn(h,...c))},error(h,...c){l(),s.then(u=>u.error(h,...c))},dispose(){o.dispose()}}}};E=qe([Ve(0,S.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,y.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,I.ILoggerService),Ve(5,I.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ie[240],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ie[241],Ce([1,0,40,16,19,20,23,2,3,171,52,187,240]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let p=class on{constructor(n,r,d,b){this.d=n,this.e=r,this.f=d,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??n})()}hasValidBasename(n,r,d){return typeof r=="string"||typeof r>"u"?this.a.then(b=>this.h(n,b,r)):this.h(n,r,d)}h(n,r,d){return n.scheme===C.Schemas.file||n.scheme===C.Schemas.vscodeRemote?(0,i.isValidBasename)(d??(0,I.basename)(n),r===1):!0}get defaultUriScheme(){return on.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(n,r){if(n.remoteAuthority)return C.Schemas.vscodeRemote;const d=(0,k.getVirtualWorkspaceScheme)(r.getWorkspace());if(d)return d;const b=r.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=r.getWorkspace().configuration;return E?E.scheme:C.Schemas.file}userHome(n){return n?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(n=>n===1?S.win32:S.posix)}async fileURI(n){let r="";if(await this.a===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const b=n.indexOf("/",2);b===-1?(r=n.substring(2),n="/"):(r=n.substring(2,b),n=n.substring(b)||"/")}return R.URI.from({scheme:C.Schemas.file,authority:r,path:n,query:"",fragment:""})}};p=qe([Ve(1,m.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(Ie[105],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(I,R){this.line=I,this.character=R}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,R){return new i(0,0)}with(I){return new i(0,0)}}e.Position=i;class C{constructor(I,R,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(I,R),this.end=new i(y,k)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new C(0,0,0,0)}with(I){return new C(0,0,0,0)}}e.Range=C;var S;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[45],Ce([1,0,18,35,22,40,10,3,19,11,105,12]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",p=" characters skipped \u27EB",f=(m.length+p.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var n;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(n=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function d(ue){return!!ue.preview}e.resultIsMatch=d;function b(ue){return!!ue.resource}e.isFileMatch=b;function E(ue){return!!ue.message}e.isProgressMessage=E;var P;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(P=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=v;class t{constructor(de,re,G){this.ranges=re;const H=Array.isArray(re)?re:[re];if(G&&G.matchLines===1&&s(H)){de=(0,I.getNLines)(de,G.matchLines);let oe="",ve=0,Ae=0;const Be=Math.floor(G.charsPerLine/5),xe=[];for(const Te of H){const Se=Math.max(Te.startColumn-Be,0),ke=Te.startColumn+G.charsPerLine;if(Se>Ae+Be+f){const se=m+(Se-Ae)+p;oe+=se+de.slice(Se,ke),ve+=Se-(Ae+se.length)}else oe+=de.slice(Ae,ke);xe.push(new l(0,Te.startColumn-ve,Te.endColumn-ve)),Ae=ke}this.preview={text:oe,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const oe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:de,matches:(0,i.mapArrayOrNot)(re,ve=>new o(ve.startLineNumber-oe,ve.startColumn,ve.endLineNumber-oe,ve.endColumn))}}}}e.TextSearchMatch=t;function s(ue){const de=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==de||re.endLineNumber!==de)return!1;return!0}class o{constructor(de,re,G,H){this.startLineNumber=de,this.startColumn=re,this.endLineNumber=G,this.endColumn=H}}e.SearchRange=o;class l extends o{constructor(de,re,G){super(de,re,de,G)}}e.OneLineRange=l;var a;(function(ue){ue.List="list",ue.Tree="tree"})(a=e.ViewMode||(e.ViewMode={}));var h;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function c(ue,de=!0){const re=ue&&ue.files&&ue.files.exclude,G=de&&ue&&ue.search&&ue.search.exclude;if(!re&&!G)return;if(!re||!G)return re||G;let H=Object.create(null);return H=S.mixin(H,S.deepClone(re)),H=S.mixin(H,S.deepClone(G),!0),H}e.getExcludes=c;function u(ue,de){return ue.excludePattern&&C.match(ue.excludePattern,de)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&C.match(ue.includePattern,de)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const G=re.folder.fsPath;if(L.isEqualOrParent(de,G)){const H=y.relative(G,de);return!re.includePattern||!!C.match(re.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(de,re){super(de),this.code=re}}e.SearchError=A;function N(ue){const de=ue.message;if((0,k.isCancellationError)(ue))return new A(de,g.canceled);try{const re=JSON.parse(de);return new A(re.message,re.code)}catch{return new A(de,g.other)}}e.deserializeSearchError=N;function q(ue){const de={message:ue.message,code:ue.code};return new Error(JSON.stringify(de))}e.serializeSearchError=q;function te(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=te;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function F(ue){return!!ue.path}e.isSerializedFileMatch=F;function $(ue,de){const re=ue.searchPath?ue.searchPath:ue.relativePath;return(0,I.fuzzyContains)(re,de)}e.isFilePatternMatch=$;class T{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=T;function M(ue,de){const re={...ue||{},...de||{}};return Object.keys(re).filter(G=>{const H=re[G];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class V{constructor(de,re){this.c=null,this.a={...de.excludePattern||{},...re.excludePattern||{}},this.b=C.parse(this.a);let G=de.includePattern;re.includePattern&&(G?G={...G,...re.includePattern}:G=re.includePattern),G&&(this.c=C.parse(G))}matchesExcludesSync(de,re,G){return!!(this.b&&this.b(de,re,G))}includedInQuerySync(de,re,G){return!(this.b&&this.b(de,re,G)||this.c&&!this.c(de,re,G))}includedInQuery(de,re,G){const H=this.b(de,re,G),oe=()=>this.c?!!this.c(de,re,G):!0;return(0,w.isThenable)(H)?H.then(ve=>ve?!1:oe()):oe()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=V;function j(ue){for(const de in ue)if(typeof ue[de]!="boolean")return!0;return!1}function le(ue){if(!ue)return;let de;return re=>(de||(de=(ue()||Promise.resolve([])).then(G=>G?pe(G):{})),de.then(G=>!!G[re]))}e.hasSiblingPromiseFn=le;function Y(ue){if(!ue)return;let de;return re=>{if(!de){const G=ue();de=G?pe(G):{}}return!!de[re]}}e.hasSiblingFn=Y;function pe(ue){const de={};for(const re of ue)de[re]=!0;return de}}),define(Ie[31],Ce([1,0,18,12,21,4,6,46,16,112,23,10,9,2,143,3,13,159,52,37,27,17,8,7,54,45,5]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v,t,s,o,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function h(x,F,$){return new O.ExtUri(T=>A(T,$)).isEqual(x,F)}function c(x,F,$){return h(x.uri,F.uri,$)?0:(0,w.compare)(x.uri.toString(),F.uri.toString())}function u(x,F,$){return x.index!==F.index?x.index<F.index?-1:1:h(x.uri,F.uri,$)?(0,w.compare)(x.name,F.name):(0,w.compare)(x.uri.toString(),F.uri.toString())}function g(x,F,$,T){const M=x.slice(0).sort((j,le)=>$(j,le,T)),V=F.slice(0).sort((j,le)=>$(j,le,T));return(0,i.delta)(M,V,(j,le)=>$(j,le,T))}function A(x,F){const $=F.getCapabilities(x.scheme);return!($&&$&1024)}class N extends b.Workspace{static toExtHostWorkspace(F,$,T,M){if(!F)return{workspace:null,added:[],removed:[]};const{id:V,name:j,folders:le,configuration:Y,transient:pe,isUntitled:ue}=F,de=[],re=$;$?le.forEach((ve,Ae)=>{const Be=p.URI.revive(ve.uri),xe=N.e(T||$,Be,M);xe?(xe.name=ve.name,xe.index=ve.index,de.push(xe)):de.push({uri:Be,name:ve.name,index:Ae})}):de.push(...le.map(({uri:ve,name:Ae,index:Be})=>({uri:p.URI.revive(ve),name:Ae,index:Be}))),de.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const G=new N(V,j,de,!!pe,Y?p.URI.revive(Y):null,!!ue,ve=>A(ve,M)),{added:H,removed:oe}=g(re?re.workspaceFolders:[],G.workspaceFolders,c,M);return{workspace:G,added:H,removed:oe}}static e(F,$,T){for(let M=0;M<F.folders.length;M++){const V=F.workspaceFolders[M];if(h(V.uri,$,T))return V}}constructor(F,$,T,M,V,j,le){super(F,T.map(Y=>new b.WorkspaceFolder(Y)),M,V,le),this.s=$,this.t=j,this.o=[],this.q=R.TernarySearchTree.forUris(le),T.forEach(Y=>{this.o.push(Y),this.q.set(Y.uri,Y)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,$){return $&&this.q.get(F)&&(F=(0,O.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let q=class{constructor(F,$,T,M,V){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=M,this.q=T,this.s=V,this.h=new k.Counter,this.j=new C.Barrier,this.n=F.getProxy(a.MainContext.MainThreadWorkspace),this.o=F.getProxy(a.MainContext.MainThreadMessageService);const j=$.workspace;this.k=j?new N(j.id,j.name,[],!!j.transient,j.configuration?p.URI.revive(j.configuration):null,!!j.isUntitled,le=>A(le,T)):void 0}$initializeWorkspace(F,$){this.u=$,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?p.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,$,T,...M){const V=[];if(Array.isArray(M)&&M.forEach(ue=>{p.URI.isUri(ue.uri)&&!V.some(de=>h(de.uri,ue.uri,this.q))&&V.push({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri)})}),this.l||[$,T].some(ue=>typeof ue!="number"||ue<0)||T===0&&V.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if($+T>j.length)return!1;const le=j.slice(0);le.splice($,T,...V.map(ue=>({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<le.length;ue++){const de=le[ue];if(le.some((re,G)=>G!==ue&&h(de.uri,re.uri,this.q)))return!1}le.forEach((ue,de)=>ue.index=de);const{added:Y,removed:pe}=g(j,le,u,this.q);if(Y.length===0&&pe.length===0)return!1;if(this.n){const ue=F.displayName||F.name;this.n.$updateWorkspaceFolders(ue,$,T,V).then(void 0,de=>{this.l=void 0;const re={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(d.Severity.Error,(0,f.localize)(0,null,ue,de.toString()),re,[])})}return this.x(le),!0}getWorkspaceFolder(F,$){if(!!this.w)return this.w.getWorkspaceFolder(F,$)}async getWorkspaceFolder2(F,$){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,$)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,$){let T,M="";if(typeof F=="string"?(T=p.URI.file(F),M=F):typeof F<"u"&&(T=F,M=F.fsPath),!T)return M;const V=this.getWorkspaceFolder(T,!0);if(!V)return M;typeof $>"u"&&this.w&&($=this.w.folders.length>1);let j=(0,O.relativePath)(V.uri,T);return $&&V.name&&(j=`${V.name}/${j}`),j}x(F){this.w&&(this.l=N.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:$,added:T,removed:M}=N.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=$||void 0,this.l=void 0,this.c.fire(Object.freeze({added:T,removed:M}))}findFiles(F,$,T,M,V=S.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let j;if($===null?j=!1:$&&(typeof $=="string"?j=$:j=$.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Y}=te(t.GlobPattern.from(F));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(le),(0,m.withUndefinedAsNull)(Y),(0,m.withUndefinedAsNull)(j),(0,m.withUndefinedAsNull)(T),V).then(pe=>Array.isArray(pe)?pe.map(ue=>p.URI.revive(ue)):[])}async findTextInFiles(F,$,T,M,V=S.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),le=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:Y,folder:pe}=te(t.GlobPattern.from($.include)),ue=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:le,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:Y,excludePattern:ue},re=!1;if(this.t[j]=G=>{if(re)return;const H=p.URI.revive(G.resource);G.results.forEach(oe=>{(0,l.resultIsMatch)(oe)?T({uri:H,preview:{text:oe.preview.text,matches:(0,i.mapArrayOrNot)(oe.preview.matches,ve=>new s.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,i.mapArrayOrNot)(oe.ranges,ve=>new s.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):T({uri:H,text:oe.text,lineNumber:oe.lineNumber})})},V.isCancellationRequested)return{};try{const G=await this.n.$startTextSearch(F,(0,m.withUndefinedAsNull)(pe),de,j,V);return delete this.t[j],G||{}}catch(G){throw delete this.t[j],G}}$handleTextSearchResult(F,$){this.t[$]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,$){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,$);const T=this.s.transformOutgoingScheme(F),M=this.y++;return this.n.$registerEditSessionIdentityProvider(M,T),(0,I.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(F,$){this.g.info("Getting edit session identifier for workspaceFolder",F);const T=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!T){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const M=this.v.get(T.uri.scheme);if(this.g.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!M),!M)return;const V=await M.provideEditSessionIdentity(T,$);if(this.g.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(F,$,T,M){this.g.info("Getting edit session identifier for workspaceFolder",F);const V=await this.resolveWorkspaceFolder(p.URI.revive(F));if(!V){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const j=this.v.get(V.uri.scheme);if(this.g.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.($,T,M);if(this.g.info("Provider returned edit session identifier match result: ",le),!!le)return le}};q=qe([Ve(0,v.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,r.ILogService),Ve(4,o.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,n.createDecorator)("IExtHostWorkspace");function te(x){let F,$;return x&&(typeof x=="string"?F=x:(F=x.pattern,$=p.URI.revive(x.baseUri))),{includePattern:F,folder:$}}}),define(Ie[32],Ce([1,0,22,4,31,5,7,162,92,9,12,3,17,13,2]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(s,o){if(o){const l=o.split(".");let a=s;for(let h=0;a&&h<l.length;h++)a=a[l[h]];return a}}function r(s){return s instanceof f.URI}function d(s){return s&&s.uri instanceof f.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function E(s){return s&&s.uri instanceof f.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function P(s){if(r(s))return{resource:s};if(d(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(E(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(o,l,a){this.a=o.getProxy(L.MainContext.MainThreadConfiguration),this.c=l,this.b=a,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,l))}};v=qe([Ve(0,m.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,p.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(o,l,a,h){this.a=new C.Emitter,this.b=o,this.f=h,this.c=l,this.e=R.Configuration.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,l){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(l,a))}getConfiguration(o,l,a){const h=P(l)||{},c=this.g(o?n(this.e.getValue(void 0,h,this.c.workspace),o):this.e.getValue(void 0,h,this.c.workspace));o&&this.h(o,h,a?.identifier);function u(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(A){return typeof n(c,A)<"u"},get:(A,N)=>{this.h(o?`${o}.${A}`:A,h,a?.identifier);let q=n(c,A);if(typeof q>"u")q=N;else{let te;const x=(F,$)=>{let T;const M=()=>{te=te||(0,i.deepClone)(c),T=T||n(te,$)};return(0,k.isObject)(F)?new Proxy(F,{get:(V,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return M(),()=>T;if(te)return T=T||n(te,$),T[j];const le=V[j];return typeof j=="string"?x(le,`${$}.${j}`):le},set:(V,j,le)=>(M(),T&&(T[j]=le),!0),deleteProperty:(V,j)=>(M(),T&&delete T[j],!0),defineProperty:(V,j,le)=>(M(),T&&Object.defineProperty(T,j,le),!0)}):F};q=x(q,A)}return q},update:(A,N,q,te)=>{A=o?`${o}.${A}`:A;const x=u(q);return N!==void 0?this.b.$updateConfigurationOption(x,A,N,h,te):this.b.$removeConfigurationOption(x,A,h,te)},inspect:A=>{A=o?`${o}.${A}`:A;const N=this.e.inspect(A,h,this.c.workspace);if(N)return{key:A,defaultValue:(0,i.deepClone)(N.policy?.value??N.default?.value),globalValue:(0,i.deepClone)(N.user?.value??N.application?.value),workspaceValue:(0,i.deepClone)(N.workspace?.value),workspaceFolderValue:(0,i.deepClone)(N.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(N.default?.override),globalLanguageValue:(0,i.deepClone)(N.user?.override??N.application?.override),workspaceLanguageValue:(0,i.deepClone)(N.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(N.workspaceFolder?.override),languageIds:(0,i.deepClone)(N.overrideIdentifiers)}}};return typeof c=="object"&&(0,i.mixin)(g,c,!1),Object.freeze(g)}g(o){const l=a=>(0,k.isObject)(a)?new Proxy(a,{get:(h,c)=>l(h[c]),set:(h,c,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(h,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(h,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(o)}h(o,l,a){const h=y.OVERRIDE_PROPERTY_REGEX.test(o)?4:this.d.get(o),c=a?`[${a.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,l){const a=new R.ConfigurationChangeEvent(o,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,c)=>a.affectsConfiguration(h,P(c))})}k(o){return o.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[106],Ce([1,0,2,12,4,5,7,31,57,32,21,60,17,27,3,16,20,13,76,199,11]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(F){function $(M){if(M!=null)return M}F.from=$;function T(M){if(M!=null)return M}F.to=T})(t||(t={}));var s;(function(F){function $(M){if(M!=null)return M}F.from=$;function T(M){if(M!=null)return M}F.to=T})(s||(s={}));var o;(function(F){function $(M){if(M!=null)return M}F.from=$;function T(M){if(M!=null)return M}F.to=T})(o||(o={}));var l;(function(F){function $(V){if(V){const j=V;return j&&!!j.process}else return!1}F.is=$;function T(V){if(V==null)return;const j={process:V.process,args:V.args};return V.options&&(j.options=o.from(V.options)),j}F.from=T;function M(V){if(V!=null)return new I.ProcessExecution(V.process,V.args,V.options)}F.to=M})(l||(l={}));var a;(function(F){function $(M){if(M!=null)return M}F.from=$;function T(M){if(M!=null)return M}F.to=T})(a||(a={}));var h;(function(F){function $(V){if(V){const j=V;return j&&(!!j.commandLine||!!j.command)}else return!1}F.is=$;function T(V){if(V==null)return;const j={};return V.commandLine!==void 0?j.commandLine=V.commandLine:(j.command=V.command,j.args=V.args),V.options&&(j.options=a.from(V.options)),j}F.from=T;function M(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new I.ShellExecution(V.commandLine,V.options):new I.ShellExecution(V.command,V.args?V.args:[],V.options)}F.to=M})(h||(h={}));var c;(function(F){function $(V){if(V){const j=V;return j&&j.customExecution==="customExecution"}else return!1}F.is=$;function T(V){return{customExecution:"customExecution"}}F.from=T;function M(V,j){return j.get(V)}F.to=M})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(F){function $(T,M){let V;return T.scope!==void 0&&typeof T.scope!="number"?V=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===I.TaskScope.Workspace&&M&&M.workspaceFile?V=M.workspaceFile:V=E.USER_TASKS_GROUP_KEY),{id:T._id,workspaceFolder:V}}F.from=$})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(F){function $(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}F.from=$})(g||(g={}));var A;(function(F){function $(V,j){if(V==null)return[];const le=[];for(const Y of V){const pe=T(Y,j);pe&&le.push(pe)}return le}F.fromMany=$;function T(V,j){if(V==null)return;let le;V.execution instanceof I.ProcessExecution?le=l.from(V.execution):V.execution instanceof I.ShellExecution?le=h.from(V.execution):V.execution&&V.execution instanceof I.CustomExecution&&(le=c.from(V.execution));const Y=t.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=I.TaskScope.Workspace,!Y||!pe?void 0:{_id:V._id,definition:Y,name:V.name,source:{extensionId:j.identifier.value,label:V.source,scope:pe},execution:le,isBackground:V.isBackground,group:g.from(V.group),presentationOptions:s.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}F.from=T;async function M(V,j,le){if(V==null)return;let Y;l.is(V.execution)?Y=l.to(V.execution):h.is(V.execution)?Y=h.to(V.execution):c.is(V.execution)&&(Y=c.to(V._id,le));const pe=t.to(V.definition);let ue;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?ue=V.source.scope:ue=await j.resolveWorkspaceFolder(i.URI.revive(V.source.scope)):ue=I.TaskScope.Workspace),!pe||!ue)return;const de=new I.Task(pe,ue,V.name,V.source.label,Y,V.problemMatchers);return V.isBackground!==void 0&&(de.isBackground=V.isBackground),V.group!==void 0&&(de.group=I.TaskGroup.from(V.group._id),de.group&&V.group.isDefault&&(de.group=new I.TaskGroup(de.group.id,de.group.label),V.group.isDefault===!0&&(de.group.isDefault=V.group.isDefault))),V.presentationOptions&&(de.presentationOptions=s.to(V.presentationOptions)),V._id&&(de._id=V._id),V.detail&&(de.detail=V.detail),de}F.to=M})(A=e.TaskDTO||(e.TaskDTO={}));var N;(function(F){function $(M){return M}F.from=$;function T(M){if(!!M)return Object.assign(Object.create(null),M)}F.to=T})(N||(N={}));class q{constructor($,T,M){this._id=T,this.a=M,v.set(this,void 0),Je(this,v,$,"f")}get task(){return this.a}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}v=new WeakMap;let te=class{constructor($,T,M,V,j,le,Y,pe){this.q=new S.Emitter,this.r=new S.Emitter,this.s=new S.Emitter,this.t=new S.Emitter,this.a=$.getProxy(L.MainContext.MainThreadTask),this.b=M,this.c=V,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Y,this.g=pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,T,M){if(!M)return new I.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:T,provider:M,extension:$}),this.a.$registerTaskProvider(V,T),new I.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem($,T){this.a.$registerTaskSystem($,T)}fetchTasks($){return this.a.$fetchTasks(N.from($)).then(async T=>{const M=[];for(const V of T){const j=await A.to(V,this.b,this.m);j&&M.push(j)}return M})}get taskExecutions(){const $=[];return this.k.forEach(T=>$.push(T)),$}terminateTask($){if(!($ instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,T,M){const V=this.m.get($.id);V&&(this.o.set($.id,V),this.e.attachPtyToTerminal(T,await V.callback(M))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const T=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const T=await this.y($.id);this.s.fire({execution:T,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const T=await this.y($.id);this.t.fire({execution:T,exitCode:$.exitCode})}$provideTasks($,T){const M=this.j.get($);if(!M)return Promise.reject(new Error("no handler found"));const V=[],j=(0,C.asPromise)(()=>M.provider.provideTasks(O.CancellationToken.None)).then(le=>this.u(T,V,M,le));return new Promise(le=>{j.then(Y=>{Promise.all(V).then(()=>{le(Y)})})})}async $resolveTask($,T){const M=this.j.get($);if(!M)return Promise.reject(new Error("no handler found"));if(T.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${M.type}].`);const V=await A.to(T,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const j=await M.provider.resolveTask(V,O.CancellationToken.None);if(!j)return;this.z(j,M);const le=A.from(j,M.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x($,T,M){const V=await this.a.$createTaskId($);!M&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,T.execution)),this.m.set(V,T.execution)}async y($,T){if(typeof $=="string"){const j=this.l.get($);if(!j)throw new P.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const M=this.l.get($.id);if(M)return M;const V=new Promise((j,le)=>{function Y(pe,ue,de){de?j(new q(pe,ue.id,de)):le("Unexpected: Task does not exist.")}T?Y(this,$,T):A.to($.task,this.b,this.m).then(pe=>Y(this,$,pe))});return this.l.set($.id,V),V.then(j=>(this.k.set($.id,j),j),j=>Promise.reject(j))}z($,T){$._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const M=this.n.values();let V=M.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=M.next()}};te=qe([Ve(0,m.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,d.ILogService),Ve(7,b.IExtHostApiDeprecationService)],te),e.ExtHostTaskBase=te;let x=class extends te{constructor($,T,M,V,j,le,Y,pe){super($,T,M,V,j,le,Y,pe),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:r.PlatformToString(0)})}async executeTask($,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const M=A.from(T,$);if(M===void 0)throw new Error("Task is not valid");if(c.is(M.execution))await this.x(M,T,!1);else throw new P.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(M),T);return this.a.$executeTask(M).catch(j=>{throw new Error(j)}),V}u($,T,M,V){const j=[];if(V)for(const le of V){this.z(le,M),(!le.definition||!$[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=A.from(le,M.extension);Y&&c.is(Y.execution)?(j.push(Y),T.push(this.x(Y,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:M.extension}}async v($){if(c.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,T,M){}};x=qe([Ve(0,m.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,d.ILogService),Ve(7,b.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[242],Ce([1,0,19,21,39,35,23,77,45]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,p,f){this.k=m,this.l=p,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const p=this.k.folderQueries||[];return new Promise((f,n)=>{const r=d=>{this.f++,m(d)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const b=d.toString(),E=i.basename(b);this.j&&this.j(b,E)||this.v(r,{base:d,basename:E})}),Promise.all(p.map(d=>this.p(d,r))).then(d=>{f({limitHit:this.e,stats:d[0]||void 0})},d=>{n(new Error((0,S.toErrorMessage)(d)))})})}async p(m,p){const f=new C.CancellationTokenSource,n=this.q(m),r=this.r(),d=new y.QueryGlobTester(this.k,m),b=!d.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=R.StopWatch.create();const P=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,f.token),v=E.elapsed(),t=R.StopWatch.create();return this.g&&!this.e||(P&&P.forEach(s=>{const o=i.posix.relative(m.folder.path,s.path);if(b){const l=i.basename(s.path);this.v(p,{base:m.folder,relativePath:o,basename:l});return}this.s(r,m.folder,o,p)}),this.g&&!this.e)?null:(this.u(r,d,p),{providerTime:v,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const p=(0,y.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,y.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:p,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},p,f,n){if(f===this.a){const d=i.basename(this.a);this.v(n,{base:p,relativePath:this.a,basename:d})}function r(d){const b=i.basename(d),E=i.dirname(d);let P=m[E];P||(P=m[E]=[],r(E)),P.push({base:p,relativePath:d,basename:b})}r(f)}u({rootEntries:m,pathToEntries:p},f,n){const r=this,d=this.a;function b(E){const P=(0,y.hasSiblingFn)(()=>E.map(v=>v.basename));for(let v=0,t=E.length;v<t;v++){const s=E[v],{relativePath:o,basename:l}=s;if(f.matchesExcludesSync(o,l,d!==l?P:void 0))continue;const a=p[o];if(a)b(a);else{if(o===d)continue;r.v(n,s)}if(r.e)break}}b(m)}v(m,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(p))}}class O{constructor(){this.b=new Map}fileSearch(m,p,f,n){const r=this.c(m.cacheKey),d=new k(m,p,r&&r.token);let b=0;const E=P=>{b+=P.length,f(P.map(v=>this.d(v)))};return this.e(d,O.a,E,n).then(P=>({limitHit:P.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:P.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new C.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:I.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,p,f,n){n.onCancellationRequested(()=>{m.cancel()});const r=b=>{b&&(d.push(b),p>0&&d.length>=p&&(f(d),d=[]))};let d=[];return m.search(r).then(b=>(d.length&&f(d),b),b=>(d.length&&f(d),Promise.reject(b)))}}e.FileSearchManager=O,O.a=512}),define(Ie[243],Ce([1,0,18,62,35,86,28,16,19,23,10,9,2,259,152,41,13,52,96,241,45]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(g,A,N,q,te){this.a=g,this.b=A,this.c=N,this.d=q,this.e=te}text(g,A,N={}){g=this.f(g,N);const q=this.a.getValue(),te=A&&A.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(A?.map(d.toWorkspaceFolder),N),type:2,contentPattern:g,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:q.search.usePCRE2||te||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(g,A){const N=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const q={...g,wordSeparators:N.editor.wordSeparators};return this.j(g,A)&&(q.isCaseSensitive=!0),this.k(g)&&(q.isMultiline=!0),q}file(g,A={}){return{...this.h(g,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(g,A){return g?(g=Array.isArray(g)?g.map(a):a(g),A?this.parseSearchPaths(g):{pattern:s(...Array.isArray(g)?g:[g])}):{}}h(g=[],A={}){const N=this.g(A.includePattern,A.expandPatterns),q=this.g(A.excludePattern,A.expandPatterns),te=g.length>1,x=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(T=>this.q(T,A,q)):g.map(T=>this.r(T,A,q,te))).filter(T=>!!T),F={_reason:A._reason,folderQueries:x,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:q.pattern,includePattern:N.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const T=i.coalesce(i.flatten(this.c.groups.map(j=>j.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const M=T.filter(j=>(0,P.pathIncludedInQuery)(F,j.fsPath)),V=this.i(M);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...F,...V}}const $=A.extraFileResources&&A.extraFileResources.filter(T=>(0,P.pathIncludedInQuery)(F,T.fsPath));return F.extraFileResources=$&&$.length?$:void 0,F}i(g){const A=[],N=new I.ResourceMap,q={};let te=!1;return g.forEach(x=>{if(x.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const $=this.b.getWorkspaceFolder(x)?.uri??x.with({path:y.dirname(x.fsPath)});let T=N.get($);T||(te=!0,T={folder:$,includePattern:{}},A.push(T),N.set($,T));const M=y.relative($.fsPath,x.fsPath);(0,w.assertIsDefined)(T.includePattern)[M.replace(/\\/g,"/")]=!0}else x.fsPath&&(te=!0,q[x.fsPath]=!0)}),{folderQueries:A,includePattern:q,usingSearchPaths:!0,excludePattern:te?void 0:{"**/*":!0}}}j(g,A){if(A.isSmartCase){if(g.isRegExp){if(O.containsUppercaseCharacter(g.pattern,!0))return!0}else if(O.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,p.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const A=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),q=(Array.isArray(g)?g:o(g)).map(V=>{const j=this.e.resolvedUserHome;return j?(0,L.untildify)(V,j.scheme===R.Schemas.file?j.fsPath:j.path):V}),te=C.groupBy(q,V=>A(V)?"searchPaths":"exprSegments"),x=(te.exprSegments||[]).map(V=>O.rtrim(V,"/")).map(V=>O.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),l(V))),F={},$=this.m(te.searchPaths||[]);$&&$.length&&(F.searchPaths=$);const T=i.flatten(x),M=s(...T);return M&&(F.pattern=M),F}l(g,A){return A.disregardExcludeSettings?void 0:(0,P.getExcludes)(g,!A.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const A=g.flatMap(q=>{let{pathPortion:te,globPortion:x}=t(q);return x&&(x=h(x)),this.n(te).flatMap($=>this.o($,x))}),N=new Map;return A.forEach(q=>{const te=q.searchPath.toString(),x=N.get(te);x?q.pattern&&(x.pattern=x.pattern||{},x.pattern[q.pattern]=!0):N.set(te,{searchPath:q.searchPath,pattern:q.pattern?s(q.pattern):void 0})}),Array.from(N.values())}n(g){if(y.isAbsolute(g)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:g})}]:[{searchPath:m.URI.file(y.normalize(g))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(g=a(g),g.startsWith("../")||g===".."){const q=y.posix.resolve(A.path,g);return[{searchPath:A.with({path:q})}]}const N=h(g);return[{searchPath:A,pattern:N}]}else{if(g==="./"||g===".\\")return[];{const A=g.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(te=>{const x=A.match(new RegExp(`^${O.escapeRegExpCharacters(te.name)}(?:/(.*)|$)`));return x?{match:x,folder:te}:null}).filter(w.isDefined);if(q.length)return q.map(te=>{const x=te.match[1];return{searchPath:te.folder.uri,pattern:x&&h(x)}});{const te=g.match(/\.[\/\\](.+)[\/\\]?/),x=te?te[1]:g,F=f.localize(0,null,x);throw new Error(F)}}}}o(g,A){const N=g.pattern&&A?`${g.pattern}/${A}`:g.pattern||A,q=[{searchPath:g.searchPath,pattern:N}];return N&&!N.endsWith("**")&&q.push({searchPath:g.searchPath,pattern:N+"/**"}),q}q(g,A,N){const q=this.r((0,d.toWorkspaceFolder)(g.searchPath),A,N,!1);return q?{...q,includePattern:g.pattern}:null}r(g,A,N,q){let te;const x=m.URI.isUri(g)?g:g.uri;if(N.searchPaths){const V=N.searchPaths.filter(j=>(0,k.isEqual)(j.searchPath,x))[0];if(V&&!V.pattern)return null;V&&(te=V.pattern)}const F=this.a.getValue({resource:x}),T={...this.l(F,A)||{},...te||{}},M=m.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:x,folderName:q?M:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!F.search.followSymlinks}}};v=qe([Ve(0,n.IConfigurationService),Ve(1,d.IWorkspaceContextService),Ve(2,b.IEditorGroupsService),Ve(3,r.ILogService),Ve(4,E.IPathService)],v),e.QueryBuilder=v;function t(u){const g=u.match(/[\*\{\}\(\)\[\]\?]/);if(g){const A=g.index,N=u.substr(0,A).match(/[/|\\][^/\\]*$/);if(N){let q=u.substr(0,N.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:u.substr((N.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((g,A)=>(g[A]=!0,g),Object.create(null)):void 0}function o(u){return S.splitGlobAware(u,",").map(g=>g.trim()).filter(g=>!!g.length)}function l(u){return[`**/${u}/**`,`**/${u}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function a(u){return u.replace(/\\/g,"/")}function h(u){return a(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(u,g){u=i.distinct(u,q=>q.toString());const A=[],N=g.getWorkspace();return u&&u.forEach(q=>{let te;if(g.getWorkbenchState()===2)te=(0,k.relativePath)(N.folders[0].uri,q),te&&te!=="."&&(te="./"+te);else{const x=g.getWorkspaceFolder(q);if(x){const F=x.name;if(N.folders.filter(T=>T.name===F).length===1){const T=(0,k.relativePath)(x.uri,q);T===""?te=`./${x.name}`:te=`./${x.name}/${T}`}else te=q.fsPath}}te&&A.push(te)}),A}e.resolveResourcesForSearchIncludes=c}),define(Ie[244],Ce([1,0,23,2,21,11,3,243,45,52]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(n,r){const d=r.activationEvents;if(!d)return Promise.resolve(void 0);const b=[],E=[];for(const l of d)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||n.forceUsingSearch?E.push(a):b.push(a)}if(b.length===0&&E.length===0)return Promise.resolve(void 0);let P;const v=new Promise((l,a)=>{P=l}),t=l=>P({activationEvent:l}),s=Promise.all(b.map(l=>m(n,l,t))).then(()=>{}),o=p(n,r.identifier,E,t);return Promise.all([s,o]).then(()=>{P(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function m(n,r,d){for(const b of n.folders)if(await n.exists(i.joinPath(C.URI.revive(b),r))){d(`workspaceContains:${r}`);return}}async function p(n,r,d,b){if(d.length===0)return Promise.resolve(void 0);const E=new S.CancellationTokenSource,P=n.checkExists(n.folders,d,E.token),v=setTimeout(async()=>{E.cancel(),n.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},O);let t=!1;try{t=await P}catch(s){L.isCancellationError(s)||L.onUnexpectedError(s)}E.dispose(),clearTimeout(v),t&&b(`workspaceContains:${d.join(",")}`)}function f(n,r,d,b){const E=n.get(I.IInstantiationService),P=n.get(y.ISearchService),t=E.createInstance(R.QueryBuilder).file(r.map(s=>(0,k.toWorkspaceFolder)(C.URI.revive(s))),{_reason:"checkExists",includePattern:d,exists:!0});return P.fileSearch(t,b).then(s=>!!s.limitHit,s=>L.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[33],Ce([1,0,138,19,82,23,12,6,46,2,13,5,32,188,80,31,24,97,11,26,25,172,7,93,3,27,81,17,67,69,60,4,244,79,174,16,78,77]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v,t,s,o,l,a,h,c,u,g,A,N,q,te,x,F,$){"use strict";var T,M,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let j=class Bi extends R.Disposable{constructor(re,G,H,oe,ve,Ae,Be,xe,Te,Se,ke){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=G,this.g=H,this.f=Be,this.j=oe,this.k=ve,this.l=Ae,this.m=Te,this.p=Se,this.s=ke,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new d.ExtensionDescriptionRegistry(this.f.allExtensions);const se=(0,r.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new d.ExtensionDescriptionRegistry(pe(this.F,se)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=xe,this.h=re.createChild(new c.ServiceCollection([f.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H])),this.J=this.B(new p.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,J,D)=>{this.v.$onExtensionActivationError(ce,b.transformErrorForSerialization(J),D)},actualActivateExtension:async(ce,J)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,J),new p.HostExtension;const D=this.D.getExtensionDescription(ce);return this.Y(D,J)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),S.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){b.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(re)}terminate(re,G=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(oe=>{this.l.error(oe)}),this.g.dispose();const H=this.Q();Promise.race([(0,I.timeout)(5e3),H]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.l.info(`Extension host exiting with code ${G}`),this.l.flush(),this.l.dispose(),this.c.exit(G)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const G=await this.v.$getExtension(re);let H;if(G?.browserNlsBundleUris){H={};for(const oe of Object.keys(G.browserNlsBundleUris))H[oe]=k.URI.revive(G.browserNlsBundleUris[oe])}return G&&{...G,identifier:new E.ExtensionIdentifier(G.identifier.value),extensionLocation:k.URI.revive(G.extensionLocation),browserNlsBundleUris:H}}R(re,G){return this.J.activateByEvent(re,G)}S(re,G){return this.J.activateById(re,G)}activateByIdWithErrors(re,G){return this.S(re,G).then(()=>{const H=this.J.getActivatedExtension(re);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==x.Schemas.file)return re;const G=await this.c.realpath(re.fsPath);return k.URI.file(G)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new ue(re))),this.L}async W(re){const G=y.TernarySearchTree.forUris(H=>L.extUriBiasedIgnorePathCase.ignorePathCasing(H));return await Promise.all(re.map(async H=>{if(this.ob(H)){const oe=await this.U(H.extensionLocation);G.set(oe,H)}})),G}X(re){let G=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return G;const H=this.J.getActivatedExtension(re);if(!H)return G;try{typeof H.module.deactivate=="function"&&(G=Promise.resolve(H.module.deactivate()).then(void 0,oe=>(this.l.error(oe),Promise.resolve(void 0))))}catch(oe){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(oe)}try{(0,R.dispose)(H.subscriptions)}catch(oe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(oe)}return G}async Y(re,G){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,G).then(H=>{const oe=H.activationTimes;return this.v.$onDidActivateExtension(re.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,G),this.Z(re,G,"success",oe),H},H=>{throw this.Z(re,G,"failure"),H})}Z(re,G,H,oe){const ve=le(re,G);this.u.$publicLog2("extensionActivationTimes",{...ve,...oe||{},outcome:H})}ab(re,G){const H=le(re,G);this.u.$publicLog2("activatePlugin",H);const oe=this.ob(re);if(!oe)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${re.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.l.flush();const ve=new p.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this.pb(re,(0,L.joinPath)(re.extensionLocation,oe),ve),this.bb(re)]).then(Ae=>(S.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Bi.cb(this.l,re.identifier,Ae[0],Ae[1],ve))).then(Ae=>(S.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ae))}bb(re){const G=new v.ExtensionGlobalMemento(re,this.G),H=new v.ExtensionMemento(re.identifier.value,!1,this.G),oe=new te.ExtensionSecrets(re,this.H),ve=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ae=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([G.whenReady,H.whenReady,this.I.whenReady]).then(()=>{const Be=this;let xe,Te;const Se=(0,r.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:H,secrets:oe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(ke){return C.join(re.extensionLocation.fsPath,ke)},get storagePath(){return Be.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return Be.I.globalValue(re).fsPath},get logPath(){return C.join(Be.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return k.URI.joinPath(Be.f.logsLocation,re.identifier.value)},get storageUri(){return Be.I.workspaceValue(re)},get globalStorageUri(){return Be.I.globalValue(re)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new Y(Be,re.identifier,re,Ae,!1)),xe},get extensionRuntime(){return(0,r.checkProposedApiEnabled)(re,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Te){if(!Se)return;const ke=A.Event.buffer(A.Event.fromDOMEventEmitter(Se,"message",se=>se.data));Se.start(),Te={onDidReceiveMessage:ke,postMessage:Se.postMessage.bind(Se)}}return Te}})})}static cb(re,G,H,oe,ve){return H=H||{activate:void 0,deactivate:void 0},this.db(re,G,H,oe,ve).then(Ae=>new p.ActivatedExtension(!1,null,ve.build(),H,Ae,oe.subscriptions))}static db(re,G,H,oe,ve){if(typeof H.activate=="function")try{ve.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Ae=typeof global=="object"?global:self,Be=H.activate.apply(Ae,[oe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Be).then(xe=>(ve.activateResolveStop(),xe))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(H)}eb(re,G){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:G}).then(void 0,H=>{this.l.error(H)})}fb(){this.v.$setPerformanceMarks(S.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const G of re.activationEvents)G==="onStartupFinished"&&this.eb(re,G)}gb(){const re=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const G=this.j.workspace?this.j.workspace.folders:[],H=this.hb(G),oe=Promise.all([re,H]).then(()=>{});return Promise.race([oe,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),oe}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(G=>this.ib(re,G))).then(()=>{})}async ib(re,G){if(this.isActivated(G.identifier))return;const H=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.l,folders:re.map(Ae=>Ae.uri),forceUsingSearch:H,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Be,xe)=>this.t.$checkExists(Ae,Be,xe)},ve=await(0,N.checkActivateWorkspaceContainsExtension)(oe,G);if(!!ve)return this.S(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:G}=this.f.environment;if(!re||!G)throw new Error(i.localize(0,null));const H=await this.pb(null,G,new p.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(i.localize(1,null,G.toString()));return new Promise((oe,ve)=>{const Ae=(Te,Se)=>{Te?ve(Te):oe(typeof Se=="number"&&Se>0?1:0)},Be=(0,L.originalFSPath)(G),xe=H.run(Be,Ae);xe&&xe.then&&xe.then(()=>{oe(0)}).catch(Te=>{ve(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,G){return this.M[re]=G,(0,R.toDisposable)(()=>{delete this.M[re]})}async lb(re){const G=re.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const H=re.substr(0,G);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this.M[H]}}async $resolveAuthority(re,G){const H=$.StopWatch.create(!1),oe=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(re)},${G})][${H.elapsed()}ms] `,ve=Se=>this.l.info(`${oe()}${Se}`),Ae=(Se,ke=void 0)=>this.l.error(`${oe()}${Se}`,ke);ve("activating resolver...");const{authorityPrefix:Be,resolver:xe}=await this.lb(re);if(!xe)return Ae("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Be}.`,detail:void 0}};const Te=new I.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(xe)),Te.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),S.mark(`code/extHost/willResolveAuthority/${Be}`);const Se=await xe.resolve(re,{resolveAttempt:G});S.mark(`code/extHost/didResolveAuthorityOK/${Be}`),Te.dispose(),ve(`returned ${Se.host}:${Se.port}`);const ke={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},se={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:se,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(S.mark(`code/extHost/didResolveAuthorityError/${Be}`),Te.dispose(),Ae("returned an error",Se),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,G){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(re)})`);const{resolver:H}=await this.lb(re);if(!H)return null;const oe=k.URI.revive(G);if(typeof H.getCanonicalURI>"u")return oe;const ve=await(0,I.asPromise)(()=>H.getCanonicalURI(oe));return ve||oe}static mb(re,G,H){const oe=new d.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());oe.deltaExtensions(H.toAdd,H.toRemove);const ve=(0,r.extensionIdentifiersArrayToSet)(G.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of H.myToRemove)ve.delete(E.ExtensionIdentifier.toKey(Be));for(const Be of H.myToAdd)ve.add(E.ExtensionIdentifier.toKey(Be));const Ae=pe(oe,ve);return{globalRegistry:oe,myExtensions:Ae}}$startExtensionHost(re){re.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:G,myExtensions:H}=Bi.mb(this.F,this.D,re);return this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),this.kb()}$activateByEvent(re,G){return G===1?this.R(re,!1):this.z.wait().then(H=>this.R(re,!1))}async $activate(re,G){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,G),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ae=>Ae.extensionLocation=k.URI.revive(Ae.extensionLocation));const{globalRegistry:G,myExtensions:H}=Bi.mb(this.F,this.D,re),oe=await this.W(H);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const G=P.VSBuffer.alloc(re),H=Math.random()%256;for(let oe=0;oe<re;oe++)G.writeUInt8(H,oe);return G}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};j=qe([Ve(0,o.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,h.IExtHostRpcService),Ve(3,n.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,l.IExtHostInitDataService),Ve(7,a.IExtensionStoragePaths),Ve(8,u.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,F.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(de,re){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class Y{constructor(re,G,H,oe,ve){T.set(this,void 0),M.set(this,void 0),V.set(this,void 0),Je(this,T,re,"f"),Je(this,M,G,"f"),Je(this,V,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=C.normalize((0,L.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=oe,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,T,"f").isActivated(Oe(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,T,"f").getExtensionExports(Oe(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,T,"f").activateByIdWithErrors(Oe(this,V,"f"),{startup:!1,extensionId:Oe(this,M,"f"),activationEvent:"api"}),this.exports}}e.Extension=Y,T=new WeakMap,M=new WeakMap,V=new WeakMap;function pe(de,re){return de.getAllExtensionDescriptions().filter(G=>re.has(E.ExtensionIdentifier.toKey(G.identifier)))}class ue{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=ue}),define(Ie[245],Ce([1,0,82,2,5,32,24,26,17,27,3,33,49,13,10]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(v,t,s,o,l,a,h){this.c=v,this.d=t,this.e=s,this.f=o,this.g=l,this.h=a,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,v,this.i)),this.register(this.e.createInstance(b,t)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,t,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this.a.set(t,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(t=>v.alternativeModuleName(t))}};n=qe([Ve(2,O.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,p.ILogService)],n),e.RequireInterceptor=n;let r=class tn{constructor(v){if(v.environment.appRoot&&tn.a.size){const t=(0,f.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),s="[a-z0-9_.-]",o=`@${s}+\\/${s}+|${s}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${l}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const t=this.b.exec(this.c(v));if(!t)return;const[,s,o,l]=t,a=tn.a.get(o);if(a!==void 0)return console.warn(`${o} as been renamed to ${a}, please update your imports`),s+a+l}c(v){return v.replace(/\\/g,"/")}};r.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),r=qe([Ve(0,k.IExtHostInitDataService)],r);class d{constructor(v,t,s,o,l){this.c=v,this.d=t,this.e=s,this.f=o,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(v,t){const s=this.d.findSubstr(t);if(s){let o=this.a.get(R.ExtensionIdentifier.toKey(s.identifier));return o||(o=this.c(s,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(s.identifier),o)),o}if(!this.b){let o="";this.d.forEach((l,a)=>o+=`	${a} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${o}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(v,t,s){this.d=v,this.nodeModuleName="keytar",this.a=t.getProxy(S.MainContext.MainThreadTelemetry);const{environment:o}=s,l=t.getProxy(S.MainContext.MainThreadKeytar);if(o.appRoot){let a=o.appRoot.fsPath;m.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.b=new Set,this.b.add(`${a}/node_modules.asar/keytar`),this.b.add(`${a}/node_modules/keytar`)}this.c={getPassword:(a,h)=>l.$getPassword(a,h),setPassword:(a,h,c)=>l.$setPassword(a,h,c),deletePassword:(a,h)=>l.$deletePassword(a,h),findPassword:a=>l.$findPassword(a),findCredentials(a){return l.$findCredentials(a)}}}load(v,t){const s=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const t=v.length;if(t<=7||!this.b)return;const s=t-7;if((v.charAt(s)==="/"||v.charAt(s)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};b=qe([Ve(1,y.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],b);let E=class{constructor(v,t,s){this.e=v,this.f=t,this.nodeModuleName=["open","opn"],this.d=s.getProxy(S.MainContext.MainThreadTelemetry);const o=s.getProxy(S.MainContext.MainThreadWindow);this.c=(l,a)=>{const h=C.URI.parse(l);return a?this.g(l,a):h.scheme==="http"||h.scheme==="https"?o.$openUri(h,l,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?o.$openUri(h,l,{}):this.g(l,a)}}load(v,t,s){const o=this.e.findSubstr(t);return o&&(this.a=o.identifier.value,this.h()),this.b=s(v),this.c}g(v,t){return this.i(),this.b(v,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,y.IExtHostRpcService)],E)}),define(Ie[107],Ce([1,0,211,6,19,49,3,57,58,33,7,31,185,32]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(d,b,E,P,v,t,s){function o(){if(E){const l=E.activeEditor();if(l)return l.document.uri;const a=P.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof O.TextDiffTabInput||a.input instanceof O.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof O.TextTabInput||a.input instanceof O.NotebookEditorTabInput||a.input instanceof O.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:l=>{const a=t.folders.filter(h=>h.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,a)=>v.getConfiguration(void 0,l).get(a),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=o();if(l)return S.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const l=o();if(l){const a=b.getWorkspaceFolder(l);if(a)return S.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(E){const l=E.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(E){const l=E.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>d.getExtension(l)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let n=class extends C.Disposable{constructor(d,b,E,P,v){super(),this.b=d,this.c=b,this.g=E,this.h=P,this.i=v,this.a=new i.Lazy(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,t,o,this.j())})}getResolver(){return this.a.getValue()}j(){}};n=qe([Ve(0,k.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,p.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs)],n),e.ExtHostVariableResolverProviderService=n}),define(Ie[108],Ce([1,0,12,4,9,2,3,5,58,33,17,7,31,177,179,32,107]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,l,a,h,c,u){this.D=l,this.E=a,this.F=h,this.G=c,this.H=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new C.Emitter,this.n=new C.Emitter,this.o=new C.Emitter,this.u=new C.Emitter,this.k=o.getProxy(R.MainContext.MainThreadDebugService),this.z=new C.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(A=>{this.I(g)}),this.I(g)})}asDebugSourceUri(o,l){const a=o;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let h=`debug:${encodeURIComponent(a.path||"")}`,c="?";return l&&(h+=`${c}session=${encodeURIComponent(l.id)}`,c="&"),h+=`${c}ref=${a.sourceReference}`,L.URI.parse(h)}else{if(a.path)return L.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(o){const l=[];for(const a of o.getAllExtensionDescriptions())if(a.contributes){const h=a.contributes.debuggers;if(h&&h.length>0)for(const c of h)(0,f.isDebuggerMainContribution)(c)&&l.push(c.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const o=[];return this.w.forEach(l=>o.push(l)),o}addBreakpoints(o){this.T();const l=o.filter(c=>{const u=c.id;return this.w.has(u)?!1:(this.w.set(u,c),!0)});this.U(l,[],[]);const a=[],h=new Map;for(const c of l)if(c instanceof w.SourceBreakpoint){let u=h.get(c.location.uri.toString());u||(u={type:"sourceMulti",uri:c.location.uri,lines:[]},h.set(c.location.uri.toString(),u),a.push(u)),u.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof w.FunctionBreakpoint&&a.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(a)}removeBreakpoints(o){this.T();const l=o.filter(u=>this.w.delete(u.id));this.U([],l,[]);const a=l.filter(u=>u instanceof w.SourceBreakpoint).map(u=>u.id),h=l.filter(u=>u instanceof w.FunctionBreakpoint).map(u=>u.id),c=l.filter(u=>u instanceof w.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(a,h,c)}startDebugging(o,l,a){return this.k.$startDebugging(o?o.uri:void 0,l,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,l,a){if(!l)return new w.Disposable(()=>{});const h=this.d++;return this.f.push({type:o,handle:h,provider:l}),this.k.$registerDebugConfigurationProvider(o,a,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,h),new w.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==l),this.k.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(o,l,a){if(!a)return new w.Disposable(()=>{});if(!this.P(o,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this.g++;return this.h.push({type:l,handle:h,factory:a}),this.k.$registerDebugAdapterDescriptorFactory(l,h),new w.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==a),this.k.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(o,l){if(!l)return new w.Disposable(()=>{});const a=this.i++;return this.j.push({type:o,handle:a,factory:l}),new w.Disposable(()=>{this.j=this.j.filter(h=>h.factory!==l)})}async $runInTerminal(o,l){return Promise.resolve(void 0)}async $substituteVariables(o,l){let a;const h=await this.W(o);return h&&(a={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(a,l)}J(o,l){if(o.type==="implementation")return new v(o.implementation)}K(){}async $startDASession(o,l){const a=this,h=await this.V(l);return this.R(this.M(h.type),h).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const u=this.L(c),g=this.J(u,h);if(!g)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const A=g;return this.A.set(o,A),this.Q(h).then(N=>(N&&this.B.set(o,N),A.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const te=q,x={type:"response",seq:0,command:te.command,request_seq:te.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(te.arguments.value);x.body={signature:F},A.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,A.sendResponse(x)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(q),q=(0,f.convertToVSCPaths)(q,!0),a.k.$acceptDAMessage(o,q)}),A.onError(q=>{N&&N.onError&&N.onError(q),this.k.$acceptDAError(o,q.name,q.message,q.stack)}),A.onExit(q=>{N&&N.onExit&&N.onExit((0,S.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(o,(0,S.withNullAsUndefined)(q),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),A.startSession()))})}$sendDAMessage(o,l){l=(0,f.convertToDAPaths)(l,!1);const a=this.B.get(o);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(l),this.A.get(o)?.sendMessage(l)}$stopDASession(o){const l=this.B.get(o);this.B.delete(o),l&&l.onWillStopSession&&l.onWillStopSession();const a=this.A.get(o);return this.A.delete(o),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const l=[],a=[],h=[];if(o.added)for(const c of o.added){const u=c.id;if(u&&!this.w.has(u)){let g;if(c.type==="function")g=new w.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")g=new w.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const A=L.URI.revive(c.uri);g=new w.SourceBreakpoint(new w.Location(A,new w.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,w.setBreakpointId)(g,u),this.w.set(u,g),l.push(g)}}if(o.removed)for(const c of o.removed){const u=this.w.get(c);u&&(this.w.delete(c),a.push(u))}if(o.changed){for(const c of o.changed)if(c.id){const u=this.w.get(c.id);if(u){if(u instanceof w.FunctionBreakpoint&&c.type==="function"){const g=u;g.enabled=c.enabled,g.condition=c.condition,g.hitCondition=c.hitCondition,g.logMessage=c.logMessage,g.functionName=c.functionName}else if(u instanceof w.SourceBreakpoint&&c.type==="source"){const g=u;g.enabled=c.enabled,g.condition=c.condition,g.hitCondition=c.hitCondition,g.logMessage=c.logMessage,g.location=new w.Location(L.URI.revive(c.uri),new w.Position(c.line,c.character))}h.push(u)}}}this.U(l,a,h)}$provideDebugConfigurations(o,l,a){return(0,i.asPromise)(async()=>{const h=this.O(o);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.W(l);return h.provideDebugConfigurations(c,a)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(o,l,a,h){return(0,i.asPromise)(async()=>{const c=this.O(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.W(l);return c.resolveDebugConfiguration(u,a,h)})}$resolveDebugConfigurationWithSubstitutedVariables(o,l,a,h){return(0,i.asPromise)(async()=>{const c=this.O(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.W(l);return c.resolveDebugConfigurationWithSubstitutedVariables(u,a,h)})}async $provideDebugAdapter(o,l){const a=this.N(o);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.V(l);return this.R(a,h).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.L(c)})}async $acceptDebugSessionStarted(o){const l=await this.V(o);this.m.fire(l)}async $acceptDebugSessionTerminated(o){const l=await this.V(o);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,l){(await this.V(o))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(o,l){const h={session:await this.V(o),event:l.event,body:l.body};this.u.fire(h)}L(o){if(o instanceof w.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof w.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}M(o){const l=this.h.filter(a=>a.type===o);if(l.length>0)return l[0].factory}N(o){const l=this.h.filter(a=>a.handle===o);if(l.length>0)return l[0].factory}O(o){const l=this.f.filter(a=>a.handle===o);if(l.length>0)return l[0].provider}P(o,l){if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0){for(const h of a)if(h.label&&h.type&&h.type===l)return!0}}return!1}Q(o){const a=o.configuration.type,h=this.j.filter(c=>c.type===a||c.type==="*").map(c=>(0,i.asPromise)(()=>c.factory.createDebugAdapterTracker(o)).then(u=>u,u=>null));return Promise.race([Promise.all(h).then(c=>{const u=c.filter(g=>!!g);if(u.length>0)return new P(u)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async R(o,l){const a=l.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new w.DebugAdapterServer(a));if(o){const c=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>o.createDebugAdapterDescriptor(l,this.S(l,c))).then(u=>{if(u)return u})}const h=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,h))}S(o,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(o,l,a){(o.length>0||l.length>0||a.length>0)&&this.z.fire(Object.freeze({added:o,removed:l,changed:a}))}async V(o){if(o)if(typeof o=="string"){const l=this.l.get(o);if(l)return l}else{let l=this.l.get(o.id);if(!l){const a=await this.W(o.folderUri),h=o.parent?this.l.get(o.parent):void 0;l=new b(this.k,o.id,o.type,o.name,a,o.configuration,h),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(o){if(o){const l=L.URI.revive(o);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};d=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,n.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,r.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class b{constructor(o,l,a,h,c,u,g){this.d=o,this.f=l,this.g=a,this.h=h,this.i=c,this.j=u,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,l){return this.d.$customDebugAdapterRequest(this.f,o,l)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.ExtHostDebugSession=b;class E{constructor(o){this.value=Object.freeze({append(l){o.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=E;class P{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(l=>l.onError?l.onError(o):void 0)}onExit(o,l){this.d.forEach(a=>a.onExit?a.onExit(o,l):void 0)}}class v extends p.AbstractDebugAdapter{constructor(o){super(),this.h=o,o.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(o,l,a,h,c,u){super(o,l,a,h,c,u)}};t=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,n.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,r.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ie[246],Ce([1,0,11,82,2,5,237,13,66,67,27,157,17,54,33,74]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class r{static async installEarlyHandler(E){const P=E.get(R.ILogService),t=E.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(s=>{P.error(s);const o=i.transformErrorForSerialization(s);t.$onUnexpectedError(o)})}static async installFullHandler(E){const P=E.get(R.ILogService),v=E.get(m.IExtHostRpcService),t=E.get(f.IExtHostExtensionService),s=E.get(n.IExtHostTelemetry),o=v.getProxy(L.MainContext.MainThreadExtensionService),l=v.getProxy(L.MainContext.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;Error.prepareStackTrace=(c,u)=>{let g="",A,N;for(const q of u)g+=`
	at ${q.toString()}`,N=q.getFileName(),!A&&N&&(A=a.findSubstr(S.URI.file(N)));return h.set(c,A?.identifier),`${c.name||"Error"}: ${c.message||""}${g}`},i.setUnexpectedErrorHandler(c=>{P.error(c);const u=i.transformErrorForSerialization(c),g=h.get(c);if(!g){l.$onUnexpectedError(u);return}o.$onExtensionRuntimeError(g,u);const A=s.onExtensionError(g,c);P.trace("forwarded error to extension?",A,g)})}}Error.stackTraceLimit=100;class d{constructor(E,P,v,t,s){this.a=v,this.b=new I.RPCProtocol(E,null,t),P=d.e(P,this.b);const o=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());o.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...P,messagePorts:s}),o.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),o.set(p.IURITransformerService,new p.URITransformerService(t)),o.set(f.IHostUtils,v);const l=new w.InstantiationService(o,!0);l.invokeFunction(r.installEarlyHandler),this.d=l.invokeFunction(a=>a.get(R.ILogService)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",P),this.c=l.invokeFunction(a=>a.get(f.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(r.installFullHandler)}async asBrowserUri(E){const P=this.b.getProxy(L.MainContext.MainThreadExtensionService);return S.URI.revive(await P.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,P){E.allExtensions.forEach(t=>{t.extensionLocation=S.URI.revive(P.transformIncomingURIs(t.extensionLocation));const s={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(o=>s[o]=S.URI.revive(P.transformIncomingURIs(t.browserNlsBundleUris[o]))),t.browserNlsBundleUris=s)}),E.environment.appRoot=S.URI.revive(P.transformIncomingURIs(E.environment.appRoot));const v=E.environment.extensionDevelopmentLocationURI;return v&&(E.environment.extensionDevelopmentLocationURI=v.map(t=>S.URI.revive(P.transformIncomingURIs(t)))),E.environment.extensionTestsLocationURI=S.URI.revive(P.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=S.URI.revive(P.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=S.URI.revive(P.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=S.URI.revive(P.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=S.URI.revive(P.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=S.URI.revive(P.transformIncomingURIs(E.logsLocation)),E.logFile=S.URI.revive(P.transformIncomingURIs(E.logFile)),E.workspace=P.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=d}),define(Ie[247],Ce([1,0,18,12,21,39,16,19,23,2,45]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(b,E,P,v){this.d=b,this.e=E,this.f=P,this.g=v,this.a=null,this.b=!1,this.c=0}search(b,E){const P=this.d.folderQueries||[],v=new S.CancellationTokenSource;return E.onCancellationRequested(()=>v.cancel()),new Promise((t,s)=>{this.a=new p(b);let o=!1;const l=(a,h)=>{if(!o&&!this.b){const c=this.h(a);n(a)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,o=!0,v.cancel(),a=this.j(a,this.d.maxResults-this.c));const u=this.h(a);this.c+=u,(u>0||!n(a))&&this.a.add(a,h)}};Promise.all(P.map((a,h)=>this.k(a,c=>l(c,h),v.token))).then(a=>{v.dispose(),this.a.flush();const h=a.some(c=>!!c&&!!c.limitHit);t({limitHit:this.b||h,messages:(0,i.flatten)(a.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},a=>{v.dispose();const h=(0,L.toErrorMessage)(a);s(new Error(h))})})}h(b){return n(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,E){const P=Array.isArray(b.ranges)?b.ranges:[b.ranges],v=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:P.slice(0,E),preview:{matches:v.slice(0,E),text:b.preview.text},uri:b.uri}}async k(b,E,P){const v=new O.QueryGlobTester(this.d,b),t=[],s={report:a=>{if(!this.l(a))return;const h=b.folder.scheme===I.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(a.uri))):void 0,c=y.relativePath(b.folder,a.uri);if(c){const u=v.includedInQuery(c,R.basename(c),h);(0,C.isThenable)(u)?t.push(u.then(g=>{g&&E(a)})):u&&E(a)}}},o=this.n(b),l=await this.e.provideTextSearchResults(m(this.d.contentPattern),o,s,P);return t.length&&await Promise.all(t),l}l(b){if(n(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const E=(0,O.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),P=(0,O.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),v={folder:k.URI.from(b.folder),excludes:P,includes:E,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=w;function m(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class p{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new r(512,E=>this.g(E))}add(b,E){this.d&&(this.b!==E||!y.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:b.uri,results:[]}),this.d.results.push(f(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=p;function f(d){return n(d)?{preview:{matches:(0,i.mapArrayOrNot)(d.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:d.preview.text},ranges:(0,i.mapArrayOrNot)(d.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function n(d){return!!d.preview}e.extensionResultIsMatch=n;class r{constructor(b,E){this.g=b,this.h=E,this.c=0,this.d=[],this.e=0}addItem(b,E){!b||this.j(b,E)}addItems(b,E){!b||this.k(b,E)}j(b,E){this.d.push(b),this.e+=E,this.l()}k(b,E){this.d=this.d.concat(b),this.e+=E,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=r,r.a=4e3,r.b=50}),define(Ie[109],Ce([1,0,6,5,3,242,17,54,13,2,247]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let w=class{constructor(n,r,d){this.k=n,this.l=r,this.n=d,this.c=this.k.getProxy(C.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(n){return this.l.transformOutgoingScheme(n)}registerTextSearchProvider(n,r){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const d=this.d++;return this.e.set(d,r),this.c.$registerTextSearchProvider(d,this.o(n)),(0,i.toDisposable)(()=>{this.g.delete(n),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(n,r){if(this.i.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.i.add(n);const d=this.d++;return this.h.set(d,r),this.c.$registerFileSearchProvider(d,this.o(n)),(0,i.toDisposable)(()=>{this.i.delete(n),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(n,r,d,b){const E=m(d),P=this.h.get(n);if(P)return this.j.fileSearch(E,P,v=>{this.c.$handleFileMatch(n,r,v.map(t=>t.resource))},b);throw new Error("unknown provider: "+n)}$clearCache(n){return this.j.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,r,d,b){const E=this.e.get(n);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const P=m(d);return this.q(P,E).search(t=>this.c.$handleTextMatch(n,r,t),b)}$enableExtensionHostSearch(){}q(n,r){return new O.TextSearchManager(n,r,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};w=qe([Ve(0,I.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,y.ILogService)],w),e.ExtHostSearch=w;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(n=>k.URI.revive(n))}}e.reviveQuery=m;function p(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ie[248],Ce([1,0,66,104,31,102,32,38,57,60,106,108,109,80,69,76,103,59,37,79,74,58,218,13,189,107,78]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v,t,s,o,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,i.registerSingleton)(s.ILoggerService,t.ExtHostLoggerService,1),(0,i.registerSingleton)(s.ILogService,o.ExtHostLogService,1),(0,i.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,i.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,i.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(r.IExtHostWindow,r.ExtHostWindow,0),(0,i.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(P.IExtHostTelemetry,P.ExtHostTelemetry,0),(0,i.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,i.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(Ie[249],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(S){if(S&&this.a.has(S)){const L=this.a.get(S);return this.a.delete(S),L}}addDragOperationTransfer(S,L){this.a.set(S,L)}getRenderedTreeElement(S){if(this.b.has(S))return this.b.get(S)}addRenderedTreeItemElement(S,L){this.b.set(S,L)}removeRenderedTreeItemElement(S){this.b.has(S)&&this.b.delete(S)}}e.TreeviewsService=i}),define(Ie[250],Ce([1,0,142,7,23,2,4,6,176,12,7,9,18,8,21,249,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(P,v){if((0,w.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let t;return Array.isArray(P.highlights)&&(t=P.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:P.label,highlights:t}}}class b{constructor(v,t,s){this.d=v,this.e=t,this.f=s,this.a=new Map,this.b=new n.TreeviewsService;function o(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>o(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(a=>o(a)?this.i(a):a):l})}registerTreeDataProvider(v,t,s){const o=this.createTreeView(v,{treeDataProvider:t},s);return{dispose:()=>o.dispose()}}createTreeView(v,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,c=this.h(v,t,s),u=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:l,hasHandleDrag:a,hasHandleDrop:h});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,r.checkProposedApiEnabled)(s,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(g){c.message=g},get title(){return c.title},set title(g){c.title=g},get description(){return c.description},set description(g){c.description=g},get badge(){return c.badge},set badge(g){g!==void 0&&O.ViewBadge.isViewBadge(g)?c.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(c.badge=void 0)},reveal:(g,A)=>c.reveal(g,A),dispose:async()=>{await u,this.a.delete(v),c.dispose()}}}$getChildren(v,t){const s=this.a.get(v);return s?s.getChildren(t):Promise.reject(new y.NoTreeViewError(v))}async $handleDrop(v,t,s,o,l,a,h,c){const u=this.a.get(v);if(!u)return Promise.reject(new y.NoTreeViewError(v));const g=p.DataTransfer.toDataTransfer(s,async A=>(await this.d.$resolveDropFileData(v,t,A)).buffer);return h===v&&c&&await this.g(g,u,c,l,a),u.onDrop(g,o,l)}async g(v,t,s,o,l){const a=this.b.removeDragOperationTransfer(l);if(a)(await a)?.forEach((h,c)=>{h&&v.set(c,h)});else if(l&&t.handleDrag){const h=t.handleDrag(s,v,o);this.b.addDragOperationTransfer(l,h),await h}return v}async $handleDrag(v,t,s,o){const l=this.a.get(v);if(!l)return Promise.reject(new y.NoTreeViewError(v));const a=await this.g(new C.DataTransfer,l,t,o,s);if(!!a)return p.DataTransfer.toDataTransferDTO(a)}async $hasResolve(v){const t=this.a.get(v);if(!t)throw new y.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,s){const o=this.a.get(v);if(!o)throw new y.NoTreeViewError(v);return o.resolveTreeItem(t,s)}$setExpanded(v,t,s){const o=this.a.get(v);if(!o)throw new y.NoTreeViewError(v);o.setExpanded(t,s)}$setSelection(v,t){const s=this.a.get(v);if(!s)throw new y.NoTreeViewError(v);s.setSelection(t)}$setFocus(v,t){const s=this.a.get(v);if(!s)throw new y.NoTreeViewError(v);s.setFocus(t)}$setVisible(v,t){const s=this.a.get(v);if(!s)throw new y.NoTreeViewError(v);s.setVisible(t)}$changeCheckboxState(v,t){const s=this.a.get(v);if(!s)throw new y.NoTreeViewError(v);s.setCheckboxState(t)}h(v,t,s){const o=new E(v,t,this.d,this.e.converter,this.f,s);return this.a.set(v,o),o}i(v){const t=this.a.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=b;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,t,s,o,l,a){if(super(),this.C=v,this.D=s,this.F=o,this.G=l,this.H=a,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new f.CancellationTokenSource,a.contributes&&a.contributes.views)for(const u in a.contributes.views)for(const g of a.contributes.views[u])g.id===v&&(this.J=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.w.fire({message:!1,element:u})));let h,c;this.B(I.Event.debounce(this.w.event,(u,g)=>(u||(u={message:!1,elements:[]}),g.element!==!1&&(h||(h=new Promise(A=>c=A),this.y=this.y.then(()=>h)),Array.isArray(g.element)?u.elements.push(...g.element):u.elements.push(g.element)),g.message&&(u.message=!0),u),200,!0)(({message:u,elements:g})=>{g.length&&(this.z=this.z.then(()=>{const A=c;return h=null,this.U(g).then(()=>A())})),u&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let s=this.Q(v);return s||(s=await this.R(t)),s?s.map(o=>o.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const s=(0,w.isUndefinedOrNull)(t.select)?!0:t.select,o=(0,w.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,w.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(a=>this.P(v,a[a.length-1]).then(h=>this.D.$reveal(this.C,{item:h.item,parentChain:a.map(c=>c.item)},{select:s,focus:o,expand:l})),a=>this.G.error(a)):this.D.$reveal(this.C,void 0,{select:s,focus:o,expand:l})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=p.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,t){const s=this.getExtensionElement(v);s&&(t?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(v){(0,m.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async s=>{const o=this.getExtensionElement(s.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(v,t,s){const o=[];for(const l of v){const a=this.getExtensionElement(l);a&&o.push(a)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,t,s){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,v,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,t){if(!this.f.resolveTreeItem)return;const s=this.i.get(v);if(s){const o=this.j.get(s);if(o){const l=await this.f.resolveTreeItem(o.extensionItem,s,t)??o.extensionItem;return this.db(l),o.item.tooltip=this.ab(l.tooltip),o.item.command=this.bb(o.disposableStore,l.command),o.item}}}N(v){return this.O(v).then(t=>t?this.N(t).then(s=>this.P(t,s[s.length-1]).then(o=>(s.push(o),s))):Promise.resolve([]))}O(v){const t=this.j.get(v);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(v))}P(v,t){const s=this.j.get(v);return s?Promise.resolve(s):(0,k.asPromise)(()=>this.f.getTreeItem(v)).then(o=>this.gb(v,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(o);if(l){const a=this.j.get(l);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}Q(v){if(v){let t;if(typeof v=="string"){const s=this.getExtensionElement(v);t=s?this.j.get(s):void 0}else t=v;return t&&t.children||void 0}return this.h}async R(v){this.nb(v);const t=new f.CancellationTokenSource(this.S.token);try{const s=v?this.j.get(v):void 0,o=await this.f.getChildren(v);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,m.coalesce)(o||[]).map(async a=>{const h=await this.f.getTreeItem(a);return h&&!t.token.isCancellationRequested?this.Z(a,h,s):null}));return t.token.isCancellationRequested?void 0:(0,m.coalesce)(l)}finally{t.dispose()}}U(v){if(v.some(s=>!s))return this.S.dispose(!0),this.S=new f.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(v);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(v){const t=new Set,s=v.map(l=>this.j.get(l));for(const l of s)if(l&&!t.has(l.item.handle)){let a=l;for(;a&&a.parent&&s.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.i.get(a.parent.item.handle);a=h?this.j.get(h):void 0}a&&!a.parent&&t.add(l.item.handle)}const o=[];return t.forEach(l=>{const a=this.i.get(l);if(a){const h=this.j.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&o.push(l)}}),o}X(v){const t={};return Promise.all(v.map(s=>this.Y(s).then(o=>{o&&(t[s]=o.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(v){const t=this.getExtensionElement(v);if(t){const s=this.j.get(t);if(s)return this.nb(t),(0,k.asPromise)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const l=this.eb(t,o,s.parent);return this.lb(t,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}Z(v,t,s){const o=this.eb(v,t,s);if(t.id&&this.i.has(o.item.handle))throw new Error((0,i.localize)(0,null,t.id));return this.kb(v,o),this.mb(o,s),o}ab(v){return O.MarkdownString.isMarkdownString(v)?p.MarkdownString.from(v):v}bb(v,t){return t?{...this.F.toInternal(t,v),originalId:t.command}:void 0}cb(v){if(!v.checkboxState)return;let t,s;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,s=v.checkboxState.tooltip),{isChecked:t===O.TreeItemCheckboxState.Checked,tooltip:s}}db(v){if(!O.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,t,s){this.db(t);const o=new R.DisposableStore,l=this.gb(v,t,s),a=this.hb(t);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(o,t.command),contextValue:t.contextValue,icon:a,iconDark:this.ib(t)||a,themeIcon:this.fb(t),collapsibleState:(0,w.isUndefinedOrNull)(t.collapsibleState)?O.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(v){return v.iconPath instanceof O.ThemeIcon?v.iconPath:void 0}gb(v,{id:t,label:s,resourceUri:o},l,a){if(t)return`${E.b}/${t}`;const h=d(s,this.H),c=l?l.item.handle:E.a;let u=h?h.label:o?(0,S.basename)(o):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const g=this.j.has(v)?this.j.get(v).item.handle:void 0,A=this.Q(l)||[];let N,q=0;do{if(N=`${c}/${q}:${u}`,a||!this.i.has(N)||g===N)break;q++}while(q<=A.length);return N}hb(v){if(v.iconPath&&!(v.iconPath instanceof O.ThemeIcon))return typeof v.iconPath=="string"||L.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof O.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return L.URI.isUri(v)?v:L.URI.file(v)}kb(v,t){this.i.set(t.item.handle,v),this.j.set(v,t)}lb(v,t,s,o){this.i.delete(t.item.handle),this.j.delete(v),t.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(v,t);const l=this.Q(o)||[],a=l.filter(h=>h.item.handle===s.item.handle)[0];a&&l.splice(l.indexOf(a),1,t)}mb(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const t=this.j.get(v);if(t){if(t.children)for(const s of t.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}t.children=void 0}}else this.pb()}ob(v){const t=this.j.get(v);if(t){if(t.children)for(const s of t.children){const o=this.i.get(s.item.handle);o&&this.ob(o)}this.j.delete(v),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(Ie[251],Ce([1,0,21,11,4,30,2,128,260,116,126,36,5,73,204,203,38,205,32,207,208,209,192,210,57,33,212,213,216,217,219,104,195,224,225,226,80,60,229,250,8,7,50,232,61,103,31,183,215,48,102,106,108,109,13,54,17,27,220,190,69,76,201,230,81,59,235,233,234,202,37,227,231,79,58,74,221,105,222,16,91,194,173,214,6,24,178,78,170,223]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,p,f,n,r,d,b,E,P,v,t,s,o,l,a,h,c,u,g,A,N,q,te,x,F,$,T,M,V,j,le,Y,pe,ue,de,re,G,H,oe,ve,Ae,Be,xe,Te,Se,ke,se,ce,J,D,B,W,K,Z,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,_,Q,ge,Me,$e,je,_e,nt,wt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ct(lt){const at=lt.get(ke.IExtHostInitDataService),Bt=lt.get(Ee.IExtHostFileSystemInfo),Ot=lt.get(Z.IExtHostConsumerFileSystem),Ft=lt.get(l.IExtHostExtensionService),ft=lt.get(de.IExtHostWorkspace),Dt=lt.get(et.IExtHostTelemetry),$t=lt.get(b.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(Se.IExtHostRpcService),Mt=lt.get(F.IExtHostStorage),Lt=lt.get(K.IExtensionStoragePaths),Ut=lt.get(xe.ILoggerService),gt=lt.get(xe.ILogService),kt=lt.get(J.IExtHostTunnelService),De=lt.get(D.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),me=lt.get(tt.IExtHostSecretState),X=lt.get(Xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Bt),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,$t),Ge.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ge.set(m.ExtHostContext.ExtHostStorage,Mt),Ge.set(m.ExtHostContext.ExtHostTunnelService,kt),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,me),Ge.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(m.ExtHostContext.ExtHostEditorTabs,X);const Re=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(oe.IExtHostDecorations)),Le=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(o.IExtHostDocumentsAndEditors)),Qe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(r.IExtHostCommands)),ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get($.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Ae.IExtHostDebugService)),bt=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(Be.IExtHostSearch)),vt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(ve.IExtHostTask)),At=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(A.IExtHostOutputService)),pt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),It=Ge.set(m.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Ge)),ht=Ge.set(m.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Ge,Le)),Kt=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ge,Le,gt)),Vt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(gt,ht,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),Et=Ge.set(m.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,Qe,Le,ht)),Qt=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(Et)),ri=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(gt,Et)),ei=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Qe,gt)),bi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),Tt=Ge.set(m.ExtHostContext.ExtHostEditors,new T.ExtHostEditors(Ge,Le)),si=Ge.set(m.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Qe,gt)),jt=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),Tt,at.remote)),ti=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,gt,Bt,Le)),oi=Ge.set(m.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ge,ht,Qe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ge,Nt,ht,Qe,ti,gt,De,Dt)),Oi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(Ge,ct)),_t=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(Ge,gt,Le)),Wt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ft,Qe)),ai=Ge.set(m.ExtHostContext.ExtHostSCM,new te.ExtHostSCM(Ge,Qe,gt)),Ei=Ge.set(m.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ge,Qe,ht)),ci=Ge.set(m.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),wi=Ge.set(m.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(Ge)),ui=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ii=Ge.set(m.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),Si=Ge.set(m.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Qe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviews,new pe.ExtHostWebviews(Ge,at.remote,ft,gt,De)),yi=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Di=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,ht,Lt,ni,yi)),Ii=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(Ge,ni)),Yt=Ge.set(m.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,Qe,Le)),Ci=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),$i=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,Et,Le,Qe,gt));const ki=Object.values(m.ExtHostContext);Ge.assertRegistered(ki);const Ti=new be.ExtHostBulkEdits(Ge,Le),zi=new n.ExtHostClipboard(Ge),Pi=new g.ExtHostMessageService(Ge,gt),Fi=new P.ExtHostDialogs(Ge),Ni=new x.ExtHostStatusBar(Ge,Qe.converter);return f.ExtHostApiCommands.register(Qe),function(Ue,Gt,li){const mt=function(){let ne=!Ue.isUnderDevelopment;function fe(){ne||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ne(rt){if(Array.isArray(rt))rt.forEach(Ne);else if(typeof rt=="string")fe();else{const yt=rt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),Wi={getSession(ne,fe,Ne){return ii.getSession(Ue,ne,fe,Ne)},async hasSession(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ne,fe,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Ne,rt){return ii.registerAuthenticationProvider(ne,fe,Ne,rt)}},Hi={registerCommand(ne,fe,Ne){return Qe.registerCommand(!0,ne,fe,Ne,void 0,Ue)},registerTextEditorCommand(ne,fe,Ne){return Qe.registerCommand(!0,ne,(...rt)=>{const yt=Tt.getActiveTextEditor();if(!yt){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{fe.apply(Ne,[yt,Pt,...rt])}).then(Pt=>{Pt||gt.warn("Edits from command "+ne+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,fe,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Qe.registerCommand(!0,ne,async(...rt)=>{const yt=Le.activeEditor(!0);if(!yt){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);fe.apply(Ne,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...fe){return Qe.executeCommand(ne,...fe)},getCommands(ne=!1){return Qe.getCommands(ne)}},Mi={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Dt.instantiateLogger(Ue,ne)},openExternal(ne,fe){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return It.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(fe){if((0,_.matchesScheme)(ne,st.Schemas.http)||(0,_.matchesScheme)(ne,st.Schemas.https))return ne;throw fe}},get remoteName(){return(0,H.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Mi);const di={createTestController(ne,fe,Ne){return Yt.createTestController(Ue,ne,fe,Ne)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.results}},hi=at.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Vi={getExtension(ne,fe){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(fe=!1);const Ne=Gt.mine.getExtensionDescription(ne);if(Ne)return new l.Extension(Ft,Ue.identifier,Ne,hi,!1);if(fe){const rt=Gt.all.getExtensionDescription(ne);if(rt)return new l.Extension(Ft,Ue.identifier,rt,hi,!0)}},get all(){const ne=[];for(const fe of Gt.mine.getAllExtensionDescriptions())ne.push(new l.Extension(Ft,Ue.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),fe=[];for(const Ne of Gt.all.getAllExtensionDescriptions()){const rt=!ne.has(Ne.identifier);fe.push(new l.Extension(Ft,Ue.identifier,Ne,hi,rt))}return fe},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?S.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},ji={createDiagnosticCollection(ne){return ti.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ti.onDidChangeDiagnostics},getDiagnostics:ne=>ti.getDiagnostics(ne),getLanguages(){return oi.getLanguages()},setTextDocumentLanguage(ne,fe){return oi.changeLanguage(ne.uri,fe)},match(ne,fe){const Ne=ht.getDocumentData(fe.uri)?.notebook;return(0,O.score)(V.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ne,fe,Ne){return ct.registerCodeActionProvider(Ue,mt(ne),fe,Ne)},registerDocumentPasteEditProvider(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,mt(ne),fe,Ne)},registerCodeLensProvider(ne,fe){return ct.registerCodeLensProvider(Ue,mt(ne),fe)},registerDefinitionProvider(ne,fe){return ct.registerDefinitionProvider(Ue,mt(ne),fe)},registerDeclarationProvider(ne,fe){return ct.registerDeclarationProvider(Ue,mt(ne),fe)},registerImplementationProvider(ne,fe){return ct.registerImplementationProvider(Ue,mt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ct.registerTypeDefinitionProvider(Ue,mt(ne),fe)},registerHoverProvider(ne,fe){return ct.registerHoverProvider(Ue,mt(ne),fe,Ue.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ct.registerEvaluatableExpressionProvider(Ue,mt(ne),fe,Ue.identifier)},registerInlineValuesProvider(ne,fe){return ct.registerInlineValuesProvider(Ue,mt(ne),fe,Ue.identifier)},registerDocumentHighlightProvider(ne,fe){return ct.registerDocumentHighlightProvider(Ue,mt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ct.registerLinkedEditingRangeProvider(Ue,mt(ne),fe)},registerReferenceProvider(ne,fe){return ct.registerReferenceProvider(Ue,mt(ne),fe)},registerRenameProvider(ne,fe){return ct.registerRenameProvider(Ue,mt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Ne){return ct.registerDocumentSymbolProvider(Ue,mt(ne),fe,Ne)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,fe){return ct.registerDocumentFormattingEditProvider(Ue,mt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ct.registerDocumentRangeFormattingEditProvider(Ue,mt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Ne,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,mt(ne),fe,[Ne].concat(rt))},registerDocumentSemanticTokensProvider(ne,fe,Ne){return ct.registerDocumentSemanticTokensProvider(Ue,mt(ne),fe,Ne)},registerDocumentRangeSemanticTokensProvider(ne,fe,Ne){return ct.registerDocumentRangeSemanticTokensProvider(Ue,mt(ne),fe,Ne)},registerSignatureHelpProvider(ne,fe,Ne,...rt){return typeof Ne=="object"?ct.registerSignatureHelpProvider(Ue,mt(ne),fe,Ne):ct.registerSignatureHelpProvider(Ue,mt(ne),fe,typeof Ne>"u"?[]:[Ne,...rt])},registerCompletionItemProvider(ne,fe,...Ne){return ct.registerCompletionItemProvider(Ue,mt(ne),fe,Ne)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,mt(ne),fe)},registerDocumentLinkProvider(ne,fe){return ct.registerDocumentLinkProvider(Ue,mt(ne),fe)},registerColorProvider(ne,fe){return ct.registerColorProvider(Ue,mt(ne),fe)},registerFoldingRangeProvider(ne,fe){return ct.registerFoldingRangeProvider(Ue,mt(ne),fe)},registerSelectionRangeProvider(ne,fe){return ct.registerSelectionRangeProvider(Ue,ne,fe)},registerCallHierarchyProvider(ne,fe){return ct.registerCallHierarchyProvider(Ue,ne,fe)},registerTypeHierarchyProvider(ne,fe){return ct.registerTypeHierarchyProvider(Ue,ne,fe)},setLanguageConfiguration:(ne,fe)=>ct.setLanguageConfiguration(Ue,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),oi.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return ct.registerInlayHintsProvider(Ue,ne,fe)},createLanguageStatusItem(ne,fe){return oi.createLanguageStatusItem(Ue,ne,fe)},registerDocumentDropEditProvider(ne,fe){return ct.registerDocumentOnDropEditProvider(Ue,ne,fe)}},qi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,fe,Ne){const rt=await(I.URI.isUri(ne)?Promise.resolve(fi.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(rt,fe,Ne)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,fe,Ne){return Tt.onDidChangeActiveTextEditor(ne,fe,Ne)},onDidChangeVisibleTextEditors(ne,fe,Ne){return Tt.onDidChangeVisibleTextEditors(ne,fe,Ne)},onDidChangeTextEditorSelection(ne,fe,Ne){return Tt.onDidChangeTextEditorSelection(ne,fe,Ne)},onDidChangeTextEditorOptions(ne,fe,Ne){return Tt.onDidChangeTextEditorOptions(ne,fe,Ne)},onDidChangeTextEditorVisibleRanges(ne,fe,Ne){return Tt.onDidChangeTextEditorVisibleRanges(ne,fe,Ne)},onDidChangeTextEditorViewColumn(ne,fe,Ne){return Tt.onDidChangeTextEditorViewColumn(ne,fe,Ne)},onDidCloseTerminal(ne,fe,Ne){return ze.onDidCloseTerminal(ne,fe,Ne)},onDidOpenTerminal(ne,fe,Ne){return ze.onDidOpenTerminal(ne,fe,Ne)},onDidChangeActiveTerminal(ne,fe,Ne){return ze.onDidChangeActiveTerminal(ne,fe,Ne)},onDidChangeTerminalDimensions(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,fe,Ne)},onDidChangeTerminalState(ne,fe,Ne){return ze.onDidChangeTerminalState(ne,fe,Ne)},onDidWriteTerminalData(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,fe,Ne)},get state(){return Pe.state},onDidChangeWindowState(ne,fe,Ne){return Pe.onDidChangeWindowState(ne,fe,Ne)},showInformationMessage(ne,...fe){return Pi.showMessage(Ue,L.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return Pi.showMessage(Ue,L.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return Pi.showMessage(Ue,L.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Ne){return Wt.showQuickPick(ne,fe,Ne)},showWorkspaceFolderPick(ne){return Wt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Wt.showInput(ne,fe)},showOpenDialog(ne){return Fi.showOpenDialog(ne)},showSaveDialog(ne){return Fi.showSaveDialog(ne)},createStatusBarItem(ne,fe,Ne){let rt,yt,Pt;return typeof ne=="string"?(rt=ne,yt=fe,Pt=Ne):(yt=ne,Pt=fe),Ni.createStatusBarEntry(Ue,rt,yt,Pt)},setStatusBarMessage(ne,fe){return Ni.setStatusBarMessage(ne,fe)},withScmProgress(ne){return De.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ci.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(fe,Ne)=>ne({report(rt){}}))},withProgress(ne,fe){return ci.withProgress(Ue,ne,fe)},createOutputChannel(ne,fe){return At.createOutputChannel(ne,fe,Ue)},createWebviewPanel(ne,fe,Ne,rt){return yi.createWebviewPanel(Ue,ne,fe,Ne,rt)},createWebviewTextEditorInset(ne,fe,Ne,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),jt.createWebviewEditorInset(ne,fe,Ne,rt,Ue)},createTerminal(ne,fe,Ne){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,fe,Ne)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return ze.registerProfileProvider(Ue,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,fe)},registerTreeDataProvider(ne,fe){return si.registerTreeDataProvider(ne,fe,Ue)},createTreeView(ne,fe){return si.createTreeView(ne,fe,Ue)},registerWebviewPanelSerializer:(ne,fe)=>yi.registerWebviewPanelSerializer(Ue,ne,fe),registerCustomEditorProvider:(ne,fe,Ne={})=>Di.registerCustomEditorProvider(Ue,ne,fe,Ne),registerFileDecorationProvider(ne){return Re.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return It.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Wt.createQuickPick(Ue)},createInputBox(){return Wt.createInputBox(Ue)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Ne){return ui.onDidChangeActiveColorTheme(ne,fe,Ne)},registerWebviewViewProvider(ne,fe,Ne){return Ii.registerWebviewViewProvider(Ue,ne,fe,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Ne){return Et.onDidChangeActiveNotebookEditor(ne,fe,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Ne){return ri.onDidChangeNotebookEditorSelection(ne,fe,Ne)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Ne){return ri.onDidChangeNotebookEditorVisibleRanges(ne,fe,Ne)},showNotebookDocument(ne,fe){return Et.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ci.registerExternalUriOpener(Ue.identifier,ne,fe,Ne)},registerProfileContentHandler(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),$i.registrProfileContentHandler(Ue,ne,fe)},get tabGroups(){return X.tabGroups}},fi={get rootPath(){return De.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,fe,...Ne)=>ft.updateWorkspaceFolders(Ue,ne,fe||0,...Ne),onDidChangeWorkspaceFolders:function(ne,fe,Ne){return ft.onDidChangeWorkspace(ne,fe,Ne)},asRelativePath:(ne,fe)=>ft.getRelativePath(ne,fe),findFiles:(ne,fe,Ne,rt)=>ft.findFiles(ne,fe,Ne,Ue.identifier,rt),findTextInFiles:(ne,fe,Ne,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let yt,Pt;return typeof fe=="object"?(yt=fe,Pt=Ne):(yt={},Pt=fe,rt=Ne),ft.findTextInFiles(ne,yt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,fe){return Ti.applyWorkspaceEdit(ne,Ue,fe)},createFileSystemWatcher:(ne,fe,Ne,rt)=>_t.createFileSystemWatcher(ft,Ue,ne,fe,Ne,rt),get textDocuments(){return ht.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let fe;const Ne=ne;if(typeof ne=="string")fe=Promise.resolve(I.URI.file(ne));else if(I.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Ne||typeof Ne=="object")fe=ht.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>ht.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(ne,fe,Ne)=>ht.onDidAddDocument(ne,fe,Ne),onDidCloseTextDocument:(ne,fe,Ne)=>ht.onDidRemoveDocument(ne,fe,Ne),onDidChangeTextDocument:(ne,fe,Ne)=>ht.onDidChangeDocument(ne,fe,Ne),onDidSaveTextDocument:(ne,fe,Ne)=>ht.onDidSaveDocument(ne,fe,Ne),onWillSaveTextDocument:(ne,fe,Ne)=>Vt.getOnWillSaveTextDocumentEvent(Ue)(ne,fe,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Ne;if(I.URI.isUri(ne))Ne=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Ne=I.URI.revive(await Et.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ne,fe,Ne){return Qt.onDidSaveNotebookDocument(ne,fe,Ne)},onDidChangeNotebookDocument(ne,fe,Ne){return Qt.onDidChangeNotebookDocument(ne,fe,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Ne,rt){return Et.registerNotebookSerializer(Ue,ne,fe,Ne,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,fe,Ne)=>li.onDidChangeConfiguration(ne,fe,Ne),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,li.getConfiguration(ne,fe,Ue)},registerTextDocumentContentProvider(ne,fe){return Kt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(De.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,ne,fe)),registerFileSystemProvider(ne,fe,Ne){return(0,$e.combinedDisposable)(Oi.registerFileSystemProvider(Ue,ne,fe,Ne),Ot.addFileSystemProvider(ne,fe))},get fs(){return Ot.value},registerFileSearchProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Ne)=>_t.onDidCreateFile(ne,fe,Ne),onDidDeleteFiles:(ne,fe,Ne)=>_t.onDidDeleteFile(ne,fe,Ne),onDidRenameFiles:(ne,fe,Ne)=>_t.onDidRenameFile(ne,fe,Ne),onWillCreateFiles:(ne,fe,Ne)=>_t.getOnWillCreateFileEvent(Ue)(ne,fe,Ne),onWillDeleteFiles:(ne,fe,Ne)=>_t.getOnWillDeleteFileEvent(Ue)(ne,fe,Ne),onWillRenameFiles:(ne,fe,Ne)=>_t.getOnWillRenameFileEvent(Ue)(ne,fe,Ne),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.openTunnel(Ue,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ne,fe,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.onDidChangeTunnels(ne,fe,Ne)),registerPortAttributesProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),kt.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),Si.registerTimelineProvider(ne,fe,Ue.identifier,Qe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Ne)=>ft.onDidGrantWorkspaceTrust(ne,fe,Ne),registerEditSessionIdentityProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,fe))},Ki={get inputBox(){return De.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ai.getLastInputBox(Ue)},createSourceControl(ne,fe,Ne){return ai.createSourceControl(Ue,ne,fe,Ne)}},xt={createCommentController(ne,fe){return Ei.createCommentController(Ue,ne,fe)}},mi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,fe,Ne){return Ze.onDidStartDebugSession(ne,fe,Ne)},onDidTerminateDebugSession(ne,fe,Ne){return Ze.onDidTerminateDebugSession(ne,fe,Ne)},onDidChangeActiveDebugSession(ne,fe,Ne){return Ze.onDidChangeActiveDebugSession(ne,fe,Ne)},onDidReceiveDebugSessionCustomEvent(ne,fe,Ne){return Ze.onDidReceiveDebugSessionCustomEvent(ne,fe,Ne)},onDidChangeBreakpoints(ne,fe,Ne){return Ze.onDidChangeBreakpoints(ne,fe,Ne)},registerDebugConfigurationProvider(ne,fe,Ne){return Ze.registerDebugConfigurationProvider(ne,fe,Ne||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return Ze.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ze.startDebugging(ne,fe,{parentSession:Ne}):Ze.startDebugging(ne,fe,Ne||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return Ze.asDebugSourceUri(ne,fe)}},Gi={registerTaskProvider:(ne,fe)=>vt.registerTaskProvider(Ue,ne,fe),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Ue,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,fe,Ne)=>vt.onDidStartTask(ne,fe,Ne),onDidEndTask:(ne,fe,Ne)=>vt.onDidEndTask(ne,fe,Ne),onDidStartTaskProcess:(ne,fe,Ne)=>vt.onDidStartTaskProcess(ne,fe,Ne),onDidEndTaskProcess:(ne,fe,Ne)=>vt.onDidEndTaskProcess(ne,fe,Ne)},zt={createNotebookController(ne,fe,Ne,rt,yt){return ei.createNotebookController(Ue,ne,fe,Ne,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,fe),createRendererMessaging(ne){return bi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.registerKernelSourceActionProvider(Ue,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),ei.onDidChangeNotebookCellExecutionState(ne,fe,Ne)}},gi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Ne=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Ue.identifier.value,{message:fe,args:Ne})}return pt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:Wi,commands:Hi,comments:xt,debug:mi,env:Mi,extensions:Vi,l10n:gi,languages:ji,notebooks:zt,scm:Ki,tasks:Gi,tests:di,window:qi,workspace:fi,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:k.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:p.UIKind,Uri:I.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ct}),define(Ie[252],Ce([1,0,251,33,2,245,7,12,236]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(p,f){for(const n of this.b){const r=n(p);if(r){p=r;break}}if(this.a.has(p))return this.a.get(p).load(p,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const p=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,p,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(p){return p.browser}async pb(p,f,n){f=f.with({path:w(f.path,".js")});const r=p?.identifier.value;r&&performance.mark(`code/extHost/willFetchExtensionCode/${r}`);const d=S.URI.revive(await this.v.$asBrowserUri(f)),b=await fetch(d.toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r}`),b.status!==200)throw new Error(b.statusText);const E=await b.text(),P=`${f.toString(!0)}#vscode-extension`,v=`${E}
//# sourceURL=${P}`;let t;try{t=new Function("module","exports","require",v)}catch(a){throw console.error(r?`Loading code for extension ${r} failed: ${a.message}`:`Loading code failed: ${a.message}`),console.error(`${f.toString(!0)}${typeof a.line=="number"?` line ${a.line}`:""}${typeof a.column=="number"?` column ${a.column}`:""}`),console.error(a),a}p&&await this.s.initializeLocalizedMessages(p);const s={},o={exports:s},l=a=>{const h=this.r.getModule(a,f);if(h===void 0)throw new Error(`Cannot load module '${a}'`);return h};try{return n.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r}`),t(o,s,l),o.exports!==s?o.exports:s}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r}`),n.codeLoadingStop()}}async $setRemoteEnvironment(p){}async tb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+p;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=O;function w(m,p){return m.endsWith(p)?m:m+p}}),define(Ie[253],Ce([1,0,66,33,81,252]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(C.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,0)}),define(Ie[261],Ce([1,0,25,4,73,246,238,19,82,16,2,248,253]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function n(t){self.fetch=async function(s,o){return s instanceof Request||p(String(s))&&(s=(await t(O.URI.parse(String(s)))).toString(!0)),f(s,o)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,o,l,a,h){(async()=>(p(o.toString())&&(o=(await t(O.URI.parse(o.toString()))).toString(!0)),super.open(s,o,l??!0,a,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(s,o){if(/^file:/i.test(s.toString()))s=k.FileAccess.uriToBrowserUri(O.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const a=`(${function(g){function A(te){return typeof te=="string"||te instanceof URL?String(te).replace(/^file:\/\//i,"vscode-file://vscode-app"):te}const N=fetch.bind(self);self.fetch=function(te,x){return te instanceof Request?N(te,x):N(A(te),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(te,x,F,$,T){return super.open(te,A(x),F??!0,$,T)}};const q=importScripts.bind(self);self.importScripts=(...te)=>{q(...te.map(A))},q(g)}.toString()}('${s}'))`;o=o||{},o.name=o.name||R.basename(s.toString());const h=new Blob([a],{type:"application/javascript"}),c=URL.createObjectURL(h);return new t(c,o)}}else self.Worker=class extends I.NestedWorker{constructor(t,s){super(m,t,{name:R.basename(t.toString()),...s})}};const r=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class d{constructor(){const s=new MessageChannel,o=new C.Emitter;let l=!1;m(s.port2,[s.port2]),s.port1.onmessage=a=>{const{data:h}=a;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const c=i.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if((0,S.isMessageOfType)(c,2)){l=!0,E("received terminate message from renderer");return}o.fire(c)},this.protocol={onMessage:o.event,send:a=>{if(!l){const h=a.buffer.buffer.slice(a.buffer.byteOffset,a.buffer.byteOffset+a.buffer.byteLength);s.port1.postMessage(h,[h])}}}}}function b(t){return new Promise(s=>{const o=t.onMessage(l=>{o.dispose();const a=JSON.parse(l.toString());t.send((0,S.createMessageOfType)(0)),s({protocol:t,initData:a})});t.send((0,S.createMessageOfType)(1))})}let E=t=>w();function P(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){y.mark("code/extHost/willConnectToRenderer");const t=new d;return{onmessage(s){!P(s)||b(t.protocol).then(o=>{y.mark("code/extHost/didWaitForInitData");const l=new L.ExtensionHostMain(o.protocol,o.initData,r,null,s.data);n(a=>l.asBrowserUri(a)),E=a=>l.terminate(a)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/04b15ff231a2c3cfcdd90d90c16075a9c1e6da15/core/vs/workbench/api/worker/extensionHostWorker.js.map
